File: 
Description:

Notes:
ToDo:
	- add comments and explenations
	- use dynamic c linking instead of static linking
	- improve get_item to receive two parameters: row, col.
<'
	//define enums for the return codes from matlab functions
type  matlab_rc_t : [SUCCESS, ERROR];
	//define the state of the matlab component
define MATLAB_STATE_UNINIT 0;
define MATLAB_STATE_INIT   1;
define MATLAB_STATE_RUN    0x2;
define MATLAB_STATE_ERROR  0x4;

type  matlab_class_id_t : [MB_DOUBLE, MB_INT32, MB_INT64];
//model a double precision variable.
//note that matlab carries al its computation using doubles.
struct sn_matlab_double_s {
	!is_double	: bool;	//false by default. meaning only the low field has a valid value.
	!is_int64	: bool;	//false by default. meaning only the low field has a valid value.
	!low : uint;//lower 32 bits of a double
	!high: uint;//high 32 bits of a double
};
struct sn_matlab_complex_s {
	!is_complex	: bool;//false by efault. meaning only the 'r' part contains meanningfull data.
	!is_double	: bool;//false by default. meaning only the low fields have valid value.
	!is_int64 	: bool;//false by default. meaning only the low fields have valid value.
	r : sn_matlab_double_s;//real part
	i : sn_matlab_double_s;//imag part
};
//model the matlab mx_array struct, which is used by the matlab api functions.
	//	name:string
	//		this corresponds to a name from the matlab workspace, i.e., a variable.
	//	its_class
	//		the matlab class, i.e., int32, int64 or double.
	//	rows
	//		# of rows in this mx_array (or better matrix)
	//	cols 
	//		# of columns
	//		note that the default layout of the matrix may differ between platform.
	//	get_item
	//		returns one item from the array. note that this item is modeled using the 
	//		sn_matlab_complex_s struct. 
	//	the principle purpose of this struct is to avoid the need for conversion
	//	from matlab mx_array to e struct and vice versa.
	//	using the provided get_item methods one can get and send data to/from matlab
	//	without realy the need to copy data from one workspace to the other.
struct matlab_mx_array_s {
	name : string;
	its_class : matlab_class_id_t;
	!is_complex : bool;
	!rows	: uint;				//#of rows
	!cols	: uint;				//#of columns
#ifndef DBG_SO_BUG {
	!mx_ptr	: uint(bits:64);	//a pointer to an external mxArray matlab struct
};
		//get an item from the array.
		//assuming it is an array of uint.
	get_item(ro : uint, co : uint ) : sn_matlab_complex_s is empty;
	get_item_as_uint64(ro : uint, co : uint ) : sn_matlab_complex_s is empty;
};
//Struct: 
//Description:
//	the e abstraction layer on top of the mx_array.
//Notes:
//ToDo:
struct sn_matlab_var_s {
	name : string;
	its_class : matlab_class_id_t;
	is_complex	: bool;
	!r_data	: list of uint;	//real data
	!i_data : list of uint;	//imaginary data
	!mx_arr	: matlab_mx_array_s;
	is_double() : bool is {
		result = (its_class == MB_DOUBLE);
	};
	is_int64() : bool is {
		result = (its_class == MB_INT64);
	};
	get_item(idx : uint) : sn_matlab_complex_s is empty;
};
//Struct: 
//Description:
//	the actual e to matlab interface.
//	provides methods to read/write data from/to the matlab workspace.
//Notes:
//ToDo:
struct matlab_ifc_s {
	!last_rc : matlab_rc_t;		//last result returned by matlab.
	!last_msg    	: string;	//a description string of the last result.
	state	: uint;				//current state.
	!dbg_flag : bool;
	!cdbg_flag : bool;
	//initialize the matlab engine, i.e., establish a connection
	//and set the transfer area
	exec(statements : list of string) : matlab_rc_t is empty; 
	get_var(v : sn_matlab_var_s) : matlab_rc_t is empty;
	put_var(v : sn_matlab_var_s) : matlab_rc_t is empty;
	is_initialized() : bool is {
		result = (state & MATLAB_STATE_INIT) != 0;
	};
	is_valid_var(v : sn_matlab_var_s) : bool is {
		result = v.name != "";
	};
	is_equal(sn_var : sn_matlab_var_s, mb_var : matlab_mx_array_s) : bool is empty;
	// compares the data in two mx arrays
	is_equal_mx(mx1 : matlab_mx_array_s, mx2 : matlab_mx_array_s) : bool is empty;
	mx_to_sn(mx : matlab_mx_array_s) : sn_matlab_var_s is empty;
};
'>
o Macro:  
o Description:
	<cmds'name> : list of string
	each item in the list will be sent to matlab for execution
o Type:
o Usage:
o Created By: meir 
<'
define <matlab_cmds_cmd'command> "MB <cmds'name>" as {
	compute matlab.exec(<cmds'name>);
};
define <matlab_dbg_on'command> "MB [c]deb[ug[ on]]" as {
	if "<1>" == "c" {
		matlab.cdbg_flag = TRUE;
	} else {
		matlab.dbg_flag = TRUE;
	};
};
define <matlab_dbg_off'command> "MB [c]deb[ug] off" as {
	if "<1>" == "c" {
		matlab.cdbg_flag = FALSE;
	} else {
		matlab.dbg_flag = FALSE;
	};
};
define <matlab_cmds_action'action> "MB <cmds'name>" as {
	compute matlab.exec(<cmds'name>);
};
define <matlab_cmds_exp'exp> "MB <cmds'name>" as {
	matlab.exec(<cmds'name>);
};
define <matlab_dbg_on'action> "MB [c]deb[ug[ on]]" as {
	if "<1>" == "c" {
		matlab.cdbg_flag = TRUE;
	} else {
		matlab.dbg_flag = TRUE;
	};
};
define <matlab_dbg_off'action> "MB [c]deb[ug] off" as {
	if "<1>" == "c" {
		matlab.cdbg_flag = FALSE;
	} else {
		matlab.dbg_flag = FALSE;
	};
};
'>
