#ifndef SN_SN_MATLAB_H
#define SN_SN_MATLAB_H

/* sn_matlab.h_.h - Translated from matlab.e by: */
/*   Specman(64) Elite (08.20.006-s)  -  Linked on Sun Jun 21 18:44:10 2009 */

/* sn_matlab.h_.h - Translated from sn_matlab.e by: */
/*   Specman(64) Elite (08.20.006-s)  -  Linked on Sun Jun 21 18:44:10 2009 */

    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef ROOT_ALL_H
#define ROOT_ALL_H

/* #include version.h */
#ifndef SN_version_included
#define SN_version_included


#define SN_VERSION "08.20.006-s"

#endif


#if defined(SOL_SPARC) || defined(SOL_X86)
#define SOLARIS_C
#endif

/* #include snoopy.h */
/* snoopy.h - the Snoopy include file ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

#ifndef snoopy_included
#define snoopy_included

#include <stdio.h>
#include <string.h>

/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
# define SN_EXTERNC extern "C"
#else
# define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
# ifndef GCC
#  define GCC
# endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
# ifndef __TOKEN_MERGER__
#  define __TOKEN_MERGER__
# endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
# define _SN_ANSI_ARGS_(x)	x
#else
# define _SN_ANSI_ARGS_(x)	()
#endif

#define SN_PTR_ALIGNMENT_64 (3)
#define SN_PTR_ALIGNMENT_32 (2)

#if defined(LINUX_C) || defined(SOL_X86)
#define SN_LITTLE_ENDIAN
#else 
#define SN_BIG_ENDIAN
#endif

#include <inttypes.h>
#if defined(_LP64) || defined(__LP64__) || defined (__64BIT__)
# define SN_64_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_64)
#else /* defined(_LP64) || defined(__LP64__) || defined (__64BIT__) */
# define SN_32_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_32)
#endif /* defined(_LP64) || defined(__LP64__) */

#ifndef offsetof
# define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
#endif

#endif /* _CPP_H_ */



/* #include regexp.h */
/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */
#ifndef regexp_included
#define regexp_included

#define NSUBEXP  51
typedef struct sn_regexp {
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} sn_regexp;

typedef struct sn_regexp *sn_pattern;

#endif

extern int sn_regexp_dont_reset_flag;



#define MAX_STRING 256  /* Max no of chars in regular string for display etc.*/
#define MAX_BIG_STRING 4000  /* Max size for a big string (e.g. script) */
		/* Max no of strings that a single split can split into */
		/* Also max no. of lines that go in mem, max no of files */
#define MAX_CHARS_IN_LIST 1024  /* Max no of chars in an flist */
#define SN_MAX_AUTO_BUF 1024 /* Maximum size of an automatic (on-stack)
                               buffer.  We don't want to blow up the
                               sta ck too much. */

/* ---- Basic types */

#ifndef TRUE
#define FALSE	0x00
#define TRUE	0x01
#endif

#ifndef	__cplusplus
typedef unsigned int bool;
#define SN_UNSPEC_PARAMS_LIST () 
#else
#define SN_UNSPEC_PARAMS_LIST (...)
#endif
typedef intptr_t (*sn_routine_pointer_type) SN_UNSPEC_PARAMS_LIST;
#ifndef SN_BOOL_DEFINED
typedef unsigned int sn_bool;
#define SN_BOOL_DEFINED
#endif

typedef char *SN_STRING;

#define SN_S0(_x) sub("\\0", _x)
#define SN_S1(_x) sub("\\1", _x)
#define SN_S2(_x) sub("\\2", _x)
#define SN_S3(_x) sub("\\3", _x)
#define SN_S4(_x) sub("\\4", _x)
#define SN_S5(_x) sub("\\5", _x)
#define SN_S6(_x) sub("\\6", _x)
#define SN_S7(_x) sub("\\7", _x)
#define SN_S8(_x) sub("\\8", _x)
#define SN_S9(_x) sub("\\9", _x)

#define SN_CHOP(_x) {(_x)[strlen(_x)-1] = '\0';}

#endif

/* extern.h - procedures and macros for snoopy ~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* ----- Macros */

SN_EXTERNC void init_routine_pointer();


/* String routines */

SN_EXTERNC sn_bool sn_str_empty _SN_ANSI_ARGS_((SN_STRING));	 /*string*/
SN_EXTERNC sn_bool str_eq();		 /*s1, s2*/
SN_EXTERNC sn_bool sn_match();		 /*string, pattern, compiled*/
SN_EXTERNC sn_bool insensitive_match(); /*string, pattern, compiled*/
SN_EXTERNC sn_bool match_next();	/*string, pattern, compiled, before, delim*/
SN_EXTERNC void init_match();	 /*compiled*/
SN_EXTERNC SN_STRING make_case_insensitive();  /* string */
SN_EXTERNC SN_STRING sub();		 /*string, compiled*/
SN_EXTERNC SN_STRING subnum();		 /*int, compiled*/
SN_EXTERNC int split();		 /*pattern, string, &list*/
SN_EXTERNC SN_STRING join();		 /*string, list, length*/
SN_EXTERNC SN_STRING sn_replace(); 	 /*string, pattern, compiled, replacement */

SN_EXTERNC int str_num();		 /*string*/
SN_EXTERNC SN_STRING substr();		 /*string, from, length ->  string */

/* ALLOC */

SN_EXTERNC void init_snoopy();

SN_EXTERNC int sn_min();		/*   num1, num2 -> min */
SN_EXTERNC int sn_max();		/*   num1, num2 -> max */
/* System routines */

SN_EXTERNC SN_STRING sn_quote(SN_STRING);
SN_EXTERNC SN_STRING sn_str_expand_dots(SN_STRING);
SN_EXTERNC char *sn_fgets(FILE *);

#ifndef FAKE_E
/* cannot put real prototype for exception_for_c_code */
/* SN_EXTERNC void exception_for_c_code(); */
SN_EXTERNC SN_STRING sf _SN_ANSI_ARGS_((SN_STRING format, ...));
SN_EXTERNC void sn_out _SN_ANSI_ARGS_((SN_STRING, ...));		/* format, a, b, c, d, e, f - to stdout */
SN_EXTERNC void sn_error _SN_ANSI_ARGS_((SN_STRING, ...));		/* format, a, b, c, d, e, f - and exits */
SN_EXTERNC void sn_fatal _SN_ANSI_ARGS_((SN_STRING, ...));		/* format, a, b, c, d, e, f - and exits */
#endif /* FAKE_E */
/* #include list.h */
    /***********************************************************************
    * COPYRIGHT (c) 1996,1997 Verisity Ltd., all rights                    *
    * reserved. This software is furnished under a license and may be used *
    * and copied only in accordance of the terms of such license and with  *
    * the inclusion of the above copyright notice.                         *
    ***********************************************************************/

#ifndef LIST_H
#define LIST_H

/* -- List macros (see proto.doc) */
/* the list holds 3 fields:
    d__: as for every struct, the type index.
    gen__: as for every struct, the generation field, a reserved element for marking.
    data: the actual data which is scalars (integers) or pointer to structures.
    and another 4 hidden fields: 
    reserved:  a reserved element for marking (e.g data[-4])
    size: the number of elements in the current list. (e.g data[-3])
    allocated: the number of allocated elements for the list (not including 
    the first & last).  (e.g data[-2])
    hash: a pointer to a hash table.  (e.g data[-1]) 
	List and list with key are two diffrent types now.*/

struct sn_key_map_t;

/* Basic plist structure */
typedef struct s__plist {
    int d__;
    int gen__;
    void* *data;
    int size;
    int allocated;
    struct sn_key_map_t *key_map;
    int reserved_stuff;
} *t__plist;

/* Basic list of int structure */
typedef struct s__ilist {
    int d__;
    int gen__;
    int *data;
    int size;
    int allocated;
    struct sn_key_map_t *key_map;
    int reserved_stuff;
} *t__ilist;

/* barf */
/*#define SN_LIST_CAREFUL_TYPECHECK(l, check) (sn_gc_in_progress || starting_in_progress || (l)->d__ == 0 || (l)->d__ == UNDEF || check (l))*/
#define SN_LIST_CAREFUL_TYPECHECK(l, fast_check, real_check) ((!GLOB || !GLOB->all_types || !GLOB->all_types->data || SN_IS_FORWARDED (l) || (l)->d__ == 0 || (l)->d__ == UNDEF) ? fast_check (l) : fast_check (l) && (fast_check (l) == real_check (l)))
#define SN_PLIST_IF_KNOWN(l) SN_LIST_CAREFUL_TYPECHECK (l, IS_LIST_A_PLIST, IS_LIST_A_PLIST_BY_TYPE)
#define SN_ILIST_IF_KNOWN(l) SN_LIST_CAREFUL_TYPECHECK (l, !IS_LIST_A_PLIST, !IS_LIST_A_PLIST_BY_TYPE)

#ifndef FAKE_E
/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */
# if SN_FILTER_COMPILE_COND(light)
#  define SN_LIST_ASSERTIONS
# endif
#endif

#ifdef SN_LIST_ASSERTIONS
# define SN_LIST_ASSERT(level,group,exp,msg) do {                       \
        if ((sn_can_use_filters ? SN_FILTER_RUNTIME_COND (level, group) : FALSE)) \
            if (!(exp))                                                 \
                SN_ERR (ERR_FILTERED_ASSERT, (#group , __LINE__, __FILE__, #exp, msg)); } while (0)
# define SN_ASSERT_PLIST(l) SN_LIST_ASSERT (light, ZERO, SN_PLIST_IF_KNOWN (l), "list is not a PLIST")
# define SN_ASSERT_ILIST(l) SN_LIST_ASSERT (light, ZERO, SN_ILIST_IF_KNOWN (l), "list is not a ILIST")
# define SN_ASSERT_RESERVED_VALUE(val)                                  \
    SN_LIST_ASSERT (light, ZERO, (unsigned int) (val) <= (unsigned int) 0xff, "list reserved value too big")
t__plist sn_as_plist (void *);
t__ilist sn_as_ilist (void *);
# define PLIST(l) (sn_as_plist ((void *) (l)))
# define ILIST(l) (sn_as_ilist ((void *) (l)))
#else
# define SN_ASSERT_RESERVED_VALUE(val)
# define SN_ASSERT_PLIST(l)
# define SN_ASSERT_ILIST(l)
# define PLIST(l) ((t__plist) (l))
# define ILIST(l) ((t__ilist) (l))
#endif

#define INIT_LIST_SIZE 2
#define PELEM2SIZE(_num) ((_num) * sizeof(void *))
#define IELEM2SIZE(_num) ((_num) * sizeof(int))
#define FORWARD(_num) (_num)
#define BACKWARD(_num) (_num)

#define LIST_ITEM(_lvar,index) ((_lvar)->data[index])

#define LIST_ITEM_WITH_CHECK(_lvar,index) (sn_check_list_index((t__ilist)_lvar,index),LIST_ITEM(_lvar,index)) 

#define LIST_MAP(_lvar)  (((t__plist)(_lvar))->key_map)
#define LIST_ALLOCATED(_lvar) (((t__plist)(_lvar))->allocated)
#define LIST_RESERVED(_lvar)  (((t__plist)(_lvar))->reserved_stuff & 0xff)
#define LIST_RESERVED_SET(_lvar,val)  do {      \
        t__ilist l__ = (t__ilist) (_lvar);      \
        SN_ASSERT_RESERVED_VALUE (val);         \
        l__->reserved_stuff &= ~0xff;           \
        l__->reserved_stuff |= val;             \
    } while (0)
#define LIST_RESERVED_SET_NOCHECK(_lvar,val)  do {      \
        t__ilist l__ = (t__ilist) (_lvar);              \
        l__->reserved_stuff &= ~0xff;                   \
        l__->reserved_stuff |= val;                     \
    } while (0)
	/* Where item 0 starts in list */
#define SIZE_CELL(_lvar) ((((t__plist)(_lvar))->size))
#define LIST_SIZE(_lvar) SIZE_CELL(_lvar)

#define PLIST_ITEM(_lvar,_index) LIST_ITEM(PLIST(_lvar),(_index))
#define ILIST_ITEM(_lvar,_index) LIST_ITEM(ILIST(_lvar),(_index))

/* NOTE: the ordering between adding an element and incrementing the
   list size is *important*!  don't let the urge for microoptimization
   get you. */

#define PLIST_ADD(_lvar, _svar) do {                    \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        plist_add_helper(PLIST(_lvar), TRUE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)


#define ILIST_ADD(_lvar, _svar) do {                    \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        list_add_helper(ILIST(_lvar), TRUE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)

#define PLIST_ADD_MALLOC(_lvar, _svar) do {             \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        plist_add_helper(PLIST(_lvar), FALSE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)


#define ILIST_ADD_MALLOC(_lvar, _svar) do {             \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        list_add_helper(ILIST(_lvar), FALSE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)


#define PLIST_ADD_NC(_lvar, _svar) do {                    \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        plist_add_helper((t__plist)(_lvar), TRUE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)


#define ILIST_ADD_NC(_lvar, _svar) do {                    \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        list_add_helper((t__ilist)(_lvar), TRUE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)

#define PLIST_ADD_MALLOC_NC(_lvar, _svar) do {             \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        plist_add_helper((t__plist)(_lvar), FALSE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)


#define ILIST_ADD_MALLOC_NC(_lvar, _svar) do {             \
        int sn__t_= LIST_SIZE(_lvar); if (sn__t_ >= LIST_ALLOCATED(_lvar)) \
        list_add_helper((t__ilist)(_lvar), FALSE);           \
	(_lvar)->data[sn__t_] = (_svar); SIZE_CELL(_lvar) = sn__t_ + 1; } while (0)


/* we keep the "plistness" flag in the list object itself, for two
 * reasons:
 *
 * * so we save time by not going through the type system
 *
 * * so we don't depend on the typesystem, since we might want to test
 * * for plistness in all kinds of bad times like during GC or
 * * restore.
 *
 * the IS_LIST_A_PLIST_BY_TYPE macro is still there so that we can
 * check the sanity of the whole arrangement.
 */
#define SN_PLIST_FLAG (1 << 8)
#define IS_LIST_A_PLIST(list) ((((t__plist) (list))->reserved_stuff & SN_PLIST_FLAG) != 0)
#define SN_SET_LIST_PLIST(list) (((t__plist) (list))->reserved_stuff |= SN_PLIST_FLAG)
#define IS_LIST_A_PLIST_BY_TYPE(list) IS_A_PLIST (TYPE (list))

/* init the list's struct */
#define MAKE_NEW_PLIST_MALLOC(_lvar, _d__)  do {                        \
        t__plist tmp_v = (t__plist)sn_calloc(1,sizeof(struct s__plist), SN_LIST); \
        SN_SET_LIST_PLIST (tmp_v);                                      \
	PLIST(tmp_v)->d__ = (_d__);                                     \
 	(_lvar) = (void *)tmp_v;                                        \
        SN_ASSERT_PLIST (tmp_v);                                        \
    } while (0)

#define MAKE_NEW_ILIST_MALLOC(_lvar, _d__)  do {                        \
        t__ilist tmp_v = (t__ilist)sn_calloc(1,sizeof(struct s__ilist), SN_LIST); \
 	(_lvar) = (void *)tmp_v;                                        \
	ILIST(tmp_v)->d__ = (_d__);                                     \
        SN_ASSERT_ILIST (tmp_v);                                        \
    } while (0)

#define MAKE_NEW_PLIST(_lvar, _d__) do {                                \
        t__plist tmp_v = (t__plist)sn_get_block (SN_BYTES2WORDS (sizeof (struct s__plist)), sn_block_TYPED, TRUE); \
        SN_SET_LIST_PLIST (tmp_v);                                      \
	PLIST(tmp_v)->d__ = (_d__);                                     \
	(_lvar) = (void *) tmp_v;                                       \
        SN_ASSERT_PLIST (tmp_v);                                        \
    } while (0)

#define MAKE_NEW_ILIST(_lvar, _d__) do {                                \
        t__ilist tmp_v = (t__ilist)sn_get_block (SN_BYTES2WORDS (sizeof (struct s__ilist)), sn_block_TYPED, TRUE); \
	(_lvar) = (void *) tmp_v;                                       \
	ILIST(tmp_v)->d__ = (_d__);                                     \
        SN_ASSERT_ILIST (tmp_v);                                        \
    } while (0)

#define MAKE_NEW_PLIST_NC(_lvar, _d__) do {                             \
        t__plist tmp_v = (t__plist)sn_get_block (SN_BYTES2WORDS (sizeof (struct s__plist)), sn_block_TYPED, TRUE); \
        SN_SET_LIST_PLIST (tmp_v);                                      \
	((t__plist)tmp_v)->d__ = (_d__);                                     \
	(_lvar) = (void *) tmp_v;                                       \
    } while (0)

#define MAKE_NEW_ILIST_NC(_lvar, _d__) do {                             \
        t__ilist tmp_v = (t__ilist)sn_get_block (SN_BYTES2WORDS (sizeof (struct s__ilist)), sn_block_TYPED, TRUE); \
	(_lvar) = (void *) tmp_v;                                       \
	((t__ilist)tmp_v)->d__ = (_d__);                                     \
    } while (0)

#define ILIST_ADD_LIST(_lvar, _svar) \
	ilist_add_list_helper(ILIST(_lvar), ILIST(_svar));

#define PLIST_ADD_LIST(_lvar, _svar) \
	plist_add_list_helper(PLIST(_lvar), PLIST(_svar));

#define ILIST_INIT(_lvar, _size, _full, _value, _keep_old) do {         \
        SN_ASSERT_ILIST (_lvar);                                        \
	ilist_init_helper(ILIST(_lvar), _size, _full, _value, _keep_old); } while (0)

#define PLIST_INIT(_lvar, _size, _full, _value, _keep_old) do {         \
        SN_ASSERT_PLIST (_lvar);                                        \
	plist_init_helper(PLIST(_lvar), _size, _full, _value, _keep_old); } while (0)

#define SN_ILIST_INTERNAL_INIT(_lvar, _size) do {                       \
        SN_ASSERT_ILIST (_lvar);                                        \
	sn_ilist_internal_init(ILIST(_lvar), _size); } while (0)

#define SN_PLIST_INTERNAL_INIT(_lvar, _size) do {                       \
        SN_ASSERT_PLIST (_lvar);                                        \
	sn_plist_internal_init(PLIST(_lvar), _size); } while (0)

#define ILIST_INIT_NC(_lvar, _size, _full, _value, _keep_old) do {         \
	ilist_init_helper((t__ilist)(_lvar), _size, _full, _value, _keep_old); } while (0)

#define PLIST_INIT_NC(_lvar, _size, _full, _value, _keep_old) do {         \
	plist_init_helper((t__plist)(_lvar), _size, _full, _value, _keep_old); } while (0)

#define LIST_IS_EMPTY(_lvar)   (LIST_SIZE(_lvar) == 0)

#define LIST_CLEAR(_lvar)  do { SIZE_CELL(_lvar) = 0; } while (0)

#define PLIST_CLEAR_AND_FREE_ELTS(l) do {                       \
        int i__; void *p__;                                     \
        SN_ASSERT_PLIST (l);                                    \
        PLIST_FOR_EACH (l, p__, i__) { if (p__) sn_free (p__, SN_LIST); }	\
        LIST_CLEAR (l); } while (0)

#define SN_REM_LIST_DATA(_list) do {                            \
        SIZE_CELL(_list) = 0; LIST_ALLOCATED(_list) = 0;        \
        (_list)->data = NULL;} while (0)

#define LIST_ALLOC_SIZE(_lvar) LIST_ALLOCATED(_lvar)
	/* Size allocated for that list, in items */

#define LIST_ITEM_EXISTS(_lvar, _index)  ((_index) >= 0 && (_index) < LIST_SIZE(_lvar))

     /* Delete the item number _index from the list _lvar and 
        put there the last item in the list */
#define LIST_DELETE(_lvar, _index, _stype) \
    do { LIST_ITEM(_lvar,_index) = LIST_ITEM(_lvar,--SIZE_CELL(_lvar)); } while (0) 

#define LIST_KEY_FAST_DELETE(_lvar, _kval, _index) \
    list_key_fast_delete_helper((t__plist)(_lvar), _kval, _index)

#define LIST_POP(_lvar, _stype) \
    ((_stype) LIST_ITEM((_lvar),--SIZE_CELL(_lvar)))

#define LIST_TOP(_lvar, _stype) \
    (LIST_ITEM(_lvar,LIST_SIZE(_lvar) - 1))

#define LIST_INSTANCE_ADD_CHECK(_lvar,_list_string) \
     ((LIST_RESERVED(_lvar) == 1)?\
      (sn_error("Can not modify '%s', it is reference to instance.",_list_string),0):0) 

#define INIT_UNIT_LIST_DATA(_lvar, _is_inst) \
    do { LIST_RESERVED_SET(_lvar, _is_inst); } while (0)

#ifdef __GNUC__
#define PLIST_FOR_EACH(_lvar1, _svar, _index)              \
        for(_index = 0;                                         \
            ((_index) < LIST_SIZE(_lvar1)) &&                   \
                     (_svar = (typeof(_svar))(intptr_t)PLIST_ITEM((_lvar1), _index),1);  \
            ++(_index))

#define PLIST_FOR_EACH_IGNORE_ANSI(_lvar1, _svar, _index)              \
        for(_index = 0;                                         \
            ((_index) < LIST_SIZE(_lvar1)) &&                   \
                     (_svar = (typeof(_svar))LIST_ITEM((_lvar1), _index),1);  \
            ++(_index))

#define ILIST_FOR_EACH(_lvar1, _svar, _index)                   \
    for(_index = 0;                                             \
        ((_index) < LIST_SIZE(_lvar1)) &&                       \
                 (_svar = (typeof(_svar))ILIST_ITEM((_lvar1), _index),1);       \
        ++(_index))

#define ILIST_FOR_EACH_IGNORE_ANSI(_lvar1, _svar, _index)         \
    for(_index = 0;                                             \
        ((_index) < LIST_SIZE(_lvar1)) &&                       \
                 (_svar = (typeof(_svar))LIST_ITEM((_lvar1), _index),1);       \
        ++(_index))

     /**  The following list_for_each eval the list size only once at the beggining **/
#define PLIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
           for(_index = 0; \
               ((_index) < (_limit))  &&  \
	       (_svar = (typeof(_svar))PLIST_ITEM((_lvar1), _index),1); \
			      ++(_index))

#define ILIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
           for(_index = 0; \
               ((_index) < (_limit))  &&  \
	       (_svar = (typeof(_svar))ILIST_ITEM((_lvar1), _index),1); \
			      ++(_index))

#define PLIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	     for(_index = LIST_SIZE(_lvar1) - 1; \
		 ((_index) >= 0)  && ((_svar) = (typeof(_svar))PLIST_ITEM((_lvar1),(_index)),1); \
		  --(_index))

#define ILIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	     for(_index = LIST_SIZE(_lvar1) - 1; \
		 ((_index) >= 0)  && ((_svar) = (typeof(_svar))ILIST_ITEM((_lvar1),(_index)),1); \
		  --(_index))
#else
#define PLIST_FOR_EACH(_lvar1, _svar, _index)              \
        for(_index = 0;                                         \
            ((_index) < LIST_SIZE(_lvar1)) &&                   \
                     (_svar = PLIST_ITEM((_lvar1), _index),1);  \
            ++(_index))

#define PLIST_FOR_EACH_IGNORE_ANSI(_lvar1, _svar, _index)              \
        for(_index = 0;                                         \
            ((_index) < LIST_SIZE(_lvar1)) &&                   \
                     (_svar = LIST_ITEM((_lvar1), _index),1);  \
            ++(_index))

#define ILIST_FOR_EACH(_lvar1, _svar, _index)                   \
    for(_index = 0;                                             \
        ((_index) < LIST_SIZE(_lvar1)) &&                       \
                 (_svar = ILIST_ITEM((_lvar1), _index),1);       \
        ++(_index))

#define ILIST_FOR_EACH_IGNORE_ANSI(_lvar1, _svar, _index)         \
    for(_index = 0;                                             \
        ((_index) < LIST_SIZE(_lvar1)) &&                       \
                 (_svar = LIST_ITEM((_lvar1), _index),1);       \
        ++(_index))

     /**  The following list_for_each eval the list size only once at the beggining **/
#define PLIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
           for(_index = 0; \
               ((_index) < (_limit))  &&  \
	       (_svar = PLIST_ITEM((_lvar1), _index),1); \
			      ++(_index))

#define ILIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
           for(_index = 0; \
               ((_index) < (_limit))  &&  \
	       (_svar = ILIST_ITEM((_lvar1), _index),1); \
			      ++(_index))

#define PLIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	     for(_index = LIST_SIZE(_lvar1) - 1; \
		 ((_index) >= 0)  && ((_svar) = PLIST_ITEM((_lvar1),(_index)),1); \
		  --(_index))

#define ILIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	     for(_index = LIST_SIZE(_lvar1) - 1; \
		 ((_index) >= 0)  && ((_svar) = ILIST_ITEM((_lvar1),(_index)),1); \
		  --(_index))
#endif

#define PLIST_APPEND(_lto, _lfrom, _ltype)      \
    do { _ltype _elem; int _tmp;                \
        PLIST_FOR_EACH(_lfrom,_elem,_tmp) {     \
	    PLIST_ADD(_lto,_elem);              \
	}                                       \
    } while (0)

#define ILIST_APPEND(_lto, _lfrom, _ltype)      \
    do { _ltype _elem; int _tmp;                \
        ILIST_FOR_EACH(_lfrom,_elem,_tmp) {     \
	    ILIST_ADD(_lto,_elem);              \
	}                                       \
    } while (0)

#define FREE_MALLOCED_LIST(_list) { if((_list)->data) { sn_free(BACKWARD((_list)->data), SN_LIST); } sn_free(_list, SN_LIST); }

/* In Keyed list, if u wish to use the macro LIST_KEY_ADD, remember to
 first use the macro LIST_ADD, because LIST_KEY_ADD adds the key 
 to the hash and not to the list.*/
#define LIST_KEY_ADD(_lvar, _str) \
	sn_list_key_add_helper((t__plist)(_lvar), (SN_STRING)(intptr_t)(_str), LIST_SIZE(_lvar)-1)

#define LIST_KEY_POP(_lvar, _str) \
	sn_list_key_pop_helper((t__plist)(_lvar), (SN_STRING)(intptr_t)(_str))

#define LIST_KEY_IN(_lvar, _str)  \
	sn_list_key_in_helper((t__plist)(_lvar), (SN_STRING)(intptr_t)(_str))

#define LIST_KEY_GET(_lvar, _str) \
    (sn_list_key_get_helper((t__plist)(_lvar), (SN_STRING)(intptr_t)(_str)))

#define LIST_KEY_INDEX(_lvar, _str)  \
	sn_list_key_index_helper((t__plist)(_lvar), (SN_STRING)(intptr_t)(_str))

#define LIST_KEY_CLEAR(_lvar)  sn_list_key_clear_helper((t__plist)(_lvar))


#define ILIST_KEY_ADD_CHECK(_lvar2, _svar2, _str2, _error)        \
    do {if (LIST_KEY_IN(_lvar2,_str2)) sn_error(_error);           \
        ILIST_ADD(_lvar2,_svar2); LIST_KEY_ADD(_lvar2,_str2);} while (0)

#define PLIST_KEY_ADD_CHECK(_lvar2, _svar2, _str2, _error)        \
    do {if (LIST_KEY_IN(_lvar2,_str2)) sn_error(_error);           \
        PLIST_ADD(_lvar2,_svar2); LIST_KEY_ADD(_lvar2,_str2);} while (0)

#define HAS_A_KEY(_type) (IS_A_LIST(_type) && AS(t__list_descriptor, _type)->kind != key_kind__none)
#define FIELD_HAS_A_KEY(_field) (HAS_A_KEY((_field)->base_type))

#define KEY_KIND(_type) (AS(t__list_descriptor, _type)->kind)
#define FIELD_KEY_KIND(_field) (KEY_KIND((_field)->base_type))

#define IFIELD_OF_INDEX(_instance,_field) (*((int *) ((char *) (_instance) + _field->field_offset)))

#define PFIELD_OF_INDEX(_instance,_field) (*((intptr_t *) ((char *) (_instance) + _field->field_offset)))

#define FIELD_OF_KEY(_instance,_list_type) sn_field_of_key ((t__base_struct) _instance, (t__list_descriptor) _list_type)

/* TCMS */
#define IS_TCM_METHOD(_m) ((_m)->d__ == d__tcm)
#define IS_TCM(_ar) (index_is_a_child_of((_ar)->d__, d__script_instance))
#define AS_TCM(_ar) ((t__script_instance)(_ar))
#define AS_TCM_IF(_ar) (IS_TCM(_ar) ? AS_TCM(_ar) : NULL)

#define GLOB_CAR_ME(_m) ((t__any_struct)(IS_TCM(GLOB_CAR) ? AS_TCM(GLOB_CAR)->sn_owner : ((SN_TYPE(any_struct))(RHS_CAR_VALUE(LIST_ITEM((_m)->scope->locals,0))))))
#define EVAL_CAR_ME(_m) ((t__any_struct)(IS_TCM(GLOB_CAR) ? AS_TCM(GLOB_CAR)->sn_owner : ((SN_TYPE(any_struct))(LIST_ITEM(GLOB_CAR->sn_values, 0)))))
#define SET_LAST_SI_CAR(_ar) {sn_session->last_si = _ar; GLOB_CAR = _ar;}

/* pack */

#define DEBUG_CODE_GEN(_d_index,_exp_code) ((((t__debug)(GLOB->debug))->packing) ? sn_out(sf("> Packing %s: = any_to_string(%s,%s)",_exp_code,_d_index)) : (void) 0)

/* error messages */
#define ERROR_STRING(_exp) ((SN_STRING)DISPATCH(error_string,_exp,ntv,(_exp)))
#define SN_LONG SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))
#define SN_LIST_LONG SN_LIST(sn_vec)

/* #include list_ix.h */

#ifndef _LIST_IX_H_
#define _LIST_IX_H_

/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
# define SN_EXTERNC extern "C"
#else
# define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
# ifndef GCC
#  define GCC
# endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
# ifndef __TOKEN_MERGER__
#  define __TOKEN_MERGER__
# endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
# define _SN_ANSI_ARGS_(x)	x
#else
# define _SN_ANSI_ARGS_(x)	()
#endif

#define SN_PTR_ALIGNMENT_64 (3)
#define SN_PTR_ALIGNMENT_32 (2)

#if defined(LINUX_C) || defined(SOL_X86)
#define SN_LITTLE_ENDIAN
#else 
#define SN_BIG_ENDIAN
#endif

#include <inttypes.h>
#if defined(_LP64) || defined(__LP64__) || defined (__64BIT__)
# define SN_64_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_64)
#else /* defined(_LP64) || defined(__LP64__) || defined (__64BIT__) */
# define SN_32_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_32)
#endif /* defined(_LP64) || defined(__LP64__) */

#ifndef offsetof
# define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
#endif

#endif /* _CPP_H_ */



#ifdef _LIST_IX_C_

#endif /* _LIST_IX_C_ */
SN_EXTERNC t__plist make_new_list(int);

SN_EXTERNC t__ilist make_new_ilist_init_data(int);
SN_EXTERNC t__plist make_new_plist_init_data(int);

SN_EXTERNC void list_add_helper(t__ilist, bool);
SN_EXTERNC void plist_add_helper(t__plist, bool);

SN_EXTERNC void ilist_add_list_helper(t__ilist, t__ilist);
SN_EXTERNC void plist_add_list_helper(t__plist, t__plist);

SN_EXTERNC t__ilist ilist_get_index_list_helper(t__ilist, t__ilist);
SN_EXTERNC t__plist plist_get_index_list_helper(t__plist, t__ilist);

SN_EXTERNC t__ilist sn_ilist_copy_helper(t__ilist list);
SN_EXTERNC t__plist sn_plist_copy_helper(t__plist list);

SN_EXTERNC t__ilist sn_copy_ilist_by_index(t__ilist list,int list_type);
SN_EXTERNC t__plist sn_copy_plist_by_index(t__plist list,int list_type);
SN_EXTERNC void sn_byte_closest_power_fill(void);
SN_EXTERNC unsigned int sn_closest_power(unsigned int);
SN_EXTERNC SN_STRING ms1(SN_STRING);
SN_EXTERNC SN_STRING sn_str_hex(int);
SN_EXTERNC SN_STRING sn_str_bin(int);
SN_EXTERNC int *make_new_malloc_helper(int, int);

SN_EXTERNC void ilist_init_helper(t__ilist, int, bool, int, bool);
SN_EXTERNC void plist_init_helper(t__plist, int, bool, void*, bool);

SN_EXTERNC void sn_ilist_internal_init(t__ilist, int);
SN_EXTERNC void sn_plist_internal_init(t__plist, int);

SN_EXTERNC void ilist_init_malloc_helper(t__ilist, int);
SN_EXTERNC void plist_init_malloc_helper(t__plist, int);

SN_EXTERNC t__ilist ilist_reverse_helper(t__ilist);
SN_EXTERNC t__plist plist_reverse_helper(t__plist);

SN_EXTERNC void ilist_insert_helper(t__ilist, int, int);
SN_EXTERNC void plist_insert_helper(t__plist, int, void*);

SN_EXTERNC void ilist_insert_list_helper(t__ilist, int, t__ilist);
SN_EXTERNC void plist_insert_list_helper(t__plist, int, t__plist);

SN_EXTERNC int ilist_delete_helper(t__ilist, int);
SN_EXTERNC void* plist_delete_helper(t__plist, int);

SN_EXTERNC bool item_is_in_plist(void*, t__plist);

SN_EXTERNC void sn_packed_list_assign_slice(t__ilist, int,int,t__ilist,int,int,bool);
SN_EXTERNC void sn_ilist_assign_slice(t__ilist, int,int,t__ilist,int,int,bool);
SN_EXTERNC void sn_plist_assign_slice(t__plist, int,int,t__plist,int,int,bool);

SN_EXTERNC void ilist_assign_slice_to_slice(t__ilist, int, int, t__ilist, int, int);
SN_EXTERNC void plist_assign_slice_to_slice(t__plist, int, int, t__plist, int, int);

struct s__sn__field;
struct s__sn__base_struct;
struct s__l__sn__base_struct;
struct s__sn__list_descriptor;

SN_STRING sn_field_of_key (struct s__sn__base_struct *, struct s__sn__list_descriptor *);
SN_EXTERNC void sn_check_list_index(t__ilist list, int index);
SN_EXTERNC t__plist sn_fake_plist_get_slice(t__plist list, int from,int  to);
#endif /* _LIST_IX_H_ */
/* #include list_key.h */
#ifndef LIST_KEY_H
#define LIST_KEY_H

/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
# define SN_EXTERNC extern "C"
#else
# define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
# ifndef GCC
#  define GCC
# endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
# ifndef __TOKEN_MERGER__
#  define __TOKEN_MERGER__
# endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
# define _SN_ANSI_ARGS_(x)	x
#else
# define _SN_ANSI_ARGS_(x)	()
#endif

#define SN_PTR_ALIGNMENT_64 (3)
#define SN_PTR_ALIGNMENT_32 (2)

#if defined(LINUX_C) || defined(SOL_X86)
#define SN_LITTLE_ENDIAN
#else 
#define SN_BIG_ENDIAN
#endif

#include <inttypes.h>
#if defined(_LP64) || defined(__LP64__) || defined (__64BIT__)
# define SN_64_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_64)
#else /* defined(_LP64) || defined(__LP64__) || defined (__64BIT__) */
# define SN_32_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_32)
#endif /* defined(_LP64) || defined(__LP64__) */

#ifndef offsetof
# define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
#endif

#endif /* _CPP_H_ */


/* #include map.h */
#ifndef MAP_H
#define MAP_H

extern void (*sn_w_map_init) (void **);
extern void **(*sn_w_map_get_addr) (void **, void *key);
extern void **(*sn_w_map_insert_addr) (void **, void *key);
extern int (*sn_w_map_delete) (void **, void *key);
extern void (*sn_w_map_free_data) (void **);
extern size_t (*sn_w_map_mem_used) (void **);
extern int (*sn_w_map_is_empty) (void **);

typedef void (*sn_w_map_cb_t) (void *key, void **value_addr, void *cb_data);
extern void (*sn_w_map_for_each) (void **, sn_w_map_cb_t callback, void *cb_data);

extern void (*sn_s_map_init) (void **);
extern void **(*sn_s_map_get_addr) (void **, char *key);
extern void **(*sn_s_map_insert_addr) (void **, char *key);
extern int (*sn_s_map_delete) (void **, char *key);
extern void (*sn_s_map_free_data) (void **);
extern size_t (*sn_s_map_mem_used) (void **);
extern int (*sn_s_map_is_empty) (void **);

extern void (*sn_a_map_init) (void **);
extern void **(*sn_a_map_get_addr) (void **, void *key, size_t key_size);
extern void **(*sn_a_map_insert_addr) (void **, void *key, size_t key_size);
extern int (*sn_a_map_delete) (void **, void *key, size_t key_size);
extern void (*sn_a_map_free_data) (void **);
extern size_t (*sn_a_map_mem_used) (void **);
extern int (*sn_a_map_is_empty) (void **);

void sn_init_map_functions (char*);

#endif /* MAP_H */

struct s__plist;

void sn_list_key_add_helper(struct s__plist *, char *, int);
void sn_list_key_pop_helper(struct s__plist *, char *);
void sn_list_key_clear_helper(struct s__plist *);
bool sn_list_key_in_helper(struct s__plist *, char *);
int sn_list_key_index_helper(struct s__plist *, char *);
intptr_t sn_list_key_get_helper(struct s__plist *, char *);

typedef struct sn_dl_chain_link_t {
    struct sn_dl_chain_link_t *prev;
    struct sn_dl_chain_link_t *next;
} sn_dl_chain_link_t;

typedef struct sn_key_map_t {
    void *map;
    uintptr_t flags;
    sn_dl_chain_link_t link;
} sn_key_map_t;

#define SN_HOOKED_UP_KEYMAP(link) \
    ((sn_key_map_t *) ((char *) (link) - offsetof (sn_key_map_t, link)))

/* be sure to keep this in sync with the "key_kind" enum! */
#define SN_KEY_KIND_NONE 0  /* For non key */
#define SN_KEY_KIND_STRING 1  /* For string keys */
#define SN_KEY_KIND_INT 2  /* For int keys */
#define SN_KEY_KIND_WORD 3  /* For struct keys */
#define SN_KEY_KIND_LONG 4  /* For long keys */
#define SN_KEY_KIND_FLOAT 5  /* For float keys */
#define SN_KEY_KIND_DOUBLE 6  /* For double keys */

#define SN_KEY_MAP_KIND(km) ((int) ((km)->flags & (uintptr_t) 0x7))
#define SN_KEY_MAP_SET_KIND(km,kind) do {       \
        (km)->flags &= ~(uintptr_t) 0x7;        \
        (km)->flags |= (uintptr_t) kind & 0x7;  \
    } while (0)
#define SN_KEY_MAP_OWN_MAP(km) ((int) (((km)->flags & (uintptr_t) 0x8) >> 3))
#define SN_KEY_MAP_SET_OWN_MAP(km,value) do {           \
        (km)->flags &= ~(uintptr_t) 0x8;                \
        (km)->flags |= (uintptr_t) (value != 0) << 3;   \
    } while (0)

sn_key_map_t *sn_make_key_map (struct s__plist *list, int key_kind);
void sn_ensure_key_map (struct s__plist *list, int key_kind);

void sn_build_key_map (struct s__plist *list);
void sn_build_key_map_no_check (struct s__plist *list);
void sn_create_keys_for_range (struct s__plist *list, int from, int to);
void sn_list_rekey_starting_from (struct s__plist *, int start_idx, int inserted_length);
void sn_copy_keymap_reversed (struct s__plist *to, struct s__plist *from);
void sn_free_list_key_map (struct s__plist *);
void sn_clear_key_map (sn_key_map_t *);

#endif /* LIST_KEY_H */

#endif /* LIST_H */

/* #include list_key.h */
#ifndef LIST_KEY_H
#define LIST_KEY_H

/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
# define SN_EXTERNC extern "C"
#else
# define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
# ifndef GCC
#  define GCC
# endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
# ifndef __TOKEN_MERGER__
#  define __TOKEN_MERGER__
# endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
# define _SN_ANSI_ARGS_(x)	x
#else
# define _SN_ANSI_ARGS_(x)	()
#endif

#define SN_PTR_ALIGNMENT_64 (3)
#define SN_PTR_ALIGNMENT_32 (2)

#if defined(LINUX_C) || defined(SOL_X86)
#define SN_LITTLE_ENDIAN
#else 
#define SN_BIG_ENDIAN
#endif

#include <inttypes.h>
#if defined(_LP64) || defined(__LP64__) || defined (__64BIT__)
# define SN_64_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_64)
#else /* defined(_LP64) || defined(__LP64__) || defined (__64BIT__) */
# define SN_32_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_32)
#endif /* defined(_LP64) || defined(__LP64__) */

#ifndef offsetof
# define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
#endif

#endif /* _CPP_H_ */


/* #include map.h */
#ifndef MAP_H
#define MAP_H

extern void (*sn_w_map_init) (void **);
extern void **(*sn_w_map_get_addr) (void **, void *key);
extern void **(*sn_w_map_insert_addr) (void **, void *key);
extern int (*sn_w_map_delete) (void **, void *key);
extern void (*sn_w_map_free_data) (void **);
extern size_t (*sn_w_map_mem_used) (void **);
extern int (*sn_w_map_is_empty) (void **);

typedef void (*sn_w_map_cb_t) (void *key, void **value_addr, void *cb_data);
extern void (*sn_w_map_for_each) (void **, sn_w_map_cb_t callback, void *cb_data);

extern void (*sn_s_map_init) (void **);
extern void **(*sn_s_map_get_addr) (void **, char *key);
extern void **(*sn_s_map_insert_addr) (void **, char *key);
extern int (*sn_s_map_delete) (void **, char *key);
extern void (*sn_s_map_free_data) (void **);
extern size_t (*sn_s_map_mem_used) (void **);
extern int (*sn_s_map_is_empty) (void **);

extern void (*sn_a_map_init) (void **);
extern void **(*sn_a_map_get_addr) (void **, void *key, size_t key_size);
extern void **(*sn_a_map_insert_addr) (void **, void *key, size_t key_size);
extern int (*sn_a_map_delete) (void **, void *key, size_t key_size);
extern void (*sn_a_map_free_data) (void **);
extern size_t (*sn_a_map_mem_used) (void **);
extern int (*sn_a_map_is_empty) (void **);

void sn_init_map_functions (char*);

#endif /* MAP_H */

struct s__plist;

void sn_list_key_add_helper(struct s__plist *, char *, int);
void sn_list_key_pop_helper(struct s__plist *, char *);
void sn_list_key_clear_helper(struct s__plist *);
bool sn_list_key_in_helper(struct s__plist *, char *);
int sn_list_key_index_helper(struct s__plist *, char *);
intptr_t sn_list_key_get_helper(struct s__plist *, char *);

typedef struct sn_dl_chain_link_t {
    struct sn_dl_chain_link_t *prev;
    struct sn_dl_chain_link_t *next;
} sn_dl_chain_link_t;

typedef struct sn_key_map_t {
    void *map;
    uintptr_t flags;
    sn_dl_chain_link_t link;
} sn_key_map_t;

#define SN_HOOKED_UP_KEYMAP(link) \
    ((sn_key_map_t *) ((char *) (link) - offsetof (sn_key_map_t, link)))

/* be sure to keep this in sync with the "key_kind" enum! */
#define SN_KEY_KIND_NONE 0  /* For non key */
#define SN_KEY_KIND_STRING 1  /* For string keys */
#define SN_KEY_KIND_INT 2  /* For int keys */
#define SN_KEY_KIND_WORD 3  /* For struct keys */
#define SN_KEY_KIND_LONG 4  /* For long keys */
#define SN_KEY_KIND_FLOAT 5  /* For float keys */
#define SN_KEY_KIND_DOUBLE 6  /* For double keys */

#define SN_KEY_MAP_KIND(km) ((int) ((km)->flags & (uintptr_t) 0x7))
#define SN_KEY_MAP_SET_KIND(km,kind) do {       \
        (km)->flags &= ~(uintptr_t) 0x7;        \
        (km)->flags |= (uintptr_t) kind & 0x7;  \
    } while (0)
#define SN_KEY_MAP_OWN_MAP(km) ((int) (((km)->flags & (uintptr_t) 0x8) >> 3))
#define SN_KEY_MAP_SET_OWN_MAP(km,value) do {           \
        (km)->flags &= ~(uintptr_t) 0x8;                \
        (km)->flags |= (uintptr_t) (value != 0) << 3;   \
    } while (0)

sn_key_map_t *sn_make_key_map (struct s__plist *list, int key_kind);
void sn_ensure_key_map (struct s__plist *list, int key_kind);

void sn_build_key_map (struct s__plist *list);
void sn_build_key_map_no_check (struct s__plist *list);
void sn_create_keys_for_range (struct s__plist *list, int from, int to);
void sn_list_rekey_starting_from (struct s__plist *, int start_idx, int inserted_length);
void sn_copy_keymap_reversed (struct s__plist *to, struct s__plist *from);
void sn_free_list_key_map (struct s__plist *);
void sn_clear_key_map (sn_key_map_t *);

#endif /* LIST_KEY_H */
/* #include type.h */
    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef TYPE_H
#define TYPE_H

#define DISPATCH_BY_INDEX(_m_ind, _v, _params) \
    ( sn_dispatch_tables[_v->d__][_m_ind]_params)

#ifdef __TOKEN_MERGER__

#define SN_CAST_DISPATCH(_m, _t) (cast_##m__##_t##__##_m)

#define DISPATCH(_m, _v, _t, _params) \
    ((SN_CAST_DISPATCH(_m,_t) (sn_dispatch_tables[_v->d__][m__##_t##__##_m]))_params)
        /* E.g. DISPATCH(print_it, my_house, house, (my_house, 3)) */

#define DISPATCH_CAREFULLY(_m, _v, _t, _params) \
    ((SN_CAST_DISPATCH(_m,_t) (sn_dispatch_tables[sn_d_index ((t__sn__base_struct) (_v))][m__##_t##__##_m]))_params)

#define DISPATCH_ON_DESCRIPTOR(_m, _d, _t, _params) \
    ((SN_CAST_DISPATCH(_m,_t) (sn_dispatch_tables[_d->d_index][m__##_t##__##_m]))_params)
/* E.g. DISPATCH_ON_DESCRIPTOR(print_it, descriptor, house, (descriptor, 3)) */

#else /* __TOKEN_MERGER__ */

#define SN_CAST_DISPATCH(_m, _t) (cast_/**/m__/**/_t/**/__/**/_m)

#define DISPATCH(_m, _v, _t, _params) \
        ((SN_CAST_DISPATCH(_m,_t) (sn_dispatch_tables[_v->d__][m__/**/_t/**/__/**/_m]))_params)
        /* E.g. DISPATCH(print_it, my_house, house, (my_house, 3)) */

#define DISPATCH_ON_DESCRIPTOR(_m, _d, _t, _params) \
          ((SN_CAST_DISPATCH(_m,_t) (sn_dispatch_tables[_d->d_index][m__/**/_t/**/__/**/_m]))_params)
          /* E.g. DISPATCH_ON_DESCRIPTOR(print_it, descriptor, house, (descriptor, 3)) */

#endif /* __TOKEN_MERGER__ */

#define SN_SYS (SYS)

#define SN_SN_DISPATCH(_m, _v, _t, _params) DISPATCH(_m,_v,_t,_params)

#ifdef __TOKEN_MERGER__
#define SN_TYPE_ID(type) d__##type
#define SN_LIST_TYPE_ID(type) d__l__##type
#define SN_TYPE(type) t__##type
#define SN_LIST(type) l__##type
#define SN_ENUM_DUMMY(type,val) type##__##val
#define SN_ENUM(type,val) SN_ENUM_DUMMY(type,val)
#define SN_DEFINE(name) SNDEF__##name
#define SN_QUALIFIED_NAME(package,type) package##__##type
#define t__SN_QUALIFIED_NAME(package,type) t__##package##__##type
#define l__SN_QUALIFIED_NAME(package,type) l__##package##__##type
#define d__SN_QUALIFIED_NAME(package,type) d__##package##__##type
#define m__SN_QUALIFIED_NAME(package,type) m__##package##__##type
#else /* __TOKEN_MERGER__ */
#define SN_TYPE_ID(type) d__/* */type
#define SN_LIST_TYPE_ID(type) d__l__/* */type
#define SN_TYPE(type) t__/* */type
#define SN_LIST(type) l__/* */type
#define SN_ENUM_DUMMY(type,val) type/* */__/* */val
#define SN_ENUM(type,val) SN_ENUM_DUMMY(type,val)
#define SN_DEFINE(name) SNDEF__/* */name
#define SN_QUALIFIED_NAME(package,type) package/* */__/* */type
#define t__SN_QUALIFIED_NAME(package,type) t__/* */package/* */__/* */type
#define l__SN_QUALIFIED_NAME(package,type) l__/* */package/* */__/* */type
#define d__SN_QUALIFIED_NAME(package,type) d__/* */package/* */__/* */type
#define m__SN_QUALIFIED_NAME(package,type) m__/* */package/* */__/* */type
#endif /* __TOKEN_MERGER__ */

#define DISPATCH1(_m1, _v1, _t1) DISPATCH(_m1,_v1,_t1,(_v1))
        /* E.g. DISPATCH1(print_it, my_house, house) */

#define DISPATCH1_CAREFULLY(_m1, _v1, _t1) DISPATCH_CAREFULLY(_m1,_v1,_t1,(_v1))

#define TYPE(_v) LIST_ITEM(GLOB->all_types,(_v)->d__)
        /* The type descriptor of that var */

#define DTYPE(_d) LIST_ITEM(GLOB->all_types,_d)
        /* The type descriptor of the d_index */

#define STRUCT_TYPE(_v1) AS(t__struct_descriptor, TYPE(_v1))
        /* The struct descriptor of that var (no checking that it is a struct */
#define LIST_TYPE(_v1) AS(t__sn__list_descriptor, TYPE(_v1))
        /* The list descriptor of that var (no checking that it is a struct */

#define T_NAME(_td) ((SN_STRING)DISPATCH(c_name,_td,type_descriptor,(_td)))


#define SN_AS_A_CHILD_OF(it, type) ((SN_TYPE(type)) as_a_child_of((SN_TYPE(base_struct))it, SN_TYPE_ID(type)))

#define FIELD_NO(_d_index, _field_no) LIST_ITEM(AS(t__sn__struct_descriptor,LIST_ITEM(GLOB->all_types,_d_index))->fields,_field_no)
        /* A way to access a field at runtime */

#define FIELD_BY_ID(_global_id) LIST_ITEM(GLOB_ST->all_fields,_global_id)

#define METHOD_NO(_d_index, _method_no) LIST_ITEM(AS(t__sn__struct_descriptor,LIST_ITEM(GLOB->all_types,_d_index))->methods,_method_no)
        /* A way to access a method at runtime */

#define GET_PRINTED_NAME(_td) ((SN_STRING)DISPATCH1(get_printed_name,_td,type_descriptor))
#define IS_STRING(_td)  ((_td) && ((_td)->short_type == short_type__STRING_TYPE))
#define IS_ENUM(_td)   ((_td) && (_td)->short_type == short_type__ENUM_TYPE)
#define IS_INT(_td)    ((_td) && (_td)->short_type == short_type__INT_TYPE)
#define IS_UINT(_td)    ((_td) && (_td)->short_type == short_type__UINT_TYPE)
#define IS_LONG_INT(_td) (_td->d_index == d__long_int)
#define IS_BOOL(_td)    ((_td) && (_td)->short_type == short_type__BOOL_TYPE)
#define IS_LIST(_td)    ((_td) && (_td)->d__ == d__list_descriptor)
#define IS_COMPOUND(_td)((_td) && (_td)->short_type == short_type__STRUCT_TYPE)
#define IS_STRUCT(_td)  (IS_COMPOUND(_td) && !IS_LIST(_td))
#define IS_SUBTYPE(_td) ((_td) && (_td)->d__ == d__subtype_descriptor)
#define IS_FOREIGN(_td) ((_td) && (_td)->short_type == short_type__OTHER_TYPE \
                         && (_td)->d_index != d__untyped)
#define IS_SCALAR(_td)  (IS_INT(_td) ||		\
			   IS_UINT(_td) ||		\
			   IS_ENUM(_td) ||		\
			   IS_BOOL(_td))
#define IS_REAL_STRUCT(_td) ((_td) && IS_COMPOUND(_td) && (!IS_LIST(_td)) && (!IS_LONG(_td)) && (!IS_DOUBLE(_td)))
#define IS_LESS_THAN_32(td) (td->size_in_bits>0 && td->size_in_bits<32)

bool sn_is_long_int(int d_index);

/* to be replaced shortly */
#define IS_A_STRING(_td) IS_STRING(_td)
#define IS_A_LIST(_td) IS_LIST(_td)
#define IS_A_STRUCT(_td) IS_STRUCT(_td)
#define IS_UNTYPED(_td) ((_td) && ((_td)->d_index == d__untyped))
#define IS_A_PLIST_ELEM(_td) (!(IS_SCALAR(_td)) || sn_is_long_int(_td->d_index))
#define IS_A_PLIST(_ld) (IS_A_PLIST_ELEM(ELEM_TYPE(_ld)))
#define IS_A_POINTER(_td) (!(IS_SCALAR(_td)))
/* #define IS_LIST_A_PLIST(_list) IS_A_PLIST(TYPE(_list)) */

#define SN_UNTYPED SN_TYPE(untyped)

#define ELEM_TYPE(_list) (AS(t__sn__list_descriptor, _list)->base_type)

#define LIST_ELEM_TYPE(_list) ((t__sn__type_descriptor)ELEM_TYPE(TYPE(_list)))

#define IS_UNSIGNED(_td) ((_td)->short_type == short_type__UINT_TYPE || (_td)->short_type == short_type__ENUM_TYPE || (_td)->short_type == short_type__BOOL_TYPE)
        /* All others are considered signed */

#define GET_IFIELD(_pointer, _field) (*(int *)(((char*)(_pointer)) + ((_field)->field_offset)))
   /* _pointer is a pointer to a struct ,
        +2 for the hidden fields: gen__ and d__ */

#define GET_PFIELD(_pointer, _field) (*(intptr_t *)(((char*)(_pointer)) + ((_field)->field_offset)))
   /* _pointer is a pointer to a struct ,
        +2 for the hidden fields: gen__ and d__ */

#define SN_GET_PFIELD(_ptr, _field, _type) (*(_type *)(((char*)(_ptr)) + ((_field)->field_offset)))

#define GET_FIELD_ADDR(_pointer, _field) (((char*)(_pointer)) + ((_field)->field_offset))

#define RHS_GET_FIELD(_pointer, _field) (t__untyped) ( \
    (!IS_A_PLIST_ELEM(_field->base_type)) ? \
      ((intptr_t)GET_IFIELD(_pointer, _field)) :  \
      (GET_PFIELD(_pointer, _field)))

#define GET_IFIELD_BY_OFF(_pointer, _off) (*(int *)(((char*)(_pointer)) + (_off)))
#define GET_PFIELD_BY_OFF(_pointer, _off) (*(intptr_t *)(((char*)(_pointer)) + (_off)))
   /* _pointer is a pointer to a struct ,
        +2 for the hidden fields: gen__ and d__ */

#define SN_IS_LP64 ((sizeof(int) != sizeof (int *)))


#define SAFE_GET_FIELD(_pointer, _field) safe_get_field_helper(_pointer, _field)

#define MAKE_NEW_ACTION(act, sr_src) \
    MAKE_NEW(act, d__n__action); \
    (act)->source_ref = (sr_src)->source_ref;


#ifdef __TOKEN_MERGER__
/* -- Some definitions for writing macro methods */
#define DISPATCH_ME(_m, _v, _t, _params)  \
    ( sn_dispatch_tables[me->n__##_v->d__][m__n__##_t##__##_m]_params)
        /* Like DISPATCH(), but on me->n__xxx */
        /* E.g. DISPATCH_ME(do_update, second__exp, exp, (second__exp, so)) */

#define DISPATCH_EACH(_m1, _var, _field, _params1) \
    { \
        t__n__##_field _var; int _temp;\
        PLIST_FOR_EACH(me->n__##_field##s,_var,_temp) { \
            DOING(_var); \
            DISPATCH(_m1,_var,n__##_field,_params1); \
            DOING(me); \
        } \
    }
        /* Dispatch each _field (call it _var) using _method with _params */
        /* E.g. DISPATCH_EACH(do_update, sm, struct_memeber, (sm, me->sd)) */

#define DISPATCH_ME1(_m1, _v1, _t1)  \
        DISPATCH_ME(_m1,_v1,_t1,(me->n__##_v1))
        /* Like DISPATCH1(), but on me->n__xxx */
        /* E.g. DISPATCH_ME1(do_update, second__exp, exp) */

#else /* __TOKEN_MERGER__ */

/* -- Some definitions for writing macro methods */
#define DISPATCH_ME(_m, _v, _t, _params)  \
    ( sn_dispatch_tables[me->n__/**/_v->d__][m__n__/**/_t/**/__/**/_m]_params)
        /* Like DISPATCH(), but on me->n__xxx */
        /* E.g. DISPATCH_ME(do_update, second__exp, exp, (second__exp, so)) */

#define DISPATCH_EACH(_m1, _var, _field, _params1) \
    { \
        t__n__/**/_field _var; int _temp;\
        PLIST_FOR_EACH(me->n__/**/_field/**/s,_var,_temp) { \
            DOING(_var); \
            DISPATCH(_m1,_var,n__/**/_field,_params1); \
            DOING(me); \
        } \
    }
        /* Dispatch each _field (call it _var) using _method with _params */
        /* E.g. DISPATCH_EACH(do_update, sm, struct_memeber, (sm, me->sd)) */

#define DISPATCH_ME1(_m1, _v1, _t1)  \
        DISPATCH_ME(_m1,_v1,_t1,(me->n__/**/_v1))
        /* Like DISPATCH1(), but on me->n__xxx */
        /* E.g. DISPATCH_ME1(do_update, second__exp, exp) */
#endif /* __TOKEN_MERGER__ */

#define UPDATE_TYPE_FIELD(_struct,_field,_value)        {                       \
        SN_TYPE(SN_QUALIFIED_NAME(sn,struct_descriptor)) ccc_sd;                                      \
        SN_TYPE(SN_QUALIFIED_NAME(sn,struct_descriptor)) ccc_child;                                   \
        int i;                                                                  \
        for(ccc_sd = _struct;IS_SUBTYPE(ccc_sd);				\
	    ccc_sd = (SN_TYPE(SN_QUALIFIED_NAME(sn,struct_descriptor)))ccc_sd->parent) { 		\
		; /* do nothing */						\
	}   									\
        ccc_sd->_field = _value;                                                \
        PLIST_FOR_EACH(ccc_sd->children,ccc_child,i) {                           \
                if(IS_SUBTYPE(ccc_child) &&                                     \
                   (SN_TYPE(SN_QUALIFIED_NAME(sn,struct_descriptor)))DISPATCH(subtype_parent,ccc_child,struct_descriptor,(ccc_child)) == ccc_sd) {               \
                        ccc_child->_field = _value;                             \
                }                                                               \
        }                                                                       \
}

extern sn_routine_pointer_type **sn_dispatch_tables;

#define	SN_ALIGN_POWER(addr, align) (((addr) + ((1<<(align))-1)) & (-1L << (align)))

#define SN_GET_ATTR(_obj,_attr_num) (((_obj)->sn_attr & (1<<(_attr_num)))!=0)
#define SN_SET_ATTR(_obj,_attr_num) ((_obj)->sn_attr |= (1<<(_attr_num)))
#define SN_RESET_ATTR(_obj,_attr_num) ((_obj)->sn_attr &= ~(1<<(_attr_num)))

#define STRUCT_MEMBER_STRUCT_PRIVATE 0
#define STRUCT_MEMBER_PACKAGE_PRIVATE 1
#define STRUCT_MEMBER_HIDDEN 2
#define STRUCT_MEMBER_ATTR 2

#define FIELD_PHYSICAL STRUCT_MEMBER_ATTR +1
#define FIELD_INSTANCE STRUCT_MEMBER_ATTR +2
#define FIELD_GENERATABLE STRUCT_MEMBER_ATTR +3
#define FIELD_NOT_UNIQUE STRUCT_MEMBER_ATTR +4
#define FIELD_SIZED STRUCT_MEMBER_ATTR +5
#define FIELD_CONST STRUCT_MEMBER_ATTR +6
#define FIELD_CONST_DETR STRUCT_MEMBER_ATTR +7
#define FIELD_SOFT_CONST STRUCT_MEMBER_ATTR +8
#define FIELD_SVTP_PACK_H STRUCT_MEMBER_ATTR +9
#define FIELD_SVTP_PACK_L STRUCT_MEMBER_ATTR +10

#define METHOD_MAIN STRUCT_MEMBER_ATTR +1
#define METHOD_UNTRACEABLE STRUCT_MEMBER_ATTR +2
#define METHOD_INLINE STRUCT_MEMBER_ATTR +3
#define METHOD_FINAL STRUCT_MEMBER_ATTR + 4
#define METHOD_INTERMAL STRUCT_MEMBER_ATTR + 5
#define METHOD_COMPILED STRUCT_MEMBER_ATTR + 6
#define METHOD_EMPTY STRUCT_MEMBER_ATTR + 7
#define METHOD_UNDEFINED STRUCT_MEMBER_ATTR + 8
#define METHOD_NO_LONG_OPT STRUCT_MEMBER_ATTR + 9
#define METHOD_AS_ATTR STRUCT_MEMBER_ATTR + 10
#define METHOD_AS_UNIT_ONLY_ATTR STRUCT_MEMBER_ATTR + 11
#define METHOD_AS_UNDEF_ATTR STRUCT_MEMBER_ATTR + 12

#define EVENT_HAS_REFERENCE  STRUCT_MEMBER_ATTR + 1

#define CONSTRAINT_INTERNAL STRUCT_MEMBER_ATTR +1


#define EXP_ATTR 0
#define LHS_EXP EXP_ATTR
#define PREPARE_EXP EXP_ATTR + 1
#define INDIRECT_EXP EXP_ATTR + 2
#define SYNTHETIC_EXP EXP_ATTR + 3
#define HAS_PARENTHESIS EXP_ATTR + 4


#define ACTION_ATTR 0
#define SINGLE_VAR_REPARSE_BLOCK ACTION_ATTR

#define STRUCT_LOCAL_ATTR 0

#define LOCAL_ASSIGN STRUCT_LOCAL_ATTR /* TODO add documentation  */


#define INIT_IN_DEC STRUCT_LOCAL_ATTR+1       /* whether initialization is required at declaration */
#define LOCAL_ACCESSED STRUCT_LOCAL_ATTR+2    /* whether local was previous accessed (read\write) */
#define INIT_CODE_WRITTEN STRUCT_LOCAL_ATTR+3 /* whether the init code for this local has been added */
#define IS_METHOD_RESULT STRUCT_LOCAL_ATTR+4  /* whether this local is the result of a method */
#define LOCAL_ON_STACK STRUCT_LOCAL_ATTR+5
#define LOCAL_EA_READ STRUCT_LOCAL_ATTR+6 
#define LOCAL_EA_WRITE STRUCT_LOCAL_ATTR+7
#define LOCAL_EA_MODIFY STRUCT_LOCAL_ATTR+8  /* local-list.add(value), local-list.reverse(), etc*/

#define RESET_ASSIGNED_LOCAL(_local)  SN_RESET_ATTR(_local, LOCAL_ASSIGN)
#define SET_ASSIGNED_LOCAL(_local)    SN_SET_ATTR(_local, LOCAL_ASSIGN)
#define IS_ASSIGNED_LOCAL(_local) SN_GET_ATTR(_local, LOCAL_ASSIGN)

#define UNINITIALIZED_ENUM_VALUE (0xfffffff3)
#endif /* TYPE_H */


/* #include mm_ix.h */
#ifndef DONT_INCLUDE_MM_IX
#ifndef MM_IX_H_
#define MM_IX_H_

#ifdef MM_H_
You should not include both mm.h and mm_ix.h
#endif

/* profiling */

/* #include mm__common.h */
#ifndef MM__COMMON_H_
#define MM__COMMON_H_

/* #include sn_alloc.h */
#ifndef SN_ALLOC_H
#define SN_ALLOC_H

#include <stdlib.h>
/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
# define SN_EXTERNC extern "C"
#else
# define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
# ifndef GCC
#  define GCC
# endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
# ifndef __TOKEN_MERGER__
#  define __TOKEN_MERGER__
# endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
# define _SN_ANSI_ARGS_(x)	x
#else
# define _SN_ANSI_ARGS_(x)	()
#endif

#define SN_PTR_ALIGNMENT_64 (3)
#define SN_PTR_ALIGNMENT_32 (2)

#if defined(LINUX_C) || defined(SOL_X86)
#define SN_LITTLE_ENDIAN
#else 
#define SN_BIG_ENDIAN
#endif

#include <inttypes.h>
#if defined(_LP64) || defined(__LP64__) || defined (__64BIT__)
# define SN_64_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_64)
#else /* defined(_LP64) || defined(__LP64__) || defined (__64BIT__) */
# define SN_32_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_32)
#endif /* defined(_LP64) || defined(__LP64__) */

#ifndef offsetof
# define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
#endif

#endif /* _CPP_H_ */



#ifdef __cplusplus
extern "C" {
#endif

/* In order to avoid recompilation of libs, items should only be added 
   (before LAST_ID), not removed */
typedef enum {
  SN_MISC = 0, 
  SN_UNKNOWN = 0,
  SN_USER,
  SN_MM,
  SN_CUDD,
  SN_ADAPTER,
  SN_LIST, 
  SN_EPI,
  SN_JUDY,
  SN_DTABLE,
  SN_MM_DATA,
  SN_LAST_ID
} sn_subsystem_id;


void* sn_calloc (size_t nmemb, size_t size, sn_subsystem_id id);
void* sn_malloc (size_t size, sn_subsystem_id id);
void* sn_realloc (void *ptr, size_t size, sn_subsystem_id id);
char* sn_strdup(const char *s1, sn_subsystem_id id);
void* sn_mmap (size_t size, sn_subsystem_id id);
void* sn_cmmap (size_t size, sn_subsystem_id id);
void  sn_free (void *ptr, sn_subsystem_id id);
void  sn_munmap (void *ptr, size_t size, sn_subsystem_id id);
void  alloc_gc_backup_memory();

void sn_print_mem_usage();  
void sn_print_mem_total();

#ifdef __cplusplus
}
#endif

#endif /* SN_ALLOC_H */
/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */

typedef enum {
    sn_block_PTRFREE = 0,
    sn_block_TYPED = 1,
    sn_block_STRING = 2,
    sn_block_BP = 3
} sn_block_type_t;

#define SN_N_BLOCK_TYPES 4

typedef uintptr_t sn_word_t;

#define SN_WORD_SIZE sizeof (sn_word_t)
#define SN_WORD_BIT_SIZE (SN_WORD_SIZE * 8)
#define SN_WORD_ADDR_MASK (~(SN_WORD_SIZE - 1))
#define SN_BYTES2WORDS(x) (((x) / SN_WORD_SIZE) + (((x) & (SN_WORD_SIZE - 1)) + SN_WORD_SIZE - 1) / SN_WORD_SIZE)
#define SN_BYTES2INTS(x) (((x) / sizeof (int)) + (((x) & (sizeof (int) - 1)) + sizeof (int) - 1) / sizeof (int))

struct sn_allocator_t;
struct s__plist;

#define SN_FORWARD_MASK ((uintptr_t) 1 << (SN_WORD_BIT_SIZE - 1))

#define SN_IS_FORWARDED(x)                      \
    (((uintptr_t *) (x)) [0] & SN_FORWARD_MASK)
#define SN_FORWARD_TARGET_(x)                   \
    ((t__base_struct) ((((uintptr_t *) (x)) [0]) << 2))

#if SN_FILTER_COMPILE_COND(heavy)
#ifdef MM_H_
# define SN_FORWARD_TARGET(from) (mm_sn_forward_target ((t__base_struct) from))
#endif
#ifdef MM_IX_H_
# define SN_FORWARD_TARGET(from) (sn_forward_target ((t__base_struct) from))
#endif
#else
# define SN_FORWARD_TARGET SN_FORWARD_TARGET_
#endif

#define SN_FORWARD(from,to)                                             \
    (((uintptr_t *) (from)) [0] = SN_FORWARD_MASK | (((uintptr_t) (to)) >> 2))
#define SN_FORWARD_TARGET_IF_ANY(from)                                  \
    (SN_IS_FORWARDED (from) ? SN_FORWARD_TARGET (from) : (t__base_struct) NULL)

#define SN_STRUCT_SIZE_IN_BYTES(sd) (sn_type_descriptor_get_size_in_bytes(sd))

extern int sn_currently_in_simulator__;

#ifdef MM_IX_H_
#define SN_GC_REGISTER_ROOT(x) sn_gc_register_root_range (&(x), 1)
#endif
#ifdef MM_H_
#define SN_GC_REGISTER_ROOT(x) mm_sn_gc_register_root_range (&(x), 1)
#endif

#ifdef MM_IX_H_
#define SN_SIM_ENTER_SPECMAN(addr) do {         \
        sn_currently_in_simulator__ = 0;        \
        sn_gc_bite(addr);                       \
    } while (0)
#endif
#ifdef MM_H_
#define SN_SIM_ENTER_SPECMAN(addr) do {         \
        sn_currently_in_simulator__ = 0;        \
        mm_sn_gc_bite(addr);                       \
    } while (0)
#endif

#ifdef MM_IX_H_
#define SN_SIM_EXIT_SPECMAN do {                \
        sn_gc_spit_out();                         \
        sn_currently_in_simulator__ = 1;        \
    } while (0)
#endif
#ifdef MM_H_
#define SN_SIM_EXIT_SPECMAN do {                \
        mm_sn_gc_spit_out();                         \
        sn_currently_in_simulator__ = 1;        \
    } while (0)
#endif

#define DEBUG_GC(string)	do {if (gc->print_debug_msgs) print_to_screen_and_log(string); } while (0)

extern unsigned int sn_gc_mem_prof_segments;

#endif /* MM__COMMON_H_ */

/* #include mm-proxy_ix.h */
#ifndef MM_PROXY_IX_H
#define MM_PROXY_IX_H

/* #include mm__common.h */
#ifndef MM__COMMON_H_
#define MM__COMMON_H_

/* #include sn_alloc.h */
#ifndef SN_ALLOC_H
#define SN_ALLOC_H

#include <stdlib.h>
/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
# define SN_EXTERNC extern "C"
#else
# define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
# ifndef GCC
#  define GCC
# endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
# ifndef __TOKEN_MERGER__
#  define __TOKEN_MERGER__
# endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
# define _SN_ANSI_ARGS_(x)	x
#else
# define _SN_ANSI_ARGS_(x)	()
#endif

#define SN_PTR_ALIGNMENT_64 (3)
#define SN_PTR_ALIGNMENT_32 (2)

#if defined(LINUX_C) || defined(SOL_X86)
#define SN_LITTLE_ENDIAN
#else 
#define SN_BIG_ENDIAN
#endif

#include <inttypes.h>
#if defined(_LP64) || defined(__LP64__) || defined (__64BIT__)
# define SN_64_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_64)
#else /* defined(_LP64) || defined(__LP64__) || defined (__64BIT__) */
# define SN_32_BIT
# define SN_PTR_ALIGNMENT (SN_PTR_ALIGNMENT_32)
#endif /* defined(_LP64) || defined(__LP64__) */

#ifndef offsetof
# define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
#endif

#endif /* _CPP_H_ */



#ifdef __cplusplus
extern "C" {
#endif

/* In order to avoid recompilation of libs, items should only be added 
   (before LAST_ID), not removed */
typedef enum {
  SN_MISC = 0, 
  SN_UNKNOWN = 0,
  SN_USER,
  SN_MM,
  SN_CUDD,
  SN_ADAPTER,
  SN_LIST, 
  SN_EPI,
  SN_JUDY,
  SN_DTABLE,
  SN_MM_DATA,
  SN_LAST_ID
} sn_subsystem_id;


void* sn_calloc (size_t nmemb, size_t size, sn_subsystem_id id);
void* sn_malloc (size_t size, sn_subsystem_id id);
void* sn_realloc (void *ptr, size_t size, sn_subsystem_id id);
char* sn_strdup(const char *s1, sn_subsystem_id id);
void* sn_mmap (size_t size, sn_subsystem_id id);
void* sn_cmmap (size_t size, sn_subsystem_id id);
void  sn_free (void *ptr, sn_subsystem_id id);
void  sn_munmap (void *ptr, size_t size, sn_subsystem_id id);
void  alloc_gc_backup_memory();

void sn_print_mem_usage();  
void sn_print_mem_total();

#ifdef __cplusplus
}
#endif

#endif /* SN_ALLOC_H */
/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */

typedef enum {
    sn_block_PTRFREE = 0,
    sn_block_TYPED = 1,
    sn_block_STRING = 2,
    sn_block_BP = 3
} sn_block_type_t;

#define SN_N_BLOCK_TYPES 4

typedef uintptr_t sn_word_t;

#define SN_WORD_SIZE sizeof (sn_word_t)
#define SN_WORD_BIT_SIZE (SN_WORD_SIZE * 8)
#define SN_WORD_ADDR_MASK (~(SN_WORD_SIZE - 1))
#define SN_BYTES2WORDS(x) (((x) / SN_WORD_SIZE) + (((x) & (SN_WORD_SIZE - 1)) + SN_WORD_SIZE - 1) / SN_WORD_SIZE)
#define SN_BYTES2INTS(x) (((x) / sizeof (int)) + (((x) & (sizeof (int) - 1)) + sizeof (int) - 1) / sizeof (int))

struct sn_allocator_t;
struct s__plist;

#define SN_FORWARD_MASK ((uintptr_t) 1 << (SN_WORD_BIT_SIZE - 1))

#define SN_IS_FORWARDED(x)                      \
    (((uintptr_t *) (x)) [0] & SN_FORWARD_MASK)
#define SN_FORWARD_TARGET_(x)                   \
    ((t__base_struct) ((((uintptr_t *) (x)) [0]) << 2))

#if SN_FILTER_COMPILE_COND(heavy)
#ifdef MM_H_
# define SN_FORWARD_TARGET(from) (mm_sn_forward_target ((t__base_struct) from))
#endif
#ifdef MM_IX_H_
# define SN_FORWARD_TARGET(from) (sn_forward_target ((t__base_struct) from))
#endif
#else
# define SN_FORWARD_TARGET SN_FORWARD_TARGET_
#endif

#define SN_FORWARD(from,to)                                             \
    (((uintptr_t *) (from)) [0] = SN_FORWARD_MASK | (((uintptr_t) (to)) >> 2))
#define SN_FORWARD_TARGET_IF_ANY(from)                                  \
    (SN_IS_FORWARDED (from) ? SN_FORWARD_TARGET (from) : (t__base_struct) NULL)

#define SN_STRUCT_SIZE_IN_BYTES(sd) (sn_type_descriptor_get_size_in_bytes(sd))

extern int sn_currently_in_simulator__;

#ifdef MM_IX_H_
#define SN_GC_REGISTER_ROOT(x) sn_gc_register_root_range (&(x), 1)
#endif
#ifdef MM_H_
#define SN_GC_REGISTER_ROOT(x) mm_sn_gc_register_root_range (&(x), 1)
#endif

#ifdef MM_IX_H_
#define SN_SIM_ENTER_SPECMAN(addr) do {         \
        sn_currently_in_simulator__ = 0;        \
        sn_gc_bite(addr);                       \
    } while (0)
#endif
#ifdef MM_H_
#define SN_SIM_ENTER_SPECMAN(addr) do {         \
        sn_currently_in_simulator__ = 0;        \
        mm_sn_gc_bite(addr);                       \
    } while (0)
#endif

#ifdef MM_IX_H_
#define SN_SIM_EXIT_SPECMAN do {                \
        sn_gc_spit_out();                         \
        sn_currently_in_simulator__ = 1;        \
    } while (0)
#endif
#ifdef MM_H_
#define SN_SIM_EXIT_SPECMAN do {                \
        mm_sn_gc_spit_out();                         \
        sn_currently_in_simulator__ = 1;        \
    } while (0)
#endif

#define DEBUG_GC(string)	do {if (gc->print_debug_msgs) print_to_screen_and_log(string); } while (0)

extern unsigned int sn_gc_mem_prof_segments;

#endif /* MM__COMMON_H_ */

struct s__plist;
struct sn_allocator_t;
struct s__sn__gc_struct;
struct s__sn__session;
struct s__ilist;
struct sn_key_map_t;
struct s__sn__base_struct;
struct s__sn__global;
struct s__l__sn__untyped;

SN_EXTERNC void sn_init_mm_functions(char* specman_dir);

SN_EXTERNC char * ts1(char *);
SN_EXTERNC void* sn_get_block(uintptr_t size, sn_block_type_t type, bool clear);
SN_EXTERNC void* sn_get_fresh_block(uintptr_t *size, sn_block_type_t type);
SN_EXTERNC void* sn_get_block_ext(uintptr_t *size, sn_block_type_t type, bool clear);
SN_EXTERNC void* sn_realloc_block(void *block, uintptr_t old_size, uintptr_t *new_size, sn_block_type_t new_type);
SN_EXTERNC void sn_alloc_list_data(struct s__plist *, uintptr_t);
SN_EXTERNC void sn_realloc_list_data(struct s__plist *, uintptr_t);
SN_EXTERNC void sn_realloc_list_data_to(struct s__plist *, uintptr_t);
SN_EXTERNC void sn_free_list_data(struct s__plist *);
SN_EXTERNC void sn_oom(char *);
SN_EXTERNC void sn_mm_update_by(long words);

#ifndef FAKE_E
SN_EXTERNC void* sn_alloc_typed(int d__, bool clear);
SN_EXTERNC void sn_destroy_allocator(struct sn_allocator_t *);
SN_EXTERNC void sn_do_copy_and_compact(struct sn_allocator_t *);
SN_EXTERNC void sn_do_dump_and_then_undump(void *jmpbuf);
SN_EXTERNC void sn_do_mark_and_sweep(void);
SN_EXTERNC void sn_do_mark_and_sweep_if_needed(void);
SN_EXTERNC void sn_do_mark_and_sweep_if_possible(void);
SN_EXTERNC void sn_free_block(void *block, uintptr_t size, sn_block_type_t type);
SN_EXTERNC void sn_free_string(char *);
SN_EXTERNC void sn_free_typed(void *block);
SN_EXTERNC void sn_gc_clear_gen__(void);
SN_EXTERNC void sn_gc_decide_to_live_after_all(void);
SN_EXTERNC void sn_gc_fix_forwarded_instances(void);
SN_EXTERNC bool sn_gc_get_block_ms(void);
SN_EXTERNC uintptr_t sn_gc_live_size(void);
SN_EXTERNC bool sn_gc_log_memory(void);
SN_EXTERNC intptr_t sn_gc_log_memory_threshold(void);
SN_EXTERNC bool sn_gc_mem_prof(void);
SN_EXTERNC void sn_gc_prepare_to_die(void);
SN_EXTERNC long int sn_gc_random_value_up_to(long int);
SN_EXTERNC void sn_gc_register_root_range(void *from, uintptr_t len);
SN_EXTERNC void sn_gc_restore_printed_structs(void);
SN_EXTERNC void sn_gc_retain_printed_structs(bool);
SN_EXTERNC void sn_gc_set_block_ms(bool);
SN_EXTERNC void sn_gc_set_log_memory_threshold(intptr_t);
SN_EXTERNC void sn_gc_set_mem_prof(bool);
SN_EXTERNC void sn_gc_set_mem_prof_threshold(uintptr_t);
SN_EXTERNC bool sn_gc_struct_is_live(void* addr);
SN_EXTERNC uintptr_t sn_gc_total_size(void);
SN_EXTERNC void* sn_gc_translate_struct_address(void* addr);
SN_EXTERNC void sn_gc_update_by(struct s__sn__gc_struct *gc, int size);
SN_EXTERNC struct sn_allocator_t * sn_get_current_allocator(void);
SN_EXTERNC bool sn_get_enable_boundary_actions(struct s__sn__session *);
SN_EXTERNC intptr_t sn_get_total_requested_size(struct sn_allocator_t *);
SN_EXTERNC void sn_init_mm(void);
SN_EXTERNC bool sn_is_a_legal_address(void *ptr, bool is_start_of_block);
SN_EXTERNC bool sn_list_allocation_ok(struct s__ilist *);
SN_EXTERNC struct sn_allocator_t * sn_make_allocator(uintptr_t threshold, intptr_t increment, uintptr_t max);
SN_EXTERNC struct sn_allocator_t * sn_make_static_allocator(uintptr_t size, void (*oom)  (void));
SN_EXTERNC void* sn_mm_align_size(int);
SN_EXTERNC void sn_mm_clean_transients(void);
SN_EXTERNC void sn_mm_clear_marks(void);
SN_EXTERNC void* sn_mm_get_size(void *);
SN_EXTERNC bool sn_mm_is_marked(void *);
SN_EXTERNC void sn_mm_mark_freelists(void);
SN_EXTERNC uintptr_t sn_mm_requested_size(void);
SN_EXTERNC void sn_register_key_map(struct sn_key_map_t *);
SN_EXTERNC bool sn_regular_gc_blocked(void);
SN_EXTERNC void sn_reset_allocator(void);
SN_EXTERNC struct sn_allocator_t * sn_set_allocator(struct sn_allocator_t *);
SN_EXTERNC void sn_set_enable_boundary_actions(struct s__sn__session *, bool);
SN_EXTERNC void sn_set_total_requested_size(struct sn_allocator_t *, intptr_t);
SN_EXTERNC bool sn_should_gc(void);
SN_EXTERNC void sn_sim_enter_specman(void *base_addr);
SN_EXTERNC void sn_sim_exit_specman(void);
SN_EXTERNC void sn_unregister_key_map(struct sn_key_map_t *);
SN_EXTERNC void sn_update_ms_threshold(void);
SN_EXTERNC void sn_update_type_infos(void);
SN_EXTERNC bool sn_using_a_temporary_heap(void);

SN_EXTERNC struct s__plist * sn_new_list_by_d_index(int, int);
SN_EXTERNC void sn_finalize_all(void);
SN_EXTERNC void sn_gc_reset_all(void);
SN_EXTERNC void sn_gc_restore_all(void);
SN_EXTERNC void sn_finalize_zombies(void);
SN_EXTERNC void sn_register_for_finalization(struct s__sn__global *, struct s__sn__base_struct *);
SN_EXTERNC void sn_gc_bite(void* addr);
SN_EXTERNC void sn_gc_spit_out(void) ;
SN_EXTERNC void* sn_get_stack_base(void);
SN_EXTERNC int sn_get_gc_copy_in_progress(void);
#if SN_FILTER_COMPILE_COND(heavy)
SN_EXTERNC struct s__sn__base_struct * sn_forward_target(struct s__sn__base_struct *);
SN_EXTERNC void sn_gc_set_filters(void);
#else
#define sn_forward_target()
#define sn_gc_set_filters()
#endif
#endif

#endif /* MM_PROXY_IX_H */

    
#endif /* MM_IX_H_ */
#endif /* DONT_INCLUDE_MM_IX */

#ifndef FAKE_E
/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */
/* #include long.h */

    /***********************************************************************
    * COPYRIGHT (c) 1996,1997 Verisity Ltd., all rights                    *
    * reserved. This software is furnished under a license and may be used *
    * and copied only in accordance of the terms of such license and with  *
    * the inclusion of the above copyright notice.                         *
    ***********************************************************************/



#ifndef LONG_H
#define LONG_H

#ifndef AIX_C
typedef  unsigned char uchar;
#elif (!defined GCC)
#include <sys/types.h>
#endif

/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */

#define IS_LONG(_td) ((_td)->d__ == d__long_descriptor)

#define IS_NUMERIC_LONG(_td) ((IS_LONG((_td))) || (_td)->d_index == d__sn_vec)

#define IS_NUMERIC(_td) (IS_LONG(_td) || IS_DOUBLE(_td) || (_td)->short_type == short_type__INT_TYPE || (_td)->short_type == short_type__UINT_TYPE)

#define IS_UNBOUNDED(_td) ( \
			   (((_td)->d_index == d__sn_ulong) \
			    ||  ((_td)->d_index == d__sn_vec) ||  ((_td)->d_index == d__sn_long) \
			    || ((_td)->size_in_bits == MAX_INT)) )

/** #define IS_UNSIGNED_LONG(_td) (index_is_a_child_of((_td)->d_index,d__sn_ulong)) **/
#define IS_UNSIGNED_LONG(_td) ( (IS_LONG(_td)) && (((t__sn__long_descriptor)(_td))->is_signed == FALSE) ) 

#define IS_DOUBLE(_td) ((_td)->d_index == d__real)

#define IS_EXTENDED_SCALAR(_td) (IS_SCALAR(_td) || IS_NUMERIC_LONG(_td) || IS_DOUBLE(_td))
#define IS_REAL_NUMERIC(_td) (IS_NUMERIC(_td) || IS_NUMERIC_LONG(_td) || IS_DOUBLE(_td))
#define ZERO_EX(_int,_shift) ((((int)(_int)) << (_shift)) >> (_shift))
/** ===============WATCH OUT the macro will be redefined ==========*/
#define GLOB_MASK1(_e) LIST_ITEM(GLOB_ST->mask_bit_table, _e)
/** ===============================================================*/

#define IS_SHORT_SIGNED (GLOB_ST->is_short_signed)
#define IS_BIT_LIST(sd) (((sd)->d_index  ==  d__l__bit) ||  (IS_LIST(sd) && ((t__sn__list_descriptor)(sd))->base_type->size_in_bits == 1))
#define IS_BYTE_LIST(sd) (((sd)->d_index  ==  d__l__byte) || (IS_LIST(sd) && ((t__sn__list_descriptor)(sd))->base_type->size_in_bits == 8))

#define LONG_ATTR 0
#define LONG_FIXED_ATTR     ACTION_ATTR
#define LONG_SIGNED_ATTR    ACTION_ATTR + 1
#define LONG_TEMP_ATTR      ACTION_ATTR + 2
#define LONG_MINUS_INF_ATTR ACTION_ATTR + 3
#define LONG_PLUS_INF_ATTR  ACTION_ATTR + 4
#define LONG_AS_XZ          ACTION_ATTR + 5

#define INF_SET_SIGNED(v)    (SN_SET_ATTR((v), LONG_SIGNED_ATTR))
#define INF_SET_UNSIGNED(v)  (SN_RESET_ATTR((v),LONG_SIGNED_ATTR))

#define INF_SET_FIXED(v)   (SN_SET_ATTR((v), LONG_FIXED_ATTR))
#define INF_SET_UNFIXED(v) (SN_RESET_ATTR((v), LONG_FIXED_ATTR))

#define INF_SET_TEMP(v)    (SN_SET_ATTR((v), LONG_TEMP_ATTR))
#define INF_SET_NONTEMP(v)  (SN_RESET_ATTR((v), LONG_TEMP_ATTR))

#define INF_IS_SIGNED(v) (SN_GET_ATTR((v), LONG_SIGNED_ATTR))
#define INF_IS_FIXED(v) (SN_GET_ATTR((v), LONG_FIXED_ATTR))
#define INF_IS_TEMP(v) (SN_GET_ATTR((v), LONG_TEMP_ATTR))


#define INF_LIST_BIT_SIZE(l)          (LIST_SIZE((l)))
#define INF_LIST_BYTE_SIZE(l)         ((LIST_SIZE((l)) + 7) >> 3)
#define INF_LIST_INT_SIZE(l)          ((LIST_SIZE((l)) + 31) >> 5)

#define INF_LIST_GET_DATA(l)          ((uchar *) ((l)->data))

  /** for put/ get byte **/
#define INF_LIST_ITEM_BYTE(l, index)            (((uchar *) ((l)->data))[(index)])

#define INF_LIST_ITEM_INT(l, index)              ((l)->data[index])

#define INF_LIST_COPY_DATA(l,offset,str,size)  \
                     (memcpy(&((uchar *)((l)->data))[(offset)], (str), (size))); 

/** infinite int interface **/
#define INF_VEC_BIT_SIZE(v)          (LIST_SIZE((v)->bytes))
#define INF_VEC_BYTE_SIZE(v)         ((LIST_SIZE((v)->bytes) + 7) >> 3)

#define INF_VEC_ITEM_BYTE(v, index)            (((uchar *) (((v)->bytes)->data))[(index)])

#define SN_STACK_SP (sn_symtab->stack_of_temp_long->sp)
#define SN_STACK_ROLLBACK(_sp) (sn_symtab->stack_of_temp_long->sp = _sp)

#define SN_REAL_STACK_SP (sn_symtab->stack_of_temp_real->sp)
#define SN_REAL_STACK_ROLLBACK(_sp) (sn_symtab->stack_of_temp_real->sp = _sp)

#define SN_VEC_GET_BYTE(v, index) (INF_LIST_ITEM_BYTE((v)->bytes, (index)))
#define SN_INT_GET_BYTE(i, index) (((i)>>(8*(index)))&0xff)
#define SN_VEC_PUT_BYTE(v, index, value)  do {INF_LIST_ITEM_BYTE((v)->bytes, (index)) = (value); } while (0)

#endif
#endif /* FAKE_E */

/* #include misc.h */
    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef SN_MISC_H
#define SN_MISC_H

/* The three functions below print text to the console
   either terminal or gui console. */

/* No specman memory allocation */
void snio_print(char *s);

/* Print formatted text. Specman memory allocation is performed
   and structs are retained.
   This function should not be used during restore or gc */
void snio_printf(char *format, ...);

/* Same as above - but pointers are not saved for gc */
void snio_printf_no_pointers(char *format, ...);


/* The functions below are low level and are normally
   intended for internal use */

/* Print user visible output to tty (specview) only */
void snio_print_tty(char *s);

/* Print specview internal messages to tty */
void snio_printf_tty_internal(char *s, ...);

/* Print text (or prompt) to strap */
void snio_print_strap(char *s);
void snio_prompt_strap(char *s);

#ifdef SN_EXTERNAL_IS_HERE
#define SN_EXTERNAL
#else
#define SN_EXTERNAL SN_EXTERNC
#endif

#define UNDEF (-1)
        /* Value returned when no index is legal */
#define MAX_INT (0x7fffffff)
#define MIN_INT (-MAX_INT-1)

#ifdef SN_64_BIT
#define MAX_LONG_INT (0x7fffffffffffffff)
#else 
#define MAX_LONG_INT MAX_INT
#endif

#define ELEMENT_SIZE 32

#define MAX_NAME_SIZE 31  /* Max size for an external name in this OS */
#define MAX_NTV_DEPTH 250  /* Max nesting for parsing */

#define AS(_type, _var) ((_type) (_var))  /* Unsafe */
#define UNTYPE(_exp) AS(t__untyped,AS(intptr_t,_exp))
#define SN_INT(_exp) AS(int,AS(intptr_t,_exp))
#define SN_UINT(_exp) AS(t__uint,AS(uintptr_t,_exp))


/* -- Some function definitions */

FILE *fopen_check();
SN_STRING c_name();
int *tcalloc();


#ifndef FAKE_E

#define SN_SRCREF_MODULE_NUM(_srcref) (sn_srcref_module(_srcref))
#define SN_SRCREF_LINE_NUM(_srcref) (sn_srcref_line(_srcref))
#define SN_SOURCE_MODULE_NUM(_s) (SN_SRCREF_MODULE_NUM((_s)->source_ref))
#define SN_SOURCE_LINE_NUM(_s) (SN_SRCREF_LINE_NUM((_s)->source_ref))

#ifdef __TOKEN_MERGER__
#define NAME(_name,_d)   (SN_STRING)DISPATCH(name,GLOB_ST->namer,namer,(GLOB_ST->namer,name_role__##_d,_name))
#else /* __TOKEN_MERGER__ */
#define NAME(_name,_d)   (SN_STRING)DISPATCH(name,GLOB_ST->namer,namer,(GLOB_ST->namer,name_role__/**/_d,_name))
#endif /* __TOKEN_MERGER__ */


/* -- The following are used only by init */

#define SN_INIT_ROUTINE(_name, _rout, _type) \
    {init_routine((SN_STRING) _name, (int (*)(void))_rout);}
    /* Needs that scope to make the name known */

#define SN_INIT_ROUTINE_POINTER(_rout, _type) \
    {init_routine_pointer((t__routine_pointer) _rout);}
    /* Needs that scope to make the name known */

/* -- Some selected globals from root.e */
SN_EXTERNAL SN_STRING specman_version;  /* The version of Specman, not in GLOB */
SN_EXTERNAL SN_STRING sn_translator_version;  /*The version of the translator of Specman*/
SN_EXTERNAL SN_STRING sn_application_linked_on;  /* string describing app with linked on info */

extern char* sn_get_application_attribute_version();


#define GLOB (the_global_struct)
        /* Note that the the_global_struct itself is only defined in root_.h */

#define GLOB_ST (sn_symtab)
        /* The symbol table */


#define GLOB_SESS ((t__session)the_global_struct->session)
        /* The session */

#define GLOB_NS ((the_global_struct->no_save))
        /* The no_save struct of global */

#define GLOB_DISP ((t__sn__sn_display)the_global_struct->display)
        /* The display struct of global */

#define GLOB_DBG (sn_on)
/** #define GLOB_DBG ((t__sn__sn_dbg)(GLOB->sn_dbg)) **/

#define SN_PARSE (the_global_struct->parse)

#define DISPLAY_STATUS(_str) DISPATCH(set_status_msg,GLOB_DISP,sn_display,(GLOB_DISP,_str))

#define DOING(_si) {GLOB_NS->current_source_item = (t__reparse_source_item) _si;}
        /* Sets this var for error messages */

#define SN_END_DOING_SI GLOB_NS->current_source_item = NULL


/* -- Globals not in root.e */
SN_EXTERNAL sn_bool translation_in_progress;  /* See translate_command() */
#ifdef SN_EXTERNAL_IS_HERE
int translation_first_module_num = 0;
sn_bool sn_can_use_filters = FALSE;
#else
SN_EXTERNAL int translation_first_module_num;  /* See translate_command() */
SN_EXTERNAL sn_bool sn_can_use_filters;
#endif
SN_EXTERNAL sn_bool load_in_progress;    /* See load_command() */
SN_EXTERNAL sn_bool starting_in_progress;   /* True until before first user command */
SN_EXTERNAL int restore_in_progress;   /* True during restore */
SN_EXTERNAL int sn_gc_in_progress;   /* True during GC */
SN_EXTERNAL sn_bool sn_gc_init_methods_in_progress;
SN_EXTERNAL sn_bool minus_command_in_progress;  /* True if executing -command */
SN_EXTERNAL sn_bool disable_code;   /* Dont create code for action inside constraints */
SN_EXTERNAL sn_bool debugging_in_progress; /* do we have breakpoints */
SN_EXTERNAL sn_bool communication_in_progress; /* True during communication session on socket */
SN_EXTERNAL sn_bool dbg_use_dispatch_table; /* should we use 'call_from_dispatch_table' */
SN_EXTERNAL sn_bool post_load_in_progress;  /* See post load stmt*/

SN_EXTERNC bool sn_preparing_ispecman_exe;  /* True when we are creaing ispecman 
						       executable or files ontop of ispecman */
SN_EXTERNC bool sn_running_ispecman_exe; /* True when running ispecman executable */
SN_EXTERNC bool sn_running_iisn_exe; /* True when running iisn - any executable on top of ispecman */
/* The following debugger flags are used to decide whether
we want to check for break points from the corresponding 
type. They are TRUE iff there is at least one b.p. of these
type. */
SN_EXTERNAL sn_bool break_on_method_call;
SN_EXTERNAL sn_bool break_on_method_return;
SN_EXTERNAL sn_bool break_on_tcm_start;
SN_EXTERNAL sn_bool break_on_tcm_end;
SN_EXTERNAL sn_bool break_on_tcm_call;
SN_EXTERNAL sn_bool break_on_tcm_return;

SN_EXTERNAL sn_bool boot_only_flag;
        /* True only during the boot_only run, used to avoid some ops */

SN_EXTERNAL int sn_after_simulator_prompt;
   /* indicates specman that simulator prompt had already shown, for the 
      activation of the SPECMAN_POST_RESTORE commands */

#define DEBUG_ON(_flag1) (((t__debug)GLOB->debug)->_flag1)
#define DBG(_flag, _string) {if (DEBUG_ON(_flag)) sn_dout(_string);}

#ifdef __TOKEN_MERGER__

#define NT(_first, _second) t__n__##_first##__##_second

#define SN_DNT(_first, _second) d__n__##_first##__##_second

/* macro for type of an ntv family member */
#define SN_NTF(ntv_family) t__n__##ntv_family

#define MY(_field) (me->n__##_field)
        /* One of the NTVs */

#define STR(_field) (me->n__##_field->x->str)
        /* The string of that field */

#define STR_EMPTY(_field) sn_str_empty(me->n__##_field->x->str)
        /* Is this field's string empty ? */

#else /* __TOKEN_MERGER__ */

#define NT(_first, _second) t__n__/**/_first/**/__/**/_second
#define SN_DNT(_first, _second) d__n__/**/_first/**/__/**/_second

#define MY(_field) (me->n__/**/_field)
        /* One of the NTVs */

#define STR(_field) (me->n__/**/_field->x->str)
        /* The string of that field */

#define STR_EMPTY(_field) sn_str_empty(me->n__/**/_field->x->str)
        /* Is this field's string empty ? */

#endif /* __TOKEN_MERGER__ */


#define SUB(_i) LIST_ITEM(me->x->sub_matches,_i)
        /* Return the corresponding item of sub_matches */

#define GET_VALUE(_ntv) DISPATCH_ME1(get_value,_ntv,num)

#endif /* FAKE_E */

/* CHECK_NULL check if the string is "sn_str_..." its sn_error "str_..." */
#define CHECK_NULL(x,h) do {                                            \
        if((x) == NULL)                                                 \
            sn_error("Illegal NULL parameter in %s()",(((h)[0] == 's' && (h)[1]== 'n' && (h)[2] == '_') ? (h)+3 : (h))); \
    } while (0)

/** sometime empty lists are actualy NULLs this macro prevernt error messages from string routines **/
#define UPDATE_NULL(x) do {                     \
        if((x) == NULL)                         \
            (x) = "";                           \
    } while (0)


#define CHECK_EMPTY(x,h) do {                                   \
        if((x) == NULL || (x)[0] == '\0')                       \
            sn_error("Illegal empty parameter in %s()",h);      \
    } while (0)                                                 \

#define SN_MAX_EXTRA_FIELDS 20

#ifdef SUN_C
#define volatile  /* Older Sun C does not recognize the "volatile" keword */
#endif

#ifdef __TOKEN_MERGER__
#define SN_TOKENIZE(str) #str
#else /* __TOKEN_MERGER__ */
#define SN_TOKENIZE(str) "str"
#endif /* __TOKEN_MERGER__ */

#define SN_INT_TO_PTR(_value) \
    ((char *)(uintptr_t)(_value))

#define SN_ERR(_error_name, _params) \
    SN_OBJ_ERR(NULL, NULL, SN_TOKENIZE(_error_name), _params)

#define SN_ERR_NEST(_error_name, _params) \
    SN_OBJ_ERR(NULL, GLOB_ST->exceptions->global_sig_cookie, SN_TOKENIZE(_error_name), _params)

#define SN_SIG_ERR(_error_name, _cookie, _params) \
    SN_OBJ_ERR(NULL, _cookie, SN_TOKENIZE(_error_name), _params)


#define SN_OBJ_ERR(_obj, _cookie, _error_name, _params)          \
     (GLOB_ST->exceptions->global_error_name = _error_name,\
      GLOB_ST->exceptions->global_error_inst = _obj,\
      GLOB_ST->exceptions->global_sig_cookie = _cookie,\
      exception_for_c_code _params,0)

#define SN_CPP_ERR(_si, _error_name, _params) do { sn_set_ntv_now((t__sn__source_item) _si) ; SN_ERR(_error_name, _params) ;} while (0)


#define SN_ENCRYPTED_LINE_MESSAGE "Encrypted file, no source available"


/** #define GLOB_SIM ((t__sn__simulator)(GLOB->simulator)) **/   
#define GLOB_SIM (sn_simulator)

#define GLOB_SIM_AM ((t__sn_adapter_manager)(sn_adapter_manager))

#define METHOD_INDEX_TOP_LIMIT 5000

#ifndef FAKE_E

#define SN_STATIC_CHAR_BUFFER(name,size)                                \
    static char name##_normal[size];                                    \
    static char name##_async[size];                                     \
    char *name = (sn_e_is_async ? name##_async : name##_normal)

extern sn_bool sn_e_is_async;
#endif

#ifndef FAKE_E

# ifdef SN_64_BIT
#  define SN_REAL_SIZE (sizeof (struct s__sn__real))
#  define SN_C_DOUBLE_ADDRESS(r) &((r)->the_double)
#  define SN_C_DOUBLE(r) ((r)->the_double)
# else
#  define SN_REAL_SIZE (sizeof (struct s__sn__real) + 4)
#  define SN_C_DOUBLE_ADDRESS(r) ((double *) (((uintptr_t) (&((r)->the_double)) + 7) & ~0x7))
#  define SN_C_DOUBLE(r) (*SN_C_DOUBLE_ADDRESS(r))
# endif

#endif

#endif /* SN_MISC_H */
/* #include code.h */
#define H_CODE SN_PARSE->h_code
#define LATE_H_CODE SN_PARSE->late_h_code
#define LIST_H_CODE SN_PARSE->list_h_code
#define ROUTINE_H_CODE SN_PARSE->routine_h_code
#define TOP_CODE SN_PARSE->top_code->code
#define INIT0_CODE SN_PARSE->init0_code->code
#define INIT_CODE SN_PARSE->init_code->code
#define ROUTINE_CODE SN_PARSE->routine_code->code
#define C_CODE SN_PARSE->c_code->code
#define LATE_C_CODE SN_PARSE->late_c_code->code
/* #include new.h */

    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef NEW_H
#define NEW_H

#ifndef FAKE_E
extern intptr_t *sn_underscore_make_new_temp;  /* For make_new_helper() */
#endif

#ifdef FAKE_E
#define make_new_sized_helper(_size, _index) \
    (sn_underscore_make_new_temp = calloc (_size, 1), *(int*)sn_underscore_make_new_temp = _index, sn_underscore_make_new_temp)
#else
#define make_new_sized_helper(_size, _index) \
    (sn_underscore_make_new_temp = sn_get_block (SN_BYTES2WORDS (_size), sn_block_TYPED, TRUE), *(int*)sn_underscore_make_new_temp = _index, sn_underscore_make_new_temp)
#endif

#define MAKE_NEW_SIZED(_svar1, _stype1, _desc1) \
    {_svar1 = (_stype1) make_new_sized_helper(sizeof(*((_stype1)_svar1)), _desc1);}

#define MAKE_NEW_SIZED_MALLOC(_svar1, _stype1, _desc1) \
    {_svar1 = (_stype1) make_new_malloc_helper(sizeof(*((_stype1)_svar1)), _desc1);}

#define FREE_MALLOC(_item) {if ((_item) != NULL) { \
    sn_free(_item, SN_MISC); (_item) = NULL;}}

#ifndef FAKE_E

#define MAKE_NEW(_svar1, _desc1)  \
  {_svar1 = (void *) make_new_helper(_desc1);}

#define MAKE_NEW1(_svar1, _desc1)  \
  {_svar1 = (int *) make_new_helper1(_desc1);}

#define MAKE_NEW2(_svar1)  \
  {make_new_helper2(_svar1);}

#define MAKE_NEW_MALLOC(_svar1, _desc1)  \
    {_svar1 = (int *) \
            make_new_malloc_helper(                                     \
                                   SN_STRUCT_SIZE_IN_BYTES ((t__sn__struct_descriptor) LIST_ITEM(GLOB->all_types,_desc1)), _desc1);}

#define SN_MAKE_NEW_MALLOC_(_res, _type_id, _type) do {                 \
        int sz = SN_STRUCT_SIZE_IN_BYTES (LIST_ITEM (GLOB->all_types,_type_id));        \
        _res = (_type) make_new_malloc_helper(sz, _type_id);            \
    } while (0)

#define SN_MAKE_NEW_MALLOC(_res, _type_name) SN_MAKE_NEW_MALLOC_(_res, d__##_type_name, t__##_type_name)

#define MAKE_COPY(_to, _from) \
    {MAKE_NEW(_to,(_from)->d__); \
        memcpy(_to, _from, SN_STRUCT_SIZE_IN_BYTES (TYPE(_from)));}

#define MAKE_EXTEND(_to, _d_index, _from) \
    {MAKE_NEW(_to,_d_index); \
        memcpy(_to, _from, SN_STRUCT_SIZE_IN_BYTES (TYPE(_from)));     \
     (_to)->d__ = _d_index;}

#ifdef __TOKEN_MERGER__

#define GET_MAKE_NEW(_name) ((t__##_name)make_new_helper(d__##_name))

#else /* __TOKEN_MERGER__ */

#define GET_MAKE_NEW(_name) ((t__/**/_name)make_new_helper(d__/**/_name))

#endif /* __TOKEN_MERGER__ */

#endif /* FAKE_E */

/* The behavior of SN_SN_STRUCT_NEW is as similar as possible to the behavior of the e <new'exp>. */
#define SN_SN_STRUCT_NEW(type) ((SN_TYPE(type))sn_make_new_and_run_helper(SN_TYPE_ID(type)))
#define SN_INTERNAL_STRUCT_NEW(type) ((SN_TYPE(type))make_new_helper(SN_TYPE_ID(type)))

#define SN_SN_LIST_NEW(type) ((SN_LIST(type))sn_make_new_list_helper(SN_LIST_TYPE_ID(type)))
#define SN_STRING_NEW(size)  ((SN_TYPE(string))(sn_make_new_string_helper(size)))
#define SN_STRING_COPY(str) ((SN_STRING)sn_string_copy(str))



SN_EXTERNC int *make_new_helper(int);
SN_EXTERNC t__plist sn_make_new_list_helper(int);
SN_EXTERNC char  *sn_make_new_string_helper(int);
SN_EXTERNC char *sn_string_copy(char *);


#endif /* NEW_H */

#ifndef FAKE_E
/* #include exception.h */
#ifndef SN_EXCEPTION
#define SN_EXCEPTION

/* -- The TRY_* stuff (for exceptions) */
#include <setjmp.h>
#include <stdlib.h>

typedef enum {
	TRY_UNUSED,
	TRY_OK, 
	TRY_ERROR,
	TRY_ERROR_BACKTRACK,
	LOW_LEVEL_ERROR_BACKTRACK
} try_status_st;

struct s__sn__activation_record;

typedef struct {
    jmp_buf *buf;
    try_status_st status;
    sn_bool valid;
    
    struct s__sn__activation_record *CAR;
    struct s__sn__activation_record *backup_CAR;
    void *user_data;
    
    SN_STRING try_string;
    SN_STRING cached_try_string;
    
    sn_bool permit_trace;
    sn_bool trace_printed;
    
    SN_STRING saved_try_string;
    try_status_st saved_status;
    jmp_buf *regular_buf;
} try_stack_elt_st;

typedef struct {
    int size;
    int allocated;
    try_stack_elt_st *data;
} try_stack_st;

extern try_stack_st try_stack;

extern sn_bool sn_try_is_bug_compatible;

SN_EXTERNC try_status_st sn_get_try_status (sn_bool for_error);
#define SN_GET_TRY_STATUS sn_get_try_status (FALSE)
SN_EXTERNC void sn_set_try_status (try_status_st);
#define SN_SET_TRY_STATUS(new_status) sn_set_try_status (new_status)
#define SN_GET_TRY_STATUS_FOR_ERROR sn_get_try_status (TRUE)

SN_EXTERNC sn_bool sn_can_trace (void);
#define SN_CAN_TRACE sn_can_trace ()

extern sn_bool ignore_break_on_error;

SN_EXTERNC SN_STRING sn_get_saved_try_string (sn_bool copy, sn_bool for_error);
SN_EXTERNC void sn_set_saved_try_string (SN_STRING);
#define SN_GET_SAVED_TRY_STRING sn_get_saved_try_string (TRUE, FALSE)
#define SN_GET_SAVED_TRY_STRING_NOCOPY sn_get_saved_try_string (FALSE, FALSE)
#define SN_SET_SAVED_TRY_STRING(val) sn_set_saved_try_string (val)
SN_EXTERNC void sn_clear_cached_try_strings (void);
#define SN_GET_SAVED_TRY_STRING_FOR_ERROR sn_get_saved_try_string (TRUE, FALSE)

SN_EXTERNC void sn_init_exception (void);
SN_EXTERNC void resize_try_stack (void);
SN_EXTERNC void sn_exception_failed (void);
SN_EXTERNC void sn_continue_output();

#define TRY_BEGIN 							\
    {                                                                   \
        sn_bool saved_ignore_break_on_error = ignore_break_on_error;    \
        int saved_try_stack_size = try_stack.size;                      \
        BASIC_TRY_BEGIN (FALSE)

#define TRY_BEGIN_PT 							\
    {                                                                   \
        sn_bool saved_ignore_break_on_error = ignore_break_on_error;    \
        int saved_try_stack_size = try_stack.size;                      \
        BASIC_TRY_BEGIN (TRUE)

#define TRY_BEGIN_IE_NOPT /* ignores break on error, but does not permit trace */ \
    {                                                                   \
        sn_bool saved_ignore_break_on_error = ignore_break_on_error;    \
        int saved_try_stack_size = try_stack.size;                      \
        ignore_break_on_error = TRUE;                                   \
        BASIC_TRY_BEGIN (FALSE)

#define TRY_BEGIN_IE /* ignore break on error and permit trace */	\
    {                                                                   \
        sn_bool saved_ignore_break_on_error = ignore_break_on_error;    \
        int saved_try_stack_size = try_stack.size;                      \
        ignore_break_on_error = TRUE;                                   \
        BASIC_TRY_BEGIN (TRUE)

SN_EXTERNC void sn_try_begin (sn_bool);
#define BASIC_TRY_BEGIN(permit_trace)                                   \
        sn_try_begin (permit_trace);                                    \
        if (!setjmp(*try_stack.data[try_stack.size - 1].buf)) {

SN_EXTERNC void sn_try_begin_with_buf (sn_bool, jmp_buf *, void *, struct s__sn__activation_record *);

SN_EXTERNC void sn_try_quit (sn_bool);
#define TRY_QUIT  sn_try_quit (saved_ignore_break_on_error);

SN_EXTERNC void sn_try_ok (sn_bool);
struct s__sn__activation_record;
SN_EXTERNC void sn_try_failed (sn_bool);
#define TRY_FAILED	                                                \
            sn_try_ok (saved_ignore_break_on_error);                    \
            sn_check_try_stack_size (saved_try_stack_size);             \
        } else {                                                        \
            sn_try_failed (saved_ignore_break_on_error);                \
            {

SN_EXTERNC void sn_check_try_stack_size (int);
SN_EXTERNC void sn_try_end (sn_bool);
#define TRY_END 							\
                sn_try_end (saved_ignore_break_on_error);               \
                sn_check_try_stack_size (saved_try_stack_size);         \
            }                                                           \
        }                                                               \
    }

struct s__sn__exceptions;
SN_EXTERNC sn_bool sn_exceptions_bug_compatible (struct s__sn__exceptions *);
SN_EXTERNC void sn_exceptions_set_bug_compatible (struct s__sn__exceptions *, sn_bool);

SN_EXTERNC void sn_fail (void);

#define SN_UNWIND_PROTECT(body,unwind) {        \
        TRY_BEGIN_PT {                          \
            body;                               \
        } TRY_FAILED {                          \
            unwind;                             \
            sn_fail ();                         \
        } TRY_END;                              \
        unwind;                                 \
    }

#define SN_UNWIND_PROTECT_IE(body,unwind) {     \
        TRY_BEGIN_IE {                          \
            body;                               \
        } TRY_FAILED {                          \
            unwind;                             \
            sn_fail ();                         \
        } TRY_END;                              \
        unwind;                                 \
    }

sn_bool sn_try_is_valid (void);
void *sn_try_user_data (void);

#endif
/* #include packed_list.h */
#ifndef PACKED_LIST_H
#define PACKED_LIST_H 
 
extern char closest_power[];
extern char closest_shift[];
extern char bit_place[];
extern char shift_table[]; 
extern char items_in_byte[]; 
#define PACKED_LIST_MAX_SIZE  16


/*the two new macro's are for the short int sake. the EX_PACKED_LIST_ITEM is
making sign extension no questions aked. the COND_EX_PACKED_LIST_ITEM check the
list type to find if the extension is needed. the last my be alot slower thus the first is recommended*/
#define PACKED_LIST_ITEM(l,i) ( packed_list_item((t__ilist)l,i) )
#define EX_PACKED_LIST_ITEM(l,i) ( ZERO_EX((int)packed_list_item((t__ilist)l,i), 32 - LIST_RESERVED(l)))
#define COND_EX_PACKED_LIST_ITEM(l,i) ((IS_INT(ELEM_TYPE(TYPE(l)))) ? ( ZERO_EX((int)packed_list_item((t__ilist)l,i), 32 - LIST_RESERVED(l))): PACKED_LIST_ITEM(l,i))

#define PACKED_LIST_LITEM(l,i,x) ( packed_list_litem_function((t__ilist)l,i,x), 1)

#define GET_DATA(l) ((l)->data)
#define PACKED_LIST_DATA_AS_BYTE(l) ((unsigned char *)(l)->data)
#define PACKED_LIST_DATA_AS_SHORT(l) ((unsigned short *)(l)->data)


		     /* _d is the d__ of the list , _l is the list 	*/
#define UPDATE_RESERVED( _l ) \
    LIST_RESERVED_SET(_l, AS(t__sn__list_descriptor,LIST_ITEM(GLOB->all_types,_l->d__))->base_type->size_in_bits);

#define UPDATE_RESERVED_EXPLICIT(_l, _size) LIST_RESERVED_SET(_l,_size)
	
#define IS_A_PACKED_LIST(_elem) \
   ((AS(t__sn__list_descriptor,_elem)->base_type->size_in_bits <= PACKED_LIST_MAX_SIZE) && (AS(t__sn__list_descriptor,_elem)->base_type->size_in_bits > 0))
#define IS_A_PACKED_LIST_ITEM(_elem) \
   (((_elem)->size_in_bits <= PACKED_LIST_MAX_SIZE) && ((_elem)->size_in_bits > 0))
#define PACKED_LIST_SIZE_IN_BITS(_d) (AS(t__sn__list_descriptor,LIST_ITEM(GLOB->all_types,_d))->base_type->size_in_bits)

#define PACKED_LIST_ADD(_lvar, _svar) \
    { if (LIST_SIZE(_lvar) >= LIST_ALLOCATED(_lvar)) \
         packed_list_add_helper((t__ilist)_lvar); \
		 packed_list_litem_function((t__ilist)_lvar,LIST_SIZE(_lvar),(_svar));SIZE_CELL(_lvar)+=1; }

#define PACKED_LIST_ADD_LIST(_lvar, _svar) \
	packed_list_add_list_helper((t__ilist)_lvar, _svar)

#define PACKED_LIST_INIT(_lvar, _size, _full, _value, _keep_old) \
        sn_packed_list_init_helper((t__ilist)_lvar, _size, _full, _value, _keep_old)

/**
o  watch the two new defines:
- EX_PACKED_LIST_FOR_EACH - always do sign extension, ussualy when the signed attribute is constant or after condition expression.
- COND_EX_PACKED_LIST_ITEM - on each iteration we ask whether the sign should be
  extended, very expensive use only where needed.
**/
#ifdef __GNUC__
#define PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = (typeof(_svar))PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))

#define EX_PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = (typeof(_svar))EX_PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))

#define COND_PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = (typeof(_svar))COND_EX_PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))
    
#define PACKED_LIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
	   for (_index = 0; \
	       (((_index) < (_limit))  &&  \
		((_svar = (typeof(_svar))PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))
#else
#define PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))

#define EX_PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = EX_PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))

#define COND_PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = COND_EX_PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))
    
#define PACKED_LIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
	   for (_index = 0; \
	       (((_index) < (_limit))  &&  \
		((_svar = PACKED_LIST_ITEM(ILIST(_lvar1), _index)),1)); \
	       ++(_index))
#endif

#define PACKED_LIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	  for (_index = LIST_SIZE(_lvar1) - 1; \
	       ((_index) >= 0)  && (((_svar) = PACKED_LIST_ITEM(ILIST(_lvar1),(_index))),1); \
	       --(_index))

#define EX_PACKED_LIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	  for (_index = LIST_SIZE(_lvar1) - 1; \
	       ((_index) >= 0)  && (((_svar) = EX_PACKED_LIST_ITEM(ILIST(_lvar1),(_index))),1); \
	       --(_index))

#define PACKED_LIST_DELETE(_lvar, _index, _stype) \
   {packed_list_litem_function(_lvar,_index, (PACKED_LIST_ITEM(_lvar,LIST_SIZE(_lvar)-1))); \
    packed_list_litem_function(_lvar,(LIST_SIZE(_lvar) - 1), 0); \
    SIZE_CELL(_lvar)-=1;}

#define PACKED_LIST_POP(_lvar, _stype) \
    ((_stype) packed_list_pop(_lvar))

#define PACKED_LIST_TOP(_lvar, _stype) \
    ((_stype) PACKED_LIST_ITEM(ILIST(_lvar),(LIST_SIZE(_lvar) - 1)))

#define PACKED_LIST_APPEND(_lto, _lfrom, _ltype) \
    { _ltype _elem; int _tmp; \
        ILIST_FOR_EACH(_lfrom,_elem,_tmp) { \
	    ILIST_ADD(_lto,_elem); \
	} \
    }

#define PACKED_LIST_GET_BYTE(_l, _bn) (((unsigned char*)((_l)->data))[_bn])
#define PACKED_LIST_PUT_BYTE(_l, _bn, _data) ((unsigned char*)((_l)->data))[_bn] =(_data)
#define PACKED_LIST_GET_SHORT(_l, _bn) (((unsigned short*)((_l)->data))[_bn])
#define PACKED_LIST_PUT_SHORT(_l, _bn, _data) ((unsigned short*)((_l)->data))[_bn] =(_data)
/* work only for list smaller than 9 bits item size */
#define PACKED_LIST_SIZE_IN_BYTES(_list, _item_size) ((((LIST_SIZE(_list) << closest_shift[_item_size]) + 7)) >> 3) 
#define PACKED_LIST_ADD_BYTE( _l, _data) \
    {if ((!(ILIST(_l)->data)) || \
        (LIST_SIZE(_l)+(8>>closest_shift[LIST_RESERVED(_l)]) > LIST_ALLOCATED(_l))) \
	packed_list_add_helper(_l); \
        PACKED_LIST_PUT_BYTE( _l, ((LIST_SIZE(_l)<<closest_shift[LIST_RESERVED(_l)])>>3), _data); \
        SIZE_CELL(_l)+=(8>>closest_shift[LIST_RESERVED(_l)]);}

#define PACKED_LIST_GET_BYTE_SIZE(_l)  \
   ((((LIST_SIZE(_l))<<closest_shift[LIST_RESERVED(_l)]) + 7)>>3 )

/* accelerator function for adding bytes to list of byte.
   to be used for STATIC list of bytes only, since it uses malloc and not
   specman GC. This macro was designed for the cases where we use list of bytes
   as string buffers */
#define SN_LOBYTE_ADD_MALLOC(_list,_byte) {			\
	if(LIST_SIZE(_list) == LIST_ALLOCATED(_list)) {    	\
		if((_list)->data == NULL) {			\
			sn_listOfByteCreateMalloc(_list);	\
		}						\
		else {						\
			sn_listOfByteResizeMalloc(_list);	\
		}						\
	}							\
	((char *)((_list)->data))[SIZE_CELL(_list)] = _byte;	\
	SIZE_CELL(_list)++;					\
}	

#define SN_LOBYTE_ADD(_list,_byte) {                            \
	if(LIST_SIZE(_list) == LIST_ALLOCATED(_list)) {    	\
        	if((_list)->data == NULL) {                       \
                	sn_listOfByteCreate(_list);             \
        	}                                               \
        	else {    					\
                	sn_listOfByteResize(_list);             \
        	}                                               \
	}							\
        ((char *)((_list)->data))[SIZE_CELL(_list)] = _byte;      \
        SIZE_CELL(_list)++;                                     \
}       

#define SN_LOBYTE_CHOP(_list) {                                         \
        if(SIZE_CELL(_list)) {                           		\
                SIZE_CELL(_list) -= 1;                                  \
                ((char *)((_list)->data))[SIZE_CELL(_list)] = '\0';       \
        }                                                               \
}

#define SN_LOBYTE_TOP(_list) (SIZE_CELL(_list) ? ((char *)((_list)->data))[SIZE_CELL(_list) - 1] : '\0')

#endif /* PACKED_LIST_H */

#endif /* FAKE_E */


#endif /* ROOT_ALL_H */
/* line 34 "../src/root_basic.e"  From 'type: string' */
typedef SN_STRING t__string;
#define d__string 3
/* line 33 "../src/root_basic.e"  From 'type: bool' */
typedef unsigned int t__bool;
#define d__bool 2
/* line 31 "../src/root_basic.e"  From 'type: int' */
typedef int t__int;
#define d__int 0
/* line 32 "../src/root_basic.e"  From 'type: uint' */
typedef unsigned int t__uint;
#define d__uint 1
/* line 39 "../src/root_basic.e"  From 'type: external_pointer' */
typedef void * t__external_pointer;
#define d__external_pointer 7
/* line 3 "/vobs/specman/src/adapter_bridge.e"  From 'Enum type 'sn_hdl_kind'' */
typedef enum {
    sn_hdl_kind__HDL_UNSET=((int)0),
    sn__sn_hdl_kind__HDL_UNSET=((int)0),
    sn_hdl_kind__HDL_VERILOG=((int)1),
    sn__sn_hdl_kind__HDL_VERILOG=((int)1),
    sn_hdl_kind__HDL_VHDL=((int)2),
    sn__sn_hdl_kind__HDL_VHDL=((int)2),
    sn_hdl_kind__HDL_SYSTEMC=((int)3),
    sn__sn_hdl_kind__HDL_SYSTEMC=((int)3),
    sn_hdl_kind__HDL_SYSTEM_VERILOG=((int)4),
    sn__sn_hdl_kind__HDL_SYSTEM_VERILOG=((int)4),
    sn_hdl_kind__HDL_OTHER=((int)5),
    sn__sn_hdl_kind__HDL_OTHER=((int)5)
} t__sn__sn_hdl_kind;

#define d__sn__sn_hdl_kind 2266

typedef t__sn__sn_hdl_kind t__sn_hdl_kind;

#define d__sn_hdl_kind d__sn__sn_hdl_kind

/* line 415 "/vobs/specman/src/scriptsim.e"  From 'Enum type 'simulator_kind'' */
typedef enum {
    simulator_kind__unknown=((int)0),
    sn__simulator_kind__unknown=((int)0),
    simulator_kind__external_run=((int)1),
    sn__simulator_kind__external_run=((int)1),
    simulator_kind__verilog=((int)2),
    sn__simulator_kind__verilog=((int)2),
    simulator_kind__vhdl=((int)3),
    sn__simulator_kind__vhdl=((int)3),
    simulator_kind__ccli=((int)4),
    sn__simulator_kind__ccli=((int)4),
    simulator_kind__snsim=((int)5),
    sn__simulator_kind__snsim=((int)5)
} t__sn__simulator_kind;

#define d__sn__simulator_kind 1262

typedef t__sn__simulator_kind t__simulator_kind;

#define d__simulator_kind d__sn__simulator_kind

/* line 424 "/vobs/specman/src/scriptsim.e"  From 'Enum type 'simulator_product'' */
typedef enum {
    simulator_product__unknown=((int)0),
    sn__simulator_product__unknown=((int)0),
    simulator_product__xl=((int)1),
    sn__simulator_product__xl=((int)1),
    simulator_product__vcs=((int)2),
    sn__simulator_product__vcs=((int)2),
    simulator_product__spd=((int)3),
    sn__simulator_product__spd=((int)3),
    simulator_product__qhsim=((int)4),
    sn__simulator_product__qhsim=((int)4),
    simulator_product__leapfrog=((int)5),
    sn__simulator_product__leapfrog=((int)5),
    simulator_product__vss=((int)6),
    sn__simulator_product__vss=((int)6),
    simulator_product__mti=((int)7),
    sn__simulator_product__mti=((int)7),
    simulator_product__nc=((int)8),
    sn__simulator_product__nc=((int)8),
    simulator_product__ncvhdl=((int)9),
    sn__simulator_product__ncvhdl=((int)9),
    simulator_product__qvh=((int)10),
    sn__simulator_product__qvh=((int)10),
    simulator_product__snsim=((int)11),
    sn__simulator_product__snsim=((int)11),
    simulator_product__xsim=((int)12),
    sn__simulator_product__xsim=((int)12),
    simulator_product__xvhdl=((int)13),
    sn__simulator_product__xvhdl=((int)13),
    simulator_product__sv=((int)14),
    sn__simulator_product__sv=((int)14)
} t__sn__simulator_product;

#define d__sn__simulator_product 1264

typedef t__sn__simulator_product t__simulator_product;

#define d__simulator_product d__sn__simulator_product

/* line 5 "/vobs/specman/src/adapter_trace.e"  From 'Enum type 'esi_trace_level'' */
typedef enum {
    esi_trace_level__NONE=((int)0),
    sn__esi_trace_level__NONE=((int)0),
    esi_trace_level__PARTIAL=((int)1),
    sn__esi_trace_level__PARTIAL=((int)1),
    esi_trace_level__FULL=((int)2),
    sn__esi_trace_level__FULL=((int)2)
} t__sn__esi_trace_level;

#define d__sn__esi_trace_level 6965

typedef t__sn__esi_trace_level t__esi_trace_level;

#define d__esi_trace_level d__sn__esi_trace_level

/* line 41 "../src/root_basic.e"  From 'type: source_ref' */
typedef unsigned int t__source_ref;
#define d__source_ref 8
/* line 12 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'sn_agent_kind'' */
typedef enum {
    sn_agent_kind__unset=((int)0),
    sn__sn_agent_kind__unset=((int)0),
    sn_agent_kind__master=((int)1),
    sn__sn_agent_kind__master=((int)1),
    sn_agent_kind__slave=((int)2),
    sn__sn_agent_kind__slave=((int)2)
} t__sn__sn_agent_kind;

#define d__sn__sn_agent_kind 2178

typedef t__sn__sn_agent_kind t__sn_agent_kind;

#define d__sn_agent_kind d__sn__sn_agent_kind

/* line 53 "/vobs/specman/src/port_defs.e"  From 'Enum type 'any_port'outside'' */
typedef enum {
    any_port__outside__undefined=((int)0),
    sn__any_port__outside__undefined=((int)0),
    any_port__outside__true=((int)1),
    sn__any_port__outside__true=((int)1),
    any_port__outside__false=((int)2),
    sn__any_port__outside__false=((int)2)
} t__imp_enum_sn__any_port__outside;

#define d__imp_enum_sn__any_port__outside 1209

typedef t__imp_enum_sn__any_port__outside t__imp_enum_any_port__outside;

#define d__imp_enum_any_port__outside d__imp_enum_sn__any_port__outside

/* line 128 "../src/root_basic.e"  From 'Enum type 'pack_level'' */
typedef enum {
    pack_level__physical=((int)0),
    e_core__pack_level__physical=((int)0),
    pack_level__minimal=((int)1),
    e_core__pack_level__minimal=((int)1),
    pack_level__vttp=((int)2),
    e_core__pack_level__vttp=((int)2),
    pack_level__svtp=((int)3),
    e_core__pack_level__svtp=((int)3),
    pack_level__mltp=((int)4),
    e_core__pack_level__mltp=((int)4),
    pack_level__full=((int)5),
    e_core__pack_level__full=((int)5)
} t__e_core__pack_level;

#define d__e_core__pack_level 20

typedef t__e_core__pack_level t__pack_level;

#define d__pack_level d__e_core__pack_level

/* line 2 "/vobs/specman/src/port_attributes.e"  From 'Enum type 'sn_drain_buffer'' */
typedef enum {
    sn_drain_buffer__unset=((int)0),
    sn__sn_drain_buffer__unset=((int)0),
    sn_drain_buffer__drain=((int)1),
    sn__sn_drain_buffer__drain=((int)1),
    sn_drain_buffer__no_drain=((int)2),
    sn__sn_drain_buffer__no_drain=((int)2)
} t__sn__sn_drain_buffer;

#define d__sn__sn_drain_buffer 6667

typedef t__sn__sn_drain_buffer t__sn_drain_buffer;

#define d__sn_drain_buffer d__sn__sn_drain_buffer

/* line 45 "../src/root_basic.e"  From 'type: bit' */
typedef unsigned int t__bit;
#define d__bit 11
/* line 722 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'callback_status'' */
typedef enum {
    callback_status__unset=((int)0),
    sn__callback_status__unset=((int)0),
    callback_status__set=((int)1),
    sn__callback_status__set=((int)1),
    callback_status__done=((int)2),
    sn__callback_status__done=((int)2)
} t__sn__callback_status;

#define d__sn__callback_status 2231

typedef t__sn__callback_status t__callback_status;

#define d__callback_status d__sn__callback_status

/* line 49 "/vobs/specman/src/num.e"  From 'Enum type 'mvl'' */
typedef enum {
    mvl__MVL_U=((int)0),
    sn__mvl__MVL_U=((int)0),
    mvl__MVL_X=((int)1),
    sn__mvl__MVL_X=((int)1),
    mvl__MVL_0=((int)2),
    sn__mvl__MVL_0=((int)2),
    mvl__MVL_1=((int)3),
    sn__mvl__MVL_1=((int)3),
    mvl__MVL_Z=((int)4),
    sn__mvl__MVL_Z=((int)4),
    mvl__MVL_W=((int)5),
    sn__mvl__MVL_W=((int)5),
    mvl__MVL_L=((int)6),
    sn__mvl__MVL_L=((int)6),
    mvl__MVL_H=((int)7),
    sn__mvl__MVL_H=((int)7),
    mvl__MVL_N=((int)8),
    sn__mvl__MVL_N=((int)8)
} t__sn__mvl;

#define d__sn__mvl 490

typedef t__sn__mvl t__mvl;

#define d__mvl d__sn__mvl

/* line 369 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'active_value_holder_type'' */
typedef enum {
    active_value_holder_type__value_undefined=((int)0),
    sn__active_value_holder_type__value_undefined=((int)0),
    active_value_holder_type__value_event=((int)1),
    sn__active_value_holder_type__value_event=((int)1),
    active_value_holder_type__value_scalar=((int)2),
    sn__active_value_holder_type__value_scalar=((int)2),
    active_value_holder_type__value_long=((int)3),
    sn__active_value_holder_type__value_long=((int)3),
    active_value_holder_type__value_list=((int)4),
    sn__active_value_holder_type__value_list=((int)4),
    active_value_holder_type__value_single_mvl=((int)5),
    sn__active_value_holder_type__value_single_mvl=((int)5),
    active_value_holder_type__value_string=((int)6),
    sn__active_value_holder_type__value_string=((int)6)
} t__sn__active_value_holder_type;

#define d__sn__active_value_holder_type 2209

typedef t__sn__active_value_holder_type t__active_value_holder_type;

#define d__active_value_holder_type d__sn__active_value_holder_type

/* line 368 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'sn_assign_fr'' */
typedef enum {
    sn_assign_fr__release=((int)0),
    sn__sn_assign_fr__release=((int)0),
    sn_assign_fr__force=((int)1),
    sn__sn_assign_fr__force=((int)1),
    sn_assign_fr__reforce=((int)2),
    sn__sn_assign_fr__reforce=((int)2)
} t__sn__sn_assign_fr;

#define d__sn__sn_assign_fr 2207

typedef t__sn__sn_assign_fr t__sn_assign_fr;

#define d__sn_assign_fr d__sn__sn_assign_fr

/* line 25 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'memory_type'' */
typedef enum {
    memory_type__normal=((int)0),
    sn__memory_type__normal=((int)0),
    memory_type__vcs_acc=((int)1),
    sn__memory_type__vcs_acc=((int)1),
    memory_type__prop=((int)2),
    sn__memory_type__prop=((int)2),
    memory_type__prop_onecell=((int)3),
    sn__memory_type__prop_onecell=((int)3),
    memory_type__prop_mx=((int)4),
    sn__memory_type__prop_mx=((int)4),
    memory_type__propagate_event=((int)5),
    sn__memory_type__propagate_event=((int)5)
} t__sn__memory_type;

#define d__sn__memory_type 2182

typedef t__sn__memory_type t__memory_type;

#define d__memory_type d__sn__memory_type

/* line 10 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'hdl_data_type'' */
typedef enum {
    hdl_data_type__uint_type=((int)0),
    sn__hdl_data_type__uint_type=((int)0),
    hdl_data_type__long_type=((int)1),
    sn__hdl_data_type__long_type=((int)1),
    hdl_data_type__bit_list_type=((int)2),
    sn__hdl_data_type__bit_list_type=((int)2),
    hdl_data_type__list_type=((int)3),
    sn__hdl_data_type__list_type=((int)3),
    hdl_data_type__list_long_type=((int)4),
    sn__hdl_data_type__list_long_type=((int)4),
    hdl_data_type__other=((int)5),
    sn__hdl_data_type__other=((int)5)
} t__sn__hdl_data_type;

#define d__sn__hdl_data_type 2174

typedef t__sn__hdl_data_type t__hdl_data_type;

#define d__hdl_data_type d__sn__hdl_data_type

/* line 8 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'sensitivity_kind'' */
typedef enum {
    sensitivity_kind__void=((int)0),
    sn__sensitivity_kind__void=((int)0),
    sensitivity_kind__change=((int)1),
    sn__sensitivity_kind__change=((int)1),
    sensitivity_kind__fall=((int)2),
    sn__sensitivity_kind__fall=((int)2),
    sensitivity_kind__rise=((int)3),
    sn__sensitivity_kind__rise=((int)3)
} t__sn__sensitivity_kind;

#define d__sn__sensitivity_kind 2170

typedef t__sn__sensitivity_kind t__sensitivity_kind;

#define d__sensitivity_kind d__sn__sensitivity_kind

/* line 241 "../src/root_types.e"  From 'Enum type 'short_type'' */
typedef enum {
    short_type__INT_TYPE=((int)0),
    sn__short_type__INT_TYPE=((int)0),
    short_type__UINT_TYPE=((int)1),
    sn__short_type__UINT_TYPE=((int)1),
    short_type__BOOL_TYPE=((int)2),
    sn__short_type__BOOL_TYPE=((int)2),
    short_type__ENUM_TYPE=((int)3),
    sn__short_type__ENUM_TYPE=((int)3),
    short_type__FLOAT_TYPE=((int)4),
    sn__short_type__FLOAT_TYPE=((int)4),
    short_type__DOUBLE_TYPE=((int)5),
    sn__short_type__DOUBLE_TYPE=((int)5),
    short_type__OTHER_TYPE=((int)6),
    sn__short_type__OTHER_TYPE=((int)6),
    short_type__STRING_TYPE=((int)7),
    sn__short_type__STRING_TYPE=((int)7),
    short_type__STRUCT_TYPE=((int)8),
    sn__short_type__STRUCT_TYPE=((int)8),
    short_type__LONG_TYPE=((int)9),
    sn__short_type__LONG_TYPE=((int)9),
    short_type__ULONG_TYPE=((int)10),
    sn__short_type__ULONG_TYPE=((int)10)
} t__sn__short_type;

#define d__sn__short_type 153

typedef t__sn__short_type t__short_type;

#define d__short_type d__sn__short_type

/* line 256 "../src/root_types.e"  From 'Enum type 'sn_export_qualified'' */
typedef enum {
    sn_export_qualified__dont_know=((int)0),
    sn__sn_export_qualified__dont_know=((int)0),
    sn_export_qualified__export_qualified_only=((int)1),
    sn__sn_export_qualified__export_qualified_only=((int)1),
    sn_export_qualified__export_non_qualified=((int)2),
    sn__sn_export_qualified__export_non_qualified=((int)2)
} t__sn__sn_export_qualified;

#define d__sn__sn_export_qualified 154

typedef t__sn__sn_export_qualified t__sn_export_qualified;

#define d__sn_export_qualified d__sn__sn_export_qualified

/* line 16 "/vobs/specman/src/script_type.e"  From 'type: count' */
#define t__sn__count t__int
#define t__count t__sn__count
/* line 20 "/vobs/specman/src/script_type.e"  From 'type: index' */
#define t__sn__index t__int
#define t__index t__sn__index
/* line 30 "/vobs/specman/src/gen_constraint_header.e"  From 'Enum type 'gc_status'' */
typedef enum {
    gc_status__active=((int)0),
    sn__gc_status__active=((int)0),
    gc_status__active_gotf=((int)1),
    sn__gc_status__active_gotf=((int)1),
    gc_status__replaced=((int)2),
    sn__gc_status__replaced=((int)2),
    gc_status__replaced_by_or_simple=((int)3),
    sn__gc_status__replaced_by_or_simple=((int)3),
    gc_status__reduce=((int)4),
    sn__gc_status__reduce=((int)4),
    gc_status__reduced_false=((int)5),
    sn__gc_status__reduced_false=((int)5),
    gc_status__ignored_has_one_alt=((int)6),
    sn__gc_status__ignored_has_one_alt=((int)6),
    gc_status__ignored_another_or_alt_is_true=((int)7),
    sn__gc_status__ignored_another_or_alt_is_true=((int)7),
    gc_status__ignored_another_and_alt_is_false=((int)8),
    sn__gc_status__ignored_another_and_alt_is_false=((int)8),
    gc_status__another_subtype=((int)9),
    sn__gc_status__another_subtype=((int)9),
    gc_status__another_gotf=((int)10),
    sn__gc_status__another_gotf=((int)10),
    gc_status__ignored_and_is_last_alt=((int)11),
    sn__gc_status__ignored_and_is_last_alt=((int)11),
    gc_status__ignored_and_with_one_alt=((int)12),
    sn__gc_status__ignored_and_with_one_alt=((int)12),
    gc_status__all_fixed=((int)13),
    sn__gc_status__all_fixed=((int)13),
    gc_status__all_fixed_in_role=((int)14),
    sn__gc_status__all_fixed_in_role=((int)14),
    gc_status__has_fixed_output=((int)15),
    sn__gc_status__has_fixed_output=((int)15),
    gc_status__has_fixed_in_role_output=((int)16),
    sn__gc_status__has_fixed_in_role_output=((int)16),
    gc_status__ignore_in_role=((int)17),
    sn__gc_status__ignore_in_role=((int)17),
    gc_status__fast_gen_updated=((int)18),
    sn__gc_status__fast_gen_updated=((int)18),
    gc_status__fast_gen_reset=((int)19),
    sn__gc_status__fast_gen_reset=((int)19),
    gc_status__not_active_in_parent=((int)20),
    sn__gc_status__not_active_in_parent=((int)20),
    gc_status__not_exist=((int)21),
    sn__gc_status__not_exist=((int)21)
} t__sn__gc_status;

#define d__sn__gc_status 2016

typedef t__sn__gc_status t__gc_status;

#define d__gc_status d__sn__gc_status

/* line 633 "/vobs/specman/src/basic_action.e"  From 'Enum type 'exp_kind'' */
typedef enum {
    exp_kind__normal=((int)0),
    sn__exp_kind__normal=((int)0),
    exp_kind__constant=((int)1),
    sn__exp_kind__constant=((int)1),
    exp_kind__call=((int)2),
    sn__exp_kind__call=((int)2),
    exp_kind__constant_call=((int)3),
    sn__exp_kind__constant_call=((int)3)
} t__sn__exp_kind;

#define d__sn__exp_kind 527

typedef t__sn__exp_kind t__exp_kind;

#define d__exp_kind d__sn__exp_kind

/* line 832 "../src/root_types.e"  From 'Enum type 'method_kind'' */
typedef enum {
    method_kind__C=((int)0),
    sn__method_kind__C=((int)0),
    method_kind__empty=((int)1),
    sn__method_kind__empty=((int)1),
    method_kind__undefined=((int)2),
    sn__method_kind__undefined=((int)2),
    method_kind__also=((int)3),
    sn__method_kind__also=((int)3),
    method_kind__first=((int)4),
    sn__method_kind__first=((int)4),
    method_kind__only=((int)5),
    sn__method_kind__only=((int)5),
    method_kind__is=((int)6),
    sn__method_kind__is=((int)6),
    method_kind__only_C=((int)7),
    sn__method_kind__only_C=((int)7),
    method_kind__roll_back=((int)8),
    sn__method_kind__roll_back=((int)8),
    method_kind__none=((int)9),
    sn__method_kind__none=((int)9)
} t__sn__method_kind;

#define d__sn__method_kind 186

typedef t__sn__method_kind t__method_kind;

#define d__method_kind d__sn__method_kind

/* line 314 "../src/root_ntv.e"  From 'Enum type 'form_kind'' */
typedef enum {
    form_kind__PARAN_FORM=((int)0),
    sn__form_kind__PARAN_FORM=((int)0),
    form_kind__SQUARE_FORM=((int)1),
    sn__form_kind__SQUARE_FORM=((int)1),
    form_kind__DOUBLE_QUOTE_FORM=((int)2),
    sn__form_kind__DOUBLE_QUOTE_FORM=((int)2),
    form_kind__CURLY_FORM=((int)3),
    sn__form_kind__CURLY_FORM=((int)3),
    form_kind__COLON_FORM=((int)4),
    sn__form_kind__COLON_FORM=((int)4),
    form_kind__HASH_COLON_FORM=((int)5),
    sn__form_kind__HASH_COLON_FORM=((int)5),
    form_kind__TOP_FORM=((int)6),
    sn__form_kind__TOP_FORM=((int)6),
    form_kind__SEMI_FORM=((int)7),
    sn__form_kind__SEMI_FORM=((int)7),
    form_kind__REPARSE_FORM=((int)8),
    sn__form_kind__REPARSE_FORM=((int)8),
    form_kind__REPARSE_MULTI_FORM=((int)9),
    sn__form_kind__REPARSE_MULTI_FORM=((int)9)
} t__sn__form_kind;

#define d__sn__form_kind 273

typedef t__sn__form_kind t__form_kind;

#define d__form_kind d__sn__form_kind

/* line 3 "/vobs/specman/src/port_attributes.e"  From 'Enum type 'analog_kind_t'' */
typedef enum {
    analog_kind_t__unset=((int)0),
    sn__analog_kind_t__unset=((int)0),
    analog_kind_t__potential=((int)1),
    sn__analog_kind_t__potential=((int)1),
    analog_kind_t__flow=((int)2),
    sn__analog_kind_t__flow=((int)2)
} t__sn__analog_kind_t;

#define d__sn__analog_kind_t 6669

typedef t__sn__analog_kind_t t__analog_kind_t;

#define d__analog_kind_t d__sn__analog_kind_t

/* line 236 "/vobs/specman/src/port_defs.e"  From 'Enum type 'sn_vhdl_delay_mode'' */
typedef enum {
    sn_vhdl_delay_mode__INERTIAL=((int)0),
    sn__sn_vhdl_delay_mode__INERTIAL=((int)0),
    sn_vhdl_delay_mode__TRANSPORT=((int)1),
    sn__sn_vhdl_delay_mode__TRANSPORT=((int)1)
} t__sn__sn_vhdl_delay_mode;

#define d__sn__sn_vhdl_delay_mode 1193

typedef t__sn__sn_vhdl_delay_mode t__sn_vhdl_delay_mode;

#define d__sn_vhdl_delay_mode d__sn__sn_vhdl_delay_mode

/* line 669 "/vobs/specman/src/hdl_struct.e"  From 'Enum type 'vhdl_set'' */
typedef enum {
    vhdl_set__INERTIAL=((int)0),
    sn__vhdl_set__INERTIAL=((int)0),
    vhdl_set__TRANSPORT=((int)1),
    sn__vhdl_set__TRANSPORT=((int)1)
} t__sn__vhdl_set;

#define d__sn__vhdl_set 2226

typedef t__sn__vhdl_set t__vhdl_set;

#define d__vhdl_set d__sn__vhdl_set

/* line 738 "/vobs/specman/src/te_structs.e"  From 'Enum type 'on_method_status'' */
typedef enum {
    on_method_status__on_unknown=((int)0),
    sn__on_method_status__on_unknown=((int)0),
    on_method_status__on_empty=((int)1),
    sn__on_method_status__on_empty=((int)1),
    on_method_status__on_extended=((int)2),
    sn__on_method_status__on_extended=((int)2)
} t__sn__on_method_status;

#define d__sn__on_method_status 2808

typedef t__sn__on_method_status t__on_method_status;

#define d__on_method_status d__sn__on_method_status

/* line 290 "/vobs/specman/src/te_structs.e"  From 'Enum type 'sn_event_kind'' */
typedef enum {
    sn_event_kind__empty=((int)0),
    sn__sn_event_kind__empty=((int)0),
    sn_event_kind__hdl=((int)1),
    sn__sn_event_kind__hdl=((int)1),
    sn_event_kind__te=((int)2),
    sn__sn_event_kind__te=((int)2),
    sn_event_kind__regular=((int)3),
    sn__sn_event_kind__regular=((int)3),
    sn_event_kind__consumed=((int)4),
    sn__sn_event_kind__consumed=((int)4)
} t__sn__sn_event_kind;

#define d__sn__sn_event_kind 2799

typedef t__sn__sn_event_kind t__sn_event_kind;

#define d__sn_event_kind d__sn__sn_event_kind

/* line 1911 "../src/root_basic.e"  From 'Enum type 'po_radix'' */
typedef enum {
    po_radix__DEC=((int)0),
    e_core__po_radix__DEC=((int)0),
    po_radix__HEX=((int)1),
    e_core__po_radix__HEX=((int)1),
    po_radix__BIN=((int)2),
    e_core__po_radix__BIN=((int)2)
} t__e_core__po_radix;

#define d__e_core__po_radix 110

typedef t__e_core__po_radix t__po_radix;

#define d__po_radix d__e_core__po_radix

/* line 173 "/vobs/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_radix'' */
typedef enum {
    sn_cvr_radix__DEC=((int)0),
    main__sn_cvr_radix__DEC=((int)0),
    sn_cvr_radix__HEX=((int)1),
    main__sn_cvr_radix__HEX=((int)1),
    sn_cvr_radix__BIN=((int)2),
    main__sn_cvr_radix__BIN=((int)2),
    sn_cvr_radix__DEF=((int)3),
    main__sn_cvr_radix__DEF=((int)3)
} t__main__sn_cvr_radix;

#define d__main__sn_cvr_radix 3574

typedef t__main__sn_cvr_radix t__sn_cvr_radix;

#define d__sn_cvr_radix d__main__sn_cvr_radix

/* line 159 "/vobs/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_external_option'' */
typedef enum {
    sn_cvr_external_option__none=((int)0),
    main__sn_cvr_external_option__none=((int)0),
    sn_cvr_external_option__external=((int)1),
    main__sn_cvr_external_option__external=((int)1),
    sn_cvr_external_option__normal=((int)2),
    main__sn_cvr_external_option__normal=((int)2)
} t__main__sn_cvr_external_option;

#define d__main__sn_cvr_external_option 3568

typedef t__main__sn_cvr_external_option t__sn_cvr_external_option;

#define d__sn_cvr_external_option d__main__sn_cvr_external_option

/* line 44 "../src/root_basic.e"  From 'type: C_double' */
typedef double t__C_double;
#define d__C_double 10
/* line 136 "/vobs/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_item_kind'' */
typedef enum {
    sn_cvr_item_kind__simple=((int)0),
    main__sn_cvr_item_kind__simple=((int)0),
    sn_cvr_item_kind__cross=((int)1),
    main__sn_cvr_item_kind__cross=((int)1),
    sn_cvr_item_kind__transition=((int)2),
    main__sn_cvr_item_kind__transition=((int)2),
    sn_cvr_item_kind__extend=((int)3),
    main__sn_cvr_item_kind__extend=((int)3)
} t__main__sn_cvr_item_kind;

#define d__main__sn_cvr_item_kind 3560

typedef t__main__sn_cvr_item_kind t__sn_cvr_item_kind;

#define d__sn_cvr_item_kind d__main__sn_cvr_item_kind

/* line 15 "/vobs/specman/src/cast.e"  From 'Enum type 'cast'' */
typedef enum {
    cast__none=((int)0),
    sn__cast__none=((int)0),
    cast__int2int=((int)1),
    sn__cast__int2int=((int)1),
    cast__int2uint=((int)2),
    sn__cast__int2uint=((int)2),
    cast__int2long=((int)3),
    sn__cast__int2long=((int)3),
    cast__int2double=((int)4),
    sn__cast__int2double=((int)4),
    cast__uint2int=((int)5),
    sn__cast__uint2int=((int)5),
    cast__uint2uint=((int)6),
    sn__cast__uint2uint=((int)6),
    cast__uint2long=((int)7),
    sn__cast__uint2long=((int)7),
    cast__uint2double=((int)8),
    sn__cast__uint2double=((int)8),
    cast__long2int=((int)9),
    sn__cast__long2int=((int)9),
    cast__long2uint=((int)10),
    sn__cast__long2uint=((int)10),
    cast__long2long=((int)11),
    sn__cast__long2long=((int)11),
    cast__long2double=((int)12),
    sn__cast__long2double=((int)12),
    cast__double2int=((int)13),
    sn__cast__double2int=((int)13),
    cast__double2uint=((int)14),
    sn__cast__double2uint=((int)14),
    cast__double2long=((int)15),
    sn__cast__double2long=((int)15),
    cast__double2double=((int)16),
    sn__cast__double2double=((int)16)
} t__sn__cast;

#define d__sn__cast 504

typedef t__sn__cast t__cast;

#define d__cast d__sn__cast

/* line 121 "/vobs/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_illegal_check_status'' */
typedef enum {
    sn_cvr_illegal_check_status__none=((int)0),
    main__sn_cvr_illegal_check_status__none=((int)0),
    sn_cvr_illegal_check_status__postponed=((int)1),
    main__sn_cvr_illegal_check_status__postponed=((int)1),
    sn_cvr_illegal_check_status__immediate=((int)2),
    main__sn_cvr_illegal_check_status__immediate=((int)2)
} t__main__sn_cvr_illegal_check_status;

#define d__main__sn_cvr_illegal_check_status 3556

typedef t__main__sn_cvr_illegal_check_status t__sn_cvr_illegal_check_status;

#define d__sn_cvr_illegal_check_status d__main__sn_cvr_illegal_check_status

/* line 150 "/vobs/specman/src/cover_com.e"  From 'type: bool (bits: 8)' */
#define t__bool__8 t__uint
/* line 17 "/vobs/specman/src/config_main.e"  From 'Enum type 'wave_event_data'' */
typedef enum {
    wave_event_data__occurrence_only=((int)0),
    sn__wave_event_data__occurrence_only=((int)0),
    wave_event_data__details=((int)1),
    sn__wave_event_data__details=((int)1),
    wave_event_data__all_data=((int)2),
    sn__wave_event_data__all_data=((int)2)
} t__sn__wave_event_data;

#define d__sn__wave_event_data 1351

typedef t__sn__wave_event_data t__wave_event_data;

#define d__wave_event_data d__sn__wave_event_data

/* line 34 "/vobs/specman/src/wave_services.e"  From 'Enum type 'wave_entry_type'' */
typedef enum {
    wave_entry_type__wave_bool=((int)0),
    sn__wave_entry_type__wave_bool=((int)0),
    wave_entry_type__wave_str=((int)1),
    sn__wave_entry_type__wave_str=((int)1),
    wave_entry_type__wave_int=((int)2),
    sn__wave_entry_type__wave_int=((int)2),
    wave_entry_type__wave_uint=((int)3),
    sn__wave_entry_type__wave_uint=((int)3),
    wave_entry_type__wave_event=((int)4),
    sn__wave_entry_type__wave_event=((int)4),
    wave_entry_type__wave_output=((int)5),
    sn__wave_entry_type__wave_output=((int)5),
    wave_entry_type__wave_error=((int)6),
    sn__wave_entry_type__wave_error=((int)6),
    wave_entry_type__wave_event_details=((int)7),
    sn__wave_entry_type__wave_event_details=((int)7)
} t__sn__wave_entry_type;

#define d__sn__wave_entry_type 4302

typedef t__sn__wave_entry_type t__wave_entry_type;

#define d__wave_entry_type d__sn__wave_entry_type

/* line 796 "/vobs/specman/src/when_subtype.e"  From 'Enum type 'subtype_descriptor'subtype_status'' */
typedef enum {
    subtype_descriptor__subtype_status__insignificant=((int)0),
    sn_when_subtype__subtype_descriptor__subtype_status__insignificant=((int)0),
    subtype_descriptor__subtype_status__significant=((int)1),
    sn_when_subtype__subtype_descriptor__subtype_status__significant=((int)1),
    subtype_descriptor__subtype_status__defined=((int)2),
    sn_when_subtype__subtype_descriptor__subtype_status__defined=((int)2)
} t__imp_enum_sn_when_subtype__subtype_descriptor__subtype_status;

#define d__imp_enum_sn_when_subtype__subtype_descriptor__subtype_status 1095

typedef t__imp_enum_sn_when_subtype__subtype_descriptor__subtype_status t__imp_enum_subtype_descriptor__subtype_status;

#define d__imp_enum_subtype_descriptor__subtype_status d__imp_enum_sn_when_subtype__subtype_descriptor__subtype_status

/* line 86 "/vobs/specman/src/gen_constraint_header.e"  From 'Enum type 'sn_fast_gen_status'' */
typedef enum {
    sn_fast_gen_status__no_dets=((int)0),
    sn__sn_fast_gen_status__no_dets=((int)0),
    sn_fast_gen_status__specified=((int)1),
    sn__sn_fast_gen_status__specified=((int)1),
    sn_fast_gen_status__specified_reset=((int)2),
    sn__sn_fast_gen_status__specified_reset=((int)2),
    sn_fast_gen_status__all_dets=((int)3),
    sn__sn_fast_gen_status__all_dets=((int)3)
} t__sn__sn_fast_gen_status;

#define d__sn__sn_fast_gen_status 2020

typedef t__sn__sn_fast_gen_status t__sn_fast_gen_status;

#define d__sn_fast_gen_status d__sn__sn_fast_gen_status

/* line 113 "/vobs/specman/src/gen_static_reachable.e"  From 'Enum type 'visited_status'' */
typedef enum {
    visited_status__not_visited=((int)0),
    sn__visited_status__not_visited=((int)0),
    visited_status__visited=((int)1),
    sn__visited_status__visited=((int)1),
    visited_status__visited_on_path=((int)2),
    sn__visited_status__visited_on_path=((int)2),
    visited_status__visited_one_field=((int)3),
    sn__visited_status__visited_one_field=((int)3),
    visited_status__visited_all=((int)4),
    sn__visited_status__visited_all=((int)4)
} t__sn__visited_status;

#define d__sn__visited_status 5794

typedef t__sn__visited_status t__visited_status;

#define d__visited_status d__sn__visited_status

/* line 69 "/vobs/specman/src/operators.e"  From 'Enum type 'constraint_role_type'' */
typedef enum {
    constraint_role_type__none=((int)0),
    sn__constraint_role_type__none=((int)0),
    constraint_role_type__in_all=((int)1),
    sn__constraint_role_type__in_all=((int)1),
    constraint_role_type__in_one=((int)2),
    sn__constraint_role_type__in_one=((int)2),
    constraint_role_type__imply_exp=((int)3),
    sn__constraint_role_type__imply_exp=((int)3),
    constraint_role_type__list_exp=((int)4),
    sn__constraint_role_type__list_exp=((int)4),
    constraint_role_type__field_exp=((int)5),
    sn__constraint_role_type__field_exp=((int)5),
    constraint_role_type__it_exp=((int)6),
    sn__constraint_role_type__it_exp=((int)6),
    constraint_role_type__index_exp=((int)7),
    sn__constraint_role_type__index_exp=((int)7),
    constraint_role_type__prev_exp=((int)8),
    sn__constraint_role_type__prev_exp=((int)8),
    constraint_role_type__and_exp=((int)9),
    sn__constraint_role_type__and_exp=((int)9),
    constraint_role_type__size_attr=((int)10),
    sn__constraint_role_type__size_attr=((int)10),
    constraint_role_type__is_empty_a=((int)11),
    sn__constraint_role_type__is_empty_a=((int)11),
    constraint_role_type__is_a_exp=((int)12),
    sn__constraint_role_type__is_a_exp=((int)12),
    constraint_role_type__as_a_exp=((int)13),
    sn__constraint_role_type__as_a_exp=((int)13),
    constraint_role_type__all_iterations=((int)14),
    sn__constraint_role_type__all_iterations=((int)14),
    constraint_role_type__elem_iteration=((int)15),
    sn__constraint_role_type__elem_iteration=((int)15),
    constraint_role_type__is_permutation=((int)16),
    sn__constraint_role_type__is_permutation=((int)16),
    constraint_role_type__elem_it_permutation=((int)17),
    sn__constraint_role_type__elem_it_permutation=((int)17),
    constraint_role_type__elem_in_permutation=((int)18),
    sn__constraint_role_type__elem_in_permutation=((int)18),
    constraint_role_type__lazy_and=((int)19),
    sn__constraint_role_type__lazy_and=((int)19),
    constraint_role_type__lazy_or=((int)20),
    sn__constraint_role_type__lazy_or=((int)20),
    constraint_role_type__and_op=((int)21),
    sn__constraint_role_type__and_op=((int)21),
    constraint_role_type__or_op=((int)22),
    sn__constraint_role_type__or_op=((int)22),
    constraint_role_type__is_not_a_exp=((int)23),
    sn__constraint_role_type__is_not_a_exp=((int)23)
} t__sn__constraint_role_type;

#define d__sn__constraint_role_type 815

typedef t__sn__constraint_role_type t__constraint_role_type;

#define d__constraint_role_type d__sn__constraint_role_type

/* line 65 "/vobs/specman/src/gen_constraint_header.e"  From 'Enum type 'om_edge_reason'' */
typedef enum {
    om_edge_reason__UNDEFINED=((int)0),
    sn__om_edge_reason__UNDEFINED=((int)0),
    om_edge_reason__explicit=((int)1),
    sn__om_edge_reason__explicit=((int)1),
    om_edge_reason__uni_const=((int)2),
    sn__om_edge_reason__uni_const=((int)2),
    om_edge_reason__bi_const=((int)3),
    sn__om_edge_reason__bi_const=((int)3),
    om_edge_reason__when_determinant=((int)4),
    sn__om_edge_reason__when_determinant=((int)4),
    om_edge_reason__list_item_constraint=((int)5),
    sn__om_edge_reason__list_item_constraint=((int)5),
    om_edge_reason__temps_closure=((int)6),
    sn__om_edge_reason__temps_closure=((int)6),
    om_edge_reason__uni_soft_bits=((int)7),
    sn__om_edge_reason__uni_soft_bits=((int)7),
    om_edge_reason__uni_bits_indices=((int)8),
    sn__om_edge_reason__uni_bits_indices=((int)8),
    om_edge_reason__uni_instance_to_unit=((int)9),
    sn__om_edge_reason__uni_instance_to_unit=((int)9),
    om_edge_reason__dof_uni_fixed_input=((int)10),
    sn__om_edge_reason__dof_uni_fixed_input=((int)10),
    om_edge_reason__dof_uni_from_outside=((int)11),
    sn__om_edge_reason__dof_uni_from_outside=((int)11),
    om_edge_reason__dof_bi_with_fixed=((int)12),
    sn__om_edge_reason__dof_bi_with_fixed=((int)12),
    om_edge_reason__pre=((int)13),
    sn__om_edge_reason__pre=((int)13),
    om_edge_reason__read_only=((int)14),
    sn__om_edge_reason__read_only=((int)14),
    om_edge_reason__list_constraint=((int)15),
    sn__om_edge_reason__list_constraint=((int)15),
    om_edge_reason__uni_unit_ref=((int)16),
    sn__om_edge_reason__uni_unit_ref=((int)16)
} t__sn__om_edge_reason;

#define d__sn__om_edge_reason 2018

typedef t__sn__om_edge_reason t__om_edge_reason;

#define d__om_edge_reason d__sn__om_edge_reason

/* line 290 "/vobs/specman/src/gen_static_header.e"  From 'Enum type 'a_role'debug_it'' */
typedef enum {
    a_role__debug_it__none=((int)0),
    sn__a_role__debug_it__none=((int)0),
    a_role__debug_it__some=((int)1),
    sn__a_role__debug_it__some=((int)1),
    a_role__debug_it__all=((int)2),
    sn__a_role__debug_it__all=((int)2)
} t__imp_enum_sn__a_role__debug_it;

#define d__imp_enum_sn__a_role__debug_it 5657

typedef t__imp_enum_sn__a_role__debug_it t__imp_enum_a_role__debug_it;

#define d__imp_enum_a_role__debug_it d__imp_enum_sn__a_role__debug_it

/* line 94 "/vobs/specman/src/gen_static_header.e"  From 'Enum type 'sn_role_creation_t'' */
typedef enum {
    sn_role_creation_t__unknown=((int)0),
    sn__sn_role_creation_t__unknown=((int)0),
    sn_role_creation_t__r_root=((int)1),
    sn__sn_role_creation_t__r_root=((int)1),
    sn_role_creation_t__r_basic=((int)2),
    sn__sn_role_creation_t__r_basic=((int)2),
    sn_role_creation_t__r_prefixed_1=((int)3),
    sn__sn_role_creation_t__r_prefixed_1=((int)3),
    sn_role_creation_t__r_extra=((int)4),
    sn__sn_role_creation_t__r_extra=((int)4),
    sn_role_creation_t__r_type=((int)5),
    sn__sn_role_creation_t__r_type=((int)5),
    sn_role_creation_t__r_prefixed_2=((int)6),
    sn__sn_role_creation_t__r_prefixed_2=((int)6),
    sn_role_creation_t__r_me=((int)7),
    sn__sn_role_creation_t__r_me=((int)7),
    sn_role_creation_t__r_holder=((int)8),
    sn__sn_role_creation_t__r_holder=((int)8),
    sn_role_creation_t__r_extra_basic=((int)9),
    sn__sn_role_creation_t__r_extra_basic=((int)9),
    sn_role_creation_t__r_soft_edge=((int)10),
    sn__sn_role_creation_t__r_soft_edge=((int)10)
} t__sn__sn_role_creation_t;

#define d__sn__sn_role_creation_t 5619

typedef t__sn__sn_role_creation_t t__sn_role_creation_t;

#define d__sn_role_creation_t d__sn__sn_role_creation_t

/* line 368 "/vobs/specman/src/gen_static_gcroles.e"  From 'Enum type 'a_role'gc_proc_status'' */
typedef enum {
    a_role__gc_proc_status__none=((int)0),
    sn__a_role__gc_proc_status__none=((int)0),
    a_role__gc_proc_status__alloced=((int)1),
    sn__a_role__gc_proc_status__alloced=((int)1),
    a_role__gc_proc_status__inited=((int)2),
    sn__a_role__gc_proc_status__inited=((int)2),
    a_role__gc_proc_status__eq_to_mgr=((int)3),
    sn__a_role__gc_proc_status__eq_to_mgr=((int)3)
} t__imp_enum_sn__a_role__gc_proc_status;

#define d__imp_enum_sn__a_role__gc_proc_status 5798

typedef t__imp_enum_sn__a_role__gc_proc_status t__imp_enum_a_role__gc_proc_status;

#define d__imp_enum_a_role__gc_proc_status d__imp_enum_sn__a_role__gc_proc_status

/* line 27 "/vobs/specman/src/gen_static_header.e"  From 'Enum type 'role_range_status'' */
typedef enum {
    role_range_status__unknown=((int)0),
    sn__role_range_status__unknown=((int)0),
    role_range_status__none=((int)1),
    sn__role_range_status__none=((int)1),
    role_range_status__has_range=((int)2),
    sn__role_range_status__has_range=((int)2),
    role_range_status__has_gcs=((int)3),
    sn__role_range_status__has_gcs=((int)3)
} t__sn__role_range_status;

#define d__sn__role_range_status 5608

typedef t__sn__role_range_status t__role_range_status;

#define d__role_range_status d__sn__role_range_status

/* line 50 "/vobs/specman/src/gen_static_header.e"  From 'Enum type 'status_in_role'' */
typedef enum {
    status_in_role__gotf=((int)0),
    sn__status_in_role__gotf=((int)0),
    status_in_role__not_gotf=((int)1),
    sn__status_in_role__not_gotf=((int)1),
    status_in_role__another_subtype=((int)2),
    sn__status_in_role__another_subtype=((int)2),
    status_in_role__dont_gen=((int)3),
    sn__status_in_role__dont_gen=((int)3),
    status_in_role__gen=((int)4),
    sn__status_in_role__gen=((int)4),
    status_in_role__on_gotf_path=((int)5),
    sn__status_in_role__on_gotf_path=((int)5),
    status_in_role__never_gen=((int)6),
    sn__status_in_role__never_gen=((int)6),
    status_in_role__tmp_gotf=((int)7),
    sn__status_in_role__tmp_gotf=((int)7),
    status_in_role__tmp_reallocated=((int)8),
    sn__status_in_role__tmp_reallocated=((int)8),
    status_in_role__tmp_in_keeping_only=((int)9),
    sn__status_in_role__tmp_in_keeping_only=((int)9),
    status_in_role__tmp_another_keeping=((int)10),
    sn__status_in_role__tmp_another_keeping=((int)10),
    status_in_role__tmp_another_local=((int)11),
    sn__status_in_role__tmp_another_local=((int)11),
    status_in_role__tmp_another_subtype=((int)12),
    sn__status_in_role__tmp_another_subtype=((int)12),
    status_in_role__tmp_global=((int)13),
    sn__status_in_role__tmp_global=((int)13),
    status_in_role__tmp_dont_gen=((int)14),
    sn__status_in_role__tmp_dont_gen=((int)14),
    status_in_role__tmp_gen=((int)15),
    sn__status_in_role__tmp_gen=((int)15),
    status_in_role__tmp_no_constraints=((int)16),
    sn__status_in_role__tmp_no_constraints=((int)16)
} t__sn__status_in_role;

#define d__sn__status_in_role 5615

typedef t__sn__status_in_role t__status_in_role;

#define d__status_in_role d__sn__status_in_role

/* line 2 "/vobs/specman/src/gen_static_comms.e"  From 'Enum type 'fg_stat'' */
typedef enum {
    fg_stat__not_relevant=((int)0),
    sn__fg_stat__not_relevant=((int)0),
    fg_stat__from_type=((int)1),
    sn__fg_stat__from_type=((int)1),
    fg_stat__from_range=((int)2),
    sn__fg_stat__from_range=((int)2),
    fg_stat__from_gcs=((int)3),
    sn__fg_stat__from_gcs=((int)3)
} t__sn__fg_stat;

#define d__sn__fg_stat 5839

typedef t__sn__fg_stat t__fg_stat;

#define d__fg_stat d__sn__fg_stat

/* line 36 "../src/root_basic.e"  From 'type: pat' */
typedef sn_pattern t__pat;
#define d__pat 5
/* line 239 "../src/root_types.e"  From 'type: routine_pointer' */
typedef sn_routine_pointer_type t__routine_pointer;
#define d__routine_pointer 152
/* line 926 "/vobs/specman/src/port_generic.e"  From 'Enum type 'cb_reason'' */
typedef enum {
    cb_reason__READ_EXTERNAL_CHANGE=((int)1),
    sn__cb_reason__READ_EXTERNAL_CHANGE=((int)1),
    cb_reason__READ_EXTERNAL=((int)3),
    sn__cb_reason__READ_EXTERNAL=((int)3),
    cb_reason__WRITE_EXTERNAL=((int)4),
    sn__cb_reason__WRITE_EXTERNAL=((int)4),
    cb_reason__EXTERNAL=((int)7),
    sn__cb_reason__EXTERNAL=((int)7),
    cb_reason__E2E_CHANGE=((int)16),
    sn__cb_reason__E2E_CHANGE=((int)16),
    cb_reason__E2E_ACTIVE=((int)24),
    sn__cb_reason__E2E_ACTIVE=((int)24),
    cb_reason__CHANGE=((int)17),
    sn__cb_reason__CHANGE=((int)17),
    cb_reason__RELEASE=((int)32),
    sn__cb_reason__RELEASE=((int)32),
    cb_reason__ANY_REASON=((int)63),
    sn__cb_reason__ANY_REASON=((int)63),
    cb_reason__ANY_TCB_REASON=((int)39),
    sn__cb_reason__ANY_TCB_REASON=((int)39),
    cb_reason__INVALID_ID=((int)128),
    sn__cb_reason__INVALID_ID=((int)128)
} t__sn__cb_reason;

#define d__sn__cb_reason 6688

typedef t__sn__cb_reason t__cb_reason;

#define d__cb_reason d__sn__cb_reason

/* line 28 "/vobs/specman/src/port_generic.e"  From 'Enum type 'sn_channel_type_t'' */
typedef enum {
    sn_channel_type_t__not_defined=((int)0),
    sn__sn_channel_type_t__not_defined=((int)0),
    sn_channel_type_t__undefined_channel=((int)1),
    sn__sn_channel_type_t__undefined_channel=((int)1),
    sn_channel_type_t__all_synthesized=((int)2),
    sn__sn_channel_type_t__all_synthesized=((int)2),
    sn_channel_type_t__empty_channel=((int)3),
    sn__sn_channel_type_t__empty_channel=((int)3),
    sn_channel_type_t__one_to_one_e2e=((int)4),
    sn__sn_channel_type_t__one_to_one_e2e=((int)4),
    sn_channel_type_t__one_to_one_ext=((int)5),
    sn__sn_channel_type_t__one_to_one_ext=((int)5),
    sn_channel_type_t__multi_e2e=((int)6),
    sn__sn_channel_type_t__multi_e2e=((int)6),
    sn_channel_type_t__multi_ext=((int)7),
    sn__sn_channel_type_t__multi_ext=((int)7)
} t__sn__sn_channel_type_t;

#define d__sn__sn_channel_type_t 6672

typedef t__sn__sn_channel_type_t t__sn_channel_type_t;

#define d__sn_channel_type_t d__sn__sn_channel_type_t

/* line 33 "../src/root_types.e"  From 'type: long_int' */
typedef long t__long_int;
#define d__long_int 144
/* line 346 "/vobs/specman/src/te_structs.e"  From 'Enum type 'waiting_thread_kind'' */
typedef enum {
    waiting_thread_kind__tcm_wait=((int)0),
    sn__waiting_thread_kind__tcm_wait=((int)0),
    waiting_thread_kind__tcm_sync=((int)1),
    sn__waiting_thread_kind__tcm_sync=((int)1),
    waiting_thread_kind__eval_event=((int)2),
    sn__waiting_thread_kind__eval_event=((int)2),
    waiting_thread_kind__eval_expect=((int)3),
    sn__waiting_thread_kind__eval_expect=((int)3)
} t__sn__waiting_thread_kind;

#define d__sn__waiting_thread_kind 2802

typedef t__sn__waiting_thread_kind t__waiting_thread_kind;

#define d__waiting_thread_kind d__sn__waiting_thread_kind

/* line 7 "/vobs/specman/src/e_core_types.e"  From 'type: thread_handle' */
#define t__e_core__thread_handle t__int
#define t__thread_handle t__e_core__thread_handle
/* line 35 "../src/root_basic.e"  From 'type: untyped' */
typedef void * t__untyped;
#define d__untyped 4
/* line 267 "/vobs/specman/src/te_root.e"  From 'type: bool (bits: 32)' */
#define t__bool__32 t__uint
/* line 235 "/vobs/specman/src/unit.e"  From 'Enum type 'e_time_units'' */
typedef enum {
    e_time_units__fs=((int)0),
    sn__e_time_units__fs=((int)0),
    e_time_units__ps=((int)1),
    sn__e_time_units__ps=((int)1),
    e_time_units__ns=((int)2),
    sn__e_time_units__ns=((int)2),
    e_time_units__us=((int)3),
    sn__e_time_units__us=((int)3),
    e_time_units__ms=((int)4),
    sn__e_time_units__ms=((int)4),
    e_time_units__sec=((int)5),
    sn__e_time_units__sec=((int)5),
    e_time_units__min=((int)6),
    sn__e_time_units__min=((int)6),
    e_time_units__hr=((int)7),
    sn__e_time_units__hr=((int)7)
} t__sn__e_time_units;

#define d__sn__e_time_units 1215

typedef t__sn__e_time_units t__e_time_units;

#define d__e_time_units d__sn__e_time_units

/* line 343 "../src/root_basic.e"  From 'Enum type 'config_os'' */
typedef enum {
    config_os__unknown=((int)0),
    e_core__config_os__unknown=((int)0),
    config_os__vms=((int)1),
    e_core__config_os__vms=((int)1),
    config_os__unix=((int)2),
    e_core__config_os__unix=((int)2)
} t__e_core__config_os;

#define d__e_core__config_os 38

typedef t__e_core__config_os t__config_os;

#define d__config_os d__e_core__config_os

/* line 349 "../src/root_basic.e"  From 'Enum type 'config_machine'' */
typedef enum {
    config_machine__unknown=((int)0),
    e_core__config_machine__unknown=((int)0),
    config_machine__vax=((int)1),
    e_core__config_machine__vax=((int)1),
    config_machine__mips=((int)2),
    e_core__config_machine__mips=((int)2),
    config_machine__alpha=((int)3),
    e_core__config_machine__alpha=((int)3),
    config_machine__sparc=((int)4),
    e_core__config_machine__sparc=((int)4),
    config_machine__hp=((int)5),
    e_core__config_machine__hp=((int)5)
} t__e_core__config_machine;

#define d__e_core__config_machine 39

typedef t__e_core__config_machine t__config_machine;

#define d__config_machine d__e_core__config_machine

/* line 36 "/vobs/specman/src/disp_modules.e"  From 'Enum type 'module_print_format_t'' */
typedef enum {
    module_print_format_t__short=((int)0),
    sn__module_print_format_t__short=((int)0),
    module_print_format_t__normal=((int)1),
    sn__module_print_format_t__normal=((int)1),
    module_print_format_t__lng=((int)2),
    sn__module_print_format_t__lng=((int)2)
} t__sn__module_print_format_t;

#define d__sn__module_print_format_t 2733

typedef t__sn__module_print_format_t t__module_print_format_t;

#define d__module_print_format_t d__sn__module_print_format_t

/* line 28 "/vobs/specman/src/erm_package_compatibility.e"  From 'Enum type 'erm_package_compatibility_warning_type'' */
typedef enum {
    erm_package_compatibility_warning_type__PACKAGE_NOT_FOUND=((int)0),
    sn__erm_package_compatibility_warning_type__PACKAGE_NOT_FOUND=((int)0),
    erm_package_compatibility_warning_type__PACKAGE_VERSION_INCOMPATIBILITY=((int)1),
    sn__erm_package_compatibility_warning_type__PACKAGE_VERSION_INCOMPATIBILITY=((int)1),
    erm_package_compatibility_warning_type__PACKAGE_VERSION_POSSIBLE_INCOMPATIBILITY=((int)2),
    sn__erm_package_compatibility_warning_type__PACKAGE_VERSION_POSSIBLE_INCOMPATIBILITY=((int)2),
    erm_package_compatibility_warning_type__SPECMAN_VERSION_INCOMPATIBILITY=((int)3),
    sn__erm_package_compatibility_warning_type__SPECMAN_VERSION_INCOMPATIBILITY=((int)3),
    erm_package_compatibility_warning_type__SPECMAN_VERSION_POSSIBLE_INCOMPATIBILITY=((int)4),
    sn__erm_package_compatibility_warning_type__SPECMAN_VERSION_POSSIBLE_INCOMPATIBILITY=((int)4)
} t__sn__erm_package_compatibility_warning_type;

#define d__sn__erm_package_compatibility_warning_type 7700

typedef t__sn__erm_package_compatibility_warning_type t__erm_package_compatibility_warning_type;

#define d__erm_package_compatibility_warning_type d__sn__erm_package_compatibility_warning_type

/* line 513 "../src/root_types.e"  From 'Enum type 'key_kind'' */
typedef enum {
    key_kind__none=((int)0),
    sn__key_kind__none=((int)0),
    key_kind__string=((int)1),
    sn__key_kind__string=((int)1),
    key_kind__int=((int)2),
    sn__key_kind__int=((int)2),
    key_kind__struct=((int)3),
    sn__key_kind__struct=((int)3),
    key_kind__long=((int)4),
    sn__key_kind__long=((int)4),
    key_kind__float=((int)5),
    sn__key_kind__float=((int)5),
    key_kind__double=((int)6),
    sn__key_kind__double=((int)6)
} t__sn__key_kind;

#define d__sn__key_kind 177

typedef t__sn__key_kind t__key_kind;

#define d__key_kind d__sn__key_kind

/* line 202 "../src/root_excep.e"  From 'Enum type 'do_reload_t'' */
typedef enum {
    do_reload_t__dont_reload=((int)0),
    sn__do_reload_t__dont_reload=((int)0),
    do_reload_t__reload_after_load=((int)1),
    sn__do_reload_t__reload_after_load=((int)1),
    do_reload_t__reload_after_translate=((int)2),
    sn__do_reload_t__reload_after_translate=((int)2)
} t__sn__do_reload_t;

#define d__sn__do_reload_t 412

typedef t__sn__do_reload_t t__do_reload_t;

#define d__do_reload_t d__sn__do_reload_t

/* line 39 "../src/root_excep.e"  From 'Enum type 'severity'' */
typedef enum {
    severity__error=((int)0),
    sn__severity__error=((int)0),
    severity__warning=((int)1),
    sn__severity__warning=((int)1),
    severity__fatal=((int)2),
    sn__severity__fatal=((int)2)
} t__sn__severity;

#define d__sn__severity 383

typedef t__sn__severity t__severity;

#define d__severity d__sn__severity

/* line 142 "../src/root_basic.e"  From 'Enum type 'vertice_color'' */
typedef enum {
    vertice_color__white=((int)0),
    e_core__vertice_color__white=((int)0),
    vertice_color__gray=((int)1),
    e_core__vertice_color__gray=((int)1),
    vertice_color__black=((int)2),
    e_core__vertice_color__black=((int)2)
} t__e_core__vertice_color;

#define d__e_core__vertice_color 21

typedef t__e_core__vertice_color t__vertice_color;

#define d__vertice_color d__e_core__vertice_color

/* line 47 "../src/root_basic.e"  From 'type: byte' */
typedef unsigned int t__byte;
#define d__byte 13
/* line 13 "/vobs/specman/src/options.e"  From 'Enum type 'option_descriptor'have_value'' */
typedef enum {
    option_descriptor__have_value__none=((int)0),
    sn__option_descriptor__have_value__none=((int)0),
    option_descriptor__have_value__possibly=((int)1),
    sn__option_descriptor__have_value__possibly=((int)1),
    option_descriptor__have_value__mandatory=((int)2),
    sn__option_descriptor__have_value__mandatory=((int)2)
} t__imp_enum_sn__option_descriptor__have_value;

#define d__imp_enum_sn__option_descriptor__have_value 1493

typedef t__imp_enum_sn__option_descriptor__have_value t__imp_enum_option_descriptor__have_value;

#define d__imp_enum_option_descriptor__have_value d__imp_enum_sn__option_descriptor__have_value

/* line 45 "/vobs/specman/src/gen_static_header.e"  From 'Enum type 'reduce_result'' */
typedef enum {
    reduce_result__normal=((int)0),
    sn__reduce_result__normal=((int)0),
    reduce_result__contradiction=((int)1),
    sn__reduce_result__contradiction=((int)1),
    reduce_result__always=((int)2),
    sn__reduce_result__always=((int)2),
    reduce_result__always_by_eval=((int)3),
    sn__reduce_result__always_by_eval=((int)3)
} t__sn__reduce_result;

#define d__sn__reduce_result 5612

typedef t__sn__reduce_result t__reduce_result;

#define d__reduce_result d__sn__reduce_result

/* line 13 "/vobs/specman/src/gen_reduce.e"  From 'Enum type 'graph_type'' */
typedef enum {
    graph_type__static=((int)0),
    sn__graph_type__static=((int)0),
    graph_type__dynamic=((int)1),
    sn__graph_type__dynamic=((int)1),
    graph_type__choose=((int)2),
    sn__graph_type__choose=((int)2)
} t__sn__graph_type;

#define d__sn__graph_type 5756

typedef t__sn__graph_type t__graph_type;

#define d__graph_type d__sn__graph_type

/* line 67 "/vobs/specman/src/gen_msg_header.e"  From 'Enum type 'gendb_item'phase'' */
typedef enum {
    gendb_item__phase__static=((int)0),
    sn__gendb_item__phase__static=((int)0),
    gendb_item__phase__dynamic=((int)1),
    sn__gendb_item__phase__dynamic=((int)1)
} t__imp_enum_sn__gendb_item__phase;

#define d__imp_enum_sn__gendb_item__phase 2144

typedef t__imp_enum_sn__gendb_item__phase t__imp_enum_gendb_item__phase;

#define d__imp_enum_gendb_item__phase d__imp_enum_sn__gendb_item__phase

/* line 28 "/vobs/specman/src/gen_static_header.e"  From 'Enum type 'which_rl'' */
typedef enum {
    which_rl__regular=((int)0),
    sn__which_rl__regular=((int)0),
    which_rl__the_size=((int)1),
    sn__which_rl__the_size=((int)1),
    which_rl__the_item=((int)2),
    sn__which_rl__the_item=((int)2),
    which_rl__list_temp=((int)3),
    sn__which_rl__list_temp=((int)3)
} t__sn__which_rl;

#define d__sn__which_rl 5610

typedef t__sn__which_rl t__which_rl;

#define d__which_rl d__sn__which_rl

/* line 24 "/vobs/specman/src/gen_run_structs.e"  From 'Enum type 'pn_status'' */
typedef enum {
    pn_status__active=((int)0),
    sn__pn_status__active=((int)0),
    pn_status__selected=((int)1),
    sn__pn_status__selected=((int)1),
    pn_status__eval_by_gen=((int)2),
    sn__pn_status__eval_by_gen=((int)2),
    pn_status__eval_by_method=((int)3),
    sn__pn_status__eval_by_method=((int)3),
    pn_status__set_by_gen=((int)4),
    sn__pn_status__set_by_gen=((int)4),
    pn_status__set_by_method=((int)5),
    sn__pn_status__set_by_method=((int)5),
    pn_status__skipped=((int)6),
    sn__pn_status__skipped=((int)6),
    pn_status__delayed=((int)7),
    sn__pn_status__delayed=((int)7)
} t__sn__pn_status;

#define d__sn__pn_status 5668

typedef t__sn__pn_status t__pn_status;

#define d__pn_status d__sn__pn_status

/* line 314 "/vobs/specman/src/rl_interface.e"  From 'Enum type 'abstract_gen_type'' */
typedef enum {
    abstract_gen_type__int_type=((int)0),
    sn_rl__abstract_gen_type__int_type=((int)0),
    abstract_gen_type__uint_type=((int)1),
    sn_rl__abstract_gen_type__uint_type=((int)1),
    abstract_gen_type__long_type=((int)2),
    sn_rl__abstract_gen_type__long_type=((int)2),
    abstract_gen_type__struct_type=((int)3),
    sn_rl__abstract_gen_type__struct_type=((int)3),
    abstract_gen_type__string_type=((int)4),
    sn_rl__abstract_gen_type__string_type=((int)4),
    abstract_gen_type__double_type=((int)5),
    sn_rl__abstract_gen_type__double_type=((int)5),
    abstract_gen_type__list_of_int_type=((int)6),
    sn_rl__abstract_gen_type__list_of_int_type=((int)6),
    abstract_gen_type__list_of_uint_type=((int)7),
    sn_rl__abstract_gen_type__list_of_uint_type=((int)7),
    abstract_gen_type__list_of_long_type=((int)8),
    sn_rl__abstract_gen_type__list_of_long_type=((int)8),
    abstract_gen_type__list_of_struct_type=((int)9),
    sn_rl__abstract_gen_type__list_of_struct_type=((int)9),
    abstract_gen_type__list_of_string_type=((int)10),
    sn_rl__abstract_gen_type__list_of_string_type=((int)10),
    abstract_gen_type__list_of_double_type=((int)11),
    sn_rl__abstract_gen_type__list_of_double_type=((int)11),
    abstract_gen_type__other_type=((int)12),
    sn_rl__abstract_gen_type__other_type=((int)12)
} t__sn_rl__abstract_gen_type;

#define d__sn_rl__abstract_gen_type 1645

typedef t__sn_rl__abstract_gen_type t__abstract_gen_type;

#define d__abstract_gen_type d__sn_rl__abstract_gen_type

/* line 35 "/vobs/specman/src/gen_run_structs.e"  From 'subtype: has_constraints field_node' */
#define d__TRUE__has_constraints__sn__field_node 5718
/* line 17 "/vobs/specman/src/gen_debug_header.e"  From 'Enum type 'sn_gen_status_type'' */
typedef enum {
    sn_gen_status_type__active=((int)0),
    sn__sn_gen_status_type__active=((int)0),
    sn_gen_status_type__is_true=((int)1),
    sn__sn_gen_status_type__is_true=((int)1),
    sn_gen_status_type__is_false=((int)2),
    sn__sn_gen_status_type__is_false=((int)2),
    sn_gen_status_type__ignore=((int)3),
    sn__sn_gen_status_type__ignore=((int)3),
    sn_gen_status_type__ignore_soft=((int)4),
    sn__sn_gen_status_type__ignore_soft=((int)4),
    sn_gen_status_type__no_active=((int)5),
    sn__sn_gen_status_type__no_active=((int)5)
} t__sn__sn_gen_status_type;

#define d__sn__sn_gen_status_type 2125

typedef t__sn__sn_gen_status_type t__sn_gen_status_type;

#define d__sn_gen_status_type d__sn__sn_gen_status_type

/* line 428 "/vobs/specman/src/gen_run_structs.e"  From 'Enum type 'sn_gen_access_status'' */
typedef enum {
    sn_gen_access_status__inaccessible=((int)0),
    sn__sn_gen_access_status__inaccessible=((int)0),
    sn_gen_access_status__accessible=((int)1),
    sn__sn_gen_access_status__accessible=((int)1),
    sn_gen_access_status__do_not_generate=((int)2),
    sn__sn_gen_access_status__do_not_generate=((int)2)
} t__sn__sn_gen_access_status;

#define d__sn__sn_gen_access_status 5691

typedef t__sn__sn_gen_access_status t__sn_gen_access_status;

#define d__sn_gen_access_status d__sn__sn_gen_access_status

/* line 35 "/vobs/specman/src/gen_run_structs.e"  From 'subtype: is_list field_node' */
#define d__TRUE__is_list__sn__field_node 5721
/* line 35 "/vobs/specman/src/gen_run_structs.e"  From 'subtype: FALSE'is_list has_constraints the_item field_node' */
#define d__the_item__the_wr__TRUE__has_constraints__FALSE__is_list__sn__field_node 5722
/* line 87 "/vobs/specman/src/gen_run_structs.e"  From 'Enum type 'list_ci'ci_type'' */
typedef enum {
    list_ci__ci_type__index_ci=((int)0),
    sn__list_ci__ci_type__index_ci=((int)0),
    list_ci__ci_type__item_in_list_ci=((int)1),
    sn__list_ci__ci_type__item_in_list_ci=((int)1),
    list_ci__ci_type__item_not_in_list_ci=((int)2),
    sn__list_ci__ci_type__item_not_in_list_ci=((int)2),
    list_ci__ci_type__list_in_list_ci=((int)3),
    sn__list_ci__ci_type__list_in_list_ci=((int)3),
    list_ci__ci_type__list_eq_ci=((int)4),
    sn__list_ci__ci_type__list_eq_ci=((int)4),
    list_ci__ci_type__list_ne_ci=((int)5),
    sn__list_ci__ci_type__list_ne_ci=((int)5),
    list_ci__ci_type__general_ci=((int)6),
    sn__list_ci__ci_type__general_ci=((int)6)
} t__imp_enum_sn__list_ci__ci_type;

#define d__imp_enum_sn__list_ci__ci_type 5707

typedef t__imp_enum_sn__list_ci__ci_type t__imp_enum_list_ci__ci_type;

#define d__imp_enum_list_ci__ci_type d__imp_enum_sn__list_ci__ci_type

/* line 35 "/vobs/specman/src/gen_run_structs.e"  From 'subtype: struct_type field_node' */
#define d__struct_type__agt__sn__field_node 5711
/* line 2469 "/vobs/specman/src/gen_gendb_header.e"  From 'Enum type 'sn_status_result_kinds'' */
typedef enum {
    sn_status_result_kinds__ci_TRUE=((int)0),
    sn__sn_status_result_kinds__ci_TRUE=((int)0),
    sn_status_result_kinds__ci_FALSE=((int)1),
    sn__sn_status_result_kinds__ci_FALSE=((int)1),
    sn_status_result_kinds__ci_IGNORED=((int)2),
    sn__sn_status_result_kinds__ci_IGNORED=((int)2),
    sn_status_result_kinds__ci_BECAME_SIMPLE=((int)3),
    sn__sn_status_result_kinds__ci_BECAME_SIMPLE=((int)3),
    sn_status_result_kinds__ci_NONE=((int)4),
    sn__sn_status_result_kinds__ci_NONE=((int)4)
} t__sn__sn_status_result_kinds;

#define d__sn__sn_status_result_kinds 5985

typedef t__sn__sn_status_result_kinds t__sn_status_result_kinds;

#define d__sn_status_result_kinds d__sn__sn_status_result_kinds

/* line 1491 "/vobs/specman/src/gen_gendb_header.e"  From 'Enum type 'sn_gendb_status'' */
typedef enum {
    sn_gendb_status__SATISFIED=((int)0),
    sn__sn_gendb_status__SATISFIED=((int)0),
    sn_gendb_status__CONTRADICTS=((int)1),
    sn__sn_gendb_status__CONTRADICTS=((int)1),
    sn_gendb_status__IGNORED_INACCESSIBLE_DONGEN_PATH=((int)2),
    sn__sn_gendb_status__IGNORED_INACCESSIBLE_DONGEN_PATH=((int)2),
    sn_gendb_status__IGNORED_AND_BECAME_FALSE=((int)3),
    sn__sn_gendb_status__IGNORED_AND_BECAME_FALSE=((int)3),
    sn_gendb_status__IGNORED_OR_BECAME_TRUE=((int)4),
    sn__sn_gendb_status__IGNORED_OR_BECAME_TRUE=((int)4),
    sn_gendb_status__IGNORED_AND_BECAME_IGNORED=((int)5),
    sn__sn_gendb_status__IGNORED_AND_BECAME_IGNORED=((int)5),
    sn_gendb_status__BECAME_SIMPLE_AND_BECAME_SIMPLE=((int)6),
    sn__sn_gendb_status__BECAME_SIMPLE_AND_BECAME_SIMPLE=((int)6),
    sn_gendb_status__BECAME_SIMPLE_OR_BECAME_ONE_ALT=((int)7),
    sn__sn_gendb_status__BECAME_SIMPLE_OR_BECAME_ONE_ALT=((int)7),
    sn_gendb_status__AND_ALT_BECAME_FALSE=((int)8),
    sn__sn_gendb_status__AND_ALT_BECAME_FALSE=((int)8),
    sn_gendb_status__AND_ALT_BECAME_TRUE=((int)9),
    sn__sn_gendb_status__AND_ALT_BECAME_TRUE=((int)9),
    sn_gendb_status__AND_LAST_ALT_BECAME_TRUE=((int)10),
    sn__sn_gendb_status__AND_LAST_ALT_BECAME_TRUE=((int)10),
    sn_gendb_status__AND_IGNORED_OR_BECAME_TRUE=((int)11),
    sn__sn_gendb_status__AND_IGNORED_OR_BECAME_TRUE=((int)11),
    sn_gendb_status__AND_IGNORED_OR_BECAME_ONE_ALT=((int)12),
    sn__sn_gendb_status__AND_IGNORED_OR_BECAME_ONE_ALT=((int)12),
    sn_gendb_status__OR_ALT_BECAME_TRUE=((int)13),
    sn__sn_gendb_status__OR_ALT_BECAME_TRUE=((int)13),
    sn_gendb_status__OR_ALT_BECAME_FALSE=((int)14),
    sn__sn_gendb_status__OR_ALT_BECAME_FALSE=((int)14),
    sn_gendb_status__OR_LEFT_WITH_ONE_ALT=((int)15),
    sn__sn_gendb_status__OR_LEFT_WITH_ONE_ALT=((int)15),
    sn_gendb_status__OR_IS_IGNORED_SOFT=((int)16),
    sn__sn_gendb_status__OR_IS_IGNORED_SOFT=((int)16)
} t__sn__sn_gendb_status;

#define d__sn__sn_gendb_status 5937

typedef t__sn__sn_gendb_status t__sn_gendb_status;

#define d__sn_gendb_status d__sn__sn_gendb_status

/* line 1086 "/vobs/specman/src/gen_gendb_header.e"  From 'Enum type 'gen_process_status'' */
typedef enum {
    gen_process_status__in_progress=((int)0),
    sn__gen_process_status__in_progress=((int)0),
    gen_process_status__complete=((int)1),
    sn__gen_process_status__complete=((int)1),
    gen_process_status__error=((int)2),
    sn__gen_process_status__error=((int)2)
} t__sn__gen_process_status;

#define d__sn__gen_process_status 5922

typedef t__sn__gen_process_status t__gen_process_status;

#define d__gen_process_status d__sn__gen_process_status

/* line 34 "/vobs/specman/src/gen_reduce_or.e"  From 'Enum type 'status_in_and'' */
typedef enum {
    status_in_and__none=((int)0),
    sn__status_in_and__none=((int)0),
    status_in_and__in_one_path=((int)1),
    sn__status_in_and__in_one_path=((int)1),
    status_in_and__in_simple=((int)2),
    sn__status_in_and__in_simple=((int)2)
} t__sn__status_in_and;

#define d__sn__status_in_and 5762

typedef t__sn__status_in_and t__status_in_and;

#define d__status_in_and d__sn__status_in_and

/* line 32 "/vobs/specman/src/gen_reduce_or.e"  From 'Enum type 'status_in_or'' */
typedef enum {
    status_in_or__none=((int)0),
    sn__status_in_or__none=((int)0),
    status_in_or__in_one_path=((int)1),
    sn__status_in_or__in_one_path=((int)1),
    status_in_or__in_simple=((int)2),
    sn__status_in_or__in_simple=((int)2),
    status_in_or__one_in_and=((int)3),
    sn__status_in_or__one_in_and=((int)3),
    status_in_or__multi_in_and=((int)4),
    sn__status_in_or__multi_in_and=((int)4),
    status_in_or__removed=((int)5),
    sn__status_in_or__removed=((int)5)
} t__sn__status_in_or;

#define d__sn__status_in_or 5760

typedef t__sn__status_in_or t__status_in_or;

#define d__status_in_or d__sn__status_in_or

/* line 46 "/vobs/specman/src/port_simple_channel.e"  From 'Enum type 'put_flag_t'' */
typedef enum {
    put_flag_t__NONE=((int)0),
    sn__put_flag_t__NONE=((int)0),
    put_flag_t__ALL_MVL=((int)1),
    sn__put_flag_t__ALL_MVL=((int)1),
    put_flag_t__ALL_BINARY=((int)2),
    sn__put_flag_t__ALL_BINARY=((int)2),
    put_flag_t__SLICE_MVL=((int)3),
    sn__put_flag_t__SLICE_MVL=((int)3),
    put_flag_t__SLICE_BINARY=((int)4),
    sn__put_flag_t__SLICE_BINARY=((int)4)
} t__sn__put_flag_t;

#define d__sn__put_flag_t 6771

typedef t__sn__put_flag_t t__put_flag_t;

#define d__put_flag_t d__sn__put_flag_t

/* line 39 "/vobs/specman/src/shlibs.e"  From 'Enum type 'sn_lib_resolve_mode'' */
typedef enum {
    sn_lib_resolve_mode__dont_care=((int)0),
    sn__sn_lib_resolve_mode__dont_care=((int)0),
    sn_lib_resolve_mode__lazy=((int)1),
    sn__sn_lib_resolve_mode__lazy=((int)1),
    sn_lib_resolve_mode__now=((int)2),
    sn__sn_lib_resolve_mode__now=((int)2)
} t__sn__sn_lib_resolve_mode;

#define d__sn__sn_lib_resolve_mode 2150

typedef t__sn__sn_lib_resolve_mode t__sn_lib_resolve_mode;

#define d__sn_lib_resolve_mode d__sn__sn_lib_resolve_mode

/* line 38 "/vobs/specman/src/shlibs.e"  From 'Enum type 'sn_lib_scope_mode'' */
typedef enum {
    sn_lib_scope_mode__dont_care=((int)0),
    sn__sn_lib_scope_mode__dont_care=((int)0),
    sn_lib_scope_mode__global=((int)1),
    sn__sn_lib_scope_mode__global=((int)1),
    sn_lib_scope_mode__local=((int)2),
    sn__sn_lib_scope_mode__local=((int)2)
} t__sn__sn_lib_scope_mode;

#define d__sn__sn_lib_scope_mode 2148

typedef t__sn__sn_lib_scope_mode t__sn_lib_scope_mode;

#define d__sn_lib_scope_mode d__sn__sn_lib_scope_mode

/* line 457 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'Enum type 'vr_gsa_port_kind'' */
typedef enum {
    vr_gsa_port_kind__scalar_t=((int)0),
    vr_gsa__vr_gsa_port_kind__scalar_t=((int)0),
    vr_gsa_port_kind__string_t=((int)1),
    vr_gsa__vr_gsa_port_kind__string_t=((int)1),
    vr_gsa_port_kind__list_of_scalar_t=((int)2),
    vr_gsa__vr_gsa_port_kind__list_of_scalar_t=((int)2),
    vr_gsa_port_kind__struct_t=((int)3),
    vr_gsa__vr_gsa_port_kind__struct_t=((int)3),
    vr_gsa_port_kind__list_of_struct_t=((int)4),
    vr_gsa__vr_gsa_port_kind__list_of_struct_t=((int)4)
} t__vr_gsa__vr_gsa_port_kind;

#define d__vr_gsa__vr_gsa_port_kind 8972

typedef t__vr_gsa__vr_gsa_port_kind t__vr_gsa_port_kind;

#define d__vr_gsa_port_kind d__vr_gsa__vr_gsa_port_kind

/* line 745 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'Enum type 'mapping_kind_t'' */
typedef enum {
    mapping_kind_t__DEFAULT=((int)0),
    vr_gsa__mapping_kind_t__DEFAULT=((int)0)
} t__vr_gsa__mapping_kind_t;

#define d__vr_gsa__mapping_kind_t 8981

typedef t__vr_gsa__mapping_kind_t t__mapping_kind_t;

#define d__mapping_kind_t d__vr_gsa__mapping_kind_t

/* line 746 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'Enum type 'mapping_behavior_t'' */
typedef enum {
    mapping_behavior_t__UNSUPPORTED=((int)0),
    vr_gsa__mapping_behavior_t__UNSUPPORTED=((int)0),
    mapping_behavior_t__DIRECT=((int)1),
    vr_gsa__mapping_behavior_t__DIRECT=((int)1),
    mapping_behavior_t__DIRECT_POINTER=((int)2),
    vr_gsa__mapping_behavior_t__DIRECT_POINTER=((int)2),
    mapping_behavior_t__INDIRECT_POINTER=((int)3),
    vr_gsa__mapping_behavior_t__INDIRECT_POINTER=((int)3)
} t__vr_gsa__mapping_behavior_t;

#define d__vr_gsa__mapping_behavior_t 8983

typedef t__vr_gsa__mapping_behavior_t t__mapping_behavior_t;

#define d__mapping_behavior_t d__vr_gsa__mapping_behavior_t

/* line 704 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'Enum type 'vr_gsa_mapping_value_kind_t'' */
typedef enum {
    vr_gsa_mapping_value_kind_t__BYTE=((int)0),
    vr_gsa__vr_gsa_mapping_value_kind_t__BYTE=((int)0),
    vr_gsa_mapping_value_kind_t__SHORT=((int)1),
    vr_gsa__vr_gsa_mapping_value_kind_t__SHORT=((int)1),
    vr_gsa_mapping_value_kind_t__INT=((int)2),
    vr_gsa__vr_gsa_mapping_value_kind_t__INT=((int)2),
    vr_gsa_mapping_value_kind_t__LONG=((int)3),
    vr_gsa__vr_gsa_mapping_value_kind_t__LONG=((int)3),
    vr_gsa_mapping_value_kind_t__STRING=((int)4),
    vr_gsa__vr_gsa_mapping_value_kind_t__STRING=((int)4),
    vr_gsa_mapping_value_kind_t__STRUCT=((int)5),
    vr_gsa__vr_gsa_mapping_value_kind_t__STRUCT=((int)5)
} t__vr_gsa__vr_gsa_mapping_value_kind_t;

#define d__vr_gsa__vr_gsa_mapping_value_kind_t 8978

typedef t__vr_gsa__vr_gsa_mapping_value_kind_t t__vr_gsa_mapping_value_kind_t;

#define d__vr_gsa_mapping_value_kind_t d__vr_gsa__vr_gsa_mapping_value_kind_t

/* line 361 "/vobs/specman/src/gen_lang.e"  From 'type: uint (bits: 16)' */
#define t__uint__16 t__uint
/* line 239 "/vobs/specman/src/port_defs.e"  From 'Enum type 'event_port_edge'' */
typedef enum {
    event_port_edge__any_change=((int)0),
    sn__event_port_edge__any_change=((int)0),
    event_port_edge__change=((int)1),
    sn__event_port_edge__change=((int)1),
    event_port_edge__rise=((int)2),
    sn__event_port_edge__rise=((int)2),
    event_port_edge__fall=((int)3),
    sn__event_port_edge__fall=((int)3),
    event_port_edge__MVL_0_to_1=((int)4),
    sn__event_port_edge__MVL_0_to_1=((int)4),
    event_port_edge__MVL_X_to_0=((int)5),
    sn__event_port_edge__MVL_X_to_0=((int)5),
    event_port_edge__MVL_0_to_X=((int)6),
    sn__event_port_edge__MVL_0_to_X=((int)6),
    event_port_edge__MVL_1_to_0=((int)7),
    sn__event_port_edge__MVL_1_to_0=((int)7),
    event_port_edge__MVL_Z_to_1=((int)8),
    sn__event_port_edge__MVL_Z_to_1=((int)8),
    event_port_edge__MVL_1_to_Z=((int)9),
    sn__event_port_edge__MVL_1_to_Z=((int)9)
} t__sn__event_port_edge;

#define d__sn__event_port_edge 1195

typedef t__sn__event_port_edge t__event_port_edge;

#define d__event_port_edge d__sn__event_port_edge

/* line 2145 "/vobs/specman/src/sv_adapter_mp.e"  From 'Enum type 'is_sv_bounded_t (bits: 2)'' */
typedef enum {
    is_sv_bounded_t__2__NOT_SET=((int)0),
    sn__is_sv_bounded_t__2__NOT_SET=((int)0),
    is_sv_bounded_t__2__NO=((int)1),
    sn__is_sv_bounded_t__2__NO=((int)1),
    is_sv_bounded_t__2__YES=((int)2),
    sn__is_sv_bounded_t__2__YES=((int)2)
} t__sn__is_sv_bounded_t__2;

#define d__sn__is_sv_bounded_t__2 7132

typedef t__sn__is_sv_bounded_t__2 t__is_sv_bounded_t__2;

#define d__is_sv_bounded_t__2 d__sn__is_sv_bounded_t__2

/* line 242 "/vobs/specman/src/port_defs.e"  From 'Enum type 'sync_mode_t'' */
typedef enum {
    sync_mode_t__undef=((int)0),
    sn__sync_mode_t__undef=((int)0),
    sync_mode_t__sync_call=((int)1),
    sn__sync_mode_t__sync_call=((int)1),
    sync_mode_t__async_call=((int)2),
    sn__sync_mode_t__async_call=((int)2),
    sync_mode_t__async_tick_call=((int)3),
    sn__sync_mode_t__async_tick_call=((int)3)
} t__sn__sync_mode_t;

#define d__sn__sync_mode_t 1197

typedef t__sn__sync_mode_t t__sync_mode_t;

#define d__sync_mode_t d__sn__sync_mode_t

/* line 243 "/vobs/specman/src/port_defs.e"  From 'Enum type 'parallel_mp_t'' */
typedef enum {
    parallel_mp_t__DEFAULT=((int)0),
    sn__parallel_mp_t__DEFAULT=((int)0),
    parallel_mp_t__YES=((int)1),
    sn__parallel_mp_t__YES=((int)1),
    parallel_mp_t__NO=((int)2),
    sn__parallel_mp_t__NO=((int)2)
} t__sn__parallel_mp_t;

#define d__sn__parallel_mp_t 1199

typedef t__sn__parallel_mp_t t__parallel_mp_t;

#define d__parallel_mp_t d__sn__parallel_mp_t

/* line 20 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_mailbox.e"  From 'Enum type 'gsa_mailbox_state_t'' */
typedef enum {
    gsa_mailbox_state_t__GSA_MB_NON_INIT=((int)0),
    vr_gsa__gsa_mailbox_state_t__GSA_MB_NON_INIT=((int)0),
    gsa_mailbox_state_t__GSA_MB_READY=((int)1),
    vr_gsa__gsa_mailbox_state_t__GSA_MB_READY=((int)1),
    gsa_mailbox_state_t__GSA_MB_PENDING_CALL=((int)2),
    vr_gsa__gsa_mailbox_state_t__GSA_MB_PENDING_CALL=((int)2),
    gsa_mailbox_state_t__GSA_MB_EXEC_CALL=((int)3),
    vr_gsa__gsa_mailbox_state_t__GSA_MB_EXEC_CALL=((int)3),
    gsa_mailbox_state_t__GSA_MB_CALL_DONE=((int)4),
    vr_gsa__gsa_mailbox_state_t__GSA_MB_CALL_DONE=((int)4)
} t__vr_gsa__gsa_mailbox_state_t;

#define d__vr_gsa__gsa_mailbox_state_t 9002

typedef t__vr_gsa__gsa_mailbox_state_t t__gsa_mailbox_state_t;

#define d__gsa_mailbox_state_t d__vr_gsa__gsa_mailbox_state_t

/* line 48 "/vobs/specman/src/tcm_data_structures.e"  From 'type: sn_thread_handle' */
#define t__sn__sn_thread_handle t__int
#define t__sn_thread_handle t__sn__sn_thread_handle
/* line 66 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver_bp.e"  From 'Enum type 'vr_gsa_dbserver_bp_intf_state'' */
typedef enum {
    vr_gsa_dbserver_bp_intf_state__SW_INTERACTIVE=((int)0),
    sn__vr_gsa_dbserver_bp_intf_state__SW_INTERACTIVE=((int)0),
    vr_gsa_dbserver_bp_intf_state__SW_BREAKPOINT=((int)1),
    sn__vr_gsa_dbserver_bp_intf_state__SW_BREAKPOINT=((int)1),
    vr_gsa_dbserver_bp_intf_state__SW_STEP=((int)2),
    sn__vr_gsa_dbserver_bp_intf_state__SW_STEP=((int)2),
    vr_gsa_dbserver_bp_intf_state__SW_EXCEPTION=((int)3),
    sn__vr_gsa_dbserver_bp_intf_state__SW_EXCEPTION=((int)3),
    vr_gsa_dbserver_bp_intf_state__SW_RUNNING=((int)4),
    sn__vr_gsa_dbserver_bp_intf_state__SW_RUNNING=((int)4)
} t__sn__vr_gsa_dbserver_bp_intf_state;

#define d__sn__vr_gsa_dbserver_bp_intf_state 9031

typedef t__sn__vr_gsa_dbserver_bp_intf_state t__vr_gsa_dbserver_bp_intf_state;

#define d__vr_gsa_dbserver_bp_intf_state d__sn__vr_gsa_dbserver_bp_intf_state

/* line 17 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver.e"  From 'Enum type 'vr_gsa_dbserver_exception_signal'' */
typedef enum {
    vr_gsa_dbserver_exception_signal__NOSIGNAL=((int)0),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__NOSIGNAL=((int)0),
    vr_gsa_dbserver_exception_signal__SIGHUP=((int)1),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGHUP=((int)1),
    vr_gsa_dbserver_exception_signal__SIGINT=((int)2),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGINT=((int)2),
    vr_gsa_dbserver_exception_signal__SIGQUIT=((int)3),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGQUIT=((int)3),
    vr_gsa_dbserver_exception_signal__SIGILL=((int)4),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGILL=((int)4),
    vr_gsa_dbserver_exception_signal__SIGTRAP=((int)5),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGTRAP=((int)5),
    vr_gsa_dbserver_exception_signal__SIGABRT=((int)6),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGABRT=((int)6),
    vr_gsa_dbserver_exception_signal__SIGBUS=((int)7),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGBUS=((int)7),
    vr_gsa_dbserver_exception_signal__SIGFPE=((int)8),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGFPE=((int)8),
    vr_gsa_dbserver_exception_signal__SIGKILL=((int)9),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGKILL=((int)9),
    vr_gsa_dbserver_exception_signal__SIGUSR1=((int)10),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGUSR1=((int)10),
    vr_gsa_dbserver_exception_signal__SIGSEGV=((int)11),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGSEGV=((int)11),
    vr_gsa_dbserver_exception_signal__SIGUSR2=((int)12),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGUSR2=((int)12),
    vr_gsa_dbserver_exception_signal__SIGPIPE=((int)13),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGPIPE=((int)13),
    vr_gsa_dbserver_exception_signal__SIGALRM=((int)14),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGALRM=((int)14),
    vr_gsa_dbserver_exception_signal__SIGTERM=((int)15),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGTERM=((int)15),
    vr_gsa_dbserver_exception_signal__SIGSTKFLT=((int)16),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGSTKFLT=((int)16),
    vr_gsa_dbserver_exception_signal__SIGCHLD=((int)17),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGCHLD=((int)17),
    vr_gsa_dbserver_exception_signal__SIGCONT=((int)18),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGCONT=((int)18),
    vr_gsa_dbserver_exception_signal__SIGSTOP=((int)19),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGSTOP=((int)19),
    vr_gsa_dbserver_exception_signal__SIGTSTP=((int)20),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGTSTP=((int)20),
    vr_gsa_dbserver_exception_signal__SIGTTIN=((int)21),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGTTIN=((int)21),
    vr_gsa_dbserver_exception_signal__SIGTTOU=((int)22),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGTTOU=((int)22),
    vr_gsa_dbserver_exception_signal__SIGURG=((int)23),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGURG=((int)23),
    vr_gsa_dbserver_exception_signal__SIGXCPU=((int)24),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGXCPU=((int)24),
    vr_gsa_dbserver_exception_signal__SIGXFSZ=((int)25),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGXFSZ=((int)25),
    vr_gsa_dbserver_exception_signal__SIGVTALRM=((int)26),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGVTALRM=((int)26),
    vr_gsa_dbserver_exception_signal__SIGPROF=((int)27),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGPROF=((int)27),
    vr_gsa_dbserver_exception_signal__SIGWINCH=((int)28),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGWINCH=((int)28),
    vr_gsa_dbserver_exception_signal__SIGIO=((int)29),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGIO=((int)29),
    vr_gsa_dbserver_exception_signal__SIGPWR=((int)30),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGPWR=((int)30),
    vr_gsa_dbserver_exception_signal__SIGSYS=((int)31),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGSYS=((int)31),
    vr_gsa_dbserver_exception_signal__SIGRTMIN=((int)32),
    vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal__SIGRTMIN=((int)32)
} t__vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal;

#define d__vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal 9022

typedef t__vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal t__vr_gsa_dbserver_exception_signal;

#define d__vr_gsa_dbserver_exception_signal d__vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal

/* line 21 "/vobs/specman/src/port_defs.e"  From 'Enum type 'sn_port_direction'' */
typedef enum {
    sn_port_direction__undef=((int)0),
    sn__sn_port_direction__undef=((int)0),
    sn_port_direction__in=((int)1),
    sn__sn_port_direction__in=((int)1),
    sn_port_direction__out=((int)2),
    sn__sn_port_direction__out=((int)2),
    sn_port_direction__inout=((int)3),
    sn__sn_port_direction__inout=((int)3)
} t__sn__sn_port_direction;

#define d__sn__sn_port_direction 1168

typedef t__sn__sn_port_direction t__sn_port_direction;

#define d__sn_port_direction d__sn__sn_port_direction

/* line 26 "/vobs/specman/src/e_core_types.e"  From 'subtype: in event_port' */
#define d__in__direction__e_core__event_port 6815
/* line 18 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_element_state'' */
typedef enum {
    vtx_element_state__VTX_UNDEFINED=((int)0),
    vt__vtx_element_state__VTX_UNDEFINED=((int)0),
    vtx_element_state__VTX_PRE_OPENED=((int)1),
    vt__vtx_element_state__VTX_PRE_OPENED=((int)1),
    vtx_element_state__VTX_OPENED=((int)2),
    vt__vtx_element_state__VTX_OPENED=((int)2),
    vtx_element_state__VTX_CLOSED=((int)3),
    vt__vtx_element_state__VTX_CLOSED=((int)3)
} t__vt__vtx_element_state;

#define d__vt__vtx_element_state 5080

typedef t__vt__vtx_element_state t__vtx_element_state;

#define d__vtx_element_state d__vt__vtx_element_state

/* line 20 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_window_layout_style'' */
typedef enum {
    vtx_window_layout_style__VTX_UNDEFINED=((int)0),
    vt__vtx_window_layout_style__VTX_UNDEFINED=((int)0),
    vtx_window_layout_style__VTX_LEFT=((int)1),
    vt__vtx_window_layout_style__VTX_LEFT=((int)1),
    vtx_window_layout_style__VTX_RIGHT=((int)2),
    vt__vtx_window_layout_style__VTX_RIGHT=((int)2),
    vtx_window_layout_style__VTX_TOP=((int)3),
    vt__vtx_window_layout_style__VTX_TOP=((int)3),
    vtx_window_layout_style__VTX_BOTTOM=((int)4),
    vt__vtx_window_layout_style__VTX_BOTTOM=((int)4)
} t__vt__vtx_window_layout_style;

#define d__vt__vtx_window_layout_style 5082

typedef t__vt__vtx_window_layout_style t__vtx_window_layout_style;

#define d__vtx_window_layout_style d__vt__vtx_window_layout_style

/* line 14 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'Enum type 'vt_menu_action_kind'' */
typedef enum {
    vt_menu_action_kind__MENU_ITEM=((int)0),
    vt__vt_menu_action_kind__MENU_ITEM=((int)0),
    vt_menu_action_kind__MENU=((int)1),
    vt__vt_menu_action_kind__MENU=((int)1),
    vt_menu_action_kind__MENU_SEPERATOR=((int)2),
    vt__vt_menu_action_kind__MENU_SEPERATOR=((int)2),
    vt_menu_action_kind__TOOLBAR_SEPERATOR=((int)3),
    vt__vt_menu_action_kind__TOOLBAR_SEPERATOR=((int)3)
} t__vt__vt_menu_action_kind;

#define d__vt__vt_menu_action_kind 2534

typedef t__vt__vt_menu_action_kind t__vt_menu_action_kind;

#define d__vt_menu_action_kind d__vt__vt_menu_action_kind

/* line 13 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'Enum type 'vt_action_type'' */
typedef enum {
    vt_action_type__NONE=((int)0),
    vt__vt_action_type__NONE=((int)0),
    vt_action_type__NORMAL=((int)1),
    vt__vt_action_type__NORMAL=((int)1),
    vt_action_type__CHECKED=((int)2),
    vt__vt_action_type__CHECKED=((int)2),
    vt_action_type__GROUP=((int)3),
    vt__vt_action_type__GROUP=((int)3)
} t__vt__vt_action_type;

#define d__vt__vt_action_type 2532

typedef t__vt__vt_action_type t__vt_action_type;

#define d__vt_action_type d__vt__vt_action_type

/* line 101 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_selection_state'' */
typedef enum {
    vtx_selection_state__VTX_NONE=((int)0),
    vt__vtx_selection_state__VTX_NONE=((int)0),
    vtx_selection_state__VTX_ACTIVE=((int)1),
    vt__vtx_selection_state__VTX_ACTIVE=((int)1),
    vtx_selection_state__VTX_INACTIVE=((int)2),
    vt__vtx_selection_state__VTX_INACTIVE=((int)2)
} t__vt__vtx_selection_state;

#define d__vt__vtx_selection_state 5100

typedef t__vt__vtx_selection_state t__vtx_selection_state;

#define d__vtx_selection_state d__vt__vtx_selection_state

/* line 62 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_user_api.e"  From 'Enum type 'vt_color'' */
typedef enum {
    vt_color__DEFAULT_COLOR=((int)268435456),
    vt__vt_color__DEFAULT_COLOR=((int)268435456),
    vt_color__BLACK=((int)0),
    vt__vt_color__BLACK=((int)0),
    vt_color__VERY_LIGHT_GRAY=((int)15790320),
    vt__vt_color__VERY_LIGHT_GRAY=((int)15790320),
    vt_color__VERY_LIGHT_RED=((int)16771561),
    vt__vt_color__VERY_LIGHT_RED=((int)16771561),
    vt_color__VERY_LIGHT_ORANGE=((int)16774377),
    vt__vt_color__VERY_LIGHT_ORANGE=((int)16774377),
    vt_color__VERY_LIGHT_YELLOW=((int)16777193),
    vt__vt_color__VERY_LIGHT_YELLOW=((int)16777193),
    vt_color__VERY_LIGHT_GREEN=((int)15335401),
    vt__vt_color__VERY_LIGHT_GREEN=((int)15335401),
    vt_color__VERY_LIGHT_CYAN=((int)15335423),
    vt__vt_color__VERY_LIGHT_CYAN=((int)15335423),
    vt_color__VERY_LIGHT_BLUE=((int)15329791),
    vt__vt_color__VERY_LIGHT_BLUE=((int)15329791),
    vt_color__VERY_LIGHT_MAGENTA=((int)16771583),
    vt__vt_color__VERY_LIGHT_MAGENTA=((int)16771583),
    vt_color__VERY_LIGHT_PURPLE=((int)16312831),
    vt__vt_color__VERY_LIGHT_PURPLE=((int)16312831),
    vt_color__LIGHT_GRAY=((int)12632256),
    vt__vt_color__LIGHT_GRAY=((int)12632256),
    vt_color__LIGHT_RED=((int)16761024),
    vt__vt_color__LIGHT_RED=((int)16761024),
    vt_color__LIGHT_ORANGE=((int)16769216),
    vt__vt_color__LIGHT_ORANGE=((int)16769216),
    vt_color__LIGHT_YELLOW=((int)16777152),
    vt__vt_color__LIGHT_YELLOW=((int)16777152),
    vt_color__LIGHT_GREEN=((int)12648384),
    vt__vt_color__LIGHT_GREEN=((int)12648384),
    vt_color__LIGHT_CYAN=((int)12648447),
    vt__vt_color__LIGHT_CYAN=((int)12648447),
    vt_color__LIGHT_BLUE=((int)12632319),
    vt__vt_color__LIGHT_BLUE=((int)12632319),
    vt_color__LIGHT_MAGENTA=((int)16761087),
    vt__vt_color__LIGHT_MAGENTA=((int)16761087),
    vt_color__LIGHT_PURPLE=((int)14721279),
    vt__vt_color__LIGHT_PURPLE=((int)14721279),
    vt_color__GRAY=((int)8421504),
    vt__vt_color__GRAY=((int)8421504),
    vt_color__RED=((int)16711680),
    vt__vt_color__RED=((int)16711680),
    vt_color__ORANGE=((int)16753920),
    vt__vt_color__ORANGE=((int)16753920),
    vt_color__YELLOW=((int)16776960),
    vt__vt_color__YELLOW=((int)16776960),
    vt_color__GREEN=((int)65280),
    vt__vt_color__GREEN=((int)65280),
    vt_color__CYAN=((int)65535),
    vt__vt_color__CYAN=((int)65535),
    vt_color__BLUE=((int)255),
    vt__vt_color__BLUE=((int)255),
    vt_color__MAGENTA=((int)16711935),
    vt__vt_color__MAGENTA=((int)16711935),
    vt_color__PURPLE=((int)10494192),
    vt__vt_color__PURPLE=((int)10494192),
    vt_color__DARK_GRAY=((int)4210752),
    vt__vt_color__DARK_GRAY=((int)4210752),
    vt_color__DARK_RED=((int)8388608),
    vt__vt_color__DARK_RED=((int)8388608),
    vt_color__DARK_ORANGE=((int)16744448),
    vt__vt_color__DARK_ORANGE=((int)16744448),
    vt_color__DARK_YELLOW=((int)8421376),
    vt__vt_color__DARK_YELLOW=((int)8421376),
    vt_color__DARK_GREEN=((int)32768),
    vt__vt_color__DARK_GREEN=((int)32768),
    vt_color__DARK_CYAN=((int)32896),
    vt__vt_color__DARK_CYAN=((int)32896),
    vt_color__DARK_BLUE=((int)128),
    vt__vt_color__DARK_BLUE=((int)128),
    vt_color__DARK_MAGENTA=((int)8388736),
    vt__vt_color__DARK_MAGENTA=((int)8388736),
    vt_color__DARK_PURPLE=((int)8392864),
    vt__vt_color__DARK_PURPLE=((int)8392864),
    vt_color__WHITE=((int)16777215),
    vt__vt_color__WHITE=((int)16777215),
    vt_color__UNDEFINED_COLOR=((int)536870912),
    vt__vt_color__UNDEFINED_COLOR=((int)536870912),
    vt_color__TABLE_MESSAGE_BG=((int)16777163),
    vt__vt_color__TABLE_MESSAGE_BG=((int)16777163),
    vt_color__TABLE_BG=((int)16777164),
    vt__vt_color__TABLE_BG=((int)16777164),
    vt_color__MEDIUM_BLUE=((int)3355545),
    vt__vt_color__MEDIUM_BLUE=((int)3355545),
    vt_color__CRIMSON=((int)14423100),
    vt__vt_color__CRIMSON=((int)14423100)
} t__vt__vt_color;

#define d__vt__vt_color 2523

typedef t__vt__vt_color t__vt_color;

#define d__vt_color d__vt__vt_color

/* line 88 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_border_kind'' */
typedef enum {
    vtx_border_kind__VTX_UNDEFINED=((int)0),
    vt__vtx_border_kind__VTX_UNDEFINED=((int)0),
    vtx_border_kind__VTX_EMPTY_BORDER=((int)1),
    vt__vtx_border_kind__VTX_EMPTY_BORDER=((int)1),
    vtx_border_kind__VTX_LINE_BORDER=((int)2),
    vt__vtx_border_kind__VTX_LINE_BORDER=((int)2),
    vtx_border_kind__VTX_TITLE_BORDER=((int)3),
    vt__vtx_border_kind__VTX_TITLE_BORDER=((int)3),
    vtx_border_kind__VTX_ETCHED_BORDER=((int)4),
    vt__vtx_border_kind__VTX_ETCHED_BORDER=((int)4)
} t__vt__vtx_border_kind;

#define d__vt__vtx_border_kind 5092

typedef t__vt__vtx_border_kind t__vtx_border_kind;

#define d__vtx_border_kind d__vt__vtx_border_kind

/* line 20 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_user_api.e"  From 'Enum type 'vt_font_kind'' */
typedef enum {
    vt_font_kind__DEFAULT_FONT=((int)0),
    vt__vt_font_kind__DEFAULT_FONT=((int)0),
    vt_font_kind__NORMAL=((int)1),
    vt__vt_font_kind__NORMAL=((int)1),
    vt_font_kind__BOLD=((int)2),
    vt__vt_font_kind__BOLD=((int)2),
    vt_font_kind__ITALIC=((int)3),
    vt__vt_font_kind__ITALIC=((int)3)
} t__vt__vt_font_kind;

#define d__vt__vt_font_kind 2519

typedef t__vt__vt_font_kind t__vt_font_kind;

#define d__vt_font_kind d__vt__vt_font_kind

/* line 103 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_expandable_mode'' */
typedef enum {
    vtx_expandable_mode__VTX_NOT_EXPANDABLE=((int)0),
    vt__vtx_expandable_mode__VTX_NOT_EXPANDABLE=((int)0),
    vtx_expandable_mode__VTX_EXPANDABLE=((int)1),
    vt__vtx_expandable_mode__VTX_EXPANDABLE=((int)1),
    vtx_expandable_mode__VTX_CONDITIONAL_EXPANDABLE=((int)2),
    vt__vtx_expandable_mode__VTX_CONDITIONAL_EXPANDABLE=((int)2)
} t__vt__vtx_expandable_mode;

#define d__vt__vtx_expandable_mode 5102

typedef t__vt__vtx_expandable_mode t__vtx_expandable_mode;

#define d__vtx_expandable_mode d__vt__vtx_expandable_mode

/* line 83 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_label_layout'' */
typedef enum {
    vtx_label_layout__VTX_LEFT=((int)0),
    vt__vtx_label_layout__VTX_LEFT=((int)0),
    vtx_label_layout__VTX_FAR_LEFT=((int)1),
    vt__vtx_label_layout__VTX_FAR_LEFT=((int)1),
    vtx_label_layout__VTX_TOP=((int)2),
    vt__vtx_label_layout__VTX_TOP=((int)2)
} t__vt__vtx_label_layout;

#define d__vt__vtx_label_layout 5090

typedef t__vt__vtx_label_layout t__vtx_label_layout;

#define d__vtx_label_layout d__vt__vtx_label_layout

/* line 3591 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_statusbar_pane_scope'' */
typedef enum {
    vt_statusbar_pane_scope__WINDOW=((int)0),
    vt__vt_statusbar_pane_scope__WINDOW=((int)0),
    vt_statusbar_pane_scope__PAGE=((int)1),
    vt__vt_statusbar_pane_scope__PAGE=((int)1),
    vt_statusbar_pane_scope__ALL=((int)2),
    vt__vt_statusbar_pane_scope__ALL=((int)2)
} t__vt__vt_statusbar_pane_scope;

#define d__vt__vt_statusbar_pane_scope 4891

typedef t__vt__vt_statusbar_pane_scope t__vt_statusbar_pane_scope;

#define d__vt_statusbar_pane_scope d__vt__vt_statusbar_pane_scope

/* line 43 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'Enum type 'vt_menu_component_kind'' */
typedef enum {
    vt_menu_component_kind__MENU=((int)0),
    vt__vt_menu_component_kind__MENU=((int)0),
    vt_menu_component_kind__ACTION=((int)1),
    vt__vt_menu_component_kind__ACTION=((int)1),
    vt_menu_component_kind__SEPARATOR=((int)2),
    vt__vt_menu_component_kind__SEPARATOR=((int)2),
    vt_menu_component_kind__SPACE_FILLER=((int)3),
    vt__vt_menu_component_kind__SPACE_FILLER=((int)3)
} t__vt__vt_menu_component_kind;

#define d__vt__vt_menu_component_kind 4926

typedef t__vt__vt_menu_component_kind t__vt_menu_component_kind;

#define d__vt_menu_component_kind d__vt__vt_menu_component_kind

/* line 44 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'Enum type 'vt_action_kind'' */
typedef enum {
    vt_action_kind__STANDALONE=((int)0),
    vt__vt_action_kind__STANDALONE=((int)0),
    vt_action_kind__CHECKED=((int)1),
    vt__vt_action_kind__CHECKED=((int)1),
    vt_action_kind__MEMBER=((int)2),
    vt__vt_action_kind__MEMBER=((int)2),
    vt_action_kind__APPL=((int)3),
    vt__vt_action_kind__APPL=((int)3)
} t__vt__vt_action_kind;

#define d__vt__vt_action_kind 4928

typedef t__vt__vt_action_kind t__vt_action_kind;

#define d__vt_action_kind d__vt__vt_action_kind

/* line 49 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'Enum type 'vt_action_special_attribute'' */
typedef enum {
    vt_action_special_attribute__NONE=((int)0),
    vt__vt_action_special_attribute__NONE=((int)0),
    vt_action_special_attribute__PREV=((int)1),
    vt__vt_action_special_attribute__PREV=((int)1),
    vt_action_special_attribute__NEXT=((int)2),
    vt__vt_action_special_attribute__NEXT=((int)2),
    vt_action_special_attribute__LOCK=((int)3),
    vt__vt_action_special_attribute__LOCK=((int)3)
} t__vt__vt_action_special_attribute;

#define d__vt__vt_action_special_attribute 4938

typedef t__vt__vt_action_special_attribute t__vt_action_special_attribute;

#define d__vt_action_special_attribute d__vt__vt_action_special_attribute

/* line 99 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_orientation'' */
typedef enum {
    vtx_orientation__VTX_VERTICAL=((int)0),
    vt__vtx_orientation__VTX_VERTICAL=((int)0),
    vtx_orientation__VTX_HORIZONTAL=((int)1),
    vt__vtx_orientation__VTX_HORIZONTAL=((int)1)
} t__vt__vtx_orientation;

#define d__vt__vtx_orientation 5098

typedef t__vt__vtx_orientation t__vtx_orientation;

#define d__vtx_orientation d__vt__vtx_orientation

/* line 27 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_align_kind'' */
typedef enum {
    vtx_align_kind__VTX_UNDEFINED=((int)0),
    vt__vtx_align_kind__VTX_UNDEFINED=((int)0),
    vtx_align_kind__VTX_LEFT=((int)1),
    vt__vtx_align_kind__VTX_LEFT=((int)1),
    vtx_align_kind__VTX_CENTER=((int)2),
    vt__vtx_align_kind__VTX_CENTER=((int)2),
    vtx_align_kind__VTX_RIGHT=((int)3),
    vt__vtx_align_kind__VTX_RIGHT=((int)3),
    vtx_align_kind__VTX_TOP=((int)4),
    vt__vtx_align_kind__VTX_TOP=((int)4),
    vtx_align_kind__VTX_MIDDLE=((int)5),
    vt__vtx_align_kind__VTX_MIDDLE=((int)5),
    vtx_align_kind__VTX_BOTTOM=((int)6),
    vt__vtx_align_kind__VTX_BOTTOM=((int)6)
} t__vt__vtx_align_kind;

#define d__vt__vtx_align_kind 5084

typedef t__vt__vtx_align_kind t__vtx_align_kind;

#define d__vtx_align_kind d__vt__vtx_align_kind

/* line 95 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_table_col_kind'' */
typedef enum {
    vtx_table_col_kind__VTX_STRING=((int)0),
    vt__vtx_table_col_kind__VTX_STRING=((int)0),
    vtx_table_col_kind__VTX_NUMBER=((int)1),
    vt__vtx_table_col_kind__VTX_NUMBER=((int)1),
    vtx_table_col_kind__VTX_BOOLEAN=((int)2),
    vt__vtx_table_col_kind__VTX_BOOLEAN=((int)2),
    vtx_table_col_kind__VTX_ICON=((int)3),
    vt__vtx_table_col_kind__VTX_ICON=((int)3),
    vtx_table_col_kind__VTX_ICON_ENHANCED=((int)4),
    vt__vtx_table_col_kind__VTX_ICON_ENHANCED=((int)4),
    vtx_table_col_kind__VTX_GRADE=((int)5),
    vt__vtx_table_col_kind__VTX_GRADE=((int)5),
    vtx_table_col_kind__VTX_HISTOGRAM=((int)6),
    vt__vtx_table_col_kind__VTX_HISTOGRAM=((int)6),
    vtx_table_col_kind__VTX_PIE=((int)7),
    vt__vtx_table_col_kind__VTX_PIE=((int)7)
} t__vt__vtx_table_col_kind;

#define d__vt__vtx_table_col_kind 5094

typedef t__vt__vtx_table_col_kind t__vtx_table_col_kind;

#define d__vtx_table_col_kind d__vt__vtx_table_col_kind

/* line 337 "../src/root_basic.e"  From 'Enum type 'next_prev_op'' */
typedef enum {
    next_prev_op__none=((int)0),
    e_core__next_prev_op__none=((int)0),
    next_prev_op__print_list=((int)1),
    e_core__next_prev_op__print_list=((int)1),
    next_prev_op__source=((int)2),
    e_core__next_prev_op__source=((int)2)
} t__e_core__next_prev_op;

#define d__e_core__next_prev_op 37

typedef t__e_core__next_prev_op t__next_prev_op;

#define d__next_prev_op d__e_core__next_prev_op

/* line 357 "/vobs/specman/src/basic_action.e"  From 'Enum type 'test_phase'' */
typedef enum {
    test_phase__before_setup=((int)0),
    sn__test_phase__before_setup=((int)0),
    test_phase__before_generate=((int)1),
    sn__test_phase__before_generate=((int)1),
    test_phase__before_start=((int)2),
    sn__test_phase__before_start=((int)2),
    test_phase__before_run=((int)3),
    sn__test_phase__before_run=((int)3),
    test_phase__before_check=((int)4),
    sn__test_phase__before_check=((int)4),
    test_phase__after_check=((int)5),
    sn__test_phase__after_check=((int)5)
} t__sn__test_phase;

#define d__sn__test_phase 513

typedef t__sn__test_phase t__test_phase;

#define d__test_phase d__sn__test_phase

/* line 362 "/vobs/specman/src/basic_action.e"  From 'Enum type 'sn_precise_test_phase'' */
typedef enum {
    sn_precise_test_phase__before_setup=((int)0),
    sn__sn_precise_test_phase__before_setup=((int)0),
    sn_precise_test_phase__after_setup=((int)1),
    sn__sn_precise_test_phase__after_setup=((int)1),
    sn_precise_test_phase__before_generate=((int)2),
    sn__sn_precise_test_phase__before_generate=((int)2),
    sn_precise_test_phase__after_generate=((int)3),
    sn__sn_precise_test_phase__after_generate=((int)3),
    sn_precise_test_phase__before_start=((int)4),
    sn__sn_precise_test_phase__before_start=((int)4),
    sn_precise_test_phase__after_start=((int)5),
    sn__sn_precise_test_phase__after_start=((int)5),
    sn_precise_test_phase__before_run=((int)6),
    sn__sn_precise_test_phase__before_run=((int)6),
    sn_precise_test_phase__after_run=((int)7),
    sn__sn_precise_test_phase__after_run=((int)7),
    sn_precise_test_phase__before_check=((int)8),
    sn__sn_precise_test_phase__before_check=((int)8),
    sn_precise_test_phase__after_check=((int)9),
    sn__sn_precise_test_phase__after_check=((int)9)
} t__sn__sn_precise_test_phase;

#define d__sn__sn_precise_test_phase 515

typedef t__sn__sn_precise_test_phase t__sn_precise_test_phase;

#define d__sn_precise_test_phase d__sn__sn_precise_test_phase

/* line 98 "/vobs/specman/src/interp.e"  From 'Enum type 'on_event_type'' */
typedef enum {
    on_event_type__none=((int)0),
    sn__on_event_type__none=((int)0),
    on_event_type__event=((int)1),
    sn__on_event_type__event=((int)1),
    on_event_type__contention=((int)2),
    sn__on_event_type__contention=((int)2),
    on_event_type__tcm_start=((int)3),
    sn__on_event_type__tcm_start=((int)3),
    on_event_type__tcm_end=((int)4),
    sn__on_event_type__tcm_end=((int)4),
    on_event_type__tcm_call=((int)5),
    sn__on_event_type__tcm_call=((int)5),
    on_event_type__tcm_return=((int)6),
    sn__on_event_type__tcm_return=((int)6),
    on_event_type__tcm_wait=((int)7),
    sn__on_event_type__tcm_wait=((int)7),
    on_event_type__tcm_state=((int)8),
    sn__on_event_type__tcm_state=((int)8),
    on_event_type__gen=((int)9),
    sn__on_event_type__gen=((int)9),
    on_event_type__call=((int)10),
    sn__on_event_type__call=((int)10),
    on_event_type__return=((int)11),
    sn__on_event_type__return=((int)11),
    on_event_type__cvl_call=((int)12),
    sn__on_event_type__cvl_call=((int)12),
    on_event_type__cvl_return=((int)13),
    sn__on_event_type__cvl_return=((int)13),
    on_event_type__sim_write=((int)14),
    sn__on_event_type__sim_write=((int)14),
    on_event_type__sim_read=((int)15),
    sn__on_event_type__sim_read=((int)15),
    on_event_type__output=((int)16),
    sn__on_event_type__output=((int)16),
    on_event_type__line=((int)17),
    sn__on_event_type__line=((int)17),
    on_event_type__check=((int)18),
    sn__on_event_type__check=((int)18),
    on_event_type__g5=((int)19),
    sn__on_event_type__g5=((int)19)
} t__sn__on_event_type;

#define d__sn__on_event_type 649

typedef t__sn__on_event_type t__on_event_type;

#define d__on_event_type d__sn__on_event_type

/* line 277 "/vobs/specman/src/scriptsim.e"  From 'Enum type 'run_status'' */
typedef enum {
    run_status__idle=((int)0),
    sn__run_status__idle=((int)0),
    run_status__ready=((int)1),
    sn__run_status__ready=((int)1),
    run_status__running=((int)2),
    sn__run_status__running=((int)2),
    run_status__stopped=((int)3),
    sn__run_status__stopped=((int)3)
} t__sn__run_status;

#define d__sn__run_status 1256

typedef t__sn__run_status t__run_status;

#define d__run_status d__sn__run_status

/* line 853 "/vobs/specman/src/show_mem.e"  From 'Enum type 'session'gc_action_time'' */
typedef enum {
    session__gc_action_time__before=((int)0),
    sn__session__gc_action_time__before=((int)0),
    session__gc_action_time__peak=((int)1),
    sn__session__gc_action_time__peak=((int)1),
    session__gc_action_time__after=((int)2),
    sn__session__gc_action_time__after=((int)2),
    session__gc_action_time__explicit=((int)3),
    sn__session__gc_action_time__explicit=((int)3)
} t__imp_enum_sn__session__gc_action_time;

#define d__imp_enum_sn__session__gc_action_time 2349

typedef t__imp_enum_sn__session__gc_action_time t__imp_enum_session__gc_action_time;

#define d__imp_enum_session__gc_action_time d__imp_enum_sn__session__gc_action_time

/* line 62 "/vobs/specman/src/config_main.e"  From 'Enum type 'config_categories'' */
typedef enum {
    config_categories__print=((int)0),
    sn__config_categories__print=((int)0),
    config_categories__cover=((int)1),
    sn__config_categories__cover=((int)1),
    config_categories__gen=((int)2),
    sn__config_categories__gen=((int)2),
    config_categories__run=((int)3),
    sn__config_categories__run=((int)3),
    config_categories__memory=((int)4),
    sn__config_categories__memory=((int)4),
    config_categories__misc=((int)5),
    sn__config_categories__misc=((int)5),
    config_categories__debug=((int)6),
    sn__config_categories__debug=((int)6),
    config_categories__gui=((int)7),
    sn__config_categories__gui=((int)7),
    config_categories__wave=((int)8),
    sn__config_categories__wave=((int)8),
    config_categories__databrowser=((int)9),
    sn__config_categories__databrowser=((int)9),
    config_categories__simulation=((int)10),
    sn__config_categories__simulation=((int)10),
    config_categories__ies=((int)11),
    sn__config_categories__ies=((int)11),
    config_categories__lang=((int)12),
    sn__config_categories__lang=((int)12),
    config_categories__eanalyzer=((int)13),
    sn__config_categories__eanalyzer=((int)13)
} t__sn__config_categories;

#define d__sn__config_categories 1364

typedef t__sn__config_categories t__config_categories;

#define d__config_categories d__sn__config_categories

/* line 1905 "../src/root_basic.e"  From 'Enum type 'radix'' */
typedef enum {
    radix__DEC=((int)0),
    e_core__radix__DEC=((int)0),
    radix__HEX=((int)1),
    e_core__radix__HEX=((int)1),
    radix__BIN=((int)2),
    e_core__radix__BIN=((int)2),
    radix__OCT=((int)3),
    e_core__radix__OCT=((int)3)
} t__e_core__radix;

#define d__e_core__radix 109

typedef t__e_core__radix t__radix;

#define d__radix d__e_core__radix

/* line 1917 "../src/root_basic.e"  From 'Enum type 'name_qualification_t'' */
typedef enum {
    name_qualification_t__upon_ambiguity=((int)0),
    e_core__name_qualification_t__upon_ambiguity=((int)0),
    name_qualification_t__never=((int)1),
    e_core__name_qualification_t__never=((int)1),
    name_qualification_t__always=((int)2),
    e_core__name_qualification_t__always=((int)2)
} t__e_core__name_qualification_t;

#define d__e_core__name_qualification_t 111

typedef t__e_core__name_qualification_t t__name_qualification_t;

#define d__name_qualification_t d__e_core__name_qualification_t

/* line 30 "/vobs/specman/src/config_print.e"  From 'Enum type 'scale_units'' */
typedef enum {
    scale_units__FS=((int)0),
    sn__scale_units__FS=((int)0),
    scale_units__PS=((int)1),
    sn__scale_units__PS=((int)1),
    scale_units__NS=((int)2),
    sn__scale_units__NS=((int)2),
    scale_units__US=((int)3),
    sn__scale_units__US=((int)3),
    scale_units__MS=((int)4),
    sn__scale_units__MS=((int)4),
    scale_units__SEC=((int)5),
    sn__scale_units__SEC=((int)5),
    scale_units__MIN=((int)6),
    sn__scale_units__MIN=((int)6),
    scale_units__HR=((int)7),
    sn__scale_units__HR=((int)7),
    scale_units__NONE=((int)8),
    sn__scale_units__NONE=((int)8),
    scale_units__SIMDEF=((int)9),
    sn__scale_units__SIMDEF=((int)9)
} t__sn__scale_units;

#define d__sn__scale_units 1450

typedef t__sn__scale_units t__scale_units;

#define d__scale_units d__sn__scale_units

/* line 214 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_cvr_grading_formula'' */
typedef enum {
    sn_cvr_grading_formula__linear=((int)0),
    sn__sn_cvr_grading_formula__linear=((int)0),
    sn_cvr_grading_formula__root_mean_square=((int)1),
    sn__sn_cvr_grading_formula__root_mean_square=((int)1)
} t__sn__sn_cvr_grading_formula;

#define d__sn__sn_cvr_grading_formula 1385

typedef t__sn__sn_cvr_grading_formula t__sn_cvr_grading_formula;

#define d__sn_cvr_grading_formula d__sn__sn_cvr_grading_formula

/* line 207 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_cfg_cover_mode'' */
typedef enum {
    sn_cfg_cover_mode__default=((int)0),
    sn__sn_cfg_cover_mode__default=((int)0),
    sn_cfg_cover_mode__off=((int)1),
    sn__sn_cfg_cover_mode__off=((int)1),
    sn_cfg_cover_mode__on=((int)2),
    sn__sn_cfg_cover_mode__on=((int)2),
    sn_cfg_cover_mode__on_interactive=((int)3),
    sn__sn_cfg_cover_mode__on_interactive=((int)3),
    sn_cfg_cover_mode__count_only=((int)4),
    sn__sn_cfg_cover_mode__count_only=((int)4),
    sn_cfg_cover_mode__normal=((int)5),
    sn__sn_cfg_cover_mode__normal=((int)5)
} t__sn__sn_cfg_cover_mode;

#define d__sn__sn_cfg_cover_mode 1383

typedef t__sn__sn_cfg_cover_mode t__sn_cfg_cover_mode;

#define d__sn_cfg_cover_mode d__sn__sn_cfg_cover_mode

/* line 203 "/vobs/specman/src/config_main.e"  From 'Enum type 'show_mode'' */
typedef enum {
    show_mode__both=((int)0),
    sn__show_mode__both=((int)0),
    show_mode__holes_only=((int)1),
    sn__show_mode__holes_only=((int)1),
    show_mode__full=((int)2),
    sn__show_mode__full=((int)2)
} t__sn__show_mode;

#define d__sn__show_mode 1381

typedef t__sn__show_mode t__show_mode;

#define d__show_mode d__sn__show_mode

/* line 218 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_cvr_cost_type'' */
typedef enum {
    sn_cvr_cost_type__constant_cost=((int)0),
    sn__sn_cvr_cost_type__constant_cost=((int)0),
    sn_cvr_cost_type__cpu_time=((int)1),
    sn__sn_cvr_cost_type__cpu_time=((int)1),
    sn_cvr_cost_type__user_cpu_time=((int)2),
    sn__sn_cvr_cost_type__user_cpu_time=((int)2),
    sn_cvr_cost_type__system_cpu_time=((int)3),
    sn__sn_cvr_cost_type__system_cpu_time=((int)3),
    sn_cvr_cost_type__test_time=((int)4),
    sn__sn_cvr_cost_type__test_time=((int)4)
} t__sn__sn_cvr_cost_type;

#define d__sn__sn_cvr_cost_type 1387

typedef t__sn__sn_cvr_cost_type t__sn_cvr_cost_type;

#define d__sn_cvr_cost_type d__sn__sn_cvr_cost_type

/* line 226 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_cover_gui_sync_mode'' */
typedef enum {
    sn_cover_gui_sync_mode__immediate=((int)0),
    sn__sn_cover_gui_sync_mode__immediate=((int)0),
    sn_cover_gui_sync_mode__deferred=((int)1),
    sn__sn_cover_gui_sync_mode__deferred=((int)1)
} t__sn__sn_cover_gui_sync_mode;

#define d__sn__sn_cover_gui_sync_mode 1389

typedef t__sn__sn_cover_gui_sync_mode t__sn_cover_gui_sync_mode;

#define d__sn_cover_gui_sync_mode d__sn__sn_cover_gui_sync_mode

/* line 245 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_cvr_code_coverage_mode'' */
typedef enum {
    sn_cvr_code_coverage_mode__off=((int)0),
    sn__sn_cvr_code_coverage_mode__off=((int)0),
    sn_cvr_code_coverage_mode__on=((int)1),
    sn__sn_cvr_code_coverage_mode__on=((int)1),
    sn_cvr_code_coverage_mode__per_type=((int)2),
    sn__sn_cvr_code_coverage_mode__per_type=((int)2)
} t__sn__sn_cvr_code_coverage_mode;

#define d__sn__sn_cvr_code_coverage_mode 1395

typedef t__sn__sn_cvr_code_coverage_mode t__sn_cvr_code_coverage_mode;

#define d__sn_cvr_code_coverage_mode d__sn__sn_cvr_code_coverage_mode

/* line 231 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_cvr_db_format'' */
typedef enum {
    sn_cvr_db_format__default=((int)0),
    sn__sn_cvr_db_format__default=((int)0),
    sn_cvr_db_format__ecov=((int)1),
    sn__sn_cvr_db_format__ecov=((int)1),
    sn_cvr_db_format__ucd=((int)2),
    sn__sn_cvr_db_format__ucd=((int)2),
    sn_cvr_db_format__both=((int)3),
    sn__sn_cvr_db_format__both=((int)3)
} t__sn__sn_cvr_db_format;

#define d__sn__sn_cvr_db_format 1391

typedef t__sn__sn_cvr_db_format t__sn_cvr_db_format;

#define d__sn_cvr_db_format d__sn__sn_cvr_db_format

/* line 238 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_cvr_model_format'' */
typedef enum {
    sn_cvr_model_format__default=((int)0),
    sn__sn_cvr_model_format__default=((int)0),
    sn_cvr_model_format__none=((int)1),
    sn__sn_cvr_model_format__none=((int)1),
    sn_cvr_model_format__excov=((int)2),
    sn__sn_cvr_model_format__excov=((int)2),
    sn_cvr_model_format__ucm=((int)3),
    sn__sn_cvr_model_format__ucm=((int)3)
} t__sn__sn_cvr_model_format;

#define d__sn__sn_cvr_model_format 1393

typedef t__sn__sn_cvr_model_format t__sn_cvr_model_format;

#define d__sn_cvr_model_format d__sn__sn_cvr_model_format

/* line 352 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_show_on_trace'' */
typedef enum {
    sn_show_on_trace__structs=((int)0),
    sn__sn_show_on_trace__structs=((int)0),
    sn_show_on_trace__all=((int)1),
    sn__sn_show_on_trace__all=((int)1),
    sn_show_on_trace__none=((int)2),
    sn__sn_show_on_trace__none=((int)2)
} t__sn__sn_show_on_trace;

#define d__sn__sn_show_on_trace 1397

typedef t__sn__sn_show_on_trace t__sn_show_on_trace;

#define d__sn_show_on_trace d__sn__sn_show_on_trace

/* line 356 "/vobs/specman/src/config_main.e"  From 'Enum type 'sn_fast_gen_t'' */
typedef enum {
    sn_fast_gen_t__default_off=((int)0),
    sn__sn_fast_gen_t__default_off=((int)0),
    sn_fast_gen_t__default_on=((int)1),
    sn__sn_fast_gen_t__default_on=((int)1),
    sn_fast_gen_t__force_off=((int)2),
    sn__sn_fast_gen_t__force_off=((int)2),
    sn_fast_gen_t__force_on=((int)3),
    sn__sn_fast_gen_t__force_on=((int)3)
} t__sn__sn_fast_gen_t;

#define d__sn__sn_fast_gen_t 1399

typedef t__sn__sn_fast_gen_t t__sn_fast_gen_t;

#define d__sn_fast_gen_t d__sn__sn_fast_gen_t

/* line 3 "/vobs/specman/src/gen/gen_g5_config_options.e"  From 'Enum type 'gen_g5_op_mode_t'' */
typedef enum {
    gen_g5_op_mode_t__g5=((int)0),
    sn__gen_g5_op_mode_t__g5=((int)0),
    gen_g5_op_mode_t__pgen3=((int)1),
    sn__gen_g5_op_mode_t__pgen3=((int)1),
    gen_g5_op_mode_t__mixed=((int)2),
    sn__gen_g5_op_mode_t__mixed=((int)2)
} t__sn__gen_g5_op_mode_t;

#define d__sn__gen_g5_op_mode_t 1920

typedef t__sn__gen_g5_op_mode_t t__gen_g5_op_mode_t;

#define d__gen_g5_op_mode_t d__sn__gen_g5_op_mode_t

/* line 6 "/vobs/specman/src/gen/gen_g5_config_options.e"  From 'Enum type 'gotf_sa_mode_t'' */
typedef enum {
    gotf_sa_mode_t__ON_DEMAND=((int)0),
    sn__gotf_sa_mode_t__ON_DEMAND=((int)0),
    gotf_sa_mode_t__ON_SETUP=((int)1),
    sn__gotf_sa_mode_t__ON_SETUP=((int)1)
} t__sn__gotf_sa_mode_t;

#define d__sn__gotf_sa_mode_t 1926

typedef t__sn__gotf_sa_mode_t t__gotf_sa_mode_t;

#define d__gotf_sa_mode_t d__sn__gotf_sa_mode_t

/* line 7 "/vobs/specman/src/gen/gen_g5_config_options.e"  From 'Enum type 'solvability_mode_t'' */
typedef enum {
    solvability_mode_t__DEFAULT=((int)0),
    sn__solvability_mode_t__DEFAULT=((int)0),
    solvability_mode_t__LOW=((int)1),
    sn__solvability_mode_t__LOW=((int)1),
    solvability_mode_t__HIGH=((int)2),
    sn__solvability_mode_t__HIGH=((int)2),
    solvability_mode_t__USER_DEFINED=((int)3),
    sn__solvability_mode_t__USER_DEFINED=((int)3)
} t__sn__solvability_mode_t;

#define d__sn__solvability_mode_t 1928

typedef t__sn__solvability_mode_t t__solvability_mode_t;

#define d__solvability_mode_t d__sn__solvability_mode_t

/* line 4 "/vobs/specman/src/gen/gen_g5_config_options.e"  From 'Enum type 'gen_technology_t'' */
typedef enum {
    gen_technology_t__IntelliGen=((int)0),
    sn__gen_technology_t__IntelliGen=((int)0),
    gen_technology_t__Pgen=((int)1),
    sn__gen_technology_t__Pgen=((int)1)
} t__sn__gen_technology_t;

#define d__sn__gen_technology_t 1922

typedef t__sn__gen_technology_t t__gen_technology_t;

#define d__gen_technology_t d__sn__gen_technology_t

/* line 5 "/vobs/specman/src/gen/gen_g5_config_options.e"  From 'Enum type 'generator_mode_t'' */
typedef enum {
    generator_mode_t__BUILD=((int)0),
    sn__generator_mode_t__BUILD=((int)0),
    generator_mode_t__MIXED=((int)1),
    sn__generator_mode_t__MIXED=((int)1),
    generator_mode_t__SIMPLE=((int)2),
    sn__generator_mode_t__SIMPLE=((int)2)
} t__sn__generator_mode_t;

#define d__sn__generator_mode_t 1924

typedef t__sn__generator_mode_t t__generator_mode_t;

#define d__generator_mode_t d__sn__generator_mode_t

/* line 8 "/vobs/specman/src/gen/gen_g5_config_options.e"  From 'Enum type 'select_semantic_t'' */
typedef enum {
    select_semantic_t__OLD=((int)0),
    sn__select_semantic_t__OLD=((int)0),
    select_semantic_t__NEW=((int)1),
    sn__select_semantic_t__NEW=((int)1)
} t__sn__select_semantic_t;

#define d__sn__select_semantic_t 1930

typedef t__sn__select_semantic_t t__select_semantic_t;

#define d__select_semantic_t d__sn__select_semantic_t

/* line 9 "/vobs/specman/src/config_run.e"  From 'Enum type 't_exit_on'' */
typedef enum {
    t_exit_on__command=((int)0),
    sn__t_exit_on__command=((int)0),
    t_exit_on__normal_stop=((int)1),
    sn__t_exit_on__normal_stop=((int)1),
    t_exit_on__error=((int)2),
    sn__t_exit_on__error=((int)2),
    t_exit_on__all=((int)3),
    sn__t_exit_on__all=((int)3)
} t__sn__t_exit_on;

#define d__sn__t_exit_on 1455

typedef t__sn__t_exit_on t__t_exit_on;

#define d__t_exit_on d__sn__t_exit_on

/* line 1832 "../src/root_types.e"  From 'Enum type 'auto_gc_setting_policy'' */
typedef enum {
    auto_gc_setting_policy__NONE=((int)0),
    sn__auto_gc_setting_policy__NONE=((int)0),
    auto_gc_setting_policy__STANDARD=((int)1),
    sn__auto_gc_setting_policy__STANDARD=((int)1)
} t__sn__auto_gc_setting_policy;

#define d__sn__auto_gc_setting_policy 249

typedef t__sn__auto_gc_setting_policy t__auto_gc_setting_policy;

#define d__auto_gc_setting_policy d__sn__auto_gc_setting_policy

/* line 74 "/vobs/specman/src/interp.e"  From 'Enum type 'macro_debug_mode'' */
typedef enum {
    macro_debug_mode__definition=((int)0),
    sn__macro_debug_mode__definition=((int)0),
    macro_debug_mode__expansion=((int)1),
    sn__macro_debug_mode__expansion=((int)1)
} t__sn__macro_debug_mode;

#define d__sn__macro_debug_mode 645

typedef t__sn__macro_debug_mode t__macro_debug_mode;

#define d__macro_debug_mode d__sn__macro_debug_mode

/* line 453 "/vobs/specman/src/macro_call_info.e"  From 'Enum type 'debug_config_options'macro_expansion'' */
typedef enum {
    debug_config_options__macro_expansion__never=((int)0),
    sn__debug_config_options__macro_expansion__never=((int)0),
    debug_config_options__macro_expansion__load_only=((int)1),
    sn__debug_config_options__macro_expansion__load_only=((int)1),
    debug_config_options__macro_expansion__load_and_compile=((int)2),
    sn__debug_config_options__macro_expansion__load_and_compile=((int)2)
} t__imp_enum_sn__debug_config_options__macro_expansion;

#define d__imp_enum_sn__debug_config_options__macro_expansion 4036

typedef t__imp_enum_sn__debug_config_options__macro_expansion t__imp_enum_debug_config_options__macro_expansion;

#define d__imp_enum_debug_config_options__macro_expansion d__imp_enum_sn__debug_config_options__macro_expansion

/* line 18 "/vobs/specman/src/config_main.e"  From 'Enum type 'wave_working_mode'' */
typedef enum {
    wave_working_mode__off_line=((int)0),
    sn__wave_working_mode__off_line=((int)0),
    wave_working_mode__manual=((int)1),
    sn__wave_working_mode__manual=((int)1),
    wave_working_mode__interactive=((int)2),
    sn__wave_working_mode__interactive=((int)2)
} t__sn__wave_working_mode;

#define d__sn__wave_working_mode 1353

typedef t__sn__wave_working_mode t__wave_working_mode;

#define d__wave_working_mode d__sn__wave_working_mode

/* line 20 "/vobs/specman/src/config_main.e"  From 'Enum type 't_ies_sync_reset'' */
typedef enum {
    t_ies_sync_reset__no_sync=((int)0),
    sn__t_ies_sync_reset__no_sync=((int)0),
    t_ies_sync_reset__reload=((int)1),
    sn__t_ies_sync_reset__reload=((int)1),
    t_ies_sync_reset__startup=((int)2),
    sn__t_ies_sync_reset__startup=((int)2),
    t_ies_sync_reset__pre_test=((int)3),
    sn__t_ies_sync_reset__pre_test=((int)3),
    t_ies_sync_reset__pre_run=((int)4),
    sn__t_ies_sync_reset__pre_run=((int)4)
} t__sn__t_ies_sync_reset;

#define d__sn__t_ies_sync_reset 1357

typedef t__sn__t_ies_sync_reset t__t_ies_sync_reset;

#define d__t_ies_sync_reset d__sn__t_ies_sync_reset

/* line 21 "/vobs/specman/src/config_main.e"  From 'Enum type 't_ies_log_to_sim'' */
typedef enum {
    t_ies_log_to_sim__none=((int)0),
    sn__t_ies_log_to_sim__none=((int)0),
    t_ies_log_to_sim__log=((int)1),
    sn__t_ies_log_to_sim__log=((int)1),
    t_ies_log_to_sim__console_and_log=((int)2),
    sn__t_ies_log_to_sim__console_and_log=((int)2)
} t__sn__t_ies_log_to_sim;

#define d__sn__t_ies_log_to_sim 1359

typedef t__sn__t_ies_log_to_sim t__t_ies_log_to_sim;

#define d__t_ies_log_to_sim d__sn__t_ies_log_to_sim

/* line 60 "/vobs/specman/src/config_main.e"  From 'Enum type 'ui_type'' */
typedef enum {
    ui_type__default_widget=((int)0),
    sn__ui_type__default_widget=((int)0),
    ui_type__check_box=((int)1),
    sn__ui_type__check_box=((int)1),
    ui_type__radio_button=((int)2),
    sn__ui_type__radio_button=((int)2),
    ui_type__drop_down=((int)3),
    sn__ui_type__drop_down=((int)3),
    ui_type__entry=((int)4),
    sn__ui_type__entry=((int)4),
    ui_type__scale=((int)5),
    sn__ui_type__scale=((int)5)
} t__sn__ui_type;

#define d__sn__ui_type 1362

typedef t__sn__ui_type t__ui_type;

#define d__ui_type d__sn__ui_type

/* line 1076 "/vobs/specman/src/config_main.e"  From 'Enum type 'config_option_status'' */
typedef enum {
    config_option_status__normal=((int)0),
    sn__config_option_status__normal=((int)0),
    config_option_status__deprecated=((int)1),
    sn__config_option_status__deprecated=((int)1),
    config_option_status__private=((int)2),
    sn__config_option_status__private=((int)2),
    config_option_status__canceled=((int)3),
    sn__config_option_status__canceled=((int)3)
} t__sn__config_option_status;

#define d__sn__config_option_status 1407

typedef t__sn__config_option_status t__config_option_status;

#define d__config_option_status d__sn__config_option_status

/* line 294 "../src/root_basic.e"  From 'Enum type 'on_status'' */
typedef enum {
    on_status__normal=((int)0),
    e_core__on_status__normal=((int)0),
    on_status__stopped=((int)1),
    e_core__on_status__stopped=((int)1),
    on_status__abort=((int)2),
    e_core__on_status__abort=((int)2),
    on_status__continue=((int)3),
    e_core__on_status__continue=((int)3)
} t__e_core__on_status;

#define d__e_core__on_status 35

typedef t__e_core__on_status t__on_status;

#define d__on_status d__e_core__on_status

/* line 28 "/vobs/specman/src/interp.e"  From 'Enum type 'on_kind'' */
typedef enum {
    on_kind__any=((int)0),
    sn__on_kind__any=((int)0),
    on_kind__call=((int)1),
    sn__on_kind__call=((int)1),
    on_kind__return=((int)2),
    sn__on_kind__return=((int)2),
    on_kind__step=((int)3),
    sn__on_kind__step=((int)3)
} t__sn__on_kind;

#define d__sn__on_kind 637

typedef t__sn__on_kind t__on_kind;

#define d__on_kind d__sn__on_kind

/* line 35 "/vobs/specman/src/interp.e"  From 'Enum type 'on_stop_kind'' */
typedef enum {
    on_stop_kind__none=((int)0),
    sn__on_stop_kind__none=((int)0),
    on_stop_kind__stop=((int)1),
    sn__on_stop_kind__stop=((int)1),
    on_stop_kind__trace=((int)2),
    sn__on_stop_kind__trace=((int)2),
    on_stop_kind__enter_debug=((int)3),
    sn__on_stop_kind__enter_debug=((int)3),
    on_stop_kind__show_calls=((int)4),
    sn__on_stop_kind__show_calls=((int)4),
    on_stop_kind__skip=((int)5),
    sn__on_stop_kind__skip=((int)5)
} t__sn__on_stop_kind;

#define d__sn__on_stop_kind 639

typedef t__sn__on_stop_kind t__on_stop_kind;

#define d__on_stop_kind d__sn__on_stop_kind

/* line 44 "/vobs/specman/src/interp.e"  From 'Enum type 'request_type'' */
typedef enum {
    request_type__normal=((int)0),
    sn__request_type__normal=((int)0),
    request_type__event=((int)1),
    sn__request_type__event=((int)1),
    request_type__contention=((int)2),
    sn__request_type__contention=((int)2),
    request_type__on_error=((int)3),
    sn__request_type__on_error=((int)3),
    request_type__on_interrupt=((int)4),
    sn__request_type__on_interrupt=((int)4),
    request_type__on_alloc=((int)5),
    sn__request_type__on_alloc=((int)5),
    request_type__on_simulator=((int)6),
    sn__request_type__on_simulator=((int)6),
    request_type__on_packing=((int)7),
    sn__request_type__on_packing=((int)7),
    request_type__on_reparse=((int)8),
    sn__request_type__on_reparse=((int)8),
    request_type__on_deep=((int)9),
    sn__request_type__on_deep=((int)9),
    request_type__gen=((int)10),
    sn__request_type__gen=((int)10),
    request_type__each_line_for_interrupt=((int)11),
    sn__request_type__each_line_for_interrupt=((int)11),
    request_type__on_change=((int)12),
    sn__request_type__on_change=((int)12),
    request_type__sim_read=((int)13),
    sn__request_type__sim_read=((int)13),
    request_type__sim_write=((int)14),
    sn__request_type__sim_write=((int)14),
    request_type__tcm_wait=((int)15),
    sn__request_type__tcm_wait=((int)15),
    request_type__tcm_state=((int)16),
    sn__request_type__tcm_state=((int)16),
    request_type__output=((int)17),
    sn__request_type__output=((int)17),
    request_type__check=((int)18),
    sn__request_type__check=((int)18),
    request_type__g5=((int)19),
    sn__request_type__g5=((int)19)
} t__sn__request_type;

#define d__sn__request_type 641

typedef t__sn__request_type t__request_type;

#define d__request_type d__sn__request_type

/* line 67 "/vobs/specman/src/interp.e"  From 'Enum type 'on_step_mode'' */
typedef enum {
    on_step_mode__none=((int)0),
    sn__on_step_mode__none=((int)0),
    on_step_mode__step=((int)1),
    sn__on_step_mode__step=((int)1),
    on_step_mode__next=((int)2),
    sn__on_step_mode__next=((int)2),
    on_step_mode__return=((int)3),
    sn__on_step_mode__return=((int)3)
} t__sn__on_step_mode;

#define d__sn__on_step_mode 643

typedef t__sn__on_step_mode t__on_step_mode;

#define d__on_step_mode d__sn__on_step_mode

/* line 26 "/vobs/specman/src/dbg_defs.e"  From 'Enum type 't_macro_debug_mode'' */
typedef enum {
    t_macro_debug_mode__definition=((int)0),
    sn_debugger__t_macro_debug_mode__definition=((int)0),
    t_macro_debug_mode__expansion=((int)1),
    sn_debugger__t_macro_debug_mode__expansion=((int)1)
} t__sn_debugger__t_macro_debug_mode;

#define d__sn_debugger__t_macro_debug_mode 4066

typedef t__sn_debugger__t_macro_debug_mode t__t_macro_debug_mode;

#define d__t_macro_debug_mode d__sn_debugger__t_macro_debug_mode

/* line 11 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'Enum type 'sn_simple_type'' */
typedef enum {
    sn_simple_type__STRING=((int)0),
    vt__sn_simple_type__STRING=((int)0),
    sn_simple_type__NUMBER=((int)1),
    vt__sn_simple_type__NUMBER=((int)1),
    sn_simple_type__BOOLEAN=((int)2),
    vt__sn_simple_type__BOOLEAN=((int)2),
    sn_simple_type__ICON=((int)3),
    vt__sn_simple_type__ICON=((int)3)
} t__vt__sn_simple_type;

#define d__vt__sn_simple_type 2530

typedef t__vt__sn_simple_type t__sn_simple_type;

#define d__sn_simple_type d__vt__sn_simple_type

/* line 1737 "../src/root_basic.e"  From 'Enum type 'sn_rs_translation'' */
typedef enum {
    sn_rs_translation__none=((int)0),
    e_core__sn_rs_translation__none=((int)0),
    sn_rs_translation__shallow=((int)1),
    e_core__sn_rs_translation__shallow=((int)1),
    sn_rs_translation__deep=((int)2),
    e_core__sn_rs_translation__deep=((int)2)
} t__e_core__sn_rs_translation;

#define d__e_core__sn_rs_translation 100

typedef t__e_core__sn_rs_translation t__sn_rs_translation;

#define d__sn_rs_translation d__e_core__sn_rs_translation

/* line 74 "/vobs/specman/src/profiler_hookup.e"  From 'Enum type 'sn_profiler_type'' */
typedef enum {
    sn_profiler_type__cpu=((int)0),
    sn__sn_profiler_type__cpu=((int)0),
    sn_profiler_type__mem=((int)1),
    sn__sn_profiler_type__mem=((int)1),
    sn_profiler_type__trace=((int)2),
    sn__sn_profiler_type__trace=((int)2)
} t__sn__sn_profiler_type;

#define d__sn__sn_profiler_type 9137

typedef t__sn__sn_profiler_type t__sn_profiler_type;

#define d__sn_profiler_type d__sn__sn_profiler_type

/* line 3 "/vobs/specman/src/prof_frob.e"  From 'Enum type 'sn_prof_backend_type'' */
typedef enum {
    sn_prof_backend_type__Sampling=((int)0),
    sn__sn_prof_backend_type__Sampling=((int)0),
    sn_prof_backend_type__Quantify=((int)1),
    sn__sn_prof_backend_type__Quantify=((int)1)
} t__sn__sn_prof_backend_type;

#define d__sn__sn_prof_backend_type 9145

typedef t__sn__sn_prof_backend_type t__sn_prof_backend_type;

#define d__sn_prof_backend_type d__sn__sn_prof_backend_type

/* line 4 "/vobs/specman/src/prof_frob.e"  From 'type: sn_prof_sig_type' */
#define t__sn__sn_prof_sig_type t__int
#define t__sn_prof_sig_type t__sn__sn_prof_sig_type
/* line 38 "../src/root_basic.e"  From 'type: C_file' */
typedef FILE * t__C_file;
#define d__C_file 6
/* line 29 "/vobs/specman/src/prof_lookup.e"  From 'Enum type 'sn_prof_C_function_type'' */
typedef enum {
    sn_prof_C_function_type__exported=((int)0),
    sn__sn_prof_C_function_type__exported=((int)0),
    sn_prof_C_function_type__static=((int)1),
    sn__sn_prof_C_function_type__static=((int)1),
    sn_prof_C_function_type__proxy=((int)2),
    sn__sn_prof_C_function_type__proxy=((int)2)
} t__sn__sn_prof_C_function_type;

#define d__sn__sn_prof_C_function_type 9156

typedef t__sn__sn_prof_C_function_type t__sn_prof_C_function_type;

#define d__sn_prof_C_function_type d__sn__sn_prof_C_function_type

/* line 80 "/vobs/specman/src/profiler_hookup.e"  From 'Enum type 'sn_profiler_cb_direction'' */
typedef enum {
    sn_profiler_cb_direction__inward=((int)0),
    sn__sn_profiler_cb_direction__inward=((int)0),
    sn_profiler_cb_direction__outward=((int)1),
    sn__sn_profiler_cb_direction__outward=((int)1)
} t__sn__sn_profiler_cb_direction;

#define d__sn__sn_profiler_cb_direction 9139

typedef t__sn__sn_profiler_cb_direction t__sn_profiler_cb_direction;

#define d__sn_profiler_cb_direction d__sn__sn_profiler_cb_direction

/* line 396 "/vobs/specman/src/prof_attribution.e"  From 'Enum type 'sn_prof_known_action'' */
typedef enum {
    sn_prof_known_action__swallow=((int)0),
    sn__sn_prof_known_action__swallow=((int)0),
    sn_prof_known_action__show=((int)1),
    sn__sn_prof_known_action__show=((int)1)
} t__sn__sn_prof_known_action;

#define d__sn__sn_prof_known_action 9187

typedef t__sn__sn_prof_known_action t__sn_prof_known_action;

#define d__sn_prof_known_action d__sn__sn_prof_known_action

/* line 4 "/vobs/specman/src/rl_rnd.e"  From 'Enum type 'rnd_policy'' */
typedef enum {
    rnd_policy__random=((int)0),
    sn_rl__rnd_policy__random=((int)0),
    rnd_policy__median=((int)1),
    sn_rl__rnd_policy__median=((int)1),
    rnd_policy__min=((int)2),
    sn_rl__rnd_policy__min=((int)2),
    rnd_policy__max=((int)3),
    sn_rl__rnd_policy__max=((int)3)
} t__sn_rl__rnd_policy;

#define d__sn_rl__rnd_policy 1692

typedef t__sn_rl__rnd_policy t__rnd_policy;

#define d__rnd_policy d__sn_rl__rnd_policy

/* line 44 "/vobs/specman/src/gen_basic.e"  From 'Enum type 'gen_phase'' */
typedef enum {
    gen_phase__none=((int)0),
    sn__gen_phase__none=((int)0),
    gen_phase__static=((int)1),
    sn__gen_phase__static=((int)1),
    gen_phase__after_static=((int)2),
    sn__gen_phase__after_static=((int)2),
    gen_phase__pre_simulation=((int)3),
    sn__gen_phase__pre_simulation=((int)3),
    gen_phase__on_the_fly=((int)4),
    sn__gen_phase__on_the_fly=((int)4)
} t__sn__gen_phase;

#define d__sn__gen_phase 2115

typedef t__sn__gen_phase t__gen_phase;

#define d__gen_phase d__sn__gen_phase

/* line 210 "/vobs/specman/src/gen_basic.e"  From 'Enum type 'pgen3'gen_status'' */
typedef enum {
    pgen3__gen_status__started=((int)0),
    sn__pgen3__gen_status__started=((int)0),
    pgen3__gen_status__completed=((int)1),
    sn__pgen3__gen_status__completed=((int)1),
    pgen3__gen_status__failed=((int)2),
    sn__pgen3__gen_status__failed=((int)2)
} t__imp_enum_sn__pgen3__gen_status;

#define d__imp_enum_sn__pgen3__gen_status 2122

typedef t__imp_enum_sn__pgen3__gen_status t__imp_enum_pgen3__gen_status;

#define d__imp_enum_pgen3__gen_status d__imp_enum_sn__pgen3__gen_status

/* line 158 "/vobs/specman/src/gen_debug_header.e"  From 'Enum type 'pgen3'visual_deb_level'' */
typedef enum {
    pgen3__visual_deb_level__none=((int)0),
    sn__pgen3__visual_deb_level__none=((int)0),
    pgen3__visual_deb_level__skeleton=((int)1),
    sn__pgen3__visual_deb_level__skeleton=((int)1),
    pgen3__visual_deb_level__full=((int)2),
    sn__pgen3__visual_deb_level__full=((int)2)
} t__imp_enum_sn__pgen3__visual_deb_level;

#define d__imp_enum_sn__pgen3__visual_deb_level 2131

typedef t__imp_enum_sn__pgen3__visual_deb_level t__imp_enum_pgen3__visual_deb_level;

#define d__imp_enum_pgen3__visual_deb_level d__imp_enum_sn__pgen3__visual_deb_level

/* line 645 "/vobs/specman/src/gen_static_header.e"  From 'Enum type 'gen_static_phase'' */
typedef enum {
    gen_static_phase__none=((int)0),
    sn__gen_static_phase__none=((int)0),
    gen_static_phase__reachability_analysis=((int)1),
    sn__gen_static_phase__reachability_analysis=((int)1),
    gen_static_phase__temps_relocation=((int)2),
    sn__gen_static_phase__temps_relocation=((int)2),
    gen_static_phase__constraints_to_role_extraction=((int)3),
    sn__gen_static_phase__constraints_to_role_extraction=((int)3),
    gen_static_phase__create_extra_roles=((int)4),
    sn__gen_static_phase__create_extra_roles=((int)4),
    gen_static_phase__update_ranges=((int)5),
    sn__gen_static_phase__update_ranges=((int)5),
    gen_static_phase__static_reduction=((int)6),
    sn__gen_static_phase__static_reduction=((int)6),
    gen_static_phase__edge_creation=((int)7),
    sn__gen_static_phase__edge_creation=((int)7),
    gen_static_phase__finalize=((int)8),
    sn__gen_static_phase__finalize=((int)8)
} t__sn__gen_static_phase;

#define d__sn__gen_static_phase 5652

typedef t__sn__gen_static_phase t__gen_static_phase;

#define d__gen_static_phase d__sn__gen_static_phase

/* line 2084 "/vobs/specman/src/gen_static_comms.e"  From 'Enum type 'pgen3'fast_gen_level'' */
typedef enum {
    pgen3__fast_gen_level__none=((int)0),
    sn__pgen3__fast_gen_level__none=((int)0),
    pgen3__fast_gen_level__all_subtypes_no_dets=((int)1),
    sn__pgen3__fast_gen_level__all_subtypes_no_dets=((int)1),
    pgen3__fast_gen_level__all_subtypes_all_dets=((int)2),
    sn__pgen3__fast_gen_level__all_subtypes_all_dets=((int)2),
    pgen3__fast_gen_level__as_specified=((int)3),
    sn__pgen3__fast_gen_level__as_specified=((int)3)
} t__imp_enum_sn__pgen3__fast_gen_level;

#define d__imp_enum_sn__pgen3__fast_gen_level 5863

typedef t__imp_enum_sn__pgen3__fast_gen_level t__imp_enum_pgen3__fast_gen_level;

#define d__imp_enum_pgen3__fast_gen_level d__imp_enum_sn__pgen3__fast_gen_level

/* line 33 "/vobs/specman/src/gen_parse.e"  From 'Enum type 'pgen3_debug'phase'' */
typedef enum {
    pgen3_debug__phase__static=((int)0),
    sn__pgen3_debug__phase__static=((int)0),
    pgen3_debug__phase__dynamic=((int)1),
    sn__pgen3_debug__phase__dynamic=((int)1)
} t__imp_enum_sn__pgen3_debug__phase;

#define d__imp_enum_sn__pgen3_debug__phase 2093

typedef t__imp_enum_sn__pgen3_debug__phase t__imp_enum_pgen3_debug__phase;

#define d__imp_enum_pgen3_debug__phase d__imp_enum_sn__pgen3_debug__phase

/* line 34 "/vobs/specman/src/gen_parse.e"  From 'Enum type 'pgen3_debug'level'' */
typedef enum {
    pgen3_debug__level__terse=((int)0),
    sn__pgen3_debug__level__terse=((int)0),
    pgen3_debug__level__detailed=((int)1),
    sn__pgen3_debug__level__detailed=((int)1),
    pgen3_debug__level__internal=((int)2),
    sn__pgen3_debug__level__internal=((int)2)
} t__imp_enum_sn__pgen3_debug__level;

#define d__imp_enum_sn__pgen3_debug__level 2094

typedef t__imp_enum_sn__pgen3_debug__level t__imp_enum_pgen3_debug__level;

#define d__imp_enum_pgen3_debug__level d__imp_enum_sn__pgen3_debug__level

/* line 14 "/vobs/specman/src/gen_debug_order_graph.e"  From 'Enum type 'gdo_node_kind'' */
typedef enum {
    gdo_node_kind__scalar=((int)0),
    sn__gdo_node_kind__scalar=((int)0),
    gdo_node_kind__struct=((int)1),
    sn__gdo_node_kind__struct=((int)1),
    gdo_node_kind__list=((int)2),
    sn__gdo_node_kind__list=((int)2)
} t__sn__gdo_node_kind;

#define d__sn__gdo_node_kind 6098

typedef t__sn__gdo_node_kind t__gdo_node_kind;

#define d__gdo_node_kind d__sn__gdo_node_kind

/* line 889 "/vobs/specman/src/gen_debug.e"  From 'Enum type 'sn_gen_boring_status'' */
typedef enum {
    sn_gen_boring_status__unknown=((int)0),
    sn__sn_gen_boring_status__unknown=((int)0),
    sn_gen_boring_status__interesting=((int)1),
    sn__sn_gen_boring_status__interesting=((int)1),
    sn_gen_boring_status__boring=((int)2),
    sn__sn_gen_boring_status__boring=((int)2)
} t__sn__sn_gen_boring_status;

#define d__sn__sn_gen_boring_status 6070

typedef t__sn__sn_gen_boring_status t__sn_gen_boring_status;

#define d__sn_gen_boring_status d__sn__sn_gen_boring_status

/* line 314 "/vobs/specman/src/gen_debug.e"  From 'Enum type 'sn_msg_show_request_kind'' */
typedef enum {
    sn_msg_show_request_kind__by_exp=((int)0),
    sn__sn_msg_show_request_kind__by_exp=((int)0),
    sn_msg_show_request_kind__by_type=((int)1),
    sn__sn_msg_show_request_kind__by_type=((int)1),
    sn_msg_show_request_kind__by_type_only=((int)2),
    sn__sn_msg_show_request_kind__by_type_only=((int)2)
} t__sn__sn_msg_show_request_kind;

#define d__sn__sn_msg_show_request_kind 6068

typedef t__sn__sn_msg_show_request_kind t__sn_msg_show_request_kind;

#define d__sn_msg_show_request_kind d__sn__sn_msg_show_request_kind

/* line 254 "/vobs/specman/src/gen_om_item.e"  From 'Enum type 'om_item_node'color'' */
typedef enum {
    om_item_node__color__white=((int)0),
    sn__om_item_node__color__white=((int)0),
    om_item_node__color__black=((int)1),
    sn__om_item_node__color__black=((int)1)
} t__imp_enum_sn__om_item_node__color;

#define d__imp_enum_sn__om_item_node__color 5893

typedef t__imp_enum_sn__om_item_node__color t__imp_enum_om_item_node__color;

#define d__imp_enum_om_item_node__color d__imp_enum_sn__om_item_node__color

/* line 469 "/vobs/specman/src/japp/gendebugger/src/gendb_order_manager.e"  From 'Enum type 'new_gdo_node_kind'' */
typedef enum {
    new_gdo_node_kind__scalar=((int)0),
    sn__new_gdo_node_kind__scalar=((int)0),
    new_gdo_node_kind__struct=((int)1),
    sn__new_gdo_node_kind__struct=((int)1),
    new_gdo_node_kind__list=((int)2),
    sn__new_gdo_node_kind__list=((int)2)
} t__sn__new_gdo_node_kind;

#define d__sn__new_gdo_node_kind 6385

typedef t__sn__new_gdo_node_kind t__new_gdo_node_kind;

#define d__new_gdo_node_kind d__sn__new_gdo_node_kind

/* line 1668 "/vobs/specman/src/gen_gendb_header.e"  From 'Enum type 'sn_create_edge_event'kind'' */
typedef enum {
    sn_create_edge_event__kind__Uni=((int)0),
    sn__sn_create_edge_event__kind__Uni=((int)0),
    sn_create_edge_event__kind__Bi=((int)1),
    sn__sn_create_edge_event__kind__Bi=((int)1),
    sn_create_edge_event__kind__Dof=((int)2),
    sn__sn_create_edge_event__kind__Dof=((int)2)
} t__imp_enum_sn__sn_create_edge_event__kind;

#define d__imp_enum_sn__sn_create_edge_event__kind 6013

typedef t__imp_enum_sn__sn_create_edge_event__kind t__imp_enum_sn_create_edge_event__kind;

#define d__imp_enum_sn_create_edge_event__kind d__imp_enum_sn__sn_create_edge_event__kind

/* line 252 "/vobs/specman/src/disp_defs.e"  From 'Enum type 'display_kind'' */
typedef enum {
    display_kind__none=((int)0),
    sn__display_kind__none=((int)0),
    display_kind__tk=((int)1),
    sn__display_kind__tk=((int)1)
} t__sn__display_kind;

#define d__sn__display_kind 2496

typedef t__sn__display_kind t__display_kind;

#define d__display_kind d__sn__display_kind

/* line 264 "/vobs/specman/src/disp_defs.e"  From 'Enum type 'presentation_type'' */
typedef enum {
    presentation_type__text=((int)0),
    sn__presentation_type__text=((int)0),
    presentation_type__image=((int)1),
    sn__presentation_type__image=((int)1),
    presentation_type__compound=((int)2),
    sn__presentation_type__compound=((int)2)
} t__sn__presentation_type;

#define d__sn__presentation_type 2498

typedef t__sn__presentation_type t__presentation_type;

#define d__presentation_type d__sn__presentation_type

/* line 110 "/vobs/specman/src/disp_defs.e"  From 'Enum type 'display_window'state'' */
typedef enum {
    display_window__state__unmapped=((int)0),
    sn__display_window__state__unmapped=((int)0),
    display_window__state__unreachable=((int)1),
    sn__display_window__state__unreachable=((int)1),
    display_window__state__invisible=((int)2),
    sn__display_window__state__invisible=((int)2),
    display_window__state__visible=((int)3),
    sn__display_window__state__visible=((int)3),
    display_window__state__visible_locked=((int)4),
    sn__display_window__state__visible_locked=((int)4)
} t__imp_enum_sn__display_window__state;

#define d__imp_enum_sn__display_window__state 2509

typedef t__imp_enum_sn__display_window__state t__imp_enum_display_window__state;

#define d__imp_enum_display_window__state d__imp_enum_sn__display_window__state

/* line 97 "/vobs/specman/src/disp_defs.e"  From 'Enum type 'main_window_kind'' */
typedef enum {
    main_window_kind__main=((int)0),
    sn__main_window_kind__main=((int)0),
    main_window_kind__list=((int)1),
    sn__main_window_kind__list=((int)1),
    main_window_kind__struct=((int)2),
    sn__main_window_kind__struct=((int)2),
    main_window_kind__file=((int)3),
    sn__main_window_kind__file=((int)3),
    main_window_kind__help=((int)4),
    sn__main_window_kind__help=((int)4),
    main_window_kind__config=((int)5),
    sn__main_window_kind__config=((int)5),
    main_window_kind__graphic=((int)6),
    sn__main_window_kind__graphic=((int)6),
    main_window_kind__cover=((int)7),
    sn__main_window_kind__cover=((int)7),
    main_window_kind__breakpoint=((int)8),
    sn__main_window_kind__breakpoint=((int)8),
    main_window_kind__src_browser=((int)9),
    sn__main_window_kind__src_browser=((int)9),
    main_window_kind__thread_list=((int)10),
    sn__main_window_kind__thread_list=((int)10),
    main_window_kind__single_thread=((int)11),
    sn__main_window_kind__single_thread=((int)11),
    main_window_kind__debug=((int)12),
    sn__main_window_kind__debug=((int)12),
    main_window_kind__event_chart=((int)13),
    sn__main_window_kind__event_chart=((int)13),
    main_window_kind__quick_load=((int)14),
    sn__main_window_kind__quick_load=((int)14),
    main_window_kind__scalar=((int)15),
    sn__main_window_kind__scalar=((int)15),
    main_window_kind__watch=((int)16),
    sn__main_window_kind__watch=((int)16),
    main_window_kind__gen_debug=((int)17),
    sn__main_window_kind__gen_debug=((int)17),
    main_window_kind__struct_expand=((int)18),
    sn__main_window_kind__struct_expand=((int)18),
    main_window_kind__list_structs=((int)19),
    sn__main_window_kind__list_structs=((int)19),
    main_window_kind__list_checks=((int)20),
    sn__main_window_kind__list_checks=((int)20),
    main_window_kind__list_event_defs=((int)21),
    sn__main_window_kind__list_event_defs=((int)21),
    main_window_kind__list_constraints=((int)22),
    sn__main_window_kind__list_constraints=((int)22)
} t__sn__main_window_kind;

#define d__sn__main_window_kind 2492

typedef t__sn__main_window_kind t__main_window_kind;

#define d__main_window_kind d__sn__main_window_kind

/* line 35 "/vobs/specman/src/disp_defs.e"  From 'Enum type 'widget_kind'' */
typedef enum {
    widget_kind__menu=((int)0),
    sn__widget_kind__menu=((int)0),
    widget_kind__toolbar=((int)1),
    sn__widget_kind__toolbar=((int)1),
    widget_kind__popup=((int)2),
    sn__widget_kind__popup=((int)2)
} t__sn__widget_kind;

#define d__sn__widget_kind 2485

typedef t__sn__widget_kind t__widget_kind;

#define d__widget_kind d__sn__widget_kind

/* line 501 "../src/root_basic.e"  From 'Enum type 'sn_compilation_mode'' */
typedef enum {
    sn_compilation_mode__default=((int)0),
    e_core__sn_compilation_mode__default=((int)0),
    sn_compilation_mode__opt=((int)1),
    e_core__sn_compilation_mode__opt=((int)1),
    sn_compilation_mode__debug=((int)2),
    e_core__sn_compilation_mode__debug=((int)2)
} t__e_core__sn_compilation_mode;

#define d__e_core__sn_compilation_mode 62

typedef t__e_core__sn_compilation_mode t__sn_compilation_mode;

#define d__sn_compilation_mode d__e_core__sn_compilation_mode

/* line 168 "/vobs/specman/src/eval_explicit.e"  From 'Enum type 'eval_exp_orig'' */
typedef enum {
    eval_exp_orig__EE_UNDEF=((int)0),
    eval_explicit__eval_exp_orig__EE_UNDEF=((int)0),
    eval_exp_orig__EE_TE=((int)1),
    eval_explicit__eval_exp_orig__EE_TE=((int)1),
    eval_exp_orig__EE_GEN=((int)2),
    eval_explicit__eval_exp_orig__EE_GEN=((int)2),
    eval_exp_orig__EE_COV=((int)3),
    eval_explicit__eval_exp_orig__EE_COV=((int)3)
} t__eval_explicit__eval_exp_orig;

#define d__eval_explicit__eval_exp_orig 1105

typedef t__eval_explicit__eval_exp_orig t__eval_exp_orig;

#define d__eval_exp_orig d__eval_explicit__eval_exp_orig

/* line 494 "../src/root_basic.e"  From 'Enum type 'sn_filter_level'' */
typedef enum {
    sn_filter_level__transparent=((int)0),
    e_core__sn_filter_level__transparent=((int)0),
    sn_filter_level__light=((int)1),
    e_core__sn_filter_level__light=((int)1),
    sn_filter_level__heavy=((int)2),
    e_core__sn_filter_level__heavy=((int)2)
} t__e_core__sn_filter_level;

#define d__e_core__sn_filter_level 61

typedef t__e_core__sn_filter_level t__sn_filter_level;

#define d__sn_filter_level d__e_core__sn_filter_level

/* line 6 "/vobs/specman/src/encrypt_table.e"  From 'Enum type 'encrypt_attribute'' */
typedef enum {
    encrypt_attribute__normal=((int)0),
    sn__encrypt_attribute__normal=((int)0),
    encrypt_attribute__monitor_ip=((int)1),
    sn__encrypt_attribute__monitor_ip=((int)1),
    encrypt_attribute__active_ip=((int)2),
    sn__encrypt_attribute__active_ip=((int)2),
    encrypt_attribute__enhanced_ip=((int)3),
    sn__encrypt_attribute__enhanced_ip=((int)3)
} t__sn__encrypt_attribute;

#define d__sn__encrypt_attribute 2404

typedef t__sn__encrypt_attribute t__encrypt_attribute;

#define d__encrypt_attribute d__sn__encrypt_attribute

/* line 442 "/vobs/specman/src/scriptsim.e"  From 'Enum type 'simulator_gui_mode'' */
typedef enum {
    simulator_gui_mode__unknown=((int)0),
    sn__simulator_gui_mode__unknown=((int)0),
    simulator_gui_mode__text=((int)1),
    sn__simulator_gui_mode__text=((int)1),
    simulator_gui_mode__gui=((int)2),
    sn__simulator_gui_mode__gui=((int)2)
} t__sn__simulator_gui_mode;

#define d__sn__simulator_gui_mode 1266

typedef t__sn__simulator_gui_mode t__simulator_gui_mode;

#define d__simulator_gui_mode d__sn__simulator_gui_mode

/* line 338 "/vobs/specman/src/time_units.e"  From 'Enum type 'xsim_compatibility_mode'' */
typedef enum {
    xsim_compatibility_mode__xsim_unspecified=((int)0),
    sn__xsim_compatibility_mode__xsim_unspecified=((int)0),
    xsim_compatibility_mode__xsim_mti_mode=((int)1),
    sn__xsim_compatibility_mode__xsim_mti_mode=((int)1),
    xsim_compatibility_mode__xsim_nc_mode=((int)2),
    sn__xsim_compatibility_mode__xsim_nc_mode=((int)2)
} t__sn__xsim_compatibility_mode;

#define d__sn__xsim_compatibility_mode 2415

typedef t__sn__xsim_compatibility_mode t__xsim_compatibility_mode;

#define d__xsim_compatibility_mode d__sn__xsim_compatibility_mode

/* line 87 "/vobs/specman/src/ml_ovm_adapter.e"  From 'Enum type 'msg_kind_t'' */
typedef enum {
    msg_kind_t__ERROR=((int)0),
    ml_ovm__msg_kind_t__ERROR=((int)0),
    msg_kind_t__DEBUG=((int)1),
    ml_ovm__msg_kind_t__DEBUG=((int)1),
    msg_kind_t__UNSET=((int)1000),
    ml_ovm__msg_kind_t__UNSET=((int)1000)
} t__ml_ovm__msg_kind_t;

#define d__ml_ovm__msg_kind_t 9113

typedef t__ml_ovm__msg_kind_t t__msg_kind_t;

#define d__msg_kind_t d__ml_ovm__msg_kind_t

/* line 19 "/vobs/specman/src/adapter_manager.e"  From 'Enum type 'stub_destination_t'' */
typedef enum {
    stub_destination_t__DEFAULT=((int)0),
    sn__stub_destination_t__DEFAULT=((int)0),
    stub_destination_t__OIG=((int)1),
    sn__stub_destination_t__OIG=((int)1)
} t__sn__stub_destination_t;

#define d__sn__stub_destination_t 2291

typedef t__sn__stub_destination_t t__stub_destination_t;

#define d__stub_destination_t d__sn__stub_destination_t

/* line 72 "/vobs/specman/src/port_trace.e"  From 'Enum type 'sn_port_trace_kind'' */
typedef enum {
    sn_port_trace_kind__sn_msg=((int)0),
    sn__sn_port_trace_kind__sn_msg=((int)0),
    sn_port_trace_kind__sn_trans=((int)1),
    sn__sn_port_trace_kind__sn_trans=((int)1)
} t__sn__sn_port_trace_kind;

#define d__sn__sn_port_trace_kind 6713

typedef t__sn__sn_port_trace_kind t__sn_port_trace_kind;

#define d__sn_port_trace_kind d__sn__sn_port_trace_kind

/* line 17 "/vobs/specman/src/script.e"  From 'Enum type 'match_status'' */
typedef enum {
    match_status__NONE=((int)0),
    sn__match_status__NONE=((int)0),
    match_status__BEFORE=((int)1),
    sn__match_status__BEFORE=((int)1),
    match_status__FAILED=((int)2),
    sn__match_status__FAILED=((int)2),
    match_status__SUCCEEDED=((int)3),
    sn__match_status__SUCCEEDED=((int)3),
    match_status__ALREADY_SUCCEEDED=((int)4),
    sn__match_status__ALREADY_SUCCEEDED=((int)4),
    match_status__WAITING=((int)5),
    sn__match_status__WAITING=((int)5),
    match_status__WAITING_FOR_CHILD=((int)6),
    sn__match_status__WAITING_FOR_CHILD=((int)6),
    match_status__TERMINATED=((int)7),
    sn__match_status__TERMINATED=((int)7),
    match_status__BREAK=((int)8),
    sn__match_status__BREAK=((int)8),
    match_status__CONTINUE=((int)9),
    sn__match_status__CONTINUE=((int)9),
    match_status__RETURN=((int)10),
    sn__match_status__RETURN=((int)10)
} t__sn__match_status;

#define d__sn__match_status 1499

typedef t__sn__match_status t__match_status;

#define d__match_status d__sn__match_status

/* line 119 "/vobs/specman/src/fl_struct.e"  From 'Enum type 'sn_fl_v_top_node'is_sticky_true_cash'' */
typedef enum {
    sn_fl_v_top_node__is_sticky_true_cash__UNSET=((int)0),
    sn_fl__sn_fl_v_top_node__is_sticky_true_cash__UNSET=((int)0),
    sn_fl_v_top_node__is_sticky_true_cash__YES=((int)1),
    sn_fl__sn_fl_v_top_node__is_sticky_true_cash__YES=((int)1),
    sn_fl_v_top_node__is_sticky_true_cash__NO=((int)2),
    sn_fl__sn_fl_v_top_node__is_sticky_true_cash__NO=((int)2)
} t__imp_enum_sn_fl__sn_fl_v_top_node__is_sticky_true_cash;

#define d__imp_enum_sn_fl__sn_fl_v_top_node__is_sticky_true_cash 2964

typedef t__imp_enum_sn_fl__sn_fl_v_top_node__is_sticky_true_cash t__imp_enum_sn_fl_v_top_node__is_sticky_true_cash;

#define d__imp_enum_sn_fl_v_top_node__is_sticky_true_cash d__imp_enum_sn_fl__sn_fl_v_top_node__is_sticky_true_cash

/* line 121 "/vobs/specman/src/fl_struct.e"  From 'Enum type 'sn_fl_v_top_node'is_neg_over_sense_cash'' */
typedef enum {
    sn_fl_v_top_node__is_neg_over_sense_cash__UNSET=((int)0),
    sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash__UNSET=((int)0),
    sn_fl_v_top_node__is_neg_over_sense_cash__YES=((int)1),
    sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash__YES=((int)1),
    sn_fl_v_top_node__is_neg_over_sense_cash__NO=((int)2),
    sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash__NO=((int)2)
} t__imp_enum_sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash;

#define d__imp_enum_sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash 2965

typedef t__imp_enum_sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash t__imp_enum_sn_fl_v_top_node__is_neg_over_sense_cash;

#define d__imp_enum_sn_fl_v_top_node__is_neg_over_sense_cash d__imp_enum_sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash

/* line 373 "/vobs/specman/src/fl_sm.e"  From 'Enum type 'sn_fl_state_status'' */
typedef enum {
    sn_fl_state_status__UNVISIT=((int)0),
    sn_fl__sn_fl_state_status__UNVISIT=((int)0),
    sn_fl_state_status__UNKNOWN=((int)1),
    sn_fl__sn_fl_state_status__UNKNOWN=((int)1),
    sn_fl_state_status__st_YES=((int)2),
    sn_fl__sn_fl_state_status__st_YES=((int)2),
    sn_fl_state_status__st_NO=((int)3),
    sn_fl__sn_fl_state_status__st_NO=((int)3)
} t__sn_fl__sn_fl_state_status;

#define d__sn_fl__sn_fl_state_status 2993

typedef t__sn_fl__sn_fl_state_status t__sn_fl_state_status;

#define d__sn_fl_state_status d__sn_fl__sn_fl_state_status

/* line 23 "/vobs/specman/src/fl_struct.e"  From 'Enum type 'sn_fl_true_occ_kind'' */
typedef enum {
    sn_fl_true_occ_kind__UNDEFINED=((int)0),
    sn_fl__sn_fl_true_occ_kind__UNDEFINED=((int)0),
    sn_fl_true_occ_kind__UNIQUE=((int)1),
    sn_fl__sn_fl_true_occ_kind__UNIQUE=((int)1),
    sn_fl_true_occ_kind__ONE_STATE=((int)2),
    sn_fl__sn_fl_true_occ_kind__ONE_STATE=((int)2),
    sn_fl_true_occ_kind__MANY_STATES=((int)3),
    sn_fl__sn_fl_true_occ_kind__MANY_STATES=((int)3)
} t__sn_fl__sn_fl_true_occ_kind;

#define d__sn_fl__sn_fl_true_occ_kind 2879

typedef t__sn_fl__sn_fl_true_occ_kind t__sn_fl_true_occ_kind;

#define d__sn_fl_true_occ_kind d__sn_fl__sn_fl_true_occ_kind

/* line 740 "/vobs/specman/src/te_structs.e"  From 'Enum type 'sn_sched_phase'' */
typedef enum {
    sn_sched_phase__none=((int)0),
    sn__sn_sched_phase__none=((int)0),
    sn_sched_phase__eval_te=((int)1),
    sn__sn_sched_phase__eval_te=((int)1),
    sn_sched_phase__eval_tcm=((int)2),
    sn__sn_sched_phase__eval_tcm=((int)2),
    sn_sched_phase__end_of_tick=((int)3),
    sn__sn_sched_phase__end_of_tick=((int)3)
} t__sn__sn_sched_phase;

#define d__sn__sn_sched_phase 2810

typedef t__sn__sn_sched_phase t__sn_sched_phase;

#define d__sn_sched_phase d__sn__sn_sched_phase

/* line 42 "/vobs/specman/src/warn_defs.e"  From 'Enum type 'sn_warning_type'' */
typedef enum {
    sn_warning_type__WARN_EANALYZER_ERM_COMMAND=((int)0),
    sn__sn_warning_type__WARN_EANALYZER_ERM_COMMAND=((int)0),
    sn_warning_type__WARN_EANALYZER_DCF_COMMAND=((int)1),
    sn__sn_warning_type__WARN_EANALYZER_DCF_COMMAND=((int)1),
    sn_warning_type__WARN_EANALYZER_ERM_NAME=((int)2),
    sn__sn_warning_type__WARN_EANALYZER_ERM_NAME=((int)2),
    sn_warning_type__DEPR_BACK32_CONFIG_FLAGS=((int)3),
    sn__sn_warning_type__DEPR_BACK32_CONFIG_FLAGS=((int)3),
    sn_warning_type__DEPR_BACK33_CONFIG_FLAGS=((int)4),
    sn__sn_warning_type__DEPR_BACK33_CONFIG_FLAGS=((int)4),
    sn_warning_type__DEPR_START_TCM=((int)5),
    sn__sn_warning_type__DEPR_START_TCM=((int)5),
    sn_warning_type__DEPR_RESIZE_MVL_LIST=((int)6),
    sn__sn_warning_type__DEPR_RESIZE_MVL_LIST=((int)6),
    sn_warning_type__DEPR_PERMUTATION_EXP=((int)7),
    sn__sn_warning_type__DEPR_PERMUTATION_EXP=((int)7),
    sn_warning_type__DEPR_MESSAGE_LOGGER_IS_UNIT=((int)8),
    sn__sn_warning_type__DEPR_MESSAGE_LOGGER_IS_UNIT=((int)8),
    sn_warning_type__DEPR_MULTI_KEEP=((int)9),
    sn__sn_warning_type__DEPR_MULTI_KEEP=((int)9),
    sn_warning_type__DEPR_SOFT_DIRECTIVE=((int)10),
    sn__sn_warning_type__DEPR_SOFT_DIRECTIVE=((int)10),
    sn_warning_type__DEPR_DIRECTIVE_IN_CONSTRAINT=((int)11),
    sn__sn_warning_type__DEPR_DIRECTIVE_IN_CONSTRAINT=((int)11),
    sn_warning_type__DEPR_DIRECTIVE_ONLY_AS_CONSTRAINT=((int)12),
    sn__sn_warning_type__DEPR_DIRECTIVE_ONLY_AS_CONSTRAINT=((int)12),
    sn_warning_type__DEPR_FORBIDDEN_ACTION_IN_SEQ_BLOCK=((int)13),
    sn__sn_warning_type__DEPR_FORBIDDEN_ACTION_IN_SEQ_BLOCK=((int)13),
    sn_warning_type__DEPR_METHOD_EXTENSION=((int)14),
    sn__sn_warning_type__DEPR_METHOD_EXTENSION=((int)14),
    sn_warning_type__DEPR_METHOD_OVERRIDE=((int)15),
    sn__sn_warning_type__DEPR_METHOD_OVERRIDE=((int)15),
    sn_warning_type__DEPR_CVL_FIELD_KEYWORD=((int)16),
    sn__sn_warning_type__DEPR_CVL_FIELD_KEYWORD=((int)16),
    sn_warning_type__DEPR_AHB_BURST_DELAY_KEYWORD=((int)17),
    sn__sn_warning_type__DEPR_AHB_BURST_DELAY_KEYWORD=((int)17),
    sn_warning_type__DEPR_AHB_TRANSFER_DELAY_KEYWORD=((int)18),
    sn__sn_warning_type__DEPR_AHB_TRANSFER_DELAY_KEYWORD=((int)18),
    sn_warning_type__DEPR_AHB_TRANSFER_START_KEYWORD=((int)19),
    sn__sn_warning_type__DEPR_AHB_TRANSFER_START_KEYWORD=((int)19),
    sn_warning_type__DEPR_AHB_BURST_START_KEYWORD=((int)20),
    sn__sn_warning_type__DEPR_AHB_BURST_START_KEYWORD=((int)20),
    sn_warning_type__DEPR_AHB_TRANSACTION_START_KEYWORD=((int)21),
    sn__sn_warning_type__DEPR_AHB_TRANSACTION_START_KEYWORD=((int)21),
    sn_warning_type__DEPR_SN_PRE_T=((int)22),
    sn__sn_warning_type__DEPR_SN_PRE_T=((int)22),
    sn_warning_type__DEPR_DUT_ERR_FIELD_MESSAGE_KEYWORD=((int)23),
    sn__sn_warning_type__DEPR_DUT_ERR_FIELD_MESSAGE_KEYWORD=((int)23),
    sn_warning_type__DEPR_LOCKER_RELEASE_TCM_KEYWORD=((int)24),
    sn__sn_warning_type__DEPR_LOCKER_RELEASE_TCM_KEYWORD=((int)24),
    sn_warning_type__DEPR_SESSION_DUT_ERR_EVENT_KEYWORD=((int)25),
    sn__sn_warning_type__DEPR_SESSION_DUT_ERR_EVENT_KEYWORD=((int)25),
    sn_warning_type__DEPR_KEEP_BLOCK=((int)26),
    sn__sn_warning_type__DEPR_KEEP_BLOCK=((int)26),
    sn_warning_type__DEPR_RESERVED_KEYWORD=((int)27),
    sn__sn_warning_type__DEPR_RESERVED_KEYWORD=((int)27),
    sn_warning_type__DEPR_WAVE_REGISTER_STRUCTS=((int)28),
    sn__sn_warning_type__DEPR_WAVE_REGISTER_STRUCTS=((int)28),
    sn_warning_type__DEPR_TYPE_SEMAPHORE=((int)29),
    sn__sn_warning_type__DEPR_TYPE_SEMAPHORE=((int)29),
    sn_warning_type__DEPR_TYPE_ANY_SEQ=((int)30),
    sn__sn_warning_type__DEPR_TYPE_ANY_SEQ=((int)30),
    sn_warning_type__DEPR_TYPE_MESSAGE=((int)31),
    sn__sn_warning_type__DEPR_TYPE_MESSAGE=((int)31),
    sn_warning_type__DEPR_TYPE_TIME_UNITS=((int)32),
    sn__sn_warning_type__DEPR_TYPE_TIME_UNITS=((int)32),
    sn_warning_type__DEPR_TYPE_MVL=((int)33),
    sn__sn_warning_type__DEPR_TYPE_MVL=((int)33),
    sn_warning_type__DEPR_TYPE_PORTS=((int)34),
    sn__sn_warning_type__DEPR_TYPE_PORTS=((int)34),
    sn_warning_type__DEPR_TYPE_PACK_LEVEL=((int)35),
    sn__sn_warning_type__DEPR_TYPE_PACK_LEVEL=((int)35),
    sn_warning_type__DEPR_TYPE_NOTIFY=((int)36),
    sn__sn_warning_type__DEPR_TYPE_NOTIFY=((int)36),
    sn_warning_type__DEPR_KEEP_SOFT_BIND=((int)37),
    sn__sn_warning_type__DEPR_KEEP_SOFT_BIND=((int)37),
    sn_warning_type__DEPR_CALL_IN_MP_WITHOUT_THIS=((int)38),
    sn__sn_warning_type__DEPR_CALL_IN_MP_WITHOUT_THIS=((int)38),
    sn_warning_type__DEPR_METHOD_BIND=((int)39),
    sn__sn_warning_type__DEPR_METHOD_BIND=((int)39),
    sn_warning_type__DEPR_METHOD_MESSAGE=((int)40),
    sn__sn_warning_type__DEPR_METHOD_MESSAGE=((int)40),
    sn_warning_type__DEPR_METHOD_IN_SEQ=((int)41),
    sn__sn_warning_type__DEPR_METHOD_IN_SEQ=((int)41),
    sn_warning_type__DEPR_METHOD_IN_UNIT=((int)42),
    sn__sn_warning_type__DEPR_METHOD_IN_UNIT=((int)42),
    sn_warning_type__DEPR_METHOD_TIMESCALE=((int)43),
    sn__sn_warning_type__DEPR_METHOD_TIMESCALE=((int)43),
    sn_warning_type__DEPR_METHOD_SYNTHESIZED=((int)44),
    sn__sn_warning_type__DEPR_METHOD_SYNTHESIZED=((int)44),
    sn_warning_type__DEPR_METHOD_AGENT=((int)45),
    sn__sn_warning_type__DEPR_METHOD_AGENT=((int)45),
    sn_warning_type__DEPR_METHOD_SHORT=((int)46),
    sn__sn_warning_type__DEPR_METHOD_SHORT=((int)46),
    sn_warning_type__DEPR_TCM_CLOCK=((int)47),
    sn__sn_warning_type__DEPR_TCM_CLOCK=((int)47),
    sn_warning_type__DEPR_SYS_HDL_PATH=((int)48),
    sn__sn_warning_type__DEPR_SYS_HDL_PATH=((int)48),
    sn_warning_type__DEPR_UNIT_INSTANCE=((int)49),
    sn__sn_warning_type__DEPR_UNIT_INSTANCE=((int)49),
    sn_warning_type__DEPR_UNIT_GEN_INSTANCE=((int)50),
    sn__sn_warning_type__DEPR_UNIT_GEN_INSTANCE=((int)50),
    sn_warning_type__DEPR_CONFIG_SHORT_IS_SIGNED=((int)51),
    sn__sn_warning_type__DEPR_CONFIG_SHORT_IS_SIGNED=((int)51),
    sn_warning_type__DEPR_CONFIG_NO_GEN_IN_WRITE_STUB=((int)52),
    sn__sn_warning_type__DEPR_CONFIG_NO_GEN_IN_WRITE_STUB=((int)52),
    sn_warning_type__DEPR_TYPE_LONG=((int)53),
    sn__sn_warning_type__DEPR_TYPE_LONG=((int)53),
    sn_warning_type__WARN_VHDL_TIME_MODELSIM_IGNORED=((int)54),
    sn__sn_warning_type__WARN_VHDL_TIME_MODELSIM_IGNORED=((int)54),
    sn_warning_type__WARN_HDL_TIME_UNITS_OVERRIDE=((int)55),
    sn__sn_warning_type__WARN_HDL_TIME_UNITS_OVERRIDE=((int)55),
    sn_warning_type__WARN_VHDL_TIME_UNITS_OVERRIDE=((int)56),
    sn__sn_warning_type__WARN_VHDL_TIME_UNITS_OVERRIDE=((int)56),
    sn_warning_type__WARN_TIME_UNITS_TRUNCATED=((int)57),
    sn__sn_warning_type__WARN_TIME_UNITS_TRUNCATED=((int)57),
    sn_warning_type__WARN_SYS_AGENT_IMPOSED=((int)58),
    sn__sn_warning_type__WARN_SYS_AGENT_IMPOSED=((int)58),
    sn_warning_type__WARN_SYS_AGENT_IMPOSED_IRUN=((int)59),
    sn__sn_warning_type__WARN_SYS_AGENT_IMPOSED_IRUN=((int)59),
    sn_warning_type__WARN_COMPUTD_LOSE_OF_INFO=((int)60),
    sn__sn_warning_type__WARN_COMPUTD_LOSE_OF_INFO=((int)60),
    sn_warning_type__WARN_METHOD_DEFINED=((int)61),
    sn__sn_warning_type__WARN_METHOD_DEFINED=((int)61),
    sn_warning_type__WARN_UNPACK_SIZE=((int)62),
    sn__sn_warning_type__WARN_UNPACK_SIZE=((int)62),
    sn_warning_type__WARN_VERSION_CHECK_SIM=((int)63),
    sn__sn_warning_type__WARN_VERSION_CHECK_SIM=((int)63),
    sn_warning_type__WARN_VERSION_CHECK_IUS=((int)64),
    sn__sn_warning_type__WARN_VERSION_CHECK_IUS=((int)64),
    sn_warning_type__DEPR_SN_VERILOG_TIME_SCALE_INCOMPAT=((int)65),
    sn__sn_warning_type__DEPR_SN_VERILOG_TIME_SCALE_INCOMPAT=((int)65),
    sn_warning_type__DEPR_VHDL_TIME_PRECISION_IGNORED=((int)66),
    sn__sn_warning_type__DEPR_VHDL_TIME_PRECISION_IGNORED=((int)66),
    sn_warning_type__DEPR_SN_VERILOG_TIME_SCALE_IC_IRUN=((int)67),
    sn__sn_warning_type__DEPR_SN_VERILOG_TIME_SCALE_IC_IRUN=((int)67),
    sn_warning_type__DEPR_AT_X_NCVHDL=((int)68),
    sn__sn_warning_type__DEPR_AT_X_NCVHDL=((int)68),
    sn_warning_type__WARN_DRIVER_NOT_SUPPORTED_NCVHDL=((int)69),
    sn__sn_warning_type__WARN_DRIVER_NOT_SUPPORTED_NCVHDL=((int)69),
    sn_warning_type__DEPR_NBASYNC=((int)70),
    sn__sn_warning_type__DEPR_NBASYNC=((int)70),
    sn_warning_type__DEPR_NBASYNC_OLD_VER=((int)71),
    sn__sn_warning_type__DEPR_NBASYNC_OLD_VER=((int)71),
    sn_warning_type__DEPR_INCORRECT_NEW_TIME=((int)72),
    sn__sn_warning_type__DEPR_INCORRECT_NEW_TIME=((int)72),
    sn_warning_type__DEPR_NO_DECLARED_RANGE=((int)73),
    sn__sn_warning_type__DEPR_NO_DECLARED_RANGE=((int)73),
    sn_warning_type__DEPR_BIT_EXTRACT_BOUNDS=((int)74),
    sn__sn_warning_type__DEPR_BIT_EXTRACT_BOUNDS=((int)74),
    sn_warning_type__WARN_DUPLICATE_CASE_ITEMS=((int)75),
    sn__sn_warning_type__WARN_DUPLICATE_CASE_ITEMS=((int)75),
    sn_warning_type__WARN_PACKAGE_NOT_LOADED=((int)76),
    sn__sn_warning_type__WARN_PACKAGE_NOT_LOADED=((int)76),
    sn_warning_type__WARN_PACKAGE_VER_INCOMP=((int)77),
    sn__sn_warning_type__WARN_PACKAGE_VER_INCOMP=((int)77),
    sn_warning_type__WARN_PACKAGE_VER_POSSIBLE_INCOMP=((int)78),
    sn__sn_warning_type__WARN_PACKAGE_VER_POSSIBLE_INCOMP=((int)78),
    sn_warning_type__WARN_SPECMAN_VER_INCOMP=((int)79),
    sn__sn_warning_type__WARN_SPECMAN_VER_INCOMP=((int)79),
    sn_warning_type__WARN_SPECMAN_VER_POSSIBLE_INCOMP=((int)80),
    sn__sn_warning_type__WARN_SPECMAN_VER_POSSIBLE_INCOMP=((int)80),
    sn_warning_type__WARN_SPECMAN_VER_INCOMP_WITH_ERM=((int)81),
    sn__sn_warning_type__WARN_SPECMAN_VER_INCOMP_WITH_ERM=((int)81),
    sn_warning_type__WARN_DISK_BASED_GC_PROBLEM=((int)82),
    sn__sn_warning_type__WARN_DISK_BASED_GC_PROBLEM=((int)82),
    sn_warning_type__DEPR_TEMPO_BACK33_ADD_EVAL=((int)83),
    sn__sn_warning_type__DEPR_TEMPO_BACK33_ADD_EVAL=((int)83),
    sn_warning_type__DEPR_TEMPO_BACK33_NO_REORDER=((int)84),
    sn__sn_warning_type__DEPR_TEMPO_BACK33_NO_REORDER=((int)84),
    sn_warning_type__DEPR_BACK33_METHOD_EXTENSION=((int)85),
    sn__sn_warning_type__DEPR_BACK33_METHOD_EXTENSION=((int)85),
    sn_warning_type__DEPR_BACK33_WHEN_STRUCT_MEMBER=((int)86),
    sn__sn_warning_type__DEPR_BACK33_WHEN_STRUCT_MEMBER=((int)86),
    sn_warning_type__DEPR_UNDEF_ATTR_KEEP=((int)87),
    sn__sn_warning_type__DEPR_UNDEF_ATTR_KEEP=((int)87),
    sn_warning_type__DEPR_UNDEF_ATTR_ACCESS=((int)88),
    sn__sn_warning_type__DEPR_UNDEF_ATTR_ACCESS=((int)88),
    sn_warning_type__DEPR_UNIT_ONLY_ATTR_ACCESS=((int)89),
    sn__sn_warning_type__DEPR_UNIT_ONLY_ATTR_ACCESS=((int)89),
    sn_warning_type__DEPR_PORTS_UNIFICATION_DISABLED=((int)90),
    sn__sn_warning_type__DEPR_PORTS_UNIFICATION_DISABLED=((int)90),
    sn_warning_type__NOTIFY_HDL_PATH_FOR_INTERFACE_PORT=((int)91),
    sn__sn_warning_type__NOTIFY_HDL_PATH_FOR_INTERFACE_PORT=((int)91),
    sn_warning_type__ERR_NO_CBS_PORT_KIND=((int)92),
    sn__sn_warning_type__ERR_NO_CBS_PORT_KIND=((int)92),
    sn_warning_type__ERR_UNDEF_CB_EVENT_PORT=((int)93),
    sn__sn_warning_type__ERR_UNDEF_CB_EVENT_PORT=((int)93),
    sn_warning_type__ERR_UNMATCHED_PORT_DIR=((int)94),
    sn__sn_warning_type__ERR_UNMATCHED_PORT_DIR=((int)94),
    sn_warning_type__ERR_NO_E2E_CBS=((int)95),
    sn__sn_warning_type__ERR_NO_E2E_CBS=((int)95),
    sn_warning_type__ERR_NO_EXTERNAL_CBS=((int)96),
    sn__sn_warning_type__ERR_NO_EXTERNAL_CBS=((int)96),
    sn_warning_type__DEPR_VERILOG_WIRE_UNDEFINED=((int)97),
    sn__sn_warning_type__DEPR_VERILOG_WIRE_UNDEFINED=((int)97),
    sn_warning_type__DEPR_NC_PROPAGATE_EVENT=((int)98),
    sn__sn_warning_type__DEPR_NC_PROPAGATE_EVENT=((int)98),
    sn_warning_type__DEPR_VCS_PLI=((int)99),
    sn__sn_warning_type__DEPR_VCS_PLI=((int)99),
    sn_warning_type__DEPR_DISABLE_COVER_EVENTS=((int)100),
    sn__sn_warning_type__DEPR_DISABLE_COVER_EVENTS=((int)100),
    sn_warning_type__DEPR_COVER_USE_SAI=((int)101),
    sn__sn_warning_type__DEPR_COVER_USE_SAI=((int)101),
    sn_warning_type__DEPR_COVER_MODES=((int)102),
    sn__sn_warning_type__DEPR_COVER_MODES=((int)102),
    sn_warning_type__DEPR_BACK33_COVER_MODE=((int)103),
    sn__sn_warning_type__DEPR_BACK33_COVER_MODE=((int)103),
    sn_warning_type__DEPR_COVER_ON_INTERACTIVE_MODE=((int)104),
    sn__sn_warning_type__DEPR_COVER_ON_INTERACTIVE_MODE=((int)104),
    sn_warning_type__NOTIFY_IMPLICT_BIND_TO_EXTERNAL=((int)105),
    sn__sn_warning_type__NOTIFY_IMPLICT_BIND_TO_EXTERNAL=((int)105),
    sn_warning_type__DEPR_PACKAGE_TYPE_IN_FIELD=((int)106),
    sn__sn_warning_type__DEPR_PACKAGE_TYPE_IN_FIELD=((int)106),
    sn_warning_type__DEPR_PACKAGE_TYPE_IN_METHOD=((int)107),
    sn__sn_warning_type__DEPR_PACKAGE_TYPE_IN_METHOD=((int)107),
    sn_warning_type__DEPR_MATH_ZERO=((int)108),
    sn__sn_warning_type__DEPR_MATH_ZERO=((int)108),
    sn_warning_type__DEPR_MATH_ZERO_NEG=((int)109),
    sn__sn_warning_type__DEPR_MATH_ZERO_NEG=((int)109),
    sn_warning_type__DEPR_SYSC_MASTER_CYCLE_MODE=((int)110),
    sn__sn_warning_type__DEPR_SYSC_MASTER_CYCLE_MODE=((int)110),
    sn_warning_type__DEPR_SYSC_XSYSTEMC=((int)111),
    sn__sn_warning_type__DEPR_SYSC_XSYSTEMC=((int)111),
    sn_warning_type__NOTIFY_RUN_ORDER_DIFFERENT=((int)112),
    sn__sn_warning_type__NOTIFY_RUN_ORDER_DIFFERENT=((int)112),
    sn_warning_type__DEPR_MACRO_ORDER=((int)113),
    sn__sn_warning_type__DEPR_MACRO_ORDER=((int)113),
    sn_warning_type__DEPR_MACRO_MULTI_REPLACEMENT_ITEMS=((int)114),
    sn__sn_warning_type__DEPR_MACRO_MULTI_REPLACEMENT_ITEMS=((int)114),
    sn_warning_type__DEPR_MACRO_EMPTY_REPLACEMENT=((int)115),
    sn__sn_warning_type__DEPR_MACRO_EMPTY_REPLACEMENT=((int)115),
    sn_warning_type__WARN_EXTEND_AFTER_TEMPLATE=((int)116),
    sn__sn_warning_type__WARN_EXTEND_AFTER_TEMPLATE=((int)116),
    sn_warning_type__DEPR_E_CORE_TYPE=((int)117),
    sn__sn_warning_type__DEPR_E_CORE_TYPE=((int)117),
    sn_warning_type__WARN_WHEN_AMBIGUITY=((int)118),
    sn__sn_warning_type__WARN_WHEN_AMBIGUITY=((int)118),
    sn_warning_type__ERR_ME_BLANKS=((int)119),
    sn__sn_warning_type__ERR_ME_BLANKS=((int)119),
    sn_warning_type__ERR_ME_EMPTY=((int)120),
    sn__sn_warning_type__ERR_ME_EMPTY=((int)120),
    sn_warning_type__ERR_ME_ILLEGAL_WS_CHAR=((int)121),
    sn__sn_warning_type__ERR_ME_ILLEGAL_WS_CHAR=((int)121),
    sn_warning_type__DEPR_PARAM_USE_BEFORE_DEF=((int)122),
    sn__sn_warning_type__DEPR_PARAM_USE_BEFORE_DEF=((int)122),
    sn_warning_type__DEPR_RESULT_DEFINE_WITHOUT_RETURN=((int)123),
    sn__sn_warning_type__DEPR_RESULT_DEFINE_WITHOUT_RETURN=((int)123),
    sn_warning_type__WARN_NUMERIC_TYPE_CAST=((int)124),
    sn__sn_warning_type__WARN_NUMERIC_TYPE_CAST=((int)124),
    sn_warning_type__WARN_POINTER_SORTING=((int)125),
    sn__sn_warning_type__WARN_POINTER_SORTING=((int)125),
    sn_warning_type__WARN_ML_OVM_MODE_TEST=((int)126),
    sn__sn_warning_type__WARN_ML_OVM_MODE_TEST=((int)126),
    sn_warning_type__ERR_OLD_ACCESS_CONTROL=((int)127),
    sn__sn_warning_type__ERR_OLD_ACCESS_CONTROL=((int)127),
    sn_warning_type__DEPR_PRIVATE_LIST_KEY=((int)128),
    sn__sn_warning_type__DEPR_PRIVATE_LIST_KEY=((int)128),
    sn_warning_type__DEPR_PROTECTED_LIST_KEY=((int)129),
    sn__sn_warning_type__DEPR_PROTECTED_LIST_KEY=((int)129),
    sn_warning_type__DEPR_LIST_KEY_ACCESS=((int)130),
    sn__sn_warning_type__DEPR_LIST_KEY_ACCESS=((int)130),
    sn_warning_type__ERR_GEN_NO_GEN_TYPE=((int)131),
    sn__sn_warning_type__ERR_GEN_NO_GEN_TYPE=((int)131),
    sn_warning_type__DEPR_SOFT_SUB_CONSTRAINT=((int)132),
    sn__sn_warning_type__DEPR_SOFT_SUB_CONSTRAINT=((int)132),
    sn_warning_type__DEPR_CONSTRAINT_CONTEXT=((int)133),
    sn__sn_warning_type__DEPR_CONSTRAINT_CONTEXT=((int)133),
    sn_warning_type__DEPR_GEN_ACTION_CONTEXT=((int)134),
    sn__sn_warning_type__DEPR_GEN_ACTION_CONTEXT=((int)134),
    sn_warning_type__DEPR_SELECT_SYNTAX=((int)135),
    sn__sn_warning_type__DEPR_SELECT_SYNTAX=((int)135),
    sn_warning_type__DEPR_CONFIG_COLLECT_ALL=((int)136),
    sn__sn_warning_type__DEPR_CONFIG_COLLECT_ALL=((int)136),
    sn_warning_type__WARN_LIST_BIDIR_LOAD_ONLY=((int)137),
    sn__sn_warning_type__WARN_LIST_BIDIR_LOAD_ONLY=((int)137),
    sn_warning_type__WARN_LIST_BIDIR_CHANGE_AFTER_EXIST=((int)138),
    sn__sn_warning_type__WARN_LIST_BIDIR_CHANGE_AFTER_EXIST=((int)138),
    sn_warning_type__ERR_GEN_NO_GEN_ITEM=((int)139),
    sn__sn_warning_type__ERR_GEN_NO_GEN_ITEM=((int)139),
    sn_warning_type__WARN_GEN_GOTF_NO_GEN_ITEM=((int)140),
    sn__sn_warning_type__WARN_GEN_GOTF_NO_GEN_ITEM=((int)140),
    sn_warning_type__ERR_GEN_STATIC_ALL_ALTS=((int)141),
    sn__sn_warning_type__ERR_GEN_STATIC_ALL_ALTS=((int)141),
    sn_warning_type__ERR_GEN_CANNOT_GENERATE_TYPE=((int)142),
    sn__sn_warning_type__ERR_GEN_CANNOT_GENERATE_TYPE=((int)142),
    sn_warning_type__ERR_GEN_STATIC_CONTRADICTION=((int)143),
    sn__sn_warning_type__ERR_GEN_STATIC_CONTRADICTION=((int)143),
    sn_warning_type__WARN_GEN_STATIC_GOTF_CONTRADICTION=((int)144),
    sn__sn_warning_type__WARN_GEN_STATIC_GOTF_CONTRADICTION=((int)144),
    sn_warning_type__WARN_GEN_OR_GOTF_WITH_NO_GEN_ALT=((int)145),
    sn__sn_warning_type__WARN_GEN_OR_GOTF_WITH_NO_GEN_ALT=((int)145),
    sn_warning_type__ERR_GEN_OR_WITH_NO_GEN_ALT=((int)146),
    sn__sn_warning_type__ERR_GEN_OR_WITH_NO_GEN_ALT=((int)146),
    sn_warning_type__ERR_GEN_MGR_CONTRADICTION=((int)147),
    sn__sn_warning_type__ERR_GEN_MGR_CONTRADICTION=((int)147),
    sn_warning_type__WARN_GEN_MGR_GOTF_CONTRADICTION=((int)148),
    sn__sn_warning_type__WARN_GEN_MGR_GOTF_CONTRADICTION=((int)148),
    sn_warning_type__WARN_FILE_MODIFIED=((int)149),
    sn__sn_warning_type__WARN_FILE_MODIFIED=((int)149),
    sn_warning_type__DEPR_TEMPORAL_PRECEDENCE=((int)150),
    sn__sn_warning_type__DEPR_TEMPORAL_PRECEDENCE=((int)150),
    sn_warning_type__DEPR_FM_REPEAT_SAMPLING=((int)151),
    sn__sn_warning_type__DEPR_FM_REPEAT_SAMPLING=((int)151),
    sn_warning_type__WARN_COV_SAME_ECOV_READ=((int)152),
    sn__sn_warning_type__WARN_COV_SAME_ECOV_READ=((int)152),
    sn_warning_type__WARN_COL_CHECKS_DISABLED=((int)153),
    sn__sn_warning_type__WARN_COL_CHECKS_DISABLED=((int)153),
    sn_warning_type__WARN_PER_INST_TRACE_ONLY=((int)154),
    sn__sn_warning_type__WARN_PER_INST_TRACE_ONLY=((int)154),
    sn_warning_type__WARN_EMPTY_RANGE=((int)155),
    sn__sn_warning_type__WARN_EMPTY_RANGE=((int)155),
    sn_warning_type__WARN_NON_CONSISTENT_ECOV=((int)156),
    sn__sn_warning_type__WARN_NON_CONSISTENT_ECOV=((int)156),
    sn_warning_type__WARN_CPI_BUCKET_WITH_SPACES=((int)157),
    sn__sn_warning_type__WARN_CPI_BUCKET_WITH_SPACES=((int)157),
    sn_warning_type__WARN_ECOV_VER_DOESNT_MATCH=((int)158),
    sn__sn_warning_type__WARN_ECOV_VER_DOESNT_MATCH=((int)158),
    sn_warning_type__WARN_ECOV_FORMAT_HAS_CHANGED=((int)159),
    sn__sn_warning_type__WARN_ECOV_FORMAT_HAS_CHANGED=((int)159),
    sn_warning_type__WARN_MAX_INT_BUCKETS_CHANGED=((int)160),
    sn__sn_warning_type__WARN_MAX_INT_BUCKETS_CHANGED=((int)160),
    sn_warning_type__WARN_AUTO_RANGES_CHANGED=((int)161),
    sn__sn_warning_type__WARN_AUTO_RANGES_CHANGED=((int)161),
    sn_warning_type__WARN_CANT_READ_ECOV=((int)162),
    sn__sn_warning_type__WARN_CANT_READ_ECOV=((int)162),
    sn_warning_type__WARN_CANT_MERGE_COV_FILES=((int)163),
    sn__sn_warning_type__WARN_CANT_MERGE_COV_FILES=((int)163),
    sn_warning_type__WARN_NO_MATCH_FOR_COV_FILE=((int)164),
    sn__sn_warning_type__WARN_NO_MATCH_FOR_COV_FILE=((int)164),
    sn_warning_type__WARN_CANT_READ_UCD=((int)165),
    sn__sn_warning_type__WARN_CANT_READ_UCD=((int)165),
    sn_warning_type__WARN_NOT_SPECMAN_UCD=((int)166),
    sn__sn_warning_type__WARN_NOT_SPECMAN_UCD=((int)166),
    sn_warning_type__WARN_BAD_EXTERNAL_GROUP_NAME=((int)167),
    sn__sn_warning_type__WARN_BAD_EXTERNAL_GROUP_NAME=((int)167),
    sn_warning_type__WARN_EXTERNAL_GROUP_NOT_DEFINED=((int)168),
    sn__sn_warning_type__WARN_EXTERNAL_GROUP_NOT_DEFINED=((int)168),
    sn_warning_type__WARN_INC_NO_SUPPORT=((int)169),
    sn__sn_warning_type__WARN_INC_NO_SUPPORT=((int)169),
    sn_warning_type__WARN_CANT_RESTORE_EXT_COV1=((int)170),
    sn__sn_warning_type__WARN_CANT_RESTORE_EXT_COV1=((int)170),
    sn_warning_type__WARN_CANT_CONNECT_EXT_COV=((int)171),
    sn__sn_warning_type__WARN_CANT_CONNECT_EXT_COV=((int)171),
    sn_warning_type__WARN_NO_RESPONSE_EXT_COV=((int)172),
    sn__sn_warning_type__WARN_NO_RESPONSE_EXT_COV=((int)172),
    sn_warning_type__WARN_CANT_SAVE_EXT_COV1=((int)173),
    sn__sn_warning_type__WARN_CANT_SAVE_EXT_COV1=((int)173),
    sn_warning_type__WARN_MANY_ITEMS_MATCH=((int)174),
    sn__sn_warning_type__WARN_MANY_ITEMS_MATCH=((int)174),
    sn_warning_type__WARN_GRADE_THRESH_OUT_OF_BOUND=((int)175),
    sn__sn_warning_type__WARN_GRADE_THRESH_OUT_OF_BOUND=((int)175),
    sn_warning_type__WARN_NO_UNIQUE_BUCKETS=((int)176),
    sn__sn_warning_type__WARN_NO_UNIQUE_BUCKETS=((int)176),
    sn_warning_type__WARN_RANK_FAIL_EXT_COV=((int)177),
    sn__sn_warning_type__WARN_RANK_FAIL_EXT_COV=((int)177),
    sn_warning_type__WARN_SURECOV_SA_MODE=((int)178),
    sn__sn_warning_type__WARN_SURECOV_SA_MODE=((int)178),
    sn_warning_type__WARN_READ_COV_EXT_COV=((int)179),
    sn__sn_warning_type__WARN_READ_COV_EXT_COV=((int)179),
    sn_warning_type__WARN_WRITE_COV_NO_SUPPORT=((int)180),
    sn__sn_warning_type__WARN_WRITE_COV_NO_SUPPORT=((int)180),
    sn_warning_type__WARN_NO_ENTITY_IN_ENV=((int)181),
    sn__sn_warning_type__WARN_NO_ENTITY_IN_ENV=((int)181),
    sn_warning_type__WARN_ENTITY_CHANGED_IN_ENV=((int)182),
    sn__sn_warning_type__WARN_ENTITY_CHANGED_IN_ENV=((int)182),
    sn_warning_type__WARN_COV_ITEM_EMPTY_TYPE=((int)183),
    sn__sn_warning_type__WARN_COV_ITEM_EMPTY_TYPE=((int)183),
    sn_warning_type__WARN_ENTITY_TYPE_CHANGED_IN_ENV=((int)184),
    sn__sn_warning_type__WARN_ENTITY_TYPE_CHANGED_IN_ENV=((int)184),
    sn_warning_type__WARN_WRITE_ECOV_WHEN_ENV_CHANGED=((int)185),
    sn__sn_warning_type__WARN_WRITE_ECOV_WHEN_ENV_CHANGED=((int)185),
    sn_warning_type__WARN_UNGRADABLE_ITEM=((int)186),
    sn__sn_warning_type__WARN_UNGRADABLE_ITEM=((int)186),
    sn_warning_type__WARN_ITEM_VALID_SPACE=((int)187),
    sn__sn_warning_type__WARN_ITEM_VALID_SPACE=((int)187),
    sn_warning_type__WARN_TOTAL_VALID_SPACE=((int)188),
    sn__sn_warning_type__WARN_TOTAL_VALID_SPACE=((int)188),
    sn_warning_type__WARN_EMPTY_VALID_SPACE=((int)189),
    sn__sn_warning_type__WARN_EMPTY_VALID_SPACE=((int)189),
    sn_warning_type__WARN_PER_INSTANCE_CANT_SAMPLE=((int)190),
    sn__sn_warning_type__WARN_PER_INSTANCE_CANT_SAMPLE=((int)190),
    sn_warning_type__WARN_PER_INSTANCE_SAMPLED_NOT_FOUND=((int)191),
    sn__sn_warning_type__WARN_PER_INSTANCE_SAMPLED_NOT_FOUND=((int)191),
    sn_warning_type__WARN_PER_INSTANCE_EXTEND_NOT_FOUND=((int)192),
    sn__sn_warning_type__WARN_PER_INSTANCE_EXTEND_NOT_FOUND=((int)192),
    sn_warning_type__WARN_DUMP_COVER_DATABASE_FAILED=((int)193),
    sn__sn_warning_type__WARN_DUMP_COVER_DATABASE_FAILED=((int)193),
    sn_warning_type__WARN_DUMP_COVER_MODEL_FAILED=((int)194),
    sn__sn_warning_type__WARN_DUMP_COVER_MODEL_FAILED=((int)194),
    sn_warning_type__WARN_LINK_COVER_MODEL_FAILED=((int)195),
    sn__sn_warning_type__WARN_LINK_COVER_MODEL_FAILED=((int)195),
    sn_warning_type__WARN_ON_INTERACTIVE_WITH_UNICOV=((int)196),
    sn__sn_warning_type__WARN_ON_INTERACTIVE_WITH_UNICOV=((int)196),
    sn_warning_type__WARN_INCONSISTENT_COVER_FORMATS=((int)197),
    sn__sn_warning_type__WARN_INCONSISTENT_COVER_FORMATS=((int)197),
    sn_warning_type__WARN_CANT_CREATE_EOD_VSOF_FILE=((int)198),
    sn__sn_warning_type__WARN_CANT_CREATE_EOD_VSOF_FILE=((int)198),
    sn_warning_type__WARN_FORCE_AGENT_DISABLING=((int)199),
    sn__sn_warning_type__WARN_FORCE_AGENT_DISABLING=((int)199),
    sn_warning_type__ERR_AGENT_VERSION_DOES_NOT_MATCH=((int)200),
    sn__sn_warning_type__ERR_AGENT_VERSION_DOES_NOT_MATCH=((int)200),
    sn_warning_type__WARN_EXT_ITEM_HAS_NO_BUCKETS=((int)201),
    sn__sn_warning_type__WARN_EXT_ITEM_HAS_NO_BUCKETS=((int)201),
    sn_warning_type__ERR_CANT_SAVE_EXT_COV=((int)202),
    sn__sn_warning_type__ERR_CANT_SAVE_EXT_COV=((int)202),
    sn_warning_type__ERR_CANT_RESTORE_EXT_COV=((int)203),
    sn__sn_warning_type__ERR_CANT_RESTORE_EXT_COV=((int)203),
    sn_warning_type__NTF_ATTRIBUTE_VALUE_TOO_LONG=((int)204),
    sn__sn_warning_type__NTF_ATTRIBUTE_VALUE_TOO_LONG=((int)204),
    sn_warning_type__WAVE_DEPTH_NEGATIVE=((int)205),
    sn__sn_warning_type__WAVE_DEPTH_NEGATIVE=((int)205),
    sn_warning_type__WAVE_DEPTH_NOT_SUPPORTED=((int)206),
    sn__sn_warning_type__WAVE_DEPTH_NOT_SUPPORTED=((int)206),
    sn_warning_type__WAVE_DEPTH_LOOP=((int)207),
    sn__sn_warning_type__WAVE_DEPTH_LOOP=((int)207),
    sn_warning_type__WAVE_DEPTH_MEM=((int)208),
    sn__sn_warning_type__WAVE_DEPTH_MEM=((int)208),
    sn_warning_type__WAVE_EXP_NOT_SUPPORTED_REAL=((int)209),
    sn__sn_warning_type__WAVE_EXP_NOT_SUPPORTED_REAL=((int)209),
    sn_warning_type__WAVE_EXP_NOT_SUPPORTED_REAL_LIST=((int)210),
    sn__sn_warning_type__WAVE_EXP_NOT_SUPPORTED_REAL_LIST=((int)210),
    sn_warning_type__WAVE_EXP_NOT_SUPPORTED_REAL_STRUCT=((int)211),
    sn__sn_warning_type__WAVE_EXP_NOT_SUPPORTED_REAL_STRUCT=((int)211),
    sn_warning_type__TRANSACTION_STATE_BEGIN=((int)212),
    sn__sn_warning_type__TRANSACTION_STATE_BEGIN=((int)212),
    sn_warning_type__TRANSACTION_STATE_END=((int)213),
    sn__sn_warning_type__TRANSACTION_STATE_END=((int)213),
    sn_warning_type__TRANSACTION_STATE_FREE=((int)214),
    sn__sn_warning_type__TRANSACTION_STATE_FREE=((int)214),
    sn_warning_type__TRANSACTION_STATE_SET_ATTR=((int)215),
    sn__sn_warning_type__TRANSACTION_STATE_SET_ATTR=((int)215),
    sn_warning_type__TRANSACTION_STATE_LINK=((int)216),
    sn__sn_warning_type__TRANSACTION_STATE_LINK=((int)216),
    sn_warning_type__INVALID_RF_SCALAR=((int)217),
    sn__sn_warning_type__INVALID_RF_SCALAR=((int)217),
    sn_warning_type__INVALID_RF_TYPE=((int)218),
    sn__sn_warning_type__INVALID_RF_TYPE=((int)218),
    sn_warning_type__INVALID_NULL_RF_TYPE=((int)219),
    sn__sn_warning_type__INVALID_NULL_RF_TYPE=((int)219),
    sn_warning_type__INVALID_VALUE=((int)220),
    sn__sn_warning_type__INVALID_VALUE=((int)220),
    sn_warning_type__DEPR_WHEN_SUBTYPE_RE=((int)221),
    sn__sn_warning_type__DEPR_WHEN_SUBTYPE_RE=((int)221),
    sn_warning_type__DEPR_EVENT_DATA=((int)222),
    sn__sn_warning_type__DEPR_EVENT_DATA=((int)222),
    sn_warning_type__DEPR_DATA=((int)223),
    sn__sn_warning_type__DEPR_DATA=((int)223),
    sn_warning_type__DEPR_CODE_LINE=((int)224),
    sn__sn_warning_type__DEPR_CODE_LINE=((int)224),
    sn_warning_type__DEPR_WAVE_OUT=((int)225),
    sn__sn_warning_type__DEPR_WAVE_OUT=((int)225),
    sn_warning_type__WARN_PATCH_MISMATCH_LOAD=((int)226),
    sn__sn_warning_type__WARN_PATCH_MISMATCH_LOAD=((int)226),
    sn_warning_type__WARN_PATCH_MISMATCH_SKIP=((int)227),
    sn__sn_warning_type__WARN_PATCH_MISMATCH_SKIP=((int)227),
    sn_warning_type__WARN_PATCH_COMP_MISMATCH_LOAD=((int)228),
    sn__sn_warning_type__WARN_PATCH_COMP_MISMATCH_LOAD=((int)228),
    sn_warning_type__WARN_PATCH_COMP_MISMATCH_SKIP=((int)229),
    sn__sn_warning_type__WARN_PATCH_COMP_MISMATCH_SKIP=((int)229),
    sn_warning_type__WARN_COMP_NONREGISTERED=((int)230),
    sn__sn_warning_type__WARN_COMP_NONREGISTERED=((int)230),
    sn_warning_type__ERR_PATCH_ALREADY_APPLIED=((int)231),
    sn__sn_warning_type__ERR_PATCH_ALREADY_APPLIED=((int)231),
    sn_warning_type__ERR_PATCH_FILE_NAME_INCORRECT=((int)232),
    sn__sn_warning_type__ERR_PATCH_FILE_NAME_INCORRECT=((int)232),
    sn_warning_type__ERR_COMPONENT_ALREADY_REGISTERED=((int)233),
    sn__sn_warning_type__ERR_COMPONENT_ALREADY_REGISTERED=((int)233),
    sn_warning_type__ERR_CANNOT_CHANGE_PATCH_ENTRY=((int)234),
    sn__sn_warning_type__ERR_CANNOT_CHANGE_PATCH_ENTRY=((int)234),
    sn_warning_type__ERR_CANNOT_CHANGE_COMPONENT_FIELD=((int)235),
    sn__sn_warning_type__ERR_CANNOT_CHANGE_COMPONENT_FIELD=((int)235),
    sn_warning_type__WARN_NO_SN_RESTORE_ON_NCSIM_RESET=((int)236),
    sn__sn_warning_type__WARN_NO_SN_RESTORE_ON_NCSIM_RESET=((int)236),
    sn_warning_type__WARN_SPECSIM_SYNC_RESET_FAILED=((int)237),
    sn__sn_warning_type__WARN_SPECSIM_SYNC_RESET_FAILED=((int)237),
    sn_warning_type__DEPR_CONFIG_NCSIM_SYNC_SAVE=((int)238),
    sn__sn_warning_type__DEPR_CONFIG_NCSIM_SYNC_SAVE=((int)238),
    sn_warning_type__DEPR_CONFIG_SPECSIM=((int)239),
    sn__sn_warning_type__DEPR_CONFIG_SPECSIM=((int)239),
    sn_warning_type__WARN_GEN_NEW_CONSTRAINT_AFTER_EVAL=((int)240),
    sn__sn_warning_type__WARN_GEN_NEW_CONSTRAINT_AFTER_EVAL=((int)240),
    sn_warning_type__ERR_IGNORED_CONSTRAINT_ON_LIST_ITEM=((int)241),
    sn__sn_warning_type__ERR_IGNORED_CONSTRAINT_ON_LIST_ITEM=((int)241),
    sn_warning_type__DEPR_NOT_SOFT_SELECT=((int)242),
    sn__sn_warning_type__DEPR_NOT_SOFT_SELECT=((int)242),
    sn_warning_type__ERR_GEN_INVALID_FOREACH_CONSTRAINT=((int)243),
    sn__sn_warning_type__ERR_GEN_INVALID_FOREACH_CONSTRAINT=((int)243),
    sn_warning_type__SN_TRACE_PORTS_SPECSIM=((int)244),
    sn__sn_warning_type__SN_TRACE_PORTS_SPECSIM=((int)244),
    sn_warning_type__SN_TRACE_PORTS_TRANS_PARAM=((int)245),
    sn__sn_warning_type__SN_TRACE_PORTS_TRANS_PARAM=((int)245),
    sn_warning_type__SN_TRACE_PORTS_PORT_TYPE=((int)246),
    sn__sn_warning_type__SN_TRACE_PORTS_PORT_TYPE=((int)246),
    sn_warning_type__SN_TRACE_PORTS_CALLBACK_SUBTYPE=((int)247),
    sn__sn_warning_type__SN_TRACE_PORTS_CALLBACK_SUBTYPE=((int)247),
    sn_warning_type__ERR_DID_NOT_FIND_ADAPTER=((int)248),
    sn__sn_warning_type__ERR_DID_NOT_FIND_ADAPTER=((int)248),
    sn_warning_type__OIG_OVM_ATTRIBUTE_NOT_SET=((int)249),
    sn__sn_warning_type__OIG_OVM_ATTRIBUTE_NOT_SET=((int)249),
    sn_warning_type__NOTIFY_IMPLICIT_ML_OVM_BINDING=((int)250),
    sn__sn_warning_type__NOTIFY_IMPLICIT_ML_OVM_BINDING=((int)250),
    sn_warning_type__WARN_GLITCH=((int)251),
    sn__sn_warning_type__WARN_GLITCH=((int)251),
    sn_warning_type__FAILED_OPEN_SYSTEM_LIBS_FOR_IES=((int)252),
    sn__sn_warning_type__FAILED_OPEN_SYSTEM_LIBS_FOR_IES=((int)252),
    sn_warning_type__WARN_SAME_BUCKET_NAME=((int)253),
    sn__sn_warning_type__WARN_SAME_BUCKET_NAME=((int)253),
    sn_warning_type__WARN_SAME_BUCKET_NAME_REAL=((int)254),
    sn__sn_warning_type__WARN_SAME_BUCKET_NAME_REAL=((int)254),
    sn_warning_type__ERR_RANGES_INTERVAL=((int)255),
    sn__sn_warning_type__ERR_RANGES_INTERVAL=((int)255),
    sn_warning_type__WARN_CANT_READ_EXCOV=((int)256),
    sn__sn_warning_type__WARN_CANT_READ_EXCOV=((int)256),
    sn_warning_type__WARN_CANT_CONVERT_OLD_EXCOV=((int)257),
    sn__sn_warning_type__WARN_CANT_CONVERT_OLD_EXCOV=((int)257),
    sn_warning_type__WARN_NO_ACTIVE_COVER_ELEMENTS=((int)258),
    sn__sn_warning_type__WARN_NO_ACTIVE_COVER_ELEMENTS=((int)258),
    sn_warning_type__WARN_SEQ_LIVE_TEMPEX=((int)259),
    sn__sn_warning_type__WARN_SEQ_LIVE_TEMPEX=((int)259),
    sn_warning_type__WARN_SEQ_ITEM_LIVE_TEMPEX=((int)260),
    sn__sn_warning_type__WARN_SEQ_ITEM_LIVE_TEMPEX=((int)260),
    sn_warning_type__DEPR_SEQ_CONST_KIND=((int)261),
    sn__sn_warning_type__DEPR_SEQ_CONST_KIND=((int)261),
    sn_warning_type__DEPR_LOAD_VT=((int)262),
    sn__sn_warning_type__DEPR_LOAD_VT=((int)262),
    sn_warning_type__WARN_GEN_OVERRIDDEN_UNDER_NULL=((int)263),
    sn__sn_warning_type__WARN_GEN_OVERRIDDEN_UNDER_NULL=((int)263),
    sn_warning_type__WARN_GEN_OVERRIDDEN_UNDER_ASSIGN=((int)264),
    sn__sn_warning_type__WARN_GEN_OVERRIDDEN_UNDER_ASSIGN=((int)264),
    sn_warning_type__GEN_NO_GENERATABLE_NOTIF=((int)265),
    sn__sn_warning_type__GEN_NO_GENERATABLE_NOTIF=((int)265),
    sn_warning_type__GEN_INVALID_FOREACH_INDEX_NOTIF=((int)266),
    sn__sn_warning_type__GEN_INVALID_FOREACH_INDEX_NOTIF=((int)266),
    sn_warning_type__GEN_IGNORED_DIRECTIVE_NOTIF=((int)267),
    sn__sn_warning_type__GEN_IGNORED_DIRECTIVE_NOTIF=((int)267),
    sn_warning_type__GEN_ILLEGAL_SELECT_ON_EXP=((int)268),
    sn__sn_warning_type__GEN_ILLEGAL_SELECT_ON_EXP=((int)268),
    sn_warning_type__GEN_BI_DIRECTIONAL_LIST_SUM=((int)269),
    sn__sn_warning_type__GEN_BI_DIRECTIONAL_LIST_SUM=((int)269),
    sn_warning_type__GEN_CONTRADICTING_SUBTYPE_NOTIF=((int)270),
    sn__sn_warning_type__GEN_CONTRADICTING_SUBTYPE_NOTIF=((int)270),
    sn_warning_type__GEN_IGNORED_CONSTRAINT_NOTIF=((int)271),
    sn__sn_warning_type__GEN_IGNORED_CONSTRAINT_NOTIF=((int)271),
    sn_warning_type__GEN_MONITOR_CONSTRAINT_NOTIF=((int)272),
    sn__sn_warning_type__GEN_MONITOR_CONSTRAINT_NOTIF=((int)272),
    sn_warning_type__WARN_GEN_BIG_LACE=((int)273),
    sn__sn_warning_type__WARN_GEN_BIG_LACE=((int)273),
    sn_warning_type__WARN_GEN_CFA_FAILED_SAMPLE=((int)274),
    sn__sn_warning_type__WARN_GEN_CFA_FAILED_SAMPLE=((int)274),
    sn_warning_type__WARN_GEN_CFA_DUAL_CONTEXTS=((int)275),
    sn__sn_warning_type__WARN_GEN_CFA_DUAL_CONTEXTS=((int)275),
    sn_warning_type__WARN_GEN_CFA_UNSUPPORTED=((int)276),
    sn__sn_warning_type__WARN_GEN_CFA_UNSUPPORTED=((int)276),
    sn_warning_type__WARN_GEN_SAMPLING_FAILURE_IN_SOFT=((int)277),
    sn__sn_warning_type__WARN_GEN_SAMPLING_FAILURE_IN_SOFT=((int)277),
    sn_warning_type__WARN_GEN_RUNTIME_ICFS=((int)278),
    sn__sn_warning_type__WARN_GEN_RUNTIME_ICFS=((int)278),
    sn_warning_type__WARN_GEN_PRERUN_ICFS=((int)279),
    sn__sn_warning_type__WARN_GEN_PRERUN_ICFS=((int)279),
    sn_warning_type__GEN_MIXED_PGEN_CONTEXT_GEN_CYCLE=((int)280),
    sn__sn_warning_type__GEN_MIXED_PGEN_CONTEXT_GEN_CYCLE=((int)280),
    sn_warning_type__GEN_MIXED_NO_GEN_PATH_CONSTRAINT=((int)281),
    sn__sn_warning_type__GEN_MIXED_NO_GEN_PATH_CONSTRAINT=((int)281),
    sn_warning_type__GEN_MIXED_CONSTRAINT_NOTIF=((int)282),
    sn__sn_warning_type__GEN_MIXED_CONSTRAINT_NOTIF=((int)282),
    sn_warning_type__GEN_KEEPING_MIXED_CONSTRAINT_NOTIF=((int)283),
    sn__sn_warning_type__GEN_KEEPING_MIXED_CONSTRAINT_NOTIF=((int)283),
    sn_warning_type__GEN_COMPLEX_MIXED_CONSTRAINT_NOTIF=((int)284),
    sn__sn_warning_type__GEN_COMPLEX_MIXED_CONSTRAINT_NOTIF=((int)284),
    sn_warning_type__GEN_KEEPING_MIXED_CONSTRAINT_IGNORE=((int)285),
    sn__sn_warning_type__GEN_KEEPING_MIXED_CONSTRAINT_IGNORE=((int)285),
    sn_warning_type__GEN_FOREACH_MIXED_CONSTRAINT_IGNORE=((int)286),
    sn__sn_warning_type__GEN_FOREACH_MIXED_CONSTRAINT_IGNORE=((int)286),
    sn_warning_type__GEN_FOREACH_MIXED_CONSTRAINT_NOTIF=((int)287),
    sn__sn_warning_type__GEN_FOREACH_MIXED_CONSTRAINT_NOTIF=((int)287),
    sn_warning_type__GEN_MIXED_CONFLICTING_COMMANDS=((int)288),
    sn__sn_warning_type__GEN_MIXED_CONFLICTING_COMMANDS=((int)288),
    sn_warning_type__GEN_INFINITENESS_UNSUPPORTED_IGEN=((int)289),
    sn__sn_warning_type__GEN_INFINITENESS_UNSUPPORTED_IGEN=((int)289),
    sn_warning_type__GEN_CFS_IDEP_GENERAL=((int)290),
    sn__sn_warning_type__GEN_CFS_IDEP_GENERAL=((int)290),
    sn_warning_type__GEN_CFS_IDEP_SUBTYPES=((int)291),
    sn__sn_warning_type__GEN_CFS_IDEP_SUBTYPES=((int)291),
    sn_warning_type__GEN_CFS_IDEP_LIST_SIZE=((int)292),
    sn__sn_warning_type__GEN_CFS_IDEP_LIST_SIZE=((int)292),
    sn_warning_type__GEN_CFS_IDEP_SOFTS=((int)293),
    sn__sn_warning_type__GEN_CFS_IDEP_SOFTS=((int)293),
    sn_warning_type__GEN_AI_NOT_SUPPORTED_INDEFINITE=((int)294),
    sn__sn_warning_type__GEN_AI_NOT_SUPPORTED_INDEFINITE=((int)294),
    sn_warning_type__GEN_AI_NOT_SUPPORTED_CONSTRAINTS=((int)295),
    sn__sn_warning_type__GEN_AI_NOT_SUPPORTED_CONSTRAINTS=((int)295),
    sn_warning_type__GEN_AI_NOT_SUPPORTED_MORE_VARS=((int)296),
    sn__sn_warning_type__GEN_AI_NOT_SUPPORTED_MORE_VARS=((int)296),
    sn_warning_type__WARN_GEN_LINTER_M1=((int)297),
    sn__sn_warning_type__WARN_GEN_LINTER_M1=((int)297),
    sn_warning_type__WARN_GEN_LINTER_M12=((int)298),
    sn__sn_warning_type__WARN_GEN_LINTER_M12=((int)298),
    sn_warning_type__WARN_GEN_LINTER_M2=((int)299),
    sn__sn_warning_type__WARN_GEN_LINTER_M2=((int)299),
    sn_warning_type__WARN_GEN_LINTER_M22=((int)300),
    sn__sn_warning_type__WARN_GEN_LINTER_M22=((int)300),
    sn_warning_type__WARN_GEN_LINTER_M3=((int)301),
    sn__sn_warning_type__WARN_GEN_LINTER_M3=((int)301),
    sn_warning_type__WARN_GEN_LINTER_M32=((int)302),
    sn__sn_warning_type__WARN_GEN_LINTER_M32=((int)302),
    sn_warning_type__WARN_GEN_LINTER_M4=((int)303),
    sn__sn_warning_type__WARN_GEN_LINTER_M4=((int)303),
    sn_warning_type__WARN_GEN_LINTER_M42=((int)304),
    sn__sn_warning_type__WARN_GEN_LINTER_M42=((int)304),
    sn_warning_type__WARN_GEN_LINTER_G1=((int)305),
    sn__sn_warning_type__WARN_GEN_LINTER_G1=((int)305),
    sn_warning_type__WARN_GEN_LINTER_G12=((int)306),
    sn__sn_warning_type__WARN_GEN_LINTER_G12=((int)306),
    sn_warning_type__WARN_GEN_LINTER_G2=((int)307),
    sn__sn_warning_type__WARN_GEN_LINTER_G2=((int)307),
    sn_warning_type__WARN_GEN_LINTER_G22=((int)308),
    sn__sn_warning_type__WARN_GEN_LINTER_G22=((int)308),
    sn_warning_type__WARN_GEN_LINTER_G3=((int)309),
    sn__sn_warning_type__WARN_GEN_LINTER_G3=((int)309),
    sn_warning_type__WARN_GEN_LINTER_G32=((int)310),
    sn__sn_warning_type__WARN_GEN_LINTER_G32=((int)310),
    sn_warning_type__WARN_GEN_LINTER_G4=((int)311),
    sn__sn_warning_type__WARN_GEN_LINTER_G4=((int)311),
    sn_warning_type__WARN_GEN_LINTER_G42=((int)312),
    sn__sn_warning_type__WARN_GEN_LINTER_G42=((int)312),
    sn_warning_type__WARN_GEN_LINTER_G5=((int)313),
    sn__sn_warning_type__WARN_GEN_LINTER_G5=((int)313),
    sn_warning_type__WARN_GEN_LINTER_G52=((int)314),
    sn__sn_warning_type__WARN_GEN_LINTER_G52=((int)314),
    sn_warning_type__WARN_GEN_LINTER_G6=((int)315),
    sn__sn_warning_type__WARN_GEN_LINTER_G6=((int)315),
    sn_warning_type__WARN_GEN_LINTER_G62=((int)316),
    sn__sn_warning_type__WARN_GEN_LINTER_G62=((int)316),
    sn_warning_type__WARN_GEN_LINTER_S1=((int)317),
    sn__sn_warning_type__WARN_GEN_LINTER_S1=((int)317),
    sn_warning_type__WARN_GEN_LINTER_NO_MODULES=((int)318),
    sn__sn_warning_type__WARN_GEN_LINTER_NO_MODULES=((int)318),
    sn_warning_type__WARN_GEN_LINTER_DEFAULT_GEN=((int)319),
    sn__sn_warning_type__WARN_GEN_LINTER_DEFAULT_GEN=((int)319),
    sn_warning_type__DEPR_CONFIG_CATEGORY_MEMORY=((int)320),
    sn__sn_warning_type__DEPR_CONFIG_CATEGORY_MEMORY=((int)320),
    sn_warning_type__WARN_IUS_PROFILER_ON=((int)321),
    sn__sn_warning_type__WARN_IUS_PROFILER_ON=((int)321),
    sn_warning_type__DEPR_SEQUENCE_FIELD_KEYWORD=((int)322),
    sn__sn_warning_type__DEPR_SEQUENCE_FIELD_KEYWORD=((int)322),
    sn_warning_type__DEPR_SEQUENCE_START_KEYWORD=((int)323),
    sn__sn_warning_type__DEPR_SEQUENCE_START_KEYWORD=((int)323),
    sn_warning_type__DEPR_SEQUENCE_ITEM_KEYWORD=((int)324),
    sn__sn_warning_type__DEPR_SEQUENCE_ITEM_KEYWORD=((int)324)
} t__sn__sn_warning_type;

#define d__sn__sn_warning_type 1615

typedef t__sn__sn_warning_type t__sn_warning_type;

#define d__sn_warning_type d__sn__sn_warning_type

/* line 9 "/vobs/specman/src/comm_request.e"  From 'Enum type 'comm_request_opcode'' */
typedef enum {
    comm_request_opcode__error=((int)0),
    sn__comm_request_opcode__error=((int)0),
    comm_request_opcode__undef=((int)1),
    sn__comm_request_opcode__undef=((int)1),
    comm_request_opcode__get_application_desc=((int)2),
    sn__comm_request_opcode__get_application_desc=((int)2),
    comm_request_opcode__general_in_request=((int)100),
    sn__comm_request_opcode__general_in_request=((int)100),
    comm_request_opcode__general_out_request=((int)101),
    sn__comm_request_opcode__general_out_request=((int)101),
    comm_request_opcode__general_in_notification_no_acknowledge=((int)102),
    sn__comm_request_opcode__general_in_notification_no_acknowledge=((int)102),
    comm_request_opcode__general_out_notification_no_acknowledge=((int)103),
    sn__comm_request_opcode__general_out_notification_no_acknowledge=((int)103),
    comm_request_opcode__general_in_notification_with_acknowledge=((int)104),
    sn__comm_request_opcode__general_in_notification_with_acknowledge=((int)104),
    comm_request_opcode__general_out_notification_with_acknowledge=((int)105),
    sn__comm_request_opcode__general_out_notification_with_acknowledge=((int)105),
    comm_request_opcode__initialize=((int)3),
    sn__comm_request_opcode__initialize=((int)3),
    comm_request_opcode__read_cover=((int)4),
    sn__comm_request_opcode__read_cover=((int)4),
    comm_request_opcode__clear_cover=((int)5),
    sn__comm_request_opcode__clear_cover=((int)5),
    comm_request_opcode__get_cover_tests=((int)6),
    sn__comm_request_opcode__get_cover_tests=((int)6),
    comm_request_opcode__get_contributed_tests=((int)7),
    sn__comm_request_opcode__get_contributed_tests=((int)7),
    comm_request_opcode__include_exclude=((int)8),
    sn__comm_request_opcode__include_exclude=((int)8),
    comm_request_opcode__get_initial_file_system_info=((int)9),
    sn__comm_request_opcode__get_initial_file_system_info=((int)9),
    comm_request_opcode__get_dir_contents=((int)10),
    sn__comm_request_opcode__get_dir_contents=((int)10),
    comm_request_opcode__get_cover_element_data=((int)11),
    sn__comm_request_opcode__get_cover_element_data=((int)11),
    comm_request_opcode__get_item_type=((int)12),
    sn__comm_request_opcode__get_item_type=((int)12),
    comm_request_opcode__report=((int)13),
    sn__comm_request_opcode__report=((int)13),
    comm_request_opcode__set_cover_config=((int)14),
    sn__comm_request_opcode__set_cover_config=((int)14),
    comm_request_opcode__get_cover_config=((int)15),
    sn__comm_request_opcode__get_cover_config=((int)15),
    comm_request_opcode__get_postrun_data=((int)16),
    sn__comm_request_opcode__get_postrun_data=((int)16),
    comm_request_opcode__opc_cancel_wakeup_in_notification=((int)200),
    sn__comm_request_opcode__opc_cancel_wakeup_in_notification=((int)200)
} t__sn__comm_request_opcode;

#define d__sn__comm_request_opcode 3295

typedef t__sn__comm_request_opcode t__comm_request_opcode;

#define d__comm_request_opcode d__sn__comm_request_opcode

/* line 16 "/vobs/specman/src/comm_request.e"  From 'Enum type 'comm_status'' */
typedef enum {
    comm_status__OK=((int)0),
    sn__comm_status__OK=((int)0),
    comm_status__ERROR=((int)1),
    sn__comm_status__ERROR=((int)1),
    comm_status__READ_COVER_FORCE_REFRESH=((int)3),
    sn__comm_status__READ_COVER_FORCE_REFRESH=((int)3)
} t__sn__comm_status;

#define d__sn__comm_status 3297

typedef t__sn__comm_status t__comm_status;

#define d__comm_status d__sn__comm_status

/* line 28 "/vobs/specman/src/cvl_defs.e"  From 'Enum type 'sn_con_state'' */
typedef enum {
    sn_con_state__BOUND=((int)0),
    sn__sn_con_state__BOUND=((int)0),
    sn_con_state__LISTEN=((int)1),
    sn__sn_con_state__LISTEN=((int)1),
    sn_con_state__CONNECTED=((int)2),
    sn__sn_con_state__CONNECTED=((int)2),
    sn_con_state__CLOSED=((int)3),
    sn__sn_con_state__CLOSED=((int)3),
    sn_con_state__ERROR=((int)4),
    sn__sn_con_state__ERROR=((int)4)
} t__sn__sn_con_state;

#define d__sn__sn_con_state 3249

typedef t__sn__sn_con_state t__sn_con_state;

#define d__sn_con_state d__sn__sn_con_state

/* line 4 "/vobs/specman/src/reserved_keywords.e"  From 'Enum type 'sn_token_kind'' */
typedef enum {
    sn_token_kind__none=((int)0),
    sn__sn_token_kind__none=((int)0),
    sn_token_kind__declare=((int)1),
    sn__sn_token_kind__declare=((int)1),
    sn_token_kind__method_call=((int)2),
    sn__sn_token_kind__method_call=((int)2),
    sn_token_kind__event_access=((int)3),
    sn__sn_token_kind__event_access=((int)3),
    sn_token_kind__field_access=((int)4),
    sn__sn_token_kind__field_access=((int)4)
} t__sn__sn_token_kind;

#define d__sn__sn_token_kind 9362

typedef t__sn__sn_token_kind t__sn_token_kind;

#define d__sn_token_kind d__sn__sn_token_kind

/* line 5 "/vobs/specman/src/reserved_keywords.e"  From 'Enum type 'sn_token_type'' */
typedef enum {
    sn_token_type__keyword=((int)0),
    sn__sn_token_type__keyword=((int)0),
    sn_token_type__keep_block=((int)1),
    sn__sn_token_type__keep_block=((int)1),
    sn_token_type__internal=((int)2),
    sn__sn_token_type__internal=((int)2),
    sn_token_type__dac=((int)3),
    sn__sn_token_type__dac=((int)3)
} t__sn__sn_token_type;

#define d__sn__sn_token_type 9364

typedef t__sn__sn_token_type t__sn_token_type;

#define d__sn_token_type d__sn__sn_token_type

/* line 30 "/vobs/specman/src/cvl_defs.e"  From 'Enum type 'sn_connection_type'' */
typedef enum {
    sn_connection_type__server=((int)0),
    sn__sn_connection_type__server=((int)0),
    sn_connection_type__client=((int)1),
    sn__sn_connection_type__client=((int)1)
} t__sn__sn_connection_type;

#define d__sn__sn_connection_type 3251

typedef t__sn__sn_connection_type t__sn_connection_type;

#define d__sn_connection_type d__sn__sn_connection_type

/* line 32 "/vobs/specman/src/cvl_defs.e"  From 'Enum type 'sn_callmode_type'' */
typedef enum {
    sn_callmode_type__sn_sync=((int)0),
    sn__sn_callmode_type__sn_sync=((int)0),
    sn_callmode_type__sn_async=((int)1),
    sn__sn_callmode_type__sn_async=((int)1)
} t__sn__sn_callmode_type;

#define d__sn__sn_callmode_type 3253

typedef t__sn__sn_callmode_type t__sn_callmode_type;

#define d__sn_callmode_type d__sn__sn_callmode_type

/* line 26 "/vobs/specman/src/cvl_defs.e"  From 'Enum type 'sn_cvl_method_type'' */
typedef enum {
    sn_cvl_method_type__cvl_method=((int)0),
    sn__sn_cvl_method_type__cvl_method=((int)0),
    sn_cvl_method_type__cvl_callback=((int)1),
    sn__sn_cvl_method_type__cvl_callback=((int)1),
    sn_cvl_method_type__stub_cvl_call=((int)2),
    sn__sn_cvl_method_type__stub_cvl_call=((int)2),
    sn_cvl_method_type__stub_cvl_method=((int)3),
    sn__sn_cvl_method_type__stub_cvl_method=((int)3)
} t__sn__sn_cvl_method_type;

#define d__sn__sn_cvl_method_type 3247

typedef t__sn__sn_cvl_method_type t__sn_cvl_method_type;

#define d__sn_cvl_method_type d__sn__sn_cvl_method_type

/* line 13 "/vobs/specman/src/e_core_types.e"  From 'Enum type 'message_verbosity'' */
typedef enum {
    message_verbosity__NONE=((int)0),
    e_core__message_verbosity__NONE=((int)0),
    message_verbosity__LOW=((int)100),
    e_core__message_verbosity__LOW=((int)100),
    message_verbosity__MEDIUM=((int)200),
    e_core__message_verbosity__MEDIUM=((int)200),
    message_verbosity__HIGH=((int)300),
    e_core__message_verbosity__HIGH=((int)300),
    message_verbosity__FULL=((int)400),
    e_core__message_verbosity__FULL=((int)400)
} t__e_core__message_verbosity;

#define d__e_core__message_verbosity 1145

typedef t__e_core__message_verbosity t__message_verbosity;

#define d__message_verbosity d__e_core__message_verbosity

/* line 14 "/vobs/specman/src/e_core_types.e"  From 'Enum type 'message_format'' */
typedef enum {
    message_format__short=((int)0),
    e_core__message_format__short=((int)0),
    message_format__long=((int)1),
    e_core__message_format__long=((int)1),
    message_format__none=((int)2),
    e_core__message_format__none=((int)2)
} t__e_core__message_format;

#define d__e_core__message_format 1147

typedef t__e_core__message_format t__message_format;

#define d__message_format d__e_core__message_format

/* line 12 "/vobs/specman/src/e_core_types.e"  From 'Enum type 'message_tag'' */
typedef enum {
    message_tag__NORMAL=((int)0),
    e_core__message_tag__NORMAL=((int)0),
    message_tag__TRACE_SEQUENCE=((int)1),
    e_core__message_tag__TRACE_SEQUENCE=((int)1),
    message_tag__TRACE_OBJECTION=((int)2),
    e_core__message_tag__TRACE_OBJECTION=((int)2),
    message_tag__GSA_TRACE=((int)3),
    e_core__message_tag__GSA_TRACE=((int)3),
    message_tag__GSA=((int)4),
    e_core__message_tag__GSA=((int)4)
} t__e_core__message_tag;

#define d__e_core__message_tag 1143

typedef t__e_core__message_tag t__message_tag;

#define d__message_tag d__e_core__message_tag

/* line 94 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'Enum type 'vt_style'' */
typedef enum {
    vt_style__BLACK=((int)0),
    vt__vt_style__BLACK=((int)0),
    vt_style__VERY_LIGHT_GRAY=((int)1),
    vt__vt_style__VERY_LIGHT_GRAY=((int)1),
    vt_style__LIGHT_GRAY=((int)2),
    vt__vt_style__LIGHT_GRAY=((int)2),
    vt_style__GRAY=((int)3),
    vt__vt_style__GRAY=((int)3),
    vt_style__DARK_GRAY=((int)4),
    vt__vt_style__DARK_GRAY=((int)4),
    vt_style__LIGHT_RED=((int)5),
    vt__vt_style__LIGHT_RED=((int)5),
    vt_style__RED=((int)6),
    vt__vt_style__RED=((int)6),
    vt_style__DARK_RED=((int)7),
    vt__vt_style__DARK_RED=((int)7),
    vt_style__LIGHT_ORANGE=((int)8),
    vt__vt_style__LIGHT_ORANGE=((int)8),
    vt_style__ORANGE=((int)9),
    vt__vt_style__ORANGE=((int)9),
    vt_style__DARK_ORANGE=((int)10),
    vt__vt_style__DARK_ORANGE=((int)10),
    vt_style__LIGHT_YELLOW=((int)11),
    vt__vt_style__LIGHT_YELLOW=((int)11),
    vt_style__YELLOW=((int)12),
    vt__vt_style__YELLOW=((int)12),
    vt_style__DARK_YELLOW=((int)13),
    vt__vt_style__DARK_YELLOW=((int)13),
    vt_style__LIGHT_GREEN=((int)14),
    vt__vt_style__LIGHT_GREEN=((int)14),
    vt_style__GREEN=((int)15),
    vt__vt_style__GREEN=((int)15),
    vt_style__DARK_GREEN=((int)16),
    vt__vt_style__DARK_GREEN=((int)16),
    vt_style__LIGHT_CYAN=((int)17),
    vt__vt_style__LIGHT_CYAN=((int)17),
    vt_style__CYAN=((int)18),
    vt__vt_style__CYAN=((int)18),
    vt_style__DARK_CYAN=((int)19),
    vt__vt_style__DARK_CYAN=((int)19),
    vt_style__LIGHT_BLUE=((int)20),
    vt__vt_style__LIGHT_BLUE=((int)20),
    vt_style__BLUE=((int)21),
    vt__vt_style__BLUE=((int)21),
    vt_style__DARK_BLUE=((int)22),
    vt__vt_style__DARK_BLUE=((int)22),
    vt_style__LIGHT_MAGENTA=((int)23),
    vt__vt_style__LIGHT_MAGENTA=((int)23),
    vt_style__MAGENTA=((int)24),
    vt__vt_style__MAGENTA=((int)24),
    vt_style__DARK_MAGENTA=((int)25),
    vt__vt_style__DARK_MAGENTA=((int)25),
    vt_style__LIGHT_PURPLE=((int)26),
    vt__vt_style__LIGHT_PURPLE=((int)26),
    vt_style__PURPLE=((int)27),
    vt__vt_style__PURPLE=((int)27),
    vt_style__DARK_PURPLE=((int)28),
    vt__vt_style__DARK_PURPLE=((int)28),
    vt_style__WHITE=((int)29),
    vt__vt_style__WHITE=((int)29)
} t__vt__vt_style;

#define d__vt__vt_style 2541

typedef t__vt__vt_style t__vt_style;

#define d__vt_style d__vt__vt_style

/* line 120 "/vobs/specman/src/script_rnd.e"  From 'Enum type 'random_policy'' */
typedef enum {
    random_policy__flat=((int)0),
    sn__random_policy__flat=((int)0),
    random_policy__lowest=((int)1),
    sn__random_policy__lowest=((int)1),
    random_policy__highest=((int)2),
    sn__random_policy__highest=((int)2),
    random_policy__jumping=((int)3),
    sn__random_policy__jumping=((int)3)
} t__sn__random_policy;

#define d__sn__random_policy 1243

typedef t__sn__random_policy t__random_policy;

#define d__random_policy d__sn__random_policy

/* line 368 "/vobs/specman/src/scriptsim.e"  From 'Enum type 'capture_mode'' */
typedef enum {
    capture_mode__inactive=((int)0),
    sn__capture_mode__inactive=((int)0),
    capture_mode__replaying=((int)1),
    sn__capture_mode__replaying=((int)1),
    capture_mode__recording=((int)2),
    sn__capture_mode__recording=((int)2)
} t__sn__capture_mode;

#define d__sn__capture_mode 1259

typedef t__sn__capture_mode t__capture_mode;

#define d__capture_mode d__sn__capture_mode

/* line 17 "/vobs/specman/src/cap_structs.e"  From 'Enum type 'data_format'' */
typedef enum {
    data_format__short_format=((int)0),
    sn__data_format__short_format=((int)0),
    data_format__long_format=((int)1),
    sn__data_format__long_format=((int)1)
} t__sn__data_format;

#define d__sn__data_format 7270

typedef t__sn__data_format t__data_format;

#define d__data_format d__sn__data_format

/* line 130 "/vobs/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_mode'' */
typedef enum {
    sn_cvr_mode__cvr_default=((int)0),
    main__sn_cvr_mode__cvr_default=((int)0),
    sn_cvr_mode__off=((int)1),
    main__sn_cvr_mode__off=((int)1),
    sn_cvr_mode__on=((int)2),
    main__sn_cvr_mode__on=((int)2),
    sn_cvr_mode__on_interactive=((int)3),
    main__sn_cvr_mode__on_interactive=((int)3)
} t__main__sn_cvr_mode;

#define d__main__sn_cvr_mode 3558

typedef t__main__sn_cvr_mode t__sn_cvr_mode;

#define d__sn_cvr_mode d__main__sn_cvr_mode

/* line 142 "/vobs/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_xyz'' */
typedef enum {
    sn_cvr_xyz__x=((int)0),
    main__sn_cvr_xyz__x=((int)0),
    sn_cvr_xyz__y=((int)1),
    main__sn_cvr_xyz__y=((int)1),
    sn_cvr_xyz__z=((int)2),
    main__sn_cvr_xyz__z=((int)2)
} t__main__sn_cvr_xyz;

#define d__main__sn_cvr_xyz 3562

typedef t__main__sn_cvr_xyz t__sn_cvr_xyz;

#define d__sn_cvr_xyz d__main__sn_cvr_xyz

/* line 168 "/vobs/specman/src/cover_basic.e"  From 'Enum type 'sn_cover_report_kind'' */
typedef enum {
    sn_cover_report_kind__full=((int)0),
    main__sn_cover_report_kind__full=((int)0),
    sn_cover_report_kind__summary=((int)1),
    main__sn_cover_report_kind__summary=((int)1),
    sn_cover_report_kind__spreadsheet=((int)2),
    main__sn_cover_report_kind__spreadsheet=((int)2)
} t__main__sn_cover_report_kind;

#define d__main__sn_cover_report_kind 3572

typedef t__main__sn_cover_report_kind t__sn_cover_report_kind;

#define d__sn_cover_report_kind d__main__sn_cover_report_kind

/* line 181 "/vobs/specman/src/cover_rank.e"  From 'type: sn_ranker'grade_threshold' */
#define t__main__sn_ranker__grade_threshold t__int
#define t__sn_ranker__grade_threshold t__main__sn_ranker__grade_threshold
/* line 40 "/vobs/specman/src/cover_base_structs.e"  From 'Enum type 'sn_cai_cov_agent_type'' */
typedef enum {
    sn_cai_cov_agent_type__none=((int)0),
    main__sn_cai_cov_agent_type__none=((int)0),
    sn_cai_cov_agent_type__surecov=((int)1),
    main__sn_cai_cov_agent_type__surecov=((int)1)
} t__main__sn_cai_cov_agent_type;

#define d__main__sn_cai_cov_agent_type 3588

typedef t__main__sn_cai_cov_agent_type t__sn_cai_cov_agent_type;

#define d__sn_cai_cov_agent_type d__main__sn_cai_cov_agent_type

/* line 17 "/vobs/specman/src/times.e"  From 'type: clock_t' */
#define t__sn__clock_t t__uint
#define t__clock_t t__sn__clock_t
/* line 37 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_window_kind'' */
typedef enum {
    vt_window_kind__ANY_WINDOW=((int)0),
    vt__vt_window_kind__ANY_WINDOW=((int)0),
    vt_window_kind__HTML_SOURCE_WINDOW=((int)1),
    vt__vt_window_kind__HTML_SOURCE_WINDOW=((int)1),
    vt_window_kind__VT_HISTORY_WINDOW=((int)2),
    vt__vt_window_kind__VT_HISTORY_WINDOW=((int)2),
    vt_window_kind__SN_SEARCH_WINDOW=((int)3),
    vt__vt_window_kind__SN_SEARCH_WINDOW=((int)3),
    vt_window_kind__ERROR_WINDOW=((int)4),
    vt__vt_window_kind__ERROR_WINDOW=((int)4),
    vt_window_kind__DECRYPTION_PASSWORD_DIALOG=((int)5),
    vt__vt_window_kind__DECRYPTION_PASSWORD_DIALOG=((int)5),
    vt_window_kind__SN_RANK_TEST_WINDOW=((int)6),
    vt__vt_window_kind__SN_RANK_TEST_WINDOW=((int)6),
    vt_window_kind__SN_RANK_BUCKET_WINDOW=((int)7),
    vt__vt_window_kind__SN_RANK_BUCKET_WINDOW=((int)7),
    vt_window_kind__SN_RANK_MAIN_WINDOW=((int)8),
    vt__vt_window_kind__SN_RANK_MAIN_WINDOW=((int)8),
    vt_window_kind__EXPORT_MULTI_TABLE_WINDOW=((int)9),
    vt__vt_window_kind__EXPORT_MULTI_TABLE_WINDOW=((int)9),
    vt_window_kind__MESSAGE_INFO_WINDOW=((int)10),
    vt__vt_window_kind__MESSAGE_INFO_WINDOW=((int)10),
    vt_window_kind__VT_UTIL_WINDOW=((int)11),
    vt__vt_window_kind__VT_UTIL_WINDOW=((int)11),
    vt_window_kind__STRIPE_CHART_WINDOW=((int)12),
    vt__vt_window_kind__STRIPE_CHART_WINDOW=((int)12),
    vt_window_kind__EDOC_WINDOW=((int)13),
    vt__vt_window_kind__EDOC_WINDOW=((int)13),
    vt_window_kind__SEQ_BROWSER_WINDOW=((int)14),
    vt__vt_window_kind__SEQ_BROWSER_WINDOW=((int)14)
} t__vt__vt_window_kind;

#define d__vt__vt_window_kind 4783

typedef t__vt__vt_window_kind t__vt_window_kind;

#define d__vt_window_kind d__vt__vt_window_kind

/* line 167 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'Enum type 'vt_window_state'' */
typedef enum {
    vt_window_state__RAW=((int)0),
    vt__vt_window_state__RAW=((int)0),
    vt_window_state__PRE_OPENED=((int)1),
    vt__vt_window_state__PRE_OPENED=((int)1),
    vt_window_state__VISIBLE=((int)2),
    vt__vt_window_state__VISIBLE=((int)2),
    vt_window_state__INVISIBLE=((int)3),
    vt__vt_window_state__INVISIBLE=((int)3),
    vt_window_state__CLOSED=((int)4),
    vt__vt_window_state__CLOSED=((int)4)
} t__vt__vt_window_state;

#define d__vt__vt_window_state 5043

typedef t__vt__vt_window_state t__vt_window_state;

#define d__vt_window_state d__vt__vt_window_state

/* line 109 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_gui_refresh_mode'' */
typedef enum {
    vt_gui_refresh_mode__ON_PROMPT=((int)0),
    vt__vt_gui_refresh_mode__ON_PROMPT=((int)0),
    vt_gui_refresh_mode__IMMEDIATE=((int)1),
    vt__vt_gui_refresh_mode__IMMEDIATE=((int)1)
} t__vt__vt_gui_refresh_mode;

#define d__vt__vt_gui_refresh_mode 4799

typedef t__vt__vt_gui_refresh_mode t__vt_gui_refresh_mode;

#define d__vt_gui_refresh_mode d__vt__vt_gui_refresh_mode

/* line 50 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'Enum type 'vt_menubar_default_actions'' */
typedef enum {
    vt_menubar_default_actions__USE_NO_ACTIONS=((int)0),
    vt__vt_menubar_default_actions__USE_NO_ACTIONS=((int)0),
    vt_menubar_default_actions__USE_ALL_PREDEFINED_ACTIONS=((int)1),
    vt__vt_menubar_default_actions__USE_ALL_PREDEFINED_ACTIONS=((int)1),
    vt_menubar_default_actions__USE_SUBSET_PREDEFINED_ACTIONS=((int)2),
    vt__vt_menubar_default_actions__USE_SUBSET_PREDEFINED_ACTIONS=((int)2)
} t__vt__vt_menubar_default_actions;

#define d__vt__vt_menubar_default_actions 4940

typedef t__vt__vt_menubar_default_actions t__vt_menubar_default_actions;

#define d__vt_menubar_default_actions d__vt__vt_menubar_default_actions

/* line 42 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'Enum type 'vt_menu_element_kind'' */
typedef enum {
    vt_menu_element_kind__MENUBAR=((int)0),
    vt__vt_menu_element_kind__MENUBAR=((int)0),
    vt_menu_element_kind__TOOLBAR=((int)1),
    vt__vt_menu_element_kind__TOOLBAR=((int)1),
    vt_menu_element_kind__APPL_TOOLBAR=((int)2),
    vt__vt_menu_element_kind__APPL_TOOLBAR=((int)2),
    vt_menu_element_kind__MENU_COMPONENT=((int)3),
    vt__vt_menu_element_kind__MENU_COMPONENT=((int)3),
    vt_menu_element_kind__ACTION_GROUP=((int)4),
    vt__vt_menu_element_kind__ACTION_GROUP=((int)4)
} t__vt__vt_menu_element_kind;

#define d__vt__vt_menu_element_kind 4924

typedef t__vt__vt_menu_element_kind t__vt_menu_element_kind;

#define d__vt_menu_element_kind d__vt__vt_menu_element_kind

/* line 39 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_web_export_level'' */
typedef enum {
    vt_web_export_level__FINAL_ACTIVE=((int)0),
    vt__vt_web_export_level__FINAL_ACTIVE=((int)0),
    vt_web_export_level__ACTIVE=((int)1),
    vt__vt_web_export_level__ACTIVE=((int)1),
    vt_web_export_level__READONLY=((int)2),
    vt__vt_web_export_level__READONLY=((int)2),
    vt_web_export_level__DISABLED=((int)3),
    vt__vt_web_export_level__DISABLED=((int)3),
    vt_web_export_level__TEXTONLY=((int)4),
    vt__vt_web_export_level__TEXTONLY=((int)4),
    vt_web_export_level__EMPTY=((int)5),
    vt__vt_web_export_level__EMPTY=((int)5)
} t__vt__vt_web_export_level;

#define d__vt__vt_web_export_level 4785

typedef t__vt__vt_web_export_level t__vt_web_export_level;

#define d__vt_web_export_level d__vt__vt_web_export_level

/* line 7 "/vobs/specman/src/japp/shared_extra/shared_extra_user_api.e"  From 'Enum type 'vt_bool_tristate'' */
typedef enum {
    vt_bool_tristate__UNDEFINED=((int)0),
    vt__vt_bool_tristate__UNDEFINED=((int)0),
    vt_bool_tristate__TRUE_VALUE=((int)1),
    vt__vt_bool_tristate__TRUE_VALUE=((int)1),
    vt_bool_tristate__FALSE_VALUE=((int)2),
    vt__vt_bool_tristate__FALSE_VALUE=((int)2)
} t__vt__vt_bool_tristate;

#define d__vt__vt_bool_tristate 4010

typedef t__vt__vt_bool_tristate t__vt_bool_tristate;

#define d__vt_bool_tristate d__vt__vt_bool_tristate

/* line 51 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_element_kind'' */
typedef enum {
    vt_element_kind__UNDEFINED=((int)0),
    vt__vt_element_kind__UNDEFINED=((int)0),
    vt_element_kind__SIMPLE_TEXT=((int)1),
    vt__vt_element_kind__SIMPLE_TEXT=((int)1),
    vt_element_kind__NATIVE_HTML=((int)2),
    vt__vt_element_kind__NATIVE_HTML=((int)2),
    vt_element_kind__TEXTFIELD=((int)3),
    vt__vt_element_kind__TEXTFIELD=((int)3),
    vt_element_kind__PASSWORDFIELD=((int)4),
    vt__vt_element_kind__PASSWORDFIELD=((int)4),
    vt_element_kind__HIDDENFIELD=((int)5),
    vt__vt_element_kind__HIDDENFIELD=((int)5),
    vt_element_kind__TEXTAREA=((int)6),
    vt__vt_element_kind__TEXTAREA=((int)6),
    vt_element_kind__FILECHOOSER=((int)7),
    vt__vt_element_kind__FILECHOOSER=((int)7),
    vt_element_kind__BUTTON=((int)8),
    vt__vt_element_kind__BUTTON=((int)8),
    vt_element_kind__CHECKBOX=((int)9),
    vt__vt_element_kind__CHECKBOX=((int)9),
    vt_element_kind__RADIOBUTTON=((int)10),
    vt__vt_element_kind__RADIOBUTTON=((int)10),
    vt_element_kind__COMBOBOX=((int)11),
    vt__vt_element_kind__COMBOBOX=((int)11),
    vt_element_kind__LISTBOX=((int)12),
    vt__vt_element_kind__LISTBOX=((int)12),
    vt_element_kind__LABEL=((int)13),
    vt__vt_element_kind__LABEL=((int)13),
    vt_element_kind__PROGRESS=((int)14),
    vt__vt_element_kind__PROGRESS=((int)14),
    vt_element_kind__MEMBER_CHECKBOX=((int)15),
    vt__vt_element_kind__MEMBER_CHECKBOX=((int)15),
    vt_element_kind__MEMBER_RADIO_BUTTON=((int)16),
    vt__vt_element_kind__MEMBER_RADIO_BUTTON=((int)16),
    vt_element_kind__HYPERLINK=((int)17),
    vt__vt_element_kind__HYPERLINK=((int)17),
    vt_element_kind__GROUP=((int)18),
    vt__vt_element_kind__GROUP=((int)18),
    vt_element_kind__PAGE=((int)19),
    vt__vt_element_kind__PAGE=((int)19),
    vt_element_kind__STRIPE=((int)20),
    vt__vt_element_kind__STRIPE=((int)20),
    vt_element_kind__PANEL=((int)21),
    vt__vt_element_kind__PANEL=((int)21),
    vt_element_kind__IMAGE=((int)22),
    vt__vt_element_kind__IMAGE=((int)22),
    vt_element_kind__ANCHOR=((int)23),
    vt__vt_element_kind__ANCHOR=((int)23),
    vt_element_kind__TABLE=((int)24),
    vt__vt_element_kind__TABLE=((int)24),
    vt_element_kind__TAB_CONTROL=((int)25),
    vt__vt_element_kind__TAB_CONTROL=((int)25),
    vt_element_kind__SUBLIST_SELECTOR=((int)26),
    vt__vt_element_kind__SUBLIST_SELECTOR=((int)26),
    vt_element_kind__TAB_CONTROL_TAB=((int)27),
    vt__vt_element_kind__TAB_CONTROL_TAB=((int)27)
} t__vt__vt_element_kind;

#define d__vt__vt_element_kind 4789

typedef t__vt__vt_element_kind t__vt_element_kind;

#define d__vt_element_kind d__vt__vt_element_kind

/* line 97 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_element_basic_kind'' */
typedef enum {
    vt_element_basic_kind__SIMPLE=((int)0),
    vt__vt_element_basic_kind__SIMPLE=((int)0),
    vt_element_basic_kind__CONTROL=((int)1),
    vt__vt_element_basic_kind__CONTROL=((int)1),
    vt_element_basic_kind__CONTAINER=((int)2),
    vt__vt_element_basic_kind__CONTAINER=((int)2)
} t__vt__vt_element_basic_kind;

#define d__vt__vt_element_basic_kind 4791

typedef t__vt__vt_element_basic_kind t__vt_element_basic_kind;

#define d__vt_element_basic_kind d__vt__vt_element_basic_kind

/* line 48 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_page_kind'' */
typedef enum {
    vt_page_kind__ANY_PAGE=((int)0),
    vt__vt_page_kind__ANY_PAGE=((int)0),
    vt_page_kind__VT_HISTORY_PAGE=((int)1),
    vt__vt_page_kind__VT_HISTORY_PAGE=((int)1),
    vt_page_kind__ERROR_PAGE=((int)2),
    vt__vt_page_kind__ERROR_PAGE=((int)2),
    vt_page_kind__DECRYPTION_PASSWORD_PAGE=((int)3),
    vt__vt_page_kind__DECRYPTION_PASSWORD_PAGE=((int)3),
    vt_page_kind__EXPORT_MULTI_TABLE_PAGE=((int)4),
    vt__vt_page_kind__EXPORT_MULTI_TABLE_PAGE=((int)4),
    vt_page_kind__MESSAGE_INFO_PAGE=((int)5),
    vt__vt_page_kind__MESSAGE_INFO_PAGE=((int)5),
    vt_page_kind__VT_UTIL_PAGE=((int)6),
    vt__vt_page_kind__VT_UTIL_PAGE=((int)6),
    vt_page_kind__SEQ_BROWSER_PAGE=((int)7),
    vt__vt_page_kind__SEQ_BROWSER_PAGE=((int)7)
} t__vt__vt_page_kind;

#define d__vt__vt_page_kind 4787

typedef t__vt__vt_page_kind t__vt_page_kind;

#define d__vt_page_kind d__vt__vt_page_kind

/* line 1193 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'Enum type 'vt_html_definition_kind'' */
typedef enum {
    vt_html_definition_kind__UNDEFINED=((int)0),
    vt__vt_html_definition_kind__UNDEFINED=((int)0),
    vt_html_definition_kind__HTML_BODY=((int)1),
    vt__vt_html_definition_kind__HTML_BODY=((int)1),
    vt_html_definition_kind__FILE=((int)2),
    vt__vt_html_definition_kind__FILE=((int)2),
    vt_html_definition_kind__URL=((int)3),
    vt__vt_html_definition_kind__URL=((int)3)
} t__vt__vt_html_definition_kind;

#define d__vt__vt_html_definition_kind 5000

typedef t__vt__vt_html_definition_kind t__vt_html_definition_kind;

#define d__vt_html_definition_kind d__vt__vt_html_definition_kind

/* line 1191 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'Enum type 'vt_page_main_state'' */
typedef enum {
    vt_page_main_state__PRE_OPENED=((int)0),
    vt__vt_page_main_state__PRE_OPENED=((int)0),
    vt_page_main_state__OPENED=((int)1),
    vt__vt_page_main_state__OPENED=((int)1),
    vt_page_main_state__CLOSED=((int)2),
    vt__vt_page_main_state__CLOSED=((int)2)
} t__vt__vt_page_main_state;

#define d__vt__vt_page_main_state 4998

typedef t__vt__vt_page_main_state t__vt_page_main_state;

#define d__vt_page_main_state d__vt__vt_page_main_state

/* line 100 "/vobs/specman/src/vt_util/vt_util_sd.e"  From 'Enum type 'seq_dbg_page_kind'' */
typedef enum {
    seq_dbg_page_kind__VT_SEQ_PAGE=((int)0),
    sn__seq_dbg_page_kind__VT_SEQ_PAGE=((int)0),
    seq_dbg_page_kind__VT_SEQ_DRIVER_PAGE=((int)1),
    sn__seq_dbg_page_kind__VT_SEQ_DRIVER_PAGE=((int)1),
    seq_dbg_page_kind__VT_TOP_SEQ_PAGE=((int)2),
    sn__seq_dbg_page_kind__VT_TOP_SEQ_PAGE=((int)2),
    seq_dbg_page_kind__VT_TOP_DRIVER_PAGE=((int)3),
    sn__seq_dbg_page_kind__VT_TOP_DRIVER_PAGE=((int)3),
    seq_dbg_page_kind__VT_SEQ_HELP_PAGE=((int)4),
    sn__seq_dbg_page_kind__VT_SEQ_HELP_PAGE=((int)4)
} t__sn__seq_dbg_page_kind;

#define d__sn__seq_dbg_page_kind 7916

typedef t__sn__seq_dbg_page_kind t__seq_dbg_page_kind;

#define d__seq_dbg_page_kind d__sn__seq_dbg_page_kind

/* line 6 "/vobs/specman/src/vt_html/vt_html_utils_user_api.e"  From 'Enum type 'vt_halign'' */
typedef enum {
    vt_halign__VT_DEFAULT=((int)0),
    vt__vt_halign__VT_DEFAULT=((int)0),
    vt_halign__VT_LEFT=((int)1),
    vt__vt_halign__VT_LEFT=((int)1),
    vt_halign__VT_CENTER=((int)2),
    vt__vt_halign__VT_CENTER=((int)2),
    vt_halign__VT_RIGHT=((int)3),
    vt__vt_halign__VT_RIGHT=((int)3)
} t__vt__vt_halign;

#define d__vt__vt_halign 7792

typedef t__vt__vt_halign t__vt_halign;

#define d__vt_halign d__vt__vt_halign

/* line 12 "/vobs/specman/src/vt_table/vt_table_user_api.e"  From 'Enum type 'vt_auto_mode_kind'' */
typedef enum {
    vt_auto_mode_kind__ALWAYS=((int)0),
    vt__vt_auto_mode_kind__ALWAYS=((int)0),
    vt_auto_mode_kind__AUTO_WITH_HANDLE=((int)1),
    vt__vt_auto_mode_kind__AUTO_WITH_HANDLE=((int)1),
    vt_auto_mode_kind__AUTO=((int)2),
    vt__vt_auto_mode_kind__AUTO=((int)2)
} t__vt__vt_auto_mode_kind;

#define d__vt__vt_auto_mode_kind 7813

typedef t__vt__vt_auto_mode_kind t__vt_auto_mode_kind;

#define d__vt_auto_mode_kind d__vt__vt_auto_mode_kind

/* line 18 "/vobs/specman/src/vt_table/vt_table_user_api.e"  From 'Enum type 'vt_table_status_bar_visibility'' */
typedef enum {
    vt_table_status_bar_visibility__UNDEFINED=((int)0),
    vt__vt_table_status_bar_visibility__UNDEFINED=((int)0),
    vt_table_status_bar_visibility__FULLY_HIDDEN=((int)1),
    vt__vt_table_status_bar_visibility__FULLY_HIDDEN=((int)1),
    vt_table_status_bar_visibility__ONLY_HANDLE_VISIBLE=((int)2),
    vt__vt_table_status_bar_visibility__ONLY_HANDLE_VISIBLE=((int)2),
    vt_table_status_bar_visibility__FULLY_VISIBLE=((int)3),
    vt__vt_table_status_bar_visibility__FULLY_VISIBLE=((int)3)
} t__vt__vt_table_status_bar_visibility;

#define d__vt__vt_table_status_bar_visibility 7817

typedef t__vt__vt_table_status_bar_visibility t__vt_table_status_bar_visibility;

#define d__vt_table_status_bar_visibility d__vt__vt_table_status_bar_visibility

/* line 11 "/vobs/specman/src/vt_table/vt_table_defs.e"  From 'Enum type 'vt_table_row_mode'' */
typedef enum {
    vt_table_row_mode__UNDEFINED=((int)0),
    vt__vt_table_row_mode__UNDEFINED=((int)0),
    vt_table_row_mode__FULL=((int)1),
    vt__vt_table_row_mode__FULL=((int)1),
    vt_table_row_mode__LAZY=((int)2),
    vt__vt_table_row_mode__LAZY=((int)2)
} t__vt__vt_table_row_mode;

#define d__vt__vt_table_row_mode 7838

typedef t__vt__vt_table_row_mode t__vt_table_row_mode;

#define d__vt_table_row_mode d__vt__vt_table_row_mode

/* line 22 "/vobs/specman/src/vt_table/vt_table_user_api.e"  From 'Enum type 'vt_table_sort_direction'' */
typedef enum {
    vt_table_sort_direction__ASCENDING=((int)0),
    vt__vt_table_sort_direction__ASCENDING=((int)0),
    vt_table_sort_direction__DESCENDING=((int)1),
    vt__vt_table_sort_direction__DESCENDING=((int)1),
    vt_table_sort_direction__NONE=((int)2),
    vt__vt_table_sort_direction__NONE=((int)2)
} t__vt__vt_table_sort_direction;

#define d__vt__vt_table_sort_direction 7819

typedef t__vt__vt_table_sort_direction t__vt_table_sort_direction;

#define d__vt_table_sort_direction d__vt__vt_table_sort_direction

/* line 106 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_image_alignment'' */
typedef enum {
    vt_image_alignment__undefined=((int)0),
    vt__vt_image_alignment__undefined=((int)0),
    vt_image_alignment__top=((int)1),
    vt__vt_image_alignment__top=((int)1),
    vt_image_alignment__middle=((int)2),
    vt__vt_image_alignment__middle=((int)2),
    vt_image_alignment__baseline=((int)3),
    vt__vt_image_alignment__baseline=((int)3),
    vt_image_alignment__bottom=((int)4),
    vt__vt_image_alignment__bottom=((int)4),
    vt_image_alignment__left=((int)5),
    vt__vt_image_alignment__left=((int)5),
    vt_image_alignment__right=((int)6),
    vt__vt_image_alignment__right=((int)6),
    vt_image_alignment__texttop=((int)7),
    vt__vt_image_alignment__texttop=((int)7),
    vt_image_alignment__absmiddle=((int)8),
    vt__vt_image_alignment__absmiddle=((int)8),
    vt_image_alignment__absbottom=((int)9),
    vt__vt_image_alignment__absbottom=((int)9)
} t__vt__vt_image_alignment;

#define d__vt__vt_image_alignment 4797

typedef t__vt__vt_image_alignment t__vt_image_alignment;

#define d__vt_image_alignment d__vt__vt_image_alignment

/* line 15 "/vobs/specman/src/vt_table/vt_table_user_api.e"  From 'Enum type 'vt_table_col_kind'' */
typedef enum {
    vt_table_col_kind__UNDEFINED=((int)0),
    vt__vt_table_col_kind__UNDEFINED=((int)0),
    vt_table_col_kind__STRING=((int)1),
    vt__vt_table_col_kind__STRING=((int)1),
    vt_table_col_kind__NUMBER=((int)2),
    vt__vt_table_col_kind__NUMBER=((int)2),
    vt_table_col_kind__BOOLEAN=((int)3),
    vt__vt_table_col_kind__BOOLEAN=((int)3),
    vt_table_col_kind__ICON=((int)4),
    vt__vt_table_col_kind__ICON=((int)4)
} t__vt__vt_table_col_kind;

#define d__vt__vt_table_col_kind 7815

typedef t__vt__vt_table_col_kind t__vt_table_col_kind;

#define d__vt_table_col_kind d__vt__vt_table_col_kind

/* line 2413 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'Enum type 'vt_filter_kind'' */
typedef enum {
    vt_filter_kind__All=((int)0),
    vt__vt_filter_kind__All=((int)0),
    vt_filter_kind__Blanks=((int)1),
    vt__vt_filter_kind__Blanks=((int)1),
    vt_filter_kind__Non_Blanks=((int)2),
    vt__vt_filter_kind__Non_Blanks=((int)2)
} t__vt__vt_filter_kind;

#define d__vt__vt_filter_kind 4876

typedef t__vt__vt_filter_kind t__vt_filter_kind;

#define d__vt_filter_kind d__vt__vt_filter_kind

/* line 3449 "/vobs/specman/src/sequence_imp.e"  From 'Enum type 'sn_seq_debug_state'' */
typedef enum {
    sn_seq_debug_state__in_pre_body=((int)0),
    sn__sn_seq_debug_state__in_pre_body=((int)0),
    sn_seq_debug_state__in_body=((int)1),
    sn__sn_seq_debug_state__in_body=((int)1),
    sn_seq_debug_state__in_post_body=((int)2),
    sn__sn_seq_debug_state__in_post_body=((int)2),
    sn_seq_debug_state__stopped=((int)3),
    sn__sn_seq_debug_state__stopped=((int)3),
    sn_seq_debug_state__ended=((int)4),
    sn__sn_seq_debug_state__ended=((int)4),
    sn_seq_debug_state__unknown=((int)5),
    sn__sn_seq_debug_state__unknown=((int)5)
} t__sn__sn_seq_debug_state;

#define d__sn__sn_seq_debug_state 7730

typedef t__sn__sn_seq_debug_state t__sn_seq_debug_state;

#define d__sn_seq_debug_state d__sn__sn_seq_debug_state

/* line 3463 "/vobs/specman/src/sequence_imp.e"  From 'Enum type 'sn_do_debug_state'' */
typedef enum {
    sn_do_debug_state__wait_until_chosen=((int)0),
    sn__sn_do_debug_state__wait_until_chosen=((int)0),
    sn_do_debug_state__in_pre_do=((int)1),
    sn__sn_do_debug_state__in_pre_do=((int)1),
    sn_do_debug_state__in_gen=((int)2),
    sn__sn_do_debug_state__in_gen=((int)2),
    sn_do_debug_state__in_bfm=((int)3),
    sn__sn_do_debug_state__in_bfm=((int)3),
    sn_do_debug_state__in_body=((int)4),
    sn__sn_do_debug_state__in_body=((int)4),
    sn_do_debug_state__in_post_do=((int)5),
    sn__sn_do_debug_state__in_post_do=((int)5),
    sn_do_debug_state__unknown=((int)6),
    sn__sn_do_debug_state__unknown=((int)6)
} t__sn__sn_do_debug_state;

#define d__sn__sn_do_debug_state 7732

typedef t__sn__sn_do_debug_state t__sn_do_debug_state;

#define d__sn_do_debug_state d__sn__sn_do_debug_state

/* line 645 "/vobs/specman/src/sequence_imp.e"  From 'Enum type 'bfm_interaction_mode_t'' */
typedef enum {
    bfm_interaction_mode_t__PULL_MODE=((int)0),
    sn__bfm_interaction_mode_t__PULL_MODE=((int)0),
    bfm_interaction_mode_t__PUSH_MODE=((int)1),
    sn__bfm_interaction_mode_t__PUSH_MODE=((int)1)
} t__sn__bfm_interaction_mode_t;

#define d__sn__bfm_interaction_mode_t 7724

typedef t__sn__bfm_interaction_mode_t t__bfm_interaction_mode_t;

#define d__bfm_interaction_mode_t d__sn__bfm_interaction_mode_t

/* line 1820 "/vobs/specman/src/sequence_imp.e"  From 'Enum type 'sn_sequence_trace_kind'' */
typedef enum {
    sn_sequence_trace_kind__off=((int)0),
    sn__sn_sequence_trace_kind__off=((int)0),
    sn_sequence_trace_kind__log_only=((int)1),
    sn__sn_sequence_trace_kind__log_only=((int)1),
    sn_sequence_trace_kind__on=((int)2),
    sn__sn_sequence_trace_kind__on=((int)2),
    sn_sequence_trace_kind__msg_only=((int)3),
    sn__sn_sequence_trace_kind__msg_only=((int)3),
    sn_sequence_trace_kind__full=((int)4),
    sn__sn_sequence_trace_kind__full=((int)4)
} t__sn__sn_sequence_trace_kind;

#define d__sn__sn_sequence_trace_kind 7727

typedef t__sn__sn_sequence_trace_kind t__sn_sequence_trace_kind;

#define d__sn_sequence_trace_kind d__sn__sn_sequence_trace_kind

/* line 3478 "/vobs/specman/src/sequence_imp.e"  From 'Enum type 'sn_driver_debug_state'' */
typedef enum {
    sn_driver_debug_state__trying_to_choose_do=((int)0),
    sn__sn_driver_debug_state__trying_to_choose_do=((int)0),
    sn_driver_debug_state__processing_do=((int)1),
    sn__sn_driver_debug_state__processing_do=((int)1),
    sn_driver_debug_state__item_in_bfm=((int)2),
    sn__sn_driver_debug_state__item_in_bfm=((int)2),
    sn_driver_debug_state__idle=((int)3),
    sn__sn_driver_debug_state__idle=((int)3),
    sn_driver_debug_state__try_next_item_fail=((int)4),
    sn__sn_driver_debug_state__try_next_item_fail=((int)4),
    sn_driver_debug_state__unknown=((int)5),
    sn__sn_driver_debug_state__unknown=((int)5)
} t__sn__sn_driver_debug_state;

#define d__sn__sn_driver_debug_state 7734

typedef t__sn__sn_driver_debug_state t__sn_driver_debug_state;

#define d__sn_driver_debug_state d__sn__sn_driver_debug_state

/* line 23 "/vobs/specman/src/sequence_imp.e"  From 'Enum type 'do_request_status'' */
typedef enum {
    do_request_status__do_pending=((int)0),
    sn__do_request_status__do_pending=((int)0),
    do_request_status__do_grant=((int)1),
    sn__do_request_status__do_grant=((int)1),
    do_request_status__item_done_recieved=((int)2),
    sn__do_request_status__item_done_recieved=((int)2),
    do_request_status__aborted=((int)3),
    sn__do_request_status__aborted=((int)3)
} t__sn__do_request_status;

#define d__sn__do_request_status 7719

typedef t__sn__do_request_status t__do_request_status;

#define d__do_request_status d__sn__do_request_status

/* line 55 "/vobs/specman/src/wave_transactions.e"  From 'Enum type 'sn_transaction_external_info_state_t'' */
typedef enum {
    sn_transaction_external_info_state_t__FREE=((int)0),
    sn__sn_transaction_external_info_state_t__FREE=((int)0),
    sn_transaction_external_info_state_t__BEGUN=((int)1),
    sn__sn_transaction_external_info_state_t__BEGUN=((int)1),
    sn_transaction_external_info_state_t__ENDED=((int)2),
    sn__sn_transaction_external_info_state_t__ENDED=((int)2)
} t__sn__sn_transaction_external_info_state_t;

#define d__sn__sn_transaction_external_info_state_t 4380

typedef t__sn__sn_transaction_external_info_state_t t__sn_transaction_external_info_state_t;

#define d__sn_transaction_external_info_state_t d__sn__sn_transaction_external_info_state_t

/* line 63 "/vobs/specman/src/wave_transactions_api.e"  From 'Enum type 'transaction_database_kind_t'' */
typedef enum {
    transaction_database_kind_t__sst2=((int)0),
    sn__transaction_database_kind_t__sst2=((int)0)
} t__sn__transaction_database_kind_t;

#define d__sn__transaction_database_kind_t 4376

typedef t__sn__transaction_database_kind_t t__transaction_database_kind_t;

#define d__transaction_database_kind_t d__sn__transaction_database_kind_t

/* line 26 "/vobs/specman/src/dut_error.e"  From 'Enum type 'check_effect'' */
typedef enum {
    check_effect__ERROR=((int)0),
    sn__check_effect__ERROR=((int)0),
    check_effect__ERROR_BREAK_RUN=((int)1),
    sn__check_effect__ERROR_BREAK_RUN=((int)1),
    check_effect__ERROR_AUTOMATIC=((int)2),
    sn__check_effect__ERROR_AUTOMATIC=((int)2),
    check_effect__ERROR_CONTINUE=((int)3),
    sn__check_effect__ERROR_CONTINUE=((int)3),
    check_effect__WARNING=((int)4),
    sn__check_effect__WARNING=((int)4),
    check_effect__IGNORE=((int)5),
    sn__check_effect__IGNORE=((int)5)
} t__sn__check_effect;

#define d__sn__check_effect 1318

typedef t__sn__check_effect t__check_effect;

#define d__check_effect d__sn__check_effect

/* line 41 "/vobs/specman/src/cover_base_structs.e"  From 'Enum type 'sn_cai_ass_agent_type'' */
typedef enum {
    sn_cai_ass_agent_type__none=((int)0),
    main__sn_cai_ass_agent_type__none=((int)0)
} t__main__sn_cai_ass_agent_type;

#define d__main__sn_cai_ass_agent_type 3590

typedef t__main__sn_cai_ass_agent_type t__sn_cai_ass_agent_type;

#define d__sn_cai_ass_agent_type d__main__sn_cai_ass_agent_type

/* line 55 "/vobs/specman/src/cover_jcvr.e"  From 'Enum type 'jcvr_pack_mode'' */
typedef enum {
    jcvr_pack_mode__property=((int)0),
    main__jcvr_pack_mode__property=((int)0),
    jcvr_pack_mode__shallow=((int)1),
    main__jcvr_pack_mode__shallow=((int)1),
    jcvr_pack_mode__deep=((int)2),
    main__jcvr_pack_mode__deep=((int)2),
    jcvr_pack_mode__item_type=((int)3),
    main__jcvr_pack_mode__item_type=((int)3)
} t__main__jcvr_pack_mode;

#define d__main__jcvr_pack_mode 3884

typedef t__main__jcvr_pack_mode t__jcvr_pack_mode;

#define d__jcvr_pack_mode d__main__jcvr_pack_mode

/* line 29 "/vobs/specman/src/cover_checks.e"  From 'Enum type 'sn_check_collection_t'' */
typedef enum {
    sn_check_collection_t__DEFAULT=((int)0),
    main__sn_check_collection_t__DEFAULT=((int)0),
    sn_check_collection_t__ON=((int)1),
    main__sn_check_collection_t__ON=((int)1),
    sn_check_collection_t__OFF=((int)2),
    main__sn_check_collection_t__OFF=((int)2)
} t__main__sn_check_collection_t;

#define d__main__sn_check_collection_t 7488

typedef t__main__sn_check_collection_t t__sn_check_collection_t;

#define d__sn_check_collection_t d__main__sn_check_collection_t

/* line 13 "/vobs/specman/src/wave_test.e"  From 'Enum type 'wave_execution_mode'' */
typedef enum {
    wave_execution_mode__normal=((int)0),
    sn__wave_execution_mode__normal=((int)0),
    wave_execution_mode__testing=((int)1),
    sn__wave_execution_mode__testing=((int)1)
} t__sn__wave_execution_mode;

#define d__sn__wave_execution_mode 2168

typedef t__sn__wave_execution_mode t__wave_execution_mode;

#define d__wave_execution_mode d__sn__wave_execution_mode

/* line 16 "/vobs/specman/src/config_main.e"  From 'Enum type 'waveform_kind'' */
typedef enum {
    waveform_kind__none=((int)0),
    sn__waveform_kind__none=((int)0),
    waveform_kind__unknown=((int)1),
    sn__waveform_kind__unknown=((int)1),
    waveform_kind__signalscan=((int)2),
    sn__waveform_kind__signalscan=((int)2),
    waveform_kind__novas=((int)3),
    sn__waveform_kind__novas=((int)3),
    waveform_kind__virsim=((int)4),
    sn__waveform_kind__virsim=((int)4),
    waveform_kind__mti=((int)5),
    sn__waveform_kind__mti=((int)5),
    waveform_kind__undertow=((int)6),
    sn__waveform_kind__undertow=((int)6),
    waveform_kind__simvision=((int)7),
    sn__waveform_kind__simvision=((int)7)
} t__sn__waveform_kind;

#define d__sn__waveform_kind 1349

typedef t__sn__waveform_kind t__waveform_kind;

#define d__waveform_kind d__sn__waveform_kind

/* line 37 "/vobs/specman/src/config_main.e"  From 'Enum type 'auto_gc_setting'gc_type'' */
typedef enum {
    auto_gc_setting__gc_type__COPY=((int)0),
    sn__auto_gc_setting__gc_type__COPY=((int)0),
    auto_gc_setting__gc_type__OTF=((int)1),
    sn__auto_gc_setting__gc_type__OTF=((int)1),
    auto_gc_setting__gc_type__DISK=((int)2),
    sn__auto_gc_setting__gc_type__DISK=((int)2)
} t__imp_enum_sn__auto_gc_setting__gc_type;

#define d__imp_enum_sn__auto_gc_setting__gc_type 1411

typedef t__imp_enum_sn__auto_gc_setting__gc_type t__imp_enum_auto_gc_setting__gc_type;

#define d__imp_enum_auto_gc_setting__gc_type d__imp_enum_sn__auto_gc_setting__gc_type

/* line 280 "/vobs/specman/src/packing.e"  From 'Enum type 'pack_originate_from'' */
typedef enum {
    pack_originate_from__exp=((int)0),
    sn__pack_originate_from__exp=((int)0),
    pack_originate_from__field=((int)1),
    sn__pack_originate_from__field=((int)1),
    pack_originate_from__list=((int)2),
    sn__pack_originate_from__list=((int)2),
    pack_originate_from__packed_list=((int)3),
    sn__pack_originate_from__packed_list=((int)3)
} t__sn__pack_originate_from;

#define d__sn__pack_originate_from 1558

typedef t__sn__pack_originate_from t__pack_originate_from;

#define d__pack_originate_from d__sn__pack_originate_from

/* line 2028 "/vobs/specman/src/packing.e"  From 'Enum type 'sn_vttp_status'' */
typedef enum {
    sn_vttp_status__none=((int)0),
    sn__sn_vttp_status__none=((int)0),
    sn_vttp_status__wip=((int)1),
    sn__sn_vttp_status__wip=((int)1),
    sn_vttp_status__done=((int)2),
    sn__sn_vttp_status__done=((int)2)
} t__sn__sn_vttp_status;

#define d__sn__sn_vttp_status 1570

typedef t__sn__sn_vttp_status t__sn_vttp_status;

#define d__sn_vttp_status d__sn__sn_vttp_status

/* line 14 "/vobs/specman/src/ea/eanalyzer_defs.e"  From 'Enum type 'eanalyzer_phase'' */
typedef enum {
    eanalyzer_phase__none=((int)0),
    ea__eanalyzer_phase__none=((int)0),
    eanalyzer_phase__load=((int)1),
    ea__eanalyzer_phase__load=((int)1),
    eanalyzer_phase__gen=((int)2),
    ea__eanalyzer_phase__gen=((int)2),
    eanalyzer_phase__user=((int)3),
    ea__eanalyzer_phase__user=((int)3)
} t__ea__eanalyzer_phase;

#define d__ea__eanalyzer_phase 1913

typedef t__ea__eanalyzer_phase t__eanalyzer_phase;

#define d__eanalyzer_phase d__ea__eanalyzer_phase

/* line 13 "/vobs/specman/src/ea/eanalyzer_defs.e"  From 'Enum type 'eanalyzer_category_t'' */
typedef enum {
    eanalyzer_category_t__LNT=((int)0),
    ea__eanalyzer_category_t__LNT=((int)0),
    eanalyzer_category_t__GEN=((int)1),
    ea__eanalyzer_category_t__GEN=((int)1),
    eanalyzer_category_t__ERM=((int)2),
    ea__eanalyzer_category_t__ERM=((int)2),
    eanalyzer_category_t__CDV=((int)3),
    ea__eanalyzer_category_t__CDV=((int)3),
    eanalyzer_category_t__STY=((int)4),
    ea__eanalyzer_category_t__STY=((int)4),
    eanalyzer_category_t__PRF=((int)5),
    ea__eanalyzer_category_t__PRF=((int)5),
    eanalyzer_category_t__ERM_INTERNAL=((int)6),
    ea__eanalyzer_category_t__ERM_INTERNAL=((int)6)
} t__ea__eanalyzer_category_t;

#define d__ea__eanalyzer_category_t 1911

typedef t__ea__eanalyzer_category_t t__eanalyzer_category_t;

#define d__eanalyzer_category_t d__ea__eanalyzer_category_t

/* line 11 "/vobs/specman/src/cover_api.e"  From 'Enum type 'bucket_status'' */
typedef enum {
    bucket_status__illegal=((int)0),
    main__bucket_status__illegal=((int)0),
    bucket_status__normal=((int)1),
    main__bucket_status__normal=((int)1),
    bucket_status__hole=((int)2),
    main__bucket_status__hole=((int)2),
    bucket_status__ignore=((int)3),
    main__bucket_status__ignore=((int)3),
    bucket_status__invalid=((int)4),
    main__bucket_status__invalid=((int)4)
} t__main__bucket_status;

#define d__main__bucket_status 3874

typedef t__main__bucket_status t__bucket_status;

#define d__bucket_status d__main__bucket_status

/* line 74 "/vobs/specman/src/ea/erm/ea_elint_checklist.e"  From 'Enum type 'ea_sn_ea_elint_msg_tag'' */
typedef enum {
    ea_sn_ea_elint_msg_tag__PK_NAME=((int)0),
    sn__ea_sn_ea_elint_msg_tag__PK_NAME=((int)0),
    ea_sn_ea_elint_msg_tag__PK_DIR=((int)1),
    sn__ea_sn_ea_elint_msg_tag__PK_DIR=((int)1),
    ea_sn_ea_elint_msg_tag__PK_README=((int)2),
    sn__ea_sn_ea_elint_msg_tag__PK_README=((int)2),
    ea_sn_ea_elint_msg_tag__PK_DIST_FORMAT=((int)3),
    sn__ea_sn_ea_elint_msg_tag__PK_DIST_FORMAT=((int)3),
    ea_sn_ea_elint_msg_tag__PK_DIR_STRUCTURE=((int)4),
    sn__ea_sn_ea_elint_msg_tag__PK_DIR_STRUCTURE=((int)4),
    ea_sn_ea_elint_msg_tag__PK_DEMO=((int)5),
    sn__ea_sn_ea_elint_msg_tag__PK_DEMO=((int)5),
    ea_sn_ea_elint_msg_tag__PK_DEMO_RUN=((int)6),
    sn__ea_sn_ea_elint_msg_tag__PK_DEMO_RUN=((int)6),
    ea_sn_ea_elint_msg_tag__PK_GOLDEN_EVC=((int)7),
    sn__ea_sn_ea_elint_msg_tag__PK_GOLDEN_EVC=((int)7),
    ea_sn_ea_elint_msg_tag__PK_SIM_SUPPORT=((int)8),
    sn__ea_sn_ea_elint_msg_tag__PK_SIM_SUPPORT=((int)8),
    ea_sn_ea_elint_msg_tag__PK_SIM_DOC=((int)9),
    sn__ea_sn_ea_elint_msg_tag__PK_SIM_DOC=((int)9),
    ea_sn_ea_elint_msg_tag__PK_FILE_NAME=((int)10),
    sn__ea_sn_ea_elint_msg_tag__PK_FILE_NAME=((int)10),
    ea_sn_ea_elint_msg_tag__PK_TYPE_NAME=((int)11),
    sn__ea_sn_ea_elint_msg_tag__PK_TYPE_NAME=((int)11),
    ea_sn_ea_elint_msg_tag__PK_DEFINE_NAME=((int)12),
    sn__ea_sn_ea_elint_msg_tag__PK_DEFINE_NAME=((int)12),
    ea_sn_ea_elint_msg_tag__PK_TYPE_EXT=((int)13),
    sn__ea_sn_ea_elint_msg_tag__PK_TYPE_EXT=((int)13),
    ea_sn_ea_elint_msg_tag__PK_TOP_FILE=((int)14),
    sn__ea_sn_ea_elint_msg_tag__PK_TOP_FILE=((int)14),
    ea_sn_ea_elint_msg_tag__PK_EX_DOC=((int)15),
    sn__ea_sn_ea_elint_msg_tag__PK_EX_DOC=((int)15),
    ea_sn_ea_elint_msg_tag__PK_EX_DOC_DETAILS=((int)16),
    sn__ea_sn_ea_elint_msg_tag__PK_EX_DOC_DETAILS=((int)16),
    ea_sn_ea_elint_msg_tag__PK_VER_NO=((int)17),
    sn__ea_sn_ea_elint_msg_tag__PK_VER_NO=((int)17),
    ea_sn_ea_elint_msg_tag__PK_TAR_FILE=((int)18),
    sn__ea_sn_ea_elint_msg_tag__PK_TAR_FILE=((int)18),
    ea_sn_ea_elint_msg_tag__PK_GLOBAL_EXT=((int)19),
    sn__ea_sn_ea_elint_msg_tag__PK_GLOBAL_EXT=((int)19),
    ea_sn_ea_elint_msg_tag__PK_ENUM_EXT=((int)20),
    sn__ea_sn_ea_elint_msg_tag__PK_ENUM_EXT=((int)20),
    ea_sn_ea_elint_msg_tag__PK_GLOBAL_EXT_NAME=((int)21),
    sn__ea_sn_ea_elint_msg_tag__PK_GLOBAL_EXT_NAME=((int)21),
    ea_sn_ea_elint_msg_tag__PK_CONFIG_TEMPLATE=((int)22),
    sn__ea_sn_ea_elint_msg_tag__PK_CONFIG_TEMPLATE=((int)22),
    ea_sn_ea_elint_msg_tag__PK_ENCAPSULATION=((int)23),
    sn__ea_sn_ea_elint_msg_tag__PK_ENCAPSULATION=((int)23),
    ea_sn_ea_elint_msg_tag__PK_PACKAGE_NAME=((int)24),
    sn__ea_sn_ea_elint_msg_tag__PK_PACKAGE_NAME=((int)24),
    ea_sn_ea_elint_msg_tag__PK_MULTI_PACKAGES=((int)25),
    sn__ea_sn_ea_elint_msg_tag__PK_MULTI_PACKAGES=((int)25),
    ea_sn_ea_elint_msg_tag__PK_PROTECTION=((int)26),
    sn__ea_sn_ea_elint_msg_tag__PK_PROTECTION=((int)26),
    ea_sn_ea_elint_msg_tag__PK_IMPORTS=((int)27),
    sn__ea_sn_ea_elint_msg_tag__PK_IMPORTS=((int)27),
    ea_sn_ea_elint_msg_tag__RS_RS_SUPPORT=((int)28),
    sn__ea_sn_ea_elint_msg_tag__RS_RS_SUPPORT=((int)28),
    ea_sn_ea_elint_msg_tag__RS_RS_CHECKS=((int)29),
    sn__ea_sn_ea_elint_msg_tag__RS_RS_CHECKS=((int)29),
    ea_sn_ea_elint_msg_tag__RS_MULTI_RS=((int)30),
    sn__ea_sn_ea_elint_msg_tag__RS_MULTI_RS=((int)30),
    ea_sn_ea_elint_msg_tag__RS_MULTI_RS_CHK=((int)31),
    sn__ea_sn_ea_elint_msg_tag__RS_MULTI_RS_CHK=((int)31),
    ea_sn_ea_elint_msg_tag__RS_PROG_RS=((int)32),
    sn__ea_sn_ea_elint_msg_tag__RS_PROG_RS=((int)32),
    ea_sn_ea_elint_msg_tag__RS_CLK_GEN=((int)33),
    sn__ea_sn_ea_elint_msg_tag__RS_CLK_GEN=((int)33),
    ea_sn_ea_elint_msg_tag__RS_DUT_CLK=((int)34),
    sn__ea_sn_ea_elint_msg_tag__RS_DUT_CLK=((int)34),
    ea_sn_ea_elint_msg_tag__RS_CLK_USE=((int)35),
    sn__ea_sn_ea_elint_msg_tag__RS_CLK_USE=((int)35),
    ea_sn_ea_elint_msg_tag__CH_CHECKS_EXPECTS=((int)36),
    sn__ea_sn_ea_elint_msg_tag__CH_CHECKS_EXPECTS=((int)36),
    ea_sn_ea_elint_msg_tag__CH_PROTOCOL_CHECKS=((int)37),
    sn__ea_sn_ea_elint_msg_tag__CH_PROTOCOL_CHECKS=((int)37),
    ea_sn_ea_elint_msg_tag__CH_DUT_ERR=((int)38),
    sn__ea_sn_ea_elint_msg_tag__CH_DUT_ERR=((int)38),
    ea_sn_ea_elint_msg_tag__CH_ERR_MSG=((int)39),
    sn__ea_sn_ea_elint_msg_tag__CH_ERR_MSG=((int)39),
    ea_sn_ea_elint_msg_tag__CH_ERR_MSG_DOC=((int)40),
    sn__ea_sn_ea_elint_msg_tag__CH_ERR_MSG_DOC=((int)40),
    ea_sn_ea_elint_msg_tag__CH_DUT=((int)41),
    sn__ea_sn_ea_elint_msg_tag__CH_DUT=((int)41),
    ea_sn_ea_elint_msg_tag__CH_SCOREBOARD=((int)42),
    sn__ea_sn_ea_elint_msg_tag__CH_SCOREBOARD=((int)42),
    ea_sn_ea_elint_msg_tag__CH_EXPECT_NAME=((int)43),
    sn__ea_sn_ea_elint_msg_tag__CH_EXPECT_NAME=((int)43),
    ea_sn_ea_elint_msg_tag__CV_COV_GRP=((int)44),
    sn__ea_sn_ea_elint_msg_tag__CV_COV_GRP=((int)44),
    ea_sn_ea_elint_msg_tag__CV_COV_ITM=((int)45),
    sn__ea_sn_ea_elint_msg_tag__CV_COV_ITM=((int)45),
    ea_sn_ea_elint_msg_tag__CV_COV_CROSS=((int)46),
    sn__ea_sn_ea_elint_msg_tag__CV_COV_CROSS=((int)46),
    ea_sn_ea_elint_msg_tag__CV_COV_RES=((int)47),
    sn__ea_sn_ea_elint_msg_tag__CV_COV_RES=((int)47),
    ea_sn_ea_elint_msg_tag__AR_SIG_DEF=((int)48),
    sn__ea_sn_ea_elint_msg_tag__AR_SIG_DEF=((int)48),
    ea_sn_ea_elint_msg_tag__AR_SIG_MAP=((int)49),
    sn__ea_sn_ea_elint_msg_tag__AR_SIG_MAP=((int)49),
    ea_sn_ea_elint_msg_tag__AR_HW_ACCESS=((int)50),
    sn__ea_sn_ea_elint_msg_tag__AR_HW_ACCESS=((int)50),
    ea_sn_ea_elint_msg_tag__AR_INST=((int)51),
    sn__ea_sn_ea_elint_msg_tag__AR_INST=((int)51),
    ea_sn_ea_elint_msg_tag__AR_MON=((int)52),
    sn__ea_sn_ea_elint_msg_tag__AR_MON=((int)52),
    ea_sn_ea_elint_msg_tag__AR_ACTIVE_AGENTS=((int)53),
    sn__ea_sn_ea_elint_msg_tag__AR_ACTIVE_AGENTS=((int)53),
    ea_sn_ea_elint_msg_tag__AR_BFM=((int)54),
    sn__ea_sn_ea_elint_msg_tag__AR_BFM=((int)54),
    ea_sn_ea_elint_msg_tag__AR_EVC_NAME=((int)55),
    sn__ea_sn_ea_elint_msg_tag__AR_EVC_NAME=((int)55),
    ea_sn_ea_elint_msg_tag__AR_AGENT_CHECK=((int)56),
    sn__ea_sn_ea_elint_msg_tag__AR_AGENT_CHECK=((int)56),
    ea_sn_ea_elint_msg_tag__AR_BFM_SIG=((int)57),
    sn__ea_sn_ea_elint_msg_tag__AR_BFM_SIG=((int)57),
    ea_sn_ea_elint_msg_tag__AR_AGENT_WITH_BFM=((int)58),
    sn__ea_sn_ea_elint_msg_tag__AR_AGENT_WITH_BFM=((int)58),
    ea_sn_ea_elint_msg_tag__AR_BFM_IN_AGENT=((int)59),
    sn__ea_sn_ea_elint_msg_tag__AR_BFM_IN_AGENT=((int)59),
    ea_sn_ea_elint_msg_tag__AR_SCOREBOARD=((int)60),
    sn__ea_sn_ea_elint_msg_tag__AR_SCOREBOARD=((int)60),
    ea_sn_ea_elint_msg_tag__SQ_BFM_PTR=((int)61),
    sn__ea_sn_ea_elint_msg_tag__SQ_BFM_PTR=((int)61),
    ea_sn_ea_elint_msg_tag__SQ_BFM_CTRL=((int)62),
    sn__ea_sn_ea_elint_msg_tag__SQ_BFM_CTRL=((int)62),
    ea_sn_ea_elint_msg_tag__SQ_VIRTUAL_SD=((int)63),
    sn__ea_sn_ea_elint_msg_tag__SQ_VIRTUAL_SD=((int)63),
    ea_sn_ea_elint_msg_tag__SQ_SUB_DRV=((int)64),
    sn__ea_sn_ea_elint_msg_tag__SQ_SUB_DRV=((int)64),
    ea_sn_ea_elint_msg_tag__SQ_STAT=((int)65),
    sn__ea_sn_ea_elint_msg_tag__SQ_STAT=((int)65),
    ea_sn_ea_elint_msg_tag__SQ_BFM_STAT=((int)66),
    sn__ea_sn_ea_elint_msg_tag__SQ_BFM_STAT=((int)66),
    ea_sn_ea_elint_msg_tag__SQ_RW=((int)67),
    sn__ea_sn_ea_elint_msg_tag__SQ_RW=((int)67),
    ea_sn_ea_elint_msg_tag__SQ_RW_WRAP=((int)68),
    sn__ea_sn_ea_elint_msg_tag__SQ_RW_WRAP=((int)68),
    ea_sn_ea_elint_msg_tag__SQ_PREDEFINED_TYPES=((int)69),
    sn__ea_sn_ea_elint_msg_tag__SQ_PREDEFINED_TYPES=((int)69),
    ea_sn_ea_elint_msg_tag__SQ_ERR_INJ=((int)70),
    sn__ea_sn_ea_elint_msg_tag__SQ_ERR_INJ=((int)70),
    ea_sn_ea_elint_msg_tag__SQ_ERR_INJ_VIRTUAL=((int)71),
    sn__ea_sn_ea_elint_msg_tag__SQ_ERR_INJ_VIRTUAL=((int)71),
    ea_sn_ea_elint_msg_tag__MN_ERR_EXT=((int)72),
    sn__ea_sn_ea_elint_msg_tag__MN_ERR_EXT=((int)72),
    ea_sn_ea_elint_msg_tag__DC_REL_NOTES=((int)73),
    sn__ea_sn_ea_elint_msg_tag__DC_REL_NOTES=((int)73),
    ea_sn_ea_elint_msg_tag__DC_DOCS=((int)74),
    sn__ea_sn_ea_elint_msg_tag__DC_DOCS=((int)74),
    ea_sn_ea_elint_msg_tag__DC_FEATURES_CNT=((int)75),
    sn__ea_sn_ea_elint_msg_tag__DC_FEATURES_CNT=((int)75),
    ea_sn_ea_elint_msg_tag__DC_CONST_FIELDS=((int)76),
    sn__ea_sn_ea_elint_msg_tag__DC_CONST_FIELDS=((int)76),
    ea_sn_ea_elint_msg_tag__DC_USABLE_FIELDS=((int)77),
    sn__ea_sn_ea_elint_msg_tag__DC_USABLE_FIELDS=((int)77),
    ea_sn_ea_elint_msg_tag__DC_INSTALL_DEMO=((int)78),
    sn__ea_sn_ea_elint_msg_tag__DC_INSTALL_DEMO=((int)78),
    ea_sn_ea_elint_msg_tag__DC_PACK_ARCH=((int)79),
    sn__ea_sn_ea_elint_msg_tag__DC_PACK_ARCH=((int)79),
    ea_sn_ea_elint_msg_tag__DC_EXAPLES=((int)80),
    sn__ea_sn_ea_elint_msg_tag__DC_EXAPLES=((int)80),
    ea_sn_ea_elint_msg_tag__DC_RESET=((int)81),
    sn__ea_sn_ea_elint_msg_tag__DC_RESET=((int)81),
    ea_sn_ea_elint_msg_tag__DC_EVC_STRUCT=((int)82),
    sn__ea_sn_ea_elint_msg_tag__DC_EVC_STRUCT=((int)82),
    ea_sn_ea_elint_msg_tag__DC_RC_PRACTICE=((int)83),
    sn__ea_sn_ea_elint_msg_tag__DC_RC_PRACTICE=((int)83),
    ea_sn_ea_elint_msg_tag__DC_SUPPORT_POLICIES=((int)84),
    sn__ea_sn_ea_elint_msg_tag__DC_SUPPORT_POLICIES=((int)84),
    ea_sn_ea_elint_msg_tag__DC_DOC_FORMAT=((int)85),
    sn__ea_sn_ea_elint_msg_tag__DC_DOC_FORMAT=((int)85),
    ea_sn_ea_elint_msg_tag__DC_PROPER_DOC=((int)86),
    sn__ea_sn_ea_elint_msg_tag__DC_PROPER_DOC=((int)86),
    ea_sn_ea_elint_msg_tag__DC_SD_DOC=((int)87),
    sn__ea_sn_ea_elint_msg_tag__DC_SD_DOC=((int)87),
    ea_sn_ea_elint_msg_tag__DC_BFM_DOC=((int)88),
    sn__ea_sn_ea_elint_msg_tag__DC_BFM_DOC=((int)88),
    ea_sn_ea_elint_msg_tag__GD_EVC_NAME=((int)89),
    sn__ea_sn_ea_elint_msg_tag__GD_EVC_NAME=((int)89),
    ea_sn_ea_elint_msg_tag__GD_PROTOCOL_NAME=((int)90),
    sn__ea_sn_ea_elint_msg_tag__GD_PROTOCOL_NAME=((int)90),
    ea_sn_ea_elint_msg_tag__GD_NEW_FUNC=((int)91),
    sn__ea_sn_ea_elint_msg_tag__GD_NEW_FUNC=((int)91),
    ea_sn_ea_elint_msg_tag__GD_CUSTOMER_FEDBACK=((int)92),
    sn__ea_sn_ea_elint_msg_tag__GD_CUSTOMER_FEDBACK=((int)92),
    ea_sn_ea_elint_msg_tag__GD_SUPPORT_MODEL=((int)93),
    sn__ea_sn_ea_elint_msg_tag__GD_SUPPORT_MODEL=((int)93),
    ea_sn_ea_elint_msg_tag__GD_TEST_PLAN=((int)94),
    sn__ea_sn_ea_elint_msg_tag__GD_TEST_PLAN=((int)94),
    ea_sn_ea_elint_msg_tag__GD_CODE_LINES=((int)95),
    sn__ea_sn_ea_elint_msg_tag__GD_CODE_LINES=((int)95),
    ea_sn_ea_elint_msg_tag__MS_SCREEN_LOGGERS=((int)96),
    sn__ea_sn_ea_elint_msg_tag__MS_SCREEN_LOGGERS=((int)96),
    ea_sn_ea_elint_msg_tag__MS_FILE_LOGGERS=((int)97),
    sn__ea_sn_ea_elint_msg_tag__MS_FILE_LOGGERS=((int)97),
    ea_sn_ea_elint_msg_tag__MS_LOGGERS_INST=((int)98),
    sn__ea_sn_ea_elint_msg_tag__MS_LOGGERS_INST=((int)98),
    ea_sn_ea_elint_msg_tag__MS_MSG_ACTION=((int)99),
    sn__ea_sn_ea_elint_msg_tag__MS_MSG_ACTION=((int)99),
    ea_sn_ea_elint_msg_tag__MS_MSG_TAGS=((int)100),
    sn__ea_sn_ea_elint_msg_tag__MS_MSG_TAGS=((int)100),
    ea_sn_ea_elint_msg_tag__MS_SHORT_NAME=((int)101),
    sn__ea_sn_ea_elint_msg_tag__MS_SHORT_NAME=((int)101),
    ea_sn_ea_elint_msg_tag__MS_SHORT_NAME_STYLE=((int)102),
    sn__ea_sn_ea_elint_msg_tag__MS_SHORT_NAME_STYLE=((int)102),
    ea_sn_ea_elint_msg_tag__MS_LOGGER_CONST=((int)103),
    sn__ea_sn_ea_elint_msg_tag__MS_LOGGER_CONST=((int)103)
} t__sn__ea_sn_ea_elint_msg_tag;

#define d__sn__ea_sn_ea_elint_msg_tag 8910

typedef t__sn__ea_sn_ea_elint_msg_tag t__ea_sn_ea_elint_msg_tag;

#define d__ea_sn_ea_elint_msg_tag d__sn__ea_sn_ea_elint_msg_tag

/* line 72 "/vobs/specman/src/ea/erm/ea_elint_checklist.e"  From 'Enum type 'ea_sn_ea_elint_msg_type'' */
typedef enum {
    ea_sn_ea_elint_msg_type__RQ=((int)0),
    sn__ea_sn_ea_elint_msg_type__RQ=((int)0),
    ea_sn_ea_elint_msg_type__RC=((int)1),
    sn__ea_sn_ea_elint_msg_type__RC=((int)1),
    ea_sn_ea_elint_msg_type__ST=((int)2),
    sn__ea_sn_ea_elint_msg_type__ST=((int)2)
} t__sn__ea_sn_ea_elint_msg_type;

#define d__sn__ea_sn_ea_elint_msg_type 8906

typedef t__sn__ea_sn_ea_elint_msg_type t__ea_sn_ea_elint_msg_type;

#define d__ea_sn_ea_elint_msg_type d__sn__ea_sn_ea_elint_msg_type

/* line 4 "/vobs/specman/src/gen/gen_sa_dependency_graph.e"  From 'Enum type 'gen_order_policy_t'' */
typedef enum {
    gen_order_policy_t__NONE=((int)0),
    gen__gen_order_policy_t__NONE=((int)0),
    gen_order_policy_t__RANDOM=((int)1),
    gen__gen_order_policy_t__RANDOM=((int)1),
    gen_order_policy_t__DECLARATION=((int)2),
    gen__gen_order_policy_t__DECLARATION=((int)2),
    gen_order_policy_t__DECLARATION_REVERSED=((int)3),
    gen__gen_order_policy_t__DECLARATION_REVERSED=((int)3)
} t__gen__gen_order_policy_t;

#define d__gen__gen_order_policy_t 8086

typedef t__gen__gen_order_policy_t t__gen_order_policy_t;

#define d__gen_order_policy_t d__gen__gen_order_policy_t

/* line 674 "/vobs/specman/src/named_exp.e"  From 'Enum type 'sn_local_exp_kind'' */
typedef enum {
    sn_local_exp_kind__err_local=((int)0),
    sn__sn_local_exp_kind__err_local=((int)0),
    sn_local_exp_kind__method_local=((int)1),
    sn__sn_local_exp_kind__method_local=((int)1),
    sn_local_exp_kind__tcm_local=((int)2),
    sn__sn_local_exp_kind__tcm_local=((int)2),
    sn_local_exp_kind__script_local=((int)3),
    sn__sn_local_exp_kind__script_local=((int)3),
    sn_local_exp_kind__me_tcm_local=((int)4),
    sn__sn_local_exp_kind__me_tcm_local=((int)4)
} t__sn__sn_local_exp_kind;

#define d__sn__sn_local_exp_kind 997

typedef t__sn__sn_local_exp_kind t__sn_local_exp_kind;

#define d__sn_local_exp_kind d__sn__sn_local_exp_kind

/* line 45 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'Enum type 'gen_error_types_t'' */
typedef enum {
    gen_error_types_t__NONE=((int)0),
    sn__gen_error_types_t__NONE=((int)0),
    gen_error_types_t__NULL_PATH=((int)1),
    sn__gen_error_types_t__NULL_PATH=((int)1),
    gen_error_types_t__OUT_OF_BOUNDS=((int)2),
    sn__gen_error_types_t__OUT_OF_BOUNDS=((int)2),
    gen_error_types_t__WRONG_ENUM_VALUE=((int)3),
    sn__gen_error_types_t__WRONG_ENUM_VALUE=((int)3),
    gen_error_types_t__DEEP_INDEX=((int)4),
    sn__gen_error_types_t__DEEP_INDEX=((int)4)
} t__sn__gen_error_types_t;

#define d__sn__gen_error_types_t 6402

typedef t__sn__gen_error_types_t t__gen_error_types_t;

#define d__gen_error_types_t d__sn__gen_error_types_t

/* line 18 "/vobs/specman/src/gen/gen_rtm_manager_api.e"  From 'Enum type 'update_root_type_status_t'' */
typedef enum {
    update_root_type_status_t__CLEARED=((int)0),
    gen__update_root_type_status_t__CLEARED=((int)0),
    update_root_type_status_t__PENDING=((int)1),
    gen__update_root_type_status_t__PENDING=((int)1),
    update_root_type_status_t__UPDATE=((int)2),
    gen__update_root_type_status_t__UPDATE=((int)2)
} t__gen__update_root_type_status_t;

#define d__gen__update_root_type_status_t 8183

typedef t__gen__update_root_type_status_t t__update_root_type_status_t;

#define d__update_root_type_status_t d__gen__update_root_type_status_t

/* line 1430 "/vobs/specman/src/gen/gen_sa_constraint_instance_imp.e"  From 'Enum type 't_reset_soft_status'' */
typedef enum {
    t_reset_soft_status__NOT_DECIDED=((int)0),
    gen__t_reset_soft_status__NOT_DECIDED=((int)0),
    t_reset_soft_status__NONE=((int)1),
    gen__t_reset_soft_status__NONE=((int)1),
    t_reset_soft_status__SIMPLE=((int)2),
    gen__t_reset_soft_status__SIMPLE=((int)2),
    t_reset_soft_status__CONDITIONAL=((int)3),
    gen__t_reset_soft_status__CONDITIONAL=((int)3)
} t__gen__t_reset_soft_status;

#define d__gen__t_reset_soft_status 8204

typedef t__gen__t_reset_soft_status t__t_reset_soft_status;

#define d__t_reset_soft_status d__gen__t_reset_soft_status

/* line 29 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'Enum type 'gen_sa_solving_status'' */
typedef enum {
    gen_sa_solving_status__REGULAR=((int)0),
    sn__gen_sa_solving_status__REGULAR=((int)0),
    gen_sa_solving_status__INPUT=((int)1),
    sn__gen_sa_solving_status__INPUT=((int)1),
    gen_sa_solving_status__IS_NULL=((int)2),
    sn__gen_sa_solving_status__IS_NULL=((int)2),
    gen_sa_solving_status__NEW_INPUT=((int)3),
    sn__gen_sa_solving_status__NEW_INPUT=((int)3)
} t__sn__gen_sa_solving_status;

#define d__sn__gen_sa_solving_status 6451

typedef t__sn__gen_sa_solving_status t__gen_sa_solving_status;

#define d__gen_sa_solving_status d__sn__gen_sa_solving_status

/* line 22 "/vobs/specman/src/gen/gen_sa_node_hdr.e"  From 'Enum type 'sample_type_t'' */
typedef enum {
    sample_type_t__CONTEXT_ROOT=((int)0),
    sn__sample_type_t__CONTEXT_ROOT=((int)0),
    sample_type_t__CONTEXT_HOLDER=((int)1),
    sn__sample_type_t__CONTEXT_HOLDER=((int)1),
    sample_type_t__HOLDER_ORIGINATOR=((int)2),
    sn__sample_type_t__HOLDER_ORIGINATOR=((int)2)
} t__sn__sample_type_t;

#define d__sn__sample_type_t 8130

typedef t__sn__sample_type_t t__sample_type_t;

#define d__sample_type_t d__sn__sample_type_t

/* line 21 "/vobs/specman/src/gen/gen_sa_node_hdr.e"  From 'Enum type 'gen_solver_node_type'' */
typedef enum {
    gen_solver_node_type__BOOL_SCALAR=((int)0),
    sn__gen_solver_node_type__BOOL_SCALAR=((int)0),
    gen_solver_node_type__SIGNED_SCALAR=((int)1),
    sn__gen_solver_node_type__SIGNED_SCALAR=((int)1),
    gen_solver_node_type__UNSIGNED_SCALAR=((int)2),
    sn__gen_solver_node_type__UNSIGNED_SCALAR=((int)2),
    gen_solver_node_type__REF=((int)3),
    sn__gen_solver_node_type__REF=((int)3),
    gen_solver_node_type__STR=((int)4),
    sn__gen_solver_node_type__STR=((int)4),
    gen_solver_node_type__LIST_SIZE=((int)5),
    sn__gen_solver_node_type__LIST_SIZE=((int)5)
} t__sn__gen_solver_node_type;

#define d__sn__gen_solver_node_type 8128

typedef t__sn__gen_solver_node_type t__gen_solver_node_type;

#define d__gen_solver_node_type d__sn__gen_solver_node_type

/* line 472 "/vobs/specman/src/gen_common.e"  From 'Enum type 'parse_generator_t'' */
typedef enum {
    parse_generator_t__parse_undef=((int)0),
    sn__parse_generator_t__parse_undef=((int)0),
    parse_generator_t__parse_igen=((int)1),
    sn__parse_generator_t__parse_igen=((int)1),
    parse_generator_t__parse_pgen3=((int)2),
    sn__parse_generator_t__parse_pgen3=((int)2),
    parse_generator_t__parse_mixed=((int)3),
    sn__parse_generator_t__parse_mixed=((int)3)
} t__sn__parse_generator_t;

#define d__sn__parse_generator_t 2109

typedef t__sn__parse_generator_t t__parse_generator_t;

#define d__parse_generator_t d__sn__parse_generator_t

/* line 602 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'Enum type 'gen_dbg_stree_node_status_t'' */
typedef enum {
    gen_dbg_stree_node_status_t__TO_BE_GEN=((int)0),
    gen_dbg__gen_dbg_stree_node_status_t__TO_BE_GEN=((int)0),
    gen_dbg_stree_node_status_t__BEING_GEN=((int)1),
    gen_dbg__gen_dbg_stree_node_status_t__BEING_GEN=((int)1),
    gen_dbg_stree_node_status_t__GEN_ALREADY=((int)2),
    gen_dbg__gen_dbg_stree_node_status_t__GEN_ALREADY=((int)2),
    gen_dbg_stree_node_status_t__CONTRADICTS=((int)3),
    gen_dbg__gen_dbg_stree_node_status_t__CONTRADICTS=((int)3)
} t__gen_dbg__gen_dbg_stree_node_status_t;

#define d__gen_dbg__gen_dbg_stree_node_status_t 8022

typedef t__gen_dbg__gen_dbg_stree_node_status_t t__gen_dbg_stree_node_status_t;

#define d__gen_dbg_stree_node_status_t d__gen_dbg__gen_dbg_stree_node_status_t

/* line 427 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'Enum type 'gen_edge_t'' */
typedef enum {
    gen_edge_t__MUTUAL=((int)0),
    sn__gen_edge_t__MUTUAL=((int)0),
    gen_edge_t__MUTUAL_WHEN=((int)1),
    sn__gen_edge_t__MUTUAL_WHEN=((int)1),
    gen_edge_t__STRUCTURAL=((int)2),
    sn__gen_edge_t__STRUCTURAL=((int)2),
    gen_edge_t__LISTSIZE=((int)3),
    sn__gen_edge_t__LISTSIZE=((int)3),
    gen_edge_t__WHEN=((int)4),
    sn__gen_edge_t__WHEN=((int)4),
    gen_edge_t__UNI_WHEN=((int)5),
    sn__gen_edge_t__UNI_WHEN=((int)5),
    gen_edge_t__PARAMETER=((int)6),
    sn__gen_edge_t__PARAMETER=((int)6),
    gen_edge_t__POST_GEN_PARAMETER=((int)7),
    sn__gen_edge_t__POST_GEN_PARAMETER=((int)7),
    gen_edge_t__ASSIGNMENT=((int)8),
    sn__gen_edge_t__ASSIGNMENT=((int)8),
    gen_edge_t__CFA_PARAM=((int)9),
    sn__gen_edge_t__CFA_PARAM=((int)9),
    gen_edge_t__CFA_WHEN=((int)10),
    sn__gen_edge_t__CFA_WHEN=((int)10)
} t__sn__gen_edge_t;

#define d__sn__gen_edge_t 6548

typedef t__sn__gen_edge_t t__gen_edge_t;

#define d__gen_edge_t d__sn__gen_edge_t

/* line 196 "/vobs/specman/src/gen/gen_dbg_instructor.e"  From 'Enum type 'gcommand_state'' */
typedef enum {
    gcommand_state__start_ctx=((int)0),
    gen_dbg__gcommand_state__start_ctx=((int)0),
    gcommand_state__start_cc=((int)1),
    gen_dbg__gcommand_state__start_cc=((int)1),
    gcommand_state__reduce=((int)2),
    gen_dbg__gcommand_state__reduce=((int)2),
    gcommand_state__assign=((int)3),
    gen_dbg__gcommand_state__assign=((int)3),
    gcommand_state__rollback=((int)4),
    gen_dbg__gcommand_state__rollback=((int)4),
    gcommand_state__sampling=((int)5),
    gen_dbg__gcommand_state__sampling=((int)5),
    gcommand_state__gsampling=((int)6),
    gen_dbg__gcommand_state__gsampling=((int)6),
    gcommand_state__soft_reg=((int)7),
    gen_dbg__gcommand_state__soft_reg=((int)7),
    gcommand_state__soft_cancel=((int)8),
    gen_dbg__gcommand_state__soft_cancel=((int)8),
    gcommand_state__policy_selection=((int)9),
    gen_dbg__gcommand_state__policy_selection=((int)9),
    gcommand_state__end_cc=((int)10),
    gen_dbg__gcommand_state__end_cc=((int)10),
    gcommand_state__end_ctx=((int)11),
    gen_dbg__gcommand_state__end_ctx=((int)11),
    gcommand_state__contradiction=((int)12),
    gen_dbg__gcommand_state__contradiction=((int)12),
    gcommand_state__start_cc_or_end_ctx=((int)13),
    gen_dbg__gcommand_state__start_cc_or_end_ctx=((int)13),
    gcommand_state__not_in_gen=((int)14),
    gen_dbg__gcommand_state__not_in_gen=((int)14),
    gcommand_state__any_state=((int)15),
    gen_dbg__gcommand_state__any_state=((int)15),
    gcommand_state__unknown=((int)16),
    gen_dbg__gcommand_state__unknown=((int)16)
} t__gen_dbg__gcommand_state;

#define d__gen_dbg__gcommand_state 8714

typedef t__gen_dbg__gcommand_state t__gcommand_state;

#define d__gcommand_state d__gen_dbg__gcommand_state

/* line 5 "/vobs/specman/src/japp/shared_extra/shared_extra_user_api.e"  From 'Enum type 'vt_font_size'' */
typedef enum {
    vt_font_size__DEFAULT_FONT_SIZE=((int)0),
    vt__vt_font_size__DEFAULT_FONT_SIZE=((int)0),
    vt_font_size__SMALL=((int)1),
    vt__vt_font_size__SMALL=((int)1),
    vt_font_size__NORMAL=((int)2),
    vt__vt_font_size__NORMAL=((int)2),
    vt_font_size__LARGE=((int)3),
    vt__vt_font_size__LARGE=((int)3)
} t__vt__vt_font_size;

#define d__vt__vt_font_size 4008

typedef t__vt__vt_font_size t__vt_font_size;

#define d__vt_font_size d__vt__vt_font_size

/* line 24 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'Enum type 'vtx_bar_format'' */
typedef enum {
    vtx_bar_format__VTX_PERCENTAGE=((int)0),
    vt__vtx_bar_format__VTX_PERCENTAGE=((int)0),
    vtx_bar_format__VTX_DIGIT=((int)1),
    vt__vtx_bar_format__VTX_DIGIT=((int)1)
} t__vt__vtx_bar_format;

#define d__vt__vtx_bar_format 5198

typedef t__vt__vtx_bar_format t__vtx_bar_format;

#define d__vtx_bar_format d__vt__vtx_bar_format

/* line 97 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'Enum type 'vtx_tab_position'' */
typedef enum {
    vtx_tab_position__VTX_TOP=((int)0),
    vt__vtx_tab_position__VTX_TOP=((int)0),
    vtx_tab_position__VTX_BOTTOM=((int)1),
    vt__vtx_tab_position__VTX_BOTTOM=((int)1),
    vtx_tab_position__VTX_LEFT=((int)2),
    vt__vtx_tab_position__VTX_LEFT=((int)2),
    vtx_tab_position__VTX_RIGHT=((int)3),
    vt__vtx_tab_position__VTX_RIGHT=((int)3)
} t__vt__vtx_tab_position;

#define d__vt__vtx_tab_position 5096

typedef t__vt__vtx_tab_position t__vtx_tab_position;

#define d__vtx_tab_position d__vt__vtx_tab_position

/* line 5 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'Enum type 'gen_pnet_var_type'' */
typedef enum {
    gen_pnet_var_type__user_signed=((int)0),
    sn__gen_pnet_var_type__user_signed=((int)0),
    gen_pnet_var_type__user_unsigned=((int)1),
    sn__gen_pnet_var_type__user_unsigned=((int)1),
    gen_pnet_var_type__user_bool=((int)2),
    sn__gen_pnet_var_type__user_bool=((int)2),
    gen_pnet_var_type__user_ref=((int)3),
    sn__gen_pnet_var_type__user_ref=((int)3),
    gen_pnet_var_type__user_string=((int)4),
    sn__gen_pnet_var_type__user_string=((int)4),
    gen_pnet_var_type__user_list_size=((int)5),
    sn__gen_pnet_var_type__user_list_size=((int)5),
    gen_pnet_var_type__temp=((int)16),
    sn__gen_pnet_var_type__temp=((int)16),
    gen_pnet_var_type__reif_temp=((int)17),
    sn__gen_pnet_var_type__reif_temp=((int)17),
    gen_pnet_var_type__soft_temp=((int)256),
    sn__gen_pnet_var_type__soft_temp=((int)256),
    gen_pnet_var_type__select_temp=((int)257),
    sn__gen_pnet_var_type__select_temp=((int)257),
    gen_pnet_var_type__gen_temp=((int)272),
    sn__gen_pnet_var_type__gen_temp=((int)272),
    gen_pnet_var_type__selector=((int)4096),
    sn__gen_pnet_var_type__selector=((int)4096)
} t__sn__gen_pnet_var_type;

#define d__sn__gen_pnet_var_type 8336

typedef t__sn__gen_pnet_var_type t__gen_pnet_var_type;

#define d__gen_pnet_var_type d__sn__gen_pnet_var_type

/* line 2 "/vobs/specman/src/gen/gen_solver_listener_api.e"  From 'Enum type 'listener_mode'' */
typedef enum {
    listener_mode__SLEEP=((int)0),
    sn__listener_mode__SLEEP=((int)0),
    listener_mode__STATIC=((int)1),
    sn__listener_mode__STATIC=((int)1),
    listener_mode__DYNAMIC=((int)2),
    sn__listener_mode__DYNAMIC=((int)2)
} t__sn__listener_mode;

#define d__sn__listener_mode 8263

typedef t__sn__listener_mode t__listener_mode;

#define d__listener_mode d__sn__listener_mode

/* line 1039 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'Enum type 'rl_propagator_status'' */
typedef enum {
    rl_propagator_status__always_true=((int)0),
    sn__rl_propagator_status__always_true=((int)0),
    rl_propagator_status__always_false=((int)1),
    sn__rl_propagator_status__always_false=((int)1),
    rl_propagator_status__sometimes_true=((int)2),
    sn__rl_propagator_status__sometimes_true=((int)2),
    rl_propagator_status__sometimes_true_no_change=((int)3),
    sn__rl_propagator_status__sometimes_true_no_change=((int)3),
    rl_propagator_status__always_true_no_change=((int)4),
    sn__rl_propagator_status__always_true_no_change=((int)4),
    rl_propagator_status__always_true_after_changes=((int)5),
    sn__rl_propagator_status__always_true_after_changes=((int)5)
} t__sn__rl_propagator_status;

#define d__sn__rl_propagator_status 8393

typedef t__sn__rl_propagator_status t__rl_propagator_status;

#define d__rl_propagator_status d__sn__rl_propagator_status

/* line 8 "/vobs/specman/src/gen/gen_linter_defs.e"  From 'Enum type 't_mode'' */
typedef enum {
    t_mode__guidelines=((int)0),
    gen__t_mode__guidelines=((int)0),
    t_mode__migration=((int)1),
    gen__t_mode__migration=((int)1),
    t_mode__dependency=((int)2),
    gen__t_mode__dependency=((int)2),
    t_mode__select_after_soft=((int)3),
    gen__t_mode__select_after_soft=((int)3)
} t__gen__t_mode;

#define d__gen__t_mode 8804

typedef t__gen__t_mode t__t_mode;

#define d__t_mode d__gen__t_mode

/* line 9 "/vobs/specman/src/gen/gen_linter_defs.e"  From 'Enum type 't_appears_in'' */
typedef enum {
    t_appears_in__unknown=((int)0),
    gen__t_appears_in__unknown=((int)0),
    t_appears_in__pre_generate=((int)1),
    gen__t_appears_in__pre_generate=((int)1),
    t_appears_in__post_generate=((int)2),
    gen__t_appears_in__post_generate=((int)2),
    t_appears_in__constraint=((int)3),
    gen__t_appears_in__constraint=((int)3),
    t_appears_in__gen_action=((int)4),
    gen__t_appears_in__gen_action=((int)4)
} t__gen__t_appears_in;

#define d__gen__t_appears_in 8806

typedef t__gen__t_appears_in t__t_appears_in;

#define d__t_appears_in d__gen__t_appears_in

/* line 15 "/vobs/specman/src/as_a.e"  From 'Enum type 'sn_as_a_kind'' */
typedef enum {
    sn_as_a_kind__error=((int)0),
    sn__sn_as_a_kind__error=((int)0),
    sn_as_a_kind__no_conversion=((int)1),
    sn__sn_as_a_kind__no_conversion=((int)1),
    sn_as_a_kind__int2long=((int)2),
    sn__sn_as_a_kind__int2long=((int)2),
    sn_as_a_kind__int2double=((int)3),
    sn__sn_as_a_kind__int2double=((int)3),
    sn_as_a_kind__int2short_int=((int)4),
    sn__sn_as_a_kind__int2short_int=((int)4),
    sn_as_a_kind__int2short_uint=((int)5),
    sn__sn_as_a_kind__int2short_uint=((int)5),
    sn_as_a_kind__int2int=((int)6),
    sn__sn_as_a_kind__int2int=((int)6),
    sn_as_a_kind__int2bool=((int)7),
    sn__sn_as_a_kind__int2bool=((int)7),
    sn_as_a_kind__uint2long=((int)8),
    sn__sn_as_a_kind__uint2long=((int)8),
    sn_as_a_kind__uint2double=((int)9),
    sn__sn_as_a_kind__uint2double=((int)9),
    sn_as_a_kind__long2double=((int)10),
    sn__sn_as_a_kind__long2double=((int)10),
    sn_as_a_kind__long2int=((int)11),
    sn__sn_as_a_kind__long2int=((int)11),
    sn_as_a_kind__long2uint=((int)12),
    sn__sn_as_a_kind__long2uint=((int)12),
    sn_as_a_kind__long2long=((int)13),
    sn__sn_as_a_kind__long2long=((int)13),
    sn_as_a_kind__long2bool=((int)14),
    sn__sn_as_a_kind__long2bool=((int)14),
    sn_as_a_kind__long2short_int=((int)15),
    sn__sn_as_a_kind__long2short_int=((int)15),
    sn_as_a_kind__long2short_uint=((int)16),
    sn__sn_as_a_kind__long2short_uint=((int)16),
    sn_as_a_kind__double2double=((int)17),
    sn__sn_as_a_kind__double2double=((int)17),
    sn_as_a_kind__double2int=((int)18),
    sn__sn_as_a_kind__double2int=((int)18),
    sn_as_a_kind__double2uint=((int)19),
    sn__sn_as_a_kind__double2uint=((int)19),
    sn_as_a_kind__double2long=((int)20),
    sn__sn_as_a_kind__double2long=((int)20),
    sn_as_a_kind__double2bool=((int)21),
    sn__sn_as_a_kind__double2bool=((int)21),
    sn_as_a_kind__double2short_int=((int)22),
    sn__sn_as_a_kind__double2short_int=((int)22),
    sn_as_a_kind__double2short_uint=((int)23),
    sn__sn_as_a_kind__double2short_uint=((int)23),
    sn_as_a_kind__normal=((int)24),
    sn__sn_as_a_kind__normal=((int)24),
    sn_as_a_kind__subtype=((int)25),
    sn__sn_as_a_kind__subtype=((int)25),
    sn_as_a_kind__subtype2=((int)26),
    sn__sn_as_a_kind__subtype2=((int)26),
    sn_as_a_kind__str2double=((int)27),
    sn__sn_as_a_kind__str2double=((int)27),
    sn_as_a_kind__str2long=((int)28),
    sn__sn_as_a_kind__str2long=((int)28),
    sn_as_a_kind__str2bool=((int)29),
    sn__sn_as_a_kind__str2bool=((int)29),
    sn_as_a_kind__str2enum=((int)30),
    sn__sn_as_a_kind__str2enum=((int)30),
    sn_as_a_kind__str2short_int=((int)31),
    sn__sn_as_a_kind__str2short_int=((int)31),
    sn_as_a_kind__str2int=((int)32),
    sn__sn_as_a_kind__str2int=((int)32),
    sn_as_a_kind__str2short_uint=((int)33),
    sn__sn_as_a_kind__str2short_uint=((int)33),
    sn_as_a_kind__str2uint=((int)34),
    sn__sn_as_a_kind__str2uint=((int)34),
    sn_as_a_kind__str2double_list=((int)35),
    sn__sn_as_a_kind__str2double_list=((int)35),
    sn_as_a_kind__str2long_list=((int)36),
    sn__sn_as_a_kind__str2long_list=((int)36),
    sn_as_a_kind__str2packed_list=((int)37),
    sn__sn_as_a_kind__str2packed_list=((int)37),
    sn_as_a_kind__str2scalar_list=((int)38),
    sn__sn_as_a_kind__str2scalar_list=((int)38),
    sn_as_a_kind__double2str=((int)39),
    sn__sn_as_a_kind__double2str=((int)39),
    sn_as_a_kind__uint2str=((int)40),
    sn__sn_as_a_kind__uint2str=((int)40),
    sn_as_a_kind__scalar2str=((int)41),
    sn__sn_as_a_kind__scalar2str=((int)41),
    sn_as_a_kind__long2str=((int)42),
    sn__sn_as_a_kind__long2str=((int)42),
    sn_as_a_kind__enum2str=((int)43),
    sn__sn_as_a_kind__enum2str=((int)43),
    sn_as_a_kind__bool2str=((int)44),
    sn__sn_as_a_kind__bool2str=((int)44),
    sn_as_a_kind__packed_list2str=((int)45),
    sn__sn_as_a_kind__packed_list2str=((int)45),
    sn_as_a_kind__double_list2str=((int)46),
    sn__sn_as_a_kind__double_list2str=((int)46),
    sn_as_a_kind__long_list2str=((int)47),
    sn__sn_as_a_kind__long_list2str=((int)47),
    sn_as_a_kind__numeric_list2str=((int)48),
    sn__sn_as_a_kind__numeric_list2str=((int)48),
    sn_as_a_kind__double_list2str_list=((int)49),
    sn__sn_as_a_kind__double_list2str_list=((int)49),
    sn_as_a_kind__scalar_list2str_list=((int)50),
    sn__sn_as_a_kind__scalar_list2str_list=((int)50),
    sn_as_a_kind__packed_list2str_list=((int)51),
    sn__sn_as_a_kind__packed_list2str_list=((int)51),
    sn_as_a_kind__long_list2str_list=((int)52),
    sn__sn_as_a_kind__long_list2str_list=((int)52),
    sn_as_a_kind__long_list2double_list=((int)53),
    sn__sn_as_a_kind__long_list2double_list=((int)53),
    sn_as_a_kind__long_list2long_list=((int)54),
    sn__sn_as_a_kind__long_list2long_list=((int)54),
    sn_as_a_kind__long_list2packed_list=((int)55),
    sn__sn_as_a_kind__long_list2packed_list=((int)55),
    sn_as_a_kind__long_list2scalar_list=((int)56),
    sn__sn_as_a_kind__long_list2scalar_list=((int)56),
    sn_as_a_kind__double_list2double_list=((int)57),
    sn__sn_as_a_kind__double_list2double_list=((int)57),
    sn_as_a_kind__double_list2long_list=((int)58),
    sn__sn_as_a_kind__double_list2long_list=((int)58),
    sn_as_a_kind__double_list2packed_list=((int)59),
    sn__sn_as_a_kind__double_list2packed_list=((int)59),
    sn_as_a_kind__double_list2scalar_list=((int)60),
    sn__sn_as_a_kind__double_list2scalar_list=((int)60),
    sn_as_a_kind__packed_list2double_list=((int)61),
    sn__sn_as_a_kind__packed_list2double_list=((int)61),
    sn_as_a_kind__packed_list2long_list=((int)62),
    sn__sn_as_a_kind__packed_list2long_list=((int)62),
    sn_as_a_kind__packed_list2packed_list=((int)63),
    sn__sn_as_a_kind__packed_list2packed_list=((int)63),
    sn_as_a_kind__packed_list2scalar_list=((int)64),
    sn__sn_as_a_kind__packed_list2scalar_list=((int)64),
    sn_as_a_kind__scalar_list2double_list=((int)65),
    sn__sn_as_a_kind__scalar_list2double_list=((int)65),
    sn_as_a_kind__scalar_list2long_list=((int)66),
    sn__sn_as_a_kind__scalar_list2long_list=((int)66),
    sn_as_a_kind__scalar_list2packed_list=((int)67),
    sn__sn_as_a_kind__scalar_list2packed_list=((int)67),
    sn_as_a_kind__scalar_list2scalar_list=((int)68),
    sn__sn_as_a_kind__scalar_list2scalar_list=((int)68),
    sn_as_a_kind__str_list2double_list=((int)69),
    sn__sn_as_a_kind__str_list2double_list=((int)69),
    sn_as_a_kind__str_list2enum_list=((int)70),
    sn__sn_as_a_kind__str_list2enum_list=((int)70),
    sn_as_a_kind__str_list2bool_list=((int)71),
    sn__sn_as_a_kind__str_list2bool_list=((int)71),
    sn_as_a_kind__str_list2packed_list=((int)72),
    sn__sn_as_a_kind__str_list2packed_list=((int)72),
    sn_as_a_kind__str_list2scalar_list=((int)73),
    sn__sn_as_a_kind__str_list2scalar_list=((int)73),
    sn_as_a_kind__str_list2long_list=((int)74),
    sn__sn_as_a_kind__str_list2long_list=((int)74),
    sn_as_a_kind__struct_list2struct_list=((int)75),
    sn__sn_as_a_kind__struct_list2struct_list=((int)75),
    sn_as_a_kind__subtype_list2subtype_list=((int)76),
    sn__sn_as_a_kind__subtype_list2subtype_list=((int)76),
    sn_as_a_kind__subtype_list2subtype_list2=((int)77),
    sn__sn_as_a_kind__subtype_list2subtype_list2=((int)77),
    sn_as_a_kind__copy_list=((int)78),
    sn__sn_as_a_kind__copy_list=((int)78),
    sn_as_a_kind__copy_keyed_list=((int)79),
    sn__sn_as_a_kind__copy_keyed_list=((int)79),
    sn_as_a_kind__copy_long_list=((int)80),
    sn__sn_as_a_kind__copy_long_list=((int)80),
    sn_as_a_kind__copy_long_keyed_list=((int)81),
    sn__sn_as_a_kind__copy_long_keyed_list=((int)81),
    sn_as_a_kind__copy_double_list=((int)82),
    sn__sn_as_a_kind__copy_double_list=((int)82),
    sn_as_a_kind__copy_double_keyed_list=((int)83),
    sn__sn_as_a_kind__copy_double_keyed_list=((int)83),
    sn_as_a_kind__copy_packed_list=((int)84),
    sn__sn_as_a_kind__copy_packed_list=((int)84),
    sn_as_a_kind__copy_packed_keyed_list=((int)85),
    sn__sn_as_a_kind__copy_packed_keyed_list=((int)85)
} t__sn__sn_as_a_kind;

#define d__sn__sn_as_a_kind 743

typedef t__sn__sn_as_a_kind t__sn_as_a_kind;

#define d__sn_as_a_kind d__sn__sn_as_a_kind

/* line 11 "/vobs/specman/src/vt_util/vt_util_edoc_defs.e"  From 'Enum type 'edoc_struct_member_category_t'' */
typedef enum {
    edoc_struct_member_category_t__FIELD=((int)0),
    sn__edoc_struct_member_category_t__FIELD=((int)0),
    edoc_struct_member_category_t__METHOD=((int)1),
    sn__edoc_struct_member_category_t__METHOD=((int)1),
    edoc_struct_member_category_t__EVENT=((int)2),
    sn__edoc_struct_member_category_t__EVENT=((int)2)
} t__sn__edoc_struct_member_category_t;

#define d__sn__edoc_struct_member_category_t 7892

typedef t__sn__edoc_struct_member_category_t t__edoc_struct_member_category_t;

#define d__edoc_struct_member_category_t d__sn__edoc_struct_member_category_t

/* line 17 "/vobs/specman/src/vt_util/vt_util_edoc_defs.e"  From 'Enum type 'edoc_encapsulation_t'' */
typedef enum {
    edoc_encapsulation_t__PRIVATE=((int)0),
    sn__edoc_encapsulation_t__PRIVATE=((int)0),
    edoc_encapsulation_t__PACKAGE=((int)1),
    sn__edoc_encapsulation_t__PACKAGE=((int)1),
    edoc_encapsulation_t__PROTECTED=((int)2),
    sn__edoc_encapsulation_t__PROTECTED=((int)2),
    edoc_encapsulation_t__PUBLIC=((int)3),
    sn__edoc_encapsulation_t__PUBLIC=((int)3),
    edoc_encapsulation_t__UNKNOWN=((int)4),
    sn__edoc_encapsulation_t__UNKNOWN=((int)4)
} t__sn__edoc_encapsulation_t;

#define d__sn__edoc_encapsulation_t 7894

typedef t__sn__edoc_encapsulation_t t__edoc_encapsulation_t;

#define d__edoc_encapsulation_t d__sn__edoc_encapsulation_t

/* line 34 "/vobs/specman/src/patch.e"  From 'Enum type 'severity_error'' */
typedef enum {
    severity_error__SKIP=((int)0),
    sn__severity_error__SKIP=((int)0),
    severity_error__LOAD=((int)1),
    sn__severity_error__LOAD=((int)1),
    severity_error__ERROR=((int)2),
    sn__severity_error__ERROR=((int)2)
} t__sn__severity_error;

#define d__sn__severity_error 4287

typedef t__sn__severity_error t__severity_error;

#define d__severity_error d__sn__severity_error

/* line 17 "/vobs/specman/src/help_html.e"  From 'Enum type 'line_kind'' */
typedef enum {
    line_kind__startl=((int)0),
    sn__line_kind__startl=((int)0),
    line_kind__endl=((int)1),
    sn__line_kind__endl=((int)1),
    line_kind__matched=((int)2),
    sn__line_kind__matched=((int)2),
    line_kind__none=((int)3),
    sn__line_kind__none=((int)3),
    line_kind__marked=((int)4),
    sn__line_kind__marked=((int)4),
    line_kind__expecting=((int)5),
    sn__line_kind__expecting=((int)5),
    line_kind__endmarked=((int)6),
    sn__line_kind__endmarked=((int)6),
    line_kind__startmarked=((int)7),
    sn__line_kind__startmarked=((int)7),
    line_kind__discard=((int)8),
    sn__line_kind__discard=((int)8)
} t__sn__line_kind;

#define d__sn__line_kind 2360

typedef t__sn__line_kind t__line_kind;

#define d__line_kind d__sn__line_kind

/* line 65 "/vobs/specman/src/japp/vt/vt_expand.e"  From 'Enum type 'sn_vt'trace'' */
typedef enum {
    sn_vt__trace__off=((int)0),
    vt__sn_vt__trace__off=((int)0),
    sn_vt__trace__on=((int)1),
    vt__sn_vt__trace__on=((int)1)
} t__imp_enum_vt__sn_vt__trace;

#define d__imp_enum_vt__sn_vt__trace 4764

typedef t__imp_enum_vt__sn_vt__trace t__imp_enum_sn_vt__trace;

#define d__imp_enum_sn_vt__trace d__imp_enum_vt__sn_vt__trace

/* line 32 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'Enum type 'vt_element_owenr_kind'' */
typedef enum {
    vt_element_owenr_kind__ANY=((int)0),
    vt__vt_element_owenr_kind__ANY=((int)0),
    vt_element_owenr_kind__USER=((int)1),
    vt__vt_element_owenr_kind__USER=((int)1),
    vt_element_owenr_kind__INTERNAL=((int)2),
    vt__vt_element_owenr_kind__INTERNAL=((int)2)
} t__vt__vt_element_owenr_kind;

#define d__vt__vt_element_owenr_kind 4974

typedef t__vt__vt_element_owenr_kind t__vt_element_owenr_kind;

#define d__vt_element_owenr_kind d__vt__vt_element_owenr_kind

/* line 18 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'Enum type 'vt_file_kind'' */
typedef enum {
    vt_file_kind__UNDEFINED=((int)0),
    vt__vt_file_kind__UNDEFINED=((int)0),
    vt_file_kind__DIR=((int)1),
    vt__vt_file_kind__DIR=((int)1),
    vt_file_kind__E=((int)2),
    vt__vt_file_kind__E=((int)2),
    vt_file_kind__TEXT=((int)3),
    vt__vt_file_kind__TEXT=((int)3),
    vt_file_kind__HTML=((int)4),
    vt__vt_file_kind__HTML=((int)4),
    vt_file_kind__IMAGE=((int)5),
    vt__vt_file_kind__IMAGE=((int)5),
    vt_file_kind__BINARY=((int)6),
    vt__vt_file_kind__BINARY=((int)6),
    vt_file_kind__NOT_FOUND=((int)7),
    vt__vt_file_kind__NOT_FOUND=((int)7),
    vt_file_kind__ECOM=((int)8),
    vt__vt_file_kind__ECOM=((int)8),
    vt_file_kind__LOG=((int)9),
    vt__vt_file_kind__LOG=((int)9),
    vt_file_kind__ECOV=((int)10),
    vt__vt_file_kind__ECOV=((int)10),
    vt_file_kind__ESV=((int)11),
    vt__vt_file_kind__ESV=((int)11)
} t__vt__vt_file_kind;

#define d__vt__vt_file_kind 5035

typedef t__vt__vt_file_kind t__vt_file_kind;

#define d__vt_file_kind d__vt__vt_file_kind

/* line 10 "/vobs/specman/src/cadence_help.e"  From 'Enum type 'cadence_help_status'' */
typedef enum {
    cadence_help_status__init_success=((int)0),
    sn__cadence_help_status__init_success=((int)0),
    cadence_help_status__before_init=((int)1),
    sn__cadence_help_status__before_init=((int)1),
    cadence_help_status__fail_load_shlib=((int)2),
    sn__cadence_help_status__fail_load_shlib=((int)2),
    cadence_help_status__fail_init_help=((int)3),
    sn__cadence_help_status__fail_init_help=((int)3),
    cadence_help_status__fail_set_library=((int)4),
    sn__cadence_help_status__fail_set_library=((int)4)
} t__sn__cadence_help_status;

#define d__sn__cadence_help_status 2702

typedef t__sn__cadence_help_status t__cadence_help_status;

#define d__cadence_help_status d__sn__cadence_help_status

/* line 18 "/vobs/specman/src/fl_debug.e"  From 'Enum type 'tdb_print_level'' */
typedef enum {
    tdb_print_level__none=((int)0),
    sn_fl__tdb_print_level__none=((int)0),
    tdb_print_level__short=((int)1),
    sn_fl__tdb_print_level__short=((int)1),
    tdb_print_level__medium=((int)2),
    sn_fl__tdb_print_level__medium=((int)2),
    tdb_print_level__long=((int)3),
    sn_fl__tdb_print_level__long=((int)3)
} t__sn_fl__tdb_print_level;

#define d__sn_fl__tdb_print_level 2998

typedef t__sn_fl__tdb_print_level t__tdb_print_level;

#define d__tdb_print_level d__sn_fl__tdb_print_level

/* line 109 "/vobs/specman/src/fl_debug.e"  From 'Enum type 'sn_hp_fsm_eval'location'' */
typedef enum {
    sn_hp_fsm_eval__location__starting=((int)0),
    sn_fl__sn_hp_fsm_eval__location__starting=((int)0),
    sn_hp_fsm_eval__location__finished=((int)1),
    sn_fl__sn_hp_fsm_eval__location__finished=((int)1)
} t__imp_enum_sn_fl__sn_hp_fsm_eval__location;

#define d__imp_enum_sn_fl__sn_hp_fsm_eval__location 3008

typedef t__imp_enum_sn_fl__sn_hp_fsm_eval__location t__imp_enum_sn_hp_fsm_eval__location;

#define d__imp_enum_sn_hp_fsm_eval__location d__imp_enum_sn_fl__sn_hp_fsm_eval__location

/* line 13 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_user_api.e"  From 'Enum type 'vt_file_dialog_content_kind'' */
typedef enum {
    vt_file_dialog_content_kind__FILE_ONLY=((int)0),
    vt__vt_file_dialog_content_kind__FILE_ONLY=((int)0),
    vt_file_dialog_content_kind__DIR_ONLY=((int)1),
    vt__vt_file_dialog_content_kind__DIR_ONLY=((int)1),
    vt_file_dialog_content_kind__FILE_AND_DIR=((int)2),
    vt__vt_file_dialog_content_kind__FILE_AND_DIR=((int)2)
} t__vt__vt_file_dialog_content_kind;

#define d__vt__vt_file_dialog_content_kind 2515

typedef t__vt__vt_file_dialog_content_kind t__vt_file_dialog_content_kind;

#define d__vt_file_dialog_content_kind d__vt__vt_file_dialog_content_kind

/* line 21 "/vobs/specman/src/snorb/edl/edl_parser.e"  From 'Enum type 'sn_edl_method_remote_kind'' */
typedef enum {
    sn_edl_method_remote_kind__sync=((int)0),
    sn__sn_edl_method_remote_kind__sync=((int)0),
    sn_edl_method_remote_kind__async_with_acknowledge=((int)1),
    sn__sn_edl_method_remote_kind__async_with_acknowledge=((int)1),
    sn_edl_method_remote_kind__async_no_acknowledge=((int)2),
    sn__sn_edl_method_remote_kind__async_no_acknowledge=((int)2)
} t__sn__sn_edl_method_remote_kind;

#define d__sn__sn_edl_method_remote_kind 3358

typedef t__sn__sn_edl_method_remote_kind t__sn_edl_method_remote_kind;

#define d__sn_edl_method_remote_kind d__sn__sn_edl_method_remote_kind

/* line 783 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'Enum type 'typeKind'' */
typedef enum {
    typeKind__edl_unknown=((int)0),
    sn__typeKind__edl_unknown=((int)0),
    typeKind__edl_byte=((int)1),
    sn__typeKind__edl_byte=((int)1),
    typeKind__edl_bool=((int)2),
    sn__typeKind__edl_bool=((int)2),
    typeKind__edl_int=((int)3),
    sn__typeKind__edl_int=((int)3),
    typeKind__edl_uint=((int)4),
    sn__typeKind__edl_uint=((int)4),
    typeKind__edl_string=((int)5),
    sn__typeKind__edl_string=((int)5),
    typeKind__edl_interface=((int)6),
    sn__typeKind__edl_interface=((int)6),
    typeKind__edl_data=((int)7),
    sn__typeKind__edl_data=((int)7),
    typeKind__edl_enum=((int)8),
    sn__typeKind__edl_enum=((int)8),
    typeKind__edl_real=((int)9),
    sn__typeKind__edl_real=((int)9)
} t__sn__typeKind;

#define d__sn__typeKind 3383

typedef t__sn__typeKind t__typeKind;

#define d__typeKind d__sn__typeKind

/* line 346 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'Enum type 'EDLLanguage'' */
typedef enum {
    EDLLanguage__none=((int)0),
    sn__EDLLanguage__none=((int)0),
    EDLLanguage__E=((int)1),
    sn__EDLLanguage__E=((int)1),
    EDLLanguage__JAVA=((int)2),
    sn__EDLLanguage__JAVA=((int)2)
} t__sn__EDLLanguage;

#define d__sn__EDLLanguage 3374

typedef t__sn__EDLLanguage t__EDLLanguage;

#define d__EDLLanguage d__sn__EDLLanguage

/* line 15 "/vobs/specman/src/japp/databrowser/db_cache_building_blocks.e"  From 'Enum type 'node_refresh_status'' */
typedef enum {
    node_refresh_status__none=((int)0),
    sn__node_refresh_status__none=((int)0),
    node_refresh_status__visited=((int)1),
    sn__node_refresh_status__visited=((int)1),
    node_refresh_status__refreshed=((int)2),
    sn__node_refresh_status__refreshed=((int)2)
} t__sn__node_refresh_status;

#define d__sn__node_refresh_status 4717

typedef t__sn__node_refresh_status t__node_refresh_status;

#define d__node_refresh_status d__sn__node_refresh_status

/* line 5 "/vobs/specman/src/hdl_assertions_defs.e"  From 'Enum type 'HDL_ASSERTION_LANGUAGE'' */
typedef enum {
    HDL_ASSERTION_LANGUAGE__NONE=((int)0),
    sn__HDL_ASSERTION_LANGUAGE__NONE=((int)0),
    HDL_ASSERTION_LANGUAGE__OVL_V1=((int)1),
    sn__HDL_ASSERTION_LANGUAGE__OVL_V1=((int)1),
    HDL_ASSERTION_LANGUAGE__OVL_V2=((int)2),
    sn__HDL_ASSERTION_LANGUAGE__OVL_V2=((int)2),
    HDL_ASSERTION_LANGUAGE__ANY_LANG=((int)3),
    sn__HDL_ASSERTION_LANGUAGE__ANY_LANG=((int)3)
} t__sn__HDL_ASSERTION_LANGUAGE;

#define d__sn__HDL_ASSERTION_LANGUAGE 6692

typedef t__sn__HDL_ASSERTION_LANGUAGE t__HDL_ASSERTION_LANGUAGE;

#define d__HDL_ASSERTION_LANGUAGE d__sn__HDL_ASSERTION_LANGUAGE

/* line 6 "/vobs/specman/src/hdl_assertions_defs.e"  From 'Enum type 'HDL_ASSERTION_SEVERITY_LEVEL'' */
typedef enum {
    HDL_ASSERTION_SEVERITY_LEVEL__NONE=((int)0),
    sn__HDL_ASSERTION_SEVERITY_LEVEL__NONE=((int)0),
    HDL_ASSERTION_SEVERITY_LEVEL__FATAL=((int)1),
    sn__HDL_ASSERTION_SEVERITY_LEVEL__FATAL=((int)1),
    HDL_ASSERTION_SEVERITY_LEVEL__ERROR=((int)2),
    sn__HDL_ASSERTION_SEVERITY_LEVEL__ERROR=((int)2),
    HDL_ASSERTION_SEVERITY_LEVEL__WARNING=((int)3),
    sn__HDL_ASSERTION_SEVERITY_LEVEL__WARNING=((int)3),
    HDL_ASSERTION_SEVERITY_LEVEL__INFO=((int)4),
    sn__HDL_ASSERTION_SEVERITY_LEVEL__INFO=((int)4)
} t__sn__HDL_ASSERTION_SEVERITY_LEVEL;

#define d__sn__HDL_ASSERTION_SEVERITY_LEVEL 6694

typedef t__sn__HDL_ASSERTION_SEVERITY_LEVEL t__HDL_ASSERTION_SEVERITY_LEVEL;

#define d__HDL_ASSERTION_SEVERITY_LEVEL d__sn__HDL_ASSERTION_SEVERITY_LEVEL

/* line 6 "/vobs/specman/src/denali_unit.e"  From 'Enum type 'sn_denali_access_type'' */
typedef enum {
    sn_denali_access_type__sn_denali_read=((int)0),
    sn__sn_denali_access_type__sn_denali_read=((int)0),
    sn_denali_access_type__sn_denali_read_unk=((int)1),
    sn__sn_denali_access_type__sn_denali_read_unk=((int)1),
    sn_denali_access_type__sn_denali_write=((int)2),
    sn__sn_denali_access_type__sn_denali_write=((int)2),
    sn_denali_access_type__sn_denali_write_unk=((int)3),
    sn__sn_denali_access_type__sn_denali_write_unk=((int)3),
    sn_denali_access_type__sn_denali_write_mask=((int)4),
    sn__sn_denali_access_type__sn_denali_write_mask=((int)4),
    sn_denali_access_type__sn_denali_write_masked_unk=((int)5),
    sn__sn_denali_access_type__sn_denali_write_masked_unk=((int)5),
    sn_denali_access_type__sn_denali_load=((int)6),
    sn__sn_denali_access_type__sn_denali_load=((int)6),
    sn_denali_access_type__sn_denali_load_done=((int)7),
    sn__sn_denali_access_type__sn_denali_load_done=((int)7),
    sn_denali_access_type__sn_denali_reset=((int)8),
    sn__sn_denali_access_type__sn_denali_reset=((int)8),
    sn_denali_access_type__sn_denali_ei=((int)9),
    sn__sn_denali_access_type__sn_denali_ei=((int)9),
    sn_denali_access_type__sn_denali_ei_unk=((int)10),
    sn__sn_denali_access_type__sn_denali_ei_unk=((int)10),
    sn_denali_access_type__sn_denali_ei_mask=((int)11),
    sn__sn_denali_access_type__sn_denali_ei_mask=((int)11),
    sn_denali_access_type__sn_denali_ei_masked_unk=((int)12),
    sn__sn_denali_access_type__sn_denali_ei_masked_unk=((int)12)
} t__sn__sn_denali_access_type;

#define d__sn__sn_denali_access_type 7235

typedef t__sn__sn_denali_access_type t__sn_denali_access_type;

#define d__sn_denali_access_type d__sn__sn_denali_access_type

/* line 321 "/vobs/specman/src/message_action.e"  From 'Enum type 'sn_message_action_kind'' */
typedef enum {
    sn_message_action_kind__normal=((int)0),
    sn__sn_message_action_kind__normal=((int)0),
    sn_message_action_kind__leader=((int)1),
    sn__sn_message_action_kind__leader=((int)1),
    sn_message_action_kind__trailer=((int)2),
    sn__sn_message_action_kind__trailer=((int)2)
} t__sn__sn_message_action_kind;

#define d__sn__sn_message_action_kind 7323

typedef t__sn__sn_message_action_kind t__sn_message_action_kind;

#define d__sn_message_action_kind d__sn__sn_message_action_kind

/* line 6 "/vobs/specman/src/evc_util_objections.e"  From 'Enum type 'objection_kind'' */
typedef enum {
    objection_kind__TEST_DONE=((int)0),
    sn__objection_kind__TEST_DONE=((int)0)
} t__sn__objection_kind;

#define d__sn__objection_kind 7785

typedef t__sn__objection_kind t__objection_kind;

#define d__objection_kind d__sn__objection_kind

/* line 59 "/vobs/specman/src/ea/erm/ea_sn_ea_com.e"  From 'Enum type 'ea_sn_ea_state_e'' */
typedef enum {
    ea_sn_ea_state_e__Idle=((int)0),
    sn__ea_sn_ea_state_e__Idle=((int)0),
    ea_sn_ea_state_e__EPanalyze=((int)1),
    sn__ea_sn_ea_state_e__EPanalyze=((int)1),
    ea_sn_ea_state_e__SNgen_load=((int)2),
    sn__ea_sn_ea_state_e__SNgen_load=((int)2),
    ea_sn_ea_state_e__SNgen_gen=((int)3),
    sn__ea_sn_ea_state_e__SNgen_gen=((int)3),
    ea_sn_ea_state_e__SNerm_load=((int)4),
    sn__ea_sn_ea_state_e__SNerm_load=((int)4),
    ea_sn_ea_state_e__SNerm_gen=((int)5),
    sn__ea_sn_ea_state_e__SNerm_gen=((int)5),
    ea_sn_ea_state_e__SNlegacy_load=((int)6),
    sn__ea_sn_ea_state_e__SNlegacy_load=((int)6),
    ea_sn_ea_state_e__SNlegacy_extract=((int)7),
    sn__ea_sn_ea_state_e__SNlegacy_extract=((int)7),
    ea_sn_ea_state_e__SNdacm_load=((int)8),
    sn__ea_sn_ea_state_e__SNdacm_load=((int)8),
    ea_sn_ea_state_e__SNdacm_report=((int)9),
    sn__ea_sn_ea_state_e__SNdacm_report=((int)9)
} t__sn__ea_sn_ea_state_e;

#define d__sn__ea_sn_ea_state_e 8934

typedef t__sn__ea_sn_ea_state_e t__ea_sn_ea_state_e;

#define d__ea_sn_ea_state_e d__sn__ea_sn_ea_state_e

/* line 11 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'Enum type 'enum__103620'' */
typedef enum {
    enum__103620__SUCCESS=((int)0),
    main__enum__103620__SUCCESS=((int)0),
    enum__103620__ERROR=((int)1),
    main__enum__103620__ERROR=((int)1)
} t__main__enum__103620;

#define d__main__enum__103620 9402

typedef t__main__enum__103620 t__enum__103620;

#define d__enum__103620 d__main__enum__103620

/* line 18 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'Enum type 'enum__103621'' */
typedef enum {
    enum__103621__MB_DOUBLE=((int)0),
    main__enum__103621__MB_DOUBLE=((int)0),
    enum__103621__MB_INT32=((int)1),
    main__enum__103621__MB_INT32=((int)1),
    enum__103621__MB_INT64=((int)2),
    main__enum__103621__MB_INT64=((int)2)
} t__main__enum__103621;

#define d__main__enum__103621 9404

typedef t__main__enum__103621 t__enum__103621;

#define d__enum__103621 d__main__enum__103621

/* line 18 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'Enum type 'matlab_class_id_t'' */
typedef enum {
    matlab_class_id_t__MB_DOUBLE=((int)0),
    main__matlab_class_id_t__MB_DOUBLE=((int)0),
    matlab_class_id_t__MB_INT32=((int)1),
    main__matlab_class_id_t__MB_INT32=((int)1),
    matlab_class_id_t__MB_INT64=((int)2),
    main__matlab_class_id_t__MB_INT64=((int)2)
} t__main__matlab_class_id_t;

#define d__main__matlab_class_id_t 9405

typedef t__main__matlab_class_id_t t__matlab_class_id_t;

#define d__matlab_class_id_t d__main__matlab_class_id_t

/* line 11 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'Enum type 'matlab_rc_t'' */
typedef enum {
    matlab_rc_t__SUCCESS=((int)0),
    main__matlab_rc_t__SUCCESS=((int)0),
    matlab_rc_t__ERROR=((int)1),
    main__matlab_rc_t__ERROR=((int)1)
} t__main__matlab_rc_t;

#define d__main__matlab_rc_t 9403

typedef t__main__matlab_rc_t t__matlab_rc_t;

#define d__matlab_rc_t d__main__matlab_rc_t

/* line 51 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'subtype: is_complex matlab_mx_array_s' */
#define d__TRUE__is_complex__main__matlab_mx_array_s 9412
/* line 51 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'subtype: FALSE'is_complex matlab_mx_array_s' */
#define d__FALSE__is_complex__main__matlab_mx_array_s 9413
/* line 51 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'subtype: is_complex MB_DOUBLE matlab_mx_array_s' */
#define d__MB_DOUBLE__its_class__TRUE__is_complex__main__matlab_mx_array_s 9414
/* line 51 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'subtype: FALSE'is_complex MB_DOUBLE matlab_mx_array_s' */
#define d__MB_DOUBLE__its_class__FALSE__is_complex__main__matlab_mx_array_s 9415
/* line 434 "/vobs/specman/src/num.e"  From 'Enum type 'sn_sort_type'' */
typedef enum {
    sn_sort_type__Int=((int)0),
    sn__sn_sort_type__Int=((int)0),
    sn_sort_type__Uint=((int)1),
    sn__sn_sort_type__Uint=((int)1),
    sn_sort_type__Long=((int)2),
    sn__sn_sort_type__Long=((int)2),
    sn_sort_type__Double=((int)3),
    sn__sn_sort_type__Double=((int)3),
    sn_sort_type__String=((int)4),
    sn__sn_sort_type__String=((int)4),
    sn_sort_type__struct=((int)5),
    sn__sn_sort_type__struct=((int)5)
} t__sn__sn_sort_type;

#define d__sn__sn_sort_type 500

typedef t__sn__sn_sort_type t__sn_sort_type;

#define d__sn_sort_type d__sn__sn_sort_type

/* line 641 "/vobs/specman/src/basic_action.e"  From 'Enum type 'sn_exp_type'' */
typedef enum {
    sn_exp_type__int=((int)0),
    sn__sn_exp_type__int=((int)0),
    sn_exp_type__uint=((int)1),
    sn__sn_exp_type__uint=((int)1),
    sn_exp_type__long=((int)2),
    sn__sn_exp_type__long=((int)2),
    sn_exp_type__double=((int)3),
    sn__sn_exp_type__double=((int)3),
    sn_exp_type__struct=((int)4),
    sn__sn_exp_type__struct=((int)4),
    sn_exp_type__string=((int)5),
    sn__sn_exp_type__string=((int)5),
    sn_exp_type__long_int=((int)6),
    sn__sn_exp_type__long_int=((int)6),
    sn_exp_type__ipacked_list=((int)7),
    sn__sn_exp_type__ipacked_list=((int)7),
    sn_exp_type__upacked_list=((int)8),
    sn__sn_exp_type__upacked_list=((int)8),
    sn_exp_type__str_list=((int)9),
    sn__sn_exp_type__str_list=((int)9),
    sn_exp_type__plist=((int)10),
    sn__sn_exp_type__plist=((int)10),
    sn_exp_type__ilist=((int)11),
    sn__sn_exp_type__ilist=((int)11),
    sn_exp_type__long_list=((int)12),
    sn__sn_exp_type__long_list=((int)12),
    sn_exp_type__double_list=((int)13),
    sn__sn_exp_type__double_list=((int)13)
} t__sn__sn_exp_type;

#define d__sn__sn_exp_type 529

typedef t__sn__sn_exp_type t__sn_exp_type;

#define d__sn_exp_type d__sn__sn_exp_type

/* line 645 "/vobs/specman/src/basic_action.e"  From 'Enum type 'sn_binary_exps_type'' */
typedef enum {
    sn_binary_exps_type__error=((int)0),
    sn__sn_binary_exps_type__error=((int)0),
    sn_binary_exps_type__short_short=((int)1),
    sn__sn_binary_exps_type__short_short=((int)1),
    sn_binary_exps_type__short_ushort=((int)2),
    sn__sn_binary_exps_type__short_ushort=((int)2),
    sn_binary_exps_type__short_int=((int)3),
    sn__sn_binary_exps_type__short_int=((int)3),
    sn_binary_exps_type__short_uint=((int)4),
    sn__sn_binary_exps_type__short_uint=((int)4),
    sn_binary_exps_type__short_long=((int)5),
    sn__sn_binary_exps_type__short_long=((int)5),
    sn_binary_exps_type__short_real=((int)6),
    sn__sn_binary_exps_type__short_real=((int)6),
    sn_binary_exps_type__ushort_short=((int)7),
    sn__sn_binary_exps_type__ushort_short=((int)7),
    sn_binary_exps_type__ushort_ushort=((int)8),
    sn__sn_binary_exps_type__ushort_ushort=((int)8),
    sn_binary_exps_type__ushort_int=((int)9),
    sn__sn_binary_exps_type__ushort_int=((int)9),
    sn_binary_exps_type__ushort_uint=((int)10),
    sn__sn_binary_exps_type__ushort_uint=((int)10),
    sn_binary_exps_type__ushort_long=((int)11),
    sn__sn_binary_exps_type__ushort_long=((int)11),
    sn_binary_exps_type__ushort_real=((int)12),
    sn__sn_binary_exps_type__ushort_real=((int)12),
    sn_binary_exps_type__int_short=((int)13),
    sn__sn_binary_exps_type__int_short=((int)13),
    sn_binary_exps_type__int_ushort=((int)14),
    sn__sn_binary_exps_type__int_ushort=((int)14),
    sn_binary_exps_type__int_int=((int)15),
    sn__sn_binary_exps_type__int_int=((int)15),
    sn_binary_exps_type__int_uint=((int)16),
    sn__sn_binary_exps_type__int_uint=((int)16),
    sn_binary_exps_type__int_long=((int)17),
    sn__sn_binary_exps_type__int_long=((int)17),
    sn_binary_exps_type__int_real=((int)18),
    sn__sn_binary_exps_type__int_real=((int)18),
    sn_binary_exps_type__uint_short=((int)19),
    sn__sn_binary_exps_type__uint_short=((int)19),
    sn_binary_exps_type__uint_ushort=((int)20),
    sn__sn_binary_exps_type__uint_ushort=((int)20),
    sn_binary_exps_type__uint_int=((int)21),
    sn__sn_binary_exps_type__uint_int=((int)21),
    sn_binary_exps_type__uint_uint=((int)22),
    sn__sn_binary_exps_type__uint_uint=((int)22),
    sn_binary_exps_type__uint_long=((int)23),
    sn__sn_binary_exps_type__uint_long=((int)23),
    sn_binary_exps_type__uint_real=((int)24),
    sn__sn_binary_exps_type__uint_real=((int)24),
    sn_binary_exps_type__long_short=((int)25),
    sn__sn_binary_exps_type__long_short=((int)25),
    sn_binary_exps_type__long_ushort=((int)26),
    sn__sn_binary_exps_type__long_ushort=((int)26),
    sn_binary_exps_type__long_int=((int)27),
    sn__sn_binary_exps_type__long_int=((int)27),
    sn_binary_exps_type__long_uint=((int)28),
    sn__sn_binary_exps_type__long_uint=((int)28),
    sn_binary_exps_type__long_long=((int)29),
    sn__sn_binary_exps_type__long_long=((int)29),
    sn_binary_exps_type__long_real=((int)30),
    sn__sn_binary_exps_type__long_real=((int)30),
    sn_binary_exps_type__real_short=((int)31),
    sn__sn_binary_exps_type__real_short=((int)31),
    sn_binary_exps_type__real_ushort=((int)32),
    sn__sn_binary_exps_type__real_ushort=((int)32),
    sn_binary_exps_type__real_int=((int)33),
    sn__sn_binary_exps_type__real_int=((int)33),
    sn_binary_exps_type__real_uint=((int)34),
    sn__sn_binary_exps_type__real_uint=((int)34),
    sn_binary_exps_type__real_long=((int)35),
    sn__sn_binary_exps_type__real_long=((int)35),
    sn_binary_exps_type__real_real=((int)36),
    sn__sn_binary_exps_type__real_real=((int)36),
    sn_binary_exps_type__l_short_short=((int)37),
    sn__sn_binary_exps_type__l_short_short=((int)37),
    sn_binary_exps_type__l_short_ushort=((int)38),
    sn__sn_binary_exps_type__l_short_ushort=((int)38),
    sn_binary_exps_type__l_short_int=((int)39),
    sn__sn_binary_exps_type__l_short_int=((int)39),
    sn_binary_exps_type__l_short_uint=((int)40),
    sn__sn_binary_exps_type__l_short_uint=((int)40),
    sn_binary_exps_type__l_short_long=((int)41),
    sn__sn_binary_exps_type__l_short_long=((int)41),
    sn_binary_exps_type__l_short_real=((int)42),
    sn__sn_binary_exps_type__l_short_real=((int)42),
    sn_binary_exps_type__l_ushort_short=((int)43),
    sn__sn_binary_exps_type__l_ushort_short=((int)43),
    sn_binary_exps_type__l_ushort_ushort=((int)44),
    sn__sn_binary_exps_type__l_ushort_ushort=((int)44),
    sn_binary_exps_type__l_ushort_int=((int)45),
    sn__sn_binary_exps_type__l_ushort_int=((int)45),
    sn_binary_exps_type__l_ushort_uint=((int)46),
    sn__sn_binary_exps_type__l_ushort_uint=((int)46),
    sn_binary_exps_type__l_ushort_long=((int)47),
    sn__sn_binary_exps_type__l_ushort_long=((int)47),
    sn_binary_exps_type__l_ushort_real=((int)48),
    sn__sn_binary_exps_type__l_ushort_real=((int)48),
    sn_binary_exps_type__l_int_short=((int)49),
    sn__sn_binary_exps_type__l_int_short=((int)49),
    sn_binary_exps_type__l_int_ushort=((int)50),
    sn__sn_binary_exps_type__l_int_ushort=((int)50),
    sn_binary_exps_type__l_int_int=((int)51),
    sn__sn_binary_exps_type__l_int_int=((int)51),
    sn_binary_exps_type__l_int_uint=((int)52),
    sn__sn_binary_exps_type__l_int_uint=((int)52),
    sn_binary_exps_type__l_int_long=((int)53),
    sn__sn_binary_exps_type__l_int_long=((int)53),
    sn_binary_exps_type__l_int_real=((int)54),
    sn__sn_binary_exps_type__l_int_real=((int)54),
    sn_binary_exps_type__l_uint_short=((int)55),
    sn__sn_binary_exps_type__l_uint_short=((int)55),
    sn_binary_exps_type__l_uint_ushort=((int)56),
    sn__sn_binary_exps_type__l_uint_ushort=((int)56),
    sn_binary_exps_type__l_uint_int=((int)57),
    sn__sn_binary_exps_type__l_uint_int=((int)57),
    sn_binary_exps_type__l_uint_uint=((int)58),
    sn__sn_binary_exps_type__l_uint_uint=((int)58),
    sn_binary_exps_type__l_uint_long=((int)59),
    sn__sn_binary_exps_type__l_uint_long=((int)59),
    sn_binary_exps_type__l_uint_real=((int)60),
    sn__sn_binary_exps_type__l_uint_real=((int)60),
    sn_binary_exps_type__l_long_short=((int)61),
    sn__sn_binary_exps_type__l_long_short=((int)61),
    sn_binary_exps_type__l_long_ushort=((int)62),
    sn__sn_binary_exps_type__l_long_ushort=((int)62),
    sn_binary_exps_type__l_long_int=((int)63),
    sn__sn_binary_exps_type__l_long_int=((int)63),
    sn_binary_exps_type__l_long_uint=((int)64),
    sn__sn_binary_exps_type__l_long_uint=((int)64),
    sn_binary_exps_type__l_long_long=((int)65),
    sn__sn_binary_exps_type__l_long_long=((int)65),
    sn_binary_exps_type__l_long_real=((int)66),
    sn__sn_binary_exps_type__l_long_real=((int)66),
    sn_binary_exps_type__l_real_short=((int)67),
    sn__sn_binary_exps_type__l_real_short=((int)67),
    sn_binary_exps_type__l_real_ushort=((int)68),
    sn__sn_binary_exps_type__l_real_ushort=((int)68),
    sn_binary_exps_type__l_real_int=((int)69),
    sn__sn_binary_exps_type__l_real_int=((int)69),
    sn_binary_exps_type__l_real_uint=((int)70),
    sn__sn_binary_exps_type__l_real_uint=((int)70),
    sn_binary_exps_type__l_real_long=((int)71),
    sn__sn_binary_exps_type__l_real_long=((int)71),
    sn_binary_exps_type__l_real_real=((int)72),
    sn__sn_binary_exps_type__l_real_real=((int)72),
    sn_binary_exps_type__lint_lint=((int)73),
    sn__sn_binary_exps_type__lint_lint=((int)73),
    sn_binary_exps_type__l_lint_lint=((int)74),
    sn__sn_binary_exps_type__l_lint_lint=((int)74),
    sn_binary_exps_type__str_str=((int)75),
    sn__sn_binary_exps_type__str_str=((int)75),
    sn_binary_exps_type__l_str_str=((int)76),
    sn__sn_binary_exps_type__l_str_str=((int)76),
    sn_binary_exps_type__l_str=((int)77),
    sn__sn_binary_exps_type__l_str=((int)77),
    sn_binary_exps_type__pointer_pointer=((int)78),
    sn__sn_binary_exps_type__pointer_pointer=((int)78),
    sn_binary_exps_type__l_pointer_pointer=((int)79),
    sn__sn_binary_exps_type__l_pointer_pointer=((int)79)
} t__sn__sn_binary_exps_type;

#define d__sn__sn_binary_exps_type 531

typedef t__sn__sn_binary_exps_type t__sn_binary_exps_type;

#define d__sn_binary_exps_type d__sn__sn_binary_exps_type

static char* sn_efile_names[] = {
  "matlab",
  "sn_matlab",
  ""
};
static unsigned int sn_efile_checksums[] = {
  2257514772u,
  4164818728u,
  0
};
SN_EXTERNC void sn_check_h_consistency(char* specman_version, char* e_file_names[], unsigned int checksums[], char* h_file);
static bool checked_h_consistency = FALSE;
#define CHECK_H_CONSISTENCY() (!checked_h_consistency ? (sn_check_h_consistency(SN_VERSION, sn_efile_names, sn_efile_checksums, "sn_matlab.h"), checked_h_consistency = TRUE) : 1)

#define SN_DISPATCH(_m, _v, _t, _params) (CHECK_H_CONSISTENCY(), SN_SN_DISPATCH(_m,_v,_t,_params))
#define SN_STRUCT_NEW(type) (CHECK_H_CONSISTENCY(), SN_SN_STRUCT_NEW(type))
#define SN_LIST_NEW(type) (CHECK_H_CONSISTENCY(), SN_SN_LIST_NEW(type))

#undef SN_CAST_DISPATCH
#define SN_CAST_DISPATCH(_m, _t) 
t__int sn_lint(char *a[],char *b[],char *c[],char *d[],char *e[],char *f,void (*g)(),char* (*h)(),t__int (*i)());
/* line 13 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '#define MATLAB_STATE_UNINIT' */
#ifndef SNDEF__MATLAB_STATE_UNINIT
#define SNDEF__MATLAB_STATE_UNINIT (0)
#endif
/* line 14 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '#define MATLAB_STATE_INIT' */
#ifndef SNDEF__MATLAB_STATE_INIT
#define SNDEF__MATLAB_STATE_INIT (1)
#endif
/* line 15 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '#define MATLAB_STATE_RUN' */
#ifndef SNDEF__MATLAB_STATE_RUN
#define SNDEF__MATLAB_STATE_RUN (2)
#endif
/* line 16 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '#define MATLAB_STATE_ERROR' */
#ifndef SNDEF__MATLAB_STATE_ERROR
#define SNDEF__MATLAB_STATE_ERROR (4)
#endif
/* line 7 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '#define DBG_SO_BUG' */
#ifndef SNDEF__DBG_SO_BUG
#define SNDEF__DBG_SO_BUG (TRUE)
#endif
/* line 1157 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__global {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__e_core__specman_config *specman_config;
    struct s__e_core__symtab *symtab;
    struct s__e_core__units *units;
    struct s__l__sn__type_descriptor *all_types;
    struct s__e_core__session *session;
    struct s__e_core__debug *debug;
    struct s__e_core__configuration *configuration;
    struct s__e_core__sn_dbg *sn_dbg;
    struct s__e_core__no_save *no_save;
    struct s__sn__sn_memory_options *sn_memory_options;
    struct s__e_core__print_options *print_options;
    struct s__e_core__compatibility_opt475 *compatibility_options;
    struct s__e_core__files *files;
    struct s__sn__interactive_scope *interactive_scope;
    struct s__sn__activation_record *CAR;
    struct s__e_core__pgen3 *pgen3;
    struct s__sn__sn_display *display;
    struct s__e_core__parse *parse;
    struct s__e_core__simulator *simulator;
    struct s__e_core__sn_adapter_manager *adapter_manager;
    struct s__e_core__scheduler *scheduler;
    struct s__e_core__specsim *specsim;
    struct s__k__sn__ExplicitName__name *all_explicit_names;
    t__string final_path;
    struct s__l__string *str_split_buffer;
    struct s__e_core__sn_application_attr *application_attr;
    t__bool in_specman_command;
    t__bool is_redirect_output;
    struct s__e_core__sn_redirect_output *sn_redirect_output;
    t__string last_line;
    t__int global_line_number;
    struct s__e_core__dual_line_buff *dl_buff;
    struct s__e_core__sn_warnings *warnings;
    t__bool run_flow_notify;
    t__bool branch_notify;
    t__bool cond_notify;
    t__bool error_notify;
    t__bool message_notify;
    t__bool rflow_mode;
    t__bool rflow_within_command;
    t__bool notify_memory_allocations;
    t__bool invisible_out;
    t__bool hide_specman;
    struct s__e_core__sn_communication *sn_communication;
    struct s__sn__keyword_manager *keyword;
    t__bool back5_0_for_from;
    struct s__l__pat *files___all_pats;
    t__bool cast_repeat_flag;
    struct s__sn__sn_cvl_manager *cvl_manager;
    t__bool keep_and_check;
    t__bool eval_check_constraint;
    struct s__e_core__sys *sys;
    struct s__l__sn__sort_item *sort___list;
    t__bool specman_version_macro_done;
    struct s__e_core__source_item *script_type___source_item;
    struct s__sn__params *params;
    struct s__sn__sn_capture *sn_capture;
    struct s__e_core__covers *covers;
    struct s__sn__sn_wave *sn_wave;
    struct s__sn__sn_dut_manager *sn_dut_manager;
    t__bool cast_write_cover_flag;
    struct s__sn__sn_interval_set_manager *IS_manager;
    struct s__l__sn__sn_recycler *sn_recyclers;
    struct s__sn__sn_dumb_recycler *sn_dumb_recycler;
    struct s__sn__sn_smarter_recycler *sn_smarter_recycler;
    struct s__k__sn__fake_signal__name *script___fake_signals;
    t__bool sn_otf_blocked;
    t__int num_fields_script_instance_back4;
    struct s__sn__auto_gc_setting *auto_gc_setting;
    struct s__sn__packing *packing;
    struct s__sn__virtual_packing *minmal_packing;
    struct s__sn__vttp_packing *vttp_packing;
    struct s__sn__svtp_packing *svtp_packing;
    struct s__sn__mltp_packing *mltp_packing;
    struct s__reflection__rf_manager *rf_manager;
    t__bool within_accessed;
    struct s__sn__method *accessed_method;
    t__bool debug_st_tree;
    struct s__l__sn__st_node *syntax_tree___st_node_buffer;
    struct s__ea__eanalyzer *eanalyzer;
    t__bool sn_enum_under_g5;
    struct s__l__sn__untyped_list_to_11892 *untyped_list_to_scalar_convertors;
    struct s__l__uint *masks;
    t__int counter_permit_extend_and_like_for_port;
    struct s__sn__gen_generator *generator;
    struct s__sn__linter_manager *linter;
    struct s__sn__sn_shlibs *shlibs;
    struct s__sn__sn_util *util;
    struct s__sn__sn_patches *sn_patches;
    t__bool sn_made_stats;
    t__bool sm_dont_paint_red;
    struct s__sn__sn_stat_selector *sn_stat_selector;
    t__int sn_gather_d_index;
    struct s__l__e_core__base_struct *sn_gathered_instances;
    struct s__sn__sn_live_stat_selector *sn_live_stat_selector;
    struct s__sn__sn_dead_stat_selector *sn_dead_stat_selector;
    struct s__sn__sn_struct_only_walk *sn_struct_only_walk;
    struct s__sn__sn_list_walk *sn_list_walk;
    struct s__sn__sn_everything_walk *sn_everything_walk;
    struct s__sn__sn_gather_walk *sn_gather_walk;
    struct s__sn__sn_deep_walk *sn_deep_walk;
    struct s__sn__sn_shallow_walk *sn_shallow_walk;
    struct s__sn__sn_walk_mark *sn_walk_mark;
    struct s__sn__sn_mem_stats *sn_live_detached_stats;
    struct s__sn__sn_mem_stats *sn_dead_detached_stats;
    struct s__sn__sn_mem_stats *sn_live_string_stats;
    struct s__sn__sn_mem_stats *sn_dead_string_stats;
    t__bool sm_testing_mode;
    struct s__sn__sn_mem_logger *sn_mem_logger;
    t__bool saved_prefer_disk_base;
    t__int sm_unit_depth;
    struct s__k__sn__unit_size__unit *sm_unit_sizes;
    struct s__sn__help_index *help_index;
    struct s__sn__interact *interact;
    struct s__vt__sn_vt *vt;
    struct s__sn__sn_tabwin *tabwin;
    struct s__sn__sn_cadence_help *cds_help;
    struct s__sn__sn_formal_link *fl;
    t__bool pause_run_flag;
    struct s__k__sn__sn_define2_descr20063 *all_def2_descriptors;
    struct s__sn__sn_abstract_syntax_21204 *as_mng;
    t__bool sn_tcm__disable_thread_reuse;
    struct s__sn__sn_tcm_stack_image *tcm_stack_image;
    struct s__sn__seamless *seamless;
    struct s__sn__sn_cvl_manager *cvl;
    struct s__sn__sn_comm_api *sn_comm_api;
    struct s__sn__snorb *snorb;
    struct s__sn__sn_edl_parser *sn_edl_parser;
    struct s__sn__sn_edl_code_generator *sn_edl_code_generator;
    struct s__sn__EDLGlobal *p_edl_global;
    struct s__l__sn__sn_curly_bracket27133 *ntf_parsers_pool;
    struct s__sn__event_viewer *eve;
    struct s__sn__sn_pub_services *pub_services;
    struct s__sn__sn_external_trace *external_trace;
    struct s__sn__sn_dynamic_call *sdi_init___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_set_database___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_create_fiber___dynamic_call;
    struct s__sn__sn_japp *japp;
    struct s__sn__sn_jspecview_deli *jspecview_deli;
    struct s__sn__sn_jconfig *p_jconfig;
    struct s__sn__sn_source_viewer *p_source_viewer;
    struct s__vt__sn_gt *sn_gt;
    struct s__sn__sn_databrowser *p_databrowser;
    struct s__sn__sn_evaluator *evaluator;
    t__int last_module_num;
    struct s__vt__sn_gui_manager *gui_manager;
    struct s__vt__vtx_manager *vtx;
    struct s__sn__major_path *major_path;
    struct s__l__string *list_for_hdl_path;
    struct s__sn__sn_checksum *sn_checksum;
    t__uint sn_max_buffer_port_size;
    struct s__sn__hdl_assertions_mgr *assert_mgr;
    struct s__sn__do_bind_utils *do_bind_utils;
    struct s__sn__sn_mvl_literal_helper *sn_mvl_literal_helper;
    struct s__sn__port_cb_manager *port_cb_manager;
    t__bool sn_adapter_struct___verisity_vhdl_adapter_allow_assign_after_force;
    struct s__ovm_interface_generator68949 *oig_api;
    t__string oig_source_ref;
    struct s__sn__sn_denali *sn_denali;
    t__bool denali_unit___sn_denali_ddv_is_used;
    t__bool disable_capture;
    struct s__sn__capture_helper *capture_helper;
    struct s__l__int *sn_message_flags;
    struct s__sn__sn_message_manager *sn_message_manager;
    struct s__sn__sn_recursive_reaper *sn_recursive_reaper;
    t__int sn_reaper_level;
    t__external_pointer SN_ZERO;
    struct s__main__code_cover_manager *code_cover_manager;
    struct s__vm_ngen__sn_ngen_manager *sn_ngen_manager;
    struct s__sn__sn_sequence_manager *sequence_manager;
    struct s__sn__sn_evc_util *evc_util;
    struct s__sn__sn_objection_manager *sn_objection_manager;
    struct s__sn__vt_util *vt_util;
    struct s__sn__edoc *edoc;
    struct s__l__source_ref *eDoc_private_sref;
    struct s__sn_wr__sn_wr_manager *sn_wr_mng;
    t__bool tc_flag_use_original_constr;
    t__bool tc_flag_sample_missing_inputs;
    struct s__l__sn__exception *ea_exception_l;
    struct s__sn__ea_sn_ea_s *ea_snea;
    t__bool ea_msg_handler_ok_;
    struct s__vr_gsa_sw_debug__debug_info *debug_info;
    struct s__sn__comm_async_manager *comm_async_manager;
    struct s__gtx__gtx_plugin_manager *gtx_plugin;
    struct s__gtx__gtx_manager *gtx;
    struct s__ml_ovm__ml_ovm *ml_ovm;
    struct s__sn__sn_profiler *sn_profiler;
    t__bool sn_in_test;
    t__bool sn_profiling_is_possible;
    struct s__sn__activation_record *run_flow_ar;
    struct s__sn__error_data *error_data;
    struct s__sn__sn_c_unit_tree_manager *c_unit_tree_mgr;
    t__bool pre_specman___pre_quit_already_called;
    struct s__main__matlab_ifc_s *matlab;
} *t__e_core__global;
#define d__e_core__global 95
typedef t__e_core__global t__global;
#define d__global d__e_core__global

/* line 104 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__any_unit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
} *t__e_core__any_unit;
#define d__e_core__any_unit 18
typedef t__e_core__any_unit t__any_unit;
#define d__any_unit d__e_core__any_unit

/* line 437 "/vobs/specman/src/atomic_exp.e"  From 'struct definition' */
typedef struct s__sn__sn_adapter_bridge {
    t__int d__;
    t__int gen__;
    t__int adapter_id;
    t__int hidden_adapter_id;
    struct s__sn__sn_adapter_imp_desc14562 *adapter_imp_desc;
    struct s__l__e_core__any_port *adapter_ports;
    struct s__l__e_core__any_simple_port *active_simple_ports;
    struct s__l__sn__sn_event_done_wrapper *event_done_wrapper_list;
    struct s__l__e_core__any_buffer_port *adapter_buffer_ports;
    struct s__l__int *adapter_tick_ports;
    struct s__l__sn__tick_port *adapter_vv_tick_ports;
    t__bool tick_requested;
    t__bool active;
    t__bool unconditional_activation;
    struct s__l__sn__instance_path_t *sn_instances;
    t__bool esi_trace;
    t__bool isCallBackDeleted;
    t__bool is_finish_called;
    t__string esi_version;
    t__sn__sn_hdl_kind hdl_kind;
    struct s__l__sn__mvl *x_or_u_or_w_or_dont_care_list;
    struct s__sn__sn_adapter_time *adapter_time;
    struct s__l__string *finish_msgs;
    struct s__sn__sn_ABSTRACT_adapter *adapter_imp;
    struct s__sn__sn_ABSTRACT_adapter *adapter_imp_verisity_verilog_services;
    struct s__sn__sn_ABSTRACT_adapter *simulator_less_adapter_imp;
    t__string current_esi_call;
    struct s__sn__sn_get_simulation_t68950 *adapter_esi___get_simulation_time_data;
    struct s__sn__sn_get_time_resolut68951 *adapter_esi___get_time_resolution_data;
    t__sn__simulator_kind simulator_kind;
    t__sn__simulator_product simulator_product;
    struct s__l__sn__sn_basic_time *slave_wakeup_time;
    t__uint slave_wakeup_time_low;
    t__uint slave_wakeup_time_high;
    t__sn__esi_trace_level trace_level;
    t__bool timers_are_saved;
    t__bool is_verisity_adapter;
    t__bool x_is_set;
    t__bool adapter_ncvhdl___vhdl_compatible_at_x_nc_was_called;
    t__bool adapter_ncvhdl___vhdl_compatible_at_x_nc;
    t__source_ref is_x_sref;
    struct s__k__sn__driver_proc_stru68952 *driver_proc_tab;
    struct s__k__sn__sim_net_struct__68953 *sim_net_tab;
} *t__sn__sn_adapter_bridge;
#define d__sn__sn_adapter_bridge 770
typedef t__sn__sn_adapter_bridge t__sn_adapter_bridge;
#define d__sn_adapter_bridge d__sn__sn_adapter_bridge

/* line 329 "/vobs/specman/src/adapter_bridge.e"  From 'struct definition' */
typedef struct s__sn__sn_adapter_imp_desc14562 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string adapter_lib;
    t__bool pure_e;
    struct s__l__string *id_names;
    struct s__l__string *normalized_id_names;
    t__int id;
    t__sn__sn_agent_kind kind;
    t__string sim_product;
} *t__sn__sn_adapter_imp_description;
#define d__sn__sn_adapter_imp_description 2267
typedef t__sn__sn_adapter_imp_description t__sn_adapter_imp_description;
#define d__sn_adapter_imp_description d__sn__sn_adapter_imp_description

/* line 17 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
} *t__e_core__any_port;
#define d__e_core__any_port 1150
typedef t__e_core__any_port t__any_port;
#define d__any_port d__e_core__any_port

/* line 434 "/vobs/specman/src/atomic_exp.e"  From 'struct definition' */
typedef struct s__sn__sn_unit_attributes {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string hdl_path;
    t__string agent;
    t__bool synthesized;
    struct s__sn__sn_unit_only_attributes *unit_only_attr;
    struct s__e_core__pack_options *pack_options;
} *t__sn__sn_unit_attributes;
#define d__sn__sn_unit_attributes 769
typedef t__sn__sn_unit_attributes t__sn_unit_attributes;
#define d__sn_unit_attributes d__sn__sn_unit_attributes

/* line 3 "/vobs/specman/src/unit_ext.e"  From 'struct definition' */
typedef struct s__sn__sn_unit_only_attributes {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__string *agent_code;
    struct s__l__string *analog_agent_code;
    struct s__l__string *analog_code;
    struct s__l__string *program_code;
    t__string ovm_class;
    t__int ovm_unit_id;
    t__string ovm_path;
    t__string verilog_timescale;
    t__string vhdl_timescale;
    struct s__l__string *pkg_conv_files;
} *t__sn__sn_unit_only_attributes;
#define d__sn__sn_unit_only_attributes 2273
typedef t__sn__sn_unit_only_attributes t__sn_unit_only_attributes;
#define d__sn_unit_only_attributes d__sn__sn_unit_only_attributes

/* line 2125 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__pack_options {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool reverse_fields;
    t__bool reverse_list_items;
    struct s__l__int *final_reorder;
    struct s__l__int *scalar_reorder;
    t__e_core__pack_level level;
} *t__e_core__pack_options;
#define d__e_core__pack_options 120
typedef t__e_core__pack_options t__pack_options;
#define d__pack_options d__e_core__pack_options

/* line 94 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_port_attributes {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool pass_by_pointer;
    t__bool analog;
    t__bool ovm;
    t__bool oig;
    t__bool vams;
    t__string hdl_expression;
    t__string hdl_path_slice_range;
    t__bool big_endian;
    t__sn__sn_drain_buffer drain;
    t__string external_type;
    t__bool sc_variable;
    t__bool static_address;
    t__bool gsa_monitor_port;
    t__string gsa_monitored_c_function;
} *t__sn__sn_port_attributes;
#define d__sn__sn_port_attributes 1173
typedef t__sn__sn_port_attributes t__sn_port_attributes;
#define d__sn_port_attributes d__sn__sn_port_attributes

/* line 259 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_ports_trace_specs {
    t__int d__;
    t__int gen__;
    t__bool read;
    t__bool write;
    struct s__e_core__any_unit *unit_inst;
    t__string full_hdl_path;
    struct s__e_core__any_port *port_ref;
    t__int port_id;
    struct s__sn__sn_trace_port_flags *trace_port_flags;
    t__sn__esi_trace_level esi_trace;
} *t__sn__sn_ports_trace_specs;
#define d__sn__sn_ports_trace_specs 1206
typedef t__sn__sn_ports_trace_specs t__sn_ports_trace_specs;
#define d__sn_ports_trace_specs d__sn__sn_ports_trace_specs

/* line 372 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__sn_trace_port_flags {
    t__int d__;
    t__int gen__;
    t__bool sim_read;
    t__bool sim_write;
    t__bool port_read;
    t__bool port_write;
    t__bool ecel_prof;
} *t__sn__sn_trace_port_flags;
#define d__sn__sn_trace_port_flags 2210
typedef t__sn__sn_trace_port_flags t__sn_trace_port_flags;
#define d__sn_trace_port_flags d__sn__sn_trace_port_flags

/* line 44 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_adapter_port4172 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *packed_data;
} *t__e_core__any_adapter_port_struct;
#define d__e_core__any_adapter_port_struct 1160
typedef t__e_core__any_adapter_port_struct t__any_adapter_port_struct;
#define d__any_adapter_port_struct d__e_core__any_adapter_port_struct

/* line 256 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__single_callback_info {
    t__int d__;
    t__int gen__;
    t__sn__callback_status status;
    t__int occurrence_time_counter;
    t__int wait_time_counter;
    struct s__sn__translated_model_struct *tms;
    struct s__e_core__any_simple_port *port;
    t__external_pointer sim_user_data;
    t__uint event_id;
    t__bool first_registration;
} *t__sn__single_callback_info;
#define d__sn__single_callback_info 1205
typedef t__sn__single_callback_info t__single_callback_info;
#define d__single_callback_info d__sn__single_callback_info

/* line 462 "/vobs/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__sn__translated_model_struct {
    t__int d__;
    t__int gen__;
    struct s__sn__verilog_variable_inst *ver_par;
    t__string source_line;
    t__string name;
    t__string normal_name;
    t__external_pointer ptr;
    t__int min;
    t__int max;
    t__int size;
    t__bool is_variable;
    t__bool is_direction_to;
    t__bool is_driver;
    t__bool is_direct_need_to_set;
    t__uint pput_count;
    t__uint gput_count;
    t__bool is_event;
    t__int event_id;
    struct s__sn__hdl_exp_info *info;
    struct s__sn__sn_verilog_variable *memory_vv;
    struct s__sn__tick_port *tick_port;
    struct s__k__sn__driver_handle__i14580 *driver_handles;
    struct s__sn__vhdl_driver_inst *vhdl_par;
    t__uint put_driverless_count;
    t__bool is_std_logic;
    struct s__sn__curr_calc *simple_calc;
    struct s__sn__curr_calc *curr_calc;
    struct s__sn__name_param *name_par;
    t__uint put_scalar_value_holder;
    struct s__sn__sn_vec *put_long_value_holder;
    struct s__l__uint *put_list_value_holder;
    t__string put_string_value_holder;
    t__sn__mvl put_single_mvl_value_holder;
    t__uint get_scalar_value_holder;
    struct s__sn__sn_vec *get_long_value_holder;
    struct s__l__uint *get_list_value_holder;
    t__string get_string_value_holder;
    t__sn__mvl get_single_mvl_value_holder;
    struct s__l__sn__mvl *put_mvl_value_holder;
    struct s__l__sn__mvl *get_mvl_value_holder;
    t__uint get_mvl_count;
    t__sn__active_value_holder_type active_value_holder;
    t__uint scalar_bit_preserve;
    struct s__sn__sn_vec *long_bit_preserve;
    struct s__l__bit *list_bit_preserve;
    t__sn__sn_assign_fr assign_fr;
    t__int size_in_bits;
    t__bool is_vector;
    t__external_pointer adapter_specific_info;
    t__int app_index;
    t__uint active_event_count;
    struct s__l__sn__single_callback_info *sig_info_list;
    t__bool is_esi_feature;
    struct s__sn__sn_adapter_bridge *adapter_struct;
    t__string get_name;
    t__string put_name;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    struct s__l__source_ref *put_source_refs;
    t__source_ref curr_source_ref;
    t__int last_change_tick_counter;
} *t__sn__translated_model_struct;
#define d__sn__translated_model_struct 1269
typedef t__sn__translated_model_struct t__translated_model_struct;
#define d__translated_model_struct d__sn__translated_model_struct

/* line 59 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__verilog_variable_inst {
    t__int d__;
    t__int gen__;
    struct s__sn__verilog_variable_de14579 *desc;
    t__string name;
    t__string full_base;
    t__string normalized_full_base;
    t__string put_name;
    t__string strobe_name;
    t__string strobe;
    t__string drive;
    t__string drive_name;
    t__string drive_hold;
} *t__sn__verilog_variable_inst;
#define d__sn__verilog_variable_inst 2184
typedef t__sn__verilog_variable_inst t__verilog_variable_inst;
#define d__verilog_variable_inst d__sn__verilog_variable_inst

/* line 32 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__verilog_variable_de14579 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__uint checksum;
    t__string properties;
    t__string name;
    t__string base;
    t__bool is_wire;
    t__bool is_drive_hold;
    t__bool is_drive;
    t__bool is_forc;
    t__bool is_strobe;
    t__string strobe;
    t__string drive_hold;
    t__string drive;
    t__bool is_delta_delay;
    t__string bits;
    t__int minv;
    t__int maxv;
    t__bool direction;
    t__bool is_memory;
    t__sn__memory_type mem_type;
    struct s__sn__memory_var *mem;
    t__int memory_min;
    t__int memory_max;
    t__bool MemoryIsSmallToBig;
    struct s__e_core__any_unit *my_unit_inst;
} *t__sn__verilog_variable_descriptor;
#define d__sn__verilog_variable_descriptor 2183
typedef t__sn__verilog_variable_descriptor t__verilog_variable_descriptor;
#define d__verilog_variable_descriptor d__sn__verilog_variable_descriptor

/* line 215 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__memory_var {
    t__int d__;
    t__int gen__;
    t__uint min;
    t__uint max;
    t__bool is_small_to_big;
} *t__sn__memory_var;
#define d__sn__memory_var 2197
typedef t__sn__memory_var t__memory_var;
#define d__memory_var d__sn__memory_var

/* line 182 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__hdl_exp_info {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int d_index;
    t__bool has_index;
    t__sn__hdl_data_type data_type;
    t__bool to_use_vec;
    t__bool was_computed;
    struct s__sn__hdl_struct *the_hdl;
    struct s__sn__computed_name *the_cms;
    struct s__sn__desc_info *dummy;
    t__int the_desc_info_index;
    t__string name;
    t__string original_string;
    t__bool IsBigToSmall;
    t__int Index;
    t__bool is_memory;
    t__sn__sensitivity_kind sensitize;
    t__bool is_kind_checked;
    t__bool use_temp_local;
    t__external_pointer value;
    t__string temp_string;
    t__bool is_unit;
    t__bool is_sys;
    struct s__sn__struct_descriptor *the_desc;
    t__string struct_string;
    struct s__e_core__any_unit *the_inst;
    t__bool is_need_to_be_set;
    t__bool is_hdl_set;
    struct s__sn__field *struct_field;
    struct s__sn__local *local;
    t__bool debug_relative_mode;
} *t__sn__hdl_exp_info;
#define d__sn__hdl_exp_info 2196
typedef t__sn__hdl_exp_info t__hdl_exp_info;
#define d__hdl_exp_info d__sn__hdl_exp_info

/* line 453 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__hdl_struct {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__sn__desc_info *desc_list_orig;
    struct s__k__sn__desc_info__the_desc *desc_list;
    struct s__sn__name_param *name_par;
} *t__sn__hdl_struct;
#define d__sn__hdl_struct 2213
typedef t__sn__hdl_struct t__hdl_struct;
#define d__hdl_struct d__sn__hdl_struct

/* line 440 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__desc_info {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *the_rf_desc;
    struct s__sn__struct_descriptor *the_desc;
    struct s__l__sn__hdl_element *elem_list;
    t__bool is_deferred_resolution;
    struct s__sn__hdl_exp_info *info;
} *t__sn__desc_info;
#define d__sn__desc_info 2211
typedef t__sn__desc_info t__desc_info;
#define d__desc_info d__sn__desc_info

/* line 205 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_struct {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd_;
} *t__reflection__rf_struct;
#define d__reflection__rf_struct 1721
typedef t__reflection__rf_struct t__rf_struct;
#define d__rf_struct d__reflection__rf_struct

/* line 415 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__struct_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    void *_sgi___ptr_padding[6];
    int _sgi___int_padding[2];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__struct_descriptor;
#define d__sn__struct_descriptor 176
typedef t__sn__struct_descriptor t__struct_descriptor;
#define d__struct_descriptor d__sn__struct_descriptor

/* line 371 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__ExplicitTypeName {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    struct s__sn__package_descriptor *package;
    t__bool package_private;
    t__bool is_hidden;
    struct s__sn__ExplicitName *next_explicit_name;
    struct s__sn__type_descriptor *my_td;
} *t__sn__ExplicitTypeName;
#define d__sn__ExplicitTypeName 160
typedef t__sn__ExplicitTypeName t__ExplicitTypeName;
#define d__ExplicitTypeName d__sn__ExplicitTypeName

/* line 44 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__package_descriptor {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__rf_structural_element *rf_object_;
    struct s__l__sn__package_descriptor *using_packages;
} *t__sn__package_descriptor;
#define d__sn__package_descriptor 148
typedef t__sn__package_descriptor t__package_descriptor;
#define d__package_descriptor d__sn__package_descriptor

/* line 35 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__rf_structural_element {
    t__int d__;
    t__int gen__;
} *t__sn__rf_structural_element;
#define d__sn__rf_structural_element 145
typedef t__sn__rf_structural_element t__rf_structural_element;
#define d__rf_structural_element d__sn__rf_structural_element

/* line 356 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__ExplicitName {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    struct s__sn__package_descriptor *package;
    t__bool package_private;
    t__bool is_hidden;
    struct s__sn__ExplicitName *next_explicit_name;
} *t__sn__ExplicitName;
#define d__sn__ExplicitName 159
typedef t__sn__ExplicitName t__ExplicitName;
#define d__ExplicitName d__sn__ExplicitName

/* line 265 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__type_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
} *t__sn__type_descriptor;
#define d__sn__type_descriptor 156
typedef t__sn__type_descriptor t__type_descriptor;
#define d__type_descriptor d__sn__type_descriptor

/* line 262 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__interval_set {
    t__int d__;
    t__int gen__;
} *t__sn__interval_set;
#define d__sn__interval_set 476
typedef t__sn__interval_set t__interval_set;
#define d__interval_set d__sn__interval_set

/* line 38 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__type_layer {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__type_descriptor *defined_type;
    struct s__sn__rf_structural_element *rf_object_;
} *t__sn__type_layer;
#define d__sn__type_layer 146
typedef t__sn__type_layer t__type_layer;
#define d__type_layer d__sn__type_layer

/* line 262 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__any_rl {
    t__int d__;
    t__int gen__;
} *t__sn__any_rl;
#define d__sn__any_rl 155
typedef t__sn__any_rl t__any_rl;
#define d__any_rl d__sn__any_rl

/* line 407 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_mem_stats {
    t__int d__;
    t__int gen__;
    t__external_pointer total_size;
    t__external_pointer self_size;
    t__external_pointer strings;
    t__external_pointer lists;
    t__external_pointer numerics;
    t__external_pointer n_items;
} *t__sn__sn_mem_stats;
#define d__sn__sn_mem_stats 172
typedef t__sn__sn_mem_stats t__sn_mem_stats;
#define d__sn_mem_stats d__sn__sn_mem_stats

/* line 1549 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__field {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__string name;
    t__string short_name;
    t__int global_field_index;
    t__int _all_when_index;
    t__int field_offset;
    t__int field_offset_other;
    struct s__sn__field_watermark *watermark;
    struct s__sn__type_descriptor *base_type;
    t__int module_num;
    struct s__sn__field_gen_info *fgi;
    struct s__sn__local *script_local;
    struct s__sn__sn_list_size *list_size;
    t__string interface_port_prefix;
    t__string interface_port_suffix;
} *t__sn__field;
#define d__sn__field 241
typedef t__sn__field t__field;
#define d__field d__sn__field

/* line 1537 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__field_watermark {
    t__int d__;
    t__int gen__;
    struct s__sn__field *prev_field;
    struct s__l__sn__field *prev_subtype_fields;
} *t__sn__field_watermark;
#define d__sn__field_watermark 239
typedef t__sn__field_watermark t__field_watermark;
#define d__field_watermark d__sn__field_watermark

/* line 1528 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__field_gen_info {
    t__int d__;
    t__int gen__;
    t__bool needs_bit_rl;
    struct s__sn__any_rl *rl;
    struct s__sn__field *fl;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *gc_inds;
    struct s__l__sn__soft_gc *soft_gcs;
    t__bool is_when_determinant;
    t__bool ever_on_gotf_path;
    t__bool marked_as_reachable;
    t__sn__count n_proccessed_constraints;
    t__uint geb_stamp;
    struct s__sn__seed_domain *the_seed;
    struct s__sn__any_rl *default_rl;
    struct s__sn__any_rl *item_default_rl;
} *t__sn__field_gen_info;
#define d__sn__field_gen_info 236
typedef t__sn__field_gen_info t__field_gen_info;
#define d__field_gen_info d__sn__field_gen_info

/* line 502 "/vobs/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__sn__simple_gen_constraint {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__index index;
    struct s__sn__n__exp *n__exp;
    struct s__sn__explicit_exp *explicit_exp;
    t__sn__gc_status status;
    struct s__l__sn__gen_constraint *derived_from;
    t__sn__count last_reduction;
    struct s__sn__sn_gc_compound_parent *top_gc;
    t__sn__index gen_fly_index;
    t__bool is_soft;
    struct s__l__sn__index *soft_inds;
    struct s__sn__me_constraint_path *for_each_list;
    t__bool do_not_order;
    struct s__l__sn__gc_order_info *gcois;
    t__bool has_soft_temps;
    t__bool reloced_temps;
    t__bool edges_created;
    struct s__k__sn__constraint_path__it *parse_pre_paths;
    t__bool read_only_gc;
    t__bool needs_bit_paths;
    t__bool one_path;
    struct s__l__sn__any_rl *constant_ranges;
    struct s__l__sn__constraint_path *constraint_paths;
    struct s__l__bool *pre_paths;
    t__string pretty;
} *t__sn__simple_gen_constraint;
#define d__sn__simple_gen_constraint 2023
typedef t__sn__simple_gen_constraint t__simple_gen_constraint;
#define d__simple_gen_constraint d__sn__simple_gen_constraint

/* line 666 "/vobs/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__sn__n__exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int sn_attr;
    struct s__sn__st_exp *st_exp;
    struct s__sn__scope *scope;
    struct s__sn__type_descriptor *base_type;
    t__sn__exp_kind kind;
    t__string code;
} *t__sn__n__exp;
#define d__sn__n__exp 532
typedef t__sn__n__exp t__n__exp;
#define d__n__exp d__sn__n__exp

/* line 228 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__reparse_source_ref {
    t__int d__;
    t__int gen__;
    t__source_ref macro_definition_ref;
    t__bool define_as_computed_macro;
    t__int macro_expansion_line;
    struct s__sn__macro_call_info *macro_call_info;
} *t__e_core__reparse_source_ref;
#define d__e_core__reparse_source_ref 31
typedef t__e_core__reparse_source_ref t__reparse_source_ref;
#define d__reparse_source_ref d__e_core__reparse_source_ref

/* line 307 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__macro_call_info {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    t__int my_index;
    t__string code;
    struct s__sn__reparse_macro_descriptor *macro;
    struct s__l__string *sub_matches;
    struct s__l__string *expansion_lines;
} *t__sn__macro_call_info;
#define d__sn__macro_call_info 272
typedef t__sn__macro_call_info t__macro_call_info;
#define d__macro_call_info d__sn__macro_call_info

/* line 285 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__reparse_macro_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    struct s__sn__nt_descriptor *nt_descriptor;
    t__string macro_pattern;
    struct s__sn__matchable_re *re;
    t__int max_submatches;
    struct s__l__sn__sub_nt *sub_nts;
    t__bool enabled;
    t__bool deep_parse;
    void *_sgi___ptr_padding[1];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__reparse_macro_descriptor;
#define d__sn__reparse_macro_descriptor 269
typedef t__sn__reparse_macro_descriptor t__reparse_macro_descriptor;
#define d__reparse_macro_descriptor d__sn__reparse_macro_descriptor

/* line 845 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__method {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    struct s__sn__method_descriptor *md;
    t__sn__method_kind kind;
    t__int layer_index;
    struct s__sn__interpreted_method *interpreted_method;
    struct s__sn__st_action *method_body;
    struct s__sn__scope *scope;
    struct s__sn__type_descriptor *result_type;
    t__source_ref fst_action_srcref;
    struct s__sn__routine *routine;
} *t__sn__method;
#define d__sn__method 187
typedef t__sn__method t__method;
#define d__method d__sn__method

/* line 3 "../src/method_descriptor.e"  From 'struct definition' */
typedef struct s__sn__method_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int index_in_struct;
    struct s__l__sn__method *layers;
    struct s__sn__rf_structural_element *rf_object_;
} *t__sn__method_descriptor;
#define d__sn__method_descriptor 260
typedef t__sn__method_descriptor t__method_descriptor;
#define d__method_descriptor d__sn__method_descriptor

/* line 1135 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__interpreted_method {
    t__int d__;
    t__int gen__;
    struct s__sn__method *method;
    struct s__sn__n__block *n__block;
} *t__sn__interpreted_method;
#define d__sn__interpreted_method 190
typedef t__sn__interpreted_method t__interpreted_method;
#define d__interpreted_method d__sn__interpreted_method

/* line 512 "/vobs/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__sn__n__block {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int sn_attr;
    struct s__sn__scope *scope;
    struct s__sn__method *method;
    t__int level;
    struct s__sn__st_action *st_action;
} *t__sn__n__block;
#define d__sn__n__block 520
typedef t__sn__n__block t__n__block;
#define d__n__block d__sn__n__block

/* line 843 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__ntv_extra {
    t__int d__;
    t__int gen__;
    t__string str;
    struct s__sn__form *form;
    struct s__sn__ntv *super_ntv;
    t__int Depth;
    struct s__sn__macro_descriptor *macro_descriptor;
    struct s__l__string *sub_matches;
    struct s__l__sn__ntv *sub_ntvs;
    t__string error;
    t__string conv_orig_string;
} *t__sn__ntv_extra;
#define d__sn__ntv_extra 281
typedef t__sn__ntv_extra t__ntv_extra;
#define d__ntv_extra d__sn__ntv_extra

/* line 327 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__form {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    t__string string;
    t__sn__form_kind form_kind;
    struct s__l__sn__form *sub_forms;
} *t__sn__form;
#define d__sn__form 274
typedef t__sn__form t__form;
#define d__form d__sn__form

/* line 389 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__ntv {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__sn__ntv;
#define d__sn__ntv 276
typedef t__sn__ntv t__ntv;
#define d__ntv d__sn__ntv

/* line 224 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__macro_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    struct s__sn__nt_descriptor *nt_descriptor;
    t__string macro_pattern;
    struct s__sn__matchable_re *re;
    t__int max_submatches;
    struct s__l__sn__sub_nt *sub_nts;
    t__bool enabled;
    int _sgi___int_padding[2];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__macro_descriptor;
#define d__sn__macro_descriptor 268
typedef t__sn__macro_descriptor t__macro_descriptor;
#define d__macro_descriptor d__sn__macro_descriptor

/* line 393 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__any_struct_info {
    t__int d__;
    t__int gen__;
    struct s__sn__unit_info *unit_info;
    struct s__l__sn__event_descriptor *events;
    struct s__l__sn__constraint_descriptor *constraints;
    struct s__l__sn__cover_descriptor *cover_groups;
} *t__sn__any_struct_info;
#define d__sn__any_struct_info 169
typedef t__sn__any_struct_info t__any_struct_info;
#define d__any_struct_info d__sn__any_struct_info

/* line 389 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__unit_info {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__any_unit *instances;
    t__bool is_agent_imposed;
    struct s__l__sn__sn_verilog_variable *sn_verilog_variables;
    struct s__l__sn__vhdl_driver_desc14563 *drivers;
    struct s__k__sn__subprogram_defin14564 *subprograms;
} *t__sn__unit_info;
#define d__sn__unit_info 165
typedef t__sn__unit_info t__unit_info;
#define d__unit_info d__sn__unit_info

/* line 233 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__sn_verilog_variable {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__tick_port *tick_port_vv;
    struct s__e_core__any_unit *my_unit_inst;
    t__string name;
    t__string base;
    t__string native_base_name;
    t__string native_name;
    t__int minv;
    t__int maxv;
    t__bool direction;
    t__string declared_range;
    t__bool is_memory;
    t__sn__memory_type mem_type;
    struct s__sn__memory_var *mem;
    t__int memory_min;
    t__int memory_max;
    t__bool memory_direction;
    t__uint memory_checksum;
    t__bool for_sig_size;
} *t__sn__sn_verilog_variable;
#define d__sn__sn_verilog_variable 2199
typedef t__sn__sn_verilog_variable t__sn_verilog_variable;
#define d__sn_verilog_variable d__sn__sn_verilog_variable

/* line 267 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__tick_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int port_id;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__sn__sn_port_attributes *port___attributes;
    struct s__sn__sn_simple_port_attri4173 *simple_port___attributes;
    t__string tick_port___source_ref;
    t__string tick_port___orig_declaration;
    t__string tick_port___e_path;
    t__bool tick_port___synthesized;
} *t__sn__tick_port;
#define d__sn__tick_port 2200
typedef t__sn__tick_port t__tick_port;
#define d__tick_port d__sn__tick_port

/* line 96 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_port_attri4173 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__sn__analog_kind_t analog_kind;
    t__bool verilog_wire;
    t__string verilog_drive;
    t__string verilog_drive_hold;
    t__bool verilog_forcible;
    t__string verilog_strobe;
    t__bool verilog_delta_delay;
    t__bool vhdl_driver;
    struct s__l__sn__mvl *vhdl_disconnect_value;
    t__sn__sn_vhdl_delay_mode vhdl_delay_mode;
    t__bool driver;
    struct s__l__sn__mvl *driver_initial_value;
    struct s__e_core__time *driver_delay;
    t__bool delayed;
    t__string declared_range;
    t__uint declared_size;
    t__bool sensitive;
    t__bool passive;
} *t__sn__sn_simple_port_attributes;
#define d__sn__sn_simple_port_attributes 1174
typedef t__sn__sn_simple_port_attributes t__sn_simple_port_attributes;
#define d__sn_simple_port_attributes d__sn__sn_simple_port_attributes

/* line 5 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__time {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__e_core__time;
#define d__e_core__time 1139
typedef t__e_core__time t__time;
#define d__time d__e_core__time

/* line 677 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__vhdl_driver_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string normal_name;
    t__uint delay;
    t__sn__vhdl_set mode;
    t__string initial_str;
    t__string disconnect_str;
    t__bool is_absolut_name;
    struct s__e_core__any_unit *my_unit_inst;
    t__bool vhdl_object;
    t__string orig_string;
    t__bool forcible;
} *t__sn__vhdl_driver_descriptor;
#define d__sn__vhdl_driver_descriptor 2228
typedef t__sn__vhdl_driver_descriptor t__vhdl_driver_descriptor;
#define d__vhdl_driver_descriptor d__sn__vhdl_driver_descriptor

/* line 477 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__subprogram_definition {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__uint checksum;
    t__string evaluated_declaration;
    struct s__reflection__rf_struct *rf_desc;
    t__sn__index index;
    t__string subprogram_name;
    t__string subprogram_clean_name;
    t__sn__simulator_kind kind;
    t__bool is_canonical;
    t__string res_func;
    struct s__l__sn__subprogram_param *params;
    t__bool is_function;
    t__int return_function_size;
    struct s__sn__vhdl_using_param *vhdl_using_param;
    t__string merge_name;
    struct s__e_core__any_unit *my_unit_inst;
} *t__sn__subprogram_definition;
#define d__sn__subprogram_definition 2214
typedef t__sn__subprogram_definition t__subprogram_definition;
#define d__subprogram_definition d__sn__subprogram_definition

/* line 495 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__subprogram_param {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int size_in_bits;
    t__bool input;
    t__bool output;
    t__bool is_literal;
    t__string sub_type;
    t__bool is_signal_type;
} *t__sn__subprogram_param;
#define d__sn__subprogram_param 2215
typedef t__sn__subprogram_param t__subprogram_param;
#define d__subprogram_param d__sn__subprogram_param

/* line 712 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__vhdl_using_param {
    t__int d__;
    t__int gen__;
    t__string library_name;
    t__string package_name;
    t__string alias_name;
    t__string declarative_item;
    t__string return_function_type;
} *t__sn__vhdl_using_param;
#define d__sn__vhdl_using_param 2229
typedef t__sn__vhdl_using_param t__vhdl_using_param;
#define d__vhdl_using_param d__sn__vhdl_using_param

/* line 1762 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__event_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__string name;
    struct s__sn__rf_structural_element *rf_object1_;
    struct s__sn__event_type *et;
    struct s__l__sn__cover_descriptor *cover_groups;
} *t__sn__event_descriptor;
#define d__sn__event_descriptor 242
typedef t__sn__event_descriptor t__event_descriptor;
#define d__event_descriptor d__sn__event_descriptor

/* line 397 "/vobs/specman/src/interp.e"  From 'struct definition' */
typedef struct s__sn__event_type {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string event_name;
    struct s__sn__struct_descriptor *parent_type;
    t__sn__index event_id;
    struct s__l__sn__index *aliases;
    t__sn__index aliased_to;
    struct s__sn__field *occurrence_field_l;
    struct s__sn__field *event_struct_field;
    struct s__sn__field *waiting_thread_field;
    t__int on_method_ind;
    t__sn__on_method_status on_status;
    t__bool trace_emit;
    t__bool log_needed;
    t__int count;
    struct s__sn__event_callback_info *callback_info;
    t__bool is_traceable;
    t__bool has_active_breakpoints;
    t__sn__sn_event_kind kind;
    t__source_ref first_usage;
    struct s__l__int *depend;
    struct s__l__int *scc;
    t__int depth;
    t__bool has_dependency;
    t__bool occurred_d;
    t__int tier;
    t__bool copy_needed;
    struct s__l__e_core__base_struct *traced_instances;
    struct s__sn__event_descriptor *event;
    struct s__main__basic_event_log *log_item;
    struct s__main__sn_cvr_main_group24182 *cover_descriptor;
    t__bool show_flag;
    t__bool collect_flag;
    t__bool is_wave_trace;
    struct s__sn__sn_wave_detailed_ev34124 *notifier;
    t__bool verilog_trace_stub;
    t__bool verilog_trace_write;
    t__int last_count;
} *t__sn__event_type;
#define d__sn__event_type 654
typedef t__sn__event_type t__event_type;
#define d__event_type d__sn__event_type

/* line 273 "/vobs/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn__event_callback_info {
    t__int d__;
    t__int gen__;
    t__sn__index event_id;
    t__string base_signame;
    struct s__l__sn__single_callback_info *cb_list;
} *t__sn__event_callback_info;
#define d__sn__event_callback_info 2797
typedef t__sn__event_callback_info t__event_callback_info;
#define d__event_callback_info d__sn__event_callback_info

/* line 50 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__base_struct {
    t__int d__;
    t__int gen__;
} *t__e_core__base_struct;
#define d__e_core__base_struct 15
typedef t__e_core__base_struct t__base_struct;
#define d__base_struct d__e_core__base_struct

/* line 27 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__basic_event_log {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__uint time_l;
    t__uint time_h;
    t__sn__index event_id;
} *t__main__basic_event_log;
#define d__main__basic_event_log 3584
typedef t__main__basic_event_log t__basic_event_log;
#define d__basic_event_log d__main__basic_event_log

/* line 169 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_main_group24182 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__source_ref source_ref;
    t__string original_file;
    t__int original_line;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    struct s__e_core__real *c_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    struct s__e_core__real *grading;
    t__bool for_report;
    t__bool rankable;
    struct s__sn__struct_descriptor *first_definition_struct;
    t__bool is_defined;
    t__bool ranges_created;
    t__bool dirty;
    struct s__l__sn__st_exp *when_exps;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__cover_descriptor *cgd;
    struct s__k__main__sn_cvr_instanc27169 *instances;
    struct s__main__sn_cvr_original_i27170 *original;
    struct s__main__sn_cvr_original_i27170 *old_original;
    struct s__l__main__sn_cvr_item_at27171 *items_definition_order;
    t__string struct_name;
    t__sn__index when_mask_size;
    struct s__sn__field *parent_field;
    struct s__sn__struct_descriptor *cover_struct_type;
    struct s__sn__event_type *event_type;
    struct s__l__main__sn_cvr_item_de24135 *items_to_sample;
    struct s__l__main__sn_cvr_item_de24135 *simple_not_to_sample;
    struct s__l__main__sn_cvr_item_de24135 *non_simple_not_to_sample;
    t__main__sn_cvr_external_option external_mode;
    struct s__main__cover_struct *run_cs;
    t__bool make_new_cover_struct;
    t__string q_name;
    t__string package_name;
    t__bool is_qualified;
    void *_instances_to_reset___ptr_padding[9];
    int _instances_to_reset___int_padding[2];
    struct s__l__main__sn_cvr_abstrac27172 *instances_to_reset;
} *t__main__sn_cvr_main_group_descriptor;
#define d__main__sn_cvr_main_group_descriptor 3594
typedef t__main__sn_cvr_main_group_descriptor t__sn_cvr_main_group_descriptor;
#define d__sn_cvr_main_group_descriptor d__main__sn_cvr_main_group_descriptor

/* line 2255 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__real {
    t__int d__;
    t__int gen__;
    t__C_double the_double;
} *t__e_core__real;
#define d__e_core__real 125
typedef t__e_core__real t__real;
#define d__real d__e_core__real

/* line 1160 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__st_exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__exp *ntv_exp;
    struct s__sn__explicit_exp *explicit_exp;
    struct s__sn__type_descriptor *base_type;
} *t__sn__st_exp;
#define d__sn__st_exp 300
typedef t__sn__st_exp t__st_exp;
#define d__st_exp d__sn__st_exp

/* line 1146 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__st_node {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
} *t__sn__st_node;
#define d__sn__st_node 298
typedef t__sn__st_node t__st_node;
#define d__st_node d__sn__st_node

/* line 1050 "/vobs/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__sn__explicit_exp {
    t__int d__;
    t__int gen__;
    t__int func_id;
    struct s__sn__n__exp *exp;
    struct s__l__sn__n__action *pre;
    t__bool is_monitor;
} *t__sn__explicit_exp;
#define d__sn__explicit_exp 533
typedef t__sn__explicit_exp t__explicit_exp;
#define d__explicit_exp d__sn__explicit_exp

/* line 291 "/vobs/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__sn__n__action {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int sn_attr;
    struct s__sn__scope *scope;
    struct s__sn__method *method;
    t__int level;
    struct s__sn__st_action *st_action;
} *t__sn__n__action;
#define d__sn__n__action 511
typedef t__sn__n__action t__n__action;
#define d__n__action d__sn__n__action

/* line 1174 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__scope {
    t__int d__;
    t__int gen__;
    struct s__l__sn__local *locals;
    struct s__sn__scope *previous;
    t__int total_num_of_locals;
} *t__sn__scope;
#define d__sn__scope 196
typedef t__sn__scope t__scope;
#define d__scope d__sn__scope

/* line 1206 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__local {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__type_descriptor *base_type;
    t__int index;
    struct s__sn__scope *scope;
    t__int sn_attr;
} *t__sn__local;
#define d__sn__local 199
typedef t__sn__local t__local;
#define d__local d__sn__local

/* line 1155 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__st_action {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__action *ntv_action;
} *t__sn__st_action;
#define d__sn__st_action 299
typedef t__sn__st_action t__st_action;
#define d__st_action d__sn__st_action

/* line 1774 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__cover_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    struct s__sn__event_descriptor *event;
    struct s__l__sn__cover_item_descriptor *items;
    struct s__l__sn__cover_group_layer *layers;
    t__string text;
    t__string vplan_ref;
    t__bool is_global;
    t__int weight;
    struct s__sn__struct_descriptor *per_instance_unit_type;
    t__string per_inst_name;
    struct s__sn__st_exp *when_cond;
    t__bool no_collect_default;
    t__e_core__po_radix radix;
    t__bool count_only;
    t__bool is_predefined;
    struct s__sn__st_exp *per_instance_name;
    struct s__sn__cover_group_layer *current_layer;
    t__string event_name;
} *t__sn__cover_descriptor;
#define d__sn__cover_descriptor 244
typedef t__sn__cover_descriptor t__cover_descriptor;
#define d__cover_descriptor d__sn__cover_descriptor

/* line 273 "/vobs/specman/src/new_cover_descriptor.e"  From 'struct definition' */
typedef struct s__sn__cover_item_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string orig_name;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__cover_descriptor *cgd;
    struct s__l__sn__cover_item_layer *layers;
    struct s__sn__cover_item_layer *current_layer;
    t__int options_attr;
    t__string text;
    t__string vplan_ref;
    t__int weight;
    t__bool is_per_instance;
    struct s__sn__st_exp *when_cond;
    struct s__sn__st_exp *ignore_cond;
    struct s__sn__st_exp *illegal_cond;
    t__bool no_collect;
    t__e_core__po_radix radix;
    t__bool is_no_trace;
    t__int at_least;
    t__int num_of_buckets;
    struct s__l__sn__st_cover_range *ranges;
    void *_rf_object____ptr_padding[2];
    struct s__reflection__rf_cover_item *rf_object_;
} *t__sn__cover_item_descriptor;
#define d__sn__cover_item_descriptor 3503
typedef t__sn__cover_item_descriptor t__cover_item_descriptor;
#define d__cover_item_descriptor d__sn__cover_item_descriptor

/* line 647 "/vobs/specman/src/new_cover_descriptor.e"  From 'struct definition' */
typedef struct s__sn__cover_item_layer {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__cover_item_descriptor *cover_item;
    struct s__sn__cover_group_layer *context_layer;
    struct s__l__sn__st_cover_option *options;
    struct s__reflection__rf_cover_it24039 *rf_object_;
} *t__sn__cover_item_layer;
#define d__sn__cover_item_layer 3508
typedef t__sn__cover_item_layer t__cover_item_layer;
#define d__cover_item_layer d__sn__cover_item_layer

/* line 554 "/vobs/specman/src/new_cover_descriptor.e"  From 'struct definition' */
typedef struct s__sn__cover_group_layer {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__cover_descriptor *cover_group;
    struct s__l__sn__st_cover_option *options;
    struct s__l__sn__cover_item_layer *item_layers;
    t__sn__method_kind kind;
    struct s__reflection__rf_cover_gr24025 *rf_object_;
    struct s__main__sn_cvr_main_group24182 *cvr_main_group;
} *t__sn__cover_group_layer;
#define d__sn__cover_group_layer 3507
typedef t__sn__cover_group_layer t__cover_group_layer;
#define d__cover_group_layer d__sn__cover_group_layer

/* line 776 "/vobs/specman/src/new_cover_descriptor.e"  From 'struct definition' */
typedef struct s__sn__st_cover_option {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
} *t__sn__st_cover_option;
#define d__sn__st_cover_option 3510
typedef t__sn__st_cover_option t__st_cover_option;
#define d__st_cover_option d__sn__st_cover_option

/* line 263 "/vobs/specman/src/cover_reflection.e"  From 'struct definition' */
typedef struct s__reflection__rf_cover_gr24025 {
    t__int d__;
    t__int gen__;
    struct s__sn__cover_group_layer *cover_reflection___cover_layer;
} *t__reflection__rf_cover_group_layer;
#define d__reflection__rf_cover_group_layer 3539
typedef t__reflection__rf_cover_group_layer t__rf_cover_group_layer;
#define d__rf_cover_group_layer d__reflection__rf_cover_group_layer

/* line 309 "/vobs/specman/src/cover_reflection.e"  From 'struct definition' */
typedef struct s__reflection__rf_cover_it24039 {
    t__int d__;
    t__int gen__;
    struct s__sn__cover_item_layer *cover_reflection___cover_layer;
} *t__reflection__rf_cover_item_layer;
#define d__reflection__rf_cover_item_layer 3540
typedef t__reflection__rf_cover_item_layer t__rf_cover_item_layer;
#define d__rf_cover_item_layer d__reflection__rf_cover_item_layer

/* line 749 "/vobs/specman/src/new_cover_descriptor.e"  From 'struct definition' */
typedef struct s__sn__st_cover_range {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    t__string name;
    t__int every_count;
    t__int at_least;
    struct s__sn__st_range_const_exp *range;
} *t__sn__st_cover_range;
#define d__sn__st_cover_range 3509
typedef t__sn__st_cover_range t__st_cover_range;
#define d__st_cover_range d__sn__st_cover_range

/* line 265 "/vobs/specman/src/syntax_exp.e"  From 'struct definition' */
typedef struct s__sn__st_range_const_exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__exp *ntv_exp;
    struct s__sn__explicit_exp *explicit_exp;
    struct s__sn__type_descriptor *base_type;
    struct s__sn__type_descriptor *td;
    struct s__sn__interval_set *set;
    t__int idx;
    struct s__sn__type_descriptor *elem_td;
    struct s__sn__local *tmp_local;
    struct s__sn_rl__scalar_rl *rl;
} *t__sn__st_range_const_exp;
#define d__sn__st_range_const_exp 704
typedef t__sn__st_range_const_exp t__st_range_const_exp;
#define d__st_range_const_exp d__sn__st_range_const_exp

/* line 20 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__scalar_rl {
    t__int d__;
    t__int gen__;
} *t__sn_rl__scalar_rl;
#define d__sn_rl__scalar_rl 1629
typedef t__sn_rl__scalar_rl t__scalar_rl;
#define d__scalar_rl d__sn_rl__scalar_rl

/* line 153 "/vobs/specman/src/cover_reflection.e"  From 'struct definition' */
typedef struct s__reflection__rf_cover_item {
    t__int d__;
    t__int gen__;
    struct s__sn__cover_item_descriptor *cover_reflection___cover_item;
} *t__reflection__rf_cover_item;
#define d__reflection__rf_cover_item 3535
typedef t__reflection__rf_cover_item t__rf_cover_item;
#define d__rf_cover_item d__reflection__rf_cover_item

/* line 452 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_instance_g27174 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__source_ref source_ref;
    t__string original_file;
    t__int original_line;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    struct s__e_core__real *c_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    struct s__e_core__real *grading;
    t__bool for_report;
    t__bool rankable;
    struct s__sn__struct_descriptor *first_definition_struct;
    t__bool is_defined;
    t__bool ranges_created;
    t__bool dirty;
    struct s__l__sn__st_exp *when_exps;
    struct s__main__sn_cvr_main_group24182 *parent;
    struct s__l__main__sn_cvr_item_de24135 *items;
    t__bool has_samples;
    struct s__e_core__real *sampled_items_weight;
    t__bool full;
    t__int gui_id;
    t__sn__index index_in_when_mask;
} *t__main__sn_cvr_instance_group_descriptor;
#define d__main__sn_cvr_instance_group_descriptor 3598
typedef t__main__sn_cvr_instance_group_descriptor t__sn_cvr_instance_group_descriptor;
#define d__sn_cvr_instance_group_descriptor d__main__sn_cvr_instance_group_descriptor

/* line 606 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_item_descriptor {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__source_ref source_ref;
    t__string original_file;
    t__int original_line;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    struct s__e_core__real *c_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    struct s__e_core__real *grading;
    t__bool for_report;
    t__bool rankable;
    struct s__sn__struct_descriptor *first_definition_struct;
    struct s__sn__cover_item_descriptor *cover_item;
    t__sn__index index_in_when_mask;
    t__main__sn_cvr_item_kind kind;
    struct s__main__sn_cvr_abstract_i24144 *parent;
    struct s__main__sn_cvr_main_group24182 *main_group;
    struct s__sn__type_descriptor *type_rep;
    struct s__sn__type_descriptor *type_descriptor;
    struct s__sn__field *field;
    struct s__sn__field *parent_field;
    t__int at_least;
    t__bool ranges_created;
    struct s__l__main__n__cover_range27175 *ranges_preparse;
    struct s__l__main__sn_cvr_item_de24135 *sub_items;
    t__int num_of_buckets;
    t__bool in_initial_state;
    struct s__main__sn_cover_distribution *runtime_distribution;
    struct s__main__sn_cover_analysis24155 *analysis_distribution;
    struct s__main__sn_cover_show_dis27176 *show_distribution;
    struct s__main__sn_cover_analysis27177 *item_insts;
    t__bool non_saved;
    t__int last_simple_ind;
    t__string exp_string;
    t__bool no_trace;
    t__bool sampling_in_progress;
    t__bool has_samples;
    struct s__e_core__real *sampled_buckets_weight;
    t__bool full;
    struct s__l__sn__st_exp *when_exps;
    struct s__l__main__sn_cover_exp *ignore_exps;
    struct s__l__main__sn_cover_exp *illegal_exps;
    struct s__sn__explicit_exp *type_exp;
    t__sn__cast cast;
    struct s__main__sn_cvr_item_descriptor *base_item;
    t__string from_inst;
    struct s__l__string *sample_full_name;
    t__bool has_illegal;
    struct s__k__main__sn_cvr_bucket_24610 *rank_bucket_descriptors;
    struct s__main__sn_cvr_valid_space *valid_space;
    t__bool scratchpad_projection_dirty;
    t__bool grade_calc_dirty;
    t__bool show_dist_sorting_dirty_flag;
    struct s__main__sn_cvr_space_desc75056 *spd;
    struct s__main__sn_cvr_grading_data *grading_ptr;
    struct s__reflection__rf_cover_item *rf_item;
    t__bool is_in_context;
    struct s__l__string *last_sampled_vals;
    t__main__sn_cvr_illegal_check_status illegal_status;
    t__uint valid_space_size;
    t__uint physical_space_size;
    void *_all_items___ptr_padding[2];
    struct s__l__main__sn_cvr_item_de24135 *all_items;
    struct s__l__int *sample_full_inds;
} *t__main__sn_cvr_item_descriptor;
#define d__main__sn_cvr_item_descriptor 3606
typedef t__main__sn_cvr_item_descriptor t__sn_cvr_item_descriptor;
#define d__sn_cvr_item_descriptor d__main__sn_cvr_item_descriptor

/* line 412 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_abstract_i24144 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__source_ref source_ref;
    t__string original_file;
    t__int original_line;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    struct s__e_core__real *c_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    struct s__e_core__real *grading;
    t__bool for_report;
    t__bool rankable;
    struct s__sn__struct_descriptor *first_definition_struct;
    t__bool is_defined;
    t__bool ranges_created;
    t__bool dirty;
    struct s__l__sn__st_exp *when_exps;
    struct s__main__sn_cvr_main_group24182 *parent;
    struct s__l__main__sn_cvr_item_de24135 *items;
    t__bool has_samples;
    struct s__e_core__real *sampled_items_weight;
    t__bool full;
    t__int gui_id;
    t__sn__index index_in_when_mask;
} *t__main__sn_cvr_abstract_instance_descriptor;
#define d__main__sn_cvr_abstract_instance_descriptor 3597
typedef t__main__sn_cvr_abstract_instance_descriptor t__sn_cvr_abstract_instance_descriptor;
#define d__sn_cvr_abstract_instance_descriptor d__main__sn_cvr_abstract_instance_descriptor

/* line 176 "/vobs/specman/src/cover_basic.e"  From 'struct definition' */
typedef struct s__main__n__cover_range_params {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    struct s__sn__n__range_list *r_preparse;
    t__bool others_flag;
    t__string name;
    t__int every_int;
    struct s__e_core__real *every_real;
    t__int at_least;
    t__string orig_name;
} *t__main__n__cover_range_params;
#define d__main__n__cover_range_params 3575
typedef t__main__n__cover_range_params t__n__cover_range_params;
#define d__n__cover_range_params d__main__n__cover_range_params

/* line 173 "/vobs/specman/src/range.e"  From 'struct definition' */
typedef struct s__sn__n__range_list {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int constant_index;
    struct s__sn__type_descriptor *type;
    t__bool forced_type;
} *t__sn__n__range_list;
#define d__sn__n__range_list 985
typedef t__sn__n__range_list t__n__range_list;
#define d__n__range_list d__sn__n__range_list

/* line 774 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_distribution {
    t__int d__;
    t__int gen__;
    struct s__l__int *counts;
    struct s__k__string__it *vals;
    struct s__l__string *vals_to_write;
} *t__main__sn_cover_distribution;
#define d__main__sn_cover_distribution 3617
typedef t__main__sn_cover_distribution t__sn_cover_distribution;
#define d__sn_cover_distribution d__main__sn_cover_distribution

/* line 767 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_analysis24155 {
    t__int d__;
    t__int gen__;
} *t__main__sn_cover_analysis_distribution;
#define d__main__sn_cover_analysis_distribution 3615
typedef t__main__sn_cover_analysis_distribution t__sn_cover_analysis_distribution;
#define d__sn_cover_analysis_distribution d__main__sn_cover_analysis_distribution

/* line 777 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_show_dis27176 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_item_descriptor *top_item;
    struct s__main__sn_cvr_sample *top_sample;
    t__int last_ind;
} *t__main__sn_cover_show_distribution;
#define d__main__sn_cover_show_distribution 3618
typedef t__main__sn_cover_show_distribution t__sn_cover_show_distribution;
#define d__sn_cover_show_distribution d__main__sn_cover_show_distribution

/* line 704 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_sample {
    t__int d__;
    t__int gen__;
    t__string unique_val;
    t__int count;
    t__int tests_count;
    struct s__main__sn_cvr_internal_sample *parent;
    t__int sample_ind;
    struct s__e_core__real *grading;
    t__int test_ind;
} *t__main__sn_cvr_sample;
#define d__main__sn_cvr_sample 7420
typedef t__main__sn_cvr_sample t__sn_cvr_sample;
#define d__sn_cvr_sample d__main__sn_cvr_sample

/* line 775 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_internal_sample {
    t__int d__;
    t__int gen__;
    t__string unique_val;
    t__int count;
    t__int tests_count;
    struct s__main__sn_cvr_internal_sample *parent;
    t__int sample_ind;
    struct s__e_core__real *grading;
    t__int test_ind;
} *t__main__sn_cvr_internal_sample;
#define d__main__sn_cvr_internal_sample 7421
typedef t__main__sn_cvr_internal_sample t__sn_cvr_internal_sample;
#define d__sn_cvr_internal_sample d__main__sn_cvr_internal_sample

/* line 1139 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_analysis27177 {
    t__int d__;
    t__int gen__;
    struct s__l__main__sn_cover_sampl24539 *distributions;
    struct s__l__main__sn_abs_cover_test *related_tests;
} *t__main__sn_cover_analysis_item_insts;
#define d__main__sn_cover_analysis_item_insts 3649
typedef t__main__sn_cover_analysis_item_insts t__sn_cover_analysis_item_insts;
#define d__sn_cover_analysis_item_insts d__main__sn_cover_analysis_item_insts

/* line 751 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_sampling24509 {
    t__int d__;
    t__int gen__;
} *t__main__sn_cover_sampling_distribution;
#define d__main__sn_cover_sampling_distribution 3614
typedef t__main__sn_cover_sampling_distribution t__sn_cover_sampling_distribution;
#define d__sn_cover_sampling_distribution d__main__sn_cover_sampling_distribution

/* line 832 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_abs_cover_test {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string test_name;
    t__string tag_name;
    t__string run_name;
    t__string full_run_name;
    t__string file_name;
    t__bool disable;
    struct s__l__int *seeds;
    struct s__e_core__time *test_time;
    t__int usr_time;
    t__int system_time;
    t__int dut_errs;
} *t__main__sn_abs_cover_test;
#define d__main__sn_abs_cover_test 3620
typedef t__main__sn_abs_cover_test t__sn_abs_cover_test;
#define d__sn_abs_cover_test d__main__sn_abs_cover_test

/* line 585 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__st_exp *exp;
} *t__main__sn_cover_exp;
#define d__main__sn_cover_exp 3604
typedef t__main__sn_cover_exp t__sn_cover_exp;
#define d__sn_cover_exp d__main__sn_cover_exp

/* line 1089 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_bucket_ran27195 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
    struct s__main__sn_cvr_item_descriptor *item_descriptor;
    t__int samples;
    t__int no_of_tests;
    t__int at_least;
    t__int weight;
    struct s__e_core__real *c_weight;
    t__int required_samples;
    t__bool full;
    t__int fill_samples;
    struct s__e_core__real *last_grade;
} *t__main__sn_cvr_bucket_rank_descriptor;
#define d__main__sn_cvr_bucket_rank_descriptor 3646
typedef t__main__sn_cvr_bucket_rank_descriptor t__sn_cvr_bucket_rank_descriptor;
#define d__sn_cvr_bucket_rank_descriptor d__main__sn_cvr_bucket_rank_descriptor

/* line 312 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_valid_space {
    t__int d__;
    t__int gen__;
    struct s__l__main__sn_cvr_bucket *valid_buckets;
    t__bool is_sampled_valid_space;
    struct s__l__main__sn_cvr_bucket *ii_buckets;
    struct s__k__main__sn_cvr_ignore_75079 *ignore_buckets;
    struct s__l__string *full_bucket_name;
    t__int sampled_space_size;
    t__bool is_ii_space_is_full;
    t__bool is_ignore_space_is_full;
} *t__main__sn_cvr_valid_space;
#define d__main__sn_cvr_valid_space 7412
typedef t__main__sn_cvr_valid_space t__sn_cvr_valid_space;
#define d__sn_cvr_valid_space d__main__sn_cvr_valid_space

/* line 1183 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_bucket {
    t__int d__;
    t__int gen__;
    t__string unique_val;
    t__int count;
    t__int index;
} *t__main__sn_cvr_bucket;
#define d__main__sn_cvr_bucket 7430
typedef t__main__sn_cvr_bucket t__sn_cvr_bucket;
#define d__sn_cvr_bucket d__main__sn_cvr_bucket

/* line 1311 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_ignore_bucket {
    t__int d__;
    t__int gen__;
    t__string unique_val;
    t__int count;
    t__int index;
} *t__main__sn_cvr_ignore_bucket;
#define d__main__sn_cvr_ignore_bucket 7437
typedef t__main__sn_cvr_ignore_bucket t__sn_cvr_ignore_bucket;
#define d__sn_cvr_ignore_bucket d__main__sn_cvr_ignore_bucket

/* line 211 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_space_desc75056 {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__scalar_rl *legal_range;
    struct s__main__sn_cover_illegal_75081 *illegal_bucket;
    t__bool gradable;
    struct s__sn__sn_long *space_size;
    t__int last_ind;
    struct s__main__sn_cvr_item_ecov_data *ecov_data;
} *t__main__sn_cvr_space_descriptor;
#define d__main__sn_cvr_space_descriptor 7404
typedef t__main__sn_cvr_space_descriptor t__sn_cvr_space_descriptor;
#define d__sn_cvr_space_descriptor d__main__sn_cvr_space_descriptor

/* line 4 "/vobs/specman/src/cover_flat_buckets.e"  From 'struct definition' */
typedef struct s__main__sn_cover_illegal_75081 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__bool bingo;
    t__bool is_illegal;
    t__string name;
    t__sn__index bucket_num;
    t__bool is_secondary;
    t__int at_least;
    struct s__sn_rl__scalar_rl *rl;
} *t__main__sn_cover_illegal_bucket;
#define d__main__sn_cover_illegal_bucket 7465
typedef t__main__sn_cover_illegal_bucket t__sn_cover_illegal_bucket;
#define d__sn_cover_illegal_bucket d__main__sn_cover_illegal_bucket

/* line 127 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__sn_long {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__sn__sn_long;
#define d__sn__sn_long 471
typedef t__sn__sn_long t__sn_long;
#define d__sn_long d__sn__sn_long

/* line 252 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_item_ecov_data {
    t__int d__;
    t__int gen__;
} *t__main__sn_cvr_item_ecov_data;
#define d__main__sn_cvr_item_ecov_data 7406
typedef t__main__sn_cvr_item_ecov_data t__sn_cvr_item_ecov_data;
#define d__sn_cvr_item_ecov_data d__main__sn_cvr_item_ecov_data

/* line 90 "/vobs/specman/src/cover_flat_basic.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_grading_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__real *grading;
    t__int samples;
} *t__main__sn_cvr_grading_data;
#define d__main__sn_cvr_grading_data 7403
typedef t__main__sn_cvr_grading_data t__sn_cvr_grading_data;
#define d__sn_cvr_grading_data d__main__sn_cvr_grading_data

/* line 461 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_original_i27170 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__source_ref source_ref;
    t__string original_file;
    t__int original_line;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    struct s__e_core__real *c_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    struct s__e_core__real *grading;
    t__bool for_report;
    t__bool rankable;
    struct s__sn__struct_descriptor *first_definition_struct;
    t__bool is_defined;
    t__bool ranges_created;
    t__bool dirty;
    struct s__l__sn__st_exp *when_exps;
    struct s__main__sn_cvr_main_group24182 *parent;
    struct s__l__main__sn_cvr_item_de24135 *items;
    t__bool has_samples;
    struct s__e_core__real *sampled_items_weight;
    t__bool full;
    t__int gui_id;
    t__sn__index index_in_when_mask;
} *t__main__sn_cvr_original_instance_group_descriptor;
#define d__main__sn_cvr_original_instance_group_descriptor 3599
typedef t__main__sn_cvr_original_instance_group_descriptor t__sn_cvr_original_instance_group_descriptor;
#define d__sn_cvr_original_instance_group_descriptor d__main__sn_cvr_original_instance_group_descriptor

/* line 593 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_item_attributes {
    t__int d__;
    t__int gen__;
    t__string instance_exp;
    struct s__main__sn_cvr_abstract_i24144 *parent;
    struct s__main__sn_cvr_item_descriptor *item;
    t__string name;
    t__int id;
} *t__main__sn_cvr_item_attributes;
#define d__main__sn_cvr_item_attributes 3605
typedef t__main__sn_cvr_item_attributes t__sn_cvr_item_attributes;
#define d__sn_cvr_item_attributes d__main__sn_cvr_item_attributes

/* line 30 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__cover_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__uint time_l;
    t__uint time_h;
    t__sn__index event_id;
    struct s__l__bool__8 *when_mask;
} *t__main__cover_struct;
#define d__main__cover_struct 3585
typedef t__main__cover_struct t__cover_struct;
#define d__cover_struct d__main__cover_struct

/* line 144 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__sn_wave_detailed_ev34124 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__wave_event_element *wave_event_elements;
    struct s__sn__event_type *et;
} *t__sn__sn_wave_detailed_event_notifier;
#define d__sn__sn_wave_detailed_event_notifier 4339
typedef t__sn__sn_wave_detailed_event_notifier t__sn_wave_detailed_event_notifier;
#define d__sn_wave_detailed_event_notifier d__sn__sn_wave_detailed_event_notifier

/* line 148 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__wave_event_element {
    t__int d__;
    t__int gen__;
    struct s__sn__wave_element_allocation *allocation;
    struct s__l__string *log_lines;
    struct s__sn__sn_wave_event_eleme33003 *notifier;
    t__sn__wave_event_data event_data;
    t__bool trace_by_type;
    struct s__sn__abs_wave_command_manager *parent;
} *t__sn__wave_event_element;
#define d__sn__wave_event_element 4340
typedef t__sn__wave_event_element t__wave_event_element;
#define d__wave_event_element d__sn__wave_event_element

/* line 1611 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_element_allocation {
    t__int d__;
    t__int gen__;
    struct s__l__sn__abs_wave_entry *wave_entries;
} *t__sn__wave_element_allocation;
#define d__sn__wave_element_allocation 4333
typedef t__sn__wave_element_allocation t__wave_element_allocation;
#define d__wave_element_allocation d__sn__wave_element_allocation

/* line 404 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__abs_wave_entry {
    t__int d__;
    t__int gen__;
    t__sn__wave_entry_type entry_type;
    t__string new_name;
    t__int signal_id;
    struct s__sn__wave_hdl_stub_info *hdl_stub_info;
    t__bool val_changed;
    t__bool val_is_undef;
    t__string scope_and_variable;
} *t__sn__abs_wave_entry;
#define d__sn__abs_wave_entry 4322
typedef t__sn__abs_wave_entry t__abs_wave_entry;
#define d__abs_wave_entry d__sn__abs_wave_entry

/* line 398 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_hdl_stub_info {
    t__int d__;
    t__int gen__;
    struct s__sn__translated_model_struct *signal_tms;
    t__uint relative_signal_id;
    struct s__sn__instance_path_t *stub_instance;
} *t__sn__wave_hdl_stub_info;
#define d__sn__wave_hdl_stub_info 4321
typedef t__sn__wave_hdl_stub_info t__wave_hdl_stub_info;
#define d__wave_hdl_stub_info d__sn__wave_hdl_stub_info

/* line 427 "/vobs/specman/src/atomic_exp.e"  From 'struct definition' */
typedef struct s__sn__instance_path_t {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_adapter_bridge *adapter_struct;
    t__string sn_hdl_path;
    t__string sn_normal_path;
    t__string wave_hdl_path;
    t__string wave_normal_path;
    t__uint checksum;
    t__uint checksum_ref;
    t__uint version_date;
    t__uint stub_constant_part_version;
    t__bool generated_stub;
    t__bool stub_version_ok;
    t__uint sn_integer_num;
    t__uint sn_boolean_num;
    t__uint sn_error_num;
    t__uint sn_error_len;
    t__uint sn_message_num;
    t__uint sn_message_len;
    t__uint sn_string_num;
    t__uint sn_string_len;
    t__uint sn_event_num;
    t__uint sn_integer_offset;
    t__uint sn_boolean_offset;
    t__uint sn_error_offset;
    t__uint sn_message_offset;
    t__uint sn_string_offset;
    t__uint sn_event_offset;
    t__bool duplicated;
} *t__sn__instance_path_t;
#define d__sn__instance_path_t 768
typedef t__sn__instance_path_t t__instance_path_t;
#define d__instance_path_t d__sn__instance_path_t

/* line 132 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__sn_wave_event_eleme33003 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__wave_event_element *wave_event_elements;
} *t__sn__sn_wave_event_element_notifier;
#define d__sn__sn_wave_event_element_notifier 4338
typedef t__sn__sn_wave_event_element_notifier t__sn_wave_event_element_notifier;
#define d__sn_wave_event_element_notifier d__sn__sn_wave_event_element_notifier

/* line 1269 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__abs_wave_command_manager {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string wave_cmd;
    t__string group_name;
    t__bool pending;
    t__bool hidden;
} *t__sn__abs_wave_command_manager;
#define d__sn__abs_wave_command_manager 4347
typedef t__sn__abs_wave_command_manager t__abs_wave_command_manager;
#define d__abs_wave_command_manager d__sn__abs_wave_command_manager

/* line 1766 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__constraint_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__string name;
    struct s__reflection__st_constraint *st_root;
} *t__sn__constraint_descriptor;
#define d__sn__constraint_descriptor 243
typedef t__sn__constraint_descriptor t__constraint_descriptor;
#define d__constraint_descriptor d__sn__constraint_descriptor

/* line 46 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__st_constraint {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__constraint *syntax_tree___constraint;
} *t__reflection__st_constraint;
#define d__reflection__st_constraint 1718
typedef t__reflection__st_constraint t__st_constraint;
#define d__st_constraint d__reflection__st_constraint

/* line 225 "/vobs/specman/src/gen_ntvs.e"  From 'struct definition' */
typedef struct s__sn__n__constraint {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__sn__n__constraint;
#define d__sn__n__constraint 1826
typedef t__sn__n__constraint t__n__constraint;
#define d__n__constraint d__sn__n__constraint

/* line 404 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__when_tree_node {
    t__int d__;
    t__int gen__;
    t__int value;
    struct s__sn__when_tree_node *prev_node;
    struct s__sn__subtype_descriptor *subtype;
    struct s__sn__when_tree_node *dont_care_edge;
    struct s__k__sn__when_tree_node__value *next_values;
    struct s__sn__field *next_field;
} *t__sn__when_tree_node;
#define d__sn__when_tree_node 171
typedef t__sn__when_tree_node t__when_tree_node;
#define d__when_tree_node d__sn__when_tree_node

/* line 578 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__subtype_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    struct s__sn__Context *Context;
    struct s__sn__type_layer *first_defining_layer;
    t__imp_enum_sn_when_subtype__subtype_descriptor__subtype_status subtype_status;
    t__string cached_short_name;
    void *_sgi___ptr_padding[2];
    int _sgi___int_padding[2];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__subtype_descriptor;
#define d__sn__subtype_descriptor 181
typedef t__sn__subtype_descriptor t__subtype_descriptor;
#define d__subtype_descriptor d__sn__subtype_descriptor

/* line 2144 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__Context {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *when_root;
    struct s__l__sn__context_item *items;
} *t__sn__Context;
#define d__sn__Context 259
typedef t__sn__Context t__Context;
#define d__Context d__sn__Context

/* line 2139 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__context_item {
    t__int d__;
    t__int gen__;
    struct s__sn__field *field;
    t__int value;
} *t__sn__context_item;
#define d__sn__context_item 257
typedef t__sn__context_item t__context_item;
#define d__context_item d__sn__context_item

/* line 576 "/vobs/specman/src/gen_lang.e"  From 'struct definition' */
typedef struct s__sn__sd_gen_info {
    t__int d__;
    t__int gen__;
    struct s__sn__composite_descriptor *sd;
    struct s__l__sn__temp_field *temp_fields;
    struct s__l__sn__gen_constraint *gcs;
    struct s__k__sn__field__it *determinants;
    t__sn__sn_fast_gen_status fast_gen_status;
    struct s__l__bool *temps_relevant;
    struct s__l__sn__a_role *roles;
    struct s__l__sn__a_role *me_roles;
    t__sn__index last_reloced_temp;
    t__sn__visited_status visited_status;
    t__bool added_to_reachable_list;
    struct s__sn__composite_descriptor *smallest_fast_subtype;
} *t__sn__sd_gen_info;
#define d__sn__sd_gen_info 1963
typedef t__sn__sd_gen_info t__sd_gen_info;
#define d__sd_gen_info d__sn__sd_gen_info

/* line 410 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__composite_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    void *_sgi___ptr_padding[14];
    int _sgi___int_padding[8];
    struct s__sn__sd_gen_info *sgi;
} *t__sn__composite_descriptor;
#define d__sn__composite_descriptor 173
typedef t__sn__composite_descriptor t__composite_descriptor;
#define d__composite_descriptor d__sn__composite_descriptor

/* line 430 "/vobs/specman/src/gen_lang.e"  From 'struct definition' */
typedef struct s__sn__temp_field {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__string name;
    t__string short_name;
    t__int global_field_index;
    t__int _all_when_index;
    t__int field_offset;
    t__int field_offset_other;
    struct s__sn__field_watermark *watermark;
    struct s__sn__type_descriptor *base_type;
    t__int module_num;
    struct s__sn__field_gen_info *fgi;
    struct s__sn__local *script_local;
    struct s__sn__sn_list_size *list_size;
    t__string interface_port_prefix;
    t__string interface_port_suffix;
    struct s__sn__composite_descriptor *pgen_context_struct;
    t__int index;
    t__bool flag;
    t__int gen_index;
} *t__sn__temp_field;
#define d__sn__temp_field 1960
typedef t__sn__temp_field t__temp_field;
#define d__temp_field d__sn__temp_field

/* line 1534 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_list_size {
    t__int d__;
    t__int gen__;
} *t__sn__sn_list_size;
#define d__sn__sn_list_size 238
typedef t__sn__sn_list_size t__sn_list_size;
#define d__sn_list_size d__sn__sn_list_size

/* line 2099 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__gen_constraint {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__index index;
    struct s__sn__n__exp *n__exp;
    struct s__sn__explicit_exp *explicit_exp;
    t__sn__gc_status status;
    struct s__l__sn__gen_constraint *derived_from;
    t__sn__count last_reduction;
    struct s__sn__sn_gc_compound_parent *top_gc;
    t__sn__index gen_fly_index;
    t__bool is_soft;
    struct s__l__sn__index *soft_inds;
    struct s__sn__me_constraint_path *for_each_list;
    t__bool do_not_order;
    struct s__l__sn__gc_order_info *gcois;
    t__bool has_soft_temps;
    t__bool reloced_temps;
    t__bool edges_created;
    struct s__k__sn__constraint_path__it *parse_pre_paths;
    t__bool read_only_gc;
    t__bool needs_bit_paths;
} *t__sn__gen_constraint;
#define d__sn__gen_constraint 255
typedef t__sn__gen_constraint t__gen_constraint;
#define d__gen_constraint d__sn__gen_constraint

/* line 113 "/vobs/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__sn__sn_gc_compound_parent {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_or *top_or;
    t__sn__index or_index;
    struct s__sn__gen_constraint_and *top_and;
    t__sn__index and_index;
} *t__sn__sn_gc_compound_parent;
#define d__sn__sn_gc_compound_parent 2022
typedef t__sn__sn_gc_compound_parent t__sn_gc_compound_parent;
#define d__sn_gc_compound_parent d__sn__sn_gc_compound_parent

/* line 693 "/vobs/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__sn__gen_constraint_or {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__index index;
    struct s__sn__n__exp *n__exp;
    struct s__sn__explicit_exp *explicit_exp;
    t__sn__gc_status status;
    struct s__l__sn__gen_constraint *derived_from;
    t__sn__count last_reduction;
    struct s__sn__sn_gc_compound_parent *top_gc;
    t__sn__index gen_fly_index;
    t__bool is_soft;
    struct s__l__sn__index *soft_inds;
    struct s__sn__me_constraint_path *for_each_list;
    t__bool do_not_order;
    struct s__l__sn__gc_order_info *gcois;
    t__bool has_soft_temps;
    t__bool reloced_temps;
    t__bool edges_created;
    struct s__k__sn__constraint_path__it *parse_pre_paths;
    t__bool read_only_gc;
    t__bool needs_bit_paths;
    struct s__l__sn__gen_constraint *constraints;
    t__bool is_imply;
} *t__sn__gen_constraint_or;
#define d__sn__gen_constraint_or 2053
typedef t__sn__gen_constraint_or t__gen_constraint_or;
#define d__gen_constraint_or d__sn__gen_constraint_or

/* line 409 "/vobs/specman/src/gen_constraint_path.e"  From 'struct definition' */
typedef struct s__sn__me_constraint_path {
    t__int d__;
    t__int gen__;
    t__string base_str;
    struct s__l__sn__field_holder *fields;
    struct s__sn__field_holder *field;
    t__sn__index role_id;
    t__bool tmp;
    t__bool temp_soft;
} *t__sn__me_constraint_path;
#define d__sn__me_constraint_path 2010
typedef t__sn__me_constraint_path t__me_constraint_path;
#define d__me_constraint_path d__sn__me_constraint_path

/* line 62 "/vobs/specman/src/gen_constraint_path.e"  From 'struct definition' */
typedef struct s__sn__field_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__field *field;
    t__sn__constraint_role_type role;
    t__sn__index local_index;
} *t__sn__field_holder;
#define d__sn__field_holder 2004
typedef t__sn__field_holder t__field_holder;
#define d__field_holder d__sn__field_holder

/* line 103 "/vobs/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__sn__gc_order_info {
    t__int d__;
    t__int gen__;
    struct s__sn__simple_gen_constraint *gc;
    t__sn__om_edge_reason reason;
    struct s__l__sn__index *input_indices;
    struct s__l__sn__index *output_indices;
    t__bool is_soft;
    t__bool has_dof;
} *t__sn__gc_order_info;
#define d__sn__gc_order_info 2021
typedef t__sn__gc_order_info t__gc_order_info;
#define d__gc_order_info d__sn__gc_order_info

/* line 137 "/vobs/specman/src/gen_constraint_path.e"  From 'struct definition' */
typedef struct s__sn__constraint_path {
    t__int d__;
    t__int gen__;
    t__string base_str;
} *t__sn__constraint_path;
#define d__sn__constraint_path 2005
typedef t__sn__constraint_path t__constraint_path;
#define d__constraint_path d__sn__constraint_path

/* line 679 "/vobs/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__sn__gen_constraint_and {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__index index;
    struct s__sn__n__exp *n__exp;
    struct s__sn__explicit_exp *explicit_exp;
    t__sn__gc_status status;
    struct s__l__sn__gen_constraint *derived_from;
    t__sn__count last_reduction;
    struct s__sn__sn_gc_compound_parent *top_gc;
    t__sn__index gen_fly_index;
    t__bool is_soft;
    struct s__l__sn__index *soft_inds;
    struct s__sn__me_constraint_path *for_each_list;
    t__bool do_not_order;
    struct s__l__sn__gc_order_info *gcois;
    t__bool has_soft_temps;
    t__bool reloced_temps;
    t__bool edges_created;
    struct s__k__sn__constraint_path__it *parse_pre_paths;
    t__bool read_only_gc;
    t__bool needs_bit_paths;
    struct s__l__sn__gen_constraint *constraints;
} *t__sn__gen_constraint_and;
#define d__sn__gen_constraint_and 2050
typedef t__sn__gen_constraint_and t__gen_constraint_and;
#define d__gen_constraint_and d__sn__gen_constraint_and

/* line 54 "/vobs/specman/src/gen_constraint_path.e"  From 'struct definition' */
typedef struct s__sn__a_role {
    t__int d__;
    t__int gen__;
    t__sn__index role_id;
    struct s__sn__sn_role_path *key;
    t__sn__index pos_in_gen_path;
    t__sn__index index_in_sd;
    t__bool is_list;
    t__imp_enum_sn__a_role__debug_it debug_it;
    struct s__l__bool *debug_fields;
    t__bool for_debug_only;
    t__string role_name;
    t__int role_hashed;
    struct s__sn__a_role *more_general_role;
    struct s__l__sn__a_role *more_specific_roles;
    struct s__l__sn__om_edge *when_om_edges;
    struct s__l__sn__om_edge *om_edges;
    struct s__l__sn__index *is_dof;
    struct s__l__sn__om_edge_reason *dof_reasons;
    t__bool cannot_be_statically_ordered;
    t__sn__index executed_size;
    t__sn__index field_gen_role_size;
    struct s__k__sn__field_gen_role__id *field_gen_roles;
    struct s__l__sn__status_in_role *f_stats;
    t__bool might_change_gc_stats;
    struct s__l__sn__index *start_parent_gcs;
    struct s__k__sn__role_gc_stat__gc *gc_stats;
    struct s__k__sn__gc_last_reduction__gc *gc_lrs;
    t__bool is_gotf_root;
    struct s__sn__role_subtype_info *subtype_info;
    t__sn__count n_non_temp_fields;
    t__sn__count n_fields;
    struct s__l__sn__index *has_down_gcs;
    struct s__l__sn__a_role *sub_type_roles;
    struct s__sn__a_role *super_type_role;
    t__bool is_like_hook;
    t__uint last_f_stats;
    t__sn__sn_role_creation_t created_by;
    t__bool graph_visited;
    t__uint key_number;
    struct s__sn__a_role *next_hashed_role;
    t__imp_enum_sn__a_role__gc_proc_status gc_proc_status;
    t__bool was_inited;
    t__bool sb_allow_iteration;
    t__uint no_executions;
    t__bool is_executed;
    struct s__l__sn__final_fgr_info_none *final_fgr_infos;
    struct s__l__sn__gen_command *gcoms;
    struct s__k__sn__field__it *fast_fields;
    struct s__l__sn__field *fixed_fast_fields;
    struct s__l__int *fixed_fast_fields_values;
    struct s__sn__struct_descriptor *fast_subtype;
    struct s__k__sn__init_graph_gen_c48777 *graphs;
    struct s__l__sn__subtype_descriptor *static_contributors;
    t__int no_of_init_graphs;
    struct s__sn__struct_descriptor *last_never;
    struct s__sn__struct_descriptor *last_always;
    t__uint counter;
} *t__sn__a_role;
#define d__sn__a_role 2003
typedef t__sn__a_role t__a_role;
#define d__a_role d__sn__a_role

/* line 145 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__sn_role_path {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *start_type;
    struct s__sn__composite_descriptor *as_a_type;
    struct s__sn__composite_descriptor *end_type;
    struct s__l__sn__field_holder *fields;
    t__sn__index last_field;
    t__sn__index gen_on_the_fly_index;
} *t__sn__sn_role_path;
#define d__sn__sn_role_path 5624
typedef t__sn__sn_role_path t__sn_role_path;
#define d__sn_role_path d__sn__sn_role_path

/* line 466 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__om_edge {
    t__int d__;
    t__int gen__;
    t__sn__om_edge_reason om_edge_reason;
    struct s__e_core__source_item *source_item;
    t__bool soft;
    struct s__sn__om_or_edge *in_or;
    struct s__sn__a_role *originating_role;
    struct s__sn__a_role *the_role;
    struct s__l__sn__a_role *turned_off_roles;
} *t__sn__om_edge;
#define d__sn__om_edge 5631
typedef t__sn__om_edge t__om_edge;
#define d__om_edge d__sn__om_edge

/* line 195 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__source_item {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
} *t__e_core__source_item;
#define d__e_core__source_item 30
typedef t__e_core__source_item t__source_item;
#define d__source_item d__e_core__source_item

/* line 464 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__om_or_edge {
    t__int d__;
    t__int gen__;
    struct s__l__sn__om_alt_edge *alt_edges;
    struct s__sn__gen_constraint_or *orig_gc;
} *t__sn__om_or_edge;
#define d__sn__om_or_edge 5630
typedef t__sn__om_or_edge t__om_or_edge;
#define d__om_or_edge d__sn__om_or_edge

/* line 1977 "/vobs/specman/src/gen_static_reorder.e"  From 'struct definition' */
typedef struct s__sn__om_alt_edge {
    t__int d__;
    t__int gen__;
    struct s__l__sn__om_edge *es;
} *t__sn__om_alt_edge;
#define d__sn__om_alt_edge 5803
typedef t__sn__om_alt_edge t__om_alt_edge;
#define d__om_alt_edge d__sn__om_alt_edge

/* line 499 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
} *t__sn__field_gen_role;
#define d__sn__field_gen_role 5635
typedef t__sn__field_gen_role t__field_gen_role;
#define d__field_gen_role d__sn__field_gen_role

/* line 145 "/vobs/specman/src/script_rnd.e"  From 'struct definition' */
typedef struct s__sn__seed_domain {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int current_seed;
    t__int state_s1;
    t__int state_s2;
    t__sn__count count;
    struct s__sn__mxi_selector *mxi_selector;
} *t__sn__seed_domain;
#define d__sn__seed_domain 1245
typedef t__sn__seed_domain t__seed_domain;
#define d__seed_domain d__sn__seed_domain

/* line 172 "/vobs/specman/src/script_rnd.e"  From 'struct definition' */
typedef struct s__sn__mxi_selector {
    t__int d__;
    t__int gen__;
} *t__sn__mxi_selector;
#define d__sn__mxi_selector 1247
typedef t__sn__mxi_selector t__mxi_selector;
#define d__mxi_selector d__sn__mxi_selector

/* line 108 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__role_gc_stat {
    t__int d__;
    t__int gen__;
    t__sn__gc_status gs;
    struct s__sn__gen_constraint *gc;
    struct s__l__sn__om_edge *derived_edges;
} *t__sn__role_gc_stat;
#define d__sn__role_gc_stat 5620
typedef t__sn__role_gc_stat t__role_gc_stat;
#define d__role_gc_stat d__sn__role_gc_stat

/* line 121 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__gc_last_reduction {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint *gc;
    t__sn__count lr;
} *t__sn__gc_last_reduction;
#define d__sn__gc_last_reduction 5623
typedef t__sn__gc_last_reduction t__gc_last_reduction;
#define d__gc_last_reduction d__sn__gc_last_reduction

/* line 1060 "/vobs/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__sn__role_subtype_info {
    t__int d__;
    t__int gen__;
    struct s__sn__subtype_descriptor *declared_subtype;
    struct s__sn__a_role *r;
    struct s__sn__subtype_descriptor *gen_subtype;
    struct s__l__sn__when_det_info *when_dets;
    struct s__k__sn__subtype_descript48789 *cant_be_subtypes;
    struct s__l__sn__context_item *lc;
    t__uint last_info_changed;
} *t__sn__role_subtype_info;
#define d__sn__role_subtype_info 5739
typedef t__sn__role_subtype_info t__role_subtype_info;
#define d__role_subtype_info d__sn__role_subtype_info

/* line 2493 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__when_det_info {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    struct s__sn_rl__scalar_rl *rl;
    t__bool singleton_in_subtype;
} *t__sn__when_det_info;
#define d__sn__when_det_info 5856
typedef t__sn__when_det_info t__when_det_info;
#define d__when_det_info d__sn__when_det_info

/* line 6 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__final_fgr_info_none {
    t__int d__;
    t__int gen__;
    t__sn__fg_stat fg_stat;
    struct s__sn__field *f;
    struct s__sn__field_gen_role *last_fgr;
} *t__sn__final_fgr_info_none;
#define d__sn__final_fgr_info_none 5840
typedef t__sn__final_fgr_info_none t__final_fgr_info_none;
#define d__final_fgr_info_none d__sn__final_fgr_info_none

/* line 43 "/vobs/specman/src/gen_commands_def.e"  From 'struct definition' */
typedef struct s__sn__gen_command {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *the_role;
} *t__sn__gen_command;
#define d__sn__gen_command 5827
typedef t__sn__gen_command t__gen_command;
#define d__gen_command d__sn__gen_command

/* line 1671 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__init_graph_gen_command {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *the_role;
    struct s__sn__composite_descriptor *sd;
    struct s__sn__init_nodes_gen_command *init_nodes;
    struct s__sn__init_cis_gen_command *init_cis;
    struct s__sn__top_gen_command *eval;
    struct s__sn__init_edges_gen_command *init_edges;
} *t__sn__init_graph_gen_command;
#define d__sn__init_graph_gen_command 5854
typedef t__sn__init_graph_gen_command t__init_graph_gen_command;
#define d__init_graph_gen_command d__sn__init_graph_gen_command

/* line 1563 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__init_nodes_gen_command {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *the_role;
    struct s__l__sn__index *fields_to_instantiate;
    struct s__k__sn__final_fgr_info_n48794 *ffis;
} *t__sn__init_nodes_gen_command;
#define d__sn__init_nodes_gen_command 5852
typedef t__sn__init_nodes_gen_command t__init_nodes_gen_command;
#define d__init_nodes_gen_command d__sn__init_nodes_gen_command

/* line 1537 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__init_cis_gen_command {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *the_role;
    struct s__l__sn__gc_holder *gc_holders;
    t__sn__count n_cis;
} *t__sn__init_cis_gen_command;
#define d__sn__init_cis_gen_command 5851
typedef t__sn__init_cis_gen_command t__init_cis_gen_command;
#define d__init_cis_gen_command d__sn__init_cis_gen_command

/* line 1277 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__gc_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint *gc;
} *t__sn__gc_holder;
#define d__sn__gc_holder 5846
typedef t__sn__gc_holder t__gc_holder;
#define d__gc_holder d__sn__gc_holder

/* line 69 "/vobs/specman/src/gen_commands_def.e"  From 'struct definition' */
typedef struct s__sn__top_gen_command {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *the_role;
    t__int ntimes;
} *t__sn__top_gen_command;
#define d__sn__top_gen_command 5829
typedef t__sn__top_gen_command t__top_gen_command;
#define d__top_gen_command d__sn__top_gen_command

/* line 1624 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__init_edges_gen_command {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *the_role;
    struct s__l__sn__index *fields_to_order;
    struct s__k__sn__index__it *dofs;
    struct s__l__sn__om_edge *edges;
} *t__sn__init_edges_gen_command;
#define d__sn__init_edges_gen_command 5853
typedef t__sn__init_edges_gen_command t__init_edges_gen_command;
#define d__init_edges_gen_command d__sn__init_edges_gen_command

/* line 168 "/vobs/specman/src/port_method_interface_helper.e"  From 'struct definition' */
typedef struct s__sn__interface_functor_helper {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *st;
    struct s__l__reflection__rf_like_s7790 *e2e_servers;
    struct s__l__reflection__rf_field *e2e_fields;
    t__bool post_load_code_added;
    t__bool subtypes_created;
} *t__sn__interface_functor_helper;
#define d__sn__interface_functor_helper 6825
typedef t__sn__interface_functor_helper t__interface_functor_helper;
#define d__interface_functor_helper d__sn__interface_functor_helper

/* line 576 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_like_struct {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd_;
} *t__reflection__rf_like_struct;
#define d__reflection__rf_like_struct 1722
typedef t__reflection__rf_like_struct t__rf_like_struct;
#define d__rf_like_struct d__reflection__rf_like_struct

/* line 1172 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_field {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f_;
    struct s__reflection__rf_definitio7719 *reflection_imp___field_declaration;
    void *_generative___ptr_padding[2];
    t__bool generative;
} *t__reflection__rf_field;
#define d__reflection__rf_field 1735
typedef t__reflection__rf_field t__rf_field;
#define d__rf_field d__reflection__rf_field

/* line 1520 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_definitio7719 {
    t__int d__;
    t__int gen__;
} *t__reflection__rf_definition_element;
#define d__reflection__rf_definition_element 1741
typedef t__reflection__rf_definition_element t__rf_definition_element;
#define d__rf_definition_element d__reflection__rf_definition_element

/* line 100 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__nt_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    struct s__sn__matchable_re *re;
    struct s__l__sn__macro_descriptor *macro_descriptors;
    struct s__sn__macro_finder *macro_finder;
    t__int max_macro_size;
    t__int index_in_parent_nt;
    t__bool multipliable;
    void *_sgi___ptr_padding[2];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__nt_descriptor;
#define d__sn__nt_descriptor 264
typedef t__sn__nt_descriptor t__nt_descriptor;
#define d__nt_descriptor d__sn__nt_descriptor

/* line 55 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__matchable_re {
    t__int d__;
    t__int gen__;
    t__string re;
    t__pat pat;
} *t__sn__matchable_re;
#define d__sn__matchable_re 261
typedef t__sn__matchable_re t__matchable_re;
#define d__matchable_re d__sn__matchable_re

/* line 94 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__macro_finder {
    t__int d__;
    t__int gen__;
    struct s__l__bool *find_table;
} *t__sn__macro_finder;
#define d__sn__macro_finder 262
typedef t__sn__macro_finder t__macro_finder;
#define d__macro_finder d__sn__macro_finder

/* line 213 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__sub_nt {
    t__int d__;
    t__int gen__;
    t__string field_name;
    struct s__sn__field *nt_field;
    struct s__sn__nt_descriptor *nt_type;
    t__int submatch_num;
    t__bool is_label;
    t__bool inner_form;
    t__string delim;
    struct s__sn__matchable_re *re;
} *t__sn__sub_nt;
#define d__sn__sub_nt 266
typedef t__sn__sub_nt t__sub_nt;
#define d__sub_nt d__sn__sub_nt

/* line 1139 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__routine {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__bool is_a_method;
    struct s__sn__scope *scope;
    struct s__sn__type_descriptor *result_type;
    t__routine_pointer routine_pointer;
    t__string cname;
    t__string when_subtype_name;
} *t__sn__routine;
#define d__sn__routine 191
typedef t__sn__routine t__routine;
#define d__routine d__sn__routine

/* line 1531 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__soft_gc {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *a_role;
    struct s__sn__simple_gen_constraint *gc;
} *t__sn__soft_gc;
#define d__sn__soft_gc 237
typedef t__sn__soft_gc t__soft_gc;
#define d__soft_gc d__sn__soft_gc

/* line 448 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__hdl_element {
    t__int d__;
    t__int gen__;
    struct s__sn__curr_calc *calc;
    struct s__sn__translated_model_struct *tms;
} *t__sn__hdl_element;
#define d__sn__hdl_element 2212
typedef t__sn__hdl_element t__hdl_element;
#define d__hdl_element d__sn__hdl_element

/* line 161 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__curr_calc {
    t__int d__;
    t__int gen__;
    t__uint smax;
    t__uint smin;
    t__uint num_shift;
    t__uint mask_val;
    t__uint mode_high;
    t__uint index_val;
    t__uint num_val_use;
    t__bool is_slice;
    t__bool is_two;
    t__uint slice_size;
    t__uint rel_high;
} *t__sn__curr_calc;
#define d__sn__curr_calc 2194
typedef t__sn__curr_calc t__curr_calc;
#define d__curr_calc d__sn__curr_calc

/* line 143 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__name_param {
    t__int d__;
    t__int gen__;
    t__bool is_x;
    t__bool is_z;
    t__bool is_a;
    t__bool is_bin;
    t__bool to_force;
    t__bool to_release;
    t__bool is_strudel_n;
    t__bool is_slice;
    t__uint smax;
    t__uint smin;
    t__string full_name;
    t__string name;
} *t__sn__name_param;
#define d__sn__name_param 2193
typedef t__sn__name_param t__name_param;
#define d__name_param d__sn__name_param

/* line 82 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__computed_name {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__hdl_struct *the_hdl;
} *t__sn__computed_name;
#define d__sn__computed_name 2187
typedef t__sn__computed_name t__computed_name;
#define d__computed_name d__sn__computed_name

/* line 465 "/vobs/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__sn__driver_handle {
    t__int d__;
    t__int gen__;
    t__uint inst_id;
    t__external_pointer ptr;
    struct s__sn__translated_model_struct *tms;
} *t__sn__driver_handle;
#define d__sn__driver_handle 1270
typedef t__sn__driver_handle t__driver_handle;
#define d__driver_handle d__sn__driver_handle

/* line 671 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__vhdl_driver_inst {
    t__int d__;
    t__int gen__;
    struct s__sn__vhdl_driver_descriptor *driver_desc;
    t__string name;
    t__string normal_name;
} *t__sn__vhdl_driver_inst;
#define d__sn__vhdl_driver_inst 2227
typedef t__sn__vhdl_driver_inst t__vhdl_driver_inst;
#define d__vhdl_driver_inst d__sn__vhdl_driver_inst

/* line 105 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__sn_vec {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__sn__sn_vec;
#define d__sn__sn_vec 470
typedef t__sn__sn_vec t__sn_vec;
#define d__sn_vec d__sn__sn_vec

/* line 23 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_simple_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_simple_port_attri4173 *simple_port___attributes;
    struct s__sn__sn_simple_channel *channel;
    t__uint active_event_count;
} *t__e_core__any_simple_port;
#define d__e_core__any_simple_port 1152
typedef t__e_core__any_simple_port t__any_simple_port;
#define d__any_simple_port d__e_core__any_simple_port

/* line 252 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_bind_channel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_port *ports;
    t__bool was_implictly_bound_to_external;
    struct s__reflection__rf_value_holder *default_val_holder;
    t__bool default_value_clean;
    t__bool take_mvl_as_default;
} *t__sn__sn_bind_channel;
#define d__sn__sn_bind_channel 1204
typedef t__sn__sn_bind_channel t__sn_bind_channel;
#define d__sn_bind_channel d__sn__sn_bind_channel

/* line 2365 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_value_holder {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_type *reflection_imp___t;
} *t__reflection__rf_value_holder;
#define d__reflection__rf_value_holder 1754
typedef t__reflection__rf_value_holder t__rf_value_holder;
#define d__rf_value_holder d__reflection__rf_value_holder

/* line 106 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_type {
    t__int d__;
    t__int gen__;
} *t__reflection__rf_type;
#define d__reflection__rf_type 1720
typedef t__reflection__rf_type t__rf_type;
#define d__rf_type d__reflection__rf_type

/* line 249 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_port_bind_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool external;
    t__bool undefined;
    t__bool empty;
} *t__sn__sn_port_bind_info;
#define d__sn__sn_port_bind_info 1203
typedef t__sn__sn_port_bind_info t__sn_port_bind_info;
#define d__sn_port_bind_info d__sn__sn_port_bind_info

/* line 40 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__any_port_cb_list_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_port *registrating_port;
    struct s__k__sn__port_cb_reason_a61204 *registrations_list;
    struct s__sn__any_port_cb *cb;
    t__uint reasons_mask;
} *t__sn__any_port_cb_list_item;
#define d__sn__any_port_cb_list_item 1171
typedef t__sn__any_port_cb_list_item t__any_port_cb_list_item;
#define d__any_port_cb_list_item d__sn__any_port_cb_list_item

/* line 561 "/vobs/specman/src/port_callbacks.e"  From 'struct definition' */
typedef struct s__sn__port_cb_reason_and_id {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__uint id;
    t__sn__cb_reason reason;
} *t__sn__port_cb_reason_and_id;
#define d__sn__port_cb_reason_and_id 6879
typedef t__sn__port_cb_reason_and_id t__port_cb_reason_and_id;
#define d__port_cb_reason_and_id d__sn__port_cb_reason_and_id

/* line 64 "/vobs/specman/src/port_callbacks.e"  From 'struct definition' */
typedef struct s__sn__any_port_cb {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__any_port_cb;
#define d__sn__any_port_cb 6872
typedef t__sn__any_port_cb t__any_port_cb;
#define d__any_port_cb d__sn__any_port_cb

/* line 43 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_port_error_info {
    t__int d__;
    t__int gen__;
    t__string message;
} *t__sn__sn_port_error_info;
#define d__sn__sn_port_error_info 1172
typedef t__sn__sn_port_error_info t__sn_port_error_info;
#define d__sn_port_error_info d__sn__sn_port_error_info

/* line 2 "/vobs/specman/src/port_simple.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_channel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_port *ports;
    struct s__l__e_core__any_port *external_out_ports;
    struct s__l__e_core__any_port *external_in_ports;
    struct s__l__source_ref *put_source_refs;
    t__source_ref curr_source_ref;
    t__sn__sn_channel_type_t channel_type;
    t__uint cb_counter;
} *t__sn__sn_simple_channel;
#define d__sn__sn_simple_channel 6750
typedef t__sn__sn_simple_channel t__sn_simple_channel;
#define d__sn_simple_channel d__sn__sn_simple_channel

/* line 247 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_event_done_wrapper {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sn_event_done_wrapper;
#define d__sn__sn_event_done_wrapper 1202
typedef t__sn__sn_event_done_wrapper t__sn_event_done_wrapper;
#define d__sn_event_done_wrapper d__sn__sn_event_done_wrapper

/* line 29 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_buffer_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_buffer_port_attri4174 *buffer_port___attributes;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___dummy_occ_l;
    struct s__sn__sn_event_struct *sn___dummy_event_struct;
    struct s__sn__waiting_thread *sn___dummy_thread;
    struct s__sn__sn_buffer_channel *channel;
    t__uint sn_vttp_packed_size;
} *t__e_core__any_buffer_port;
#define d__e_core__any_buffer_port 1154
typedef t__e_core__any_buffer_port t__any_buffer_port;
#define d__any_buffer_port d__e_core__any_buffer_port

/* line 100 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_buffer_port_attri4174 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__uint buffer_size;
    t__bool external_buffer;
} *t__sn__sn_buffer_port_attributes;
#define d__sn__sn_buffer_port_attributes 1176
typedef t__sn__sn_buffer_port_attributes t__sn_buffer_port_attributes;
#define d__sn_buffer_port_attributes d__sn__sn_buffer_port_attributes

/* line 152 "/vobs/specman/src/script.e"  From 'struct definition' */
typedef struct s__sn__sn_event_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct *inst;
    struct s__sn__event_type *event;
    struct s__l__sn__wait_entry *waiting;
    struct s__l__sn__wait_entry *swap_waiting;
    t__bool evaluated;
    t__int last_cleaned_we_size;
} *t__sn__sn_event_struct;
#define d__sn__sn_event_struct 1501
typedef t__sn__sn_event_struct t__sn_event_struct;
#define d__sn_event_struct d__sn__sn_event_struct

/* line 77 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__any_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__e_core__any_struct;
#define d__e_core__any_struct 17
typedef t__e_core__any_struct t__any_struct;
#define d__any_struct d__e_core__any_struct

/* line 337 "/vobs/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn__wait_entry {
    t__int d__;
    t__int gen__;
    t__int sig_entry;
    t__long_int start_eval_tick;
    t__long_int stop_eval_tick;
    struct s__sn__waiting_thread *thread;
    t__int thread_generation;
    t__int num_events_left;
} *t__sn__wait_entry;
#define d__sn__wait_entry 2800
typedef t__sn__wait_entry t__wait_entry;
#define d__wait_entry d__sn__wait_entry

/* line 292 "/vobs/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn__waiting_thread {
    t__int d__;
    t__int gen__;
    t__sn__waiting_thread_kind kind;
    t__bool queued;
    t__int cur_generation;
    t__int prev_generation;
    t__long_int start_eval_tick;
    t__long_int quit_tick;
    t__int temporal_exp_id;
    t__int ind;
    t__int last_eval_gen;
    t__int last_eval_te_gen;
    t__int tier;
    struct s__sn__activation_record *context;
    struct s__e_core__any_struct *inst;
    struct s__sn__te_memory *the_te_mem;
    t__int event_id;
    t__bool visited;
    t__int eval_sig_entry;
    t__int eval_inst;
    t__int next_sig_entry;
    t__int next_inst;
    t__int we_recycle_generation_in_wt;
    t__e_core__thread_handle thread_handle;
} *t__sn__waiting_thread;
#define d__sn__waiting_thread 2771
typedef t__sn__waiting_thread t__waiting_thread;
#define d__waiting_thread d__sn__waiting_thread

/* line 1298 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__activation_record {
    t__int d__;
    t__int gen__;
    struct s__sn__method *sn_method;
    struct s__l__untyped *sn_values;
    struct s__sn__activation_record *sn_caller;
    struct s__sn__routine *sn_routine;
    t__int sn_call_num;
    t__int sn_sub_call_num;
    t__source_ref sn_lock_source_ref;
    struct s__e_core__reparse_source_ref *sn_lock_reparse_source_ref;
    t__bool sn_already_stopped;
    struct s__l__int *sn_list_of_traced_req_ids;
    t__int sn_next_stop_sub_call;
    t__int sn_next_stop_sub_return;
    struct s__sn__n__action *sn_current_action;
} *t__sn__activation_record;
#define d__sn__activation_record 218
typedef t__sn__activation_record t__activation_record;
#define d__activation_record d__sn__activation_record

/* line 266 "/vobs/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn__te_memory {
    t__int d__;
    t__int gen__;
    struct s__l__bool__32 *table_curr_states;
    struct s__l__bool__32 *table_next_states;
    t__long_int last_evaluation;
    t__long_int previous_evaluation;
    struct s__l__sn_fl__counter_list *table_curr_cnts;
    struct s__l__sn_fl__counter_list *table_next_cnts;
    t__long_int trigger_tick;
    struct s__sn__waiting_thread *the_waiting_thread;
} *t__sn__te_memory;
#define d__sn__te_memory 2770
typedef t__sn__te_memory t__te_memory;
#define d__te_memory d__sn__te_memory

/* line 40 "/vobs/specman/src/fl_cnt.e"  From 'struct definition' */
typedef struct s__sn_fl__counter_list {
    t__int d__;
    t__int gen__;
} *t__sn_fl__counter_list;
#define d__sn_fl__counter_list 2758
typedef t__sn_fl__counter_list t__counter_list;
#define d__counter_list d__sn_fl__counter_list

/* line 435 "/vobs/specman/src/port_buffer.e"  From 'struct definition' */
typedef struct s__sn__sn_buffer_channel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_port *ports;
    struct s__l__e_core__any_port *external_out_ports;
    struct s__l__e_core__any_port *external_in_ports;
    struct s__l__source_ref *put_source_refs;
    t__source_ref curr_source_ref;
    t__sn__sn_channel_type_t channel_type;
    t__uint cb_counter;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__bool wait_for_ok_to_put_active;
    t__bool wait_for_ok_to_get_active;
    t__bool pass_by_value;
} *t__sn__sn_buffer_channel;
#define d__sn__sn_buffer_channel 6792
typedef t__sn__sn_buffer_channel t__sn_buffer_channel;
#define d__sn_buffer_channel d__sn__sn_buffer_channel

/* line 240 "/vobs/specman/src/sim_time.e"  From 'struct definition' */
typedef struct s__sn__sn_adapter_time {
    t__int d__;
    t__int gen__;
    t__uint low;
    t__uint high;
    struct s__e_core__time *tmp_time;
    struct s__e_core__time *scale_time;
    t__bool has_time_knowledge;
    t__bool new_time;
    struct s__sn__sn_adapter_bridge *adapter;
    struct s__sn__sn_long_time *session_time;
} *t__sn__sn_adapter_time;
#define d__sn__sn_adapter_time 2276
typedef t__sn__sn_adapter_time t__sn_adapter_time;
#define d__sn_adapter_time d__sn__sn_adapter_time

/* line 14 "/vobs/specman/src/sim_time.e"  From 'struct definition' */
typedef struct s__sn__sn_long_time {
    t__int d__;
    t__int gen__;
    t__uint low;
    t__uint high;
    struct s__e_core__time *tmp_time;
    struct s__e_core__time *scale_time;
    t__bool has_time_knowledge;
    t__bool new_time;
} *t__sn__sn_long_time;
#define d__sn__sn_long_time 2275
typedef t__sn__sn_long_time t__sn_long_time;
#define d__sn_long_time d__sn__sn_long_time

/* line 5 "/vobs/specman/src/adapter_abstract.e"  From 'struct definition' */
typedef struct s__sn__sn_ABSTRACT_adapter {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_adapter_unit_manager *adapter_unit_manager;
    struct s__sn__sn_adapter_bridge *adapter_abstract___bridge;
    t__bool can_master_specman;
} *t__sn__sn_ABSTRACT_adapter;
#define d__sn__sn_ABSTRACT_adapter 6703
typedef t__sn__sn_ABSTRACT_adapter t__sn_ABSTRACT_adapter;
#define d__sn_ABSTRACT_adapter d__sn__sn_ABSTRACT_adapter

/* line 3 "/vobs/specman/src/adapter_abstract.e"  From 'struct definition' */
typedef struct s__sn__sn_adapter_unit_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__any_adapter_unit *my_adapter_units;
    t__string id_name;
} *t__sn__sn_adapter_unit_manager;
#define d__sn__sn_adapter_unit_manager 6702
typedef t__sn__sn_adapter_unit_manager t__sn_adapter_unit_manager;
#define d__sn_adapter_unit_manager d__sn__sn_adapter_unit_manager

/* line 38 "/vobs/specman/src/adapter_unit.e"  From 'struct definition' */
typedef struct s__sn__any_adapter_unit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    t__bool disabled;
} *t__sn__any_adapter_unit;
#define d__sn__any_adapter_unit 7081
typedef t__sn__any_adapter_unit t__any_adapter_unit;
#define d__any_adapter_unit d__sn__any_adapter_unit

/* line 228 "/vobs/specman/src/adapter_esi.e"  From 'struct definition' */
typedef struct s__sn__sn_get_simulation_t68950 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_adapter_time *adapter_time;
    t__bool res;
} *t__sn__sn_get_simulation_time_data;
#define d__sn__sn_get_simulation_time_data 6705
typedef t__sn__sn_get_simulation_time_data t__sn_get_simulation_time_data;
#define d__sn_get_simulation_time_data d__sn__sn_get_simulation_time_data

/* line 219 "/vobs/specman/src/adapter_esi.e"  From 'struct definition' */
typedef struct s__sn__sn_get_time_resolut68951 {
    t__int d__;
    t__int gen__;
    t__bool res;
    t__sn__e_time_units units;
    t__uint units_num;
} *t__sn__sn_get_time_resolution_data;
#define d__sn__sn_get_time_resolution_data 6704
typedef t__sn__sn_get_time_resolution_data t__sn_get_time_resolution_data;
#define d__sn_get_time_resolution_data d__sn__sn_get_time_resolution_data

/* line 10 "/vobs/specman/src/sim_time.e"  From 'struct definition' */
typedef struct s__sn__sn_basic_time {
    t__int d__;
    t__int gen__;
    t__uint low;
    t__uint high;
} *t__sn__sn_basic_time;
#define d__sn__sn_basic_time 2274
typedef t__sn__sn_basic_time t__sn_basic_time;
#define d__sn_basic_time d__sn__sn_basic_time

/* line 46 "/vobs/specman/src/adapter_ncvhdl.e"  From 'struct definition' */
typedef struct s__sn__driver_proc_struct {
    t__int d__;
    t__int gen__;
    t__int port_id;
    t__string proc_name;
} *t__sn__driver_proc_struct;
#define d__sn__driver_proc_struct 6983
typedef t__sn__driver_proc_struct t__driver_proc_struct;
#define d__driver_proc_struct d__sn__driver_proc_struct

/* line 51 "/vobs/specman/src/adapter_ncvhdl.e"  From 'struct definition' */
typedef struct s__sn__sim_net_struct {
    t__int d__;
    t__int gen__;
    t__uint sim_net_hand;
    t__int port_id;
} *t__sn__sim_net_struct;
#define d__sn__sim_net_struct 6984
typedef t__sn__sim_net_struct t__sim_net_struct;
#define d__sim_net_struct d__sn__sim_net_struct

/* line 359 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__specman_config {
    t__int d__;
    t__int gen__;
    t__string version;
    t__string specman_version;
    t__e_core__config_os os;
    t__e_core__config_machine machine;
    t__bool is_LP64;
    t__bool numeric_type_casting;
} *t__e_core__specman_config;
#define d__e_core__specman_config 40
typedef t__e_core__specman_config t__specman_config;
#define d__specman_config d__e_core__specman_config

/* line 379 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__symtab {
    t__int d__;
    t__int gen__;
    struct s__k__sn__module__name *modules;
    struct s__k__sn__pp_module__name *pp_modules;
    struct s__k__sn__package_descriptor476 *all_packages;
    struct s__l__sn__form *all_forms;
    struct s__k__sn__routine__name *all_routines;
    struct s__l__sn__gen_constraint *all_constraints;
    struct s__l__sn__field *all_fields;
    struct s__k__sn__token_descriptor__477 *all_tokens;
    t__int last_updated_field;
    struct s__l__sn__method *all_layers;
    struct s__k__string__it *all_pseudo_methods;
    struct s__sn__module *current_module;
    struct s__sn__method *current_method;
    struct s__sn__struct_descriptor *current_struct;
    t__int next_cgl_num;
    t__int unique_module_counter;
    t__int relax_excep_count;
    struct s__l__int *mask_bit_table;
    t__bool force_gc_after_load;
    struct s__l__sn__sn_vec *long_constants;
    struct s__e_core__namer *namer;
    t__int last_sn_module;
    struct s__e_core__hang_type *hang_type;
    t__bool dont_descend_refs;
    t__int method_index_top_limit;
    struct s__sn__package_descriptor *context_package;
    struct s__e_core__sn_stack_of_temp_478 *stack_of_temp_long;
    struct s__e_core__sn_stack_of_temp_479 *stack_of_temp_real;
    struct s__k__sn__type_descriptor__it *types_declarations;
    struct s__l__sn__ntv *act_common_macros;
    struct s__l__sn__ntv *exp_common_macros;
    t__bool unit_warning;
    t__int last_initialized_module;
    struct s__sn__exceptions *exceptions;
    t__bool errors_on;
    t__bool is_short_signed;
    t__bool icfg_load;
    struct s__e_core__directed_graph *import_graph;
    struct s__l__e_core__scc_item *sccs;
    t__bool is_LP64_data_model;
    t__bool alloc_profile;
    struct s__sn__sn_long *oneK;
    struct s__l__sn__method *call_in_translate_methods;
    struct s__l__bit *indexing_list;
    struct s__l__bit *indexing_list2;
    t__bool within_llwait;
    struct s__sn__sn_long_op *long_op;
    t__int bits_taken;
    t__bool use_bits_taken;
    t__int bit_offset;
    struct s__l__bit *bit_slice_lob;
    struct s__l__sn__interval_set *constant_sets;
    struct s__l__sn__sn_uint_list_holder *const_uints;
    struct s__l__sn__sn_string_list_holder *const_strs;
    struct s__l__sn__sn_struct_list_holder *const_structs;
    struct s__l__sn__sn_vec_list_holder *const_longs;
    struct s__l__sn__sn_double_list_holder *const_doubles;
    struct s__l__string *lhs_pseudo_method;
    struct s__sn__sn_deep_copy_info *deep_copy_info;
    struct s__l__int *tmp_int_buffer;
    struct s__l__uint *tmp_uint_buffer;
    struct s__l__sn__sn_vec *tmp_long_buffer;
    struct s__k__sn__option_list_descr4169 *options;
    struct s__l__string *structs_with_quit;
    t__int time_d_index;
    struct s__sn__sn_long *one_giga;
    struct s__sn_rl__uint_rl *universal_uint_rl;
    struct s__l__sn_rl__scalar_rl *new_constant_rls;
    struct s__l__string *abstr_gen_type_strings;
    struct s__l__int *rl_int_list;
    struct s__l__uint *rl_uint_list;
    struct s__l__sn__sn_vec *rl_long_list;
    struct s__l__e_core__real *rl_double_list;
    struct s__l__sn__sn_vec *tmp1_long_list;
    struct s__l__sn__sn_vec *tmp2_long_list;
    struct s__sn_rl__long_rl *emptyset;
    struct s__e_core__source_item *temp_source_item;
    struct s__l__sn__attr_handle *all_attributes;
    struct s__sn__pgen_parser *pgen_parser;
    struct s__k__sn__field_type_relat11894 *all_type_relations;
    struct s__l__sn__sn_vec *verilog_string_constants;
    t__sn__module_print_format_t module_print_format;
    struct s__l__sn__construct_keyword *all_keywords;
    t__int last_sim_event;
    struct s__l__sn__te_header_desc *all_temporals;
    t__bool seq_of_size_one;
    t__bool under_and_te;
    struct s__l__sn__macro_call_info *all_macro_calls;
    t__int sb_max_limit;
    struct s__k__sn__struct_threads__34125 *all_struct_threads;
    struct s__sn__reduction *reduction;
    struct s__l__sn__composite_descriptor *reachable_struct_types;
    struct s__l__sn__field *reachable_fields;
    struct s__l__sn__field *gotf_reachable_fields;
    struct s__sn__composite_descriptor *gen_root_struct;
    struct s__sn__a_role *gen_root_role;
    struct s__sn__composite_descriptor *gen_root_list;
    struct s__sn__a_role *gen_root_list_role;
    t__sn__index last_role_ind;
    struct s__sn__inherite_edges_iterator *iei;
    struct s__sn__finalize_iterator *fin;
    t__uint last_processed_gc;
    t__uint last_reachable_field;
    struct s__l__sn__field *deters;
    t__bool do_internal_check;
    t__bool disable_sequence_lint;
    struct s__sn_rl__bool_rl *bool_universal_rl;
} *t__e_core__symtab;
#define d__e_core__symtab 55
typedef t__e_core__symtab t__symtab;
#define d__symtab d__e_core__symtab

/* line 74 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__module {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__package_descriptor *my_package;
    struct s__sn__sn_erm_package_descri480 *my_erm_package;
    t__int lines_number;
    t__int first_line;
    t__string name;
    t__int module_num;
    t__string file_name;
    t__string full_file_name;
    t__string relative_path;
    t__int file_age;
    t__bool loaded;
    struct s__l__sn__type_layer *type_layers;
    t__uint checksum;
    t__uint initial_checksum;
    t__string specman_version;
    t__string parent;
    t__bool encrypted;
    t__bool isitornot;
    struct s__sn__rf_structural_element *rf_object_;
    t__bool non_checksummed;
    t__bool has_macro_expansion;
} *t__sn__module;
#define d__sn__module 151
typedef t__sn__module t__module;
#define d__module d__sn__module

/* line 71 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_erm_package_descri480 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string dir;
    t__string version;
    t__string title;
    t__string comments_to;
    t__string support;
    t__string problem;
    t__uint package_index;
    struct s__l__sn__erm_packages_req80362 *requirements;
    t__bool is_loaded;
    t__bool top_is_loaded;
    t__bool internal_erm_package;
    t__bool checked_validity;
    struct s__k__sn__module__it *modules;
    struct s__reflection__rf_erm_package *rf_object_;
    struct s__sn__sn_library_descriptor *erm_package_reflection___lib_descriptor;
    struct s__l__sn__sn_erm_req_error *req_errors;
} *t__sn__sn_erm_package_descriptor;
#define d__sn__sn_erm_package_descriptor 149
typedef t__sn__sn_erm_package_descriptor t__sn_erm_package_descriptor;
#define d__sn_erm_package_descriptor d__sn__sn_erm_package_descriptor

/* line 293 "/vobs/specman/src/erm_package.e"  From 'struct definition' */
typedef struct s__sn__erm_packages_req_ve80375 {
    t__int d__;
    t__int gen__;
    t__string element_name;
    t__string element_requirement;
    struct s__l__sn__erm_package_conv80376 *conv_requirements;
    t__bool checked;
} *t__sn__erm_packages_req_versions;
#define d__sn__erm_packages_req_versions 7679
typedef t__sn__erm_packages_req_versions t__erm_packages_req_versions;
#define d__erm_packages_req_versions d__sn__erm_packages_req_versions

/* line 262 "/vobs/specman/src/erm_package.e"  From 'struct definition' */
typedef struct s__sn__erm_package_convert75618 {
    t__int d__;
    t__int gen__;
    t__int specific_version;
    t__int from_version;
    t__int to_version;
    t__string problem;
} *t__sn__erm_package_converted_requirements;
#define d__sn__erm_package_converted_requirements 7678
typedef t__sn__erm_package_converted_requirements t__erm_package_converted_requirements;
#define d__erm_package_converted_requirements d__sn__erm_package_converted_requirements

/* line 43 "/vobs/specman/src/erm_package_reflection.e"  From 'struct definition' */
typedef struct s__reflection__rf_erm_package {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_erm_package_descri480 *erm_package_reflection___descriptor;
} *t__reflection__rf_erm_package;
#define d__reflection__rf_erm_package 7694
typedef t__reflection__rf_erm_package t__rf_erm_package;
#define d__rf_erm_package d__reflection__rf_erm_package

/* line 231 "/vobs/specman/src/evc_util_package.e"  From 'struct definition' */
typedef struct s__sn__sn_library_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string dir;
    t__string title;
    t__string problem;
    struct s__l__sn__sn_erm_package_d80383 *packages;
    struct s__reflection__rf_erm_library *rf_object_;
} *t__sn__sn_library_descriptor;
#define d__sn__sn_library_descriptor 7690
typedef t__sn__sn_library_descriptor t__sn_library_descriptor;
#define d__sn_library_descriptor d__sn__sn_library_descriptor

/* line 128 "/vobs/specman/src/erm_package_reflection.e"  From 'struct definition' */
typedef struct s__reflection__rf_erm_library {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_library_descriptor *erm_package_reflection___descriptor;
} *t__reflection__rf_erm_library;
#define d__reflection__rf_erm_library 7695
typedef t__reflection__rf_erm_library t__rf_erm_library;
#define d__rf_erm_library d__reflection__rf_erm_library

/* line 32 "/vobs/specman/src/erm_package_compatibility.e"  From 'struct definition' */
typedef struct s__sn__sn_erm_req_error {
    t__int d__;
    t__int gen__;
    t__sn__erm_package_compatibility_warning_type type;
    struct s__l__string *params;
    t__string readme_name;
    t__bool printed;
} *t__sn__sn_erm_req_error;
#define d__sn__sn_erm_req_error 7701
typedef t__sn__sn_erm_req_error t__sn_erm_req_error;
#define d__sn_erm_req_error d__sn__sn_erm_req_error

/* line 13 "../src/root_preprocessor.e"  From 'struct definition' */
typedef struct s__sn__pp_module {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__package_descriptor *my_package;
    struct s__l__sn__pp_module *imported_pp_modules;
} *t__sn__pp_module;
#define d__sn__pp_module 437
typedef t__sn__pp_module t__pp_module;
#define d__pp_module d__sn__pp_module

/* line 119 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__token_descriptor {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__matchable_re *re;
} *t__sn__token_descriptor;
#define d__sn__token_descriptor 265
typedef t__sn__token_descriptor t__token_descriptor;
#define d__token_descriptor d__sn__token_descriptor

/* line 859 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__namer {
    t__int d__;
    t__int gen__;
    struct s__k__e_core__both__long_str *names;
} *t__e_core__namer;
#define d__e_core__namer 76
typedef t__e_core__namer t__namer;
#define d__namer d__e_core__namer

/* line 854 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__both {
    t__int d__;
    t__int gen__;
    t__string long_str;
    t__string cgl_str;
} *t__e_core__both;
#define d__e_core__both 74
typedef t__e_core__both t__both;
#define d__both d__e_core__both

/* line 369 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__hang_type {
    t__int d__;
    t__int gen__;
    struct s__sn__int_interval_set *irl;
    struct s__sn__list_descriptor *ld;
} *t__e_core__hang_type;
#define d__e_core__hang_type 41
typedef t__e_core__hang_type t__hang_type;
#define d__hang_type d__e_core__hang_type

/* line 266 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__int_interval_set {
    t__int d__;
    t__int gen__;
    struct s__l__int *rl_list;
} *t__sn__int_interval_set;
#define d__sn__int_interval_set 477
typedef t__sn__int_interval_set t__int_interval_set;
#define d__int_interval_set d__sn__int_interval_set

/* line 524 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__list_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    struct s__sn__type_descriptor *base_type;
    t__sn__key_kind kind;
    struct s__sn__field *key_field;
    t__bool is_weak;
    void *_sgi___ptr_padding[10];
    int _sgi___int_padding[8];
    struct s__sn__sd_gen_info *sgi;
} *t__sn__list_descriptor;
#define d__sn__list_descriptor 178
typedef t__sn__list_descriptor t__list_descriptor;
#define d__list_descriptor d__sn__list_descriptor

/* line 603 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_stack_of_temp_478 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_vec *l;
    t__int sp;
} *t__e_core__sn_stack_of_temp_long;
#define d__e_core__sn_stack_of_temp_long 70
typedef t__e_core__sn_stack_of_temp_long t__sn_stack_of_temp_long;
#define d__sn_stack_of_temp_long d__e_core__sn_stack_of_temp_long

/* line 611 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_stack_of_temp_479 {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__real *l;
    t__int sp;
} *t__e_core__sn_stack_of_temp_real;
#define d__e_core__sn_stack_of_temp_real 72
typedef t__e_core__sn_stack_of_temp_real t__sn_stack_of_temp_real;
#define d__sn_stack_of_temp_real d__e_core__sn_stack_of_temp_real

/* line 272 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__sn__exceptions {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_exception__name *exceptions;
    t__string global_error_name;
    struct s__e_core__base_struct *global_error_inst;
    t__external_pointer global_sig_cookie;
    t__int exceptions_num;
    t__int max_errors;
    t__bool in_safe_command;
    struct s__l__sn__sn_exception_data *exceptions_stack;
    t__bool after_flush;
    t__string struct_member_name;
    struct s__sn__sn_exception_data *active_exception;
    t__string try_string;
    t__int try_status;
    struct s__k__string__it *err_details_list;
    t__sn__do_reload_t do_reload;
    t__sn__do_reload_t keep_do_reload;
    struct s__l__string *pre_commands;
} *t__sn__exceptions;
#define d__sn__exceptions 417
typedef t__sn__exceptions t__exceptions;
#define d__exceptions d__sn__exceptions

/* line 50 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__sn__sn_exception {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int index;
    t__sn__severity severity;
    t__string message;
    struct s__l__string *params_types;
} *t__sn__sn_exception;
#define d__sn__sn_exception 384
typedef t__sn__sn_exception t__sn_exception;
#define d__sn_exception d__sn__sn_exception

/* line 208 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__sn__sn_exception_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__reparse_source_item *si;
    t__string error_msg;
    struct s__sn__sn_exception *exception;
    struct s__l__untyped *values;
    struct s__sn__method *compiled_method;
    t__bool translation;
    t__string pre_command;
    t__string message_suffix;
} *t__sn__sn_exception_data;
#define d__sn__sn_exception_data 413
typedef t__sn__sn_exception_data t__sn_exception_data;
#define d__sn_exception_data d__sn__sn_exception_data

/* line 237 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__reparse_source_item {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
} *t__e_core__reparse_source_item;
#define d__e_core__reparse_source_item 32
typedef t__e_core__reparse_source_item t__reparse_source_item;
#define d__reparse_source_item d__e_core__reparse_source_item

/* line 171 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__directed_graph {
    t__int d__;
    t__int gen__;
    struct s__k__e_core__vertice__name *vertices;
    t__bool dfs_done;
    t__bool sccs_done;
    t__bool acyclic;
    struct s__l__e_core__vertice *torder;
    t__int scc_pos;
    t__int time;
    struct s__l__sn__cyclic_import_pair *succ_cyclic;
} *t__e_core__directed_graph;
#define d__e_core__directed_graph 29
typedef t__e_core__directed_graph t__directed_graph;
#define d__directed_graph d__e_core__directed_graph

/* line 148 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__vertice {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int scc_id;
    t__int finished;
    t__e_core__vertice_color color;
    struct s__l__e_core__vertice *pred;
    struct s__l__e_core__vertice *succ;
    struct s__l__int *succ_line;
    t__string relative_path;
} *t__e_core__vertice;
#define d__e_core__vertice 24
typedef t__e_core__vertice t__vertice;
#define d__vertice d__e_core__vertice

/* line 72 "/vobs/specman/src/cyclic_import.e"  From 'struct definition' */
typedef struct s__sn__cyclic_import_pair {
    t__int d__;
    t__int gen__;
    struct s__e_core__vertice *to;
    t__int id;
} *t__sn__cyclic_import_pair;
#define d__sn__cyclic_import_pair 1715
typedef t__sn__cyclic_import_pair t__cyclic_import_pair;
#define d__cyclic_import_pair d__sn__cyclic_import_pair

/* line 159 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__scc_item {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__vertice *files;
    struct s__l__e_core__scc_item *succ;
    t__e_core__vertice_color color;
} *t__e_core__scc_item;
#define d__e_core__scc_item 25
typedef t__e_core__scc_item t__scc_item;
#define d__scc_item d__e_core__scc_item

/* line 948 "/vobs/specman/src/action.e"  From 'struct definition' */
typedef struct s__sn__sn_long_op {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_vec *v1;
    struct s__sn__sn_vec *v2;
    struct s__sn__sn_vec *tmp_res;
    struct s__l__byte *x;
    struct s__l__byte *y;
    struct s__l__byte *q;
    struct s__l__byte *r;
    struct s__l__byte *d;
    struct s__l__byte *dq;
} *t__sn__sn_long_op;
#define d__sn__sn_long_op 667
typedef t__sn__sn_long_op t__sn_long_op;
#define d__sn_long_op d__sn__sn_long_op

/* line 1368 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_uint_list_holder {
    t__int d__;
    t__int gen__;
    struct s__l__uint *value;
} *t__sn__sn_uint_list_holder;
#define d__sn__sn_uint_list_holder 230
typedef t__sn__sn_uint_list_holder t__sn_uint_list_holder;
#define d__sn_uint_list_holder d__sn__sn_uint_list_holder

/* line 1373 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_string_list_holder {
    t__int d__;
    t__int gen__;
    struct s__l__string *value;
} *t__sn__sn_string_list_holder;
#define d__sn__sn_string_list_holder 231
typedef t__sn__sn_string_list_holder t__sn_string_list_holder;
#define d__sn_string_list_holder d__sn__sn_string_list_holder

/* line 1378 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_list_holder {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__base_struct *value;
} *t__sn__sn_struct_list_holder;
#define d__sn__sn_struct_list_holder 232
typedef t__sn__sn_struct_list_holder t__sn_struct_list_holder;
#define d__sn_struct_list_holder d__sn__sn_struct_list_holder

/* line 1383 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_vec_list_holder {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_vec *value;
} *t__sn__sn_vec_list_holder;
#define d__sn__sn_vec_list_holder 233
typedef t__sn__sn_vec_list_holder t__sn_vec_list_holder;
#define d__sn_vec_list_holder d__sn__sn_vec_list_holder

/* line 1388 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_double_list_holder {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__real *value;
} *t__sn__sn_double_list_holder;
#define d__sn__sn_double_list_holder 234
typedef t__sn__sn_double_list_holder t__sn_double_list_holder;
#define d__sn_double_list_holder d__sn__sn_double_list_holder

/* line 65 "/vobs/specman/src/deep_copy_mac.e"  From 'struct definition' */
typedef struct s__sn__sn_deep_copy_info {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_copied_item__src *copied_already;
    struct s__k__e_core__any_struct__it *seen_before;
    struct s__l__e_core__any_struct *lists_with_key;
    struct s__sn__sn_graph_fields_iterator *src_iterator;
    struct s__sn__sn_graph_fields_iterator *dst_iterator;
    t__bool all_normal_compare;
} *t__sn__sn_deep_copy_info;
#define d__sn__sn_deep_copy_info 1278
typedef t__sn__sn_deep_copy_info t__sn_deep_copy_info;
#define d__sn_deep_copy_info d__sn__sn_deep_copy_info

/* line 33 "/vobs/specman/src/deep_copy.e"  From 'struct definition' */
typedef struct s__sn__sn_copied_item {
    t__int d__;
    t__int gen__;
    t__untyped src;
    t__untyped dst;
} *t__sn__sn_copied_item;
#define d__sn__sn_copied_item 1303
typedef t__sn__sn_copied_item t__sn_copied_item;
#define d__sn_copied_item d__sn__sn_copied_item

/* line 185 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_graph_fields_iterator {
    t__int d__;
    t__int gen__;
    t__bool config_done;
    t__bool exclude_scalar_fields;
    t__bool only_physical;
    t__bool new_instance_pending;
    t__int index_limit_pending;
    struct s__l__e_core__any_struct *parents;
    struct s__l__sn__field *field_stack;
    struct s__l__int *field_nos;
    struct s__l__int *indexes;
    struct s__l__int *max_indexes;
    struct s__l__sn__sn_basic_fields_i4195 *stack;
    t__int top_index;
    struct s__sn__sn_list_items_iterator *li;
    struct s__sn__sn_struct_fields_ite4196 *sfi;
    struct s__sn__sn_ilist_item *liitem;
    struct s__sn__sn_plist_item *lpitem;
    struct s__sn__sn_packed_list_item *plitem;
    struct s__sn__sn_field_item *fitem;
    struct s__sn__sn_basic_item *curr_item;
} *t__sn__sn_graph_fields_iterator;
#define d__sn__sn_graph_fields_iterator 1297
typedef t__sn__sn_graph_fields_iterator t__sn_graph_fields_iterator;
#define d__sn_graph_fields_iterator d__sn__sn_graph_fields_iterator

/* line 120 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_basic_fields_iterator {
    t__int d__;
    t__int gen__;
} *t__sn__sn_basic_fields_iterator;
#define d__sn__sn_basic_fields_iterator 1294
typedef t__sn__sn_basic_fields_iterator t__sn_basic_fields_iterator;
#define d__sn_basic_fields_iterator d__sn__sn_basic_fields_iterator

/* line 163 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_list_items_iterator {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_graph_fields_iterator *gi;
} *t__sn__sn_list_items_iterator;
#define d__sn__sn_list_items_iterator 1296
typedef t__sn__sn_list_items_iterator t__sn_list_items_iterator;
#define d__sn_list_items_iterator d__sn__sn_list_items_iterator

/* line 126 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_fields_ite4196 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_graph_fields_iterator *gi;
} *t__sn__sn_struct_fields_iterator;
#define d__sn__sn_struct_fields_iterator 1295
typedef t__sn__sn_struct_fields_iterator t__sn_struct_fields_iterator;
#define d__sn_struct_fields_iterator d__sn__sn_struct_fields_iterator

/* line 74 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_ilist_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct *parent;
    struct s__sn__field *my_field;
    t__int index;
} *t__sn__sn_ilist_item;
#define d__sn__sn_ilist_item 1291
typedef t__sn__sn_ilist_item t__sn_ilist_item;
#define d__sn_ilist_item d__sn__sn_ilist_item

/* line 92 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_plist_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct *parent;
    struct s__sn__field *my_field;
    t__int index;
} *t__sn__sn_plist_item;
#define d__sn__sn_plist_item 1292
typedef t__sn__sn_plist_item t__sn_plist_item;
#define d__sn_plist_item d__sn__sn_plist_item

/* line 110 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_packed_list_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct *parent;
    struct s__sn__field *my_field;
    t__int index;
} *t__sn__sn_packed_list_item;
#define d__sn__sn_packed_list_item 1293
typedef t__sn__sn_packed_list_item t__sn_packed_list_item;
#define d__sn_packed_list_item d__sn__sn_packed_list_item

/* line 49 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_field_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct *parent;
    struct s__sn__field *my_field;
    t__int index;
} *t__sn__sn_field_item;
#define d__sn__sn_field_item 1289
typedef t__sn__sn_field_item t__sn_field_item;
#define d__sn_field_item d__sn__sn_field_item

/* line 11 "/vobs/specman/src/iterator.e"  From 'struct definition' */
typedef struct s__sn__sn_basic_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct *parent;
    struct s__sn__field *my_field;
    t__int index;
} *t__sn__sn_basic_item;
#define d__sn__sn_basic_item 1288
typedef t__sn__sn_basic_item t__sn_basic_item;
#define d__sn_basic_item d__sn__sn_basic_item

/* line 40 "/vobs/specman/src/options.e"  From 'struct definition' */
typedef struct s__sn__option_list_descriptor {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__sn__option_descriptor *option_descs;
} *t__sn__option_list_descriptor;
#define d__sn__option_list_descriptor 1483
typedef t__sn__option_list_descriptor t__option_list_descriptor;
#define d__option_list_descriptor d__sn__option_list_descriptor

/* line 8 "/vobs/specman/src/options.e"  From 'struct definition' */
typedef struct s__sn__option_descriptor {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string pattern;
    t__bool required;
    t__bool repeatable;
    t__imp_enum_sn__option_descriptor__have_value have_value;
    t__bool exclusive;
} *t__sn__option_descriptor;
#define d__sn__option_descriptor 1482
typedef t__sn__option_descriptor t__option_descriptor;
#define d__option_descriptor d__sn__option_descriptor

/* line 23 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__uint_rl {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
} *t__sn_rl__uint_rl;
#define d__sn_rl__uint_rl 1632
typedef t__sn_rl__uint_rl t__uint_rl;
#define d__uint_rl d__sn_rl__uint_rl

/* line 24 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__long_rl {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_vec *rl_list;
} *t__sn_rl__long_rl;
#define d__sn_rl__long_rl 1633
typedef t__sn_rl__long_rl t__long_rl;
#define d__long_rl d__sn_rl__long_rl

/* line 23 "/vobs/specman/src/unit_attributes.e"  From 'struct definition' */
typedef struct s__sn__attr_handle {
    t__int d__;
    t__int gen__;
    struct s__sn__method *attr_method;
    struct s__l__sn__field *fields;
} *t__sn__attr_handle;
#define d__sn__attr_handle 2078
typedef t__sn__attr_handle t__attr_handle;
#define d__attr_handle d__sn__attr_handle

/* line 1059 "/vobs/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__sn__pgen_parser {
    t__int d__;
    t__int gen__;
    struct s__l__sn__local_frame *local_frame_list;
    t__bool debug;
    struct s__sn__struct_descriptor *current_struct_context;
    struct s__sn__struct_descriptor *struct_parent;
    struct s__sn__activation_record *pgen_ar;
    struct s__sn__scope *the_scope;
    t__int n_temps;
    t__int gen_fly_current_index;
    t__bool gen_on_the_fly;
    struct s__l__sn__constraint_path *gen_paths;
    t__int for_each_nested;
    struct s__l__sn__me_constraint_path *for_each_list_paths;
    struct s__l__sn__simple_gen_constraint *list_constraint_gcs;
    t__bool complex_is_bidir;
    t__bool apply_demorgan;
    t__untyped x;
    t__int max_ar_index;
    t__int inside_foreach_cnt;
    t__bool is_read_only;
    struct s__k__sn__constraint_path__it *pgen_pre_paths;
} *t__sn__pgen_parser;
#define d__sn__pgen_parser 2090
typedef t__sn__pgen_parser t__pgen_parser;
#define d__pgen_parser d__sn__pgen_parser

/* line 975 "/vobs/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__sn__local_frame {
    t__int d__;
    t__int gen__;
    struct s__l__sn__local_item *local_list;
} *t__sn__local_frame;
#define d__sn__local_frame 2089
typedef t__sn__local_frame t__local_frame;
#define d__local_frame d__sn__local_frame

/* line 969 "/vobs/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__sn__local_item {
    t__int d__;
    t__int gen__;
    struct s__sn__local *local_ptr;
    struct s__sn__fields_constraint_path *cp;
    t__sn__constraint_role_type role;
} *t__sn__local_item;
#define d__sn__local_item 2088
typedef t__sn__local_item t__local_item;
#define d__local_item d__sn__local_item

/* line 251 "/vobs/specman/src/gen_constraint_path.e"  From 'struct definition' */
typedef struct s__sn__fields_constraint_path {
    t__int d__;
    t__int gen__;
    t__string base_str;
    struct s__l__sn__field_holder *fields;
    struct s__sn__field_holder *field;
    t__sn__index role_id;
} *t__sn__fields_constraint_path;
#define d__sn__fields_constraint_path 2007
typedef t__sn__fields_constraint_path t__fields_constraint_path;
#define d__fields_constraint_path d__sn__fields_constraint_path

/* line 62 "/vobs/specman/src/type_narrow.e"  From 'struct definition' */
typedef struct s__sn__field_type_relation {
    t__int d__;
    t__int gen__;
    struct s__sn__field *field;
    struct s__sn__field *reverse_field;
    struct s__l__sn__struct_pair *pairs;
} *t__sn__field_type_relation;
#define d__sn__field_type_relation 2162
typedef t__sn__field_type_relation t__field_type_relation;
#define d__field_type_relation d__sn__field_type_relation

/* line 9 "/vobs/specman/src/type_narrow.e"  From 'struct definition' */
typedef struct s__sn__struct_pair {
    t__int d__;
    t__int gen__;
} *t__sn__struct_pair;
#define d__sn__struct_pair 2159
typedef t__sn__struct_pair t__struct_pair;
#define d__struct_pair d__sn__struct_pair

/* line 184 "/vobs/specman/src/disp_err_recovery.e"  From 'struct definition' */
typedef struct s__sn__construct_keyword {
    t__int d__;
    t__int gen__;
    t__string kind;
    t__string keyword;
    t__string full_keyword;
} *t__sn__construct_keyword;
#define d__sn__construct_keyword 2737
typedef t__sn__construct_keyword t__construct_keyword;
#define d__construct_keyword d__sn__construct_keyword

/* line 299 "/vobs/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn__te_header_desc {
    t__int d__;
    t__int gen__;
    struct s__l__int *depend;
    t__source_ref source;
    t__int tier;
    t__int event_id;
    t__string te_name;
    struct s__sn__struct_descriptor *te_parent_type;
    t__int num_of_states;
    t__int te_kind;
    t__int sense_size;
    t__bool optimized;
} *t__sn__te_header_desc;
#define d__sn__te_header_desc 2773
typedef t__sn__te_header_desc t__te_header_desc;
#define d__te_header_desc d__sn__te_header_desc

/* line 1182 "/vobs/specman/src/wave_services.e"  From 'struct definition' */
typedef struct s__sn__struct_threads {
    t__int d__;
    t__int gen__;
    struct s__l__sn__tcm *startable_tcms;
    t__string struct_name;
    struct s__reflection__rf_struct *struct_reflection;
} *t__sn__struct_threads;
#define d__sn__struct_threads 4307
typedef t__sn__struct_threads t__struct_threads;
#define d__struct_threads d__sn__struct_threads

/* line 947 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__tcm {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    struct s__sn__method_descriptor *md;
    t__sn__method_kind kind;
    t__int layer_index;
    struct s__sn__interpreted_method *interpreted_method;
    struct s__sn__st_action *method_body;
    struct s__sn__scope *scope;
    struct s__sn__type_descriptor *result_type;
    t__source_ref fst_action_srcref;
    struct s__sn__routine *routine;
    struct s__sn__tcm *previous_tcm;
    struct s__sn__script_descriptor *scd;
    struct s__sn__n__block *my_ntv_tree;
    struct s__l__sn__tcm_body *tcm_bodies;
    t__int prev_ext_call_label;
    struct s__sn__Action *my_AST_root;
    struct s__sn__sn_tcm_flow_graph *flow_graph;
    struct s__l__sn__routine *sub_tcm_routines;
} *t__sn__tcm;
#define d__sn__tcm 189
typedef t__sn__tcm t__tcm;
#define d__tcm d__sn__tcm

/* line 415 "/vobs/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__sn__script_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    struct s__sn__struct_descriptor *owning_struct;
    t__string default_event_name;
    t__sn__index default_event_id;
    struct s__sn__tcm *tcm_desc;
    void *_sgi___ptr_padding[2];
    int _sgi___int_padding[2];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__script_descriptor;
#define d__sn__script_descriptor 518
typedef t__sn__script_descriptor t__script_descriptor;
#define d__script_descriptor d__sn__script_descriptor

/* line 122 "/vobs/specman/src/tcm_meta.e"  From 'struct definition' */
typedef struct s__sn__tcm_body {
    t__int d__;
    t__int gen__;
    struct s__sn__tcm *tcm_desc;
    struct s__sn__sn_fg_debugger_hook_info *debug_info;
    t__int tcm_index;
    t__int states_cnt;
    struct s__sn__Action *AST_root;
    struct s__sn__sn_tcm_flow_graph *flow_graph;
    struct s__l__sn__local *thread_reuse_locals_bank;
} *t__sn__tcm_body;
#define d__sn__tcm_body 3101
typedef t__sn__tcm_body t__tcm_body;
#define d__tcm_body d__sn__tcm_body

/* line 116 "/vobs/specman/src/tcm_meta.e"  From 'struct definition' */
typedef struct s__sn__sn_fg_debugger_hook_info {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__scope *scope;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
} *t__sn__sn_fg_debugger_hook_info;
#define d__sn__sn_fg_debugger_hook_info 3100
typedef t__sn__sn_fg_debugger_hook_info t__sn_fg_debugger_hook_info;
#define d__sn_fg_debugger_hook_info d__sn__sn_fg_debugger_hook_info

/* line 128 "/vobs/specman/src/tcm_as_translation.e"  From 'struct definition' */
typedef struct s__sn__Action {
    t__int d__;
    t__int gen__;
    struct s__sn__ASTNode *parent;
    t__int level;
    t__string id_str;
    t__int id_num;
    struct s__sn__ntv *tcm_as_translation___my_ntv;
    struct s__sn__sub_tcm_body *sub_tcm_body;
} *t__sn__Action;
#define d__sn__Action 3125
typedef t__sn__Action t__Action;
#define d__Action d__sn__Action

/* line 107 "/vobs/specman/src/tcm_as_translation.e"  From 'struct definition' */
typedef struct s__sn__ASTNode {
    t__int d__;
    t__int gen__;
    struct s__sn__ASTNode *parent;
    t__int level;
    t__string id_str;
    t__int id_num;
} *t__sn__ASTNode;
#define d__sn__ASTNode 3124
typedef t__sn__ASTNode t__ASTNode;
#define d__ASTNode d__sn__ASTNode

/* line 161 "/vobs/specman/src/tcm_meta.e"  From 'struct definition' */
typedef struct s__sn__sub_tcm_body {
    t__int d__;
    t__int gen__;
    struct s__sn__tcm *tcm_desc;
    struct s__sn__sn_fg_debugger_hook_info *debug_info;
    t__int tcm_index;
    t__int states_cnt;
    struct s__sn__Action *AST_root;
    struct s__sn__sn_tcm_flow_graph *flow_graph;
    struct s__l__sn__local *thread_reuse_locals_bank;
    t__int ind;
    t__int branching_degree;
    struct s__sn__local *thread_reuse_local;
} *t__sn__sub_tcm_body;
#define d__sn__sub_tcm_body 3103
typedef t__sn__sub_tcm_body t__sub_tcm_body;
#define d__sub_tcm_body d__sn__sub_tcm_body

/* line 71 "/vobs/specman/src/tcm_data_structures.e"  From 'struct definition' */
typedef struct s__sn__sn_tcm_flow_graph {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_tcm_flow_grap21205 *nodes;
    struct s__sn__Action *root_action;
    struct s__sn__sn_tcm_flow_graph_node *initial_node;
    struct s__sn__sub_tcm_body *sub_tcm_body;
    struct s__sn__tcm *tcm_desc;
    struct s__sn__n__action *debug_dummy_action;
    struct s__sn__pre_wait_action *debug_dummy_pre_wait_action;
    struct s__sn__sn_fg_debugger_hook_info *header_debug_info;
} *t__sn__sn_tcm_flow_graph;
#define d__sn__sn_tcm_flow_graph 3109
typedef t__sn__sn_tcm_flow_graph t__sn_tcm_flow_graph;
#define d__sn_tcm_flow_graph d__sn__sn_tcm_flow_graph

/* line 45 "/vobs/specman/src/tcm_flow_graph.e"  From 'struct definition' */
typedef struct s__sn__sn_tcm_flow_graph_node {
    t__int d__;
    t__int gen__;
    t__string label;
    struct s__l__sn__sn_tcm_flow_grap21205 *succ;
    t__int index;
    struct s__sn__sn_fg_debugger_hook_info *debug_info;
} *t__sn__sn_tcm_flow_graph_node;
#define d__sn__sn_tcm_flow_graph_node 3204
typedef t__sn__sn_tcm_flow_graph_node t__sn_tcm_flow_graph_node;
#define d__sn_tcm_flow_graph_node d__sn__sn_tcm_flow_graph_node

/* line 30 "/vobs/specman/src/tcm_flow_graph.e"  From 'struct definition' */
typedef struct s__sn__pre_wait_action {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__action *ntv_action;
    t__string method_name;
    struct s__e_core__any_struct *sn_owner;
} *t__sn__pre_wait_action;
#define d__sn__pre_wait_action 3203
typedef t__sn__pre_wait_action t__pre_wait_action;
#define d__pre_wait_action d__sn__pre_wait_action

/* line 280 "/vobs/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__sn__reduction {
    t__int d__;
    t__int gen__;
    t__string one_path_msg;
    t__string init_msg;
    struct s__l__sn__gen_constraint *the_gcs;
    struct s__l__sn__index *the_inds;
    struct s__l__sn__index *the_soft_inds;
    t__bool debug_reduction;
    struct s__l__sn__any_rl *orig_rls;
    struct s__l__sn__any_rl *reduced_rls;
    struct s__l__sn__any_rl *debug_rls;
    struct s__l__bool *changed;
    t__sn__reduce_result reduce_result;
    t__bool in_reduction;
    t__bool recursive_reduction;
    t__sn__graph_type graph_type;
    struct s__l__sn__save_reduction_info *prev_reductions;
    t__sn__index last_save;
    struct s__l__bool *pre_l;
    t__bool in_place;
    struct s__sn__static_reduce_graph *static_reduce_graph;
    struct s__sn__dynamic_reduce_graph *dynamic_reduce_graph;
    struct s__sn__choose_reduce_graph *choose_reduce_graph;
    struct s__l__sn__and_info *gcas;
    struct s__l__sn__gen_constraint_range *the_one_paths_gcs;
    struct s__l__sn__gen_constraint_or *possibly_contradicting_ors;
    struct s__l__sn__derived_or_info *derived_ors;
    struct s__k__sn__or_info__gco *or_gcs_info;
    struct s__l__sn__count *poset_in_degree;
    struct s__l__sn__count *poset_out_degree;
    struct s__l__sn__index *poset_ready_in;
    struct s__l__sn__index *poset_ready_out;
    struct s__l__bool *poset_changed_min;
    struct s__l__bool *poset_changed_max;
    struct s__sn_rl__struct_rl *null_struct_rl;
    t__sn__count reduction_time;
    t__string par_orig_str;
} *t__sn__reduction;
#define d__sn__reduction 5737
typedef t__sn__reduction t__reduction;
#define d__reduction d__sn__reduction

/* line 15 "/vobs/specman/src/gen_reduce.e"  From 'struct definition' */
typedef struct s__sn__save_reduction_info {
    t__int d__;
    t__int gen__;
    t__bool debug_reduction;
    struct s__l__bool *changed;
    t__sn__reduce_result reduce_result;
    t__bool in_reduction;
    t__bool recursive_reduction;
    t__bool in_place;
    t__sn__graph_type graph_type;
    struct s__l__sn__any_rl *reduced_rls;
    struct s__l__sn__any_rl *debug_rls;
    struct s__sn__reduce_graph *the_graph;
} *t__sn__save_reduction_info;
#define d__sn__save_reduction_info 5757
typedef t__sn__save_reduction_info t__save_reduction_info;
#define d__save_reduction_info d__sn__save_reduction_info

/* line 483 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__reduce_graph {
    t__int d__;
    t__int gen__;
    t__sn__count no_of_reduction_phases;
    t__sn__count total_no_of_reductions;
    t__sn__count no_of_reductions_in_phase;
    t__sn__count max_no_of_reductions_in_phase;
    t__sn__index contradiction_index;
    struct s__l__sn__gendb_item *dbg_items;
    t__bool to_test;
    struct s__l__sn__any_rl *rls;
    struct s__l__string *lines;
    t__bool debug_it;
    struct s__l__sn__index *debug_pars;
} *t__sn__reduce_graph;
#define d__sn__reduce_graph 5696
typedef t__sn__reduce_graph t__reduce_graph;
#define d__reduce_graph d__sn__reduce_graph

/* line 64 "/vobs/specman/src/gen_msg_header.e"  From 'struct definition' */
typedef struct s__sn__gendb_item {
    t__int d__;
    t__int gen__;
    t__imp_enum_sn__gendb_item__phase phase;
    t__bool changed;
    struct s__sn__constraint_path *cp;
    t__bool accessible;
    t__bool fix;
    t__int item_ind;
    struct s__sn__type_descriptor *td;
    struct s__sn__any_rl *rl;
    struct s__sn__any_rl *pre_rl;
} *t__sn__gendb_item;
#define d__sn__gendb_item 2136
typedef t__sn__gendb_item t__gendb_item;
#define d__gendb_item d__sn__gendb_item

/* line 533 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__static_reduce_graph {
    t__int d__;
    t__int gen__;
    t__sn__count no_of_reduction_phases;
    t__sn__count total_no_of_reductions;
    t__sn__count no_of_reductions_in_phase;
    t__sn__count max_no_of_reductions_in_phase;
    t__sn__index contradiction_index;
    struct s__l__sn__gendb_item *dbg_items;
    t__bool to_test;
    struct s__l__sn__any_rl *rls;
    struct s__l__string *lines;
    t__bool debug_it;
    struct s__l__sn__index *debug_pars;
    struct s__l__sn__field_gen_role *croles;
    struct s__l__sn__which_rl *which_rls_q;
    struct s__sn__simple_gen_constraint *gc;
    struct s__l__sn__field_gen_role *par_roles;
    struct s__l__sn__which_rl *which_rls;
    struct s__sn__field_gen_role *fgr;
    t__sn__which_rl the_wr;
    struct s__sn__field_gen_role *pfgr;
    t__sn__index ind_in_crole;
    struct s__sn__a_role *me_role;
    t__bool in_base_role;
    struct s__l__sn__simple_gen_constraint *the_gcs;
    struct s__l__sn__index *the_par_inds;
    struct s__l__sn__index *the_par_soft_inds;
    struct s__sn__gen_constraint_or *the_or;
} *t__sn__static_reduce_graph;
#define d__sn__static_reduce_graph 5697
typedef t__sn__static_reduce_graph t__static_reduce_graph;
#define d__static_reduce_graph d__sn__static_reduce_graph

/* line 549 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__dynamic_reduce_graph {
    t__int d__;
    t__int gen__;
    t__sn__count no_of_reduction_phases;
    t__sn__count total_no_of_reductions;
    t__sn__count no_of_reductions_in_phase;
    t__sn__count max_no_of_reductions_in_phase;
    t__sn__index contradiction_index;
    struct s__l__sn__gendb_item *dbg_items;
    t__bool to_test;
    struct s__l__sn__any_rl *rls;
    struct s__l__string *lines;
    t__bool debug_it;
    struct s__l__sn__index *debug_pars;
    struct s__l__sn__field_node *par_nodes;
    struct s__sn__field_node *curr_par;
    struct s__sn__sn_simple_constrain46815 *ci;
    struct s__l__sn__field_node *ci_par_nodes;
    t__sn__index ci_index;
    t__sn__index par_ind;
    struct s__l__sn__field_node *orig_par_nodes;
    t__bool one_to_test;
    struct s__sn__sn_compound_constra48782 *curr_and_node;
    t__sn__index curr_and_alt;
    struct s__sn__sn_compound_constra48782 *curr_or_node;
    t__sn__index curr_or_alt;
    t__bool tmp_in_and;
    struct s__l__sn__index *upto_cis;
    t__sn__index upto_ci;
    t__sn__index last_changed_index;
    struct s__l__sn__sn_simple_constr49763 *to_mark_cis;
    struct s__l__sn__sn_gen_event *reduction_events;
} *t__sn__dynamic_reduce_graph;
#define d__sn__dynamic_reduce_graph 5699
typedef t__sn__dynamic_reduce_graph t__dynamic_reduce_graph;
#define d__dynamic_reduce_graph d__sn__dynamic_reduce_graph

/* line 35 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__field_node {
    t__int d__;
    t__int gen__;
    t__sn__index global_id;
    struct s__sn__field *field;
    t__sn__which_rl the_wr;
    t__bool debug_field;
    struct s__sn__seed_domain *the_seed;
    struct s__sn__struct_path_item *mpj;
    struct s__sn__dangling_cis_holder *dch;
    t__bool has_constraints;
    t__sn__pn_status pn_status;
    t__bool is_list;
    t__sn_rl__abstract_gen_type agt;
    struct s__sn_rl__int_rl *int_type__range;
    struct s__sn__int_field_gen_role *int_type__range_fgr;
    struct s__sn_rl__uint_rl *uint_type__range;
    struct s__sn__uint_field_gen_role *uint_type__range_fgr;
    struct s__sn_rl__long_rl *long_type__range;
    struct s__sn__long_field_gen_role *long_type__range_fgr;
    struct s__sn_rl__struct_rl *struct_type__range;
    struct s__sn__struct_field_gen_role *struct_type__range_fgr;
    struct s__sn_rl__string_rl *string_type__range;
    struct s__sn__string_field_gen_role *string_type__range_fgr;
    struct s__l__untyped *real_list;
    struct s__sn_rl__list_of_int_rl *list_of_int_type__range;
    struct s__sn__int_list_field_gen_role *list_of_int_type__range_fgr;
    struct s__sn_rl__list_of_uint_rl *list_of_uint_type__range;
    struct s__sn__uint_list_field_gen_role *list_of_uint_type__range_fgr;
    struct s__sn_rl__list_of_long_rl *list_of_long_type__range;
    struct s__sn__long_list_field_gen_role *list_of_long_type__range_fgr;
    struct s__sn_rl__list_of_struct_rl *list_of_struct_type__range;
    struct s__sn__struct_list_field_g48778 *list_of_struct_type__range_fgr;
    struct s__sn_rl__list_of_string_rl *list_of_string_type__range;
    struct s__sn__string_list_field_g48779 *list_of_string_type__range_fgr;
    t__sn__index has_constraints__last_reduction;
    t__bool has_constraints__in_reduction_list;
    struct s__l__sn__sn_cpi *has_constraints__exact_cpis;
    t__uint the_item__ind_in_list;
    struct s__sn__field_node *the_item__of_list;
    struct s__sn__field_node *is_list__the_item;
    struct s__l__sn__list_ci *is_list__has_constraints__list_cis;
} *t__sn__field_node;
#define d__sn__field_node 5669
typedef t__sn__field_node t__field_node;
#define d__field_node d__sn__field_node

/* line 289 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__struct_path_item {
    t__int d__;
    t__int gen__;
    struct s__sn__field *the_field;
    t__sn__count depth;
    t__bool debug_it;
    struct s__l__sn__a_role *active_roles;
    struct s__l__sn__index *position_in_roles;
    struct s__l__sn__a_role *relevant_roles;
    t__string path_str;
    struct s__sn__field_node *pn_for_soft;
    struct s__l__sn__field_node *pn_temps_list;
    t__bool above_gotf_root;
    t__sn__index curr_om_frame;
    struct s__sn__struct_descriptor *struct_type;
    struct s__sn__struct_descriptor *fast_subtype;
    struct s__sn__a_role *msr;
    struct s__sn__field_node *fn;
    struct s__sn__compound_path_item *next;
    struct s__e_core__any_struct *the_struct;
    struct s__l__sn__field_node *field_nodes;
    t__sn__index start_frame_id;
    struct s__l__sn__sn_constraint_in48781 *me_cis;
    struct s__l__sn__field_node *pending_dofs;
} *t__sn__struct_path_item;
#define d__sn__struct_path_item 5676
typedef t__sn__struct_path_item t__struct_path_item;
#define d__struct_path_item d__sn__struct_path_item

/* line 16 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__dangling_cis_holder {
    t__int d__;
    t__int gen__;
    struct s__l__sn__dangling_ci *dangling_cis;
    struct s__k__sn__subtype_dangling54690 *sdcis;
} *t__sn__dangling_cis_holder;
#define d__sn__dangling_cis_holder 5666
typedef t__sn__dangling_cis_holder t__dangling_cis_holder;
#define d__dangling_cis_holder d__sn__dangling_cis_holder

/* line 11 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__dangling_ci {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_simple_constrain46815 *the_ci;
    struct s__l__sn__sn_me_cpi *the_cpis;
    struct s__l__sn__attach_cpi_result *attachs;
} *t__sn__dangling_ci;
#define d__sn__dangling_ci 5665
typedef t__sn__dangling_ci t__dangling_ci;
#define d__dangling_ci d__sn__dangling_ci

/* line 402 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_constrain46815 {
    t__int d__;
    t__int gen__;
    t__sn__sn_gen_status_type status;
    struct s__sn__struct_path_item *spi;
    struct s__sn__sn_or_constraint_in48084 *top_or;
    t__int or_index;
    struct s__sn__sn_and_constraint_i48082 *top_and;
    t__int and_index;
    t__bool last_alternative;
    struct s__sn__simple_gen_constraint *gc;
    t__sn__index last_reduction;
    t__bool is_general;
    t__string pretty;
    struct s__l__sn__sn_cpi *cpis;
} *t__sn__sn_simple_constraint_instance;
#define d__sn__sn_simple_constraint_instance 5686
typedef t__sn__sn_simple_constraint_instance t__sn_simple_constraint_instance;
#define d__sn_simple_constraint_instance d__sn__sn_simple_constraint_instance

/* line 424 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_or_constraint_in48084 {
    t__int d__;
    t__int gen__;
    t__sn__sn_gen_status_type status;
    struct s__sn__struct_path_item *spi;
    struct s__sn__sn_or_constraint_in48084 *top_or;
    t__int or_index;
    struct s__sn__sn_and_constraint_i48082 *top_and;
    t__int and_index;
    t__bool last_alternative;
    struct s__sn__gen_constraint_compound *gc;
    struct s__l__sn__sn_constraint_in48781 *alternatives;
} *t__sn__sn_or_constraint_instance;
#define d__sn__sn_or_constraint_instance 5688
typedef t__sn__sn_or_constraint_instance t__sn_or_constraint_instance;
#define d__sn_or_constraint_instance d__sn__sn_or_constraint_instance

/* line 425 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_and_constraint_i48082 {
    t__int d__;
    t__int gen__;
    t__sn__sn_gen_status_type status;
    struct s__sn__struct_path_item *spi;
    struct s__sn__sn_or_constraint_in48084 *top_or;
    t__int or_index;
    struct s__sn__sn_and_constraint_i48082 *top_and;
    t__int and_index;
    t__bool last_alternative;
    struct s__sn__gen_constraint_compound *gc;
    struct s__l__sn__sn_constraint_in48781 *alternatives;
    struct s__l__sn__sn_me_cpi *tmp_cpis;
    struct s__l__sn__sn_constraint_in48781 *tmp_cpi_alts;
    struct s__l__sn__index *tmp_cpis_alt_starts;
    struct s__l__sn__count *tmp_cpis_alt_nos;
    struct s__l__sn__index *tmp_cpis_alt_inds;
} *t__sn__sn_and_constraint_instance;
#define d__sn__sn_and_constraint_instance 5689
typedef t__sn__sn_and_constraint_instance t__sn_and_constraint_instance;
#define d__sn_and_constraint_instance d__sn__sn_and_constraint_instance

/* line 615 "/vobs/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__sn__gen_constraint_compound {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__index index;
    struct s__sn__n__exp *n__exp;
    struct s__sn__explicit_exp *explicit_exp;
    t__sn__gc_status status;
    struct s__l__sn__gen_constraint *derived_from;
    t__sn__count last_reduction;
    struct s__sn__sn_gc_compound_parent *top_gc;
    t__sn__index gen_fly_index;
    t__bool is_soft;
    struct s__l__sn__index *soft_inds;
    struct s__sn__me_constraint_path *for_each_list;
    t__bool do_not_order;
    struct s__l__sn__gc_order_info *gcois;
    t__bool has_soft_temps;
    t__bool reloced_temps;
    t__bool edges_created;
    struct s__k__sn__constraint_path__it *parse_pre_paths;
    t__bool read_only_gc;
    t__bool needs_bit_paths;
    struct s__l__sn__gen_constraint *constraints;
} *t__sn__gen_constraint_compound;
#define d__sn__gen_constraint_compound 2024
typedef t__sn__gen_constraint_compound t__gen_constraint_compound;
#define d__gen_constraint_compound d__sn__gen_constraint_compound

/* line 379 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_constraint_instance {
    t__int d__;
    t__int gen__;
    t__sn__sn_gen_status_type status;
    struct s__sn__struct_path_item *spi;
    struct s__sn__sn_or_constraint_in48084 *top_or;
    t__int or_index;
    struct s__sn__sn_and_constraint_i48082 *top_and;
    t__int and_index;
    t__bool last_alternative;
} *t__sn__sn_constraint_instance;
#define d__sn__sn_constraint_instance 5685
typedef t__sn__sn_constraint_instance t__sn_constraint_instance;
#define d__sn_constraint_instance d__sn__sn_constraint_instance

/* line 1418 "/vobs/specman/src/gen_cpi.e"  From 'struct definition' */
typedef struct s__sn__sn_me_cpi {
    t__int d__;
    t__int gen__;
    t__sn__index ind_in_ci;
    struct s__sn__any_rl *rl;
    struct s__sn__deffered_gendb_items *deffered_gendb_items;
    struct s__sn__sn_simple_constrain46815 *ci;
    struct s__sn__fields_constraint_path *cp;
    t__sn__sn_gen_access_status access_status;
    t__bool fix;
    t__bool do_not_generate;
    t__bool evaluated;
    struct s__e_core__base_struct *the_me;
    struct s__e_core__base_struct *last_struct;
    t__sn__index last_field_index;
    struct s__e_core__base_struct *holder;
    struct s__sn__field_node *pn;
    t__sn__count last_reduction;
} *t__sn__sn_me_cpi;
#define d__sn__sn_me_cpi 5901
typedef t__sn__sn_me_cpi t__sn_me_cpi;
#define d__sn_me_cpi d__sn__sn_me_cpi

/* line 430 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__deffered_gendb_items {
    t__int d__;
    t__int gen__;
    struct s__l__sn__deffered_gendb_item *items;
} *t__sn__deffered_gendb_items;
#define d__sn__deffered_gendb_items 5692
typedef t__sn__deffered_gendb_items t__deffered_gendb_items;
#define d__deffered_gendb_items d__sn__deffered_gendb_items

/* line 141 "/vobs/specman/src/gen_msg_header.e"  From 'struct definition' */
typedef struct s__sn__deffered_gendb_item {
    t__int d__;
    t__int gen__;
    t__imp_enum_sn__gendb_item__phase phase;
    t__bool changed;
    struct s__sn__constraint_path *cp;
    t__bool accessible;
    t__bool fix;
    t__int item_ind;
    struct s__sn__type_descriptor *td;
    struct s__sn__any_rl *rl;
    struct s__sn__any_rl *pre_rl;
    struct s__e_core__base_struct *holder;
    t__string path_str;
} *t__sn__deffered_gendb_item;
#define d__sn__deffered_gendb_item 2140
typedef t__sn__deffered_gendb_item t__deffered_gendb_item;
#define d__deffered_gendb_item d__sn__deffered_gendb_item

/* line 433 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_cpi {
    t__int d__;
    t__int gen__;
    t__sn__index ind_in_ci;
    struct s__sn__any_rl *rl;
    struct s__sn__deffered_gendb_items *deffered_gendb_items;
    struct s__sn__sn_simple_constrain46815 *ci;
} *t__sn__sn_cpi;
#define d__sn__sn_cpi 5693
typedef t__sn__sn_cpi t__sn_cpi;
#define d__sn_cpi d__sn__sn_cpi

/* line 7 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__attach_cpi_result {
    t__int d__;
    t__int gen__;
    struct s__sn__field_holder *fh;
    struct s__sn__field_node *pn;
    t__bool is_dont_gen;
} *t__sn__attach_cpi_result;
#define d__sn__attach_cpi_result 5664
typedef t__sn__attach_cpi_result t__attach_cpi_result;
#define d__attach_cpi_result d__sn__attach_cpi_result

/* line 410 "/vobs/specman/src/gen_yolka.e"  From 'struct definition' */
typedef struct s__sn__subtype_dangling_ci {
    t__int d__;
    t__int gen__;
    struct s__sn__composite_descriptor *sd;
    struct s__l__sn__dangling_ci *dcis;
} *t__sn__subtype_dangling_ci;
#define d__sn__subtype_dangling_ci 6050
typedef t__sn__subtype_dangling_ci t__subtype_dangling_ci;
#define d__subtype_dangling_ci d__sn__subtype_dangling_ci

/* line 22 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__int_rl {
    t__int d__;
    t__int gen__;
    struct s__l__int *rl_list;
} *t__sn_rl__int_rl;
#define d__sn_rl__int_rl 1631
typedef t__sn_rl__int_rl t__int_rl;
#define d__int_rl d__sn_rl__int_rl

/* line 571 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__int_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__sn_rl__int_rl *int_rl;
} *t__sn__int_field_gen_role;
#define d__sn__int_field_gen_role 5638
typedef t__sn__int_field_gen_role t__int_field_gen_role;
#define d__int_field_gen_role d__sn__int_field_gen_role

/* line 573 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__uint_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__sn_rl__uint_rl *uint_rl;
} *t__sn__uint_field_gen_role;
#define d__sn__uint_field_gen_role 5639
typedef t__sn__uint_field_gen_role t__uint_field_gen_role;
#define d__uint_field_gen_role d__sn__uint_field_gen_role

/* line 575 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__long_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__sn_rl__long_rl *long_rl;
} *t__sn__long_field_gen_role;
#define d__sn__long_field_gen_role 5640
typedef t__sn__long_field_gen_role t__long_field_gen_role;
#define d__long_field_gen_role d__sn__long_field_gen_role

/* line 92 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__struct_rl {
    t__int d__;
    t__int gen__;
    t__bool is_complement;
    struct s__l__e_core__base_struct *rl_list;
} *t__sn_rl__struct_rl;
#define d__sn_rl__struct_rl 1642
typedef t__sn_rl__struct_rl t__struct_rl;
#define d__struct_rl d__sn_rl__struct_rl

/* line 577 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__struct_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__sn_rl__struct_rl *struct_rl;
} *t__sn__struct_field_gen_role;
#define d__sn__struct_field_gen_role 5641
typedef t__sn__struct_field_gen_role t__struct_field_gen_role;
#define d__struct_field_gen_role d__sn__struct_field_gen_role

/* line 93 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__string_rl {
    t__int d__;
    t__int gen__;
    t__bool is_complement;
    struct s__l__string *rl_list;
} *t__sn_rl__string_rl;
#define d__sn_rl__string_rl 1643
typedef t__sn_rl__string_rl t__string_rl;
#define d__string_rl d__sn_rl__string_rl

/* line 579 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__string_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__sn_rl__string_rl *string_rl;
} *t__sn__string_field_gen_role;
#define d__sn__string_field_gen_role 5642
typedef t__sn__string_field_gen_role t__string_field_gen_role;
#define d__string_field_gen_role d__sn__string_field_gen_role

/* line 84 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__list_of_int_rl {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
    struct s__l__sn_rl__uint_rl *inds;
    struct s__l__uint *single_inds;
    struct s__sn_rl__list_rl *in_list;
    struct s__sn_rl__uint_rl *in_list_inds;
    struct s__l__uint *in_list_inds_fast;
    struct s__l__sn_rl__int_rl *vals;
    struct s__l__int *single_vals;
    struct s__sn_rl__int_rl *single_vals_range;
    t__bool fast_in_list;
    struct s__sn_rl__int_rl *last_inds_query;
    struct s__sn_rl__uint_rl *last_inds_query_result;
    struct s__sn_rl__uint_rl *last_vals_query;
    struct s__sn_rl__int_rl *last_vals_query_result;
    t__uint last_search_stop;
    struct s__sn_rl__uint_rl *last_precise_inds;
    struct s__sn_rl__int_rl *last_precise_vals;
} *t__sn_rl__list_of_int_rl;
#define d__sn_rl__list_of_int_rl 1637
typedef t__sn_rl__list_of_int_rl t__list_of_int_rl;
#define d__list_of_int_rl d__sn_rl__list_of_int_rl

/* line 47 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__list_rl {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
    struct s__l__sn_rl__uint_rl *inds;
    struct s__l__uint *single_inds;
    struct s__sn_rl__list_rl *in_list;
    struct s__sn_rl__uint_rl *in_list_inds;
    struct s__l__uint *in_list_inds_fast;
} *t__sn_rl__list_rl;
#define d__sn_rl__list_rl 1635
typedef t__sn_rl__list_rl t__list_rl;
#define d__list_rl d__sn_rl__list_rl

/* line 591 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__int_list_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__l__sn__simple_gen_constraint *item_gcs;
    struct s__l__sn__index *item_par_inds;
    struct s__l__sn__index *item_soft_inds;
    t__sn__count item_last_reduction;
    t__bool item_in_reduction_list;
    t__sn__role_range_status item_role_range_status;
    struct s__sn_rl__list_of_int_rl *list_of_int_rl;
} *t__sn__int_list_field_gen_role;
#define d__sn__int_list_field_gen_role 5644
typedef t__sn__int_list_field_gen_role t__int_list_field_gen_role;
#define d__int_list_field_gen_role d__sn__int_list_field_gen_role

/* line 83 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__list_of_uint_rl {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
    struct s__l__sn_rl__uint_rl *inds;
    struct s__l__uint *single_inds;
    struct s__sn_rl__list_rl *in_list;
    struct s__sn_rl__uint_rl *in_list_inds;
    struct s__l__uint *in_list_inds_fast;
    struct s__l__sn_rl__uint_rl *vals;
    struct s__l__uint *single_vals;
    struct s__sn_rl__uint_rl *single_vals_range;
    t__bool fast_in_list;
    struct s__sn_rl__uint_rl *last_inds_query;
    struct s__sn_rl__uint_rl *last_inds_query_result;
    struct s__sn_rl__uint_rl *last_vals_query;
    struct s__sn_rl__uint_rl *last_vals_query_result;
    t__uint last_search_stop;
    struct s__sn_rl__uint_rl *last_precise_inds;
    struct s__sn_rl__uint_rl *last_precise_vals;
} *t__sn_rl__list_of_uint_rl;
#define d__sn_rl__list_of_uint_rl 1636
typedef t__sn_rl__list_of_uint_rl t__list_of_uint_rl;
#define d__list_of_uint_rl d__sn_rl__list_of_uint_rl

/* line 593 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__uint_list_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__l__sn__simple_gen_constraint *item_gcs;
    struct s__l__sn__index *item_par_inds;
    struct s__l__sn__index *item_soft_inds;
    t__sn__count item_last_reduction;
    t__bool item_in_reduction_list;
    t__sn__role_range_status item_role_range_status;
    struct s__sn_rl__list_of_uint_rl *list_of_uint_rl;
} *t__sn__uint_list_field_gen_role;
#define d__sn__uint_list_field_gen_role 5645
typedef t__sn__uint_list_field_gen_role t__uint_list_field_gen_role;
#define d__uint_list_field_gen_role d__sn__uint_list_field_gen_role

/* line 85 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__list_of_long_rl {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
    struct s__l__sn_rl__uint_rl *inds;
    struct s__l__uint *single_inds;
    struct s__sn_rl__list_rl *in_list;
    struct s__sn_rl__uint_rl *in_list_inds;
    struct s__l__uint *in_list_inds_fast;
    struct s__l__sn_rl__long_rl *vals;
    struct s__l__sn__sn_vec *single_vals;
    struct s__sn_rl__long_rl *single_vals_range;
    t__bool fast_in_list;
    struct s__sn_rl__long_rl *last_inds_query;
    struct s__sn_rl__uint_rl *last_inds_query_result;
    struct s__sn_rl__uint_rl *last_vals_query;
    struct s__sn_rl__long_rl *last_vals_query_result;
    t__uint last_search_stop;
    struct s__sn_rl__uint_rl *last_precise_inds;
    struct s__sn_rl__long_rl *last_precise_vals;
} *t__sn_rl__list_of_long_rl;
#define d__sn_rl__list_of_long_rl 1638
typedef t__sn_rl__list_of_long_rl t__list_of_long_rl;
#define d__list_of_long_rl d__sn_rl__list_of_long_rl

/* line 595 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__long_list_field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__l__sn__simple_gen_constraint *item_gcs;
    struct s__l__sn__index *item_par_inds;
    struct s__l__sn__index *item_soft_inds;
    t__sn__count item_last_reduction;
    t__bool item_in_reduction_list;
    t__sn__role_range_status item_role_range_status;
    struct s__sn_rl__list_of_long_rl *list_of_long_rl;
} *t__sn__long_list_field_gen_role;
#define d__sn__long_list_field_gen_role 5646
typedef t__sn__long_list_field_gen_role t__long_list_field_gen_role;
#define d__long_list_field_gen_role d__sn__long_list_field_gen_role

/* line 86 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__list_of_struct_rl {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
    struct s__l__sn_rl__uint_rl *inds;
    struct s__l__uint *single_inds;
    struct s__sn_rl__list_rl *in_list;
    struct s__sn_rl__uint_rl *in_list_inds;
    struct s__l__uint *in_list_inds_fast;
    struct s__l__sn_rl__struct_rl *vals;
    struct s__l__e_core__base_struct *single_vals;
    struct s__sn_rl__struct_rl *single_vals_range;
    t__bool fast_in_list;
    struct s__sn_rl__struct_rl *last_inds_query;
    struct s__sn_rl__uint_rl *last_inds_query_result;
    struct s__sn_rl__uint_rl *last_vals_query;
    struct s__sn_rl__struct_rl *last_vals_query_result;
    t__uint last_search_stop;
    struct s__sn_rl__uint_rl *last_precise_inds;
    struct s__sn_rl__struct_rl *last_precise_vals;
} *t__sn_rl__list_of_struct_rl;
#define d__sn_rl__list_of_struct_rl 1639
typedef t__sn_rl__list_of_struct_rl t__list_of_struct_rl;
#define d__list_of_struct_rl d__sn_rl__list_of_struct_rl

/* line 597 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__struct_list_field_g48778 {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__l__sn__simple_gen_constraint *item_gcs;
    struct s__l__sn__index *item_par_inds;
    struct s__l__sn__index *item_soft_inds;
    t__sn__count item_last_reduction;
    t__bool item_in_reduction_list;
    t__sn__role_range_status item_role_range_status;
    struct s__sn_rl__list_of_struct_rl *list_of_struct_rl;
} *t__sn__struct_list_field_gen_role;
#define d__sn__struct_list_field_gen_role 5647
typedef t__sn__struct_list_field_gen_role t__struct_list_field_gen_role;
#define d__struct_list_field_gen_role d__sn__struct_list_field_gen_role

/* line 87 "/vobs/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__sn_rl__list_of_string_rl {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
    struct s__l__sn_rl__uint_rl *inds;
    struct s__l__uint *single_inds;
    struct s__sn_rl__list_rl *in_list;
    struct s__sn_rl__uint_rl *in_list_inds;
    struct s__l__uint *in_list_inds_fast;
    struct s__l__sn_rl__string_rl *vals;
    struct s__l__string *single_vals;
    struct s__sn_rl__string_rl *single_vals_range;
    t__bool fast_in_list;
    struct s__sn_rl__string_rl *last_inds_query;
    struct s__sn_rl__uint_rl *last_inds_query_result;
    struct s__sn_rl__uint_rl *last_vals_query;
    struct s__sn_rl__string_rl *last_vals_query_result;
    t__uint last_search_stop;
    struct s__sn_rl__uint_rl *last_precise_inds;
    struct s__sn_rl__string_rl *last_precise_vals;
} *t__sn_rl__list_of_string_rl;
#define d__sn_rl__list_of_string_rl 1640
typedef t__sn_rl__list_of_string_rl t__list_of_string_rl;
#define d__list_of_string_rl d__sn_rl__list_of_string_rl

/* line 599 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__string_list_field_g48779 {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__sn__index id;
    struct s__sn__a_role *parent_role;
    struct s__sn__field_gen_role *more_general_fgr;
    struct s__sn__seed_domain *the_seed;
    struct s__l__sn__simple_gen_constraint *gcs;
    struct s__l__sn__index *par_inds;
    struct s__l__sn__index *soft_inds;
    t__sn__count last_reduction;
    t__bool in_reduction_list;
    t__sn__role_range_status role_range_status;
    struct s__l__sn__simple_gen_constraint *item_gcs;
    struct s__l__sn__index *item_par_inds;
    struct s__l__sn__index *item_soft_inds;
    t__sn__count item_last_reduction;
    t__bool item_in_reduction_list;
    t__sn__role_range_status item_role_range_status;
    struct s__sn_rl__list_of_string_rl *list_of_string_rl;
} *t__sn__string_list_field_gen_role;
#define d__sn__string_list_field_gen_role 5648
typedef t__sn__string_list_field_gen_role t__string_list_field_gen_role;
#define d__string_list_field_gen_role d__sn__string_list_field_gen_role

/* line 86 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__list_ci {
    t__int d__;
    t__int gen__;
    t__imp_enum_sn__list_ci__ci_type ci_type;
    struct s__sn__any_rl *index_rl;
    t__sn__index ind_in_ci;
    struct s__sn__sn_simple_constrain46815 *ci;
} *t__sn__list_ci;
#define d__sn__list_ci 5670
typedef t__sn__list_ci t__list_ci;
#define d__list_ci d__sn__list_ci

/* line 235 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__compound_path_item {
    t__int d__;
    t__int gen__;
    struct s__sn__field *the_field;
    t__sn__count depth;
    t__bool debug_it;
    struct s__l__sn__a_role *active_roles;
    struct s__l__sn__index *position_in_roles;
    struct s__l__sn__a_role *relevant_roles;
    t__string path_str;
    struct s__sn__field_node *pn_for_soft;
    struct s__l__sn__field_node *pn_temps_list;
    t__bool above_gotf_root;
    t__sn__index curr_om_frame;
} *t__sn__compound_path_item;
#define d__sn__compound_path_item 5672
typedef t__sn__compound_path_item t__compound_path_item;
#define d__compound_path_item d__sn__compound_path_item

/* line 415 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_compound_constra48782 {
    t__int d__;
    t__int gen__;
    t__sn__sn_gen_status_type status;
    struct s__sn__struct_path_item *spi;
    struct s__sn__sn_or_constraint_in48084 *top_or;
    t__int or_index;
    struct s__sn__sn_and_constraint_i48082 *top_and;
    t__int and_index;
    t__bool last_alternative;
    struct s__sn__gen_constraint_compound *gc;
    struct s__l__sn__sn_constraint_in48781 *alternatives;
} *t__sn__sn_compound_constraint_instance;
#define d__sn__sn_compound_constraint_instance 5687
typedef t__sn__sn_compound_constraint_instance t__sn_compound_constraint_instance;
#define d__sn_compound_constraint_instance d__sn__sn_compound_constraint_instance

/* line 807 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
} *t__sn__sn_gen_event;
#define d__sn__sn_gen_event 5913
typedef t__sn__sn_gen_event t__sn_gen_event;
#define d__sn_gen_event d__sn__sn_gen_event

/* line 552 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__choose_reduce_graph {
    t__int d__;
    t__int gen__;
    t__sn__count no_of_reduction_phases;
    t__sn__count total_no_of_reductions;
    t__sn__count no_of_reductions_in_phase;
    t__sn__count max_no_of_reductions_in_phase;
    t__sn__index contradiction_index;
    struct s__l__sn__gendb_item *dbg_items;
    t__bool to_test;
    struct s__l__sn__any_rl *rls;
    struct s__l__string *lines;
    t__bool debug_it;
    struct s__l__sn__index *debug_pars;
    struct s__l__sn__field_node *par_nodes;
    struct s__sn__field_node *curr_par;
    struct s__sn__sn_simple_constrain46815 *ci;
    struct s__l__sn__field_node *ci_par_nodes;
    t__sn__index ci_index;
    t__sn__index par_ind;
    struct s__sn__any_rl *save_rl;
    struct s__l__sn__sn_simple_constr49763 *soft_cis;
    struct s__l__sn__sn_cpi *soft_cpis;
    struct s__sn__any_rl *par_range;
    t__bool first_time;
    t__bool no_more;
    t__bool found_successful;
    struct s__l__sn__sn_soft_testing_event *soft_testing_events;
} *t__sn__choose_reduce_graph;
#define d__sn__choose_reduce_graph 5700
typedef t__sn__choose_reduce_graph t__choose_reduce_graph;
#define d__choose_reduce_graph d__sn__choose_reduce_graph

/* line 1595 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_soft_testing_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__l__sn__sn_gendb_item *parameters;
    struct s__sn__sn_ci_status_changed *new_status;
    struct s__sn__not_fix_me_gendb_item *item;
} *t__sn__sn_soft_testing_event;
#define d__sn__sn_soft_testing_event 5941
typedef t__sn__sn_soft_testing_event t__sn_soft_testing_event;
#define d__sn_soft_testing_event d__sn__sn_soft_testing_event

/* line 2522 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_gendb_item {
    t__int d__;
    t__int gen__;
    t__int parameter_index;
    struct s__sn__any_rl *rl;
    struct s__sn__type_descriptor *td;
    struct s__sn__constraint_path *cp;
    struct s__sn__sn_gen_event *holding_event;
} *t__sn__sn_gendb_item;
#define d__sn__sn_gendb_item 5988
typedef t__sn__sn_gendb_item t__sn_gendb_item;
#define d__sn_gendb_item d__sn__sn_gendb_item

/* line 2478 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_ci_status_changed {
    t__int d__;
    t__int gen__;
    t__int parameter_index;
    t__sn__sn_status_result_kinds result;
    struct s__sn__sn_gen_event *holding_event;
    struct s__sn__gendb_constraint *ci;
    t__sn__index index_in_cig;
} *t__sn__sn_ci_status_changed;
#define d__sn__sn_ci_status_changed 5986
typedef t__sn__sn_ci_status_changed t__sn_ci_status_changed;
#define d__sn_ci_status_changed d__sn__sn_ci_status_changed

/* line 2337 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gendb_constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint *gc;
    t__sn__index index;
    struct s__sn__sn_set_status_event *set_status;
    struct s__l__sn__sn_ci_status_changed *history;
} *t__sn__gendb_constraint;
#define d__sn__gendb_constraint 5976
typedef t__sn__gendb_constraint t__gendb_constraint;
#define d__gendb_constraint d__sn__gendb_constraint

/* line 1517 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_set_status_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__sn__sn_gen_event *direct_event_reason;
    t__sn__sn_gendb_status kind;
    struct s__sn__sn_ci_status_changed *changed_status;
} *t__sn__sn_set_status_event;
#define d__sn__sn_set_status_event 5938
typedef t__sn__sn_set_status_event t__sn_set_status_event;
#define d__sn_set_status_event d__sn__sn_set_status_event

/* line 2793 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__not_fix_me_gendb_item {
    t__int d__;
    t__int gen__;
    t__int parameter_index;
    struct s__sn__any_rl *rl;
    struct s__sn__type_descriptor *td;
    struct s__sn__constraint_path *cp;
    struct s__sn__sn_gen_event *holding_event;
    struct s__e_core__base_struct *holder;
    struct s__sn__field *f;
    t__bool fixed;
    t__bool accessible;
    struct s__e_core__base_struct *initial_struct;
    struct s__l__int *path_indexes;
    t__int last_accessible_field;
    t__bool deffered;
    struct s__sn__gendb_field_in_gen *fig;
    t__sn__index index_in_fig;
} *t__sn__not_fix_me_gendb_item;
#define d__sn__not_fix_me_gendb_item 5999
typedef t__sn__not_fix_me_gendb_item t__not_fix_me_gendb_item;
#define d__not_fix_me_gendb_item d__sn__not_fix_me_gendb_item

/* line 2193 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gendb_field_in_gen {
    t__int d__;
    t__int gen__;
    t__sn__index index_in_holder;
    struct s__sn__field *f;
    struct s__l__sn__not_fix_me_gendb_item *history;
    struct s__sn__sn_gen_root_event *holder;
    struct s__e_core__base_struct *instance;
    t__int order_index;
    struct s__sn__gendb_field_in_role *static_field;
} *t__sn__gendb_field_in_gen;
#define d__sn__gendb_field_in_gen 5972
typedef t__sn__gendb_field_in_gen t__gendb_field_in_gen;
#define d__gendb_field_in_gen d__sn__gendb_field_in_gen

/* line 1089 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_root_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__sn__me_gendb_item *item;
    t__bool trace_from_begining;
    t__bool trace_till_end;
    t__bool complete_trace;
    t__bool failed_because_try;
    t__sn__gen_process_status status;
    struct s__k__sn__gendb_field_in_gen__f *all_fields;
    struct s__l__sn__sn_gen_event *all_events;
    struct s__k__sn__gendb_ci_in_gen__gc *me_app_constraints;
    struct s__sn__sn_role_info *role;
    t__bool is_gotf_path;
} *t__sn__sn_gen_root_event;
#define d__sn__sn_gen_root_event 5923
typedef t__sn__sn_gen_root_event t__sn_gen_root_event;
#define d__sn_gen_root_event d__sn__sn_gen_root_event

/* line 2746 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__me_gendb_item {
    t__int d__;
    t__int gen__;
    t__int parameter_index;
    struct s__sn__any_rl *rl;
    struct s__sn__type_descriptor *td;
    struct s__sn__constraint_path *cp;
    struct s__sn__sn_gen_event *holding_event;
    struct s__e_core__base_struct *holder;
    struct s__sn__field *f;
    t__bool fixed;
    t__bool accessible;
    struct s__e_core__base_struct *initial_struct;
    struct s__l__int *path_indexes;
    t__int last_accessible_field;
} *t__sn__me_gendb_item;
#define d__sn__me_gendb_item 5995
typedef t__sn__me_gendb_item t__me_gendb_item;
#define d__me_gendb_item d__sn__me_gendb_item

/* line 2386 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gendb_ci_in_gen {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint *gc;
    t__sn__index index;
    struct s__sn__sn_set_status_event *set_status;
    struct s__l__sn__sn_ci_status_changed *history;
    struct s__e_core__base_struct *instance;
    struct s__sn__sn_gen_root_event *holder;
    struct s__sn__gendb_ci_in_gen *parent;
    struct s__l__sn__gendb_ci_in_gen *children;
    struct s__sn__gendb_gc_in_role *static_constraint;
} *t__sn__gendb_ci_in_gen;
#define d__sn__gendb_ci_in_gen 5978
typedef t__sn__gendb_ci_in_gen t__gendb_ci_in_gen;
#define d__gendb_ci_in_gen d__sn__gendb_ci_in_gen

/* line 2366 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gendb_gc_in_role {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint *gc;
    t__sn__index index;
    struct s__sn__sn_set_status_event *set_status;
    struct s__l__sn__sn_ci_status_changed *history;
    struct s__sn__sn_role_info *holder;
} *t__sn__gendb_gc_in_role;
#define d__sn__gendb_gc_in_role 5977
typedef t__sn__gendb_gc_in_role t__gendb_gc_in_role;
#define d__gendb_gc_in_role d__sn__gendb_gc_in_role

/* line 2023 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_role_info {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role *role;
    struct s__k__sn__gendb_field_in_r54775 *all_fields;
    struct s__k__sn__gendb_gc_in_role__gc *app_constraints;
    struct s__l__sn__sn_gen_event *all_events;
    t__uint role_id;
} *t__sn__sn_role_info;
#define d__sn__sn_role_info 5966
typedef t__sn__sn_role_info t__sn_role_info;
#define d__sn_role_info d__sn__sn_role_info

/* line 2116 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gendb_field_in_role {
    t__int d__;
    t__int gen__;
    t__sn__index index_in_holder;
    struct s__sn__field *f;
    struct s__sn__sn_role_info *holder;
    struct s__l__sn__changed_static_g49782 *history;
    struct s__l__sn__gendb_gc_in_role *involved_in_constraint;
    struct s__l__sn__index *location_in_constraints;
    struct s__sn__any_rl *static_range;
} *t__sn__gendb_field_in_role;
#define d__sn__gendb_field_in_role 5968
typedef t__sn__gendb_field_in_role t__gendb_field_in_role;
#define d__gendb_field_in_role d__sn__gendb_field_in_role

/* line 2630 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__changed_static_gend50111 {
    t__int d__;
    t__int gen__;
    t__int parameter_index;
    struct s__sn__any_rl *rl;
    struct s__sn__type_descriptor *td;
    struct s__sn__constraint_path *cp;
    struct s__sn__sn_gen_event *holding_event;
    struct s__sn__field *f;
    struct s__sn__any_rl *pre_rl;
    struct s__sn__gendb_field_in_role *fir;
    t__sn__index index_in_fir;
} *t__sn__changed_static_gendb_item;
#define d__sn__changed_static_gendb_item 5992
typedef t__sn__changed_static_gendb_item t__changed_static_gendb_item;
#define d__changed_static_gendb_item d__sn__changed_static_gendb_item

/* line 73 "/vobs/specman/src/gen_reduce_or.e"  From 'struct definition' */
typedef struct s__sn__and_info {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_and *gca;
    struct s__l__sn__status_in_and *stats;
    struct s__l__sn__gen_constraint *gcs;
    struct s__l__sn__index *gcs_inds;
} *t__sn__and_info;
#define d__sn__and_info 5764
typedef t__sn__and_info t__and_info;
#define d__and_info d__sn__and_info

/* line 662 "/vobs/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__sn__gen_constraint_range {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int sn_attr;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__index index;
    struct s__sn__n__exp *n__exp;
    struct s__sn__explicit_exp *explicit_exp;
    t__sn__gc_status status;
    struct s__l__sn__gen_constraint *derived_from;
    t__sn__count last_reduction;
    struct s__sn__sn_gc_compound_parent *top_gc;
    t__sn__index gen_fly_index;
    t__bool is_soft;
    struct s__l__sn__index *soft_inds;
    struct s__sn__me_constraint_path *for_each_list;
    t__bool do_not_order;
    struct s__l__sn__gc_order_info *gcois;
    t__bool has_soft_temps;
    t__bool reloced_temps;
    t__bool edges_created;
    struct s__k__sn__constraint_path__it *parse_pre_paths;
    t__bool read_only_gc;
    t__bool needs_bit_paths;
    t__bool one_path;
    struct s__l__sn__any_rl *constant_ranges;
    struct s__l__sn__constraint_path *constraint_paths;
    struct s__l__bool *pre_paths;
    t__string pretty;
    struct s__sn__any_rl *the_range_list;
    t__bool inverted;
} *t__sn__gen_constraint_range;
#define d__sn__gen_constraint_range 2040
typedef t__sn__gen_constraint_range t__gen_constraint_range;
#define d__gen_constraint_range d__sn__gen_constraint_range

/* line 36 "/vobs/specman/src/gen_reduce_or.e"  From 'struct definition' */
typedef struct s__sn__derived_or_info {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_constraint_range *gcrs;
    struct s__l__sn__gen_constraint_or *gcos;
    struct s__l__sn__gen_constraint *gcs;
} *t__sn__derived_or_info;
#define d__sn__derived_or_info 5763
typedef t__sn__derived_or_info t__derived_or_info;
#define d__derived_or_info d__sn__derived_or_info

/* line 122 "/vobs/specman/src/gen_reduce_or.e"  From 'struct definition' */
typedef struct s__sn__or_info {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_or *gco;
    struct s__l__sn__status_in_or *stats;
    struct s__l__sn__and_info *gcas;
    struct s__l__sn__index *gcs_inds;
    struct s__sn__gen_constraint_range *the_one_path_gc;
    struct s__sn__a_role *me_role;
} *t__sn__or_info;
#define d__sn__or_info 5765
typedef t__sn__or_info t__or_info;
#define d__or_info d__sn__or_info

/* line 1423 "/vobs/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__sn__inherite_edges_iterator {
    t__int d__;
    t__int gen__;
    struct s__sn__role_collector *rc;
    t__sn__index last_id;
} *t__sn__inherite_edges_iterator;
#define d__sn__inherite_edges_iterator 5822
typedef t__sn__inherite_edges_iterator t__inherite_edges_iterator;
#define d__inherite_edges_iterator d__sn__inherite_edges_iterator

/* line 498 "/vobs/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__sn__role_collector {
    t__int d__;
    t__int gen__;
    struct s__sn__role_collector *prev;
    struct s__sn__a_role *the_role;
} *t__sn__role_collector;
#define d__sn__role_collector 5814
typedef t__sn__role_collector t__role_collector;
#define d__role_collector d__sn__role_collector

/* line 458 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__finalize_iterator {
    t__int d__;
    t__int gen__;
    t__sn__count n_nt;
    t__sn__count n_f;
    struct s__sn__a_role *the_role;
    struct s__l__sn__sn_field_collector *fcs;
    struct s__l__sn__a_role *prevs;
} *t__sn__finalize_iterator;
#define d__sn__finalize_iterator 5844
typedef t__sn__finalize_iterator t__finalize_iterator;
#define d__finalize_iterator d__sn__finalize_iterator

/* line 102 "/vobs/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__sn__sn_field_collector {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_field_collector *prev;
    t__sn__index i;
    struct s__sn__a_role *r;
} *t__sn__sn_field_collector;
#define d__sn__sn_field_collector 5806
typedef t__sn__sn_field_collector t__sn_field_collector;
#define d__sn_field_collector d__sn__sn_field_collector

/* line 1299 "/vobs/specman/src/gen/specman_rl_ext.e"  From 'struct definition' */
typedef struct s__sn_rl__bool_rl {
    t__int d__;
    t__int gen__;
    t__uint bitmap;
} *t__sn_rl__bool_rl;
#define d__sn_rl__bool_rl 8054
typedef t__sn_rl__bool_rl t__bool_rl;
#define d__bool_rl d__sn_rl__bool_rl

/* line 486 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__units {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__any_unit *instances;
    t__bool some_unit_instantiated;
    struct s__sn__unit_enclosing_descri481 *unit_enclosing_descriptor;
    struct s__sn__globalComputedStructList *globalComputedStructList;
    struct s__l__sn__struct_descriptor *all_units;
    t__bool is_elaborate_hdl_done;
    struct s__sn__curr_calc *global_calc;
    struct s__l__sn__unit_instance_info *instance_info_list;
    struct s__k__sn__hdl_struct__name *hdl_structs;
    struct s__k__sn__hdl_full_type_de14565 *all_existing_unit_types;
    struct s__k__sn__hdl_cache_rf_sub14567 *cached_all_rf_subtypes;
    struct s__k__sn__subprogram_handl14568 *subprogram_handles;
    struct s__k__sn__subprogram_entry14569 *subprogram_entries;
    struct s__k__sn__subprogram_defin14564 *subprograms;
    struct s__l__string *orig_subprogram_name;
    struct s__l__sn__subprogram_exp_info *subprograms_exp_info;
    struct s__sn__globalComputedSubpr14570 *globalComputedSubprogramsList;
    struct s__k__e_core__any_unit__ro14572 *units_by_noraml_hdl_path;
    struct s__e_core__any_simple_port *proto_global_tick_port;
    struct s__l__sn__sn_simple_def_channel *e2e_active_simple_channel;
    struct s__inout__simple_port__int *global_tick_port;
    struct s__l__vr_gsa__vr_gsa_unit *vr_gsa_gdbserver___vr_gsa_units;
} *t__e_core__units;
#define d__e_core__units 60
typedef t__e_core__units t__units;
#define d__units d__e_core__units

/* line 400 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__unit_enclosing_descri481 {
    t__int d__;
    t__int gen__;
    struct s__k__string__it *global_enclosing_list;
    t__bool enclosing_list_was_enlarge;
} *t__sn__unit_enclosing_descriptor;
#define d__sn__unit_enclosing_descriptor 170
typedef t__sn__unit_enclosing_descriptor t__unit_enclosing_descriptor;
#define d__unit_enclosing_descriptor d__sn__unit_enclosing_descriptor

/* line 114 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__globalComputedStructList {
    t__int d__;
    t__int gen__;
    struct s__l__sn__computed_struct_list *Table;
    t__uint str_counter;
    struct s__l__bool *is_first_unit;
} *t__sn__globalComputedStructList;
#define d__sn__globalComputedStructList 2191
typedef t__sn__globalComputedStructList t__globalComputedStructList;
#define d__globalComputedStructList d__sn__globalComputedStructList

/* line 101 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__computed_struct_list {
    t__int d__;
    t__int gen__;
    struct s__l__sn__computed_name *lst;
} *t__sn__computed_struct_list;
#define d__sn__computed_struct_list 2188
typedef t__sn__computed_struct_list t__computed_struct_list;
#define d__computed_struct_list d__sn__computed_struct_list

/* line 221 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__unit_instance_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *unit_inst;
    struct s__reflection__rf_struct *real_type;
    t__uint real_relative_id;
    struct s__k__sn__subprogram_handl12408 *me_subprograms;
    struct s__k__sn__subprogram_handl12408 *all_hilhul_subprograms;
    t__string short_name;
    t__bool name_in_cache;
} *t__sn__unit_instance_info;
#define d__sn__unit_instance_info 2198
typedef t__sn__unit_instance_info t__unit_instance_info;
#define d__unit_instance_info d__sn__unit_instance_info

/* line 468 "/vobs/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__sn__subprogram_handle {
    t__int d__;
    t__int gen__;
    t__string subprogram_name;
    t__string subprogram_noraml_name;
    t__string subprogram_native_name;
    t__sn__simulator_kind kind;
    struct s__sn__all_tms_for_subprogram *all_tms_for_subprogram;
    t__string trig_in_name;
    t__string trig_out_name;
    t__string res_func_name;
    t__string return_name_type;
    t__string merge_name;
    t__string process_name;
    t__uint return_function_size;
    struct s__sn__subprogram_definition *vtd;
    t__uint param_size;
    struct s__l__sn__subprogram_param *params;
    struct s__sn__subprogram_exp_info *info;
    struct s__e_core__any_unit *unit_inst;
    t__bool is_busy;
    struct s__sn__sn_adapter_bridge *adapter_struct;
    struct s__l__sn__connecte_cell *connecte_cell_param;
    struct s__l__int *original_sig_param;
} *t__sn__subprogram_handle;
#define d__sn__subprogram_handle 1271
typedef t__sn__subprogram_handle t__subprogram_handle;
#define d__subprogram_handle d__sn__subprogram_handle

/* line 529 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__all_tms_for_subprogram {
    t__int d__;
    t__int gen__;
    struct s__l__sn__translated_model14577 *subprogram_params;
    struct s__sn__translated_model_struct *trig_in;
} *t__sn__all_tms_for_subprogram;
#define d__sn__all_tms_for_subprogram 2217
typedef t__sn__all_tms_for_subprogram t__all_tms_for_subprogram;
#define d__all_tms_for_subprogram d__sn__all_tms_for_subprogram

/* line 509 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__subprogram_exp_info {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string original_string;
    struct s__reflection__rf_struct *unit_rf_desc;
    struct s__sn__subprogram_entry *the_entry;
    struct s__sn__computed_subprogram_name *the_cms;
    struct s__sn__desc_subprogram_info *the_desc_info;
    t__bool is_unit;
    t__bool is_canonical;
    t__bool was_computed;
    struct s__l__sn__hdl_data_type *data_types;
    struct s__l__sn__type_descriptor *list_type;
    t__uint param_size;
    struct s__l__untyped *values;
    t__bool is_entry_set;
    t__string struct_string;
    struct s__e_core__any_unit *the_inst;
} *t__sn__subprogram_exp_info;
#define d__sn__subprogram_exp_info 2216
typedef t__sn__subprogram_exp_info t__subprogram_exp_info;
#define d__subprogram_exp_info d__sn__subprogram_exp_info

/* line 566 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__subprogram_entry {
    t__int d__;
    t__int gen__;
    t__string subprogram_name;
    t__string subprogram_full_name;
    t__bool is_canonical;
    struct s__k__sn__desc_subprogram_14581 *descs;
} *t__sn__subprogram_entry;
#define d__sn__subprogram_entry 2219
typedef t__sn__subprogram_entry t__subprogram_entry;
#define d__subprogram_entry d__sn__subprogram_entry

/* line 559 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__desc_subprogram_info {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *unit_rf_desc;
    struct s__l__sn__subprogram_handle *subprogram_handles;
    t__string source_ref;
} *t__sn__desc_subprogram_info;
#define d__sn__desc_subprogram_info 2218
typedef t__sn__desc_subprogram_info t__desc_subprogram_info;
#define d__desc_subprogram_info d__sn__desc_subprogram_info

/* line 105 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__computed_subprogram_name {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__subprogram_entry *the_entry;
} *t__sn__computed_subprogram_name;
#define d__sn__computed_subprogram_name 2189
typedef t__sn__computed_subprogram_name t__computed_subprogram_name;
#define d__computed_subprogram_name d__sn__computed_subprogram_name

/* line 595 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__connecte_cell {
    t__int d__;
    t__int gen__;
    t__bool is_free;
    struct s__sn__translated_model_struct *conc_tms;
} *t__sn__connecte_cell;
#define d__sn__connecte_cell 2222
typedef t__sn__connecte_cell t__connecte_cell;
#define d__connecte_cell d__sn__connecte_cell

/* line 308 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__hdl_full_type_desc {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *full_type;
    struct s__l__e_core__any_unit *instances;
} *t__sn__hdl_full_type_desc;
#define d__sn__hdl_full_type_desc 2204
typedef t__sn__hdl_full_type_desc t__hdl_full_type_desc;
#define d__hdl_full_type_desc d__sn__hdl_full_type_desc

/* line 314 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__hdl_cache_rf_subtype {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *base_type;
    struct s__l__reflection__rf_struct *all_rf_like_when_subtypes;
} *t__sn__hdl_cache_rf_subtype;
#define d__sn__hdl_cache_rf_subtype 2205
typedef t__sn__hdl_cache_rf_subtype t__hdl_cache_rf_subtype;
#define d__hdl_cache_rf_subtype d__sn__hdl_cache_rf_subtype

/* line 120 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__globalComputedSubpr14570 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__computed_subprog14585 *Table;
    t__uint str_counter;
    struct s__l__bool *is_first_unit;
} *t__sn__globalComputedSubprogramList;
#define d__sn__globalComputedSubprogramList 2192
typedef t__sn__globalComputedSubprogramList t__globalComputedSubprogramList;
#define d__globalComputedSubprogramList d__sn__globalComputedSubprogramList

/* line 110 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__computed_subprogram_list {
    t__int d__;
    t__int gen__;
    struct s__l__sn__computed_subprog14584 *lst;
} *t__sn__computed_subprogram_list;
#define d__sn__computed_subprogram_list 2190
typedef t__sn__computed_subprogram_list t__computed_subprogram_list;
#define d__computed_subprogram_list d__sn__computed_subprogram_list

/* line 40 "/vobs/specman/src/port_simple.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_def_channel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_port *ports;
    struct s__l__e_core__any_port *external_out_ports;
    struct s__l__e_core__any_port *external_in_ports;
    struct s__l__source_ref *put_source_refs;
    t__source_ref curr_source_ref;
    t__sn__sn_channel_type_t channel_type;
    t__uint cb_counter;
    t__bool pass_by_value;
    t__bool delayed;
    struct s__reflection__rf_type *data_type;
    struct s__sn__sn_simple_channel_m68983 *mvl_holder;
    struct s__sn__sn_simple_holder *put_value;
    struct s__sn__sn_simple_holder *get_value;
    t__uint get_tick_count;
    t__uint put_tick_count;
    t__uint now_tick_count;
    t__bool force;
    t__sn__put_flag_t put_flag;
    t__bool keep_mvl;
    struct s__sn__sn_simple_channel_mask *mask_inst;
    t__bool update_mask_flag;
} *t__sn__sn_simple_def_channel;
#define d__sn__sn_simple_def_channel 6752
typedef t__sn__sn_simple_def_channel t__sn_simple_def_channel;
#define d__sn_simple_def_channel d__sn__sn_simple_def_channel

/* line 20 "/vobs/specman/src/port_simple_channel.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_channel_m68983 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__mvl *put_mvl_value;
    struct s__l__sn__mvl *get_mvl_value;
    t__uint get_tick_count;
    struct s__e_core__any_simple_port *external_in_port;
} *t__sn__sn_simple_channel_mvl_holder;
#define d__sn__sn_simple_channel_mvl_holder 6768
typedef t__sn__sn_simple_channel_mvl_holder t__sn_simple_channel_mvl_holder;
#define d__sn_simple_channel_mvl_holder d__sn__sn_simple_channel_mvl_holder

/* line 79 "/vobs/specman/src/port_simple_value.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_holder {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int my_d;
} *t__sn__sn_simple_holder;
#define d__sn__sn_simple_holder 6733
typedef t__sn__sn_simple_holder t__sn_simple_holder;
#define d__sn_simple_holder d__sn__sn_simple_holder

/* line 4 "/vobs/specman/src/port_simple_channel.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_channel_mask {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_simple_def_channel *channel;
    t__uint element_size;
} *t__sn__sn_simple_channel_mask;
#define d__sn__sn_simple_channel_mask 6767
typedef t__sn__sn_simple_channel_mask t__sn_simple_channel_mask;
#define d__sn_simple_channel_mask d__sn__sn_simple_channel_mask

/* line 54 "/vobs/specman/src/tms_esi.e"  From 'struct definition' */
typedef struct s__inout__simple_port__int {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_simple_port_attri4173 *simple_port___attributes;
    struct s__sn__sn_simple_channel *channel;
    t__uint active_event_count;
} *t__inout__simple_port__int;
#define d__inout__simple_port__int 7315

/* line 136 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_unit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__vr_gsa__vr_gsa_adapter *adapter;
    struct s__e_core__semaphore *in_use;
    t__string application;
    t__bool misra_compliant_code;
    t__uint sn_gsa_message_str_length;
    t__bool trace_backdoor_access;
    t__bool default_external_type;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___clock_occ_l;
    struct s__sn__sn_event_struct *sn___clock_event_struct;
    struct s__sn__waiting_thread *sn___clock_thread;
    t__long_int sn___initialization_done_occ_l;
    struct s__sn__sn_event_struct *sn___initialization_done_event_struct;
    t__string sw_executable;
    t__string gnu_tools_path;
    t__string debug_info_command;
    t__string debug_information_file;
    struct s__l__string *sw_source_path;
    t__bool search_sw_source_files;
    t__bool gen_extern_decl_for_ports;
    struct s__vr_gsa_sw_debug__debug_info *debug_info;
    void *_dbserver_intf___ptr_padding[2];
    struct s__vr_gsa_sw_debug__vr_gs100931 *dbserver_intf;
} *t__vr_gsa__vr_gsa_unit;
#define d__vr_gsa__vr_gsa_unit 8968
typedef t__vr_gsa__vr_gsa_unit t__vr_gsa_unit;
#define d__vr_gsa_unit d__vr_gsa__vr_gsa_unit

/* line 143 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_adapter {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_adapter_unit_manager *adapter_unit_manager;
    struct s__sn__sn_adapter_bridge *adapter_abstract___bridge;
    t__bool can_master_specman;
    struct s__sn__sn_dynamic_call *sn_check_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_product___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_kind___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_put_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_hdl_scalar___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_hdl_string___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_create_driver___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_fetch_value___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_set_to_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_decanon_name___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_set_adapter_id_in_framework___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_append_full_name___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_register_cb_param___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_disable_cb_param___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_restore___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_log_write___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_screen_write___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_gui_mode___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_refresh_simulator_gui___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_screen_prompt___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_gets___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_set_ptr_sig_param_callback_data___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_specman_instance_path___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_hdl_path_separator___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_version___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_argv___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_create_sig_param_data_new_proc___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_create_sig_param_data___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_and_put___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_alocate_in_simulator___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_receive_cb_denali___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_decanon_name___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_framework_version___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_init_uninit_driver___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_gui_detach_actions___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_gui_attach_actions___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_push_fix_new_time_in_multiple_ticks_at_fractional_delay___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_push_notify_incorrect_new_time_at_fractional_delay___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_call___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_update_args___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_tcm_completed___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_call_stream___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_update_args_stream___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_tcm_completed_stream___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_interface_call___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_interface_tcm_call___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_interface_tcm_update___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_unilang_raise_trigger___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_initialize_adapter___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_elf___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_adapter_description___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_inform_state___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_quit_simulation___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_tick_start___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_tick_end___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_require_tick___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_advance___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_simulation_time___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_time_resolution___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_do_commands___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_release___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_emit___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_sensitize___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_desensitize___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_is_external_buffer_full___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_is_external_buffer_empty___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_int_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_int_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_long_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_long_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_string_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_string_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_struct_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_struct_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_int_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_int_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_long_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_long_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_string_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_string_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_struct_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_struct_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_flush___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_number_of_elements___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_notify_number_of_elements___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_number_of_free_elements___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_port_description___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_set_timer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_separator___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_static_and_variable_paths___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_release___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_app_check_port___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_check_port_pre_elab___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_find_assertions___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_add_assert_by_name___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_register_cb___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_instance_name___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_file_name___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_line_number___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_severity_level___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_msg___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_failure_count___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_enable___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_enable___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_remove_assertion_cb___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_restore_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_write_stubs___dynamic_call;
    struct s__vr_gsa__vr_gsa_unit *gsa_unit;
    t__bool initialized;
    struct s__l__vr_gsa__vr_gsa_basi100930 *simple_event_info_list;
    t__int updated_port_cnt;
    struct s__l__vr_gsa__vr_gsa_event99171 *event_info_list;
    struct s__l__vr_gsa__vr_gsa_metho99165 *method_info_list;
    struct s__l__vr_gsa__vr_gsa_metho99165 *out_method_info_list;
    struct s__l__vr_gsa__vr_gsa_metho99165 *in_method_info_list;
    t__uint sw_mailbox_address;
    t__uint sw_mailbox_size;
    t__uint sw_mailbox_usable_size;
    struct s__l__uint *sw_mailbox_ranges;
    t__uint sw_mailbox_in_mp;
    t__string sw_mailbox_name;
    t__uint sw_last_mailbox;
    struct s__e_core__time *sw_last_mailbox_time;
    t__bool sw_read_gsamailbox_file;
    t__uint init_flag_offset;
    t__uint checksum_offset;
    t__uint sw_error_offset;
    t__uint gsa_status;
    t__uint simple_port_ptrs_offset;
    t__uint num_enableable_ports;
    t__int mb_start;
    t__int mb_params;
    t__int mb_enable_words;
    t__int mb_enables;
    t__uint check_sum;
    struct s__e_core__any_method_port *active_method_port;
    struct s__vr_gsa__vr_gsa_mailbox *gsa_mb;
    struct s__l__untyped *in_mp_params;
    t__uint adapter_id;
    struct s__vr_gsa__vr_gsa_tp_unit *parent;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___watchpoint_reached_ev_occ_l;
    struct s__sn__sn_event_struct *sn___watchpoint_reached_ev_event_struct;
    struct s__sn__waiting_thread *sn___watchpoint_reached_ev_thread;
} *t__vr_gsa__vr_gsa_adapter;
#define d__vr_gsa__vr_gsa_adapter 8969
typedef t__vr_gsa__vr_gsa_adapter t__vr_gsa_adapter;
#define d__vr_gsa_adapter d__vr_gsa__vr_gsa_adapter

/* line 604 "/vobs/specman/src/shlibs.e"  From 'struct definition' */
typedef struct s__sn__sn_dynamic_call {
    t__int d__;
    t__int gen__;
    t__string lib_name;
    t__string call_name;
    t__sn__sn_lib_resolve_mode lazy_mode;
    t__sn__sn_lib_scope_mode scope_mode;
    t__string reserve_lib_name;
    t__string reserve_call_name;
    t__string dynamic_c___name;
    t__external_pointer dynamic_c___func_ptr;
    struct s__sn__sn_library *dynamic_c___lib_struct;
    struct s__l__untyped *dynamic_c___params_list;
} *t__sn__sn_dynamic_call;
#define d__sn__sn_dynamic_call 2153
typedef t__sn__sn_dynamic_call t__sn_dynamic_call;
#define d__sn_dynamic_call d__sn__sn_dynamic_call

/* line 41 "/vobs/specman/src/shlibs.e"  From 'struct definition' */
typedef struct s__sn__sn_library {
    t__int d__;
    t__int gen__;
    t__string name;
    t__external_pointer shlib_handler;
    t__bool loaded;
    t__bool close_upon_restore;
    t__sn__sn_lib_resolve_mode resolve;
    t__sn__sn_lib_scope_mode scope;
    struct s__l__sn__sn_dynamic_call *calls;
} *t__sn__sn_library;
#define d__sn__sn_library 2151
typedef t__sn__sn_library t__sn_library;
#define d__sn_library d__sn__sn_library

/* line 458 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_basic_p100932 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *packed_data;
    struct s__vr_gsa__vr_gsa_adapter *adapter;
    struct s__e_core__any_port *port;
    t__int port_id;
    t__string path;
    t__string realpath;
    struct s__vr_gsa_sw_debug__c_info *c_info;
    t__bool watchpoint;
    struct s__e_core__time *last_access_time;
    t__uint call_count;
    struct s__vr_gsa__vr_gsa_subject *subject;
    t__bool initialized;
    t__int updated_port_id;
    t__vr_gsa__vr_gsa_port_kind kind;
    t__uint address;
    t__int c_size;
    t__int size_in_bits;
    t__uint decl_size;
    t__bool c_signed;
    t__bool f__signed;
    t__bool static_address;
    struct s__vr_gsa__any_gsa_mapper *mapper;
} *t__vr_gsa__vr_gsa_basic_port_struct;
#define d__vr_gsa__vr_gsa_basic_port_struct 8973
typedef t__vr_gsa__vr_gsa_basic_port_struct t__vr_gsa_basic_port_struct;
#define d__vr_gsa_basic_port_struct d__vr_gsa__vr_gsa_basic_port_struct

/* line 46 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/get_dbg_info.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__c_info {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__file_info *file_info;
    t__string name;
    t__string address;
    t__string line_number;
} *t__vr_gsa_sw_debug__c_info;
#define d__vr_gsa_sw_debug__c_info 8947
typedef t__vr_gsa_sw_debug__c_info t__c_info;
#define d__c_info d__vr_gsa_sw_debug__c_info

/* line 62 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/get_dbg_info.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__file_info {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__vr_gsa_sw_debug__fu100920 *funcs;
    struct s__l__vr_gsa_sw_debug__id_info *statics;
} *t__vr_gsa_sw_debug__file_info;
#define d__vr_gsa_sw_debug__file_info 8948
typedef t__vr_gsa_sw_debug__file_info t__file_info;
#define d__file_info d__vr_gsa_sw_debug__file_info

/* line 69 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/get_dbg_info.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__func_info {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__file_info *file_info;
    t__string name;
    t__string address;
    t__string line_number;
    t__string return_type;
    struct s__l__vr_gsa_sw_debug__id_info *params;
    struct s__l__vr_gsa_sw_debug__id_info *statics;
    struct s__vr_gsa_sw_debug__id_info *c_return_type;
} *t__vr_gsa_sw_debug__func_info;
#define d__vr_gsa_sw_debug__func_info 8949
typedef t__vr_gsa_sw_debug__func_info t__func_info;
#define d__func_info d__vr_gsa_sw_debug__func_info

/* line 97 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/get_dbg_info.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__id_info {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__file_info *file_info;
    t__string name;
    t__string address;
    t__string line_number;
    t__string type;
    t__string selected_e_type;
    struct s__l__string *e_types;
} *t__vr_gsa_sw_debug__id_info;
#define d__vr_gsa_sw_debug__id_info 8950
typedef t__vr_gsa_sw_debug__id_info t__id_info;
#define d__id_info d__vr_gsa_sw_debug__id_info

/* line 25 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_observer.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_subject {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__vr_gsa__vr_gsa_observer *observer;
} *t__vr_gsa__vr_gsa_subject;
#define d__vr_gsa__vr_gsa_subject 8965
typedef t__vr_gsa__vr_gsa_subject t__vr_gsa_subject;
#define d__vr_gsa_subject d__vr_gsa__vr_gsa_subject

/* line 20 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_observer.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_observer {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vr_gsa__vr_gsa_observer;
#define d__vr_gsa__vr_gsa_observer 8964
typedef t__vr_gsa__vr_gsa_observer t__vr_gsa_observer;
#define d__vr_gsa_observer d__vr_gsa__vr_gsa_observer

/* line 748 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__any_gsa_mapper {
    t__int d__;
    t__int gen__;
    t__vr_gsa__mapping_kind_t kind;
    struct s__l__reflection__rf_type *e_types;
    struct s__l__string *c_types;
    struct s__l__vr_gsa__vr_gsa_mapp100933 *mapping_values;
    t__uint array_stride;
    t__uint byte_size;
    t__bool builtin;
    t__vr_gsa__mapping_behavior_t parameter_behavior;
    t__vr_gsa__mapping_behavior_t result_behavior;
} *t__vr_gsa__any_gsa_mapper;
#define d__vr_gsa__any_gsa_mapper 8984
typedef t__vr_gsa__any_gsa_mapper t__any_gsa_mapper;
#define d__any_gsa_mapper d__vr_gsa__any_gsa_mapper

/* line 705 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_mapping_value {
    t__int d__;
    t__int gen__;
    t__vr_gsa__vr_gsa_mapping_value_kind_t kind;
    t__uint offset;
    t__byte BYTE__value;
    t__uint__16 SHORT__value;
    t__uint INT__value;
    struct s__uint__64 *LONG__value;
    t__string STRING__value;
    struct s__vr_gsa__any_gsa_mapper *STRUCT__mapper;
    struct s__e_core__any_struct *STRUCT__value;
} *t__vr_gsa__vr_gsa_mapping_value;
#define d__vr_gsa__vr_gsa_mapping_value 8979
typedef t__vr_gsa__vr_gsa_mapping_value t__vr_gsa_mapping_value;
#define d__vr_gsa_mapping_value d__vr_gsa__vr_gsa_mapping_value

/* line 400 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__uint__64 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__uint__64;
#define d__uint__64 1401

/* line 620 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_event_p100934 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *packed_data;
    struct s__vr_gsa__vr_gsa_adapter *adapter;
    struct s__e_core__any_port *port;
    t__int port_id;
    t__string path;
    t__string realpath;
    struct s__vr_gsa_sw_debug__c_info *c_info;
    t__bool watchpoint;
    struct s__e_core__time *last_access_time;
    t__uint call_count;
    struct s__vr_gsa__vr_gsa_subject *subject;
    t__bool initialized;
    t__int updated_port_id;
    t__vr_gsa__vr_gsa_port_kind kind;
    t__uint address;
    t__int c_size;
    t__int size_in_bits;
    t__uint decl_size;
    t__bool c_signed;
    t__bool f__signed;
    t__bool static_address;
    struct s__vr_gsa__any_gsa_mapper *mapper;
    t__sn__event_port_edge edge;
    t__uint prev_value;
    t__uint value;
} *t__vr_gsa__vr_gsa_event_port_struct;
#define d__vr_gsa__vr_gsa_event_port_struct 8975
typedef t__vr_gsa__vr_gsa_event_port_struct t__vr_gsa_event_port_struct;
#define d__vr_gsa_event_port_struct d__vr_gsa__vr_gsa_event_port_struct

/* line 664 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_method_p99181 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *packed_data;
    struct s__vr_gsa__vr_gsa_adapter *adapter;
    struct s__e_core__any_port *port;
    t__int port_id;
    t__string path;
    t__string realpath;
    struct s__vr_gsa_sw_debug__c_info *c_info;
    t__bool watchpoint;
    struct s__e_core__time *last_access_time;
    t__uint call_count;
    struct s__vr_gsa__vr_gsa_subject *subject;
    struct s__reflection__rf_method *my_method;
    struct s__l__reflection__rf_parameter *my_parameters;
    struct s__reflection__rf_type *my_result_type;
    struct s__vr_gsa__any_gsa_mapper *result_mapper;
    t__uint arg_num;
    t__uint min_mbox_words;
    t__uint est_extra_mbox_words;
    struct s__vr_gsa__vr_gsa_method_p99444 *mp_c_info;
    t__uint total_param_word_size;
    t__uint result_mailbox_word_size;
    t__uint result_word_size;
    t__uint est_words_per_list;
    t__uint est_words_per_string;
    t__uint enable_word;
    t__uint enable_bit;
    struct s__vr_gsa__vr_gsa_mp_cov_struct *ct;
    struct s__l__untyped *params;
} *t__vr_gsa__vr_gsa_method_port_struct;
#define d__vr_gsa__vr_gsa_method_port_struct 8976
typedef t__vr_gsa__vr_gsa_method_port_struct t__vr_gsa_method_port_struct;
#define d__vr_gsa_method_port_struct d__vr_gsa__vr_gsa_method_port_struct

/* line 1268 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_method {
    t__int d__;
    t__int gen__;
    struct s__sn__method_descriptor *m_;
    struct s__l__reflection__rf_parameter *parameters_;
} *t__reflection__rf_method;
#define d__reflection__rf_method 1736
typedef t__reflection__rf_method t__rf_method;
#define d__rf_method d__reflection__rf_method

/* line 1352 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_parameter {
    t__int d__;
    t__int gen__;
    struct s__sn__local *l_;
    struct s__vr_gsa__any_gsa_mapper *mapper;
    t__string param_c_type;
    t__uint word_size;
    t__uint mailbox_word_size;
    t__uint mailbox_loc;
    t__vr_gsa__mapping_behavior_t behavior;
    t__uint data_loc;
} *t__reflection__rf_parameter;
#define d__reflection__rf_parameter 1737
typedef t__reflection__rf_parameter t__rf_parameter;
#define d__rf_parameter d__reflection__rf_parameter

/* line 838 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_types.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_method_p99444 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string result_type;
    struct s__l__string *param_types;
    struct s__l__string *param_names;
} *t__vr_gsa__vr_gsa_method_port_c_info;
#define d__vr_gsa__vr_gsa_method_port_c_info 8986
typedef t__vr_gsa__vr_gsa_method_port_c_info t__vr_gsa_method_port_c_info;
#define d__vr_gsa_method_port_c_info d__vr_gsa__vr_gsa_method_port_c_info

/* line 19 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_port_coverage.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_mp_cov_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___call_occ_l;
    struct s__sn__sn_event_struct *sn___call_event_struct;
    struct s__sn__waiting_thread *sn___call_thread;
    t__long_int sn___return_occ_l;
    struct s__sn__sn_event_struct *sn___return_event_struct;
    struct s__sn__waiting_thread *sn___return_thread;
    struct s__e_core__any_port *port;
    struct s__l__uint *call_vals;
    t__uint return_val;
} *t__vr_gsa__vr_gsa_mp_cov_struct;
#define d__vr_gsa__vr_gsa_mp_cov_struct 9037
typedef t__vr_gsa__vr_gsa_mp_cov_struct t__vr_gsa_mp_cov_struct;
#define d__vr_gsa_mp_cov_struct d__vr_gsa__vr_gsa_mp_cov_struct

/* line 32 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_method_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_method_port_attri4175 *method_port___attributes;
    struct s__sn__sn_method_channel *channel;
    struct s__sn__sn_method_port_even68955 *event_done_wrapper;
    struct s__sn__sn_any_functor *generic_client;
    struct s__e_core__pack_options *stream_pack_options;
    t__uint current_call_index;
    void *_my_adapter_config___ptr_padding[3];
    struct s__sn__sn_sv_adapter_unit_65587 *my_adapter_config;
    t__sn__is_sv_bounded_t__2 is_sv_bounded;
} *t__e_core__any_method_port;
#define d__e_core__any_method_port 1155
typedef t__e_core__any_method_port t__any_method_port;
#define d__any_method_port d__e_core__any_method_port

/* line 102 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_method_port_attri4175 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string hdl_convertor;
    t__sn__sync_mode_t sync_mode;
    t__string static_sensitivity;
    t__sn__parallel_mp_t parallel;
    t__string sv_package;
} *t__sn__sn_method_port_attributes;
#define d__sn__sn_method_port_attributes 1177
typedef t__sn__sn_method_port_attributes t__sn_method_port_attributes;
#define d__sn_method_port_attributes d__sn__sn_method_port_attributes

/* line 3 "/vobs/specman/src/port_method_interface_helper.e"  From 'struct definition' */
typedef struct s__sn__sn_method_channel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_port *ports;
    struct s__l__e_core__any_port *external_out_ports;
    struct s__l__e_core__any_port *external_in_ports;
    struct s__l__source_ref *put_source_refs;
    t__source_ref curr_source_ref;
    t__sn__sn_channel_type_t channel_type;
    t__uint cb_counter;
    struct s__l__sn__any_in_method_port *in_ports;
    struct s__l__sn__any_out_method_port *out_ports;
    struct s__reflection__rf_method *invoke_method;
    struct s__sn__sn_any_functor *client;
    struct s__l__untyped *channel_args;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    struct s__k__sn__sn_method_port_e69032 *wrappers;
} *t__sn__sn_method_channel;
#define d__sn__sn_method_channel 6819
typedef t__sn__sn_method_channel t__sn_method_channel;
#define d__sn_method_channel d__sn__sn_method_channel

/* line 448 "/vobs/specman/src/port_method.e"  From 'struct definition' */
typedef struct s__sn__any_in_method_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_method_port_attri4175 *method_port___attributes;
    struct s__sn__sn_method_channel *channel;
    struct s__sn__sn_method_port_even68955 *event_done_wrapper;
    struct s__sn__sn_any_functor *generic_client;
    struct s__e_core__pack_options *stream_pack_options;
    t__uint current_call_index;
    t__string last_error;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    struct s__sn__sn_sv_adapter_unit_65587 *my_adapter_config;
    t__sn__is_sv_bounded_t__2 is_sv_bounded;
} *t__sn__any_in_method_port;
#define d__sn__any_in_method_port 6833
typedef t__sn__any_in_method_port t__any_in_method_port;
#define d__any_in_method_port d__sn__any_in_method_port

/* line 751 "/vobs/specman/src/port_generic.e"  From 'struct definition' */
typedef struct s__sn__sn_method_port_even68955 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___done_occ_l;
    struct s__sn__sn_event_struct *sn___done_event_struct;
    struct s__sn__waiting_thread *sn___done_thread;
} *t__sn__sn_method_port_event_done_wrapper;
#define d__sn__sn_method_port_event_done_wrapper 6682
typedef t__sn__sn_method_port_event_done_wrapper t__sn_method_port_event_done_wrapper;
#define d__sn_method_port_event_done_wrapper d__sn__sn_method_port_event_done_wrapper

/* line 197 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_any_functor {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    struct s__e_core__any_method_port *last_calling_port;
    struct s__sn__any_in_method_port *ip;
    struct s__sn__sn_method_channel *channel;
} *t__sn__sn_any_functor;
#define d__sn__sn_any_functor 1182
typedef t__sn__sn_any_functor t__sn_any_functor;
#define d__sn_any_functor d__sn__sn_any_functor

/* line 64 "/vobs/specman/src/adapter_unit.e"  From 'struct definition' */
typedef struct s__sn__sn_sv_adapter_unit_65587 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__any_adapter_unit *my_adapter_units;
    t__string id_name;
    struct s__k__sn__sv_when_hierarch69133 *sv_when_hierarchies_stub_time;
    struct s__k__sv_stub__sn_sv_when_69135 *sv_when_hierarchies_run_time;
    struct s__k__sv_stub__sn_sv_wst_p69137 *sv_when_parents_run_time;
} *t__sn__sn_sv_adapter_unit_manager;
#define d__sn__sn_sv_adapter_unit_manager 7082
typedef t__sn__sn_sv_adapter_unit_manager t__sn_sv_adapter_unit_manager;
#define d__sn_sv_adapter_unit_manager d__sn__sn_sv_adapter_unit_manager

/* line 42 "/vobs/specman/src/sv_adapter_unit.e"  From 'struct definition' */
typedef struct s__sn__sv_when_hierarchy {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_like_struct *hierarchy_base;
    struct s__l__reflection__rf_when_s7796 *subtypes;
    struct s__l__reflection__rf_struct *parents;
    struct s__l__reflection__rf_field *flattened_when_fields;
} *t__sn__sv_when_hierarchy;
#define d__sn__sv_when_hierarchy 7104
typedef t__sn__sv_when_hierarchy t__sv_when_hierarchy;
#define d__sv_when_hierarchy d__sn__sv_when_hierarchy

/* line 757 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_when_subtype {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd_;
} *t__reflection__rf_when_subtype;
#define d__reflection__rf_when_subtype 1723
typedef t__reflection__rf_when_subtype t__rf_when_subtype;
#define d__rf_when_subtype d__reflection__rf_when_subtype

/* line 1290 "/vobs/specman/src/sv_adapter_reflection.e"  From 'struct definition' */
typedef struct s__sv_stub__sn_sv_when_subtypes {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *base;
    struct s__l__sn__subtype_descriptor *subtypes;
    struct s__l__sn__field *flattened_fields;
} *t__sv_stub__sn_sv_when_subtypes;
#define d__sv_stub__sn_sv_when_subtypes 7107
typedef t__sv_stub__sn_sv_when_subtypes t__sn_sv_when_subtypes;
#define d__sn_sv_when_subtypes d__sv_stub__sn_sv_when_subtypes

/* line 1296 "/vobs/specman/src/sv_adapter_reflection.e"  From 'struct definition' */
typedef struct s__sv_stub__sn_sv_wst_pare69139 {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *wst;
    struct s__sn__struct_descriptor *parent;
} *t__sv_stub__sn_sv_wst_parent_info;
#define d__sv_stub__sn_sv_wst_parent_info 7108
typedef t__sv_stub__sn_sv_wst_parent_info t__sn_sv_wst_parent_info;
#define d__sn_sv_wst_parent_info d__sv_stub__sn_sv_wst_parent_info

/* line 492 "/vobs/specman/src/port_method.e"  From 'struct definition' */
typedef struct s__sn__any_out_method_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_method_port_attri4175 *method_port___attributes;
    struct s__sn__sn_method_channel *channel;
    struct s__sn__sn_method_port_even68955 *event_done_wrapper;
    struct s__sn__sn_any_functor *generic_client;
    struct s__e_core__pack_options *stream_pack_options;
    t__uint current_call_index;
    struct s__l__untyped *esi_out_args;
    struct s__l__bit *esi_out_stream;
    void *_my_adapter_config___ptr_padding[1];
    struct s__sn__sn_sv_adapter_unit_65587 *my_adapter_config;
    t__sn__is_sv_bounded_t__2 is_sv_bounded;
} *t__sn__any_out_method_port;
#define d__sn__any_out_method_port 6834
typedef t__sn__any_out_method_port t__any_out_method_port;
#define d__any_out_method_port d__sn__any_out_method_port

/* line 713 "/vobs/specman/src/port_method.e"  From 'struct definition' */
typedef struct s__sn__sn_method_port_even60793 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___done_occ_l;
    struct s__sn__sn_event_struct *sn___done_event_struct;
    struct s__sn__waiting_thread *sn___done_thread;
    t__int call_id;
} *t__sn__sn_method_port_event_done_wrapper_for_call_id;
#define d__sn__sn_method_port_event_done_wrapper_for_call_id 6835
typedef t__sn__sn_method_port_event_done_wrapper_for_call_id t__sn_method_port_event_done_wrapper_for_call_id;
#define d__sn_method_port_event_done_wrapper_for_call_id d__sn__sn_method_port_event_done_wrapper_for_call_id

/* line 27 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_mailbox.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_mailbox {
    t__int d__;
    t__int gen__;
    struct s__l__vr_gsa__gsa_mailbox_state *gsa_mb_states;
} *t__vr_gsa__vr_gsa_mailbox;
#define d__vr_gsa__vr_gsa_mailbox 9004
typedef t__vr_gsa__vr_gsa_mailbox t__vr_gsa_mailbox;
#define d__vr_gsa_mailbox d__vr_gsa__vr_gsa_mailbox

/* line 22 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_mailbox.e"  From 'struct definition' */
typedef struct s__vr_gsa__gsa_mailbox_state {
    t__int d__;
    t__int gen__;
    t__vr_gsa__gsa_mailbox_state_t id;
    t__string name;
} *t__vr_gsa__gsa_mailbox_state;
#define d__vr_gsa__gsa_mailbox_state 9003
typedef t__vr_gsa__gsa_mailbox_state t__gsa_mailbox_state;
#define d__gsa_mailbox_state d__vr_gsa__gsa_mailbox_state

/* line 48 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_tp.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_tp_unit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__vr_gsa__vr_gsa_adapter *adapter;
    struct s__e_core__semaphore *in_use;
    t__string application;
    t__bool misra_compliant_code;
    t__uint sn_gsa_message_str_length;
    t__bool trace_backdoor_access;
    t__bool default_external_type;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___clock_occ_l;
    struct s__sn__sn_event_struct *sn___clock_event_struct;
    struct s__sn__waiting_thread *sn___clock_thread;
    t__long_int sn___initialization_done_occ_l;
    struct s__sn__sn_event_struct *sn___initialization_done_event_struct;
    t__string sw_executable;
    t__string gnu_tools_path;
    t__string debug_info_command;
    t__string debug_information_file;
    struct s__l__string *sw_source_path;
    t__bool search_sw_source_files;
    t__bool gen_extern_decl_for_ports;
    struct s__vr_gsa_sw_debug__debug_info *debug_info;
    struct s__in__simple_port__string *sn_sw_message_str;
    struct s__inout__simple_port__uint__8 *sn_sw_message_flg;
    struct s__vr_gsa_sw_debug__vr_gs100931 *dbserver_intf;
    struct s__vr_gsa__vr_gsa_debug_win *debug_win;
    t__bool init_complete;
    t__bool open_debugger_on_init;
    t__string name;
    struct s__vr_gsa__vr_gsa_subject *subject;
} *t__vr_gsa__vr_gsa_tp_unit;
#define d__vr_gsa__vr_gsa_tp_unit 9016
typedef t__vr_gsa__vr_gsa_tp_unit t__vr_gsa_tp_unit;
#define d__vr_gsa_tp_unit d__vr_gsa__vr_gsa_tp_unit

/* line 47 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__semaphore {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    struct s__l__sn__sn_thread_handle *u_queue;
    struct s__l__sn__sn_thread_handle *d_queue;
    t__bool started;
    t__bool wait_tcms_started;
    t__uint value;
    t__uint max_value;
    t__long_int sn___u_released_occ_l;
    struct s__sn__sn_event_struct *sn___u_released_event_struct;
    t__long_int sn___d_released_occ_l;
    struct s__sn__sn_event_struct *sn___d_released_event_struct;
} *t__e_core__semaphore;
#define d__e_core__semaphore 1161
typedef t__e_core__semaphore t__semaphore;
#define d__semaphore d__e_core__semaphore

/* line 128 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/get_dbg_info.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__debug_info {
    t__int d__;
    t__int gen__;
    struct s__l__vr_gsa_sw_debug__fi100926 *dbg_files;
    struct s__k__vr_gsa_sw_debug__ty100927 *type_sizes;
    t__bool data_valid;
    struct s__vr_dwarf__vr_dwarf_file *dwarf_file;
    struct s__k__vr_gsa_sw_debug__id100929 *c_to_e_type_map;
} *t__vr_gsa_sw_debug__debug_info;
#define d__vr_gsa_sw_debug__debug_info 8951
typedef t__vr_gsa_sw_debug__debug_info t__debug_info;
#define d__debug_info d__vr_gsa_sw_debug__debug_info

/* line 41 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/get_dbg_info.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__type_size {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string size;
} *t__vr_gsa_sw_debug__type_size;
#define d__vr_gsa_sw_debug__type_size 8946
typedef t__vr_gsa_sw_debug__type_size t__type_size;
#define d__type_size d__vr_gsa_sw_debug__type_size

/* line 351 "/vobs/specman/sn_lib/vr_dwarf/e/vr_dwarf_parse.e"  From 'struct definition' */
typedef struct s__vr_dwarf__vr_dwarf_file {
    t__int d__;
    t__int gen__;
    struct s__l__vr_dwarf__vr_dwarf_entry *entries;
    struct s__vr_dwarf__vr_dwarf_entry *root;
    struct s__l__string *other_languages;
    t__string cur_mem;
    t__string cur_par;
    t__uint pointer_byte_size;
    struct s__l__vr_dwarf__vr_dwarf_entry *converted_enums;
    struct s__l__vr_dwarf__vr_dwarf_entry *enums_to_convert;
    struct s__l__vr_dwarf__vr_dwarf_entry *converted_structs;
    struct s__l__vr_dwarf__vr_dwarf_entry *structs_to_convert;
} *t__vr_dwarf__vr_dwarf_file;
#define d__vr_dwarf__vr_dwarf_file 8940
typedef t__vr_dwarf__vr_dwarf_file t__vr_dwarf_file;
#define d__vr_dwarf_file d__vr_dwarf__vr_dwarf_file

/* line 29 "/vobs/specman/sn_lib/vr_dwarf/e/vr_dwarf_parse.e"  From 'struct definition' */
typedef struct s__vr_dwarf__vr_dwarf_entry {
    t__int d__;
    t__int gen__;
    t__string kind;
    t__uint compunit;
    t__uint level;
    t__uint cu_offset;
    struct s__l__vr_dwarf__vr_dwarf_100919 *attributes;
    struct s__vr_dwarf__vr_dwarf_entry *type_ref;
    t__uint global_offset;
    struct s__l__vr_dwarf__vr_dwarf_entry *children;
} *t__vr_dwarf__vr_dwarf_entry;
#define d__vr_dwarf__vr_dwarf_entry 8939
typedef t__vr_dwarf__vr_dwarf_entry t__vr_dwarf_entry;
#define d__vr_dwarf_entry d__vr_dwarf__vr_dwarf_entry

/* line 24 "/vobs/specman/sn_lib/vr_dwarf/e/vr_dwarf_parse.e"  From 'struct definition' */
typedef struct s__vr_dwarf__vr_dwarf_attribute {
    t__int d__;
    t__int gen__;
    t__string tag;
    t__string value;
} *t__vr_dwarf__vr_dwarf_attribute;
#define d__vr_dwarf__vr_dwarf_attribute 8938
typedef t__vr_dwarf__vr_dwarf_attribute t__vr_dwarf_attribute;
#define d__vr_dwarf_attribute d__vr_dwarf__vr_dwarf_attribute

/* line 296 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_tp.e"  From 'struct definition' */
typedef struct s__in__simple_port__string {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_simple_port_attri4173 *simple_port___attributes;
    struct s__sn__sn_simple_channel *channel;
    t__uint active_event_count;
} *t__in__simple_port__string;
#define d__in__simple_port__string 9018

/* line 300 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_tp.e"  From 'struct definition' */
typedef struct s__inout__simple_port__uint__8 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_simple_port_attri4173 *simple_port___attributes;
    struct s__sn__sn_simple_channel *channel;
    t__uint active_event_count;
} *t__inout__simple_port__uint__8;
#define d__inout__simple_port__uint__8 9019

/* line 201 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__vr_gs100931 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__vr_gsa__vr_gsa_unit *adapter_unit;
    t__uint debug_level;
    struct s__vr_gsa_sw_debug__vr_gs100945 *reg_intf;
    t__bool in_use;
    struct s__vr_gsa_sw_debug__vr_gs100946 *bp_intf;
    t__bool in_interactive_mode;
    struct s__sn__sn_dynamic_call *dbserver_set_debug___dynamic_call;
    struct s__sn__sn_dynamic_call *dbserver_start___dynamic_call;
    struct s__sn__sn_dynamic_call *dbserver_resume___dynamic_call;
    struct s__sn__sn_dynamic_call *dbserver_wait___dynamic_call;
} *t__vr_gsa_sw_debug__vr_gsa_dbserver_intf;
#define d__vr_gsa_sw_debug__vr_gsa_dbserver_intf 9026
typedef t__vr_gsa_sw_debug__vr_gsa_dbserver_intf t__vr_gsa_dbserver_intf;
#define d__vr_gsa_dbserver_intf d__vr_gsa_sw_debug__vr_gsa_dbserver_intf

/* line 123 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__vr_gs100945 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__vr_gsa_sw_debug__vr_gs100931 *dbserver;
    t__uint registers_num;
    struct s__l__vr_gsa_sw_debug__vr100947 *registers;
    t__string register_values;
} *t__vr_gsa_sw_debug__vr_gsa_dbserver_regs_intf;
#define d__vr_gsa_sw_debug__vr_gsa_dbserver_regs_intf 9024
typedef t__vr_gsa_sw_debug__vr_gsa_dbserver_regs_intf t__vr_gsa_dbserver_regs_intf;
#define d__vr_gsa_dbserver_regs_intf d__vr_gsa_sw_debug__vr_gsa_dbserver_regs_intf

/* line 112 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__vr_gsa99957 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    t__string name;
    t__uint id;
    t__bool pc;
    t__bool exception;
} *t__vr_gsa_sw_debug__vr_gsa_dbserver_register_unit;
#define d__vr_gsa_sw_debug__vr_gsa_dbserver_register_unit 9023
typedef t__vr_gsa_sw_debug__vr_gsa_dbserver_register_unit t__vr_gsa_dbserver_register_unit;
#define d__vr_gsa_dbserver_register_unit d__vr_gsa_sw_debug__vr_gsa_dbserver_register_unit

/* line 167 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver.e"  From 'struct definition' */
typedef struct s__vr_gsa_sw_debug__vr_gs100946 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__vr_gsa_sw_debug__vr_gs100931 *dbserver;
    t__bool in_use;
    t__uint max_bp_num;
    t__string bp_notifier_name;
    struct s__e_core__event_port *bp_occurrence_port;
    t__sn__vr_gsa_dbserver_bp_intf_state state;
    t__vr_gsa_sw_debug__vr_gsa_dbserver_exception_signal last_exception;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___bp_occurred_occ_l;
    struct s__sn__sn_event_struct *sn___bp_occurred_event_struct;
    struct s__sn__waiting_thread *sn___bp_occurred_thread;
    t__string stepi_activator_name;
    struct s__out__simple_port__bit *stepi_activate_port;
    t__string stepi_notifier_name;
    struct s__e_core__event_port *stepi_port;
    t__long_int sn___stepi_done_occ_l;
    struct s__sn__sn_event_struct *sn___stepi_done_event_struct;
    struct s__sn__waiting_thread *sn___stepi_done_thread;
    struct s__l__sn__vr_gsa_dbserver100949 *bp_units;
    struct s__vr_gsa_sw_debug__vr_gsa99957 *pc_unit;
} *t__vr_gsa_sw_debug__vr_gsa_dbserver_bp_intf;
#define d__vr_gsa_sw_debug__vr_gsa_dbserver_bp_intf 9025
typedef t__vr_gsa_sw_debug__vr_gsa_dbserver_bp_intf t__vr_gsa_dbserver_bp_intf;
#define d__vr_gsa_dbserver_bp_intf d__vr_gsa_sw_debug__vr_gsa_dbserver_bp_intf

/* line 26 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__event_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_event_port_attributes *event_port___attributes;
    struct s__sn__sn_event_channel *channel;
    t__bool inout_feedback;
    t__sn__sn_port_direction direction;
} *t__e_core__event_port;
#define d__e_core__event_port 1153
typedef t__e_core__event_port t__event_port;
#define d__event_port d__e_core__event_port

/* line 98 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_event_port_attributes {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__sn__event_port_edge edge;
} *t__sn__sn_event_port_attributes;
#define d__sn__sn_event_port_attributes 1175
typedef t__sn__sn_event_port_attributes t__sn_event_port_attributes;
#define d__sn_event_port_attributes d__sn__sn_event_port_attributes

/* line 118 "/vobs/specman/src/port_event.e"  From 'struct definition' */
typedef struct s__sn__sn_event_channel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_port *ports;
    struct s__l__e_core__any_port *external_out_ports;
    struct s__l__e_core__any_port *external_in_ports;
    struct s__l__source_ref *put_source_refs;
    t__source_ref curr_source_ref;
    t__sn__sn_channel_type_t channel_type;
    t__uint cb_counter;
    struct s__sn__sn_event_port_event68967 *event_done_wrapper;
    struct s__l__e_core__event_port *non_synthesized_input_ports;
    struct s__e_core__any_event_port *active_port;
} *t__sn__sn_event_channel;
#define d__sn__sn_event_channel 6809
typedef t__sn__sn_event_channel t__sn_event_channel;
#define d__sn_event_channel d__sn__sn_event_channel

/* line 768 "/vobs/specman/src/port_generic.e"  From 'struct definition' */
typedef struct s__sn__sn_event_port_event68967 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___done_occ_l;
    struct s__sn__sn_event_struct *sn___done_event_struct;
    struct s__sn__waiting_thread *sn___done_thread;
    t__sn__count external_emit_tick_counter;
    t__bool external_emit_is_active;
    struct s__sn__sn_event_channel *channel;
    struct s__l__e_core__any_event_port *active_ports;
} *t__sn__sn_event_port_event_done_wrapper;
#define d__sn__sn_event_port_event_done_wrapper 6686
typedef t__sn__sn_event_port_event_done_wrapper t__sn_event_port_event_done_wrapper;
#define d__sn_event_port_event_done_wrapper d__sn__sn_event_port_event_done_wrapper

/* line 20 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_event_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_event_port_attributes *event_port___attributes;
    struct s__sn__sn_event_channel *channel;
    t__bool inout_feedback;
} *t__e_core__any_event_port;
#define d__e_core__any_event_port 1151
typedef t__e_core__any_event_port t__any_event_port;
#define d__any_event_port d__e_core__any_event_port

/* line 10 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver_bp.e"  From 'struct definition' */
typedef struct s__out__simple_port__bit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_simple_port_attri4173 *simple_port___attributes;
    struct s__sn__sn_simple_channel *channel;
    t__uint active_event_count;
} *t__out__simple_port__bit;
#define d__out__simple_port__bit 9032

/* line 3 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver_bp.e"  From 'struct definition' */
typedef struct s__sn__vr_gsa_dbserver_bp_unit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    t__uint id;
    t__bool active;
    struct s__vr_gsa_sw_debug__vr_gs100931 *dbserver;
    t__string activator_name;
    struct s__out__simple_port__bit *activator_port;
    t__string address_name;
    struct s__out__simple_port__uint *address_port;
} *t__sn__vr_gsa_dbserver_bp_unit;
#define d__sn__vr_gsa_dbserver_bp_unit 9029
typedef t__sn__vr_gsa_dbserver_bp_unit t__vr_gsa_dbserver_bp_unit;
#define d__vr_gsa_dbserver_bp_unit d__sn__vr_gsa_dbserver_bp_unit

/* line 15 "/vobs/specman/sn_lib/vr_gsa_sw_debug/e/vr_gsa_gdbserver_bp.e"  From 'struct definition' */
typedef struct s__out__simple_port__uint {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_simple_port_attri4173 *simple_port___attributes;
    struct s__sn__sn_simple_channel *channel;
    t__uint active_event_count;
} *t__out__simple_port__uint;
#define d__out__simple_port__uint 9033

/* line 82 "/vobs/specman/sn_lib/vr_gsa/e/vr_gsa_debug_win.e"  From 'struct definition' */
typedef struct s__vr_gsa__vr_gsa_debug_win {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    t__string m_title;
    t__vt__vtx_element_state m_state;
    struct s__vt__vt_size *m_requested_size;
    struct s__vt__vt_location *m_requested_location;
    t__string m_window_kind;
    struct s__l__vt__vtx_action *m_actions;
    struct s__vt__vtx_component *m_primary_pane;
    struct s__vt__vtx_component *m_secondary_pane1;
    struct s__vt__vtx_component *m_secondary_pane2;
    struct s__vt__vtx_combobox *m_top_combobox;
    struct s__vt__vtx_component *m_window_header;
    struct s__vt__sni_vtx_jbase_window *j_me;
    struct s__vt__vtx_snorb_window_ac39957 *m_actual_attributes;
    struct s__vt__vtx_window_sni_helper *m_sni_helper;
    t__vt__vtx_window_layout_style m_window_layout_style;
    t__int m_primary_pane_ratio;
    t__int m_secondary1_pane_ratio;
    t__int m_primary_divider_location;
    t__int m_secondary_divider_location;
    struct s__vt__vtx_selectable_widget *m_selection_owner;
    struct s__k__string__it *m_initially_disabled_action_names;
    t__bool m_is_always_on_top;
    t__bool m_using_dnd;
    t__bool m_lockable;
    t__bool m_locked;
    struct s__vt__vt_statusbar *m_status_bar;
    struct s__vr_gsa__vr_gsa_tp_unit *parent;
    struct s__vt__vtx_panel *top_panel;
    t__uint my_x;
    t__uint my_y;
    t__uint memory_dump_start;
    t__uint memory_dump_size;
    struct s__vt__vtx_textfield *memory_start_field;
    struct s__vt__vtx_textfield *memory_size_field;
    struct s__vt__vtx_table *memory_dump_table;
} *t__vr_gsa__vr_gsa_debug_win;
#define d__vr_gsa__vr_gsa_debug_win 9036
typedef t__vr_gsa__vr_gsa_debug_win t__vr_gsa_debug_win;
#define d__vr_gsa_debug_win d__vr_gsa__vr_gsa_debug_win

/* line 17 "/vobs/specman/src/japp/shared_extra/shared_extra_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_size {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int width;
    t__int height;
} *t__vt__vt_size;
#define d__vt__vt_size 4012
typedef t__vt__vt_size t__vt_size;
#define d__vt_size d__vt__vt_size

/* line 11 "/vobs/specman/src/japp/shared_extra/shared_extra_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_location {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int x;
    t__int y;
} *t__vt__vt_location;
#define d__vt__vt_location 4011
typedef t__vt__vt_location t__vt_location;
#define d__vt_location d__vt__vt_location

/* line 1829 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_action {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string related_menu_name;
    t__string title;
    t__string tooltip;
    t__string command;
    t__string icon_file;
    t__string tool_bar_title;
    t__bool enabled;
    t__vt__vt_menu_action_kind kind;
    t__vt__vt_action_type type;
    t__bool has_menubar_button;
    struct s__l__string *items;
    t__int pos;
    t__bool f_dynamic;
    t__string name;
    t__bool selection_sensitive;
    t__bool checkable;
    t__string checked_icon;
    t__bool main_toolbar;
    t__bool selected;
} *t__vt__vtx_action;
#define d__vt__vtx_action 5180
typedef t__vt__vtx_action t__vtx_action;
#define d__vtx_action d__vt__vtx_action

/* line 156 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_component {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
} *t__vt__vtx_component;
#define d__vt__vtx_component 5108
typedef t__vt__vtx_component t__vtx_component;
#define d__vtx_component d__vt__vtx_component

/* line 1533 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_base_window {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    t__string m_title;
    t__vt__vtx_element_state m_state;
    struct s__vt__vt_size *m_requested_size;
    struct s__vt__vt_location *m_requested_location;
    t__string m_window_kind;
    struct s__l__vt__vtx_action *m_actions;
    struct s__vt__vtx_component *m_primary_pane;
    struct s__vt__vtx_component *m_secondary_pane1;
    struct s__vt__vtx_component *m_secondary_pane2;
    struct s__vt__vtx_combobox *m_top_combobox;
    struct s__vt__vtx_component *m_window_header;
    struct s__vt__sni_vtx_jbase_window *j_me;
    struct s__vt__vtx_snorb_window_ac39957 *m_actual_attributes;
    struct s__vt__vtx_window_sni_helper *m_sni_helper;
    t__vt__vtx_window_layout_style m_window_layout_style;
    t__int m_primary_pane_ratio;
    t__int m_secondary1_pane_ratio;
    t__int m_primary_divider_location;
    t__int m_secondary_divider_location;
    struct s__vt__vtx_selectable_widget *m_selection_owner;
    struct s__k__string__it *m_initially_disabled_action_names;
    t__bool m_is_always_on_top;
    t__bool m_using_dnd;
} *t__vt__vtx_base_window;
#define d__vt__vtx_base_window 5173
typedef t__vt__vtx_base_window t__vtx_base_window;
#define d__vtx_base_window d__vt__vtx_base_window

/* line 792 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_combobox {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__string *m_items;
    t__string m_selected_item;
    struct s__vt__sni_vtx_jcombobox *j_me;
    t__string m_label;
    t__vt__vtx_label_layout m_label_layout;
    t__bool m_editable;
    t__bool m_filter_ignores_case;
} *t__vt__vtx_combobox;
#define d__vt__vtx_combobox 5142
typedef t__vt__vtx_combobox t__vtx_combobox;
#define d__vtx_combobox d__vt__vtx_combobox

/* line 270 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_container {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
} *t__vt__vtx_container;
#define d__vt__vtx_container 5110
typedef t__vt__vtx_container t__vtx_container;
#define d__vtx_container d__vt__vtx_container

/* line 771 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jcombobox {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jcombobox;
#define d__vt__sni_vtx_jcombobox 5140
typedef t__vt__sni_vtx_jcombobox t__sni_vtx_jcombobox;
#define d__sni_vtx_jcombobox d__vt__sni_vtx_jcombobox

/* line 1686 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jbase_window {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jbase_window;
#define d__vt__sni_vtx_jbase_window 5177
typedef t__vt__sni_vtx_jbase_window t__sni_vtx_jbase_window;
#define d__sni_vtx_jbase_window d__vt__sni_vtx_jbase_window

/* line 1689 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_snorb_window_ac39957 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string id;
    struct s__vt__sni_vtx_jbase_window *sni_base_window;
} *t__vt__vtx_snorb_window_actual_attributes;
#define d__vt__vtx_snorb_window_actual_attributes 5178
typedef t__vt__vtx_snorb_window_actual_attributes t__vtx_snorb_window_actual_attributes;
#define d__vtx_snorb_window_actual_attributes d__vt__vtx_snorb_window_actual_attributes

/* line 1678 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_window_sni_helper {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__vt__vtx_base_window *m_window;
} *t__vt__vtx_window_sni_helper;
#define d__vt__vtx_window_sni_helper 5176
typedef t__vt__vtx_window_sni_helper t__vtx_window_sni_helper;
#define d__vtx_window_sni_helper d__vt__vtx_window_sni_helper

/* line 1009 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_selectable_widget {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__string *m_default_popup_action_names;
} *t__vt__vtx_selectable_widget;
#define d__vt__vtx_selectable_widget 5154
typedef t__vt__vtx_selectable_widget t__vtx_selectable_widget;
#define d__vtx_selectable_widget d__vt__vtx_selectable_widget

/* line 5006 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_statusbar {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__vt__vt_statusbar_pane *panes;
    t__string expandable_status_pane_name;
    struct s__vt__vt_progress_pane *progress_pane;
    t__bool has_content_type_pane;
} *t__vt__vt_statusbar;
#define d__vt__vt_statusbar 4898
typedef t__vt__vt_statusbar t__vt_statusbar;
#define d__vt_statusbar d__vt__vt_statusbar

/* line 5020 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_statusbar_pane {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int width;
    t__vt__vt_statusbar_pane_scope scope;
    struct s__vt__status_pane_modifya37345 *data;
} *t__vt__vt_statusbar_pane;
#define d__vt__vt_statusbar_pane 4900
typedef t__vt__vt_statusbar_pane t__vt_statusbar_pane;
#define d__vt_statusbar_pane d__vt__vt_statusbar_pane

/* line 5116 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__status_pane_modifya37345 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string name;
    t__string text;
    t__string image;
    t__string tooltip;
    t__vt__vt_color bg_color;
    t__vt__vt_color fg_color;
    struct s__l__vt__jvt_action *jactions;
    t__string jaction;
} *t__vt__status_pane_modifyable_data;
#define d__vt__status_pane_modifyable_data 4901
typedef t__vt__status_pane_modifyable_data t__status_pane_modifyable_data;
#define d__status_pane_modifyable_data d__vt__status_pane_modifyable_data

/* line 632 "/vobs/specman/src/japp/vt/vt_menubar_defs.e"  From 'struct definition' */
typedef struct s__vt__jvt_action {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__vt__vt_menu_component_kind kind;
    t__string name;
    t__string title;
    t__int mnemonic_key;
    t__vt__vt_action_kind action_kind;
    t__string toolbar_title;
    t__string tooltip;
    t__string icon;
    t__string selected_icon;
    t__string command;
    t__int accelerator_key;
    t__bool enabled;
    t__bool selected;
    t__string group_name;
    t__vt__vt_action_special_attribute special;
} *t__vt__jvt_action;
#define d__vt__jvt_action 5071
typedef t__vt__jvt_action t__jvt_action;
#define d__jvt_action d__vt__jvt_action

/* line 5012 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_progress_pane {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int width;
    t__string text;
    t__vt__vt_color bar_color;
    t__string bar_label;
    t__bool is_rabbit;
} *t__vt__vt_progress_pane;
#define d__vt__vt_progress_pane 4899
typedef t__vt__vt_progress_pane t__vt_progress_pane;
#define d__vt_progress_pane d__vt__vt_progress_pane

/* line 431 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_panel {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
} *t__vt__vtx_panel;
#define d__vt__vtx_panel 5118
typedef t__vt__vtx_panel t__vtx_panel;
#define d__vtx_panel d__vt__vtx_panel

/* line 428 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jpanel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jpanel;
#define d__vt__sni_vtx_jpanel 5117
typedef t__vt__sni_vtx_jpanel t__sni_vtx_jpanel;
#define d__sni_vtx_jpanel d__vt__sni_vtx_jpanel

/* line 887 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_textfield {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__vt__sni_vtx_jtextfield *j_me;
    t__bool m_editable;
    t__string m_text;
    t__bool m_using_key_listener;
    t__string m_label;
    t__vt__vtx_label_layout m_label_layout;
} *t__vt__vtx_textfield;
#define d__vt__vtx_textfield 5146
typedef t__vt__vtx_textfield t__vtx_textfield;
#define d__vtx_textfield d__vt__vtx_textfield

/* line 870 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jtextfield {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jtextfield;
#define d__vt__sni_vtx_jtextfield 5144
typedef t__vt__sni_vtx_jtextfield t__sni_vtx_jtextfield;
#define d__sni_vtx_jtextfield d__vt__sni_vtx_jtextfield

/* line 1414 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_table {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__string *m_default_popup_action_names;
    t__string m_title;
    t__string m_most_common_action_name;
    t__string m_corner_action_name;
    struct s__k__vt__vtx_table_col__m_name *m_cols;
    t__bool m_using_filter_panel;
    t__string m_initial_filtered_col_name;
    struct s__k__vt__vtx_table_row__m_id *m_rows;
    struct s__vt__vtx_table_row *m_selected_row;
    t__bool m_using_table_header;
    t__int m_row_height;
    t__bool m_using_horizontal_grid;
    t__bool m_using_vertical_grid;
    struct s__vt__sni_vtx_jtable *j_me;
} *t__vt__vtx_table;
#define d__vt__vtx_table 5172
typedef t__vt__vtx_table t__vtx_table;
#define d__vtx_table d__vt__vtx_table

/* line 1342 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_table_col {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_table *m_table;
    t__string m_title;
    t__string m_tooltip;
    t__string m_icon;
    t__bool m_sortable;
    t__vt__vtx_table_col_kind m_kind;
    t__int m_col_num;
    t__int m_width;
    t__bool m_is_left_align;
    t__bool m_is_only_icon_width;
} *t__vt__vtx_table_col;
#define d__vt__vtx_table_col 5170
typedef t__vt__vtx_table_col t__vtx_table_col;
#define d__vtx_table_col d__vt__vtx_table_col

/* line 1302 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_table_row {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_table *m_table;
    t__string m_text;
    struct s__vt__vt_lnf_props *m_lnf;
    struct s__l__string *m_actions_to_disable;
    struct s__l__string *m_cells;
    struct s__l__string *m_popup_action_names;
} *t__vt__vtx_table_row;
#define d__vt__vtx_table_row 5169
typedef t__vt__vtx_table_row t__vtx_table_row;
#define d__vtx_table_row d__vt__vtx_table_row

/* line 122 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_lnf_props {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__vt__vt_color fg;
    t__vt__vt_color bg;
    t__vt__vt_font_kind font_kind;
    t__string tooltip;
} *t__vt__vt_lnf_props;
#define d__vt__vt_lnf_props 2545
typedef t__vt__vt_lnf_props t__vt_lnf_props;
#define d__vt_lnf_props d__vt__vt_lnf_props

/* line 1299 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jtable {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jtable;
#define d__vt__sni_vtx_jtable 5168
typedef t__vt__sni_vtx_jtable t__sni_vtx_jtable;
#define d__sni_vtx_jtable d__vt__sni_vtx_jtable

/* line 954 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__session {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int num_of_errors;
    t__string last_save_file_name;
    t__e_core__next_prev_op next_prev_op;
    t__bool retain_state_across_restore;
    t__uint pid;
    t__bool do_not_save_raw;
    t__uint currently_running_adapter;
    struct s__l__bit *indexing_list;
    t__bool any_struct_run_order;
    t__bool show_calls_on_error;
    struct s__sn__script_instance *last_si;
    struct s__sn__script_instance *current_si;
    t__sn__test_phase test_phase;
    t__sn__sn_precise_test_phase precise_test_phase;
    t__sn__on_event_type pre_event;
    struct s__sn__struct_descriptor *parent_sd;
    t__string method_name;
    t__string output_string;
    t__string signal_name;
    t__bool during_run_dfs;
    struct s__k__e_core__any_struct__it *new_on_run_dfs;
    struct s__k__sn__seed_domain__name *seed_domains;
    t__bool run_in_progress;
    t__bool test_command_in_progress;
    t__bool global_extract_in_progress;
    t__bool global_check_in_progress;
    t__bool end_of_test;
    t__bool do_automatic_check;
    t__bool do_only_dump_cover_file;
    t__bool some_script_started;
    t__sn__run_status run_status;
    t__sn__count tick_counter;
    t__long_int long_tick_counter;
    t__sn__count update_count;
    t__sn__count update_count_simulator;
    t__bool sim_read_traced;
    t__bool sim_write_traced;
    t__bool tcm_state_traced;
    t__bool output_traced;
    t__int num_of_dut_errors;
    t__int num_of_dut_warnings;
    t__bool check_failed;
    t__bool check_ok;
    struct s__sn__sn_config *sn_config;
    struct s__sn__config_all *config;
    struct s__l__string *refresh_options;
    struct s__l__sn__configuration_cat4170 *configuration_categories;
    struct s__sn__sn_long_time *longTime;
    struct s__l__uint *timers_low;
    struct s__l__uint *timers_high;
    struct s__sn__sn_trace_port_flags *trace_port_flags;
    t__source_ref curr_expr_src_ref;
    struct s__l__sn__sn_gc_debug_thing *gc_debug_things;
    t__bool some_gc_debug_thing_is_on_before_gc;
    t__bool some_gc_debug_thing_is_on_after_gc;
    t__bool some_gc_debug_thing_is_on_completely_after_gc;
    t__imp_enum_sn__session__gc_action_time gc_action_time;
    struct s__sn__sn_gc_debug_predicate *gc_p_before;
    struct s__sn__sn_gc_debug_predicate *gc_p_after;
    struct s__sn__sn_gc_debug_predicate *gc_p_completely_after;
    struct s__l__sn__esv_info_s *esv_info_list;
    struct s__l__string *top_module_list;
    t__bool TEs_at_sim;
    t__bool new_time_started;
    t__bool on_event_exist;
    t__bool tcm_wait_traced;
    t__bool port_at_sim;
    t__int sn_cmd_counter_in_tick;
    t__int last_sn_cmd_idx_on_prompt;
    t__bool pass_pre_tick_check;
    t__bool in_specman_tick;
    t__long_int sn___start_of_test_occ_l;
    struct s__sn__sn_event_struct *sn___start_of_test_event_struct;
    t__uint user_time;
    t__uint system_time;
    t__string host_name;
    t__uint specman_memory;
    t__uint break_on_alloc_prev_stop;
    t__uint break_on_alloc_curr_stop;
    t__uint break_on_alloc_next_stop;
    t__int break_on_alloc_step_size;
    t__int break_on_alloc_counter;
    t__string break_on_alloc_def_step_size_str;
    t__bool trace_bind_flag;
    t__bool trace_port_uni_flag;
    t__bool after_inform_state_run;
    t__bool back_compat_no_nbasync_old;
    t__bool inside_connect_ports_flag;
    t__bool trace_adapter_unit_flag;
    t__long_int sn___tcm_start_occ_l;
    struct s__sn__sn_event_struct *sn___tcm_start_event_struct;
    t__long_int sn___tcm_end_occ_l;
    struct s__sn__sn_event_struct *sn___tcm_end_event_struct;
    t__long_int sn___tcm_call_occ_l;
    struct s__sn__sn_event_struct *sn___tcm_call_event_struct;
    t__long_int sn___tcm_return_occ_l;
    struct s__sn__sn_event_struct *sn___tcm_return_event_struct;
    t__long_int sn___call_occ_l;
    struct s__sn__sn_event_struct *sn___call_event_struct;
    t__long_int sn___return_occ_l;
    struct s__sn__sn_event_struct *sn___return_event_struct;
    t__long_int sn___cvl_call_occ_l;
    struct s__sn__sn_event_struct *sn___cvl_call_event_struct;
    t__long_int sn___cvl_return_occ_l;
    struct s__sn__sn_event_struct *sn___cvl_return_event_struct;
    t__long_int sn___output_occ_l;
    struct s__sn__sn_event_struct *sn___output_event_struct;
    t__long_int sn___line_occ_l;
    struct s__sn__sn_event_struct *sn___line_event_struct;
    t__source_ref source_ref;
    struct s__e_core__base_struct *parent_struct;
    t__long_int sn___tcm_wait_occ_l;
    struct s__sn__sn_event_struct *sn___tcm_wait_event_struct;
    t__long_int sn___tcm_state_occ_l;
    struct s__sn__sn_event_struct *sn___tcm_state_event_struct;
    t__string from_state;
    t__string to_state;
    t__string signal_translation;
    t__string signal_val;
    t__long_int sn___sim_read_occ_l;
    struct s__sn__sn_event_struct *sn___sim_read_event_struct;
    t__long_int sn___sim_write_occ_l;
    struct s__sn__sn_event_struct *sn___sim_write_event_struct;
    t__long_int sn___check_occ_l;
    struct s__sn__sn_event_struct *sn___check_event_struct;
    t__int check_index;
    t__long_int sn___dut_error_occ_l;
    struct s__sn__sn_event_struct *sn___dut_error_event_struct;
    t__long_int sn___dut_err_occ_l;
    struct s__sn__sn_event_struct *sn___dut_err_event_struct;
    struct s__l__sn__index *special_events;
    t__sn__index max_special;
    t__long_int sn___end_of_test_occ_l;
    struct s__sn__sn_event_struct *sn___end_of_test_event_struct;
    t__long_int sn___interactive_coverage_occ_l;
    struct s__sn__sn_event_struct *sn___interactive_coverage_event_struct;
    t__long_int sn___events_occ_l;
    struct s__sn__sn_event_struct *sn___events_event_struct;
    t__bool alloc_counting;
    struct s__int__2147483647 *alloc_counter;
    struct s__sn__sn_uintptr_t *alloc_counter_tmp;
} *t__e_core__session;
#define d__e_core__session 80
typedef t__e_core__session t__session;
#define d__session d__e_core__session

/* line 1318 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__script_instance {
    t__int d__;
    t__int gen__;
    struct s__sn__method *sn_method;
    struct s__l__untyped *sn_values;
    struct s__sn__activation_record *sn_caller;
    struct s__sn__routine *sn_routine;
    t__int sn_call_num;
    t__int sn_sub_call_num;
    t__source_ref sn_lock_source_ref;
    struct s__e_core__reparse_source_ref *sn_lock_reparse_source_ref;
    t__bool sn_already_stopped;
    struct s__l__int *sn_list_of_traced_req_ids;
    t__int sn_next_stop_sub_call;
    t__int sn_next_stop_sub_return;
    struct s__sn__n__action *sn_current_action;
    struct s__e_core__any_struct *sn_owner;
    t__bool is_very_first;
    t__routine_pointer return_point__routine;
    struct s__sn__sn_tcm_flow_graph *return_point__flow_graph;
    t__int return_point__state;
    struct s__sn__script_instance *sn_proto_si;
} *t__sn__script_instance;
#define d__sn__script_instance 219
typedef t__sn__script_instance t__script_instance;
#define d__script_instance d__sn__script_instance

/* line 602 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__sn_config {
    t__int d__;
    t__int gen__;
    t__bool already_validate;
} *t__sn__sn_config;
#define d__sn__sn_config 1404
typedef t__sn__sn_config t__sn_config;
#define d__sn_config d__sn__sn_config

/* line 452 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__config_all {
    t__int d__;
    t__int gen__;
    struct s__sn__print_config_options *print;
    struct s__sn__cover_config_options *cover;
    struct s__sn__gen_config_options *gen;
    struct s__sn__run_config_options *run;
    struct s__sn__memory_config_options *memory;
    struct s__sn__misc_config_options *misc;
    struct s__sn__debug_config_options *debug;
    struct s__sn__gui_config_options *gui;
    struct s__sn__wave_config_options *wave;
    struct s__sn__databrowser_config_o4212 *databrowser;
    struct s__sn__simulation_config_op4213 *simulation;
    struct s__sn__ies_config_options *ies;
    struct s__sn__lang_config_options *lang;
    struct s__sn__eanalyzer_config_options *eanalyzer;
} *t__sn__config_all;
#define d__sn__config_all 1403
typedef t__sn__config_all t__config_all;
#define d__config_all d__sn__config_all

/* line 119 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__print_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__e_core__po_radix radix;
    t__int items;
    t__int list_lines;
    t__int list_from;
    t__string title;
    t__bool raw_print;
    t__bool window;
    t__bool list_is_horizontal;
    t__bool list_starts_on_right;
    t__int list_grouping;
    t__bool list_of_bit_in_hex;
    t__e_core__radix list_index_radix;
    t__bool list_end_flag;
    t__bool full;
    t__int source_lines;
    t__int line_size;
    t__e_core__name_qualification_t type_name_qualification;
    t__sn__scale_units scale;
    t__int event_chart_headers_width;
    t__int event_chart_headers_event_percent;
    t__bool wide;
} *t__sn__print_config_options;
#define d__sn__print_config_options 1366
typedef t__sn__print_config_options t__print_config_options;
#define d__print_config_options d__sn__print_config_options

/* line 125 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__cover_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__int at_least_multiplier;
    t__sn__sn_cvr_grading_formula grading_formula;
    t__sn__sn_cfg_cover_mode mode;
    t__bool check_illegal_immediately;
    t__bool verbose_interface;
    t__int max_int_buckets;
    t__int absolute_max_buckets;
    t__sn__show_mode show_mode;
    t__bool sorted;
    t__bool show_file_names;
    t__bool show_sub_holes;
    t__bool show_instances_only;
    t__bool show_partial_grade;
    t__string dir;
    t__string file_name;
    t__string test_name;
    t__string run_name;
    t__string tag_name;
    t__sn__sn_cvr_cost_type ranking_cost;
    t__int ranking_precision;
    t__sn__sn_cover_gui_sync_mode gui_sync_mode;
    t__int max_gui_buckets;
    t__bool cover_enums_by_numeric_val;
    t__bool optimize_read_cover;
    t__int max_item_valid_space;
    t__int absolute_item_valid_space;
    t__int max_total_valid_space;
    t__int absolute_total_valid_space;
    t__bool auto_cover_events;
    t__bool auto_ranges;
    t__int printed_items_num;
    t__bool dump_failed_runs_data;
    t__bool collect_checks_expects;
    t__sn__sn_cvr_code_coverage_mode block_coverage_mode;
    t__sn__sn_cvr_db_format database_format;
    t__sn__sn_cvr_model_format write_model;
    t__string model_name;
    t__string model_dir;
    struct s__e_core__real *real_tolerance;
    t__bool new_engine;
    t__string surecov_config;
} *t__sn__cover_config_options;
#define d__sn__cover_config_options 1367
typedef t__sn__cover_config_options t__cover_config_options;
#define d__cover_config_options d__sn__cover_config_options

/* line 130 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__gen_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__int seed;
    t__int default_max_list_size;
    t__int absolute_max_list_size;
    t__int max_depth;
    t__int max_structs;
    t__bool warn;
    t__sn__sn_show_on_trace show_on_trace;
    t__int show_repeats;
    t__bool reorder_fields;
    t__bool resolve_cycles;
    t__bool check_unsatisfied_cons;
    t__uint long_max_width;
    t__sn__sn_fast_gen_t determinants_before_subtypes;
    t__int nesting;
    t__bool prefix;
    t__bool reduction_colors;
    t__uint max_range_strlen;
    t__bool collect_gen;
    t__bool static_analysis_opt;
    t__bool bool_exp_is_bidir;
    t__bool unit_reference_rule;
    t__bool list_constraint_is_bidir;
    t__bool disable_clear_sa_lists;
    t__bool improve_correlated_random;
    t__bool debug_in_try;
    t__bool automatic_tc_util;
    t__string tc_util_test_name;
    t__bool random_or;
    t__bool random_soft;
    t__sn__gen_g5_op_mode_t g5_op_mode;
    t__bool gen_internals;
    t__bool gc_cleanup;
    t__bool exclude_contradicting_subtypes;
    t__bool handle_constraints_from_above;
    t__bool check_constraints_under_pointers;
    t__bool constraint_monitor;
    t__bool del_old_dbg_info;
    t__bool show_vals_in_tree;
    t__bool default_list_size;
    t__sn__gotf_sa_mode_t gotf_sa_mode;
    t__sn__solvability_mode_t solvability_mode;
    t__sn__gen_technology_t default_generator;
    t__sn__generator_mode_t generator_mode;
    t__sn__gen_technology_t default_solver_mode;
    t__bool global_transformation;
    t__uint lace_size_warn_threshold;
    t__uint global_backtrack_limit;
    t__uint local_backtrack_limit;
    t__uint propagations_limit;
    t__uint max_consecutive_rollbacks;
    t__uint max_rows_in_table;
    t__uint max_cfss_in_group;
    t__uint max_list_items_in_group;
    t__sn__select_semantic_t select_semantic;
    t__bool hide_internal_lint_warnings;
    struct s__l__gen__gen_mm_cmd *gen_cmd_list;
    struct s__k__gen__gen_mm_rf_port_56799 *hash_ports_ancestor;
    struct s__k__gen__gen_mm_rf_struc56800 *rf_struct_constraint_list;
} *t__sn__gen_config_options;
#define d__sn__gen_config_options 1368
typedef t__sn__gen_config_options t__gen_config_options;
#define d__gen_config_options d__sn__gen_config_options

/* line 124 "/vobs/specman/src/gen/gen_mm_manager_parsing_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_mm_cmd {
    t__int d__;
    t__int gen__;
    t__bool is_user_command;
    t__sn__gen_technology_t solver;
    t__string str;
} *t__gen__gen_mm_cmd;
#define d__gen__gen_mm_cmd 6647
typedef t__gen__gen_mm_cmd t__gen_mm_cmd;
#define d__gen_mm_cmd d__gen__gen_mm_cmd

/* line 38 "/vobs/specman/src/gen/gen_mm_manager_parsing_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_mm_rf_port_por56898 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_port *a_port;
    struct s__reflection__rf_struct *ancestor;
} *t__gen__gen_mm_rf_port_ports_ancestor_hash;
#define d__gen__gen_mm_rf_port_ports_ancestor_hash 6645
typedef t__gen__gen_mm_rf_port_ports_ancestor_hash t__gen_mm_rf_port_ports_ancestor_hash;
#define d__gen_mm_rf_port_ports_ancestor_hash d__gen__gen_mm_rf_port_ports_ancestor_hash

/* line 3152 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_port {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *my_rf_struct;
} *t__reflection__rf_port;
#define d__reflection__rf_port 1767
typedef t__reflection__rf_port t__rf_port;
#define d__rf_port d__reflection__rf_port

/* line 44 "/vobs/specman/src/gen/gen_mm_manager_parsing_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_mm_rf_struct_s56899 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *a_struct;
    struct s__l__reflection__st_constraint *st_pgen_list;
    struct s__l__reflection__st_constraint *st_igen_list;
} *t__gen__gen_mm_rf_struct_st_constraint_list;
#define d__gen__gen_mm_rf_struct_st_constraint_list 6646
typedef t__gen__gen_mm_rf_struct_st_constraint_list t__gen_mm_rf_struct_st_constraint_list;
#define d__gen_mm_rf_struct_st_constraint_list d__gen__gen_mm_rf_struct_st_constraint_list

/* line 136 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__run_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    struct s__sn__sn_intptr_t *tick_max;
    t__string error_command;
    t__bool use_manual_tick;
    t__bool quit_on_stop;
    t__sn__t_exit_on exit_on;
    t__bool finish_on_error;
    t__bool error_is_fatal;
    t__bool fixed_run_order_6_0;
    t__bool compare_run_order;
} *t__sn__run_config_options;
#define d__sn__run_config_options 1369
typedef t__sn__run_config_options t__run_config_options;
#define d__run_config_options d__sn__run_config_options

/* line 399 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__sn_intptr_t {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__sn__sn_intptr_t;
#define d__sn__sn_intptr_t 1400
typedef t__sn__sn_intptr_t t__sn_intptr_t;
#define d__sn_intptr_t d__sn__sn_intptr_t

/* line 141 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__memory_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__sn__auto_gc_setting_policy automatic_gc_settings;
    struct s__sn__sn_uintptr_t *optimal_process_size;
    t__bool notify_gc_settings;
    struct s__sn__sn_uintptr_t *gc_threshold;
    struct s__sn__sn_intptr_t *gc_increment;
    struct s__sn__sn_uintptr_t *otf_threshold;
    struct s__sn__sn_intptr_t *otf_increment;
    struct s__sn__sn_uintptr_t *max_size;
    struct s__sn__sn_uintptr_t *absolute_max_size;
    t__bool print_msg;
    t__bool print_otf_msg;
    t__bool retain_printed_structs;
    t__bool retain_trace_structs;
    t__uint max_retained_structs;
    t__bool disable_disk_based_gc;
    struct s__sn__sn_intptr_t *log_interval;
    t__bool check_consistency;
    t__bool show_mem_raw;
    t__bool debug_thread_leak;
    t__bool print_process_size;
    t__bool print_debug_msgs;
    t__uint check_before_gc_overhead;
    t__uint expand_stack;
    t__string pre_gc_commands;
    t__string post_gc_commands;
} *t__sn__memory_config_options;
#define d__sn__memory_config_options 1370
typedef t__sn__memory_config_options t__memory_config_options;
#define d__memory_config_options d__sn__memory_config_options

/* line 400 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__sn_uintptr_t {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__sn__sn_uintptr_t;
#define d__sn__sn_uintptr_t 1402
typedef t__sn__sn_uintptr_t t__sn_uintptr_t;
#define d__sn_uintptr_t d__sn__sn_uintptr_t

/* line 147 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__misc_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__string pre_specman_path;
    t__string post_specman_path;
    t__bool warn;
    t__int max_esi_packed_size;
    t__bool temporal_new_pkg;
    t__bool cover_new_pkg;
    t__bool open_support_page;
    t__string support_info_file;
    t__bool synthesized;
    t__bool spextreme;
    t__bool ports_data_pass_by_pointer;
    t__int esv_compression_level;
} *t__sn__misc_config_options;
#define d__sn__misc_config_options 1371
typedef t__sn__misc_config_options t__misc_config_options;
#define d__misc_config_options d__sn__misc_config_options

/* line 153 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__debug_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__int watch_list_items;
    t__sn__macro_debug_mode macro_debug_mode;
    t__bool hide_untraceable_events;
    t__imp_enum_sn__debug_config_options__macro_expansion macro_expansion;
} *t__sn__debug_config_options;
#define d__sn__debug_config_options 1372
typedef t__sn__debug_config_options t__debug_config_options;
#define d__debug_config_options d__sn__debug_config_options

/* line 159 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__gui_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__bool auto_scroll;
    t__bool use_help_browser;
    t__bool new_help_window;
    t__int lines_num_in_source_viewer;
    t__bool use_table_windows;
} *t__sn__gui_config_options;
#define d__sn__gui_config_options 1373
typedef t__sn__gui_config_options t__gui_config_options;
#define d__gui_config_options d__sn__gui_config_options

/* line 165 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__wave_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__string dumpfile_dir;
    t__sn__wave_working_mode working_mode;
    t__bool auto_refresh;
    t__sn__wave_event_data event_data;
    t__int list_items;
    t__bool thread_code_line;
    t__bool hierarchy_name;
    t__bool use_wave;
    t__int stub_output;
    t__int stub_errors;
    t__int stub_message_len;
    t__int stub_events;
    t__int stub_integers;
    t__int stub_strings;
    t__int stub_strings_len;
    t__int stub_booleans;
    t__int port;
    t__string dump_file;
    t__int timeout;
    t__string path_separator;
} *t__sn__wave_config_options;
#define d__sn__wave_config_options 1374
typedef t__sn__wave_config_options t__wave_config_options;
#define d__wave_config_options d__sn__wave_config_options

/* line 171 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__databrowser_config_o4212 {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__bool exp_as_root;
    t__int list_first_items;
    t__int items_in_packed_list;
    t__bool view_source;
    t__bool auto_visualize;
} *t__sn__databrowser_config_options;
#define d__sn__databrowser_config_options 1375
typedef t__sn__databrowser_config_options t__databrowser_config_options;
#define d__databrowser_config_options d__sn__databrowser_config_options

/* line 177 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__simulation_config_op4213 {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__bool enable_vhdl_time_mti;
    t__bool ncsim_sync_save;
    t__bool back_compat_no_nbasync;
    t__bool compatible_vhdl_at_x_nc;
    t__bool resize_mvl_list;
    t__bool enable_ports_unification;
    t__bool create_redundant_adapters;
    t__bool force_sv_adapter;
    t__bool fix_new_time_in_multiple_ticks_at_fractional_delay;
    t__bool back_compat_vhdl_sync;
    t__bool back_compat_vhdl_autosync;
    t__bool truncate_sim_time_nc;
    t__bool disable_no_declared_range;
    t__bool propagate_memory_event_ncvlog;
    t__bool use_unbounded_method_ports;
    t__bool wrap_async_in_method_ports_with_try;
    t__bool stub_ports_represent_by_e_path;
} *t__sn__simulation_config_options;
#define d__sn__simulation_config_options 1376
typedef t__sn__simulation_config_options t__simulation_config_options;
#define d__simulation_config_options d__sn__simulation_config_options

/* line 183 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__ies_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__sn__t_ies_sync_reset sync_reset;
    t__bool sync_save;
    t__sn__t_ies_log_to_sim log_to_sim;
    t__bool use_vhdl_time_precision;
} *t__sn__ies_config_options;
#define d__sn__ies_config_options 1377
typedef t__sn__ies_config_options t__ies_config_options;
#define d__ies_config_options d__sn__ies_config_options

/* line 189 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__lang_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__bool old_te_precedence;
    t__bool old_macro_order;
    t__bool old_method_result_params;
    t__bool old_numeric_type_cast;
} *t__sn__lang_config_options;
#define d__sn__lang_config_options 1378
typedef t__sn__lang_config_options t__lang_config_options;
#define d__lang_config_options d__sn__lang_config_options

/* line 194 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__eanalyzer_config_options {
    t__int d__;
    t__int gen__;
    t__sn__config_categories category;
    t__string short_name;
    t__string category_title;
    t__bool on;
} *t__sn__eanalyzer_config_options;
#define d__sn__eanalyzer_config_options 1379
typedef t__sn__eanalyzer_config_options t__eanalyzer_config_options;
#define d__eanalyzer_config_options d__sn__eanalyzer_config_options

/* line 1226 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__configuration_category {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string label;
    struct s__l__sn__configuration_option *customized_configuration_options;
} *t__sn__configuration_category;
#define d__sn__configuration_category 1409
typedef t__sn__configuration_category t__configuration_category;
#define d__configuration_category d__sn__configuration_category

/* line 1078 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__configuration_option {
    t__int d__;
    t__int gen__;
    t__string category;
    t__string field_name;
    t__string label;
    t__string tool_tip;
    t__string group;
    t__sn__ui_type widget;
    struct s__sn__sn_value_holder *lower_bound;
    struct s__sn__sn_value_holder *upper_bound;
    t__string re;
    t__sn__config_option_status status;
    t__bool open_lower_bound;
} *t__sn__configuration_option;
#define d__sn__configuration_option 1408
typedef t__sn__configuration_option t__configuration_option;
#define d__configuration_option d__sn__configuration_option

/* line 1326 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_value_holder {
    t__int d__;
    t__int gen__;
} *t__sn__sn_value_holder;
#define d__sn__sn_value_holder 221
typedef t__sn__sn_value_holder t__sn_value_holder;
#define d__sn_value_holder d__sn__sn_value_holder

/* line 837 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_gc_debug_thing {
    t__int d__;
    t__int gen__;
    t__bool active_before_gc;
    t__bool active_after_gc;
    t__bool active_completely_after_gc;
} *t__sn__sn_gc_debug_thing;
#define d__sn__sn_gc_debug_thing 2331
typedef t__sn__sn_gc_debug_thing t__sn_gc_debug_thing;
#define d__sn_gc_debug_thing d__sn__sn_gc_debug_thing

/* line 901 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_gc_debug_predicate {
    t__int d__;
    t__int gen__;
} *t__sn__sn_gc_debug_predicate;
#define d__sn__sn_gc_debug_predicate 2332
typedef t__sn__sn_gc_debug_predicate t__sn_gc_debug_predicate;
#define d__sn_gc_debug_predicate d__sn__sn_gc_debug_predicate

/* line 203 "/vobs/specman/src/disp_reload.e"  From 'struct definition' */
typedef struct s__sn__esv_info_s {
    t__int d__;
    t__int gen__;
    t__string file_name;
    t__int last_module;
    t__bool invisible;
} *t__sn__esv_info_s;
#define d__sn__esv_info_s 2745
typedef t__sn__esv_info_s t__esv_info_s;
#define d__esv_info_s d__sn__esv_info_s

/* line 319 "/vobs/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__int__2147483647 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__int__2147483647;
#define d__int__2147483647 1273

/* line 270 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__debug {
    t__int d__;
    t__int gen__;
    t__bool root;
    t__bool parse;
    t__bool reparse;
    t__string reparse_match;
    t__bool alloc;
    t__bool vec_long;
    t__bool forms;
    t__bool empty;
    t__bool files;
    t__external_pointer err_file;
    t__bool packing;
    t__bool deep;
    t__bool trace_config;
    t__int gen;
    t__bool support;
    t__bool trace;
    t__bool display;
    t__bool keep;
    t__bool output;
    t__bool help;
    t__bool cvr_define2;
    t__bool cvr_define_reparse;
    t__bool server;
    t__bool interrupt;
    t__bool wakeup;
    t__bool edl;
    t__bool snorb;
    t__bool snorb2;
    t__int cvr;
    t__bool cvr_sai;
    t__int cvr_rank;
    t__int cvr_action;
    t__int cvr_parse;
    t__int cvr_read;
    t__int cvr_cfg;
    t__int cvr_grad;
    t__int cvr_gui;
    t__bool need_macro_call_info_for_command;
    t__bool threads;
    t__bool reset;
    t__bool dbg;
    t__bool bp;
    t__bool wave;
    t__bool jres;
    t__bool databrowser;
    t__bool vt;
    t__bool vt2;
    t__bool vthist;
    t__bool vt_html;
    t__bool vt_container;
    t__bool vt_container_perf;
    t__bool vt_page_perf;
    t__bool vt_segment;
    t__bool vt_menubar;
    t__bool vtx_event;
    t__int gen_sa;
    t__int gen_gc_stat;
    t__bool capture;
    t__bool cai_integrator;
    struct s__sn__sn_prof_lookup *lookup;
} *t__e_core__debug;
#define d__e_core__debug 33
typedef t__e_core__debug t__debug;
#define d__debug d__e_core__debug

/* line 42 "/vobs/specman/src/prof_lookup.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_lookup {
    t__int d__;
    t__int gen__;
    t__string directory;
} *t__sn__sn_prof_lookup;
#define d__sn__sn_prof_lookup 9158
typedef t__sn__sn_prof_lookup t__sn_prof_lookup;
#define d__sn_prof_lookup d__sn__sn_prof_lookup

/* line 289 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__configuration {
    t__int d__;
    t__int gen__;
    t__bool refresh;
    t__bool restore;
    t__string p_config_file_ext;
} *t__e_core__configuration;
#define d__e_core__configuration 34
typedef t__e_core__configuration t__configuration;
#define d__configuration d__e_core__configuration

/* line 303 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_dbg {
    t__int d__;
    t__int gen__;
    t__e_core__on_status status;
    t__bool break_on_interrupt;
    t__bool exception_is_error;
    t__bool suspect_threads_changed;
    t__bool in_print_loop;
    t__bool debug_action_off;
    t__int stopped_try_level;
    t__bool enabled;
    t__bool watch_enabled;
    t__string do_after_abort;
    struct s__sn__method *method;
    struct s__e_core__base_struct *the_me;
    t__sn__on_kind kind;
    t__sn__on_stop_kind stop_kind;
    t__bool compiled_routine;
    t__bool main;
    t__untyped result;
    struct s__sn__activation_record *initial_activation_record;
    struct s__sn__activation_record *activation_record;
    struct s__sn__scope *scope;
    struct s__sn__n__action *n__action;
    t__int global_call_num;
    struct s__sn__sn_dbg_threads_forest *the_threads_forest;
    struct s__sn__sn_dbg_scope *dbg_scope;
    t__bool threads_forest_is_active;
    t__bool break_on_simulator;
    t__bool sim_stopped_by_break_sim;
    t__bool disable_br_on_err_flag;
    struct s__l__sn__on_request *list_of_break_hit_requests;
    struct s__sn__exceptions *tmp_exceptions;
    t__bool on_debugging_in_progress;
    t__bool on_dbg_use_dispatch_table;
    t__bool on_break_on_method_call;
    t__bool on_break_on_method_return;
    t__bool on_break_on_tcm_start;
    t__bool on_break_on_tcm_end;
    t__bool on_break_on_tcm_call;
    t__bool on_break_on_tcm_return;
    struct s__l__sn__on_request *requests;
    t__int stopping_request_num;
    t__source_ref stopping_source_ref;
    t__sn__request_type stopping_special_type;
    t__int stopping_count_back;
    t__bool watch_steps;
    t__bool watch_calls_to_routines;
    t__sn__on_event_type event_type;
    t__int current_event_id;
    t__string current_error_message;
    t__string type_wildcard;
    t__string method_wildcard;
    t__bool show_extra_debug_info;
    t__sn__on_step_mode step_mode;
    t__int step_line;
    t__int step_ar_num;
    struct s__sn__macro_call_info *step_macro_info;
    t__int step_thread_id;
    t__int next_mini_id;
    struct s__sn__activation_record *eval_activation_record;
    t__int last_request_id;
    struct s__sn__n__action *macro_info_action;
    t__bool stop_for_g5;
    struct s__sn__sn_stepping_context *stepping_context;
    t__bool f_notify_threads_changes;
    t__bool on_debugging_contention_in_progress;
    t__string NO_BREAKPOINTS_MESSAGE;
    t__string NO_WATCH_ITEMS_MESSAGE;
    t__sn_debugger__t_macro_debug_mode macro_debug_mode;
    struct s__l__sn_debugger__watch_item *watch_list;
    t__int last_watch_id;
    t__bool auto_watch_active;
    t__bool watch_list_changed;
    t__bool auto_watch_internal_disable;
    struct s__sn_debugger__sn_dbg_api *api;
    t__bool debug_ttf;
    t__int num_of_errors;
    struct s__sn__macro_call_info *macro_expansion_info;
    t__bool inside_break_on_error;
    t__string debug_info_file_ext;
    t__string p_retain_state_file_ext;
    t__string p_action_widgets_file_ext;
    struct s__sn_debugger__sn_thread_31727 *thread_manager;
    t__string BP_ID_STR;
    t__string BP_PKG_STR;
    t__string BP_FQ_STR;
    t__string BP_NQ_STR;
    t__string BP_SHORT_STR;
    t__string BP_DYNAMIC_STR;
    t__string BP_DISABLED_STR;
    t__string BP_FORCE_FQ_STR;
    t__string BP_ATTR_TAG_START_STR;
    t__string BP_ATTR_TAG_END_STR;
    t__string BP_STRUCT_PLACEHOLDER_STR;
    t__string BP_STRUCT_PLACEHOLDER_RE;
    t__string NAME_CHAR_RE;
    t__string NONBLANK_CHAR_RE;
    t__string contention_field_name;
    t__string contention_message;
    t__string threads_forest_int_err_msg;
    t__string threads_forest_user_err_msg;
    t__bool m_force_refresh_all_threads_in_all_windows;
    struct s__sn_debugger__sn_dbg_thr28897 *threads_changes;
    struct s__sn__sn_dbg_threads_forest *upcoming_threads_forest;
    t__int forced_source_thread_id;
    struct s__e_core__time *last_refresh_time;
    t__string MSG_CANNOT_EVAL;
    t__string MSG_INACTIVE_THREAD;
    t__string MSG_INACTIVE;
    t__string MSG_NO_CURRENT_THREAD;
    t__string MSG_CURRENT_THREAD;
    t__string MSG_GLOBAL_WATCHES;
    t__string MSG_CURRENT_TIME;
    t__string MSG_THREAD;
    t__string INTERACTIVE_SCOPE_STR;
    t__string macro_expansion_file_name;
    struct s__l__int *special_stopping_hook_indecis;
} *t__e_core__sn_dbg;
#define d__e_core__sn_dbg 36
typedef t__e_core__sn_dbg t__sn_dbg;
#define d__sn_dbg d__e_core__sn_dbg

/* line 81 "/vobs/specman/src/interp.e"  From 'struct definition' */
typedef struct s__sn__sn_dbg_threads_forest {
    t__int d__;
    t__int gen__;
    t__int MAX_THID_LEN;
    t__int BROWSER_ID_LEN;
    t__string THID_SF_STR;
    t__string THID_SPACE_STR;
    t__string THID_DASH_STR;
    struct s__k__sn_debugger__sn_dbg_28141 *all_forest_calls;
    struct s__sn__n__action *original_stopped_action;
    struct s__sn__n__action *original_last_tcm_action;
    t__source_ref last_user_stopped_src_ref;
    struct s__sn__activation_record *original_last_tcm_ar;
    struct s__l__sn_debugger__ar_sr *all_source_refs;
    struct s__k__sn_debugger__sn_dbg_28896 *all_threads;
    struct s__k__sn_debugger__sn_dbg_29860 *temp_all_mini_threads;
    struct s__k__sn_debugger__sn_dbg_29860 *all_mini_threads;
    struct s__sn_debugger__sn_dbg_thread *thread0;
    struct s__sn_debugger__sn_dbg_thread *current_thread;
    struct s__sn_debugger__sn_dbg_min28894 *current_mini_thread;
    struct s__sn_debugger__sn_dbg_call *stopped_call;
    struct s__sn_debugger__sn_dbg_call *stopped_user_call;
    t__bool ready;
} *t__sn__sn_dbg_threads_forest;
#define d__sn__sn_dbg_threads_forest 646
typedef t__sn__sn_dbg_threads_forest t__sn_dbg_threads_forest;
#define d__sn_dbg_threads_forest d__sn__sn_dbg_threads_forest

/* line 113 "/vobs/specman/src/dbg_user_api.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_dbg_call {
    t__int d__;
    t__int gen__;
    void *_s_id___ptr_padding[1];
    t__string s_id;
    t__int mini_id;
    t__source_ref src_ref;
    struct s__l__sn_debugger__sn_dbg_call *children;
    struct s__e_core__source_item *src_item;
    t__int index_in_stack;
    struct s__sn_debugger__sn_dbg_min28894 *mini_thread;
    struct s__sn__scope *tcm_scope;
    struct s__sn_debugger__sn_dbg_call *caller;
    struct s__sn_debugger__sn_dbg_thread *thread;
    struct s__sn_debugger__sn_dbg_call *tcm_caller;
    struct s__sn__activation_record *ar;
    struct s__sn_debugger__dbg_ar_info *ar_info;
} *t__sn_debugger__sn_dbg_call;
#define d__sn_debugger__sn_dbg_call 4052
typedef t__sn_debugger__sn_dbg_call t__sn_dbg_call;
#define d__sn_dbg_call d__sn_debugger__sn_dbg_call

/* line 171 "/vobs/specman/src/dbg_ontop_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_dbg_min28894 {
    t__int d__;
    t__int gen__;
    t__int mini_id;
    t__int mini_id_parent;
    struct s__l__sn_debugger__sn_dbg_call *stack;
    struct s__sn_debugger__sn_dbg_min28894 *temp_parent;
    struct s__l__sn_debugger__sn_dbg_28899 *temp_children;
    struct s__sn_debugger__sn_dbg_min28894 *parent;
    struct s__l__sn_debugger__sn_dbg_28899 *children;
    struct s__sn_debugger__sn_dbg_thread *dbg_thread;
} *t__sn_debugger__sn_dbg_mini_thread;
#define d__sn_debugger__sn_dbg_mini_thread 4129
typedef t__sn_debugger__sn_dbg_mini_thread t__sn_dbg_mini_thread;
#define d__sn_dbg_mini_thread d__sn_debugger__sn_dbg_mini_thread

/* line 180 "/vobs/specman/src/dbg_user_api.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_dbg_thread {
    t__int d__;
    t__int gen__;
    t__int n_id;
    struct s__sn_debugger__sn_dbg_call *root;
    struct s__sn_debugger__sn_dbg_min28894 *top_mini_thread;
    struct s__sn__sn_dbg_threads_forest *forest;
    struct s__sn_debugger__sn_dbg_path *current_path;
    t__source_ref starter_src_ref;
    struct s__e_core__time *start_time;
    t__int calls_count;
    struct s__l__sn_debugger__sn_dbg_call *all_leafs;
    t__bool dirty;
} *t__sn_debugger__sn_dbg_thread;
#define d__sn_debugger__sn_dbg_thread 4053
typedef t__sn_debugger__sn_dbg_thread t__sn_dbg_thread;
#define d__sn_dbg_thread d__sn_debugger__sn_dbg_thread

/* line 219 "/vobs/specman/src/dbg_user_api.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_dbg_path {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__sn_dbg_thread *thread;
    struct s__l__sn_debugger__sn_dbg_call *all_calls;
    t__int curr_elem_index;
} *t__sn_debugger__sn_dbg_path;
#define d__sn_debugger__sn_dbg_path 4054
typedef t__sn_debugger__sn_dbg_path t__sn_dbg_path;
#define d__sn_dbg_path d__sn_debugger__sn_dbg_path

/* line 284 "/vobs/specman/src/dbg_ontop_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__dbg_ar_info {
    t__int d__;
    t__int gen__;
    t__int call_num;
    struct s__sn__n__action *current_action;
    t__string params_line;
    t__string params_str;
    struct s__sn__method *method;
    struct s__e_core__base_struct *owner;
} *t__sn_debugger__dbg_ar_info;
#define d__sn_debugger__dbg_ar_info 4130
typedef t__sn_debugger__dbg_ar_info t__dbg_ar_info;
#define d__dbg_ar_info d__sn_debugger__dbg_ar_info

/* line 212 "/vobs/specman/src/dbg_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__ar_sr {
    t__int d__;
    t__int gen__;
    t__int call_num;
    t__source_ref sr;
} *t__sn_debugger__ar_sr;
#define d__sn_debugger__ar_sr 4069
typedef t__sn_debugger__ar_sr t__ar_sr;
#define d__ar_sr d__sn_debugger__ar_sr

/* line 88 "/vobs/specman/src/interp.e"  From 'struct definition' */
typedef struct s__sn__sn_dbg_scope {
    t__int d__;
    t__int gen__;
    t__bool is_active_scope;
    struct s__sn__scope *curr_scope;
    struct s__sn__activation_record *curr_activation_record;
    struct s__sn__n__action *curr_action;
} *t__sn__sn_dbg_scope;
#define d__sn__sn_dbg_scope 647
typedef t__sn__sn_dbg_scope t__sn_dbg_scope;
#define d__sn_dbg_scope d__sn__sn_dbg_scope

/* line 349 "/vobs/specman/src/interp.e"  From 'struct definition' */
typedef struct s__sn__on_request {
    t__int d__;
    t__int gen__;
    t__sn__on_kind kind;
    t__sn__on_stop_kind stop_kind;
    t__sn__request_type special_type;
    t__sn__on_event_type event_type;
    t__string type_wildcard;
    t__pat type_wildcard_pat;
    t__string method_wildcard;
    t__pat method_wildcard_pat;
    t__bool enabled;
    t__bool internal_enabled;
    struct s__sn__struct_descriptor *sd;
    t__int type_index;
    t__int method_index;
    t__bool main_only;
    t__bool break_temp;
    t__int line_no;
    struct s__sn__module *requested_module;
    t__int macro_expansion_index;
    t__bool break_anywhere;
    struct s__sn__explicit_exp *when_exp;
    t__string when_exp_string;
    struct s__sn__n__block *n__block;
    t__bool active_scope;
    t__int thread_id;
    t__int request_id;
    t__bool f_fq_type_wildcard;
    t__bool f_tick_type_wildcard;
    t__bool original_enabled;
    t__bool pending;
    t__string original_method_name;
    struct s__sn__trace_gen_request *trace_gen_request;
    t__string m_org_member_name;
    t__string m_full_name_str;
    t__string m_line_num_str;
    t__string m_ext_str;
    t__bool m_force;
    t__string m_event_type_str;
    t__int m_break_on_alloc_start;
    t__string m_orig_pure_cmd;
    struct s__sn_debugger__sn_dbg_bp_29121 *m_struct_data;
    struct s__sn_debugger__br_g5_info_type *br_g5_info;
} *t__sn__on_request;
#define d__sn__on_request 652
typedef t__sn__on_request t__on_request;
#define d__on_request d__sn__on_request

/* line 61 "/vobs/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__sn__trace_gen_request {
    t__int d__;
    t__int gen__;
    t__string wildchar;
    t__bool disabled;
    struct s__l__string *sts;
} *t__sn__trace_gen_request;
#define d__sn__trace_gen_request 2129
typedef t__sn__trace_gen_request t__trace_gen_request;
#define d__trace_gen_request d__sn__trace_gen_request

/* line 11 "/vobs/specman/src/dbg_request.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_dbg_bp_29121 {
    t__int d__;
    t__int gen__;
    t__string m_package_name;
    t__string m_fq_name;
    t__string m_nq_name;
    t__string m_short_name;
    struct s__sn__on_request *m_req;
    t__bool m_is_dynamic;
    t__bool m_is_force_fq;
} *t__sn_debugger__sn_dbg_bp_struct_data;
#define d__sn_debugger__sn_dbg_bp_struct_data 4177
typedef t__sn_debugger__sn_dbg_bp_struct_data t__sn_dbg_bp_struct_data;
#define d__sn_dbg_bp_struct_data d__sn_debugger__sn_dbg_bp_struct_data

/* line 198 "/vobs/specman/src/dbg_request.e"  From 'struct definition' */
typedef struct s__sn_debugger__br_g5_info_type {
    t__int d__;
    t__int gen__;
    t__string wild_str;
    t__bool assign;
    t__bool reduce;
    t__int action_id;
    t__int cfs_id;
    t__bool on_error;
    t__bool no_gui;
    struct s__reflection__rf_field *fld;
    struct s__reflection__rf_struct *holding_struct;
} *t__sn_debugger__br_g5_info_type;
#define d__sn_debugger__br_g5_info_type 4178
typedef t__sn_debugger__br_g5_info_type t__br_g5_info_type;
#define d__br_g5_info_type d__sn_debugger__br_g5_info_type

/* line 333 "/vobs/specman/src/interp.e"  From 'struct definition' */
typedef struct s__sn__sn_stepping_context {
    t__int d__;
    t__int gen__;
    t__bool enabled;
    t__sn__on_kind kind;
    t__sn__on_step_mode step_mode;
    t__int step_line;
    t__int step_ar_num;
    struct s__sn__macro_call_info *step_macro_info;
    t__int step_thread_id;
    t__bool watch_steps;
    t__int next_mini_id;
} *t__sn__sn_stepping_context;
#define d__sn__sn_stepping_context 650
typedef t__sn__sn_stepping_context t__sn_stepping_context;
#define d__sn_stepping_context d__sn__sn_stepping_context

/* line 429 "/vobs/specman/src/dbg_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__watch_item {
    t__int d__;
    t__int gen__;
    t__string exp_string;
    t__int id;
    t__int thread_id;
    t__e_core__po_radix radix;
    t__bool use_radix;
    t__int list_items;
} *t__sn_debugger__watch_item;
#define d__sn_debugger__watch_item 4071
typedef t__sn_debugger__watch_item t__watch_item;
#define d__watch_item d__sn_debugger__watch_item

/* line 29 "/vobs/specman/src/dbg_user_api.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_dbg_api {
    t__int d__;
    t__int gen__;
} *t__sn_debugger__sn_dbg_api;
#define d__sn_debugger__sn_dbg_api 4051
typedef t__sn_debugger__sn_dbg_api t__sn_dbg_api;
#define d__sn_dbg_api d__sn_debugger__sn_dbg_api

/* line 293 "/vobs/specman/src/dbg_ontop_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_thread_31727 {
    t__int d__;
    t__int gen__;
    t__string THERADS_WINDOW_NAME;
    t__string THERADS_WINDOW_TITLE;
    t__string TREE_WINDOW_NAME;
    t__string ACTIVE_ICON;
    t__string EMPTY_ICON;
    t__string EMPTY_CALL_ICON;
    t__string THREAD_HEADER_ICON;
    t__string STOPPED_THREAD_ICON;
    t__string WAITING_THREAD_ICON;
    t__string EXISTING_THREAD_ICON;
    t__string IDLE_THREAD_ICON;
    t__string ACTIVE_CALL_ICON;
    t__string PATH_CALL_ICON;
    t__string STOPPED_STATE_ICON;
    t__string WAITING_STATE_ICON;
    t__string IDLE_STATE_ICON;
    t__string STATE_HEADER_ICON;
    t__string TCM_ICON;
    t__string FORK_ICON;
    t__string METHOD_ICON;
    t__string STOPPED_TCM_ICON;
    t__string STOPPED_FORK_ICON;
    t__string STOPPED_METHOD_ICON;
    t__string METHOD_HEADER_ICON;
    t__string TCM_STOP_MARK_ICON;
    t__string FORK_STOP_MARK_ICON;
    t__string METHOD_STOP_MARK_ICON;
    struct s__vt__sn_pair_nums *THREADS_WINDOW_DEFAULT_LOCATION;
    struct s__vt__sn_pair_nums *THREADS_WINDOW_DEFAULT_SIZE;
    struct s__vt__sn_pair_nums *THREAD_TREE_WINDOW_DEFAULT_LOCATION;
    struct s__vt__sn_pair_nums *THREAD_TREE_WINDOW_DEFAULT_SIZE;
    t__string ACTIVE_CURRENT_CALL_ICON;
    t__string INACTIVE_CURRENT_CALL_ICON;
    t__string ACTIVE_PATH_CALL_ICON;
    t__string INACTIVE_PATH_CALL_ICON;
    t__int KIND_IDLE_THREAD0;
    t__int KIND_STOPPED_CURR_THREAD0;
    t__int KIND_STOPPED_NCURR_THREAD0;
    t__int KIND_STOPPED_CURR_THREAD;
    t__int KIND_STOPPED_NCURR_THREAD;
    t__int KIND_NSTOPPED_CURR_THREAD;
    t__int KIND_NSTOPPED_NCURR_THREAD;
    t__int KIND_STOPPED_CURR_CALL;
    t__int KIND_NSTOPPED_CURR_CALL;
    t__int KIND_STOPPED_NCURR_CALL;
    t__int KIND_NSTOPPED_NCURR_CALL;
    struct s__vt__vt_user_action *show_starter_action;
    struct s__vt__vt_user_action *show_source_action;
    struct s__vt__vt_user_action *show_tree_action;
    struct s__sn__sn_dbg_threads_forest *forest;
    struct s__vt__sn_table_window_data *threads_window_data;
    struct s__vt__sn_tree_window_data *thread_tree_window_data;
    struct s__l__vt__vt_user_action *lst_threads_window_actions;
    struct s__l__vt__vt_user_action *lst_thread_tree_window_actions;
    struct s__l__vt__sn_table_col *lst_threads_window_cols;
    t__string SET_THREAD_SCOPE_ACTION_NAME;
    t__string SHOW_THREAD_SOURCE_ACTION_NAME;
    t__string SHOW_THREAD_TREE_ACTION_NAME;
    t__string SHOW_THREAD_CURR_OWNER_ACTION_NAME;
    t__string SHOW_STARTER_ACTION_NAME;
    t__string SHOW_START_TIME_ACTION_NAME;
    t__string FIND_STOPPED_ACTION_NAME;
    t__string FIND_CURRENT_ACTION_NAME;
    t__string SET_CALL_SCOPE_ACTION_NAME;
    t__string SHOW_CALL_SOURCE_ACTION_NAME;
    t__string SHOW_ME_ACTION_NAME;
    t__string SHOW_CALL_ID_ACTION_NAME;
    struct s__l__sn_debugger__thread_31824 *thread_tree_win_counter_list;
    t__sn__count thread_tree_win_counter;
} *t__sn_debugger__sn_thread_manager;
#define d__sn_debugger__sn_thread_manager 4131
typedef t__sn_debugger__sn_thread_manager t__sn_thread_manager;
#define d__sn_thread_manager d__sn_debugger__sn_thread_manager

/* line 110 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_pair_nums {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int n1;
    t__int n2;
} *t__vt__sn_pair_nums;
#define d__vt__sn_pair_nums 2544
typedef t__vt__sn_pair_nums t__sn_pair_nums;
#define d__sn_pair_nums d__vt__sn_pair_nums

/* line 113 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_user_action {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string related_menu_name;
    t__string title;
    t__string tooltip;
    t__string command;
    t__string icon_file;
    t__string tool_bar_title;
    t__bool enabled;
    t__vt__vt_menu_action_kind kind;
    t__vt__vt_action_type type;
    t__bool has_menubar_button;
    struct s__l__string *items;
    t__int pos;
    t__bool f_dynamic;
    t__string name;
    t__bool selection_sensitive;
    t__bool checkable;
    t__string checked_icon;
} *t__vt__vt_user_action;
#define d__vt__vt_user_action 2527
typedef t__vt__vt_user_action t__vt_user_action;
#define d__vt_user_action d__vt__vt_user_action

/* line 340 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_table_window_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string s_kind;
    struct s__vt__sn_pair_nums *location;
    struct s__vt__sn_pair_nums *size;
    t__bool f_lockable;
    t__bool f_show_source;
    t__bool f_check_na_actions;
    struct s__l__vt__vt_user_action *lst_actions;
    t__string most_common_action;
    struct s__vt__vt_window_header_config *header_config;
    struct s__l__vt__sn_table_col *lst_cols;
} *t__vt__sn_table_window_data;
#define d__vt__sn_table_window_data 2555
typedef t__vt__sn_table_window_data t__sn_table_window_data;
#define d__sn_table_window_data d__vt__sn_table_window_data

/* line 97 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_window_header_config {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int m_font_level;
    t__bool m_f_bold;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__int m_alignment;
} *t__vt__vt_window_header_config;
#define d__vt__vt_window_header_config 2542
typedef t__vt__vt_window_header_config t__vt_window_header_config;
#define d__vt_window_header_config d__vt__vt_window_header_config

/* line 192 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_table_col {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string p_s_id;
    t__string p_title;
    t__string p_icon_file;
    t__vt__sn_simple_type p_simple_type;
    t__int p_width;
    t__bool p_sortable;
    t__string p_tooltip;
    t__bool p_is_left_align;
    t__bool p_is_3_dots_right;
} *t__vt__sn_table_col;
#define d__vt__sn_table_col 2550
typedef t__vt__sn_table_col t__sn_table_col;
#define d__sn_table_col d__vt__sn_table_col

/* line 285 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_tree_window_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string s_kind;
    struct s__vt__sn_pair_nums *location;
    struct s__vt__sn_pair_nums *size;
    t__bool f_lockable;
    t__bool f_show_source;
    t__bool f_check_na_actions;
    struct s__l__vt__vt_user_action *lst_actions;
    t__string most_common_action;
    struct s__vt__vt_window_header_config *header_config;
    t__bool f_expand_all;
    t__int num_icons_per_node;
} *t__vt__sn_tree_window_data;
#define d__vt__sn_tree_window_data 2553
typedef t__vt__sn_tree_window_data t__sn_tree_window_data;
#define d__sn_tree_window_data d__vt__sn_tree_window_data

/* line 4 "/vobs/specman/src/dbg_threads_window.e"  From 'struct definition' */
typedef struct s__sn_debugger__thread_tre31864 {
    t__int d__;
    t__int gen__;
    t__int thread_id;
    t__sn__count win_idx;
} *t__sn_debugger__thread_tree_win_counter;
#define d__sn_debugger__thread_tree_win_counter 4183
typedef t__sn_debugger__thread_tree_win_counter t__thread_tree_win_counter;
#define d__thread_tree_win_counter d__sn_debugger__thread_tree_win_counter

/* line 65 "/vobs/specman/src/dbg_ontop_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_dbg_thr28897 {
    t__int d__;
    t__int gen__;
    struct s__k__sn_debugger__sn_dbg_28896 *changed_threads;
    struct s__k__sn_debugger__sn_dbg_28896 *added_threads;
    struct s__k__int__it *removed_thread_ids;
    struct s__sn__sn_dbg_threads_forest *old_forest;
} *t__sn_debugger__sn_dbg_threads_changes;
#define d__sn_debugger__sn_dbg_threads_changes 4128
typedef t__sn_debugger__sn_dbg_threads_changes t__sn_dbg_threads_changes;
#define d__sn_dbg_threads_changes d__sn_debugger__sn_dbg_threads_changes

/* line 1744 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__no_save {
    t__int d__;
    t__int gen__;
    struct s__e_core__reparse_source_item *current_source_item;
    struct s__e_core__file_contents *current_file_contents;
    struct s__e_core__file_contents *memory_save;
    struct s__sn__gc_struct *gc;
    struct s__l__e_core__type_translation *type_translations;
    struct s__l__bool *type_was_saved;
    struct s__l__sn__ntv *update_relaxation_ntvs;
    struct s__l__e_core__display_item *display_items;
    t__bool mark_rl_results;
    t__bool create_all_structs;
    struct s__l__e_core__base_struct *all_structs;
    t__string magic_function_dividing_line;
    t__string magic_C_code_end_line;
    t__bool split_generated_C_files;
    t__bool write_h_only;
    t__e_core__sn_rs_translation last_read_struct_translation;
    struct s__k__e_core__file_contents_483 *file_cache;
    t__int disabled_otf_gc;
    struct s__l__sn_when_subtype__n__s2668 *subtype_ntvs;
    struct s__l__sn__when_tree_node *when_subtype___et_stack;
    struct s__sn__Context *when_subtype___temp_context;
    struct s__k__sn__sn_user_dir_pair_4506 *static_user_home_dir;
    t__string static_curr_dir;
    t__string static_curr_user_home_dir;
    struct s__sn__sn_profiler *profiler;
    t__bool prof_first_tick;
} *t__e_core__no_save;
#define d__e_core__no_save 106
typedef t__e_core__no_save t__no_save;
#define d__no_save d__e_core__no_save

/* line 1881 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__file_contents {
    t__int d__;
    t__int gen__;
    t__string file_name;
    t__int next_line;
    struct s__l__string *lines;
    t__int timestamp;
} *t__e_core__file_contents;
#define d__e_core__file_contents 107
typedef t__e_core__file_contents t__file_contents;
#define d__file_contents d__e_core__file_contents

/* line 1837 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__gc_struct {
    t__int d__;
    t__int gen__;
    t__external_pointer threshold_size;
    t__external_pointer otf_threshold_size;
    t__external_pointer increment_size;
    t__external_pointer otf_increment_size;
    t__bool no_print_msg;
    t__bool print_otf_msg;
    t__external_pointer max_size;
    t__external_pointer absolute_max_size;
    t__bool retain_printed_structs;
    t__bool retain_trace_structs;
    t__uint max_retained_structs;
    t__int restore_generation;
    t__int primary_current_generation;
    t__int secondary_current_generation;
    t__bool disable_disk_based_gc;
    t__bool prefer_disk_based_gc;
    t__string disk_based_gc_area;
    t__uint disk_based_chunk_size;
    t__bool crash_alloc;
    t__uint alloc_crash_threshold;
    t__int otf_gc_idx;
    t__int disk_based_gc_idx;
    t__bool stress_otf_gc;
    t__external_pointer stress_otf_gc_threshold;
    t__bool stress;
    t__int stress_divisor;
    t__int stress_count;
    t__bool print_debug_msgs;
    t__uint debug_headroom;
    t__int check_before_gc_overhead;
    t__uint expand_stack;
    t__sn__auto_gc_setting_policy automatic_gc_settings;
    t__external_pointer optimal_process_size;
    t__bool notify_gc_settings;
    t__uint headroom;
    t__bool check_consistency_is_on;
    t__bool pool_storage;
} *t__sn__gc_struct;
#define d__sn__gc_struct 250
typedef t__sn__gc_struct t__gc_struct;
#define d__gc_struct d__sn__gc_struct

/* line 1891 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__type_translation {
    t__int d__;
    t__int gen__;
    t__int translation;
    struct s__l__int *field_translations;
    struct s__l__int *orig_field_offset;
    struct s__l__bool *orig_is_pointer;
} *t__e_core__type_translation;
#define d__e_core__type_translation 108
typedef t__e_core__type_translation t__type_translation;
#define d__type_translation d__e_core__type_translation

/* line 2007 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__display_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__base_struct *the_struct;
    t__string initial;
    t__int field_no;
    t__int item_no;
    struct s__l__untyped *the_list;
} *t__e_core__display_item;
#define d__e_core__display_item 114
typedef t__e_core__display_item t__display_item;
#define d__display_item d__e_core__display_item

/* line 1279 "/vobs/specman/src/when_subtype.e"  From 'struct definition' */
typedef struct s__sn_when_subtype__n__subt2674 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    struct s__sn__struct_descriptor *when_root;
    struct s__sn__Context *init_context;
    struct s__sn__subtype_descriptor *f__std;
    struct s__sn_when_subtype__n__subtype *n__subtype;
} *t__sn_when_subtype__n__subtype__regular_type;
#define d__sn_when_subtype__n__subtype__regular_type 1086
typedef t__sn_when_subtype__n__subtype__regular_type t__n__subtype__regular_type;
#define d__n__subtype__regular_type d__sn_when_subtype__n__subtype__regular_type

/* line 1216 "/vobs/specman/src/when_subtype.e"  From 'struct definition' */
typedef struct s__sn_when_subtype__n__subtype {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__sn_when_subtype__n__subtype;
#define d__sn_when_subtype__n__subtype 1083
typedef t__sn_when_subtype__n__subtype t__n__subtype;
#define d__n__subtype d__sn_when_subtype__n__subtype

/* line 20 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_user_dir_pair {
    t__int d__;
    t__int gen__;
    t__string user_name;
    t__string home_dir;
} *t__sn__sn_user_dir_pair;
#define d__sn__sn_user_dir_pair 1511
typedef t__sn__sn_user_dir_pair t__sn_user_dir_pair;
#define d__sn_user_dir_pair d__sn__sn_user_dir_pair

/* line 5 "/vobs/specman/src/profiler_hookup.e"  From 'struct definition' */
typedef struct s__sn__sn_profiler {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_args *args;
    t__string directory;
    t__string temp_directory;
    t__string dump_file_name;
    t__string run_info_file_name;
    t__string final_info_file_name;
    t__bool verbose;
    t__bool v_dump;
    t__bool all_internal;
    t__bool raw_n_globals;
    struct s__sn__sn_prof_run_info *info;
    struct s__sn__sn_prof_dictionary *dictionary;
    t__bool dictionary_configured;
    struct s__sn__sn_prof_lookup *lookup;
    struct s__sn__struct_descriptor *lookup_sd;
    t__bool lookup_configured;
    struct s__sn__sn_prof_summation *summation;
    t__bool in_sim;
    t__bool in_specman_tick;
    t__bool rnd;
    t__int sampled_amount;
    struct s__sn__sn_prof_attribution *attribution;
    t__bool static_state_restored;
    t__bool report_unknown;
    t__bool swallow_unknown;
    struct s__sn__sn_prof_callbacks *callbacks;
    t__bool callbacks_configured;
    t__bool callbacks_registered;
    struct s__sn__sn_prof_sampling *sampling;
    t__bool static_state_saved;
    t__bool static_state_built;
    t__bool sample_segments;
    t__bool just_for_trace;
    struct s__sn__sn_prof_assimilation *assimilation;
    struct s__sn__sn_prof_html_maker *h;
    struct s__l__string *h_tags;
    struct s__sn__sn_prof_html_br *the_br;
    struct s__sn__sn_prof_html_hr *the_hr;
    struct s__sn__sn_prof_html_p *the_p;
    struct s__sn__sn_prof_html_nbsp *the_nbsp;
    struct s__sn__sn_prof_html_string *the_empty;
    struct s__sn__sn_prof_reporting *reporting;
    t__string diff_res;
    t__bool warned_already;
} *t__sn__sn_profiler;
#define d__sn__sn_profiler 9134
typedef t__sn__sn_profiler t__sn_profiler;
#define d__sn_profiler d__sn__sn_profiler

/* line 6 "/vobs/specman/src/prof_frob.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_args {
    t__int d__;
    t__int gen__;
    t__string directory;
    t__string temp_directory;
    t__bool temp_directory_is_real;
    t__sn__sn_profiler_type type;
    t__sn__sn_prof_backend_type backend;
    t__int interval;
    t__bool keep_tmp;
    t__sn__sn_prof_sig_type sig;
    t__bool enc;
    t__bool rel_internal;
    t__bool all_internal;
    t__bool raw;
    t__int exclude;
    t__int area_size;
    t__string prf_file;
    t__bool profile_all;
    struct s__l__string *invocation_list;
    t__bool verbose;
    t__bool no_report;
} *t__sn__sn_prof_args;
#define d__sn__sn_prof_args 9148
typedef t__sn__sn_prof_args t__sn_prof_args;
#define d__sn_prof_args d__sn__sn_prof_args

/* line 87 "/vobs/specman/src/prof_frob.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_run_info {
    t__int d__;
    t__int gen__;
    t__string OS;
    t__int period;
    t__int block_size;
    t__string program_name;
    t__int PID;
    struct s__l__string *invocation;
    struct s__l__string *profiler_invocation;
    t__string machine;
    t__sn__sn_profiler_type type;
    t__string time;
    t__string sn_version;
    t__sn__sn_prof_backend_type backend;
    struct s__sn__sn_prof_long *samples_per_usecond_numerator;
    struct s__sn__sn_prof_long *samples_per_usecond_denominator;
} *t__sn__sn_prof_run_info;
#define d__sn__sn_prof_run_info 9149
typedef t__sn__sn_prof_run_info t__sn_prof_run_info;
#define d__sn_prof_run_info d__sn__sn_prof_run_info

/* line 6 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_long {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__sn__sn_prof_long;
#define d__sn__sn_prof_long 9174
typedef t__sn__sn_prof_long t__sn_prof_long;
#define d__sn_prof_long d__sn__sn_prof_long

/* line 44 "/vobs/specman/src/prof_dictionary.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_dictionary {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_prof_user_mo101516 *modules;
    struct s__k__sn__sn_prof_e_routi101519 *routines;
    t__bool enc;
    struct s__k__string__it *bogus_methods;
    struct s__l__string *te_names;
    t__string directory;
    t__string save_name;
    t__bool built;
} *t__sn__sn_prof_dictionary;
#define d__sn__sn_prof_dictionary 9152
typedef t__sn__sn_prof_dictionary t__sn_prof_dictionary;
#define d__sn_prof_dictionary d__sn__sn_prof_dictionary

/* line 36 "/vobs/specman/src/prof_dictionary.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_user_module {
    t__int d__;
    t__int gen__;
    t__string name;
    t__bool is_loaded;
    t__int num;
    t__bool is_encrypted;
    t__string file_name;
} *t__sn__sn_prof_user_module;
#define d__sn__sn_prof_user_module 9151
typedef t__sn__sn_prof_user_module t__sn_prof_user_module;
#define d__sn_prof_user_module d__sn__sn_prof_user_module

/* line 22 "/vobs/specman/src/prof_dictionary.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_e_routine {
    t__int d__;
    t__int gen__;
    t__string c_name;
    t__external_pointer addr;
    t__string addr_str;
    t__string struct_name;
    t__string method_name;
    t__string module;
    t__int module_num;
    t__int line_num;
    t__sn__method_kind method_kind;
    t__string full_name;
    t__string print_name;
} *t__sn__sn_prof_e_routine;
#define d__sn__sn_prof_e_routine 9150
typedef t__sn__sn_prof_e_routine t__sn_prof_e_routine;
#define d__sn_prof_e_routine d__sn__sn_prof_e_routine

/* line 87 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_summation {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_sample_summary *summary;
    t__string out_fname;
    t__bool is_in_specman_run;
    struct s__k__sn__sn_prof_functio103522 *functions;
    struct s__k__sn__sn_prof_program103517 *categories;
    struct s__sn__sn_prof_long *samples_counter;
    struct s__sn__sn_prof_long *total_amount;
} *t__sn__sn_prof_summation;
#define d__sn__sn_prof_summation 9176
typedef t__sn__sn_prof_summation t__sn_prof_summation;
#define d__sn_prof_summation d__sn__sn_prof_summation

/* line 255 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_sample_summary {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_prof_func_su103516 *functions;
    struct s__k__sn__sn_prof_program103517 *categories;
    t__int cycles_per_usecond;
} *t__sn__sn_prof_sample_summary;
#define d__sn__sn_prof_sample_summary 9177
typedef t__sn__sn_prof_sample_summary t__sn_prof_sample_summary;
#define d__sn_prof_sample_summary d__sn__sn_prof_sample_summary

/* line 261 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_func_summary {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__string *categories;
    struct s__sn__sn_prof_long *call_count;
    struct s__sn__sn_prof_long *cycle_count;
    struct s__sn__sn_prof_long *self_plus_callees_cycle_count;
    struct s__l__sn__sn_prof_func_su103518 *callers;
} *t__sn__sn_prof_func_summary;
#define d__sn__sn_prof_func_summary 9178
typedef t__sn__sn_prof_func_summary t__sn_prof_func_summary;
#define d__sn_prof_func_summary d__sn__sn_prof_func_summary

/* line 270 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_func_summa103519 {
    t__int d__;
    t__int gen__;
    t__string caller;
    struct s__sn__sn_prof_long *call_count;
    struct s__sn__sn_prof_long *cycle_count;
} *t__sn__sn_prof_func_summary_call;
#define d__sn__sn_prof_func_summary_call 9179
typedef t__sn__sn_prof_func_summary_call t__sn_prof_func_summary_call;
#define d__sn_prof_func_summary_call d__sn__sn_prof_func_summary_call

/* line 284 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_program_category {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__sn_prof_long *pre_specman_run_cycles;
    struct s__sn__sn_prof_long *specman_run_cycles;
    struct s__sn__sn_prof_long *cycles;
    struct s__sn__sn_prof_long *self_cycles;
    t__uint last_sample;
} *t__sn__sn_prof_program_category;
#define d__sn__sn_prof_program_category 9181
typedef t__sn__sn_prof_program_category t__sn_prof_program_category;
#define d__sn_prof_program_category d__sn__sn_prof_program_category

/* line 13 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_function_w103521 {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__sn_prof_long *count;
    struct s__sn__sn_prof_long *func_plus_descendant_count;
    struct s__l__string *callers;
    struct s__l__sn__sn_prof_long *callers_count;
    struct s__l__int *caller_last_sample;
    struct s__sn__sn_prof_long *last_sampled;
    struct s__l__string *categories;
} *t__sn__sn_prof_function_with_callers;
#define d__sn__sn_prof_function_with_callers 9175
typedef t__sn__sn_prof_function_with_callers t__sn_prof_function_with_callers;
#define d__sn_prof_function_with_callers d__sn__sn_prof_function_with_callers

/* line 142 "/vobs/specman/src/prof_attribution.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_attribution {
    t__int d__;
    t__int gen__;
    t__bool elaborate;
    t__bool raw;
    t__bool only_raw;
    t__bool ignore_nesting;
    t__int cooking_pass_num;
    t__string directory;
    t__string temp_directory;
    t__bool be_silent;
    t__bool not_eof;
    struct s__e_core__file *out_unknown;
    struct s__e_core__file *in;
    struct s__e_core__file *out;
    t__int sample_id;
    t__uint specman_run_start;
    struct s__sn__sn_prof_C_function *unknown_function;
    struct s__l__string *ignored_unknowns;
    t__bool in_specman_run;
    t__bool warned_about_sn_prof;
} *t__sn__sn_prof_attribution;
#define d__sn__sn_prof_attribution 9184
typedef t__sn__sn_prof_attribution t__sn_prof_attribution;
#define d__sn_prof_attribution d__sn__sn_prof_attribution

/* line 888 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__file {
    t__int d__;
    t__int gen__;
    t__C_file cfile;
    t__string name;
    t__string role;
    t__string mode;
    t__bool was_restored;
    t__uint position;
} *t__e_core__file;
#define d__e_core__file 78
typedef t__e_core__file t__file;
#define d__file d__e_core__file

/* line 31 "/vobs/specman/src/prof_lookup.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_C_function {
    t__int d__;
    t__int gen__;
    t__string name;
    t__sn__sn_prof_C_function_type type;
    t__string print_name;
} *t__sn__sn_prof_C_function;
#define d__sn__sn_prof_C_function 9157
typedef t__sn__sn_prof_C_function t__sn_prof_C_function;
#define d__sn_prof_C_function d__sn__sn_prof_C_function

/* line 34 "/vobs/specman/src/prof_callbacks.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_callbacks {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_prof_cb_thing *callbacks;
    struct s__l__sn__sn_profiler_sta103524 *state_savers;
    struct s__l__sn__struct_descriptor *state_saver_sds;
    struct s__l__sn__sn_prof_known_thing *known_names;
    struct s__l__sn__sn_prof_name_su103526 *substitutions;
    struct s__sn__sn_profiler_tcm_callback *tcm_callback;
    t__sn__index first_tcm_idx;
} *t__sn__sn_prof_callbacks;
#define d__sn__sn_prof_callbacks 9189
typedef t__sn__sn_prof_callbacks t__sn_prof_callbacks;
#define d__sn_prof_callbacks d__sn__sn_prof_callbacks

/* line 200 "/vobs/specman/src/prof_callbacks.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_cb_thing {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd;
    struct s__sn__sn_profiler_callback *cb;
    struct s__sn__struct_descriptor *cb_sd;
    t__sn__sn_profiler_cb_direction direction;
} *t__sn__sn_prof_cb_thing;
#define d__sn__sn_prof_cb_thing 9191
typedef t__sn__sn_prof_cb_thing t__sn_prof_cb_thing;
#define d__sn_prof_cb_thing d__sn__sn_prof_cb_thing

/* line 67 "/vobs/specman/src/profiler_hookup.e"  From 'struct definition' */
typedef struct s__sn__sn_profiler_callback {
    t__int d__;
    t__int gen__;
} *t__sn__sn_profiler_callback;
#define d__sn__sn_profiler_callback 9135
typedef t__sn__sn_profiler_callback t__sn_profiler_callback;
#define d__sn_profiler_callback d__sn__sn_profiler_callback

/* line 85 "/vobs/specman/src/profiler_hookup.e"  From 'struct definition' */
typedef struct s__sn__sn_profiler_state_saver {
    t__int d__;
    t__int gen__;
} *t__sn__sn_profiler_state_saver;
#define d__sn__sn_profiler_state_saver 9140
typedef t__sn__sn_profiler_state_saver t__sn_profiler_state_saver;
#define d__sn_profiler_state_saver d__sn__sn_profiler_state_saver

/* line 245 "/vobs/specman/src/prof_callbacks.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_known_thing {
    t__int d__;
    t__int gen__;
    t__sn__sn_prof_known_action action;
} *t__sn__sn_prof_known_thing;
#define d__sn__sn_prof_known_thing 9197
typedef t__sn__sn_prof_known_thing t__sn_prof_known_thing;
#define d__sn_prof_known_thing d__sn__sn_prof_known_thing

/* line 224 "/vobs/specman/src/prof_callbacks.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_name_subst101753 {
    t__int d__;
    t__int gen__;
    t__string to;
} *t__sn__sn_prof_name_substitution;
#define d__sn__sn_prof_name_substitution 9194
typedef t__sn__sn_prof_name_substitution t__sn_prof_name_substitution;
#define d__sn_prof_name_substitution d__sn__sn_prof_name_substitution

/* line 33 "/vobs/specman/src/prof_callbacks.e"  From 'struct definition' */
typedef struct s__sn__sn_profiler_tcm_callback {
    t__int d__;
    t__int gen__;
    struct s__l__string *current_method_names;
    t__sn__index last_sample;
    t__sn__index last_save_sample;
    t__sn__index last_restore_sample;
    struct s__sn__activation_record *car;
    struct s__e_core__base_struct *owner;
} *t__sn__sn_profiler_tcm_callback;
#define d__sn__sn_profiler_tcm_callback 9188
typedef t__sn__sn_profiler_tcm_callback t__sn_profiler_tcm_callback;
#define d__sn_profiler_tcm_callback d__sn__sn_profiler_tcm_callback

/* line 11 "/vobs/specman/src/prof_sampling.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_sampling {
    t__int d__;
    t__int gen__;
    t__string drop_file_name;
    struct s__e_core__file *drop_file;
    t__bool running;
    t__bool invalid;
    t__bool started;
    t__bool show_myself;
    t__int sample_id;
    struct s__l__sn__sn_prof_samplin103530 *actions;
    struct s__l__sn__struct_descriptor *action_sds;
    t__external_pointer sampled_amount;
    t__bool need_own_alloc;
    t__bool bounded;
} *t__sn__sn_prof_sampling;
#define d__sn__sn_prof_sampling 9212
typedef t__sn__sn_prof_sampling t__sn_prof_sampling;
#define d__sn_prof_sampling d__sn__sn_prof_sampling

/* line 257 "/vobs/specman/src/prof_sampling.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_sampling_action {
    t__int d__;
    t__int gen__;
} *t__sn__sn_prof_sampling_action;
#define d__sn__sn_prof_sampling_action 9213
typedef t__sn__sn_prof_sampling_action t__sn_prof_sampling_action;
#define d__sn_prof_sampling_action d__sn__sn_prof_sampling_action

/* line 59 "/vobs/specman/src/prof_quantify.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_assimilation {
    t__int d__;
    t__int gen__;
} *t__sn__sn_prof_assimilation;
#define d__sn__sn_prof_assimilation 9222
typedef t__sn__sn_prof_assimilation t__sn_prof_assimilation;
#define d__sn_prof_assimilation d__sn__sn_prof_assimilation

/* line 317 "/vobs/specman/src/prof_html.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_html_maker {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_prof_html_li103539 *links;
    t__int href_count;
} *t__sn__sn_prof_html_maker;
#define d__sn__sn_prof_html_maker 9263
typedef t__sn__sn_prof_html_maker t__sn_prof_html_maker;
#define d__sn_prof_html_maker d__sn__sn_prof_html_maker

/* line 312 "/vobs/specman/src/prof_html.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_html_link_data {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string href;
} *t__sn__sn_prof_html_link_data;
#define d__sn__sn_prof_html_link_data 9262
typedef t__sn__sn_prof_html_link_data t__sn_prof_html_link_data;
#define d__sn_prof_html_link_data d__sn__sn_prof_html_link_data

/* line 87 "/vobs/specman/src/prof_html.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_html_br {
    t__int d__;
    t__int gen__;
} *t__sn__sn_prof_html_br;
#define d__sn__sn_prof_html_br 9230
typedef t__sn__sn_prof_html_br t__sn_prof_html_br;
#define d__sn_prof_html_br d__sn__sn_prof_html_br

/* line 91 "/vobs/specman/src/prof_html.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_html_hr {
    t__int d__;
    t__int gen__;
} *t__sn__sn_prof_html_hr;
#define d__sn__sn_prof_html_hr 9231
typedef t__sn__sn_prof_html_hr t__sn_prof_html_hr;
#define d__sn_prof_html_hr d__sn__sn_prof_html_hr

/* line 95 "/vobs/specman/src/prof_html.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_html_p {
    t__int d__;
    t__int gen__;
} *t__sn__sn_prof_html_p;
#define d__sn__sn_prof_html_p 9232
typedef t__sn__sn_prof_html_p t__sn_prof_html_p;
#define d__sn_prof_html_p d__sn__sn_prof_html_p

/* line 99 "/vobs/specman/src/prof_html.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_html_nbsp {
    t__int d__;
    t__int gen__;
} *t__sn__sn_prof_html_nbsp;
#define d__sn__sn_prof_html_nbsp 9233
typedef t__sn__sn_prof_html_nbsp t__sn_prof_html_nbsp;
#define d__sn_prof_html_nbsp d__sn__sn_prof_html_nbsp

/* line 73 "/vobs/specman/src/prof_html.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_html_string {
    t__int d__;
    t__int gen__;
    t__string data;
    t__string escaped;
} *t__sn__sn_prof_html_string;
#define d__sn__sn_prof_html_string 9229
typedef t__sn__sn_prof_html_string t__sn_prof_html_string;
#define d__sn_prof_html_string d__sn__sn_prof_html_string

/* line 303 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_reporting {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_report_data *data;
    struct s__sn__sn_prof_html_maker *html;
    t__string prf_file_name;
    t__int exclude;
    t__string out_fname;
    struct s__k__sn__sn_prof_source_103547 *source_files;
    struct s__sn__sn_prof_entity_tree *et;
    t__bool suppress_src_msg;
} *t__sn__sn_prof_reporting;
#define d__sn__sn_prof_reporting 9274
typedef t__sn__sn_prof_reporting t__sn_prof_reporting;
#define d__sn_prof_reporting d__sn__sn_prof_reporting

/* line 93 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_report_data {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_entity_tree *et;
    struct s__sn__sn_prof_activity_summary *summary;
    struct s__sn__sn_prof_summary_by102117 *summary_by_category;
    struct s__k__sn__sn_prof_entity__name *interesting;
    struct s__k__sn__sn_prof_entity__name *user_by_self_plus_callees_cycles;
    struct s__k__sn__sn_prof_entity__name *by_cycles;
    struct s__k__sn__sn_prof_entity__name *by_self_plus_callees_cycles;
    struct s__l__uint *te_evals;
    struct s__l__uint *event_occs;
    t__bool te_evals_saved;
    t__int ticks;
} *t__sn__sn_prof_report_data;
#define d__sn__sn_prof_report_data 9268
typedef t__sn__sn_prof_report_data t__sn_prof_report_data;
#define d__sn_prof_report_data d__sn__sn_prof_report_data

/* line 36 "/vobs/specman/src/prof_entity_tree.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_entity_tree {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_entity *root;
    struct s__sn__sn_prof_long *time;
    struct s__sn__sn_prof_long *samples;
    struct s__sn__sn_prof_long *total;
    struct s__k__sn__sn_prof_entity__name *entities;
    struct s__k__sn__sn_prof_categor103540 *categories;
    struct s__k__sn__sn_prof_name_pa103541 *real2context;
    struct s__k__sn__sn_prof_name_pa103541 *context2real;
} *t__sn__sn_prof_entity_tree;
#define d__sn__sn_prof_entity_tree 9290
typedef t__sn__sn_prof_entity_tree t__sn_prof_entity_tree;
#define d__sn_prof_entity_tree d__sn__sn_prof_entity_tree

/* line 7 "/vobs/specman/src/prof_entity_tree.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_entity {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__sn_prof_long *call_count;
    struct s__sn__sn_prof_long *cycle_count;
    struct s__sn__sn_prof_long *self_plus_callees_cycle_count;
    struct s__l__sn__sn_prof_call *callers;
    struct s__l__sn__sn_prof_call *callees;
    struct s__l__string *categories;
    t__int level;
    struct s__sn__sn_prof_long *promils;
    t__int index;
} *t__sn__sn_prof_entity;
#define d__sn__sn_prof_entity 9288
typedef t__sn__sn_prof_entity t__sn_prof_entity;
#define d__sn_prof_entity d__sn__sn_prof_entity

/* line 28 "/vobs/specman/src/prof_entity_tree.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_call {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_entity *entity;
    struct s__sn__sn_prof_long *call_count;
    struct s__sn__sn_prof_long *cycle_count;
    struct s__sn__sn_prof_long *promils;
} *t__sn__sn_prof_call;
#define d__sn__sn_prof_call 9289
typedef t__sn__sn_prof_call t__sn_prof_call;
#define d__sn_prof_call d__sn__sn_prof_call

/* line 276 "/vobs/specman/src/prof_summation.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_category {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__sn_prof_long *pre_specman_run_cycles;
    struct s__sn__sn_prof_long *specman_run_cycles;
    struct s__sn__sn_prof_long *cycles;
    struct s__sn__sn_prof_long *self_cycles;
} *t__sn__sn_prof_category;
#define d__sn__sn_prof_category 9180
typedef t__sn__sn_prof_category t__sn_prof_category;
#define d__sn_prof_category d__sn__sn_prof_category

/* line 148 "/vobs/specman/src/prof_entity_tree.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_name_pair {
    t__int d__;
    t__int gen__;
    t__string key;
    t__string value;
} *t__sn__sn_prof_name_pair;
#define d__sn__sn_prof_name_pair 9296
typedef t__sn__sn_prof_name_pair t__sn_prof_name_pair;
#define d__sn_prof_name_pair d__sn__sn_prof_name_pair

/* line 564 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_activity_summary {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_summary_node *top;
    struct s__sn__sn_prof_entity_tree *et;
} *t__sn__sn_prof_activity_summary;
#define d__sn__sn_prof_activity_summary 9277
typedef t__sn__sn_prof_activity_summary t__sn_prof_activity_summary;
#define d__sn_prof_activity_summary d__sn__sn_prof_activity_summary

/* line 630 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_summary_node {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__sn_prof_long *cycles;
    struct s__sn__sn_prof_entity_predicate *predicate;
    struct s__l__sn__sn_prof_summary_node *topics;
    t__bool link;
} *t__sn__sn_prof_summary_node;
#define d__sn__sn_prof_summary_node 9279
typedef t__sn__sn_prof_summary_node t__sn_prof_summary_node;
#define d__sn_prof_summary_node d__sn__sn_prof_summary_node

/* line 679 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_entity_predicate {
    t__int d__;
    t__int gen__;
} *t__sn__sn_prof_entity_predicate;
#define d__sn__sn_prof_entity_predicate 9280
typedef t__sn__sn_prof_entity_predicate t__sn_prof_entity_predicate;
#define d__sn_prof_entity_predicate d__sn__sn_prof_entity_predicate

/* line 718 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_summary_by102117 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_prof_summary103543 *nodes;
    struct s__l__sn__sn_prof_category *categories;
} *t__sn__sn_prof_summary_by_category;
#define d__sn__sn_prof_summary_by_category 9286
typedef t__sn__sn_prof_summary_by_category t__sn_prof_summary_by_category;
#define d__sn_prof_summary_by_category d__sn__sn_prof_summary_by_category

/* line 715 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_summary_by103545 {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__sn_prof_long *cycles;
} *t__sn__sn_prof_summary_by_category_node;
#define d__sn__sn_prof_summary_by_category_node 9285
typedef t__sn__sn_prof_summary_by_category_node t__sn_prof_summary_by_category_node;
#define d__sn_prof_summary_by_category_node d__sn__sn_prof_summary_by_category_node

/* line 874 "/vobs/specman/src/prof_reporting.e"  From 'struct definition' */
typedef struct s__sn__sn_prof_source_file {
    t__int d__;
    t__int gen__;
    t__string module_name;
    struct s__l__string *lines;
} *t__sn__sn_prof_source_file;
#define d__sn__sn_prof_source_file 9287
typedef t__sn__sn_prof_source_file t__sn_prof_source_file;
#define d__sn_prof_source_file d__sn__sn_prof_source_file

/* line 1782 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__sn_memory_options {
    t__int d__;
    t__int gen__;
    t__uint threshold_size_0;
    t__uint threshold_size_1;
    t__uint otf_threshold_size_0;
    t__uint otf_threshold_size_1;
    t__int increment_size_0;
    t__int increment_size_1;
    t__int otf_increment_size_0;
    t__int otf_increment_size_1;
    t__bool no_print_msg;
    t__bool print_otf_msg;
    t__uint max_size_0;
    t__uint max_size_1;
    t__uint absolute_max_size_0;
    t__uint absolute_max_size_1;
    t__bool retain_printed_structs;
    t__bool retain_trace_structs;
    t__uint max_retained_structs;
} *t__sn__sn_memory_options;
#define d__sn__sn_memory_options 245
typedef t__sn__sn_memory_options t__sn_memory_options;
#define d__sn_memory_options d__sn__sn_memory_options

/* line 1926 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__print_options {
    t__int d__;
    t__int gen__;
    t__int items;
    t__bool hide_title;
    t__bool show_control_chars;
    t__bool hide_module_dividers;
    struct s__l__string *root___title_list;
    struct s__l__string *root___value_list;
    t__int after_module_num;
    t__int sn___databrowser_items_in_line;
    t__string win_title;
    t__string source_viewer;
    t__int list_item_width;
    struct s__sn__print_config_options *config_print___keep_config;
    struct s__sn__print_config_options *config_print___next_config;
} *t__e_core__print_options;
#define d__e_core__print_options 112
typedef t__e_core__print_options t__print_options;
#define d__print_options d__e_core__print_options

/* line 2027 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__compatibility_opt475 {
    t__int d__;
    t__int gen__;
    t__bool use_old_byte_array;
    t__bool use_colon_block;
    t__bool use_old_short_arithmetic;
    t__bool run_extra_half_cycle;
} *t__e_core__compatibility_options;
#define d__e_core__compatibility_options 115
typedef t__e_core__compatibility_options t__compatibility_options;
#define d__compatibility_options d__e_core__compatibility_options

/* line 879 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__files {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool add_e_extension;
    t__bool read_include_comments;
    struct s__l__e_core__file *open_files;
    struct s__l__string *p___tmp_de_list;
    t__bool p___de_alert_on;
} *t__e_core__files;
#define d__e_core__files 77
typedef t__e_core__files t__files;
#define d__files d__e_core__files

/* line 1196 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__interactive_scope {
    t__int d__;
    t__int gen__;
    struct s__l__sn__local *locals;
    struct s__sn__scope *previous;
    t__int total_num_of_locals;
    struct s__sn__activation_record *activation_record;
    struct s__l__sn__sn_value_holder *value_holders;
} *t__sn__interactive_scope;
#define d__sn__interactive_scope 198
typedef t__sn__interactive_scope t__interactive_scope;
#define d__interactive_scope d__sn__interactive_scope

/* line 1067 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__pgen3 {
    t__int d__;
    t__int gen__;
    t__uint long_max_width;
    t__sn_rl__rnd_policy rnd_policy;
    struct s__sn__seed_domain *user_domain;
    t__int user_seed;
    t__bool warn;
    t__bool errors_during_static_analysis;
    t__bool has_list_constraint;
    struct s__sn__pgen3_debug *pgen3_debug;
    struct s__sn__field_holder *temp_fl;
    t__sn__count max_depth;
    t__sn__count max_num_of_structs;
    t__bool bits_uni_directional;
    struct s__k__sn__index__it *list_constraint_ids;
    struct s__sn__pgen_flags *flags;
    t__bool reorder_fields;
    t__bool sa_on_demand;
    t__sn__count last_analysis_stamp;
    struct s__sn__field *gen_prof_field;
    t__sn__index gen_prof_role_id;
    t__sn__index gen_prof_reachable_struct;
    t__sn__index gen_prof_gc_index;
    t__sn__count max_structs;
    t__sn__count default_max_structs;
    struct s__l__sn__count *alloc_types;
    t__sn__count alloc_struct_count;
    t__sn__gen_phase current_phase;
    t__imp_enum_sn__pgen3__gen_status gen_status;
    t__source_ref gotf_source_ref;
    t__bool skip_contradiction;
    t__sn__count no_of_contradictions;
    struct s__l__e_core__source_item *sis;
    struct s__sn__gen_constraint *related_gc;
    struct s__sn__pgen3_debug *deb;
    t__bool use_visual_deb;
    t__bool debug;
    t__imp_enum_sn__pgen3__visual_deb_level visual_deb_level;
    struct s__sn__gen_order_manager *om;
    struct s__sn__sn_type_role_path *tmp_abs_path_type;
    struct s__sn__sn_suffix_fields_ro48626 *tmp_abs_path_suffix;
    struct s__sn__sn_gotf_fields_role_path *tmp_abs_path_gotf;
    t__sn__gen_static_phase gen_static_phase;
    struct s__sn__role_manager *role_manager;
    struct s__sn__static_order *static_order;
    t__bool error_occured_during_gen;
    struct s__sn__yolka_inhibitor *yolka_inhibitor;
    t__bool when_opt;
    t__bool opt_sa_mem;
    struct s__sn__field_gen_role *related_fgr;
    struct s__k__sn__role_count__role_str *role_counts;
    struct s__l__sn__gotf_info *gotf_infos;
    struct s__k__sn__gotf_count__gotf_id *gotf_counts;
    t__uint rhb_type;
    t__uint rhb_type_gotf;
    t__uint rhb_field;
    t__bool do_static_checks;
    struct s__sn__final_fgr_info_none *ffin;
    struct s__sn__a_role *role_to_order;
    struct s__l__sn__static_om_f *static_om_fields;
    t__imp_enum_sn__pgen3__fast_gen_level fast_gen_level;
    struct s__sn_rl__uint_rl *default_list_size_rl;
    t__sn__count default_min_list_size;
    t__sn__count default_max_list_size;
    struct s__l__sn__sn_me_cpi *tmps_candidates;
    struct s__l__sn__sn_me_cpi *tmps_needed_tmps;
    struct s__l__sn__sn_me_cpi *tmps_tmps;
    struct s__l__sn__struct_path_item *curr_spis;
    struct s__l__sn__sn_cpi *tmp_cpis;
    struct s__l__sn__field_node *accessible_outputs;
    struct s__l__sn__field_node *ci_outputs;
    struct s__l__sn__field_node *ci_inputs;
    struct s__l__sn__index *last_frame_id;
    t__bool collect_items;
    t__bool deb_was_on;
    struct s__sn__gen_frame *curr_gen_frame;
    struct s__sn__sn_gen_debugger *gen_debugger;
    t__bool in_list_temps;
    struct s__sn__list_path_item *temps_list;
    t__bool event_browser_is_on;
    struct s__sn__sn_start_preorder_event *start_spe;
    t__sn__count n_ordered_fields;
    struct s__l__sn__sn_preorder_top_event *ptes;
    struct s__l__sn__sn_static_edge_event *sees;
    struct s__l__sn__field_node *all_field_nodes;
    struct s__l__sn__field_node *pending_list_items;
    struct s__l__sn__sn_compute_selec54691 *csss;
    struct s__sn__sn_compute_select_struct *current_css;
    t__uint in_all_iterations_stack;
    struct s__e_core__any_struct *alloc_for_iter;
    t__string last_warn_msg;
    struct s__l__string *stats_struct_name;
    struct s__l__sn__struct_status *stats_table;
} *t__e_core__pgen3;
#define d__e_core__pgen3 88
typedef t__e_core__pgen3 t__pgen3;
#define d__pgen3 d__e_core__pgen3

/* line 32 "/vobs/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__sn__pgen3_debug {
    t__int d__;
    t__int gen__;
    t__imp_enum_sn__pgen3_debug__phase phase;
    t__imp_enum_sn__pgen3_debug__level level;
    t__bool static_warnings;
    t__bool dynamic_checking;
    t__bool should_issue_check;
    struct s__l__sn__field *might_be_infinite;
    struct s__l__sn__struct_descriptor *might_be_infinite_holder;
    struct s__l__sn__field *two_output_fields;
    struct s__l__sn__field *output_and_cons_fields;
    struct s__sn__pgen3_debug_flags *flags;
    struct s__l__sn__index *gen_struct_stack;
    struct s__sn__debug_order *debug_order;
    struct s__sn__pgen3_debug_tgrq_manager *tgrq_manager;
    t__bool expand_in_progress;
    t__bool check_unsatisfied_constraints;
    t__sn__index end_static_time;
    t__sn__index shown_msg_time;
    t__int current_nesting;
    t__uint depth;
    t__bool show_prefix_on_each_line;
    t__bool highlight_reductions;
    struct s__l__sn__sn_msg_struct *msg_list;
    struct s__k__sn__sn_msg_set_struc54692 *msg_set_struct_list;
    struct s__l__sn__a_role *roles_list;
    t__sn__sn_show_on_trace show_on_trace;
    t__int show_repeats;
    t__bool fields_flag;
    t__bool details_flag;
    t__bool reordering_flag;
    t__bool reductions_flag;
    t__bool constraints_flag;
    t__bool in_place_flag;
    t__bool last_struct_flag;
    t__bool last_gen_flag;
    t__bool showing_now;
    struct s__l__sn__sn_msg_show_request *show_requests;
    struct s__e_core__base_struct *show_gen_struct;
    struct s__k__sn__sn_gen_repeat_co54694 *repeat_counters;
    struct s__k__sn__sn_gen_string_re54696 *string_repeat_counters;
    struct s__l__sn__sn_msg_start_gen *start_gen_stack;
    struct s__k__e_core__base_struct__it *start_gen_finals;
} *t__sn__pgen3_debug;
#define d__sn__pgen3_debug 2085
typedef t__sn__pgen3_debug t__pgen3_debug;
#define d__pgen3_debug d__sn__pgen3_debug

/* line 24 "/vobs/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__sn__pgen3_debug_flags {
    t__int d__;
    t__int gen__;
    t__bool dropped_constraints;
    t__bool display_order_graph;
    t__bool trace_gen_request_causes_static_analysis;
    t__bool pretty_print_simple_parenthesis;
} *t__sn__pgen3_debug_flags;
#define d__sn__pgen3_debug_flags 2126
typedef t__sn__pgen3_debug_flags t__pgen3_debug_flags;
#define d__pgen3_debug_flags d__sn__pgen3_debug_flags

/* line 45 "/vobs/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__sn__debug_order {
    t__int d__;
    t__int gen__;
    struct s__sn__gdo_graph *gdo_graph;
    t__sn__index time;
    struct s__sn__composite_descriptor *sd;
    t__sn__index holder_time;
    struct s__e_core__base_struct *holder;
    struct s__l__sn__field *fs_and_tfs;
    struct s__l__bool *active_fields;
    struct s__l__sn__sn_msg_struct *ml;
    struct s__sn__gdo_mw_find_generat54697 *gdo_mw_find_generated_fields;
    struct s__sn__gdo_mw_find_active_edges *gdo_mw_find_active_edges;
} *t__sn__debug_order;
#define d__sn__debug_order 2128
typedef t__sn__debug_order t__debug_order;
#define d__debug_order d__sn__debug_order

/* line 35 "/vobs/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__sn__gdo_graph {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gdo_node *nodes;
    struct s__l__sn__gdo_edge *edges;
    struct s__l__sn__gdo_frc *frcs;
    t__bool recursivly_check_cycle_in_frcs;
    struct s__sn__sn_msg_struct *msg_gen_holder;
} *t__sn__gdo_graph;
#define d__sn__gdo_graph 2127
typedef t__sn__gdo_graph t__gdo_graph;
#define d__gdo_graph d__sn__gdo_graph

/* line 16 "/vobs/specman/src/gen_debug_order_graph.e"  From 'struct definition' */
typedef struct s__sn__gdo_node {
    t__int d__;
    t__int gen__;
    t__sn__index index;
    t__string name;
    t__sn__gdo_node_kind kind;
    struct s__sn__gdo_frc *frc;
} *t__sn__gdo_node;
#define d__sn__gdo_node 6099
typedef t__sn__gdo_node t__gdo_node;
#define d__gdo_node d__sn__gdo_node

/* line 36 "/vobs/specman/src/gen_debug_order_graph.e"  From 'struct definition' */
typedef struct s__sn__gdo_frc {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gdo_node *nodes;
    t__sn__index index;
    struct s__l__sn__gdo_edge *internal_edges;
    struct s__l__sn__gdo_edge *out_edges;
    t__bool in_stack;
    t__bool visited;
} *t__sn__gdo_frc;
#define d__sn__gdo_frc 6101
typedef t__sn__gdo_frc t__gdo_frc;
#define d__gdo_frc d__sn__gdo_frc

/* line 26 "/vobs/specman/src/gen_debug_order_graph.e"  From 'struct definition' */
typedef struct s__sn__gdo_edge {
    t__int d__;
    t__int gen__;
    t__bool contradicting;
    struct s__sn__gdo_node *n1;
    struct s__sn__gdo_node *n2;
    struct s__sn__sn_msg_create_edge *msg;
    t__bool visited;
    struct s__sn__simple_gen_constraint *gc;
} *t__sn__gdo_edge;
#define d__sn__gdo_edge 6100
typedef t__sn__gdo_edge t__gdo_edge;
#define d__gdo_edge d__sn__gdo_edge

/* line 1927 "/vobs/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn__sn_msg_create_edge {
    t__int d__;
    t__int gen__;
    t__sn__index index;
    struct s__sn__sn_msg_start_gen *last_start_gen;
    t__bool soft;
    t__sn__om_edge_reason reason;
    struct s__e_core__source_item *si;
    t__bool dynamic;
    struct s__e_core__base_struct *holder;
    t__string fs1;
    t__string fs2;
} *t__sn__sn_msg_create_edge;
#define d__sn__sn_msg_create_edge 6085
typedef t__sn__sn_msg_create_edge t__sn_msg_create_edge;
#define d__sn_msg_create_edge d__sn__sn_msg_create_edge

/* line 1320 "/vobs/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn__sn_msg_start_gen {
    t__int d__;
    t__int gen__;
    t__sn__index index;
    t__sn__index end_order_index;
    struct s__e_core__source_item *si;
    struct s__e_core__base_struct *holder;
    t__string path;
    struct s__e_core__time *time;
    struct s__e_core__base_struct *final_holder;
    t__string final_holder_path;
    t__bool shown_already;
    t__sn__sn_gen_boring_status boring_status;
} *t__sn__sn_msg_start_gen;
#define d__sn__sn_msg_start_gen 6076
typedef t__sn__sn_msg_start_gen t__sn_msg_start_gen;
#define d__sn_msg_start_gen d__sn__sn_msg_start_gen

/* line 187 "/vobs/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn__sn_msg_struct {
    t__int d__;
    t__int gen__;
    t__sn__index index;
} *t__sn__sn_msg_struct;
#define d__sn__sn_msg_struct 6064
typedef t__sn__sn_msg_struct t__sn_msg_struct;
#define d__sn_msg_struct d__sn__sn_msg_struct

/* line 341 "/vobs/specman/src/gen_debug_order.e"  From 'struct definition' */
typedef struct s__sn__gdo_mw_find_generat54697 {
    t__int d__;
    t__int gen__;
    struct s__sn__debug_order *f__do;
} *t__sn__gdo_mw_find_generated_fields;
#define d__sn__gdo_mw_find_generated_fields 6108
typedef t__sn__gdo_mw_find_generated_fields t__gdo_mw_find_generated_fields;
#define d__gdo_mw_find_generated_fields d__sn__gdo_mw_find_generated_fields

/* line 362 "/vobs/specman/src/gen_debug_order.e"  From 'struct definition' */
typedef struct s__sn__gdo_mw_find_active_edges {
    t__int d__;
    t__int gen__;
    struct s__sn__debug_order *f__do;
} *t__sn__gdo_mw_find_active_edges;
#define d__sn__gdo_mw_find_active_edges 6109
typedef t__sn__gdo_mw_find_active_edges t__gdo_mw_find_active_edges;
#define d__gdo_mw_find_active_edges d__sn__gdo_mw_find_active_edges

/* line 71 "/vobs/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__sn__pgen3_debug_tgrq_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__trace_gen_request *trqs;
    t__bool changed;
} *t__sn__pgen3_debug_tgrq_manager;
#define d__sn__pgen3_debug_tgrq_manager 2130
typedef t__sn__pgen3_debug_tgrq_manager t__pgen3_debug_tgrq_manager;
#define d__pgen3_debug_tgrq_manager d__sn__pgen3_debug_tgrq_manager

/* line 1550 "/vobs/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn__sn_msg_set_struct {
    t__int d__;
    t__int gen__;
    t__sn__index index;
    t__sn__index end_order_index;
    struct s__sn__a_role *role;
    struct s__e_core__base_struct *holder;
    t__string fs;
    struct s__e_core__base_struct *value;
    t__string from_range;
    t__string struct_path;
    struct s__sn__sn_msg_start_gen *last_start_gen;
    t__bool is_gotf_path_only;
    struct s__sn__a_role *most_specific_role;
    t__bool shown_already;
    t__sn__sn_gen_boring_status boring_status;
} *t__sn__sn_msg_set_struct;
#define d__sn__sn_msg_set_struct 6079
typedef t__sn__sn_msg_set_struct t__sn_msg_set_struct;
#define d__sn_msg_set_struct d__sn__sn_msg_set_struct

/* line 49 "/vobs/specman/src/gen_msg_header.e"  From 'struct definition' */
typedef struct s__sn__sn_msg_show_request {
    t__int d__;
    t__int gen__;
    t__sn__sn_msg_show_request_kind kind;
    struct s__e_core__base_struct *the_struct;
    t__string type;
    t__string field;
    t__string type_re;
    t__pat type_pat;
    t__string field_re;
    t__pat field_pat;
    t__string chupchik_field;
    t__string chupchik_field_re;
    t__pat chupchik_field_pat;
} *t__sn__sn_msg_show_request;
#define d__sn__sn_msg_show_request 2135
typedef t__sn__sn_msg_show_request t__sn_msg_show_request;
#define d__sn_msg_show_request d__sn__sn_msg_show_request

/* line 891 "/vobs/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_repeat_counter {
    t__int d__;
    t__int gen__;
    t__source_ref sr;
    struct s__e_core__base_struct *unique_item;
    struct s__l__e_core__base_struct *repetitions;
    t__bool wrote_comment;
} *t__sn__sn_gen_repeat_counter;
#define d__sn__sn_gen_repeat_counter 6071
typedef t__sn__sn_gen_repeat_counter t__sn_gen_repeat_counter;
#define d__sn_gen_repeat_counter d__sn__sn_gen_repeat_counter

/* line 901 "/vobs/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_string_repea54808 {
    t__int d__;
    t__int gen__;
    t__string unique_item;
    struct s__l__string *repetitions;
    t__bool wrote_comment;
} *t__sn__sn_gen_string_repeat_counter;
#define d__sn__sn_gen_string_repeat_counter 6072
typedef t__sn__sn_gen_string_repeat_counter t__sn_gen_string_repeat_counter;
#define d__sn_gen_string_repeat_counter d__sn__sn_gen_string_repeat_counter

/* line 11 "/vobs/specman/src/gen_basic.e"  From 'struct definition' */
typedef struct s__sn__pgen_flags {
    t__int d__;
    t__int gen__;
    t__bool do_static_checks;
    t__bool show_structs_only;
    t__bool show_full_path;
    t__bool show_internal_info;
    t__bool show_unchanged_reduced_fields;
    t__bool show_other_reduced_fields;
} *t__sn__pgen_flags;
#define d__sn__pgen_flags 2113
typedef t__sn__pgen_flags t__pgen_flags;
#define d__pgen_flags d__sn__pgen_flags

/* line 19 "/vobs/specman/src/gen_om_interface.e"  From 'struct definition' */
typedef struct s__sn__gen_order_manager {
    t__int d__;
    t__int gen__;
    struct s__k__sn__om_item_node__it *hashed_backwards_dfs;
    struct s__l__sn__om_frame *frames;
    struct s__sn__om_frame *cur_frame;
    t__int cur_frame_idx;
    t__bool reorder_fields;
    t__bool resolve_cycles;
    struct s__l__int *frame_idx_diff;
    struct s__l__sn__om_item_node *nodes_map;
    t__int nodes_map_top;
    t__int last_id;
} *t__sn__gen_order_manager;
#define d__sn__gen_order_manager 2146
typedef t__sn__gen_order_manager t__gen_order_manager;
#define d__gen_order_manager d__sn__gen_order_manager

/* line 67 "/vobs/specman/src/gen_om_item.e"  From 'struct definition' */
typedef struct s__sn__om_item_node {
    t__int d__;
    t__int gen__;
    t__int id;
    t__bool f__void;
    struct s__sn__om_node *frc_repr;
    t__int in_degree;
    t__int soft_in_degree;
    struct s__l__sn__om_item_node *in_edges;
    struct s__l__sn__om_item_node *soft_in_edges;
    t__int frame_idx;
    t__int cur_in_degree;
    t__int cur_soft_in_degree;
    t__int cur_min_id;
    t__int heap_idx;
    struct s__l__sn__om_item_node *edges;
    struct s__l__sn__om_item_node *soft_edges;
    struct s__sn__om_item_node *right;
    struct s__sn__om_item_node *left;
    struct s__sn__om_item_node *right_dof;
    struct s__sn__om_item_node *left_dof;
    t__imp_enum_sn__om_item_node__color color;
    t__int min_id;
    struct s__sn__om_item_node *min_id_root;
    t__int min_id_stamp;
    t__int min_id_root_stamp;
} *t__sn__om_item_node;
#define d__sn__om_item_node 5889
typedef t__sn__om_item_node t__om_item_node;
#define d__om_item_node d__sn__om_item_node

/* line 16 "/vobs/specman/src/gen_om_item.e"  From 'struct definition' */
typedef struct s__sn__om_node {
    t__int d__;
    t__int gen__;
    t__int id;
    t__bool f__void;
    struct s__sn__om_node *frc_repr;
    t__int in_degree;
    t__int soft_in_degree;
    struct s__l__sn__om_item_node *in_edges;
    struct s__l__sn__om_item_node *soft_in_edges;
    t__int frame_idx;
    t__int cur_in_degree;
    t__int cur_soft_in_degree;
    t__int cur_min_id;
    t__int heap_idx;
} *t__sn__om_node;
#define d__sn__om_node 5888
typedef t__sn__om_node t__om_node;
#define d__om_node d__sn__om_node

/* line 20 "/vobs/specman/src/gen_om_frame.e"  From 'struct definition' */
typedef struct s__sn__om_frame {
    t__int d__;
    t__int gen__;
    t__int min_id;
    t__int max_id;
    struct s__l__sn__om_node *nodes_heap;
    struct s__l__sn__om_item_node *returned_nodes;
    t__int heap_size;
    struct s__l__sn__om_node *all_frc_reprs;
} *t__sn__om_frame;
#define d__sn__om_frame 5894
typedef t__sn__om_frame t__om_frame;
#define d__om_frame d__sn__om_frame

/* line 235 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__sn_type_role_path {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *start_type;
    struct s__sn__composite_descriptor *as_a_type;
    struct s__sn__composite_descriptor *end_type;
    struct s__l__sn__field_holder *fields;
    t__sn__index last_field;
    t__sn__index gen_on_the_fly_index;
} *t__sn__sn_type_role_path;
#define d__sn__sn_type_role_path 5626
typedef t__sn__sn_type_role_path t__sn_type_role_path;
#define d__sn_type_role_path d__sn__sn_type_role_path

/* line 237 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__sn_suffix_fields_ro48626 {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *start_type;
    struct s__sn__composite_descriptor *as_a_type;
    struct s__sn__composite_descriptor *end_type;
    struct s__l__sn__field_holder *fields;
    t__sn__index last_field;
    t__sn__index gen_on_the_fly_index;
} *t__sn__sn_suffix_fields_role_path;
#define d__sn__sn_suffix_fields_role_path 5628
typedef t__sn__sn_suffix_fields_role_path t__sn_suffix_fields_role_path;
#define d__sn_suffix_fields_role_path d__sn__sn_suffix_fields_role_path

/* line 238 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__sn_gotf_fields_role_path {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *start_type;
    struct s__sn__composite_descriptor *as_a_type;
    struct s__sn__composite_descriptor *end_type;
    struct s__l__sn__field_holder *fields;
    t__sn__index last_field;
    t__sn__index gen_on_the_fly_index;
} *t__sn__sn_gotf_fields_role_path;
#define d__sn__sn_gotf_fields_role_path 5629
typedef t__sn__sn_gotf_fields_role_path t__sn_gotf_fields_role_path;
#define d__sn_gotf_fields_role_path d__sn__sn_gotf_fields_role_path

/* line 612 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__role_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__a_role *all_roles;
    struct s__k__sn__a_role__key_number *hashed_roles;
    struct s__sn__a_root_role *root;
} *t__sn__role_manager;
#define d__sn__role_manager 5650
typedef t__sn__role_manager t__role_manager;
#define d__role_manager d__sn__role_manager

/* line 2700 "/vobs/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__sn__a_root_role {
    t__int d__;
    t__int gen__;
    t__sn__index role_id;
    struct s__sn__sn_role_path *key;
    t__sn__index pos_in_gen_path;
    t__sn__index index_in_sd;
    t__bool is_list;
    t__imp_enum_sn__a_role__debug_it debug_it;
    struct s__l__bool *debug_fields;
    t__bool for_debug_only;
    t__string role_name;
    t__int role_hashed;
    struct s__sn__a_role *more_general_role;
    struct s__l__sn__a_role *more_specific_roles;
    struct s__l__sn__om_edge *when_om_edges;
    struct s__l__sn__om_edge *om_edges;
    struct s__l__sn__index *is_dof;
    struct s__l__sn__om_edge_reason *dof_reasons;
    t__bool cannot_be_statically_ordered;
    t__sn__index executed_size;
    t__sn__index field_gen_role_size;
    struct s__k__sn__field_gen_role__id *field_gen_roles;
    struct s__l__sn__status_in_role *f_stats;
    t__bool might_change_gc_stats;
    struct s__l__sn__index *start_parent_gcs;
    struct s__k__sn__role_gc_stat__gc *gc_stats;
    struct s__k__sn__gc_last_reduction__gc *gc_lrs;
    t__bool is_gotf_root;
    struct s__sn__role_subtype_info *subtype_info;
    t__sn__count n_non_temp_fields;
    t__sn__count n_fields;
    struct s__l__sn__index *has_down_gcs;
    struct s__l__sn__a_role *sub_type_roles;
    struct s__sn__a_role *super_type_role;
    t__bool is_like_hook;
    t__uint last_f_stats;
    t__sn__sn_role_creation_t created_by;
    t__bool graph_visited;
    t__uint key_number;
    struct s__sn__a_role *next_hashed_role;
    t__imp_enum_sn__a_role__gc_proc_status gc_proc_status;
    t__bool was_inited;
    t__bool sb_allow_iteration;
    t__uint no_executions;
    t__bool is_executed;
    struct s__l__sn__final_fgr_info_none *final_fgr_infos;
    struct s__l__sn__gen_command *gcoms;
    struct s__k__sn__field__it *fast_fields;
    struct s__l__sn__field *fixed_fast_fields;
    struct s__l__int *fixed_fast_fields_values;
    struct s__sn__struct_descriptor *fast_subtype;
    struct s__k__sn__init_graph_gen_c48777 *graphs;
    struct s__l__sn__subtype_descriptor *static_contributors;
    t__int no_of_init_graphs;
    struct s__sn__struct_descriptor *last_never;
    struct s__sn__struct_descriptor *last_always;
    t__uint counter;
} *t__sn__a_root_role;
#define d__sn__a_root_role 5743
typedef t__sn__a_root_role t__a_root_role;
#define d__a_root_role d__sn__a_root_role

/* line 666 "/vobs/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__sn__static_order {
    t__int d__;
    t__int gen__;
    struct s__l__sn__fields_constrain48780 *both;
    t__uint geb_stamp;
    struct s__l__sn__fields_constrain48780 *cps;
    struct s__l__bool *from_b;
    struct s__l__bool *to_b;
    struct s__l__sn__index *li;
    struct s__l__sn__index *lo;
    struct s__sn__prefix_tree_stat *prefix_tree_stat;
} *t__sn__static_order;
#define d__sn__static_order 5653
typedef t__sn__static_order t__static_order;
#define d__static_order d__sn__static_order

/* line 139 "/vobs/specman/src/gen_static_reorder.e"  From 'struct definition' */
typedef struct s__sn__prefix_tree_stat {
    t__int d__;
    t__int gen__;
    t__bool is_soft;
    t__sn__om_edge_reason om_edge_reason;
    t__bool is_bid;
    struct s__sn__simple_gen_constraint *gc;
    struct s__sn__composite_descriptor *start_sd;
    t__uint stamp;
} *t__sn__prefix_tree_stat;
#define d__sn__prefix_tree_stat 5802
typedef t__sn__prefix_tree_stat t__prefix_tree_stat;
#define d__prefix_tree_stat d__sn__prefix_tree_stat

/* line 581 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__yolka_inhibitor {
    t__int d__;
    t__int gen__;
} *t__sn__yolka_inhibitor;
#define d__sn__yolka_inhibitor 5701
typedef t__sn__yolka_inhibitor t__yolka_inhibitor;
#define d__yolka_inhibitor d__sn__yolka_inhibitor

/* line 1820 "/vobs/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__sn__role_count {
    t__int d__;
    t__int gen__;
    t__string role_str;
    t__sn__count role_count;
} *t__sn__role_count;
#define d__sn__role_count 5740
typedef t__sn__role_count t__role_count;
#define d__role_count d__sn__role_count

/* line 1891 "/vobs/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__sn__gotf_info {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd;
    t__string module_name;
    struct s__sn__method *the_method;
    struct s__sn__field *first_field;
    struct s__sn__field *generated_field;
    t__sn__index gen_index;
    struct s__sn__constraint_path *gen_path;
    t__bool has_keeping_gcs;
    struct s__sn__a_role *gotf_role;
    t__source_ref sr;
    t__string id_str;
    struct s__sn__a_role *holder_role;
    struct s__l__sn__a_role *path_roles;
    struct s__k__sn__field__it *relevant_temps;
} *t__sn__gotf_info;
#define d__sn__gotf_info 5741
typedef t__sn__gotf_info t__gotf_info;
#define d__gotf_info d__sn__gotf_info

/* line 1893 "/vobs/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__sn__gotf_count {
    t__int d__;
    t__int gen__;
    t__string gotf_id;
    struct s__sn__gotf_info *gotfi;
} *t__sn__gotf_count;
#define d__sn__gotf_count 5742
typedef t__sn__gotf_count t__gotf_count;
#define d__gotf_count d__sn__gotf_count

/* line 1062 "/vobs/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__sn__static_om_f {
    t__int d__;
    t__int gen__;
    t__bool ordered;
    struct s__l__sn__om_edge *non_exact_edges;
    struct s__l__sn__index *non_exact_inds;
} *t__sn__static_om_f;
#define d__sn__static_om_f 5845
typedef t__sn__static_om_f t__static_om_f;
#define d__static_om_f d__sn__static_om_f

/* line 328 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_frame {
    t__int d__;
    t__int gen__;
    struct s__sn__compound_path_item *gotf_first;
    struct s__sn__compound_path_item *gotf_root;
    t__bool gotf_is_scalar;
    struct s__sn__field *gotf_field;
    t__sn__index gotf_index;
    t__bool gotf_first_is_temp;
    struct s__sn__activation_record *gotf_ar;
    struct s__sn__compound_path_item *gotf_last;
    t__untyped gotf_generated_value;
    struct s__sn__field_node *gotf_field_node;
    t__sn__index gotf_first_ind;
    struct s__e_core__any_struct *gotf_the_me;
    struct s__sn__seed_domain *the_seed_domain;
    struct s__sn__compound_path_item *last;
    t__source_ref sr;
    t__string last_path_collected;
    struct s__l__e_core__any_unit *curr_units;
    t__bool gotf_first_indirect;
    t__bool compiled;
} *t__sn__gen_frame;
#define d__sn__gen_frame 5679
typedef t__sn__gen_frame t__gen_frame;
#define d__gen_frame d__sn__gen_frame

/* line 20 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_debugger {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_debug_data_manager *data;
    struct s__sn__gen_debug_trace_manager *trace_manager;
    struct s__sn__gen_debug_server *server;
    struct s__sn__new_debug_order *order;
    t__bool gui_has_info;
    t__bool gui_is_open;
    t__bool collect_all;
    t__bool full_format_to_range_enum;
} *t__sn__sn_gen_debugger;
#define d__sn__sn_gen_debugger 5906
typedef t__sn__sn_gen_debugger t__sn_gen_debugger;
#define d__sn_gen_debugger d__sn__sn_gen_debugger

/* line 237 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gen_debug_data_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_debugger *parent;
    struct s__sn__instanciated_fields_pool *all_instanciated_fields;
    struct s__k__sn__sn_gen_event__index *all_static_events;
    struct s__k__sn__sn_gen_event__index *all_run_time_events;
    struct s__k__sn__sn_gen_event__index *all_other_events;
    struct s__k__sn__sn_role_info__role_id *all_roles;
    struct s__l__sn__sn_start_gen_event *all_roots;
    struct s__l__sn__sn_gen_root_event *gen_op_stack;
    t__int end_static_time;
    struct s__l__sn__sn_set_value_event *set_value_stack;
    t__int current_key;
    t__int current_event_parameter_key;
    t__int last_refresh_time;
    t__bool needs_refresh;
    struct s__k__sn__sn_event_paramet54778 *all_static_event_parameters;
    struct s__k__sn__sn_event_paramet54778 *all_run_time_event_parameters;
    struct s__k__sn__sn_ci_to_fig__ci *ci_to_figs;
    struct s__k__sn__sn_ci_to_deferred__ci *cis_to_deferred;
} *t__sn__gen_debug_data_manager;
#define d__sn__gen_debug_data_manager 5907
typedef t__sn__gen_debug_data_manager t__gen_debug_data_manager;
#define d__gen_debug_data_manager d__sn__gen_debug_data_manager

/* line 602 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__instanciated_fields_pool {
    t__int d__;
    t__int gen__;
    struct s__k__sn__instanciated_fie54780 *all_instances;
    struct s__l__sn__sn_instanciated_field *all_objects;
} *t__sn__instanciated_fields_pool;
#define d__sn__instanciated_fields_pool 5908
typedef t__sn__instanciated_fields_pool t__instanciated_fields_pool;
#define d__instanciated_fields_pool d__sn__instanciated_fields_pool

/* line 625 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__instanciated_fields54782 {
    t__int d__;
    t__int gen__;
    struct s__e_core__base_struct *instance;
    struct s__k__sn__sn_instanciated_54783 *all_fields;
} *t__sn__instanciated_fields_of_an_instance;
#define d__sn__instanciated_fields_of_an_instance 5909
typedef t__sn__instanciated_fields_of_an_instance t__instanciated_fields_of_an_instance;
#define d__instanciated_fields_of_an_instance d__sn__instanciated_fields_of_an_instance

/* line 1947 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_instanciated_field {
    t__int d__;
    t__int gen__;
    t__int index_in_all_objects;
    struct s__e_core__base_struct *holder;
    struct s__sn__field *f;
    struct s__l__sn__gendb_field_in_gen *all_generations;
} *t__sn__sn_instanciated_field;
#define d__sn__sn_instanciated_field 5963
typedef t__sn__sn_instanciated_field t__sn_instanciated_field;
#define d__sn_instanciated_field d__sn__sn_instanciated_field

/* line 1215 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_start_gen_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__sn__me_gendb_item *item;
    t__bool trace_from_begining;
    t__bool trace_till_end;
    t__bool complete_trace;
    t__bool failed_because_try;
    t__sn__gen_process_status status;
    struct s__k__sn__gendb_field_in_gen__f *all_fields;
    struct s__l__sn__sn_gen_event *all_events;
    struct s__k__sn__gendb_ci_in_gen__gc *me_app_constraints;
    struct s__sn__sn_role_info *role;
    t__bool is_gotf_path;
    struct s__e_core__source_item *si;
    t__uint sys_time;
    t__sn__index serial_number;
    struct s__e_core__base_struct *final_holder;
    t__string final_holder_path;
} *t__sn__sn_start_gen_event;
#define d__sn__sn_start_gen_event 5924
typedef t__sn__sn_start_gen_event t__sn_start_gen_event;
#define d__sn_start_gen_event d__sn__sn_start_gen_event

/* line 917 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_set_value_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__sn__changed_gendb_item *item;
} *t__sn__sn_set_value_event;
#define d__sn__sn_set_value_event 5915
typedef t__sn__sn_set_value_event t__sn_set_value_event;
#define d__sn_set_value_event d__sn__sn_set_value_event

/* line 2835 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__changed_gendb_item {
    t__int d__;
    t__int gen__;
    t__int parameter_index;
    struct s__sn__any_rl *rl;
    struct s__sn__type_descriptor *td;
    struct s__sn__constraint_path *cp;
    struct s__sn__sn_gen_event *holding_event;
    struct s__e_core__base_struct *holder;
    struct s__sn__field *f;
    t__bool fixed;
    t__bool accessible;
    struct s__e_core__base_struct *initial_struct;
    struct s__l__int *path_indexes;
    t__int last_accessible_field;
    t__bool deffered;
    struct s__sn__gendb_field_in_gen *fig;
    t__sn__index index_in_fig;
    struct s__sn__any_rl *pre_rl;
} *t__sn__changed_gendb_item;
#define d__sn__changed_gendb_item 6000
typedef t__sn__changed_gendb_item t__changed_gendb_item;
#define d__changed_gendb_item d__sn__changed_gendb_item

/* line 2447 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_event_parameter {
    t__int d__;
    t__int gen__;
    t__int parameter_index;
} *t__sn__sn_event_parameter;
#define d__sn__sn_event_parameter 5983
typedef t__sn__sn_event_parameter t__sn_event_parameter;
#define d__sn_event_parameter d__sn__sn_event_parameter

/* line 3350 "/vobs/specman/src/gen_gendb_interface.e"  From 'struct definition' */
typedef struct s__sn__sn_ci_to_fig {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_ci_in_gen *ci;
    struct s__l__sn__gendb_field_in_gen *figs;
} *t__sn__sn_ci_to_fig;
#define d__sn__sn_ci_to_fig 6035
typedef t__sn__sn_ci_to_fig t__sn_ci_to_fig;
#define d__sn_ci_to_fig d__sn__sn_ci_to_fig

/* line 3496 "/vobs/specman/src/gen_gendb_interface.e"  From 'struct definition' */
typedef struct s__sn__sn_ci_to_deferred {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_ci_in_gen *ci;
    struct s__k__sn__deferred_par__par_no *deferred_pars;
} *t__sn__sn_ci_to_deferred;
#define d__sn__sn_ci_to_deferred 6037
typedef t__sn__sn_ci_to_deferred t__sn_ci_to_deferred;
#define d__sn_ci_to_deferred d__sn__sn_ci_to_deferred

/* line 3491 "/vobs/specman/src/gen_gendb_interface.e"  From 'struct definition' */
typedef struct s__sn__deferred_par {
    t__int d__;
    t__int gen__;
    t__sn__index par_no;
    struct s__l__sn__changed_gendb_item *deferred_items;
} *t__sn__deferred_par;
#define d__sn__deferred_par 6036
typedef t__sn__deferred_par t__deferred_par;
#define d__deferred_par d__sn__deferred_par

/* line 657 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gen_debug_trace_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_debugger *parent;
    t__bool start_collect_from_begining;
    t__bool collect_now;
    t__bool was_collect_before;
    t__bool complete_collect;
    struct s__l__sn__sn_skeleton_event *stop_tracing_storage;
    struct s__l__sn__sn_gen_root_event *stop_tracing_stack;
} *t__sn__gen_debug_trace_manager;
#define d__sn__gen_debug_trace_manager 5910
typedef t__sn__gen_debug_trace_manager t__gen_debug_trace_manager;
#define d__gen_debug_trace_manager d__sn__gen_debug_trace_manager

/* line 884 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_skeleton_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
} *t__sn__sn_skeleton_event;
#define d__sn__sn_skeleton_event 5914
typedef t__sn__sn_skeleton_event t__sn_skeleton_event;
#define d__sn_skeleton_event d__sn__sn_skeleton_event

/* line 736 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gen_debug_server {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_debugger *parent;
    struct s__sn__sn_gendebugger_deli *gendb_deli;
    struct s__sn__sni_egendebugger_service *e_gendb_service;
} *t__sn__gen_debug_server;
#define d__sn__gen_debug_server 5911
typedef t__sn__gen_debug_server t__gen_debug_server;
#define d__gen_debug_server d__sn__gen_debug_server

/* line 5 "/vobs/specman/src/japp/gendebugger/src/gendb_service_header.e"  From 'struct definition' */
typedef struct s__sn__sn_gendebugger_deli {
    t__int d__;
    t__int gen__;
    struct s__sn__sni_jgendebugger_service *j_gendb_service;
} *t__sn__sn_gendebugger_deli;
#define d__sn__sn_gendebugger_deli 6214
typedef t__sn__sn_gendebugger_deli t__sn_gendebugger_deli;
#define d__sn_gendebugger_deli d__sn__sn_gendebugger_deli

/* line 5 "/vobs/specman/src/japp/gendebugger/gendb_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jgendebugger_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jgendebugger_service;
#define d__sn__sni_jgendebugger_service 6211
typedef t__sn__sni_jgendebugger_service t__sni_jgendebugger_service;
#define d__sni_jgendebugger_service d__sn__sni_jgendebugger_service

/* line 2 "/vobs/specman/src/japp/gendebugger/gendb_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_egendebugger_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_egendebugger_service;
#define d__sn__sni_egendebugger_service 6210
typedef t__sn__sni_egendebugger_service t__sni_egendebugger_service;
#define d__sni_egendebugger_service d__sn__sni_egendebugger_service

/* line 775 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__new_debug_order {
    t__int d__;
    t__int gen__;
    t__sn__index time;
    struct s__e_core__base_struct *subject;
    t__string subject_prefix;
    struct s__e_core__base_struct *internal_subject;
    struct s__sn__composite_descriptor *sd;
    struct s__l__sn__field *fs_and_tfs;
    struct s__l__bool *active_fields;
    struct s__sn__new_gdo_graph *gdo_graph;
} *t__sn__new_debug_order;
#define d__sn__new_debug_order 5912
typedef t__sn__new_debug_order t__new_debug_order;
#define d__new_debug_order d__sn__new_debug_order

/* line 704 "/vobs/specman/src/japp/gendebugger/src/gendb_order_manager.e"  From 'struct definition' */
typedef struct s__sn__new_gdo_graph {
    t__int d__;
    t__int gen__;
    struct s__l__sn__new_gdo_node *nodes;
    struct s__l__sn__new_gdo_edge *edges;
    struct s__l__sn__new_gdo_frc *frcs;
    t__bool recursivly_check_cycle_in_frcs;
    struct s__sn__new_debug_order *debug_order;
} *t__sn__new_gdo_graph;
#define d__sn__new_gdo_graph 6389
typedef t__sn__new_gdo_graph t__new_gdo_graph;
#define d__new_gdo_graph d__sn__new_gdo_graph

/* line 471 "/vobs/specman/src/japp/gendebugger/src/gendb_order_manager.e"  From 'struct definition' */
typedef struct s__sn__new_gdo_node {
    t__int d__;
    t__int gen__;
    t__sn__index index;
    t__string name;
    struct s__sn__field *f;
    t__string prefix;
    t__sn__new_gdo_node_kind kind;
    struct s__sn__new_gdo_frc *frc;
} *t__sn__new_gdo_node;
#define d__sn__new_gdo_node 6386
typedef t__sn__new_gdo_node t__new_gdo_node;
#define d__new_gdo_node d__sn__new_gdo_node

/* line 556 "/vobs/specman/src/japp/gendebugger/src/gendb_order_manager.e"  From 'struct definition' */
typedef struct s__sn__new_gdo_frc {
    t__int d__;
    t__int gen__;
    t__sn__index index;
    struct s__l__sn__new_gdo_node *nodes;
    struct s__l__sn__new_gdo_edge *internal_edges;
    struct s__l__sn__new_gdo_edge *out_edges;
    t__bool in_stack;
    t__bool visited;
} *t__sn__new_gdo_frc;
#define d__sn__new_gdo_frc 6388
typedef t__sn__new_gdo_frc t__new_gdo_frc;
#define d__new_gdo_frc d__sn__new_gdo_frc

/* line 500 "/vobs/specman/src/japp/gendebugger/src/gendb_order_manager.e"  From 'struct definition' */
typedef struct s__sn__new_gdo_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_create_edge_event *content;
    struct s__sn__new_gdo_node *n1;
    struct s__sn__new_gdo_node *n2;
    t__bool visited;
} *t__sn__new_gdo_edge;
#define d__sn__new_gdo_edge 6387
typedef t__sn__new_gdo_edge t__new_gdo_edge;
#define d__new_gdo_edge d__sn__new_gdo_edge

/* line 1660 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_create_edge_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__sn__gendb_field *from;
    struct s__sn__gendb_field *to;
    t__sn__om_edge_reason reason;
    t__imp_enum_sn__sn_create_edge_event__kind kind;
    t__bool is_soft;
    struct s__sn__gendb_constraint *constraint;
} *t__sn__sn_create_edge_event;
#define d__sn__sn_create_edge_event 5945
typedef t__sn__sn_create_edge_event t__sn_create_edge_event;
#define d__sn_create_edge_event d__sn__sn_create_edge_event

/* line 2085 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__gendb_field {
    t__int d__;
    t__int gen__;
    t__sn__index index_in_holder;
    struct s__sn__field *f;
} *t__sn__gendb_field;
#define d__sn__gendb_field 5967
typedef t__sn__gendb_field t__gendb_field;
#define d__gendb_field d__sn__gendb_field

/* line 246 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__list_path_item {
    t__int d__;
    t__int gen__;
    struct s__sn__field *the_field;
    t__sn__count depth;
    t__bool debug_it;
    struct s__l__sn__a_role *active_roles;
    struct s__l__sn__index *position_in_roles;
    struct s__l__sn__a_role *relevant_roles;
    t__string path_str;
    struct s__sn__field_node *pn_for_soft;
    struct s__l__sn__field_node *pn_temps_list;
    t__bool above_gotf_root;
    t__sn__index curr_om_frame;
    struct s__sn__struct_path_item *previous;
    t__sn__count the_size;
    struct s__sn__field_node *list_par_node;
    struct s__sn__field_node *item_par_node;
    struct s__sn__field_node *fn;
    t__sn__count eval_items;
    struct s__sn__any_rl *prev_item_rl;
    struct s__sn_rl__uint_rl *index_rl;
    struct s__sn_rl__uint_rl *curr_indices_rl;
    struct s__sn__any_rl *curr_items_rl;
    struct s__sn__any_rl *curr_item_rl;
    t__bool all_items_eq;
    struct s__l__sn__sn_cpi *index_cpis;
    struct s__l__sn__sn_cpi *prev_cpis;
    struct s__sn__sn_save_cis_info *sci;
    struct s__sn__type_descriptor *item_type;
} *t__sn__list_path_item;
#define d__sn__list_path_item 5673
typedef t__sn__list_path_item t__list_path_item;
#define d__list_path_item d__sn__list_path_item

/* line 457 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_save_cis_info {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_ci_info *cis;
    struct s__l__sn__sn_cpi *cpis;
} *t__sn__sn_save_cis_info;
#define d__sn__sn_save_cis_info 5695
typedef t__sn__sn_save_cis_info t__sn_save_cis_info;
#define d__sn_save_cis_info d__sn__sn_save_cis_info

/* line 453 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_ci_info {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_constraint_instance *orig_ci;
    t__sn__sn_gen_status_type orig_status;
    t__bool orig_last_alternative;
} *t__sn__sn_ci_info;
#define d__sn__sn_ci_info 5694
typedef t__sn__sn_ci_info t__sn_ci_info;
#define d__sn_ci_info d__sn__sn_ci_info

/* line 1692 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_start_preorder_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__l__sn__sn_gen_event *all_order_events;
} *t__sn__sn_start_preorder_event;
#define d__sn__sn_start_preorder_event 5948
typedef t__sn__sn_start_preorder_event t__sn_start_preorder_event;
#define d__sn_start_preorder_event d__sn__sn_start_preorder_event

/* line 1709 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_preorder_top_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__sn__sn_start_preorder_event *start_order_event;
    struct s__sn__gendb_field_in_role *f;
} *t__sn__sn_preorder_top_event;
#define d__sn__sn_preorder_top_event 5950
typedef t__sn__sn_preorder_top_event t__sn_preorder_top_event;
#define d__sn_preorder_top_event d__sn__sn_preorder_top_event

/* line 1678 "/vobs/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn__sn_static_edge_event {
    t__int d__;
    t__int gen__;
    t__int index;
    struct s__e_core__base_struct *holder_entity;
    t__int location_in_holder;
    struct s__sn__gendb_field *from;
    struct s__sn__gendb_field *to;
    t__sn__om_edge_reason reason;
    t__imp_enum_sn__sn_create_edge_event__kind kind;
    t__bool is_soft;
    struct s__sn__gendb_constraint *constraint;
    struct s__sn__sn_start_preorder_event *start_order_event;
} *t__sn__sn_static_edge_event;
#define d__sn__sn_static_edge_event 5946
typedef t__sn__sn_static_edge_event t__sn_static_edge_event;
#define d__sn_static_edge_event d__sn__sn_static_edge_event

/* line 61 "/vobs/specman/src/gen_select.e"  From 'struct definition' */
typedef struct s__sn__sn_compute_select_struct {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint *gc;
    t__bool in_use;
    struct s__sn__any_rl *input_range_list;
    struct s__l__sn__any_rl *range_lists;
    struct s__l__int *weights;
    struct s__sn__seed_domain *seed_domain;
    t__bool OK;
    t__untyped res;
} *t__sn__sn_compute_select_struct;
#define d__sn__sn_compute_select_struct 6057
typedef t__sn__sn_compute_select_struct t__sn_compute_select_struct;
#define d__sn_compute_select_struct d__sn__sn_compute_select_struct

/* line 84 "/vobs/specman/src/gen_statistics.e"  From 'struct definition' */
typedef struct s__sn__struct_status {
    t__int d__;
    t__int gen__;
    t__string struct_title;
    struct s__l__sn__phase_status *all_status;
} *t__sn__struct_status;
#define d__sn__struct_status 6114
typedef t__sn__struct_status t__struct_status;
#define d__struct_status d__sn__struct_status

/* line 71 "/vobs/specman/src/gen_statistics.e"  From 'struct definition' */
typedef struct s__sn__phase_status {
    t__int d__;
    t__int gen__;
    t__string phase_name;
    t__uint tot_roles;
    t__uint gotf_roles;
    t__uint tot_gc_stats;
    t__uint max_gc_stats;
    t__uint ave_gc_stats;
    t__uint tot_ffis;
    t__uint max_ffis;
    t__uint ave_ffis;
    t__uint gotf_ffis;
} *t__sn__phase_status;
#define d__sn__phase_status 6113
typedef t__sn__phase_status t__phase_status;
#define d__phase_status d__sn__phase_status

/* line 185 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__sn_display {
    t__int d__;
    t__int gen__;
    t__bool on;
    t__bool retro_command;
    t__bool busy_by_specman;
    struct s__sn__sn_value_holder *last_printed_value;
    struct s__sn__type_descriptor *last_printed_type;
    t__bool last_printed_value_is_legal;
    struct s__k__int__it *actual_printed_structs;
    struct s__k__int__it *actual_printed_structs_ui;
    t__int least_recent_ui;
    t__int most_recent_ui;
    struct s__k__e_core__base_struct__it *printed_structs;
    struct s__k__int__it *printed_struct_index;
    t__int next_printed_index;
    struct s__l__string *very_nice_support_properties;
    struct s__l__sn__display_window *windows;
    struct s__sn__global_gui_action_m16660 *global_action_manager;
    struct s__l__string *next_window_location;
    struct s__l__string *original_size;
    struct s__l__string *lst_windows_default_geo;
    struct s__l__sn__index *next_window_width;
    t__bool replace_in_place;
    struct s__l__sn__display_window *shown_windows;
    struct s__l__sn__counter_of_open_win *counter_of_open_win_list;
    struct s__sn__display_window *req_window;
    t__string req_window_name;
    t__string req_location;
    t__string req_tag;
    t__string req_tag_text;
    t__string req_line_text;
    t__string req_button;
    struct s__l__string *p_lst_req_s_params;
    struct s__k__sn__dbg_thread_geome16662 *dbg_locked_threads_geometry;
    t__sn__display_kind kind;
    t__int max_tk_size;
    struct s__sn__display_window *output_window;
    t__string req_entry_value;
    t__string toolbar_font;
    t__sn__presentation_type toolbar_type;
    t__string menu_font;
    t__sn__presentation_type menu_type;
    struct s__e_core__base_struct *parent_struct;
    struct s__sn__field *my_field;
    struct s__sn__display_window *next_window;
    struct s__k__sn__product_shortcut16663 *products_shortcut;
    t__bool pre_command_in_progress;
    t__bool show_source_on_stop;
    struct s__l__string *colours;
    struct s__sn__display_window *disp_interrupt___prev_output_window;
    struct s__sn__properties_manager *properties;
    t__bool wakeup;
    t__bool display_on;
    struct s__k__sn__sn_gui_tag_info_16664 *p_ht_of_style_tags;
    t__sn__count display___index_for_new_window;
    t__bool simulator_exists_was_updated;
    struct s__l__string *nice_support_properties;
    t__string support_url;
    t__string support_url_base;
    t__bool new_help_window;
    struct s__sn_debugger__watch_disp31728 *the_watch_window;
    struct s__sn_debugger__threads_gui *threads_gui;
    t__bool f_restore_winfo;
    t__string tk_debugger_mode;
    t__string tk_capture_mode;
    t__string tk_thread_name;
    t__string tk_debug_wname;
    t__bool show_tooltip;
    t__bool use_one_long_cmd;
    t__bool auto_command_active;
    struct s__l__string *the_auto_command_sl;
    t__bool internal_auto_command_active;
    struct s__sn__gen_debug_gui *gen_debug_gui;
    t__e_core__on_status prev_on_status;
    struct s__vt__sn_image_manager *image_manager;
    struct s__l__vt__vt_user_action *lst_modules_window_actions;
    struct s__l__vt__sn_table_col *lst_modules_window_cols;
    struct s__vt__sn_table_window_data *modules_window_data;
    t__int p_last_displayed_module_num;
    struct s__l__vt__vt_user_action *lst_checks_window_actions;
    struct s__l__vt__sn_table_col *lst_checks_window_cols;
    struct s__vt__sn_table_window_data *checks_window_data;
    struct s__l__vt__vt_user_action *lst_patches_window_actions;
    struct s__l__vt__sn_table_col *lst_patches_window_cols;
    struct s__vt__sn_table_window_data *patches_window_data;
    t__bool hidden_mode;
} *t__sn__sn_display;
#define d__sn__sn_display 475
typedef t__sn__sn_display t__sn_display;
#define d__sn_display d__sn__sn_display

/* line 50 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__display_window {
    t__int d__;
    t__int gen__;
    struct s__sn__gui_action_manager *p_action_manager;
    t__string name;
    t__imp_enum_sn__display_window__state state;
    t__sn__index index;
    t__string title;
    t__sn__main_window_kind kind;
    t__sn__count win_idx;
    t__string win_kind_title;
    t__sn__index window_set;
    t__sn__index window_width;
    struct s__sn__display_window *from;
    t__string next_location;
    t__sn__index last_printed_item;
    t__bool f_initialized;
    t__bool main_window;
} *t__sn__display_window;
#define d__sn__display_window 2489
typedef t__sn__display_window t__display_window;
#define d__display_window d__sn__display_window

/* line 18 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__gui_action_manager {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_action__p_s_key *p_lst_action_table;
    struct s__sn__display_window *p_display_window;
} *t__sn__gui_action_manager;
#define d__sn__gui_action_manager 2481
typedef t__sn__gui_action_manager t__gui_action_manager;
#define d__gui_action_manager d__sn__gui_action_manager

/* line 27 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_action {
    t__int d__;
    t__int gen__;
    t__string p_s_key;
    t__string p_s_label;
    t__string p_s_short_label;
    t__bool p_f_checkable;
    t__string p_s_accelerator;
    t__string p_s_image_name;
    t__string p_s_help;
    t__bool p_f_global;
    t__bool p_f_check_val;
    struct s__l__sn__sn_action_widget *p_lst_action_widgets;
    t__bool p_f_state;
    t__bool f_help_includes_key;
    struct s__sn__gui_action_manager *p_gui_action_manager;
} *t__sn__sn_action;
#define d__sn__sn_action 2483
typedef t__sn__sn_action t__sn_action;
#define d__sn_action d__sn__sn_action

/* line 36 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_action_widget {
    t__int d__;
    t__int gen__;
    t__string p_s_widget_name;
    t__string p_s_full_path;
    t__sn__widget_kind p_t_widget_kind;
    t__string p_s_compound_image;
    struct s__sn__sn_action *p_t_action;
} *t__sn__sn_action_widget;
#define d__sn__sn_action_widget 2486
typedef t__sn__sn_action_widget t__sn_action_widget;
#define d__sn_action_widget d__sn__sn_action_widget

/* line 25 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__global_gui_action_m16660 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_action__p_s_key *p_lst_action_table;
    struct s__sn__display_window *p_display_window;
} *t__sn__global_gui_action_manager;
#define d__sn__global_gui_action_manager 2482
typedef t__sn__global_gui_action_manager t__global_gui_action_manager;
#define d__global_gui_action_manager d__sn__global_gui_action_manager

/* line 103 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__counter_of_open_win {
    t__int d__;
    t__int gen__;
    t__sn__main_window_kind win_kind;
    t__sn__count counter;
} *t__sn__counter_of_open_win;
#define d__sn__counter_of_open_win 2493
typedef t__sn__counter_of_open_win t__counter_of_open_win;
#define d__counter_of_open_win d__sn__counter_of_open_win

/* line 226 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__dbg_thread_geometry {
    t__int d__;
    t__int gen__;
    t__int p_thread_id;
    t__string p_s_geo;
    t__bool p_f_show_stack;
} *t__sn__dbg_thread_geometry;
#define d__sn__dbg_thread_geometry 2494
typedef t__sn__dbg_thread_geometry t__dbg_thread_geometry;
#define d__dbg_thread_geometry d__sn__dbg_thread_geometry

/* line 1700 "/vobs/specman/src/disp_action.e"  From 'struct definition' */
typedef struct s__sn__product_shortcut_at16682 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string name;
    t__string command;
    t__string product_home;
    t__string image_file;
    t__string tooltip;
    t__string error_name;
} *t__sn__product_shortcut_attributes;
#define d__sn__product_shortcut_attributes 2662
typedef t__sn__product_shortcut_attributes t__product_shortcut_attributes;
#define d__product_shortcut_attributes d__sn__product_shortcut_attributes

/* line 121 "/vobs/specman/src/disp_properties.e"  From 'struct definition' */
typedef struct s__sn__properties_manager {
    t__int d__;
    t__int gen__;
    struct s__k__sn__property_item__p16725 *p_list_items;
    t__string p_s_file_name;
} *t__sn__properties_manager;
#define d__sn__properties_manager 2743
typedef t__sn__properties_manager t__properties_manager;
#define d__properties_manager d__sn__properties_manager

/* line 6 "/vobs/specman/src/disp_properties.e"  From 'struct definition' */
typedef struct s__sn__property_item {
    t__int d__;
    t__int gen__;
    t__string p_s_property_name;
    t__string p_s_property_value;
    t__string p_s_property_type;
} *t__sn__property_item;
#define d__sn__property_item 2742
typedef t__sn__property_item t__property_item;
#define d__property_item d__sn__property_item

/* line 78 "/vobs/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_gui_tag_info {
    t__int d__;
    t__int gen__;
    t__string s_name;
    t__string s_params;
    t__bool f_hyperlink;
} *t__sn__sn_gui_tag_info;
#define d__sn__sn_gui_tag_info 2490
typedef t__sn__sn_gui_tag_info t__sn_gui_tag_info;
#define d__sn_gui_tag_info d__sn__sn_gui_tag_info

/* line 485 "/vobs/specman/src/dbg_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__watch_disp31728 {
    t__int d__;
    t__int gen__;
    struct s__sn__gui_action_manager *p_action_manager;
    t__string name;
    t__imp_enum_sn__display_window__state state;
    t__sn__index index;
    t__string title;
    t__sn__main_window_kind kind;
    t__sn__count win_idx;
    t__string win_kind_title;
    t__sn__index window_set;
    t__sn__index window_width;
    struct s__sn__display_window *from;
    t__string next_location;
    t__sn__index last_printed_item;
    t__bool f_initialized;
    t__bool main_window;
} *t__sn_debugger__watch_display_window;
#define d__sn_debugger__watch_display_window 4072
typedef t__sn_debugger__watch_display_window t__watch_display_window;
#define d__watch_display_window d__sn_debugger__watch_display_window

/* line 151 "/vobs/specman/src/dbg_minimal_window.e"  From 'struct definition' */
typedef struct s__sn_debugger__threads_gui {
    t__int d__;
    t__int gen__;
} *t__sn_debugger__threads_gui;
#define d__sn_debugger__threads_gui 4082
typedef t__sn_debugger__threads_gui t__threads_gui;
#define d__threads_gui d__sn_debugger__threads_gui

/* line 57 "/vobs/specman/src/ui_gen_debug.e"  From 'struct definition' */
typedef struct s__sn__gen_debug_gui {
    t__int d__;
    t__int gen__;
} *t__sn__gen_debug_gui;
#define d__sn__gen_debug_gui 4216
typedef t__sn__gen_debug_gui t__gen_debug_gui;
#define d__gen_debug_gui d__sn__gen_debug_gui

/* line 575 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_image_manager {
    t__int d__;
    t__int gen__;
    struct s__k__vt__sn_image_data__name *hash_of_image_names;
} *t__vt__sn_image_manager;
#define d__vt__sn_image_manager 5058
typedef t__vt__sn_image_manager t__sn_image_manager;
#define d__sn_image_manager d__vt__sn_image_manager

/* line 682 "/vobs/specman/src/japp/vt/vt_utils.e"  From 'struct definition' */
typedef struct s__vt__sn_image_data {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string full_name;
} *t__vt__sn_image_data;
#define d__vt__sn_image_data 5388
typedef t__vt__sn_image_data t__sn_image_data;
#define d__sn_image_data d__vt__sn_image_data

/* line 525 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__parse {
    t__int d__;
    t__int gen__;
    struct s__sn__const_controller *const_controller;
    t__bool need_keep_forms;
    t__bool fast_parse;
    struct s__l__string *h_code;
    struct s__l__string *late_h_code;
    struct s__l__string *list_h_code;
    struct s__l__string *routine_h_code;
    t__int lines_per_c_file;
    struct s__e_core__c_code *top_code;
    struct s__e_core__c_code *init0_code;
    struct s__e_core__c_code *init_code;
    struct s__e_core__c_code *routine_code;
    struct s__e_core__c_code *c_code;
    struct s__e_core__c_code *late_c_code;
    struct s__k__sn__type_descriptor__it *types_for_h_code;
    struct s__k__sn__routine__name *routines_for_h_code;
    t__bool debug_fast_parse;
    t__string cgl;
    struct s__l__string *initial_h_code;
    struct s__l__string *final_h_code;
    struct s__l__string *other_h_code;
    t__bool full_e;
    t__string trans_fname;
    t__e_core__sn_compilation_mode compilation_mode;
    t__bool enable_gc_during_translate;
    t__bool enable_DAC_during_translate;
    t__bool allow_c_define_inside_macro;
    struct s__l__sn__post_load_detail *sn_post_load;
    struct s__l__sn__post_load_detail *sn_inner_post_load;
    struct s__e_core__sn_filtered_block484 *filtered_blocks_manager;
    struct s__l__sn__ntv *clean_ntvs;
    struct s__k__string__it *method_full_names;
    struct s__l__string *method_unqual_names;
    struct s__l__int *method_indices;
    struct s__l__string *method_type_strings;
    struct s__sn__sn_generated_exp_manager *generated_exp_manager;
    t__eval_explicit__eval_exp_orig orig;
    t__int func_id;
    t__bool define_version_macro_done;
    struct s__k__sn__field_attributes_4171 *fields_attrs;
    struct s__sn__template_instance_de5329 *tmp_template_instance;
    struct s__sn__sn_NSS *sn_NSS;
    struct s__l__sn__encrypt_module *eee_mmm;
    struct s__sn_encrypt__sn_encryptor *encryptor;
    struct s__sn__error_recovery *curr_err;
} *t__e_core__parse;
#define d__e_core__parse 68
typedef t__e_core__parse t__parse;
#define d__parse d__e_core__parse

/* line 61 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__const_controller {
    t__int d__;
    t__int gen__;
    struct s__k__sn__const__name *const_table;
    t__int verilog_last_size;
    t__int verilog_deferred_last_size;
    struct s__l__sn__form *forms;
} *t__sn__const_controller;
#define d__sn__const_controller 469
typedef t__sn__const_controller t__const_controller;
#define d__const_controller d__sn__const_controller

/* line 54 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__const {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string file_name;
    t__int line;
    t__bool active;
    t__string value;
    struct s__sn__pp_source_ref *undefined_from;
    struct s__sn__const *next_state;
} *t__sn__const;
#define d__sn__const 467
typedef t__sn__const t__const;
#define d__const d__sn__const

/* line 8 "../src/root_preprocessor.e"  From 'struct definition' */
typedef struct s__sn__pp_source_ref {
    t__int d__;
    t__int gen__;
    t__string file_name;
    t__int line_no;
} *t__sn__pp_source_ref;
#define d__sn__pp_source_ref 435
typedef t__sn__pp_source_ref t__pp_source_ref;
#define d__pp_source_ref d__sn__pp_source_ref

/* line 518 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__c_code {
    t__int d__;
    t__int gen__;
    struct s__l__string *code;
    t__int file_idx;
    t__int line_num;
    t__bool do_append;
} *t__e_core__c_code;
#define d__e_core__c_code 66
typedef t__e_core__c_code t__c_code;
#define d__c_code d__e_core__c_code

/* line 103 "../src/root_command.e"  From 'struct definition' */
typedef struct s__sn__post_load_detail {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    t__string post_load_string;
} *t__sn__post_load_detail;
#define d__sn__post_load_detail 423
typedef t__sn__post_load_detail t__post_load_detail;
#define d__post_load_detail d__sn__post_load_detail

/* line 510 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_filtered_block484 {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__sn_filter_level *C_run_time_flags;
    t__e_core__sn_filter_level default_level;
    struct s__l__source_ref *added_source_refs;
    struct s__l__int *filtered_blocks_run_level;
    struct s__l__sn__method *filtered_block_methods;
} *t__e_core__sn_filtered_blocks_manager;
#define d__e_core__sn_filtered_blocks_manager 65
typedef t__e_core__sn_filtered_blocks_manager t__sn_filtered_blocks_manager;
#define d__sn_filtered_blocks_manager d__e_core__sn_filtered_blocks_manager

/* line 191 "/vobs/specman/src/list_macros.e"  From 'struct definition' */
typedef struct s__sn__sn_generated_exp_manager {
    t__int d__;
    t__int gen__;
    t__int generated_exp_idx;
    struct s__l__sn__sn_generated_exp_code *generated_exp_code;
} *t__sn__sn_generated_exp_manager;
#define d__sn__sn_generated_exp_manager 933
typedef t__sn__sn_generated_exp_manager t__sn_generated_exp_manager;
#define d__sn_generated_exp_manager d__sn__sn_generated_exp_manager

/* line 51 "/vobs/specman/src/list_macros.e"  From 'struct definition' */
typedef struct s__sn__sn_generated_exp_code {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__string *c_code;
    t__string routine_signature;
    t__bool has_been_output;
} *t__sn__sn_generated_exp_code;
#define d__sn__sn_generated_exp_code 932
typedef t__sn__sn_generated_exp_code t__sn_generated_exp_code;
#define d__sn_generated_exp_code d__sn__sn_generated_exp_code

/* line 29 "/vobs/specman/src/attr.e"  From 'struct definition' */
typedef struct s__sn__field_attributes {
    t__int d__;
    t__int gen__;
    struct s__sn__field *field;
    struct s__l__sn__attr_item *attributes;
} *t__sn__field_attributes;
#define d__sn__field_attributes 1284
typedef t__sn__field_attributes t__field_attributes;
#define d__field_attributes d__sn__field_attributes

/* line 4 "/vobs/specman/src/attr.e"  From 'struct definition' */
typedef struct s__sn__attr_item {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__struct_descriptor *containing_struct;
} *t__sn__attr_item;
#define d__sn__attr_item 1281
typedef t__sn__attr_item t__attr_item;
#define d__attr_item d__sn__attr_item

/* line 96 "/vobs/specman/src/template.e"  From 'struct definition' */
typedef struct s__sn__template_instance_de5329 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    struct s__sn__template_descriptor *tmpl_d;
    struct s__l__sn__type_descriptor *params;
    struct s__sn__n__template_instance9846 *first_instance_ref;
    void *_sgi___ptr_padding[3];
    int _sgi___int_padding[2];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__template_instance_descriptor;
#define d__sn__template_instance_descriptor 1596
typedef t__sn__template_instance_descriptor t__template_instance_descriptor;
#define d__template_instance_descriptor d__sn__template_instance_descriptor

/* line 37 "/vobs/specman/src/template.e"  From 'struct definition' */
typedef struct s__sn__template_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__ExplicitTemplateName *explicit_name;
    struct s__l__string *params;
    struct s__sn__struct_descriptor *parent;
    struct s__sn__n__simple_type *parent_ntv;
    struct s__l__sn__n__struct_member *members;
    t__bool is_unit;
    struct s__l__sn__template_instance9845 *instances;
} *t__sn__template_descriptor;
#define d__sn__template_descriptor 1594
typedef t__sn__template_descriptor t__template_descriptor;
#define d__template_descriptor d__sn__template_descriptor

/* line 66 "/vobs/specman/src/template.e"  From 'struct definition' */
typedef struct s__sn__ExplicitTemplateName {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    struct s__sn__package_descriptor *package;
    t__bool package_private;
    t__bool is_hidden;
    struct s__sn__ExplicitName *next_explicit_name;
    struct s__sn__template_descriptor *tmpl_d;
} *t__sn__ExplicitTemplateName;
#define d__sn__ExplicitTemplateName 1595
typedef t__sn__ExplicitTemplateName t__ExplicitTemplateName;
#define d__ExplicitTemplateName d__sn__ExplicitTemplateName

/* line 131 "../src/root_type.e"  From 'struct definition' */
typedef struct s__sn__n__simple_type {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    struct s__sn__type_descriptor *td;
} *t__sn__n__simple_type;
#define d__sn__n__simple_type 307
typedef t__sn__n__simple_type t__n__simple_type;
#define d__n__simple_type d__sn__n__simple_type

/* line 1066 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__sn__n__struct_member {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    struct s__sn__struct_descriptor *context_struct;
} *t__sn__n__struct_member;
#define d__sn__n__struct_member 288
typedef t__sn__n__struct_member t__n__struct_member;
#define d__n__struct_member d__sn__n__struct_member

/* line 513 "/vobs/specman/src/template.e"  From 'struct definition' */
typedef struct s__sn__n__template_instance9846 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    struct s__sn__type_descriptor *td;
    struct s__sn__n__explicit_name *n__explicit_name;
    struct s__l__sn__n__type *n__param__types;
} *t__sn__n__template_instance__simple_type;
#define d__sn__n__template_instance__simple_type 1601
typedef t__sn__n__template_instance__simple_type t__n__template_instance__simple_type;
#define d__n__template_instance__simple_type d__sn__n__template_instance__simple_type

/* line 139 "../src/root_type.e"  From 'struct definition' */
typedef struct s__sn__n__explicit_name {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__sn__n__explicit_name;
#define d__sn__n__explicit_name 308
typedef t__sn__n__explicit_name t__n__explicit_name;
#define d__n__explicit_name d__sn__n__explicit_name

/* line 73 "../src/root_type.e"  From 'struct definition' */
typedef struct s__sn__n__type {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__sn__n__type;
#define d__sn__n__type 305
typedef t__sn__n__type t__n__type;
#define d__n__type d__sn__n__type

/* line 5 "/vobs/specman/src/license.e"  From 'struct definition' */
typedef struct s__sn__sn_NSS {
    t__int d__;
    t__int gen__;
} *t__sn__sn_NSS;
#define d__sn__sn_NSS 2402
typedef t__sn__sn_NSS t__sn_NSS;
#define d__sn_NSS d__sn__sn_NSS

/* line 8 "/vobs/specman/src/encrypt_table.e"  From 'struct definition' */
typedef struct s__sn__encrypt_module {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string license;
    t__sn__encrypt_attribute attribute;
} *t__sn__encrypt_module;
#define d__sn__encrypt_module 2405
typedef t__sn__encrypt_module t__encrypt_module;
#define d__encrypt_module d__sn__encrypt_module

/* line 533 "/vobs/specman/src/encryptor.e"  From 'struct definition' */
typedef struct s__sn_encrypt__sn_encryptor {
    t__int d__;
    t__int gen__;
    struct s__sn_encrypt__sn_encrypti13777 *current_key;
    struct s__e_core__file *current_file;
    struct s__l__byte *buffer;
    struct s__sn__sn_enc_checksum *checksum;
} *t__sn_encrypt__sn_encryptor;
#define d__sn_encrypt__sn_encryptor 2411
typedef t__sn_encrypt__sn_encryptor t__sn_encryptor;
#define d__sn_encryptor d__sn_encrypt__sn_encryptor

/* line 30 "/vobs/specman/src/encryptor.e"  From 'struct definition' */
typedef struct s__sn_encrypt__sn_encrypti13777 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__sn_encrypt__sn_encryption_key;
#define d__sn_encrypt__sn_encryption_key 2408
typedef t__sn_encrypt__sn_encryption_key t__sn_encryption_key;
#define d__sn_encryption_key d__sn_encrypt__sn_encryption_key

/* line 9 "/vobs/specman/src/enc_checksum.e"  From 'struct definition' */
typedef struct s__sn__sn_enc_checksum {
    t__int d__;
    t__int gen__;
} *t__sn__sn_enc_checksum;
#define d__sn__sn_enc_checksum 2401
typedef t__sn__sn_enc_checksum t__sn_enc_checksum;
#define d__sn_enc_checksum d__sn__sn_enc_checksum

/* line 14 "/vobs/specman/src/disp_err_recovery.e"  From 'struct definition' */
typedef struct s__sn__error_recovery {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    t__string desc1;
    t__string desc2;
    t__string mark_str;
    t__bool is_in_command;
    t__int priority;
} *t__sn__error_recovery;
#define d__sn__error_recovery 2736
typedef t__sn__error_recovery t__error_recovery;
#define d__error_recovery d__sn__error_recovery

/* line 1038 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__simulator {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__k__e_core__verilog_macro_485 *verilog_macros;
    struct s__k__e_core__deferred_macro486 *deferred_macros;
    t__bool exists;
    t__int simulator_gui_refresh_time;
    t__bool simulator_gui_refresh_needed;
    t__sn__simulator_product product;
    t__sn__simulator_kind kind;
    t__string sim_product;
    t__sn__simulator_kind stub_kind;
    t__sn__simulator_product stub_product;
    t__sn__simulator_gui_mode gui_mode_var;
    t__bool DUT_in_error_now;
    struct s__k__sn__computed_name__name *computed_names;
    struct s__k__sn__computed_subprog14574 *computed_subprograms;
    struct s__k__sn__vhdl_driver_inst14575 *vhdl_drivers;
    t__uint valid_initial_time;
    t__bool to_set_driver_now;
    t__bool init_uninit_driver;
    struct s__l__sn__sn_verilog_code_inst *verilog_codes;
    struct s__l__string *vhdl_code_line;
    struct s__sn__sn_verilog_time_inst *verilog_timescale;
    struct s__l__int *list_for_mask;
    t__int checksum_vlog;
    t__int checksum_vhdl;
    struct s__l__sn__hdl_exp_info *hdls_exp_info;
    struct s__k__sn__translated_model14576 *translated_model_structs;
    t__bool always_translate_names;
    struct s__l__sn__translated_model14577 *list_tran_to_put_sig;
    t__string model_name;
    struct s__l__string *orig_name;
    t__bool is_deferred_resolution;
    struct s__l__sn__subprogram_param_info *all_subprogram_param_tms;
    struct s__l__external_pointer *free_process_mti;
    struct s__sn__subprogram_cluster *subprogram_cluster;
    struct s__l__string *empty_string_list;
    t__bool issued_warning_on_macro_translation;
    struct s__l__string *import_verilog_files;
    struct s__k__sn__vlogfile__full_f14578 *vlogfiles;
    t__int tmpint;
    struct s__sn__n__exp *tmpexp;
    t__string tran;
    t__bool proprietary;
    struct s__sn__sn_resolution_struct *sn_resolution;
    t__source_ref resolution_source_ref;
    t__sn__e_time_units simulation__timeUnit;
    t__uint simulation__unitsNum;
    t__bool resolution_setting;
    t__source_ref resolution_used_sref;
    t__bool mti_vhdl_time_ignore;
    t__sn__xsim_compatibility_mode xsim_compatibility_mode_flag;
    t__uint checkDateVerilogStubVersion;
    t__uint checkDateVHDLStubVersion;
    t__uint checkDateXVLOGStubVersion;
    t__uint checkDateSVStubVersion;
    t__uint checkDateNCVHDLStubVersion;
    t__bool vhdl_old_sync_mode;
    t__string stub_file_name;
    t__string stub_sim_name;
    t__string write_stub_error;
    t__bool use_sn_vhpi_foreign_arch;
    struct s__l__string *mti_versions;
    struct s__l__string *vcs_versions;
    t__long_int sn___timer_occ_l;
    struct s__sn__sn_event_struct *sn___timer_event_struct;
    struct s__sn__delayList *delayList;
    t__bool f_had_sim_reset_for_sn_reset;
    struct s__sn__sn_unit_only_attributes *default_unit_only_attr;
    t__string stub_base_name;
    t__bool enable_trace_glitch;
    t__bool trace_glitch_all;
    struct s__l__bit *sn_tlm_empty_list;
    struct s__l__int *interface_port_dummy_int_list;
    struct s__l__bit *interface_port_dummy_bit_list;
    t__bool delay_tick_access;
    t__bool retain_forced_value_after_release;
    struct s__sn__esi_app_hdl_info *ts;
    struct s__l__sn__mvl *one_or_z_list;
    struct s__l__sn__mvl *z_list;
    struct s__l__sn__mvl *z_or_h_or_one_list;
    struct s__l__sn__mvl *tmp_save_mvl_value;
    struct s__l__sn__mvl *tmp_mvl_list;
    struct s__l__bit *tmp_list_bit;
    struct s__sn__sn_long *tmp_vec;
    struct s__sn__sn_ML_OVM_adapter *ml_ovm_adapter;
    t__bool ovm_phases_active;
    struct s__sn__sn_dynamic_call *unilang_in_ml_ovm_mode___dynamic_call;
    t__ml_ovm__msg_kind_t save_unilang_debug_level;
} *t__e_core__simulator;
#define d__e_core__simulator 87
typedef t__e_core__simulator t__simulator;
#define d__simulator d__e_core__simulator

/* line 1022 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__verilog_macro {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string file_name;
    t__int line;
    t__bool active;
    t__string translation;
    t__bool in_use;
    t__int imp_line;
    t__string imp_file_name;
} *t__e_core__verilog_macro;
#define d__e_core__verilog_macro 83
typedef t__e_core__verilog_macro t__verilog_macro;
#define d__verilog_macro d__e_core__verilog_macro

/* line 1032 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__deferred_macro {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string file_name;
    t__int line;
    t__bool active;
    t__string translation;
    t__bool in_use;
    t__int imp_line;
    t__string imp_file_name;
    struct s__sn__sn_value_holder *value;
    t__string str_value;
} *t__e_core__deferred_macro;
#define d__e_core__deferred_macro 84
typedef t__e_core__deferred_macro t__deferred_macro;
#define d__deferred_macro d__e_core__deferred_macro

/* line 14 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__sn_verilog_code_inst {
    t__int d__;
    t__int gen__;
    struct s__l__string *lines;
    t__string source_ref;
    struct s__e_core__any_unit *unit_inst;
} *t__sn__sn_verilog_code_inst;
#define d__sn__sn_verilog_code_inst 2179
typedef t__sn__sn_verilog_code_inst t__sn_verilog_code_inst;
#define d__sn_verilog_code_inst d__sn__sn_verilog_code_inst

/* line 20 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__sn_verilog_time_inst {
    t__int d__;
    t__int gen__;
    t__string line;
    t__string source;
} *t__sn__sn_verilog_time_inst;
#define d__sn__sn_verilog_time_inst 2180
typedef t__sn__sn_verilog_time_inst t__sn_verilog_time_inst;
#define d__sn_verilog_time_inst d__sn__sn_verilog_time_inst

/* line 586 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__subprogram_param_info {
    t__int d__;
    t__int gen__;
    struct s__sn__translated_model_struct *my_tms;
    struct s__l__sn__connecte_cell *tms_connected;
    t__external_pointer sig_param_callback_data;
    t__bool is_need_callback;
} *t__sn__subprogram_param_info;
#define d__sn__subprogram_param_info 2221
typedef t__sn__subprogram_param_info t__subprogram_param_info;
#define d__subprogram_param_info d__sn__subprogram_param_info

/* line 648 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__subprogram_cluster {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_vec *current_vec;
    t__untyped current_value;
    t__untyped current_list;
    struct s__sn__subprogram_exp_info *current_exp_info;
    struct s__sn__subprogram_info_for14590 *current_subprogram_info_for_sig_param;
    struct s__sn__subprogram_handle *current_suprogram_handle;
    struct s__sn__translated_model_struct *current_tms_last_read;
} *t__sn__subprogram_cluster;
#define d__sn__subprogram_cluster 2224
typedef t__sn__subprogram_cluster t__subprogram_cluster;
#define d__subprogram_cluster d__sn__subprogram_cluster

/* line 574 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__subprogram_info_for14590 {
    t__int d__;
    t__int gen__;
    t__uint index_parm;
    struct s__sn__subprogram_handle *subprogram_handle;
} *t__sn__subprogram_info_for_sig_param;
#define d__sn__subprogram_info_for_sig_param 2220
typedef t__sn__subprogram_info_for_sig_param t__subprogram_info_for_sig_param;
#define d__subprogram_info_for_sig_param d__sn__subprogram_info_for_sig_param

/* line 73 "/vobs/specman/src/verilog_define.e"  From 'struct definition' */
typedef struct s__sn__vlogfile {
    t__int d__;
    t__int gen__;
    t__string file_name;
    t__string full_file_name;
    t__int file_age;
} *t__sn__vlogfile;
#define d__sn__vlogfile 2398
typedef t__sn__vlogfile t__vlogfile;
#define d__vlogfile d__sn__vlogfile

/* line 65 "/vobs/specman/src/time_units.e"  From 'struct definition' */
typedef struct s__sn__sn_resolution_struct {
    t__int d__;
    t__int gen__;
    t__uint unitsNum;
    t__sn__e_time_units vhdlTimeUnit;
} *t__sn__sn_resolution_struct;
#define d__sn__sn_resolution_struct 2413
typedef t__sn__sn_resolution_struct t__sn_resolution_struct;
#define d__sn_resolution_struct d__sn__sn_resolution_struct

/* line 29 "/vobs/specman/src/te_utils.e"  From 'struct definition' */
typedef struct s__sn__delayList {
    t__int d__;
    t__int gen__;
    struct s__l__sn__low_high *lstt;
    struct s__sn__low_high *lastlh;
    struct s__e_core__time *tmpt;
} *t__sn__delayList;
#define d__sn__delayList 3040
typedef t__sn__delayList t__delayList;
#define d__delayList d__sn__delayList

/* line 24 "/vobs/specman/src/te_utils.e"  From 'struct definition' */
typedef struct s__sn__low_high {
    t__int d__;
    t__int gen__;
    t__uint low;
    t__uint high;
} *t__sn__low_high;
#define d__sn__low_high 3039
typedef t__sn__low_high t__low_high;
#define d__low_high d__sn__low_high

/* line 175 "/vobs/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn__esi_app_hdl_info {
    t__int d__;
    t__int gen__;
    t__uint left_bound;
    t__uint right_bound;
    t__int size_in_bits;
    t__bool is_vector;
} *t__sn__esi_app_hdl_info;
#define d__sn__esi_app_hdl_info 2195
typedef t__sn__esi_app_hdl_info t__esi_app_hdl_info;
#define d__esi_app_hdl_info d__sn__esi_app_hdl_info

/* line 2 "/vobs/specman/src/ml_ovm_adapter_api.e"  From 'struct definition' */
typedef struct s__sn__sn_ML_OVM_adapter {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_adapter_unit_manager *adapter_unit_manager;
    struct s__sn__sn_adapter_bridge *adapter_abstract___bridge;
    t__bool can_master_specman;
    struct s__sn__sn_dynamic_call *sn_check_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_product___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_kind___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_put_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_hdl_scalar___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_hdl_string___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_create_driver___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_fetch_value___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_set_to_sig___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_decanon_name___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_set_adapter_id_in_framework___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_append_full_name___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_register_cb_param___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_disable_cb_param___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_restore___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_log_write___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_screen_write___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_gui_mode___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_refresh_simulator_gui___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_screen_prompt___dynamic_call;
    struct s__sn__sn_dynamic_call *simulator_gets___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_set_ptr_sig_param_callback_data___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_specman_instance_path___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_hdl_path_separator___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_simulator_version___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_argv___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_create_sig_param_data_new_proc___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_create_sig_param_data___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_and_put___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_alocate_in_simulator___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_receive_cb_denali___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_decanon_name___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_framework_version___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_init_uninit_driver___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_gui_detach_actions___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_gui_attach_actions___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_push_fix_new_time_in_multiple_ticks_at_fractional_delay___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_push_notify_incorrect_new_time_at_fractional_delay___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_call___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_update_args___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_tcm_completed___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_call_stream___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_update_args_stream___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_method_tcm_completed_stream___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_interface_call___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_interface_tcm_call___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_interface_tcm_update___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_unilang_raise_trigger___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_initialize_adapter___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_elf___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_adapter_description___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_inform_state___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_quit_simulation___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_tick_start___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_tick_end___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_require_tick___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_advance___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_simulation_time___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_time_resolution___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_do_commands___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_get_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_put_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_force_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_release___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_emit___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_sensitize___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_desensitize___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_is_external_buffer_full___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_is_external_buffer_empty___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_int_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_int_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_long_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_long_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_string_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_string_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_struct_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_put_list_of_struct_to_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_int_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_int_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_long_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_long_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_string_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_string_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_struct_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_get_list_of_struct_from_external_buffer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_buffer_flush___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_number_of_elements___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_notify_number_of_elements___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_number_of_free_elements___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_port_description___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_set_timer___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_separator___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_get_static_and_variable_paths___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_get_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_put_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_int___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_mvl___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_long___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_string___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_real___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_force_list_of_struct___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_simple_indexed_release___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_app_check_port___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_check_port_pre_elab___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_find_assertions___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_add_assert_by_name___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_register_cb___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_instance_name___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_file_name___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_line_number___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_severity_level___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_msg___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_failure_count___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_get_enable___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_enable___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_remove_assertion_cb___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_assert_restore_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *esi_write_stubs___dynamic_call;
    t__int esi_adapter_id;
    t__int ml_ovm_adapter_id;
    struct s__l__e_core__any_interfa103496 *my_ports;
    struct s__l__e_core__any_interfa103496 *pre_elab_ports;
    struct s__l__int *port_id_to_ml_ovm_port_id;
    struct s__l__bit *empty_list;
    t__bool elaborate_adapter_done;
    struct s__k__ml_ovm__bitstream_h103498 *bitstreams;
    t__int debug_mode;
    struct s__sn__sn_dynamic_call *unilang_connect_names___dynamic_call;
    t__external_pointer clist0;
    t__uint clist0_size;
    struct s__sn__sn_dynamic_call *unilang_can_get___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_try_get_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_ok_to_get___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_can_peek___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_try_peek_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_ok_to_peek___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_can_put___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_try_put_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_ok_to_put___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_write_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_get_bitstream_request___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_get_requested_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_peek_bitstream_request___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_peek_requested_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_put_bitstream_request___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_nb_transport_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_transport_bitstream_request___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_transport_response_bitstream___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_notify_end_tcm___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_connect___dynamic_call;
    struct s__sn__sn_dynamic_call *unilang_set_debug_mode___dynamic_call;
    t__external_pointer snsv_unilang_raise_trigger_ptr;
    struct s__sn__sn_adapter_bridge *external_sv_adapter;
    struct s__sn__sn_adapter_bridge *external_sc_adapter;
} *t__sn__sn_ML_OVM_adapter;
#define d__sn__sn_ML_OVM_adapter 9111
typedef t__sn__sn_ML_OVM_adapter t__sn_ML_OVM_adapter;
#define d__sn_ML_OVM_adapter d__sn__sn_ML_OVM_adapter

/* line 35 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_interface_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_interface_port_at4176 *interface_port___attributes;
    struct s__sn__sn_interface_channel *channel;
    struct s__sn__any_interface *generic_client;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    struct s__k__sn__sn_interface_por68957 *wrappers;
    struct s__sn__sn_interface_port_o68958 *ok_to_wrapper;
    t__uint current_call_index;
} *t__e_core__any_interface_port;
#define d__e_core__any_interface_port 1156
typedef t__e_core__any_interface_port t__any_interface_port;
#define d__any_interface_port d__e_core__any_interface_port

/* line 104 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_interface_port_at4176 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string external_ovm_path;
} *t__sn__sn_interface_port_attributes;
#define d__sn__sn_interface_port_attributes 1178
typedef t__sn__sn_interface_port_attributes t__sn_interface_port_attributes;
#define d__sn_interface_port_attributes d__sn__sn_interface_port_attributes

/* line 4 "/vobs/specman/src/port_method_interface_helper.e"  From 'struct definition' */
typedef struct s__sn__sn_interface_channel {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_port *ports;
    struct s__l__e_core__any_port *external_out_ports;
    struct s__l__e_core__any_port *external_in_ports;
    struct s__l__source_ref *put_source_refs;
    t__source_ref curr_source_ref;
    t__sn__sn_channel_type_t channel_type;
    t__uint cb_counter;
} *t__sn__sn_interface_channel;
#define d__sn__sn_interface_channel 6820
typedef t__sn__sn_interface_channel t__sn_interface_channel;
#define d__sn_interface_channel d__sn__sn_interface_channel

/* line 200 "/vobs/specman/src/port_defs.e"  From 'struct definition' */
typedef struct s__sn__any_interface {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__e_core__any_interface_port *last_calling_port;
    struct s__sn__any_in_interface_port *ip;
    struct s__sn__sn_interface_channel *channel;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
} *t__sn__any_interface;
#define d__sn__any_interface 1183
typedef t__sn__any_interface t__any_interface;
#define d__any_interface d__sn__any_interface

/* line 53 "/vobs/specman/src/port_interface.e"  From 'struct definition' */
typedef struct s__sn__any_in_interface_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_port_attributes *port___attributes;
    t__int port_id;
    t__external_pointer adapter_specific_info;
    struct s__sn__sn_ports_trace_specs *trace_specs;
    t__imp_enum_sn__any_port__outside outside;
    struct s__e_core__any_adapter_port4172 *adapter_info;
    struct s__l__sn__single_callback_info *sig_info_list;
    struct s__sn__sn_bind_channel *bind_channel;
    struct s__sn__sn_port_bind_info *special_bind_info;
    t__int last_change_tick_counter;
    struct s__l__sn__any_port_cb_list_item *port_cbs;
    t__bool trace_trans;
    struct s__sn__sn_port_error_info *error_info;
    struct s__sn__sn_interface_port_at4176 *interface_port___attributes;
    struct s__sn__sn_interface_channel *channel;
    struct s__sn__any_interface *generic_client;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    struct s__k__sn__sn_interface_por68957 *wrappers;
    struct s__sn__sn_interface_port_o68958 *ok_to_wrapper;
    t__uint current_call_index;
} *t__sn__any_in_interface_port;
#define d__sn__any_in_interface_port 6853
typedef t__sn__any_in_interface_port t__any_in_interface_port;
#define d__any_in_interface_port d__sn__any_in_interface_port

/* line 622 "/vobs/specman/src/port_interface.e"  From 'struct definition' */
typedef struct s__sn__sn_interface_port_e61024 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___done_occ_l;
    struct s__sn__sn_event_struct *sn___done_event_struct;
    struct s__sn__waiting_thread *sn___done_thread;
    t__int call_id;
} *t__sn__sn_interface_port_event_wrapper;
#define d__sn__sn_interface_port_event_wrapper 6860
typedef t__sn__sn_interface_port_event_wrapper t__sn_interface_port_event_wrapper;
#define d__sn_interface_port_event_wrapper d__sn__sn_interface_port_event_wrapper

/* line 630 "/vobs/specman/src/port_interface.e"  From 'struct definition' */
typedef struct s__sn__sn_interface_port_o68958 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__tlm__tlm_event *my_ok_ev;
} *t__sn__sn_interface_port_ok_to_wrapper;
#define d__sn__sn_interface_port_ok_to_wrapper 6861
typedef t__sn__sn_interface_port_ok_to_wrapper t__sn_interface_port_ok_to_wrapper;
#define d__sn_interface_port_ok_to_wrapper d__sn__sn_interface_port_ok_to_wrapper

/* line 26 "/vobs/specman/src/tlm_fwd.e"  From 'struct definition' */
typedef struct s__tlm__tlm_event {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___trigger_occ_l;
    struct s__sn__sn_event_struct *sn___trigger_event_struct;
    struct s__sn__waiting_thread *sn___trigger_thread;
} *t__tlm__tlm_event;
#define d__tlm__tlm_event 6850
typedef t__tlm__tlm_event t__tlm_event;
#define d__tlm_event d__tlm__tlm_event

/* line 123 "/vobs/specman/src/ml_ovm_adapter.e"  From 'struct definition' */
typedef struct s__ml_ovm__bitstream_holder {
    t__int d__;
    t__int gen__;
    t__int call_id;
    struct s__l__bit *stream;
    struct s__e_core__any_interface_port *port;
    t__int template_parameter_index;
} *t__ml_ovm__bitstream_holder;
#define d__ml_ovm__bitstream_holder 9114
typedef t__ml_ovm__bitstream_holder t__bitstream_holder;
#define d__bitstream_holder d__ml_ovm__bitstream_holder

/* line 1077 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_adapter_manager {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__any_port *all_ports;
    struct s__l__sn__sn_adapter_bridge *adapters;
    struct s__l__sn__sn_adapter_bridge *slave_adapters;
    struct s__sn__sn_adapter_bridge *main_adapter;
    t__uint master_adapter_tick_request_count;
    t__uint tick_start_counter;
    t__bool masters_have_sensitive_ports;
    struct s__sn__translated_model_struct *standalone_generic_tms;
    struct s__l__string *used_id_names;
    t__string agent_stub;
    struct s__sn__sn_adapter_bridge *stub_writer_adapter;
    struct s__sn__sn_adapter_bridge *adapter_on_sys_befor_stub;
    struct s__sn__sn_adapter_bridge *xvlog_adapter;
    t__bool writing_xsim_stub;
    t__bool writing_xmhdl_stub;
    t__bool doing_stub;
    t__bool doing_esi_stub;
    t__bool doing_ncrun_stub;
    t__sn__stub_destination_t stub_destination;
    t__bool te_utils___finish_from_simulator_already_called;
    t__bool trace_port_thread;
    t__uint traced_esi_call_adapter_id;
    t__int call_depth;
    struct s__sn__sn_adapter_time *time_holder;
    t__bool has_active_slaves;
    t__bool unconditional_active_slaves;
    struct s__sn__sn_basic_time *slave_wakeup_time;
    struct s__sn__sn_adapter_bridge *adapter_flow___current_adapter_slave_adapter;
    t__bool elaboration_done;
    struct s__l__sn__sn_port_trace *port_traces;
    t__bool port_uni_enabled;
    struct s__l__sn__sn_bind_channel *bind_channels_before_unification;
    t__string current_string;
    t__string agent_name_gc;
    t__string base_name_gc;
    struct s__l__sn__sn_esi_trace *esi_traces;
    t__bool loading_xvhdl;
    struct s__l__string *required_adapter_unit_managers;
    struct s__l__sn__sn_adapter_unit_68954 *adapter_unit_managers_with_no_adapters;
    struct s__sn__sn_adapter_bridge *current_initialized_adapter;
    t__bool synch_stop_request;
} *t__e_core__sn_adapter_manager;
#define d__e_core__sn_adapter_manager 90
typedef t__e_core__sn_adapter_manager t__sn_adapter_manager;
#define d__sn_adapter_manager d__e_core__sn_adapter_manager

/* line 74 "/vobs/specman/src/port_trace.e"  From 'struct definition' */
typedef struct s__sn__sn_port_trace {
    t__int d__;
    t__int gen__;
    t__string trace_cmd;
    t__bool external;
    t__bool read;
    t__bool write;
    struct s__sn__type_descriptor *port_type;
    t__sn__sn_port_trace_kind trace_destination;
    t__bool on;
    t__string adapter_pattern;
    t__string unit_pattern;
    t__string port_pattern;
    t__string e_path;
    t__bool trace_thread;
    t__string trace_activator;
} *t__sn__sn_port_trace;
#define d__sn__sn_port_trace 6714
typedef t__sn__sn_port_trace t__sn_port_trace;
#define d__sn_port_trace d__sn__sn_port_trace

/* line 16 "/vobs/specman/src/adapter_trace.e"  From 'struct definition' */
typedef struct s__sn__sn_esi_trace {
    t__int d__;
    t__int gen__;
    t__string trace_cmd;
    struct s__l__string *adapter_pattern;
    t__bool null_sim;
    struct s__e_core__time *start_time;
    struct s__e_core__time *end_time;
    struct s__l__string *method_name;
    struct s__l__string *port_kind;
    struct s__l__string *unit_pattern;
    struct s__l__string *port_pattern;
    t__bool tick_access;
    struct s__l__string *e_path;
    t__sn__esi_trace_level level;
    t__bool port_options_entered;
} *t__sn__sn_esi_trace;
#define d__sn__sn_esi_trace 6966
typedef t__sn__sn_esi_trace t__sn_esi_trace;
#define d__sn_esi_trace d__sn__sn_esi_trace

/* line 1073 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__scheduler {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__untyped tcm_result;
    t__int script_instance_init_fields_count;
    t__bool scheduler___init_done;
    t__bool scheduler___allow_locking;
    t__sn__match_status scheduler___ms;
    t__e_core__thread_handle scheduler___thread_counter;
    struct s__l__sn__thread_list *all_structs;
    struct s__k__e_core__any_struct__it *quitted_structs;
    struct s__l__e_core__any_struct *rerun_structs;
    struct s__l__e_core__any_struct *next_rerun_structs;
    t__long_int rerun_structs_time;
    t__int current_te_id;
    struct s__sn__activation_record *current_ar;
    struct s__l__int *counters_scratch;
    struct s__l__uint *singleton_tmp;
    struct s__l__sn__event_type *event_map;
    struct s__sn__aliased_events_manager *aliased_events_manager;
    struct s__sn__event_type *neg_event_type;
    struct s__sn__event_type *tick_end_event_type;
    struct s__sn__sched_ext *sched_ext;
    struct s__sn__te_memory *curr_te_memory;
    struct s__l__sn__sn_event_struct *sense;
    t__int sense_max_size;
    t__bool trigger_sense;
    struct s__l__int *sig_entries;
    t__int cur_sig_entry;
    struct s__l__int *stat;
    t__bool temporal_opt_flag;
    struct s__l__sn__sn_event_struct *event_que;
    struct s__sn__sn_pri_queue *thread_que;
    struct s__l__sn__waiting_thread *waiting_threads;
    struct s__sn__activation_record *current_context;
    t__int emit_gen;
    t__int eval_te_gen;
    t__int tcm_gen;
    t__bool within_sync;
    t__bool first_sense;
    t__int eval_tick;
    t__int time_counter;
    t__long_int tick_counter;
    struct s__l__sn__index *active_callbacks;
    struct s__l__sn__wait_entry *wait_entry_bank;
    struct s__l__sn__waiting_thread *waiting_thread_bank;
    t__bool after_restore;
    t__bool debug_multi_event;
    t__string debug_multi_event_name;
    t__long_int sn___NEG_occ_l;
    struct s__sn__sn_event_struct *sn___NEG_event_struct;
    struct s__l__sn__tesv_store *tesv_free_store;
    t__bool trace_tcm_eval;
    struct s__sn__sn_tcm_thread *current_thread;
    struct s__sn__sn_tcm_thread *current_te_thread;
    struct s__sn__sn_tcm_thread_table *threads;
    struct s__l__sn__frame_list *frames_bank;
    struct s__sn__sn_tcm_thread *tcm_queue_first;
    struct s__sn__sn_tcm_thread *tcm_queue_last;
    struct s__sn__waiting_thread *current_waiting_thread;
    struct s__sn__sn_tcm_thread *tcm_queue_retained_last;
    t__uint thread_handle_allocator;
    t__bool is_very_first;
    t__bool debug_event_next;
    t__bool debug_redundant_events;
    t__int tcm_try_setjmp_result;
    struct s__l__int *da_threads;
    struct s__l__e_core__base_struct *da_owners;
    struct s__l__reflection__rf_field *da_fields;
    struct s__l__int *da_int_values;
    struct s__l__reflection__rf_value_9907 *da_values;
    struct s__l__source_ref *da_sources;
    struct s__sn_debugger__sn_sched_d31729 *sched_dbg_api;
    t__int new_time_tick_counter;
    t__bool display_report;
    struct s__l__sn__sn_tprof_util *static_tprof_elems;
} *t__e_core__scheduler;
#define d__e_core__scheduler 89
typedef t__e_core__scheduler t__scheduler;
#define d__scheduler d__e_core__scheduler

/* line 32 "/vobs/specman/src/scheduler.e"  From 'struct definition' */
typedef struct s__sn__thread_list {
    t__int d__;
    t__int gen__;
    struct s__l__sn__script_instance *threads;
    struct s__l__sn__sn_thread_handle *new_threads;
} *t__sn__thread_list;
#define d__sn__thread_list 2356
typedef t__sn__thread_list t__thread_list;
#define d__thread_list d__sn__thread_list

/* line 440 "/vobs/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn__aliased_events_manager {
    t__int d__;
    t__int gen__;
    t__sn__index alias_event_id;
    struct s__l__sn__event_type *aliased_events;
    struct s__k__sn__te_aliased_chang20065 *aliased_change_events;
    struct s__k__sn__te_aliased_chang20067 *aliased_change_events_by_event_id;
    struct s__k__sn__one_instances_wt20068 *wts_by_inst;
    struct s__l__sn__one_instances_wts *one_instances_wts_bank;
    struct s__k__sn__sn_one_inst_alia20070 *change_opt_candidates;
} *t__sn__aliased_events_manager;
#define d__sn__aliased_events_manager 2783
typedef t__sn__aliased_events_manager t__aliased_events_manager;
#define d__aliased_events_manager d__sn__aliased_events_manager

/* line 431 "/vobs/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn__te_aliased_change_desc {
    t__int d__;
    t__int gen__;
    struct s__l__int *depend;
    t__source_ref source;
    t__int tier;
    t__int event_id;
    t__string te_name;
    struct s__sn__struct_descriptor *te_parent_type;
    t__int num_of_states;
    t__int te_kind;
    t__int sense_size;
    t__bool optimized;
    struct s__l__sn__sn_fl_count_state *counter_carry_states;
    t__int te_id;
    struct s__sn_fl__sn_fl_v_top_node *tableau;
    struct s__sn__n__exp *ntv_exp;
    struct s__sn__explicit_exp *explicit_exp;
    struct s__sn__st_action *init_action;
    struct s__eval_explicit__explicit_2420 *init_explicit_action;
    struct s__l__sn__event_type *rise_events;
    struct s__l__sn__event_type *fall_events;
    t__string key_string;
    struct s__sn__struct_descriptor *parent_struct;
    t__bool is_dummy;
} *t__sn__te_aliased_change_desc;
#define d__sn__te_aliased_change_desc 2782
typedef t__sn__te_aliased_change_desc t__te_aliased_change_desc;
#define d__te_aliased_change_desc d__sn__te_aliased_change_desc

/* line 259 "/vobs/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn__sn_fl_count_state {
    t__int d__;
    t__int gen__;
    t__sn__index ind;
    t__uint type;
} *t__sn__sn_fl_count_state;
#define d__sn__sn_fl_count_state 2769
typedef t__sn__sn_fl_count_state t__sn_fl_count_state;
#define d__sn_fl_count_state d__sn__sn_fl_count_state

/* line 113 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_v_top_node {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn_fl__sn_fl_te_node *texp;
    struct s__sn_fl__sn_fl_state_table *stt;
    struct s__l__sn_fl__sn_fl_var_scndry *top_actions;
    struct s__sn_fl__sn_fl_var_event *sample;
    t__bool single_clk;
    struct s__e_core__sn_struct *es_aux;
    t__int id;
    t__int te_kind;
    t__int event_id;
    t__imp_enum_sn_fl__sn_fl_v_top_node__is_sticky_true_cash is_sticky_true_cash;
    t__imp_enum_sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash is_neg_over_sense_cash;
} *t__sn_fl__sn_fl_v_top_node;
#define d__sn_fl__sn_fl_v_top_node 2885
typedef t__sn_fl__sn_fl_v_top_node t__sn_fl_v_top_node;
#define d__sn_fl_v_top_node d__sn_fl__sn_fl_v_top_node

/* line 704 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_te_node {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn__ntv *my_ntv;
    struct s__sn_fl__sn_fl_top_node *top;
    t__string id;
    struct s__sn_fl__sn_fl_var_event *sample;
    struct s__l__sn_fl__sn_fl_var_event *samples;
} *t__sn_fl__sn_fl_te_node;
#define d__sn_fl__sn_fl_te_node 2909
typedef t__sn_fl__sn_fl_te_node t__sn_fl_te_node;
#define d__sn_fl_te_node d__sn_fl__sn_fl_te_node

/* line 391 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_top_node {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn_fl__sn_fl_te_node *texp;
    struct s__sn_fl__sn_fl_state_table *stt;
    struct s__l__sn_fl__sn_fl_var_scndry *top_actions;
    struct s__sn_fl__sn_fl_var_event *sample;
    t__bool single_clk;
    struct s__e_core__sn_struct *es_aux;
    t__int id;
    t__int te_kind;
    t__int event_id;
    t__imp_enum_sn_fl__sn_fl_v_top_node__is_sticky_true_cash is_sticky_true_cash;
    t__imp_enum_sn_fl__sn_fl_v_top_node__is_neg_over_sense_cash is_neg_over_sense_cash;
    struct s__sn_fl__sn_fl_base_top_node *sn_fl_base_top_node;
    struct s__sn_fl__sn_fl_var_event *trigger_event;
    struct s__l__sn_fl__sn_fl_detach_19616 *detach_list;
    struct s__sn__sn_bdd_manager *mng;
    struct s__sn_fl__sn_fl_bdd_add_on *bdd_add_on;
    struct s__sn_fl__sn_fl_te_node *succ_te;
    struct s__sn_fl__sn_fl_te_node *stuck_te;
    struct s__l__sn_fl__sn_fl_var_exec *user_sdef;
    struct s__l__sn_fl__sn_fl_var_true *all_trues;
    struct s__sn_fl__sn_fl_cache_top_node *all_fails;
    struct s__l__sn_fl__sn_fl_var_count *all_counters;
    struct s__l__sn_fl__sn_fl_var_event *var_events;
    t__int neg_ind;
    t__int any_ind;
    t__bool any_sense;
    t__uint edges_num;
    t__uint states_num;
} *t__sn_fl__sn_fl_top_node;
#define d__sn_fl__sn_fl_top_node 2896
typedef t__sn_fl__sn_fl_top_node t__sn_fl_top_node;
#define d__sn_fl_top_node d__sn_fl__sn_fl_top_node

/* line 613 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_state_table {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_base_top_node *top_node;
    struct s__k__sn_fl__sn_fl_fsm_ent19617 *sts;
    struct s__l__sn_fl__sn_fl_fsm_edge *all_edges;
    t__int first_state;
    t__int fake_state_num;
    struct s__l__sn_fl__sn_fl_var_alpha *alphas;
    t__string res_name;
} *t__sn_fl__sn_fl_state_table;
#define d__sn_fl__sn_fl_state_table 2904
typedef t__sn_fl__sn_fl_state_table t__sn_fl_state_table;
#define d__sn_fl_state_table d__sn_fl__sn_fl_state_table

/* line 69 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_base_top_node {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn_fl__sn_fl_te_node *texp;
    struct s__sn_fl__sn_fl_state_table *stt;
    struct s__l__sn_fl__sn_fl_var_scndry *top_actions;
    struct s__sn_fl__sn_fl_var_event *sample;
    t__bool single_clk;
    struct s__e_core__sn_struct *es_aux;
} *t__sn_fl__sn_fl_base_top_node;
#define d__sn_fl__sn_fl_base_top_node 2884
typedef t__sn_fl__sn_fl_base_top_node t__sn_fl_base_top_node;
#define d__sn_fl_base_top_node d__sn_fl__sn_fl_base_top_node

/* line 1413 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_scndry {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
} *t__sn_fl__sn_fl_var_scndry;
#define d__sn_fl__sn_fl_var_scndry 2957
typedef t__sn_fl__sn_fl_var_scndry t__sn_fl_var_scndry;
#define d__sn_fl_var_scndry d__sn_fl__sn_fl_var_scndry

/* line 1269 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_event {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string path_str;
    t__string event_name;
    t__int event_id;
    t__string event_field_name;
    t__int ind_in_te;
} *t__sn_fl__sn_fl_var_event;
#define d__sn_fl__sn_fl_var_event 2950
typedef t__sn_fl__sn_fl_var_event t__sn_fl_var_event;
#define d__sn_fl_var_event d__sn_fl__sn_fl_var_event

/* line 73 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_struct {
    t__int d__;
    t__int gen__;
} *t__e_core__sn_struct;
#define d__e_core__sn_struct 16
typedef t__e_core__sn_struct t__sn_struct;
#define d__sn_struct d__e_core__sn_struct

/* line 631 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_fsm_entry {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_state_table *stt;
    t__int ind;
    t__string id;
    struct s__sn_fl__sn_fl_te_node *texp;
    t__bool determ;
    t__bool visit;
    t__sn_fl__sn_fl_state_status status;
    t__int last_edge;
    struct s__l__sn_fl__sn_fl_fsm_edge *succs;
    struct s__l__sn_fl__sn_fl_fsm_edge *preds;
    struct s__l__bool *sense;
    struct s__l__sn_fl__sn_fl_var_alpha *sdef;
    struct s__sn_fl__sn_fl_state_dec *dec;
    struct s__l__sn_fl__sn_fl_var_true *true_vars;
    struct s__sn__sn_bdd *bddexp;
} *t__sn_fl__sn_fl_fsm_entry;
#define d__sn_fl__sn_fl_fsm_entry 2905
typedef t__sn_fl__sn_fl_fsm_entry t__sn_fl_fsm_entry;
#define d__sn_fl_fsm_entry d__sn_fl__sn_fl_fsm_entry

/* line 636 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_fsm_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_bdd *bddexp;
    struct s__sn_fl__sn_fl_bexp *bexp;
    struct s__sn_fl__sn_fl_bexp *r_bexp;
    struct s__sn_fl__sn_fl_fsm_entry *pred;
    struct s__sn_fl__sn_fl_fsm_entry *succ;
    struct s__l__sn_fl__sn_fl_var_scndry *sdef;
    struct s__l__sn_fl__sn_fl_var_exec *user_sdef;
    t__bool visit;
} *t__sn_fl__sn_fl_fsm_edge;
#define d__sn_fl__sn_fl_fsm_edge 2906
typedef t__sn_fl__sn_fl_fsm_edge t__sn_fl_fsm_edge;
#define d__sn_fl_fsm_edge d__sn_fl__sn_fl_fsm_edge

/* line 23 "/vobs/specman/src/bdd.e"  From 'struct definition' */
typedef struct s__sn__sn_bdd {
    t__int d__;
    t__int gen__;
    t__external_pointer bdd;
    struct s__sn__sn_bdd_manager *mng;
} *t__sn__sn_bdd;
#define d__sn__sn_bdd 2869
typedef t__sn__sn_bdd t__sn_bdd;
#define d__sn_bdd d__sn__sn_bdd

/* line 34 "/vobs/specman/src/bdd.e"  From 'struct definition' */
typedef struct s__sn__sn_bdd_manager {
    t__int d__;
    t__int gen__;
    t__external_pointer mng;
    struct s__sn__sn_bdd *one_bdd;
    struct s__sn__sn_bdd *zero_bdd;
    struct s__k__sn__sn_bdd_var__name *vars;
    struct s__sn_fl__sn_fl_top_node *sn_fl_top_node;
} *t__sn__sn_bdd_manager;
#define d__sn__sn_bdd_manager 2870
typedef t__sn__sn_bdd_manager t__sn_bdd_manager;
#define d__sn_bdd_manager d__sn__sn_bdd_manager

/* line 46 "/vobs/specman/src/bdd_legacy.e"  From 'struct definition' */
typedef struct s__sn__sn_bdd_var {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
    struct s__sn__sn_bdd *bdd;
    struct s__sn_fl__sn_fl_var_bexp *bexp;
} *t__sn__sn_bdd_var;
#define d__sn__sn_bdd_var 2873
typedef t__sn__sn_bdd_var t__sn_bdd_var;
#define d__sn_bdd_var d__sn__sn_bdd_var

/* line 46 "/vobs/specman/src/fl_bexp.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_bexp {
    t__int d__;
    t__int gen__;
    t__string name;
} *t__sn_fl__sn_fl_var_bexp;
#define d__sn_fl__sn_fl_var_bexp 2863
typedef t__sn_fl__sn_fl_var_bexp t__sn_fl_var_bexp;
#define d__sn_fl_var_bexp d__sn_fl__sn_fl_var_bexp

/* line 21 "/vobs/specman/src/fl_bexp.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_bexp {
    t__int d__;
    t__int gen__;
} *t__sn_fl__sn_fl_bexp;
#define d__sn_fl__sn_fl_bexp 2859
typedef t__sn_fl__sn_fl_bexp t__sn_fl_bexp;
#define d__sn_fl_bexp d__sn_fl__sn_fl_bexp

/* line 1799 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_exec {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
    t__string action_str;
    t__uint ind;
    t__bool multi;
    t__int consumed_event_id;
} *t__sn_fl__sn_fl_var_exec;
#define d__sn_fl__sn_fl_var_exec 2962
typedef t__sn_fl__sn_fl_var_exec t__sn_fl_var_exec;
#define d__sn_fl_var_exec d__sn_fl__sn_fl_var_exec

/* line 1448 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_alpha {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
    t__int num;
    t__bool is_const;
    t__string exp_str;
    struct s__sn_fl__sn_fl_var_loop *loop;
    struct s__sn_fl__sn_fl_var_loop *loop2;
    struct s__sn_fl__sn_fl_var_alpha *f__double;
} *t__sn_fl__sn_fl_var_alpha;
#define d__sn_fl__sn_fl_var_alpha 2959
typedef t__sn_fl__sn_fl_var_alpha t__sn_fl_var_alpha;
#define d__sn_fl_var_alpha d__sn_fl__sn_fl_var_alpha

/* line 1720 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_loop {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
    t__int num;
    t__bool is_const;
    t__string exp_str;
    struct s__sn_fl__sn_fl_var_alpha *alpha;
    t__bool merge_only;
    struct s__sn_fl__sn_fl_var_loop_dummy *dummy_act;
} *t__sn_fl__sn_fl_var_loop;
#define d__sn_fl__sn_fl_var_loop 2960
typedef t__sn_fl__sn_fl_var_loop t__sn_fl_var_loop;
#define d__sn_fl_var_loop d__sn_fl__sn_fl_var_loop

/* line 1768 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_loop_dummy {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
    t__int num;
    t__bool is_const;
    t__string exp_str;
    struct s__sn_fl__sn_fl_var_alpha *alpha;
} *t__sn_fl__sn_fl_var_loop_dummy;
#define d__sn_fl__sn_fl_var_loop_dummy 2961
typedef t__sn_fl__sn_fl_var_loop_dummy t__sn_fl_var_loop_dummy;
#define d__sn_fl_var_loop_dummy d__sn_fl__sn_fl_var_loop_dummy

/* line 14 "/vobs/specman/src/fl_sm.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_state_dec {
    t__int d__;
    t__int gen__;
} *t__sn_fl__sn_fl_state_dec;
#define d__sn_fl__sn_fl_state_dec 2988
typedef t__sn_fl__sn_fl_state_dec t__sn_fl_state_dec;
#define d__sn_fl_state_dec d__sn_fl__sn_fl_state_dec

/* line 1351 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_true {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__sn_fl__sn_fl_fsm_entry *src_states;
    t__int occur_num;
    t__int id;
    t__sn_fl__sn_fl_true_occ_kind kind;
    t__bool sticky;
    t__bool neg_sense;
} *t__sn_fl__sn_fl_var_true;
#define d__sn_fl__sn_fl_var_true 2954
typedef t__sn_fl__sn_fl_var_true t__sn_fl_var_true;
#define d__sn_fl_var_true d__sn_fl__sn_fl_var_true

/* line 556 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_detach_top_node {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn_fl__sn_fl_te_node *texp;
    struct s__sn_fl__sn_fl_state_table *stt;
    struct s__l__sn_fl__sn_fl_var_scndry *top_actions;
    struct s__sn_fl__sn_fl_var_event *sample;
    t__bool single_clk;
    struct s__e_core__sn_struct *es_aux;
    struct s__sn_fl__sn_fl_top_node *parent_top;
    t__int detach_id;
    t__uint offset;
} *t__sn_fl__sn_fl_detach_top_node;
#define d__sn_fl__sn_fl_detach_top_node 2898
typedef t__sn_fl__sn_fl_detach_top_node t__sn_fl_detach_top_node;
#define d__sn_fl_detach_top_node d__sn_fl__sn_fl_detach_top_node

/* line 61 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_bdd_add_on {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_bdd *all_vars_not;
} *t__sn_fl__sn_fl_bdd_add_on;
#define d__sn_fl__sn_fl_bdd_add_on 2883
typedef t__sn_fl__sn_fl_bdd_add_on t__sn_fl_bdd_add_on;
#define d__sn_fl_bdd_add_on d__sn_fl__sn_fl_bdd_add_on

/* line 607 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_cache_top_node {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__sn_fl__sn_fl_te_node *texp;
    struct s__sn_fl__sn_fl_state_table *stt;
    struct s__l__sn_fl__sn_fl_var_scndry *top_actions;
    struct s__sn_fl__sn_fl_var_event *sample;
    t__bool single_clk;
    struct s__e_core__sn_struct *es_aux;
    struct s__sn_fl__sn_fl_top_node *parent_top;
} *t__sn_fl__sn_fl_cache_top_node;
#define d__sn_fl__sn_fl_cache_top_node 2903
typedef t__sn_fl__sn_fl_cache_top_node t__sn_fl_cache_top_node;
#define d__sn_fl_cache_top_node d__sn_fl__sn_fl_cache_top_node

/* line 1423 "/vobs/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_fl_var_count {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int id;
    t__int num;
    t__bool is_const;
    t__string exp_str;
} *t__sn_fl__sn_fl_var_count;
#define d__sn_fl__sn_fl_var_count 2958
typedef t__sn_fl__sn_fl_var_count t__sn_fl_var_count;
#define d__sn_fl_var_count d__sn_fl__sn_fl_var_count

/* line 107 "/vobs/specman/src/eval_explicit.e"  From 'struct definition' */
typedef struct s__eval_explicit__explicit_2420 {
    t__int d__;
    t__int gen__;
    t__int func_id;
    struct s__sn__st_action *action;
} *t__eval_explicit__explicit_action;
#define d__eval_explicit__explicit_action 1103
typedef t__eval_explicit__explicit_action t__explicit_action;
#define d__explicit_action d__eval_explicit__explicit_action

/* line 53 "/vobs/specman/src/te_event_alias_quit.e"  From 'struct definition' */
typedef struct s__sn__one_instances_wts {
    t__int d__;
    t__int gen__;
    struct s__l__sn__waiting_thread *wts;
    struct s__e_core__any_struct *inst;
} *t__sn__one_instances_wts;
#define d__sn__one_instances_wts 3049
typedef t__sn__one_instances_wts t__one_instances_wts;
#define d__one_instances_wts d__sn__one_instances_wts

/* line 67 "/vobs/specman/src/te_event_alias_run.e"  From 'struct definition' */
typedef struct s__sn__sn_one_inst_alias_d20073 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__te_aliased_chang20074 *alias_descs;
    struct s__e_core__any_struct *inst;
} *t__sn__sn_one_inst_alias_descriptors;
#define d__sn__sn_one_inst_alias_descriptors 3052
typedef t__sn__sn_one_inst_alias_descriptors t__sn_one_inst_alias_descriptors;
#define d__sn_one_inst_alias_descriptors d__sn__sn_one_inst_alias_descriptors

/* line 429 "/vobs/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn__sched_ext {
    t__int d__;
    t__int gen__;
    t__int Entry_Recycle_Size;
    t__int Entry_Recycle_Rate;
    t__int Big_Recycle_Rate;
    t__int last_wt_cleaned_size;
    t__int recycle_counter;
    t__int wt_clean_size;
    t__bool trace_no_intermid;
    t__bool trace_on;
    t__int event_time;
    struct s__l__sn__event_trace_type *event_trace;
    t__bool trace_main_loop;
    t__int we_recycle_generation;
    struct s__l__sn__sn_event_struct *long_wes;
} *t__sn__sched_ext;
#define d__sn__sched_ext 2803
typedef t__sn__sched_ext t__sched_ext;
#define d__sched_ext d__sn__sched_ext

/* line 742 "/vobs/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn__event_trace_type {
    t__int d__;
    t__int gen__;
    struct s__e_core__base_struct *parent;
    t__sn__index event;
    t__int time;
    t__sn__sn_sched_phase phase;
} *t__sn__event_trace_type;
#define d__sn__event_trace_type 2811
typedef t__sn__event_trace_type t__event_trace_type;
#define d__event_trace_type d__sn__event_trace_type

/* line 516 "/vobs/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_pri_queue {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_queue *queues;
    t__int next_priority;
    t__int size;
} *t__sn__sn_pri_queue;
#define d__sn__sn_pri_queue 2805
typedef t__sn__sn_pri_queue t__sn_pri_queue;
#define d__sn_pri_queue d__sn__sn_pri_queue

/* line 468 "/vobs/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn__sn_queue {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__sn_struct *entries;
    t__int next_entry;
} *t__sn__sn_queue;
#define d__sn__sn_queue 2804
typedef t__sn__sn_queue t__sn_queue;
#define d__sn_queue d__sn__sn_queue

/* line 406 "/vobs/specman/src/te_utils.e"  From 'struct definition' */
typedef struct s__sn__tesv_store {
    t__int d__;
    t__int gen__;
    struct s__l__sn__te_memory *s;
} *t__sn__tesv_store;
#define d__sn__tesv_store 3041
typedef t__sn__tesv_store t__tesv_store;
#define d__tesv_store d__sn__tesv_store

/* line 49 "/vobs/specman/src/tcm_data_structures.e"  From 'struct definition' */
typedef struct s__sn__sn_tcm_thread {
    t__int d__;
    t__int gen__;
    t__sn__sn_thread_handle handle;
    struct s__e_core__any_struct *sn_owner;
    struct s__l__sn__script_instance *stack;
    struct s__sn__sn_tcm_thread *parent_thread;
    t__uint all_of_counter;
    t__routine_pointer pc__routine;
    struct s__sn__sn_tcm_flow_graph *pc__flow_graph;
    t__int pc__state;
    struct s__sn__sn_tcm_thread *next_in_tcm_queue;
    struct s__sn__sn_tcm_thread *next_in_all_threads_table;
    t__source_ref start_source_ref;
    t__uint start_time_low;
    t__uint start_time_high;
} *t__sn__sn_tcm_thread;
#define d__sn__sn_tcm_thread 3108
typedef t__sn__sn_tcm_thread t__sn_tcm_thread;
#define d__sn_tcm_thread d__sn__sn_tcm_thread

/* line 84 "/vobs/specman/src/tcm_data_structures.e"  From 'struct definition' */
typedef struct s__sn__sn_tcm_thread_table {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_tcm_thread *table;
    t__int cache_miss_counter;
} *t__sn__sn_tcm_thread_table;
#define d__sn__sn_tcm_thread_table 3111
typedef t__sn__sn_tcm_thread_table t__sn_tcm_thread_table;
#define d__sn_tcm_thread_table d__sn__sn_tcm_thread_table

/* line 78 "/vobs/specman/src/tcm_data_structures.e"  From 'struct definition' */
typedef struct s__sn__frame_list {
    t__int d__;
    t__int gen__;
    struct s__l__sn__script_instance *frames;
} *t__sn__frame_list;
#define d__sn__frame_list 3110
typedef t__sn__frame_list t__frame_list;
#define d__frame_list d__sn__frame_list

/* line 398 "/vobs/specman/src/dbg_defs.e"  From 'struct definition' */
typedef struct s__sn_debugger__sn_sched_d31729 {
    t__int d__;
    t__int gen__;
} *t__sn_debugger__sn_sched_dbg_api;
#define d__sn_debugger__sn_sched_dbg_api 4070
typedef t__sn_debugger__sn_sched_dbg_api t__sn_sched_dbg_api;
#define d__sn_sched_dbg_api d__sn_debugger__sn_sched_dbg_api

/* line 225 "/vobs/specman/src/tempo_prof.e"  From 'struct definition' */
typedef struct s__sn__sn_tprof_util {
    t__int d__;
    t__int gen__;
    t__int indx;
    t__int count;
    t__int count2;
    t__int redundancy;
} *t__sn__sn_tprof_util;
#define d__sn__sn_tprof_util 9141
typedef t__sn__sn_tprof_util t__sn_tprof_util;
#define d__sn_tprof_util d__sn__sn_tprof_util

/* line 2169 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__specsim {
    t__int d__;
    t__int gen__;
    struct s__e_core__nbg *nbg;
    t__bool dtf_mode;
    t__bool nbg_active;
    t__bool itc_active;
    t__bool active;
    t__bool simvision_active;
    t__string version;
    t__string ncrun_mode;
    t__bool ncrun_active;
    t__bool irun_batch_mode;
    t__bool ncrun_wrote_stub;
    t__bool ncrun_doing_stub;
    struct s__sn__itc *itc;
    t__bool stopped_in_dbg;
} *t__e_core__specsim;
#define d__e_core__specsim 123
typedef t__e_core__specsim t__specsim;
#define d__specsim d__e_core__specsim

/* line 2165 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__nbg {
    t__int d__;
    t__int gen__;
    t__string m_prev_sim_time;
    t__string m_prev_sys_time;
} *t__e_core__nbg;
#define d__e_core__nbg 122
typedef t__e_core__nbg t__nbg;
#define d__nbg d__e_core__nbg

/* line 130 "/vobs/specman/src/specsim.e"  From 'struct definition' */
typedef struct s__sn__itc {
    t__int d__;
    t__int gen__;
} *t__sn__itc;
#define d__sn__itc 4367
typedef t__sn__itc t__itc;
#define d__itc d__sn__itc

/* line 1087 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_application_attr {
    t__int d__;
    t__int gen__;
} *t__e_core__sn_application_attr;
#define d__e_core__sn_application_attr 92
typedef t__e_core__sn_application_attr t__sn_application_attr;
#define d__sn_application_attr d__e_core__sn_application_attr

/* line 1434 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_redirect_output {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__sn_redirect_ou488 *string_buffer;
    struct s__l__string *output_strings;
    t__bool pause_output;
    t__bool force_output;
} *t__e_core__sn_redirect_output;
#define d__e_core__sn_redirect_output 97
typedef t__e_core__sn_redirect_output t__sn_redirect_output;
#define d__sn_redirect_output d__e_core__sn_redirect_output

/* line 1450 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_redirect_outpu489 {
    t__int d__;
    t__int gen__;
    struct s__l__string *msg;
} *t__e_core__sn_redirect_output_bucket;
#define d__e_core__sn_redirect_output_bucket 98
typedef t__e_core__sn_redirect_output_bucket t__sn_redirect_output_bucket;
#define d__sn_redirect_output_bucket d__e_core__sn_redirect_output_bucket

/* line 2120 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__dual_line_buff {
    t__int d__;
    t__int gen__;
    struct s__l__byte *lobyte;
    struct s__e_core__phys_buff *phys_buff;
    t__int lines_num;
} *t__e_core__dual_line_buff;
#define d__e_core__dual_line_buff 119
typedef t__e_core__dual_line_buff t__dual_line_buff;
#define d__dual_line_buff d__e_core__dual_line_buff

/* line 2066 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__phys_buff {
    t__int d__;
    t__int gen__;
    t__int read;
    t__int current_size;
    t__string buff;
    struct s__e_core__file *file;
    t__string feature;
} *t__e_core__phys_buff;
#define d__e_core__phys_buff 116
typedef t__e_core__phys_buff t__phys_buff;
#define d__phys_buff d__e_core__phys_buff

/* line 2129 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_warnings {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_warn_struct__id *warnings;
    t__source_ref null_sref;
    t__int max_cnt;
    t__string my_try_string;
    struct s__k__sn__sn_warn_struct_m11896 *shadow_types;
    struct s__k__sn__sn_warn_struct_m11898 *shadow_methods;
} *t__e_core__sn_warnings;
#define d__e_core__sn_warnings 121
typedef t__e_core__sn_warnings t__sn_warnings;
#define d__sn_warnings d__e_core__sn_warnings

/* line 44 "/vobs/specman/src/warn_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_warn_struct {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__sn__sn_warning_type id;
} *t__sn__sn_warn_struct;
#define d__sn__sn_warn_struct 1616
typedef t__sn__sn_warn_struct t__sn_warn_struct;
#define d__sn_warn_struct d__sn__sn_warn_struct

/* line 619 "/vobs/specman/src/warn_ext.e"  From 'struct definition' */
typedef struct s__sn__sn_warn_struct_member {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd;
    t__string struct_name;
    t__string struct_member_name;
} *t__sn__sn_warn_struct_member;
#define d__sn__sn_warn_struct_member 1931
typedef t__sn__sn_warn_struct_member t__sn_warn_struct_member;
#define d__sn_warn_struct_member d__sn__sn_warn_struct_member

/* line 1454 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_communication {
    t__int d__;
    t__int gen__;
    t__int active_out_request_counter;
    t__int active_in_request_counter;
    t__int comm_busy_counter;
    struct s__sn__comm_config *comm_config;
    t__int debug_comm;
    t__bool use_stub;
    t__bool quit_on_disconnect;
    t__bool error_on_disconnect;
    struct s__sn__comm_in_request_manager *in_request_manager;
    struct s__sn__comm_out_request_manager *out_request_manager;
    struct s__sn__comm_message_manager *message_manager;
    struct s__sn__comm_connection_manager *connection_manager;
    struct s__l__sn__comm_client_appl22356 *client_apps;
} *t__e_core__sn_communication;
#define d__e_core__sn_communication 99
typedef t__e_core__sn_communication t__sn_communication;
#define d__sn_communication d__e_core__sn_communication

/* line 4 "/vobs/specman/src/comm_communication.e"  From 'struct definition' */
typedef struct s__sn__comm_config {
    t__int d__;
    t__int gen__;
    t__int server_default_port;
    t__int port_search_range;
    t__string registration_file;
    t__int client_port;
} *t__sn__comm_config;
#define d__sn__comm_config 3293
typedef t__sn__comm_config t__comm_config;
#define d__comm_config d__sn__comm_config

/* line 8 "/vobs/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__sn__comm_in_request_manager {
    t__int d__;
    t__int gen__;
} *t__sn__comm_in_request_manager;
#define d__sn__comm_in_request_manager 3322
typedef t__sn__comm_in_request_manager t__comm_in_request_manager;
#define d__comm_in_request_manager d__sn__comm_in_request_manager

/* line 288 "/vobs/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__sn__comm_out_request_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_transfered_out22360 *transfered_out_request_map;
    struct s__sn__comm_waiting_in_rep22361 *waiting_replies;
} *t__sn__comm_out_request_manager;
#define d__sn__comm_out_request_manager 3327
typedef t__sn__comm_out_request_manager t__comm_out_request_manager;
#define d__comm_out_request_manager d__sn__comm_out_request_manager

/* line 226 "/vobs/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__sn__comm_transfered_out22360 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__comm_transfered_22363 *transfered_out_requests;
} *t__sn__comm_transfered_out_request_map;
#define d__sn__comm_transfered_out_request_map 3326
typedef t__sn__comm_transfered_out_request_map t__comm_transfered_out_request_map;
#define d__comm_transfered_out_request_map d__sn__comm_transfered_out_request_map

/* line 191 "/vobs/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__sn__comm_transfered_out22230 {
    t__int d__;
    t__int gen__;
    t__int id;
    struct s__sn__comm_out_request *out_request;
} *t__sn__comm_transfered_out_request;
#define d__sn__comm_transfered_out_request 3325
typedef t__sn__comm_transfered_out_request t__comm_transfered_out_request;
#define d__comm_transfered_out_request d__sn__comm_transfered_out_request

/* line 76 "/vobs/specman/src/comm_request.e"  From 'struct definition' */
typedef struct s__sn__comm_out_request {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    t__sn__comm_request_opcode opcode;
} *t__sn__comm_out_request;
#define d__sn__comm_out_request 3300
typedef t__sn__comm_out_request t__comm_out_request;
#define d__comm_out_request d__sn__comm_out_request

/* line 124 "/vobs/specman/src/comm_request.e"  From 'struct definition' */
typedef struct s__sn__comm_abs_basic_reply {
    t__int d__;
    t__int gen__;
} *t__sn__comm_abs_basic_reply;
#define d__sn__comm_abs_basic_reply 3301
typedef t__sn__comm_abs_basic_reply t__comm_abs_basic_reply;
#define d__comm_abs_basic_reply d__sn__comm_abs_basic_reply

/* line 168 "/vobs/specman/src/comm_request.e"  From 'struct definition' */
typedef struct s__sn__comm_request_status {
    t__int d__;
    t__int gen__;
    t__sn__comm_status status;
    t__string error_message;
} *t__sn__comm_request_status;
#define d__sn__comm_request_status 3304
typedef t__sn__comm_request_status t__comm_request_status;
#define d__comm_request_status d__sn__comm_request_status

/* line 116 "/vobs/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__sn__comm_waiting_in_rep22361 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__comm_waiting_in_22366 *waiting_in_reply_queue;
} *t__sn__comm_waiting_in_reply_queue;
#define d__sn__comm_waiting_in_reply_queue 3324
typedef t__sn__comm_waiting_in_reply_queue t__comm_waiting_in_reply_queue;
#define d__comm_waiting_in_reply_queue d__sn__comm_waiting_in_reply_queue

/* line 87 "/vobs/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__sn__comm_waiting_in_reply {
    t__int d__;
    t__int gen__;
    t__int id;
    struct s__sn__comm_data_header *reply_data_header;
    struct s__sn__comm_pack_unpackable *msg;
} *t__sn__comm_waiting_in_reply;
#define d__sn__comm_waiting_in_reply 3323
typedef t__sn__comm_waiting_in_reply t__comm_waiting_in_reply;
#define d__comm_waiting_in_reply d__sn__comm_waiting_in_reply

/* line 15 "/vobs/specman/src/comm_data_header.e"  From 'struct definition' */
typedef struct s__sn__comm_data_header {
    t__int d__;
    t__int gen__;
    t__int id;
    t__sn__comm_request_opcode opcode;
    t__bool is_request;
    t__bool is_notification;
} *t__sn__comm_data_header;
#define d__sn__comm_data_header 3320
typedef t__sn__comm_data_header t__comm_data_header;
#define d__comm_data_header d__sn__comm_data_header

/* line 5 "/vobs/specman/src/comm_packable.e"  From 'struct definition' */
typedef struct s__sn__comm_pack_unpackable {
    t__int d__;
    t__int gen__;
} *t__sn__comm_pack_unpackable;
#define d__sn__comm_pack_unpackable 3291
typedef t__sn__comm_pack_unpackable t__comm_pack_unpackable;
#define d__comm_pack_unpackable d__sn__comm_pack_unpackable

/* line 10 "/vobs/specman/src/comm_msg_man.e"  From 'struct definition' */
typedef struct s__sn__comm_message_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_data_header_factory *data_header_factory;
    struct s__sn__comm_msg_dispatcher *msg_dispatcher;
    t__int next_out_message_id;
} *t__sn__comm_message_manager;
#define d__sn__comm_message_manager 3330
typedef t__sn__comm_message_manager t__comm_message_manager;
#define d__comm_message_manager d__sn__comm_message_manager

/* line 142 "/vobs/specman/src/comm_data_header.e"  From 'struct definition' */
typedef struct s__sn__comm_data_header_factory {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *data_header_sd;
} *t__sn__comm_data_header_factory;
#define d__sn__comm_data_header_factory 3321
typedef t__sn__comm_data_header_factory t__comm_data_header_factory;
#define d__comm_data_header_factory d__sn__comm_data_header_factory

/* line 318 "/vobs/specman/src/comm_msg_man.e"  From 'struct definition' */
typedef struct s__sn__comm_msg_dispatcher {
    t__int d__;
    t__int gen__;
} *t__sn__comm_msg_dispatcher;
#define d__sn__comm_msg_dispatcher 3331
typedef t__sn__comm_msg_dispatcher t__comm_msg_dispatcher;
#define d__comm_msg_dispatcher d__sn__comm_msg_dispatcher

/* line 66 "/vobs/specman/src/comm_con_man.e"  From 'struct definition' */
typedef struct s__sn__comm_connection_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_socket_interactor *data_socket;
} *t__sn__comm_connection_manager;
#define d__sn__comm_connection_manager 3332
typedef t__sn__comm_connection_manager t__comm_connection_manager;
#define d__comm_connection_manager d__sn__comm_connection_manager

/* line 6 "/vobs/specman/src/comm_socket.e"  From 'struct definition' */
typedef struct s__sn__comm_socket_interactor {
    t__int d__;
    t__int gen__;
    t__int socket_id;
    struct s__l__byte *buffer;
    t__int port;
    t__sn__sn_con_state state;
    struct s__e_core__file *file_stream;
    t__external_pointer file_stream_buffer;
    t__string server_ip_addr;
    struct s__sn__comm_socket_interactor *original_comm_socket;
    t__int MAX_SNORB_STR_LEN;
} *t__sn__comm_socket_interactor;
#define d__sn__comm_socket_interactor 3288
typedef t__sn__comm_socket_interactor t__comm_socket_interactor;
#define d__comm_socket_interactor d__sn__comm_socket_interactor

/* line 206 "/vobs/specman/src/communication.e"  From 'struct definition' */
typedef struct s__sn__comm_client_applica22370 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string version;
} *t__sn__comm_client_application_desc;
#define d__sn__comm_client_application_desc 3340
typedef t__sn__comm_client_application_desc t__comm_client_application_desc;
#define d__comm_client_application_desc d__sn__comm_client_application_desc

/* line 2328 "/vobs/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__sn__keyword_manager {
    t__int d__;
    t__int gen__;
    t__bool ignore_keywords;
    struct s__k__string__it *keywords;
    struct s__k__string__it *pseudo_methods;
    struct s__k__string__it *pre_define_types;
    struct s__k__string__it *names;
    struct s__k__string__it *depricated_tokens;
    struct s__k__string__it *config_words;
    struct s__l__reflection__rf_type *config_types;
    struct s__l__sn__Token *tokens;
    t__int keyword_line;
    t__bool only_one;
} *t__sn__keyword_manager;
#define d__sn__keyword_manager 545
typedef t__sn__keyword_manager t__keyword_manager;
#define d__keyword_manager d__sn__keyword_manager

/* line 7 "/vobs/specman/src/reserved_keywords.e"  From 'struct definition' */
typedef struct s__sn__Token {
    t__int d__;
    t__int gen__;
    t__string reserved_keywords___token;
    t__int reserved_keywords___end_line;
    struct s__reflection__rf_struct *reserved_keywords___rf_struct;
    t__sn__sn_token_kind reserved_keywords___rf_struct_kind;
    struct s__e_core__source_item *reserved_keywords___source_item;
    t__bool reserved_keywords___first_err;
    t__sn__sn_token_type reserved_keywords___type;
    t__string append_error;
    t__string dac___type__reserved_keywords___orig_pattern;
    t__string dac___type__reserved_keywords___new_pattern;
} *t__sn__Token;
#define d__sn__Token 9365
typedef t__sn__Token t__Token;
#define d__Token d__sn__Token

/* line 403 "/vobs/specman/src/interp.e"  From 'struct definition' */
typedef struct s__sn__sn_cvl_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__cvl_connection *cons;
    t__bool trace;
    t__bool data_trace;
    struct s__sn__type_descriptor *cvl_connection_type;
    t__uint server_port;
    t__uint buffers_init_size;
    t__uint buffers_max_size;
    t__uint checksum;
    t__uint close_timeout;
    t__bool compatibility323;
    struct s__l__sn__sn_checksum_t *cons_checksum;
    t__int socket_timeout;
    struct s__sn__sn_socket_interactor *main_sock;
    t__bool user_set_trace;
    struct s__l__sn__sn_cvl_method *all_cvl_methods;
    struct s__l__sn__sn_cvl_method *all_cvl_callbacks;
    struct s__l__sn__sn_cvl_method *all_stub_cvl_calls;
    struct s__l__sn__sn_cvl_method *all_stub_cvl_methods;
    struct s__sn__sn_cvl_method *first_method_with_arg_struct;
    t__uint next_id;
    struct s__l__string *cvl_structs;
} *t__sn__sn_cvl_manager;
#define d__sn__sn_cvl_manager 655
typedef t__sn__sn_cvl_manager t__sn_cvl_manager;
#define d__sn_cvl_manager d__sn__sn_cvl_manager

/* line 51 "/vobs/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn__cvl_connection {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___connection_closed_occ_l;
    struct s__sn__sn_event_struct *sn___connection_closed_event_struct;
    t__long_int sn___connection_opened_occ_l;
    struct s__sn__sn_event_struct *sn___connection_opened_event_struct;
    t__string name;
    t__bool used;
    t__bool trace;
    t__bool data_trace;
    t__bool specman_initiate_close;
    t__sn__sn_connection_type kind;
    t__bool need_to_resume_listening;
    t__sn__test_phase connected_process_phase;
    t__uint server_port;
    t__string server_host;
    t__uint timeout;
    t__uint stack_ptr;
    struct s__l__sn__queued_cvl_call *waiting_list;
    t__bool need_to_consume_event;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    struct s__sn__sn_cvl_buffer *ib;
    struct s__sn__sn_cvl_output_buffer *ob;
    struct s__sn__sn_socket_interactor *sock;
    t__sn__sn_callmode_type previous_callmode;
    t__bool in_resync_context;
    struct s__e_core__any_struct *owner_struct;
} *t__sn__cvl_connection;
#define d__sn__cvl_connection 3256
typedef t__sn__cvl_connection t__cvl_connection;
#define d__cvl_connection d__sn__cvl_connection

/* line 170 "/vobs/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn__queued_cvl_call {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___lifo_occ_l;
    struct s__sn__sn_event_struct *sn___lifo_event_struct;
} *t__sn__queued_cvl_call;
#define d__sn__queued_cvl_call 3257
typedef t__sn__queued_cvl_call t__queued_cvl_call;
#define d__queued_cvl_call d__sn__queued_cvl_call

/* line 273 "/vobs/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_cvl_buffer {
    t__int d__;
    t__int gen__;
    struct s__l__byte *buf;
    t__uint buf_start;
    t__uint buf_end;
    t__uint item_count;
    t__uint last_buffer_size;
} *t__sn__sn_cvl_buffer;
#define d__sn__sn_cvl_buffer 3259
typedef t__sn__sn_cvl_buffer t__sn_cvl_buffer;
#define d__sn_cvl_buffer d__sn__sn_cvl_buffer

/* line 351 "/vobs/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_cvl_output_buffer {
    t__int d__;
    t__int gen__;
    struct s__l__byte *buf;
    t__uint buf_start;
    t__uint buf_end;
    t__uint item_count;
    t__uint last_buffer_size;
} *t__sn__sn_cvl_output_buffer;
#define d__sn__sn_cvl_output_buffer 3260
typedef t__sn__sn_cvl_output_buffer t__sn_cvl_output_buffer;
#define d__sn_cvl_output_buffer d__sn__sn_cvl_output_buffer

/* line 26 "/vobs/specman/src/cvl_socket_interactor.e"  From 'struct definition' */
typedef struct s__sn__sn_socket_interactor {
    t__int d__;
    t__int gen__;
    t__int socket_id;
    struct s__l__byte *buffer;
    t__int port;
    t__sn__sn_con_state state;
} *t__sn__sn_socket_interactor;
#define d__sn__sn_socket_interactor 3266
typedef t__sn__sn_socket_interactor t__sn_socket_interactor;
#define d__sn_socket_interactor d__sn__sn_socket_interactor

/* line 262 "/vobs/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_checksum_t {
    t__int d__;
    t__int gen__;
    t__string struct_name;
    t__uint checksum;
} *t__sn__sn_checksum_t;
#define d__sn__sn_checksum_t 3258
typedef t__sn__sn_checksum_t t__sn_checksum_t;
#define d__sn_checksum_t d__sn__sn_checksum_t

/* line 24 "/vobs/specman/src/cvl_statements.e"  From 'struct definition' */
typedef struct s__sn__sn_cvl_method {
    t__int d__;
    t__int gen__;
    struct s__sn__method *method;
    t__string method_name;
    t__uint id;
    t__string c_function_name;
    t__string target_struct;
    t__string c_args;
    t__string collect_all_arg_names;
    t__sn__sn_cvl_method_type kind;
    t__sn__sn_callmode_type calltype;
    t__string interface;
    t__string callback_named_event;
} *t__sn__sn_cvl_method;
#define d__sn__sn_cvl_method 3276
typedef t__sn__sn_cvl_method t__sn_cvl_method;
#define d__sn_cvl_method d__sn__sn_cvl_method

/* line 33 "/vobs/specman/src/operators1.e"  From 'struct definition' */
typedef struct s__e_core__sys {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__e_core__time *time;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___tick_start_occ_l;
    struct s__sn__sn_event_struct *sn___tick_start_event_struct;
    t__long_int sn___tick_end_occ_l;
    struct s__sn__sn_event_struct *sn___tick_end_event_struct;
    t__long_int sn___any_occ_l;
    struct s__sn__sn_event_struct *sn___any_event_struct;
    t__long_int sn___new_time_occ_l;
    struct s__sn__sn_event_struct *sn___new_time_event_struct;
    struct s__e_core__message_logger *logger;
} *t__e_core__sys;
#define d__e_core__sys 887
typedef t__e_core__sys t__sys;
#define d__sys d__e_core__sys

/* line 9 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__message_logger {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__k__sn__sn_message_action__it *actions;
    struct s__k__sn__sn_message_desti70941 *destinations;
    struct s__e_core__any_unit *base_unit;
    struct s__l__e_core__message_tag *tags;
    t__e_core__message_verbosity verbosity;
    t__string modules;
    t__string string_pattern;
    t__string to_file;
    t__bool to_screen;
    t__e_core__message_format format;
    t__int flush_frequency;
    t__string name;
    struct s__l__sn__sn_message_desti70942 *sn___current_destinations_stack;
} *t__e_core__message_logger;
#define d__e_core__message_logger 1141
typedef t__e_core__message_logger t__message_logger;
#define d__message_logger d__e_core__message_logger

/* line 1827 "/vobs/specman/src/flow_control.e"  From 'struct definition' */
typedef struct s__sn__sn_message_action {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__int ind;
    t__e_core__message_tag tag;
    t__e_core__message_verbosity verbosity;
    t__string f__template;
    t__string method_name;
    t__bool f_flag;
    t__bool leader;
    t__vt__vt_style style;
    struct s__sn__rf_message_action *message_action___rf_message_action;
} *t__sn__sn_message_action;
#define d__sn__sn_message_action 600
typedef t__sn__sn_message_action t__sn_message_action;
#define d__sn_message_action d__sn__sn_message_action

/* line 760 "/vobs/specman/src/message_action.e"  From 'struct definition' */
typedef struct s__sn__rf_message_action {
    t__int d__;
    t__int gen__;
    t__e_core__message_tag tag;
    t__e_core__message_verbosity verbosity;
    t__string pattern;
    struct s__e_core__source_item *source_item;
} *t__sn__rf_message_action;
#define d__sn__rf_message_action 7328
typedef t__sn__rf_message_action t__rf_message_action;
#define d__rf_message_action d__sn__rf_message_action

/* line 43 "/vobs/specman/src/message_action.e"  From 'struct definition' */
typedef struct s__sn__sn_message_destination {
    t__int d__;
    t__int gen__;
    t__string name;
} *t__sn__sn_message_destination;
#define d__sn__sn_message_destination 7318
typedef t__sn__sn_message_destination t__sn_message_destination;
#define d__sn_message_destination d__sn__sn_message_destination

/* line 11 "/vobs/specman/src/message_logger.e"  From 'struct definition' */
typedef struct s__sn__sn_message_destinations {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_message_desti70940 *destinations;
} *t__sn__sn_message_destinations;
#define d__sn__sn_message_destinations 7373
typedef t__sn__sn_message_destinations t__sn_message_destinations;
#define d__sn_message_destinations d__sn__sn_message_destinations

/* line 2174 "/vobs/specman/src/list_macros.e"  From 'struct definition' */
typedef struct s__sn__sort_item {
    t__int d__;
    t__int gen__;
    t__untyped field;
    t__int index;
} *t__sn__sort_item;
#define d__sn__sort_item 958
typedef t__sn__sort_item t__sort_item;
#define d__sort_item d__sn__sort_item

/* line 127 "/vobs/specman/src/script_rnd.e"  From 'struct definition' */
typedef struct s__sn__params {
    t__int d__;
    t__int gen__;
    t__int seed;
    t__sn__random_policy random_policy;
} *t__sn__params;
#define d__sn__params 1244
typedef t__sn__params t__params;
#define d__params d__sn__params

/* line 369 "/vobs/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__sn__sn_capture {
    t__int d__;
    t__int gen__;
    t__sn__capture_mode capture_mode;
    t__bool is_in_record_mode;
    t__bool is_in_replay_mode;
    t__bool debug_mode;
    t__bool oncap;
    t__string capture_tar_file;
    t__string capture_pure_tar_file;
    t__string capture_top_dir;
    t__string capture_dir;
    t__sn__capture_mode requested_mode;
    t__bool force_trans_files;
    t__int interaction_counter;
    t__int command_counter;
    t__int real_command_counter;
    t__int tick_command_counter;
    t__sn__data_format capture_data_format;
    t__string capture_data_version;
    t__bool trace_file_eof;
    t__string next_interactions_line;
    t__bool has_line_waiting;
    t__bool capture_is_enabled;
    t__bool recording_through_redo;
    t__bool dont_record_current_command;
    t__bool ignore_retro_command;
    t__bool replay_stop_in_debugger;
    t__int recorded_method_nesting_level;
    t__string current_recorded_method_name;
    t__int redo_status_code;
    t__bool flush_each_writing;
    struct s__sn__trans_table *files_trans_table;
    struct s__sn__trans_table *symbols_trans_table;
    t__string starting_esv_file_name;
    t__string compiled_esv_file_name;
    struct s__l__string *handled_esv_list;
    t__bool replay_esv_was_saved;
    t__string last_command_line;
    t__bool do_read_verilog_defines;
    struct s__sn__cap_info *info;
    struct s__l__string *sn_system_dirs;
    t__string sn_system_dirs_pat;
    struct s__l__string *sn_system_files;
    t__string sn_system_files_pat;
    t__string sn_temp_dir_pat;
    t__string specman_home;
    t__int replay_redo_first_index;
    t__int replay_commands_count;
    t__int replay_redo_last_index;
    t__int replay_redo_last_stop;
    t__int replay_redo_until_index;
    t__int replay_until_step;
    t__int replay_num_real_commands;
    t__bool saved_simulator_exists;
    t__sn__simulator_kind saved_simulator_kind;
    t__sn__simulator_product saved_simulator_product;
    t__bool faked_simulator_exists;
    t__sn__simulator_kind faked_simulator_kind;
    t__sn__simulator_product faked_simulator_product;
    struct s__sn__sn_vec *global_old_ba;
    t__string initial_file;
    t__string redo_file;
    t__string trace_file;
    t__string readme_file;
    t__string tables_file;
    t__string load_modules_file;
    t__string makefile_file;
    t__string elist_file;
    t__string exec_name_file;
    t__string redo_buffer_file;
    t__string esv_info_file;
    t__string record_flag_file;
    t__string replay_continue_file;
    t__string run_redo_file;
    t__string restore_replay_file;
    t__string initial_file_name;
    t__string redo_file_name;
    t__string trace_file_name;
    t__string readme_file_name;
    t__string tables_file_name;
    t__string load_modules_file_name;
    t__string makefile_file_name;
    t__string elist_file_name;
    t__string exec_name_file_name;
    t__string redo_buffer_file_name;
    t__string esv_info_file_name;
    t__string record_flag_file_name;
    t__string replay_continue_file_name;
    t__string run_redo_file_name;
    t__string restore_replay_file_name;
    t__string recovery_file_name;
    t__string config_file_name;
    t__string bp_file_name;
    t__string backup_bp_file_name;
} *t__sn__sn_capture;
#define d__sn__sn_capture 1260
typedef t__sn__sn_capture t__sn_capture;
#define d__sn_capture d__sn__sn_capture

/* line 61 "/vobs/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__sn__trans_table {
    t__int d__;
    t__int gen__;
    struct s__l__sn__trans_table_item *items_list;
} *t__sn__trans_table;
#define d__sn__trans_table 7274
typedef t__sn__trans_table t__trans_table;
#define d__trans_table d__sn__trans_table

/* line 51 "/vobs/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__sn__trans_table_item {
    t__int d__;
    t__int gen__;
    t__string from_str;
    t__string to_str;
} *t__sn__trans_table_item;
#define d__sn__trans_table_item 7273
typedef t__sn__trans_table_item t__trans_table_item;
#define d__trans_table_item d__sn__trans_table_item

/* line 196 "/vobs/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__sn__cap_info {
    t__int d__;
    t__int gen__;
    t__string user_name;
    t__string capture_file_name;
    t__string capture_dir;
    t__string capture_top_dir;
    t__string start_time;
    t__string end_time;
    t__string machine;
    t__string operation_system;
    struct s__l__string *capture_ls_dir;
    t__string current_dir;
    t__string record_command;
    struct s__l__string *first_ls_dir;
    struct s__l__string *end_ls_dir;
    struct s__e_core__time *sys_time;
    struct s__sn__params *params;
    struct s__e_core__specman_config *specman_config;
    struct s__e_core__compatibility_opt475 *compatibility_options;
    struct s__sn__cap_info_simulator *simulator;
    struct s__sn__cap_info_session *session;
    t__bool display_on;
    struct s__l__string *env_vars;
} *t__sn__cap_info;
#define d__sn__cap_info 7277
typedef t__sn__cap_info t__cap_info;
#define d__cap_info d__sn__cap_info

/* line 190 "/vobs/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__sn__cap_info_simulator {
    t__int d__;
    t__int gen__;
    t__bool exists;
    t__sn__simulator_kind kind;
    t__sn__simulator_product product;
} *t__sn__cap_info_simulator;
#define d__sn__cap_info_simulator 7276
typedef t__sn__cap_info_simulator t__cap_info_simulator;
#define d__cap_info_simulator d__sn__cap_info_simulator

/* line 168 "/vobs/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__sn__cap_info_session {
    t__int d__;
    t__int gen__;
    t__int num_of_errors;
    t__string last_save_file_name;
    t__e_core__next_prev_op next_prev_op;
    t__bool exit_on_error;
    t__string error_command;
    t__bool show_calls_on_error;
    t__bool check_ok;
    t__int num_of_dut_errors;
    t__int num_of_dut_warnings;
    t__sn__test_phase test_phase;
    struct s__sn__sn_intptr_t *run_tick_max;
    t__bool run_in_progress;
    t__bool test_command_in_progress;
    t__bool global_extract_in_progress;
    t__bool global_check_in_progress;
    t__bool end_of_test;
    t__bool do_automatic_check;
    t__bool do_only_dump_cover_file;
} *t__sn__cap_info_session;
#define d__sn__cap_info_session 7275
typedef t__sn__cap_info_session t__cap_info_session;
#define d__cap_info_session d__sn__cap_info_session

/* line 50 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__covers {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string report_file_name;
    struct s__e_core__file *report_file;
    t__string float_format;
    struct s__e_core__real *f_one;
    struct s__e_core__real *f_minus_one;
    struct s__e_core__real *f_zero;
    t__uint global_bdd_var_cnt;
    struct s__main__sn_ranker *ranker;
    struct s__main__sn_cvr_group_inst24179 *instance_iterator;
    struct s__k__main__sn_cvr_main_gr27134 *all_groups;
    t__int at_least_multiplier;
    struct s__main__sn_cvr_formula_holder *formula;
    t__main__sn_cvr_mode mode;
    t__bool check_illegal_immediately;
    t__string dir;
    t__string file_name;
    t__string test_name;
    t__string run_name;
    t__string tag_name;
    t__sn__count max_int_buckets;
    t__uint absolute_max_buckets;
    t__uint max_item_valid_space;
    t__uint absolute_item_valid_space;
    t__uint max_total_valid_space;
    t__uint absolute_total_valid_space;
    t__sn__show_mode show_mode;
    t__bool sorted;
    t__bool show_file_names;
    t__bool show_sub_holes;
    t__bool show_instances_only;
    t__bool show_partial_grade;
    t__sn__sn_cvr_cost_type ranking_cost;
    t__sn__sn_cover_gui_sync_mode gui_sync_mode;
    struct s__l__string *parse_event_lines;
    struct s__e_core__real *total_grade;
    struct s__sn__check *cover_check;
    t__bool active;
    t__bool not_prepared;
    t__main__sn_cvr_xyz file_type;
    t__string file_extention;
    t__bool ranking_flag;
    struct s__l__string *full_bucket_name;
    t__bool allow_space_separator;
    t__uint total_valid_space_size;
    t__bool check_valid_space_size;
    t__bool real_instances_parsed;
    t__bool allow_new_instances_on_read;
    struct s__e_core__time *last_update_time;
    t__bool control_dirty;
    t__bool data_dirty;
    t__bool structure_dirty;
    t__bool all_items;
    t__bool instances_only_dirty;
    struct s__l__int *ids_for_contributed;
    t__int max_contributing_tests;
    t__bool report_ungradable_only;
    t__bool report_leaf_buckts_only;
    t__bool report_summary_only;
    t__bool title_done;
    t__bool is_ready;
    t__string surecov_config;
    struct s__e_core__any_struct *parent_ptr;
    struct s__k__main__sn_cvr_main_gr27136 *all_groups_by_simple_name;
    struct s__l__main__sn_cvr_main_gr24808 *groups_report;
    t__string last_item_names;
    t__bool no_warn;
    t__main__sn_cvr_mode curr_mode;
    t__bool update_checks_counters;
    struct s__l__main__sn_cover_analy27137 *tests;
    struct s__main__sn_cover_test *current_test;
    struct s__main__sn_cover_analysis_test *current_analysis_test;
    struct s__sn__sn_cai *cai;
    struct s__reflection__rf_enum *external_entity_rf_type;
    struct s__k__main__sn_external_A_27138 *all_external_A_agents;
    struct s__k__main__sn_external_B_27139 *all_external_B_agents;
    struct s__k__main__sn_external_C_27141 *all_external_C_agents;
    struct s__k__main__sn_external_co27142 *all_external_agents;
    struct s__main__sn_cvr_item_descriptor *current_item;
    struct s__sn__event_type *current_event;
    struct s__main__sn_cvr_main_group24182 *current_group;
    struct s__main__cover_struct *cs;
    struct s__l__main__cover_struct *empty_cs_list;
    struct s__l__main__cover_struct *lcs;
    struct s__l__string *reparse_list;
    t__bool info_lost_while_reading;
    t__string last_dumped_model_file;
    t__string last_dumped_data_file;
    t__bool new_cai;
    struct s__sn__any_rl *dummy_rl;
    t__int dummy_event_id_counter;
    t__bool report_no_traced_too;
    struct s__l__string *c_cross_items;
    struct s__l__string *c_interval_events;
    t__bool cvr_use_interval;
    t__string cvr_from_event;
    t__string cvr_to_event;
    t__bool cvr_only_simultaneous;
    struct s__main__sn_cross_searcher *cross_searcher;
    t__bool new_engine;
    struct s__main__jcover *jcover;
    struct s__e_core__real *grading;
    t__int rank_gui_table_size;
    t__int rank_gui_buckets_size;
    t__sn__sn_cvr_grading_formula grading_formula;
    t__bool ignore_grade;
    t__main__sn_cover_report_kind report_kind;
    t__bool scan_physical_space;
    t__bool tmp_flag;
    t__main__sn_cover_report_kind curr_report_kind;
    t__bool full_warning_report;
    t__int curr_test_ind;
    t__string delim;
    t__bool check_ii_on_all;
    struct s__k__main__sn_cover_item_75057 *read_normal_insts;
    t__bool read_with_merge;
    t__bool value_out_of_range;
    struct s__l__string *empty_str_list;
    t__int const_count;
    struct s__sn__val_and_index *tmp_val_and_index;
    t__bool is_report_sai;
    t__bool is_write_while_test;
    struct s__sn_rl__int_rl *ecov_irl;
    struct s__sn_rl__uint_rl *ecov_url;
    struct s__k__main__sn_unicov_chec75058 *unicov_check_descriptors;
    struct s__l__main__sn_set_cover_c75059 *sn_set_cover_check_coms;
    struct s__l__main__sn_block_cover75060 *sn_block_cover_descriptors;
    struct s__main__sn_unicov_method_75061 *sn_curr_method_for_block_coverage;
    struct s__k__main__cov_per_instan75062 *cov_structs;
    struct s__main__cov_per_instance_graph *cov_insts_graph;
    t__sn__sn_cvr_model_format sn_model_comp;
    t__bool is_cs_post_mode;
    struct s__l__int *full_inds;
    t__bool is_recycle_during_read;
    struct s__main__read_cover_merge_info *read_cover_merge_info;
    struct s__main__sn_cover_analysis_test *merged_test;
    t__string last_scan;
    struct s__main__sn_cvr_item_descriptor *current_oom_item;
    struct s__l__main__sn_cvr_excov_h75063 *read_excov_holders;
    struct s__main__sn_cvr_excov_holder *write_excov_holder;
    struct s__k__sn__st_exp__it *sn_checked_ii_exps_in_unicov_cs;
    struct s__sn__sn_cvr_unicov_manager *unicov_dynamic_mngr;
    struct s__k__main__unicov_handle_75064 *modules_list;
    t__uint unicov_ver_hier_cs;
    struct s__l__main__sn_unicov_item_ptr *unicov_items_list_for_valid_space_dump;
    struct s__main__unicov_handle_tre74902 *instances_tree_root;
    struct s__l__sn__sn_cvr_double_sp75066 *test_double_spds;
    struct s__l__main__sn_cover_item_75067 *sn_cover_item_dists;
} *t__e_core__covers;
#define d__e_core__covers 1162
typedef t__e_core__covers t__covers;
#define d__covers d__e_core__covers

/* line 1096 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_ranker {
    t__int d__;
    t__int gen__;
    struct s__l__main__sn_cvr_instanc27209 *external_groups;
    struct s__k__main__sn_external_A_27138 *active_externals_A;
    struct s__main__sn_cvr_rank_config *config;
    t__bool gui;
    t__bool sort_only;
    t__bool omit_test_details;
    t__bool dont_report_rel_info;
    t__string item_names;
    t__string initial_list_file;
    struct s__l__main__sn_cvr_test_ra27211 *init_tests;
    t__main__sn_ranker__grade_threshold grade_threshold;
    t__int cost_threshold;
    t__bool recover;
    struct s__main__sn_cvr_rank_recover *recover_info;
    t__string recover_file_name;
    t__uint recover_interval;
    t__bool modified_structure;
    struct s__k__main__sn_cvr_test_ra27212 *tests;
    t__bool modified_attributes;
    struct s__l__main__sn_cvr_abstrac27172 *groups_to_fill;
    struct s__k__main__sn_cvr_test_ra27212 *ranked_tests;
    t__bool ranked;
    t__bool sorted;
    struct s__e_core__real *max_grade;
    t__int average_cost;
    struct s__e_core__real *sampled_groups_weight;
    struct s__l__main__sn_cvr_test_ra27211 *optimal_tests;
    struct s__e_core__real *cum_grade;
    t__int cum_cost;
    struct s__k__string__it *test_full_names;
    struct s__k__string__it *test_file_names;
    struct s__main__sn_rank_window *rank_window;
} *t__main__sn_ranker;
#define d__main__sn_ranker 3648
typedef t__main__sn_ranker t__sn_ranker;
#define d__sn_ranker d__main__sn_ranker

/* line 1015 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_external_A_cov27202 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__main__sn_cai_cov_agent_type kind;
    struct s__l__main__sn_cvr_externa27190 *all_groups;
    t__bool disabled;
    t__bool is_dirty;
} *t__main__sn_external_A_cover_agent;
#define d__main__sn_external_A_cover_agent 3638
typedef t__main__sn_external_A_cover_agent t__sn_external_A_cover_agent;
#define d__sn_external_A_cover_agent d__main__sn_external_A_cover_agent

/* line 389 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_external_m27192 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__source_ref source_ref;
    t__string original_file;
    t__int original_line;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    struct s__e_core__real *c_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    struct s__e_core__real *grading;
    t__bool for_report;
    t__bool rankable;
    struct s__sn__struct_descriptor *first_definition_struct;
    t__bool is_defined;
    t__bool ranges_created;
    t__bool dirty;
    struct s__l__sn__st_exp *when_exps;
    struct s__sn__struct_descriptor *Context_struct;
    struct s__sn__cover_descriptor *cgd;
    struct s__k__main__sn_cvr_instanc27169 *instances;
    struct s__main__sn_cvr_original_i27170 *original;
    struct s__main__sn_cvr_original_i27170 *old_original;
    struct s__l__main__sn_cvr_item_at27171 *items_definition_order;
    t__string struct_name;
    t__sn__index when_mask_size;
    struct s__sn__field *parent_field;
    struct s__sn__struct_descriptor *cover_struct_type;
    struct s__sn__event_type *event_type;
    struct s__l__main__sn_cvr_item_de24135 *items_to_sample;
    struct s__l__main__sn_cvr_item_de24135 *simple_not_to_sample;
    struct s__l__main__sn_cvr_item_de24135 *non_simple_not_to_sample;
    t__main__sn_cvr_external_option external_mode;
    struct s__main__cover_struct *run_cs;
    t__bool make_new_cover_struct;
    t__string q_name;
    t__string package_name;
    t__bool is_qualified;
    t__int dummy_event_id;
    t__string short_name;
    t__string agent_options;
    t__main__sn_cai_cov_agent_type external;
    struct s__main__sn_external_cover24234 *external_agent;
    void *_instances_to_reset___ptr_padding[6];
    struct s__l__main__sn_cvr_abstrac27172 *instances_to_reset;
} *t__main__sn_cvr_external_main_group_descriptor;
#define d__main__sn_cvr_external_main_group_descriptor 3596
typedef t__main__sn_cvr_external_main_group_descriptor t__sn_cvr_external_main_group_descriptor;
#define d__sn_cvr_external_main_group_descriptor d__main__sn_cvr_external_main_group_descriptor

/* line 972 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_external_cover24234 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__main__sn_cai_cov_agent_type kind;
    struct s__l__main__sn_cvr_externa27190 *all_groups;
    t__bool disabled;
    t__bool is_dirty;
} *t__main__sn_external_cover_agent;
#define d__main__sn_external_cover_agent 3635
typedef t__main__sn_external_cover_agent t__sn_external_cover_agent;
#define d__sn_external_cover_agent d__main__sn_external_cover_agent

/* line 1092 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_rank_config {
    t__int d__;
    t__int gen__;
    t__int index_width;
    t__int name_width;
    t__int cum_grade_width;
    t__int rel_grade_width;
    t__int cum_cost_width;
    t__int cost_width;
    t__int abs_grade_width;
    t__int eff_width;
    t__int ubuckets_width;
    t__int dut_err_width;
    t__int seed_width;
} *t__main__sn_cvr_rank_config;
#define d__main__sn_cvr_rank_config 3647
typedef t__main__sn_cvr_rank_config t__sn_cvr_rank_config;
#define d__sn_cvr_rank_config d__main__sn_cvr_rank_config

/* line 1047 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_test_rank_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__real *opt_grade;
    t__int id;
    struct s__main__sn_abs_cover_test *inst;
    struct s__l__main__sn_cvr_group_r24528 *groups;
    t__bool in_init_list;
    t__string external_key;
    t__bool rankable;
    t__bool in_opt_list;
    t__int cost;
    struct s__e_core__real *norm_cost;
    struct s__e_core__real *efficiency;
    struct s__e_core__real *abs_grade;
    struct s__l__main__sn_cvr_bucket_27207 *unique_buckets;
    struct s__e_core__real *opt_efficiency;
    struct s__e_core__real *cum_grade;
    t__int cum_cost;
} *t__main__sn_cvr_test_rank_info;
#define d__main__sn_cvr_test_rank_info 3642
typedef t__main__sn_cvr_test_rank_info t__sn_cvr_test_rank_info;
#define d__sn_cvr_test_rank_info d__main__sn_cvr_test_rank_info

/* line 1073 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_group_rank_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__real *opt_grade;
    struct s__main__sn_cvr_abstract_i24144 *desc;
    struct s__l__main__sn_cvr_item_ra27205 *items;
} *t__main__sn_cvr_group_rank_info;
#define d__main__sn_cvr_group_rank_info 3643
typedef t__main__sn_cvr_group_rank_info t__sn_cvr_group_rank_info;
#define d__sn_cvr_group_rank_info d__main__sn_cvr_group_rank_info

/* line 1079 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_item_rank_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__real *opt_grade;
    struct s__main__sn_cvr_item_descriptor *desc;
    struct s__l__main__sn_cvr_bucket_24154 *buckets;
} *t__main__sn_cvr_item_rank_info;
#define d__main__sn_cvr_item_rank_info 3644
typedef t__main__sn_cvr_item_rank_info t__sn_cvr_item_rank_info;
#define d__sn_cvr_item_rank_info d__main__sn_cvr_item_rank_info

/* line 1084 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_bucket_ran27194 {
    t__int d__;
    t__int gen__;
    struct s__e_core__real *opt_grade;
    struct s__main__sn_cvr_bucket_ran27195 *desc;
    t__int samples;
} *t__main__sn_cvr_bucket_rank_info;
#define d__main__sn_cvr_bucket_rank_info 3645
typedef t__main__sn_cvr_bucket_rank_info t__sn_cvr_bucket_rank_info;
#define d__sn_cvr_bucket_rank_info d__main__sn_cvr_bucket_rank_info

/* line 1447 "/vobs/specman/src/cover_rank.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_rank_recover {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_timer *timer;
    t__uint last_sample;
    t__string item_names;
    struct s__l__string *init_test_names;
    struct s__l__int *optimal_test_ids;
} *t__main__sn_cvr_rank_recover;
#define d__main__sn_cvr_rank_recover 3878
typedef t__main__sn_cvr_rank_recover t__sn_cvr_rank_recover;
#define d__sn_cvr_rank_recover d__main__sn_cvr_rank_recover

/* line 42 "/vobs/specman/src/times.e"  From 'struct definition' */
typedef struct s__sn__sn_timer {
    t__int d__;
    t__int gen__;
    struct s__sn__tms *from;
    struct s__sn__tms *to;
    struct s__sn__timeval *micro_from;
    struct s__sn__timeval *micro_to;
    struct s__sn__timeval *accorate_time;
} *t__sn__sn_timer;
#define d__sn__sn_timer 3499
typedef t__sn__sn_timer t__sn_timer;
#define d__sn_timer d__sn__sn_timer

/* line 19 "/vobs/specman/src/times.e"  From 'struct definition' */
typedef struct s__sn__tms {
    t__int d__;
    t__int gen__;
    t__sn__clock_t tms_utime;
    t__sn__clock_t tms_stime;
    t__sn__clock_t tms_cutime;
    t__sn__clock_t tms_cstime;
} *t__sn__tms;
#define d__sn__tms 3497
typedef t__sn__tms t__tms;
#define d__tms d__sn__tms

/* line 26 "/vobs/specman/src/times.e"  From 'struct definition' */
typedef struct s__sn__timeval {
    t__int d__;
    t__int gen__;
    t__uint tv_sec;
    t__uint tv_usec;
} *t__sn__timeval;
#define d__sn__timeval 3498
typedef t__sn__timeval t__timeval;
#define d__timeval d__sn__timeval

/* line 296 "/vobs/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__main__sn_rank_window {
    t__int d__;
    t__int gen__;
    struct s__l__string *initial_list;
    t__bool ignore;
    t__bool not_finished;
    t__bool recover;
    t__string grade_kind;
    t__string items;
    struct s__l__main__sn_cvr_gui_cur75073 *checked_till_now;
    struct s__main__sn_cvr_gui_curr_page *curr_page;
    t__bool sort;
    struct s__main__sn_rank_html_table *table;
    struct s__l__main__sn_cvr_gui_cur75073 *gui_curr_bucket_pages;
    struct s__main__sn_cvr_gui_curr_page *curr_bucket_page;
    t__string curr_test_context;
    struct s__vt__vt_window *win;
    struct s__vt__vt_window *single_win;
    struct s__vt__vt_window *bucket_win;
} *t__main__sn_rank_window;
#define d__main__sn_rank_window 7393
typedef t__main__sn_rank_window t__sn_rank_window;
#define d__sn_rank_window d__main__sn_rank_window

/* line 288 "/vobs/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_gui_curr_page {
    t__int d__;
    t__int gen__;
    struct s__l__int *checked;
    t__int from;
    t__int to;
    t__int id;
} *t__main__sn_cvr_gui_curr_page;
#define d__main__sn_cvr_gui_curr_page 7392
typedef t__main__sn_cvr_gui_curr_page t__sn_cvr_gui_curr_page;
#define d__sn_cvr_gui_curr_page d__main__sn_cvr_gui_curr_page

/* line 157 "/vobs/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__main__sn_rank_html_table {
    t__int d__;
    t__int gen__;
    struct s__l__main__sn_cvr_table_column *columns;
    t__string heading;
} *t__main__sn_rank_html_table;
#define d__main__sn_rank_html_table 7391
typedef t__main__sn_rank_html_table t__sn_rank_html_table;
#define d__sn_rank_html_table d__main__sn_rank_html_table

/* line 76 "/vobs/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_table_column {
    t__int d__;
    t__int gen__;
    t__string heading;
    struct s__l__string *f__entry;
    t__int width;
    t__int height;
} *t__main__sn_cvr_table_column;
#define d__main__sn_cvr_table_column 7389
typedef t__main__sn_cvr_table_column t__sn_cvr_table_column;
#define d__sn_cvr_table_column d__main__sn_cvr_table_column

/* line 29 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_window {
    t__int d__;
    t__int gen__;
    t__vt__vt_window_kind kind;
    struct s__vt__vt_window_action_manager *action_manager;
    struct s__vt__vt_window_callback_39932 *callback_handler;
    t__vt__vt_window_state state;
    t__bool m_modal;
    t__bool m_dirty_gui;
    t__vt__vt_gui_refresh_mode m_gui_refresh_mode;
    struct s__vt__sni_vt_jwindow *p_win;
    t__bool p_is_locked;
    t__bool p_vt_extended_mode;
    t__int p_n_id;
    t__string s_win_id;
    struct s__vt__vt_window_attributes *curr_attributes;
    t__bool f_was_visible;
    t__int curr_page_index;
    struct s__vt__vt_window_pages_history *history;
    t__string category_name;
    struct s__vt__vt_window_requested39115 *requested_attributes;
    struct s__vt__vt_window_additiona39933 *additional_attributes;
    t__string requested_title_prefix;
    struct s__vt__vt_page *first_page;
    t__bool fixed_title_was_set;
    t__bool configuration_in_progress;
    t__bool m_configuration_completed;
    t__bool visited_configure;
    t__bool m_offline;
    t__bool m_destroyed;
    struct s__k__string__it *m_initially_disabled_action_names;
    struct s__vt__vt_symbol_manager *symbol_manager;
    t__int DEFAULT_HISTORY_DEPTH;
    t__int ABSOLUTE_HISTORY_DEPTH;
    t__int history_depth;
    struct s__vt__vt_window_handler *m_window_handler;
    t__bool DECRYPTION_PASSWORD_DIALOG__m_password_confirmed;
} *t__vt__vt_window;
#define d__vt__vt_window 2539
typedef t__vt__vt_window t__vt_window;
#define d__vt_window d__vt__vt_window

/* line 169 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_window_action_manager {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_window *m_window;
    struct s__vt__vt_menubar *m_menubar;
    struct s__l__vt__vt_toolbar *m_toolbars;
    struct s__vt__vt_appl_toolbar *m_appl_toolbar;
    struct s__k__vt__vt_menu__m_name *m_menus;
    struct s__k__vt__vt_base_action__39950 *m_actions;
    struct s__k__vt__vt_action_group_39951 *m_action_groups;
    t__bool m_dirty;
    t__vt__vt_menubar_default_actions m_default_actions;
} *t__vt__vt_window_action_manager;
#define d__vt__vt_window_action_manager 4942
typedef t__vt__vt_window_action_manager t__vt_window_action_manager;
#define d__vt_window_action_manager d__vt__vt_window_action_manager

/* line 367 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_menubar {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    struct s__vt__vt_window *m_window;
    struct s__vt__vt_menubar_containe37375 *m_helper;
} *t__vt__vt_menubar;
#define d__vt__vt_menubar 4944
typedef t__vt__vt_menubar t__vt_menubar;
#define d__vt_menubar d__vt__vt_menubar

/* line 678 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_menubar_containe37375 {
    t__int d__;
    t__int gen__;
    struct s__l__vt__vt_menu_component *m_leading_items;
    struct s__l__vt__vt_menu_component *m_user_items;
    struct s__l__vt__vt_menu_component *m_trailing_items;
    t__bool m_first_user_separator;
    t__bool m_last_user_separator;
} *t__vt__vt_menubar_container_helper;
#define d__vt__vt_menubar_container_helper 4950
typedef t__vt__vt_menubar_container_helper t__vt_menubar_container_helper;
#define d__vt_menubar_container_helper d__vt__vt_menubar_container_helper

/* line 495 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_menu_component {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    t__vt__vt_menu_component_kind m_kind;
} *t__vt__vt_menu_component;
#define d__vt__vt_menu_component 4947
typedef t__vt__vt_menu_component t__vt_menu_component;
#define d__vt_menu_component d__vt__vt_menu_component

/* line 410 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_toolbar {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    struct s__vt__vt_window *m_window;
    struct s__vt__vt_menubar_containe37375 *m_helper;
} *t__vt__vt_toolbar;
#define d__vt__vt_toolbar 4945
typedef t__vt__vt_toolbar t__vt_toolbar;
#define d__vt_toolbar d__vt__vt_toolbar

/* line 465 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_appl_toolbar {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    struct s__vt__vt_window *m_window;
    struct s__l__vt__vt_appl_action *m_actions;
} *t__vt__vt_appl_toolbar;
#define d__vt__vt_appl_toolbar 4946
typedef t__vt__vt_appl_toolbar t__vt_appl_toolbar;
#define d__vt_appl_toolbar d__vt__vt_appl_toolbar

/* line 830 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_appl_action {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    t__vt__vt_menu_component_kind m_kind;
    struct s__vt__vt_menu *m_menu_parent;
    t__string m_title;
    t__int m_mnemonic_key;
    t__bool m_predefined;
    t__vt__vt_action_kind m_action_kind;
    t__string m_tooltip;
    t__string m_icon;
    t__string m_command;
    t__int m_accelerator_key;
    t__bool m_enabled;
    t__bool m_enabled_at_window_level;
    t__vt__vt_action_special_attribute m_special_attribute;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    struct s__vt__vt_appl_toolbar *m_appl_toolbar_parent;
} *t__vt__vt_appl_action;
#define d__vt__vt_appl_action 4952
typedef t__vt__vt_appl_action t__vt_appl_action;
#define d__vt_appl_action d__vt__vt_appl_action

/* line 588 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_menu {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    t__vt__vt_menu_component_kind m_kind;
    struct s__vt__vt_menu *m_menu_parent;
    t__string m_title;
    t__int m_mnemonic_key;
    t__bool m_predefined;
    struct s__vt__vt_menubar_containe37375 *m_helper;
    struct s__vt__vt_menubar *m_menubar_parent;
} *t__vt__vt_menu;
#define d__vt__vt_menu 4949
typedef t__vt__vt_menu t__vt_menu;
#define d__vt_menu d__vt__vt_menu

/* line 197 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_web_export_info {
    t__int d__;
    t__int gen__;
} *t__vt__vt_web_export_info;
#define d__vt__vt_web_export_info 4805
typedef t__vt__vt_web_export_info t__vt_web_export_info;
#define d__vt_web_export_info d__vt__vt_web_export_info

/* line 695 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_base_action {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    t__vt__vt_menu_component_kind m_kind;
    struct s__vt__vt_menu *m_menu_parent;
    t__string m_title;
    t__int m_mnemonic_key;
    t__bool m_predefined;
    t__vt__vt_action_kind m_action_kind;
    t__string m_tooltip;
    t__string m_icon;
    t__string m_command;
    t__int m_accelerator_key;
    t__bool m_enabled;
    t__bool m_enabled_at_window_level;
    t__vt__vt_action_special_attribute m_special_attribute;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
} *t__vt__vt_base_action;
#define d__vt__vt_base_action 4951
typedef t__vt__vt_base_action t__vt_base_action;
#define d__vt_base_action d__vt__vt_base_action

/* line 950 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_action_group {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    struct s__vt__vt_window *m_window;
    struct s__l__vt__vt_member_action *m_actions;
} *t__vt__vt_action_group;
#define d__vt__vt_action_group 4958
typedef t__vt__vt_action_group t__vt_action_group;
#define d__vt_action_group d__vt__vt_action_group

/* line 915 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_member_action {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__vt__vt_menu_element_kind m_menu_element_kind;
    t__vt__vt_menu_component_kind m_kind;
    struct s__vt__vt_menu *m_menu_parent;
    t__string m_title;
    t__int m_mnemonic_key;
    t__bool m_predefined;
    t__vt__vt_action_kind m_action_kind;
    t__string m_tooltip;
    t__string m_icon;
    t__string m_command;
    t__int m_accelerator_key;
    t__bool m_enabled;
    t__bool m_enabled_at_window_level;
    t__vt__vt_action_special_attribute m_special_attribute;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    struct s__vt__vt_toolbar *m_toolbar_parent;
    t__string m_toolbar_title;
    t__bool m_selected;
    t__string m_selected_icon;
    t__string m_group_name;
} *t__vt__vt_member_action;
#define d__vt__vt_member_action 4957
typedef t__vt__vt_member_action t__vt_member_action;
#define d__vt_member_action d__vt__vt_member_action

/* line 40 "/vobs/specman/src/japp/vt/vt_window.e"  From 'struct definition' */
typedef struct s__vt__vt_window_callback_39932 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__vt__vt_window *window;
} *t__vt__vt_window_callback_handler;
#define d__vt__vt_window_callback_handler 5382
typedef t__vt__vt_window_callback_handler t__vt_window_callback_handler;
#define d__vt_window_callback_handler d__vt__vt_window_callback_handler

/* line 238 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__sni_vt_jwindow {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vt_jwindow;
#define d__vt__sni_vt_jwindow 5049
typedef t__vt__sni_vt_jwindow t__sni_vt_jwindow;
#define d__sni_vt_jwindow d__vt__sni_vt_jwindow

/* line 473 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_window_attributes {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string close_action;
    t__string s_file_name;
    t__string s_title;
    struct s__vt__sn_pair_nums *location;
    struct s__vt__sn_pair_nums *size;
    t__bool is_loacked;
    struct s__l__string *components;
} *t__vt__vt_window_attributes;
#define d__vt__vt_window_attributes 5056
typedef t__vt__vt_window_attributes t__vt_window_attributes;
#define d__vt_window_attributes d__vt__vt_window_attributes

/* line 170 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_window_pages_history {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__sn_struct *elements;
    t__int curr_index;
    struct s__vt__vt_window *window;
} *t__vt__vt_window_pages_history;
#define d__vt__vt_window_pages_history 5044
typedef t__vt__vt_window_pages_history t__vt_window_pages_history;
#define d__vt_window_pages_history d__vt__vt_window_pages_history

/* line 439 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_window_requested39115 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__vt__vt_location *location;
    struct s__vt__vt_size *size;
    t__bool navigation_buttons;
    t__bool lockable;
    t__bool locked;
    t__string pre_close_command;
    t__string icon;
    struct s__vt__jaction_manager *action_manager;
    struct s__vt__vt_statusbar *statusbar;
} *t__vt__vt_window_requested_attributes;
#define d__vt__vt_window_requested_attributes 5052
typedef t__vt__vt_window_requested_attributes t__vt_window_requested_attributes;
#define d__vt_window_requested_attributes d__vt__vt_window_requested_attributes

/* line 451 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__jaction_manager {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__vt__jvt_action *actions;
    struct s__l__vt__jvt_menu *menus;
    struct s__l__vt__jvt_action *buttons;
    struct s__l__vt__jvt_toolbar *toolbars;
} *t__vt__jaction_manager;
#define d__vt__jaction_manager 5053
typedef t__vt__jaction_manager t__jaction_manager;
#define d__jaction_manager d__vt__jaction_manager

/* line 623 "/vobs/specman/src/japp/vt/vt_menubar_defs.e"  From 'struct definition' */
typedef struct s__vt__jvt_menu {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__vt__vt_menu_component_kind kind;
    t__string name;
    t__string title;
    t__int mnemonic_key;
    struct s__l__vt__jmenu_component *items;
} *t__vt__jvt_menu;
#define d__vt__jvt_menu 5070
typedef t__vt__jvt_menu t__jvt_menu;
#define d__jvt_menu d__vt__jvt_menu

/* line 606 "/vobs/specman/src/japp/vt/vt_menubar_defs.e"  From 'struct definition' */
typedef struct s__vt__jmenu_component {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__vt__vt_menu_component_kind kind;
} *t__vt__jmenu_component;
#define d__vt__jmenu_component 5068
typedef t__vt__jmenu_component t__jmenu_component;
#define d__jmenu_component d__vt__jmenu_component

/* line 599 "/vobs/specman/src/japp/vt/vt_menubar_defs.e"  From 'struct definition' */
typedef struct s__vt__jvt_toolbar {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string name;
    struct s__l__vt__jmenu_component *items;
} *t__vt__jvt_toolbar;
#define d__vt__jvt_toolbar 5067
typedef t__vt__jvt_toolbar t__jvt_toolbar;
#define d__jvt_toolbar d__vt__jvt_toolbar

/* line 430 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_window_additiona39933 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__vt__vt_location *location;
    struct s__vt__vt_size *size;
    t__vt__vt_bool_tristate navigation_buttons;
    t__vt__vt_bool_tristate lockable;
    t__string pre_close_command;
    t__string icon;
} *t__vt__vt_window_additional_attributes;
#define d__vt__vt_window_additional_attributes 5051
typedef t__vt__vt_window_additional_attributes t__vt_window_additional_attributes;
#define d__vt_window_additional_attributes d__vt__vt_window_additional_attributes

/* line 3199 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_page {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__bool m_exposed;
    t__bool m_enabled;
    struct s__vt__vt_container_model *m_model;
    struct s__vt__vt_page *m_page;
    t__bool m_in_page_exposed_tree;
    struct s__vt__vt_container_handler *m_handler;
    t__vt__vt_page_kind kind;
    t__vt__vt_window_kind window_kind;
    struct s__vt__vt_window *VT_HISTORY_PAGE__original_window;
    struct s__vt__vt_window *window;
    t__string window_category_name;
    t__string template_fname;
    t__bool user_title_was_requested;
    struct s__vt__vt_saved_location_p37342 *m_saved_location_props;
    t__string m_requested_title;
    t__string m_orig_requested_url;
    t__string m_orig_requested_file_name;
    t__string m_calced_existing_orig_full_requested_fname;
    t__string m_orig_requested_anchor;
    struct s__l__string *m_orig_requested_html_body;
    struct s__l__string *m_final_requested_html_body;
    t__string m_prev_page_orig_base_dir;
    t__string m_orig_base_dir;
    t__string m_final_calculated_url;
    t__string m_final_calculated_file_name;
    t__bool m_is_final_html_file;
    struct s__vt__vt_page_locations_h37341 *history;
    t__bool stale;
    t__vt__vt_html_definition_kind m_final_html_definition_kind;
    struct s__k__vt__vt_temp_file_dat39738 *m_page_temp_files;
    struct s__l__string *page_disabled_action_names;
    struct s__l__vt__vt_action_enabli48631 *pending_actions_enabling_info;
    t__vt__vt_page_main_state main_state;
    t__bool configuration_in_progress;
    t__bool visited_configure;
    t__bool use_fixed_font;
    t__string bg_code;
    t__bool f_dir;
    t__int num_files_in_dir;
    t__bool f_url_not_found;
    t__bool using_html_wrapper;
    t__bool should_be_removed;
    struct s__vt__vt_page_attributes *m_actual_page_attributes;
    struct s__l__vt__status_pane_modi37344 *status_panes_data;
    struct s__vt__sn_time_sample *m_open_time;
    struct s__vt__sn_time_sample *m_close_time;
    struct s__vt__vt_symbol_manager *symbol_manager;
    struct s__l__vt__vt_table *lst_exportable_tables;
    t__sn__seq_dbg_page_kind SEQ_BROWSER_PAGE__seq_dbg_page_kind;
    struct s__e_core__any_sequence *VT_SEQ_PAGE__SEQ_BROWSER_PAGE__owner;
    t__string VT_SEQ_PAGE__SEQ_BROWSER_PAGE__content_str;
    struct s__e_core__any_sequence_driver *VT_SEQ_DRIVER_PAGE__SEQ_BROWSER_PAGE__owner;
    t__string VT_SEQ_DRIVER_PAGE__SEQ_BROWSER_PAGE__content_str;
    struct s__e_core__any_unit *VT_TOP_SEQ_PAGE__SEQ_BROWSER_PAGE__owner;
    t__string VT_TOP_SEQ_PAGE__SEQ_BROWSER_PAGE__content_str;
    struct s__e_core__any_unit *VT_TOP_DRIVER_PAGE__SEQ_BROWSER_PAGE__owner;
    t__string VT_TOP_DRIVER_PAGE__SEQ_BROWSER_PAGE__content_str;
} *t__vt__vt_page;
#define d__vt__vt_page 4886
typedef t__vt__vt_page t__vt_page;
#define d__vt_page d__vt__vt_page

/* line 1865 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_container {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__bool m_exposed;
    t__bool m_enabled;
    struct s__vt__vt_container_model *m_model;
    struct s__vt__vt_page *m_page;
    t__bool m_in_page_exposed_tree;
    struct s__vt__vt_container_handler *m_handler;
} *t__vt__vt_container;
#define d__vt__vt_container 4867
typedef t__vt__vt_container t__vt_container;
#define d__vt_container d__vt__vt_container

/* line 1860 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_container_model {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_container *m_container;
    struct s__vt__vt_html_exposed_segment *m_exposed_segment;
    struct s__vt__vt_html_segment *m_full_segment;
    t__bool m_full_data_ready;
    t__bool m_destroyed;
    struct s__l__vt__vt_toggle_button37314 *m_groups;
} *t__vt__vt_container_model;
#define d__vt__vt_container_model 4866
typedef t__vt__vt_container_model t__vt_container_model;
#define d__vt_container_model d__vt__vt_container_model

/* line 1861 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_html_exposed_segment {
    t__int d__;
    t__int gen__;
    struct s__l__string *m_orig_lines;
    t__bool m_should_be_computed;
    struct s__k__vt__vt_element__m_name *m_all_simple_elements_by_name;
    struct s__k__vt__vt_control__m_name *m_all_controls_by_name;
    struct s__k__vt__vt_container__m_name *m_all_containers_by_name;
    struct s__l__string *m_eid_html_lines;
    struct s__l__vt__vt_element *m_eid_elements_or_nulls;
    t__bool m_contains_orig_eid;
    struct s__k__vt__vt_control__m_id *m_all_controls_by_id;
    struct s__k__vt__vt_container__m_id *m_all_containers_by_id;
    t__bool m_retain_newlines;
} *t__vt__vt_html_exposed_segment;
#define d__vt__vt_html_exposed_segment 5017
typedef t__vt__vt_html_exposed_segment t__vt_html_exposed_segment;
#define d__vt_html_exposed_segment d__vt__vt_html_exposed_segment

/* line 201 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_element {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
} *t__vt__vt_element;
#define d__vt__vt_element 4806
typedef t__vt__vt_element t__vt_element;
#define d__vt_element d__vt__vt_element

/* line 581 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_control {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__bool m_exposed;
    t__bool m_enabled;
    struct s__vt__vt_behaviour *m_behaviour;
} *t__vt__vt_control;
#define d__vt__vt_control 4815
typedef t__vt__vt_control t__vt_control;
#define d__vt_control d__vt__vt_control

/* line 554 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_behaviour {
    t__int d__;
    t__int gen__;
} *t__vt__vt_behaviour;
#define d__vt__vt_behaviour 4813
typedef t__vt__vt_behaviour t__vt_behaviour;
#define d__vt_behaviour d__vt__vt_behaviour

/* line 1818 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_html_segment {
    t__int d__;
    t__int gen__;
    struct s__l__string *m_orig_lines;
    t__bool m_should_be_computed;
    struct s__k__vt__vt_element__m_name *m_all_simple_elements_by_name;
    struct s__k__vt__vt_control__m_name *m_all_controls_by_name;
    struct s__k__vt__vt_container__m_name *m_all_containers_by_name;
} *t__vt__vt_html_segment;
#define d__vt__vt_html_segment 5015
typedef t__vt__vt_html_segment t__vt_html_segment;
#define d__vt_html_segment d__vt__vt_html_segment

/* line 1221 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_toggle_button_group {
    t__int d__;
    t__int gen__;
    t__string m_group_name;
    struct s__vt__vt_container *m_parent;
    t__bool m_destroyed;
} *t__vt__vt_toggle_button_group;
#define d__vt__vt_toggle_button_group 4840
typedef t__vt__vt_toggle_button_group t__vt_toggle_button_group;
#define d__vt_toggle_button_group d__vt__vt_toggle_button_group

/* line 2380 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_container_handler {
    t__int d__;
    t__int gen__;
} *t__vt__vt_container_handler;
#define d__vt__vt_container_handler 4870
typedef t__vt__vt_container_handler t__vt_container_handler;
#define d__vt_container_handler d__vt__vt_container_handler

/* line 1134 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_saved_location_p37342 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__vt__vt_location *visible_area_location;
    t__string text;
    t__int start;
    t__bool first_only;
    t__bool whole;
    t__bool case_sensitive;
    t__bool mark_first;
    t__string anchor;
} *t__vt__vt_saved_location_properties;
#define d__vt__vt_saved_location_properties 4990
typedef t__vt__vt_saved_location_properties t__vt_saved_location_properties;
#define d__vt_saved_location_properties d__vt__vt_saved_location_properties

/* line 1185 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_page_locations_h37341 {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__sn_struct *elements;
    t__int curr_index;
    struct s__vt__vt_page *page;
} *t__vt__vt_page_locations_history;
#define d__vt__vt_page_locations_history 4994
typedef t__vt__vt_page_locations_history t__vt_page_locations_history;
#define d__vt_page_locations_history d__vt__vt_page_locations_history

/* line 56 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_temp_file_data {
    t__int d__;
    t__int gen__;
    t__string file_name;
    t__string description;
} *t__vt__vt_temp_file_data;
#define d__vt__vt_temp_file_data 4982
typedef t__vt__vt_temp_file_data t__vt_temp_file_data;
#define d__vt_temp_file_data d__vt__vt_temp_file_data

/* line 517 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_action_enabling_info {
    t__int d__;
    t__int gen__;
    t__string action_name_or_title;
    t__bool enabled;
    t__bool use_name;
} *t__vt__vt_action_enabling_info;
#define d__vt__vt_action_enabling_info 5057
typedef t__vt__vt_action_enabling_info t__vt_action_enabling_info;
#define d__vt_action_enabling_info d__vt__vt_action_enabling_info

/* line 1210 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_page_attributes {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string file_name;
    t__string html_title;
    struct s__l__string *html_body;
} *t__vt__vt_page_attributes;
#define d__vt__vt_page_attributes 5002
typedef t__vt__vt_page_attributes t__vt_page_attributes;
#define d__vt_page_attributes d__vt__vt_page_attributes

/* line 1895 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_time_sample {
    t__int d__;
    t__int gen__;
    t__string m_start_time;
    t__int m_id;
} *t__vt__sn_time_sample;
#define d__vt__sn_time_sample 5018
typedef t__vt__sn_time_sample t__sn_time_sample;
#define d__sn_time_sample d__vt__sn_time_sample

/* line 191 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_symbol_manager {
    t__int d__;
    t__int gen__;
    struct s__k__vt__vt_symbol__name *symbol_table;
    struct s__vt__vt_symbol_manager *higher_symbol_manager;
} *t__vt__vt_symbol_manager;
#define d__vt__vt_symbol_manager 5047
typedef t__vt__vt_symbol_manager t__vt_symbol_manager;
#define d__vt_symbol_manager d__vt__vt_symbol_manager

/* line 3159 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_symbol {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string value;
} *t__vt__vt_symbol;
#define d__vt__vt_symbol 4883
typedef t__vt__vt_symbol t__vt_symbol;
#define d__vt_symbol d__vt__vt_symbol

/* line 2410 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_table {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__bool m_exposed;
    t__bool m_enabled;
    struct s__vt__vt_container_model *m_model;
    struct s__vt__vt_page *m_page;
    t__bool m_in_page_exposed_tree;
    struct s__vt__vt_container_handler *m_handler;
    t__bool p_csv_exportable;
    t__string p_name;
    struct s__k__vt__vt_table_col_wra76966 *m_columns;
    t__vt__vt_color p_bg;
    t__vt__vt_color p_fg;
    t__string p_header;
    t__vt__vt_halign p_header_alignment;
    t__bool p_show_title_row;
    struct s__vt__vt_table_title_row *p_title_row;
    t__vt__vt_color p_status_bar_bg;
    t__vt__vt_auto_mode_kind p_show_status_bar_mode;
    t__vt__vt_table_status_bar_visibility p_status_bar_visibility;
    struct s__vt__vt_command_hyperlink *m_show_status_bar_lnk;
    struct s__vt__vt_command_hyperlink *m_hide_status_bar_lnk;
    struct s__vt__vt_command_hyperlink *m_top_lnk;
    struct s__vt__vt_command_hyperlink *m_prev_lnk;
    struct s__vt__vt_command_hyperlink *m_all_lnk;
    struct s__vt__vt_command_hyperlink *m_next_lnk;
    struct s__vt__vt_command_hyperlink *m_bottom_lnk;
    struct s__vt__vt_text_field *m_goto_page_textfield;
    struct s__vt__vt_command_hyperlink *m_unsort_lnk;
    struct s__vt__vt_command_hyperlink *m_unfilter_lnk;
    struct s__vt__vt_command_hyperlink *m_show_hide_filters_lnk;
    struct s__vt__vt_text_field *m_max_items_textfield;
    struct s__l__bool *m_calced_sort_value_flags;
    struct s__l__bool *m_calced_filter_value_flags;
    t__int p_table_width;
    t__bool p_is_width_proportional;
    t__bool p_show_border;
    t__uint p_max_items;
    struct s__k__vt__vt_data_table_row__it *p_orig_rows;
    struct s__k__vt__vt_data_table_row__it *p_filtered_rows;
    struct s__k__vt__vt_data_table_row__it *p_sorted_rows;
    t__int m_curr_slice_num;
    t__bool p_show_filters;
    t__bool m_user_sort_mode;
    struct s__vt__vt_table_user_sort_data *m_user_sort_data;
    struct s__k__vt__vt_table_sorted_80438 *m_sorted_cols_data;
    t__vt__vt_table_row_mode m_row_mode;
    t__int nof_rows;
    t__bool has_data_service;
    t__bool is_first_in_struct;
    t__string alternative_header;
    t__string text_header;
} *t__vt__vt_table;
#define d__vt__vt_table 4874
typedef t__vt__vt_table t__vt_table;
#define d__vt_table d__vt__vt_table

/* line 100 "/vobs/specman/src/vt_table/vt_table_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_table_col_wrapper {
    t__int d__;
    t__int gen__;
    t__string m_name;
    struct s__vt__vt_table *m_table;
    t__int m_col_num;
    t__string m_curr_filter_item;
    t__bool m_use_cell_filter_value;
    t__vt__vt_table_sort_direction m_sort_direction;
    t__bool m_use_cell_sort_value;
    struct s__vt__vt_command_hyperlink *m_sort_title_lnk;
    struct s__vt__vt_command_hyperlink *m_sort_icon_lnk;
    struct s__vt__vt_combobox *m_filter_combo;
    t__bool m_created_exposed_combo_attr;
    t__int m_final_col_width;
    struct s__vt__vt_table_col *m_user_col;
} *t__vt__vt_table_col_wrapper;
#define d__vt__vt_table_col_wrapper 7841
typedef t__vt__vt_table_col_wrapper t__vt_table_col_wrapper;
#define d__vt_table_col_wrapper d__vt__vt_table_col_wrapper

/* line 1626 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_command_hyperlink {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__bool m_exposed;
    t__bool m_enabled;
    struct s__vt__vt_behaviour *m_behaviour;
    struct s__vt__vt_image *m_image;
    t__string m_text;
    t__bool m_underline;
    struct s__vt__vt_text_attributes *m_text_attributes;
} *t__vt__vt_command_hyperlink;
#define d__vt__vt_command_hyperlink 4854
typedef t__vt__vt_command_hyperlink t__vt_command_hyperlink;
#define d__vt_command_hyperlink d__vt__vt_command_hyperlink

/* line 316 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_image {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__string m_image_file_name;
    t__int m_border_width;
    t__vt__vt_image_alignment m_alignment;
    t__int m_width;
    t__int m_height;
    t__int m_margins_width;
    t__int m_margins_height;
} *t__vt__vt_image;
#define d__vt__vt_image 4808
typedef t__vt__vt_image t__vt_image;
#define d__vt_image d__vt__vt_image

/* line 436 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_text_attributes {
    t__int d__;
    t__int gen__;
    t__vt__vt_color bg_color;
    t__vt__vt_color fg_color;
    t__bool f_bold;
    t__bool f_italic;
    t__bool f_underline;
    t__string font_name;
    t__int font_size;
} *t__vt__vt_text_attributes;
#define d__vt__vt_text_attributes 4809
typedef t__vt__vt_text_attributes t__vt_text_attributes;
#define d__vt_text_attributes d__vt__vt_text_attributes

/* line 804 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_combobox {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__bool m_exposed;
    t__bool m_enabled;
    struct s__vt__vt_behaviour *m_behaviour;
    t__int m_width;
    struct s__vt__vt_widget_modifiabl37310 *m_modifiable_attributes;
    t__uint m_dirty_attributes;
    t__bool m_unique_items;
} *t__vt__vt_combobox;
#define d__vt__vt_combobox 4820
typedef t__vt__vt_combobox t__vt_combobox;
#define d__vt_combobox d__vt__vt_combobox

/* line 122 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_widget_modifiabl37310 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string value;
    struct s__vt__vt_items_wrapper *items_wrapper;
    t__vt__vt_color bg_color;
    t__vt__vt_color fg_color;
    t__vt__vt_bool_tristate enabled;
    t__vt__vt_bool_tristate editable;
    t__vt__vt_bool_tristate no_callback;
} *t__vt__vt_widget_modifiable_attributes;
#define d__vt__vt_widget_modifiable_attributes 4804
typedef t__vt__vt_widget_modifiable_attributes t__vt_widget_modifiable_attributes;
#define d__vt_widget_modifiable_attributes d__vt__vt_widget_modifiable_attributes

/* line 6 "/vobs/specman/src/japp/shared_extra/shared_extra_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_items_wrapper {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__string *items;
} *t__vt__vt_items_wrapper;
#define d__vt__vt_items_wrapper 4014
typedef t__vt__vt_items_wrapper t__vt_items_wrapper;
#define d__vt_items_wrapper d__vt__vt_items_wrapper

/* line 402 "/vobs/specman/src/vt_table/vt_table_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_table_col {
    t__int d__;
    t__int gen__;
    t__string p_name;
    t__string m_title;
    t__string m_tooltip;
    t__string m_icon;
    t__bool m_sortable;
    t__bool m_filterable;
    t__int m_col_width;
    t__vt__vt_table_col_kind m_col_kind;
    t__vt__vt_table_col_kind m_col_sort_kind;
    t__vt__vt_color m_title_bg;
    t__vt__vt_color m_title_fg;
    t__vt__vt_color m_cells_bg;
    t__vt__vt_color m_cells_fg;
    t__bool m_use_values_filter;
    struct s__l__vt__vt_filter_kind *m_active_filters;
    t__bool m_opened;
} *t__vt__vt_table_col;
#define d__vt__vt_table_col 7820
typedef t__vt__vt_table_col t__vt_table_col;
#define d__vt_table_col d__vt__vt_table_col

/* line 236 "/vobs/specman/src/vt_table/vt_table_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_table_title_row {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_table *p_table;
    t__vt__vt_color p_bg;
    t__vt__vt_color p_fg;
    t__bool p_bold;
    t__bool m_destroyed;
} *t__vt__vt_table_title_row;
#define d__vt__vt_table_title_row 7842
typedef t__vt__vt_table_title_row t__vt_table_title_row;
#define d__vt_table_title_row d__vt__vt_table_title_row

/* line 915 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_text_field {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    t__bool m_exposed;
    t__bool m_enabled;
    struct s__vt__vt_behaviour *m_behaviour;
    t__int m_width;
    struct s__vt__vt_widget_modifiabl37310 *m_modifiable_attributes;
    t__uint m_dirty_attributes;
} *t__vt__vt_text_field;
#define d__vt__vt_text_field 4828
typedef t__vt__vt_text_field t__vt_text_field;
#define d__vt_text_field d__vt__vt_text_field

/* line 600 "/vobs/specman/src/vt_table/vt_table_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_data_table_row {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_table *p_table;
    t__vt__vt_color p_bg;
    t__vt__vt_color p_fg;
    t__bool p_bold;
    t__bool m_destroyed;
    struct s__l__string *p_cells;
    struct s__l__string *p_sort_values;
    struct s__l__string *p_filter_values;
    struct s__l__vt__vt_color *p_cell_bg_colors;
    struct s__l__vt__vt_color *p_cell_fg_colors;
} *t__vt__vt_data_table_row;
#define d__vt__vt_data_table_row 7822
typedef t__vt__vt_data_table_row t__vt_data_table_row;
#define d__vt_data_table_row d__vt__vt_data_table_row

/* line 42 "/vobs/specman/src/vt_table/vt_table.e"  From 'struct definition' */
typedef struct s__vt__vt_table_user_sort_data {
    t__int d__;
    t__int gen__;
    struct s__k__vt__vt_control__m_name *m_controls;
    struct s__k__vt__vt_container__m_name *m_containers;
    struct s__k__vt__vt_element__m_name *m_simple_elements;
} *t__vt__vt_table_user_sort_data;
#define d__vt__vt_table_user_sort_data 7850
typedef t__vt__vt_table_user_sort_data t__vt_table_user_sort_data;
#define d__vt_table_user_sort_data d__vt__vt_table_user_sort_data

/* line 13 "/vobs/specman/src/vt_table/vt_table.e"  From 'struct definition' */
typedef struct s__vt__vt_table_sorted_col_data {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_table_col_wrapper *m_col;
    t__string m_col_name;
} *t__vt__vt_table_sorted_col_data;
#define d__vt__vt_table_sorted_col_data 7849
typedef t__vt__vt_table_sorted_col_data t__vt_table_sorted_col_data;
#define d__vt_table_sorted_col_data d__vt__vt_table_sorted_col_data

/* line 40 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_sequence {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__e_core__any_sequence *parent_sequence;
    struct s__sn__any_sequence_do *sequence_imp___do_action;
    struct s__sn__sn_stripe_info *stripe_info;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___started_occ_l;
    struct s__sn__sn_event_struct *sn___started_event_struct;
    struct s__sn__waiting_thread *sn___started_thread;
    t__long_int sn___ended_occ_l;
    struct s__sn__sn_event_struct *sn___ended_event_struct;
    struct s__sn__waiting_thread *sn___ended_thread;
    t__long_int sn___stopped_occ_l;
    struct s__sn__sn_event_struct *sn___stopped_event_struct;
    struct s__sn__waiting_thread *sn___stopped_thread;
    t__int sequence_imp___depth_from_driver;
    t__bool sequence_imp___started;
    t__int sequence_imp___do_index;
    struct s__sn__item_producer *sequence_imp___iprod;
    t__int sequence_imp___iprod_id;
    t__bool sequence_imp___terminated;
    struct s__e_core__any_sequence_item *sequence_imp___cur_item_instance;
    struct s__l__e_core__any_sequence_item *sequence_imp___trace_list;
    t__sn__sn_seq_debug_state sequence_imp___state;
} *t__e_core__any_sequence;
#define d__e_core__any_sequence 1158
typedef t__e_core__any_sequence t__any_sequence;
#define d__any_sequence d__e_core__any_sequence

/* line 82 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__any_sequence_do {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__any_sequence *parent_sequence;
    t__bool is_item;
    t__sn__sn_do_debug_state state;
    struct s__sn__sn_stripe_info *stripe_info;
} *t__sn__any_sequence_do;
#define d__sn__any_sequence_do 7721
typedef t__sn__any_sequence_do t__any_sequence_do;
#define d__any_sequence_do d__sn__any_sequence_do

/* line 13 "/vobs/specman/src/seq_def.e"  From 'struct definition' */
typedef struct s__sn__sn_stripe_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__time *start_time;
    struct s__e_core__time *end_time;
    t__uint idx;
    t__string do_location;
    t__string container_name;
    t__bool expanded;
    t__uint global_index;
    t__bool fake;
} *t__sn__sn_stripe_info;
#define d__sn__sn_stripe_info 7663
typedef t__sn__sn_stripe_info t__sn_stripe_info;
#define d__sn_stripe_info d__sn__sn_stripe_info

/* line 236 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__item_producer {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int prod_id;
    struct s__e_core__any_sequence *my_seq;
    struct s__sn__item_producer *parent_producer;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___grab_grant_occ_l;
    struct s__sn__sn_event_struct *sn___grab_grant_event_struct;
    struct s__sn__waiting_thread *sn___grab_grant_thread;
} *t__sn__item_producer;
#define d__sn__item_producer 7722
typedef t__sn__item_producer t__item_producer;
#define d__item_producer d__sn__item_producer

/* line 38 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_sequence_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__e_core__any_sequence *parent_sequence;
    struct s__sn__any_sequence_do *sequence_imp___do_action;
    struct s__sn__sn_stripe_info *stripe_info;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
} *t__e_core__any_sequence_item;
#define d__e_core__any_sequence_item 1157
typedef t__e_core__any_sequence_item t__any_sequence_item;
#define d__any_sequence_item d__e_core__any_sequence_item

/* line 42 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__e_core__any_sequence_driver {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__int max_random_depth;
    t__int num_of_last_items;
    t__sn__bfm_interaction_mode_t bfm_interaction_mode;
    t__long_int sn___clock_occ_l;
    struct s__sn__sn_event_struct *sn___clock_event_struct;
    struct s__sn__waiting_thread *sn___clock_thread;
    t__long_int sn___item_done_occ_l;
    struct s__sn__sn_event_struct *sn___item_done_event_struct;
    struct s__sn__waiting_thread *sn___item_done_thread;
    t__bool using_new_sequence_naming;
    t__int sequence_imp___driver_index;
    struct s__e_core__any_sequence_item *sequence_imp___current_item;
    struct s__sn__do_request *sequence_imp___current_do;
    t__int sequence_imp___items_sent;
    struct s__l__e_core__any_sequence_item *sequence_imp___last_items;
    t__uint sequence_imp___last_item_idx;
    struct s__e_core__semaphore *sequence_imp___grab_locker;
    t__bool sequence_imp___dont_start_main_on_run;
    t__bool gen_and_start_main;
    struct s__l__e_core__any_sequence *sequence_imp___started_sequences;
    t__sn__sn_sequence_trace_kind sequence_imp___trace;
    t__bool sequence_imp___trace_msg;
    t__bool sequence_imp___trace_log;
    struct s__l__e_core__any_sequence_item *sequence_imp___full_trace_list;
    struct s__l__sn__do_request *sequence_imp___pending_dos;
    struct s__l__sn__item_producer *sequence_imp___pending_grabbers;
    struct s__l__sn__item_producer *sequence_imp___old_grabbers;
    struct s__sn__item_producer *sequence_imp___default_producer;
    t__bool sequence_imp___new_do_queue_sample_timing;
    t__long_int sn___refresh_do_queue_occ_l;
    struct s__sn__sn_event_struct *sn___refresh_do_queue_event_struct;
    struct s__sn__waiting_thread *sn___refresh_do_queue_thread;
    t__long_int sn___sample_do_queue_occ_l;
    struct s__sn__sn_event_struct *sn___sample_do_queue_event_struct;
    struct s__sn__waiting_thread *sn___sample_do_queue_thread;
    t__bool sequence_imp___under_rerun;
    t__bool sequence_imp___about_to_rerun;
    t__bool wave_flag;
    struct s__sn__sn_sequence_wave_info *wave_info;
    t__bool sequence_imp___can_get_next_item;
    t__sn__sn_driver_debug_state sequence_imp___state;
    struct s__e_core__time *sequence_imp___next_item_call_time;
    t__long_int sn___changed_state_occ_l;
    struct s__sn__sn_event_struct *sn___changed_state_event_struct;
    struct s__sn__waiting_thread *sn___changed_state_thread;
    t__int sequence_imp___get_next_item_branch_handle;
    t__int sequence_imp___last_get_next_item_thread;
    t__bool tr_ext_flag;
    struct s__l__sn__sn_sequence_tr_e80363 *tr_ext_infos;
    struct s__l__sn__sn_root_sequence80365 *root_seq_transaction_external_info;
    t__string items_fiber_name;
    t__string items_fiber_scope;
    struct s__sn__trans_debug_info *driver_trans;
} *t__e_core__any_sequence_driver;
#define d__e_core__any_sequence_driver 1159
typedef t__e_core__any_sequence_driver t__any_sequence_driver;
#define d__any_sequence_driver d__e_core__any_sequence_driver

/* line 25 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__do_request {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___do_grant_occ_l;
    struct s__sn__sn_event_struct *sn___do_grant_event_struct;
    struct s__sn__waiting_thread *sn___do_grant_thread;
    t__long_int sn___item_ready_occ_l;
    struct s__sn__sn_event_struct *sn___item_ready_event_struct;
    struct s__sn__waiting_thread *sn___item_ready_thread;
    t__long_int sn___item_done_recieved_occ_l;
    struct s__sn__sn_event_struct *sn___item_done_recieved_event_struct;
    struct s__sn__waiting_thread *sn___item_done_recieved_thread;
    t__sn__do_request_status state;
    struct s__sn__item_producer *requesting_prod;
    struct s__e_core__any_sequence_item *gen_item;
    t__int branch_handle;
    struct s__sn__any_sequence_do *do_action;
} *t__sn__do_request;
#define d__sn__do_request 7720
typedef t__sn__do_request t__do_request;
#define d__do_request d__sn__do_request

/* line 15 "/vobs/specman/src/seq_def.e"  From 'struct definition' */
typedef struct s__sn__sn_sequence_wave_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_sequence_driver *sequence_imp___driver;
    t__string parent_sequence;
    t__string Sequence;
    t__string Item;
    t__string do_line;
    t__string do_location;
} *t__sn__sn_sequence_wave_info;
#define d__sn__sn_sequence_wave_info 7664
typedef t__sn__sn_sequence_wave_info t__sn_sequence_wave_info;
#define d__sn_sequence_wave_info d__sn__sn_sequence_wave_info

/* line 4713 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__sn_sequence_tr_ext_info {
    t__int d__;
    t__int gen__;
    t__external_pointer tr_transaction_h;
    struct s__l__sn__sn_transaction_attr *attributes;
    struct s__sn__sn_transaction_interface *ifc;
    t__sn__sn_transaction_external_info_state_t state;
    t__string begun_fiber;
    struct s__e_core__any_unit *begun_unit;
    t__string begun_thread;
    t__string begun_label;
    struct s__e_core__any_sequence_driver *driver;
    struct s__e_core__any_sequence_item *seq;
    t__string label;
    struct s__sn__sn_sequence_tr_ext_info *parent_ext_info;
    struct s__e_core__any_sequence_driver *root_scope;
    t__string root_fiber_name;
} *t__sn__sn_sequence_tr_ext_info;
#define d__sn__sn_sequence_tr_ext_info 7736
typedef t__sn__sn_sequence_tr_ext_info t__sn_sequence_tr_ext_info;
#define d__sn_sequence_tr_ext_info d__sn__sn_sequence_tr_ext_info

/* line 6 "/vobs/specman/src/wave_transactions.e"  From 'struct definition' */
typedef struct s__sn__sn_transaction_attr {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string value;
} *t__sn__sn_transaction_attr;
#define d__sn__sn_transaction_attr 4378
typedef t__sn__sn_transaction_attr t__sn_transaction_attr;
#define d__sn_transaction_attr d__sn__sn_transaction_attr

/* line 25 "/vobs/specman/src/wave_transactions_api.e"  From 'struct definition' */
typedef struct s__sn__sn_transaction_interface {
    t__int d__;
    t__int gen__;
    t__sn__transaction_database_kind_t kind;
    t__bool transaction_db_open;
    t__external_pointer transaction_db_h;
    t__string tr_db_name;
    t__string feature_name;
    struct s__l__sn__sn_transaction_e34152 *external_infos_bank;
    struct s__k__sn__sn_fiber__scope_34153 *fibers;
    t__int tr_specifier;
} *t__sn__sn_transaction_interface;
#define d__sn__sn_transaction_interface 4373
typedef t__sn__sn_transaction_interface t__sn_transaction_interface;
#define d__sn_transaction_interface d__sn__sn_transaction_interface

/* line 45 "/vobs/specman/src/wave_transactions_api.e"  From 'struct definition' */
typedef struct s__sn__sn_transaction_exte33625 {
    t__int d__;
    t__int gen__;
    t__external_pointer tr_transaction_h;
    struct s__l__sn__sn_transaction_attr *attributes;
    struct s__sn__sn_transaction_interface *ifc;
    t__sn__sn_transaction_external_info_state_t state;
    t__string begun_fiber;
    struct s__e_core__any_unit *begun_unit;
    t__string begun_thread;
    t__string begun_label;
} *t__sn__sn_transaction_external_info;
#define d__sn__sn_transaction_external_info 4374
typedef t__sn__sn_transaction_external_info t__sn_transaction_external_info;
#define d__sn_transaction_external_info d__sn__sn_transaction_external_info

/* line 81 "/vobs/specman/src/wave_transactions_api.e"  From 'struct definition' */
typedef struct s__sn__sn_fiber {
    t__int d__;
    t__int gen__;
    t__string scope_name;
    t__string fiber_name;
    t__string scope_and_fiber_names;
    t__external_pointer fiber_handle;
    struct s__sn__sn_transaction_interface *ifc;
    struct s__k__sn__sn_trans_type_th34158 *trans_type_threads;
} *t__sn__sn_fiber;
#define d__sn__sn_fiber 4377
typedef t__sn__sn_fiber t__sn_fiber;
#define d__sn_fiber d__sn__sn_fiber

/* line 675 "/vobs/specman/src/wave_transactions.e"  From 'struct definition' */
typedef struct s__sn__sn_trans_type_thread {
    t__int d__;
    t__int gen__;
    t__string trans_type;
    struct s__sn__sn_transaction_exte33625 *box;
} *t__sn__sn_trans_type_thread;
#define d__sn__sn_trans_type_thread 4382
typedef t__sn__sn_trans_type_thread t__sn_trans_type_thread;
#define d__sn_trans_type_thread d__sn__sn_trans_type_thread

/* line 5537 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__sn_root_sequence_tr80399 {
    t__int d__;
    t__int gen__;
    t__external_pointer tr_transaction_h;
    struct s__l__sn__sn_transaction_attr *attributes;
    struct s__sn__sn_transaction_interface *ifc;
    t__sn__sn_transaction_external_info_state_t state;
    t__string begun_fiber;
    struct s__e_core__any_unit *begun_unit;
    t__string begun_thread;
    t__string begun_label;
    struct s__e_core__any_sequence_driver *driver;
    struct s__e_core__any_sequence_item *seq;
    t__string label;
    struct s__sn__sn_sequence_tr_ext_info *parent_ext_info;
    struct s__e_core__any_sequence_driver *root_scope;
    t__string root_fiber_name;
    t__string seq_tr_fiber_name;
} *t__sn__sn_root_sequence_tr_ext_info;
#define d__sn__sn_root_sequence_tr_ext_info 7738
typedef t__sn__sn_root_sequence_tr_ext_info t__sn_root_sequence_tr_ext_info;
#define d__sn_root_sequence_tr_ext_info d__sn__sn_root_sequence_tr_ext_info

/* line 5739 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__trans_debug_info {
    t__int d__;
    t__int gen__;
    struct s__l__string *sn_driver_debug_state_string_list;
    struct s__l__e_core__any_sequence *grabbing_sequences_list;
} *t__sn__trans_debug_info;
#define d__sn__trans_debug_info 7739
typedef t__sn__trans_debug_info t__trans_debug_info;
#define d__trans_debug_info d__sn__trans_debug_info

/* line 4957 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_window_handler {
    t__int d__;
    t__int gen__;
} *t__vt__vt_window_handler;
#define d__vt__vt_window_handler 4896
typedef t__vt__vt_window_handler t__vt_window_handler;
#define d__vt_window_handler d__vt__vt_window_handler

/* line 525 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_group_inst24179 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__int curr_ind;
    struct s__main__sn_cvr_main_group24182 *group_desc;
    t__bool instances_done;
} *t__main__sn_cvr_group_instances_iterator;
#define d__main__sn_cvr_group_instances_iterator 3602
typedef t__main__sn_cvr_group_instances_iterator t__sn_cvr_group_instances_iterator;
#define d__sn_cvr_group_instances_iterator d__main__sn_cvr_group_instances_iterator

/* line 909 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_formula_holder {
    t__int d__;
    t__int gen__;
    t__sn__sn_cvr_grading_formula kind;
} *t__main__sn_cvr_formula_holder;
#define d__main__sn_cvr_formula_holder 3628
typedef t__main__sn_cvr_formula_holder t__sn_cvr_formula_holder;
#define d__sn_cvr_formula_holder d__main__sn_cvr_formula_holder

/* line 42 "/vobs/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__sn__check {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__method *method;
    struct s__sn__check *declaration_layer;
    struct s__sn__struct_descriptor *context_struct;
    t__string message;
    t__sn__check_effect check_effect;
    t__sn__count count;
    t__sn__count count_pass;
    t__int index;
    t__bool has_block;
    t__bool has_condition;
    t__bool f_flag;
    struct s__l__sn__sn_run_time_match4201 *run_time_matches;
    t__string name;
    struct s__reflection__rf_check *rf_object_;
} *t__sn__check;
#define d__sn__check 1320
typedef t__sn__check t__check;
#define d__check d__sn__check

/* line 37 "/vobs/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__sn__sn_run_time_match_check {
    t__int d__;
    t__int gen__;
    t__string reg_exp;
    t__sn__check_effect effect;
} *t__sn__sn_run_time_match_check;
#define d__sn__sn_run_time_match_check 1319
typedef t__sn__sn_run_time_match_check t__sn_run_time_match_check;
#define d__sn_run_time_match_check d__sn__sn_run_time_match_check

/* line 3015 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_check {
    t__int d__;
    t__int gen__;
    struct s__sn__check *check_;
} *t__reflection__rf_check;
#define d__reflection__rf_check 1764
typedef t__reflection__rf_check t__rf_check;
#define d__rf_check d__reflection__rf_check

/* line 397 "/vobs/specman/src/cover_test_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_analysis_test {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string test_name;
    t__string tag_name;
    t__string run_name;
    t__string full_run_name;
    t__string file_name;
    t__bool disable;
    struct s__l__int *seeds;
    struct s__e_core__time *test_time;
    t__int usr_time;
    t__int system_time;
    t__int dut_errs;
    struct s__l__main__sn_cvr_item_de24135 *sampled_items;
    struct s__l__main__sn_cover_sampl24539 *distributions;
} *t__main__sn_cover_analysis_test;
#define d__main__sn_cover_analysis_test 3683
typedef t__main__sn_cover_analysis_test t__sn_cover_analysis_test;
#define d__sn_cover_analysis_test d__main__sn_cover_analysis_test

/* line 856 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_test {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string test_name;
    t__string tag_name;
    t__string run_name;
    t__string full_run_name;
    t__string file_name;
    t__bool disable;
    struct s__l__int *seeds;
    struct s__e_core__time *test_time;
    t__int usr_time;
    t__int system_time;
    t__int dut_errs;
    struct s__l__main__sn_cover_group_inst *group_insts;
    struct s__l__main__cover_struct *collected_data;
} *t__main__sn_cover_test;
#define d__main__sn_cover_test 3621
typedef t__main__sn_cover_test t__sn_cover_test;
#define d__sn_cover_test d__main__sn_cover_test

/* line 872 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_group_inst {
    t__int d__;
    t__int gen__;
    t__string struct_name;
    t__string package_name;
    t__string event_name;
    t__sn__index event_id;
    t__string instance_name;
    struct s__l__main__sn_cover_item_inst *item_insts;
    struct s__main__sn_cvr_main_group24182 *group_desc;
    struct s__main__sn_cvr_abstract_i24144 *instance_desc;
    t__bool count_only;
    struct s__main__sn_cover_test *parent_test;
    t__sn__index index_in_when_mask;
} *t__main__sn_cover_group_inst;
#define d__main__sn_cover_group_inst 3623
typedef t__main__sn_cover_group_inst t__sn_cover_group_inst;
#define d__sn_cover_group_inst d__main__sn_cover_group_inst

/* line 897 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cover_item_inst {
    t__int d__;
    t__int gen__;
    t__string name;
    t__main__sn_cvr_item_kind kind;
    t__sn__index index_in_when_mask;
    struct s__main__sn_cover_sampling24509 *distribution;
    struct s__l__uint *values;
    struct s__l__main__sn_cover_item_inst *sub_item_insts;
    t__int last_simple_ind;
    struct s__main__sn_cover_group_inst *parent_group;
    struct s__main__sn_cvr_item_descriptor *item_desc;
    t__bool non_saved;
    t__bool was_translated;
    struct s__main__sn_cvr_space_desc75056 *spd;
    t__int spd_ind;
    struct s__main__sn_cvr_item_ecov_data *ecov_data;
    struct s__k__main__mapping_env_pa75068 *mapping_table;
    t__uint checksum;
} *t__main__sn_cover_item_inst;
#define d__main__sn_cover_item_inst 3627
typedef t__main__sn_cover_item_inst t__sn_cover_item_inst;
#define d__sn_cover_item_inst d__main__sn_cover_item_inst

/* line 1529 "/vobs/specman/src/cover_flat_read_write.e"  From 'struct definition' */
typedef struct s__main__mapping_env_pair {
    t__int d__;
    t__int gen__;
    t__string symbolic_val;
    t__uint numeric_val;
} *t__main__mapping_env_pair;
#define d__main__mapping_env_pair 7513
typedef t__main__mapping_env_pair t__mapping_env_pair;
#define d__mapping_env_pair d__main__mapping_env_pair

/* line 8 "/vobs/specman/src/cai_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_cai {
    t__int d__;
    t__int gen__;
    struct s__k__main__sn_external_as75070 *all_external_ass_agents;
    struct s__l__sn__assert_info *assertions;
    struct s__l__sn__assert_info *ass_info_bank;
    struct s__sn__cai_assertion_event75071 *tick_listener;
    struct s__sn__cai_err_event_done_75072 *err_tick_listener;
} *t__sn__sn_cai;
#define d__sn__sn_cai 3706
typedef t__sn__sn_cai t__sn_cai;
#define d__sn_cai d__sn__sn_cai

/* line 969 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_external_asser24698 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__main__sn_cai_ass_agent_type agent_type;
    struct s__sn__sn_adapter_bridge *adapter;
} *t__main__sn_external_assertion_agent;
#define d__main__sn_external_assertion_agent 3634
typedef t__main__sn_external_assertion_agent t__sn_external_assertion_agent;
#define d__sn_external_assertion_agent d__main__sn_external_assertion_agent

/* line 125 "/vobs/specman/src/cai_assertions.e"  From 'struct definition' */
typedef struct s__sn__assert_info {
    t__int d__;
    t__int gen__;
    struct s__main__sn_external_asser24698 *agent;
    t__bool is_error;
    t__string err_msg;
    t__string more_params;
} *t__sn__assert_info;
#define d__sn__assert_info 7552
typedef t__sn__assert_info t__assert_info;
#define d__assert_info d__sn__assert_info

/* line 116 "/vobs/specman/src/cai_assertions.e"  From 'struct definition' */
typedef struct s__sn__cai_assertion_event75071 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool was_registered_in_this_cycle;
} *t__sn__cai_assertion_event_done_wrapper;
#define d__sn__cai_assertion_event_done_wrapper 7551
typedef t__sn__cai_assertion_event_done_wrapper t__cai_assertion_event_done_wrapper;
#define d__cai_assertion_event_done_wrapper d__sn__cai_assertion_event_done_wrapper

/* line 96 "/vobs/specman/src/cai_assertions.e"  From 'struct definition' */
typedef struct s__sn__cai_err_event_done_75072 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool was_registered_in_this_cycle;
    t__string err_str;
    struct s__sn__sn_exception *sn_err;
} *t__sn__cai_err_event_done_wrapper;
#define d__sn__cai_err_event_done_wrapper 7550
typedef t__sn__cai_err_event_done_wrapper t__cai_err_event_done_wrapper;
#define d__cai_err_event_done_wrapper d__sn__cai_err_event_done_wrapper

/* line 1019 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_enum {
    t__int d__;
    t__int gen__;
    struct s__sn__enum_descriptor *ed_;
} *t__reflection__rf_enum;
#define d__reflection__rf_enum 1731
typedef t__reflection__rf_enum t__rf_enum;
#define d__rf_enum d__reflection__rf_enum

/* line 675 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__enum_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__type_descriptor *base_type;
    struct s__k__sn__enum_item__name *items;
    t__int max_value;
    t__bool incontiguous;
    struct s__sn_rl__enum_rl *enum_rl;
    struct s__sn__enum_descriptor *enum_names;
} *t__sn__enum_descriptor;
#define d__sn__enum_descriptor 183
typedef t__sn__enum_descriptor t__enum_descriptor;
#define d__enum_descriptor d__sn__enum_descriptor

/* line 692 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__enum_item {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int value;
    struct s__sn__enum_descriptor *defining_type;
    struct s__sn__rf_structural_element *rf_object_;
} *t__sn__enum_item;
#define d__sn__enum_item 184
typedef t__sn__enum_item t__enum_item;
#define d__enum_item d__sn__enum_item

/* line 1294 "/vobs/specman/src/gen/specman_rl_ext.e"  From 'struct definition' */
typedef struct s__sn_rl__enum_rl {
    t__int d__;
    t__int gen__;
} *t__sn_rl__enum_rl;
#define d__sn_rl__enum_rl 8049
typedef t__sn_rl__enum_rl t__enum_rl;
#define d__enum_rl d__sn_rl__enum_rl

/* line 1021 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_external_B_cov27203 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__main__sn_cai_cov_agent_type kind;
    struct s__l__main__sn_cvr_externa27190 *all_groups;
    t__bool disabled;
    t__bool is_dirty;
} *t__main__sn_external_B_cover_agent;
#define d__main__sn_external_B_cover_agent 3639
typedef t__main__sn_external_B_cover_agent t__sn_external_B_cover_agent;
#define d__sn_external_B_cover_agent d__main__sn_external_B_cover_agent

/* line 1026 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_external_C_cov27204 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__main__sn_cai_cov_agent_type kind;
    struct s__l__main__sn_cvr_externa27190 *all_groups;
    t__bool disabled;
    t__bool is_dirty;
} *t__main__sn_external_C_cover_agent;
#define d__main__sn_external_C_cover_agent 3640
typedef t__main__sn_external_C_cover_agent t__sn_external_C_cover_agent;
#define d__sn_external_C_cover_agent d__main__sn_external_C_cover_agent

/* line 1283 "/vobs/specman/src/cover_postrun.e"  From 'struct definition' */
typedef struct s__main__sn_cross_searcher {
    t__int d__;
    t__int gen__;
    t__bool end_of_test_terminates_interval;
    t__bool ignore_order_in_tick;
    struct s__l__main__cover_struct *data;
    struct s__l__main__sn_search_item *search_items;
    t__bool interval_mode;
    t__sn__index interval_start_id;
    t__sn__index interval_end_id;
    t__bool only_simultaneous;
    t__bool all_samples;
    struct s__l__main__cover_struct *curr_sample;
    struct s__l__sn__index *curr_indexes;
    struct s__l__main__cover_struct *curr_predecessors;
    struct s__l__main__cover_struct *empty_list;
    t__sn__index range_start;
    t__sn__index range_end;
    t__sn__index start_event_in_range;
    t__sn__index end_event_in_range;
    t__bool inside_range;
} *t__main__sn_cross_searcher;
#define d__main__sn_cross_searcher 3784
typedef t__main__sn_cross_searcher t__sn_cross_searcher;
#define d__sn_cross_searcher d__main__sn_cross_searcher

/* line 1318 "/vobs/specman/src/cover_postrun.e"  From 'struct definition' */
typedef struct s__main__sn_search_item {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_item_descriptor *parent;
    t__sn__index event_id;
    t__sn__index index_in_when_mask;
    t__sn__index index_in_when_mask_for_transition;
    t__bool global;
} *t__main__sn_search_item;
#define d__main__sn_search_item 3785
typedef t__main__sn_search_item t__sn_search_item;
#define d__sn_search_item d__main__sn_search_item

/* line 250 "/vobs/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__main__jcover {
    t__int d__;
    t__int gen__;
    struct s__l__main__sn_cvr_abstrac27172 *relevant_groups;
    struct s__e_core__real *grading;
    struct s__main__jcvr_item_pack_object *item_obj;
    struct s__main__jcvr_item_type_pa27341 *item_type_obj;
    struct s__main__jcvr_pack_object_tests *tests_obj;
    struct s__main__jcvr_category_pac27340 *category_obj;
    struct s__main__jcvr_group_pack_object *group_obj;
    struct s__sn__sn_flag *values_dirty;
    struct s__sn__sn_flag *structure_dirty;
    struct s__main__sn_cover_jcvr_pos27342 *postrun;
    t__bool cov_win_exists;
} *t__main__jcover;
#define d__main__jcover 3895
typedef t__main__jcover t__jcover;
#define d__jcover d__main__jcover

/* line 228 "/vobs/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__main__jcvr_item_pack_object {
    t__int d__;
    t__int gen__;
    struct s__l__int *ids;
    t__main__jcvr_pack_mode mode;
    struct s__main__sn_cvr_item_descriptor *item;
} *t__main__jcvr_item_pack_object;
#define d__main__jcvr_item_pack_object 3893
typedef t__main__jcvr_item_pack_object t__jcvr_item_pack_object;
#define d__jcvr_item_pack_object d__main__jcvr_item_pack_object

/* line 240 "/vobs/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__main__jcvr_item_type_pa27341 {
    t__int d__;
    t__int gen__;
    struct s__l__int *ids;
    t__main__jcvr_pack_mode mode;
    struct s__main__sn_cvr_item_descriptor *item;
} *t__main__jcvr_item_type_pack_object;
#define d__main__jcvr_item_type_pack_object 3894
typedef t__main__jcvr_item_type_pack_object t__jcvr_item_type_pack_object;
#define d__jcvr_item_type_pack_object d__main__jcvr_item_type_pack_object

/* line 96 "/vobs/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__main__jcvr_pack_object_tests {
    t__int d__;
    t__int gen__;
} *t__main__jcvr_pack_object_tests;
#define d__main__jcvr_pack_object_tests 3890
typedef t__main__jcvr_pack_object_tests t__jcvr_pack_object_tests;
#define d__jcvr_pack_object_tests d__main__jcvr_pack_object_tests

/* line 146 "/vobs/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__main__jcvr_category_pac27340 {
    t__int d__;
    t__int gen__;
    struct s__l__int *ids;
    t__main__jcvr_pack_mode mode;
    t__int category_id;
} *t__main__jcvr_category_pack_object;
#define d__main__jcvr_category_pack_object 3891
typedef t__main__jcvr_category_pack_object t__jcvr_category_pack_object;
#define d__jcvr_category_pack_object d__main__jcvr_category_pack_object

/* line 216 "/vobs/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__main__jcvr_group_pack_object {
    t__int d__;
    t__int gen__;
    struct s__l__int *ids;
    t__main__jcvr_pack_mode mode;
    struct s__main__sn_cvr_abstract_i24144 *group;
} *t__main__jcvr_group_pack_object;
#define d__main__jcvr_group_pack_object 3892
typedef t__main__jcvr_group_pack_object t__jcvr_group_pack_object;
#define d__jcvr_group_pack_object d__main__jcvr_group_pack_object

/* line 949 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_flag {
    t__int d__;
    t__int gen__;
    t__bool flag;
    t__bool notify_flag;
} *t__sn__sn_flag;
#define d__sn__sn_flag 1518
typedef t__sn__sn_flag t__sn_flag;
#define d__sn_flag d__sn__sn_flag

/* line 169 "/vobs/specman/src/cover_jcvr_ext.e"  From 'struct definition' */
typedef struct s__main__sn_cover_jcvr_pos27342 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_key_store *p_cross_store;
} *t__main__sn_cover_jcvr_postrun_api;
#define d__main__sn_cover_jcvr_postrun_api 3918
typedef t__main__sn_cover_jcvr_postrun_api t__sn_cover_jcvr_postrun_api;
#define d__sn_cover_jcvr_postrun_api d__main__sn_cover_jcvr_postrun_api

/* line 1010 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_key_store {
    t__int d__;
    t__int gen__;
    t__bool p_initialized;
    t__int p_next_key;
    struct s__k__sn__sn_p_key_store_en4515 *p_list;
} *t__sn__sn_key_store;
#define d__sn__sn_key_store 1520
typedef t__sn__sn_key_store t__sn_key_store;
#define d__sn_key_store d__sn__sn_key_store

/* line 998 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_p_key_store_entry {
    t__int d__;
    t__int gen__;
    t__int key;
    struct s__e_core__base_struct *value;
} *t__sn__sn_p_key_store_entry;
#define d__sn__sn_p_key_store_entry 1519
typedef t__sn__sn_p_key_store_entry t__sn_p_key_store_entry;
#define d__sn_p_key_store_entry d__sn__sn_p_key_store_entry

/* line 61 "/vobs/specman/src/rl_cover.e"  From 'struct definition' */
typedef struct s__sn__val_and_index {
    t__int d__;
    t__int gen__;
    t__untyped val;
    t__int sub_rl_index;
} *t__sn__val_and_index;
#define d__sn__val_and_index 1714
typedef t__sn__val_and_index t__val_and_index;
#define d__val_and_index d__sn__val_and_index

/* line 39 "/vobs/specman/src/cover_checks.e"  From 'struct definition' */
typedef struct s__main__sn_unicov_check_d75128 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_check *rfc;
    t__string unicov_name;
    struct s__main__sn_unicov_check_d75130 *options;
    t__external_pointer unicov_check_desc;
    struct s__main__sn_per_inst_unico72311 *pt_inst;
    struct s__k__main__sn_per_inst_un75131 *pi_descriptors;
} *t__main__sn_unicov_check_descriptor;
#define d__main__sn_unicov_check_descriptor 7490
typedef t__main__sn_unicov_check_descriptor t__sn_unicov_check_descriptor;
#define d__sn_unicov_check_descriptor d__main__sn_unicov_check_descriptor

/* line 31 "/vobs/specman/src/cover_checks.e"  From 'struct definition' */
typedef struct s__main__sn_unicov_check_d75130 {
    t__int d__;
    t__int gen__;
    t__main__sn_check_collection_t collect;
} *t__main__sn_unicov_check_desc_options;
#define d__main__sn_unicov_check_desc_options 7489
typedef t__main__sn_unicov_check_desc_options t__sn_unicov_check_desc_options;
#define d__sn_unicov_check_desc_options d__main__sn_unicov_check_desc_options

/* line 202 "/vobs/specman/src/cover_checks.e"  From 'struct definition' */
typedef struct s__main__sn_per_inst_unico72311 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_unicov_check_d75128 *parent;
    struct s__e_core__any_struct *inst;
    struct s__main__sn_unicov_inst_na75129 *inst_name_wrapper;
    struct s__main__sn_unicov_check_d75130 *options;
    t__int count_checked;
    t__int count_failed;
    t__int count_pass;
} *t__main__sn_per_inst_unicov_check_descriptor;
#define d__main__sn_per_inst_unicov_check_descriptor 7492
typedef t__main__sn_per_inst_unicov_check_descriptor t__sn_per_inst_unicov_check_descriptor;
#define d__sn_per_inst_unicov_check_descriptor d__main__sn_per_inst_unicov_check_descriptor

/* line 196 "/vobs/specman/src/cover_checks.e"  From 'struct definition' */
typedef struct s__main__sn_unicov_inst_na75129 {
    t__int d__;
    t__int gen__;
    t__string name;
} *t__main__sn_unicov_inst_name_wrapper;
#define d__main__sn_unicov_inst_name_wrapper 7491
typedef t__main__sn_unicov_inst_name_wrapper t__sn_unicov_inst_name_wrapper;
#define d__sn_unicov_inst_name_wrapper d__main__sn_unicov_inst_name_wrapper

/* line 406 "/vobs/specman/src/cover_checks.e"  From 'struct definition' */
typedef struct s__main__sn_set_cover_check_com {
    t__int d__;
    t__int gen__;
    t__string package_wc;
    t__string struct_wc;
    t__string check_name_wc;
    t__string inst_name_wc;
    t__main__sn_check_collection_t collect;
} *t__main__sn_set_cover_check_com;
#define d__main__sn_set_cover_check_com 7493
typedef t__main__sn_set_cover_check_com t__sn_set_cover_check_com;
#define d__sn_set_cover_check_com d__main__sn_set_cover_check_com

/* line 16 "/vobs/specman/src/cover_blocks.e"  From 'struct definition' */
typedef struct s__main__sn_block_cover_de75135 {
    t__int d__;
    t__int gen__;
    t__source_ref sref;
    struct s__reflection__rf_struct *rfs;
    t__uint pt_counter;
    struct s__main__sn_unicov_method_75061 *method_control;
    t__external_pointer unicov_block_desc;
} *t__main__sn_block_cover_descriptor;
#define d__main__sn_block_cover_descriptor 7500
typedef t__main__sn_block_cover_descriptor t__sn_block_cover_descriptor;
#define d__sn_block_cover_descriptor d__main__sn_block_cover_descriptor

/* line 5 "/vobs/specman/src/cover_blocks.e"  From 'struct definition' */
typedef struct s__main__sn_unicov_method_75061 {
    t__int d__;
    t__int gen__;
    struct s__sn__method *tm;
    t__external_pointer control_ptr;
} *t__main__sn_unicov_method_control;
#define d__main__sn_unicov_method_control 7498
typedef t__main__sn_unicov_method_control t__sn_unicov_method_control;
#define d__sn_unicov_method_control d__main__sn_unicov_method_control

/* line 577 "/vobs/specman/src/cover_flat_sampling.e"  From 'struct definition' */
typedef struct s__main__cov_per_instance_75144 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *cov_struct;
    struct s__l__main__sn_cvr_main_gr24808 *groups;
    struct s__l__main__sn_unicov_chec75143 *checks;
    struct s__l__main__sn_block_cover75060 *blocks;
} *t__main__cov_per_instance_groups;
#define d__main__cov_per_instance_groups 7505
typedef t__main__cov_per_instance_groups t__cov_per_instance_groups;
#define d__cov_per_instance_groups d__main__cov_per_instance_groups

/* line 600 "/vobs/specman/src/cover_flat_sampling.e"  From 'struct definition' */
typedef struct s__main__cov_per_instance_graph {
    t__int d__;
    t__int gen__;
    struct s__main__cov_per_instance_node *root;
    t__bool donot_remove;
} *t__main__cov_per_instance_graph;
#define d__main__cov_per_instance_graph 7507
typedef t__main__cov_per_instance_graph t__cov_per_instance_graph;
#define d__cov_per_instance_graph d__main__cov_per_instance_graph

/* line 587 "/vobs/specman/src/cover_flat_sampling.e"  From 'struct definition' */
typedef struct s__main__cov_per_instance_node {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__e_core__any_struct *ptr;
    struct s__k__main__cov_per_instan75140 *children;
    t__string source_file;
    t__int source_line;
    struct s__l__main__sn_cvr_real_in27184 *cover_insts;
    struct s__l__main__sn_per_inst_un75141 *check_insts;
    struct s__l__main__sn_block_cover75060 *block_insts;
    t__uint ucv_checksum;
    t__external_pointer instance_ptr;
} *t__main__cov_per_instance_node;
#define d__main__cov_per_instance_node 7506
typedef t__main__cov_per_instance_node t__cov_per_instance_node;
#define d__cov_per_instance_node d__main__cov_per_instance_node

/* line 500 "/vobs/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_real_insta24113 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string name;
    t__source_ref source_ref;
    t__string original_file;
    t__int original_line;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    struct s__e_core__real *c_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    struct s__e_core__real *grading;
    t__bool for_report;
    t__bool rankable;
    struct s__sn__struct_descriptor *first_definition_struct;
    t__bool is_defined;
    t__bool ranges_created;
    t__bool dirty;
    struct s__l__sn__st_exp *when_exps;
    struct s__main__sn_cvr_main_group24182 *parent;
    struct s__l__main__sn_cvr_item_de24135 *items;
    t__bool has_samples;
    struct s__e_core__real *sampled_items_weight;
    t__bool full;
    t__int gui_id;
    t__sn__index index_in_when_mask;
    struct s__e_core__any_struct *ptr;
    t__int depth;
    t__string path;
    t__external_pointer mod_ptr;
} *t__main__sn_cvr_real_instance_descriptor;
#define d__main__sn_cvr_real_instance_descriptor 3601
typedef t__main__sn_cvr_real_instance_descriptor t__sn_cvr_real_instance_descriptor;
#define d__sn_cvr_real_instance_descriptor d__main__sn_cvr_real_instance_descriptor

/* line 2048 "/vobs/specman/src/cover_flat_read_write.e"  From 'struct definition' */
typedef struct s__main__read_cover_merge_info {
    t__int d__;
    t__int gen__;
    struct s__e_core__time *test_time;
    t__int usr_time;
    t__int system_time;
    t__int dut_errs;
    struct s__l__int *seeds;
    struct s__l__string *external_keys;
} *t__main__read_cover_merge_info;
#define d__main__read_cover_merge_info 7516
typedef t__main__read_cover_merge_info t__read_cover_merge_info;
#define d__read_cover_merge_info d__main__read_cover_merge_info

/* line 258 "/vobs/specman/src/cover_excov.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_excov_hold75174 {
    t__int d__;
    t__int gen__;
    t__string file_name;
    struct s__main__sn_cvr_excov_holder *holder;
} *t__main__sn_cvr_excov_holder_wrapper;
#define d__main__sn_cvr_excov_holder_wrapper 7567
typedef t__main__sn_cvr_excov_holder_wrapper t__sn_cvr_excov_holder_wrapper;
#define d__sn_cvr_excov_holder_wrapper d__main__sn_cvr_excov_holder_wrapper

/* line 249 "/vobs/specman/src/cover_excov.e"  From 'struct definition' */
typedef struct s__main__sn_cvr_excov_holder {
    t__int d__;
    t__int gen__;
    t__string version;
    struct s__l__main__sn_excov_group75171 *groups;
    struct s__main__cov_per_instance_graph *cov_insts_graph;
    t__bool show_sub_holes;
    t__bool show_instances_only;
} *t__main__sn_cvr_excov_holder;
#define d__main__sn_cvr_excov_holder 7566
typedef t__main__sn_cvr_excov_holder t__sn_cvr_excov_holder;
#define d__sn_cvr_excov_holder d__main__sn_cvr_excov_holder

/* line 226 "/vobs/specman/src/cover_excov.e"  From 'struct definition' */
typedef struct s__main__sn_excov_group_holder {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string original_file;
    t__int original_line;
    t__string package_name;
    t__string struct_name;
    t__string event_name;
    t__string external;
    t__string agent_options;
    struct s__l__main__sn_excov_inst_75172 *instances;
} *t__main__sn_excov_group_holder;
#define d__main__sn_excov_group_holder 7565
typedef t__main__sn_excov_group_holder t__sn_excov_group_holder;
#define d__sn_excov_group_holder d__main__sn_excov_group_holder

/* line 211 "/vobs/specman/src/cover_excov.e"  From 'struct definition' */
typedef struct s__main__sn_excov_inst_holder {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string original_file;
    t__int original_line;
    t__string long_name;
    struct s__l__main__sn_excov_item_75173 *items;
    struct s__main__cov_per_instance_node *graph_ptr;
    t__external_pointer mod_ptr;
} *t__main__sn_excov_inst_holder;
#define d__main__sn_excov_inst_holder 7564
typedef t__main__sn_excov_inst_holder t__sn_excov_inst_holder;
#define d__sn_excov_inst_holder d__main__sn_excov_inst_holder

/* line 187 "/vobs/specman/src/cover_excov.e"  From 'struct definition' */
typedef struct s__main__sn_excov_item_holder {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string text;
    t__string cvr_text;
    t__int weight;
    t__int cvr_weight;
    t__e_core__po_radix radix;
    t__main__sn_cvr_radix cvr_radix;
    t__string vplan_ref;
    t__bool trace_only;
    t__bool started_trace_only;
    t__string original_file;
    t__int original_line;
    t__main__sn_cvr_item_kind kind;
    t__string type_string;
    struct s__main__sn_cvr_valid_space *valid_space;
    struct s__l__string *sub_items;
    t__int at_least;
    t__string agent_options;
    struct s__main__sn_cvr_space_desc75056 *spd;
    struct s__l__main__sn_excov_bucke73870 *buckets_info;
    t__bool is_gradable;
    t__uint ign_ill_checksum;
} *t__main__sn_excov_item_holder;
#define d__main__sn_excov_item_holder 7563
typedef t__main__sn_excov_item_holder t__sn_excov_item_holder;
#define d__sn_excov_item_holder d__main__sn_excov_item_holder

/* line 115 "/vobs/specman/src/cover_excov.e"  From 'struct definition' */
typedef struct s__main__sn_excov_buckets_info {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int at_least;
    struct s__sn_rl__scalar_rl *range;
    t__int num_of_buckets;
    t__int every_num;
    t__source_ref sref;
} *t__main__sn_excov_buckets_info;
#define d__main__sn_excov_buckets_info 7562
typedef t__main__sn_excov_buckets_info t__sn_excov_buckets_info;
#define d__sn_excov_buckets_info d__main__sn_excov_buckets_info

/* line 56 "/vobs/specman/src/unicov_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_cvr_unicov_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_dynamic_call *unicov_get_error_string_from_c___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_coverage_model_builder___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_coverage_model_builder___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_coverage_model___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_coverage_model_clone___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_n_s_t_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_coverage_model___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_verification_engine_kind___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_model_tool_info___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_source___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_module___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_generate___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_module_source___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_named_block___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_generate_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_named_block_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_cover_group_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_cover_group___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_simple_item_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_external_item_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_cross_item_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_transition_item_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_item_auto_bin_space_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_enum_item_auto_bin_space_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_item_string_space_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_item_ranges_space_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_enum_item_ranges_space_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_bucket_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_transitions_bucket_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_enum_item_overlap_ranges_space_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_item_overlap_ranges_space_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_cover_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_valid_bucket___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_valid_bucket_exists___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_auto_create_valid_space___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_unique_runtime_sampled_bucket___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_assertion_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_control_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_block_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_block___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_expression_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_expression___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_s_o_p_table_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_s_o_p_table___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_min_term_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_min_term___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_min_term_vector___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_test_group___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_testcase___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_f_s_m_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_f_s_m___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_state_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_state___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_transition_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_transition___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_f_s_m_transition_min_term_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_f_s_m_transition_min_term___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_f_s_m_signal___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_transition_source___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_signal_descriptor___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_signal___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_signal_bit___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_write_model_binary___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_write_model_binary_helper___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_read_model_binary___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_coverage_data_builder___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_coverage_data_builder___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_coverage_data___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_coverage_data___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_data_tool_info___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_module___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_generate___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_named_block___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_generate_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_named_block_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_cover_group___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_ranges_sampled_cover_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_simple_sampled_cover_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_string_to_string_sampled_cover_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_string_sampled_cover_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_cross_sampled_cover_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_sampled_bucket___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_dynamic_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_dynamic_deselect_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_static_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_static_deselect_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_static_constraint_assertion___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_block___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_com_block___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_expression___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_expr_value___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_com_expr_value___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_expr_vector_value___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_expr_vector_value_count___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_ith_count_of_min_term_vector___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_testcase___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_f_s_m___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_state___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_transition___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_arc___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_signal___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_bit___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_sampled_com_bit___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_write_data_binary___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_read_data_binary___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_handle_property___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_handle_property___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_iterate___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_scan___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_move_it_to_index___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_iterator___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_bucket_unique_values___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_by_ptr___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_bucket_unique_values___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_unique_value_from_space_desc___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_expr_sop_row_index___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_ith_index_value___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_ith_count_of_vector___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_boolean_property___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_boolean_property___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_option_compute_checksum___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_option_include_assert_name_in_checksum___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_string_property___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_string_property_from_c___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_int_property___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_int_property___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_int_property_by_obj_index___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_create___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_free___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_scan___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_model_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_module_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_instance_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_cover_group_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_cover_item_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_bucket_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_assertion_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_test_group_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_testcase_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_visitor_set_f_s_m_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_search_model_instance_by_path___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_search_data_instance_by_path___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_iterator_model_instances_wildcards___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_iterator_model_instances_wildcards_scan___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_iterator_model_instances_wildcards_free___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_top_instances_contain_name___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_run_over_model_insts___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_is_calc_deselected_assertions___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_coverage_model2_coverage_data___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_compute_count_from_ucd___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_compute_logical_instance_count_from_ucd___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_coverage_data2_runtime_coverage_data___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_logical_instance_coverage_data2_runtime_coverage_data___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_free_runtime_coverage_data___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_reset_counts___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_reset_models_checksums_desc___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_reset_element_counts___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_set_mark_resolution___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_get_mark_resolution___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_resolve_module_mark___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_resolve_module_mark_for_merge___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_compute_counts___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_set_error_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_model_union_set_message_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_set_merge_message_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_valid_space_size_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_union_coverage_models___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_subtract_coverage_models___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_union_coverage_models_helper___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_set_coverage_type_merge___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_dml_get_coverage_type_merge___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_unionset_coverage_type_merge___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_unionget_coverage_type_merge___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_sampled_uids___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_calculate_grade___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_buckets_sampled_space___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_unique_samples___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_samples___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_enum_name_by_id___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_second_unique_id___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_bucket_descriptor_by_id___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_data_get_enums_iterator___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_data_enums_iterator_next___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_data_enums_iterator_get_val___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_data_enums_iterator_get_name___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_data_enums_iterator_is_end___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_data_enums_iterator_free___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_enums_iterator___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_enums_iterator_next___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_enums_iterator_get_val___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_enums_iterator_get_name___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_enums_iterator_is_end___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_enums_iterator_free___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_create___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_next___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_is_end___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_get_low___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_get_high___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_get_last_high___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_get_last_low___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_ranges_iterator_free___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_range_first_val___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_range_last_val___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_is_transition_bin___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_transition_string___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_unique_val___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_assertion_property_name___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_assertion_property_value___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_f_s_m_signal_name___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_partial_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_subcross_item___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_write_model_internal___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_write_data_internal___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_get_global_update_id___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_create_coverage_summary___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_free_coverage_summary___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_init_c_r_c___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_int_to_c_r_c___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_add_str_to_c_r_c___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_set_mem_handler___dynamic_call;
    struct s__sn__sn_dynamic_call *unicov_try_mem_handler___dynamic_call;
} *t__sn__sn_cvr_unicov_manager;
#define d__sn__sn_cvr_unicov_manager 7574
typedef t__sn__sn_cvr_unicov_manager t__sn_cvr_unicov_manager;
#define d__sn_cvr_unicov_manager d__sn__sn_cvr_unicov_manager

/* line 10 "/vobs/specman/src/cover_model_dump.e"  From 'struct definition' */
typedef struct s__main__unicov_handle_con75176 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__external_pointer ptr;
} *t__main__unicov_handle_container;
#define d__main__unicov_handle_container 7632
typedef t__main__unicov_handle_container t__unicov_handle_container;
#define d__unicov_handle_container d__main__unicov_handle_container

/* line 52 "/vobs/specman/src/cover_model_dump.e"  From 'struct definition' */
typedef struct s__main__sn_unicov_item_ptr {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_item_descriptor *item;
    t__external_pointer ptr;
    struct s__main__sn_cvr_abstract_i24144 *parent;
} *t__main__sn_unicov_item_ptr;
#define d__main__sn_unicov_item_ptr 7634
typedef t__main__sn_unicov_item_ptr t__sn_unicov_item_ptr;
#define d__sn_unicov_item_ptr d__main__sn_unicov_item_ptr

/* line 4 "/vobs/specman/src/cover_database_dump.e"  From 'struct definition' */
typedef struct s__main__unicov_handle_tre74902 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__external_pointer unicov_ptr;
    struct s__k__main__unicov_handle_75180 *children;
} *t__main__unicov_handle_tree_node;
#define d__main__unicov_handle_tree_node 7638
typedef t__main__unicov_handle_tree_node t__unicov_handle_tree_node;
#define d__unicov_handle_tree_node d__main__unicov_handle_tree_node

/* line 43 "/vobs/specman/src/cover_real.e"  From 'struct definition' */
typedef struct s__sn__sn_cvr_double_space75168 {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__scalar_rl *legal_range;
    struct s__main__sn_cover_illegal_75081 *illegal_bucket;
    t__bool gradable;
    struct s__sn__sn_long *space_size;
    t__int last_ind;
    struct s__main__sn_cvr_item_ecov_data *ecov_data;
    struct s__k__string__it *names;
    struct s__l__string *real_bucket_names;
    t__sn__index print_index;
} *t__sn__sn_cvr_double_space_descriptor;
#define d__sn__sn_cvr_double_space_descriptor 7555
typedef t__sn__sn_cvr_double_space_descriptor t__sn_cvr_double_space_descriptor;
#define d__sn_cvr_double_space_descriptor d__sn__sn_cvr_double_space_descriptor

/* line 448 "/vobs/specman/src/cover_database_dump.e"  From 'struct definition' */
typedef struct s__main__sn_cover_item_dis75183 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_item_inst *item;
    struct s__k__string__it *vals;
} *t__main__sn_cover_item_dis_keyed_list;
#define d__main__sn_cover_item_dis_keyed_list 7639
typedef t__main__sn_cover_item_dis_keyed_list t__sn_cover_item_dis_keyed_list;
#define d__sn_cover_item_dis_keyed_list d__main__sn_cover_item_dis_keyed_list

/* line 1029 "/vobs/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__sn__sn_wave {
    t__int d__;
    t__int gen__;
    t__sn__wave_execution_mode execution_mode;
    t__sn__waveform_kind viewer;
    t__bool use_default_working_mode;
    struct s__sn__sn_adapter_bridge *wave_sim_adapter;
    struct s__sn__wave_stub_services *wave_stub_services;
    struct s__sn__wave_services *wave_services;
    struct s__e_core__file *global_cfg_file;
    t__string global_cfg_file_name;
    struct s__e_core__file *batch_cfg_file;
    t__string batch_cfg_file_name;
    t__bool config_was_set_flag;
    struct s__sn__wave_log_manager *log_mngr;
    struct s__sn__wave_dump_manager *wave_dump_mngr;
    struct s__sn__wave_viewers_api *api;
    t__int flush_at_tick;
    t__bool dump_wave_trace;
    struct s__sn__wave_commands_manager *wave_cmd_mngr;
    struct s__l__string *files_to_delete;
    struct s__sn__undertow_interface *undertow_interface;
    struct s__sn__simvision_interface *simvision_interface;
} *t__sn__sn_wave;
#define d__sn__sn_wave 1335
typedef t__sn__sn_wave t__sn_wave;
#define d__sn_wave d__sn__sn_wave

/* line 3 "/vobs/specman/src/wave_stub_services.e"  From 'struct definition' */
typedef struct s__sn__wave_stub_services {
    t__int d__;
    t__int gen__;
} *t__sn__wave_stub_services;
#define d__sn__wave_stub_services 4297
typedef t__sn__wave_stub_services t__wave_stub_services;
#define d__wave_stub_services d__sn__wave_stub_services

/* line 63 "/vobs/specman/src/wave_services.e"  From 'struct definition' */
typedef struct s__sn__wave_services {
    t__int d__;
    t__int gen__;
    struct s__sn__wave_cfg_file_services *cfg_file_services;
} *t__sn__wave_services;
#define d__sn__wave_services 4305
typedef t__sn__wave_services t__wave_services;
#define d__wave_services d__sn__wave_services

/* line 564 "/vobs/specman/src/wave_services.e"  From 'struct definition' */
typedef struct s__sn__wave_cfg_file_services {
    t__int d__;
    t__int gen__;
} *t__sn__wave_cfg_file_services;
#define d__sn__wave_cfg_file_services 4306
typedef t__sn__wave_cfg_file_services t__wave_cfg_file_services;
#define d__wave_cfg_file_services d__sn__wave_cfg_file_services

/* line 2 "/vobs/specman/src/wave_log.e"  From 'struct definition' */
typedef struct s__sn__wave_log_manager {
    t__int d__;
    t__int gen__;
    t__bool should_log;
    t__string log_file_name;
    struct s__l__string *log_lines;
} *t__sn__wave_log_manager;
#define d__sn__wave_log_manager 4311
typedef t__sn__wave_log_manager t__wave_log_manager;
#define d__wave_log_manager d__sn__wave_log_manager

/* line 1746 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_dump_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__abs_wave_entry *modified_wave_entries;
} *t__sn__wave_dump_manager;
#define d__sn__wave_dump_manager 4334
typedef t__sn__wave_dump_manager t__wave_dump_manager;
#define d__wave_dump_manager d__sn__wave_dump_manager

/* line 21 "/vobs/specman/src/wave_interface.e"  From 'struct definition' */
typedef struct s__sn__wave_viewers_api {
    t__int d__;
    t__int gen__;
    t__string waveform_name;
    t__bool wave_is_connected;
    t__int wave_win_id;
    struct s__sn__sn_dynamic_call *CmdCltCreate___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_create___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_connect___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_get_free_port___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_command___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_check_connection___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_set_abort_proc___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_check_for_events___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_destroy___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_refresh_display___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_create_window___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_get_current_window___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_add_all_event_callbacks___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_restore_signal___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_set_win_option___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_do_dumpflush___dynamic_call;
} *t__sn__wave_viewers_api;
#define d__sn__wave_viewers_api 4336
typedef t__sn__wave_viewers_api t__wave_viewers_api;
#define d__wave_viewers_api d__sn__wave_viewers_api

/* line 2209 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__wave_commands_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__abs_wave_command34141 *all_cmd_mngr;
    struct s__sn__wave_output_command34140 *output_cmd_mngr;
    t__bool trace_output;
    struct s__sn__wave_command_manage34139 *id_factory;
    struct s__sn__wave_signal_allocat34138 *allocation_mngr;
    t__bool any_wave_cmd_occur;
    struct s__k__sn__signal_naming_ma34135 *group_unique_naming_manager;
    struct s__l__sn__sn_hidden_command *hidden_commands;
    struct s__k__sn__sn_wave_drill_do34143 *drill_down_struct_ids;
    struct s__sn__sn_list_abs_wave_co34144 *all_cmd_mngr_sticky;
    struct s__sn__sn_wave_signal_data32733 *wave_signal_database_mngr;
} *t__sn__wave_commands_manager;
#define d__sn__wave_commands_manager 4351
typedef t__sn__wave_commands_manager t__wave_commands_manager;
#define d__wave_commands_manager d__sn__wave_commands_manager

/* line 1503 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__wave_output_command34140 {
    t__int d__;
    t__int gen__;
    t__int id;
    t__string wave_cmd;
    t__string group_name;
    t__bool pending;
    t__bool hidden;
    struct s__sn__wave_output_element *wave_output_element;
    struct s__sn__wave_error_element *wave_error_element;
} *t__sn__wave_output_command_manager;
#define d__sn__wave_output_command_manager 4348
typedef t__sn__wave_output_command_manager t__wave_output_command_manager;
#define d__wave_output_command_manager d__sn__wave_output_command_manager

/* line 1159 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__wave_output_element {
    t__int d__;
    t__int gen__;
    struct s__sn__wave_element_allocation *allocation;
    struct s__l__string *log_lines;
    t__bool free_entry_exist;
    t__string non_terminated_str;
} *t__sn__wave_output_element;
#define d__sn__wave_output_element 4344
typedef t__sn__wave_output_element t__wave_output_element;
#define d__wave_output_element d__sn__wave_output_element

/* line 1195 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__wave_error_element {
    t__int d__;
    t__int gen__;
    struct s__sn__wave_element_allocation *allocation;
    struct s__l__string *log_lines;
    t__bool free_entry_exist;
    t__string non_terminated_str;
} *t__sn__wave_error_element;
#define d__sn__wave_error_element 4345
typedef t__sn__wave_error_element t__wave_error_element;
#define d__wave_error_element d__sn__wave_error_element

/* line 1242 "/vobs/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__sn__wave_command_manage34139 {
    t__int d__;
    t__int gen__;
    t__int myNextId;
} *t__sn__wave_command_manager_id_factory;
#define d__sn__wave_command_manager_id_factory 4346
typedef t__sn__wave_command_manager_id_factory t__wave_command_manager_id_factory;
#define d__wave_command_manager_id_factory d__sn__wave_command_manager_id_factory

/* line 3 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_signal_allocat34138 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__signal_naming_ma34135 *signal_unique_naming_manager;
    t__bool has_been_initialized;
    struct s__sn__wave_event_allocator *event_allocator;
    struct s__sn__wave_scalar_allocator *scalar_allocator;
    struct s__sn__wave_bool_allocator *bool_allocator;
    struct s__sn__wave_str_allocator *str_allocator;
    struct s__sn__wave_output_allocator *output_allocator;
    struct s__sn__wave_error_allocator *error_allocator;
} *t__sn__wave_signal_allocators_manager;
#define d__sn__wave_signal_allocators_manager 4313
typedef t__sn__wave_signal_allocators_manager t__wave_signal_allocators_manager;
#define d__wave_signal_allocators_manager d__sn__wave_signal_allocators_manager

/* line 21 "/vobs/specman/src/wave_services.e"  From 'struct definition' */
typedef struct s__sn__signal_naming_map {
    t__int d__;
    t__int gen__;
    t__string new_name;
    t__int counter;
} *t__sn__signal_naming_map;
#define d__sn__signal_naming_map 4298
typedef t__sn__signal_naming_map t__signal_naming_map;
#define d__signal_naming_map d__sn__signal_naming_map

/* line 319 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_event_allocator {
    t__int d__;
    t__int gen__;
    t__int total;
    t__int next_id;
} *t__sn__wave_event_allocator;
#define d__sn__wave_event_allocator 4317
typedef t__sn__wave_event_allocator t__wave_event_allocator;
#define d__wave_event_allocator d__sn__wave_event_allocator

/* line 373 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_scalar_allocator {
    t__int d__;
    t__int gen__;
    t__int total;
    t__int next_id;
} *t__sn__wave_scalar_allocator;
#define d__sn__wave_scalar_allocator 4320
typedef t__sn__wave_scalar_allocator t__wave_scalar_allocator;
#define d__wave_scalar_allocator d__sn__wave_scalar_allocator

/* line 336 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_bool_allocator {
    t__int d__;
    t__int gen__;
    t__int total;
    t__int next_id;
} *t__sn__wave_bool_allocator;
#define d__sn__wave_bool_allocator 4318
typedef t__sn__wave_bool_allocator t__wave_bool_allocator;
#define d__wave_bool_allocator d__sn__wave_bool_allocator

/* line 354 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_str_allocator {
    t__int d__;
    t__int gen__;
    t__int total;
    t__int next_id;
} *t__sn__wave_str_allocator;
#define d__sn__wave_str_allocator 4319
typedef t__sn__wave_str_allocator t__wave_str_allocator;
#define d__wave_str_allocator d__sn__wave_str_allocator

/* line 262 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_output_allocator {
    t__int d__;
    t__int gen__;
    t__int total;
    t__int next_id;
} *t__sn__wave_output_allocator;
#define d__sn__wave_output_allocator 4315
typedef t__sn__wave_output_allocator t__wave_output_allocator;
#define d__wave_output_allocator d__sn__wave_output_allocator

/* line 290 "/vobs/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__sn__wave_error_allocator {
    t__int d__;
    t__int gen__;
    t__int total;
    t__int next_id;
} *t__sn__wave_error_allocator;
#define d__sn__wave_error_allocator 4316
typedef t__sn__wave_error_allocator t__wave_error_allocator;
#define d__wave_error_allocator d__sn__wave_error_allocator

/* line 84 "/vobs/specman/src/wave_depth.e"  From 'struct definition' */
typedef struct s__sn__sn_hidden_command {
    t__int d__;
    t__int gen__;
    t__string command_string;
} *t__sn__sn_hidden_command;
#define d__sn__sn_hidden_command 4355
typedef t__sn__sn_hidden_command t__sn_hidden_command;
#define d__sn_hidden_command d__sn__sn_hidden_command

/* line 145 "/vobs/specman/src/wave_depth.e"  From 'struct definition' */
typedef struct s__sn__sn_wave_drill_down_info {
    t__int d__;
    t__int gen__;
    t__string exp_struct_id;
    t__string exp_string;
} *t__sn__sn_wave_drill_down_info;
#define d__sn__sn_wave_drill_down_info 4356
typedef t__sn__sn_wave_drill_down_info t__sn_wave_drill_down_info;
#define d__sn_wave_drill_down_info d__sn__sn_wave_drill_down_info

/* line 334 "/vobs/specman/src/wave_cmd_keep_info.e"  From 'struct definition' */
typedef struct s__sn__sn_list_abs_wave_co34144 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__abs_wave_command34141 *m_cmds;
} *t__sn__sn_list_abs_wave_command_manager;
#define d__sn__sn_list_abs_wave_command_manager 4371
typedef t__sn__sn_list_abs_wave_command_manager t__sn_list_abs_wave_command_manager;
#define d__sn_list_abs_wave_command_manager d__sn__sn_list_abs_wave_command_manager

/* line 3 "/vobs/specman/src/wave_signals_api.e"  From 'struct definition' */
typedef struct s__sn__sn_wave_signal_data32733 {
    t__int d__;
    t__int gen__;
    t__bool database_open;
    t__bool send_to_waveform_upon_define;
    t__external_pointer database_h;
    t__sn__e_time_units units;
    t__int units_int;
    t__bool init_done;
    struct s__k__sn__sn_wave_signal_d34136 *variables;
    struct s__sn__sn_dynamic_call *dwSSTClose___dynamic_call;
    struct s__sn__sn_dynamic_call *dwDefineVariable___dynamic_call;
    struct s__sn__sn_dynamic_call *dwDefineScope___dynamic_call;
    struct s__sn__sn_dynamic_call *dwAddIntTransition___dynamic_call;
    struct s__sn__sn_dynamic_call *dwAddStringTransition___dynamic_call;
    struct s__sn__sn_dynamic_call *dwAddStructTransition___dynamic_call;
    struct s__sn__sn_dynamic_call *dwAddTransition___dynamic_call;
    struct s__sn__sn_dynamic_call *dwSSTReset___dynamic_call;
    struct s__sn__sn_dynamic_call *dwFlushDesign___dynamic_call;
    struct s__sn__sn_dynamic_call *dcCdsSimPaused___dynamic_call;
    struct s__sn__sn_dynamic_call *dcCdsProcessEvents___dynamic_call;
    struct s__k__sn__sn_wave_signal_d34137 *scopes;
    struct s__sn__sn_intptr_t *database_h_shadow;
} *t__sn__sn_wave_signal_database_manager;
#define d__sn__sn_wave_signal_database_manager 4312
typedef t__sn__sn_wave_signal_database_manager t__sn_wave_signal_database_manager;
#define d__sn_wave_signal_database_manager d__sn__sn_wave_signal_database_manager

/* line 263 "/vobs/specman/src/wave_signals_simvision.e"  From 'struct definition' */
typedef struct s__sn__sn_wave_signal_data33946 {
    t__int d__;
    t__int gen__;
    t__string scope_and_name;
    t__int variable_type;
    t__external_pointer variable_h;
    struct s__sn__sn_intptr_t *variable_h_shadow;
} *t__sn__sn_wave_signal_database_variable;
#define d__sn__sn_wave_signal_database_variable 4393
typedef t__sn__sn_wave_signal_database_variable t__sn_wave_signal_database_variable;
#define d__sn_wave_signal_database_variable d__sn__sn_wave_signal_database_variable

/* line 696 "/vobs/specman/src/wave_signals_simvision.e"  From 'struct definition' */
typedef struct s__sn__sn_wave_signal_data33996 {
    t__int d__;
    t__int gen__;
    t__string scope_and_name;
    t__int scope_type;
    t__external_pointer scope_h;
    struct s__sn__sn_intptr_t *scope_h_shadow;
} *t__sn__sn_wave_signal_database_scope;
#define d__sn__sn_wave_signal_database_scope 4394
typedef t__sn__sn_wave_signal_database_scope t__sn_wave_signal_database_scope;
#define d__sn_wave_signal_database_scope d__sn__sn_wave_signal_database_scope

/* line 2 "/vobs/specman/src/wave_undertow.e"  From 'struct definition' */
typedef struct s__sn__undertow_interface {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__undertow_interface;
#define d__sn__undertow_interface 4366
typedef t__sn__undertow_interface t__undertow_interface;
#define d__undertow_interface d__sn__undertow_interface

/* line 5 "/vobs/specman/src/wave_simvision.e"  From 'struct definition' */
typedef struct s__sn__simvision_interface {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool db_commands_sent;
    t__bool created_plugin_cntrols;
} *t__sn__simvision_interface;
#define d__sn__simvision_interface 4370
typedef t__sn__simvision_interface t__simvision_interface;
#define d__simvision_interface d__sn__simvision_interface

/* line 126 "/vobs/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__sn__sn_dut_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__check *all_checks;
    struct s__sn__check *current_interactive_check;
    t__bool check_traced;
    struct s__sn__dut_error_struct *dut_error___dut_err;
} *t__sn__sn_dut_manager;
#define d__sn__sn_dut_manager 1321
typedef t__sn__sn_dut_manager t__sn_dut_manager;
#define d__sn_dut_manager d__sn__sn_dut_manager

/* line 1058 "/vobs/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__sn__dut_error_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__check *dut_error___check;
    struct s__l__string *dut_error___extra_str;
    t__string dut_error___notify_err_str;
    t__string message;
    struct s__e_core__any_struct *dut_error___source_struct;
    t__string dut_error___source_location;
    t__string dut_error___source_struct_name;
    t__string dut_error___source_method_name;
    t__sn__check_effect dut_error___check_effect;
} *t__sn__dut_error_struct;
#define d__sn__dut_error_struct 1336
typedef t__sn__dut_error_struct t__dut_error_struct;
#define d__dut_error_struct d__sn__dut_error_struct

/* line 9 "/vobs/specman/src/interval_set.e"  From 'struct definition' */
typedef struct s__sn__sn_interval_set_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__int_interval_set *int_sets;
    struct s__l__sn__uint_interval_set *uint_sets;
    struct s__l__sn__enum_interval_set *enum_sets;
    struct s__l__sn__long_interval_set *long_sets;
    struct s__int__2147483647 *long_as_max_int;
    struct s__int__2147483647 *long_as_min_int;
    struct s__int__2147483647 *long_as_max_uint;
    struct s__int__2147483647 *long_as_zero;
    struct s__int__2147483647 *long_as_inf;
    struct s__int__2147483647 *long_as_minus_inf;
    struct s__sn__long_interval_set *long_universal_set;
    struct s__l__uint *neg_list;
    struct s__l__uint *pos_list;
    struct s__l__int__2147483647 *neg_list_long;
    struct s__l__int__2147483647 *pos_list_long;
} *t__sn__sn_interval_set_manager;
#define d__sn__sn_interval_set_manager 1460
typedef t__sn__sn_interval_set_manager t__sn_interval_set_manager;
#define d__sn_interval_set_manager d__sn__sn_interval_set_manager

/* line 270 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__uint_interval_set {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
} *t__sn__uint_interval_set;
#define d__sn__uint_interval_set 478
typedef t__sn__uint_interval_set t__uint_interval_set;
#define d__uint_interval_set d__sn__uint_interval_set

/* line 274 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__enum_interval_set {
    t__int d__;
    t__int gen__;
    struct s__l__uint *rl_list;
    struct s__sn__enum_descriptor *type;
} *t__sn__enum_interval_set;
#define d__sn__enum_interval_set 479
typedef t__sn__enum_interval_set t__enum_interval_set;
#define d__enum_interval_set d__sn__enum_interval_set

/* line 281 "../src/root.e"  From 'struct definition' */
typedef struct s__sn__long_interval_set {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_long *rl_list;
} *t__sn__long_interval_set;
#define d__sn__long_interval_set 481
typedef t__sn__long_interval_set t__long_interval_set;
#define d__long_interval_set d__sn__long_interval_set

/* line 67 "/vobs/specman/src/recycler.e"  From 'struct definition' */
typedef struct s__sn__sn_recycler {
    t__int d__;
    t__int gen__;
    t__external_pointer lists;
} *t__sn__sn_recycler;
#define d__sn__sn_recycler 1475
typedef t__sn__sn_recycler t__sn_recycler;
#define d__sn_recycler d__sn__sn_recycler

/* line 225 "/vobs/specman/src/recycler.e"  From 'struct definition' */
typedef struct s__sn__sn_dumb_recycler {
    t__int d__;
    t__int gen__;
    t__external_pointer lists;
} *t__sn__sn_dumb_recycler;
#define d__sn__sn_dumb_recycler 1476
typedef t__sn__sn_dumb_recycler t__sn_dumb_recycler;
#define d__sn_dumb_recycler d__sn__sn_dumb_recycler

/* line 231 "/vobs/specman/src/recycler.e"  From 'struct definition' */
typedef struct s__sn__sn_smarter_recycler {
    t__int d__;
    t__int gen__;
    t__external_pointer lists;
} *t__sn__sn_smarter_recycler;
#define d__sn__sn_smarter_recycler 1477
typedef t__sn__sn_smarter_recycler t__sn_smarter_recycler;
#define d__sn_smarter_recycler d__sn__sn_smarter_recycler

/* line 315 "/vobs/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__sn__fake_signal {
    t__int d__;
    t__int gen__;
    t__bool current_is_long;
    t__string name;
    t__uint value;
    struct s__int__2147483647 *lvalue;
} *t__sn__fake_signal;
#define d__sn__fake_signal 1257
typedef t__sn__fake_signal t__fake_signal;
#define d__fake_signal d__sn__fake_signal

/* line 23 "/vobs/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn__auto_gc_setting {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_uintptr_t *heap_size;
    struct s__sn__sn_uintptr_t *static_size;
    t__bool after_run;
    t__bool not_first_run;
    struct s__sn__sn_uintptr_t *pre_gc_size;
    struct s__sn__sn_uintptr_t *post_gc_size;
    t__int minimal_ticks_between_gc;
    t__int gc_count;
    t__imp_enum_sn__auto_gc_setting__gc_type gc_type;
    t__bool auto_gc_set_config;
} *t__sn__auto_gc_setting;
#define d__sn__auto_gc_setting 1360
typedef t__sn__auto_gc_setting t__auto_gc_setting;
#define d__auto_gc_setting d__sn__auto_gc_setting

/* line 642 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__packing {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool lob_is_free;
    struct s__l__bit *temp_lob;
    struct s__l__bit *append_int_tmp_lob;
    struct s__l__bit *append_string_tmp_lob;
    struct s__e_core__pack_options *global_default;
    struct s__e_core__pack_options *high;
    struct s__e_core__pack_options *low;
    struct s__e_core__pack_options *high_big_endian;
    struct s__e_core__pack_options *low_big_endian;
    struct s__e_core__pack_options *adapter;
    struct s__e_core__pack_options *network;
    struct s__e_core__pack_options *synthesized___pack;
    struct s__e_core__pack_options *sn___svmp;
    struct s__e_core__pack_options *sn___svubmp;
    struct s__e_core__pack_options *sn___ml_ovm;
    t__bool vttp_packing;
    struct s__l__e_core__source_item *source_items;
    struct s__l__e_core__any_unit *instances_list;
    struct s__l__sn__debug_item *pack_debug_info;
    struct s__l__sn__debug_item *unpack_debug_info;
    struct s__sn__string_stack *debug_names_stack;
    struct s__sn__string_stack *unpack_debug_names_stack;
    t__bool show_pack;
    t__bool show_vttp_pack;
    struct s__l__int *byte_mask;
    struct s__l__sn__debug_item *temp_debug_info;
} *t__sn__packing;
#define d__sn__packing 1563
typedef t__sn__packing t__packing;
#define d__packing d__sn__packing

/* line 349 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__debug_item {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__bit *lob;
} *t__sn__debug_item;
#define d__sn__debug_item 1561
typedef t__sn__debug_item t__debug_item;
#define d__debug_item d__sn__debug_item

/* line 290 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__string_stack {
    t__int d__;
    t__int gen__;
    struct s__l__sn__pack_string_item *names;
} *t__sn__string_stack;
#define d__sn__string_stack 1560
typedef t__sn__string_stack t__string_stack;
#define d__string_stack d__sn__string_stack

/* line 285 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__pack_string_item {
    t__int d__;
    t__int gen__;
    t__string name;
    t__sn__pack_originate_from pack_originate_from;
} *t__sn__pack_string_item;
#define d__sn__pack_string_item 1559
typedef t__sn__pack_string_item t__pack_string_item;
#define d__pack_string_item d__sn__pack_string_item

/* line 708 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__virtual_packing {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool lob_is_free;
    struct s__l__bit *temp_lob;
    struct s__l__bit *append_int_tmp_lob;
    struct s__l__bit *append_string_tmp_lob;
    struct s__e_core__pack_options *global_default;
    struct s__e_core__pack_options *high;
    struct s__e_core__pack_options *low;
    struct s__e_core__pack_options *high_big_endian;
    struct s__e_core__pack_options *low_big_endian;
    struct s__e_core__pack_options *adapter;
    struct s__e_core__pack_options *network;
    struct s__e_core__pack_options *synthesized___pack;
    struct s__e_core__pack_options *sn___svmp;
    struct s__e_core__pack_options *sn___svubmp;
    struct s__e_core__pack_options *sn___ml_ovm;
    t__bool vttp_packing;
    struct s__l__e_core__source_item *source_items;
    struct s__l__e_core__any_unit *instances_list;
    struct s__l__sn__debug_item *pack_debug_info;
    struct s__l__sn__debug_item *unpack_debug_info;
    struct s__sn__string_stack *debug_names_stack;
    struct s__sn__string_stack *unpack_debug_names_stack;
    t__bool show_pack;
    t__bool show_vttp_pack;
    struct s__l__int *byte_mask;
    struct s__l__sn__debug_item *temp_debug_info;
} *t__sn__virtual_packing;
#define d__sn__virtual_packing 1564
typedef t__sn__virtual_packing t__virtual_packing;
#define d__virtual_packing d__sn__virtual_packing

/* line 820 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__vttp_packing {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool lob_is_free;
    struct s__l__bit *temp_lob;
    struct s__l__bit *append_int_tmp_lob;
    struct s__l__bit *append_string_tmp_lob;
    struct s__e_core__pack_options *global_default;
    struct s__e_core__pack_options *high;
    struct s__e_core__pack_options *low;
    struct s__e_core__pack_options *high_big_endian;
    struct s__e_core__pack_options *low_big_endian;
    struct s__e_core__pack_options *adapter;
    struct s__e_core__pack_options *network;
    struct s__e_core__pack_options *synthesized___pack;
    struct s__e_core__pack_options *sn___svmp;
    struct s__e_core__pack_options *sn___svubmp;
    struct s__e_core__pack_options *sn___ml_ovm;
    t__bool vttp_packing;
    struct s__l__e_core__source_item *source_items;
    struct s__l__e_core__any_unit *instances_list;
    struct s__l__sn__debug_item *pack_debug_info;
    struct s__l__sn__debug_item *unpack_debug_info;
    struct s__sn__string_stack *debug_names_stack;
    struct s__sn__string_stack *unpack_debug_names_stack;
    t__bool show_pack;
    t__bool show_vttp_pack;
    struct s__l__int *byte_mask;
    struct s__l__sn__debug_item *temp_debug_info;
    struct s__l__sn__struct_descriptor *virtual_pack_sds;
    struct s__k__sn__sn_vttp_struct__id *vttp_items;
    struct s__sn__field *current_field;
    struct s__l__sn__field *trace_fields;
} *t__sn__vttp_packing;
#define d__sn__vttp_packing 1565
typedef t__sn__vttp_packing t__vttp_packing;
#define d__vttp_packing d__sn__vttp_packing

/* line 2030 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__sn_vttp_struct {
    t__int d__;
    t__int gen__;
    t__int id;
    struct s__sn__struct_descriptor *base_struct;
    struct s__l__sn__struct_descriptor *contained_structs;
    struct s__k__sn__vttp_field_offset__f *fields;
    t__uint sib;
    t__sn__sn_vttp_status status;
} *t__sn__sn_vttp_struct;
#define d__sn__sn_vttp_struct 1571
typedef t__sn__sn_vttp_struct t__sn_vttp_struct;
#define d__sn_vttp_struct d__sn__sn_vttp_struct

/* line 2022 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__vttp_field_offset {
    t__int d__;
    t__int gen__;
    struct s__sn__field *f;
    t__uint offset;
    t__uint sib;
} *t__sn__vttp_field_offset;
#define d__sn__vttp_field_offset 1568
typedef t__sn__vttp_field_offset t__vttp_field_offset;
#define d__vttp_field_offset d__sn__vttp_field_offset

/* line 1393 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__svtp_packing {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool lob_is_free;
    struct s__l__bit *temp_lob;
    struct s__l__bit *append_int_tmp_lob;
    struct s__l__bit *append_string_tmp_lob;
    struct s__e_core__pack_options *global_default;
    struct s__e_core__pack_options *high;
    struct s__e_core__pack_options *low;
    struct s__e_core__pack_options *high_big_endian;
    struct s__e_core__pack_options *low_big_endian;
    struct s__e_core__pack_options *adapter;
    struct s__e_core__pack_options *network;
    struct s__e_core__pack_options *synthesized___pack;
    struct s__e_core__pack_options *sn___svmp;
    struct s__e_core__pack_options *sn___svubmp;
    struct s__e_core__pack_options *sn___ml_ovm;
    t__bool vttp_packing;
    struct s__l__e_core__source_item *source_items;
    struct s__l__e_core__any_unit *instances_list;
    struct s__l__sn__debug_item *pack_debug_info;
    struct s__l__sn__debug_item *unpack_debug_info;
    struct s__sn__string_stack *debug_names_stack;
    struct s__sn__string_stack *unpack_debug_names_stack;
    t__bool show_pack;
    t__bool show_vttp_pack;
    struct s__l__int *byte_mask;
    struct s__l__sn__debug_item *temp_debug_info;
    struct s__sn__sn_sv_adapter_unit_65587 *config_manager;
} *t__sn__svtp_packing;
#define d__sn__svtp_packing 1566
typedef t__sn__svtp_packing t__svtp_packing;
#define d__svtp_packing d__sn__svtp_packing

/* line 1413 "/vobs/specman/src/packing.e"  From 'struct definition' */
typedef struct s__sn__mltp_packing {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool lob_is_free;
    struct s__l__bit *temp_lob;
    struct s__l__bit *append_int_tmp_lob;
    struct s__l__bit *append_string_tmp_lob;
    struct s__e_core__pack_options *global_default;
    struct s__e_core__pack_options *high;
    struct s__e_core__pack_options *low;
    struct s__e_core__pack_options *high_big_endian;
    struct s__e_core__pack_options *low_big_endian;
    struct s__e_core__pack_options *adapter;
    struct s__e_core__pack_options *network;
    struct s__e_core__pack_options *synthesized___pack;
    struct s__e_core__pack_options *sn___svmp;
    struct s__e_core__pack_options *sn___svubmp;
    struct s__e_core__pack_options *sn___ml_ovm;
    t__bool vttp_packing;
    struct s__l__e_core__source_item *source_items;
    struct s__l__e_core__any_unit *instances_list;
    struct s__l__sn__debug_item *pack_debug_info;
    struct s__l__sn__debug_item *unpack_debug_info;
    struct s__sn__string_stack *debug_names_stack;
    struct s__sn__string_stack *unpack_debug_names_stack;
    t__bool show_pack;
    t__bool show_vttp_pack;
    struct s__l__int *byte_mask;
    struct s__l__sn__debug_item *temp_debug_info;
    struct s__sn__sn_sv_adapter_unit_65587 *config_manager;
} *t__sn__mltp_packing;
#define d__sn__mltp_packing 1567
typedef t__sn__mltp_packing t__mltp_packing;
#define d__mltp_packing d__sn__mltp_packing

/* line 2062 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_manager {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__reflection__rf_value_9907 *reflection_imp___value_holder_cache;
    struct s__l__reflection__instance_9908 *reflection_imp___instance_path_node_stack;
    struct s__k__reflection__rf_define9909 *reflection_imp___defines;
} *t__reflection__rf_manager;
#define d__reflection__rf_manager 1753
typedef t__reflection__rf_manager t__rf_manager;
#define d__rf_manager d__reflection__rf_manager

/* line 3457 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__instance_pat8138 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_field *fld;
    t__int list_index;
    t__untyped val;
    t__int pop_after;
} *t__reflection__instance_path_node;
#define d__reflection__instance_path_node 1774
typedef t__reflection__instance_path_node t__instance_path_node;
#define d__instance_path_node d__reflection__instance_path_node

/* line 3528 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_define {
    t__int d__;
    t__int gen__;
    struct s__e_core__global_const *d_;
    t__string name;
} *t__reflection__rf_define;
#define d__reflection__rf_define 1776
typedef t__reflection__rf_define t__rf_define;
#define d__rf_define d__reflection__rf_define

/* line 1011 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__global_const {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__string file_name;
    t__int line;
    t__bool active;
} *t__e_core__global_const;
#define d__e_core__global_const 82
typedef t__e_core__global_const t__global_const;
#define d__global_const d__e_core__global_const

/* line 16 "/vobs/specman/src/ea/eanalyzer_defs.e"  From 'struct definition' */
typedef struct s__ea__eanalyzer {
    t__int d__;
    t__int gen__;
    struct s__l__ea__eanalyzer_category_t *check_categories;
    t__string log_file;
    t__bool is_active;
    t__bool developer_mode;
    struct s__l__string *erm_package_names;
    struct s__k__ea__eanalyzer_check__id *checks;
    t__int c_check_id;
    struct s__ea__ea_sn_ea_elint *elint;
    struct s__sn__option_list *option_list;
    t__ea__eanalyzer_phase phase;
    t__external_pointer hal_err_func;
    t__external_pointer hal_param_lookup_func;
    t__bool debug;
    struct s__l__ea__eanalyzer_notifi98720 *notifications;
    struct s__l__string *filtered_files;
    struct s__l__string *filtered_directories;
    struct s__l__ea__eanalyzer_filter98721 *filtered_lines;
    struct s__l__string *filtered_ids;
    struct s__k__uint__it *already_filtered_files;
    t__bool check_sn_internal;
    struct s__e_core__source_item *g_item;
    t__string perf_report_name;
    struct s__reflection__rf_struct *current_struct;
    struct s__l__ea__ea_local *vars_not_used;
    struct s__l__ea__ea_local *vars_not_read;
    struct s__l__ea__ea_local *vars_not_written;
    struct s__l__ea__ea_config_option *conf_list;
    struct s__sn__ea_sn_ea_define_manager *define_manager;
    struct s__sn__ea_sn_ea_unit_inst_98722 *unit_inst_manager;
    struct s__sn__ea_sn_ea_elint_util *elint_util;
    struct s__sn__ea_sn_ea_erm_checklist *erm_checklist;
    t__int method_padding_threshold;
    t__int field_padding_threshold;
    t__int method_extension_threshold;
    struct s__l__source_ref *state_machine_refs;
} *t__ea__eanalyzer;
#define d__ea__eanalyzer 1914
typedef t__ea__eanalyzer t__eanalyzer;
#define d__eanalyzer d__ea__eanalyzer

/* line 36 "/vobs/specman/src/ea/eanalyzer_defs.e"  From 'struct definition' */
typedef struct s__ea__eanalyzer_check {
    t__int d__;
    t__int gen__;
    t__string id;
    t__int c_id;
    t__string msg;
    struct s__l__string *param_names;
    struct s__l__string *param_values;
} *t__ea__eanalyzer_check;
#define d__ea__eanalyzer_check 1915
typedef t__ea__eanalyzer_check t__eanalyzer_check;
#define d__eanalyzer_check d__ea__eanalyzer_check

/* line 65 "/vobs/specman/src/ea/eanalyzer_defs.e"  From 'struct definition' */
typedef struct s__ea__ea_sn_ea_elint {
    t__int d__;
    t__int gen__;
    t__string ver_;
    t__bool isElintTool_;
    struct s__k__sn__ea_sn_ea_elint_m98723 *msgs;
    t__string current_package_name;
    struct s__reflection__rf_erm_package *current_package;
    struct s__k__string__it *signal_maps_;
    struct s__k__string__it *monitors_;
    struct s__k__string__it *bfms_;
    struct s__k__string__it *agents_;
    struct s__k__string__it *super_agents_;
    struct s__k__string__it *envs_;
    struct s__k__reflection__rf_module__it *package_modules_;
    struct s__k__reflection__rf_struct__it *package_structs_;
    struct s__l__reflection__rf_struct *agent_structs;
    struct s__l__reflection__rf_struct *monitor_structs;
    struct s__l__reflection__rf_struct *bfm_structs;
    struct s__l__reflection__rf_struct *env_structs;
    struct s__l__reflection__rf_struct *signal_maps_structs;
    struct s__k__sn__ea_rf_unit_inst__it *bfm_units;
    struct s__k__sn__ea_rf_unit_inst__it *all_active_agents;
    struct s__k__reflection__rf_struct__it *super_agent_structs;
    struct s__k__sn__rf_sequence__it *all_sequences;
    struct s__k__reflection__rf_struct__it *all_seq_drivers;
    struct s__l__sn__rf_virtual_sequence *virtual_seqs;
    struct s__l__sn__rf_bfm_sequence *bfm_seqs;
    struct s__sn__ea_elint_cover_api *coverage_info;
    struct s__k__reflection__rf_check__it *all_checks;
    struct s__k__reflection__rf_check98724 *all_check_actions;
    struct s__k__reflection__rf_expect__it *all_expects;
    t__string dcf_;
    t__bool dcf_ok_;
    struct s__l__string *dcf_warnings;
    struct s__l__string *dcf_errors;
    struct s__l__string *top_files_list_;
    t__uint msg_counter_;
    t__string log_file_name_;
    struct s__e_core__file *log_file_;
    t__string output_file_;
} *t__ea__ea_sn_ea_elint;
#define d__ea__ea_sn_ea_elint 1916
typedef t__ea__ea_sn_ea_elint t__ea_sn_ea_elint;
#define d__ea_sn_ea_elint d__ea__ea_sn_ea_elint

/* line 2 "/vobs/specman/src/ea/erm/ea_elint.e"  From 'struct definition' */
typedef struct s__sn__ea_sn_ea_elint_msg {
    t__int d__;
    t__int gen__;
    t__string id;
    t__string msg;
    t__bool is_good;
    t__bool is_applicable;
} *t__sn__ea_sn_ea_elint_msg;
#define d__sn__ea_sn_ea_elint_msg 8899
typedef t__sn__ea_sn_ea_elint_msg t__ea_sn_ea_elint_msg;
#define d__ea_sn_ea_elint_msg d__sn__ea_sn_ea_elint_msg

/* line 1915 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_module {
    t__int d__;
    t__int gen__;
    struct s__sn__module *m_;
} *t__reflection__rf_module;
#define d__reflection__rf_module 1751
typedef t__reflection__rf_module t__rf_module;
#define d__rf_module d__reflection__rf_module

/* line 158 "/vobs/specman/src/ea/erm/ea_elint_rf_extend.e"  From 'struct definition' */
typedef struct s__sn__ea_rf_unit_inst {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *unit_struct;
    struct s__e_core__any_unit *unit_inst;
    struct s__sn__ea_rf_unit_inst *parent;
} *t__sn__ea_rf_unit_inst;
#define d__sn__ea_rf_unit_inst 8895
typedef t__sn__ea_rf_unit_inst t__ea_rf_unit_inst;
#define d__ea_rf_unit_inst d__sn__ea_rf_unit_inst

/* line 242 "/vobs/specman/src/seq_semantic_checks.e"  From 'struct definition' */
typedef struct s__sn__rf_sequence {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd_;
} *t__sn__rf_sequence;
#define d__sn__rf_sequence 7672
typedef t__sn__rf_sequence t__rf_sequence;
#define d__rf_sequence d__sn__rf_sequence

/* line 270 "/vobs/specman/src/seq_semantic_checks.e"  From 'struct definition' */
typedef struct s__sn__rf_virtual_sequence {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd_;
} *t__sn__rf_virtual_sequence;
#define d__sn__rf_virtual_sequence 7673
typedef t__sn__rf_virtual_sequence t__rf_virtual_sequence;
#define d__rf_virtual_sequence d__sn__rf_virtual_sequence

/* line 279 "/vobs/specman/src/seq_semantic_checks.e"  From 'struct definition' */
typedef struct s__sn__rf_bfm_sequence {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor *sd_;
} *t__sn__rf_bfm_sequence;
#define d__sn__rf_bfm_sequence 7674
typedef t__sn__rf_bfm_sequence t__rf_bfm_sequence;
#define d__rf_bfm_sequence d__sn__rf_bfm_sequence

/* line 2 "/vobs/specman/src/ea/erm/ea_elint_coverage.e"  From 'struct definition' */
typedef struct s__sn__ea_elint_cover_api {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int all_grade;
    t__string struct_name;
    t__string group_name;
    t__string group_text;
    t__int group_weight;
    t__int group_grade;
    t__string external;
    t__string package_name;
    t__string instance_name;
    t__string instance_text;
    t__int instance_weight;
    t__int instance_grade;
    t__int item_cnt;
    t__string item_name;
    struct s__l__string *sub_items;
    t__int samples;
    t__int item_at_least;
    t__string item_text;
    t__int item_no_of_tests;
    t__string item_when_string;
    t__string item_exp_string;
    t__string item_type;
    t__int item_weight;
    t__int item_grade;
    t__string bucket_name;
    t__int count;
    t__main__bucket_status status;
    t__int percent;
    t__int at_least;
    t__int no_of_tests;
    t__sn__index cross_level;
    t__bool is_string;
    t__bool is_real;
    t__int int_value;
    t__int hi_int_value;
    struct s__e_core__real *min_real_value;
    struct s__e_core__real *max_real_value;
    struct s__sn_rl__scalar_rl *bucket_range_list;
    t__int bucket_grade;
    t__int bucket_weight;
    struct s__l__string *full_bucket_name;
    t__source_ref group_source_ref;
    t__source_ref item_source_ref;
    t__bool show_empty_buckets;
    t__string item_kind;
    t__bool item_is_no_collect;
    t__int num_of_groups;
    t__int num_of_items;
    t__int num_of_cross_items;
    t__int num_of_transition_items;
    t__int num_of_simple_items;
    t__bool is_in_package;
} *t__sn__ea_elint_cover_api;
#define d__sn__ea_elint_cover_api 8929
typedef t__sn__ea_elint_cover_api t__ea_elint_cover_api;
#define d__ea_elint_cover_api d__sn__ea_elint_cover_api

/* line 3070 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_check_action {
    t__int d__;
    t__int gen__;
    struct s__sn__check *check_;
} *t__reflection__rf_check_action;
#define d__reflection__rf_check_action 1765
typedef t__reflection__rf_check_action t__rf_check_action;
#define d__rf_check_action d__reflection__rf_check_action

/* line 3093 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_expect {
    t__int d__;
    t__int gen__;
    struct s__sn__check *check_;
} *t__reflection__rf_expect;
#define d__reflection__rf_expect 1766
typedef t__reflection__rf_expect t__rf_expect;
#define d__rf_expect d__reflection__rf_expect

/* line 97 "/vobs/specman/src/options.e"  From 'struct definition' */
typedef struct s__sn__option_list {
    t__int d__;
    t__int gen__;
    struct s__k__sn__option__option_desc *all_options;
} *t__sn__option_list;
#define d__sn__option_list 1485
typedef t__sn__option_list t__option_list;
#define d__option_list d__sn__option_list

/* line 82 "/vobs/specman/src/options.e"  From 'struct definition' */
typedef struct s__sn__option {
    t__int d__;
    t__int gen__;
    struct s__sn__option_descriptor *option_desc;
    struct s__l__string *actual_names;
    struct s__l__string *values;
} *t__sn__option;
#define d__sn__option 1484
typedef t__sn__option t__option;
#define d__option d__sn__option

/* line 6 "/vobs/specman/src/ea/eanalyzer_main.e"  From 'struct definition' */
typedef struct s__ea__eanalyzer_notification {
    t__int d__;
    t__int gen__;
    t__string id;
    t__string msg;
    t__string srcfile;
    t__int srcline;
    t__int list_key;
    t__string full_msg;
    t__int module_num;
    struct s__l__string *params;
} *t__ea__eanalyzer_notification;
#define d__ea__eanalyzer_notification 8884
typedef t__ea__eanalyzer_notification t__eanalyzer_notification;
#define d__eanalyzer_notification d__ea__eanalyzer_notification

/* line 27 "/vobs/specman/src/ea/eanalyzer_main.e"  From 'struct definition' */
typedef struct s__ea__eanalyzer_filtered_lines {
    t__int d__;
    t__int gen__;
    t__string srcfile;
    t__int from;
    t__int to;
} *t__ea__eanalyzer_filtered_lines;
#define d__ea__eanalyzer_filtered_lines 8885
typedef t__ea__eanalyzer_filtered_lines t__eanalyzer_filtered_lines;
#define d__eanalyzer_filtered_lines d__ea__eanalyzer_filtered_lines

/* line 424 "/vobs/specman/src/ea/eanalyzer_lint.e"  From 'struct definition' */
typedef struct s__ea__ea_local {
    t__int d__;
    t__int gen__;
    struct s__sn__local *local;
    t__source_ref declaration_ref;
} *t__ea__ea_local;
#define d__ea__ea_local 8890
typedef t__ea__ea_local t__ea_local;
#define d__ea_local d__ea__ea_local

/* line 239 "/vobs/specman/src/ea/eanalyzer_lint.e"  From 'struct definition' */
typedef struct s__ea__ea_config_option {
    t__int d__;
    t__int gen__;
    t__string category;
    t__string option;
    t__string value;
    t__source_ref source_ref;
} *t__ea__ea_config_option;
#define d__ea__ea_config_option 8889
typedef t__ea__ea_config_option t__ea_config_option;
#define d__ea_config_option d__ea__ea_config_option

/* line 68 "/vobs/specman/src/ea/erm/ea_elint_rf_extend.e"  From 'struct definition' */
typedef struct s__sn__ea_sn_ea_define_manager {
    t__int d__;
    t__int gen__;
    struct s__k__sn__ea_rf_elint_defi97593 *rf_define_list;
} *t__sn__ea_sn_ea_define_manager;
#define d__sn__ea_sn_ea_define_manager 8894
typedef t__sn__ea_sn_ea_define_manager t__ea_sn_ea_define_manager;
#define d__ea_sn_ea_define_manager d__sn__ea_sn_ea_define_manager

/* line 43 "/vobs/specman/src/ea/erm/ea_elint_rf_extend.e"  From 'struct definition' */
typedef struct s__sn__ea_rf_elint_define {
    t__int d__;
    t__int gen__;
    t__string define_name;
    t__string define_val;
    t__bool is_verilog;
    struct s__e_core__source_item *source_item;
} *t__sn__ea_rf_elint_define;
#define d__sn__ea_rf_elint_define 8893
typedef t__sn__ea_rf_elint_define t__ea_rf_elint_define;
#define d__ea_rf_elint_define d__sn__ea_rf_elint_define

/* line 212 "/vobs/specman/src/ea/erm/ea_elint_rf_extend.e"  From 'struct definition' */
typedef struct s__sn__ea_sn_ea_unit_inst_98722 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__ea_rf_unit_inst *ea_rf_unit_inst_list;
} *t__sn__ea_sn_ea_unit_inst_manager;
#define d__sn__ea_sn_ea_unit_inst_manager 8896
typedef t__sn__ea_sn_ea_unit_inst_manager t__ea_sn_ea_unit_inst_manager;
#define d__ea_sn_ea_unit_inst_manager d__sn__ea_sn_ea_unit_inst_manager

/* line 8 "/vobs/specman/src/ea/erm/ea_elint_util.e"  From 'struct definition' */
typedef struct s__sn__ea_sn_ea_elint_util {
    t__int d__;
    t__int gen__;
} *t__sn__ea_sn_ea_elint_util;
#define d__sn__ea_sn_ea_elint_util 8903
typedef t__sn__ea_sn_ea_elint_util t__ea_sn_ea_elint_util;
#define d__ea_sn_ea_elint_util d__sn__ea_sn_ea_elint_util

/* line 203 "/vobs/specman/src/ea/erm/ea_elint_checklist.e"  From 'struct definition' */
typedef struct s__sn__ea_sn_ea_erm_checklist {
    t__int d__;
    t__int gen__;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_packaging_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_reset_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_check_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_coverage_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_architecture_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_sequence_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_monitor_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_doc_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_general_checks;
    struct s__k__sn__ea_sn_ea_erm_che98727 *erm_message_checks;
    struct s__k__string__it *erm_manual_check_any_answer;
} *t__sn__ea_sn_ea_erm_checklist;
#define d__sn__ea_sn_ea_erm_checklist 8912
typedef t__sn__ea_sn_ea_erm_checklist t__ea_sn_ea_erm_checklist;
#define d__ea_sn_ea_erm_checklist d__sn__ea_sn_ea_erm_checklist

/* line 181 "/vobs/specman/src/ea/erm/ea_elint_checklist.e"  From 'struct definition' */
typedef struct s__sn__ea_sn_ea_erm_check {
    t__int d__;
    t__int gen__;
    t__sn__ea_sn_ea_elint_msg_tag tag;
    t__string id;
    t__bool is_auto;
    t__sn__ea_sn_ea_elint_msg_type msg_type;
    t__string title;
    t__string question;
    t__string ok_msg;
    t__string bad_msg;
    t__string elint_msg;
    t__string elint_details;
    t__string comment;
    t__bool is_applicable;
} *t__sn__ea_sn_ea_erm_check;
#define d__sn__ea_sn_ea_erm_check 8911
typedef t__sn__ea_sn_ea_erm_check t__ea_sn_ea_erm_check;
#define d__ea_sn_ea_erm_check d__sn__ea_sn_ea_erm_check

/* line 312 "/vobs/specman/src/gen_lang.e"  From 'struct definition' */
typedef struct s__sn__untyped_list_to_sca11909 {
    t__int d__;
    t__int gen__;
} *t__sn__untyped_list_to_scalar_convertor;
#define d__sn__untyped_list_to_scalar_convertor 1942
typedef t__sn__untyped_list_to_scalar_convertor t__untyped_list_to_scalar_convertor;
#define d__untyped_list_to_scalar_convertor d__sn__untyped_list_to_scalar_convertor

/* line 40 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_generator {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_parsing_manager *parsing_manager;
    struct s__sn__gen_rt_manager *rt_manager;
    struct s__sn__gen_mm_manager *mm_manager;
    struct s__sn__gen_err_handler *err_handler;
    t__bool ignore_gotf_graph_reuse;
    t__bool ignore_conceptual_bug_solution;
    t__bool ignore_ixcc;
    t__bool ignore_unsafe_list_equality;
    t__bool monitor_infiniteness;
    t__bool monitor_pgcc_cycles;
    t__bool sample_inputs_serially;
    t__sn__count default_min_list_size;
    t__sn__count default_max_list_size;
    t__sn__count absolute_max_list_size;
    t__sn__count ra_default_list_size;
    t__sn__count ixcc_max_space_size;
    t__sn__count ps_inf_lint_threshold;
    struct s__sn_rl__uint_rl *default_list_size_rl;
    struct s__sn_rl__uint_rl *absolute_list_size_rl;
    t__sn__gotf_sa_mode_t gotf_sa_mode;
    t__sn__count gotf_sas_counter;
    t__sn__count lace_size_warn_threshold;
    struct s__sn__g5_prof_info *prof;
    struct s__l__sn__gen_context *contexts;
    struct s__sn__gen_path_elements_f56801 *path_elem_factory;
    struct s__gen__gen_sa_atomic_condition *EMPTY_ATOMIC_CONDITION;
    struct s__sn__gen_cmd_manager *cmd_manager;
    struct s__e_core__sn_weak_map *auxilary_info_table;
    struct s__l__sn__gen_user_constraint *constr;
    struct s__l__sn__gen_cc_seed_domain *seeds;
    struct s__gen_dbg__gen_dbg_debugger *debugger;
    t__gen__gen_order_policy_t generation_order_policy;
    struct s__sn__gen_sa_manager *sa_manager;
    t__uint ccs_solving_count;
    t__bool allow_cf_on_softs;
    t__uint node_counter;
    t__bool check_constraints_under_pointers;
    t__bool internal_global_transformation;
    t__bool simple_gen_disable;
    t__bool in_linter_dependency_mode;
    t__bool kill_unit_types_after_prerun;
    t__bool delete_solvers_after_prerun;
    t__sn__index cc_counter_for_id;
    struct s__k__sn__gen_sa_simple_cc96792 *headers_for_profiler;
    struct s__l__string *headers_user_strings;
    struct s__sn__gen_sa_simple_cc_header *REMOVED_SIMPLE_CC;
    struct s__sn__solver_bdd_info *gen_solver_bdd_info;
    t__uint propagations_limit;
    t__uint bdd_build_threshold;
    struct s__sn_rl__uint_rl *zero_rl;
    struct s__sn_rl__uint_rl *one_rl;
    struct s__sn_rl__uint_rl *zero_one_rl;
    struct s__sn_rl__bool_rl *false_rl;
    struct s__sn_rl__bool_rl *true_rl;
    struct s__sn_rl__bool_rl *a_bool_rl;
    struct s__sn__sn_bdd *zero_bdd;
    struct s__sn__sn_bdd *one_bdd;
    struct s__l__sn__gen_pnet_var *varlist;
    struct s__sn__global_trails *solver_trails;
    struct s__sn__qpack *solver_q;
    t__int gen_solver_unique_reference;
    struct s__sn__gen_constant_folder *constant_folder;
    struct s__sn__gen_slm_manager *slm_manager;
    t__uint shift_left_limit;
    struct s__sn_rl__int_rl *scalar_solver_tmp_int_rl;
    struct s__sn_rl__uint_rl *scalar_solver_tmp_uint_rl;
    struct s__sn_rl__long_rl *scalar_solver_tmp_long_rl;
    struct s__sn_rl__bool_rl *scalar_solver_tmp_bool_rl;
    struct s__sn_rl__short_enum_rl *scalar_solver_tmp_short_enum_rl;
    struct s__sn_rl__long_enum_rl *scalar_solver_tmp_long_enum_rl;
    t__bool minimize_failed_reductions;
    t__bool transform_eqs;
    struct s__k__sn__gen_pnet_var__it *solver_vs_hashed;
    struct s__k__sn__gen_pnet_propaga96793 *solver_ps_hashed;
    struct s__sn__rf_gen_manager *rf_gen_manager;
    struct s__sn__gen_path *EMPTY_PATH;
    t__bool dbgr_on;
    struct s__sn__gen_path *self_referencing_path;
    struct s__gen__gen_limitations_util *limitation_util;
    struct s__sn__test_case_e_code *tc_util;
} *t__sn__gen_generator;
#define d__sn__gen_generator 2101
typedef t__sn__gen_generator t__gen_generator;
#define d__gen_generator d__sn__gen_generator

/* line 69 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_parsing_manager {
    t__int d__;
    t__int gen__;
    t__bool is_in_sa_phase;
    struct s__reflection__rf_type *RF_UINT;
    struct s__reflection__rf_type *RF_TIME;
    struct s__l__sn__gen_path *is_a_paths;
    struct s__l__sn__st_local_exp *is_a_locals;
    struct s__l__gen__gen_sa_list_ind54961 *list_index_conditions;
    t__bool cur_path_has_list_index;
    struct s__l__sn__gen_path *lpm_paths;
    struct s__l__sn__st_local_exp *lpm_locals;
    struct s__sn__gen_path *last_all_lpm_path;
    t__string GENERIC_STR;
    t__string EMPTY_STR;
    t__string DOT_STR;
} *t__sn__gen_parsing_manager;
#define d__sn__gen_parsing_manager 2106
typedef t__sn__gen_parsing_manager t__gen_parsing_manager;
#define d__gen_parsing_manager d__sn__gen_parsing_manager

/* line 106 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path {
    t__int d__;
    t__int gen__;
    struct s__sn__st_exp *parse_exp;
    struct s__l__sn__gen_path_element *elements;
    t__bool is_main_path;
} *t__sn__gen_path;
#define d__sn__gen_path 6408
typedef t__sn__gen_path t__gen_path;
#define d__gen_path d__sn__gen_path

/* line 191 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_element {
    t__int d__;
    t__int gen__;
} *t__sn__gen_path_element;
#define d__sn__gen_path_element 6419
typedef t__sn__gen_path_element t__gen_path_element;
#define d__gen_path_element d__sn__gen_path_element

/* line 204 "/vobs/specman/src/syntax_exp.e"  From 'struct definition' */
typedef struct s__sn__st_local_exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__exp *ntv_exp;
    struct s__sn__explicit_exp *explicit_exp;
    struct s__sn__type_descriptor *base_type;
    t__sn__sn_local_exp_kind local_exp_kind;
    struct s__sn__sn_local_exp *local_exp;
    void *_sref___ptr_padding[1];
    t__source_ref sref;
} *t__sn__st_local_exp;
#define d__sn__st_local_exp 685
typedef t__sn__st_local_exp t__st_local_exp;
#define d__st_local_exp d__sn__st_local_exp

/* line 246 "/vobs/specman/src/named_exp.e"  From 'struct definition' */
typedef struct s__sn__sn_local_exp {
    t__int d__;
    t__int gen__;
    t__bool lhs;
    t__bool debug_mode;
} *t__sn__sn_local_exp;
#define d__sn__sn_local_exp 991
typedef t__sn__sn_local_exp t__sn_local_exp;
#define d__sn_local_exp d__sn__sn_local_exp

/* line 176 "/vobs/specman/src/gen/gen_sa_condition_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_list_index_56851 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_determinant_list *determinants;
    struct s__gen__gen_list_index_det54964 *det;
    struct s__sn_rl__uint_rl *irange;
} *t__gen__gen_sa_list_index_condition;
#define d__gen__gen_sa_list_index_condition 6582
typedef t__gen__gen_sa_list_index_condition t__gen_sa_list_index_condition;
#define d__gen_sa_list_index_condition d__gen__gen_sa_list_index_condition

/* line 51 "/vobs/specman/src/gen/gen_determinant_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_determinant_list {
    t__int d__;
    t__int gen__;
    struct s__l__gen__gen_determinant *determinants;
} *t__gen__gen_determinant_list;
#define d__gen__gen_determinant_list 6557
typedef t__gen__gen_determinant_list t__gen_determinant_list;
#define d__gen_determinant_list d__gen__gen_determinant_list

/* line 29 "/vobs/specman/src/gen/gen_determinant_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_determinant {
    t__int d__;
    t__int gen__;
} *t__gen__gen_determinant;
#define d__gen__gen_determinant 6554
typedef t__gen__gen_determinant t__gen_determinant;
#define d__gen_determinant d__gen__gen_determinant

/* line 45 "/vobs/specman/src/gen/gen_determinant_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_list_index_det54964 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path *list_path;
} *t__gen__gen_list_index_determinant;
#define d__gen__gen_list_index_determinant 6556
typedef t__gen__gen_list_index_determinant t__gen_list_index_determinant;
#define d__gen_list_index_determinant d__gen__gen_list_index_determinant

/* line 51 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_rt_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_rt_record *rt_record_stack;
    struct s__l__int *inds;
    struct s__gen__gen_context_ref_manager *context_ref_manager;
} *t__sn__gen_rt_manager;
#define d__sn__gen_rt_manager 2103
typedef t__sn__gen_rt_manager t__gen_rt_manager;
#define d__gen_rt_manager d__sn__gen_rt_manager

/* line 60 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_rt_record {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct *current_struct;
    t__sn__gen_error_types_t error_type;
    struct s__sn__activation_record *ar;
    struct s__sn__gen_context *current_context;
    struct s__sn__gen_path *generated_path;
    t__untyped current_context_instance;
    t__untyped root_instance;
    struct s__reflection__rf_struct *root_type;
    t__bool update_type;
    t__gen__update_root_type_status_t update_root_status;
    struct s__l__sn__gen_sa_ccs *ccs_queue;
    struct s__k__gen__root_to_indices96850 *root_indices;
    struct s__sn_wr__gen_context_abov80504 *above_context_ref;
    struct s__l__sn__gen_slm_abstract96851 *list_iterators;
    struct s__l__int *prefix_indices;
    struct s__l__int *current_indices;
    struct s__gen__gen_slm_sampling_record *sampling_data;
} *t__sn__gen_rt_record;
#define d__sn__gen_rt_record 2104
typedef t__sn__gen_rt_record t__gen_rt_record;
#define d__gen_rt_record d__sn__gen_rt_record

/* line 66 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_context {
    t__int d__;
    t__int gen__;
    struct s__sn__st_gen_keeping_action *gen_action;
    struct s__l__sn__gen_path *generated_paths;
    struct s__l__sn__gen_user_constraint *user_constraints;
    t__uint id;
    t__string seed_domain_str;
    struct s__reflection__rf_type *context_type;
    struct s__sn__st_local_exp *it_local;
    struct s__reflection__rf_struct *containing_struct;
    struct s__sn__gen_sa_ccs *ccs;
    struct s__sn__gen_sa_hierarchy_node *root;
    struct s__l__sn__gen_sa_pgen3_node *pgen3_nodes;
    struct s__l__gen__gen_sa_pointer_83391 *ctx_cpe_conditions;
    struct s__l__sn__gen_sa_cc_header *active_headers;
    struct s__gen__gen_simple_basic *simple_gen;
} *t__sn__gen_context;
#define d__sn__gen_context 2105
typedef t__sn__gen_context t__gen_context;
#define d__gen_context d__sn__gen_context

/* line 2995 "/vobs/specman/src/syntax_tree.e"  From 'struct definition' */
typedef struct s__sn__st_gen_keeping_action {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__action *ntv_action;
    struct s__sn__method *gen___method;
    t__int context_id;
    struct s__sn__st_local_exp *local_exp;
    struct s__l__reflection__st_constraint *constraints;
    struct s__sn__st_exp *path_exp;
    struct s__l__sn__n__constraint *ntv_constraints;
    struct s__sn_when_subtype__n__when2681 *ntv_path;
    t__string it_name;
    struct s__l__sn__scope *scopes;
    t__bool without_keeping;
    struct s__sn__gen_keeping_info *info;
} *t__sn__st_gen_keeping_action;
#define d__sn__st_gen_keeping_action 1883
typedef t__sn__st_gen_keeping_action t__st_gen_keeping_action;
#define d__st_gen_keeping_action d__sn__st_gen_keeping_action

/* line 1360 "/vobs/specman/src/when_subtype.e"  From 'struct definition' */
typedef struct s__sn_when_subtype__n__when2681 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    struct s__sn__type_descriptor *td;
} *t__sn_when_subtype__n__when_qualified_exp;
#define d__sn_when_subtype__n__when_qualified_exp 1087
typedef t__sn_when_subtype__n__when_qualified_exp t__n__when_qualified_exp;
#define d__n__when_qualified_exp d__sn_when_subtype__n__when_qualified_exp

/* line 11 "/vobs/specman/src/gen.e"  From 'struct definition' */
typedef struct s__sn__gen_keeping_info {
    t__int d__;
    t__int gen__;
    t__bool is_local;
    t__bool is_local_path;
    t__int gen_index;
    t__bool is_long;
    t__bool is_tcm;
    t__bool is_global_path;
    t__int it_path_index;
    struct s__sn__fields_constraint_path *it_path;
    struct s__sn__gen_keeping_local *it_var;
    t__int local_id;
    t__bool local_indirect;
    struct s__sn__struct_descriptor *sd;
    t__string local_c_name;
    t__int source_r;
} *t__sn__gen_keeping_info;
#define d__sn__gen_keeping_info 6396
typedef t__sn__gen_keeping_info t__gen_keeping_info;
#define d__gen_keeping_info d__sn__gen_keeping_info

/* line 1264 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__gen_keeping_local {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__type_descriptor *base_type;
    t__int index;
    struct s__sn__scope *scope;
    t__int sn_attr;
    t__string orig_string;
} *t__sn__gen_keeping_local;
#define d__sn__gen_keeping_local 209
typedef t__sn__gen_keeping_local t__gen_keeping_local;
#define d__gen_keeping_local d__sn__gen_keeping_local

/* line 48 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_user_constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_info *info;
    struct s__reflection__st_constraint *parse_tree;
    struct s__l__sn__gen_path *determinants;
    struct s__l__sn__gen_path *paths;
    struct s__l__sn__gen_constraint_i55052 *inputs;
    t__bool semantically_ignored;
    struct s__l__sn__st_exp *in_list_exps;
    void *_reset_soft_flag___ptr_padding[2];
    int _reset_soft_flag___int_padding[1];
    t__gen__t_reset_soft_status reset_soft_flag;
} *t__sn__gen_user_constraint;
#define d__sn__gen_user_constraint 2102
typedef t__sn__gen_user_constraint t__gen_user_constraint;
#define d__gen_user_constraint d__sn__gen_user_constraint

/* line 239 "/vobs/specman/src/gen/gen_parser_constraint_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_constraint_info {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *condition;
    struct s__sn__gen_implicit_constr56867 *implicit_constraints;
} *t__sn__gen_constraint_info;
#define d__sn__gen_constraint_info 6606
typedef t__sn__gen_constraint_info t__gen_constraint_info;
#define d__gen_constraint_info d__sn__gen_constraint_info

/* line 32 "/vobs/specman/src/gen/gen_sa_condition_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_condition {
    t__int d__;
    t__int gen__;
    struct s__l__gen__gen_sa_atomic_c54962 *atomic_conditions;
} *t__gen__gen_sa_condition;
#define d__gen__gen_sa_condition 6568
typedef t__gen__gen_sa_condition t__gen_sa_condition;
#define d__gen_sa_condition d__gen__gen_sa_condition

/* line 133 "/vobs/specman/src/gen/gen_sa_condition_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_atomic_condition {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_determinant_list *determinants;
} *t__gen__gen_sa_atomic_condition;
#define d__gen__gen_sa_atomic_condition 6579
typedef t__gen__gen_sa_atomic_condition t__gen_sa_atomic_condition;
#define d__gen_sa_atomic_condition d__gen__gen_sa_atomic_condition

/* line 303 "/vobs/specman/src/gen/gen_parser_constraint_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_implicit_constr56867 {
    t__int d__;
    t__int gen__;
    struct s__l__gen__gen_implicit_co54963 *constraints;
} *t__sn__gen_implicit_constraint_holder;
#define d__sn__gen_implicit_constraint_holder 6609
typedef t__sn__gen_implicit_constraint_holder t__gen_implicit_constraint_holder;
#define d__gen_implicit_constraint_holder d__sn__gen_implicit_constraint_holder

/* line 98 "/vobs/specman/src/gen/gen_sa_condition_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_implicit_constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_info *info;
    struct s__reflection__st_constraint *parse_tree;
    struct s__l__sn__gen_path *determinants;
    struct s__l__sn__gen_path *paths;
    struct s__l__sn__gen_constraint_i55052 *inputs;
    t__bool semantically_ignored;
    struct s__l__sn__st_exp *in_list_exps;
    void *_reset_soft_flag___ptr_padding[2];
    int _reset_soft_flag___int_padding[1];
    t__gen__t_reset_soft_status reset_soft_flag;
} *t__gen__gen_implicit_constraint;
#define d__gen__gen_implicit_constraint 6569
typedef t__gen__gen_implicit_constraint t__gen_implicit_constraint;
#define d__gen_implicit_constraint d__gen__gen_implicit_constraint

/* line 81 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_constraint_input_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__st_exp *parse_exp;
    t__bool is_under_keeping;
    struct s__l__sn__gen_path *determinants;
} *t__sn__gen_constraint_input_exp;
#define d__sn__gen_constraint_input_exp 6404
typedef t__sn__gen_constraint_input_exp t__gen_constraint_input_exp;
#define d__gen_constraint_input_exp d__sn__gen_constraint_input_exp

/* line 167 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_ccs {
    t__int d__;
    t__int gen__;
    t__bool prepared_for_simple;
    struct s__sn__gen_sa_reuse_tree *cc_reuse_tree;
    struct s__sn__gen_sa_condition_manager *condition_manager;
    struct s__sn__gen_sa_hierarchy_node *root;
    struct s__sn__gen_context *context;
    struct s__l__sn__gen_sa_hierarchy_node *rt_static_nodes;
    t__bool created_flag;
    struct s__l__gen__gen_sa_exported85485 *exported_dependencies;
    t__bool is_rt_ready;
    struct s__gen__gen_determinant_list *long_distance_determinants;
    struct s__gen__gen_rt_pas_manager *pointer_assignment_table;
} *t__sn__gen_sa_ccs;
#define d__sn__gen_sa_ccs 6489
typedef t__sn__gen_sa_ccs t__gen_sa_ccs;
#define d__gen_sa_ccs d__sn__gen_sa_ccs

/* line 340 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_reuse_tree {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_regular_reus56840 *root;
    t__bool is_built;
    struct s__l__sn__gen_sa_cc_header *gen_sa_cc_reuse_tree_imp___get_cc_headers_result;
} *t__sn__gen_sa_reuse_tree;
#define d__sn__gen_sa_reuse_tree 6525
typedef t__sn__gen_sa_reuse_tree t__gen_sa_reuse_tree;
#define d__gen_sa_reuse_tree d__sn__gen_sa_reuse_tree

/* line 346 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_regular_reus56840 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path *prefix_from_current_ctx;
    struct s__sn__gen_sa_ccs *originating_ccs;
    struct s__sn__gen_path_element *label;
    struct s__e_core__base_struct *label_key;
    struct s__gen__gen_sa_condition *definition_condition;
    struct s__sn__gen_sa_regular_reus56840 *parent;
    struct s__l__untyped *dinamic_alloc_list;
    struct s__sn__gen_sa_cc_dag *self_cc_dag;
    struct s__gen__gen_sa_reuse_node_dag *children;
    struct s__sn__gen_sa_prefix_pas_data *prefix_pas_data;
    struct s__k__gen__gen_sa_alloced_96895 *dinamic_allocs;
    struct s__sn__gen_sa_rt_order_list *rt_order_elements;
} *t__sn__gen_sa_regular_reuse_node;
#define d__sn__gen_sa_regular_reuse_node 6527
typedef t__sn__gen_sa_regular_reuse_node t__gen_sa_regular_reuse_node;
#define d__gen_sa_regular_reuse_node d__sn__gen_sa_regular_reuse_node

/* line 358 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_cc_dag {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_direct_cc_h82653 *dep_graph;
} *t__sn__gen_sa_cc_dag;
#define d__sn__gen_sa_cc_dag 6531
typedef t__sn__gen_sa_cc_dag t__gen_sa_cc_dag;
#define d__gen_sa_cc_dag d__sn__gen_sa_cc_dag

/* line 4 "/vobs/specman/src/gen/gen_sa_cc_reuse_tree_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_direct_cc_h82653 {
    t__int d__;
    t__int gen__;
    struct s__k__gen__gen_sa_direct_c82681 *nodes;
    struct s__k__gen__gen_sa_direct_c96913 *components;
    t__bool had_back_edge;
    t__uint timestamp;
} *t__gen__gen_sa_direct_cc_header_dependency_graph;
#define d__gen__gen_sa_direct_cc_header_dependency_graph 8158
typedef t__gen__gen_sa_direct_cc_header_dependency_graph t__gen_sa_direct_cc_header_dependency_graph;
#define d__gen_sa_direct_cc_header_dependency_graph d__gen__gen_sa_direct_cc_header_dependency_graph

/* line 4 "/vobs/specman/src/gen/gen_sa_cc_reuse_tree_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_direct_cc_h82650 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_direct_cc_header *id;
    struct s__k__sn__gen_sa_direct_cc82648 *dependants;
    struct s__k__gen__gen_sa_direct_c96910 *t_dependants;
    t__uint color;
    struct s__gen__gen_sa_direct_cc_h96911 *cormen_pi;
    struct s__gen__gen_sa_direct_cc_h82650 *parent;
    t__bool has_self_edge;
    struct s__gen__gen_sa_direct_cc_h82625 *my_component;
    struct s__gen__gen_sa_direct_cc_h82653 *dgraph;
} *t__gen__gen_sa_direct_cc_header_dependency_node;
#define d__gen__gen_sa_direct_cc_header_dependency_node 8159
typedef t__gen__gen_sa_direct_cc_header_dependency_node t__gen_sa_direct_cc_header_dependency_node;
#define d__gen_sa_direct_cc_header_dependency_node d__gen__gen_sa_direct_cc_header_dependency_node

/* line 187 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_direct_cc_header {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *condition;
    struct s__sn__gen_sa_ccs *containing_ccs;
    struct s__sn__gen_sa_cc_above_data *above_data;
    struct s__sn__gen_sa_solving_info56832 *graph;
} *t__sn__gen_sa_direct_cc_header;
#define d__sn__gen_sa_direct_cc_header 6492
typedef t__sn__gen_sa_direct_cc_header t__gen_sa_direct_cc_header;
#define d__gen_sa_direct_cc_header d__sn__gen_sa_direct_cc_header

/* line 211 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_cc_above_data {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_sa_constrain82582 *constraints;
} *t__sn__gen_sa_cc_above_data;
#define d__sn__gen_sa_cc_above_data 6499
typedef t__sn__gen_sa_cc_above_data t__gen_sa_cc_above_data;
#define d__gen_sa_cc_above_data d__sn__gen_sa_cc_above_data

/* line 278 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_constraint_i54950 {
    t__int d__;
    t__int gen__;
    t__bool is_from_original_context;
    struct s__sn__gen_sa_constraint_i54950 *orig_cons;
    struct s__sn__gen_path *rpath;
    struct s__sn__gen_path *cfa_merge_path;
} *t__sn__gen_sa_constraint_instance;
#define d__sn__gen_sa_constraint_instance 6513
typedef t__sn__gen_sa_constraint_instance t__gen_sa_constraint_instance;
#define d__gen_sa_constraint_instance d__sn__gen_sa_constraint_instance

/* line 246 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_solving_info56832 {
    t__int d__;
    t__int gen__;
} *t__sn__gen_sa_solving_info_container;
#define d__sn__gen_sa_solving_info_container 6505
typedef t__sn__gen_sa_solving_info_container t__gen_sa_solving_info_container;
#define d__gen_sa_solving_info_container d__sn__gen_sa_solving_info_container

/* line 4 "/vobs/specman/src/gen/gen_sa_cc_reuse_tree_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_direct_cc_h96911 {
    t__int d__;
    t__int gen__;
    struct s__k__gen__gen_sa_direct_c96910 *nodes;
} *t__gen__gen_sa_direct_cc_header_dnode_holder;
#define d__gen__gen_sa_direct_cc_header_dnode_holder 8160
typedef t__gen__gen_sa_direct_cc_header_dnode_holder t__gen_sa_direct_cc_header_dnode_holder;
#define d__gen_sa_direct_cc_header_dnode_holder d__gen__gen_sa_direct_cc_header_dnode_holder

/* line 4 "/vobs/specman/src/gen/gen_sa_cc_reuse_tree_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_direct_cc_h82625 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__gen_sa_direct_cc82648 *elements;
    t__bool is_cyclic;
} *t__gen__gen_sa_direct_cc_header_component;
#define d__gen__gen_sa_direct_cc_header_component 8157
typedef t__gen__gen_sa_direct_cc_header_component t__gen_sa_direct_cc_header_component;
#define d__gen_sa_direct_cc_header_component d__gen__gen_sa_direct_cc_header_component

/* line 861 "/vobs/specman/src/gen/gen_sa_cc_reuse_tree_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_reuse_node_dag {
    t__int d__;
    t__int gen__;
    struct s__k__sn__gen_sa_reuse_nod84881 *labeled_children;
} *t__gen__gen_sa_reuse_node_dag;
#define d__gen__gen_sa_reuse_node_dag 8209
typedef t__gen__gen_sa_reuse_node_dag t__gen_sa_reuse_node_dag;
#define d__gen_sa_reuse_node_dag d__gen__gen_sa_reuse_node_dag

/* line 343 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_reuse_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path *prefix_from_current_ctx;
    struct s__sn__gen_sa_ccs *originating_ccs;
    struct s__sn__gen_path_element *label;
    struct s__e_core__base_struct *label_key;
    struct s__gen__gen_sa_condition *definition_condition;
    struct s__sn__gen_sa_regular_reus56840 *parent;
    struct s__l__untyped *dinamic_alloc_list;
} *t__sn__gen_sa_reuse_node;
#define d__sn__gen_sa_reuse_node 6526
typedef t__sn__gen_sa_reuse_node t__gen_sa_reuse_node;
#define d__gen_sa_reuse_node d__sn__gen_sa_reuse_node

/* line 355 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_prefix_pas_data {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path *my_prefix;
    struct s__l__gen__gen_sa_pas_record *pas_records;
} *t__sn__gen_sa_prefix_pas_data;
#define d__sn__gen_sa_prefix_pas_data 6530
typedef t__sn__gen_sa_prefix_pas_data t__gen_sa_prefix_pas_data;
#define d__gen_sa_prefix_pas_data d__sn__gen_sa_prefix_pas_data

/* line 1178 "/vobs/specman/src/gen/gen_sa_ccs_rt_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_pas_record {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path *path;
    struct s__l__int *indices;
    t__untyped root;
    t__sn__gen_sa_solving_status stat;
} *t__gen__gen_sa_pas_record;
#define d__gen__gen_sa_pas_record 8282
typedef t__gen__gen_sa_pas_record t__gen_sa_pas_record;
#define d__gen_sa_pas_record d__gen__gen_sa_pas_record

/* line 884 "/vobs/specman/src/gen/gen_sa_cc_reuse_tree_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_alloced_nod96934 {
    t__int d__;
    t__int gen__;
    t__untyped val;
    struct s__sn__gen_sa_hierarchy_node *node;
} *t__gen__gen_sa_alloced_node_record;
#define d__gen__gen_sa_alloced_node_record 8210
typedef t__gen__gen_sa_alloced_node_record t__gen_sa_alloced_node_record;
#define d__gen_sa_alloced_node_record d__gen__gen_sa_alloced_node_record

/* line 75 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_hierarchy_node {
    t__int d__;
    t__int gen__;
    t__uint id;
    struct s__sn__gen_path *my_path;
    struct s__reflection__rf_type *my_type;
    struct s__sn__gen_seed_domains *seed_domains;
    struct s__sn__gen_path_element *my_label;
    t__sn__gen_sa_solving_status solving_status;
    t__bool is_definite_regular;
    struct s__gen__gen_sa_solving_nod96848 *solving_nodes;
    struct s__gen__gen_sa_condition *definition_condition;
    struct s__sn__gen_sa_shadow_node *shadow_node;
    t__bool has_virtual_mirror;
    t__bool is_irrelevant_virtual;
    struct s__reflection__rf_struct *declaring_struct;
    struct s__e_core__base_struct *my_label_key;
    struct s__sn__gen_sa_direct_cc_header *cc_header;
} *t__sn__gen_sa_hierarchy_node;
#define d__sn__gen_sa_hierarchy_node 6460
typedef t__sn__gen_sa_hierarchy_node t__gen_sa_hierarchy_node;
#define d__gen_sa_hierarchy_node d__sn__gen_sa_hierarchy_node

/* line 51 "/vobs/specman/src/gen/gen_slm_random_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_seed_domains {
    t__int d__;
    t__int gen__;
} *t__sn__gen_seed_domains;
#define d__sn__gen_seed_domains 8075
typedef t__sn__gen_seed_domains t__gen_seed_domains;
#define d__gen_seed_domains d__sn__gen_seed_domains

/* line 2524 "/vobs/specman/src/gen/gen_sa_node_basic_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_solving_nod96848 {
    t__int d__;
    t__int gen__;
    struct s__k__gen__gen_sa_solving_96925 *nodes;
    struct s__l__sn__gen_sa_hierarchy_node *possible_mirrors;
} *t__gen__gen_sa_solving_nodes_list;
#define d__gen__gen_sa_solving_nodes_list 8173
typedef t__gen__gen_sa_solving_nodes_list t__gen_sa_solving_nodes_list;
#define d__gen_sa_solving_nodes_list d__gen__gen_sa_solving_nodes_list

/* line 2529 "/vobs/specman/src/gen/gen_sa_node_basic_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_solving_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_hierarchy_node *node;
    struct s__sn__gen_sa_cc_graph *graph;
} *t__gen__gen_sa_solving_node;
#define d__gen__gen_sa_solving_node 8174
typedef t__gen__gen_sa_solving_node t__gen_sa_solving_node;
#define d__gen_sa_solving_node d__gen__gen_sa_solving_node

/* line 250 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_cc_graph {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_abstract_in56844 *gen_sa_simple_cc_header_basic_imp___index_iterator;
    struct s__l__sn__gen_sa_solving_status *gen_sa_simple_cc_header_basic_imp___get_nodes_solving_status_result;
    struct s__sn__gen_sa_cc_info_component *self_info_component;
    struct s__gen__gen_cc_determinant_list *determinants;
    struct s__l__sn__any_rl *consts_list;
    t__int consts_list_from;
    t__bool is_rt_ready;
    struct s__gen__gen_sa_condition *rt_condition;
    struct s__gen__gen_sa_condition *dependency_condition;
    struct s__sn__gen_sa_cc_graph *orig_graph;
    struct s__gen_dbg__gen_dbg_cc_stat *cc_stat;
    struct s__gen__gen_simple_basic *simple_gen;
    struct s__gen__gen_simple_basic *exclusion_simple_gen;
    struct s__sn_rl__uint_rl *exclusion_rl;
    struct s__gen__gen_sa_tmp_graphs_96892 *tmp_graphs_holder;
    struct s__sn__gen_soft_orderer *constraints_orderer;
    struct s__sn__gen_soft_orderer *selects_orderer;
    struct s__sn__gen_cc_solver *cc_solver;
    t__bool reset_cc_solvar_blocked;
    struct s__gen__gen_slm_solver_dat86104 *slm_data_holder;
    struct s__gen__gen_slm_softs_mapper *softs_mapper;
} *t__sn__gen_sa_cc_graph;
#define d__sn__gen_sa_cc_graph 6506
typedef t__sn__gen_sa_cc_graph t__gen_sa_cc_graph;
#define d__gen_sa_cc_graph d__sn__gen_sa_cc_graph

/* line 409 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_abstract_in56844 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_rt_record *rt_record;
} *t__sn__gen_slm_abstract_index_iterator;
#define d__sn__gen_slm_abstract_index_iterator 6542
typedef t__sn__gen_slm_abstract_index_iterator t__gen_slm_abstract_index_iterator;
#define d__gen_slm_abstract_index_iterator d__sn__gen_slm_abstract_index_iterator

/* line 260 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_cc_info_component {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_sa_hierarchy_node *nodes;
    struct s__l__sn__gen_sa_input_node *inputs;
    struct s__l__sn__gen_sa_constrain82582 *constraints;
    struct s__gen__gen_determinant_list *determinants;
    struct s__sn__gen_sa_folded_domai56833 *folded_domains;
    t__bool has_absolute_defaults;
} *t__sn__gen_sa_cc_info_component;
#define d__sn__gen_sa_cc_info_component 6509
typedef t__sn__gen_sa_cc_info_component t__gen_sa_cc_info_component;
#define d__gen_sa_cc_info_component d__sn__gen_sa_cc_info_component

/* line 78 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_input_node {
    t__int d__;
    t__int gen__;
    t__uint id;
    struct s__gen__gen_sa_condition *definition_condition;
    void *_parameter___ptr_padding[3];
    struct s__sn__gencov_base_parameter *parameter;
    struct s__sn__gen_path *prefix;
    t__sn__sample_type_t sample_type;
    struct s__sn__gen_sa_constraint_i54950 *originator;
    t__uint id_in_originator;
} *t__sn__gen_sa_input_node;
#define d__sn__gen_sa_input_node 6461
typedef t__sn__gen_sa_input_node t__gen_sa_input_node;
#define d__gen_sa_input_node d__sn__gen_sa_input_node

/* line 70 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gencov_base_parameter {
    t__int d__;
    t__int gen__;
    struct s__sn__st_exp *parse_exp;
} *t__sn__gencov_base_parameter;
#define d__sn__gencov_base_parameter 6403
typedef t__sn__gencov_base_parameter t__gencov_base_parameter;
#define d__gencov_base_parameter d__sn__gencov_base_parameter

/* line 263 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_folded_domai56833 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__gen_sa_folded_do85004 *items;
} *t__sn__gen_sa_folded_domain_handler;
#define d__sn__gen_sa_folded_domain_handler 6510
typedef t__sn__gen_sa_folded_domain_handler t__gen_sa_folded_domain_handler;
#define d__gen_sa_folded_domain_handler d__sn__gen_sa_folded_domain_handler

/* line 266 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_folded_domai56834 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_hierarchy_node *node;
} *t__sn__gen_sa_folded_domain_item;
#define d__sn__gen_sa_folded_domain_item 6511
typedef t__sn__gen_sa_folded_domain_item t__gen_sa_folded_domain_item;
#define d__gen_sa_folded_domain_item d__sn__gen_sa_folded_domain_item

/* line 72 "/vobs/specman/src/gen/gen_determinant_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_cc_determinant_list {
    t__int d__;
    t__int gen__;
    struct s__l__gen__gen_determinant *determinants;
} *t__gen__gen_cc_determinant_list;
#define d__gen__gen_cc_determinant_list 6558
typedef t__gen__gen_cc_determinant_list t__gen_cc_determinant_list;
#define d__gen_cc_determinant_list d__gen__gen_cc_determinant_list

/* line 576 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_cc_stat {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_sa_solving_status *stats;
} *t__gen_dbg__gen_dbg_cc_stat;
#define d__gen_dbg__gen_dbg_cc_stat 8016
typedef t__gen_dbg__gen_dbg_cc_stat t__gen_dbg_cc_stat;
#define d__gen_dbg_cc_stat d__gen_dbg__gen_dbg_cc_stat

/* line 123 "/vobs/specman/src/gen/gen_sa_context_basic_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_simple_basic {
    t__int d__;
    t__int gen__;
} *t__gen__gen_simple_basic;
#define d__gen__gen_simple_basic 8141
typedef t__gen__gen_simple_basic t__gen_simple_basic;
#define d__gen_simple_basic d__gen__gen_simple_basic

/* line 1245 "/vobs/specman/src/gen/gen_sa_cc_graph_basic_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_tmp_graphs_96892 {
    t__int d__;
    t__int gen__;
    struct s__l__gen__gen_sa_graph_an96940 *tmps;
} *t__gen__gen_sa_tmp_graphs_holder;
#define d__gen__gen_sa_tmp_graphs_holder 8216
typedef t__gen__gen_sa_tmp_graphs_holder t__gen_sa_tmp_graphs_holder;
#define d__gen_sa_tmp_graphs_holder d__gen__gen_sa_tmp_graphs_holder

/* line 1249 "/vobs/specman/src/gen/gen_sa_cc_graph_basic_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_graph_and_stats {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_cc_graph *graph;
    struct s__l__sn__gen_sa_solving_status *old_solving_statuses;
    struct s__l__sn__gen_sa_solving_status *new_solving_statuses;
} *t__gen__gen_sa_graph_and_stats;
#define d__gen__gen_sa_graph_and_stats 8217
typedef t__gen__gen_sa_graph_and_stats t__gen_sa_graph_and_stats;
#define d__gen_sa_graph_and_stats d__gen__gen_sa_graph_and_stats

/* line 27 "/vobs/specman/src/gen/gen_slm_soft_constraints_orderer.e"  From 'struct definition' */
typedef struct s__sn__gen_soft_orderer {
    t__int d__;
    t__int gen__;
    struct s__l__sn__orderable_object *objects;
    struct s__l__sn__object_layer *layers;
} *t__sn__gen_soft_orderer;
#define d__sn__gen_soft_orderer 8271
typedef t__sn__gen_soft_orderer t__gen_soft_orderer;
#define d__gen_soft_orderer d__sn__gen_soft_orderer

/* line 22 "/vobs/specman/src/gen/gen_slm_soft_constraints_orderer.e"  From 'struct definition' */
typedef struct s__sn__orderable_object {
    t__int d__;
    t__int gen__;
} *t__sn__orderable_object;
#define d__sn__orderable_object 8270
typedef t__sn__orderable_object t__orderable_object;
#define d__orderable_object d__sn__orderable_object

/* line 149 "/vobs/specman/src/gen/gen_slm_soft_constraints_orderer.e"  From 'struct definition' */
typedef struct s__sn__object_layer {
    t__int d__;
    t__int gen__;
    struct s__sn__abstract_orderer *orderer;
    struct s__l__int *independent_objects;
} *t__sn__object_layer;
#define d__sn__object_layer 8274
typedef t__sn__object_layer t__object_layer;
#define d__object_layer d__sn__object_layer

/* line 7 "/vobs/specman/src/gen/gen_slm_soft_constraints_orderer.e"  From 'struct definition' */
typedef struct s__sn__abstract_orderer {
    t__int d__;
    t__int gen__;
    struct s__l__sn__orderable_object *objects;
    struct s__l__sn__object_layer *layers;
} *t__sn__abstract_orderer;
#define d__sn__abstract_orderer 8269
typedef t__sn__abstract_orderer t__abstract_orderer;
#define d__abstract_orderer d__sn__abstract_orderer

/* line 457 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_cc_solver {
    t__int d__;
    t__int gen__;
} *t__sn__gen_cc_solver;
#define d__sn__gen_cc_solver 6552
typedef t__sn__gen_cc_solver t__gen_cc_solver;
#define d__gen_cc_solver d__sn__gen_cc_solver

/* line 30 "/vobs/specman/src/gen/gen_slm_cc_graph_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_slm_solver_dat86104 {
    t__int d__;
    t__int gen__;
    struct s__l__uint *select_on_exps_added_vars_ids;
    struct s__l__uint *conditional_select_translation_added_vars_ids;
    struct s__l__gen__slm_tree_map *select_temp_constrs;
    struct s__l__gen__slm_tree_map *reset_soft_temp_vars;
    struct s__l__uint *conditional_rs_added_vars_ids;
    struct s__l__sn__gen_sa_constrain82582 *conditional_rs_ci_table;
    struct s__l__uint *conditional_rs_vars;
    struct s__l__sn__int_list_holder *soft_ids;
} *t__gen__gen_slm_solver_data_holder;
#define d__gen__gen_slm_solver_data_holder 8318
typedef t__gen__gen_slm_solver_data_holder t__gen_slm_solver_data_holder;
#define d__gen_slm_solver_data_holder d__gen__gen_slm_solver_data_holder

/* line 349 "/vobs/specman/src/gen/gen_slm_cc_graph_imp.e"  From 'struct definition' */
typedef struct s__gen__slm_tree_map {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_constraint_86091 *key;
    t__uint value;
} *t__gen__slm_tree_map;
#define d__gen__slm_tree_map 8606
typedef t__gen__slm_tree_map t__slm_tree_map;
#define d__slm_tree_map d__gen__slm_tree_map

/* line 49 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_constraint_86091 {
    t__int d__;
    t__int gen__;
} *t__sn__gen_slm_constraint_tree_node;
#define d__sn__gen_slm_constraint_tree_node 8247
typedef t__sn__gen_slm_constraint_tree_node t__gen_slm_constraint_tree_node;
#define d__gen_slm_constraint_tree_node d__sn__gen_slm_constraint_tree_node

/* line 2701 "/vobs/specman/src/list_macros.e"  From 'struct definition' */
typedef struct s__sn__int_list_holder {
    t__int d__;
    t__int gen__;
    struct s__l__int *value;
} *t__sn__int_list_holder;
#define d__sn__int_list_holder 970
typedef t__sn__int_list_holder t__int_list_holder;
#define d__int_list_holder d__sn__int_list_holder

/* line 23 "/vobs/specman/src/gen/gen_slm_cc_graph_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_slm_softs_mapper {
    t__int d__;
    t__int gen__;
    struct s__l__int *soft_indices;
    struct s__l__sn__gen_sa_constrain82582 *soft_constrs;
    struct s__l__gen__selects_chain_c96986 *select_chains;
    struct s__l__int *select_indices;
} *t__gen__gen_slm_softs_mapper;
#define d__gen__gen_slm_softs_mapper 8317
typedef t__gen__gen_slm_softs_mapper t__gen_slm_softs_mapper;
#define d__gen_slm_softs_mapper d__gen__gen_slm_softs_mapper

/* line 21 "/vobs/specman/src/gen/gen_slm_cc_graph_hdr.e"  From 'struct definition' */
typedef struct s__gen__selects_chain_container {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_sa_constrain82582 *constrs;
} *t__gen__selects_chain_container;
#define d__gen__selects_chain_container 8316
typedef t__gen__selects_chain_container t__selects_chain_container;
#define d__selects_chain_container d__gen__selects_chain_container

/* line 93 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_shadow_node {
    t__int d__;
    t__int gen__;
    t__uint id;
    struct s__gen__gen_sa_condition *definition_condition;
    void *_parameter___ptr_padding[3];
    struct s__sn__gencov_base_parameter *parameter;
    struct s__sn__gen_path *prefix;
    t__sn__sample_type_t sample_type;
    struct s__sn__gen_sa_constraint_i54950 *originator;
    t__uint id_in_originator;
} *t__sn__gen_sa_shadow_node;
#define d__sn__gen_sa_shadow_node 6466
typedef t__sn__gen_sa_shadow_node t__gen_sa_shadow_node;
#define d__gen_sa_shadow_node d__sn__gen_sa_shadow_node

/* line 406 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_rt_order_list {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_ccs *ccs;
    struct s__sn__gen_sa_rt_order_item *zero_item;
    struct s__sn__gen_sa_rt_order_item *first_item;
} *t__sn__gen_sa_rt_order_list;
#define d__sn__gen_sa_rt_order_list 6541
typedef t__sn__gen_sa_rt_order_list t__gen_sa_rt_order_list;
#define d__gen_sa_rt_order_list d__sn__gen_sa_rt_order_list

/* line 403 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_rt_order_item {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_direct_cc_header *current_cc;
    struct s__sn__gen_sa_rt_order_item *next_item;
} *t__sn__gen_sa_rt_order_item;
#define d__sn__gen_sa_rt_order_item 6540
typedef t__sn__gen_sa_rt_order_item t__gen_sa_rt_order_item;
#define d__gen_sa_rt_order_item d__sn__gen_sa_rt_order_item

/* line 175 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_cc_header {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *condition;
    struct s__sn__gen_sa_ccs *containing_ccs;
} *t__sn__gen_sa_cc_header;
#define d__sn__gen_sa_cc_header 6490
typedef t__sn__gen_sa_cc_header t__gen_sa_cc_header;
#define d__gen_sa_cc_header d__sn__gen_sa_cc_header

/* line 8 "/vobs/specman/src/gen/gen_sa_condition_manager.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_condition_manager {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__uint_rl *private_rl;
    struct s__sn_rl__uint_rl *public_rl;
    struct s__l__gen__gen_sa_list_ind54961 *atomic_non_lace;
    struct s__l__gen__gen_sa_list_ind54961 *atomic_laces;
    struct s__l__gen__gen_sa_condition *conditions_cache;
    struct s__gen__gen_sa_condition *tmp_condition;
} *t__sn__gen_sa_condition_manager;
#define d__sn__gen_sa_condition_manager 8207
typedef t__sn__gen_sa_condition_manager t__gen_sa_condition_manager;
#define d__gen_sa_condition_manager d__sn__gen_sa_condition_manager

/* line 657 "/vobs/specman/src/gen/gen_sa_dependency_analysis.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_exported_de96944 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_hierarchy_node *child;
    struct s__sn__gen_sa_hierarchy_node *deep_node;
} *t__gen__gen_sa_exported_dependency;
#define d__gen__gen_sa_exported_dependency 8227
typedef t__gen__gen_sa_exported_dependency t__gen_sa_exported_dependency;
#define d__gen_sa_exported_dependency d__gen__gen_sa_exported_dependency

/* line 935 "/vobs/specman/src/gen/gen_sa_ccs_rt_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_rt_pas_manager {
    t__int d__;
    t__int gen__;
    t__uint size_threshold;
    t__uint added_records;
    t__sn__gen_sa_solving_status pas_root_stat;
} *t__gen__gen_rt_pas_manager;
#define d__gen__gen_rt_pas_manager 8281
typedef t__gen__gen_rt_pas_manager t__gen_rt_pas_manager;
#define d__gen_rt_pas_manager d__gen__gen_rt_pas_manager

/* line 156 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_pgen3_node {
    t__int d__;
    t__int gen__;
    t__uint id;
    struct s__sn__gen_path *my_path;
    struct s__reflection__rf_type *my_type;
    struct s__sn__gen_seed_domains *seed_domains;
    struct s__sn__gen_path_element *my_label;
    t__sn__gen_sa_solving_status solving_status;
    t__bool is_definite_regular;
    struct s__gen__gen_sa_solving_nod96848 *solving_nodes;
    struct s__gen__gen_sa_condition *definition_condition;
    struct s__sn__gen_sa_shadow_node *shadow_node;
    t__bool has_virtual_mirror;
    t__bool is_irrelevant_virtual;
    struct s__reflection__rf_struct *declaring_struct;
    struct s__e_core__base_struct *my_label_key;
    struct s__sn__gen_sa_direct_cc_header *cc_header;
    t__uint pgen3_ctx_info;
    struct s__l__gen__gen_determinant *determinants;
    t__bool had_fully_been_solved;
} *t__sn__gen_sa_pgen3_node;
#define d__sn__gen_sa_pgen3_node 6487
typedef t__sn__gen_sa_pgen3_node t__gen_sa_pgen3_node;
#define d__gen_sa_pgen3_node d__sn__gen_sa_pgen3_node

/* line 172 "/vobs/specman/src/gen/gen_sa_condition_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_pointer_equ56859 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_determinant_list *determinants;
    t__bool is_definite;
    struct s__sn__gen_user_constraint *orig_uc;
} *t__gen__gen_sa_pointer_equality_condition;
#define d__gen__gen_sa_pointer_equality_condition 6581
typedef t__gen__gen_sa_pointer_equality_condition t__gen_sa_pointer_equality_condition;
#define d__gen_sa_pointer_equality_condition d__gen__gen_sa_pointer_equality_condition

/* line 198 "/vobs/specman/src/gen/gen_rtm_manager_api.e"  From 'struct definition' */
typedef struct s__gen__root_to_indices_mapper {
    t__int d__;
    t__int gen__;
    t__untyped root;
    struct s__l__int *indices;
} *t__gen__root_to_indices_mapper;
#define d__gen__root_to_indices_mapper 8184
typedef t__gen__root_to_indices_mapper t__root_to_indices_mapper;
#define d__root_to_indices_mapper d__gen__root_to_indices_mapper

/* line 352 "/vobs/specman/src/weak_ref.e"  From 'struct definition' */
typedef struct s__sn_wr__gen_context_abov80504 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_hierarchy_node *above_node;
    struct s__l__gen__gen_sa_ci_sampl96830 *ci_sample_results;
} *t__sn_wr__gen_context_above_info;
#define d__sn_wr__gen_context_above_info 8026
typedef t__sn_wr__gen_context_above_info t__gen_context_above_info;
#define d__gen_context_above_info d__sn_wr__gen_context_above_info

/* line 3224 "/vobs/specman/src/gen/gen_sa_context_basic_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_ci_sample_r96929 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_constraint_i54950 *ci;
    struct s__l__sn__any_rl *sample_results;
    t__bool ignored;
} *t__gen__gen_sa_ci_sample_results;
#define d__gen__gen_sa_ci_sample_results 8188
typedef t__gen__gen_sa_ci_sample_results t__gen_sa_ci_sample_results;
#define d__gen_sa_ci_sample_results d__gen__gen_sa_ci_sample_results

/* line 99 "/vobs/specman/src/gen/gen_slm_sample_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_slm_sampling_record {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path *full_prefix;
    struct s__l__int *instantiated_indices;
    struct s__sn__gen_slm_multiplicit86160 *excluding_node;
    struct s__sn__activation_record *ar;
    t__bool sampling_cpe_implicit;
} *t__gen__gen_slm_sampling_record;
#define d__gen__gen_slm_sampling_record 8295
typedef t__gen__gen_slm_sampling_record t__gen_slm_sampling_record;
#define d__gen_slm_sampling_record d__gen__gen_slm_sampling_record

/* line 51 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_multiplicit86160 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *lace_cond;
    t__int node_count;
    struct s__sn_rl__uint_rl *ids_range;
    struct s__l__int *new_solver_nodes_ids;
    t__sn__gen_solver_node_type var_type;
    struct s__sn_rl__scalar_rl *rl;
    t__int size_in_bits;
    struct s__sn_rl__scalar_rl *rl_soft_default_val;
    struct s__sn__gen_slm_mult_node_i87982 *iterator;
    struct s__sn__gen_sa_hierarchy_node *node;
    t__uint list_size_id;
    struct s__sn__any_rl *list_size_dmn;
} *t__sn__gen_slm_multiplicity_node;
#define d__sn__gen_slm_multiplicity_node 8249
typedef t__sn__gen_slm_multiplicity_node t__gen_slm_multiplicity_node;
#define d__gen_slm_multiplicity_node d__sn__gen_slm_multiplicity_node

/* line 861 "/vobs/specman/src/gen/gen_slm_index_iterator_imp.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_mult_node_i87982 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_rt_record *rt_record;
    struct s__l__sn_rl__uint_rl *size_list;
    struct s__l__sn_rl__uint_rl *static_size_list;
    struct s__l__sn__gen_path *lists_to_sample;
    struct s__sn__gen_path *prefix;
    struct s__gen__gen_sa_condition *condition;
    struct s__gen__gen_determinant_list *determinants;
    struct s__l__int *indices;
    t__bool not_started;
    t__int location;
    t__bool not_empty;
    struct s__l__sn__gen_slm_rl_iterator *rl_iterators;
    struct s__k__int__it *counter_ids;
    struct s__l__sn_rl__uint_rl *counter_rls;
    t__bool registered;
    t__bool freezed;
    struct s__l__int *const_ind;
    struct s__sn__gen_sa_cc_graph *orig_graph;
    t__bool use_virtual;
    struct s__sn__gen_slm_size_tree *size_tree;
    t__bool size_tree_initilized;
    t__bool size_tree_flag;
} *t__sn__gen_slm_mult_node_index_iterator;
#define d__sn__gen_slm_mult_node_index_iterator 8290
typedef t__sn__gen_slm_mult_node_index_iterator t__gen_slm_mult_node_index_iterator;
#define d__gen_slm_mult_node_index_iterator d__sn__gen_slm_mult_node_index_iterator

/* line 418 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_rl_iterator {
    t__int d__;
    t__int gen__;
    t__uint current_min;
    t__uint current_max;
    t__sn__index current_k;
    t__uint current_index;
    struct s__sn_rl__uint_rl *rl;
} *t__sn__gen_slm_rl_iterator;
#define d__sn__gen_slm_rl_iterator 6545
typedef t__sn__gen_slm_rl_iterator t__gen_slm_rl_iterator;
#define d__gen_slm_rl_iterator d__sn__gen_slm_rl_iterator

/* line 4 "/vobs/specman/src/gen/gen_slm_size_tree_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_size_tree {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_size_tree_node *root;
    t__uint depth;
} *t__sn__gen_slm_size_tree;
#define d__sn__gen_slm_size_tree 8267
typedef t__sn__gen_slm_size_tree t__gen_slm_size_tree;
#define d__gen_slm_size_tree d__sn__gen_slm_size_tree

/* line 23 "/vobs/specman/src/gen/gen_slm_size_tree_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_size_tree_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_size_tree_node *parent;
    struct s__l__sn__gen_slm_size_tre96958 *descendants;
    t__bool is_leaf;
    struct s__sn_rl__uint_rl *range;
    t__uint from_id;
    t__uint size;
} *t__sn__gen_slm_size_tree_node;
#define d__sn__gen_slm_size_tree_node 8268
typedef t__sn__gen_slm_size_tree_node t__gen_slm_size_tree_node;
#define d__gen_slm_size_tree_node d__sn__gen_slm_size_tree_node

/* line 1469 "/vobs/specman/src/gen/gen_rtm_manager_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_context_ref_manager {
    t__int d__;
    t__int gen__;
} *t__gen__gen_context_ref_manager;
#define d__gen__gen_context_ref_manager 8411
typedef t__gen__gen_context_ref_manager t__gen_context_ref_manager;
#define d__gen_context_ref_manager d__gen__gen_context_ref_manager

/* line 481 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_mm_manager {
    t__int d__;
    t__int gen__;
    struct s__l__gen__pgen_context_edge *pgen_ctx_edges;
    struct s__k__gen__gen_mm_parsing_56803 *parsing_rf_struct_hash_table;
    struct s__k__gen__gen_mm_rf_port_56799 *hash_ports_ancestor;
    struct s__k__gen__gen_mm_rf_struc56800 *rf_struct_constraint_list;
    struct s__l__gen__gen_mm_cmd *gen_cmd_list;
    t__uint uniqe_method_name;
    struct s__l__e_core__any_struct *curr_virtual_struct;
} *t__sn__gen_mm_manager;
#define d__sn__gen_mm_manager 2110
typedef t__sn__gen_mm_manager t__gen_mm_manager;
#define d__gen_mm_manager d__sn__gen_mm_manager

/* line 93 "/vobs/specman/src/gen/gen_determinant_hdr.e"  From 'struct definition' */
typedef struct s__gen__pgen_context_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path *from_path;
    struct s__sn__gen_path *to_path;
} *t__gen__pgen_context_edge;
#define d__gen__pgen_context_edge 6563
typedef t__gen__pgen_context_edge t__pgen_context_edge;
#define d__pgen_context_edge d__gen__pgen_context_edge

/* line 32 "/vobs/specman/src/gen/gen_mm_manager_parsing_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_mm_parsing_rf_56897 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct *a_struct;
    t__sn__parse_generator_t parsing_t;
} *t__gen__gen_mm_parsing_rf_struct_hash_struct;
#define d__gen__gen_mm_parsing_rf_struct_hash_struct 6644
typedef t__gen__gen_mm_parsing_rf_struct_hash_struct t__gen_mm_parsing_rf_struct_hash_struct;
#define d__gen_mm_parsing_rf_struct_hash_struct d__gen__gen_mm_parsing_rf_struct_hash_struct

/* line 114 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__gen_err_handler {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_context *contexts_stack;
    struct s__k__sn__gen_user_constra96794 *constraint_cashe;
} *t__sn__gen_err_handler;
#define d__sn__gen_err_handler 2107
typedef t__sn__gen_err_handler t__gen_err_handler;
#define d__gen_err_handler d__sn__gen_err_handler

/* line 461 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__g5_prof_info {
    t__int d__;
    t__int gen__;
    struct s__l__sn__index *context_id;
    t__sn__index cc_id;
    t__bool should_print_cc_constraints;
    t__source_ref gc_src_ref;
    t__uint backtracks;
} *t__sn__g5_prof_info;
#define d__sn__g5_prof_info 6553
typedef t__sn__g5_prof_info t__g5_prof_info;
#define d__g5_prof_info d__sn__g5_prof_info

/* line 22 "/vobs/specman/src/gen/gen_parser_parameter_factory.e"  From 'struct definition' */
typedef struct s__sn__gen_path_elements_f56801 {
    t__int d__;
    t__int gen__;
    t__uint li_cache_size;
    struct s__k__sn__gen_path_field_e56878 *field_element_l;
    struct s__k__sn__gen_path_attr_el56881 *attr_element_l;
    struct s__sn__gen_path_list_size_55023 *list_size_element;
    struct s__sn__gen_path_normal_bin55008 *path_normal_bind_element;
    struct s__sn__gen_path_external_b55012 *path_external_bind_element;
    struct s__sn__gen_path_undefined_55014 *path_undefined_bind_element;
    struct s__sn__gen_path_empty_bind55016 *path_empty_bind_element;
    struct s__l__sn__gen_path_temp_li56884 *temp_li_elements;
} *t__sn__gen_path_elements_factory;
#define d__sn__gen_path_elements_factory 6622
typedef t__sn__gen_path_elements_factory t__gen_path_elements_factory;
#define d__gen_path_elements_factory d__sn__gen_path_elements_factory

/* line 206 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_field_element {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_field *field;
} *t__sn__gen_path_field_element;
#define d__sn__gen_path_field_element 6420
typedef t__sn__gen_path_field_element t__gen_path_field_element;
#define d__gen_path_field_element d__sn__gen_path_field_element

/* line 312 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_attr_element {
    t__int d__;
    t__int gen__;
    t__string attr_name;
    struct s__sn__attr_handle *handle;
} *t__sn__gen_path_attr_element;
#define d__sn__gen_path_attr_element 6441
typedef t__sn__gen_path_attr_element t__gen_path_attr_element;
#define d__gen_path_attr_element d__sn__gen_path_attr_element

/* line 226 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_list_size_55023 {
    t__int d__;
    t__int gen__;
} *t__sn__gen_path_list_size_element;
#define d__sn__gen_path_list_size_element 6425
typedef t__sn__gen_path_list_size_element t__gen_path_list_size_element;
#define d__gen_path_list_size_element d__sn__gen_path_list_size_element

/* line 316 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_normal_bin55008 {
    t__int d__;
    t__int gen__;
} *t__sn__gen_path_normal_bind_element;
#define d__sn__gen_path_normal_bind_element 6442
typedef t__sn__gen_path_normal_bind_element t__gen_path_normal_bind_element;
#define d__gen_path_normal_bind_element d__sn__gen_path_normal_bind_element

/* line 320 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_external_b55012 {
    t__int d__;
    t__int gen__;
    t__bool info;
} *t__sn__gen_path_external_bind_element;
#define d__sn__gen_path_external_bind_element 6444
typedef t__sn__gen_path_external_bind_element t__gen_path_external_bind_element;
#define d__gen_path_external_bind_element d__sn__gen_path_external_bind_element

/* line 322 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_undefined_55014 {
    t__int d__;
    t__int gen__;
    t__bool info;
} *t__sn__gen_path_undefined_bind_element;
#define d__sn__gen_path_undefined_bind_element 6445
typedef t__sn__gen_path_undefined_bind_element t__gen_path_undefined_bind_element;
#define d__gen_path_undefined_bind_element d__sn__gen_path_undefined_bind_element

/* line 324 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_empty_bind55016 {
    t__int d__;
    t__int gen__;
    t__bool info;
} *t__sn__gen_path_empty_bind_element;
#define d__sn__gen_path_empty_bind_element 6446
typedef t__sn__gen_path_empty_bind_element t__gen_path_empty_bind_element;
#define d__gen_path_empty_bind_element d__sn__gen_path_empty_bind_element

/* line 259 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_temp_list_55027 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_type *item_type;
    t__sn__index id;
} *t__sn__gen_path_temp_list_index_element;
#define d__sn__gen_path_temp_list_index_element 6430
typedef t__sn__gen_path_temp_list_index_element t__gen_path_temp_list_index_element;
#define d__gen_path_temp_list_index_element d__sn__gen_path_temp_list_index_element

/* line 7 "/vobs/specman/src/gen/gen_command_header.e"  From 'struct definition' */
typedef struct s__sn__gen_cmd_manager {
    t__int d__;
    t__int gen__;
    t__bool constraint_monitoring_mode;
    t__bool constraint_monitoring_mode_ver;
} *t__sn__gen_cmd_manager;
#define d__sn__gen_cmd_manager 7962
typedef t__sn__gen_cmd_manager t__gen_cmd_manager;
#define d__gen_cmd_manager d__sn__gen_cmd_manager

/* line 2270 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_weak_map {
    t__int d__;
    t__int gen__;
    struct s__k__external_pointer__it *keys;
    struct s__l__external_pointer *shadowed_keys;
    t__bool updated_keys;
    struct s__l__e_core__base_struct *values;
} *t__e_core__sn_weak_map;
#define d__e_core__sn_weak_map 129
typedef t__e_core__sn_weak_map t__sn_weak_map;
#define d__sn_weak_map d__e_core__sn_weak_map

/* line 81 "/vobs/specman/src/gen/gen_slm_random_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_cc_seed_domain {
    t__int d__;
    t__int gen__;
} *t__sn__gen_cc_seed_domain;
#define d__sn__gen_cc_seed_domain 8078
typedef t__sn__gen_cc_seed_domain t__gen_cc_seed_domain;
#define d__gen_cc_seed_domain d__sn__gen_cc_seed_domain

/* line 28 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_debugger {
    t__int d__;
    t__int gen__;
    struct s__l__uint *EMPTY_UINT_LIST;
    struct s__l__gen_dbg__gen_dbg_variable *EMPTY_VAR_LIST;
    struct s__l__gen_dbg__gen_dbg_con93696 *EMPTY_CON_LIST;
    struct s__gen_dbg__gen_dbg_starti96797 *EMPTY_STARTING_POINT;
    struct s__gen_dbg__gen_dbg_instructor *instructor;
    struct s__l__bool *within_real_context;
    struct s__l__bool *within_static_phase;
    t__bool out_of_sync;
    struct s__l__gen_dbg__gen_dbg_context *contexts;
    struct s__l__gen_dbg__gen_dbg_context *static_contexts;
    struct s__k__gen_dbg__gen_dbg_reu96799 *reusable_ccs;
    struct s__k__gen_dbg__gen_dbg_reu96800 *reusable_ccs_without_solver;
    struct s__l__gen_dbg__gen_dbg_context *current_contexts;
    struct s__gen_dbg__gen_dbg_deduce96801 *a_general_dbg_suitcase;
    struct s__gen_dbg__gen_dbg_reusable_cc *cc_for_later;
    t__uint counter_4_inconsistency_lint;
    t__bool ctdoc;
    t__uint max_consec_rollbacks;
    struct s__gen_dbg__gen_dbg_event *the_broken_event;
    t__bool in_source_debugger;
    t__string dbgr_msg;
    t__bool hook_called;
    struct s__gen_dbg_gui__gen_dbg_gui *gen_dbg_gui;
    t__string ctx_to_open;
    t__uint ctx_id_to_open;
} *t__gen_dbg__gen_dbg_debugger;
#define d__gen_dbg__gen_dbg_debugger 7965
typedef t__gen_dbg__gen_dbg_debugger t__gen_dbg_debugger;
#define d__gen_dbg_debugger d__gen_dbg__gen_dbg_debugger

/* line 97 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_variable {
    t__int d__;
    t__int gen__;
    t__uint id;
    struct s__sn__any_rl *initial_range;
    struct s__gen_dbg__gen_dbg_cc *cc;
    t__bool is_idet;
    t__bool is_generic;
    struct s__l__gen_dbg__gen_dbg_cycle *all_cycles;
    void *_in_tree___ptr_padding[3];
    struct s__gen_dbg__gen_dbg_stree_node *in_tree;
} *t__gen_dbg__gen_dbg_variable;
#define d__gen_dbg__gen_dbg_variable 7971
typedef t__gen_dbg__gen_dbg_variable t__gen_dbg_variable;
#define d__gen_dbg_variable d__gen_dbg__gen_dbg_variable

/* line 75 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_cc {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_direct_cc_header *ref;
    struct s__gen_dbg__gen_dbg_context *context;
    struct s__l__gen_dbg__gen_dbg_variable *genvars;
    struct s__l__gen_dbg__gen_dbg_variable *inpvars;
    struct s__l__gen_dbg__gen_dbg_variable *determinants;
    struct s__l__gen_dbg__gen_dbg_con93696 *constraints;
    struct s__gen_dbg__gen_dbg_cc_stat *stat;
    struct s__gen_dbg__gen_dbg_solvin93615 *first_step;
    struct s__gen_dbg__gen_dbg_solvin93615 *last_step;
    t__string full_cc_prefix;
    t__uint runtime_id;
    struct s__l__uint *nonlace_indices;
    t__bool done;
    t__bool terminated;
    struct s__l__gen_dbg__gen_dbg_cycle *all_cycles;
    struct s__l__gen_dbg__gen_dbg_sim93780 *generic_vars;
    struct s__sn__gen_path *the_actual_prefix;
} *t__gen_dbg__gen_dbg_cc;
#define d__gen_dbg__gen_dbg_cc 7968
typedef t__gen_dbg__gen_dbg_cc t__gen_dbg_cc;
#define d__gen_dbg_cc d__gen_dbg__gen_dbg_cc

/* line 67 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_context {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_debugger *dbgr;
    struct s__sn__gen_context *ref;
    struct s__e_core__any_struct *holding_struct;
    struct s__reflection__rf_struct *holding_struct_type;
    struct s__l__gen_dbg__gen_dbg_cc *ccs;
    struct s__l__gen_dbg__gen_dbg_cc *static_ccs;
    struct s__gen_dbg__gen_dbg_context *holding_context;
    t__uint runtime_id;
    struct s__gen_dbg__gen_dbg_cc *current_cc;
    t__bool done;
    t__bool terminated;
    t__string err_msg;
    t__uint step_runtime_id_counter;
    t__bool is_idcfs_lint_ctx;
    struct s__gen_dbg__gen_dbg_stree *tree;
    struct s__gen_dbg__gen_dbg_listid96802 *listidx_factory;
    struct s__gen_dbg__gen_dbg_determ96803 *det_manager;
} *t__gen_dbg__gen_dbg_context;
#define d__gen_dbg__gen_dbg_context 7967
typedef t__gen_dbg__gen_dbg_context t__gen_dbg_context;
#define d__gen_dbg_context d__gen_dbg__gen_dbg_context

/* line 505 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_stree {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path_element *el;
    struct s__reflection__rf_field *rf;
    struct s__gen_dbg__gen_dbg_variable *db_var;
    struct s__k__gen_dbg__gen_dbg_str94202 *sons;
    t__gen_dbg__gen_dbg_stree_node_status_t status;
    struct s__gen_dbg__gen_dbg_context *ctx;
} *t__gen_dbg__gen_dbg_stree;
#define d__gen_dbg__gen_dbg_stree 8011
typedef t__gen_dbg__gen_dbg_stree t__gen_dbg_stree;
#define d__gen_dbg_stree d__gen_dbg__gen_dbg_stree

/* line 490 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_stree_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path_element *el;
    struct s__reflection__rf_field *rf;
    struct s__gen_dbg__gen_dbg_variable *db_var;
    struct s__k__gen_dbg__gen_dbg_str94202 *sons;
    t__gen_dbg__gen_dbg_stree_node_status_t status;
} *t__gen_dbg__gen_dbg_stree_node;
#define d__gen_dbg__gen_dbg_stree_node 8009
typedef t__gen_dbg__gen_dbg_stree_node t__gen_dbg_stree_node;
#define d__gen_dbg_stree_node d__gen_dbg__gen_dbg_stree_node

/* line 578 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_listid96802 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__gen_path_temp_li96829 *els;
} *t__gen_dbg__gen_dbg_listidx_factory;
#define d__gen_dbg__gen_dbg_listidx_factory 8017
typedef t__gen_dbg__gen_dbg_listidx_factory t__gen_dbg_listidx_factory;
#define d__gen_dbg_listidx_factory d__gen_dbg__gen_dbg_listidx_factory

/* line 537 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_determ96803 {
    t__int d__;
    t__int gen__;
    struct s__l__gen_dbg__gen_dbg_det96826 *dets;
    struct s__l__gen_dbg__gen_dbg_variable *inps;
} *t__gen_dbg__gen_dbg_determinant_manager;
#define d__gen_dbg__gen_dbg_determinant_manager 8013
typedef t__gen_dbg__gen_dbg_determinant_manager t__gen_dbg_determinant_manager;
#define d__gen_dbg_determinant_manager d__gen_dbg__gen_dbg_determinant_manager

/* line 530 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_determinant {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_variable *genvar;
    struct s__gen_dbg__gen_dbg_variable *inpvar;
} *t__gen_dbg__gen_dbg_determinant;
#define d__gen_dbg__gen_dbg_determinant 8012
typedef t__gen_dbg__gen_dbg_determinant t__gen_dbg_determinant;
#define d__gen_dbg_determinant d__gen_dbg__gen_dbg_determinant

/* line 82 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_constraint {
    t__int d__;
    t__int gen__;
    t__uint id;
    t__bool ignored;
    struct s__gen_dbg__gen_dbg_cc *cc;
} *t__gen_dbg__gen_dbg_constraint;
#define d__gen_dbg__gen_dbg_constraint 7969
typedef t__gen_dbg__gen_dbg_constraint t__gen_dbg_constraint;
#define d__gen_dbg_constraint d__gen_dbg__gen_dbg_constraint

/* line 204 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_solvin93615 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_solvin93615 *prev_step;
    struct s__gen_dbg__gen_dbg_solvin93615 *next_step;
    t__uint runtime_id;
} *t__gen_dbg__gen_dbg_solving_step;
#define d__gen_dbg__gen_dbg_solving_step 7982
typedef t__gen_dbg__gen_dbg_solving_step t__gen_dbg_solving_step;
#define d__gen_dbg_solving_step d__gen_dbg__gen_dbg_solving_step

/* line 154 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_cycle {
    t__int d__;
    t__int gen__;
    struct s__l__gen_dbg__gen_dbg_edge *edg_es;
} *t__gen_dbg__gen_dbg_cycle;
#define d__gen_dbg__gen_dbg_cycle 7979
typedef t__gen_dbg__gen_dbg_cycle t__gen_dbg_cycle;
#define d__gen_dbg_cycle d__gen_dbg__gen_dbg_cycle

/* line 147 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_edge *ref;
    struct s__gen_dbg__gen_dbg_cc *cc;
} *t__gen_dbg__gen_dbg_edge;
#define d__gen_dbg__gen_dbg_edge 7978
typedef t__gen_dbg__gen_dbg_edge t__gen_dbg_edge;
#define d__gen_dbg_edge d__gen_dbg__gen_dbg_edge

/* line 451 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_edge {
    t__int d__;
    t__int gen__;
    t__uint from_var;
    t__uint to_var;
    struct s__l__sn__gen_edge_t *typ_es;
    struct s__l__uint *constraints;
    t__uint input;
    struct s__sn__gen_path *post_gen_determinant;
    struct s__sn__gen_user_constraint *user_constraint;
} *t__sn__gen_sa_edge;
#define d__sn__gen_sa_edge 6550
typedef t__sn__gen_sa_edge t__gen_sa_edge;
#define d__gen_sa_edge d__sn__gen_sa_edge

/* line 126 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_simple93530 {
    t__int d__;
    t__int gen__;
    t__uint id;
    struct s__sn__any_rl *initial_range;
    struct s__gen_dbg__gen_dbg_cc *cc;
    t__bool is_idet;
    t__bool is_generic;
    struct s__l__gen_dbg__gen_dbg_cycle *all_cycles;
    void *_in_tree___ptr_padding[3];
    struct s__gen_dbg__gen_dbg_stree_node *in_tree;
} *t__gen_dbg__gen_dbg_simple_variable;
#define d__gen_dbg__gen_dbg_simple_variable 7975
typedef t__gen_dbg__gen_dbg_simple_variable t__gen_dbg_simple_variable;
#define d__gen_dbg_simple_variable d__gen_dbg__gen_dbg_simple_variable

/* line 571 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_starti96797 {
    t__int d__;
    t__int gen__;
    struct s__l__gen_dbg__gen_dbg_con93696 *bad_constrs;
    struct s__l__gen_dbg__gen_dbg_variable *bad_vars;
    t__bool dont_recycle;
} *t__gen_dbg__gen_dbg_starting_point;
#define d__gen_dbg__gen_dbg_starting_point 8015
typedef t__gen_dbg__gen_dbg_starting_point t__gen_dbg_starting_point;
#define d__gen_dbg_starting_point d__gen_dbg__gen_dbg_starting_point

/* line 36 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_instructor {
    t__int d__;
    t__int gen__;
    struct s__l__sn__on_request *bps;
    struct s__l__int *break_cause;
    t__bool after_gstep;
    t__bool after_gnext;
    t__bool after_gfin;
    t__bool gstep_triggered;
    t__bool gnext_triggered;
    t__bool gfin_triggered;
    t__int g_thread;
    t__gen_dbg__gcommand_state current_gcommand_state;
    t__gen_dbg__gcommand_state expected_gcommand_state;
    t__uint depth_at_gcommand;
    struct s__l__uint *ctxts_stack;
    struct s__l__uint *ccs_stack;
    struct s__l__bool *collecting_ctx;
    struct s__l__bool *collecting_cc;
    struct s__l__bool *in_visible_cc_stack;
    t__bool collecting_static_cc;
    struct s__l__bool *continue_issued;
    t__uint continued_ctx;
} *t__gen_dbg__gen_dbg_instructor;
#define d__gen_dbg__gen_dbg_instructor 7966
typedef t__gen_dbg__gen_dbg_instructor t__gen_dbg_instructor;
#define d__gen_dbg_instructor d__gen_dbg__gen_dbg_instructor

/* line 560 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_reusable_cc {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_cc_solver *solver;
    struct s__sn__gen_sa_direct_cc_header *cc;
    struct s__gen_dbg__gen_dbg_cc *dbg_cc;
    struct s__l__gen_dbg__gen_dbg_red96827 *reductions;
    struct s__l__uint *ignored_cons;
} *t__gen_dbg__gen_dbg_reusable_cc;
#define d__gen_dbg__gen_dbg_reusable_cc 8014
typedef t__gen_dbg__gen_dbg_reusable_cc t__gen_dbg_reusable_cc;
#define d__gen_dbg_reusable_cc d__gen_dbg__gen_dbg_reusable_cc

/* line 376 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_reduct93259 {
    t__int d__;
    t__int gen__;
    t__bool should_be_collected;
    t__bool should_break;
    t__bool only_trace;
    struct s__l__uint *constraints;
    struct s__l__uint *nodes;
    struct s__l__sn__any_rl *new_ranges;
    struct s__l__uint *canceled_softs;
    t__bool status;
    t__bool f__static;
    struct s__l__uint *failed_cons;
    struct s__l__uint *failed_nodes;
    struct s__gen_dbg__gen_dbg_reduct93572 *dbg_reduction;
} *t__gen_dbg__gen_dbg_reduction_event;
#define d__gen_dbg__gen_dbg_reduction_event 7997
typedef t__gen_dbg__gen_dbg_reduction_event t__gen_dbg_reduction_event;
#define d__gen_dbg_reduction_event d__gen_dbg__gen_dbg_reduction_event

/* line 213 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_reduct93572 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_solvin93615 *prev_step;
    struct s__gen_dbg__gen_dbg_solvin93615 *next_step;
    t__uint runtime_id;
    struct s__gen_dbg__gen_dbg_cc *cc;
    struct s__l__gen_dbg__gen_dbg_con93696 *constraints;
    struct s__l__gen_dbg__gen_dbg_variable *variables;
    struct s__l__sn__any_rl *new_ranges;
    struct s__l__gen_dbg__gen_dbg_variable *other_involved_variables;
    struct s__l__sn__any_rl *other_involved_ranges;
    struct s__l__uint *sampled_inputs;
    t__bool f__static;
    struct s__gen_dbg__gen_dbg_starti96797 *sp;
} *t__gen_dbg__gen_dbg_reduction_solving_step;
#define d__gen_dbg__gen_dbg_reduction_solving_step 7983
typedef t__gen_dbg__gen_dbg_reduction_solving_step t__gen_dbg_reduction_solving_step;
#define d__gen_dbg_reduction_solving_step d__gen_dbg__gen_dbg_reduction_solving_step

/* line 90 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_deduce96801 {
    t__int d__;
    t__int gen__;
    t__uint id;
    t__bool ignored;
    struct s__gen_dbg__gen_dbg_cc *cc;
} *t__gen_dbg__gen_dbg_deduced_constraint;
#define d__gen_dbg__gen_dbg_deduced_constraint 7970
typedef t__gen_dbg__gen_dbg_deduced_constraint t__gen_dbg_deduced_constraint;
#define d__gen_dbg_deduced_constraint d__gen_dbg__gen_dbg_deduced_constraint

/* line 330 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_event {
    t__int d__;
    t__int gen__;
    t__bool should_be_collected;
    t__bool should_break;
    t__bool only_trace;
} *t__gen_dbg__gen_dbg_event;
#define d__gen_dbg__gen_dbg_event 7991
typedef t__gen_dbg__gen_dbg_event t__gen_dbg_event;
#define d__gen_dbg_event d__gen_dbg__gen_dbg_event

/* line 9 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_gui {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_lnf_props *normal_row;
    struct s__vt__vt_lnf_props *gen_var_highlight_row;
    struct s__vt__vt_lnf_props *det_var_highlight_row;
    struct s__vt__vt_lnf_props *idet_var_highlight_row;
    struct s__vt__vt_lnf_props *input_var_highlight_row;
    struct s__vt__vt_lnf_props *const_highlight_row;
    struct s__gen_dbg_gui__gen_dbg_window *dbgr_main_window;
    struct s__gen_dbg_gui__gen_dbg_co97219 *dbgr_action_select_window;
    t__bool as_good_as_closed;
} *t__gen_dbg_gui__gen_dbg_gui;
#define d__gen_dbg_gui__gen_dbg_gui 8735
typedef t__gen_dbg_gui__gen_dbg_gui t__gen_dbg_gui;
#define d__gen_dbg_gui d__gen_dbg_gui__gen_dbg_gui

/* line 16 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_window {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    t__string m_title;
    t__vt__vtx_element_state m_state;
    struct s__vt__vt_size *m_requested_size;
    struct s__vt__vt_location *m_requested_location;
    t__string m_window_kind;
    struct s__l__vt__vtx_action *m_actions;
    struct s__vt__vtx_component *m_primary_pane;
    struct s__vt__vtx_component *m_secondary_pane1;
    struct s__vt__vtx_component *m_secondary_pane2;
    struct s__vt__vtx_combobox *m_top_combobox;
    struct s__vt__vtx_component *m_window_header;
    struct s__vt__sni_vtx_jbase_window *j_me;
    struct s__vt__vtx_snorb_window_ac39957 *m_actual_attributes;
    struct s__vt__vtx_window_sni_helper *m_sni_helper;
    t__vt__vtx_window_layout_style m_window_layout_style;
    t__int m_primary_pane_ratio;
    t__int m_secondary1_pane_ratio;
    t__int m_primary_divider_location;
    t__int m_secondary_divider_location;
    struct s__vt__vtx_selectable_widget *m_selection_owner;
    struct s__k__string__it *m_initially_disabled_action_names;
    t__bool m_is_always_on_top;
    t__bool m_using_dnd;
    t__bool m_lockable;
    t__bool m_locked;
    struct s__vt__vt_statusbar *m_status_bar;
    struct s__gen_dbg_gui__gen_dbg_pr97220 *process_tree;
    struct s__gen_dbg_gui__gen_dbg_st97222 *structure_tree;
    struct s__gen_dbg_gui__gen_dbg_ma97223 *header_panel;
    struct s__gen_dbg_gui__gen_dbg_ta97225 *tables_panel;
    struct s__gen_dbg_gui__gen_dbg_de97228 *details_panel;
    struct s__l__gen_dbg_gui__gen_dbg97231 *main_components;
    struct s__gen_dbg__gen_dbg_variable *from_show_step_var;
    struct s__l__gen_dbg__gen_dbg_struct *back_pointers;
    struct s__l__gen_dbg__gen_dbg_struct *forward_pointers;
} *t__gen_dbg_gui__gen_dbg_window;
#define d__gen_dbg_gui__gen_dbg_window 8736
typedef t__gen_dbg_gui__gen_dbg_window t__gen_dbg_window;
#define d__gen_dbg_window d__gen_dbg_gui__gen_dbg_window

/* line 38 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_pr97220 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_tree *the_tree;
    struct s__gen_dbg_gui__gen_dbg_tr97221 *the_header;
    struct s__gen_dbg_gui__gen_dbg_tr94971 *the_root;
} *t__gen_dbg_gui__gen_dbg_process_tree_panel;
#define d__gen_dbg_gui__gen_dbg_process_tree_panel 8742
typedef t__gen_dbg_gui__gen_dbg_process_tree_panel t__gen_dbg_process_tree_panel;
#define d__gen_dbg_process_tree_panel d__gen_dbg_gui__gen_dbg_process_tree_panel

/* line 1169 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_tree {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__string *m_default_popup_action_names;
    t__string m_title;
    t__bool m_initial_expand_all;
    t__string m_most_common_action_name;
    t__int m_max_bars;
    t__int m_max_icons;
    t__bool m_is_bar_first;
    struct s__vt__vtx_tree_node *m_root;
    struct s__vt__vtx_snorb_tree_node *m_snorb_root;
    t__bool m_shows_root;
    t__bool m_shows_root_handles;
    struct s__vt__vtx_tree_node *m_selected_node;
    t__bool m_dirty_nodes_visibility;
    struct s__vt__sni_vtx_jtree *j_me;
} *t__vt__vtx_tree;
#define d__vt__vtx_tree 5166
typedef t__vt__vtx_tree t__vtx_tree;
#define d__vtx_tree d__vt__vtx_tree

/* line 1060 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_tree_node {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__l__vt__vtx_tree_node *p___children;
    t__bool p___children_prepared;
    t__bool p___children_collected;
    struct s__vt__vtx_tree_node *p___parent;
    t__int p___index_in_parent;
    t__string p___text;
    t__string p___id;
    struct s__vt__vt_lnf_props *p___lnf;
    struct s__l__string *p___icons;
    struct s__l__vt__vtx_bar_data *p___bars;
    struct s__vt__vtx_pie_data *p___pie;
    struct s__l__string *p___popup_action_names;
    struct s__l__string *p___actions_to_disable;
    t__int p___child_count;
    t__bool p___visible;
    t__uint p___lazy_ready_bits;
    t__string p___id_set;
    t__string p___tooltip;
} *t__vt__vtx_tree_node;
#define d__vt__vtx_tree_node 5162
typedef t__vt__vtx_tree_node t__vtx_tree_node;
#define d__vtx_tree_node d__vt__vtx_tree_node

/* line 1051 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_bar_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__vt__vt_color fg;
    t__vt__vt_color bg;
    t__vt__vt_font_kind font_kind;
    t__string tooltip;
    t__string text;
    t__bool has_border;
    t__int width;
    t__int height;
    t__vt__vt_font_size font_size;
    t__vt__vt_color bar_fg;
    t__vt__vt_color bar_bg;
    t__int value;
    t__int milli_value;
    t__vt__vtx_bar_format format;
    t__int percision;
    t__int spacing;
    t__string icon;
    t__int icon_x;
    t__int icon_y;
} *t__vt__vtx_bar_data;
#define d__vt__vtx_bar_data 5159
typedef t__vt__vtx_bar_data t__vtx_bar_data;
#define d__vtx_bar_data d__vt__vtx_bar_data

/* line 1057 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_pie_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__vt__vtx_pie_slice *slices;
    t__string image;
    t__vt__vt_color background_color;
    t__string tooltip;
    t__bool is_pie;
    t__int sort_value;
} *t__vt__vtx_pie_data;
#define d__vt__vtx_pie_data 5161
typedef t__vt__vtx_pie_data t__vtx_pie_data;
#define d__vtx_pie_data d__vt__vtx_pie_data

/* line 1054 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_pie_slice {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int value;
    t__vt__vt_color color;
    t__string text;
    t__vt__vt_color text_color;
    t__vt__vt_color text_selected_color;
    t__bool bold;
} *t__vt__vtx_pie_slice;
#define d__vt__vtx_pie_slice 5160
typedef t__vt__vtx_pie_slice t__vtx_pie_slice;
#define d__vtx_pie_slice d__vt__vtx_pie_slice

/* line 1166 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_snorb_tree_node {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string snid;
    t__string text;
    struct s__vt__vt_lnf_props *lnf_props;
    struct s__l__string *actions_to_disable;
    struct s__l__string *popup_action_names;
    struct s__l__string *icons;
    struct s__l__vt__vtx_bar_data *bars;
    struct s__vt__vtx_pie_data *pie;
    struct s__l__vt__vtx_snorb_tree_node *children;
    t__bool children_ready;
    t__int child_count;
    t__string tooltip;
} *t__vt__vtx_snorb_tree_node;
#define d__vt__vtx_snorb_tree_node 5165
typedef t__vt__vtx_snorb_tree_node t__vtx_snorb_tree_node;
#define d__vtx_snorb_tree_node d__vt__vtx_snorb_tree_node

/* line 1160 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jtree {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jtree;
#define d__vt__sni_vtx_jtree 5163
typedef t__vt__sni_vtx_jtree t__sni_vtx_jtree;
#define d__sni_vtx_jtree d__vt__sni_vtx_jtree

/* line 49 "/vobs/specman/src/gen/gen_dbg_gui_tree.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_tr97221 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_label *the_label;
    struct s__vt__vtx_button *the_button;
} *t__gen_dbg_gui__gen_dbg_tree_header;
#define d__gen_dbg_gui__gen_dbg_tree_header 8761
typedef t__gen_dbg_gui__gen_dbg_tree_header t__gen_dbg_tree_header;
#define d__gen_dbg_tree_header d__gen_dbg_gui__gen_dbg_tree_header

/* line 927 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_label {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__vt__sni_vtx_jtextfield *j_me;
    t__bool m_editable;
    t__string m_text;
    t__bool m_using_key_listener;
    t__string m_icon_name;
    t__vt__vtx_align_kind m_horizontal_text_position;
    t__vt__vtx_align_kind m_vertical_text_position;
} *t__vt__vtx_label;
#define d__vt__vtx_label 5148
typedef t__vt__vtx_label t__vtx_label;
#define d__vtx_label d__vt__vtx_label

/* line 707 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_button {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    t__string m_text;
    struct s__vt__sni_vtx_jbutton *j_me;
    t__vt__vtx_align_kind m_horizontal_text_position;
    t__vt__vtx_align_kind m_vertical_text_position;
    struct s__vt__vtx_button_group *m_group;
    t__string m_icon;
    t__string m_rollover_icon;
} *t__vt__vtx_button;
#define d__vt__vtx_button 5135
typedef t__vt__vtx_button t__vtx_button;
#define d__vtx_button d__vt__vtx_button

/* line 651 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jbutton {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jbutton;
#define d__vt__sni_vtx_jbutton 5129
typedef t__vt__sni_vtx_jbutton t__sni_vtx_jbutton;
#define d__sni_vtx_jbutton d__vt__sni_vtx_jbutton

/* line 574 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_button_group {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    t__string m_group_id;
    struct s__vt__vtx_base_button *m_selected_button;
    struct s__l__vt__vtx_base_button *m_buttons;
} *t__vt__vtx_button_group;
#define d__vt__vtx_button_group 5124
typedef t__vt__vtx_button_group t__vtx_button_group;
#define d__vtx_button_group d__vt__vtx_button_group

/* line 654 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_base_button {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    t__string m_text;
    struct s__vt__sni_vtx_jbutton *j_me;
    t__vt__vtx_align_kind m_horizontal_text_position;
    t__vt__vtx_align_kind m_vertical_text_position;
    struct s__vt__vtx_button_group *m_group;
} *t__vt__vtx_base_button;
#define d__vt__vtx_base_button 5130
typedef t__vt__vtx_base_button t__vtx_base_button;
#define d__vtx_base_button d__vt__vtx_base_button

/* line 180 "/vobs/specman/src/gen/gen_dbg_gui_tree.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_tr94971 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__l__vt__vtx_tree_node *p___children;
    t__bool p___children_prepared;
    t__bool p___children_collected;
    struct s__vt__vtx_tree_node *p___parent;
    t__int p___index_in_parent;
    t__string p___text;
    t__string p___id;
    struct s__vt__vt_lnf_props *p___lnf;
    struct s__l__string *p___icons;
    struct s__l__vt__vtx_bar_data *p___bars;
    struct s__vt__vtx_pie_data *p___pie;
    struct s__l__string *p___popup_action_names;
    struct s__l__string *p___actions_to_disable;
    t__int p___child_count;
    t__bool p___visible;
    t__uint p___lazy_ready_bits;
    t__string p___id_set;
    t__string p___tooltip;
} *t__gen_dbg_gui__gen_dbg_tree_node;
#define d__gen_dbg_gui__gen_dbg_tree_node 8762
typedef t__gen_dbg_gui__gen_dbg_tree_node t__gen_dbg_tree_node;
#define d__gen_dbg_tree_node d__gen_dbg_gui__gen_dbg_tree_node

/* line 41 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_st97222 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_tree *the_tree;
    struct s__gen_dbg_gui__gen_dbg_tr97221 *the_header;
    struct s__gen_dbg_gui__gen_dbg_tr94971 *the_root;
    t__bool show_vals;
} *t__gen_dbg_gui__gen_dbg_struct_tree_panel;
#define d__gen_dbg_gui__gen_dbg_struct_tree_panel 8743
typedef t__gen_dbg_gui__gen_dbg_struct_tree_panel t__gen_dbg_struct_tree_panel;
#define d__gen_dbg_struct_tree_panel d__gen_dbg_gui__gen_dbg_struct_tree_panel

/* line 47 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_ma97223 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__gen_dbg_gui__gen_dbg_ht97224 *the_text;
    struct s__vt__vtx_label *the_icon;
} *t__gen_dbg_gui__gen_dbg_main_header_panel;
#define d__gen_dbg_gui__gen_dbg_main_header_panel 8745
typedef t__gen_dbg_gui__gen_dbg_main_header_panel t__gen_dbg_main_header_panel;
#define d__gen_dbg_main_header_panel d__gen_dbg_gui__gen_dbg_main_header_panel

/* line 43 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_ht97224 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_html_viewer *the_text;
} *t__gen_dbg_gui__gen_dbg_html_panel;
#define d__gen_dbg_gui__gen_dbg_html_panel 8744
typedef t__gen_dbg_gui__gen_dbg_html_panel t__gen_dbg_html_panel;
#define d__gen_dbg_html_panel d__gen_dbg_gui__gen_dbg_html_panel

/* line 743 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_html_viewer {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__string *m_html;
    struct s__vt__sni_vtx_jhtml_viewer *j_me;
} *t__vt__vtx_html_viewer;
#define d__vt__vtx_html_viewer 5139
typedef t__vt__vtx_html_viewer t__vtx_html_viewer;
#define d__vtx_html_viewer d__vt__vtx_html_viewer

/* line 740 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jhtml_viewer {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jhtml_viewer;
#define d__vt__sni_vtx_jhtml_viewer 5138
typedef t__vt__sni_vtx_jhtml_viewer t__sni_vtx_jhtml_viewer;
#define d__sni_vtx_jhtml_viewer d__vt__sni_vtx_jhtml_viewer

/* line 33 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_ta97225 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__gen_dbg_gui__gen_dbg_no97226 *the_normal_panel;
    struct s__gen_dbg_gui__gen_dbg_id97227 *the_idcfs_panel;
    struct s__vt__vtx_changer *the_changer;
} *t__gen_dbg_gui__gen_dbg_tables_panel;
#define d__gen_dbg_gui__gen_dbg_tables_panel 8738
typedef t__gen_dbg_gui__gen_dbg_tables_panel t__gen_dbg_tables_panel;
#define d__gen_dbg_tables_panel d__gen_dbg_gui__gen_dbg_tables_panel

/* line 121 "/vobs/specman/src/gen/gen_dbg_gui_table.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_no97226 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_splitter *the_splitter;
    struct s__gen_dbg_gui__gen_dbg_va97235 *vars_table;
    struct s__gen_dbg_gui__gen_dbg_co97236 *const_table;
} *t__gen_dbg_gui__gen_dbg_normal_tables_panel;
#define d__gen_dbg_gui__gen_dbg_normal_tables_panel 8748
typedef t__gen_dbg_gui__gen_dbg_normal_tables_panel t__gen_dbg_normal_tables_panel;
#define d__gen_dbg_normal_tables_panel d__gen_dbg_gui__gen_dbg_normal_tables_panel

/* line 388 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_splitter {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    t__int m_first_pane_ratio;
    t__vt__vtx_orientation m_orientation;
    struct s__vt__vtx_component *m_first_pane;
    struct s__vt__vtx_component *m_second_pane;
    t__int m_divider_location;
    t__int m_divider_width;
    struct s__vt__sni_vtx_jsplitter *j_me;
} *t__vt__vtx_splitter;
#define d__vt__vtx_splitter 5116
typedef t__vt__vtx_splitter t__vtx_splitter;
#define d__vtx_splitter d__vt__vtx_splitter

/* line 385 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jsplitter {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jsplitter;
#define d__vt__sni_vtx_jsplitter 5115
typedef t__vt__sni_vtx_jsplitter t__sni_vtx_jsplitter;
#define d__sni_vtx_jsplitter d__vt__sni_vtx_jsplitter

/* line 458 "/vobs/specman/src/gen/gen_dbg_gui_table.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_va97235 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_table *the_table;
    struct s__vt__vtx_panel *the_table_panel;
    struct s__vt__vtx_label *the_header;
    struct s__vt__vtx_panel *the_header_panel;
    struct s__l__vt__vtx_table_row *rows;
    struct s__vt__vtx_changer *the_changer;
    t__bool is_step_table;
    struct s__vt__vtx_table *the_step_table;
    struct s__vt__vtx_table *the_other_table;
} *t__gen_dbg_gui__gen_dbg_vars_table_panel;
#define d__gen_dbg_gui__gen_dbg_vars_table_panel 8753
typedef t__gen_dbg_gui__gen_dbg_vars_table_panel t__gen_dbg_vars_table_panel;
#define d__gen_dbg_vars_table_panel d__gen_dbg_gui__gen_dbg_vars_table_panel

/* line 509 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_changer {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    struct s__vt__vtx_component *m_current_component;
    t__int m_index;
    struct s__vt__sni_vtx_jpanel *j_me;
} *t__vt__vtx_changer;
#define d__vt__vtx_changer 5121
typedef t__vt__vtx_changer t__vtx_changer;
#define d__vtx_changer d__vt__vtx_changer

/* line 793 "/vobs/specman/src/gen/gen_dbg_gui_table.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_co97236 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_table *the_table;
    struct s__vt__vtx_panel *the_table_panel;
    struct s__vt__vtx_label *the_header;
    struct s__vt__vtx_panel *the_header_panel;
    struct s__l__vt__vtx_table_row *rows;
    struct s__vt__vtx_button_group *bar_const_button_group;
    struct s__vt__vtx_radio_button *bar_const_radiobutton1;
    struct s__vt__vtx_radio_button *bar_const_radiobutton2;
} *t__gen_dbg_gui__gen_dbg_const_table_panel;
#define d__gen_dbg_gui__gen_dbg_const_table_panel 8755
typedef t__gen_dbg_gui__gen_dbg_const_table_panel t__gen_dbg_const_table_panel;
#define d__gen_dbg_const_table_panel d__gen_dbg_gui__gen_dbg_const_table_panel

/* line 701 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_radio_button {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    t__string m_text;
    struct s__vt__sni_vtx_jbutton *j_me;
    t__vt__vtx_align_kind m_horizontal_text_position;
    t__vt__vtx_align_kind m_vertical_text_position;
    struct s__vt__vtx_button_group *m_group;
    t__bool m_selected;
} *t__vt__vtx_radio_button;
#define d__vt__vtx_radio_button 5134
typedef t__vt__vtx_radio_button t__vtx_radio_button;
#define d__vtx_radio_button d__vt__vtx_radio_button

/* line 173 "/vobs/specman/src/gen/gen_dbg_gui_table.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_id97227 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_splitter *the_splitter;
    struct s__vt__vtx_changer *the_changer;
    struct s__gen_dbg__gen_dbg_cc *pointer;
    struct s__gen_dbg_gui__gen_dbg_no97226 *the_normal_view;
    struct s__gen_dbg_gui__gen_dbg_cy97237 *the_cycles_view;
    struct s__vt__vtx_button_group *bar_button_group;
    struct s__vt__vtx_toggle_button *bar_togglebutton1;
    struct s__vt__vtx_toggle_button *bar_togglebutton2;
    struct s__vt__vtx_radio_button *bar_radiobutton1;
    struct s__vt__vtx_radio_button *bar_radiobutton2;
} *t__gen_dbg_gui__gen_dbg_idcfs_tables_panel;
#define d__gen_dbg_gui__gen_dbg_idcfs_tables_panel 8749
typedef t__gen_dbg_gui__gen_dbg_idcfs_tables_panel t__gen_dbg_idcfs_tables_panel;
#define d__gen_dbg_idcfs_tables_panel d__gen_dbg_gui__gen_dbg_idcfs_tables_panel

/* line 339 "/vobs/specman/src/gen/gen_dbg_gui_table.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_cy97237 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__gen_dbg_gui__gen_dbg_cy97238 *cycles_list_table;
    struct s__gen_dbg_gui__gen_dbg_cy97239 *cycle_table;
    struct s__vt__vtx_splitter *the_splitter;
} *t__gen_dbg_gui__gen_dbg_cycles_tables_panel;
#define d__gen_dbg_gui__gen_dbg_cycles_tables_panel 8750
typedef t__gen_dbg_gui__gen_dbg_cycles_tables_panel t__gen_dbg_cycles_tables_panel;
#define d__gen_dbg_cycles_tables_panel d__gen_dbg_gui__gen_dbg_cycles_tables_panel

/* line 1225 "/vobs/specman/src/gen/gen_dbg_gui_table.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_cy97238 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_table *the_table;
    struct s__vt__vtx_panel *the_table_panel;
    struct s__vt__vtx_label *the_header;
    struct s__vt__vtx_panel *the_header_panel;
    struct s__l__vt__vtx_table_row *rows;
} *t__gen_dbg_gui__gen_dbg_cycles_list_table_panel;
#define d__gen_dbg_gui__gen_dbg_cycles_list_table_panel 8757
typedef t__gen_dbg_gui__gen_dbg_cycles_list_table_panel t__gen_dbg_cycles_list_table_panel;
#define d__gen_dbg_cycles_list_table_panel d__gen_dbg_gui__gen_dbg_cycles_list_table_panel

/* line 1268 "/vobs/specman/src/gen/gen_dbg_gui_table.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_cy97239 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__vt__vtx_table *the_table;
    struct s__vt__vtx_panel *the_table_panel;
    struct s__vt__vtx_label *the_header;
    struct s__vt__vtx_panel *the_header_panel;
    struct s__l__vt__vtx_table_row *rows;
} *t__gen_dbg_gui__gen_dbg_cycle_table_panel;
#define d__gen_dbg_gui__gen_dbg_cycle_table_panel 8759
typedef t__gen_dbg_gui__gen_dbg_cycle_table_panel t__gen_dbg_cycle_table_panel;
#define d__gen_dbg_cycle_table_panel d__gen_dbg_gui__gen_dbg_cycle_table_panel

/* line 678 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_toggle_button {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    t__string m_text;
    struct s__vt__sni_vtx_jbutton *j_me;
    t__vt__vtx_align_kind m_horizontal_text_position;
    t__vt__vtx_align_kind m_vertical_text_position;
    struct s__vt__vtx_button_group *m_group;
    t__bool m_checked;
    t__string m_icon;
    t__string m_selected_icon;
    t__string m_rollover_icon;
} *t__vt__vtx_toggle_button;
#define d__vt__vtx_toggle_button 5132
typedef t__vt__vtx_toggle_button t__vtx_toggle_button;
#define d__vtx_toggle_button d__vt__vtx_toggle_button

/* line 36 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_de97228 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__gen_dbg_gui__gen_dbg_de95181 *current_panel;
    struct s__l__gen_dbg_gui__gen_dbg97230 *the_panels;
    struct s__vt__vtx_changer *the_changer;
} *t__gen_dbg_gui__gen_dbg_details_panel;
#define d__gen_dbg_gui__gen_dbg_details_panel 8741
typedef t__gen_dbg_gui__gen_dbg_details_panel t__gen_dbg_details_panel;
#define d__gen_dbg_details_panel d__gen_dbg_gui__gen_dbg_details_panel

/* line 74 "/vobs/specman/src/gen/gen_dbg_gui_details.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_de95181 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__gen_dbg_gui__gen_dbg_de97234 *the_header;
    struct s__vt__vtx_tabctrl *the_tab;
    struct s__l__gen_dbg_gui__gen_dbg97261 *the_tabs;
} *t__gen_dbg_gui__gen_dbg_details_changer_panel;
#define d__gen_dbg_gui__gen_dbg_details_changer_panel 8777
typedef t__gen_dbg_gui__gen_dbg_details_changer_panel t__gen_dbg_details_changer_panel;
#define d__gen_dbg_details_changer_panel d__gen_dbg_gui__gen_dbg_details_changer_panel

/* line 48 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_de97234 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
    struct s__gen_dbg_gui__gen_dbg_ht97224 *the_text;
    struct s__vt__vtx_label *the_icon;
} *t__gen_dbg_gui__gen_dbg_details_header_panel;
#define d__gen_dbg_gui__gen_dbg_details_header_panel 8746
typedef t__gen_dbg_gui__gen_dbg_details_header_panel t__gen_dbg_details_header_panel;
#define d__gen_dbg_details_header_panel d__gen_dbg_gui__gen_dbg_details_header_panel

/* line 291 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_tabctrl {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__k__vt__vtx_tab__m_id *m_tabs;
    t__int m_selected_tab_index;
    t__vt__vtx_tab_position m_tab_position;
    t__bool m_using_scroll_tab_layout;
    struct s__vt__sni_vtx_jtabctrl *j_me;
} *t__vt__vtx_tabctrl;
#define d__vt__vtx_tabctrl 5112
typedef t__vt__vtx_tabctrl t__vtx_tabctrl;
#define d__vtx_tabctrl d__vt__vtx_tabctrl

/* line 339 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_tab {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    t__string m_title;
    t__string m_icon;
    t__int m_tab_index;
    struct s__vt__vtx_component *m_content;
    struct s__vt__vtx_tabctrl *m_tabctrl;
    struct s__vt__sni_vtx_jtab *j_me;
} *t__vt__vtx_tab;
#define d__vt__vtx_tab 5114
typedef t__vt__vtx_tab t__vtx_tab;
#define d__vtx_tab d__vt__vtx_tab

/* line 336 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jtab {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jtab;
#define d__vt__sni_vtx_jtab 5113
typedef t__vt__sni_vtx_jtab t__sni_vtx_jtab;
#define d__sni_vtx_jtab d__vt__sni_vtx_jtab

/* line 288 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jtabctrl {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jtabctrl;
#define d__vt__sni_vtx_jtabctrl 5111
typedef t__vt__sni_vtx_jtabctrl t__sni_vtx_jtabctrl;
#define d__sni_vtx_jtabctrl d__vt__sni_vtx_jtabctrl

/* line 239 "/vobs/specman/src/gen/gen_dbg_gui_details.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_de97262 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
} *t__gen_dbg_gui__gen_dbg_details_tab;
#define d__gen_dbg_gui__gen_dbg_details_tab 8782
typedef t__gen_dbg_gui__gen_dbg_details_tab t__gen_dbg_details_tab;
#define d__gen_dbg_details_tab d__gen_dbg_gui__gen_dbg_details_tab

/* line 27 "/vobs/specman/src/gen/gen_dbg_gui_hdr.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_panel {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    struct s__vt__vtx_base_window *m_window;
    t__bool m_closed;
    t__vt__vtx_selection_state m_selection_state;
    t__vt__vt_color m_bg;
    t__vt__vt_color m_fg;
    t__vt__vtx_border_kind m_border_kind;
    t__int m_border_width;
    t__vt__vt_color m_border_color;
    t__string m_border_title;
    t__int m_font_size;
    t__vt__vt_font_kind m_font_kind;
    t__bool m_enabled;
    t__string m_tooltip;
    t__int m_width;
    t__int m_height;
    t__vt__vtx_expandable_mode m_vertical_expandable;
    t__vt__vtx_expandable_mode m_horizontal_expandable;
    struct s__vt__vtx_container *m_container;
    struct s__l__vt__vtx_component *m_components;
    t__vt__vtx_orientation m_orientation;
    t__vt__vtx_align_kind m_vertical_align;
    t__vt__vtx_align_kind m_horizontal_align;
    t__int m_pre_padding;
    t__int m_padding;
    t__int m_post_padding;
    t__bool m_ensure_common_width;
    struct s__vt__sni_vtx_jpanel *j_me;
    t__bool m_using_scrollbars;
} *t__gen_dbg_gui__gen_dbg_panel;
#define d__gen_dbg_gui__gen_dbg_panel 8737
typedef t__gen_dbg_gui__gen_dbg_panel t__gen_dbg_panel;
#define d__gen_dbg_panel d__gen_dbg_gui__gen_dbg_panel

/* line 7 "/vobs/specman/src/gen/gen_dbg_types.e"  From 'struct definition' */
typedef struct s__gen_dbg__gen_dbg_struct {
    t__int d__;
    t__int gen__;
} *t__gen_dbg__gen_dbg_struct;
#define d__gen_dbg__gen_dbg_struct 7964
typedef t__gen_dbg__gen_dbg_struct t__gen_dbg_struct;
#define d__gen_dbg_struct d__gen_dbg__gen_dbg_struct

/* line 296 "/vobs/specman/src/gen/gen_dbg_gui_window.e"  From 'struct definition' */
typedef struct s__gen_dbg_gui__gen_dbg_co97219 {
    t__int d__;
    t__int gen__;
    t__string m_id;
    t__string m_name;
    struct s__e_core__base_struct *m_user_data;
    t__string m_title;
    t__vt__vtx_element_state m_state;
    struct s__vt__vt_size *m_requested_size;
    struct s__vt__vt_location *m_requested_location;
    t__string m_window_kind;
    struct s__l__vt__vtx_action *m_actions;
    struct s__vt__vtx_component *m_primary_pane;
    struct s__vt__vtx_component *m_secondary_pane1;
    struct s__vt__vtx_component *m_secondary_pane2;
    struct s__vt__vtx_combobox *m_top_combobox;
    struct s__vt__vtx_component *m_window_header;
    struct s__vt__sni_vtx_jbase_window *j_me;
    struct s__vt__vtx_snorb_window_ac39957 *m_actual_attributes;
    struct s__vt__vtx_window_sni_helper *m_sni_helper;
    t__vt__vtx_window_layout_style m_window_layout_style;
    t__int m_primary_pane_ratio;
    t__int m_secondary1_pane_ratio;
    t__int m_primary_divider_location;
    t__int m_secondary_divider_location;
    struct s__vt__vtx_selectable_widget *m_selection_owner;
    struct s__k__string__it *m_initially_disabled_action_names;
    t__bool m_is_always_on_top;
    t__bool m_using_dnd;
    t__bool m_lockable;
    t__bool m_locked;
    struct s__vt__vt_statusbar *m_status_bar;
    struct s__vt__vtx_table *contexts_table;
} *t__gen_dbg_gui__gen_dbg_context_select_window;
#define d__gen_dbg_gui__gen_dbg_context_select_window 8796
typedef t__gen_dbg_gui__gen_dbg_context_select_window t__gen_dbg_context_select_window;
#define d__gen_dbg_context_select_window d__gen_dbg_gui__gen_dbg_context_select_window

/* line 40 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_object_pool *pool;
    struct s__k__sn__gen_sa_pure_type96896 *pure_types;
    struct s__l__reflection__rf_type *type_stack;
    t__bool initialized;
    struct s__l__sn__gen_sa_cc_graph *graph_cashe;
    struct s__l__gen__gen_sa_hierarch96898 *node_graphs_cashe;
    struct s__l__sn__gen_sa_cc_motivator *motivators_cashe;
    struct s__l__sn__gen_sa_cc_reuse_data *reuse_datas;
    struct s__l__gen__gen_sa_cc_merge_data *merge_datas;
} *t__sn__gen_sa_manager;
#define d__sn__gen_sa_manager 6452
typedef t__sn__gen_sa_manager t__gen_sa_manager;
#define d__gen_sa_manager d__sn__gen_sa_manager

/* line 140 "/vobs/specman/src/gen/gen_sa_manager_basic_api.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_object_pool {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *DEFAULT_CC_CONDITION;
    struct s__sn__gen_sa_cc_header *NO_CC_HEADER;
    struct s__sn__any_rl *SAMPLE_ONLY_RL;
    struct s__sn_rl__uint_rl *MAXIMAL_UINT_RL;
    struct s__l__sn__gen_path *DUMMY_DET_LIST;
    struct s__sn_rl__scalar_rl *SAMPLE_FAILED_RL;
    struct s__sn_rl__scalar_rl *NOT_INFLUENCING_RL;
    struct s__sn_rl__scalar_rl *EMPTY_RL;
    t__string EMPTY_STRING;
    struct s__reflection__rf_type *RF_UINT;
    struct s__reflection__rf_type *RF_SYS;
    struct s__reflection__rf_type *RF_BOOL;
    struct s__reflection__rf_type *RF_STRING;
    struct s__sn__gen_path_element *NULL_PATH_ELEMENT;
    struct s__sn__gen_path_list_index55055 *LIST_INDEX_ELEMENT;
    struct s__sn__gen_path_list_size_55023 *LIST_SIZE_ELEMENT;
    struct s__sn__gen_path_normal_bin55008 *NORMAL_BIND_ELEMENT;
    struct s__sn__gen_path_external_b55012 *EXTERNAL_BIND_ELEMENT;
    struct s__sn__gen_path_undefined_55014 *UNDEFINED_BIND_ELEMENT;
    struct s__sn__gen_path_empty_bind55016 *EMPTY_BIND_ELEMENT;
    struct s__reflection__rf_type *RF_SIMPLE_PORT;
    struct s__reflection__rf_type *RF_EVENT_PORT;
    struct s__reflection__rf_type *RF_METHOD_PORT;
    struct s__reflection__rf_type *RF_BUFFER_PORT;
    struct s__reflection__rf_type *RF_INTERFACE_PORT;
    struct s__reflection__rf_type *RF_ANY_PORT;
    struct s__k__sn__gen_sa_direct_cc82648 *direct_headers;
} *t__sn__gen_sa_object_pool;
#define d__sn__gen_sa_object_pool 8140
typedef t__sn__gen_sa_object_pool t__gen_sa_object_pool;
#define d__gen_sa_object_pool d__sn__gen_sa_object_pool

/* line 250 "/vobs/specman/src/gen/gen_parser_parameter_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_path_list_index55055 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_type *item_type;
} *t__sn__gen_path_list_index_element;
#define d__sn__gen_path_list_index_element 6429
typedef t__sn__gen_path_list_index_element t__gen_path_list_index_element;
#define d__gen_path_list_index_element d__sn__gen_path_list_index_element

/* line 49 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_pure_type {
    t__int d__;
    t__int gen__;
    struct s__sn__st_gen_keeping_action *gen_action;
    struct s__l__sn__gen_path *generated_paths;
    struct s__l__sn__gen_user_constraint *user_constraints;
    t__uint id;
    t__string seed_domain_str;
    struct s__reflection__rf_type *context_type;
    struct s__sn__st_local_exp *it_local;
    struct s__reflection__rf_struct *containing_struct;
    struct s__sn__gen_sa_ccs *ccs;
    struct s__sn__gen_sa_hierarchy_node *root;
    struct s__l__sn__gen_sa_pgen3_node *pgen3_nodes;
    struct s__l__gen__gen_sa_pointer_83391 *ctx_cpe_conditions;
    struct s__l__sn__gen_sa_cc_header *active_headers;
    struct s__gen__gen_simple_basic *simple_gen;
    struct s__reflection__rf_type *etype;
} *t__sn__gen_sa_pure_type;
#define d__sn__gen_sa_pure_type 6453
typedef t__sn__gen_sa_pure_type t__gen_sa_pure_type;
#define d__gen_sa_pure_type d__sn__gen_sa_pure_type

/* line 561 "/vobs/specman/src/gen/gen_sa_dependency_graph.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_hierarchy_n82234 {
    t__int d__;
    t__int gen__;
    struct s__k__gen__gen_sa_hierarch96865 *nodes;
    struct s__k__gen__gen_sa_hierarch96866 *components;
    t__bool had_back_edge;
    t__uint timestamp;
} *t__gen__gen_sa_hierarchy_node_dependency_graph;
#define d__gen__gen_sa_hierarchy_node_dependency_graph 8092
typedef t__gen__gen_sa_hierarchy_node_dependency_graph t__gen_sa_hierarchy_node_dependency_graph;
#define d__gen_sa_hierarchy_node_dependency_graph d__gen__gen_sa_hierarchy_node_dependency_graph

/* line 561 "/vobs/specman/src/gen/gen_sa_dependency_graph.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_hierarchy_n82231 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_hierarchy_node *id;
    struct s__k__sn__gen_sa_hierarchy82229 *dependants;
    struct s__k__gen__gen_sa_hierarch96862 *t_dependants;
    t__uint color;
    struct s__gen__gen_sa_hierarchy_n96863 *cormen_pi;
    struct s__gen__gen_sa_hierarchy_n82231 *parent;
    t__bool has_self_edge;
    struct s__gen__gen_sa_hierarchy_n82206 *my_component;
    struct s__gen__gen_sa_hierarchy_n82234 *dgraph;
} *t__gen__gen_sa_hierarchy_node_dependency_node;
#define d__gen__gen_sa_hierarchy_node_dependency_node 8093
typedef t__gen__gen_sa_hierarchy_node_dependency_node t__gen_sa_hierarchy_node_dependency_node;
#define d__gen_sa_hierarchy_node_dependency_node d__gen__gen_sa_hierarchy_node_dependency_node

/* line 561 "/vobs/specman/src/gen/gen_sa_dependency_graph.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_hierarchy_n96863 {
    t__int d__;
    t__int gen__;
    struct s__k__gen__gen_sa_hierarch96862 *nodes;
} *t__gen__gen_sa_hierarchy_node_dnode_holder;
#define d__gen__gen_sa_hierarchy_node_dnode_holder 8094
typedef t__gen__gen_sa_hierarchy_node_dnode_holder t__gen_sa_hierarchy_node_dnode_holder;
#define d__gen_sa_hierarchy_node_dnode_holder d__gen__gen_sa_hierarchy_node_dnode_holder

/* line 561 "/vobs/specman/src/gen/gen_sa_dependency_graph.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_hierarchy_n82206 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__gen_sa_hierarchy82229 *elements;
    t__bool is_cyclic;
} *t__gen__gen_sa_hierarchy_node_component;
#define d__gen__gen_sa_hierarchy_node_component 8091
typedef t__gen__gen_sa_hierarchy_node_component t__gen_sa_hierarchy_node_component;
#define d__gen_sa_hierarchy_node_component d__gen__gen_sa_hierarchy_node_component

/* line 234 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_cc_motivator {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *cond;
    struct s__l__sn__gen_sa_constrain82582 *constraints;
    struct s__gen__gen_determinant_list *determinants;
    struct s__l__sn__gen_sa_input_node *inputs;
    struct s__l__sn__gen_sa_direct_cc82607 *cc_list;
    t__bool is_all_iter;
    struct s__sn__gen_user_constraint *ai_cons;
    struct s__sn__gen_sa_hierarchy_node *list_node;
    struct s__sn__gen_sa_hierarchy_node *list_size_node;
    struct s__sn__gen_sa_hierarchy_node *list_item_node;
    struct s__l__sn__gen_sa_hierarchy_node *iterated_nodes;
} *t__sn__gen_sa_cc_motivator;
#define d__sn__gen_sa_cc_motivator 6504
typedef t__sn__gen_sa_cc_motivator t__gen_sa_cc_motivator;
#define d__gen_sa_cc_motivator d__sn__gen_sa_cc_motivator

/* line 337 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_cc_reuse_data {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_cc_header *reuse_cc;
    struct s__sn__gen_sa_ccs *target_ccs;
    struct s__sn__gen_sa_reuse_node *reuse_node;
} *t__sn__gen_sa_cc_reuse_data;
#define d__sn__gen_sa_cc_reuse_data 6524
typedef t__sn__gen_sa_cc_reuse_data t__gen_sa_cc_reuse_data;
#define d__gen_sa_cc_reuse_data d__sn__gen_sa_cc_reuse_data

/* line 43 "/vobs/specman/src/gen/gen_sa_merge_administrator_hdr.e"  From 'struct definition' */
typedef struct s__gen__gen_sa_cc_merge_data {
    t__int d__;
    t__int gen__;
    t__string merge_key;
    struct s__sn__gen_path *merge_path;
    struct s__sn__gen_sa_ccs *target_ccs;
    struct s__sn__gen_sa_ccs *source_ccs;
    struct s__sn__gen_sa_hierarchy_node *pivot_node;
    struct s__sn__gen_sa_direct_cc_header *cc;
} *t__gen__gen_sa_cc_merge_data;
#define d__gen__gen_sa_cc_merge_data 8126
typedef t__gen__gen_sa_cc_merge_data t__gen_sa_cc_merge_data;
#define d__gen_sa_cc_merge_data d__gen__gen_sa_cc_merge_data

/* line 190 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_simple_cc_header {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *condition;
    struct s__sn__gen_sa_ccs *containing_ccs;
    struct s__sn__gen_sa_cc_above_data *above_data;
    struct s__sn__gen_sa_solving_info56832 *graph;
    t__uint iter_ind;
    struct s__sn__gen_cc_seed_domain *cc_seed_domain;
    struct s__sn__gen_path *rt_full_prefix;
    t__sn__count sas_count;
    t__sn__index cc_id;
} *t__sn__gen_sa_simple_cc_header;
#define d__sn__gen_sa_simple_cc_header 6493
typedef t__sn__gen_sa_simple_cc_header t__gen_sa_simple_cc_header;
#define d__gen_sa_simple_cc_header d__sn__gen_sa_simple_cc_header

/* line 170 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__solver_bdd_info {
    t__int d__;
    t__int gen__;
    struct s__k__external_pointer__it *gen_solver_bdd_hash;
    struct s__l__external_pointer *gen_solver_support;
    struct s__l__uint *gen_solver_supp_size;
    struct s__l__uint *gen_solver_minterms;
    struct s__l__bit *rnd_bits;
    t__bool gen_table_initialized;
    t__uint gen_table_cashe_size;
    struct s__sn__sn_cudd_bdd_manager *mng;
    struct s__l__uint *global_levels;
} *t__sn__solver_bdd_info;
#define d__sn__solver_bdd_info 8385
typedef t__sn__solver_bdd_info t__solver_bdd_info;
#define d__solver_bdd_info d__sn__solver_bdd_info

/* line 45 "/vobs/specman/src/bdd_cudd.e"  From 'struct definition' */
typedef struct s__sn__sn_cudd_bdd_manager {
    t__int d__;
    t__int gen__;
    t__external_pointer mng;
    struct s__sn__sn_bdd *one_bdd;
    struct s__sn__sn_bdd *zero_bdd;
    struct s__k__sn__sn_bdd_var__name *vars;
    struct s__sn_fl__sn_fl_top_node *sn_fl_top_node;
    struct s__sn__bdd_manager_save_info *save_info;
    struct s__l__uint *restored_ids;
} *t__sn__sn_cudd_bdd_manager;
#define d__sn__sn_cudd_bdd_manager 3011
typedef t__sn__sn_cudd_bdd_manager t__sn_cudd_bdd_manager;
#define d__sn_cudd_bdd_manager d__sn__sn_cudd_bdd_manager

/* line 7 "/vobs/specman/src/gen/bdd_save.e"  From 'struct definition' */
typedef struct s__sn__bdd_manager_save_info {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_bdd__bdd *save_hash;
    struct s__l__sn__sn_bdd *restore_cache;
    struct s__l__uint *save_list;
    t__bool saved_state;
    struct s__l__uint *vars_perm;
} *t__sn__bdd_manager_save_info;
#define d__sn__bdd_manager_save_info 8032
typedef t__sn__bdd_manager_save_info t__bdd_manager_save_info;
#define d__bdd_manager_save_info d__sn__bdd_manager_save_info

/* line 93 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pnet_var {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node_graph_data *graph_data;
    t__uint status;
    struct s__sn__gen_sa_constraint_i54950 *src;
    struct s__sn__gen_srcs *multi_src;
    t__bool hybrid;
    t__sn__gen_pnet_var_type var_type;
    struct s__sn__gen_scalar_constrai86423 *my_solver;
    struct s__l__sn__gen_pnet_propagator *ps;
    t__uint dsize;
    struct s__sn_rl__scalar_rl *domain_rl;
    struct s__sn__seed_domain *sd;
    struct s__l__sn__gen_policy *policies;
    struct s__sn__gen_pnet_var *selector_link;
    struct s__sn__gen_bdd_domain_extension *hybrid__bdd_ext;
    t__int size_in_bits;
    struct s__sn__input_list_container *input_list;
} *t__sn__gen_pnet_var;
#define d__sn__gen_pnet_var 8338
typedef t__sn__gen_pnet_var t__gen_pnet_var;
#define d__gen_pnet_var d__sn__gen_pnet_var

/* line 625 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pnet_node_graph_data {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node *dfs_parent;
    t__int dfs_children;
    t__int dfs_index;
    t__int bcc;
    t__int dfs_low;
} *t__sn__gen_pnet_node_graph_data;
#define d__sn__gen_pnet_node_graph_data 8389
typedef t__sn__gen_pnet_node_graph_data t__gen_pnet_node_graph_data;
#define d__gen_pnet_node_graph_data d__sn__gen_pnet_node_graph_data

/* line 90 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pnet_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node_graph_data *graph_data;
    t__uint status;
    struct s__sn__gen_sa_constraint_i54950 *src;
    struct s__sn__gen_srcs *multi_src;
} *t__sn__gen_pnet_node;
#define d__sn__gen_pnet_node 8337
typedef t__sn__gen_pnet_node t__gen_pnet_node;
#define d__gen_pnet_node d__sn__gen_pnet_node

/* line 712 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_srcs {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_sa_constrain82582 *srcs;
} *t__sn__gen_srcs;
#define d__sn__gen_srcs 8391
typedef t__sn__gen_srcs t__gen_srcs;
#define d__gen_srcs d__sn__gen_srcs

/* line 310 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_scalar_constrai86423 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_pnet_var *vs;
    struct s__l__sn__gen_pnet_propagator *ps;
    struct s__l__uint *bdd_var_levels;
    struct s__l__uint *user_var_map;
    struct s__l__uint *temp_var_map;
    struct s__l__uint *reif_temp_var_map;
    struct s__l__uint *soft_temp_var_map;
    struct s__l__uint *select_temp_var_map;
    struct s__l__uint *gen_temp_var_map;
    struct s__l__uint *selector_var_map;
    struct s__l__uint *vs_trailed;
    struct s__l__uint *vs_status_trail;
    struct s__l__sn_rl__scalar_rl *vs_rl_trail;
    struct s__l__sn__sn_bdd *vs_bdd_trail;
    struct s__l__uint *vs_dsize_trail;
    struct s__l__uint *vs_linl_trail;
    struct s__l__uint *ps_trailed;
    struct s__l__uint *ps_status_trail;
    struct s__l__uint *private_vs_trailed;
    struct s__l__uint *private_vs_status_trail;
    struct s__l__sn_rl__scalar_rl *private_vs_rl_trail;
    struct s__l__sn__sn_bdd *private_vs_bdd_trail;
    struct s__l__uint *private_vs_dsize_trail;
    struct s__l__uint *private_vs_linl_trail;
    struct s__l__uint *private_ps_trailed;
    struct s__l__uint *private_ps_status_trail;
    struct s__sn__qpack *q;
    t__uint propagations;
    t__uint backtracks;
    t__uint trail_watermark;
    t__uint do_prop_stamp;
    t__uint propagations_limit;
    t__uint global_backtrack_limit;
    t__uint local_backtrack_limit;
    t__bool show_stat;
    t__uint randomize_reif;
    t__uint randomize_user;
    struct s__sn__gen_solver_listener *dbg_handler;
    t__bool dbg_marking_mode;
    struct s__l__sn__gen_pnet_var *iterated_vars;
    struct s__l__sn__gen_pnet_var *last_solution;
    struct s__sn__gen_pnet_propagator96991 *lex_gt;
    struct s__sn__gen_pnet_propagator_bdd *whole_bdd;
    struct s__sn__sn_bdd *whole_bdd_support;
    struct s__sn__gen_hl_bdd_holder *rt_bdds;
    t__bool do_bdd_transform;
    t__uint bdd_transform_distance;
    t__bool bdd_transform_global;
    t__uint bdd_transform_max_bdd;
    t__uint bdd_global_transform_limit;
    struct s__l__sn__var_eq_class *all_classes;
    struct s__k__sn__var2class__v *v2cs;
    struct s__l__sn__gen_pnet_propagator *transform_candidates;
    struct s__l__sn__gen_pnet_propagator *transform_bdd_umbrellas;
    struct s__sn__labeling_iterator *li;
    struct s__l__int *soft_permutation;
    struct s__sn__gen_pnet_propagator96992 *soft_chain;
    struct s__sn__gen_cc_seed_domain *extra_seeds;
    struct s__l__sn__gen_pnet_var *soft_temps;
    struct s__l__sn__gen_pnet_var *reif_temps;
    struct s__l__sn__gen_pnet_var *vars_with_policies;
    struct s__l__sn__gen_pnet_var *gen_vars;
    struct s__l__uint *vs_multiset_trail;
} *t__sn__gen_scalar_constraint_solver;
#define d__sn__gen_scalar_constraint_solver 8387
typedef t__sn__gen_scalar_constraint_solver t__gen_scalar_constraint_solver;
#define d__gen_scalar_constraint_solver d__sn__gen_scalar_constraint_solver

/* line 96 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pnet_propagator {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node_graph_data *graph_data;
    t__uint status;
    struct s__sn__gen_sa_constraint_i54950 *src;
    struct s__sn__gen_srcs *multi_src;
    struct s__l__sn__gen_pnet_var *vs;
    struct s__e_core__sn_struct *source;
    struct s__sn__queue *queued;
    t__uint counter;
    t__uint do_prop_stamp;
    struct s__sn__gen_bdd_recycler *bdd_recycler;
} *t__sn__gen_pnet_propagator;
#define d__sn__gen_pnet_propagator 8339
typedef t__sn__gen_pnet_propagator t__gen_pnet_propagator;
#define d__gen_pnet_propagator d__sn__gen_pnet_propagator

/* line 167 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__queue {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_pnet_propagator *l;
    t__uint f;
    t__uint t;
    t__uint sz;
} *t__sn__queue;
#define d__sn__queue 8383
typedef t__sn__queue t__queue;
#define d__queue d__sn__queue

/* line 1057 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_bdd_recycler {
    t__int d__;
    t__int gen__;
    struct s__l__external_pointer *bdds_to_recycle;
} *t__sn__gen_bdd_recycler;
#define d__sn__gen_bdd_recycler 8395
typedef t__sn__gen_bdd_recycler t__gen_bdd_recycler;
#define d__gen_bdd_recycler d__sn__gen_bdd_recycler

/* line 168 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__qpack {
    t__int d__;
    t__int gen__;
    struct s__l__sn__queue *qs;
    t__uint in_q;
    struct s__sn__gen_pnet_propagator *origin;
} *t__sn__qpack;
#define d__sn__qpack 8384
typedef t__sn__qpack t__qpack;
#define d__qpack d__sn__qpack

/* line 15 "/vobs/specman/src/gen/gen_solver_listener_api.e"  From 'struct definition' */
typedef struct s__sn__gen_solver_listener {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_sa_direct_cc82607 *current_ccs;
    struct s__l__sn__gen_sa_cc_graph *current_graphs;
    struct s__l__sn__gen_cc_solver *current_solvers;
    struct s__l__sn__listener_mode *current_modes;
    struct s__l__gen__list_indices *current_indices;
    struct s__l__sn__gen_rt_record *current_rt_records;
    struct s__gen__gen_unique_ids_supplier *ids_supplier;
} *t__sn__gen_solver_listener;
#define d__sn__gen_solver_listener 8264
typedef t__sn__gen_solver_listener t__gen_solver_listener;
#define d__gen_solver_listener d__sn__gen_solver_listener

/* line 66 "/vobs/specman/src/gen/gen_solver_listener_imp.e"  From 'struct definition' */
typedef struct s__gen__list_indices {
    t__int d__;
    t__int gen__;
    struct s__l__int *indices;
} *t__gen__list_indices;
#define d__gen__list_indices 8731
typedef t__gen__list_indices t__list_indices;
#define d__list_indices d__gen__list_indices

/* line 24 "/vobs/specman/src/gen/gen_solver_listener_imp.e"  From 'struct definition' */
typedef struct s__gen__gen_unique_ids_supplier {
    t__int d__;
    t__int gen__;
    t__uint cc_counter;
    t__uint ctx_counter;
    struct s__l__uint *cc_counter_queue;
    struct s__l__uint *ctx_counter_queue;
} *t__gen__gen_unique_ids_supplier;
#define d__gen__gen_unique_ids_supplier 8730
typedef t__gen__gen_unique_ids_supplier t__gen_unique_ids_supplier;
#define d__gen_unique_ids_supplier d__gen__gen_unique_ids_supplier

/* line 1295 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pnet_propagator96991 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node_graph_data *graph_data;
    t__uint status;
    struct s__sn__gen_sa_constraint_i54950 *src;
    struct s__sn__gen_srcs *multi_src;
    struct s__l__sn__gen_pnet_var *vs;
    struct s__e_core__sn_struct *source;
    struct s__sn__queue *queued;
    t__uint counter;
    t__uint do_prop_stamp;
    struct s__sn__gen_bdd_recycler *bdd_recycler;
    struct s__sn__gen_rl_recycler *rl_recycler;
    struct s__l__sn_rl__scalar_rl *orig_rls;
    struct s__l__sn_rl__scalar_rl *rls;
    t__sn__rl_propagator_status last_result;
    t__bool should_update;
} *t__sn__gen_pnet_propagator_rl_lex_gt;
#define d__sn__gen_pnet_propagator_rl_lex_gt 8401
typedef t__sn__gen_pnet_propagator_rl_lex_gt t__gen_pnet_propagator_rl_lex_gt;
#define d__gen_pnet_propagator_rl_lex_gt d__sn__gen_pnet_propagator_rl_lex_gt

/* line 1061 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_rl_recycler {
    t__int d__;
    t__int gen__;
    struct s__l__sn_rl__scalar_rl *rls_to_recycle;
} *t__sn__gen_rl_recycler;
#define d__sn__gen_rl_recycler 8396
typedef t__sn__gen_rl_recycler t__gen_rl_recycler;
#define d__gen_rl_recycler d__sn__gen_rl_recycler

/* line 99 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pnet_propagator_bdd {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node_graph_data *graph_data;
    t__uint status;
    struct s__sn__gen_sa_constraint_i54950 *src;
    struct s__sn__gen_srcs *multi_src;
    struct s__l__sn__gen_pnet_var *vs;
    struct s__e_core__sn_struct *source;
    struct s__sn__queue *queued;
    t__uint counter;
    t__uint do_prop_stamp;
    struct s__sn__gen_bdd_recycler *bdd_recycler;
    struct s__sn__sn_bdd *relation;
    struct s__l__uint *relation_save;
} *t__sn__gen_pnet_propagator_bdd;
#define d__sn__gen_pnet_propagator_bdd 8340
typedef t__sn__gen_pnet_propagator_bdd t__gen_pnet_propagator_bdd;
#define d__gen_pnet_propagator_bdd d__sn__gen_pnet_propagator_bdd

/* line 21 "/vobs/specman/src/bdd_cudd.e"  From 'struct definition' */
typedef struct s__sn__gen_hl_bdd_holder {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_bdd *bdds;
} *t__sn__gen_hl_bdd_holder;
#define d__sn__gen_hl_bdd_holder 3009
typedef t__sn__gen_hl_bdd_holder t__gen_hl_bdd_holder;
#define d__gen_hl_bdd_holder d__sn__gen_hl_bdd_holder

/* line 392 "/vobs/specman/src/gen/gen_scalar_solver_rls_transform.e"  From 'struct definition' */
typedef struct s__sn__var_eq_class {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_pnet_var *vars;
    struct s__sn__var_eq_class *merged_into;
    struct s__l__sn__gen_sa_constrain82582 *srcs;
} *t__sn__var_eq_class;
#define d__sn__var_eq_class 8662
typedef t__sn__var_eq_class t__var_eq_class;
#define d__var_eq_class d__sn__var_eq_class

/* line 498 "/vobs/specman/src/gen/gen_scalar_solver_rls_transform.e"  From 'struct definition' */
typedef struct s__sn__var2class {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_var *v;
    struct s__sn__var_eq_class *c;
} *t__sn__var2class;
#define d__sn__var2class 8663
typedef t__sn__var2class t__var2class;
#define d__var2class d__sn__var2class

/* line 50 "/vobs/specman/src/gen/gen_scalar_solver_labeling.e"  From 'struct definition' */
typedef struct s__sn__labeling_iterator {
    t__int d__;
    t__int gen__;
    struct s__l__sn__gen_pnet_var *vars;
    t__uint last_var;
    t__uint heur_start;
    t__uint randomize_user;
    t__uint size_threshold;
    struct s__sn__seed_domain *seed;
} *t__sn__labeling_iterator;
#define d__sn__labeling_iterator 8678
typedef t__sn__labeling_iterator t__labeling_iterator;
#define d__labeling_iterator d__sn__labeling_iterator

/* line 1225 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pnet_propagator96992 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node_graph_data *graph_data;
    t__uint status;
    struct s__sn__gen_sa_constraint_i54950 *src;
    struct s__sn__gen_srcs *multi_src;
    struct s__l__sn__gen_pnet_var *vs;
    struct s__e_core__sn_struct *source;
    struct s__sn__queue *queued;
    t__uint counter;
    t__uint do_prop_stamp;
    struct s__sn__gen_bdd_recycler *bdd_recycler;
    struct s__sn__gen_rl_recycler *rl_recycler;
    struct s__l__sn_rl__scalar_rl *orig_rls;
    struct s__l__sn_rl__scalar_rl *rls;
    t__sn__rl_propagator_status last_result;
    t__bool should_update;
} *t__sn__gen_pnet_propagator_rl_soft_chain;
#define d__sn__gen_pnet_propagator_rl_soft_chain 8399
typedef t__sn__gen_pnet_propagator_rl_soft_chain t__gen_pnet_propagator_rl_soft_chain;
#define d__gen_pnet_propagator_rl_soft_chain d__sn__gen_pnet_propagator_rl_soft_chain

/* line 56 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_policy {
    t__int d__;
    t__int gen__;
    t__bool f__void;
} *t__sn__gen_policy;
#define d__sn__gen_policy 8252
typedef t__sn__gen_policy t__gen_policy;
#define d__gen_policy d__sn__gen_policy

/* line 648 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_bdd_domain_extension {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_bdd *domain_bdd;
    struct s__l__sn__sn_bdd *support_bits;
    struct s__sn__sn_bdd *support;
    struct s__sn__sn_bdd *not_support;
    struct s__sn_rl__scalar_rl *tmp_rl;
    struct s__l__uint *domain_save;
    struct s__l__uint *support_inds;
} *t__sn__gen_bdd_domain_extension;
#define d__sn__gen_bdd_domain_extension 8390
typedef t__sn__gen_bdd_domain_extension t__gen_bdd_domain_extension;
#define d__gen_bdd_domain_extension d__sn__gen_bdd_domain_extension

/* line 16 "/vobs/specman/src/gen/gen_scalar_solver_list_in_list.e"  From 'struct definition' */
typedef struct s__sn__input_list_container {
    t__int d__;
    t__int gen__;
    t__uint sz;
} *t__sn__input_list_container;
#define d__sn__input_list_container 8685
typedef t__sn__input_list_container t__input_list_container;
#define d__input_list_container d__sn__input_list_container

/* line 180 "/vobs/specman/src/gen/gen_scalar_solver_hdr.e"  From 'struct definition' */
typedef struct s__sn__global_trails {
    t__int d__;
    t__int gen__;
    struct s__l__uint *vs_trailed;
    struct s__l__uint *vs_status_trail;
    struct s__l__sn_rl__scalar_rl *vs_rl_trail;
    struct s__l__sn__sn_bdd *vs_bdd_trail;
    struct s__l__uint *vs_dsize_trail;
    struct s__l__uint *vs_linl_trail;
    struct s__l__uint *ps_trailed;
    struct s__l__uint *ps_status_trail;
} *t__sn__global_trails;
#define d__sn__global_trails 8386
typedef t__sn__global_trails t__global_trails;
#define d__global_trails d__sn__global_trails

/* line 44 "/vobs/specman/src/gen/gen_constant_folder_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_constant_folder {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_node_graph_data *graph_data;
    t__uint status;
    struct s__sn__gen_sa_constraint_i54950 *src;
    struct s__sn__gen_srcs *multi_src;
    struct s__l__sn__gen_pnet_var *vs;
    struct s__e_core__sn_struct *source;
    struct s__sn__queue *queued;
    t__uint counter;
    t__uint do_prop_stamp;
    struct s__sn__gen_bdd_recycler *bdd_recycler;
    struct s__sn__gen_rl_recycler *rl_recycler;
    struct s__l__sn_rl__scalar_rl *orig_rls;
    struct s__l__sn_rl__scalar_rl *rls;
    t__sn__rl_propagator_status last_result;
    t__bool should_update;
    t__bool active;
} *t__sn__gen_constant_folder;
#define d__sn__gen_constant_folder 8410
typedef t__sn__gen_constant_folder t__gen_constant_folder;
#define d__gen_constant_folder d__sn__gen_constant_folder

/* line 20 "/vobs/specman/src/gen/gen_slm_manager.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_no_constrs_solver *DEFAULT_NO_CONSTRS_SOLVER;
    struct s__sn__gen_dedicated_inp_solver *DEFAULT_INP_ONLY_DED_SOLVER;
    struct s__sn__gen_dedicated_inp_p96950 *DEFAULT_POINTER_DED_SOLVER;
    struct s__sn__gen_lace_cc_solver *DEFAULT_LACE_CC_SOLVER;
    struct s__sn__gen_cc_solver *DEFAULT_CF_CONTRADICTION_SOLVER;
    struct s__sn_rl__int_rl *DEFAULT_INT_RL;
    struct s__sn_rl__uint_rl *DEFAULT_UINT_RL;
    struct s__l__sn__gen_path *EMPTY_LIST_OF_GEN_PATH;
    struct s__sn__gen_solver_listener *SOLVER_LISTENER;
    struct s__l__uint *DUMMY_LIST_OF_UINT;
    struct s__sn__gen_pass_policy *pass_policy;
    struct s__sn__gen_others_policy *others_policy;
    struct s__sn__gen_edges_policy *edges_policy;
    struct s__sn__gen_min_policy *min_policy;
    struct s__sn__gen_max_policy *max_policy;
} *t__sn__gen_slm_manager;
#define d__sn__gen_slm_manager 8448
typedef t__sn__gen_slm_manager t__gen_slm_manager;
#define d__gen_slm_manager d__sn__gen_slm_manager

/* line 41 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_no_constrs_solver {
    t__int d__;
    t__int gen__;
} *t__sn__gen_no_constrs_solver;
#define d__sn__gen_no_constrs_solver 8241
typedef t__sn__gen_no_constrs_solver t__gen_no_constrs_solver;
#define d__gen_no_constrs_solver d__sn__gen_no_constrs_solver

/* line 42 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_dedicated_inp_solver {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_simple_basic *simple_gen;
} *t__sn__gen_dedicated_inp_solver;
#define d__sn__gen_dedicated_inp_solver 8242
typedef t__sn__gen_dedicated_inp_solver t__gen_dedicated_inp_solver;
#define d__gen_dedicated_inp_solver d__sn__gen_dedicated_inp_solver

/* line 43 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_dedicated_inp_p96950 {
    t__int d__;
    t__int gen__;
} *t__sn__gen_dedicated_inp_pointer_solver;
#define d__sn__gen_dedicated_inp_pointer_solver 8243
typedef t__sn__gen_dedicated_inp_pointer_solver t__gen_dedicated_inp_pointer_solver;
#define d__gen_dedicated_inp_pointer_solver d__sn__gen_dedicated_inp_pointer_solver

/* line 45 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_lace_cc_solver {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_slm_reuse_manager *reuse_manager;
    struct s__l__gen__gen_slm_constra96951 *constrs_info;
    struct s__sn__gen_cc_solver *solver;
    struct s__l__sn__gen_slm_multipli96952 *mult_nodes;
    struct s__l__sn__gen_slm_multipli96953 *mult_inputs;
    t__uint mult_nodes_count;
} *t__sn__gen_lace_cc_solver;
#define d__sn__gen_lace_cc_solver 8244
typedef t__sn__gen_lace_cc_solver t__gen_lace_cc_solver;
#define d__gen_lace_cc_solver d__sn__gen_lace_cc_solver

/* line 25 "/vobs/specman/src/gen/gen_slm_lace_reuse_api.e"  From 'struct definition' */
typedef struct s__gen__gen_slm_reuse_manager {
    t__int d__;
    t__int gen__;
    struct s__l__gen__gen_slm_reuse_c96987 *reuse_components;
} *t__gen__gen_slm_reuse_manager;
#define d__gen__gen_slm_reuse_manager 8319
typedef t__gen__gen_slm_reuse_manager t__gen_slm_reuse_manager;
#define d__gen_slm_reuse_manager d__gen__gen_slm_reuse_manager

/* line 27 "/vobs/specman/src/gen/gen_slm_lace_reuse_api.e"  From 'struct definition' */
typedef struct s__gen__gen_slm_reuse_component {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_cc_solver *solver;
    struct s__l__gen__gen_slm_constra96951 *constrs_info;
    struct s__l__gen__gen_mult_node_r96988 *mult_node_reuse_infos;
    struct s__sn__gen_soft_orderer *constraints_orderer;
    struct s__sn__gen_soft_orderer *selects_orderer;
    struct s__gen__gen_slm_softs_mapper *softs_mapper;
    struct s__gen__gen_slm_solver_dat86104 *slm_data_holder;
} *t__gen__gen_slm_reuse_component;
#define d__gen__gen_slm_reuse_component 8320
typedef t__gen__gen_slm_reuse_component t__gen_slm_reuse_component;
#define d__gen_slm_reuse_component d__gen__gen_slm_reuse_component

/* line 29 "/vobs/specman/src/gen/gen_slm_lace_reuse_api.e"  From 'struct definition' */
typedef struct s__gen__gen_slm_constraint96990 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_constraint_i54950 *constr_inst;
    struct s__sn__gen_slm_constraint_86091 *constr_tree;
    t__bool is_single;
    struct s__gen__gen_sa_condition *constr_condition;
    t__int prev_new_nodes_counter;
    t__int new_nodes_counter;
    t__int new_unique_id;
    struct s__l__int *related_mult_nodes_inds;
} *t__gen__gen_slm_constraint_reuse_info;
#define d__gen__gen_slm_constraint_reuse_info 8321
typedef t__gen__gen_slm_constraint_reuse_info t__gen_slm_constraint_reuse_info;
#define d__gen_slm_constraint_reuse_info d__gen__gen_slm_constraint_reuse_info

/* line 33 "/vobs/specman/src/gen/gen_slm_lace_reuse_api.e"  From 'struct definition' */
typedef struct s__gen__gen_mult_node_reus86103 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_node *node;
    struct s__gen__gen_sa_condition *lace_cond;
    t__uint from_id;
    t__uint node_count;
    struct s__l__int *new_solver_nodes_ids;
    struct s__sn__gen_slm_size_tree *size_tree;
    t__bool iterator_not_empty;
    struct s__sn_rl__uint_rl *ids_range;
    t__uint list_size_id;
} *t__gen__gen_mult_node_reuse_info;
#define d__gen__gen_mult_node_reuse_info 8322
typedef t__gen__gen_mult_node_reuse_info t__gen_mult_node_reuse_info;
#define d__gen_mult_node_reuse_info d__gen__gen_mult_node_reuse_info

/* line 72 "/vobs/specman/src/gen/gen_sa_structs.e"  From 'struct definition' */
typedef struct s__sn__gen_sa_node {
    t__int d__;
    t__int gen__;
    t__uint id;
} *t__sn__gen_sa_node;
#define d__sn__gen_sa_node 6459
typedef t__sn__gen_sa_node t__gen_sa_node;
#define d__gen_sa_node d__sn__gen_sa_node

/* line 52 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_slm_multiplicit86158 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition *lace_cond;
    t__int node_count;
    struct s__sn_rl__uint_rl *ids_range;
    struct s__l__int *new_solver_nodes_ids;
    t__sn__gen_solver_node_type var_type;
    struct s__sn_rl__scalar_rl *rl;
    t__int size_in_bits;
    struct s__sn_rl__scalar_rl *rl_soft_default_val;
    struct s__sn__gen_slm_mult_node_i87982 *iterator;
    struct s__sn__gen_sa_input_node *input;
    struct s__l__sn__gen_slm_multipli96952 *mult_nodes;
    t__int input_solver_id;
} *t__sn__gen_slm_multiplicity_input;
#define d__sn__gen_slm_multiplicity_input 8250
typedef t__sn__gen_slm_multiplicity_input t__gen_slm_multiplicity_input;
#define d__gen_slm_multiplicity_input d__sn__gen_slm_multiplicity_input

/* line 85 "/vobs/specman/src/gen/gen_slm_policies_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_pass_policy {
    t__int d__;
    t__int gen__;
    t__bool f__void;
    struct s__sn__gen_distribution *pass_distribution;
} *t__sn__gen_pass_policy;
#define d__sn__gen_pass_policy 8456
typedef t__sn__gen_pass_policy t__gen_pass_policy;
#define d__gen_pass_policy d__sn__gen_pass_policy

/* line 58 "/vobs/specman/src/gen/gen_slm_solver_api.e"  From 'struct definition' */
typedef struct s__sn__gen_distribution {
    t__int d__;
    t__int gen__;
} *t__sn__gen_distribution;
#define d__sn__gen_distribution 8253
typedef t__sn__gen_distribution t__gen_distribution;
#define d__gen_distribution d__sn__gen_distribution

/* line 89 "/vobs/specman/src/gen/gen_slm_policies_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_others_policy {
    t__int d__;
    t__int gen__;
    t__bool f__void;
} *t__sn__gen_others_policy;
#define d__sn__gen_others_policy 8457
typedef t__sn__gen_others_policy t__gen_others_policy;
#define d__gen_others_policy d__sn__gen_others_policy

/* line 65 "/vobs/specman/src/gen/gen_slm_policies_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_edges_policy {
    t__int d__;
    t__int gen__;
    t__bool f__void;
} *t__sn__gen_edges_policy;
#define d__sn__gen_edges_policy 8450
typedef t__sn__gen_edges_policy t__gen_edges_policy;
#define d__gen_edges_policy d__sn__gen_edges_policy

/* line 66 "/vobs/specman/src/gen/gen_slm_policies_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_min_policy {
    t__int d__;
    t__int gen__;
    t__bool f__void;
} *t__sn__gen_min_policy;
#define d__sn__gen_min_policy 8451
typedef t__sn__gen_min_policy t__gen_min_policy;
#define d__gen_min_policy d__sn__gen_min_policy

/* line 67 "/vobs/specman/src/gen/gen_slm_policies_hdr.e"  From 'struct definition' */
typedef struct s__sn__gen_max_policy {
    t__int d__;
    t__int gen__;
    t__bool f__void;
} *t__sn__gen_max_policy;
#define d__sn__gen_max_policy 8452
typedef t__sn__gen_max_policy t__gen_max_policy;
#define d__gen_max_policy d__sn__gen_max_policy

/* line 1297 "/vobs/specman/src/gen/specman_rl_ext.e"  From 'struct definition' */
typedef struct s__sn_rl__short_enum_rl {
    t__int d__;
    t__int gen__;
    t__uint bitmap;
} *t__sn_rl__short_enum_rl;
#define d__sn_rl__short_enum_rl 8052
typedef t__sn_rl__short_enum_rl t__short_enum_rl;
#define d__short_enum_rl d__sn_rl__short_enum_rl

/* line 1295 "/vobs/specman/src/gen/specman_rl_ext.e"  From 'struct definition' */
typedef struct s__sn_rl__long_enum_rl {
    t__int d__;
    t__int gen__;
    struct s__sn__enum_descriptor *type;
    struct s__l__uint *bitmap;
    t__uint size_flags;
} *t__sn_rl__long_enum_rl;
#define d__sn_rl__long_enum_rl 8050
typedef t__sn_rl__long_enum_rl t__long_enum_rl;
#define d__long_enum_rl d__sn_rl__long_enum_rl

/* line 13 "/vobs/specman/src/gen/gen_reflection_structs.e"  From 'struct definition' */
typedef struct s__sn__rf_gen_manager {
    t__int d__;
    t__int gen__;
} *t__sn__rf_gen_manager;
#define d__sn__rf_gen_manager 8691
typedef t__sn__rf_gen_manager t__rf_gen_manager;
#define d__rf_gen_manager d__sn__rf_gen_manager

/* line 13 "/vobs/specman/src/gen/gen_limitations_util.e"  From 'struct definition' */
typedef struct s__gen__gen_limitations_util {
    t__int d__;
    t__int gen__;
    t__bool limitation_found;
} *t__gen__gen_limitations_util;
#define d__gen__gen_limitations_util 8846
typedef t__gen__gen_limitations_util t__gen_limitations_util;
#define d__gen_limitations_util d__gen__gen_limitations_util

/* line 124 "/vobs/specman/src/gen/tc_util_top.e"  From 'struct definition' */
typedef struct s__sn__test_case_e_code {
    t__int d__;
    t__int gen__;
    struct s__l__sn__etx_type *all_types;
    struct s__sn__gen_rt_record *rt_record;
    t__int meth_cnt;
    struct s__reflection__rf_type *instance_type;
    struct s__l__sn__etx_constraint *keeping_cons;
    struct s__k__sn__input_map__i *input_maps;
    struct s__sn__gen_sa_cc_graph *graph;
    struct s__l__sn__etx_ref_local *locals;
    t__string name;
    struct s__l__string *warnings;
    t__bool already_had_soft;
    t__bool automatic_tc_done;
} *t__sn__test_case_e_code;
#define d__sn__test_case_e_code 8859
typedef t__sn__test_case_e_code t__test_case_e_code;
#define d__test_case_e_code d__sn__test_case_e_code

/* line 81 "/vobs/specman/src/gen/tc_util_top.e"  From 'struct definition' */
typedef struct s__sn__etx_type {
    t__int d__;
    t__int gen__;
    t__bool created;
    t__string name;
    t__string str;
    t__string default_val;
} *t__sn__etx_type;
#define d__sn__etx_type 8856
typedef t__sn__etx_type t__etx_type;
#define d__etx_type d__sn__etx_type

/* line 87 "/vobs/specman/src/gen/tc_util_top.e"  From 'struct definition' */
typedef struct s__sn__etx_constraint {
    t__int d__;
    t__int gen__;
    t__bool created;
} *t__sn__etx_constraint;
#define d__sn__etx_constraint 8857
typedef t__sn__etx_constraint t__etx_constraint;
#define d__etx_constraint d__sn__etx_constraint

/* line 885 "/vobs/specman/src/gen/tc_util_top.e"  From 'struct definition' */
typedef struct s__sn__input_map {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_input_node *i;
    t__string val;
} *t__sn__input_map;
#define d__sn__input_map 8860
typedef t__sn__input_map t__input_map;
#define d__input_map d__sn__input_map

/* line 890 "/vobs/specman/src/gen/tc_util_top.e"  From 'struct definition' */
typedef struct s__sn__etx_ref_local {
    t__int d__;
    t__int gen__;
    t__bool created;
    t__string name;
    struct s__sn__etx_type *type;
    struct s__sn__local *ref;
} *t__sn__etx_ref_local;
#define d__sn__etx_ref_local 8861
typedef t__sn__etx_ref_local t__etx_ref_local;
#define d__etx_ref_local d__sn__etx_ref_local

/* line 528 "/vobs/specman/src/gen_common.e"  From 'struct definition' */
typedef struct s__sn__linter_manager {
    t__int d__;
    t__int gen__;
    t__gen__t_mode mode;
    t__bool debug;
    t__string filter;
    t__gen__t_appears_in appears_in;
    struct s__reflection__rf_struct *current_struct;
    struct s__gen__linter_constraint_info *current_constraint;
    struct s__sn__st_exp *current_gen_root;
    struct s__l__sn__st_method_call_exp *methods_stack;
    t__uint method_index;
    struct s__reflection__rf_struct *pointer_to_sys;
    t__bool lint_idcfs;
    t__bool show_stack;
    struct s__l__gen__linter_error *errors;
    struct s__l__sn__checked_method *wip_methods;
    struct s__l__sn__checked_method *checked_methods;
    struct s__l__sn__st_node *g5_params;
} *t__sn__linter_manager;
#define d__sn__linter_manager 2111
typedef t__sn__linter_manager t__linter_manager;
#define d__linter_manager d__sn__linter_manager

/* line 59 "/vobs/specman/src/gen/gen_linter_defs.e"  From 'struct definition' */
typedef struct s__gen__linter_constraint_info {
    t__int d__;
    t__int gen__;
    struct s__reflection__st_constraint *constraint;
    struct s__l__sn__st_field_access_exp *prefix_list;
    t__bool list_computed;
    struct s__l__sn__st_named_is_a_exp *is_a_list;
} *t__gen__linter_constraint_info;
#define d__gen__linter_constraint_info 8807
typedef t__gen__linter_constraint_info t__linter_constraint_info;
#define d__linter_constraint_info d__gen__linter_constraint_info

/* line 255 "/vobs/specman/src/syntax_exp.e"  From 'struct definition' */
typedef struct s__sn__st_field_access_exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__exp *ntv_exp;
    struct s__sn__explicit_exp *explicit_exp;
    struct s__sn__type_descriptor *base_type;
    struct s__sn__n__exp *ntv_target;
    struct s__sn__st_exp *target;
    struct s__sn__field *f;
    t__string field_name;
    t__untyped obj;
    void *_field___ptr_padding[4];
    int _field___int_padding[2];
    struct s__reflection__rf_field *field;
} *t__sn__st_field_access_exp;
#define d__sn__st_field_access_exp 702
typedef t__sn__st_field_access_exp t__st_field_access_exp;
#define d__st_field_access_exp d__sn__st_field_access_exp

/* line 794 "/vobs/specman/src/as_a.e"  From 'struct definition' */
typedef struct s__sn__st_named_is_a_exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__exp *ntv_exp;
    struct s__sn__explicit_exp *explicit_exp;
    struct s__sn__type_descriptor *base_type;
    t__int expected_size;
    t__sn__sn_as_a_kind logic;
    struct s__sn__type_descriptor *to_type;
    struct s__sn__st_exp *child;
    struct s__sn__is_a_local *local;
    struct s__sn__st_local_exp *st_local;
} *t__sn__st_named_is_a_exp;
#define d__sn__st_named_is_a_exp 748
typedef t__sn__st_named_is_a_exp t__st_named_is_a_exp;
#define d__st_named_is_a_exp d__sn__st_named_is_a_exp

/* line 1249 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__is_a_local {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__sn__type_descriptor *base_type;
    t__int index;
    struct s__sn__scope *scope;
    t__int sn_attr;
    t__string orig_string;
} *t__sn__is_a_local;
#define d__sn__is_a_local 204
typedef t__sn__is_a_local t__is_a_local;
#define d__is_a_local d__sn__is_a_local

/* line 479 "/vobs/specman/src/method_call.e"  From 'struct definition' */
typedef struct s__sn__st_method_call_exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__st_node *parent;
    t__int sn_attr;
    struct s__sn__n__exp *ntv_exp;
    struct s__sn__explicit_exp *explicit_exp;
    struct s__sn__type_descriptor *base_type;
    struct s__l__sn__st_exp *params;
    struct s__l__sn__n__rhs_exp *ntv_rhs_args;
    struct s__sn__n__exp *ntv_target;
    struct s__sn__st_exp *target;
    struct s__sn__method *method;
    t__int index_in_struct;
    t__bool under_constraint;
    t__bool keep_err_ntv;
    struct s__sn__struct_descriptor *downcast_type;
    t__string downcast_err_str;
    void *_current_obj___ptr_padding[4];
    t__untyped current_obj;
} *t__sn__st_method_call_exp;
#define d__sn__st_method_call_exp 735
typedef t__sn__st_method_call_exp t__st_method_call_exp;
#define d__st_method_call_exp d__sn__st_method_call_exp

/* line 221 "/vobs/specman/src/basic_exp.e"  From 'struct definition' */
typedef struct s__sn__n__rhs_exp {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__bool indirect;
    struct s__sn__local *local;
    t__string downcast_err_str;
} *t__sn__n__rhs_exp;
#define d__sn__n__rhs_exp 673
typedef t__sn__n__rhs_exp t__n__rhs_exp;
#define d__n__rhs_exp d__sn__n__rhs_exp

/* line 70 "/vobs/specman/src/gen/gen_linter_error.e"  From 'struct definition' */
typedef struct s__gen__linter_error {
    t__int d__;
    t__int gen__;
    t__string warn_str;
    t__string name;
    t__source_ref source_ref;
    t__string methods_source_ref;
    t__bool has_unenc;
} *t__gen__linter_error;
#define d__gen__linter_error 8817
typedef t__gen__linter_error t__linter_error;
#define d__linter_error d__gen__linter_error

/* line 2 "/vobs/specman/src/gen/gen_linter_db.e"  From 'struct definition' */
typedef struct s__sn__checked_method {
    t__int d__;
    t__int gen__;
    t__string method_name;
    struct s__reflection__rf_struct *current_struct;
    struct s__sn__st_exp *current_gen_root;
    t__gen__t_appears_in appears_in;
} *t__sn__checked_method;
#define d__sn__checked_method 8819
typedef t__sn__checked_method t__checked_method;
#define d__checked_method d__sn__checked_method

/* line 341 "/vobs/specman/src/shlibs.e"  From 'struct definition' */
typedef struct s__sn__sn_shlibs {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_library *libraries;
    t__bool trace;
    struct s__l__string *trace_matches;
    t__string lib_only;
} *t__sn__sn_shlibs;
#define d__sn__sn_shlibs 2152
typedef t__sn__sn_shlibs t__sn_shlibs;
#define d__sn_shlibs d__sn__sn_shlibs

/* line 523 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_util {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__k__e_core__sn_component34126 *component_list;
    struct s__l__e_core__sn_component *pre_components;
    struct s__vt__sn_time_sample *m_last_time_sample;
    t__int m_time_sample_counter;
    struct s__sn__vt_doc *vt_doc;
    struct s__k__string__it *sn_util___evc_names;
} *t__sn__sn_util;
#define d__sn__sn_util 1512
typedef t__sn__sn_util t__sn_util;
#define d__sn_util d__sn__sn_util

/* line 600 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_component {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string version;
} *t__e_core__sn_component;
#define d__e_core__sn_component 69
typedef t__e_core__sn_component t__sn_component;
#define d__sn_component d__e_core__sn_component

/* line 70 "/vobs/specman/src/vt_util/vt_util_edoc.e"  From 'struct definition' */
typedef struct s__sn__vt_doc {
    t__int d__;
    t__int gen__;
    struct s__l__reflection__rf_erm_p75752 *packages;
    struct s__l__reflection__rf_module *modules;
    struct s__k__sn__edoc_rf_struct__name *all_structs;
    struct s__l__reflection__rf_scalar *all_scalar_types;
    struct s__l__reflection__rf_struct *all_method_types;
    struct s__l__vt__vt_table *all_tables;
    t__string html_file;
    t__bool is_data_extracted;
    t__bool resort_structs;
    t__bool remake_rf;
    t__bool remake_tables;
    t__bool remake_html;
    t__bool sort_alphabetic_flag;
    t__bool vt_display_flag;
    t__string filename;
    t__string title;
    t__uint num_of_user_structs;
    t__bool user_order;
    t__bool show_rest;
    struct s__l__string *shadow_base_structs;
    struct s__l__sn__edoc_encapsulation_t *encapsulations_shown;
    t__bool show_when_documentation_location;
    t__string mif_contents_table_format;
    t__string mif_struct_members_table_format;
    t__string mif_types_table_format;
    t__string mif_contents_table_title_format;
    struct s__l__string *mif_contents_table_heading_formats;
    struct s__l__string *mif_contents_table_cell_formats;
    t__string mif_struct_members_table_title_format;
    struct s__l__string *mif_struct_members_table_heading_formats;
    struct s__l__string *mif_struct_members_table_cell_formats;
    t__string mif_types_table_title_format;
    struct s__l__string *mif_types_table_heading_formats;
    struct s__l__string *mif_types_table_cell_formats;
    t__string mif_struct_members_name_font;
    t__string mif_struct_members_encap_font;
    t__bool mif_show_sequence_subtypes_table;
    t__bool mif_type_params_newline;
    t__string mif_scalar_types_name_font;
    t__string mif_units;
    struct s__l__uint *mif_contents_column_widths;
    struct s__l__uint *mif_struct_members_column_widths;
    struct s__l__uint *mif_types_column_widths;
    t__string mif_contents_table_title;
    t__string mif_types_table_title;
    t__string mif_contents_xref_font;
    t__string mif_types_xref_font;
    t__string mif_structs_heading_format;
    t__string mif_types_heading_format;
    t__bool mif_types_show_enum_values;
    t__string mif_read_only_tag;
    struct s__l__string *mif_read_only_effect;
    t__string mif_non_documented_tag;
    t__string mif_sequence_start_tag;
    t__string mif_sequence_end_tag;
    t__string mif_driver_start_tag;
    t__string mif_driver_end_tag;
    struct s__l__string *mif_markup;
    t__uint mif_curr_table_id;
    struct s__l__string *mif_decl;
    struct s__l__string *mif_textflow;
} *t__sn__vt_doc;
#define d__sn__vt_doc 7895
typedef t__sn__vt_doc t__vt_doc;
#define d__vt_doc d__sn__vt_doc

/* line 630 "/vobs/specman/src/vt_util/vt_util_edoc.e"  From 'struct definition' */
typedef struct s__sn__edoc_rf_struct {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__reflection__rf_like_struct *the_struct;
    struct s__l__sn__edoc_members_lis80449 *member_list_wrappers;
    t__bool is_user_selected;
    t__bool is_user_deselected;
} *t__sn__edoc_rf_struct;
#define d__sn__edoc_rf_struct 7897
typedef t__sn__edoc_rf_struct t__edoc_rf_struct;
#define d__edoc_rf_struct d__sn__edoc_rf_struct

/* line 739 "/vobs/specman/src/vt_util/vt_util_edoc.e"  From 'struct definition' */
typedef struct s__sn__edoc_members_list_w78540 {
    t__int d__;
    t__int gen__;
    struct s__k__sn__edoc_rf_struct_m78543 *the_members;
    t__sn__edoc_struct_member_category_t category;
    struct s__sn__edoc_select_options *select_opts;
} *t__sn__edoc_members_list_wrapper;
#define d__sn__edoc_members_list_wrapper 7898
typedef t__sn__edoc_members_list_wrapper t__edoc_members_list_wrapper;
#define d__edoc_members_list_wrapper d__sn__edoc_members_list_wrapper

/* line 591 "/vobs/specman/src/vt_util/vt_util_edoc.e"  From 'struct definition' */
typedef struct s__sn__edoc_rf_struct_member {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__reflection__rf_struct_member *the_member;
    t__sn__edoc_encapsulation_t encapsulation;
    t__bool is_user_selected;
    t__bool is_user_deselected;
} *t__sn__edoc_rf_struct_member;
#define d__sn__edoc_rf_struct_member 7896
typedef t__sn__edoc_rf_struct_member t__edoc_rf_struct_member;
#define d__edoc_rf_struct_member d__sn__edoc_rf_struct_member

/* line 1126 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_struct_member {
    t__int d__;
    t__int gen__;
} *t__reflection__rf_struct_member;
#define d__reflection__rf_struct_member 1733
typedef t__reflection__rf_struct_member t__rf_struct_member;
#define d__rf_struct_member d__reflection__rf_struct_member

/* line 772 "/vobs/specman/src/vt_util/vt_util_edoc.e"  From 'struct definition' */
typedef struct s__sn__edoc_select_options {
    t__int d__;
    t__int gen__;
    t__bool user_order;
    t__bool show_rest;
    t__bool resort;
    t__uint num_of_user_requests;
} *t__sn__edoc_select_options;
#define d__sn__edoc_select_options 7899
typedef t__sn__edoc_select_options t__edoc_select_options;
#define d__edoc_select_options d__sn__edoc_select_options

/* line 946 "/vobs/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__reflection__rf_scalar {
    t__int d__;
    t__int gen__;
} *t__reflection__rf_scalar;
#define d__reflection__rf_scalar 1727
typedef t__reflection__rf_scalar t__rf_scalar;
#define d__rf_scalar d__reflection__rf_scalar

/* line 321 "/vobs/specman/src/pre_display.e"  From 'struct definition' */
typedef struct s__sn__sn_patches {
    t__int d__;
    t__int gen__;
    struct s__k__e_core__sn_patch__in34127 *all_patches;
    struct s__l__e_core__sn_patch *pre_patches;
    struct s__sn__sn_command_option_parser *patch_parser;
} *t__sn__sn_patches;
#define d__sn__sn_patches 2279
typedef t__sn__sn_patches t__sn_patches;
#define d__sn_patches d__sn__sn_patches

/* line 507 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__e_core__sn_patch {
    t__int d__;
    t__int gen__;
    t__string info_key;
    t__string id;
    struct s__l__string *specman_releases;
    t__sn__severity_error sn_version_mismatch_policy;
    t__string component;
    struct s__l__string *component_releases;
    t__sn__severity_error component_version_mismatch_policy;
    t__bool error_no_component;
    struct s__l__string *ccrs;
    struct s__l__string *related_ccrs;
    t__string date;
    struct s__l__string *authors;
    t__string description;
    t__string patch_file_name;
    struct s__l__string *contradicts;
    struct s__l__string *requires;
    t__bool compiled;
    t__string error_message;
    t__bool no_sn_release_entry;
    t__bool specman_ver_match;
    t__bool component_ver_match;
} *t__e_core__sn_patch;
#define d__e_core__sn_patch 63
typedef t__e_core__sn_patch t__sn_patch;
#define d__sn_patch d__e_core__sn_patch

/* line 14 "/vobs/specman/src/command_with_options.e"  From 'struct definition' */
typedef struct s__sn__sn_command_option_parser {
    t__int d__;
    t__int gen__;
    t__string context;
    struct s__k__sn__sn_command_optio34129 *descriptors;
} *t__sn__sn_command_option_parser;
#define d__sn__sn_command_option_parser 4279
typedef t__sn__sn_command_option_parser t__sn_command_option_parser;
#define d__sn_command_option_parser d__sn__sn_command_option_parser

/* line 3 "/vobs/specman/src/command_with_options.e"  From 'struct definition' */
typedef struct s__sn__sn_command_option_d32215 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__bool just_one_value;
    t__bool required;
} *t__sn__sn_command_option_descriptor;
#define d__sn__sn_command_option_descriptor 4277
typedef t__sn__sn_command_option_descriptor t__sn_command_option_descriptor;
#define d__sn_command_option_descriptor d__sn__sn_command_option_descriptor

/* line 573 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_stat_selector {
    t__int d__;
    t__int gen__;
} *t__sn__sn_stat_selector;
#define d__sn__sn_stat_selector 2317
typedef t__sn__sn_stat_selector t__sn_stat_selector;
#define d__sn_stat_selector d__sn__sn_stat_selector

/* line 579 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_live_stat_selector {
    t__int d__;
    t__int gen__;
} *t__sn__sn_live_stat_selector;
#define d__sn__sn_live_stat_selector 2318
typedef t__sn__sn_live_stat_selector t__sn_live_stat_selector;
#define d__sn_live_stat_selector d__sn__sn_live_stat_selector

/* line 591 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_dead_stat_selector {
    t__int d__;
    t__int gen__;
} *t__sn__sn_dead_stat_selector;
#define d__sn__sn_dead_stat_selector 2319
typedef t__sn__sn_dead_stat_selector t__sn_dead_stat_selector;
#define d__sn_dead_stat_selector d__sn__sn_dead_stat_selector

/* line 790 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_only_walk {
    t__int d__;
    t__int gen__;
} *t__sn__sn_struct_only_walk;
#define d__sn__sn_struct_only_walk 2326
typedef t__sn__sn_struct_only_walk t__sn_struct_only_walk;
#define d__sn_struct_only_walk d__sn__sn_struct_only_walk

/* line 796 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_list_walk {
    t__int d__;
    t__int gen__;
} *t__sn__sn_list_walk;
#define d__sn__sn_list_walk 2327
typedef t__sn__sn_list_walk t__sn_list_walk;
#define d__sn_list_walk d__sn__sn_list_walk

/* line 802 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_everything_walk {
    t__int d__;
    t__int gen__;
} *t__sn__sn_everything_walk;
#define d__sn__sn_everything_walk 2328
typedef t__sn__sn_everything_walk t__sn_everything_walk;
#define d__sn_everything_walk d__sn__sn_everything_walk

/* line 814 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_gather_walk {
    t__int d__;
    t__int gen__;
} *t__sn__sn_gather_walk;
#define d__sn__sn_gather_walk 2330
typedef t__sn__sn_gather_walk t__sn_gather_walk;
#define d__sn_gather_walk d__sn__sn_gather_walk

/* line 787 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_deep_walk {
    t__int d__;
    t__int gen__;
} *t__sn__sn_deep_walk;
#define d__sn__sn_deep_walk 2325
typedef t__sn__sn_deep_walk t__sn_deep_walk;
#define d__sn_deep_walk d__sn__sn_deep_walk

/* line 777 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_shallow_walk {
    t__int d__;
    t__int gen__;
} *t__sn__sn_shallow_walk;
#define d__sn__sn_shallow_walk 2324
typedef t__sn__sn_shallow_walk t__sn_shallow_walk;
#define d__sn_shallow_walk d__sn__sn_shallow_walk

/* line 805 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_walk_mark {
    t__int d__;
    t__int gen__;
} *t__sn__sn_walk_mark;
#define d__sn__sn_walk_mark 2329
typedef t__sn__sn_walk_mark t__sn_walk_mark;
#define d__sn_walk_mark d__sn__sn_walk_mark

/* line 1317 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__sn_mem_logger {
    t__int d__;
    t__int gen__;
    t__external_pointer file;
    t__int sample_id;
    t__int level;
} *t__sn__sn_mem_logger;
#define d__sn__sn_mem_logger 2344
typedef t__sn__sn_mem_logger t__sn_mem_logger;
#define d__sn_mem_logger d__sn__sn_mem_logger

/* line 1748 "/vobs/specman/src/show_mem.e"  From 'struct definition' */
typedef struct s__sn__unit_size {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *unit;
    struct s__sn__sn_uintptr_t *self;
    struct s__sn__sn_uintptr_t *selfplus;
    struct s__sn__unit_size *parent;
    struct s__l__e_core__any_unit *children;
} *t__sn__unit_size;
#define d__sn__unit_size 2346
typedef t__sn__unit_size t__unit_size;
#define d__unit_size d__sn__unit_size

/* line 25 "/vobs/specman/src/help_html.e"  From 'struct definition' */
typedef struct s__sn__help_index {
    t__int d__;
    t__int gen__;
    struct s__l__string *lines;
    struct s__l__sn__line_kind *kinds;
    struct s__l__int *levels;
    struct s__l__string *text;
    struct s__l__int *starts;
    struct s__l__string *word_patterns;
    struct s__l__bool *matched_words;
    t__string fast_pattern;
    t__int level;
    t__int max_level;
    struct s__l__bool *found;
    struct s__l__int *start_levels;
    struct s__l__sn__word_indices *indices_stack;
    struct s__l__string *output_lines;
    t__string full_path;
    t__string index_file;
    t__bool none_found;
} *t__sn__help_index;
#define d__sn__help_index 2362
typedef t__sn__help_index t__help_index;
#define d__help_index d__sn__help_index

/* line 19 "/vobs/specman/src/help_html.e"  From 'struct definition' */
typedef struct s__sn__word_indices {
    t__int d__;
    t__int gen__;
    struct s__l__int *inds;
    t__int nleft;
    t__int line_no;
} *t__sn__word_indices;
#define d__sn__word_indices 2361
typedef t__sn__word_indices t__word_indices;
#define d__word_indices d__sn__word_indices

/* line 150 "/vobs/specman/src/interactor.e"  From 'struct definition' */
typedef struct s__sn__interact {
    t__int d__;
    t__int gen__;
    t__uint max_socket_buffer;
    t__bool stdin_is_ready;
} *t__sn__interact;
#define d__sn__interact 2391
typedef t__sn__interact t__interact;
#define d__interact d__sn__interact

/* line 31 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__sn_vt {
    t__int d__;
    t__int gen__;
    t__string HTML_NEWLINE;
    t__string HTML_SPACE;
    t__string HTML_HORIZONTAL_LINE;
    struct s__vt__vt_user_action *VT_TOOLBAR_SEPERATOR;
    t__string UNDEFINED_STRING;
    t__string FILE_MENU_TITLE;
    t__string EDIT_MENU_TITLE;
    t__string VIEW_MENU_TITLE;
    t__string OPTIONS_MENU_TITLE;
    t__string TOOLS_MENU_TITLE;
    t__int LEFT;
    t__int CENTER;
    t__int RIGHT;
    struct s__vt__vt_factory *factory;
    struct s__k__vt__vt_style_props__16666 *all_styles;
    struct s__l__string *p_pseudo_methods;
    struct s__k__vt__sn_vt_buffer__name *buffers;
    struct s__l__vt__sn_vt_buffer *list_buffers;
    struct s__vt__sn_vt_buffer *current_buffer;
    t__string et_dir;
    t__imp_enum_vt__sn_vt__trace trace;
    struct s__l__string *p___templatize_result;
    t__int MIN_WIDGET_SIZE;
    t__int MAX_WIDGET_SIZE;
    t__int MIN_BORDER_WIDTH;
    t__int MAX_BORDER_WIDTH;
    t__int MIN_MARGINS_SIZE;
    t__int MAX_MARGINS_SIZE;
    t__int MIN_FONT_SIZE;
    t__int MAX_FONT_SIZE;
    struct s__vt__vt_element_factory *element_factory;
    struct s__vt__vt_html_native *ELEM_NEWLINE;
    struct s__vt__vt_html_native *ELEM_SPACE;
    struct s__vt__vt_file_filter *FILE_FILTER_ALL_FILES;
    struct s__vt__vt_file_filter *FILE_FILTER_E_FILES;
    struct s__vt__vt_action_factory *action_factory;
    t__string MAIN_TOOLBAR;
    t__string APPL_TOOLBAR;
    t__string FILE_MENU;
    t__string EDIT_MENU;
    t__string VIEW_MENU;
    t__string OPTIONS_MENU;
    t__string WINDOW_MENU;
    t__string HELP_MENU;
    t__string NAVIGATION_ACTIONS;
    t__string TOOLBAR_ACTIONS;
    t__string PREV_ACTION;
    t__string NEXT_ACTION;
    t__string SHOW_TOOLBAR_ACTION;
    t__string TEXT_AND_ICON_ACTION;
    t__string ICON_ONLY_ACTION;
    t__string TEXT_ONLY_ACTION;
    t__string LOCK_ACTION;
    t__string CLOSE_ACTION;
    t__string FIND_ACTION;
    t__string BROWSER_ACTION;
    t__string SHOW_HTML_SOURCE_ACTION;
    t__string SHOW_HELP_ACTION;
    t__string OPEN_FILE_ACTION;
    t__string SAVE_FILE_AS_ACTION;
    t__string EXPORT_TO_CSV_ACTION;
    struct s__vt__vt_html_defaults *html_defaults;
    struct s__l__string *EMPTY_STR_LIST;
    struct s__vt__vt_container_manager *panman;
    struct s__vt__vt_table_manager *tm;
    struct s__vt__vt_filter_manager *fm;
    struct s__vt__vt_export_multi_table *emt;
    t__string icon_verisity;
    t__string icon_dir;
    t__string icon_e_file;
    t__string icon_text_file;
    t__string icon_html_file;
    t__string icon_image_file;
    t__string icon_binary_file;
    t__string icon_other_file;
    t__string icon_not_found;
    t__string icon_ecov_file;
    t__string icon_ecom_file;
    t__string icon_log_file;
    t__string icon_esv_file;
    t__string icon_prev;
    t__string icon_next;
    t__string icon_mixed_toolbar_both;
    t__string icon_sunken_mixed_toolbar_both;
    t__string icon_mixed_toolbar_icon;
    t__string icon_sunken_mixed_toolbar_icon;
    t__string icon_mixed_toolbar_text;
    t__string icon_sunken_mixed_toolbar_text;
    t__string icon_lock;
    t__string icon_lock_sel;
    t__string icon_stop;
    t__string icon_close;
    t__string icon_find;
    t__string icon_web_browser;
    t__string icon_source;
    t__string icon_help;
    t__string icon_open_file;
    t__string icon_save_as_file;
    t__string icon_refresh;
    t__string vm_icon_export_csv;
    t__string icon_visualization;
    struct s__e_core__source_item *temp_src_item;
    t__int DEFAULT_WINDOW_X;
    t__int DEFAULT_WINDOW_Y;
    t__int DEFAULT_WINDOW_WIDTH;
    t__int DEFAULT_WINDOW_HEIGHT;
    t__int ANY_WINDOW_DEFAULT_WIDTH;
    t__int ANY_WINDOW_DEFAULT_HEIGHT;
    t__string HTML_ATTR_SN_NAME;
    t__string HTML_ATTR_VALUE;
    t__string HTML_ATTR_TYPE;
    t__string HTML_ATTR_SIZE;
    t__string HTML_ATTR_WIDTH;
    t__string HTML_ATTR_CELL_WIDTH;
    t__string HTML_ATTR_SN_CMD;
    t__string HTML_ATTR_TOOLTIP;
    t__string HTML_ATTR_SRC;
    t__string HTML_ATTR_HREF;
    t__string HTML_TAG_A;
    t__string HTML_TAG_INPUT;
    t__string HTML_TAG_OPTION;
    t__int FILE_MENU_LEVEL;
    t__int EDIT_MENU_LEVEL;
    t__int VIEW_MENU_LEVEL;
    t__int OPTIONS_MENU_LEVEL;
    t__int WINDOW_MENU_LEVEL;
    t__int HELP_MENU_LEVEL;
    t__int PREV_ACTION_LEVEL;
    t__int NEXT_ACTION_LEVEL;
    t__int SHOW_TOOLBAR_ACTION_LEVEL;
    t__int TEXT_AND_ICON_ACTION_LEVEL;
    t__int ICON_ONLY_ACTION_LEVEL;
    t__int TEXT_ONLY_ACTION_LEVEL;
    t__int LOCK_ACTION_LEVEL;
    t__int CLOSE_ACTION_LEVEL;
    t__string SN_SEPARATOR;
    t__string SN_SPACE_FILLER;
    t__string SN_MENUBAR;
    struct s__l__vt__vt_window *all_windows;
    t__int page_id_counter;
    t__int next_win_id;
    t__vt__vt_gui_refresh_mode m_default_gui_refresh_mode;
    struct s__vt__sn_time_sample *m_time_sample;
    struct s__vt__vt_file_chooser_manager *file_chooser_manager;
    t__bool show_dir_images;
    struct s__l__vt__vt_file_kind *lst_file_kinds_filter;
    t__string HTML_SOURCE_COMMENT;
    t__string START_FIXED_FONT;
    t__string END_FIXED_FONT;
    t__string VT_WINDOW_DEFAULT_TITLE_PREFIX;
    t__int THUMBNAIL_HEIGHT;
    t__int THUMBNAIL_WIDTH;
    t__bool checked_13_warning;
    struct s__vt__jvt_service_deli *p_jvt_deli;
    struct s__vt__sni_evt_service *p_evt_service;
    t__bool vt_extended_mode;
    struct s__l__string *UNDEFINED_STRING_LIST;
    struct s__l__string *EMPTY_LIST;
    struct s__vt__vt_utils *utils;
    struct s__k__vt__vt_file_kind_dat39736 *file_kind_data_list;
    struct s__k__vt__vt_temp_file_dat39738 *m_shared_temp_files;
    t__string GO_NEXT_ACTION;
    t__string GO_BACK_ACTION;
    t__string MAIN_STATUS_PANE;
    t__int counter;
    t__string html_path_re;
    t__string html_img_pref_re;
    t__string html_href_pref_re;
    t__string html_img_re;
    t__string html_href_re;
    t__string encode_str;
    struct s__l__string *WIDGET_TAG_NAMES;
    struct s__k__vt__vt_widget_window39739 *all_open_widget_windows;
    t__int tree_node_counter;
    struct s__k__vt__sn_tree_node_pai39741 *hash_of_sn_tree_node_pairs;
    struct s__l__vt__sn_vt_box *boxes;
    t__bool m_use_eid_only;
    struct s__k__vt__vt_predefined_me48627 *m_predefined_menus_data;
    struct s__k__vt__vt_predefined_ac48628 *m_predefined_actions_data;
    struct s__k__vt__vt_predefined_gr48630 *m_predefined_groups_data;
    t__string BLANK;
    t__string BLANK2;
    t__string BLANK4;
    t__string BLANK8;
    t__string GTMARK;
    t__string GTMARK2;
    t__string LTMARK;
    t__string LTMARK2;
    struct s__l__vt__vt_color *dark_colors;
} *t__vt__sn_vt;
#define d__vt__sn_vt 2521
typedef t__vt__sn_vt t__sn_vt;
#define d__sn_vt d__vt__sn_vt

/* line 105 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_factory {
    t__int d__;
    t__int gen__;
} *t__vt__vt_factory;
#define d__vt__vt_factory 2524
typedef t__vt__vt_factory t__vt_factory;
#define d__vt_factory d__vt__vt_factory

/* line 230 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_style_props {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__vt__vt_style p_style;
    t__vt__vt_color p_fg;
    t__vt__vt_color p_bg;
} *t__vt__vt_style_props;
#define d__vt__vt_style_props 2551
typedef t__vt__vt_style_props t__vt_style_props;
#define d__vt_style_props d__vt__vt_style_props

/* line 38 "/vobs/specman/src/japp/vt/vt_expand.e"  From 'struct definition' */
typedef struct s__vt__sn_vt_buffer {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__string *lines;
    struct s__sn__module *module;
    t__int line_no;
    struct s__vt__sn_vt_buffer *prev;
} *t__vt__sn_vt_buffer;
#define d__vt__sn_vt_buffer 4751
typedef t__vt__sn_vt_buffer t__sn_vt_buffer;
#define d__sn_vt_buffer d__vt__sn_vt_buffer

/* line 2730 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_element_factory {
    t__int d__;
    t__int gen__;
    t__string SN_ID_KEYWORD;
    t__string SN_IMPLICIT_KEYWORD;
    t__string SN_ID_START_KEYWORD;
    t__string SN_ID_END_KEYWORD;
    t__string SN_EID_PREFIX;
    t__string VALID_EID_TAG_REGEXP;
    t__string INTERACTIVE_ID_PREFIX;
    t__string FULL_INTERACTIVE_ID_PREFIX;
    t__string FULL_INTERACTIVE_ID_PREFIX_RE;
    t__int elem_name_counter;
    t__int elem_id_counter;
    struct s__k__vt__vt_element__m_eid *hash_of_elements_by_eid;
    struct s__vt__vt_image *m_visualization_nonid_image;
} *t__vt__vt_element_factory;
#define d__vt__vt_element_factory 4882
typedef t__vt__vt_element_factory t__vt_element_factory;
#define d__vt_element_factory d__vt__vt_element_factory

/* line 439 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_html_native {
    t__int d__;
    t__int gen__;
    t__string m_name;
    t__string m_id;
    t__string m_eid;
    t__vt__vt_element_kind m_element_kind;
    t__vt__vt_element_basic_kind m_basic_kind;
    t__string m_tooltip;
    t__bool m_internal;
    t__bool m_implicit;
    t__bool m_destroyed;
    t__bool m_static;
    struct s__vt__vt_container *m_parent;
    t__vt__vt_web_export_level m_export_level;
    struct s__vt__vt_web_export_info *m_web_export_info;
    struct s__l__string *m_native_html;
} *t__vt__vt_html_native;
#define d__vt__vt_html_native 4810
typedef t__vt__vt_html_native t__vt_html_native;
#define d__vt_html_native d__vt__vt_html_native

/* line 3183 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_file_filter {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string filter;
    t__string description;
} *t__vt__vt_file_filter;
#define d__vt__vt_file_filter 4885
typedef t__vt__vt_file_filter t__vt_file_filter;
#define d__vt_file_filter d__vt__vt_file_filter

/* line 98 "/vobs/specman/src/japp/vt/vt_menubar_api.e"  From 'struct definition' */
typedef struct s__vt__vt_action_factory {
    t__int d__;
    t__int gen__;
} *t__vt__vt_action_factory;
#define d__vt__vt_action_factory 4941
typedef t__vt__vt_action_factory t__vt_action_factory;
#define d__vt_action_factory d__vt__vt_action_factory

/* line 1413 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_html_defaults {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int SELECT_WIDGET_MIN_WIDTH;
    t__int LISTBOX_DEFAULT_HEIGHT;
    t__int TEXTAREA_DEFAULT_WIDTH;
    t__int TEXTAREA_DEFAULT_HEIGHT;
    t__int TEXTFIELD_DEFAULT_WIDTH;
    t__int PASSWORDFIELD_DEFAULT_WIDTH;
    t__int BUTTON_MIN_WIDTH;
} *t__vt__vt_html_defaults;
#define d__vt__vt_html_defaults 5003
typedef t__vt__vt_html_defaults t__vt_html_defaults;
#define d__vt_html_defaults d__vt__vt_html_defaults

/* line 1568 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_container_manager {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_element_query *QUERY_ANY;
    struct s__vt__vt_element_query *QUERY_INTERNAL;
    struct s__vt__vt_element_query *QUERY_USER;
    struct s__vt__vt_element_query *QUERY_TABLE;
    struct s__vt__vt_element_query *QUERY_TAB_CONTROL;
    struct s__vt__vt_element_query *QUERY_MEMBER_CHECKBOX_ANY;
    struct s__vt__vt_element_query *QUERY_MEMBER_RADIO_BUTTON_ANY;
    struct s__vt__vt_element_query *QUERY_SUBLIST_SELECTOR;
    t__string EID_COLLAPSE_SCRIPT;
    t__string REFORMAT_NEWLINES_SCRIPT;
    t__string NEWLINE_TAG;
    t__string PREDEF_PARENT_NAME;
    t__string PREDEF_ME_NAME;
    t__string PREDEF_PAGE_NAME;
    t__string PREDEF_WINDOW_NAME;
    t__string PREDEF_OLD_WINDOW_NAME;
    struct s__vt__vt_element_query *QUERY_PANEL;
    struct s__vt__vt_element_query *QUERY_STRIPE;
} *t__vt__vt_container_manager;
#define d__vt__vt_container_manager 5004
typedef t__vt__vt_container_manager t__vt_container_manager;
#define d__vt_container_manager d__vt__vt_container_manager

/* line 478 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_element_query {
    t__int d__;
    t__int gen__;
    t__vt__vt_element_kind m_elem_kind;
    t__vt__vt_element_owenr_kind m_owner_kind;
} *t__vt__vt_element_query;
#define d__vt__vt_element_query 4983
typedef t__vt__vt_element_query t__vt_element_query;
#define d__vt_element_query d__vt__vt_element_query

/* line 1919 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_table_manager {
    t__int d__;
    t__int gen__;
    t__string icon_all_page;
    t__string icon_all_page_dis;
    t__string icon_next_page;
    t__string icon_next_page_dis;
    t__string icon_top_page;
    t__string icon_top_page_dis;
    t__string icon_bottom_page;
    t__string icon_bottom_page_dis;
    t__string icon_prev_page;
    t__string icon_prev_page_dis;
    t__string icon_unfilter;
    t__string icon_unfilter_dis;
    t__string icon_hide_filters;
    t__string icon_hide_filters_dis;
    t__string icon_show_filters;
    t__string icon_show_filters_dis;
    t__string icon_unsort;
    t__string icon_unsort_dis;
    t__string icon_empty;
    t__string icon_mark;
    t__string light_icon_sort_asc;
    t__string light_icon_sort_desc;
    t__string dark_icon_sort_asc;
    t__string dark_icon_sort_desc;
    t__string icon_show_status_bar;
    t__string icon_show_status_bar_dis;
    t__string icon_hide_status_bar;
    t__string icon_hide_status_bar_dis;
    t__string icon_unsorted;
    t__string icon_sorted_down;
    t__string icon_sorted_up;
} *t__vt__vt_table_manager;
#define d__vt__vt_table_manager 5019
typedef t__vt__vt_table_manager t__vt_table_manager;
#define d__vt_table_manager d__vt__vt_table_manager

/* line 2001 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_filter_manager {
    t__int d__;
    t__int gen__;
    t__string WRAPPED_ALL;
    struct s__vt__vt_filter *main_filter;
    struct s__l__vt__vt_filter_kind *default_string_filters;
} *t__vt__vt_filter_manager;
#define d__vt__vt_filter_manager 5022
typedef t__vt__vt_filter_manager t__vt_filter_manager;
#define d__vt_filter_manager d__vt__vt_filter_manager

/* line 1998 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_filter {
    t__int d__;
    t__int gen__;
} *t__vt__vt_filter;
#define d__vt__vt_filter 5021
typedef t__vt__vt_filter t__vt_filter;
#define d__vt_filter d__vt__vt_filter

/* line 1995 "/vobs/specman/src/japp/vt/vt_element_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_export_multi_table {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_table *export_table;
    t__string export_dir;
    struct s__l__string *tf_list;
    t__bool is_legal;
    t__string current_tf_data;
    struct s__l__vt__export_table_data *out_data;
    struct s__vt__vt_page *p_original_page;
} *t__vt__vt_export_multi_table;
#define d__vt__vt_export_multi_table 5020
typedef t__vt__vt_export_multi_table t__vt_export_multi_table;
#define d__vt_export_multi_table d__vt__vt_export_multi_table

/* line 748 "/vobs/specman/src/vt_table/vt_table_user_api.e"  From 'struct definition' */
typedef struct s__vt__export_table_data {
    t__int d__;
    t__int gen__;
    t__string table_name;
    t__string file_name;
} *t__vt__export_table_data;
#define d__vt__export_table_data 7825
typedef t__vt__export_table_data t__export_table_data;
#define d__export_table_data d__vt__export_table_data

/* line 206 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_file_chooser_manager {
    t__int d__;
    t__int gen__;
    struct s__k__vt__file_chooser_dat39954 *file_chooser_table;
} *t__vt__vt_file_chooser_manager;
#define d__vt__vt_file_chooser_manager 5048
typedef t__vt__vt_file_chooser_manager t__vt_file_chooser_manager;
#define d__vt_file_chooser_manager d__vt__vt_file_chooser_manager

/* line 3171 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__file_chooser_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string category;
    t__string extension;
    t__string dir;
    t__string fulldir;
    t__string fname;
    t__string fullname;
    struct s__l__string *alldirs;
    struct s__l__string *allfiles;
    struct s__l__string *data;
} *t__vt__file_chooser_data;
#define d__vt__file_chooser_data 4884
typedef t__vt__file_chooser_data t__file_chooser_data;
#define d__file_chooser_data d__vt__file_chooser_data

/* line 1525 "/vobs/specman/src/japp/vt/vt_manager.e"  From 'struct definition' */
typedef struct s__vt__jvt_service_deli {
    t__int d__;
    t__int gen__;
    struct s__vt__sni_jvt_service *p_jvt_service;
} *t__vt__jvt_service_deli;
#define d__vt__jvt_service_deli 5372
typedef t__vt__jvt_service_deli t__jvt_service_deli;
#define d__jvt_service_deli d__vt__jvt_service_deli

/* line 154 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__sni_jvt_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_jvt_service;
#define d__vt__sni_jvt_service 5040
typedef t__vt__sni_jvt_service t__sni_jvt_service;
#define d__sni_jvt_service d__vt__sni_jvt_service

/* line 157 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__sni_evt_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_evt_service;
#define d__vt__sni_evt_service 5041
typedef t__vt__sni_evt_service t__sni_evt_service;
#define d__sni_evt_service d__vt__sni_evt_service

/* line 4989 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__vt_utils {
    t__int d__;
    t__int gen__;
} *t__vt__vt_utils;
#define d__vt__vt_utils 4897
typedef t__vt__vt_utils t__vt_utils;
#define d__vt_utils d__vt__vt_utils

/* line 27 "/vobs/specman/src/japp/vt/vt_main_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_file_kind_data {
    t__int d__;
    t__int gen__;
    t__vt__vt_file_kind kind;
    t__string tooltip_text;
    t__string short_text;
    t__string icon_name;
} *t__vt__vt_file_kind_data;
#define d__vt__vt_file_kind_data 5037
typedef t__vt__vt_file_kind_data t__vt_file_kind_data;
#define d__vt_file_kind_data d__vt__vt_file_kind_data

/* line 38 "/vobs/specman/src/japp/vt/tabwin/tabwin_shared.e"  From 'struct definition' */
typedef struct s__vt__vt_widget_window_info {
    t__int d__;
    t__int gen__;
    t__string id;
    t__string kind;
    struct s__e_core__base_struct *user_info;
} *t__vt__vt_widget_window_info;
#define d__vt__vt_widget_window_info 5392
typedef t__vt__vt_widget_window_info t__vt_widget_window_info;
#define d__vt_widget_window_info d__vt__vt_widget_window_info

/* line 732 "/vobs/specman/src/japp/vt/tabwin/tabwin_shared.e"  From 'struct definition' */
typedef struct s__vt__sn_tree_node_pairs {
    t__int d__;
    t__int gen__;
    t__string s_internal_id;
    struct s__vt__sn_internal_tree_node *sn_node;
    struct s__vt__sn_tree_node *user_node;
} *t__vt__sn_tree_node_pairs;
#define d__vt__sn_tree_node_pairs 5395
typedef t__vt__sn_tree_node_pairs t__sn_tree_node_pairs;
#define d__sn_tree_node_pairs d__vt__sn_tree_node_pairs

/* line 168 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_internal_tree_node {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string p_s_internal_id;
    t__string p_s_id;
    struct s__vt__sn_source_ref *p_sn_sref;
    t__string p_src_item_name;
    t__string p_instance_name;
    t__string p_text;
    struct s__vt__vt_lnf_props *p_lnf_props;
    struct s__l__string *p_actions_to_disable;
    struct s__l__string *p_icons;
    struct s__l__vt__sn_internal_tree_node *p_children;
    t__bool p_f_children_exist;
    t__int p_child_count;
} *t__vt__sn_internal_tree_node;
#define d__vt__sn_internal_tree_node 2548
typedef t__vt__sn_internal_tree_node t__sn_internal_tree_node;
#define d__sn_internal_tree_node d__vt__sn_internal_tree_node

/* line 161 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_source_ref {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int module_id;
    t__int line_num;
} *t__vt__sn_source_ref;
#define d__vt__sn_source_ref 2547
typedef t__vt__sn_source_ref t__sn_source_ref;
#define d__sn_source_ref d__vt__sn_source_ref

/* line 56 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt.e"  From 'struct definition' */
typedef struct s__vt__sn_tree_node {
    t__int d__;
    t__int gen__;
    struct s__l__vt__sn_tree_node *p___temp_children;
} *t__vt__sn_tree_node;
#define d__vt__sn_tree_node 2561
typedef t__vt__sn_tree_node t__sn_tree_node;
#define d__sn_tree_node d__vt__sn_tree_node

/* line 2419 "/vobs/specman/src/japp/vt/vt_user_api.e"  From 'struct definition' */
typedef struct s__vt__sn_vt_box {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool is_divider;
    t__string title;
    t__string value;
    t__string color;
} *t__vt__sn_vt_box;
#define d__vt__sn_vt_box 4877
typedef t__vt__sn_vt_box t__sn_vt_box;
#define d__sn_vt_box d__vt__sn_vt_box

/* line 404 "/vobs/specman/src/japp/vt/vt_menubar_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_predefined_menu_data {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string title;
    t__int level;
    t__bool leading;
    t__string mnemonic;
} *t__vt__vt_predefined_menu_data;
#define d__vt__vt_predefined_menu_data 5062
typedef t__vt__vt_predefined_menu_data t__vt_predefined_menu_data;
#define d__vt_predefined_menu_data d__vt__vt_predefined_menu_data

/* line 455 "/vobs/specman/src/japp/vt/vt_menubar_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_predefined_actio37374 {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string title;
    t__string toolbar_title;
    t__string tooltip;
    t__string icon;
    t__string selected_icon;
    t__string command;
    t__int mnemonic_key;
    t__int accelerator_key;
    t__vt__vt_action_kind kind;
    t__bool enabled;
    t__bool selected;
    t__string group_name;
    t__string menu_name;
    t__int level;
    t__bool leading;
    t__bool first_in_group;
    t__bool last_in_group;
    t__bool custom;
    t__vt__vt_action_special_attribute special;
} *t__vt__vt_predefined_action_data;
#define d__vt__vt_predefined_action_data 5064
typedef t__vt__vt_predefined_action_data t__vt_predefined_action_data;
#define d__vt_predefined_action_data d__vt__vt_predefined_action_data

/* line 431 "/vobs/specman/src/japp/vt/vt_menubar_defs.e"  From 'struct definition' */
typedef struct s__vt__vt_predefined_group_data {
    t__int d__;
    t__int gen__;
    t__string name;
    t__string menu_name;
    t__bool add_to_toolbar;
    struct s__l__vt__vt_predefined_ac37373 *actions;
} *t__vt__vt_predefined_group_data;
#define d__vt__vt_predefined_group_data 5063
typedef t__vt__vt_predefined_group_data t__vt_predefined_group_data;
#define d__vt_predefined_group_data d__vt__vt_predefined_group_data

/* line 4 "/vobs/specman/src/japp/shared_minimal/shared_minimal_tabwin.e"  From 'struct definition' */
typedef struct s__sn__sn_tabwin {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_user_action *p_show_source_action;
    struct s__vt__vt_user_action *p_edit_source_action;
    struct s__vt__vt_user_action *p_show_data_action;
} *t__sn__sn_tabwin;
#define d__sn__sn_tabwin 2570
typedef t__sn__sn_tabwin t__sn_tabwin;
#define d__sn_tabwin d__sn__sn_tabwin

/* line 13 "/vobs/specman/src/cadence_help.e"  From 'struct definition' */
typedef struct s__sn__sn_cadence_help {
    t__int d__;
    t__int gen__;
    t__string err_tool_name;
    t__sn__cadence_help_status help_status;
    t__string cdnshelp_exec;
    struct s__sn__sn_dynamic_call *obInitEx___dynamic_call;
    struct s__sn__sn_dynamic_call *obShowTag___dynamic_call;
    struct s__sn__sn_dynamic_call *obStatusString___dynamic_call;
    struct s__sn__sn_dynamic_call *setLibrary___dynamic_call;
} *t__sn__sn_cadence_help;
#define d__sn__sn_cadence_help 2703
typedef t__sn__sn_cadence_help t__sn_cadence_help;
#define d__sn_cadence_help d__sn__sn_cadence_help

/* line 57 "/vobs/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn__sn_formal_link {
    t__int d__;
    t__int gen__;
    t__bool unsupported_te;
    struct s__sn_fl__sn_fl_bexp *one_bexp;
    struct s__sn_fl__sn_fl_bexp *zero_bexp;
    t__string te_string;
    t__bool warn_any;
    t__bool warn_clk;
    t__bool warn_big;
    t__uint fsm_big_edges;
    t__bool te_parsing_debug;
    t__bool te_FSM_debug;
    struct s__l__string *te_reparse;
    t__uint unfold_max_val;
    t__bool fsm_stat_only;
    t__uint fsm_max_edges;
    t__bool single_clk_opt;
    t__bool more_tprof;
    t__bool step_debug;
    t__bool check_id;
    struct s__l__sn_fl__sn_fl_te_node *tes;
    t__bool te_eval_debug;
    t__bool retain_FSM;
    t__bool expect_without_fail;
    t__int detach_event_no;
    struct s__l__sn_fl__sn_fl_top_node *top_tes;
    t__bool determ;
    t__bool first_for_change;
    t__bool split_fix_rep_flag;
    t__bool clean_all;
    t__string prolog_str1;
    t__string prolog_str2;
    struct s__l__uint *alpha_list;
    t__int any_id;
    t__int neg_id;
    struct s__sn_fl__sn_fl_var_event *any_var;
    struct s__sn_fl__sn_fl_var_event *neg_var;
    struct s__sn_fl__sn_fl_var_event *timer_var;
    t__int scndry_no;
    t__bool cover_expect_trigger;
    t__bool cover_expect_success;
    t__bool ignore_load_opt;
    t__bool ignore_trigger_opt;
    t__bool ignore_change_opt;
    struct s__sn_te_new_parser__sn_ba19608 *sn4_parse;
    struct s__sn_fl__sn_te_debugger *tdb;
} *t__sn__sn_formal_link;
#define d__sn__sn_formal_link 2764
typedef t__sn__sn_formal_link t__sn_formal_link;
#define d__sn_formal_link d__sn__sn_formal_link

/* line 35 "/vobs/specman/src/te_new_parser.e"  From 'struct definition' */
typedef struct s__sn_te_new_parser__sn_ba19608 {
    t__int d__;
    t__int gen__;
    t__string CONVERT_SCRIPT_FILE_NAME;
    t__string CONVERT_SCRIPT_INFO_FILE_NAME;
    struct s__l__sn__ntv *te_id_map;
    struct s__l__sn_te_new_parser__sn19633 *compare_storage;
    struct s__l__sn_te_new_parser__sn19634 *last_line_map;
    t__bool print_both;
    t__bool needs_to_convert_files;
    t__bool sn4_parse_order;
} *t__sn_te_new_parser__sn_back4_te_parser_manager;
#define d__sn_te_new_parser__sn_back4_te_parser_manager 2978
typedef t__sn_te_new_parser__sn_back4_te_parser_manager t__sn_back4_te_parser_manager;
#define d__sn_back4_te_parser_manager d__sn_te_new_parser__sn_back4_te_parser_manager

/* line 350 "/vobs/specman/src/te_new_parser.e"  From 'struct definition' */
typedef struct s__sn_te_new_parser__sn_te19631 {
    t__int d__;
    t__int gen__;
    struct s__l__int *expression;
    struct s__l__string *names_map;
} *t__sn_te_new_parser__sn_te_descriptor;
#define d__sn_te_new_parser__sn_te_descriptor 2982
typedef t__sn_te_new_parser__sn_te_descriptor t__sn_te_descriptor;
#define d__sn_te_descriptor d__sn_te_new_parser__sn_te_descriptor

/* line 30 "/vobs/specman/src/te_new_parser.e"  From 'struct definition' */
typedef struct s__sn_te_new_parser__sn_la19630 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__source_ref source_ref;
    t__int last_line;
} *t__sn_te_new_parser__sn_last_line_pair;
#define d__sn_te_new_parser__sn_last_line_pair 2977
typedef t__sn_te_new_parser__sn_last_line_pair t__sn_last_line_pair;
#define d__sn_last_line_pair d__sn_te_new_parser__sn_last_line_pair

/* line 19 "/vobs/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_te_debugger {
    t__int d__;
    t__int gen__;
    t__sn_fl__tdb_print_level print_level;
    t__uint breaks_uid;
    struct s__l__sn_fl__tdb_break_point *break_points;
    struct s__l__string *scratch;
    struct s__sn_fl__sn_hp_fsm_eval *hp_sig_fsm_eval;
    struct s__sn_fl__sn_hp_fsm_eval_o19638 *hp_sig_fsm_eval_opt_wait;
} *t__sn_fl__sn_te_debugger;
#define d__sn_fl__sn_te_debugger 2999
typedef t__sn_fl__sn_te_debugger t__sn_te_debugger;
#define d__sn_te_debugger d__sn_fl__sn_te_debugger

/* line 68 "/vobs/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__sn_fl__tdb_break_point {
    t__int d__;
    t__int gen__;
    t__uint id;
    t__bool trace_only;
} *t__sn_fl__tdb_break_point;
#define d__sn_fl__tdb_break_point 3000
typedef t__sn_fl__tdb_break_point t__tdb_break_point;
#define d__tdb_break_point d__sn_fl__tdb_break_point

/* line 103 "/vobs/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_hp_fsm_eval {
    t__int d__;
    t__int gen__;
    t__int te_id;
    struct s__sn__te_memory *mem;
    struct s__e_core__base_struct *inst;
    t__imp_enum_sn_fl__sn_hp_fsm_eval__location location;
} *t__sn_fl__sn_hp_fsm_eval;
#define d__sn_fl__sn_hp_fsm_eval 3003
typedef t__sn_fl__sn_hp_fsm_eval t__sn_hp_fsm_eval;
#define d__sn_hp_fsm_eval d__sn_fl__sn_hp_fsm_eval

/* line 185 "/vobs/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__sn_fl__sn_hp_fsm_eval_o19638 {
    t__int d__;
    t__int gen__;
    t__int te_id;
    struct s__sn__te_memory *mem;
    struct s__e_core__base_struct *inst;
    t__imp_enum_sn_fl__sn_hp_fsm_eval__location location;
} *t__sn_fl__sn_hp_fsm_eval_opt_wait;
#define d__sn_fl__sn_hp_fsm_eval_opt_wait 3006
typedef t__sn_fl__sn_hp_fsm_eval_opt_wait t__sn_hp_fsm_eval_opt_wait;
#define d__sn_hp_fsm_eval_opt_wait d__sn_fl__sn_hp_fsm_eval_opt_wait

/* line 232 "/vobs/specman/src/any_order_define.e"  From 'struct definition' */
typedef struct s__sn__sn_define2_descriptor {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__k__sn__def2_name_string20098 *options;
    t__int opt_num;
    t__bool two_or_three;
} *t__sn__sn_define2_descriptor;
#define d__sn__sn_define2_descriptor 3094
typedef t__sn__sn_define2_descriptor t__sn_define2_descriptor;
#define d__sn_define2_descriptor d__sn__sn_define2_descriptor

/* line 228 "/vobs/specman/src/any_order_define.e"  From 'struct definition' */
typedef struct s__sn__def2_name_string {
    t__int d__;
    t__int gen__;
    t__string name;
    t__int place;
} *t__sn__def2_name_string;
#define d__sn__def2_name_string 3093
typedef t__sn__def2_name_string t__def2_name_string;
#define d__def2_name_string d__sn__def2_name_string

/* line 5 "/vobs/specman/src/tcm_flow_graph.e"  From 'struct definition' */
typedef struct s__sn__sn_abstract_syntax_21204 {
    t__int d__;
    t__int gen__;
    t__int id_counter;
    struct s__k__string__it *syntax_trees_cache;
    t__int stub_uid_allocator;
} *t__sn__sn_abstract_syntax_manager;
#define d__sn__sn_abstract_syntax_manager 3202
typedef t__sn__sn_abstract_syntax_manager t__sn_abstract_syntax_manager;
#define d__sn_abstract_syntax_manager d__sn__sn_abstract_syntax_manager

/* line 164 "/vobs/specman/src/tcm_service.e"  From 'struct definition' */
typedef struct s__sn__sn_tcm_stack_image {
    t__int d__;
    t__int gen__;
    t__int full_size;
    t__int max_capacity;
    struct s__l__sn__script_instance *stack;
} *t__sn__sn_tcm_stack_image;
#define d__sn__sn_tcm_stack_image 3220
typedef t__sn__sn_tcm_stack_image t__sn_tcm_stack_image;
#define d__sn_tcm_stack_image d__sn__sn_tcm_stack_image

/* line 279 "/vobs/specman/src/seamless_def.e"  From 'struct definition' */
typedef struct s__sn__seamless {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool spi_trace;
    struct s__sn__sn_dynamic_call *sn_sl_init_spi_ptrs___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_init_spi_client___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_model_name___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_cpu_exists___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_open_model___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_calc_address___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_set_address___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_address___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_data___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_set_data___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_spi_error___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_error___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_time_opt_on___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_time_opt_was_on___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_sl_get_is_ready___dynamic_call;
    struct s__k__sn__seamless_connect22006 *connections;
    struct s__sn__sn_adapter_bridge *adapter_struct;
    t__bool did_spi_init;
    t__external_pointer client_id;
    t__int num_models;
    t__external_pointer models;
    t__bool debug;
    t__bool trace;
} *t__sn__seamless;
#define d__sn__seamless 3239
typedef t__sn__seamless t__seamless;
#define d__seamless d__sn__seamless

/* line 362 "/vobs/specman/src/seamless_def.e"  From 'struct definition' */
typedef struct s__sn__seamless_connection {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string tag;
    t__string cpu;
    t__string addr_space;
    t__bool is_real;
    t__bool little_endian;
    t__bool connection_opened;
    t__external_pointer spi_id;
    struct s__k__sn__sw_obj__descr *objs;
} *t__sn__seamless_connection;
#define d__sn__seamless_connection 3240
typedef t__sn__seamless_connection t__seamless_connection;
#define d__seamless_connection d__sn__seamless_connection

/* line 728 "/vobs/specman/src/seamless_impl.e"  From 'struct definition' */
typedef struct s__sn__sw_obj {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string descr;
    t__external_pointer addr;
    t__uint size;
    t__string full_descr;
    t__bool auto_addr_calc;
    t__bool was_accessed;
    struct s__sn__seamless_connection *connection;
    struct s__l__bit *value;
    t__bool trace;
} *t__sn__sw_obj;
#define d__sn__sw_obj 3241
typedef t__sn__sw_obj t__sw_obj;
#define d__sw_obj d__sn__sw_obj

/* line 126 "/vobs/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn__sn_comm_api {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_all_in_requests *all_in_requests;
    struct s__sn__comm_all_out_requests *all_out_requests;
    struct s__sn__comm_all_in_notific22169 *all_in_notifications_with_acknowledge;
    struct s__sn__comm_all_in_notific22171 *all_in_notifications_no_acknowledge;
    struct s__sn__comm_all_out_notifi22165 *all_out_notifications_no_acknowledge;
    struct s__sn__comm_all_out_notifi22167 *all_out_notifications_with_acknowledge;
} *t__sn__sn_comm_api;
#define d__sn__sn_comm_api 3319
typedef t__sn__sn_comm_api t__sn_comm_api;
#define d__sn_comm_api d__sn__sn_comm_api

/* line 7 "/vobs/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn__comm_all_in_requests {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_get_applicatio22359 *get_application_desc_request;
    struct s__sn__comm_general_in_request *general_in_request;
    struct s__sn__icover_initialize_r27143 *initialize_request;
    struct s__sn__icover_get_dir_cont27144 *get_dir_contents_request;
    struct s__sn__icover_read_cover_r27145 *read_cover_request;
    struct s__sn__icover_clear_cover_27146 *clear_cover_request;
    struct s__sn__icover_get_initial_27147 *get_initial_file_system_info_request;
    struct s__sn__icover_get_cover_el27148 *get_cover_element_data_request;
    struct s__sn__icover_get_item_typ27149 *get_item_type_request;
    struct s__sn__icover_get_cover_te27150 *get_cover_tests_request;
    struct s__sn__icover_get_contribu27151 *get_contributed_tests_request;
    struct s__sn__icover_report_request *report_request;
    struct s__sn__icover_set_cover_co27152 *set_cover_config_request;
    struct s__sn__icover_get_cover_co27153 *get_cover_config_request;
} *t__sn__comm_all_in_requests;
#define d__sn__comm_all_in_requests 3313
typedef t__sn__comm_all_in_requests t__comm_all_in_requests;
#define d__comm_all_in_requests d__sn__comm_all_in_requests

/* line 259 "/vobs/specman/src/communication.e"  From 'struct definition' */
typedef struct s__sn__comm_get_applicatio22359 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    t__string app_name;
} *t__sn__comm_get_application_desc_request;
#define d__sn__comm_get_application_desc_request 3341
typedef t__sn__comm_get_application_desc_request t__comm_get_application_desc_request;
#define d__comm_get_application_desc_request d__sn__comm_get_application_desc_request

/* line 144 "/vobs/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__sn__comm_general_in_request {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    struct s__sn__snorb_object_id *object_id;
    struct s__sn__snorb_method_id *method_id;
    struct s__sn__snorb_param_demarshaller *in_params;
} *t__sn__comm_general_in_request;
#define d__sn__comm_general_in_request 3473
typedef t__sn__comm_general_in_request t__comm_general_in_request;
#define d__comm_general_in_request d__sn__comm_general_in_request

/* line 32 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_object_id {
    t__int d__;
    t__int gen__;
    t__int n_home_orb;
    t__int n_id;
    t__string p_s_hash_code;
    struct s__sn__sn_string_hashable *p_string_hash_key;
} *t__sn__snorb_object_id;
#define d__sn__snorb_object_id 3434
typedef t__sn__snorb_object_id t__snorb_object_id;
#define d__snorb_object_id d__sn__snorb_object_id

/* line 712 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_string_hashable {
    t__int d__;
    t__int gen__;
    t__string p_s_hash_code;
} *t__sn__sn_string_hashable;
#define d__sn__sn_string_hashable 1515
typedef t__sn__sn_string_hashable t__sn_string_hashable;
#define d__sn_string_hashable d__sn__sn_string_hashable

/* line 209 "/vobs/specman/src/snorb/orb/snorb_id.e"  From 'struct definition' */
typedef struct s__sn__snorb_method_id {
    t__int d__;
    t__int gen__;
    t__string s_string;
} *t__sn__snorb_method_id;
#define d__sn__snorb_method_id 3467
typedef t__sn__snorb_method_id t__snorb_method_id;
#define d__snorb_method_id d__sn__snorb_method_id

/* line 87 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_param_demarshaller {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_socket_interactor *input_stream;
} *t__sn__snorb_param_demarshaller;
#define d__sn__snorb_param_demarshaller 3444
typedef t__sn__snorb_param_demarshaller t__snorb_param_demarshaller;
#define d__snorb_param_demarshaller d__sn__snorb_param_demarshaller

/* line 446 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_initialize_r27143 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
} *t__sn__icover_initialize_request;
#define d__sn__icover_initialize_request 3925
typedef t__sn__icover_initialize_request t__icover_initialize_request;
#define d__icover_initialize_request d__sn__icover_initialize_request

/* line 57 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_get_dir_cont27144 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    t__string dir_path;
    t__string default_filter;
    t__vt__vt_file_dialog_content_kind content_kind;
} *t__sn__icover_get_dir_contents_request;
#define d__sn__icover_get_dir_contents_request 3920
typedef t__sn__icover_get_dir_contents_request t__icover_get_dir_contents_request;
#define d__icover_get_dir_contents_request d__sn__icover_get_dir_contents_request

/* line 542 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_read_cover_r27145 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    struct s__l__string *filenames;
} *t__sn__icover_read_cover_request;
#define d__sn__icover_read_cover_request 3927
typedef t__sn__icover_read_cover_request t__icover_read_cover_request;
#define d__icover_read_cover_request d__sn__icover_read_cover_request

/* line 644 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_clear_cover_27146 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
} *t__sn__icover_clear_cover_request;
#define d__sn__icover_clear_cover_request 3929
typedef t__sn__icover_clear_cover_request t__icover_clear_cover_request;
#define d__icover_clear_cover_request d__sn__icover_clear_cover_request

/* line 383 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_get_initial_27147 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
} *t__sn__icover_get_initial_file_system_info_request;
#define d__sn__icover_get_initial_file_system_info_request 3923
typedef t__sn__icover_get_initial_file_system_info_request t__icover_get_initial_file_system_info_request;
#define d__icover_get_initial_file_system_info_request d__sn__icover_get_initial_file_system_info_request

/* line 712 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_get_cover_el27148 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    t__main__jcvr_pack_mode mode;
    struct s__sn__icover_idpath *id_path;
} *t__sn__icover_get_cover_element_data_request;
#define d__sn__icover_get_cover_element_data_request 3931
typedef t__sn__icover_get_cover_element_data_request t__icover_get_cover_element_data_request;
#define d__icover_get_cover_element_data_request d__sn__icover_get_cover_element_data_request

/* line 27 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_idpath {
    t__int d__;
    t__int gen__;
    struct s__l__int *p_path;
} *t__sn__icover_idpath;
#define d__sn__icover_idpath 3919
typedef t__sn__icover_idpath t__icover_idpath;
#define d__icover_idpath d__sn__icover_idpath

/* line 787 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_get_item_typ27149 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    struct s__sn__icover_idpath *id_path;
} *t__sn__icover_get_item_type_request;
#define d__sn__icover_get_item_type_request 3933
typedef t__sn__icover_get_item_type_request t__icover_get_item_type_request;
#define d__icover_get_item_type_request d__sn__icover_get_item_type_request

/* line 850 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_get_cover_te27150 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
} *t__sn__icover_get_cover_tests_request;
#define d__sn__icover_get_cover_tests_request 3935
typedef t__sn__icover_get_cover_tests_request t__icover_get_cover_tests_request;
#define d__icover_get_cover_tests_request d__sn__icover_get_cover_tests_request

/* line 903 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_get_contribu27151 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    struct s__sn__icover_idpath *id_path;
} *t__sn__icover_get_contributed_tests_request;
#define d__sn__icover_get_contributed_tests_request 3937
typedef t__sn__icover_get_contributed_tests_request t__icover_get_contributed_tests_request;
#define d__icover_get_contributed_tests_request d__sn__icover_get_contributed_tests_request

/* line 976 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_report_request {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    struct s__sn__icover_idpath *id_path;
    t__string file_name;
    t__main__sn_cover_report_kind kind;
    t__sn__show_mode filter;
    t__int tests;
} *t__sn__icover_report_request;
#define d__sn__icover_report_request 3939
typedef t__sn__icover_report_request t__icover_report_request;
#define d__icover_report_request d__sn__icover_report_request

/* line 1056 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_set_cover_co27152 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    t__sn__sn_cvr_grading_formula grade_type;
    t__int at_least_multiplier;
} *t__sn__icover_set_cover_config_request;
#define d__sn__icover_set_cover_config_request 3941
typedef t__sn__icover_set_cover_config_request t__icover_set_cover_config_request;
#define d__icover_set_cover_config_request d__sn__icover_set_cover_config_request

/* line 1155 "/vobs/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__sn__icover_get_cover_co27153 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
} *t__sn__icover_get_cover_config_request;
#define d__sn__icover_get_cover_config_request 3943
typedef t__sn__icover_get_cover_config_request t__icover_get_cover_config_request;
#define d__icover_get_cover_config_request d__sn__icover_get_cover_config_request

/* line 28 "/vobs/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn__comm_all_out_requests {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_general_out_request *general_out_request;
} *t__sn__comm_all_out_requests;
#define d__sn__comm_all_out_requests 3314
typedef t__sn__comm_all_out_requests t__comm_all_out_requests;
#define d__comm_all_out_requests d__sn__comm_all_out_requests

/* line 133 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__comm_general_out_request {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    t__sn__comm_request_opcode opcode;
    struct s__sn__snorb_object_id *object_id;
    struct s__sn__snorb_method_id *method_id;
    struct s__sn__snorb_param_marshaller *request_params;
    struct s__sn__comm_general_in_reply *general_reply;
} *t__sn__comm_general_out_request;
#define d__sn__comm_general_out_request 3464
typedef t__sn__comm_general_out_request t__comm_general_out_request;
#define d__comm_general_out_request d__sn__comm_general_out_request

/* line 82 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_param_marshaller {
    t__int d__;
    t__int gen__;
    struct s__l__sn__comm_pack_unpackable *params;
} *t__sn__snorb_param_marshaller;
#define d__sn__snorb_param_marshaller 3443
typedef t__sn__snorb_param_marshaller t__snorb_param_marshaller;
#define d__snorb_param_marshaller d__sn__snorb_param_marshaller

/* line 339 "/vobs/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__sn__comm_general_in_reply {
    t__int d__;
    t__int gen__;
    struct s__sn__snorb_param_demarshaller *returned_params;
    struct s__sn__struct_descriptor *demarshaller_sd;
} *t__sn__comm_general_in_reply;
#define d__sn__comm_general_in_reply 3474
typedef t__sn__comm_general_in_reply t__comm_general_in_reply;
#define d__comm_general_in_reply d__sn__comm_general_in_reply

/* line 48 "/vobs/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn__comm_all_in_notific22169 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_general_in_not23742 *general_in_notification_with_acknowledge;
} *t__sn__comm_all_in_notifications_with_acknowledge;
#define d__sn__comm_all_in_notifications_with_acknowledge 3315
typedef t__sn__comm_all_in_notifications_with_acknowledge t__comm_all_in_notifications_with_acknowledge;
#define d__comm_all_in_notifications_with_acknowledge d__sn__comm_all_in_notifications_with_acknowledge

/* line 378 "/vobs/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__sn__comm_general_in_not23742 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    struct s__sn__snorb_object_id *object_id;
    struct s__sn__snorb_method_id *method_id;
    struct s__sn__snorb_param_demarshaller *in_params;
} *t__sn__comm_general_in_notification_with_acknowledge;
#define d__sn__comm_general_in_notification_with_acknowledge 3475
typedef t__sn__comm_general_in_notification_with_acknowledge t__comm_general_in_notification_with_acknowledge;
#define d__comm_general_in_notification_with_acknowledge d__sn__comm_general_in_notification_with_acknowledge

/* line 66 "/vobs/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn__comm_all_in_notific22171 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_general_in_not23743 *general_in_notification_no_acknowledge;
    struct s__sn__sn_cancel_wakeup_in39742 *cancel_wakeup_in_notification;
} *t__sn__comm_all_in_notifications_no_acknowledge;
#define d__sn__comm_all_in_notifications_no_acknowledge 3316
typedef t__sn__comm_all_in_notifications_no_acknowledge t__comm_all_in_notifications_no_acknowledge;
#define d__comm_all_in_notifications_no_acknowledge d__sn__comm_all_in_notifications_no_acknowledge

/* line 421 "/vobs/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__sn__comm_general_in_not23743 {
    t__int d__;
    t__int gen__;
    struct s__sn__snorb_object_id *object_id;
    struct s__sn__snorb_method_id *method_id;
    struct s__sn__snorb_param_demarshaller *in_params;
} *t__sn__comm_general_in_notification_no_acknowledge;
#define d__sn__comm_general_in_notification_no_acknowledge 3476
typedef t__sn__comm_general_in_notification_no_acknowledge t__comm_general_in_notification_no_acknowledge;
#define d__comm_general_in_notification_no_acknowledge d__sn__comm_general_in_notification_no_acknowledge

/* line 62 "/vobs/specman/src/japp/jspecview_deli/jspecview_wakeup.e"  From 'struct definition' */
typedef struct s__sn__sn_cancel_wakeup_in39742 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_cancel_wakeup_in_notification;
#define d__sn__sn_cancel_wakeup_in_notification 4414
typedef t__sn__sn_cancel_wakeup_in_notification t__sn_cancel_wakeup_in_notification;
#define d__sn_cancel_wakeup_in_notification d__sn__sn_cancel_wakeup_in_notification

/* line 105 "/vobs/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn__comm_all_out_notifi22165 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_general_out_no23744 *general_out_notification_no_acknowledge;
} *t__sn__comm_all_out_notifications_no_acknowledge;
#define d__sn__comm_all_out_notifications_no_acknowledge 3318
typedef t__sn__comm_all_out_notifications_no_acknowledge t__comm_all_out_notifications_no_acknowledge;
#define d__comm_all_out_notifications_no_acknowledge d__sn__comm_all_out_notifications_no_acknowledge

/* line 473 "/vobs/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__sn__comm_general_out_no23744 {
    t__int d__;
    t__int gen__;
    t__sn__comm_request_opcode opcode;
    struct s__sn__snorb_object_id *object_id;
    struct s__sn__snorb_method_id *method_id;
    struct s__sn__snorb_param_marshaller *request_params;
} *t__sn__comm_general_out_notification_no_acknowledge;
#define d__sn__comm_general_out_notification_no_acknowledge 3477
typedef t__sn__comm_general_out_notification_no_acknowledge t__comm_general_out_notification_no_acknowledge;
#define d__comm_general_out_notification_no_acknowledge d__sn__comm_general_out_notification_no_acknowledge

/* line 87 "/vobs/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn__comm_all_out_notifi22167 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_general_out_no23745 *general_out_notification_with_acknowledge;
} *t__sn__comm_all_out_notifications_with_acknowledge;
#define d__sn__comm_all_out_notifications_with_acknowledge 3317
typedef t__sn__comm_all_out_notifications_with_acknowledge t__comm_all_out_notifications_with_acknowledge;
#define d__comm_all_out_notifications_with_acknowledge d__sn__comm_all_out_notifications_with_acknowledge

/* line 539 "/vobs/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__sn__comm_general_out_no23745 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_abs_basic_reply *the_reply_obj;
    struct s__sn__comm_request_status *the_status_obj;
    t__sn__comm_request_opcode opcode;
    struct s__sn__comm_out_notificati22357 *acknowledge_reply;
    struct s__sn__snorb_object_id *object_id;
    struct s__sn__snorb_method_id *method_id;
    struct s__sn__snorb_param_marshaller *request_params;
} *t__sn__comm_general_out_notification_with_acknowledge;
#define d__sn__comm_general_out_notification_with_acknowledge 3478
typedef t__sn__comm_general_out_notification_with_acknowledge t__comm_general_out_notification_with_acknowledge;
#define d__comm_general_out_notification_with_acknowledge d__sn__comm_general_out_notification_with_acknowledge

/* line 229 "/vobs/specman/src/comm_request.e"  From 'struct definition' */
typedef struct s__sn__comm_out_notificati22357 {
    t__int d__;
    t__int gen__;
} *t__sn__comm_out_notification_acknowledge_reply;
#define d__sn__comm_out_notification_acknowledge_reply 3305
typedef t__sn__comm_out_notification_acknowledge_reply t__comm_out_notification_acknowledge_reply;
#define d__comm_out_notification_acknowledge_reply d__sn__comm_out_notification_acknowledge_reply

/* line 5 "/vobs/specman/src/snorb/edl/edl_utils.e"  From 'struct definition' */
typedef struct s__sn__snorb {
    t__int d__;
    t__int gen__;
    struct s__sn__snorb_all_descriptors *descriptor;
    struct s__sn__snorb_all_flags *flags;
    struct s__sn__snorb_data_helper *data_helper;
    struct s__sn__snorb_object_helper *obj_helper;
    struct s__sn__snorb_sender *sender;
    struct s__sn__snorb_receiver *receiver;
    struct s__sn__snorb_service_repository *p_service_repository;
    struct s__sn__snorb_service_finder *p_service_finder_default;
    t__int m_send_counter;
    t__int m_receive_counter;
} *t__sn__snorb;
#define d__sn__snorb 3346
typedef t__sn__snorb t__snorb;
#define d__snorb d__sn__snorb

/* line 111 "/vobs/specman/src/snorb/orb/snorb.e"  From 'struct definition' */
typedef struct s__sn__snorb_all_descriptors {
    t__int d__;
    t__int gen__;
    struct s__sn__sni_service_reposit23750 *sni_service_repository;
    struct s__sn__sn_object_id_data_d23751 *sn_object_id_data;
    struct s__sn__sn_jcvr_id_path_des27154 *sn_jcvr_id_path;
    struct s__sn__sn_jcvr_cross_inter27155 *sn_jcvr_cross_interval;
    struct s__sn__sni_jcvr_change_lis27156 *sni_jcvr_change_listener;
    struct s__sn__sni_jcvr_service_de27157 *sni_jcvr_service;
    struct s__sn__sni_jcvrgui_service27158 *sni_jcvrgui_service;
    struct s__sn__show_mode_descriptor *show_mode;
    struct s__sn__vt_abs_action_descriptor *vt_abs_action;
    struct s__sn__vt_action_descriptor *vt_action;
    struct s__sn__vt_user_action_desc31730 *vt_user_action;
    struct s__sn__vt_lnf_props_descriptor *vt_lnf_props;
    struct s__sn__sn_window_toplevel_31731 *sn_window_toplevel_data;
    struct s__sn__sn_window_kind_data31732 *sn_window_kind_data;
    struct s__sn__sn_table_window_dat31733 *sn_table_window_data;
    struct s__sn__sn_tree_window_data31734 *sn_tree_window_data;
    struct s__sn__sn_widget_item_desc31735 *sn_widget_item;
    struct s__sn__sn_table_row_descriptor *sn_table_row;
    struct s__sn__sn_delta_row_update31736 *sn_delta_row_update;
    struct s__sn__sn_internal_tree_no31737 *sn_internal_tree_node;
    struct s__sn__sn_table_col_descriptor *sn_table_col;
    struct s__sn__vt_window_header_co31738 *vt_window_header_config;
    struct s__sn__vt_window_header_da31739 *vt_window_header_data;
    struct s__sn__sn_vt_action_kind_d31740 *sn_vt_action_kind;
    struct s__sn__vt_action_type_desc31741 *vt_action_type;
    struct s__sn__vt_menu_action_kind31742 *vt_menu_action_kind;
    struct s__sn__vt_file_dialog_cont31743 *vt_file_dialog_content_kind;
    struct s__sn__vt_file_dialog_oper31744 *vt_file_dialog_operation_kind;
    struct s__sn__vt_color_descriptor *vt_color;
    struct s__sn__vt_font_kind_descriptor *vt_font_kind;
    struct s__sn__sn_pair_nums_descriptor *sn_pair_nums;
    struct s__sn__sn_source_ref_descriptor *sn_source_ref;
    struct s__sn__sn_simple_type_desc31745 *sn_simple_type;
    struct s__sn__file_status_descriptor *file_status;
    struct s__sn__sn_coordinate_descriptor *sn_coordinate;
    struct s__sn__vt_items_wrapper_de31746 *vt_items_wrapper;
    struct s__sn__sn_int_list_wrapper31747 *sn_int_list_wrapper;
    struct s__sn__vt_location_descriptor *vt_location;
    struct s__sn__vt_size_descriptor *vt_size;
    struct s__sn__vt_rect_descriptor *vt_rect;
    struct s__sn__vt_font_size_descriptor *vt_font_size;
    struct s__sn__vt_bool_tristate_de31748 *vt_bool_tristate;
    struct s__sn__sn_pair_strings_des31749 *sn_pair_strings;
    struct s__sn__sni_specman_command31750 *sni_specman_command;
    struct s__sn__sn_specman_status_d31751 *sn_specman_status;
    struct s__sn__sni_specview_servic31752 *sni_specview_service;
    struct s__sn__sn_font_data_descriptor *sn_font_data;
    struct s__sn__sn_color_data_descriptor *sn_color_data;
    struct s__sn__sn_gui_resources_de31753 *sn_gui_resources;
    struct s__sn__sn_specview_socket_31754 *sn_specview_socket_data;
    struct s__sn__sni_remote_appl_man31755 *sni_remote_appl_manager;
    struct s__sn__sni_remote_appl_des31756 *sni_remote_appl;
    struct s__sn__sni_jspecview_servi39743 *sni_jspecview_service;
    struct s__sn__sni_e_jcvr_external39744 *sni_e_jcvr_external_service;
    struct s__sn__sn_jcvr_external_pr39745 *sn_jcvr_external_properties;
    struct s__sn__sn_jcvr_external_de39746 *sn_jcvr_external;
    struct s__sn__sni_e_jutils_servic39747 *sni_e_jutils_service;
    struct s__sn__sn_source_descriptor *sn_source;
    struct s__sn__sn_module_descriptor *sn_module;
    struct s__sn__sn_file_descriptor *sn_file;
    struct s__sn__sn_e_file_descriptor *sn_e_file;
    struct s__sn__encryption_status_d39748 *encryption_status;
    struct s__sn__sni_jconfig_service39749 *sni_jconfig_service;
    struct s__sn__sni_econfig_service39750 *sni_econfig_service;
    struct s__sn__sn_jconfig_data_des39751 *sn_jconfig_data;
    struct s__sn__sn_jconfig_category39752 *sn_jconfig_category_val;
    struct s__sn__sn_jconfig_item_val39753 *sn_jconfig_item_val;
    struct s__sn__sni_jsource_viewer_39754 *sni_jsource_viewer_service;
    struct s__sn__sni_jmini_guitest_s39755 *sni_jmini_guitest_service;
    struct s__sn__vtx_tree_node_actua39756 *vtx_tree_node_actual_data;
    struct s__sn__vtx_bar_actual_data39757 *vtx_bar_actual_data;
    struct s__sn__vtx_pie_slice_actua39758 *vtx_pie_slice_actual_data;
    struct s__sn__vtx_pie_actual_data39759 *vtx_pie_actual_data;
    struct s__sn__sn_abs_val_identifi39760 *sn_abs_val_identifier;
    struct s__sn__sn_val_ref_descriptor *sn_val_ref;
    struct s__sn__sn_scalar_val_ref_d39761 *sn_scalar_val_ref;
    struct s__sn__sn_abs_val_descriptor *sn_abs_val;
    struct s__sn__sn_abs_scalar_val_d39762 *sn_abs_scalar_val;
    struct s__sn__sn_event_val_descriptor *sn_event_val;
    struct s__sn__sn_abs_container_va39763 *sn_abs_container_val;
    struct s__sn__sn_list_val_descriptor *sn_list_val;
    struct s__sn__sn_port_val_descriptor *sn_port_val;
    struct s__sn__sn_instance_val_des39764 *sn_instance_val;
    struct s__sn__sn_instance_null_va39765 *sn_instance_null_val;
    struct s__sn__sn_unit_instance_va39766 *sn_unit_instance_val;
    struct s__sn__sn_string_val_descriptor *sn_string_val;
    struct s__sn__sn_specman_special_39767 *sn_specman_special_type_val;
    struct s__sn__sn_specman_special_39768 *sn_specman_special_type_val_group;
    struct s__sn__sn_int_val_descriptor *sn_int_val;
    struct s__sn__sn_uint_val_descriptor *sn_uint_val;
    struct s__sn__sn_bool_val_descriptor *sn_bool_val;
    struct s__sn__sn_sized_int_val_de39769 *sn_sized_int_val;
    struct s__sn__sn_enum_val_descriptor *sn_enum_val;
    struct s__sn__sn_real_val_descriptor *sn_real_val;
    struct s__sn__sn_abs_structual_se39770 *sn_abs_structual_segment;
    struct s__sn__sn_abs_extension_de39771 *sn_abs_extension;
    struct s__sn__sn_abs_descriptor_d39772 *sn_abs_descriptor;
    struct s__sn__sn_type_descriptor_39773 *sn_type_descriptor;
    struct s__sn__sn_scalar_descripto39774 *sn_scalar_descriptor;
    struct s__sn__sn_enum_extension_d39775 *sn_enum_extension_descriptor;
    struct s__sn__sn_enum_descriptor_39776 *sn_enum_descriptor;
    struct s__sn__sn_list_descriptor_39777 *sn_list_descriptor;
    struct s__sn__sn_port_descriptor_39778 *sn_port_descriptor;
    struct s__sn__sn_struct_descripto39779 *sn_struct_descriptor;
    struct s__sn__sn_unit_descriptor_39780 *sn_unit_descriptor;
    struct s__sn__sn_struct_storage_d39781 *sn_struct_storage;
    struct s__sn__sn_struct_storage_d39782 *sn_struct_storage_details;
    struct s__sn__sn_struct_member_de39783 *sn_struct_member_descriptor;
    struct s__sn__sn_field_descriptor39784 *sn_field_descriptor;
    struct s__sn__sn_method_extension39785 *sn_method_extension_descriptor;
    struct s__sn__sn_event_descriptor39786 *sn_event_descriptor;
    struct s__sn__sn_method_descripto39787 *sn_method_descriptor;
    struct s__sn__sn_method_param_des39788 *sn_method_param_descriptor;
    struct s__sn__sn_tcm_descriptor_d39789 *sn_tcm_descriptor;
    struct s__sn__sn_on_descriptor_de39790 *sn_on_descriptor;
    struct s__sn__sn_constraint_descr39791 *sn_constraint_descriptor;
    struct s__sn__sn_type_update_desc39792 *sn_type_update;
    struct s__sn__sn_struct_storage_u39793 *sn_struct_storage_update;
    struct s__sn__sn_enum_update_desc39794 *sn_enum_update;
    struct s__sn__method_kind_descriptor *method_kind;
    struct s__sn__sn_event_kind_descriptor *sn_event_kind;
    struct s__sn__sni_jdatabrowser_se39795 *sni_jdatabrowser_service;
    struct s__sn__sni_edatabrowser_se39796 *sni_edatabrowser_service;
    struct s__sn__descs_and_storages_39797 *descs_and_storages;
    struct s__sn__mixed_query_result_39798 *mixed_query_result;
    struct s__sn__sn_masked_val_descriptor *sn_masked_val;
    struct s__sn__array_of_sn_masked_39799 *array_of_sn_masked_vals;
    struct s__sn__e_val_change_descriptor *e_val_change;
    struct s__sn__e_root_refresh_resu39800 *e_root_refresh_result;
    struct s__sn__sn_root_di_info_des39801 *sn_root_di_info;
    struct s__sn__root_tokens_and_val39802 *root_tokens_and_values;
    struct s__sn__change_type_descriptor *change_type;
    struct s__sn__sn_exp_descriptor *sn_exp;
    struct s__sn__sn_declared_exp_des39803 *sn_declared_exp;
    struct s__sn__sni_gui_jmanager_se39804 *sni_gui_jmanager_service;
    struct s__sn__sn_general_dialog_i39805 *sn_general_dialog_input_defs;
    struct s__sn__sn_general_dialog_c39806 *sn_general_dialog_checkbox_defs;
    struct s__sn__sn_general_dialog_b39807 *sn_general_dialog_button_defs;
    struct s__sn__sn_input_dialog_rep39808 *sn_input_dialog_reply;
    struct s__sn__sn_general_dialog_r39809 *sn_general_dialog_reply;
    struct s__sn__sn_message_dialog_k39810 *sn_message_dialog_kind;
    struct s__sn__sn_question_dialog_39811 *sn_question_dialog_kind;
    struct s__sn__sn_dialog_button_ki39812 *sn_dialog_button_kind;
    struct s__sn__sn_general_dialog_i39813 *sn_general_dialog_input_kind;
    struct s__sn__sn_general_dialog_b39814 *sn_general_dialog_button_kind;
    struct s__sn__sni_jvt_service_des39815 *sni_jvt_service;
    struct s__sn__sni_evt_service_des39816 *sni_evt_service;
    struct s__sn__sni_vt_jwindow_desc39817 *sni_vt_jwindow;
    struct s__sn__sni_vtw_callback_ha39818 *sni_vtw_callback_handler;
    struct s__sn__vt_window_additiona39819 *vt_window_additional_attributes;
    struct s__sn__vt_window_requested39820 *vt_window_requested_attributes;
    struct s__sn__vt_window_actual_at39821 *vt_window_actual_attributes;
    struct s__sn__vt_page_attributes_39822 *vt_page_attributes;
    struct s__sn__vt_location_attribu39823 *vt_location_attributes;
    struct s__sn__vt_page_related_pro39824 *vt_page_related_properties;
    struct s__sn__vt_page_related_pro39825 *vt_page_related_properties_for_viewer;
    struct s__sn__vt_page_related_pro39826 *vt_page_related_properties_for_html;
    struct s__sn__vt_saved_location_p39827 *vt_saved_location_properties;
    struct s__sn__vt_saved_page_prope39828 *vt_saved_page_properties;
    struct s__sn__vt_saved_properties39829 *vt_saved_properties;
    struct s__sn__vt_widget_modifiabl39830 *vt_widget_modifiable_attributes;
    struct s__sn__vt_element_data_des39831 *vt_element_data;
    struct s__sn__vt_hyperlink_data_d39832 *vt_hyperlink_data;
    struct s__sn__jaction_manager_des39833 *jaction_manager;
    struct s__sn__jvt_toolbar_descriptor *jvt_toolbar;
    struct s__sn__jmenu_component_des39834 *jmenu_component;
    struct s__sn__jmenu_item_descriptor *jmenu_item;
    struct s__sn__jvt_menu_descriptor *jvt_menu;
    struct s__sn__jvt_action_descriptor *jvt_action;
    struct s__sn__vt_statusbar_descriptor *vt_statusbar;
    struct s__sn__vt_statusbar_pane_d39835 *vt_statusbar_pane;
    struct s__sn__status_pane_modifya39836 *status_pane_modifyable_data;
    struct s__sn__vt_progress_pane_de39837 *vt_progress_pane;
    struct s__sn__progress_pane_modif39838 *progress_pane_modifyable_data;
    struct s__sn__file_chooser_data_d39839 *file_chooser_data;
    struct s__sn__vt_file_filter_desc39840 *vt_file_filter;
    struct s__sn__vt_html_defaults_de39841 *vt_html_defaults;
    struct s__sn__vt_initial_window_a39842 *vt_initial_window_attributes;
    struct s__sn__vt_window_attribute39843 *vt_window_attributes;
    struct s__sn__vt_history_event_de39844 *vt_history_event;
    struct s__sn__vt_element_kind_des39845 *vt_element_kind;
    struct s__sn__vt_menu_component_k39846 *vt_menu_component_kind;
    struct s__sn__vt_action_kind_desc39847 *vt_action_kind;
    struct s__sn__vt_action_related_s39848 *vt_action_related_separator_kind;
    struct s__sn__vt_action_special_a39849 *vt_action_special_attribute;
    struct s__sn__vt_statusbar_pane_s39850 *vt_statusbar_pane_scope;
    struct s__sn__vt_history_event_ki39851 *vt_history_event_kind;
    struct s__sn__vt_toolbar_mode_des39852 *vt_toolbar_mode;
    struct s__sn__sni_vtx_jmanager_se48632 *sni_vtx_jmanager_service;
    struct s__sn__sni_vtx_jtable_desc48633 *sni_vtx_jtable;
    struct s__sn__sni_vtx_jtree_descriptor *sni_vtx_jtree;
    struct s__sn__sni_vtx_jtabctrl_de48634 *sni_vtx_jtabctrl;
    struct s__sn__sni_vtx_jtab_descriptor *sni_vtx_jtab;
    struct s__sn__sni_vtx_jdiff_viewe48635 *sni_vtx_jdiff_viewer;
    struct s__sn__sni_vtx_jhtml_viewe48636 *sni_vtx_jhtml_viewer;
    struct s__sn__sni_vtx_jcombobox_d48637 *sni_vtx_jcombobox;
    struct s__sn__sni_vtx_jtextfield_48638 *sni_vtx_jtextfield;
    struct s__sn__sni_vtx_jimage_desc48639 *sni_vtx_jimage;
    struct s__sn__sni_vtx_jsource_vie48640 *sni_vtx_jsource_viewer;
    struct s__sn__sni_vtx_jwindow_hea48641 *sni_vtx_jwindow_header;
    struct s__sn__sni_vtx_jbutton_des48642 *sni_vtx_jbutton;
    struct s__sn__sni_vtx_jsplitter_d48643 *sni_vtx_jsplitter;
    struct s__sn__sni_vtx_jpanel_desc48644 *sni_vtx_jpanel;
    struct s__sn__sni_vtx_jbase_windo48645 *sni_vtx_jbase_window;
    struct s__sn__sni_vtx_ebase_windo48646 *sni_vtx_ebase_window;
    struct s__sn__vtx_drawer_data_des48647 *vtx_drawer_data;
    struct s__sn__vtx_text_data_descriptor *vtx_text_data;
    struct s__sn__vtx_icon_data_descriptor *vtx_icon_data;
    struct s__sn__vtx_box_data_descriptor *vtx_box_data;
    struct s__sn__vtx_bar_data_descriptor *vtx_bar_data;
    struct s__sn__vtx_pie_slice_descriptor *vtx_pie_slice;
    struct s__sn__vtx_pie_data_descriptor *vtx_pie_data;
    struct s__sn__vtx_snorb_widget_it48648 *vtx_snorb_widget_item;
    struct s__sn__vtx_action_descriptor *vtx_action;
    struct s__sn__vtx_font_data_descriptor *vtx_font_data;
    struct s__sn__vtx_snorb_props_des48649 *vtx_snorb_props;
    struct s__sn__vtx_manager_snorb_p48650 *vtx_manager_snorb_props;
    struct s__sn__vtx_snorb_element_p48651 *vtx_snorb_element_props;
    struct s__sn__vtx_component_snorb48652 *vtx_component_snorb_props;
    struct s__sn__vtx_snorb_component48653 *vtx_snorb_component_actual_attributes;
    struct s__sn__vtx_snorb_table_row48654 *vtx_snorb_table_row;
    struct s__sn__vtx_snorb_table_col48655 *vtx_snorb_table_col;
    struct s__sn__vtx_col_cell_values48656 *vtx_col_cell_values;
    struct s__sn__vtx_table_snorb_pro48657 *vtx_table_snorb_props;
    struct s__sn__vtx_snorb_table_act48658 *vtx_snorb_table_actual_attributes;
    struct s__sn__vtx_snorb_tree_node48659 *vtx_snorb_tree_node;
    struct s__sn__vtx_tree_snorb_prop48660 *vtx_tree_snorb_props;
    struct s__sn__vtx_tree_path_wrapp48661 *vtx_tree_path_wrapper;
    struct s__sn__vtx_snorb_tree_actu48662 *vtx_snorb_tree_actual_attributes;
    struct s__sn__vtx_tabctrl_snorb_p48663 *vtx_tabctrl_snorb_props;
    struct s__sn__vtx_snorb_tabctrl_a48664 *vtx_snorb_tabctrl_actual_attributes;
    struct s__sn__vtx_tab_snorb_props48665 *vtx_tab_snorb_props;
    struct s__sn__vtx_snorb_tab_actua48666 *vtx_snorb_tab_actual_attributes;
    struct s__sn__vtx_diff_viewer_sno48667 *vtx_diff_viewer_snorb_props;
    struct s__sn__vtx_diff_viewer_act48668 *vtx_diff_viewer_actual_attributes;
    struct s__sn__vtx_html_viewer_sno48669 *vtx_html_viewer_snorb_props;
    struct s__sn__vtx_snorb_html_view48670 *vtx_snorb_html_viewer_actual_attributes;
    struct s__sn__vtx_combobox_snorb_48671 *vtx_combobox_snorb_props;
    struct s__sn__vtx_snorb_combobox_48672 *vtx_snorb_combobox_actual_attributes;
    struct s__sn__vtx_textfield_snorb48673 *vtx_textfield_snorb_props;
    struct s__sn__vtx_snorb_textfield48674 *vtx_snorb_textfield_actual_attributes;
    struct s__sn__vtx_image_snorb_pro48675 *vtx_image_snorb_props;
    struct s__sn__vtx_snorb_image_act48676 *vtx_snorb_image_actual_attributes;
    struct s__sn__vtx_source_viewer_s48677 *vtx_source_viewer_snorb_props;
    struct s__sn__vtx_snorb_source_vi48678 *vtx_snorb_source_viewer_actual_attributes;
    struct s__sn__vtx_window_header_s48679 *vtx_window_header_snorb_props;
    struct s__sn__vtx_snorb_window_he48680 *vtx_snorb_window_header_actual_attributes;
    struct s__sn__vtx_button_snorb_pr48681 *vtx_button_snorb_props;
    struct s__sn__vtx_snorb_button_ac48682 *vtx_snorb_button_actual_attributes;
    struct s__sn__vtx_splitter_snorb_48683 *vtx_splitter_snorb_props;
    struct s__sn__vtx_snorb_splitter_48684 *vtx_snorb_splitter_actual_attributes;
    struct s__sn__vtx_panel_snorb_pro48685 *vtx_panel_snorb_props;
    struct s__sn__vtx_snorb_panel_act48686 *vtx_snorb_panel_actual_attributes;
    struct s__sn__vtx_snorb_base_wind48687 *vtx_snorb_base_window_props;
    struct s__sn__vtx_snorb_window_ac48688 *vtx_snorb_window_actual_attributes;
    struct s__sn__vtx_snorb_window_cr48689 *vtx_snorb_window_creation_result;
    struct s__sn__vtx_snorb_splitter_48690 *vtx_snorb_splitter_settings;
    struct s__sn__vtx_snorb_tabctrl_s48691 *vtx_snorb_tabctrl_settings;
    struct s__sn__vtx_snorb_base_wind48692 *vtx_snorb_base_window_gui_settings;
    struct s__sn__vtx_bar_format_desc48693 *vtx_bar_format;
    struct s__sn__vtx_element_kind_de48694 *vtx_element_kind;
    struct s__sn__vtx_raw_event_kind_48695 *vtx_raw_event_kind;
    struct s__sn__vtx_align_kind_desc48696 *vtx_align_kind;
    struct s__sn__vtx_border_kind_des48697 *vtx_border_kind;
    struct s__sn__vtx_expandable_mode48698 *vtx_expandable_mode;
    struct s__sn__vtx_table_col_kind_48699 *vtx_table_col_kind;
    struct s__sn__vtx_tab_position_de48700 *vtx_tab_position;
    struct s__sn__vtx_label_layout_de48701 *vtx_label_layout;
    struct s__sn__sn_abs_key_descriptor *sn_abs_key;
    struct s__sn__sn_event_parameter_54698 *sn_event_parameter_key;
    struct s__sn__sn_event_key_descriptor *sn_event_key;
    struct s__sn__sn_gendb_item_in_ge54699 *sn_gendb_item_in_gen_key;
    struct s__sn__sn_gendb_list_temp_54700 *sn_gendb_list_temp_key;
    struct s__sn__sn_instanciated_fie54701 *sn_instanciated_field_key;
    struct s__sn__sn_instanciated_lis54702 *sn_instanciated_list_item_key;
    struct s__sn__sn_role_info_key_de54703 *sn_role_info_key;
    struct s__sn__item_in_gen_kind_de54704 *item_in_gen_kind;
    struct s__sn__abs_range_props_des54705 *abs_range_props;
    struct s__sn__regular_range_props54706 *regular_range_props;
    struct s__sn__bit_range_props_des54707 *bit_range_props;
    struct s__sn__list_range_props_de54708 *list_range_props;
    struct s__sn__sni_egendebugger_se54709 *sni_egendebugger_service;
    struct s__sn__sni_jgendebugger_se54710 *sni_jgendebugger_service;
    struct s__sn__sn_gen_event_props_54711 *sn_gen_event_props;
    struct s__sn__sn_set_value_event_54712 *sn_set_value_event_props;
    struct s__sn__sn_set_scalar_event54713 *sn_set_scalar_event_props;
    struct s__sn__sn_set_struct_event54714 *sn_set_struct_event_props;
    struct s__sn__sn_set_list_event_p54715 *sn_set_list_event_props;
    struct s__sn__sn_gen_root_event_p54716 *sn_gen_root_event_props;
    struct s__sn__sn_gen_root_event_p54717 *sn_gen_root_event_props_flags;
    struct s__sn__sn_start_gen_event_54718 *sn_start_gen_event_props;
    struct s__sn__sn_gen_struct_event54719 *sn_gen_struct_event_props;
    struct s__sn__sn_gen_list_event_p54720 *sn_gen_list_event_props;
    struct s__sn__sn_end_event_props_54721 *sn_end_event_props;
    struct s__sn__sn_end_gen_event_pr54722 *sn_end_gen_event_props;
    struct s__sn__sn_end_struct_event54723 *sn_end_struct_event_props;
    struct s__sn__sn_end_list_event_p54724 *sn_end_list_event_props;
    struct s__sn__sn_testing_event_pr54725 *sn_testing_event_props;
    struct s__sn__sn_constraint_testi54726 *sn_constraint_testing_event_props;
    struct s__sn__sn_dynamic_reductio54727 *sn_dynamic_reduction_event_props;
    struct s__sn__sn_static_reduction54728 *sn_static_reduction_event_props;
    struct s__sn__sn_soft_testing_eve54729 *sn_soft_testing_event_props;
    struct s__sn__sn_soft_reduction_e54730 *sn_soft_reduction_event_props;
    struct s__sn__sn_reset_soft_event54731 *sn_reset_soft_event_props;
    struct s__sn__sn_set_status_event54732 *sn_set_status_event_props;
    struct s__sn__sn_create_edge_even54733 *sn_create_edge_event_props;
    struct s__sn__sn_dynamic_edge_eve54734 *sn_dynamic_edge_event_props;
    struct s__sn__sn_start_collect_ev54735 *sn_start_collect_event_props;
    struct s__sn__sn_stop_collect_eve54736 *sn_stop_collect_event_props;
    struct s__sn__sn_static_edge_even54737 *sn_static_edge_event_props;
    struct s__sn__sn_start_preorder_e54738 *sn_start_preorder_event_props;
    struct s__sn__sn_end_preorder_eve54739 *sn_end_preorder_event_props;
    struct s__sn__sn_cycle_error_even54740 *sn_cycle_error_event_props;
    struct s__sn__sn_static_cycle_err54741 *sn_static_cycle_error_event_props;
    struct s__sn__sn_run_time_cycle_e54742 *sn_run_time_cycle_error_event_props;
    struct s__sn__sn_preorder_top_eve54743 *sn_preorder_top_event_props;
    struct s__sn__sn_instanciated_fie54744 *sn_instanciated_field_props;
    struct s__sn__sn_instanciated_lis54745 *sn_instanciated_list_props;
    struct s__sn__sn_instanciated_lis54746 *sn_instanciated_list_item_props;
    struct s__sn__sn_role_info_props_54747 *sn_role_info_props;
    struct s__sn__gendb_item_in_gen_p54748 *gendb_item_in_gen_props;
    struct s__sn__gendb_field_in_role54749 *gendb_field_in_role_props;
    struct s__sn__gendb_list_in_role_54750 *gendb_list_in_role_props;
    struct s__sn__gendb_field_in_gen_54751 *gendb_field_in_gen_props;
    struct s__sn__gendb_list_item_in_54752 *gendb_list_item_in_gen_props;
    struct s__sn__gendb_gc_in_role_pr54753 *gendb_gc_in_role_props;
    struct s__sn__gendb_ci_in_gen_pro54754 *gendb_ci_in_gen_props;
    struct s__sn__gendb_item_props_de54755 *gendb_item_props;
    struct s__sn__constant_gendb_item54756 *constant_gendb_item_props;
    struct s__sn__simple_local_gendb_54757 *simple_local_gendb_item_props;
    struct s__sn__static_gendb_item_p54758 *static_gendb_item_props;
    struct s__sn__changed_static_gend54759 *changed_static_gendb_item_props;
    struct s__sn__held_gendb_item_pro54760 *held_gendb_item_props;
    struct s__sn__me_gendb_item_props54761 *me_gendb_item_props;
    struct s__sn__fix_me_gendb_item_p54762 *fix_me_gendb_item_props;
    struct s__sn__not_fix_me_gendb_it54763 *not_fix_me_gendb_item_props;
    struct s__sn__changed_gendb_item_54764 *changed_gendb_item_props;
    struct s__sn__sn_arrow_props_desc54765 *sn_arrow_props;
    struct s__sn__abs_query_result_pr54766 *abs_query_result_props;
    struct s__sn__history_result_prop54767 *history_result_props;
    struct s__sn__reason_result_props54768 *reason_result_props;
    struct s__sn__closure_result_prop54769 *closure_result_props;
    struct s__sn__effect_result_props54770 *effect_result_props;
    struct s__sn__abs_ci_status_props54771 *abs_ci_status_props;
    struct s__sn__sn_ci_status_unchan54772 *sn_ci_status_unchanged_props;
    struct s__sn__sn_ci_status_change54773 *sn_ci_status_changed_props;
    struct s__sn__sn_status_result_ki54774 *sn_status_result_kinds;
} *t__sn__snorb_all_descriptors;
#define d__sn__snorb_all_descriptors 3465
typedef t__sn__snorb_all_descriptors t__snorb_all_descriptors;
#define d__snorb_all_descriptors d__sn__snorb_all_descriptors

/* line 15 "/vobs/specman/src/snorb/orb/services/gencode/sni_service_repository_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_service_reposit23750 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_service_repository_descriptor;
#define d__sn__sni_service_repository_descriptor 3484
typedef t__sn__sni_service_repository_descriptor t__sni_service_repository_descriptor;
#define d__sni_service_repository_descriptor d__sn__sni_service_repository_descriptor

/* line 15 "/vobs/specman/src/snorb/orb/services/gencode/sn_object_id_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_object_id_data_d23751 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_object_id_data_descriptor;
#define d__sn__sn_object_id_data_descriptor 3485
typedef t__sn__sn_object_id_data_descriptor t__sn_object_id_data_descriptor;
#define d__sn_object_id_data_descriptor d__sn__sn_object_id_data_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sn_jcvr_id_path_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_jcvr_id_path_des27154 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_jcvr_id_path_descriptor;
#define d__sn__sn_jcvr_id_path_descriptor 3903
typedef t__sn__sn_jcvr_id_path_descriptor t__sn_jcvr_id_path_descriptor;
#define d__sn_jcvr_id_path_descriptor d__sn__sn_jcvr_id_path_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sn_jcvr_cross_interval_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_jcvr_cross_inter27155 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_jcvr_cross_interval_descriptor;
#define d__sn__sn_jcvr_cross_interval_descriptor 3904
typedef t__sn__sn_jcvr_cross_interval_descriptor t__sn_jcvr_cross_interval_descriptor;
#define d__sn_jcvr_cross_interval_descriptor d__sn__sn_jcvr_cross_interval_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sni_jcvr_change_listener_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jcvr_change_lis27156 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jcvr_change_listener_descriptor;
#define d__sn__sni_jcvr_change_listener_descriptor 3905
typedef t__sn__sni_jcvr_change_listener_descriptor t__sni_jcvr_change_listener_descriptor;
#define d__sni_jcvr_change_listener_descriptor d__sn__sni_jcvr_change_listener_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sni_jcvr_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jcvr_service_de27157 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jcvr_service_descriptor;
#define d__sn__sni_jcvr_service_descriptor 3906
typedef t__sn__sni_jcvr_service_descriptor t__sni_jcvr_service_descriptor;
#define d__sni_jcvr_service_descriptor d__sn__sni_jcvr_service_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sni_jcvrgui_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jcvrgui_service27158 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jcvrgui_service_descriptor;
#define d__sn__sni_jcvrgui_service_descriptor 3907
typedef t__sn__sni_jcvrgui_service_descriptor t__sni_jcvrgui_service_descriptor;
#define d__sni_jcvrgui_service_descriptor d__sn__sni_jcvrgui_service_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/show_mode_declare.e"  From 'struct definition' */
typedef struct s__sn__show_mode_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__show_mode_descriptor;
#define d__sn__show_mode_descriptor 3908
typedef t__sn__show_mode_descriptor t__show_mode_descriptor;
#define d__show_mode_descriptor d__sn__show_mode_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_abs_action_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_abs_action_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_abs_action_descriptor;
#define d__sn__vt_abs_action_descriptor 3953
typedef t__sn__vt_abs_action_descriptor t__vt_abs_action_descriptor;
#define d__vt_abs_action_descriptor d__sn__vt_abs_action_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_action_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_action_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_action_descriptor;
#define d__sn__vt_action_descriptor 3954
typedef t__sn__vt_action_descriptor t__vt_action_descriptor;
#define d__vt_action_descriptor d__sn__vt_action_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_user_action_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_user_action_desc31730 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_user_action_descriptor;
#define d__sn__vt_user_action_descriptor 3955
typedef t__sn__vt_user_action_descriptor t__vt_user_action_descriptor;
#define d__vt_user_action_descriptor d__sn__vt_user_action_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_lnf_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_lnf_props_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_lnf_props_descriptor;
#define d__sn__vt_lnf_props_descriptor 3956
typedef t__sn__vt_lnf_props_descriptor t__vt_lnf_props_descriptor;
#define d__vt_lnf_props_descriptor d__sn__vt_lnf_props_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_window_toplevel_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_window_toplevel_31731 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_window_toplevel_data_descriptor;
#define d__sn__sn_window_toplevel_data_descriptor 3957
typedef t__sn__sn_window_toplevel_data_descriptor t__sn_window_toplevel_data_descriptor;
#define d__sn_window_toplevel_data_descriptor d__sn__sn_window_toplevel_data_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_window_kind_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_window_kind_data31732 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_window_kind_data_descriptor;
#define d__sn__sn_window_kind_data_descriptor 3958
typedef t__sn__sn_window_kind_data_descriptor t__sn_window_kind_data_descriptor;
#define d__sn_window_kind_data_descriptor d__sn__sn_window_kind_data_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_table_window_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_table_window_dat31733 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_table_window_data_descriptor;
#define d__sn__sn_table_window_data_descriptor 3959
typedef t__sn__sn_table_window_data_descriptor t__sn_table_window_data_descriptor;
#define d__sn_table_window_data_descriptor d__sn__sn_table_window_data_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_tree_window_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_tree_window_data31734 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_tree_window_data_descriptor;
#define d__sn__sn_tree_window_data_descriptor 3960
typedef t__sn__sn_tree_window_data_descriptor t__sn_tree_window_data_descriptor;
#define d__sn_tree_window_data_descriptor d__sn__sn_tree_window_data_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_widget_item_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_widget_item_desc31735 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_widget_item_descriptor;
#define d__sn__sn_widget_item_descriptor 3961
typedef t__sn__sn_widget_item_descriptor t__sn_widget_item_descriptor;
#define d__sn_widget_item_descriptor d__sn__sn_widget_item_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_table_row_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_table_row_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_table_row_descriptor;
#define d__sn__sn_table_row_descriptor 3962
typedef t__sn__sn_table_row_descriptor t__sn_table_row_descriptor;
#define d__sn_table_row_descriptor d__sn__sn_table_row_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_delta_row_update_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_delta_row_update31736 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_delta_row_update_descriptor;
#define d__sn__sn_delta_row_update_descriptor 3963
typedef t__sn__sn_delta_row_update_descriptor t__sn_delta_row_update_descriptor;
#define d__sn_delta_row_update_descriptor d__sn__sn_delta_row_update_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_internal_tree_node_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_internal_tree_no31737 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_internal_tree_node_descriptor;
#define d__sn__sn_internal_tree_node_descriptor 3964
typedef t__sn__sn_internal_tree_node_descriptor t__sn_internal_tree_node_descriptor;
#define d__sn_internal_tree_node_descriptor d__sn__sn_internal_tree_node_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_table_col_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_table_col_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_table_col_descriptor;
#define d__sn__sn_table_col_descriptor 3965
typedef t__sn__sn_table_col_descriptor t__sn_table_col_descriptor;
#define d__sn_table_col_descriptor d__sn__sn_table_col_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_window_header_config_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_window_header_co31738 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_window_header_config_descriptor;
#define d__sn__vt_window_header_config_descriptor 3966
typedef t__sn__vt_window_header_config_descriptor t__vt_window_header_config_descriptor;
#define d__vt_window_header_config_descriptor d__sn__vt_window_header_config_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_window_header_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_window_header_da31739 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_window_header_data_descriptor;
#define d__sn__vt_window_header_data_descriptor 3967
typedef t__sn__vt_window_header_data_descriptor t__vt_window_header_data_descriptor;
#define d__vt_window_header_data_descriptor d__sn__vt_window_header_data_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_vt_action_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_vt_action_kind_d31740 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_vt_action_kind_descriptor;
#define d__sn__sn_vt_action_kind_descriptor 3968
typedef t__sn__sn_vt_action_kind_descriptor t__sn_vt_action_kind_descriptor;
#define d__sn_vt_action_kind_descriptor d__sn__sn_vt_action_kind_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_action_type_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_action_type_desc31741 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_action_type_descriptor;
#define d__sn__vt_action_type_descriptor 3970
typedef t__sn__vt_action_type_descriptor t__vt_action_type_descriptor;
#define d__vt_action_type_descriptor d__sn__vt_action_type_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_menu_action_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_menu_action_kind31742 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_menu_action_kind_descriptor;
#define d__sn__vt_menu_action_kind_descriptor 3972
typedef t__sn__vt_menu_action_kind_descriptor t__vt_menu_action_kind_descriptor;
#define d__vt_menu_action_kind_descriptor d__sn__vt_menu_action_kind_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_file_dialog_content_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_file_dialog_cont31743 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_file_dialog_content_kind_descriptor;
#define d__sn__vt_file_dialog_content_kind_descriptor 3974
typedef t__sn__vt_file_dialog_content_kind_descriptor t__vt_file_dialog_content_kind_descriptor;
#define d__vt_file_dialog_content_kind_descriptor d__sn__vt_file_dialog_content_kind_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_file_dialog_operation_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_file_dialog_oper31744 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_file_dialog_operation_kind_descriptor;
#define d__sn__vt_file_dialog_operation_kind_descriptor 3976
typedef t__sn__vt_file_dialog_operation_kind_descriptor t__vt_file_dialog_operation_kind_descriptor;
#define d__vt_file_dialog_operation_kind_descriptor d__sn__vt_file_dialog_operation_kind_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_color_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_color_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__vt_color_descriptor;
#define d__sn__vt_color_descriptor 3978
typedef t__sn__vt_color_descriptor t__vt_color_descriptor;
#define d__vt_color_descriptor d__sn__vt_color_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/vt_font_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_font_kind_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__vt_font_kind_descriptor;
#define d__sn__vt_font_kind_descriptor 3980
typedef t__sn__vt_font_kind_descriptor t__vt_font_kind_descriptor;
#define d__vt_font_kind_descriptor d__sn__vt_font_kind_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_pair_nums_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_pair_nums_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_pair_nums_descriptor;
#define d__sn__sn_pair_nums_descriptor 3982
typedef t__sn__sn_pair_nums_descriptor t__sn_pair_nums_descriptor;
#define d__sn_pair_nums_descriptor d__sn__sn_pair_nums_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_source_ref_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_source_ref_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_source_ref_descriptor;
#define d__sn__sn_source_ref_descriptor 3983
typedef t__sn__sn_source_ref_descriptor t__sn_source_ref_descriptor;
#define d__sn_source_ref_descriptor d__sn__sn_source_ref_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_simple_type_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_simple_type_desc31745 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_simple_type_descriptor;
#define d__sn__sn_simple_type_descriptor 3984
typedef t__sn__sn_simple_type_descriptor t__sn_simple_type_descriptor;
#define d__sn_simple_type_descriptor d__sn__sn_simple_type_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/file_status_declare.e"  From 'struct definition' */
typedef struct s__sn__file_status_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__file_status_descriptor;
#define d__sn__file_status_descriptor 3986
typedef t__sn__file_status_descriptor t__file_status_descriptor;
#define d__file_status_descriptor d__sn__file_status_descriptor

/* line 14 "/vobs/specman/src/japp/shared_minimal/gencode/sn_coordinate_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_coordinate_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_coordinate_descriptor;
#define d__sn__sn_coordinate_descriptor 3988
typedef t__sn__sn_coordinate_descriptor t__sn_coordinate_descriptor;
#define d__sn_coordinate_descriptor d__sn__sn_coordinate_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/vt_items_wrapper_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_items_wrapper_de31746 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_items_wrapper_descriptor;
#define d__sn__vt_items_wrapper_descriptor 4017
typedef t__sn__vt_items_wrapper_descriptor t__vt_items_wrapper_descriptor;
#define d__vt_items_wrapper_descriptor d__sn__vt_items_wrapper_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/sn_int_list_wrapper_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_int_list_wrapper31747 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_int_list_wrapper_descriptor;
#define d__sn__sn_int_list_wrapper_descriptor 4018
typedef t__sn__sn_int_list_wrapper_descriptor t__sn_int_list_wrapper_descriptor;
#define d__sn_int_list_wrapper_descriptor d__sn__sn_int_list_wrapper_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/vt_location_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_location_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_location_descriptor;
#define d__sn__vt_location_descriptor 4019
typedef t__sn__vt_location_descriptor t__vt_location_descriptor;
#define d__vt_location_descriptor d__sn__vt_location_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/vt_size_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_size_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_size_descriptor;
#define d__sn__vt_size_descriptor 4020
typedef t__sn__vt_size_descriptor t__vt_size_descriptor;
#define d__vt_size_descriptor d__sn__vt_size_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/vt_rect_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_rect_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_rect_descriptor;
#define d__sn__vt_rect_descriptor 4021
typedef t__sn__vt_rect_descriptor t__vt_rect_descriptor;
#define d__vt_rect_descriptor d__sn__vt_rect_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/vt_font_size_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_font_size_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__vt_font_size_descriptor;
#define d__sn__vt_font_size_descriptor 4022
typedef t__sn__vt_font_size_descriptor t__vt_font_size_descriptor;
#define d__vt_font_size_descriptor d__sn__vt_font_size_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/vt_bool_tristate_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_bool_tristate_de31748 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_bool_tristate_descriptor;
#define d__sn__vt_bool_tristate_descriptor 4024
typedef t__sn__vt_bool_tristate_descriptor t__vt_bool_tristate_descriptor;
#define d__vt_bool_tristate_descriptor d__sn__vt_bool_tristate_descriptor

/* line 14 "/vobs/specman/src/japp/shared_extra/gencode/sn_pair_strings_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_pair_strings_des31749 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_pair_strings_descriptor;
#define d__sn__sn_pair_strings_descriptor 4026
typedef t__sn__sn_pair_strings_descriptor t__sn_pair_strings_descriptor;
#define d__sn_pair_strings_descriptor d__sn__sn_pair_strings_descriptor

/* line 14 "/vobs/specman/src/snorb/pub_services/sni_specman_command/gencode/sni_specman_command_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_specman_command31750 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_specman_command_descriptor;
#define d__sn__sni_specman_command_descriptor 4227
typedef t__sn__sni_specman_command_descriptor t__sni_specman_command_descriptor;
#define d__sni_specman_command_descriptor d__sn__sni_specman_command_descriptor

/* line 14 "/vobs/specman/src/snorb/pub_services/sni_specman_command/gencode/sn_specman_status_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_specman_status_d31751 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_specman_status_descriptor;
#define d__sn__sn_specman_status_descriptor 4228
typedef t__sn__sn_specman_status_descriptor t__sn_specman_status_descriptor;
#define d__sn_specman_status_descriptor d__sn__sn_specman_status_descriptor

/* line 15 "/vobs/specman/src/snorb/pub_services/sni_specview_service/gencode/sni_specview_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_specview_servic31752 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_specview_service_descriptor;
#define d__sn__sni_specview_service_descriptor 4237
typedef t__sn__sni_specview_service_descriptor t__sni_specview_service_descriptor;
#define d__sni_specview_service_descriptor d__sn__sni_specview_service_descriptor

/* line 15 "/vobs/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_font_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_font_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_font_data_descriptor;
#define d__sn__sn_font_data_descriptor 4238
typedef t__sn__sn_font_data_descriptor t__sn_font_data_descriptor;
#define d__sn_font_data_descriptor d__sn__sn_font_data_descriptor

/* line 15 "/vobs/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_color_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_color_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_color_data_descriptor;
#define d__sn__sn_color_data_descriptor 4239
typedef t__sn__sn_color_data_descriptor t__sn_color_data_descriptor;
#define d__sn_color_data_descriptor d__sn__sn_color_data_descriptor

/* line 15 "/vobs/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_gui_resources_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gui_resources_de31753 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gui_resources_descriptor;
#define d__sn__sn_gui_resources_descriptor 4240
typedef t__sn__sn_gui_resources_descriptor t__sn_gui_resources_descriptor;
#define d__sn_gui_resources_descriptor d__sn__sn_gui_resources_descriptor

/* line 15 "/vobs/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_specview_socket_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_specview_socket_31754 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_specview_socket_data_descriptor;
#define d__sn__sn_specview_socket_data_descriptor 4241
typedef t__sn__sn_specview_socket_data_descriptor t__sn_specview_socket_data_descriptor;
#define d__sn_specview_socket_data_descriptor d__sn__sn_specview_socket_data_descriptor

/* line 15 "/vobs/specman/src/snorb/pub_services/sni_remote_appl_manager/gencode/sni_remote_appl_manager_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_remote_appl_man31755 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_remote_appl_manager_descriptor;
#define d__sn__sni_remote_appl_manager_descriptor 4253
typedef t__sn__sni_remote_appl_manager_descriptor t__sni_remote_appl_manager_descriptor;
#define d__sni_remote_appl_manager_descriptor d__sn__sni_remote_appl_manager_descriptor

/* line 15 "/vobs/specman/src/snorb/pub_services/sni_remote_appl_manager/gencode/sni_remote_appl_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_remote_appl_des31756 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_remote_appl_descriptor;
#define d__sn__sni_remote_appl_descriptor 4254
typedef t__sn__sni_remote_appl_descriptor t__sni_remote_appl_descriptor;
#define d__sni_remote_appl_descriptor d__sn__sni_remote_appl_descriptor

/* line 14 "/vobs/specman/src/japp/jspecview_deli/gencode/sni_jspecview_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jspecview_servi39743 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jspecview_service_descriptor;
#define d__sn__sni_jspecview_service_descriptor 4409
typedef t__sn__sni_jspecview_service_descriptor t__sni_jspecview_service_descriptor;
#define d__sni_jspecview_service_descriptor d__sn__sni_jspecview_service_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sni_e_jcvr_external_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_e_jcvr_external39744 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_e_jcvr_external_service_descriptor;
#define d__sn__sni_e_jcvr_external_service_descriptor 4424
typedef t__sn__sni_e_jcvr_external_service_descriptor t__sni_e_jcvr_external_service_descriptor;
#define d__sni_e_jcvr_external_service_descriptor d__sn__sni_e_jcvr_external_service_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sn_jcvr_external_properties_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_jcvr_external_pr39745 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_jcvr_external_properties_descriptor;
#define d__sn__sn_jcvr_external_properties_descriptor 4425
typedef t__sn__sn_jcvr_external_properties_descriptor t__sn_jcvr_external_properties_descriptor;
#define d__sn_jcvr_external_properties_descriptor d__sn__sn_jcvr_external_properties_descriptor

/* line 15 "/vobs/specman/src/japp/jcvr/gencode/sn_jcvr_external_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_jcvr_external_de39746 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_jcvr_external_descriptor;
#define d__sn__sn_jcvr_external_descriptor 4426
typedef t__sn__sn_jcvr_external_descriptor t__sn_jcvr_external_descriptor;
#define d__sn_jcvr_external_descriptor d__sn__sn_jcvr_external_descriptor

/* line 14 "/vobs/specman/src/japp/jutils/gencode/sni_e_jutils_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_e_jutils_servic39747 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_e_jutils_service_descriptor;
#define d__sn__sni_e_jutils_service_descriptor 4439
typedef t__sn__sni_e_jutils_service_descriptor t__sni_e_jutils_service_descriptor;
#define d__sni_e_jutils_service_descriptor d__sn__sni_e_jutils_service_descriptor

/* line 14 "/vobs/specman/src/japp/jutils/gencode/sn_source_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_source_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_source_descriptor;
#define d__sn__sn_source_descriptor 4440
typedef t__sn__sn_source_descriptor t__sn_source_descriptor;
#define d__sn_source_descriptor d__sn__sn_source_descriptor

/* line 14 "/vobs/specman/src/japp/jutils/gencode/sn_module_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_module_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_module_descriptor;
#define d__sn__sn_module_descriptor 4441
typedef t__sn__sn_module_descriptor t__sn_module_descriptor;
#define d__sn_module_descriptor d__sn__sn_module_descriptor

/* line 14 "/vobs/specman/src/japp/jutils/gencode/sn_file_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_file_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_file_descriptor;
#define d__sn__sn_file_descriptor 4442
typedef t__sn__sn_file_descriptor t__sn_file_descriptor;
#define d__sn_file_descriptor d__sn__sn_file_descriptor

/* line 14 "/vobs/specman/src/japp/jutils/gencode/sn_e_file_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_e_file_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_e_file_descriptor;
#define d__sn__sn_e_file_descriptor 4443
typedef t__sn__sn_e_file_descriptor t__sn_e_file_descriptor;
#define d__sn_e_file_descriptor d__sn__sn_e_file_descriptor

/* line 14 "/vobs/specman/src/japp/jutils/gencode/encryption_status_declare.e"  From 'struct definition' */
typedef struct s__sn__encryption_status_d39748 {
    t__int d__;
    t__int gen__;
} *t__sn__encryption_status_descriptor;
#define d__sn__encryption_status_descriptor 4444
typedef t__sn__encryption_status_descriptor t__encryption_status_descriptor;
#define d__encryption_status_descriptor d__sn__encryption_status_descriptor

/* line 14 "/vobs/specman/src/japp/jconfig/gencode/sni_jconfig_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jconfig_service39749 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jconfig_service_descriptor;
#define d__sn__sni_jconfig_service_descriptor 4460
typedef t__sn__sni_jconfig_service_descriptor t__sni_jconfig_service_descriptor;
#define d__sni_jconfig_service_descriptor d__sn__sni_jconfig_service_descriptor

/* line 14 "/vobs/specman/src/japp/jconfig/gencode/sni_econfig_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_econfig_service39750 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_econfig_service_descriptor;
#define d__sn__sni_econfig_service_descriptor 4461
typedef t__sn__sni_econfig_service_descriptor t__sni_econfig_service_descriptor;
#define d__sni_econfig_service_descriptor d__sn__sni_econfig_service_descriptor

/* line 14 "/vobs/specman/src/japp/jconfig/gencode/sn_jconfig_data_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig_data_des39751 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_jconfig_data_descriptor;
#define d__sn__sn_jconfig_data_descriptor 4462
typedef t__sn__sn_jconfig_data_descriptor t__sn_jconfig_data_descriptor;
#define d__sn_jconfig_data_descriptor d__sn__sn_jconfig_data_descriptor

/* line 14 "/vobs/specman/src/japp/jconfig/gencode/sn_jconfig_category_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig_category39752 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_jconfig_category_val_descriptor;
#define d__sn__sn_jconfig_category_val_descriptor 4463
typedef t__sn__sn_jconfig_category_val_descriptor t__sn_jconfig_category_val_descriptor;
#define d__sn_jconfig_category_val_descriptor d__sn__sn_jconfig_category_val_descriptor

/* line 14 "/vobs/specman/src/japp/jconfig/gencode/sn_jconfig_item_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig_item_val39753 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_jconfig_item_val_descriptor;
#define d__sn__sn_jconfig_item_val_descriptor 4464
typedef t__sn__sn_jconfig_item_val_descriptor t__sn_jconfig_item_val_descriptor;
#define d__sn_jconfig_item_val_descriptor d__sn__sn_jconfig_item_val_descriptor

/* line 14 "/vobs/specman/src/japp/jsource_viewer/gencode/sni_jsource_viewer_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jsource_viewer_39754 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jsource_viewer_service_descriptor;
#define d__sn__sni_jsource_viewer_service_descriptor 4479
typedef t__sn__sni_jsource_viewer_service_descriptor t__sni_jsource_viewer_service_descriptor;
#define d__sni_jsource_viewer_service_descriptor d__sn__sni_jsource_viewer_service_descriptor

/* line 14 "/vobs/specman/src/japp/mini_guitest/gencode/sni_jmini_guitest_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jmini_guitest_s39755 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jmini_guitest_service_descriptor;
#define d__sn__sni_jmini_guitest_service_descriptor 4494
typedef t__sn__sni_jmini_guitest_service_descriptor t__sni_jmini_guitest_service_descriptor;
#define d__sni_jmini_guitest_service_descriptor d__sn__sni_jmini_guitest_service_descriptor

/* line 14 "/vobs/specman/src/japp/mini_guitest/gencode/vtx_tree_node_actual_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_tree_node_actua39756 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_tree_node_actual_data_descriptor;
#define d__sn__vtx_tree_node_actual_data_descriptor 4495
typedef t__sn__vtx_tree_node_actual_data_descriptor t__vtx_tree_node_actual_data_descriptor;
#define d__vtx_tree_node_actual_data_descriptor d__sn__vtx_tree_node_actual_data_descriptor

/* line 14 "/vobs/specman/src/japp/mini_guitest/gencode/vtx_bar_actual_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_bar_actual_data39757 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_bar_actual_data_descriptor;
#define d__sn__vtx_bar_actual_data_descriptor 4496
typedef t__sn__vtx_bar_actual_data_descriptor t__vtx_bar_actual_data_descriptor;
#define d__vtx_bar_actual_data_descriptor d__sn__vtx_bar_actual_data_descriptor

/* line 14 "/vobs/specman/src/japp/mini_guitest/gencode/vtx_pie_slice_actual_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_pie_slice_actua39758 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_pie_slice_actual_data_descriptor;
#define d__sn__vtx_pie_slice_actual_data_descriptor 4497
typedef t__sn__vtx_pie_slice_actual_data_descriptor t__vtx_pie_slice_actual_data_descriptor;
#define d__vtx_pie_slice_actual_data_descriptor d__sn__vtx_pie_slice_actual_data_descriptor

/* line 14 "/vobs/specman/src/japp/mini_guitest/gencode/vtx_pie_actual_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_pie_actual_data39759 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_pie_actual_data_descriptor;
#define d__sn__vtx_pie_actual_data_descriptor 4498
typedef t__sn__vtx_pie_actual_data_descriptor t__vtx_pie_actual_data_descriptor;
#define d__vtx_pie_actual_data_descriptor d__sn__vtx_pie_actual_data_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_abs_val_identifier_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_val_identifi39760 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_val_identifier_descriptor;
#define d__sn__sn_abs_val_identifier_descriptor 4590
typedef t__sn__sn_abs_val_identifier_descriptor t__sn_abs_val_identifier_descriptor;
#define d__sn_abs_val_identifier_descriptor d__sn__sn_abs_val_identifier_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_val_ref_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_val_ref_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_val_ref_descriptor;
#define d__sn__sn_val_ref_descriptor 4591
typedef t__sn__sn_val_ref_descriptor t__sn_val_ref_descriptor;
#define d__sn_val_ref_descriptor d__sn__sn_val_ref_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_scalar_val_ref_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_scalar_val_ref_d39761 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_scalar_val_ref_descriptor;
#define d__sn__sn_scalar_val_ref_descriptor 4592
typedef t__sn__sn_scalar_val_ref_descriptor t__sn_scalar_val_ref_descriptor;
#define d__sn_scalar_val_ref_descriptor d__sn__sn_scalar_val_ref_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_abs_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_val_descriptor;
#define d__sn__sn_abs_val_descriptor 4593
typedef t__sn__sn_abs_val_descriptor t__sn_abs_val_descriptor;
#define d__sn_abs_val_descriptor d__sn__sn_abs_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_abs_scalar_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_scalar_val_d39762 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_scalar_val_descriptor;
#define d__sn__sn_abs_scalar_val_descriptor 4594
typedef t__sn__sn_abs_scalar_val_descriptor t__sn_abs_scalar_val_descriptor;
#define d__sn_abs_scalar_val_descriptor d__sn__sn_abs_scalar_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_event_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_event_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_event_val_descriptor;
#define d__sn__sn_event_val_descriptor 4595
typedef t__sn__sn_event_val_descriptor t__sn_event_val_descriptor;
#define d__sn_event_val_descriptor d__sn__sn_event_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_abs_container_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_container_va39763 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_container_val_descriptor;
#define d__sn__sn_abs_container_val_descriptor 4596
typedef t__sn__sn_abs_container_val_descriptor t__sn_abs_container_val_descriptor;
#define d__sn_abs_container_val_descriptor d__sn__sn_abs_container_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_list_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_list_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_list_val_descriptor;
#define d__sn__sn_list_val_descriptor 4597
typedef t__sn__sn_list_val_descriptor t__sn_list_val_descriptor;
#define d__sn_list_val_descriptor d__sn__sn_list_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_port_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_port_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_port_val_descriptor;
#define d__sn__sn_port_val_descriptor 4598
typedef t__sn__sn_port_val_descriptor t__sn_port_val_descriptor;
#define d__sn_port_val_descriptor d__sn__sn_port_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_instance_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_instance_val_des39764 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_instance_val_descriptor;
#define d__sn__sn_instance_val_descriptor 4599
typedef t__sn__sn_instance_val_descriptor t__sn_instance_val_descriptor;
#define d__sn_instance_val_descriptor d__sn__sn_instance_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_instance_null_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_instance_null_va39765 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_instance_null_val_descriptor;
#define d__sn__sn_instance_null_val_descriptor 4600
typedef t__sn__sn_instance_null_val_descriptor t__sn_instance_null_val_descriptor;
#define d__sn_instance_null_val_descriptor d__sn__sn_instance_null_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_unit_instance_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_unit_instance_va39766 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_unit_instance_val_descriptor;
#define d__sn__sn_unit_instance_val_descriptor 4601
typedef t__sn__sn_unit_instance_val_descriptor t__sn_unit_instance_val_descriptor;
#define d__sn_unit_instance_val_descriptor d__sn__sn_unit_instance_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_string_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_string_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_string_val_descriptor;
#define d__sn__sn_string_val_descriptor 4602
typedef t__sn__sn_string_val_descriptor t__sn_string_val_descriptor;
#define d__sn_string_val_descriptor d__sn__sn_string_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_specman_special_type_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_specman_special_39767 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_specman_special_type_val_descriptor;
#define d__sn__sn_specman_special_type_val_descriptor 4603
typedef t__sn__sn_specman_special_type_val_descriptor t__sn_specman_special_type_val_descriptor;
#define d__sn_specman_special_type_val_descriptor d__sn__sn_specman_special_type_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_specman_special_type_val_group_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_specman_special_39768 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_specman_special_type_val_group_descriptor;
#define d__sn__sn_specman_special_type_val_group_descriptor 4604
typedef t__sn__sn_specman_special_type_val_group_descriptor t__sn_specman_special_type_val_group_descriptor;
#define d__sn_specman_special_type_val_group_descriptor d__sn__sn_specman_special_type_val_group_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_int_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_int_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_int_val_descriptor;
#define d__sn__sn_int_val_descriptor 4605
typedef t__sn__sn_int_val_descriptor t__sn_int_val_descriptor;
#define d__sn_int_val_descriptor d__sn__sn_int_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_uint_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_uint_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_uint_val_descriptor;
#define d__sn__sn_uint_val_descriptor 4606
typedef t__sn__sn_uint_val_descriptor t__sn_uint_val_descriptor;
#define d__sn_uint_val_descriptor d__sn__sn_uint_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_bool_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_bool_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_bool_val_descriptor;
#define d__sn__sn_bool_val_descriptor 4607
typedef t__sn__sn_bool_val_descriptor t__sn_bool_val_descriptor;
#define d__sn_bool_val_descriptor d__sn__sn_bool_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_sized_int_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_sized_int_val_de39769 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_sized_int_val_descriptor;
#define d__sn__sn_sized_int_val_descriptor 4608
typedef t__sn__sn_sized_int_val_descriptor t__sn_sized_int_val_descriptor;
#define d__sn_sized_int_val_descriptor d__sn__sn_sized_int_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_enum_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_enum_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_enum_val_descriptor;
#define d__sn__sn_enum_val_descriptor 4609
typedef t__sn__sn_enum_val_descriptor t__sn_enum_val_descriptor;
#define d__sn_enum_val_descriptor d__sn__sn_enum_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_real_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_real_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_real_val_descriptor;
#define d__sn__sn_real_val_descriptor 4610
typedef t__sn__sn_real_val_descriptor t__sn_real_val_descriptor;
#define d__sn_real_val_descriptor d__sn__sn_real_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_abs_structual_segment_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_structual_se39770 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_structual_segment_descriptor;
#define d__sn__sn_abs_structual_segment_descriptor 4611
typedef t__sn__sn_abs_structual_segment_descriptor t__sn_abs_structual_segment_descriptor;
#define d__sn_abs_structual_segment_descriptor d__sn__sn_abs_structual_segment_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_abs_extension_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_extension_de39771 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_extension_descriptor;
#define d__sn__sn_abs_extension_descriptor 4612
typedef t__sn__sn_abs_extension_descriptor t__sn_abs_extension_descriptor;
#define d__sn_abs_extension_descriptor d__sn__sn_abs_extension_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_abs_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_descriptor_d39772 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_descriptor_descriptor;
#define d__sn__sn_abs_descriptor_descriptor 4613
typedef t__sn__sn_abs_descriptor_descriptor t__sn_abs_descriptor_descriptor;
#define d__sn_abs_descriptor_descriptor d__sn__sn_abs_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_type_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_type_descriptor_39773 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_type_descriptor_descriptor;
#define d__sn__sn_type_descriptor_descriptor 4614
typedef t__sn__sn_type_descriptor_descriptor t__sn_type_descriptor_descriptor;
#define d__sn_type_descriptor_descriptor d__sn__sn_type_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_scalar_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_scalar_descripto39774 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_scalar_descriptor_descriptor;
#define d__sn__sn_scalar_descriptor_descriptor 4615
typedef t__sn__sn_scalar_descriptor_descriptor t__sn_scalar_descriptor_descriptor;
#define d__sn_scalar_descriptor_descriptor d__sn__sn_scalar_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_enum_extension_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_enum_extension_d39775 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_enum_extension_descriptor_descriptor;
#define d__sn__sn_enum_extension_descriptor_descriptor 4616
typedef t__sn__sn_enum_extension_descriptor_descriptor t__sn_enum_extension_descriptor_descriptor;
#define d__sn_enum_extension_descriptor_descriptor d__sn__sn_enum_extension_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_enum_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_enum_descriptor_39776 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_enum_descriptor_descriptor;
#define d__sn__sn_enum_descriptor_descriptor 4617
typedef t__sn__sn_enum_descriptor_descriptor t__sn_enum_descriptor_descriptor;
#define d__sn_enum_descriptor_descriptor d__sn__sn_enum_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_list_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_list_descriptor_39777 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_list_descriptor_descriptor;
#define d__sn__sn_list_descriptor_descriptor 4618
typedef t__sn__sn_list_descriptor_descriptor t__sn_list_descriptor_descriptor;
#define d__sn_list_descriptor_descriptor d__sn__sn_list_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_port_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_port_descriptor_39778 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_port_descriptor_descriptor;
#define d__sn__sn_port_descriptor_descriptor 4619
typedef t__sn__sn_port_descriptor_descriptor t__sn_port_descriptor_descriptor;
#define d__sn_port_descriptor_descriptor d__sn__sn_port_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_struct_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_descripto39779 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_struct_descriptor_descriptor;
#define d__sn__sn_struct_descriptor_descriptor 4620
typedef t__sn__sn_struct_descriptor_descriptor t__sn_struct_descriptor_descriptor;
#define d__sn_struct_descriptor_descriptor d__sn__sn_struct_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_unit_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_unit_descriptor_39780 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_unit_descriptor_descriptor;
#define d__sn__sn_unit_descriptor_descriptor 4621
typedef t__sn__sn_unit_descriptor_descriptor t__sn_unit_descriptor_descriptor;
#define d__sn_unit_descriptor_descriptor d__sn__sn_unit_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_struct_storage_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_storage_d39781 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_struct_storage_descriptor;
#define d__sn__sn_struct_storage_descriptor 4622
typedef t__sn__sn_struct_storage_descriptor t__sn_struct_storage_descriptor;
#define d__sn_struct_storage_descriptor d__sn__sn_struct_storage_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_struct_storage_details_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_storage_d39782 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_struct_storage_details_descriptor;
#define d__sn__sn_struct_storage_details_descriptor 4623
typedef t__sn__sn_struct_storage_details_descriptor t__sn_struct_storage_details_descriptor;
#define d__sn_struct_storage_details_descriptor d__sn__sn_struct_storage_details_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_struct_member_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_member_de39783 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_struct_member_descriptor_descriptor;
#define d__sn__sn_struct_member_descriptor_descriptor 4624
typedef t__sn__sn_struct_member_descriptor_descriptor t__sn_struct_member_descriptor_descriptor;
#define d__sn_struct_member_descriptor_descriptor d__sn__sn_struct_member_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_field_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_field_descriptor39784 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_field_descriptor_descriptor;
#define d__sn__sn_field_descriptor_descriptor 4625
typedef t__sn__sn_field_descriptor_descriptor t__sn_field_descriptor_descriptor;
#define d__sn_field_descriptor_descriptor d__sn__sn_field_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_method_extension_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_method_extension39785 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_method_extension_descriptor_descriptor;
#define d__sn__sn_method_extension_descriptor_descriptor 4626
typedef t__sn__sn_method_extension_descriptor_descriptor t__sn_method_extension_descriptor_descriptor;
#define d__sn_method_extension_descriptor_descriptor d__sn__sn_method_extension_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_event_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_event_descriptor39786 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_event_descriptor_descriptor;
#define d__sn__sn_event_descriptor_descriptor 4627
typedef t__sn__sn_event_descriptor_descriptor t__sn_event_descriptor_descriptor;
#define d__sn_event_descriptor_descriptor d__sn__sn_event_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_method_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_method_descripto39787 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_method_descriptor_descriptor;
#define d__sn__sn_method_descriptor_descriptor 4628
typedef t__sn__sn_method_descriptor_descriptor t__sn_method_descriptor_descriptor;
#define d__sn_method_descriptor_descriptor d__sn__sn_method_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_method_param_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_method_param_des39788 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_method_param_descriptor_descriptor;
#define d__sn__sn_method_param_descriptor_descriptor 4629
typedef t__sn__sn_method_param_descriptor_descriptor t__sn_method_param_descriptor_descriptor;
#define d__sn_method_param_descriptor_descriptor d__sn__sn_method_param_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_tcm_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_tcm_descriptor_d39789 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_tcm_descriptor_descriptor;
#define d__sn__sn_tcm_descriptor_descriptor 4630
typedef t__sn__sn_tcm_descriptor_descriptor t__sn_tcm_descriptor_descriptor;
#define d__sn_tcm_descriptor_descriptor d__sn__sn_tcm_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_on_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_on_descriptor_de39790 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_on_descriptor_descriptor;
#define d__sn__sn_on_descriptor_descriptor 4631
typedef t__sn__sn_on_descriptor_descriptor t__sn_on_descriptor_descriptor;
#define d__sn_on_descriptor_descriptor d__sn__sn_on_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_constraint_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_constraint_descr39791 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_constraint_descriptor_descriptor;
#define d__sn__sn_constraint_descriptor_descriptor 4632
typedef t__sn__sn_constraint_descriptor_descriptor t__sn_constraint_descriptor_descriptor;
#define d__sn_constraint_descriptor_descriptor d__sn__sn_constraint_descriptor_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_type_update_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_type_update_desc39792 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_type_update_descriptor;
#define d__sn__sn_type_update_descriptor 4633
typedef t__sn__sn_type_update_descriptor t__sn_type_update_descriptor;
#define d__sn_type_update_descriptor d__sn__sn_type_update_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_struct_storage_update_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_struct_storage_u39793 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_struct_storage_update_descriptor;
#define d__sn__sn_struct_storage_update_descriptor 4634
typedef t__sn__sn_struct_storage_update_descriptor t__sn_struct_storage_update_descriptor;
#define d__sn_struct_storage_update_descriptor d__sn__sn_struct_storage_update_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_enum_update_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_enum_update_desc39794 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_enum_update_descriptor;
#define d__sn__sn_enum_update_descriptor 4635
typedef t__sn__sn_enum_update_descriptor t__sn_enum_update_descriptor;
#define d__sn_enum_update_descriptor d__sn__sn_enum_update_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/method_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__method_kind_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__method_kind_descriptor;
#define d__sn__method_kind_descriptor 4636
typedef t__sn__method_kind_descriptor t__method_kind_descriptor;
#define d__method_kind_descriptor d__sn__method_kind_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_event_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_event_kind_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__sn_event_kind_descriptor;
#define d__sn__sn_event_kind_descriptor 4638
typedef t__sn__sn_event_kind_descriptor t__sn_event_kind_descriptor;
#define d__sn_event_kind_descriptor d__sn__sn_event_kind_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sni_jdatabrowser_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jdatabrowser_se39795 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jdatabrowser_service_descriptor;
#define d__sn__sni_jdatabrowser_service_descriptor 4640
typedef t__sn__sni_jdatabrowser_service_descriptor t__sni_jdatabrowser_service_descriptor;
#define d__sni_jdatabrowser_service_descriptor d__sn__sni_jdatabrowser_service_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sni_edatabrowser_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_edatabrowser_se39796 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_edatabrowser_service_descriptor;
#define d__sn__sni_edatabrowser_service_descriptor 4641
typedef t__sn__sni_edatabrowser_service_descriptor t__sni_edatabrowser_service_descriptor;
#define d__sni_edatabrowser_service_descriptor d__sn__sni_edatabrowser_service_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/descs_and_storages_declare.e"  From 'struct definition' */
typedef struct s__sn__descs_and_storages_39797 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__descs_and_storages_descriptor;
#define d__sn__descs_and_storages_descriptor 4642
typedef t__sn__descs_and_storages_descriptor t__descs_and_storages_descriptor;
#define d__descs_and_storages_descriptor d__sn__descs_and_storages_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/mixed_query_result_declare.e"  From 'struct definition' */
typedef struct s__sn__mixed_query_result_39798 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__mixed_query_result_descriptor;
#define d__sn__mixed_query_result_descriptor 4643
typedef t__sn__mixed_query_result_descriptor t__mixed_query_result_descriptor;
#define d__mixed_query_result_descriptor d__sn__mixed_query_result_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_masked_val_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_masked_val_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_masked_val_descriptor;
#define d__sn__sn_masked_val_descriptor 4644
typedef t__sn__sn_masked_val_descriptor t__sn_masked_val_descriptor;
#define d__sn_masked_val_descriptor d__sn__sn_masked_val_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/array_of_sn_masked_vals_declare.e"  From 'struct definition' */
typedef struct s__sn__array_of_sn_masked_39799 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__array_of_sn_masked_vals_descriptor;
#define d__sn__array_of_sn_masked_vals_descriptor 4645
typedef t__sn__array_of_sn_masked_vals_descriptor t__array_of_sn_masked_vals_descriptor;
#define d__array_of_sn_masked_vals_descriptor d__sn__array_of_sn_masked_vals_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/e_val_change_declare.e"  From 'struct definition' */
typedef struct s__sn__e_val_change_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__e_val_change_descriptor;
#define d__sn__e_val_change_descriptor 4646
typedef t__sn__e_val_change_descriptor t__e_val_change_descriptor;
#define d__e_val_change_descriptor d__sn__e_val_change_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/e_root_refresh_result_declare.e"  From 'struct definition' */
typedef struct s__sn__e_root_refresh_resu39800 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__e_root_refresh_result_descriptor;
#define d__sn__e_root_refresh_result_descriptor 4647
typedef t__sn__e_root_refresh_result_descriptor t__e_root_refresh_result_descriptor;
#define d__e_root_refresh_result_descriptor d__sn__e_root_refresh_result_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_root_di_info_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_root_di_info_des39801 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_root_di_info_descriptor;
#define d__sn__sn_root_di_info_descriptor 4648
typedef t__sn__sn_root_di_info_descriptor t__sn_root_di_info_descriptor;
#define d__sn_root_di_info_descriptor d__sn__sn_root_di_info_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/root_tokens_and_values_declare.e"  From 'struct definition' */
typedef struct s__sn__root_tokens_and_val39802 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__root_tokens_and_values_descriptor;
#define d__sn__root_tokens_and_values_descriptor 4649
typedef t__sn__root_tokens_and_values_descriptor t__root_tokens_and_values_descriptor;
#define d__root_tokens_and_values_descriptor d__sn__root_tokens_and_values_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/change_type_declare.e"  From 'struct definition' */
typedef struct s__sn__change_type_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__change_type_descriptor;
#define d__sn__change_type_descriptor 4650
typedef t__sn__change_type_descriptor t__change_type_descriptor;
#define d__change_type_descriptor d__sn__change_type_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_exp_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_exp_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_exp_descriptor;
#define d__sn__sn_exp_descriptor 4652
typedef t__sn__sn_exp_descriptor t__sn_exp_descriptor;
#define d__sn_exp_descriptor d__sn__sn_exp_descriptor

/* line 14 "/vobs/specman/src/japp/databrowser/gencode/sn_declared_exp_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_declared_exp_des39803 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_declared_exp_descriptor;
#define d__sn__sn_declared_exp_descriptor 4653
typedef t__sn__sn_declared_exp_descriptor t__sn_declared_exp_descriptor;
#define d__sn_declared_exp_descriptor d__sn__sn_declared_exp_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sni_gui_jmanager_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_gui_jmanager_se39804 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_gui_jmanager_service_descriptor;
#define d__sn__sni_gui_jmanager_service_descriptor 5258
typedef t__sn__sni_gui_jmanager_service_descriptor t__sni_gui_jmanager_service_descriptor;
#define d__sni_gui_jmanager_service_descriptor d__sn__sni_gui_jmanager_service_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_general_dialog_input_defs_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_general_dialog_i39805 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_general_dialog_input_defs_descriptor;
#define d__sn__sn_general_dialog_input_defs_descriptor 5259
typedef t__sn__sn_general_dialog_input_defs_descriptor t__sn_general_dialog_input_defs_descriptor;
#define d__sn_general_dialog_input_defs_descriptor d__sn__sn_general_dialog_input_defs_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_general_dialog_checkbox_defs_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_general_dialog_c39806 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_general_dialog_checkbox_defs_descriptor;
#define d__sn__sn_general_dialog_checkbox_defs_descriptor 5260
typedef t__sn__sn_general_dialog_checkbox_defs_descriptor t__sn_general_dialog_checkbox_defs_descriptor;
#define d__sn_general_dialog_checkbox_defs_descriptor d__sn__sn_general_dialog_checkbox_defs_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_general_dialog_button_defs_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_general_dialog_b39807 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_general_dialog_button_defs_descriptor;
#define d__sn__sn_general_dialog_button_defs_descriptor 5261
typedef t__sn__sn_general_dialog_button_defs_descriptor t__sn_general_dialog_button_defs_descriptor;
#define d__sn_general_dialog_button_defs_descriptor d__sn__sn_general_dialog_button_defs_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_input_dialog_reply_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_input_dialog_rep39808 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_input_dialog_reply_descriptor;
#define d__sn__sn_input_dialog_reply_descriptor 5262
typedef t__sn__sn_input_dialog_reply_descriptor t__sn_input_dialog_reply_descriptor;
#define d__sn_input_dialog_reply_descriptor d__sn__sn_input_dialog_reply_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_general_dialog_reply_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_general_dialog_r39809 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_general_dialog_reply_descriptor;
#define d__sn__sn_general_dialog_reply_descriptor 5263
typedef t__sn__sn_general_dialog_reply_descriptor t__sn_general_dialog_reply_descriptor;
#define d__sn_general_dialog_reply_descriptor d__sn__sn_general_dialog_reply_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_message_dialog_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_message_dialog_k39810 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_message_dialog_kind_descriptor;
#define d__sn__sn_message_dialog_kind_descriptor 5264
typedef t__sn__sn_message_dialog_kind_descriptor t__sn_message_dialog_kind_descriptor;
#define d__sn_message_dialog_kind_descriptor d__sn__sn_message_dialog_kind_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_question_dialog_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_question_dialog_39811 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_question_dialog_kind_descriptor;
#define d__sn__sn_question_dialog_kind_descriptor 5266
typedef t__sn__sn_question_dialog_kind_descriptor t__sn_question_dialog_kind_descriptor;
#define d__sn_question_dialog_kind_descriptor d__sn__sn_question_dialog_kind_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_dialog_button_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_dialog_button_ki39812 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_dialog_button_kind_descriptor;
#define d__sn__sn_dialog_button_kind_descriptor 5268
typedef t__sn__sn_dialog_button_kind_descriptor t__sn_dialog_button_kind_descriptor;
#define d__sn_dialog_button_kind_descriptor d__sn__sn_dialog_button_kind_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_general_dialog_input_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_general_dialog_i39813 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_general_dialog_input_kind_descriptor;
#define d__sn__sn_general_dialog_input_kind_descriptor 5270
typedef t__sn__sn_general_dialog_input_kind_descriptor t__sn_general_dialog_input_kind_descriptor;
#define d__sn_general_dialog_input_kind_descriptor d__sn__sn_general_dialog_input_kind_descriptor

/* line 14 "/vobs/specman/src/japp/gui/gencode/sn_general_dialog_button_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_general_dialog_b39814 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_general_dialog_button_kind_descriptor;
#define d__sn__sn_general_dialog_button_kind_descriptor 5272
typedef t__sn__sn_general_dialog_button_kind_descriptor t__sn_general_dialog_button_kind_descriptor;
#define d__sn_general_dialog_button_kind_descriptor d__sn__sn_general_dialog_button_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/sni_jvt_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jvt_service_des39815 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jvt_service_descriptor;
#define d__sn__sni_jvt_service_descriptor 5282
typedef t__sn__sni_jvt_service_descriptor t__sni_jvt_service_descriptor;
#define d__sni_jvt_service_descriptor d__sn__sni_jvt_service_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/sni_evt_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_evt_service_des39816 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_evt_service_descriptor;
#define d__sn__sni_evt_service_descriptor 5283
typedef t__sn__sni_evt_service_descriptor t__sni_evt_service_descriptor;
#define d__sni_evt_service_descriptor d__sn__sni_evt_service_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/sni_vt_jwindow_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vt_jwindow_desc39817 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vt_jwindow_descriptor;
#define d__sn__sni_vt_jwindow_descriptor 5284
typedef t__sn__sni_vt_jwindow_descriptor t__sni_vt_jwindow_descriptor;
#define d__sni_vt_jwindow_descriptor d__sn__sni_vt_jwindow_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/sni_vtw_callback_handler_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtw_callback_ha39818 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtw_callback_handler_descriptor;
#define d__sn__sni_vtw_callback_handler_descriptor 5285
typedef t__sn__sni_vtw_callback_handler_descriptor t__sni_vtw_callback_handler_descriptor;
#define d__sni_vtw_callback_handler_descriptor d__sn__sni_vtw_callback_handler_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_window_additional_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_window_additiona39819 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_window_additional_attributes_descriptor;
#define d__sn__vt_window_additional_attributes_descriptor 5286
typedef t__sn__vt_window_additional_attributes_descriptor t__vt_window_additional_attributes_descriptor;
#define d__vt_window_additional_attributes_descriptor d__sn__vt_window_additional_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_window_requested_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_window_requested39820 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_window_requested_attributes_descriptor;
#define d__sn__vt_window_requested_attributes_descriptor 5287
typedef t__sn__vt_window_requested_attributes_descriptor t__vt_window_requested_attributes_descriptor;
#define d__vt_window_requested_attributes_descriptor d__sn__vt_window_requested_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_window_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_window_actual_at39821 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_window_actual_attributes_descriptor;
#define d__sn__vt_window_actual_attributes_descriptor 5288
typedef t__sn__vt_window_actual_attributes_descriptor t__vt_window_actual_attributes_descriptor;
#define d__vt_window_actual_attributes_descriptor d__sn__vt_window_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_page_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_page_attributes_39822 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_page_attributes_descriptor;
#define d__sn__vt_page_attributes_descriptor 5289
typedef t__sn__vt_page_attributes_descriptor t__vt_page_attributes_descriptor;
#define d__vt_page_attributes_descriptor d__sn__vt_page_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_location_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_location_attribu39823 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_location_attributes_descriptor;
#define d__sn__vt_location_attributes_descriptor 5290
typedef t__sn__vt_location_attributes_descriptor t__vt_location_attributes_descriptor;
#define d__vt_location_attributes_descriptor d__sn__vt_location_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_page_related_properties_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_page_related_pro39824 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_page_related_properties_descriptor;
#define d__sn__vt_page_related_properties_descriptor 5291
typedef t__sn__vt_page_related_properties_descriptor t__vt_page_related_properties_descriptor;
#define d__vt_page_related_properties_descriptor d__sn__vt_page_related_properties_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_page_related_properties_for_viewer_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_page_related_pro39825 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_page_related_properties_for_viewer_descriptor;
#define d__sn__vt_page_related_properties_for_viewer_descriptor 5292
typedef t__sn__vt_page_related_properties_for_viewer_descriptor t__vt_page_related_properties_for_viewer_descriptor;
#define d__vt_page_related_properties_for_viewer_descriptor d__sn__vt_page_related_properties_for_viewer_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_page_related_properties_for_html_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_page_related_pro39826 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_page_related_properties_for_html_descriptor;
#define d__sn__vt_page_related_properties_for_html_descriptor 5293
typedef t__sn__vt_page_related_properties_for_html_descriptor t__vt_page_related_properties_for_html_descriptor;
#define d__vt_page_related_properties_for_html_descriptor d__sn__vt_page_related_properties_for_html_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_saved_location_properties_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_saved_location_p39827 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_saved_location_properties_descriptor;
#define d__sn__vt_saved_location_properties_descriptor 5294
typedef t__sn__vt_saved_location_properties_descriptor t__vt_saved_location_properties_descriptor;
#define d__vt_saved_location_properties_descriptor d__sn__vt_saved_location_properties_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_saved_page_properties_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_saved_page_prope39828 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_saved_page_properties_descriptor;
#define d__sn__vt_saved_page_properties_descriptor 5295
typedef t__sn__vt_saved_page_properties_descriptor t__vt_saved_page_properties_descriptor;
#define d__vt_saved_page_properties_descriptor d__sn__vt_saved_page_properties_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_saved_properties_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_saved_properties39829 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_saved_properties_descriptor;
#define d__sn__vt_saved_properties_descriptor 5296
typedef t__sn__vt_saved_properties_descriptor t__vt_saved_properties_descriptor;
#define d__vt_saved_properties_descriptor d__sn__vt_saved_properties_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_widget_modifiable_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_widget_modifiabl39830 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_widget_modifiable_attributes_descriptor;
#define d__sn__vt_widget_modifiable_attributes_descriptor 5297
typedef t__sn__vt_widget_modifiable_attributes_descriptor t__vt_widget_modifiable_attributes_descriptor;
#define d__vt_widget_modifiable_attributes_descriptor d__sn__vt_widget_modifiable_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_element_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_element_data_des39831 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_element_data_descriptor;
#define d__sn__vt_element_data_descriptor 5298
typedef t__sn__vt_element_data_descriptor t__vt_element_data_descriptor;
#define d__vt_element_data_descriptor d__sn__vt_element_data_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_hyperlink_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_hyperlink_data_d39832 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_hyperlink_data_descriptor;
#define d__sn__vt_hyperlink_data_descriptor 5299
typedef t__sn__vt_hyperlink_data_descriptor t__vt_hyperlink_data_descriptor;
#define d__vt_hyperlink_data_descriptor d__sn__vt_hyperlink_data_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/jaction_manager_declare.e"  From 'struct definition' */
typedef struct s__sn__jaction_manager_des39833 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__jaction_manager_descriptor;
#define d__sn__jaction_manager_descriptor 5300
typedef t__sn__jaction_manager_descriptor t__jaction_manager_descriptor;
#define d__jaction_manager_descriptor d__sn__jaction_manager_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/jvt_toolbar_declare.e"  From 'struct definition' */
typedef struct s__sn__jvt_toolbar_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__jvt_toolbar_descriptor;
#define d__sn__jvt_toolbar_descriptor 5301
typedef t__sn__jvt_toolbar_descriptor t__jvt_toolbar_descriptor;
#define d__jvt_toolbar_descriptor d__sn__jvt_toolbar_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/jmenu_component_declare.e"  From 'struct definition' */
typedef struct s__sn__jmenu_component_des39834 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__jmenu_component_descriptor;
#define d__sn__jmenu_component_descriptor 5302
typedef t__sn__jmenu_component_descriptor t__jmenu_component_descriptor;
#define d__jmenu_component_descriptor d__sn__jmenu_component_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/jmenu_item_declare.e"  From 'struct definition' */
typedef struct s__sn__jmenu_item_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__jmenu_item_descriptor;
#define d__sn__jmenu_item_descriptor 5303
typedef t__sn__jmenu_item_descriptor t__jmenu_item_descriptor;
#define d__jmenu_item_descriptor d__sn__jmenu_item_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/jvt_menu_declare.e"  From 'struct definition' */
typedef struct s__sn__jvt_menu_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__jvt_menu_descriptor;
#define d__sn__jvt_menu_descriptor 5304
typedef t__sn__jvt_menu_descriptor t__jvt_menu_descriptor;
#define d__jvt_menu_descriptor d__sn__jvt_menu_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/jvt_action_declare.e"  From 'struct definition' */
typedef struct s__sn__jvt_action_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__jvt_action_descriptor;
#define d__sn__jvt_action_descriptor 5305
typedef t__sn__jvt_action_descriptor t__jvt_action_descriptor;
#define d__jvt_action_descriptor d__sn__jvt_action_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_statusbar_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_statusbar_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_statusbar_descriptor;
#define d__sn__vt_statusbar_descriptor 5306
typedef t__sn__vt_statusbar_descriptor t__vt_statusbar_descriptor;
#define d__vt_statusbar_descriptor d__sn__vt_statusbar_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_statusbar_pane_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_statusbar_pane_d39835 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_statusbar_pane_descriptor;
#define d__sn__vt_statusbar_pane_descriptor 5307
typedef t__sn__vt_statusbar_pane_descriptor t__vt_statusbar_pane_descriptor;
#define d__vt_statusbar_pane_descriptor d__sn__vt_statusbar_pane_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/status_pane_modifyable_data_declare.e"  From 'struct definition' */
typedef struct s__sn__status_pane_modifya39836 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__status_pane_modifyable_data_descriptor;
#define d__sn__status_pane_modifyable_data_descriptor 5308
typedef t__sn__status_pane_modifyable_data_descriptor t__status_pane_modifyable_data_descriptor;
#define d__status_pane_modifyable_data_descriptor d__sn__status_pane_modifyable_data_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_progress_pane_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_progress_pane_de39837 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_progress_pane_descriptor;
#define d__sn__vt_progress_pane_descriptor 5309
typedef t__sn__vt_progress_pane_descriptor t__vt_progress_pane_descriptor;
#define d__vt_progress_pane_descriptor d__sn__vt_progress_pane_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/progress_pane_modifyable_data_declare.e"  From 'struct definition' */
typedef struct s__sn__progress_pane_modif39838 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__progress_pane_modifyable_data_descriptor;
#define d__sn__progress_pane_modifyable_data_descriptor 5310
typedef t__sn__progress_pane_modifyable_data_descriptor t__progress_pane_modifyable_data_descriptor;
#define d__progress_pane_modifyable_data_descriptor d__sn__progress_pane_modifyable_data_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/file_chooser_data_declare.e"  From 'struct definition' */
typedef struct s__sn__file_chooser_data_d39839 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__file_chooser_data_descriptor;
#define d__sn__file_chooser_data_descriptor 5311
typedef t__sn__file_chooser_data_descriptor t__file_chooser_data_descriptor;
#define d__file_chooser_data_descriptor d__sn__file_chooser_data_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_file_filter_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_file_filter_desc39840 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_file_filter_descriptor;
#define d__sn__vt_file_filter_descriptor 5312
typedef t__sn__vt_file_filter_descriptor t__vt_file_filter_descriptor;
#define d__vt_file_filter_descriptor d__sn__vt_file_filter_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_html_defaults_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_html_defaults_de39841 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_html_defaults_descriptor;
#define d__sn__vt_html_defaults_descriptor 5313
typedef t__sn__vt_html_defaults_descriptor t__vt_html_defaults_descriptor;
#define d__vt_html_defaults_descriptor d__sn__vt_html_defaults_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_initial_window_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_initial_window_a39842 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_initial_window_attributes_descriptor;
#define d__sn__vt_initial_window_attributes_descriptor 5314
typedef t__sn__vt_initial_window_attributes_descriptor t__vt_initial_window_attributes_descriptor;
#define d__vt_initial_window_attributes_descriptor d__sn__vt_initial_window_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_window_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_window_attribute39843 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_window_attributes_descriptor;
#define d__sn__vt_window_attributes_descriptor 5315
typedef t__sn__vt_window_attributes_descriptor t__vt_window_attributes_descriptor;
#define d__vt_window_attributes_descriptor d__sn__vt_window_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_history_event_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_history_event_de39844 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vt_history_event_descriptor;
#define d__sn__vt_history_event_descriptor 5316
typedef t__sn__vt_history_event_descriptor t__vt_history_event_descriptor;
#define d__vt_history_event_descriptor d__sn__vt_history_event_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_element_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_element_kind_des39845 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_element_kind_descriptor;
#define d__sn__vt_element_kind_descriptor 5317
typedef t__sn__vt_element_kind_descriptor t__vt_element_kind_descriptor;
#define d__vt_element_kind_descriptor d__sn__vt_element_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_menu_component_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_menu_component_k39846 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_menu_component_kind_descriptor;
#define d__sn__vt_menu_component_kind_descriptor 5319
typedef t__sn__vt_menu_component_kind_descriptor t__vt_menu_component_kind_descriptor;
#define d__vt_menu_component_kind_descriptor d__sn__vt_menu_component_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_action_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_action_kind_desc39847 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_action_kind_descriptor;
#define d__sn__vt_action_kind_descriptor 5321
typedef t__sn__vt_action_kind_descriptor t__vt_action_kind_descriptor;
#define d__vt_action_kind_descriptor d__sn__vt_action_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_action_related_separator_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_action_related_s39848 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_action_related_separator_kind_descriptor;
#define d__sn__vt_action_related_separator_kind_descriptor 5323
typedef t__sn__vt_action_related_separator_kind_descriptor t__vt_action_related_separator_kind_descriptor;
#define d__vt_action_related_separator_kind_descriptor d__sn__vt_action_related_separator_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_action_special_attribute_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_action_special_a39849 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_action_special_attribute_descriptor;
#define d__sn__vt_action_special_attribute_descriptor 5325
typedef t__sn__vt_action_special_attribute_descriptor t__vt_action_special_attribute_descriptor;
#define d__vt_action_special_attribute_descriptor d__sn__vt_action_special_attribute_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_statusbar_pane_scope_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_statusbar_pane_s39850 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_statusbar_pane_scope_descriptor;
#define d__sn__vt_statusbar_pane_scope_descriptor 5327
typedef t__sn__vt_statusbar_pane_scope_descriptor t__vt_statusbar_pane_scope_descriptor;
#define d__vt_statusbar_pane_scope_descriptor d__sn__vt_statusbar_pane_scope_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_history_event_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_history_event_ki39851 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_history_event_kind_descriptor;
#define d__sn__vt_history_event_kind_descriptor 5329
typedef t__sn__vt_history_event_kind_descriptor t__vt_history_event_kind_descriptor;
#define d__vt_history_event_kind_descriptor d__sn__vt_history_event_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vt/gencode/vt_toolbar_mode_declare.e"  From 'struct definition' */
typedef struct s__sn__vt_toolbar_mode_des39852 {
    t__int d__;
    t__int gen__;
} *t__sn__vt_toolbar_mode_descriptor;
#define d__sn__vt_toolbar_mode_descriptor 5331
typedef t__sn__vt_toolbar_mode_descriptor t__vt_toolbar_mode_descriptor;
#define d__vt_toolbar_mode_descriptor d__sn__vt_toolbar_mode_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jmanager_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jmanager_se48632 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jmanager_service_descriptor;
#define d__sn__sni_vtx_jmanager_service_descriptor 5413
typedef t__sn__sni_vtx_jmanager_service_descriptor t__sni_vtx_jmanager_service_descriptor;
#define d__sni_vtx_jmanager_service_descriptor d__sn__sni_vtx_jmanager_service_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jtable_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jtable_desc48633 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jtable_descriptor;
#define d__sn__sni_vtx_jtable_descriptor 5414
typedef t__sn__sni_vtx_jtable_descriptor t__sni_vtx_jtable_descriptor;
#define d__sni_vtx_jtable_descriptor d__sn__sni_vtx_jtable_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jtree_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jtree_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jtree_descriptor;
#define d__sn__sni_vtx_jtree_descriptor 5415
typedef t__sn__sni_vtx_jtree_descriptor t__sni_vtx_jtree_descriptor;
#define d__sni_vtx_jtree_descriptor d__sn__sni_vtx_jtree_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jtabctrl_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jtabctrl_de48634 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jtabctrl_descriptor;
#define d__sn__sni_vtx_jtabctrl_descriptor 5416
typedef t__sn__sni_vtx_jtabctrl_descriptor t__sni_vtx_jtabctrl_descriptor;
#define d__sni_vtx_jtabctrl_descriptor d__sn__sni_vtx_jtabctrl_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jtab_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jtab_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jtab_descriptor;
#define d__sn__sni_vtx_jtab_descriptor 5417
typedef t__sn__sni_vtx_jtab_descriptor t__sni_vtx_jtab_descriptor;
#define d__sni_vtx_jtab_descriptor d__sn__sni_vtx_jtab_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jdiff_viewer_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jdiff_viewe48635 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jdiff_viewer_descriptor;
#define d__sn__sni_vtx_jdiff_viewer_descriptor 5418
typedef t__sn__sni_vtx_jdiff_viewer_descriptor t__sni_vtx_jdiff_viewer_descriptor;
#define d__sni_vtx_jdiff_viewer_descriptor d__sn__sni_vtx_jdiff_viewer_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jhtml_viewer_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jhtml_viewe48636 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jhtml_viewer_descriptor;
#define d__sn__sni_vtx_jhtml_viewer_descriptor 5419
typedef t__sn__sni_vtx_jhtml_viewer_descriptor t__sni_vtx_jhtml_viewer_descriptor;
#define d__sni_vtx_jhtml_viewer_descriptor d__sn__sni_vtx_jhtml_viewer_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jcombobox_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jcombobox_d48637 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jcombobox_descriptor;
#define d__sn__sni_vtx_jcombobox_descriptor 5420
typedef t__sn__sni_vtx_jcombobox_descriptor t__sni_vtx_jcombobox_descriptor;
#define d__sni_vtx_jcombobox_descriptor d__sn__sni_vtx_jcombobox_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jtextfield_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jtextfield_48638 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jtextfield_descriptor;
#define d__sn__sni_vtx_jtextfield_descriptor 5421
typedef t__sn__sni_vtx_jtextfield_descriptor t__sni_vtx_jtextfield_descriptor;
#define d__sni_vtx_jtextfield_descriptor d__sn__sni_vtx_jtextfield_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jimage_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jimage_desc48639 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jimage_descriptor;
#define d__sn__sni_vtx_jimage_descriptor 5422
typedef t__sn__sni_vtx_jimage_descriptor t__sni_vtx_jimage_descriptor;
#define d__sni_vtx_jimage_descriptor d__sn__sni_vtx_jimage_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jsource_viewer_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jsource_vie48640 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jsource_viewer_descriptor;
#define d__sn__sni_vtx_jsource_viewer_descriptor 5423
typedef t__sn__sni_vtx_jsource_viewer_descriptor t__sni_vtx_jsource_viewer_descriptor;
#define d__sni_vtx_jsource_viewer_descriptor d__sn__sni_vtx_jsource_viewer_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jwindow_header_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jwindow_hea48641 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jwindow_header_descriptor;
#define d__sn__sni_vtx_jwindow_header_descriptor 5424
typedef t__sn__sni_vtx_jwindow_header_descriptor t__sni_vtx_jwindow_header_descriptor;
#define d__sni_vtx_jwindow_header_descriptor d__sn__sni_vtx_jwindow_header_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jbutton_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jbutton_des48642 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jbutton_descriptor;
#define d__sn__sni_vtx_jbutton_descriptor 5425
typedef t__sn__sni_vtx_jbutton_descriptor t__sni_vtx_jbutton_descriptor;
#define d__sni_vtx_jbutton_descriptor d__sn__sni_vtx_jbutton_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jsplitter_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jsplitter_d48643 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jsplitter_descriptor;
#define d__sn__sni_vtx_jsplitter_descriptor 5426
typedef t__sn__sni_vtx_jsplitter_descriptor t__sni_vtx_jsplitter_descriptor;
#define d__sni_vtx_jsplitter_descriptor d__sn__sni_vtx_jsplitter_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jpanel_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jpanel_desc48644 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jpanel_descriptor;
#define d__sn__sni_vtx_jpanel_descriptor 5427
typedef t__sn__sni_vtx_jpanel_descriptor t__sni_vtx_jpanel_descriptor;
#define d__sni_vtx_jpanel_descriptor d__sn__sni_vtx_jpanel_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_jbase_window_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_jbase_windo48645 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_jbase_window_descriptor;
#define d__sn__sni_vtx_jbase_window_descriptor 5428
typedef t__sn__sni_vtx_jbase_window_descriptor t__sni_vtx_jbase_window_descriptor;
#define d__sni_vtx_jbase_window_descriptor d__sn__sni_vtx_jbase_window_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/sni_vtx_ebase_window_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_vtx_ebase_windo48646 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_vtx_ebase_window_descriptor;
#define d__sn__sni_vtx_ebase_window_descriptor 5429
typedef t__sn__sni_vtx_ebase_window_descriptor t__sni_vtx_ebase_window_descriptor;
#define d__sni_vtx_ebase_window_descriptor d__sn__sni_vtx_ebase_window_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_drawer_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_drawer_data_des48647 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_drawer_data_descriptor;
#define d__sn__vtx_drawer_data_descriptor 5430
typedef t__sn__vtx_drawer_data_descriptor t__vtx_drawer_data_descriptor;
#define d__vtx_drawer_data_descriptor d__sn__vtx_drawer_data_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_text_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_text_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_text_data_descriptor;
#define d__sn__vtx_text_data_descriptor 5431
typedef t__sn__vtx_text_data_descriptor t__vtx_text_data_descriptor;
#define d__vtx_text_data_descriptor d__sn__vtx_text_data_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_icon_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_icon_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_icon_data_descriptor;
#define d__sn__vtx_icon_data_descriptor 5432
typedef t__sn__vtx_icon_data_descriptor t__vtx_icon_data_descriptor;
#define d__vtx_icon_data_descriptor d__sn__vtx_icon_data_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_box_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_box_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_box_data_descriptor;
#define d__sn__vtx_box_data_descriptor 5433
typedef t__sn__vtx_box_data_descriptor t__vtx_box_data_descriptor;
#define d__vtx_box_data_descriptor d__sn__vtx_box_data_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_bar_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_bar_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_bar_data_descriptor;
#define d__sn__vtx_bar_data_descriptor 5434
typedef t__sn__vtx_bar_data_descriptor t__vtx_bar_data_descriptor;
#define d__vtx_bar_data_descriptor d__sn__vtx_bar_data_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_pie_slice_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_pie_slice_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_pie_slice_descriptor;
#define d__sn__vtx_pie_slice_descriptor 5435
typedef t__sn__vtx_pie_slice_descriptor t__vtx_pie_slice_descriptor;
#define d__vtx_pie_slice_descriptor d__sn__vtx_pie_slice_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_pie_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_pie_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_pie_data_descriptor;
#define d__sn__vtx_pie_data_descriptor 5436
typedef t__sn__vtx_pie_data_descriptor t__vtx_pie_data_descriptor;
#define d__vtx_pie_data_descriptor d__sn__vtx_pie_data_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_widget_item_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_widget_it48648 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_widget_item_descriptor;
#define d__sn__vtx_snorb_widget_item_descriptor 5437
typedef t__sn__vtx_snorb_widget_item_descriptor t__vtx_snorb_widget_item_descriptor;
#define d__vtx_snorb_widget_item_descriptor d__sn__vtx_snorb_widget_item_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_action_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_action_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_action_descriptor;
#define d__sn__vtx_action_descriptor 5438
typedef t__sn__vtx_action_descriptor t__vtx_action_descriptor;
#define d__vtx_action_descriptor d__sn__vtx_action_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_font_data_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_font_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_font_data_descriptor;
#define d__sn__vtx_font_data_descriptor 5439
typedef t__sn__vtx_font_data_descriptor t__vtx_font_data_descriptor;
#define d__vtx_font_data_descriptor d__sn__vtx_font_data_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_props_des48649 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_props_descriptor;
#define d__sn__vtx_snorb_props_descriptor 5440
typedef t__sn__vtx_snorb_props_descriptor t__vtx_snorb_props_descriptor;
#define d__vtx_snorb_props_descriptor d__sn__vtx_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_manager_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_manager_snorb_p48650 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_manager_snorb_props_descriptor;
#define d__sn__vtx_manager_snorb_props_descriptor 5441
typedef t__sn__vtx_manager_snorb_props_descriptor t__vtx_manager_snorb_props_descriptor;
#define d__vtx_manager_snorb_props_descriptor d__sn__vtx_manager_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_element_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_element_p48651 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_element_props_descriptor;
#define d__sn__vtx_snorb_element_props_descriptor 5442
typedef t__sn__vtx_snorb_element_props_descriptor t__vtx_snorb_element_props_descriptor;
#define d__vtx_snorb_element_props_descriptor d__sn__vtx_snorb_element_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_component_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_component_snorb48652 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_component_snorb_props_descriptor;
#define d__sn__vtx_component_snorb_props_descriptor 5443
typedef t__sn__vtx_component_snorb_props_descriptor t__vtx_component_snorb_props_descriptor;
#define d__vtx_component_snorb_props_descriptor d__sn__vtx_component_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_component_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_component48653 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_component_actual_attributes_descriptor;
#define d__sn__vtx_snorb_component_actual_attributes_descriptor 5444
typedef t__sn__vtx_snorb_component_actual_attributes_descriptor t__vtx_snorb_component_actual_attributes_descriptor;
#define d__vtx_snorb_component_actual_attributes_descriptor d__sn__vtx_snorb_component_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_table_row_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_table_row48654 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_table_row_descriptor;
#define d__sn__vtx_snorb_table_row_descriptor 5445
typedef t__sn__vtx_snorb_table_row_descriptor t__vtx_snorb_table_row_descriptor;
#define d__vtx_snorb_table_row_descriptor d__sn__vtx_snorb_table_row_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_table_col_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_table_col48655 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_table_col_descriptor;
#define d__sn__vtx_snorb_table_col_descriptor 5446
typedef t__sn__vtx_snorb_table_col_descriptor t__vtx_snorb_table_col_descriptor;
#define d__vtx_snorb_table_col_descriptor d__sn__vtx_snorb_table_col_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_col_cell_values_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_col_cell_values48656 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_col_cell_values_descriptor;
#define d__sn__vtx_col_cell_values_descriptor 5447
typedef t__sn__vtx_col_cell_values_descriptor t__vtx_col_cell_values_descriptor;
#define d__vtx_col_cell_values_descriptor d__sn__vtx_col_cell_values_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_table_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_table_snorb_pro48657 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_table_snorb_props_descriptor;
#define d__sn__vtx_table_snorb_props_descriptor 5448
typedef t__sn__vtx_table_snorb_props_descriptor t__vtx_table_snorb_props_descriptor;
#define d__vtx_table_snorb_props_descriptor d__sn__vtx_table_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_table_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_table_act48658 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_table_actual_attributes_descriptor;
#define d__sn__vtx_snorb_table_actual_attributes_descriptor 5449
typedef t__sn__vtx_snorb_table_actual_attributes_descriptor t__vtx_snorb_table_actual_attributes_descriptor;
#define d__vtx_snorb_table_actual_attributes_descriptor d__sn__vtx_snorb_table_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_tree_node_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_tree_node48659 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_tree_node_descriptor;
#define d__sn__vtx_snorb_tree_node_descriptor 5450
typedef t__sn__vtx_snorb_tree_node_descriptor t__vtx_snorb_tree_node_descriptor;
#define d__vtx_snorb_tree_node_descriptor d__sn__vtx_snorb_tree_node_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_tree_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_tree_snorb_prop48660 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_tree_snorb_props_descriptor;
#define d__sn__vtx_tree_snorb_props_descriptor 5451
typedef t__sn__vtx_tree_snorb_props_descriptor t__vtx_tree_snorb_props_descriptor;
#define d__vtx_tree_snorb_props_descriptor d__sn__vtx_tree_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_tree_path_wrapper_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_tree_path_wrapp48661 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_tree_path_wrapper_descriptor;
#define d__sn__vtx_tree_path_wrapper_descriptor 5452
typedef t__sn__vtx_tree_path_wrapper_descriptor t__vtx_tree_path_wrapper_descriptor;
#define d__vtx_tree_path_wrapper_descriptor d__sn__vtx_tree_path_wrapper_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_tree_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_tree_actu48662 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_tree_actual_attributes_descriptor;
#define d__sn__vtx_snorb_tree_actual_attributes_descriptor 5453
typedef t__sn__vtx_snorb_tree_actual_attributes_descriptor t__vtx_snorb_tree_actual_attributes_descriptor;
#define d__vtx_snorb_tree_actual_attributes_descriptor d__sn__vtx_snorb_tree_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_tabctrl_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_tabctrl_snorb_p48663 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_tabctrl_snorb_props_descriptor;
#define d__sn__vtx_tabctrl_snorb_props_descriptor 5454
typedef t__sn__vtx_tabctrl_snorb_props_descriptor t__vtx_tabctrl_snorb_props_descriptor;
#define d__vtx_tabctrl_snorb_props_descriptor d__sn__vtx_tabctrl_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_tabctrl_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_tabctrl_a48664 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_tabctrl_actual_attributes_descriptor;
#define d__sn__vtx_snorb_tabctrl_actual_attributes_descriptor 5455
typedef t__sn__vtx_snorb_tabctrl_actual_attributes_descriptor t__vtx_snorb_tabctrl_actual_attributes_descriptor;
#define d__vtx_snorb_tabctrl_actual_attributes_descriptor d__sn__vtx_snorb_tabctrl_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_tab_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_tab_snorb_props48665 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_tab_snorb_props_descriptor;
#define d__sn__vtx_tab_snorb_props_descriptor 5456
typedef t__sn__vtx_tab_snorb_props_descriptor t__vtx_tab_snorb_props_descriptor;
#define d__vtx_tab_snorb_props_descriptor d__sn__vtx_tab_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_tab_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_tab_actua48666 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_tab_actual_attributes_descriptor;
#define d__sn__vtx_snorb_tab_actual_attributes_descriptor 5457
typedef t__sn__vtx_snorb_tab_actual_attributes_descriptor t__vtx_snorb_tab_actual_attributes_descriptor;
#define d__vtx_snorb_tab_actual_attributes_descriptor d__sn__vtx_snorb_tab_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_diff_viewer_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_diff_viewer_sno48667 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_diff_viewer_snorb_props_descriptor;
#define d__sn__vtx_diff_viewer_snorb_props_descriptor 5458
typedef t__sn__vtx_diff_viewer_snorb_props_descriptor t__vtx_diff_viewer_snorb_props_descriptor;
#define d__vtx_diff_viewer_snorb_props_descriptor d__sn__vtx_diff_viewer_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_diff_viewer_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_diff_viewer_act48668 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_diff_viewer_actual_attributes_descriptor;
#define d__sn__vtx_diff_viewer_actual_attributes_descriptor 5459
typedef t__sn__vtx_diff_viewer_actual_attributes_descriptor t__vtx_diff_viewer_actual_attributes_descriptor;
#define d__vtx_diff_viewer_actual_attributes_descriptor d__sn__vtx_diff_viewer_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_html_viewer_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_html_viewer_sno48669 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_html_viewer_snorb_props_descriptor;
#define d__sn__vtx_html_viewer_snorb_props_descriptor 5460
typedef t__sn__vtx_html_viewer_snorb_props_descriptor t__vtx_html_viewer_snorb_props_descriptor;
#define d__vtx_html_viewer_snorb_props_descriptor d__sn__vtx_html_viewer_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_html_viewer_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_html_view48670 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_html_viewer_actual_attributes_descriptor;
#define d__sn__vtx_snorb_html_viewer_actual_attributes_descriptor 5461
typedef t__sn__vtx_snorb_html_viewer_actual_attributes_descriptor t__vtx_snorb_html_viewer_actual_attributes_descriptor;
#define d__vtx_snorb_html_viewer_actual_attributes_descriptor d__sn__vtx_snorb_html_viewer_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_combobox_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_combobox_snorb_48671 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_combobox_snorb_props_descriptor;
#define d__sn__vtx_combobox_snorb_props_descriptor 5462
typedef t__sn__vtx_combobox_snorb_props_descriptor t__vtx_combobox_snorb_props_descriptor;
#define d__vtx_combobox_snorb_props_descriptor d__sn__vtx_combobox_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_combobox_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_combobox_48672 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_combobox_actual_attributes_descriptor;
#define d__sn__vtx_snorb_combobox_actual_attributes_descriptor 5463
typedef t__sn__vtx_snorb_combobox_actual_attributes_descriptor t__vtx_snorb_combobox_actual_attributes_descriptor;
#define d__vtx_snorb_combobox_actual_attributes_descriptor d__sn__vtx_snorb_combobox_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_textfield_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_textfield_snorb48673 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_textfield_snorb_props_descriptor;
#define d__sn__vtx_textfield_snorb_props_descriptor 5464
typedef t__sn__vtx_textfield_snorb_props_descriptor t__vtx_textfield_snorb_props_descriptor;
#define d__vtx_textfield_snorb_props_descriptor d__sn__vtx_textfield_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_textfield_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_textfield48674 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_textfield_actual_attributes_descriptor;
#define d__sn__vtx_snorb_textfield_actual_attributes_descriptor 5465
typedef t__sn__vtx_snorb_textfield_actual_attributes_descriptor t__vtx_snorb_textfield_actual_attributes_descriptor;
#define d__vtx_snorb_textfield_actual_attributes_descriptor d__sn__vtx_snorb_textfield_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_image_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_image_snorb_pro48675 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_image_snorb_props_descriptor;
#define d__sn__vtx_image_snorb_props_descriptor 5466
typedef t__sn__vtx_image_snorb_props_descriptor t__vtx_image_snorb_props_descriptor;
#define d__vtx_image_snorb_props_descriptor d__sn__vtx_image_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_image_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_image_act48676 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_image_actual_attributes_descriptor;
#define d__sn__vtx_snorb_image_actual_attributes_descriptor 5467
typedef t__sn__vtx_snorb_image_actual_attributes_descriptor t__vtx_snorb_image_actual_attributes_descriptor;
#define d__vtx_snorb_image_actual_attributes_descriptor d__sn__vtx_snorb_image_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_source_viewer_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_source_viewer_s48677 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_source_viewer_snorb_props_descriptor;
#define d__sn__vtx_source_viewer_snorb_props_descriptor 5468
typedef t__sn__vtx_source_viewer_snorb_props_descriptor t__vtx_source_viewer_snorb_props_descriptor;
#define d__vtx_source_viewer_snorb_props_descriptor d__sn__vtx_source_viewer_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_source_viewer_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_source_vi48678 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_source_viewer_actual_attributes_descriptor;
#define d__sn__vtx_snorb_source_viewer_actual_attributes_descriptor 5469
typedef t__sn__vtx_snorb_source_viewer_actual_attributes_descriptor t__vtx_snorb_source_viewer_actual_attributes_descriptor;
#define d__vtx_snorb_source_viewer_actual_attributes_descriptor d__sn__vtx_snorb_source_viewer_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_window_header_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_window_header_s48679 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_window_header_snorb_props_descriptor;
#define d__sn__vtx_window_header_snorb_props_descriptor 5470
typedef t__sn__vtx_window_header_snorb_props_descriptor t__vtx_window_header_snorb_props_descriptor;
#define d__vtx_window_header_snorb_props_descriptor d__sn__vtx_window_header_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_window_header_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_window_he48680 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_window_header_actual_attributes_descriptor;
#define d__sn__vtx_snorb_window_header_actual_attributes_descriptor 5471
typedef t__sn__vtx_snorb_window_header_actual_attributes_descriptor t__vtx_snorb_window_header_actual_attributes_descriptor;
#define d__vtx_snorb_window_header_actual_attributes_descriptor d__sn__vtx_snorb_window_header_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_button_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_button_snorb_pr48681 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_button_snorb_props_descriptor;
#define d__sn__vtx_button_snorb_props_descriptor 5472
typedef t__sn__vtx_button_snorb_props_descriptor t__vtx_button_snorb_props_descriptor;
#define d__vtx_button_snorb_props_descriptor d__sn__vtx_button_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_button_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_button_ac48682 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_button_actual_attributes_descriptor;
#define d__sn__vtx_snorb_button_actual_attributes_descriptor 5473
typedef t__sn__vtx_snorb_button_actual_attributes_descriptor t__vtx_snorb_button_actual_attributes_descriptor;
#define d__vtx_snorb_button_actual_attributes_descriptor d__sn__vtx_snorb_button_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_splitter_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_splitter_snorb_48683 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_splitter_snorb_props_descriptor;
#define d__sn__vtx_splitter_snorb_props_descriptor 5474
typedef t__sn__vtx_splitter_snorb_props_descriptor t__vtx_splitter_snorb_props_descriptor;
#define d__vtx_splitter_snorb_props_descriptor d__sn__vtx_splitter_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_splitter_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_splitter_48684 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_splitter_actual_attributes_descriptor;
#define d__sn__vtx_snorb_splitter_actual_attributes_descriptor 5475
typedef t__sn__vtx_snorb_splitter_actual_attributes_descriptor t__vtx_snorb_splitter_actual_attributes_descriptor;
#define d__vtx_snorb_splitter_actual_attributes_descriptor d__sn__vtx_snorb_splitter_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_panel_snorb_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_panel_snorb_pro48685 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_panel_snorb_props_descriptor;
#define d__sn__vtx_panel_snorb_props_descriptor 5476
typedef t__sn__vtx_panel_snorb_props_descriptor t__vtx_panel_snorb_props_descriptor;
#define d__vtx_panel_snorb_props_descriptor d__sn__vtx_panel_snorb_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_panel_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_panel_act48686 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_panel_actual_attributes_descriptor;
#define d__sn__vtx_snorb_panel_actual_attributes_descriptor 5477
typedef t__sn__vtx_snorb_panel_actual_attributes_descriptor t__vtx_snorb_panel_actual_attributes_descriptor;
#define d__vtx_snorb_panel_actual_attributes_descriptor d__sn__vtx_snorb_panel_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_base_window_props_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_base_wind48687 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_base_window_props_descriptor;
#define d__sn__vtx_snorb_base_window_props_descriptor 5478
typedef t__sn__vtx_snorb_base_window_props_descriptor t__vtx_snorb_base_window_props_descriptor;
#define d__vtx_snorb_base_window_props_descriptor d__sn__vtx_snorb_base_window_props_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_window_actual_attributes_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_window_ac48688 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_window_actual_attributes_descriptor;
#define d__sn__vtx_snorb_window_actual_attributes_descriptor 5479
typedef t__sn__vtx_snorb_window_actual_attributes_descriptor t__vtx_snorb_window_actual_attributes_descriptor;
#define d__vtx_snorb_window_actual_attributes_descriptor d__sn__vtx_snorb_window_actual_attributes_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_window_creation_result_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_window_cr48689 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_window_creation_result_descriptor;
#define d__sn__vtx_snorb_window_creation_result_descriptor 5480
typedef t__sn__vtx_snorb_window_creation_result_descriptor t__vtx_snorb_window_creation_result_descriptor;
#define d__vtx_snorb_window_creation_result_descriptor d__sn__vtx_snorb_window_creation_result_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_splitter_settings_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_splitter_48690 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_splitter_settings_descriptor;
#define d__sn__vtx_snorb_splitter_settings_descriptor 5481
typedef t__sn__vtx_snorb_splitter_settings_descriptor t__vtx_snorb_splitter_settings_descriptor;
#define d__vtx_snorb_splitter_settings_descriptor d__sn__vtx_snorb_splitter_settings_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_tabctrl_settings_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_tabctrl_s48691 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_tabctrl_settings_descriptor;
#define d__sn__vtx_snorb_tabctrl_settings_descriptor 5482
typedef t__sn__vtx_snorb_tabctrl_settings_descriptor t__vtx_snorb_tabctrl_settings_descriptor;
#define d__vtx_snorb_tabctrl_settings_descriptor d__sn__vtx_snorb_tabctrl_settings_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_snorb_base_window_gui_settings_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_snorb_base_wind48692 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__vtx_snorb_base_window_gui_settings_descriptor;
#define d__sn__vtx_snorb_base_window_gui_settings_descriptor 5483
typedef t__sn__vtx_snorb_base_window_gui_settings_descriptor t__vtx_snorb_base_window_gui_settings_descriptor;
#define d__vtx_snorb_base_window_gui_settings_descriptor d__sn__vtx_snorb_base_window_gui_settings_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_bar_format_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_bar_format_desc48693 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_bar_format_descriptor;
#define d__sn__vtx_bar_format_descriptor 5484
typedef t__sn__vtx_bar_format_descriptor t__vtx_bar_format_descriptor;
#define d__vtx_bar_format_descriptor d__sn__vtx_bar_format_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_element_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_element_kind_de48694 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_element_kind_descriptor;
#define d__sn__vtx_element_kind_descriptor 5486
typedef t__sn__vtx_element_kind_descriptor t__vtx_element_kind_descriptor;
#define d__vtx_element_kind_descriptor d__sn__vtx_element_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_raw_event_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_raw_event_kind_48695 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_raw_event_kind_descriptor;
#define d__sn__vtx_raw_event_kind_descriptor 5488
typedef t__sn__vtx_raw_event_kind_descriptor t__vtx_raw_event_kind_descriptor;
#define d__vtx_raw_event_kind_descriptor d__sn__vtx_raw_event_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_align_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_align_kind_desc48696 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_align_kind_descriptor;
#define d__sn__vtx_align_kind_descriptor 5490
typedef t__sn__vtx_align_kind_descriptor t__vtx_align_kind_descriptor;
#define d__vtx_align_kind_descriptor d__sn__vtx_align_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_border_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_border_kind_des48697 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_border_kind_descriptor;
#define d__sn__vtx_border_kind_descriptor 5492
typedef t__sn__vtx_border_kind_descriptor t__vtx_border_kind_descriptor;
#define d__vtx_border_kind_descriptor d__sn__vtx_border_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_expandable_mode_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_expandable_mode48698 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_expandable_mode_descriptor;
#define d__sn__vtx_expandable_mode_descriptor 5494
typedef t__sn__vtx_expandable_mode_descriptor t__vtx_expandable_mode_descriptor;
#define d__vtx_expandable_mode_descriptor d__sn__vtx_expandable_mode_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_table_col_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_table_col_kind_48699 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_table_col_kind_descriptor;
#define d__sn__vtx_table_col_kind_descriptor 5496
typedef t__sn__vtx_table_col_kind_descriptor t__vtx_table_col_kind_descriptor;
#define d__vtx_table_col_kind_descriptor d__sn__vtx_table_col_kind_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_tab_position_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_tab_position_de48700 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_tab_position_descriptor;
#define d__sn__vtx_tab_position_descriptor 5498
typedef t__sn__vtx_tab_position_descriptor t__vtx_tab_position_descriptor;
#define d__vtx_tab_position_descriptor d__sn__vtx_tab_position_descriptor

/* line 14 "/vobs/specman/src/japp/vtx/gencode/vtx_label_layout_declare.e"  From 'struct definition' */
typedef struct s__sn__vtx_label_layout_de48701 {
    t__int d__;
    t__int gen__;
} *t__sn__vtx_label_layout_descriptor;
#define d__sn__vtx_label_layout_descriptor 5500
typedef t__sn__vtx_label_layout_descriptor t__vtx_label_layout_descriptor;
#define d__vtx_label_layout_descriptor d__sn__vtx_label_layout_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_abs_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_abs_key_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_abs_key_descriptor;
#define d__sn__sn_abs_key_descriptor 6222
typedef t__sn__sn_abs_key_descriptor t__sn_abs_key_descriptor;
#define d__sn_abs_key_descriptor d__sn__sn_abs_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_event_parameter_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_event_parameter_54698 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_event_parameter_key_descriptor;
#define d__sn__sn_event_parameter_key_descriptor 6223
typedef t__sn__sn_event_parameter_key_descriptor t__sn_event_parameter_key_descriptor;
#define d__sn_event_parameter_key_descriptor d__sn__sn_event_parameter_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_event_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_event_key_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_event_key_descriptor;
#define d__sn__sn_event_key_descriptor 6224
typedef t__sn__sn_event_key_descriptor t__sn_event_key_descriptor;
#define d__sn_event_key_descriptor d__sn__sn_event_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_gendb_item_in_gen_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gendb_item_in_ge54699 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gendb_item_in_gen_key_descriptor;
#define d__sn__sn_gendb_item_in_gen_key_descriptor 6225
typedef t__sn__sn_gendb_item_in_gen_key_descriptor t__sn_gendb_item_in_gen_key_descriptor;
#define d__sn_gendb_item_in_gen_key_descriptor d__sn__sn_gendb_item_in_gen_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_gendb_list_temp_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gendb_list_temp_54700 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gendb_list_temp_key_descriptor;
#define d__sn__sn_gendb_list_temp_key_descriptor 6226
typedef t__sn__sn_gendb_list_temp_key_descriptor t__sn_gendb_list_temp_key_descriptor;
#define d__sn_gendb_list_temp_key_descriptor d__sn__sn_gendb_list_temp_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_instanciated_field_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_instanciated_fie54701 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_instanciated_field_key_descriptor;
#define d__sn__sn_instanciated_field_key_descriptor 6227
typedef t__sn__sn_instanciated_field_key_descriptor t__sn_instanciated_field_key_descriptor;
#define d__sn_instanciated_field_key_descriptor d__sn__sn_instanciated_field_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_instanciated_list_item_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_instanciated_lis54702 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_instanciated_list_item_key_descriptor;
#define d__sn__sn_instanciated_list_item_key_descriptor 6228
typedef t__sn__sn_instanciated_list_item_key_descriptor t__sn_instanciated_list_item_key_descriptor;
#define d__sn_instanciated_list_item_key_descriptor d__sn__sn_instanciated_list_item_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_role_info_key_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_role_info_key_de54703 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_role_info_key_descriptor;
#define d__sn__sn_role_info_key_descriptor 6229
typedef t__sn__sn_role_info_key_descriptor t__sn_role_info_key_descriptor;
#define d__sn_role_info_key_descriptor d__sn__sn_role_info_key_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/item_in_gen_kind_declare.e"  From 'struct definition' */
typedef struct s__sn__item_in_gen_kind_de54704 {
    t__int d__;
    t__int gen__;
} *t__sn__item_in_gen_kind_descriptor;
#define d__sn__item_in_gen_kind_descriptor 6230
typedef t__sn__item_in_gen_kind_descriptor t__item_in_gen_kind_descriptor;
#define d__item_in_gen_kind_descriptor d__sn__item_in_gen_kind_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/abs_range_props_declare.e"  From 'struct definition' */
typedef struct s__sn__abs_range_props_des54705 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__abs_range_props_descriptor;
#define d__sn__abs_range_props_descriptor 6232
typedef t__sn__abs_range_props_descriptor t__abs_range_props_descriptor;
#define d__abs_range_props_descriptor d__sn__abs_range_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/regular_range_props_declare.e"  From 'struct definition' */
typedef struct s__sn__regular_range_props54706 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__regular_range_props_descriptor;
#define d__sn__regular_range_props_descriptor 6233
typedef t__sn__regular_range_props_descriptor t__regular_range_props_descriptor;
#define d__regular_range_props_descriptor d__sn__regular_range_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/bit_range_props_declare.e"  From 'struct definition' */
typedef struct s__sn__bit_range_props_des54707 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__bit_range_props_descriptor;
#define d__sn__bit_range_props_descriptor 6234
typedef t__sn__bit_range_props_descriptor t__bit_range_props_descriptor;
#define d__bit_range_props_descriptor d__sn__bit_range_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/list_range_props_declare.e"  From 'struct definition' */
typedef struct s__sn__list_range_props_de54708 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__list_range_props_descriptor;
#define d__sn__list_range_props_descriptor 6235
typedef t__sn__list_range_props_descriptor t__list_range_props_descriptor;
#define d__list_range_props_descriptor d__sn__list_range_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sni_egendebugger_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_egendebugger_se54709 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_egendebugger_service_descriptor;
#define d__sn__sni_egendebugger_service_descriptor 6236
typedef t__sn__sni_egendebugger_service_descriptor t__sni_egendebugger_service_descriptor;
#define d__sni_egendebugger_service_descriptor d__sn__sni_egendebugger_service_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sni_jgendebugger_service_declare.e"  From 'struct definition' */
typedef struct s__sn__sni_jgendebugger_se54710 {
    t__int d__;
    t__int gen__;
} *t__sn__sni_jgendebugger_service_descriptor;
#define d__sn__sni_jgendebugger_service_descriptor 6237
typedef t__sn__sni_jgendebugger_service_descriptor t__sni_jgendebugger_service_descriptor;
#define d__sni_jgendebugger_service_descriptor d__sn__sni_jgendebugger_service_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_gen_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_event_props_54711 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gen_event_props_descriptor;
#define d__sn__sn_gen_event_props_descriptor 6238
typedef t__sn__sn_gen_event_props_descriptor t__sn_gen_event_props_descriptor;
#define d__sn_gen_event_props_descriptor d__sn__sn_gen_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_set_value_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_set_value_event_54712 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_set_value_event_props_descriptor;
#define d__sn__sn_set_value_event_props_descriptor 6239
typedef t__sn__sn_set_value_event_props_descriptor t__sn_set_value_event_props_descriptor;
#define d__sn_set_value_event_props_descriptor d__sn__sn_set_value_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_set_scalar_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_set_scalar_event54713 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_set_scalar_event_props_descriptor;
#define d__sn__sn_set_scalar_event_props_descriptor 6240
typedef t__sn__sn_set_scalar_event_props_descriptor t__sn_set_scalar_event_props_descriptor;
#define d__sn_set_scalar_event_props_descriptor d__sn__sn_set_scalar_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_set_struct_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_set_struct_event54714 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_set_struct_event_props_descriptor;
#define d__sn__sn_set_struct_event_props_descriptor 6241
typedef t__sn__sn_set_struct_event_props_descriptor t__sn_set_struct_event_props_descriptor;
#define d__sn_set_struct_event_props_descriptor d__sn__sn_set_struct_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_set_list_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_set_list_event_p54715 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_set_list_event_props_descriptor;
#define d__sn__sn_set_list_event_props_descriptor 6242
typedef t__sn__sn_set_list_event_props_descriptor t__sn_set_list_event_props_descriptor;
#define d__sn_set_list_event_props_descriptor d__sn__sn_set_list_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_gen_root_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_root_event_p54716 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gen_root_event_props_descriptor;
#define d__sn__sn_gen_root_event_props_descriptor 6243
typedef t__sn__sn_gen_root_event_props_descriptor t__sn_gen_root_event_props_descriptor;
#define d__sn_gen_root_event_props_descriptor d__sn__sn_gen_root_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_gen_root_event_props_flags_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_root_event_p54717 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gen_root_event_props_flags_descriptor;
#define d__sn__sn_gen_root_event_props_flags_descriptor 6244
typedef t__sn__sn_gen_root_event_props_flags_descriptor t__sn_gen_root_event_props_flags_descriptor;
#define d__sn_gen_root_event_props_flags_descriptor d__sn__sn_gen_root_event_props_flags_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_start_gen_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_start_gen_event_54718 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_start_gen_event_props_descriptor;
#define d__sn__sn_start_gen_event_props_descriptor 6245
typedef t__sn__sn_start_gen_event_props_descriptor t__sn_start_gen_event_props_descriptor;
#define d__sn_start_gen_event_props_descriptor d__sn__sn_start_gen_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_gen_struct_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_struct_event54719 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gen_struct_event_props_descriptor;
#define d__sn__sn_gen_struct_event_props_descriptor 6246
typedef t__sn__sn_gen_struct_event_props_descriptor t__sn_gen_struct_event_props_descriptor;
#define d__sn_gen_struct_event_props_descriptor d__sn__sn_gen_struct_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_gen_list_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_gen_list_event_p54720 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_gen_list_event_props_descriptor;
#define d__sn__sn_gen_list_event_props_descriptor 6247
typedef t__sn__sn_gen_list_event_props_descriptor t__sn_gen_list_event_props_descriptor;
#define d__sn_gen_list_event_props_descriptor d__sn__sn_gen_list_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_end_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_end_event_props_54721 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_end_event_props_descriptor;
#define d__sn__sn_end_event_props_descriptor 6248
typedef t__sn__sn_end_event_props_descriptor t__sn_end_event_props_descriptor;
#define d__sn_end_event_props_descriptor d__sn__sn_end_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_end_gen_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_end_gen_event_pr54722 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_end_gen_event_props_descriptor;
#define d__sn__sn_end_gen_event_props_descriptor 6249
typedef t__sn__sn_end_gen_event_props_descriptor t__sn_end_gen_event_props_descriptor;
#define d__sn_end_gen_event_props_descriptor d__sn__sn_end_gen_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_end_struct_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_end_struct_event54723 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_end_struct_event_props_descriptor;
#define d__sn__sn_end_struct_event_props_descriptor 6250
typedef t__sn__sn_end_struct_event_props_descriptor t__sn_end_struct_event_props_descriptor;
#define d__sn_end_struct_event_props_descriptor d__sn__sn_end_struct_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_end_list_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_end_list_event_p54724 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_end_list_event_props_descriptor;
#define d__sn__sn_end_list_event_props_descriptor 6251
typedef t__sn__sn_end_list_event_props_descriptor t__sn_end_list_event_props_descriptor;
#define d__sn_end_list_event_props_descriptor d__sn__sn_end_list_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_testing_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_testing_event_pr54725 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_testing_event_props_descriptor;
#define d__sn__sn_testing_event_props_descriptor 6252
typedef t__sn__sn_testing_event_props_descriptor t__sn_testing_event_props_descriptor;
#define d__sn_testing_event_props_descriptor d__sn__sn_testing_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_constraint_testing_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_constraint_testi54726 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_constraint_testing_event_props_descriptor;
#define d__sn__sn_constraint_testing_event_props_descriptor 6253
typedef t__sn__sn_constraint_testing_event_props_descriptor t__sn_constraint_testing_event_props_descriptor;
#define d__sn_constraint_testing_event_props_descriptor d__sn__sn_constraint_testing_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_dynamic_reduction_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_dynamic_reductio54727 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_dynamic_reduction_event_props_descriptor;
#define d__sn__sn_dynamic_reduction_event_props_descriptor 6254
typedef t__sn__sn_dynamic_reduction_event_props_descriptor t__sn_dynamic_reduction_event_props_descriptor;
#define d__sn_dynamic_reduction_event_props_descriptor d__sn__sn_dynamic_reduction_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_static_reduction_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_static_reduction54728 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_static_reduction_event_props_descriptor;
#define d__sn__sn_static_reduction_event_props_descriptor 6255
typedef t__sn__sn_static_reduction_event_props_descriptor t__sn_static_reduction_event_props_descriptor;
#define d__sn_static_reduction_event_props_descriptor d__sn__sn_static_reduction_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_soft_testing_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_soft_testing_eve54729 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_soft_testing_event_props_descriptor;
#define d__sn__sn_soft_testing_event_props_descriptor 6256
typedef t__sn__sn_soft_testing_event_props_descriptor t__sn_soft_testing_event_props_descriptor;
#define d__sn_soft_testing_event_props_descriptor d__sn__sn_soft_testing_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_soft_reduction_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_soft_reduction_e54730 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_soft_reduction_event_props_descriptor;
#define d__sn__sn_soft_reduction_event_props_descriptor 6257
typedef t__sn__sn_soft_reduction_event_props_descriptor t__sn_soft_reduction_event_props_descriptor;
#define d__sn_soft_reduction_event_props_descriptor d__sn__sn_soft_reduction_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_reset_soft_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_reset_soft_event54731 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_reset_soft_event_props_descriptor;
#define d__sn__sn_reset_soft_event_props_descriptor 6258
typedef t__sn__sn_reset_soft_event_props_descriptor t__sn_reset_soft_event_props_descriptor;
#define d__sn_reset_soft_event_props_descriptor d__sn__sn_reset_soft_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_set_status_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_set_status_event54732 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_set_status_event_props_descriptor;
#define d__sn__sn_set_status_event_props_descriptor 6259
typedef t__sn__sn_set_status_event_props_descriptor t__sn_set_status_event_props_descriptor;
#define d__sn_set_status_event_props_descriptor d__sn__sn_set_status_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_create_edge_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_create_edge_even54733 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_create_edge_event_props_descriptor;
#define d__sn__sn_create_edge_event_props_descriptor 6260
typedef t__sn__sn_create_edge_event_props_descriptor t__sn_create_edge_event_props_descriptor;
#define d__sn_create_edge_event_props_descriptor d__sn__sn_create_edge_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_dynamic_edge_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_dynamic_edge_eve54734 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_dynamic_edge_event_props_descriptor;
#define d__sn__sn_dynamic_edge_event_props_descriptor 6261
typedef t__sn__sn_dynamic_edge_event_props_descriptor t__sn_dynamic_edge_event_props_descriptor;
#define d__sn_dynamic_edge_event_props_descriptor d__sn__sn_dynamic_edge_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_start_collect_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_start_collect_ev54735 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_start_collect_event_props_descriptor;
#define d__sn__sn_start_collect_event_props_descriptor 6262
typedef t__sn__sn_start_collect_event_props_descriptor t__sn_start_collect_event_props_descriptor;
#define d__sn_start_collect_event_props_descriptor d__sn__sn_start_collect_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_stop_collect_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_stop_collect_eve54736 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_stop_collect_event_props_descriptor;
#define d__sn__sn_stop_collect_event_props_descriptor 6263
typedef t__sn__sn_stop_collect_event_props_descriptor t__sn_stop_collect_event_props_descriptor;
#define d__sn_stop_collect_event_props_descriptor d__sn__sn_stop_collect_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_static_edge_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_static_edge_even54737 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_static_edge_event_props_descriptor;
#define d__sn__sn_static_edge_event_props_descriptor 6264
typedef t__sn__sn_static_edge_event_props_descriptor t__sn_static_edge_event_props_descriptor;
#define d__sn_static_edge_event_props_descriptor d__sn__sn_static_edge_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_start_preorder_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_start_preorder_e54738 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_start_preorder_event_props_descriptor;
#define d__sn__sn_start_preorder_event_props_descriptor 6265
typedef t__sn__sn_start_preorder_event_props_descriptor t__sn_start_preorder_event_props_descriptor;
#define d__sn_start_preorder_event_props_descriptor d__sn__sn_start_preorder_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_end_preorder_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_end_preorder_eve54739 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_end_preorder_event_props_descriptor;
#define d__sn__sn_end_preorder_event_props_descriptor 6266
typedef t__sn__sn_end_preorder_event_props_descriptor t__sn_end_preorder_event_props_descriptor;
#define d__sn_end_preorder_event_props_descriptor d__sn__sn_end_preorder_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_cycle_error_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_cycle_error_even54740 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_cycle_error_event_props_descriptor;
#define d__sn__sn_cycle_error_event_props_descriptor 6267
typedef t__sn__sn_cycle_error_event_props_descriptor t__sn_cycle_error_event_props_descriptor;
#define d__sn_cycle_error_event_props_descriptor d__sn__sn_cycle_error_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_static_cycle_error_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_static_cycle_err54741 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_static_cycle_error_event_props_descriptor;
#define d__sn__sn_static_cycle_error_event_props_descriptor 6268
typedef t__sn__sn_static_cycle_error_event_props_descriptor t__sn_static_cycle_error_event_props_descriptor;
#define d__sn_static_cycle_error_event_props_descriptor d__sn__sn_static_cycle_error_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_run_time_cycle_error_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_run_time_cycle_e54742 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_run_time_cycle_error_event_props_descriptor;
#define d__sn__sn_run_time_cycle_error_event_props_descriptor 6269
typedef t__sn__sn_run_time_cycle_error_event_props_descriptor t__sn_run_time_cycle_error_event_props_descriptor;
#define d__sn_run_time_cycle_error_event_props_descriptor d__sn__sn_run_time_cycle_error_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_preorder_top_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_preorder_top_eve54743 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_preorder_top_event_props_descriptor;
#define d__sn__sn_preorder_top_event_props_descriptor 6270
typedef t__sn__sn_preorder_top_event_props_descriptor t__sn_preorder_top_event_props_descriptor;
#define d__sn_preorder_top_event_props_descriptor d__sn__sn_preorder_top_event_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_instanciated_field_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_instanciated_fie54744 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_instanciated_field_props_descriptor;
#define d__sn__sn_instanciated_field_props_descriptor 6271
typedef t__sn__sn_instanciated_field_props_descriptor t__sn_instanciated_field_props_descriptor;
#define d__sn_instanciated_field_props_descriptor d__sn__sn_instanciated_field_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_instanciated_list_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_instanciated_lis54745 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_instanciated_list_props_descriptor;
#define d__sn__sn_instanciated_list_props_descriptor 6272
typedef t__sn__sn_instanciated_list_props_descriptor t__sn_instanciated_list_props_descriptor;
#define d__sn_instanciated_list_props_descriptor d__sn__sn_instanciated_list_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_instanciated_list_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_instanciated_lis54746 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_instanciated_list_item_props_descriptor;
#define d__sn__sn_instanciated_list_item_props_descriptor 6273
typedef t__sn__sn_instanciated_list_item_props_descriptor t__sn_instanciated_list_item_props_descriptor;
#define d__sn_instanciated_list_item_props_descriptor d__sn__sn_instanciated_list_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_role_info_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_role_info_props_54747 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_role_info_props_descriptor;
#define d__sn__sn_role_info_props_descriptor 6274
typedef t__sn__sn_role_info_props_descriptor t__sn_role_info_props_descriptor;
#define d__sn_role_info_props_descriptor d__sn__sn_role_info_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_item_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_item_in_gen_p54748 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_item_in_gen_props_descriptor;
#define d__sn__gendb_item_in_gen_props_descriptor 6275
typedef t__sn__gendb_item_in_gen_props_descriptor t__gendb_item_in_gen_props_descriptor;
#define d__gendb_item_in_gen_props_descriptor d__sn__gendb_item_in_gen_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_field_in_role_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_field_in_role54749 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_field_in_role_props_descriptor;
#define d__sn__gendb_field_in_role_props_descriptor 6276
typedef t__sn__gendb_field_in_role_props_descriptor t__gendb_field_in_role_props_descriptor;
#define d__gendb_field_in_role_props_descriptor d__sn__gendb_field_in_role_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_list_in_role_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_list_in_role_54750 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_list_in_role_props_descriptor;
#define d__sn__gendb_list_in_role_props_descriptor 6277
typedef t__sn__gendb_list_in_role_props_descriptor t__gendb_list_in_role_props_descriptor;
#define d__gendb_list_in_role_props_descriptor d__sn__gendb_list_in_role_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_field_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_field_in_gen_54751 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_field_in_gen_props_descriptor;
#define d__sn__gendb_field_in_gen_props_descriptor 6278
typedef t__sn__gendb_field_in_gen_props_descriptor t__gendb_field_in_gen_props_descriptor;
#define d__gendb_field_in_gen_props_descriptor d__sn__gendb_field_in_gen_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_list_item_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_list_item_in_54752 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_list_item_in_gen_props_descriptor;
#define d__sn__gendb_list_item_in_gen_props_descriptor 6279
typedef t__sn__gendb_list_item_in_gen_props_descriptor t__gendb_list_item_in_gen_props_descriptor;
#define d__gendb_list_item_in_gen_props_descriptor d__sn__gendb_list_item_in_gen_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_gc_in_role_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_gc_in_role_pr54753 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_gc_in_role_props_descriptor;
#define d__sn__gendb_gc_in_role_props_descriptor 6280
typedef t__sn__gendb_gc_in_role_props_descriptor t__gendb_gc_in_role_props_descriptor;
#define d__gendb_gc_in_role_props_descriptor d__sn__gendb_gc_in_role_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_ci_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_ci_in_gen_pro54754 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_ci_in_gen_props_descriptor;
#define d__sn__gendb_ci_in_gen_props_descriptor 6281
typedef t__sn__gendb_ci_in_gen_props_descriptor t__gendb_ci_in_gen_props_descriptor;
#define d__gendb_ci_in_gen_props_descriptor d__sn__gendb_ci_in_gen_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__gendb_item_props_de54755 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__gendb_item_props_descriptor;
#define d__sn__gendb_item_props_descriptor 6282
typedef t__sn__gendb_item_props_descriptor t__gendb_item_props_descriptor;
#define d__gendb_item_props_descriptor d__sn__gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/constant_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__constant_gendb_item54756 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__constant_gendb_item_props_descriptor;
#define d__sn__constant_gendb_item_props_descriptor 6283
typedef t__sn__constant_gendb_item_props_descriptor t__constant_gendb_item_props_descriptor;
#define d__constant_gendb_item_props_descriptor d__sn__constant_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/simple_local_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__simple_local_gendb_54757 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__simple_local_gendb_item_props_descriptor;
#define d__sn__simple_local_gendb_item_props_descriptor 6284
typedef t__sn__simple_local_gendb_item_props_descriptor t__simple_local_gendb_item_props_descriptor;
#define d__simple_local_gendb_item_props_descriptor d__sn__simple_local_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/static_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__static_gendb_item_p54758 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__static_gendb_item_props_descriptor;
#define d__sn__static_gendb_item_props_descriptor 6285
typedef t__sn__static_gendb_item_props_descriptor t__static_gendb_item_props_descriptor;
#define d__static_gendb_item_props_descriptor d__sn__static_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/changed_static_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__changed_static_gend54759 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__changed_static_gendb_item_props_descriptor;
#define d__sn__changed_static_gendb_item_props_descriptor 6286
typedef t__sn__changed_static_gendb_item_props_descriptor t__changed_static_gendb_item_props_descriptor;
#define d__changed_static_gendb_item_props_descriptor d__sn__changed_static_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/held_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__held_gendb_item_pro54760 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__held_gendb_item_props_descriptor;
#define d__sn__held_gendb_item_props_descriptor 6287
typedef t__sn__held_gendb_item_props_descriptor t__held_gendb_item_props_descriptor;
#define d__held_gendb_item_props_descriptor d__sn__held_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/me_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__me_gendb_item_props54761 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__me_gendb_item_props_descriptor;
#define d__sn__me_gendb_item_props_descriptor 6288
typedef t__sn__me_gendb_item_props_descriptor t__me_gendb_item_props_descriptor;
#define d__me_gendb_item_props_descriptor d__sn__me_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/fix_me_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__fix_me_gendb_item_p54762 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__fix_me_gendb_item_props_descriptor;
#define d__sn__fix_me_gendb_item_props_descriptor 6289
typedef t__sn__fix_me_gendb_item_props_descriptor t__fix_me_gendb_item_props_descriptor;
#define d__fix_me_gendb_item_props_descriptor d__sn__fix_me_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/not_fix_me_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__not_fix_me_gendb_it54763 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__not_fix_me_gendb_item_props_descriptor;
#define d__sn__not_fix_me_gendb_item_props_descriptor 6290
typedef t__sn__not_fix_me_gendb_item_props_descriptor t__not_fix_me_gendb_item_props_descriptor;
#define d__not_fix_me_gendb_item_props_descriptor d__sn__not_fix_me_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/changed_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn__changed_gendb_item_54764 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__changed_gendb_item_props_descriptor;
#define d__sn__changed_gendb_item_props_descriptor 6291
typedef t__sn__changed_gendb_item_props_descriptor t__changed_gendb_item_props_descriptor;
#define d__changed_gendb_item_props_descriptor d__sn__changed_gendb_item_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_arrow_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_arrow_props_desc54765 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_arrow_props_descriptor;
#define d__sn__sn_arrow_props_descriptor 6292
typedef t__sn__sn_arrow_props_descriptor t__sn_arrow_props_descriptor;
#define d__sn_arrow_props_descriptor d__sn__sn_arrow_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/abs_query_result_props_declare.e"  From 'struct definition' */
typedef struct s__sn__abs_query_result_pr54766 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__abs_query_result_props_descriptor;
#define d__sn__abs_query_result_props_descriptor 6293
typedef t__sn__abs_query_result_props_descriptor t__abs_query_result_props_descriptor;
#define d__abs_query_result_props_descriptor d__sn__abs_query_result_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/history_result_props_declare.e"  From 'struct definition' */
typedef struct s__sn__history_result_prop54767 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__history_result_props_descriptor;
#define d__sn__history_result_props_descriptor 6294
typedef t__sn__history_result_props_descriptor t__history_result_props_descriptor;
#define d__history_result_props_descriptor d__sn__history_result_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/reason_result_props_declare.e"  From 'struct definition' */
typedef struct s__sn__reason_result_props54768 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__reason_result_props_descriptor;
#define d__sn__reason_result_props_descriptor 6295
typedef t__sn__reason_result_props_descriptor t__reason_result_props_descriptor;
#define d__reason_result_props_descriptor d__sn__reason_result_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/closure_result_props_declare.e"  From 'struct definition' */
typedef struct s__sn__closure_result_prop54769 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__closure_result_props_descriptor;
#define d__sn__closure_result_props_descriptor 6296
typedef t__sn__closure_result_props_descriptor t__closure_result_props_descriptor;
#define d__closure_result_props_descriptor d__sn__closure_result_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/effect_result_props_declare.e"  From 'struct definition' */
typedef struct s__sn__effect_result_props54770 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__effect_result_props_descriptor;
#define d__sn__effect_result_props_descriptor 6297
typedef t__sn__effect_result_props_descriptor t__effect_result_props_descriptor;
#define d__effect_result_props_descriptor d__sn__effect_result_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/abs_ci_status_props_declare.e"  From 'struct definition' */
typedef struct s__sn__abs_ci_status_props54771 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__abs_ci_status_props_descriptor;
#define d__sn__abs_ci_status_props_descriptor 6298
typedef t__sn__abs_ci_status_props_descriptor t__abs_ci_status_props_descriptor;
#define d__abs_ci_status_props_descriptor d__sn__abs_ci_status_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_ci_status_unchanged_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_ci_status_unchan54772 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_ci_status_unchanged_props_descriptor;
#define d__sn__sn_ci_status_unchanged_props_descriptor 6299
typedef t__sn__sn_ci_status_unchanged_props_descriptor t__sn_ci_status_unchanged_props_descriptor;
#define d__sn_ci_status_unchanged_props_descriptor d__sn__sn_ci_status_unchanged_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_ci_status_changed_props_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_ci_status_change54773 {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *data_type;
    struct s__sn__struct_descriptor *p_sd_packer;
} *t__sn__sn_ci_status_changed_props_descriptor;
#define d__sn__sn_ci_status_changed_props_descriptor 6300
typedef t__sn__sn_ci_status_changed_props_descriptor t__sn_ci_status_changed_props_descriptor;
#define d__sn_ci_status_changed_props_descriptor d__sn__sn_ci_status_changed_props_descriptor

/* line 14 "/vobs/specman/src/japp/gendebugger/gencode/sn_status_result_kinds_declare.e"  From 'struct definition' */
typedef struct s__sn__sn_status_result_ki54774 {
    t__int d__;
    t__int gen__;
} *t__sn__sn_status_result_kinds_descriptor;
#define d__sn__sn_status_result_kinds_descriptor 6301
typedef t__sn__sn_status_result_kinds_descriptor t__sn_status_result_kinds_descriptor;
#define d__sn_status_result_kinds_descriptor d__sn__sn_status_result_kinds_descriptor

/* line 134 "/vobs/specman/src/snorb/orb/snorb.e"  From 'struct definition' */
typedef struct s__sn__snorb_all_flags {
    t__int d__;
    t__int gen__;
    t__bool impl_repository_debug;
    t__bool USE_LOOPBACK;
} *t__sn__snorb_all_flags;
#define d__sn__snorb_all_flags 3466
typedef t__sn__snorb_all_flags t__snorb_all_flags;
#define d__snorb_all_flags d__sn__snorb_all_flags

/* line 52 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_data_helper {
    t__int d__;
    t__int gen__;
    struct s__k__sn__name_id_pair__name *type_name_to_id;
    struct s__l__sn__snorb_data_descriptor *id_to_desc;
} *t__sn__snorb_data_helper;
#define d__sn__snorb_data_helper 3441
typedef t__sn__snorb_data_helper t__snorb_data_helper;
#define d__snorb_data_helper d__sn__snorb_data_helper

/* line 38 "/vobs/specman/src/snorb/orb/snorb_helpers.e"  From 'struct definition' */
typedef struct s__sn__name_id_pair {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string name;
    t__int id;
} *t__sn__name_id_pair;
#define d__sn__name_id_pair 3479
typedef t__sn__name_id_pair t__name_id_pair;
#define d__name_id_pair d__sn__name_id_pair

/* line 43 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_data_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn__snorb_data_descriptor;
#define d__sn__snorb_data_descriptor 3437
typedef t__sn__snorb_data_descriptor t__snorb_data_descriptor;
#define d__snorb_data_descriptor d__sn__snorb_data_descriptor

/* line 66 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_object_helper {
    t__int d__;
    t__int gen__;
} *t__sn__snorb_object_helper;
#define d__sn__snorb_object_helper 3442
typedef t__sn__snorb_object_helper t__snorb_object_helper;
#define d__snorb_object_helper d__sn__snorb_object_helper

/* line 117 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_sender {
    t__int d__;
    t__int gen__;
    struct s__sn__snorb_stub_factory *p_factory;
    t__int send_counter;
} *t__sn__snorb_sender;
#define d__sn__snorb_sender 3461
typedef t__sn__snorb_sender t__snorb_sender;
#define d__snorb_sender d__sn__snorb_sender

/* line 128 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_stub_factory {
    t__int d__;
    t__int gen__;
    struct s__sn__p_snorb_stub_cache *p_cache;
} *t__sn__snorb_stub_factory;
#define d__sn__snorb_stub_factory 3462
typedef t__sn__snorb_stub_factory t__snorb_stub_factory;
#define d__snorb_stub_factory d__sn__snorb_stub_factory

/* line 150 "/vobs/specman/src/snorb/orb/snorb_stub_factory.e"  From 'struct definition' */
typedef struct s__sn__p_snorb_stub_cache {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_string_hash_table *p_hash_oid_to_data;
    struct s__sn__sn_map *p_map_stub_to_desc;
} *t__sn__p_snorb_stub_cache;
#define d__sn__p_snorb_stub_cache 3469
typedef t__sn__p_snorb_stub_cache t__p_snorb_stub_cache;
#define d__p_snorb_stub_cache d__sn__p_snorb_stub_cache

/* line 761 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_string_hash_table {
    t__int d__;
    t__int gen__;
    struct s__k__sn__p_sn_string_hash_4513 *p_data;
    t__bool p_initialized;
} *t__sn__sn_string_hash_table;
#define d__sn__sn_string_hash_table 1517
typedef t__sn__sn_string_hash_table t__sn_string_hash_table;
#define d__sn_string_hash_table d__sn__sn_string_hash_table

/* line 735 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__p_sn_string_hash_tab4511 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_string_hashable *p_key;
    struct s__e_core__base_struct *p_value;
    t__string p_internal_key;
} *t__sn__p_sn_string_hash_table_entry;
#define d__sn__p_sn_string_hash_table_entry 1516
typedef t__sn__p_sn_string_hash_table_entry t__p_sn_string_hash_table_entry;
#define d__p_sn_string_hash_table_entry d__sn__p_sn_string_hash_table_entry

/* line 646 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__sn_map {
    t__int d__;
    t__int gen__;
    t__bool initialized;
    struct s__k__sn__p_map_entry__key *p_list;
} *t__sn__sn_map;
#define d__sn__sn_map 1514
typedef t__sn__sn_map t__sn_map;
#define d__sn_map d__sn__sn_map

/* line 635 "/vobs/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn__p_map_entry {
    t__int d__;
    t__int gen__;
    struct s__e_core__base_struct *key;
    struct s__e_core__base_struct *value;
} *t__sn__p_map_entry;
#define d__sn__p_map_entry 1513
typedef t__sn__p_map_entry t__p_map_entry;
#define d__p_map_entry d__sn__p_map_entry

/* line 112 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_receiver {
    t__int d__;
    t__int gen__;
    t__int p_n_orbid;
    struct s__sn__snorb_impl_repository *p_repository;
    struct s__sn__snorb_impl_adapter_23749 *p_adapter_factory;
    t__int receive_counter;
} *t__sn__snorb_receiver;
#define d__sn__snorb_receiver 3460
typedef t__sn__snorb_receiver t__snorb_receiver;
#define d__snorb_receiver d__sn__snorb_receiver

/* line 16 "/vobs/specman/src/snorb/orb/snorb_impl_repository.e"  From 'struct definition' */
typedef struct s__sn__snorb_impl_repository {
    t__int d__;
    t__int gen__;
    t__int p_n_orb_id;
    t__int p_n_object_id_count;
    struct s__sn__snorb_object_id *p_objid_bootstrap;
    struct s__sn__sn_string_hash_table *p_hash_id_to_impl;
    struct s__sn__sn_map *p_hash_impl_to_id;
} *t__sn__snorb_impl_repository;
#define d__sn__snorb_impl_repository 3470
typedef t__sn__snorb_impl_repository t__snorb_impl_repository;
#define d__snorb_impl_repository d__sn__snorb_impl_repository

/* line 111 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__snorb_impl_adapter_23749 {
    t__int d__;
    t__int gen__;
    struct s__sn__p_snorb_adapter_cache *p_cache;
} *t__sn__snorb_impl_adapter_factory;
#define d__sn__snorb_impl_adapter_factory 3459
typedef t__sn__snorb_impl_adapter_factory t__snorb_impl_adapter_factory;
#define d__snorb_impl_adapter_factory d__sn__snorb_impl_adapter_factory

/* line 87 "/vobs/specman/src/snorb/orb/snorb_impl_adapter_factory.e"  From 'struct definition' */
typedef struct s__sn__p_snorb_adapter_cache {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_map *p_map;
} *t__sn__p_snorb_adapter_cache;
#define d__sn__p_snorb_adapter_cache 3471
typedef t__sn__p_snorb_adapter_cache t__p_snorb_adapter_cache;
#define d__p_snorb_adapter_cache d__sn__p_snorb_adapter_cache

/* line 19 "/vobs/specman/src/snorb/orb/services/snorb_service_repository.e"  From 'struct definition' */
typedef struct s__sn__snorb_service_repository {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_string_hash_table *p_map_key_to_id;
} *t__sn__snorb_service_repository;
#define d__sn__snorb_service_repository 3491
typedef t__sn__snorb_service_repository t__snorb_service_repository;
#define d__snorb_service_repository d__sn__snorb_service_repository

/* line 130 "/vobs/specman/src/snorb/orb/services/snorb_service_repository.e"  From 'struct definition' */
typedef struct s__sn__snorb_service_finder {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int p_n_id_peer_orb;
    struct s__sn__sni_service_repository *p_isr_remote;
} *t__sn__snorb_service_finder;
#define d__sn__snorb_service_finder 3492
typedef t__sn__snorb_service_finder t__snorb_service_finder;
#define d__snorb_service_finder d__sn__snorb_service_finder

/* line 8 "/vobs/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__sn__sni_service_repository {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_service_repository;
#define d__sn__sni_service_repository 3426
typedef t__sn__sni_service_repository t__sni_service_repository;
#define d__sni_service_repository d__sn__sni_service_repository

/* line 26 "/vobs/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn__sn_edl_parser {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_edl_struct_in22780 *all_structs;
    struct s__k__string__it *loaded_gen_structs_registry;
} *t__sn__sn_edl_parser;
#define d__sn__sn_edl_parser 3359
typedef t__sn__sn_edl_parser t__sn_edl_parser;
#define d__sn_edl_parser d__sn__sn_edl_parser

/* line 259 "/vobs/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn__sn_edl_struct_info {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor *p_td;
    struct s__sn__struct_descriptor *p_sd_base;
    t__bool p_f_enum;
    t__bool p_f_interface;
    t__bool p_f_exported;
    t__string p_s_package;
    t__string p_s_e_parallel_struct;
    t__string p_s_j_parallel_struct;
    t__string p_s_is_abstract;
    t__string p_s_java_ext;
    struct s__k__sn__sn_edl_method_in22778 *all_methods;
    struct s__k__sn__sn_edl_const_inf22779 *all_consts;
} *t__sn__sn_edl_struct_info;
#define d__sn__sn_edl_struct_info 3360
typedef t__sn__sn_edl_struct_info t__sn_edl_struct_info;
#define d__sn_edl_struct_info d__sn__sn_edl_struct_info

/* line 383 "/vobs/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn__sn_edl_method_info {
    t__int d__;
    t__int gen__;
    struct s__sn__method *p_method;
    t__bool p_f_notifier;
    t__sn__sn_edl_method_remote_kind p_remote_kind;
} *t__sn__sn_edl_method_info;
#define d__sn__sn_edl_method_info 3362
typedef t__sn__sn_edl_method_info t__sn_edl_method_info;
#define d__sn_edl_method_info d__sn__sn_edl_method_info

/* line 371 "/vobs/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn__sn_edl_const_info {
    t__int d__;
    t__int gen__;
    t__string p_s_name;
    t__string p_s_type;
    t__string p_s_value;
} *t__sn__sn_edl_const_info;
#define d__sn__sn_edl_const_info 3361
typedef t__sn__sn_edl_const_info t__sn_edl_const_info;
#define d__sn_edl_const_info d__sn__sn_edl_const_info

/* line 119 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__sn_edl_code_generator {
    t__int d__;
    t__int gen__;
} *t__sn__sn_edl_code_generator;
#define d__sn__sn_edl_code_generator 3372
typedef t__sn__sn_edl_code_generator t__sn_edl_code_generator;
#define d__sn_edl_code_generator d__sn__sn_edl_code_generator

/* line 438 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLGlobal {
    t__int d__;
    t__int gen__;
    struct s__sn__EDLRoot *p_edl_root;
    struct s__sn__EDLUtils *p_edl_utils;
    struct s__sn__BasicTypesManager *p_primitive_types_manager;
    t__bool initialized;
    struct s__sn__EDLGenerator *p_edl_generator;
} *t__sn__EDLGlobal;
#define d__sn__EDLGlobal 3376
typedef t__sn__EDLGlobal t__EDLGlobal;
#define d__EDLGlobal d__sn__EDLGlobal

/* line 521 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLRoot {
    t__int d__;
    t__int gen__;
    struct s__l__sn__EDLPackage *p_list_of_packages;
} *t__sn__EDLRoot;
#define d__sn__EDLRoot 3380
typedef t__sn__EDLRoot t__EDLRoot;
#define d__EDLRoot d__sn__EDLRoot

/* line 603 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLPackage {
    t__int d__;
    t__int gen__;
    t__string p_s_name;
    struct s__l__sn__EDLAbsUserType *p_list_of_user_types;
} *t__sn__EDLPackage;
#define d__sn__EDLPackage 3381
typedef t__sn__EDLPackage t__EDLPackage;
#define d__EDLPackage d__sn__EDLPackage

/* line 863 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLAbsUserType {
    t__int d__;
    t__int gen__;
    t__sn__typeKind p_kind;
    struct s__sn__EDLPackage *p_package;
    struct s__k__sn__EDLAbsUserType__it *list_of_related_user_types;
    struct s__sn__EDLBaseStruct *p_base_struct;
    struct s__sn__sn_edl_struct_info *p_struct_info;
    t__bool p_gen_it;
} *t__sn__EDLAbsUserType;
#define d__sn__EDLAbsUserType 3388
typedef t__sn__EDLAbsUserType t__EDLAbsUserType;
#define d__EDLAbsUserType d__sn__EDLAbsUserType

/* line 1556 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLBaseStruct {
    t__int d__;
    t__int gen__;
    struct s__sn__EDLAbsType *p_type;
    t__bool p_f_list;
    struct s__sn__EDLAbsUserType *p_original_struct;
} *t__sn__EDLBaseStruct;
#define d__sn__EDLBaseStruct 3394
typedef t__sn__EDLBaseStruct t__EDLBaseStruct;
#define d__EDLBaseStruct d__sn__EDLBaseStruct

/* line 791 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLAbsType {
    t__int d__;
    t__int gen__;
    t__sn__typeKind p_kind;
} *t__sn__EDLAbsType;
#define d__sn__EDLAbsType 3384
typedef t__sn__EDLAbsType t__EDLAbsType;
#define d__EDLAbsType d__sn__EDLAbsType

/* line 352 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLUtils {
    t__int d__;
    t__int gen__;
} *t__sn__EDLUtils;
#define d__sn__EDLUtils 3375
typedef t__sn__EDLUtils t__EDLUtils;
#define d__EDLUtils d__sn__EDLUtils

/* line 2017 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__BasicTypesManager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__EDLAbsBasicType *p_list_of_basic_types;
} *t__sn__BasicTypesManager;
#define d__sn__BasicTypesManager 3401
typedef t__sn__BasicTypesManager t__BasicTypesManager;
#define d__BasicTypesManager d__sn__BasicTypesManager

/* line 810 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLAbsBasicType {
    t__int d__;
    t__int gen__;
    t__sn__typeKind p_kind;
    struct s__sn__type_descriptor *p_td;
} *t__sn__EDLAbsBasicType;
#define d__sn__EDLAbsBasicType 3385
typedef t__sn__EDLAbsBasicType t__EDLAbsBasicType;
#define d__EDLAbsBasicType d__sn__EDLAbsBasicType

/* line 450 "/vobs/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn__EDLGenerator {
    t__int d__;
    t__int gen__;
    t__sn__EDLLanguage LANGUAGE;
    t__string HOME_DIR;
    t__string TOP_NAME;
    t__string DEFAULT_E_HOME_DIR;
    t__string DEFAULT_JAVA_HOME_DIR;
    struct s__l__string *modified_files;
    struct s__l__string *failed_modified_files;
    struct s__l__string *new_files;
    struct s__l__string *failed_new_files;
    struct s__l__string *checked_out_files;
    t__int counter;
    t__string logfile;
} *t__sn__EDLGenerator;
#define d__sn__EDLGenerator 3377
typedef t__sn__EDLGenerator t__EDLGenerator;
#define d__EDLGenerator d__sn__EDLGenerator

/* line 160 "/vobs/specman/src/vmp_brackets.e"  From 'struct definition' */
typedef struct s__sn__sn_curly_brackets_p25736 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_text_input_parser *target;
    struct s__l__sn__sn_vm_parse_elem27312 *l;
    t__string file_name;
    t__int depth;
    struct s__l__sn__sn_vm_parse_entity *ntf_entities;
    struct s__l__int *lines_stack;
    struct s__l__string *text_lines;
} *t__sn__sn_curly_brackets_processor;
#define d__sn__sn_curly_brackets_processor 3822
typedef t__sn__sn_curly_brackets_processor t__sn_curly_brackets_processor;
#define d__sn_curly_brackets_processor d__sn__sn_curly_brackets_processor

/* line 15 "/vobs/specman/src/vmp_brackets.e"  From 'struct definition' */
typedef struct s__sn__sn_text_input_parser {
    t__int d__;
    t__int gen__;
} *t__sn__sn_text_input_parser;
#define d__sn__sn_text_input_parser 3814
typedef t__sn__sn_text_input_parser t__sn_text_input_parser;
#define d__sn_text_input_parser d__sn__sn_text_input_parser

/* line 137 "/vobs/specman/src/vmp_brackets.e"  From 'struct definition' */
typedef struct s__sn__sn_vm_parse_element27313 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_vm_parse_entity *entities;
} *t__sn__sn_vm_parse_elements_holder;
#define d__sn__sn_vm_parse_elements_holder 3821
typedef t__sn__sn_vm_parse_elements_holder t__sn_vm_parse_elements_holder;
#define d__sn_vm_parse_elements_holder d__sn__sn_vm_parse_elements_holder

/* line 46 "/vobs/specman/src/vmp_brackets.e"  From 'struct definition' */
typedef struct s__sn__sn_vm_parse_entity {
    t__int d__;
    t__int gen__;
    t__string definition_file;
    t__string key_word;
    t__int line;
} *t__sn__sn_vm_parse_entity;
#define d__sn__sn_vm_parse_entity 3815
typedef t__sn__sn_vm_parse_entity t__sn_vm_parse_entity;
#define d__sn_vm_parse_entity d__sn__sn_vm_parse_entity

/* line 63 "/vobs/specman/src/eve.e"  From 'struct definition' */
typedef struct s__sn__event_viewer {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__main__basic_event_log *collected;
    t__int prev_shown_time;
    t__string last_time_ref_str;
    t__string last_events_str;
    struct s__l__sn__sn_ec_point_envi25953 *last_environments;
    struct s__e_core__time *last_chart_start_time;
    struct s__e_core__time *last_chart_end_time;
    t__bool last_chart_prev_info_exists;
    t__bool last_chart_next_info_exists;
    struct s__l__int *last_chart_events;
    struct s__l__string *last_chart_selectors;
    t__bool shown_prev_syntax;
    t__bool shown_next_syntax;
} *t__sn__event_viewer;
#define d__sn__event_viewer 3826
typedef t__sn__event_viewer t__event_viewer;
#define d__event_viewer d__sn__event_viewer

/* line 225 "/vobs/specman/src/eve_chart.e"  From 'struct definition' */
typedef struct s__sn__sn_ec_point_environment {
    t__int d__;
    t__int gen__;
    struct s__e_core__time *point_time;
    struct s__e_core__time *env_beginnig;
    struct s__e_core__time *env_end;
} *t__sn__sn_ec_point_environment;
#define d__sn__sn_ec_point_environment 3855
typedef t__sn__sn_ec_point_environment t__sn_ec_point_environment;
#define d__sn_ec_point_environment d__sn__sn_ec_point_environment

/* line 5 "/vobs/specman/src/snorb/pub_services/pub_services.e"  From 'struct definition' */
typedef struct s__sn__sn_pub_services {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__e_core__any_struct *lst_services;
    struct s__sn__sn_specman_command_31881 *p_specman_command;
    struct s__sn__sn_specview_service *p_specview_service;
    struct s__sn__sn_service_deli_manager *service_deli_manager;
    struct s__sn__sn_remote_appl_mana31882 *remote_appl_manager;
    struct s__sn__sn_jcvr_service_impl *p_jcvr;
    struct s__sn__sn_e_jcvr_external_34466 *p_e_jcvr_external_service;
    struct s__sn__sn_e_jutils_service *p_e_jutils_service;
} *t__sn__sn_pub_services;
#define d__sn__sn_pub_services 4225
typedef t__sn__sn_pub_services t__sn_pub_services;
#define d__sn_pub_services d__sn__sn_pub_services

/* line 7 "/vobs/specman/src/snorb/pub_services/sni_specman_command/sni_specman_command.e"  From 'struct definition' */
typedef struct s__sn__sn_specman_command_31881 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sn_specman_command_service;
#define d__sn__sn_specman_command_service 4232
typedef t__sn__sn_specman_command_service t__sn_specman_command_service;
#define d__sn_specman_command_service d__sn__sn_specman_command_service

/* line 18 "/vobs/specman/src/snorb/pub_services/sni_specview_service/specview_service.e"  From 'struct definition' */
typedef struct s__sn__sn_specview_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_gui_resources *p_resources;
} *t__sn__sn_specview_service;
#define d__sn__sn_specview_service 4248
typedef t__sn__sn_specview_service t__sn_specview_service;
#define d__sn_specview_service d__sn__sn_specview_service

/* line 53 "/vobs/specman/src/snorb/pub_services/sni_specview_service/specview_service_edl.e"  From 'struct definition' */
typedef struct s__sn__sn_gui_resources {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_color_data *text_area_bg_color;
    struct s__sn__sn_color_data *text_area_fg_color;
    struct s__sn__sn_color_data *text_area_sel_bg_color;
    struct s__sn__sn_color_data *text_area_sel_fg_color;
    struct s__sn__sn_color_data *text_area_cursor_color;
    struct s__sn__sn_font_data *toolbar_font;
    struct s__sn__sn_font_data *menu_font;
    struct s__sn__sn_font_data *default_font;
    t__int text_icon_mixed_mode;
    t__int tab_size;
} *t__sn__sn_gui_resources;
#define d__sn__sn_gui_resources 4235
typedef t__sn__sn_gui_resources t__sn_gui_resources;
#define d__sn_gui_resources d__sn__sn_gui_resources

/* line 32 "/vobs/specman/src/snorb/pub_services/sni_specview_service/specview_service_edl.e"  From 'struct definition' */
typedef struct s__sn__sn_color_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int r;
    t__int g;
    t__int b;
} *t__sn__sn_color_data;
#define d__sn__sn_color_data 4234
typedef t__sn__sn_color_data t__sn_color_data;
#define d__sn_color_data d__sn__sn_color_data

/* line 16 "/vobs/specman/src/snorb/pub_services/sni_specview_service/specview_service_edl.e"  From 'struct definition' */
typedef struct s__sn__sn_font_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string s_name;
    t__int n_style;
    t__int n_size;
} *t__sn__sn_font_data;
#define d__sn__sn_font_data 4233
typedef t__sn__sn_font_data t__sn_font_data;
#define d__sn_font_data d__sn__sn_font_data

/* line 27 "/vobs/specman/src/snorb/pub_services/sni_remote_appl_manager/service_deli_manager.e"  From 'struct definition' */
typedef struct s__sn__sn_service_deli_manager {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__k__sn__sn_service_deli_31887 *lst_service_entries;
} *t__sn__sn_service_deli_manager;
#define d__sn__sn_service_deli_manager 4251
typedef t__sn__sn_service_deli_manager t__sn_service_deli_manager;
#define d__sn_service_deli_manager d__sn__sn_service_deli_manager

/* line 14 "/vobs/specman/src/snorb/pub_services/sni_remote_appl_manager/service_deli_manager.e"  From 'struct definition' */
typedef struct s__sn__sn_service_deli_entry {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__abs_remote_service_deli *p_service_deli;
    t__string p_s_name;
} *t__sn__sn_service_deli_entry;
#define d__sn__sn_service_deli_entry 4250
typedef t__sn__sn_service_deli_entry t__sn_service_deli_entry;
#define d__sn_service_deli_entry d__sn__sn_service_deli_entry

/* line 3 "/vobs/specman/src/snorb/pub_services/sni_remote_appl_manager/service_deli_manager.e"  From 'struct definition' */
typedef struct s__sn__abs_remote_service_deli {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__abs_remote_service_deli;
#define d__sn__abs_remote_service_deli 4249
typedef t__sn__abs_remote_service_deli t__abs_remote_service_deli;
#define d__abs_remote_service_deli d__sn__abs_remote_service_deli

/* line 9 "/vobs/specman/src/snorb/pub_services/sni_remote_appl_manager/sni_remote_appl_manager.e"  From 'struct definition' */
typedef struct s__sn__sn_remote_appl_mana31882 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__k__string__it *lst_applications;
} *t__sn__sn_remote_appl_manager_service;
#define d__sn__sn_remote_appl_manager_service 4259
typedef t__sn__sn_remote_appl_manager_service t__sn_remote_appl_manager_service;
#define d__sn_remote_appl_manager_service d__sn__sn_remote_appl_manager_service

/* line 35 "/vobs/specman/src/japp/jcvr/jcvr.e"  From 'struct definition' */
typedef struct s__sn__sn_jcvr_service_impl {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__sn__sni_jcvr_change_39854 *p_listeners;
} *t__sn__sn_jcvr_service_impl;
#define d__sn__sn_jcvr_service_impl 4418
typedef t__sn__sn_jcvr_service_impl t__sn_jcvr_service_impl;
#define d__sn_jcvr_service_impl d__sn__sn_jcvr_service_impl

/* line 7 "/vobs/specman/src/japp/jcvr/jcvr_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jcvr_change_listener {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jcvr_change_listener;
#define d__sn__sni_jcvr_change_listener 3896
typedef t__sn__sni_jcvr_change_listener t__sni_jcvr_change_listener;
#define d__sni_jcvr_change_listener d__sn__sni_jcvr_change_listener

/* line 21 "/vobs/specman/src/japp/jcvr/jcvr_external.e"  From 'struct definition' */
typedef struct s__sn__sn_e_jcvr_external_34466 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sn_e_jcvr_external_service;
#define d__sn__sn_e_jcvr_external_service 4431
typedef t__sn__sn_e_jcvr_external_service t__sn_e_jcvr_external_service;
#define d__sn_e_jcvr_external_service d__sn__sn_e_jcvr_external_service

/* line 31 "/vobs/specman/src/japp/jutils/jutils.e"  From 'struct definition' */
typedef struct s__sn__sn_e_jutils_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string p_private_src_dir;
} *t__sn__sn_e_jutils_service;
#define d__sn__sn_e_jutils_service 4452
typedef t__sn__sn_e_jutils_service t__sn_e_jutils_service;
#define d__sn_e_jutils_service d__sn__sn_e_jutils_service

/* line 5 "/vobs/specman/src/wave_transactions_api.e"  From 'struct definition' */
typedef struct s__sn__sn_external_trace {
    t__int d__;
    t__int gen__;
    t__sn__transaction_database_kind_t transaction_database_kind;
    struct s__l__sn__sn_transaction_attr *attrs_bank;
    struct s__k__sn__sn_transaction_i34154 *transaction_database_interfaces;
    struct s__k__sn__unit_info_s__uni34155 *unit_hash;
    struct s__sn__sn_transaction_interface *sn_tr_db_ifc;
    struct s__sn__sn_dynamic_call *sdi_transaction___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_set_attribute___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_end_transaction___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_link_transaction___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_free_transaction_handle___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_close_database___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_start_of_reset___dynamic_call;
    struct s__sn__sn_dynamic_call *sdi_end_of_reset___dynamic_call;
    t__string cds_lib_dir_name;
    t__bool close_upon_restore;
    t__bool init_done;
    t__sn__e_time_units db_time_units;
    t__int db_time_units_factor;
    t__bool db_time_units_initialized;
    t__bool sdi_supports_overlapping_transactions;
    t__bool sdi_supports_overlapping_transactions_initialized;
    struct s__k__sn__sn_sdi_feature__34157 *sdi_features;
    struct s__sn__external_trace_sequene *trace_seq;
} *t__sn__sn_external_trace;
#define d__sn__sn_external_trace 4372
typedef t__sn__sn_external_trace t__sn_external_trace;
#define d__sn_external_trace d__sn__sn_external_trace

/* line 422 "/vobs/specman/src/wave_transactions.e"  From 'struct definition' */
typedef struct s__sn__unit_info_s {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *unit_object;
    t__string name_chain;
} *t__sn__unit_info_s;
#define d__sn__unit_info_s 4381
typedef t__sn__unit_info_s t__unit_info_s;
#define d__unit_info_s d__sn__unit_info_s

/* line 741 "/vobs/specman/src/wave_transactions_simvision.e"  From 'struct definition' */
typedef struct s__sn__sn_sdi_feature {
    t__int d__;
    t__int gen__;
    t__string feature_name;
    t__int feature_version;
} *t__sn__sn_sdi_feature;
#define d__sn__sn_sdi_feature 4389
typedef t__sn__sn_sdi_feature t__sn_sdi_feature;
#define d__sn_sdi_feature d__sn__sn_sdi_feature

/* line 4683 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__external_trace_sequene {
    t__int d__;
    t__int gen__;
} *t__sn__external_trace_sequene;
#define d__sn__external_trace_sequene 7735
typedef t__sn__external_trace_sequene t__external_trace_sequene;
#define d__external_trace_sequene d__sn__external_trace_sequene

/* line 8 "/vobs/specman/src/japp/jspecview_deli/jspecview_main.e"  From 'struct definition' */
typedef struct s__sn__sn_japp {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_jcvrgui_deli *p_jcvrgui_deli;
} *t__sn__sn_japp;
#define d__sn__sn_japp 4412
typedef t__sn__sn_japp t__sn_japp;
#define d__sn_japp d__sn__sn_japp

/* line 20 "/vobs/specman/src/japp/jcvr/jcvrgui.e"  From 'struct definition' */
typedef struct s__sn__sn_jcvrgui_deli {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sni_jcvrgui_service *p_sn_jcvrgui_deli;
} *t__sn__sn_jcvrgui_deli;
#define d__sn__sn_jcvrgui_deli 4420
typedef t__sn__sn_jcvrgui_deli t__sn_jcvrgui_deli;
#define d__sn_jcvrgui_deli d__sn__sn_jcvrgui_deli

/* line 16 "/vobs/specman/src/japp/jcvr/jcvr_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jcvrgui_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jcvrgui_service;
#define d__sn__sni_jcvrgui_service 3899
typedef t__sn__sni_jcvrgui_service t__sni_jcvrgui_service;
#define d__sni_jcvrgui_service d__sn__sni_jcvrgui_service

/* line 17 "/vobs/specman/src/japp/jspecview_deli/jspecview_main.e"  From 'struct definition' */
typedef struct s__sn__sn_jspecview_deli {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__comm_socket_interactor *p_socket;
    struct s__sn__sni_jspecview_service *p_jspecview_service;
    t__string p_s_user_classpath;
    t__int n_comm_timout;
    t__int n_comm_msg_interval;
    t__bool p_f_connect_asap;
    t__string p_time_str_mark;
    t__bool p_f_stay_awake;
} *t__sn__sn_jspecview_deli;
#define d__sn__sn_jspecview_deli 4413
typedef t__sn__sn_jspecview_deli t__sn_jspecview_deli;
#define d__sn_jspecview_deli d__sn__sn_jspecview_deli

/* line 3 "/vobs/specman/src/japp/jspecview_deli/jspecview_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jspecview_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jspecview_service;
#define d__sn__sni_jspecview_service 4408
typedef t__sn__sni_jspecview_service t__sni_jspecview_service;
#define d__sni_jspecview_service d__sn__sni_jspecview_service

/* line 126 "/vobs/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig {
    t__int d__;
    t__int gen__;
    struct s__sn__jconfig_service_deli *p_jconfig_deli;
    struct s__sn__sni_econfig_service *p_econfig_service;
    struct s__sn__sn_jconfig_utils *p_jconfig_utils;
    struct s__k__sn__sn_config_full_i39864 *p_lst_registered_items;
    struct s__sn__sn_jconfig_data *p_new_data_buffer;
    t__bool f_initial_data_sent;
} *t__sn__sn_jconfig;
#define d__sn__sn_jconfig 4474
typedef t__sn__sn_jconfig t__sn_jconfig;
#define d__sn_jconfig d__sn__sn_jconfig

/* line 10 "/vobs/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__sn__jconfig_service_deli {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sni_jconfig_service *p_jconfig_service;
} *t__sn__jconfig_service_deli;
#define d__sn__jconfig_service_deli 4472
typedef t__sn__jconfig_service_deli t__jconfig_service_deli;
#define d__jconfig_service_deli d__sn__jconfig_service_deli

/* line 3 "/vobs/specman/src/japp/jconfig/jconfig_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jconfig_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jconfig_service;
#define d__sn__sni_jconfig_service 4453
typedef t__sn__sni_jconfig_service t__sni_jconfig_service;
#define d__sni_jconfig_service d__sn__sni_jconfig_service

/* line 6 "/vobs/specman/src/japp/jconfig/jconfig_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_econfig_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_econfig_service;
#define d__sn__sni_econfig_service 4454
typedef t__sn__sni_econfig_service t__sni_econfig_service;
#define d__sni_econfig_service d__sn__sni_econfig_service

/* line 334 "/vobs/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig_utils {
    t__int d__;
    t__int gen__;
} *t__sn__sn_jconfig_utils;
#define d__sn__sn_jconfig_utils 4475
typedef t__sn__sn_jconfig_utils t__sn_jconfig_utils;
#define d__sn_jconfig_utils d__sn__sn_jconfig_utils

/* line 450 "/vobs/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__sn__sn_config_full_item {
    t__int d__;
    t__int gen__;
    t__string p_s_category;
    t__string p_s_item;
    t__string p_s_key;
    t__string p_curr_val;
} *t__sn__sn_config_full_item;
#define d__sn__sn_config_full_item 4476
typedef t__sn__sn_config_full_item t__sn_config_full_item;
#define d__sn_config_full_item d__sn__sn_config_full_item

/* line 10 "/vobs/specman/src/japp/jconfig/jconfig_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__sn__sn_jconfig_categ39859 *lst_category_vals;
} *t__sn__sn_jconfig_data;
#define d__sn__sn_jconfig_data 4455
typedef t__sn__sn_jconfig_data t__sn_jconfig_data;
#define d__sn_jconfig_data d__sn__sn_jconfig_data

/* line 14 "/vobs/specman/src/japp/jconfig/jconfig_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig_category_val {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string s_category;
    struct s__l__sn__sn_jconfig_item_val *lst_item_vals;
} *t__sn__sn_jconfig_category_val;
#define d__sn__sn_jconfig_category_val 4456
typedef t__sn__sn_jconfig_category_val t__sn_jconfig_category_val;
#define d__sn_jconfig_category_val d__sn__sn_jconfig_category_val

/* line 24 "/vobs/specman/src/japp/jconfig/jconfig_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_jconfig_item_val {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string s_item;
    t__string s_value;
} *t__sn__sn_jconfig_item_val;
#define d__sn__sn_jconfig_item_val 4457
typedef t__sn__sn_jconfig_item_val t__sn_jconfig_item_val;
#define d__sn_jconfig_item_val d__sn__sn_jconfig_item_val

/* line 30 "/vobs/specman/src/japp/jsource_viewer/source_viewer.e"  From 'struct definition' */
typedef struct s__sn__sn_source_viewer {
    t__int d__;
    t__int gen__;
    struct s__sn__sni_jsource_viewer_34841 *p_jsource_viewer_service;
} *t__sn__sn_source_viewer;
#define d__sn__sn_source_viewer 4485
typedef t__sn__sn_source_viewer t__sn_source_viewer;
#define d__sn_source_viewer d__sn__sn_source_viewer

/* line 3 "/vobs/specman/src/japp/jsource_viewer/source_viewer_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jsource_viewer_34841 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jsource_viewer_service;
#define d__sn__sni_jsource_viewer_service 4478
typedef t__sn__sni_jsource_viewer_service t__sni_jsource_viewer_service;
#define d__sni_jsource_viewer_service d__sn__sni_jsource_viewer_service

/* line 478 "/vobs/specman/src/japp/shared_minimal/shared_minimal_vt_defs.e"  From 'struct definition' */
typedef struct s__vt__sn_gt {
    t__int d__;
    t__int gen__;
    struct s__sn__sni_jmini_guitest_s34900 *jservice;
    t__bool p_pending_gt_cmd;
    t__bool p_pending_gt_on;
} *t__vt__sn_gt;
#define d__vt__sn_gt 2557
typedef t__vt__sn_gt t__sn_gt;
#define d__sn_gt d__vt__sn_gt

/* line 4 "/vobs/specman/src/japp/mini_guitest/mini_guitest_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jmini_guitest_s34900 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jmini_guitest_service;
#define d__sn__sni_jmini_guitest_service 4486
typedef t__sn__sni_jmini_guitest_service t__sni_jmini_guitest_service;
#define d__sni_jmini_guitest_service d__sn__sni_jmini_guitest_service

/* line 9 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__sn_databrowser {
    t__int d__;
    t__int gen__;
    t__bool db_raw_print_config_flag;
    t__bool db_raw_print_config_flag_was_initialized;
    struct s__sn__sn_jdatabrowser_del39875 *p_jdatabrowser_deli;
    struct s__sn__sn_edatabrowser_service *p_edatabrowser_service;
} *t__sn__sn_databrowser;
#define d__sn__sn_databrowser 4507
typedef t__sn__sn_databrowser t__sn_databrowser;
#define d__sn_databrowser d__sn__sn_databrowser

/* line 4 "/vobs/specman/src/japp/databrowser/db_jdatabrowser_deligator.e"  From 'struct definition' */
typedef struct s__sn__sn_jdatabrowser_del39875 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sni_jdatabrowser_service *p_jdatabrowser_service;
} *t__sn__sn_jdatabrowser_deligator;
#define d__sn__sn_jdatabrowser_deligator 4731
typedef t__sn__sn_jdatabrowser_deligator t__sn_jdatabrowser_deligator;
#define d__sn_jdatabrowser_deligator d__sn__sn_jdatabrowser_deligator

/* line 35 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__sni_jdatabrowser_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sni_jdatabrowser_service;
#define d__sn__sni_jdatabrowser_service 4508
typedef t__sn__sni_jdatabrowser_service t__sni_jdatabrowser_service;
#define d__sni_jdatabrowser_service d__sn__sni_jdatabrowser_service

/* line 9 "/vobs/specman/src/japp/databrowser/db_edatabrowser_service.e"  From 'struct definition' */
typedef struct s__sn__sn_edatabrowser_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__databrowser_cache_m39917 *p_cache_manager;
} *t__sn__sn_edatabrowser_service;
#define d__sn__sn_edatabrowser_service 4730
typedef t__sn__sn_edatabrowser_service t__sn_edatabrowser_service;
#define d__sn_edatabrowser_service d__sn__sn_edatabrowser_service

/* line 188 "/vobs/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__sn__databrowser_cache_m39917 {
    t__int d__;
    t__int gen__;
    t__int curr_refreshed_root_id;
    struct s__sn__scalar_nodes_cache *scalar_nodes_cache;
    struct s__sn__non_scalar_nodes_cache *non_scalar_nodes_cache;
    t__int entries_id_fetcher;
    struct s__l__sn__cache_entry *curr_roots;
    struct s__k__int__it *ids_of_types_that_were_transfered_to_java;
    struct s__k__int__it *ids_of_type_storages_that_were_transfered_to_java;
    struct s__k__int__it *ids_of_type_details_that_were_transfered_to_java;
} *t__sn__databrowser_cache_manager;
#define d__sn__databrowser_cache_manager 4720
typedef t__sn__databrowser_cache_manager t__databrowser_cache_manager;
#define d__databrowser_cache_manager d__sn__databrowser_cache_manager

/* line 556 "/vobs/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__sn__scalar_nodes_cache {
    t__int d__;
    t__int gen__;
    struct s__k__sn__scalars_holders_39918 *all_scalar_val_nodes;
    struct s__sn__databrowser_cache_m39917 *global_cache_manager;
} *t__sn__scalar_nodes_cache;
#define d__sn__scalar_nodes_cache 4721
typedef t__sn__scalar_nodes_cache t__scalar_nodes_cache;
#define d__scalar_nodes_cache d__sn__scalar_nodes_cache

/* line 783 "/vobs/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__sn__scalars_holders {
    t__int d__;
    t__int gen__;
    t__int parent_id;
    struct s__k__sn__scalar_cache_nod39920 *all_parent_scalar_childs;
} *t__sn__scalars_holders;
#define d__sn__scalars_holders 4722
typedef t__sn__scalars_holders t__scalars_holders;
#define d__scalars_holders d__sn__scalars_holders

/* line 104 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__scalar_cache_node {
    t__int d__;
    t__int gen__;
    t__int parent_id;
    t__int child_index;
    struct s__sn__rf_value_holder_wrapper *val;
} *t__sn__scalar_cache_node;
#define d__sn__scalar_cache_node 4515
typedef t__sn__scalar_cache_node t__scalar_cache_node;
#define d__scalar_cache_node d__sn__scalar_cache_node

/* line 43 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__rf_value_holder_wrapper {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_value_holder *holder;
    struct s__reflection__rf_type *actual_type;
    t__string str_val;
} *t__sn__rf_value_holder_wrapper;
#define d__sn__rf_value_holder_wrapper 4510
typedef t__sn__rf_value_holder_wrapper t__rf_value_holder_wrapper;
#define d__rf_value_holder_wrapper d__sn__rf_value_holder_wrapper

/* line 820 "/vobs/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__sn__non_scalar_nodes_cache {
    t__int d__;
    t__int gen__;
    struct s__sn__databrowser_cache_m39917 *global_cache_manager;
    t__int id_fetcher;
    struct s__k__sn__container_cache_39923 *untyped_val_to_cache_container_cache_node;
    struct s__k__sn__null_container_c39925 *null_struct_to_container_cache_node;
    struct s__k__sn__container_cache_39926 *id_to_container_cache_node;
} *t__sn__non_scalar_nodes_cache;
#define d__sn__non_scalar_nodes_cache 4723
typedef t__sn__non_scalar_nodes_cache t__non_scalar_nodes_cache;
#define d__non_scalar_nodes_cache d__sn__non_scalar_nodes_cache

/* line 107 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__container_cache_node {
    t__int d__;
    t__int gen__;
    t__bool gc_flag;
    t__sn__node_refresh_status refresh_flag;
    t__bool should_be_refreshed_flag;
    struct s__l__sn__abs_cache_node *children;
    t__bool were_children_initialized;
    struct s__sn__rf_value_holder_wrapper *val;
    t__int id;
    t__int unique_key;
} *t__sn__container_cache_node;
#define d__sn__container_cache_node 4516
typedef t__sn__container_cache_node t__container_cache_node;
#define d__container_cache_node d__sn__container_cache_node

/* line 98 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__abs_cache_node {
    t__int d__;
    t__int gen__;
} *t__sn__abs_cache_node;
#define d__sn__abs_cache_node 4513
typedef t__sn__abs_cache_node t__abs_cache_node;
#define d__abs_cache_node d__sn__abs_cache_node

/* line 110 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__null_container_cach39876 {
    t__int d__;
    t__int gen__;
    t__bool gc_flag;
    t__sn__node_refresh_status refresh_flag;
    t__bool should_be_refreshed_flag;
    struct s__l__sn__abs_cache_node *children;
    t__bool were_children_initialized;
    struct s__sn__rf_value_holder_wrapper *val;
    t__int id;
    t__int unique_key;
    struct s__reflection__rf_type *val_type;
} *t__sn__null_container_cache_node;
#define d__sn__null_container_cache_node 4517
typedef t__sn__null_container_cache_node t__null_container_cache_node;
#define d__null_container_cache_node d__sn__null_container_cache_node

/* line 101 "/vobs/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn__cache_entry {
    t__int d__;
    t__int gen__;
    t__string s_exp;
    struct s__sn__abs_cache_node *child;
    t__int id;
    t__sn__node_refresh_status refresh_flag;
} *t__sn__cache_entry;
#define d__sn__cache_entry 4514
typedef t__sn__cache_entry t__cache_entry;
#define d__cache_entry d__sn__cache_entry

/* line 11 "/vobs/specman/src/japp/databrowser/db_evaluator.e"  From 'struct definition' */
typedef struct s__sn__sn_evaluator {
    t__int d__;
    t__int gen__;
} *t__sn__sn_evaluator;
#define d__sn__sn_evaluator 4714
typedef t__sn__sn_evaluator t__sn_evaluator;
#define d__sn_evaluator d__sn__sn_evaluator

/* line 78 "/vobs/specman/src/japp/gui/gui_user_api.e"  From 'struct definition' */
typedef struct s__vt__sn_gui_manager {
    t__int d__;
    t__int gen__;
    t__string MESSAGE_TITLE;
    t__string ERROR_TITLE;
    t__string WARNING_TITLE;
    t__string INPUT_TITLE;
    t__string QUESTION_TITLE;
    struct s__vt__sni_gui_jmanager_service *p_gui_sni;
    struct s__vt__jgui_manager_deli *p_jgui_manager_deli;
    t__string p___activity_win_id;
    t__vt__vt_bool_tristate p___activity_started_on_sn;
    t__string p___activity_name;
} *t__vt__sn_gui_manager;
#define d__vt__sn_gui_manager 4780
typedef t__vt__sn_gui_manager t__sn_gui_manager;
#define d__sn_gui_manager d__vt__sn_gui_manager

/* line 12 "/vobs/specman/src/japp/gui/gui_defs.e"  From 'struct definition' */
typedef struct s__vt__sni_gui_jmanager_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_gui_jmanager_service;
#define d__vt__sni_gui_jmanager_service 4781
typedef t__vt__sni_gui_jmanager_service t__sni_gui_jmanager_service;
#define d__sni_gui_jmanager_service d__vt__sni_gui_jmanager_service

/* line 6 "/vobs/specman/src/japp/gui/gui_manager.e"  From 'struct definition' */
typedef struct s__vt__jgui_manager_deli {
    t__int d__;
    t__int gen__;
    struct s__vt__sni_gui_jmanager_service *p_jgui_manager_service;
} *t__vt__jgui_manager_deli;
#define d__vt__jgui_manager_deli 5281
typedef t__vt__jgui_manager_deli t__jgui_manager_deli;
#define d__jgui_manager_deli d__vt__jgui_manager_deli

/* line 210 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_manager {
    t__int d__;
    t__int gen__;
    struct s__l__string *EMPTY_STRING_LIST;
    t__int m_expanded_nodes_threshold;
    struct s__vt__vt_size *DEFAULT_WINDOW_SIZE;
    struct s__vt__vt_location *DEFAULT_WINDOW_LOCATION;
    struct s__vt__vtx_factory *factory;
    struct s__k__vt__vtx_base_window__m_id *m_all_windows;
    t__int m_counter;
    struct s__vt__vtx_manager_snorb_props *m_props;
    t__bool m_props_prepared;
    struct s__vt__sni_vtx_jmanager_service *p_vtx_sni;
    struct s__k__vt__vtx_window_kind_48703 *m_hash_gui_settings;
    t__bool m_auto_save_gui_settings;
    t__bool m_gui_settings_loaded;
    struct s__vt__jvtx_manager_deli *p_jvtx_manager_deli;
    t__string GENERAL_WINDOW_KIND;
    struct s__vt__vtx_settings_manager *setman;
} *t__vt__vtx_manager;
#define d__vt__vtx_manager 5109
typedef t__vt__vtx_manager t__vtx_manager;
#define d__vtx_manager d__vt__vtx_manager

/* line 1280 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_factory {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__vtx_factory;
#define d__vt__vtx_factory 5167
typedef t__vt__vtx_factory t__vtx_factory;
#define d__vtx_factory d__vt__vtx_factory

/* line 432 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'struct definition' */
typedef struct s__vt__vtx_manager_snorb_props {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int window_header_text_area_width;
    struct s__vt__vtx_font_data *window_header_text_area_font;
    t__bool window_header_html_area_scrollable;
    t__int window_header_height;
    t__vt__vt_color window_header_background;
    t__vt__vt_color window_header_foreground;
} *t__vt__vtx_manager_snorb_props;
#define d__vt__vtx_manager_snorb_props 5206
typedef t__vt__vtx_manager_snorb_props t__vtx_manager_snorb_props;
#define d__vtx_manager_snorb_props d__vt__vtx_manager_snorb_props

/* line 1834 "/vobs/specman/src/japp/vtx/vtx_user_api.e"  From 'struct definition' */
typedef struct s__vt__vtx_font_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string name;
    t__vt__vt_font_kind style;
    t__int size;
} *t__vt__vtx_font_data;
#define d__vt__vtx_font_data 5181
typedef t__vt__vtx_font_data t__vtx_font_data;
#define d__vtx_font_data d__vt__vtx_font_data

/* line 478 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'struct definition' */
typedef struct s__vt__sni_vtx_jmanager_service {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__vt__sni_vtx_jmanager_service;
#define d__vt__sni_vtx_jmanager_service 5210
typedef t__vt__sni_vtx_jmanager_service t__sni_vtx_jmanager_service;
#define d__sni_vtx_jmanager_service d__vt__sni_vtx_jmanager_service

/* line 61 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'struct definition' */
typedef struct s__vt__vtx_window_kind_gui39964 {
    t__int d__;
    t__int gen__;
    t__string kind;
    struct s__vt__vtx_snorb_base_wind37403 *gui_settings;
} *t__vt__vtx_window_kind_gui_settings;
#define d__vt__vtx_window_kind_gui_settings 5203
typedef t__vt__vtx_window_kind_gui_settings t__vtx_window_kind_gui_settings;
#define d__vtx_window_kind_gui_settings d__vt__vtx_window_kind_gui_settings

/* line 778 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'struct definition' */
typedef struct s__vt__vtx_snorb_base_wind37403 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__vt__vt_size *size;
    struct s__vt__vt_location *location;
    struct s__l__vt__vtx_snorb_splitt39959 *splitters_data_list;
    struct s__l__vt__vtx_snorb_tabctr39961 *tabctrls_data_list;
} *t__vt__vtx_snorb_base_window_gui_settings;
#define d__vt__vtx_snorb_base_window_gui_settings 5246
typedef t__vt__vtx_snorb_base_window_gui_settings t__vtx_snorb_base_window_gui_settings;
#define d__vtx_snorb_base_window_gui_settings d__vt__vtx_snorb_base_window_gui_settings

/* line 767 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'struct definition' */
typedef struct s__vt__vtx_snorb_splitter_39962 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string splitter_id;
    t__int splitter_location;
    t__int splitter_last_location;
} *t__vt__vtx_snorb_splitter_settings;
#define d__vt__vtx_snorb_splitter_settings 5244
typedef t__vt__vtx_snorb_splitter_settings t__vtx_snorb_splitter_settings;
#define d__vtx_snorb_splitter_settings d__vt__vtx_snorb_splitter_settings

/* line 773 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'struct definition' */
typedef struct s__vt__vtx_snorb_tabctrl_s39963 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string tabctrl_id;
    t__string selected_tab_id;
} *t__vt__vtx_snorb_tabctrl_settings;
#define d__vt__vtx_snorb_tabctrl_settings 5245
typedef t__vt__vtx_snorb_tabctrl_settings t__vtx_snorb_tabctrl_settings;
#define d__vtx_snorb_tabctrl_settings d__vt__vtx_snorb_tabctrl_settings

/* line 686 "/vobs/specman/src/japp/vtx/vtx_manager.e"  From 'struct definition' */
typedef struct s__vt__jvtx_manager_deli {
    t__int d__;
    t__int gen__;
    struct s__vt__sni_vtx_jmanager_service *p_jvtx_manager_service;
} *t__vt__jvtx_manager_deli;
#define d__vt__jvtx_manager_deli 5592
typedef t__vt__jvtx_manager_deli t__jvtx_manager_deli;
#define d__jvtx_manager_deli d__vt__jvtx_manager_deli

/* line 47 "/vobs/specman/src/japp/vtx/vtx_defs.e"  From 'struct definition' */
typedef struct s__vt__vtx_settings_manager {
    t__int d__;
    t__int gen__;
    t__string TAG_WINDOW_KIND;
    t__string TAG_SPLITTERS;
    t__string TAG_TABCTRLS;
    t__string TAG_ATTRIBUTES;
} *t__vt__vtx_settings_manager;
#define d__vt__vtx_settings_manager 5201
typedef t__vt__vtx_settings_manager t__vtx_settings_manager;
#define d__vtx_settings_manager d__vt__vtx_settings_manager

/* line 349 "/vobs/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn__major_path {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_frame *curr_gen_frame;
    struct s__l__sn__gen_frame *prev_frames;
} *t__sn__major_path;
#define d__sn__major_path 5680
typedef t__sn__major_path t__major_path;
#define d__major_path d__sn__major_path

/* line 2 "/vobs/specman/src/checksum.e"  From 'struct definition' */
typedef struct s__sn__sn_checksum {
    t__int d__;
    t__int gen__;
    struct s__l__byte *checksum___non_commutative_add;
    t__int ip_specman_check___ip_char_counter;
} *t__sn__sn_checksum;
#define d__sn__sn_checksum 6662
typedef t__sn__sn_checksum t__sn_checksum;
#define d__sn_checksum d__sn__sn_checksum

/* line 10 "/vobs/specman/src/hdl_assertions_defs.e"  From 'struct definition' */
typedef struct s__sn__hdl_assertions_mgr {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__sn__sn_adapter_bridge *m_support_assert_adapters;
    t__bool m_is_search_supported_adapters;
    struct s__l__sn__hdl_assertion *m_pending_assertions;
    t__bool m_is_tick_listener_registered_in_the_cycle;
    struct s__sn__sn_hdl_assertions_t68968 *m_tick_listener;
    struct s__l__sn__hdl_assertion *m_assertions;
} *t__sn__hdl_assertions_mgr;
#define d__sn__hdl_assertions_mgr 6695
typedef t__sn__hdl_assertions_mgr t__hdl_assertions_mgr;
#define d__hdl_assertions_mgr d__sn__hdl_assertions_mgr

/* line 15 "/vobs/specman/src/hdl_assertions_defs.e"  From 'struct definition' */
typedef struct s__sn__hdl_assertion {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__external_pointer m_handle_to_assert;
    t__sn__HDL_ASSERTION_LANGUAGE m_hdl_lang;
    t__external_pointer m_handle_to_cb;
    t__int m_adapter_id;
    struct s__l__sn__hdl_assertion_cb *m_cb_handles;
    t__string m_instance_full_path;
    t__string m_instance_name;
    t__string m_file_name;
    t__int m_line_number;
    t__sn__HDL_ASSERTION_SEVERITY_LEVEL m_severity_level;
    t__int m_previous_error_count;
    t__string m_msg;
    t__bool m_is_occurred_in_this_cycle;
} *t__sn__hdl_assertion;
#define d__sn__hdl_assertion 6696
typedef t__sn__hdl_assertion t__hdl_assertion;
#define d__hdl_assertion d__sn__hdl_assertion

/* line 20 "/vobs/specman/src/hdl_assertions_defs.e"  From 'struct definition' */
typedef struct s__sn__hdl_assertion_cb {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__l__sn__cb_assertion *m_associated_assertions;
} *t__sn__hdl_assertion_cb;
#define d__sn__hdl_assertion_cb 6697
typedef t__sn__hdl_assertion_cb t__hdl_assertion_cb;
#define d__hdl_assertion_cb d__sn__hdl_assertion_cb

/* line 24 "/vobs/specman/src/hdl_assertions_defs.e"  From 'struct definition' */
typedef struct s__sn__cb_assertion {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_assertion *m_assert;
    t__bool m_is_cb_occured_in_this_cycle;
} *t__sn__cb_assertion;
#define d__sn__cb_assertion 6698
typedef t__sn__cb_assertion t__cb_assertion;
#define d__cb_assertion d__sn__cb_assertion

/* line 11 "/vobs/specman/src/hdl_assertions_mgr.e"  From 'struct definition' */
typedef struct s__sn__sn_hdl_assertions_t68968 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sn_hdl_assertions_tick_listener;
#define d__sn__sn_hdl_assertions_tick_listener 6699
typedef t__sn__sn_hdl_assertions_tick_listener t__sn_hdl_assertions_tick_listener;
#define d__sn_hdl_assertions_tick_listener d__sn__sn_hdl_assertions_tick_listener

/* line 25 "/vobs/specman/src/port_bind.e"  From 'struct definition' */
typedef struct s__sn__do_bind_utils {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__any_port *sn_do_bind_internal_list;
} *t__sn__do_bind_utils;
#define d__sn__do_bind_utils 6721
typedef t__sn__do_bind_utils t__do_bind_utils;
#define d__do_bind_utils d__sn__do_bind_utils

/* line 9 "/vobs/specman/src/port_mvl.e"  From 'struct definition' */
typedef struct s__sn__sn_mvl_literal_helper {
    t__int d__;
    t__int gen__;
    t__string raw;
    t__e_core__radix radix;
    t__string value;
    t__int size;
    t__int attributes;
    struct s__l__sn__mvl *mvl_list;
    struct s__k__sn__calculated_mvl_s68979 *calculated_mvl_strings;
} *t__sn__sn_mvl_literal_helper;
#define d__sn__sn_mvl_literal_helper 6731
typedef t__sn__sn_mvl_literal_helper t__sn_mvl_literal_helper;
#define d__sn_mvl_literal_helper d__sn__sn_mvl_literal_helper

/* line 5 "/vobs/specman/src/port_mvl.e"  From 'struct definition' */
typedef struct s__sn__calculated_mvl_string {
    t__int d__;
    t__int gen__;
    t__string str;
    struct s__l__sn__mvl *mvl_list;
} *t__sn__calculated_mvl_string;
#define d__sn__calculated_mvl_string 6730
typedef t__sn__calculated_mvl_string t__calculated_mvl_string;
#define d__calculated_mvl_string d__sn__calculated_mvl_string

/* line 98 "/vobs/specman/src/port_callbacks.e"  From 'struct definition' */
typedef struct s__sn__port_cb_manager {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__uint sn_next_port_cb_key;
    struct s__l__sn__any_port_cb_list_item *sn_global_port_cb_list;
    struct s__sn__unsaved_cb_data_simple *sn_simple_cbd;
    t__uint sn_simple_cb_depth;
    struct s__sn__unsaved_cb_data_event *sn_event_cbd;
    t__uint sn_event_cb_depth;
    struct s__k__sn__any_tick_cb_list69052 *sn_global_tick_cb_list;
    t__uint global_tcb_reason_mask;
} *t__sn__port_cb_manager;
#define d__sn__port_cb_manager 6874
typedef t__sn__port_cb_manager t__port_cb_manager;
#define d__port_cb_manager d__sn__port_cb_manager

/* line 233 "/vobs/specman/src/port_callbacks.e"  From 'struct definition' */
typedef struct s__sn__unsaved_cb_data_simple {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__e_core__any_port *cb_port;
    t__sn__cb_reason reason;
    t__bool is_mvl_op;
} *t__sn__unsaved_cb_data_simple;
#define d__sn__unsaved_cb_data_simple 6875
typedef t__sn__unsaved_cb_data_simple t__unsaved_cb_data_simple;
#define d__unsaved_cb_data_simple d__sn__unsaved_cb_data_simple

/* line 419 "/vobs/specman/src/port_callbacks.e"  From 'struct definition' */
typedef struct s__sn__unsaved_cb_data_event {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__e_core__any_port *cb_port;
} *t__sn__unsaved_cb_data_event;
#define d__sn__unsaved_cb_data_event 6877
typedef t__sn__unsaved_cb_data_event t__unsaved_cb_data_event;
#define d__unsaved_cb_data_event d__sn__unsaved_cb_data_event

/* line 57 "/vobs/specman/src/tick_callbacks.e"  From 'struct definition' */
typedef struct s__sn__any_tick_cb_list_item {
    t__int d__;
    t__int gen__;
    struct s__sn__any_tick_cb *cb;
    t__uint reasons_mask;
} *t__sn__any_tick_cb_list_item;
#define d__sn__any_tick_cb_list_item 6883
typedef t__sn__any_tick_cb_list_item t__any_tick_cb_list_item;
#define d__any_tick_cb_list_item d__sn__any_tick_cb_list_item

/* line 68 "/vobs/specman/src/port_callbacks.e"  From 'struct definition' */
typedef struct s__sn__any_tick_cb {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__any_tick_cb;
#define d__sn__any_tick_cb 6873
typedef t__sn__any_tick_cb t__any_tick_cb;
#define d__any_tick_cb d__sn__any_tick_cb

/* line 26 "/vobs/specman/src/oig_api.e"  From 'struct definition' */
typedef struct s__ovm_interface_generator68949 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_dynamic_call *oig_get_num_instances___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_inst_path_by_id___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_id_of_instance___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_field_value_int___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_field_value_string___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_dut_interface_path___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_dut_interface_id___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_array_size___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_get_field_value_long___dynamic_call;
    struct s__sn__sn_dynamic_call *oig_set_source_ref___dynamic_call;
} *t__ovm_interface_generator__oig_api;
#define d__ovm_interface_generator__oig_api 7137
typedef t__ovm_interface_generator__oig_api t__oig_api;
#define d__oig_api d__ovm_interface_generator__oig_api

/* line 13 "/vobs/specman/src/denali_unit_h.e"  From 'struct definition' */
typedef struct s__sn__sn_denali {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__k__sn__sn_denali_unit__70900 *all_sn_denali_units;
    struct s__sn__sn_denali_call_manager *denali_call_manager;
    struct s__sn__sn_denali_ddv_call_70901 *denali_ddv_call_manager;
    struct s__sn__libdenalisn_call_manager *libdenalisn_call_manager;
    t__uint cb_datasize_limit;
} *t__sn__sn_denali;
#define d__sn__sn_denali 7229
typedef t__sn__sn_denali t__sn_denali;
#define d__sn_denali d__sn__sn_denali

/* line 29 "/vobs/specman/src/denali_unit_h.e"  From 'struct definition' */
typedef struct s__sn__sn_denali_unit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_denali_add_on *add_on;
    t__string denali_unit___name;
    t__string denali_unit___type;
    t__uint denali_unit___width;
    t__uint denali_unit___wwidth;
    t__uint denali_unit___depth;
    t__uint denali_unit___id;
    t__uint denali_unit___swidth;
    t__bool denali_unit___elaborated;
    t__bool denali_unit___is_init_denali_data_done;
    t__sn__index denali_unit___access_cb_method_index;
    struct s__sn__struct_descriptor *denali_unit___den_type;
    t__long_int sn___quit_occ_l;
    struct s__sn__sn_event_struct *sn___quit_event_struct;
    t__long_int sn___access_event_occ_l;
    struct s__sn__sn_event_struct *sn___access_event_event_struct;
    struct s__sn__waiting_thread *sn___access_event_thread;
    struct s__l__sn__sn_denali_cb_dat70902 *denali_unit___cb_list;
    t__uint denali_unit___cb_num;
    t__sn__index denali_unit___access_cb_with_mask_method_index;
    t__int denali_unit___last_tick_count;
    t__bool denali_unit___sn_is_immediate_callback_enabled;
    t__bool denali_unit___sn_is_immediate_callback_with_mask_enabled;
} *t__sn__sn_denali_unit;
#define d__sn__sn_denali_unit 7231
typedef t__sn__sn_denali_unit t__sn_denali_unit;
#define d__sn_denali_unit d__sn__sn_denali_unit

/* line 25 "/vobs/specman/src/denali_unit_h.e"  From 'struct definition' */
typedef struct s__sn__sn_denali_add_on {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__sn__sn_denali_add_on;
#define d__sn__sn_denali_add_on 7230
typedef t__sn__sn_denali_add_on t__sn_denali_add_on;
#define d__sn_denali_add_on d__sn__sn_denali_add_on

/* line 1015 "/vobs/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn__sn_denali_cb_data_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__uint addr;
    t__sn__sn_denali_access_type access_type;
    t__external_pointer data_ptr;
} *t__sn__sn_denali_cb_data_item;
#define d__sn__sn_denali_cb_data_item 7243
typedef t__sn__sn_denali_cb_data_item t__sn_denali_cb_data_item;
#define d__sn_denali_cb_data_item d__sn__sn_denali_cb_data_item

/* line 189 "/vobs/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn__sn_denali_call_manager {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_dynamic_call *DENALIaccessClearCallback___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIaccessSetCallback___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIgetIdByName___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIgetInfoById___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIinitialize___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIload___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIsave___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIread___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIwrite___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIgetIds___dynamic_call;
} *t__sn__sn_denali_call_manager;
#define d__sn__sn_denali_call_manager 7239
typedef t__sn__sn_denali_call_manager t__sn_denali_call_manager;
#define d__sn_denali_call_manager d__sn__sn_denali_call_manager

/* line 88 "/vobs/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn__sn_denali_ddv_call_70901 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__external_pointer ddv_id;
    struct s__sn__sn_dynamic_call *DENALIDDVaccessClearCallback___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVgetIdByName___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVgetInfoById___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVinitialize___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVload___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVsave___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVread___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVwrite___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVgetIds___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVsetAddr___dynamic_call;
    struct s__sn__sn_dynamic_call *DENALIDDVsplitAddr___dynamic_call;
} *t__sn__sn_denali_ddv_call_manager;
#define d__sn__sn_denali_ddv_call_manager 7238
typedef t__sn__sn_denali_ddv_call_manager t__sn_denali_ddv_call_manager;
#define d__sn_denali_ddv_call_manager d__sn__sn_denali_ddv_call_manager

/* line 253 "/vobs/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn__libdenalisn_call_manager {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    struct s__sn__sn_dynamic_call *sn_denali_init___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_init_cb_data___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_setIdByName___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_setInfoById___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_read___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_read_unk___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_write___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_write_unk___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_set_sndi_by_id___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_get_all_denali_ids___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_enable_callback___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_disable_callback___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_save___dynamic_call;
    struct s__sn__sn_dynamic_call *sn_denali_load___dynamic_call;
} *t__sn__libdenalisn_call_manager;
#define d__sn__libdenalisn_call_manager 7240
typedef t__sn__libdenalisn_call_manager t__libdenalisn_call_manager;
#define d__libdenalisn_call_manager d__sn__libdenalisn_call_manager

/* line 89 "/vobs/specman/src/cap_main.e"  From 'struct definition' */
typedef struct s__sn__capture_helper {
    t__int d__;
    t__int gen__;
    struct s__e_core__file *dummy_file;
} *t__sn__capture_helper;
#define d__sn__capture_helper 7289
typedef t__sn__capture_helper t__capture_helper;
#define d__capture_helper d__sn__capture_helper

/* line 440 "/vobs/specman/src/message_action.e"  From 'struct definition' */
typedef struct s__sn__sn_message_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_message_actio70943 *message_action_handlers;
    struct s__k__sn__sn_message_action__it *actions;
    struct s__l__int *msg_action_ind;
    struct s__l__sn__sn_message_action *sorted_actions;
    struct s__k__e_core__message_logg70626 *loggers;
    struct s__l__sn__sn_message_desti70940 *destinations;
    struct s__sn__sn_screen_destination *screen_destination;
    struct s__l__sn__sn_active_logger_data *sn__active_logger_data_stack;
    struct s__l__e_core__any_unit *all_units;
    struct s__sn__method *format_message_method;
    t__bool ignore_new_line;
    struct s__l__sn__sn_message_command *set_commands;
    struct s__l__sn__sn_message_unit_info *units_info;
    struct s__l__string *current_output;
    struct s__l__string *message_logger___output;
    struct s__l__sn__sn_message_actio70943 *message_action_handlers_gc;
    struct s__l__string *message_logger___messages_gc;
    struct s__sn__sn_vt_message *vt_message;
} *t__sn__sn_message_manager;
#define d__sn__sn_message_manager 7326
typedef t__sn__sn_message_manager t__sn_message_manager;
#define d__sn_message_manager d__sn__sn_message_manager

/* line 323 "/vobs/specman/src/message_action.e"  From 'struct definition' */
typedef struct s__sn__sn_message_action_h70619 {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_active_logger_data *active_loggers_data;
    struct s__sn__sn_message_action *current_message_action;
    struct s__e_core__base_struct *current_struct;
    t__sn__sn_message_action_kind action_kind;
    struct s__int__64 *time;
    t__vt__vt_style time_style;
    t__bool light_gray;
    t__bool active_message;
    struct s__k__sn__sn_message_desti70941 *sn__visited_destinations;
} *t__sn__sn_message_action_handler;
#define d__sn__sn_message_action_handler 7324
typedef t__sn__sn_message_action_handler t__sn_message_action_handler;
#define d__sn_message_action_handler d__sn__sn_message_action_handler

/* line 743 "/vobs/specman/src/message_action.e"  From 'struct definition' */
typedef struct s__sn__sn_active_logger_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__message_logger *logger;
    struct s__l__sn__sn_message_desti70940 *destinations;
    struct s__l__string *output;
} *t__sn__sn_active_logger_data;
#define d__sn__sn_active_logger_data 7327
typedef t__sn__sn_active_logger_data t__sn_active_logger_data;
#define d__sn_active_logger_data d__sn__sn_active_logger_data

/* line 5 "/vobs/specman/src/e_core_types.e"  From 'struct definition' */
typedef struct s__int__64 {
    t__int d__;
    t__int gen__;
    struct s__l__bit *bytes;
    t__int sn_attr;
} *t__int__64;
#define d__int__64 1138

/* line 49 "/vobs/specman/src/message_action.e"  From 'struct definition' */
typedef struct s__sn__sn_screen_destination {
    t__int d__;
    t__int gen__;
    t__string name;
} *t__sn__sn_screen_destination;
#define d__sn__sn_screen_destination 7320
typedef t__sn__sn_screen_destination t__sn_screen_destination;
#define d__sn_screen_destination d__sn__sn_screen_destination

/* line 182 "/vobs/specman/src/message_logger.e"  From 'struct definition' */
typedef struct s__sn__sn_message_command {
    t__int d__;
    t__int gen__;
} *t__sn__sn_message_command;
#define d__sn__sn_message_command 7374
typedef t__sn__sn_message_command t__sn_message_command;
#define d__sn_message_command d__sn__sn_message_command

/* line 429 "/vobs/specman/src/message_action.e"  From 'struct definition' */
typedef struct s__sn__sn_message_unit_info {
    t__int d__;
    t__int gen__;
    struct s__k__e_core__message_logg70626 *message_loggers;
    t__string short_name;
    t__string short_name_path;
    t__bool name_in_cache;
    struct s__sn__sn_objection_info *evc_util_objections___objection_info;
} *t__sn__sn_message_unit_info;
#define d__sn__sn_message_unit_info 7325
typedef t__sn__sn_message_unit_info t__sn_message_unit_info;
#define d__sn_message_unit_info d__sn__sn_message_unit_info

/* line 8 "/vobs/specman/src/evc_util_objections.e"  From 'struct definition' */
typedef struct s__sn__sn_objection_info {
    t__int d__;
    t__int gen__;
    struct s__l__int *objection_counter;
    struct s__l__uint *objection_counter_total;
    t__bool quitted;
} *t__sn__sn_objection_info;
#define d__sn__sn_objection_info 7786
typedef t__sn__sn_objection_info t__sn_objection_info;
#define d__sn_objection_info d__sn__sn_objection_info

/* line 48 "/vobs/specman/src/evc_util/evc_util_message_vt.e"  From 'struct definition' */
typedef struct s__sn__sn_vt_message {
    t__int d__;
    t__int gen__;
} *t__sn__sn_vt_message;
#define d__sn__sn_vt_message 7871
typedef t__sn__sn_vt_message t__sn_vt_message;
#define d__sn_vt_message d__sn__sn_vt_message

/* line 11 "/vobs/specman/src/mm_recycle.e"  From 'struct definition' */
typedef struct s__sn__sn_recursive_reaper {
    t__int d__;
    t__int gen__;
    struct s__l__untyped *structs;
    struct s__l__untyped *lists;
    struct s__l__untyped *strings;
    t__bool check_consistency;
    struct s__k__untyped__it *structs_to_check;
    struct s__k__untyped__it *lists_to_check;
    struct s__k__untyped__it *strings_to_check;
} *t__sn__sn_recursive_reaper;
#define d__sn__sn_recursive_reaper 7401
typedef t__sn__sn_recursive_reaper t__sn_recursive_reaper;
#define d__sn_recursive_reaper d__sn__sn_recursive_reaper

/* line 32 "/vobs/specman/src/cover_model_dump.e"  From 'struct definition' */
typedef struct s__main__code_cover_manager {
    t__int d__;
    t__int gen__;
    t__bool block_cover2unicov;
    t__bool flow_cover;
    t__bool code_cover_flag;
    t__int force_cover_off;
    struct s__k__sn__code_cover_item__sref *code_cover_items;
} *t__main__code_cover_manager;
#define d__main__code_cover_manager 7633
typedef t__main__code_cover_manager t__code_cover_manager;
#define d__code_cover_manager d__main__code_cover_manager

/* line 4 "/vobs/specman/src/code_coverage.e"  From 'struct definition' */
typedef struct s__sn__code_cover_item {
    t__int d__;
    t__int gen__;
    t__source_ref sref;
    t__int counter;
    t__int id;
} *t__sn__code_cover_item;
#define d__sn__code_cover_item 7651
typedef t__sn__code_cover_item t__code_cover_item;
#define d__code_cover_item d__sn__code_cover_item

/* line 7 "/vobs/specman/src/sn_ngen.e"  From 'struct definition' */
typedef struct s__vm_ngen__sn_ngen_manager {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_dynamic_call *NGenIsActive___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenLibraryErrorMsg___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenStdErrorMessage___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenLibraryOpen___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenLibraryClose___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenGetVsofPath___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRCreateSession___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRCreateRun___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRCreateCoverageModel___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRCreateCoverageData___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRCreateFilter___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRSetSessionValue___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRSetRunValue___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRSetCoverageModelValue___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRSetCoverageDataValue___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRSetFilterValue___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenCurrentSession___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenCurrentRun___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenGetValueByKey___dynamic_call;
    struct s__sn__sn_dynamic_call *NGenSRWrite___dynamic_call;
} *t__vm_ngen__sn_ngen_manager;
#define d__vm_ngen__sn_ngen_manager 7648
typedef t__vm_ngen__sn_ngen_manager t__sn_ngen_manager;
#define d__sn_ngen_manager d__vm_ngen__sn_ngen_manager

/* line 10 "/vobs/specman/src/seq_def.e"  From 'struct definition' */
typedef struct s__sn__sn_sequence_manager {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__any_sequence75911 *all_drivers;
    t__int next_item_producer_id;
    struct s__k__sn__item_producer__p80366 *item_producers;
    struct s__sn__item_producer *default_producer;
    t__bool new_do_queue_sample_timing_default;
    struct s__e_core__any_sequence *last_sequence;
    struct s__l__sn__trace_seq_cmd *trace_cmds_msg;
    struct s__l__sn__trace_seq_cmd *trace_cmds_log;
    t__bool already_warned_about_no_driver;
    t__bool stripe_info_active;
    struct s__sn__sn_tr_seq_manager *tr_seq_mngr;
    struct s__l__sn__trace_seq_cmd *external_trace_cmds;
    t__uint vt_page_counter;
} *t__sn__sn_sequence_manager;
#define d__sn__sn_sequence_manager 7662
typedef t__sn__sn_sequence_manager t__sn_sequence_manager;
#define d__sn_sequence_manager d__sn__sn_sequence_manager

/* line 1832 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__trace_seq_cmd {
    t__int d__;
    t__int gen__;
    t__bool mode;
    t__string wildcard;
} *t__sn__trace_seq_cmd;
#define d__sn__trace_seq_cmd 7728
typedef t__sn__trace_seq_cmd t__trace_seq_cmd;
#define d__trace_seq_cmd d__sn__trace_seq_cmd

/* line 5070 "/vobs/specman/src/sequence_imp.e"  From 'struct definition' */
typedef struct s__sn__sn_tr_seq_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_sequence_tr_e80363 *tr_ext_infos_bank;
} *t__sn__sn_tr_seq_manager;
#define d__sn__sn_tr_seq_manager 7737
typedef t__sn__sn_tr_seq_manager t__sn_tr_seq_manager;
#define d__sn_tr_seq_manager d__sn__sn_tr_seq_manager

/* line 75 "/vobs/specman/src/erm_package.e"  From 'struct definition' */
typedef struct s__sn__sn_evc_util {
    t__int d__;
    t__int gen__;
    struct s__k__sn__sn_erm_package_d80378 *loaded_erm_packages;
    struct s__k__sn__sn_erm_package_d80380 *all_erm_packages;
    struct s__l__sn__sn_library_descriptor *all_libraries_on_disk;
    struct s__l__sn__any_env *all_envs;
    t__bool evc_util_package___get_all_erm_libraries_for_the_first_time;
    struct s__sn__sn_stripe_manager *stripe_manager;
    t__int number_of_modules_before_gen;
} *t__sn__sn_evc_util;
#define d__sn__sn_evc_util 7676
typedef t__sn__sn_evc_util t__sn_evc_util;
#define d__sn_evc_util d__sn__sn_evc_util

/* line 23 "/vobs/specman/src/evc_util_package.e"  From 'struct definition' */
typedef struct s__sn__any_env {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__int root___instance_id;
    t__string root___e_path;
    t__string root___full_hdl_path;
    t__string root___converted_full_hdl_path;
    t__string root___normal_hdl_path;
    t__int root___relative_id;
    t__bool root___is_instance_info_created;
    struct s__sn__sn_adapter_bridge *atomic_exp___adapter_struct;
    struct s__sn__sn_unit_attributes *atomic_exp___attributes;
    struct s__e_core__any_unit *atomic_exp___parent_unit;
    struct s__l__e_core__any_unit *atomic_exp___enclosing_list;
    struct s__sn__sn_erm_package_descri480 *evc_util_package___descriptor;
} *t__sn__any_env;
#define d__sn__any_env 7689
typedef t__sn__any_env t__any_env;
#define d__any_env d__sn__any_env

/* line 220 "/vobs/specman/src/vt_util/vt_util_env.e"  From 'struct definition' */
typedef struct s__sn__sn_stripe_manager {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_stripe_env *visual_envs;
    t__uint stripes_global_index;
} *t__sn__sn_stripe_manager;
#define d__sn__sn_stripe_manager 7878
typedef t__sn__sn_stripe_manager t__sn_stripe_manager;
#define d__sn_stripe_manager d__sn__sn_stripe_manager

/* line 647 "/vobs/specman/src/vt_util/vt_util_env.e"  From 'struct definition' */
typedef struct s__sn__sn_stripe_env {
    t__int d__;
    t__int gen__;
    struct s__l__sn__sn_stripe_container *stripe_containers;
    struct s__sn__any_env *my_env;
    t__uint counter;
} *t__sn__sn_stripe_env;
#define d__sn__sn_stripe_env 7885
typedef t__sn__sn_stripe_env t__sn_stripe_env;
#define d__sn_stripe_env d__sn__sn_stripe_env

/* line 254 "/vobs/specman/src/vt_util/vt_util_env.e"  From 'struct definition' */
typedef struct s__sn__sn_stripe_container {
    t__int d__;
    t__int gen__;
    t__string name;
    struct s__l__e_core__any_sequence_item *st_list;
    t__bool show;
} *t__sn__sn_stripe_container;
#define d__sn__sn_stripe_container 7879
typedef t__sn__sn_stripe_container t__sn_stripe_container;
#define d__sn_stripe_container d__sn__sn_stripe_container

/* line 69 "/vobs/specman/src/evc_util_objections.e"  From 'struct definition' */
typedef struct s__sn__sn_objection_manager {
    t__int d__;
    t__int gen__;
    t__bool trace;
    t__string trace_prefix;
    struct s__l__sn__objection_kind *objection_kinds;
} *t__sn__sn_objection_manager;
#define d__sn__sn_objection_manager 7787
typedef t__sn__sn_objection_manager t__sn_objection_manager;
#define d__sn_objection_manager d__sn__sn_objection_manager

/* line 9 "/vobs/specman/src/vt_util/vt_util_logic.e"  From 'struct definition' */
typedef struct s__sn__vt_util {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__any_unit *all_units;
} *t__sn__vt_util;
#define d__sn__vt_util 7875
typedef t__sn__vt_util t__vt_util;
#define d__vt_util d__sn__vt_util

/* line 9 "/vobs/specman/src/vt_util/edoc_definitions.e"  From 'struct definition' */
typedef struct s__sn__edoc {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_write_doc_options *user_options;
    struct s__l__reflection__rf_erm_p75752 *packages;
    struct s__l__reflection__rf_module *modules;
    struct s__l__reflection__rf_struct *structs;
    struct s__l__reflection__rf_struct *units;
    struct s__l__sn__rf_sequence *sequences;
    struct s__l__reflection__rf_enum *enums;
    struct s__l__reflection__rf_type *types;
    struct s__l__reflection__rf_type *method_types;
    struct s__l__sn__edoc_html_page_b80455 *all_pages;
    t__bool show_struct_flag;
    t__bool developer_flag;
    struct s__l__uint *tree_stack;
} *t__sn__edoc;
#define d__sn__edoc 7925
typedef t__sn__edoc t__edoc;
#define d__edoc d__sn__edoc

/* line 41 "/vobs/specman/src/vt_util/edoc_definitions.e"  From 'struct definition' */
typedef struct s__sn__sn_write_doc_options {
    t__int d__;
    t__int gen__;
    t__string write_doc_cmd;
    t__bool load_order;
    t__string path;
    t__string dir;
    t__bool overwrite;
    t__bool no_show;
    t__bool detail;
    t__bool f__public;
    t__bool f__protected;
    t__bool package;
    t__bool f__private;
    struct s__l__string *packages_modules_names;
    t__string f__struct;
    t__string html_full_path;
} *t__sn__sn_write_doc_options;
#define d__sn__sn_write_doc_options 7926
typedef t__sn__sn_write_doc_options t__sn_write_doc_options;
#define d__sn_write_doc_options d__sn__sn_write_doc_options

/* line 43 "/vobs/specman/src/vt_util/edoc_definitions.e"  From 'struct definition' */
typedef struct s__sn__edoc_html_page_builder {
    t__int d__;
    t__int gen__;
    t__string file_name;
} *t__sn__edoc_html_page_builder;
#define d__sn__edoc_html_page_builder 7927
typedef t__sn__edoc_html_page_builder t__edoc_html_page_builder;
#define d__edoc_html_page_builder d__sn__edoc_html_page_builder

/* line 54 "/vobs/specman/src/weak_ref.e"  From 'struct definition' */
typedef struct s__sn_wr__sn_wr_manager {
    t__int d__;
    t__int gen__;
    struct s__l__e_core__sn_weak_map *tables;
} *t__sn_wr__sn_wr_manager;
#define d__sn_wr__sn_wr_manager 8025
typedef t__sn_wr__sn_wr_manager t__sn_wr_manager;
#define d__sn_wr_manager d__sn_wr__sn_wr_manager

/* line 234 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__sn__exception {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_exception_data *item;
} *t__sn__exception;
#define d__sn__exception 414
typedef t__sn__exception t__exception;
#define d__exception d__sn__exception

/* line 62 "/vobs/specman/src/ea/erm/ea_sn_ea_com.e"  From 'struct definition' */
typedef struct s__sn__ea_sn_ea_s {
    t__int d__;
    t__int gen__;
    t__sn__ea_sn_ea_state_e state_;
    t__string comf_;
    t__bool has_parsing_err_;
    t__bool has_cl_err_;
    t__int exit_status_;
    t__bool error_emitted_;
} *t__sn__ea_sn_ea_s;
#define d__sn__ea_sn_ea_s 8935
typedef t__sn__ea_sn_ea_s t__ea_sn_ea_s;
#define d__ea_sn_ea_s d__sn__ea_sn_ea_s

/* line 49 "/vobs/specman/src/comm_async_interface.e"  From 'struct definition' */
typedef struct s__sn__comm_async_manager {
    t__int d__;
    t__int gen__;
} *t__sn__comm_async_manager;
#define d__sn__comm_async_manager 9103
typedef t__sn__comm_async_manager t__comm_async_manager;
#define d__comm_async_manager d__sn__comm_async_manager

/* line 14 "/vobs/specman/src/gtx_plugin_mgr.e"  From 'struct definition' */
typedef struct s__gtx__gtx_plugin_manager {
    t__int d__;
    t__int gen__;
    t__string m_str_result;
    t__int m_log_mark_counter;
    t__string m_last_log_mark;
    t__bool m_is_active;
} *t__gtx__gtx_plugin_manager;
#define d__gtx__gtx_plugin_manager 9108
typedef t__gtx__gtx_plugin_manager t__gtx_plugin_manager;
#define d__gtx_plugin_manager d__gtx__gtx_plugin_manager

/* line 253 "/vobs/specman/src/gtx_plugin_mgr.e"  From 'struct definition' */
typedef struct s__gtx__gtx_manager {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
} *t__gtx__gtx_manager;
#define d__gtx__gtx_manager 9110
typedef t__gtx__gtx_manager t__gtx_manager;
#define d__gtx_manager d__gtx__gtx_manager

/* line 7 "/vobs/specman/src/ml_ovm_utils.e"  From 'struct definition' */
typedef struct s__ml_ovm__ml_ovm {
    t__int d__;
    t__int gen__;
} *t__ml_ovm__ml_ovm;
#define d__ml_ovm__ml_ovm 9123
typedef t__ml_ovm__ml_ovm t__ml_ovm;
#define d__ml_ovm d__ml_ovm__ml_ovm

/* line 857 "/vobs/specman/src/run_flow_notify.e"  From 'struct definition' */
typedef struct s__sn__error_data {
    t__int d__;
    t__int gen__;
    struct s__e_core__base_struct *obj;
    t__string msg;
    t__source_ref sref;
} *t__sn__error_data;
#define d__sn__error_data 9376
typedef t__sn__error_data t__error_data;
#define d__error_data d__sn__error_data

/* line 15 "/vobs/specman/src/c_unit_tree_manager.e"  From 'struct definition' */
typedef struct s__sn__sn_c_unit_tree_manager {
    t__int d__;
    t__int gen__;
} *t__sn__sn_c_unit_tree_manager;
#define d__sn__sn_c_unit_tree_manager 9385
typedef t__sn__sn_c_unit_tree_manager t__sn_c_unit_tree_manager;
#define d__sn_c_unit_tree_manager d__sn__sn_c_unit_tree_manager

/* line 21 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__sn_matlab_double_s {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool is_double;
    t__bool is_int64;
    t__uint low;
    t__uint high;
} *t__main__sn_matlab_double_s;
#define d__main__sn_matlab_double_s 9406
typedef t__main__sn_matlab_double_s t__sn_matlab_double_s;
#define d__sn_matlab_double_s d__main__sn_matlab_double_s

/* line 27 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__sn_matlab_complex_s {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__bool is_complex;
    t__bool is_double;
    t__bool is_int64;
    struct s__main__sn_matlab_double_s *r;
    struct s__main__sn_matlab_double_s *i;
} *t__main__sn_matlab_complex_s;
#define d__main__sn_matlab_complex_s 9407
typedef t__main__sn_matlab_complex_s t__sn_matlab_complex_s;
#define d__sn_matlab_complex_s d__main__sn_matlab_complex_s

/* line 51 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__matlab_mx_array_s {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string name;
    t__main__matlab_class_id_t its_class;
    t__bool is_complex;
    t__uint rows;
    t__uint cols;
    t__uint mx_ptr;
    t__uint mx_ptr_upper;
} *t__main__matlab_mx_array_s;
#define d__main__matlab_mx_array_s 9408
typedef t__main__matlab_mx_array_s t__matlab_mx_array_s;
#define d__matlab_mx_array_s d__main__matlab_mx_array_s

/* line 70 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__sn_matlab_var_s {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__string name;
    t__main__matlab_class_id_t its_class;
    t__bool is_complex;
    struct s__l__uint *r_data;
    struct s__l__uint *i_data;
    struct s__main__matlab_mx_array_s *mx_arr;
} *t__main__sn_matlab_var_s;
#define d__main__sn_matlab_var_s 9409
typedef t__main__sn_matlab_var_s t__sn_matlab_var_s;
#define d__sn_matlab_var_s d__main__sn_matlab_var_s

/* line 91 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__matlab_ifc_s {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit *root___unit;
    t__main__matlab_rc_t last_rc;
    t__string last_msg;
    t__uint state;
    t__bool dbg_flag;
    t__bool cdbg_flag;
    t__external_pointer eng;
    struct s__l__main__matlab_mx_array_s *mx_ptrs;
    struct s__main__matlab_mx_array_s *mxc;
    struct s__main__matlab_mx_array_s *mxr;
    struct s__main__matlab_mx_array_s *mxcd;
    struct s__main__matlab_mx_array_s *mxrd;
} *t__main__matlab_ifc_s;
#define d__main__matlab_ifc_s 9410
typedef t__main__matlab_ifc_s t__matlab_ifc_s;
#define d__matlab_ifc_s d__main__matlab_ifc_s

/* line 122 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__n__matlab_cmds_c103660 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__main__n__matlab_cmds_cmd__command;
#define d__main__n__matlab_cmds_cmd__command 9395
typedef t__main__n__matlab_cmds_cmd__command t__n__matlab_cmds_cmd__command;
#define d__n__matlab_cmds_cmd__command d__main__n__matlab_cmds_cmd__command

/* line 125 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__n__matlab_dbg_on103661 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__main__n__matlab_dbg_on__command;
#define d__main__n__matlab_dbg_on__command 9396
typedef t__main__n__matlab_dbg_on__command t__n__matlab_dbg_on__command;
#define d__n__matlab_dbg_on__command d__main__n__matlab_dbg_on__command

/* line 132 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__n__matlab_dbg_of103662 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
} *t__main__n__matlab_dbg_off__command;
#define d__main__n__matlab_dbg_off__command 9397
typedef t__main__n__matlab_dbg_off__command t__n__matlab_dbg_off__command;
#define d__n__matlab_dbg_off__command d__main__n__matlab_dbg_off__command

/* line 139 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__n__matlab_cmds_a103663 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int sn_attr;
    struct s__sn__scope *scope;
    struct s__sn__method *method;
    t__int level;
    struct s__sn__st_action *st_action;
} *t__main__n__matlab_cmds_action__action;
#define d__main__n__matlab_cmds_action__action 9398
typedef t__main__n__matlab_cmds_action__action t__n__matlab_cmds_action__action;
#define d__n__matlab_cmds_action__action d__main__n__matlab_cmds_action__action

/* line 142 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__n__matlab_cmds_e103664 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int sn_attr;
    struct s__sn__st_exp *st_exp;
    struct s__sn__scope *scope;
    struct s__sn__type_descriptor *base_type;
    t__sn__exp_kind kind;
    t__string code;
} *t__main__n__matlab_cmds_exp__exp;
#define d__main__n__matlab_cmds_exp__exp 9399
typedef t__main__n__matlab_cmds_exp__exp t__n__matlab_cmds_exp__exp;
#define d__n__matlab_cmds_exp__exp d__main__n__matlab_cmds_exp__exp

/* line 145 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__n__matlab_dbg_on103665 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int sn_attr;
    struct s__sn__scope *scope;
    struct s__sn__method *method;
    t__int level;
    struct s__sn__st_action *st_action;
} *t__main__n__matlab_dbg_on__action;
#define d__main__n__matlab_dbg_on__action 9400
typedef t__main__n__matlab_dbg_on__action t__n__matlab_dbg_on__action;
#define d__n__matlab_dbg_on__action d__main__n__matlab_dbg_on__action

/* line 152 "/home/jangook/shr_sn_matlab/e/matlab.e"  From 'struct definition' */
typedef struct s__main__n__matlab_dbg_of103666 {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    struct s__e_core__reparse_source_ref *reparse_source_ref;
    struct s__sn__ntv_extra *x;
    t__int sn_attr;
    struct s__sn__scope *scope;
    struct s__sn__method *method;
    t__int level;
    struct s__sn__st_action *st_action;
} *t__main__n__matlab_dbg_off__action;
#define d__main__n__matlab_dbg_off__action 9401
typedef t__main__n__matlab_dbg_off__action t__n__matlab_dbg_off__action;
#define d__n__matlab_dbg_off__action d__main__n__matlab_dbg_off__action

/* line 484 "/vobs/specman/src/tcm.e"  From 'struct definition' */
typedef struct s__sn__ref_field {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_value_holder *value_holder;
    struct s__sn__field *field;
} *t__sn__ref_field;
#define d__sn__ref_field 1540
typedef t__sn__ref_field t__ref_field;
#define d__ref_field d__sn__ref_field

/* line 505 "/vobs/specman/src/tcm.e"  From 'struct definition' */
typedef struct s__sn__ref_item {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_value_holder *value_holder;
    t__int item_index;
} *t__sn__ref_item;
#define d__sn__ref_item 1541
typedef t__sn__ref_item t__ref_item;
#define d__ref_item d__sn__ref_item

/* line 2264 "/vobs/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__sn__ref_param {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_value_holder *value_holder;
} *t__sn__ref_param;
#define d__sn__ref_param 544
typedef t__sn__ref_param t__ref_param;
#define d__ref_param d__sn__ref_param

/* line 100 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__sn__sn_err_warning {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int index;
    t__sn__severity severity;
    t__string message;
    struct s__l__string *params_types;
} *t__sn__sn_err_warning;
#define d__sn__sn_err_warning 387
typedef t__sn__sn_err_warning t__sn_err_warning;
#define d__sn_err_warning d__sn__sn_err_warning

/* line 560 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn__long_descriptor {
    t__int d__;
    t__int gen__;
    t__source_ref source_ref;
    t__string name;
    t__int _size_in_bytes;
    t__sn__short_type short_type;
    t__bool _debug;
    t__string _c_name;
    t__string predefined_declaration;
    struct s__sn__ExplicitTypeName *explicit_type_name;
    t__int d_index;
    struct s__sn__interval_set *set;
    struct s__l__sn__type_layer *layers;
    struct s__l__sn__type_descriptor *derived_types;
    t__int size_in_bits;
    struct s__sn__any_rl *universal_rl;
    struct s__sn__rf_structural_element *rf_object_;
    t__sn__sn_export_qualified export_qualified;
    struct s__sn__sn_mem_stats *live_stats;
    struct s__sn__sn_mem_stats *dead_stats;
    t__int from;
    t__int to;
    struct s__k__sn__field__short_name *fields;
    struct s__l__sn__field *all_when_fields;
    struct s__l__sn__method *methods;
    struct s__l__sn__field *init_fields;
    struct s__sn__struct_descriptor *parent;
    struct s__l__sn__struct_descriptor *children;
    t__bool need_call_init;
    t__bool instantiated;
    t__bool deep_copy_required;
    t__bool has_const_determinant;
    struct s__sn__any_struct_info *any_struct_info;
    struct s__sn__when_tree_node *tree_root;
    struct s__sn__type_descriptor *base_type;
    t__bool is_signed;
    void *_sgi___ptr_padding[4];
    int _sgi___int_padding[2];
    struct s__sn__sd_gen_info *sgi;
    void *_if_helper___ptr_padding[1];
    struct s__sn__interface_functor_helper *if_helper;
} *t__sn__long_descriptor;
#define d__sn__long_descriptor 180
typedef t__sn__long_descriptor t__long_descriptor;
#define d__long_descriptor d__sn__long_descriptor

/* line 16 "/vobs/specman/src/num.e"  From 'H code' */
#define BASE_TYPE(_exp) (MY(_exp)->base_type)
#define MY_ELEM_TYPE(_ntv) ELEM_TYPE(MY(_ntv)->base_type)

/* line 13 "/vobs/specman/src/basic_action.e"  From 'H code' */
SN_EXTERNAL t__global the_global_struct;
/* line 1803 "/vobs/specman/src/basic_action.e"  From 'H code' */
#define EVAL(_type, _exp) ((_type)(intptr_t)DISPATCH1(eval,_exp->st_exp, st_exp))
#define GLOB_CAR ((GLOB->CAR))
#define CAR_VALUE64(_local) (*car_value_64((t__local)_local))
#define CAR_VALUE32(_local) (*car_value_32((t__local)_local))
#define RHS_CAR_VALUE(_local) (IS_A_PLIST_ELEM(_local->base_type)?  CAR_VALUE64(_local) : (intptr_t)CAR_VALUE32(_local)) 
#define ON_AR_VALUE64(_local) (*on_ar_value_64(_local))
#define ON_AR_VALUE32(_local) (*on_ar_value_32(_local))
#define RHS_ON_AR_VALUE(_local) (IS_A_PLIST_ELEM(_local->base_type)? ON_AR_VALUE64(_local) : ON_AR_VALUE32(_local))
#define GLOB_DBG_AR ((t__activation_record)((t__sn_dbg)GLOB_DBG)->activation_record)
#define GLOB_MASK(_e) (GLOB_MASK1(_e->size_in_bits))
#define DIFF_BIT_SIZE(_a,_b) ((_a) != (_b))
#define WAS_SPECIFIED(_exp) (STRUCT_TYPE(_exp)->d__ != d__nt_descriptor)
      /* Was specified here (not empty) */
#define SET_CODE(_s) if (!load_in_progress) me->code = (_s)
      /* Sets the code the requested value */
#define MAX_ROUTINE_PARAMS 15  
#define IS_CALL_EXP(exp) ((exp)->kind == exp_kind__call)

SN_EXTERNC intptr_t *ar_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,activation_record)),SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
SN_EXTERNC intptr_t *car_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
int *ar_value_32();
int *car_value_32();
SN_EXTERNC intptr_t *on_ar_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
int *on_ar_value_32();
t__untyped call_anything();
void sn_show_source();
void sn_show_source_item();
SN_EXTERNC t__module source_item_module(t__source_item);

/*  -- get_file_contents0(SN_STRING fname, bool give_error, bool chached)
    -- returns an object with the file contents, either
    -- chached or not, depending on the 'cached' parameter
*/
t__file_contents get_file_contents0();

void change_exp();


/* line 2 "/vobs/specman/src/tcm_eval_basic.e"  From 'H code' */

/* temporary kludge*/
typedef SN_TYPE(script_instance) SN_TYPE(sn_tcm_frame);


/* line 31 "/vobs/specman/src/flow_control.e"  From 'H code' */
#define ACTION_BLOCK_DEBUG(_ntv) \
    {if (GLOB_DBG->watch_steps && \
        _ntv->method != NULL && \
        GLOB_DBG->status == on_status__normal) { \
            action_debug((SN_NTF(action))_ntv); }}
/* line 11 "/vobs/specman/src/action.e"  From 'H code' */
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_sort_type)) sn_get_sort_type(SN_TYPE(SN_QUALIFIED_NAME(sn,type_descriptor)));    
SN_EXTERNC void sn_plist_key_insert_helper _SN_ANSI_ARGS_((t__plist, int, SN_UNTYPED));
SN_EXTERNC t__untyped plist_key_delete_helper _SN_ANSI_ARGS_((t__plist, int));
SN_EXTERNC t__string sn_str_to_re _SN_ANSI_ARGS_((t__string));    
SN_EXTERNC SN_STRING str_replace _SN_ANSI_ARGS_((SN_STRING, SN_STRING, SN_STRING, int));
SN_EXTERNC t__module sn_srcref_module _SN_ANSI_ARGS_ ((t__source_ref));
SN_EXTERNC SN_STRING get_struct_path_string _SN_ANSI_ARGS_((void));    
SN_EXTERNC SN_STRING sn_get_the_error _SN_ANSI_ARGS_((void));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) sn_get_or_create_list_descriptor _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,type_descriptor)), SN_TYPE(source_ref)));    
SN_EXTERNC SN_STRING struct_to_string _SN_ANSI_ARGS_((t__base_struct));    
SN_EXTERNC SN_STRING sim_safe_specman_command _SN_ANSI_ARGS_((SN_STRING, bool));
SN_EXTERNC SN_STRING safe_specman_command _SN_ANSI_ARGS_((SN_STRING, bool));
SN_EXTERNC SN_STRING sn_str_add_dots _SN_ANSI_ARGS_((SN_STRING));   
SN_EXTERNC SN_STRING source_item_full _SN_ANSI_ARGS_((t__source_item));    
SN_EXTERNC SN_STRING sn_str_pad_ch _SN_ANSI_ARGS_((SN_STRING, int, SN_STRING));    
SN_EXTERNC t__string sn_str_pad  _SN_ANSI_ARGS_((t__string,t__int));
SN_EXTERNC t__module source_item_module _SN_ANSI_ARGS_((t__source_item));    
SN_EXTERNC SN_STRING sn_get_dut_msg _SN_ANSI_ARGS_((t__bool, t__plist));   
SN_EXTERNC void sn_intf_assign (SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) make_new_long _SN_ANSI_ARGS_((t__int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) get_temp_long _SN_ANSI_ARGS_((t__int));

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_int2long _SN_ANSI_ARGS_((int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_uint2long _SN_ANSI_ARGS_((unsigned int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_float2long _SN_ANSI_ARGS_((double));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) float2long _SN_ANSI_ARGS_((float));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_inc2long(SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_dec2long(SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_assign_ret _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_sub2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(bool)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_add_uint_int2long _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_uint_int2long _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult_uint_int2long _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div_uint_int2long _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod_uint_int2long _SN_ANSI_ARGS_((t__uint,int));

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and_uint_int2long _SN_ANSI_ARGS_((t__uint,int));

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or_uint_int2long _SN_ANSI_ARGS_((t__uint,int));

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_int2long _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_long2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_uint2long _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_ints2long _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_uints2long _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_int_uint2long _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor_uint_int2long _SN_ANSI_ARGS_((t__uint,int));

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__uint sn_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__int sn_double2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_double2bool _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_sub_long2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mult2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_div2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_mod2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_minus_long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_bit_not_long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_log2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(int) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_and2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_or2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_xor2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_abs2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_shift_right _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_shift_left _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), int ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_vec_from_hex_str _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_STRING));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_vec_get_vec _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(int), SN_TYPE(int), sn_bool ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_vec_get_vec_fast _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(int), SN_TYPE(int), sn_bool ));
SN_EXTERNC void sn_vec_put_vec _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(int), SN_TYPE(int), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_vec_get_from_lbit _SN_ANSI_ARGS_((SN_TYPE(ilist), SN_TYPE(int), SN_TYPE(int), sn_bool ));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_vec_get_from_lbyte _SN_ANSI_ARGS_((SN_TYPE(ilist), SN_TYPE(int), SN_TYPE(int), sn_bool ));
SN_EXTERNC void sn_put_vec_in_packed_list _SN_ANSI_ARGS_((SN_TYPE(ilist), SN_TYPE(int), SN_TYPE(int), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) ));
SN_EXTERNC void sn_put_vec_in_byte_list _SN_ANSI_ARGS_((SN_TYPE(ilist), SN_TYPE(int), SN_TYPE(int), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC int source_item_line _SN_ANSI_ARGS_((SN_TYPE(source_item)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,activation_record)) get_activation_record _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,method))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,activation_record)) get_on_eval_AR _SN_ANSI_ARGS_((void));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,type_descriptor)) new_higher_type _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,type_descriptor)), SN_TYPE(SN_QUALIFIED_NAME(sn,type_descriptor))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,field)) get_global _SN_ANSI_ARGS_((SN_STRING));
SN_EXTERNC SN_TYPE(base_struct) as_a_child_of _SN_ANSI_ARGS_((SN_TYPE(base_struct), int));
SN_EXTERNC SN_STRING sn_error_message _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,ntv))));
SN_EXTERNC SN_STRING add_file_type _SN_ANSI_ARGS_((SN_STRING, SN_STRING, bool));
SN_EXTERNC SN_STRING check_file_type _SN_ANSI_ARGS_((SN_STRING, SN_STRING, bool));
SN_EXTERNC SN_STRING sn_new_temp_file _SN_ANSI_ARGS_ ((void));
SN_EXTERNC SN_STRING sn_new_temp_file_key _SN_ANSI_ARGS_ ((void));
SN_EXTERNC SN_STRING sn_get_temp_dir _SN_ANSI_ARGS_((void));
SN_EXTERNC SN_STRING new_local_name _SN_ANSI_ARGS_((void));
SN_EXTERNC SN_TYPE(base_struct) make_new_helper0 _SN_ANSI_ARGS_((int));
SN_EXTERNC SN_TYPE(base_struct) make_new_helper1 _SN_ANSI_ARGS_((int));
SN_EXTERNC SN_TYPE(base_struct) read_struct _SN_ANSI_ARGS_((SN_STRING, bool, bool));
SN_EXTERNC SN_STRING file_extension _SN_ANSI_ARGS_((SN_STRING));
SN_EXTERNC SN_STRING file_dir _SN_ANSI_ARGS_((SN_STRING));
SN_EXTERNC void sn_error_backtrack _SN_ANSI_ARGS_((char *, ...));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_str2long _SN_ANSI_ARGS_((SN_STRING));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_vec_copy _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) me));
SN_EXTERNC SN_STRING sn_append_numbered_strings _SN_ANSI_ARGS_((SN_STRING, int, SN_STRING *));
SN_EXTERNC SN_STRING get_file_name _SN_ANSI_ARGS_((SN_STRING)); 
SN_EXTERNC SN_STRING sn_source_item_lines_as_string _SN_ANSI_ARGS_((SN_TYPE(source_item)));
SN_EXTERNC t__local sn_get_local(SN_STRING,t__type_descriptor);
SN_EXTERNC void sn_set_memory  _SN_ANSI_ARGS_ ((t__untyped,t__untyped));
SN_EXTERNC void sn_set_memory_32  _SN_ANSI_ARGS_ ((t__untyped,int));
SN_EXTERNC SN_STRING sn_create_method_type _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,method))));
SN_EXTERNC int empty_routine();
SN_EXTERNC void add_ntv(t__ntv, SN_STRING, t__form, t__ntv *, int, SN_TYPE(sub_nt), bool);
SN_EXTERNC void reparse(t__ntv, SN_STRING);
SN_EXTERNC void sn_assign(t__sn_vec, t__sn_vec);
SN_EXTERNC void sn_intf_assign(t__sn_vec, t__sn_vec);
SN_EXTERNC void exception_for_c_code(char *, ...);
SN_EXTERNC void sn_assign_int2long(t__sn_vec, int);
SN_EXTERNC t__bool is_str_long(SN_STRING);
SN_EXTERNC t__int sn_long2int(t__sn_vec);
SN_EXTERNC t__bool sn_gt2long(t__sn_vec, t__sn_vec);
SN_EXTERNC void generic_do_clean(t__ntv);
SN_EXTERNC t__uint sn_long2uint(t__sn_vec);
SN_EXTERNC bool index_is_a_child_of(int, int);
SN_EXTERNC bool index_is_a_child_of(int, int);
SN_EXTERNC bool sn_internal_child_of(int, int);
SN_EXTERNC void sn_register_statics__prepare_c (void);
SN_EXTERNC void sn_ntv_extra_dec_reparse_depth(t__ntv_extra);
SN_EXTERNC void action_debug(t__n__action);
bool sn_method_is_untraceable(t__method me);
SN_EXTERNC void sn_not_loadable(SN_STRING);
SN_EXTERNC void sn_check_list(t__n__exp, bool);
SN_EXTERNC int  packed_list_item(t__ilist, int);
SN_EXTERNC int packed_list_item(t__ilist, int);
SN_EXTERNC void sn_set_print_flag(bool);
SN_EXTERNC void sn_check_const_field_assignement(t__base_struct instance, t__field cf, t__untyped value, bool allow_determinant_reassign);
SN_EXTERNC void *sn_list_hash_total_size(t__ilist);
SN_EXTERNC void make_new_helper2(t__base_struct);
SN_EXTERNC void write_struct(SN_STRING, t__base_struct);
SN_EXTERNC bool sn_file_exists(SN_STRING);
SN_EXTERNC bool sn_file_is_readable(SN_STRING);
SN_EXTERNC bool sn_file_is_temp(SN_STRING);
SN_EXTERNC bool sn_file_is_dir(SN_STRING);
SN_EXTERNC bool sn_file_is_link(SN_STRING);
SN_EXTERNC bool sn_file_is_regular(SN_STRING);
SN_EXTERNC bool sn_file_is_text(SN_STRING);
SN_EXTERNC int sn_file_age(SN_STRING);
SN_EXTERNC int sn_file_size(SN_STRING);
SN_EXTERNC void file_delete(SN_STRING);
SN_EXTERNC void file_append(SN_STRING, SN_STRING);
SN_EXTERNC void file_copy(SN_STRING, SN_STRING);
SN_EXTERNC void file_rename(SN_STRING, SN_STRING);
SN_EXTERNC void log_off(bool);
SN_EXTERNC void log_on(SN_STRING, bool);
SN_EXTERNC int my_system(SN_STRING);
SN_EXTERNC void do_gc_if_needed(bool);
SN_EXTERNC void specman_command_loop(bool, bool);
SN_EXTERNC void print_list(SN_TYPE(plist));
SN_EXTERNC void sn_show(SN_STRING);
SN_EXTERNC t__bool in_good_module(t__source_item);
SN_EXTERNC void sn_print_next(bool, int);
SN_EXTERNC void on_abort_routine(t__sn_dbg);
SN_EXTERNC void C_set_traceable_by_default(bool);
SN_EXTERNC bool C_get_traceable_by_default(void);
SN_EXTERNC void redo_from_file(SN_STRING);
SN_EXTERNC void sn_remove_temp_dir(void);
SN_EXTERNC void add_ntv_list(t__ntv, SN_STRING, SN_STRING, t__form, int, SN_TYPE(sub_nt), SN_STRING);
SN_EXTERNC SN_STRING sn_ntv_get_submatch(t__ntv me, SN_STRING name);

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_int2double _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_uint2double _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_double2int _SN_ANSI_ARGS_(( SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_ints2double _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_uints2double _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_int_uint2double _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_uint_int2double _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_longs2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_int_long2double _SN_ANSI_ARGS_((int,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_long_int2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_long_uint2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_add_uint_long2double _SN_ANSI_ARGS_((t__uint,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_int2double _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_double2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_uint2double _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_ints2double _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_uints2double _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_int_uint2double _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_uint_int2double _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_longs2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_int_long2double _SN_ANSI_ARGS_((int,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_long_int2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_uint_long2double _SN_ANSI_ARGS_((t__uint,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub_long_uint2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sub2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_int2double _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_uint2double _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_double2int _SN_ANSI_ARGS_(( SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_ints2double _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_uints2double _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_int_uint2double _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_uint_int2double _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_longs2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_int_long2double _SN_ANSI_ARGS_((int,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_long_int2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_long_uint2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_mult_uint_long2double _SN_ANSI_ARGS_((t__uint,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));

SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_int2double _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_uint2double _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_double2int _SN_ANSI_ARGS_(( SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_ints2double _SN_ANSI_ARGS_((int,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_uints2double _SN_ANSI_ARGS_((t__uint,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_int_uint2double _SN_ANSI_ARGS_((int,t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_uint_int2double _SN_ANSI_ARGS_((t__uint,int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_longs2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_int_long2double _SN_ANSI_ARGS_((int,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_long_int2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_long_uint2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),t__uint));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_div_uint_long2double _SN_ANSI_ARGS_((t__uint,SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_min2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_max2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_pow2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_double_div_round_up _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC void sn_set_int2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), int));
SN_EXTERNC void sn_set_uint2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC void sn_set_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_int2double _SN_ANSI_ARGS_((int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_uint2double _SN_ANSI_ARGS_((unsigned int));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_minus_double(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_double_sqrt(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_double_log(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_double_log2(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_double_log10(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_abs2double(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC t__bool sn_equal2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_lt2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_gt2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_le2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_ge2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_equal_double2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), int));
SN_EXTERNC t__bool sn_lt_double2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), int));
SN_EXTERNC t__bool sn_gt_double2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), int));
SN_EXTERNC t__bool sn_le_double2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), int));
SN_EXTERNC t__bool sn_ge_double2int _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), int));
SN_EXTERNC t__bool sn_equal_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC t__bool sn_equal_uint2double _SN_ANSI_ARGS_((t__uint, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_equal_int2double _SN_ANSI_ARGS_((int, SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_lt_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC t__bool sn_gt_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC t__bool sn_le_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));
SN_EXTERNC t__bool sn_ge_double2uint _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__uint));

SN_EXTERNC t__bool sn_equal_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC t__bool sn_equal_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_lt_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC t__bool sn_lt_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_gt_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC t__bool sn_gt_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_le_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC t__bool sn_le_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC t__bool sn_ge_double2long _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec))));
SN_EXTERNC t__bool sn_ge_long2double _SN_ANSI_ARGS_((SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)),SN_TYPE(SN_QUALIFIED_NAME(e_core,real))));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_copy_double(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC void sn_copy_double_data(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_make_new_double(void);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_get_temp_real(void);
SN_EXTERNC t__bool sn_is_zero_value(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)));
SN_EXTERNC double sn_vec_to_double(SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_double_to_vec(double);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_real_make_double(double value);
SN_EXTERNC double sn_real_get_double_value(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_inc2double(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_dec2double(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC void sn_check_double(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC t__untyped sn_get_list_item_eval(t__plist,int,t__bool);
SN_EXTERNC SN_STRING sn_get_list_item_code(SN_STRING,SN_STRING,t__list_descriptor ld);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_round(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_floor(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_ceil(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_exp(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sin(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_cos(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_tan(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_asin(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_acos(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_atan(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_sinh(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_cosh(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_tanh(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_asinh(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_acosh(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_atanh(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_atan2(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d1, SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d2);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_hypot(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d1, SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d2);
SN_EXTERNC SN_TYPE(bool) sn_isnan(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) d);

SN_EXTERNC SN_STRING sn_add_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_add_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_sub_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_sub_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_mult_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_mult_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_div_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_div_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_mod_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_mod_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);

SN_EXTERNC SN_STRING sn_or_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_or_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);

SN_EXTERNC SN_STRING sn_xor_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_xor_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);

SN_EXTERNC SN_STRING sn_and_exp_code(SN_STRING item1, SN_STRING item2, t__sn_exp_type kind, t__sn_binary_exps_type);
SN_EXTERNC t__untyped sn_and_exp_eval(t__untyped v1, t__untyped v2, t__sn_exp_type kind, t__sn_binary_exps_type);

SN_EXTERNC SN_STRING sn_inc_exp_code(SN_STRING item,t__sn_exp_type kind);
SN_EXTERNC t__untyped sn_inc_exp_eval(t__untyped value, t__sn_exp_type kind);
SN_EXTERNC SN_STRING sn_dec_exp_code(SN_STRING item,t__sn_exp_type kind);
SN_EXTERNC t__untyped sn_dec_exp_eval(t__untyped value, t__sn_exp_type kind);
SN_EXTERNC SN_STRING sn_le_exp_code(SN_STRING, SN_STRING, t__sn_binary_exps_type);
SN_EXTERNC t__bool sn_le_exp_eval(t__untyped, t__untyped, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_ge_exp_code(SN_STRING, SN_STRING, t__sn_binary_exps_type);
SN_EXTERNC t__bool sn_ge_exp_eval(t__untyped, t__untyped, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_lt_exp_code(SN_STRING, SN_STRING, t__sn_binary_exps_type);
SN_EXTERNC t__bool sn_lt_exp_eval(t__untyped, t__untyped, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_gt_exp_code(SN_STRING, SN_STRING, t__sn_binary_exps_type);
SN_EXTERNC t__bool sn_gt_exp_eval(t__untyped, t__untyped, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_eq_exp_code(SN_STRING, SN_STRING, t__sn_binary_exps_type);
SN_EXTERNC t__bool sn_eq_exp_eval(t__untyped, t__untyped, t__sn_binary_exps_type);
SN_EXTERNC SN_STRING sn_assign_action_code(SN_STRING, SN_STRING, t__sn_binary_exps_type, int, bool);
SN_EXTERNC void sn_assign_scalar_action_eval(int *, t__untyped, t__sn_binary_exps_type,int);
SN_EXTERNC void sn_assign_ptr_action_eval(t__untyped*, t__untyped, t__sn_binary_exps_type, bool);

/* line 235 "/vobs/specman/src/basic_exp.e"  From 'H code' */

SN_EXTERNC int sn_developer_mode;

#if SN_FILTER_COMPILE_COND(heavy)
t__base_struct sn_check_instance (t__base_struct);
#else
# define sn_check_instance(x) (x)
#endif

/* line 17 "/vobs/specman/src/bit_extract.e"  From 'H code' */
SN_EXTERNC t__uint sn_int_bit_mask[];
#define SN_GET_BITS_OPT(_src,_mask,_offset) (((_src) & (_mask)) >> (_offset))
#define SN_GET_BITS(_src,_offset,_length) (((_src) & ((sn_int_bit_mask[_length]) << (_offset) ) ) >> (_offset))
#define SN_GET_UINT_BITS(_src,_offset,_length,_mask) ( SN_GET_BITS(_src,_offset,_length) & (_mask))
#define SN_GET_INT_BITS(_src,_offset,_length,_bit_size) (ZERO_EX(SN_GET_BITS(_src,_offset,_length) ,_bit_size))
/* line 46 "/vobs/specman/src/range.e"  From 'H code' */
#define CONSTANT_SET(_d)	(LIST_ITEM(GLOB_ST->constant_sets,(_d)))
/* line 14 "/vobs/specman/src/named_exp.e"  From 'H code' */
SN_EXTERNC t__symtab sn_symtab;
SN_EXTERNC t__session sn_session;
SN_EXTERNC t__files sn_files;
SN_EXTERNC t__simulator sn_simulator;
SN_EXTERNC t__sn_adapter_manager sn_adapter_manager;
SN_EXTERNC t__scheduler sn_scheduler;
SN_EXTERNC t__pgen3 sn_pgen3;
SN_EXTERNC t__sn_dbg    sn_on;
SN_EXTERNC t__units sn_units;
/* line 148 "/vobs/specman/src/exp_new.e"  From 'H code' */
SN_EXTERNC t__base_struct sn_make_new_and_run_helper _SN_ANSI_ARGS_((int));
/* line 50 "/vobs/specman/src/ams_consts.e"  From 'H code' */
    /* Mathematical constants for SN-AMS*/
#define SN_M_E		2.7182818284590452354
#define SN_M_LOG2E	1.4426950408889634074
#define SN_M_LOG10E	0.43429448190325182765
#define SN_M_LN2	0.69314718055994530942
#define SN_M_LN10	2.30258509299404568402
#define SN_M_PI		3.14159265358979323846
#define SN_M_TWO_PI	6.28318530717958647652
#define SN_M_PI_2	1.57079632679489661923
#define SN_M_PI_4	0.78539816339744830962
#define SN_M_1_PI	0.31830988618379067154
#define SN_M_2_PI	0.63661977236758134308
#define SN_M_2_SQRTPI	1.12837916709551257390
#define SN_M_SQRT2	1.41421356237309504880
#define SN_M_SQRT1_2	0.70710678118654752440
     
/* Physical constants for SN-AMS */

/* charge of electron in coulombs */
#define SN_P_Q	1.6021918e-19
/* speed of light in vacuum in meters/sec*/
#define SN_P_C	2.997924562e8
/* Boltzmann's constant in joules/kelvin*/
#define SN_P_K	1.3806226e-23
/* Planck's constant in joules*sec*/
#define SN_P_H	6.6260755e-34 
/* permittivity of vacuum in farads/meter*/
#define SN_P_EPS0	8.85418792394420013968e-12 
/* permeability of vacuum in henrys/meter*/
#define SN_P_U0	(4.0e-7 * SN_M_PI) 
/* zero celsius in kelvin*/
#define SN_P_CELSIUS0	273.15
    
/* line 10 "/vobs/specman/src/cint.e"  From 'H code' */

#define SN_SN_LIST_SIZE(li) (sn_list_size(li))
#define SN_SN_LIST_GET(li,index,type) (((SN_TYPE(type))(unsigned long)sn_list_get((SN_TYPE(ilist))(li),(index))))
#define SN_SN_LIST_SET(li,index,item) (sn_list_set((SN_TYPE(ilist))(li),(index),(void*)(item)))    
#define SN_SN_LIST_ADD(li,item) (sn_list_add((SN_TYPE(ilist))(li),(void*)(item)))
#define SN_SN_LIST_CHANGE(li,size) (sn_list_change((SN_TYPE(ilist))(li),(size)))

#define SN_LIST_SIZE(li) SN_SN_LIST_SIZE(li)
#define SN_LIST_GET(li,index,type) SN_SN_LIST_GET(li,index,type)
#define SN_LIST_SET(li,index,item) SN_SN_LIST_SET(li,index,item)
#define SN_LIST_ADD(li,item) SN_SN_LIST_ADD(li,item)
#define SN_LIST_CHANGE(li,size) SN_SN_LIST_CHANGE(li,size)

SN_EXTERNC int sn_list_size SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void *sn_list_get SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void sn_list_set SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void sn_list_add SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void sn_list_change SN_UNSPEC_PARAMS_LIST;

/* LONG and other extensions for ESI */

/** PACKED LIST **/
/** *********** **/
/** the same a regular list **/
#define SN_PACKED_LIST_SIZE(li) (sn_list_size((SN_TYPE(ilist))li)) 
#define SN_PACKED_LIST_SIZE_BYTES(li) (sn_packed_list_size_bytes((SN_TYPE(ilist))li))
#define SN_PACKED_LIST_SIZE_INTS(li) (sn_packed_list_size_ints((SN_TYPE(ilist))li))
#define SN_LIST_ELEMENT_SIZE(li) (sn_list_element_size((SN_TYPE(ilist))li)) 
    
/**  returns raw data  (byte *)   **/
#define SN_PACKED_LIST_DATA_POINTER(li) (sn_packed_list_data_pointer((SN_TYPE(ilist))(li)))

/** put/get byte to/from packed list **/
#define SN_PACKED_LIST_GET_BYTE(li,index) (sn_packed_list_get_byte((SN_TYPE(ilist))(li),index))
#define SN_PACKED_LIST_SET_BYTE(li,index,item) (sn_packed_list_set_byte((SN_TYPE(ilist))(li),index,item))
#define SN_PACKED_LIST_GET_INT(li,index) (sn_packed_list_get_int((SN_TYPE(ilist))(li),index))
#define SN_PACKED_LIST_SET_INT(li,index,item) (sn_packed_list_set_int((SN_TYPE(ilist))(li),index,item))

SN_EXTERNC int sn_packed_list_size_bytes SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC int sn_packed_list_size_ints  SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC int sn_list_element_size  SN_UNSPEC_PARAMS_LIST;

SN_EXTERNC unsigned char * sn_packed_list_data_pointer SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC unsigned int    sn_packed_list_get_byte     SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void            sn_packed_list_set_byte     SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC unsigned int    sn_packed_list_get_int      SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void            sn_packed_list_set_int      SN_UNSPEC_PARAMS_LIST;


/** LONG INTEGER **/
/** ************ **/
/** returns size of long in bits **/
#define SN_LONG_SIZE(longv) (sn_long_size((SN_LONG)longv))
#define SN_LONG_SIZE_BYTES(longv) (sn_long_size_bytes((SN_LONG)longv))
#define SN_LONG_SIZE_INTS(longv) (sn_long_size_ints((SN_LONG)longv))

#define SN_LONG_DATA_POINTER(longv) (sn_long_data_pointer((SN_LONG)longv))
#define SN_LONG_GET_BYTE(longv,index) (sn_long_get_byte((SN_LONG)longv,index))
#define SN_LONG_SET_BYTE(longv,index,item) (sn_long_set_byte((SN_LONG)longv,index,item))
#define SN_LONG_GET_INT(longv,index) (sn_long_get_int((SN_LONG)longv,index))
#define SN_LONG_SET_INT(longv,index,item) (sn_long_set_int((SN_LONG)longv,index,item))

/** -- LONG INTEGER LIST */
#define SN_LIST_LONG_GET(li,index) SN_LIST_GET(li,index,sn_vec)
    
SN_EXTERNC int sn_long_size       SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC int sn_long_size_bytes SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC int sn_long_size_ints  SN_UNSPEC_PARAMS_LIST;

SN_EXTERNC unsigned char * sn_long_data_pointer SN_UNSPEC_PARAMS_LIST; 
SN_EXTERNC unsigned int    sn_long_get_byte     SN_UNSPEC_PARAMS_LIST; 
SN_EXTERNC void            sn_long_set_byte     SN_UNSPEC_PARAMS_LIST; 
SN_EXTERNC unsigned int    sn_long_get_int      SN_UNSPEC_PARAMS_LIST; 
SN_EXTERNC void            sn_long_set_int      SN_UNSPEC_PARAMS_LIST; 

/* --REAL */
#define SN_REAL_NEW(_value) (sn_real_make_double(_value))
#define SN_REAL_GET(_real) (sn_real_get_double_value(_real))

/* line 48 "/vobs/specman/src/scriptsim.e"  From 'H code' */
#define GLOB_UNITS    ((t__units)(sn_units))    
#define SYS ((t__sys)(GLOB->sys))
SN_EXTERNC SN_STRING sn_str_expand_dots(SN_STRING);
/* line 326 "/vobs/specman/src/scriptsim.e"  From 'H code' */
    extern struct s__l__untyped *sn_signal_locals;
/* line 1596 "/vobs/specman/src/config_main.e"  From 'H code' */
  
t__sn__sn_intptr_t sn_ep2intptr (t__external_pointer);
t__sn__sn_uintptr_t sn_ep2uintptr (t__external_pointer);
t__external_pointer sn_intptr2ep (t__sn__sn_intptr_t);
t__external_pointer sn_uintptr2ep (t__sn__sn_uintptr_t);
  
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_08_20
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_FULL_VERSION_08_20_006
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_0_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_0_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_0_2_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_0_3_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_0_4_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_1_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_2_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_2_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_3_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_3_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_3_2_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_3_3_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_3_4_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_4_3_5_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_5_0_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_5_0_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_5_0_2_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_5_0_3_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_5_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_6_0_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_6_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_6_1_1_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_06_20_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_08_10_OR_LATER
/* line 34 "/vobs/specman/src/err_tcm.e"  From 'H code' */
#define SPECMAN_VERSION_08_20_OR_LATER
/* line 35 "/vobs/specman/src/rl_lang.e"  From 'H code' */
#define SN_NEW_CONSTANT_RANGE_LIST(_d)	(LIST_ITEM(GLOB_ST->new_constant_rls,(_d)))
/* line 735 "/vobs/specman/src/hdl_struct.e"  From 'H code' */
#include <sys/types.h>
typedef struct sn_call_back_struct{
     void *ptr;
     void *ud;
     int event_id;
     int index_in_info;
     time_t  valid_initial_time;
 } sn_call_back_struct,*psn_call_back_struct;
/* line 2 "/vobs/specman/src/sim_time.e"  From 'H code' */
    typedef struct sn_long_time_struct_ {
    unsigned int low;
    unsigned int high;
} sn_long_time;
#define _sn_long_time_t
/* line 17 "/vobs/specman/src/bdd.e"  From 'H code' */
#define SN_BDD_TYPE SN_TYPE(sn_bdd)
#define SN_BDD_TYPE_ID SN_TYPE_ID(sn_bdd)
/* line 168 "/vobs/specman/src/te_tick.e"  From 'H code' */
#define GLOB_SCHED ((t__scheduler)(sn_scheduler))
/* line 18 "/vobs/specman/src/te_utils.e"  From 'H code' */
#define SIM_DELST ((t__delayList)(GLOB_SIM->delayList))
#define LAST_DELST ((t__low_high)(GLOB_SIM->delayList->lastlh))
#define GLOB_SCED  ((t__scheduler)(sn_scheduler))       
/* line 17 "/vobs/specman/src/tcm_data_structures.e"  From 'H code' */

typedef struct sn_program_counter {
  SN_TYPE(routine_pointer) routine;
  SN_TYPE(sn_tcm_flow_graph) flow_graph;
  SN_TYPE(int) state;
} *sn_program_counter_ptr;

/* pre-processor concatination */
#ifdef __TOKEN_MERGER__
#define PC(_v,_f) \
    ((sn_program_counter_ptr)(&((_v)->_f##__routine)))
#else /* __TOKEN_MERGER__ */
#define PC(_v,_f) \
    ((sn_program_counter_ptr)(&((_v)->_f/**/__routine)))
#endif /* __TOKEN_MERGER__ */

/* line 267 "/vobs/specman/src/tcm_scheduler.e"  From 'H code' */

/* for a tcm start */
SN_TYPE(sn_tcm_frame) sn_tcm__unresolved_call(
                        SN_TYPE(source_ref) source_ref ,
                        SN_TYPE(sn_tcm_thread) thread ,
                        SN_TYPE(any_struct) sn_owner, 
                        SN_TYPE(int) m_index);

/* for a tcm call */
SN_TYPE(sn_tcm_frame) sn_tcm__resolved_call(
                        SN_TYPE(source_ref) source_ref, 
                        SN_TYPE(sn_tcm_thread) thread,
                        SN_TYPE(any_struct) sn_owner, 
                        SN_TYPE(routine_pointer) routine, 
                        SN_TYPE(sn_tcm_flow_graph) flow_graph,
                        SN_TYPE(int) frame_d_index);

/* for a first/all of branch */
SN_TYPE(sn_tcm_thread) sn_tcm__start_branch(
                        SN_TYPE(sn_tcm_thread) parent_thread,
                        SN_TYPE(sn_tcm_thread) sub_thread,
                        SN_TYPE(sn_tcm_frame) frame, 
                        SN_TYPE(routine_pointer) routine,
                        SN_TYPE(sn_tcm_flow_graph) flow_graph,
                        SN_TYPE(int) tcm_index
                      );
void sn_tcm__resume_imm(
                        SN_TYPE(sn_tcm_thread) thread,
                        SN_TYPE(sn_tcm_thread) after_thread);
void sn_tcm__kill(SN_TYPE(sn_thread_handle) handle);
void sn_tcm__free_frame(SN_TYPE(sn_tcm_frame));
/* line 107 "/vobs/specman/src/times.e"  From 'H code' */
#ifdef SUN_C
#undef  ushort
#undef  uint
#endif
#include <limits.h>
/* line 6 "/vobs/specman/src/oig_api.e"  From 'H code' */

#define OIG_DEFAULT_LONG_SIZE 1056

/* line 3 "/vobs/specman/src/gen/times2.e"  From 'H code' */
#include <sys/times.h>
/* line 2 "/vobs/specman/src/dyn_cint.e"  From 'H code' */

#ifdef SN_USE_DYNAMIC_C_INTERFACE

#include <dlfcn.h>
     

static void * sn_boot_exe_handle() {
  static void * lib_handle = NULL;
  static int init = 0;

  if(!init) {
    lib_handle=dlopen(0, RTLD_LAZY | RTLD_GLOBAL);
    if(!lib_handle) {
        char* err = dlerror(); \
        if (!err) err = "Unknown"; \
        fprintf(stderr,"\n*** Error: Cannot get handle to executable\n   System Error:%s",err); \
        exit(255);
    }
    init=1;
  }
  return lib_handle;
}

#define SN_DYN_CHECK_FOR_NULL(ptr,function_name) \
if ( ptr == NULL ) { \
    char* err = dlerror(); \
    if (!err) err = "Unknown"; \
    fprintf(stderr, "\n *** Error: Failed to find symbol '%s' for dynamic C interface\n   System error: %s\n",function_name,err); \
    exit(255); \
}

typedef int (*sn_list_size_ptr_t) (SN_TYPE(ilist));
typedef void* (* sn_list_get_ptr_t) (SN_TYPE(ilist),int);
typedef void (* sn_list_set_ptr_t) (SN_TYPE(ilist),int,void*);
typedef void (* sn_list_add_ptr_t) (SN_TYPE(ilist),void*);
typedef void (* sn_list_change_ptr_t) (SN_TYPE(ilist),int);


typedef SN_TYPE(ilist) (* sn_make_new_list_helper_ptr_t) (int);
typedef SN_STRING (* sn_make_new_string_helper_ptr_t ) (int);
typedef SN_STRING (* sn_string_copy_ptr_t ) (SN_TYPE(string));

typedef SN_TYPE(base_struct) (* sn_make_new_and_run_helper_ptr_t) (int);
typedef SN_TYPE(type_descriptor) (*type_called_ptr_t)(char*);

typedef void (*sn_long_set_int_ptr_t)(SN_LONG,int,unsigned int);
typedef unsigned int (*sn_long_get_int_ptr_t)(SN_LONG,int);
typedef void (*sn_long_set_byte_ptr_t)(SN_LONG, int, unsigned int);
typedef unsigned int (*sn_long_get_byte_ptr_t)(SN_LONG, int);
typedef unsigned char *(* sn_long_data_pointer_ptr_t)(SN_LONG);
typedef int (*sn_long_size_ptr_t)(SN_LONG);
typedef int (*sn_long_size_bytes_ptr_t)(SN_LONG);
typedef int (*sn_long_size_ints_ptr_t)(SN_LONG);
typedef void* sn_dispatch_tables_ptr_t;
typedef void* the_global_struct_ptr_t;
typedef double (*sn_real_get_double_value_ptr_t)(SN_TYPE(real) r);
typedef SN_TYPE(real) (*sn_real_make_double_ptr_t)(double v);

    

static sn_list_size_ptr_t sn_list_size_ptr = NULL;
static sn_list_get_ptr_t sn_list_get_ptr = NULL;
static sn_list_set_ptr_t sn_list_set_ptr = NULL;
static sn_list_add_ptr_t sn_list_add_ptr = NULL;
static sn_list_change_ptr_t sn_list_change_ptr = NULL;
static sn_make_new_list_helper_ptr_t sn_make_new_list_helper_ptr = NULL;
static sn_make_new_string_helper_ptr_t sn_make_new_string_helper_ptr = NULL;
static sn_string_copy_ptr_t sn_string_copy_ptr = NULL;
static sn_make_new_and_run_helper_ptr_t sn_make_new_and_run_helper_ptr = NULL;
static type_called_ptr_t type_called_ptr = NULL;
static sn_long_set_int_ptr_t sn_long_set_int_ptr = NULL;
static sn_long_get_int_ptr_t sn_long_get_int_ptr = NULL;
static sn_long_set_byte_ptr_t sn_long_set_byte_ptr = NULL;
static sn_long_get_byte_ptr_t sn_long_get_byte_ptr = NULL;
static sn_long_data_pointer_ptr_t sn_long_data_pointer_ptr = NULL;
static sn_long_size_ptr_t sn_long_size_ptr = NULL;
static sn_long_size_bytes_ptr_t sn_long_size_bytes_ptr = NULL;
static sn_long_size_ints_ptr_t sn_long_size_ints_ptr = NULL;
static sn_real_get_double_value_ptr_t sn_real_get_double_value_ptr = NULL;
static sn_real_make_double_ptr_t sn_real_make_double_ptr = NULL;
static sn_dispatch_tables_ptr_t sn_dispatch_tables_ptr = NULL;
static the_global_struct_ptr_t the_global_struct_ptr = NULL;

static void* sn_dyn_resolve_symbol(char* symbol) {
  void* ptr = (void*)dlsym(sn_boot_exe_handle(),symbol);
  SN_DYN_CHECK_FOR_NULL(ptr,symbol);
  return ptr;
}

/* this functions never called - they use all the static
    functions to avoid warnings */
static void sn_never_called_dyn_cint1();
static void sn_never_called_dyn_cint2() {
  sn_never_called_dyn_cint1();
}
static void sn_never_called_dyn_cint1() {
  SN_TYPE(ilist) l;
  SN_LONG lv;
  void* dummy;
  SN_TYPE(real) r;
  SN_TYPE(type_descriptor) dummy_ts;
  sn_list_size_ptr(l);
  sn_list_get_ptr(l,2);
  sn_list_set_ptr(l,2,dummy);
  sn_list_add_ptr(l,dummy);
  sn_list_change_ptr(l,3);

  sn_make_new_list_helper_ptr(5);
  sn_make_new_string_helper_ptr (5);
  sn_string_copy_ptr ("aaa");

  sn_make_new_and_run_helper_ptr (5);

  sn_long_set_int_ptr(lv,5,5);
  sn_long_get_int_ptr(lv,5);
  sn_long_set_byte_ptr(lv,5,5);
  sn_long_get_byte_ptr(lv,5);
  sn_long_data_pointer_ptr(lv);
  sn_long_size_ptr(lv);
  sn_long_size_bytes_ptr(lv);
  sn_long_size_ints_ptr(lv);    
    
  sn_dispatch_tables_ptr = 0;
  the_global_struct_ptr = 0;
  sn_dyn_resolve_symbol("aaa");
  sn_real_get_double_value_ptr(r);
  r = sn_real_make_double_ptr(5.5);
  dummy_ts =  type_called_ptr("int");
  sn_never_called_dyn_cint2();
}

#ifdef SN_LIST_SIZE
#undef SN_LIST_SIZE
#endif

#ifdef SN_LIST_GET
#undef SN_LIST_GET
#endif

#ifdef SN_LIST_SET
#undef SN_LIST_SET
#endif

#ifdef SN_LIST_ADD
#undef SN_LIST_ADD
#endif

#ifdef SN_LIST_CHANGE
#undef SN_LIST_CHANGE
#endif

#ifdef SN_LIST_NEW
#undef SN_LIST_NEW
#endif

#ifdef SN_STRING_NEW
#undef SN_STRING_NEW
#endif

#ifdef SN_STRING_COPY
#undef SN_STRING_COPY
#endif

#ifdef SN_STRUCT_NEW
#undef SN_STRUCT_NEW
#endif
    
#ifdef SN_LONG_SIZE
#undef SN_LONG_SIZE
#endif

#ifdef SN_LONG_SIZE_BYTES
#undef SN_LONG_SIZE_BYTES
#endif

#ifdef SN_LONG_SIZE_INTS
#undef SN_LONG_SIZE_INTS
#endif

#ifdef SN_LONG_DATA_POINTER
#undef SN_LONG_DATA_POINTER
#endif

#ifdef SN_LONG_GET_BYTE
#undef SN_LONG_GET_BYTE
#endif

#ifdef SN_LONG_SET_BYTE
#undef SN_LONG_SET_BYTE
#endif

#ifdef SN_LONG_GET_INT
#undef SN_LONG_GET_INT
#endif

#ifdef SN_LONG_SET_INT
#undef SN_LONG_SET_INT
#endif
    
#ifdef SN_DISPATCH
#undef SN_DISPATCH
#endif
    
#ifdef SN_SYS
#undef SN_SYS
#endif
    
#ifdef SN_REAL_GET
#undef SN_REAL_GET
#endif
    
#ifdef SN_REAL_NEW
#undef SN_REAL_NEW
#endif
    
#define SN_RESOLVE_IF_NULL_AND_CAST(symbol,to_cast) \
    (to_cast(SN_RESOLVE_IF_NULL(symbol)))

#ifdef __TOKEN_MERGER__
#define SN_RESOLVE_IF_NULL(symbol) \
( (symbol##_ptr) ? symbol##_ptr : ( symbol##_ptr = (symbol##_ptr_t)sn_dyn_resolve_symbol(#symbol)) ) 
#else /* __TOKEN_MERGER__ */
#define SN_RESOLVE_IF_NULL(symbol) \
( (symbol/**/_ptr) ? symbol/**/_ptr : ( symbol/**/_ptr = (symbol/**/_ptr_t)sn_dyn_resolve_symbol(#symbol)) )  
#endif /*__TOKEN_MERGER__*/

#define SN_LIST_SIZE(li) ( \
(*SN_RESOLVE_IF_NULL(sn_list_size)) \
((SN_TYPE(ilist))(li)))

#define SN_LIST_GET(li,index,type) \
((SN_TYPE(type)) ((unsigned long) \
(*SN_RESOLVE_IF_NULL(sn_list_get)) \
((SN_TYPE(ilist))(li),(index))))

#define SN_LIST_SET(li,index,item) ( \
(*SN_RESOLVE_IF_NULL(sn_list_set)) \
((SN_TYPE(ilist))(li),(index),(void*)(item)))    

#define SN_LIST_ADD(li,item) (\
(*SN_RESOLVE_IF_NULL(sn_list_add)) \
((SN_TYPE(ilist))(li),(void*)(item)))

#define SN_LIST_CHANGE(li,size) (\
(*SN_RESOLVE_IF_NULL(sn_list_change)) \
((SN_TYPE(ilist))(li),(size)))

#define SN_LIST_CHANGE(li,size) (\
(*SN_RESOLVE_IF_NULL(sn_list_change)) \
((SN_TYPE(ilist))(li),(size)))

#define SN_LIST_NEW(type) (((SN_LIST(type)) \
(*SN_RESOLVE_IF_NULL(sn_make_new_list_helper)) \
(SN_LIST_TYPE_ID(type))))

#define SN_STRING_NEW(size) ((SN_TYPE(string))(\
(*SN_RESOLVE_IF_NULL(sn_make_new_string_helper)) \
(size)))

#define SN_STRING_COPY(str) ((SN_STRING) \
(*SN_RESOLVE_IF_NULL(sn_string_copy)) \
(str))

#define SN_STRUCT_NEW(type) ((SN_TYPE(type)) \
(*SN_RESOLVE_IF_NULL(sn_make_new_and_run_helper)) \
(SN_TYPE_ID(type)))
    
#define SN_SN_INTERNAL_DYNAMIC_ESI_STRUCT_NEW(type) ((SN_TYPE(type)) \
    (*SN_RESOLVE_IF_NULL(sn_make_new_and_run_helper)) \
    (((*SN_RESOLVE_IF_NULL(type_called))(_SN_STRINGIFY_(type)))->d_index))

#define SN_LONG_SIZE(longv) ( \
(*SN_RESOLVE_IF_NULL(sn_long_size )) \
((SN_LONG)longv)) 

#define SN_LONG_SIZE_BYTES(longv) ( \
(*SN_RESOLVE_IF_NULL(sn_long_size_bytes )) \
((SN_LONG)longv))

#define SN_LONG_SIZE_INTS(longv) ( \
(*SN_RESOLVE_IF_NULL(sn_long_size_ints )) \
((SN_LONG)longv))

#define SN_LONG_DATA_POINTER(longv) ( \
(*SN_RESOLVE_IF_NULL(sn_long_data_pointer)) \
((SN_LONG) longv))

#define SN_LONG_GET_BYTE(longv,index) ( \
(*SN_RESOLVE_IF_NULL(sn_long_get_byte)) \
((SN_LONG)longv,index))

#define SN_LONG_SET_BYTE(longv,index,item) ( \
(*SN_RESOLVE_IF_NULL(sn_long_set_byte )) \
((SN_LONG)longv,index,item))

#define SN_LONG_GET_INT(longv,index) ( \
(*SN_RESOLVE_IF_NULL(sn_long_get_int )) \
((SN_LONG)longv,index))

#define SN_LONG_SET_INT(longv,index,item) ( \
(*SN_RESOLVE_IF_NULL(sn_long_set_int )) \
((SN_LONG)longv,index,item))
    
#define SN_REAL_GET(real) ( \
(*SN_RESOLVE_IF_NULL(sn_real_get_double_value )) \
(real))
    
#define SN_REAL_NEW(d_value) ( \
(*SN_RESOLVE_IF_NULL(sn_real_make_double)) \
(d_value))   
    
#ifdef __TOKEN_MERGER__
#define SN_DISPATCH(_m, _v, _t, _params) ( \
(*SN_RESOLVE_IF_NULL_AND_CAST(sn_dispatch_tables,(SN_TYPE(routine_pointer) ***))) \
[_v->d__][m__##_t##__##_m]_params)
#else /* __TOKEN_MERGER__ */
#define SN_DISPATCH(_m, _v, _t, _params) ( \
(*SN_RESOLVE_IF_NULL_AND_CAST(sn_dispatch_tables,(SN_TYPE(routine_pointer) ***))) \
[_v->d__][m__/**/_t/**/__/**/_m]_params)
#endif /* __TOKEN_MERGER__ */ 
    
#define SN_SYS ((t__sys)( \
(*SN_RESOLVE_IF_NULL_AND_CAST(the_global_struct,(t__global*))) \
->sys))

#endif /* SN_USE_DYNAMIC_C_INTERFACE */
    
    


#define m__main__matlab_mx_array_s__get_item 26
#define cast_m__main__matlab_mx_array_s__get_item struct s__main__sn_matlab_complex_s * (*)  _SN_ANSI_ARGS_ ((void*, t__uint, t__uint))
#undef m__matlab_mx_array_s__get_item
#define m__matlab_mx_array_s__get_item m__main__matlab_mx_array_s__get_item
#undef cast_m__matlab_mx_array_s__get_item
#define cast_m__matlab_mx_array_s__get_item cast_m__main__matlab_mx_array_s__get_item
#define m__main__matlab_mx_array_s__get_item_as_uint64 27
#define cast_m__main__matlab_mx_array_s__get_item_as_uint64 struct s__main__sn_matlab_complex_s * (*)  _SN_ANSI_ARGS_ ((void*, t__uint, t__uint))
#undef m__matlab_mx_array_s__get_item_as_uint64
#define m__matlab_mx_array_s__get_item_as_uint64 m__main__matlab_mx_array_s__get_item_as_uint64
#undef cast_m__matlab_mx_array_s__get_item_as_uint64
#define cast_m__matlab_mx_array_s__get_item_as_uint64 cast_m__main__matlab_mx_array_s__get_item_as_uint64
#define m__main__sn_matlab_var_s__is_double 26
#define cast_m__main__sn_matlab_var_s__is_double t__bool (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__sn_matlab_var_s__is_double
#define m__sn_matlab_var_s__is_double m__main__sn_matlab_var_s__is_double
#undef cast_m__sn_matlab_var_s__is_double
#define cast_m__sn_matlab_var_s__is_double cast_m__main__sn_matlab_var_s__is_double
#define m__main__sn_matlab_var_s__is_int64 27
#define cast_m__main__sn_matlab_var_s__is_int64 t__bool (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__sn_matlab_var_s__is_int64
#define m__sn_matlab_var_s__is_int64 m__main__sn_matlab_var_s__is_int64
#undef cast_m__sn_matlab_var_s__is_int64
#define cast_m__sn_matlab_var_s__is_int64 cast_m__main__sn_matlab_var_s__is_int64
#define m__main__sn_matlab_var_s__get_item 28
#define cast_m__main__sn_matlab_var_s__get_item struct s__main__sn_matlab_complex_s * (*)  _SN_ANSI_ARGS_ ((void*, t__uint))
#undef m__sn_matlab_var_s__get_item
#define m__sn_matlab_var_s__get_item m__main__sn_matlab_var_s__get_item
#undef cast_m__sn_matlab_var_s__get_item
#define cast_m__sn_matlab_var_s__get_item cast_m__main__sn_matlab_var_s__get_item
#define m__main__matlab_ifc_s__exec 26
#define cast_m__main__matlab_ifc_s__exec t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*, l__string))
#undef m__matlab_ifc_s__exec
#define m__matlab_ifc_s__exec m__main__matlab_ifc_s__exec
#undef cast_m__matlab_ifc_s__exec
#define cast_m__matlab_ifc_s__exec cast_m__main__matlab_ifc_s__exec
#define m__main__matlab_ifc_s__get_var 27
#define cast_m__main__matlab_ifc_s__get_var t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*, t__main__sn_matlab_var_s))
#undef m__matlab_ifc_s__get_var
#define m__matlab_ifc_s__get_var m__main__matlab_ifc_s__get_var
#undef cast_m__matlab_ifc_s__get_var
#define cast_m__matlab_ifc_s__get_var cast_m__main__matlab_ifc_s__get_var
#define m__main__matlab_ifc_s__put_var 28
#define cast_m__main__matlab_ifc_s__put_var t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*, t__main__sn_matlab_var_s))
#undef m__matlab_ifc_s__put_var
#define m__matlab_ifc_s__put_var m__main__matlab_ifc_s__put_var
#undef cast_m__matlab_ifc_s__put_var
#define cast_m__matlab_ifc_s__put_var cast_m__main__matlab_ifc_s__put_var
#define m__main__matlab_ifc_s__is_initialized 29
#define cast_m__main__matlab_ifc_s__is_initialized t__bool (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__is_initialized
#define m__matlab_ifc_s__is_initialized m__main__matlab_ifc_s__is_initialized
#undef cast_m__matlab_ifc_s__is_initialized
#define cast_m__matlab_ifc_s__is_initialized cast_m__main__matlab_ifc_s__is_initialized
#define m__main__matlab_ifc_s__is_valid_var 30
#define cast_m__main__matlab_ifc_s__is_valid_var t__bool (*)  _SN_ANSI_ARGS_ ((void*, t__main__sn_matlab_var_s))
#undef m__matlab_ifc_s__is_valid_var
#define m__matlab_ifc_s__is_valid_var m__main__matlab_ifc_s__is_valid_var
#undef cast_m__matlab_ifc_s__is_valid_var
#define cast_m__matlab_ifc_s__is_valid_var cast_m__main__matlab_ifc_s__is_valid_var
#define m__main__matlab_ifc_s__is_equal 31
#define cast_m__main__matlab_ifc_s__is_equal t__bool (*)  _SN_ANSI_ARGS_ ((void*, t__main__sn_matlab_var_s, t__main__matlab_mx_array_s))
#undef m__matlab_ifc_s__is_equal
#define m__matlab_ifc_s__is_equal m__main__matlab_ifc_s__is_equal
#undef cast_m__matlab_ifc_s__is_equal
#define cast_m__matlab_ifc_s__is_equal cast_m__main__matlab_ifc_s__is_equal
#define m__main__matlab_ifc_s__is_equal_mx 32
#define cast_m__main__matlab_ifc_s__is_equal_mx t__bool (*)  _SN_ANSI_ARGS_ ((void*, t__main__matlab_mx_array_s, t__main__matlab_mx_array_s))
#undef m__matlab_ifc_s__is_equal_mx
#define m__matlab_ifc_s__is_equal_mx m__main__matlab_ifc_s__is_equal_mx
#undef cast_m__matlab_ifc_s__is_equal_mx
#define cast_m__matlab_ifc_s__is_equal_mx cast_m__main__matlab_ifc_s__is_equal_mx
#define m__main__matlab_ifc_s__mx_to_sn 33
#define cast_m__main__matlab_ifc_s__mx_to_sn struct s__main__sn_matlab_var_s * (*)  _SN_ANSI_ARGS_ ((void*, t__main__matlab_mx_array_s))
#undef m__matlab_ifc_s__mx_to_sn
#define m__matlab_ifc_s__mx_to_sn m__main__matlab_ifc_s__mx_to_sn
#undef cast_m__matlab_ifc_s__mx_to_sn
#define cast_m__matlab_ifc_s__mx_to_sn cast_m__main__matlab_ifc_s__mx_to_sn
#define m__main__sn_matlab_complex_s__init 0
#define cast_m__main__sn_matlab_complex_s__init void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__sn_matlab_complex_s__init
#define m__sn_matlab_complex_s__init m__main__sn_matlab_complex_s__init
#undef cast_m__sn_matlab_complex_s__init
#define cast_m__sn_matlab_complex_s__init cast_m__main__sn_matlab_complex_s__init
#define m__main__matlab_mx_array_s__get_mx_item 28
#define cast_m__main__matlab_mx_array_s__get_mx_item void (*)  _SN_ANSI_ARGS_ ((void*, t__uint, t__uint, t__main__sn_matlab_complex_s))
#undef m__matlab_mx_array_s__get_mx_item
#define m__matlab_mx_array_s__get_mx_item m__main__matlab_mx_array_s__get_mx_item
#undef cast_m__matlab_mx_array_s__get_mx_item
#define cast_m__matlab_mx_array_s__get_mx_item cast_m__main__matlab_mx_array_s__get_mx_item
#define m__main__matlab_mx_array_s__get_mx_item_as_uint64 29
#define cast_m__main__matlab_mx_array_s__get_mx_item_as_uint64 void (*)  _SN_ANSI_ARGS_ ((void*, t__uint, t__uint, t__main__sn_matlab_complex_s))
#undef m__matlab_mx_array_s__get_mx_item_as_uint64
#define m__matlab_mx_array_s__get_mx_item_as_uint64 m__main__matlab_mx_array_s__get_mx_item_as_uint64
#undef cast_m__matlab_mx_array_s__get_mx_item_as_uint64
#define cast_m__matlab_mx_array_s__get_mx_item_as_uint64 cast_m__main__matlab_mx_array_s__get_mx_item_as_uint64
#define m__main__matlab_mx_array_s__free_mx_ptr 30
#define cast_m__main__matlab_mx_array_s__free_mx_ptr void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_mx_array_s__free_mx_ptr
#define m__matlab_mx_array_s__free_mx_ptr m__main__matlab_mx_array_s__free_mx_ptr
#undef cast_m__matlab_mx_array_s__free_mx_ptr
#define cast_m__matlab_mx_array_s__free_mx_ptr cast_m__main__matlab_mx_array_s__free_mx_ptr
#define m__main__sn_matlab_var_s__init 0
#define cast_m__main__sn_matlab_var_s__init void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__sn_matlab_var_s__init
#define m__sn_matlab_var_s__init m__main__sn_matlab_var_s__init
#undef cast_m__sn_matlab_var_s__init
#define cast_m__sn_matlab_var_s__init cast_m__main__sn_matlab_var_s__init
#define m__main__matlab_ifc_s__check_result 34
#define cast_m__main__matlab_ifc_s__check_result void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__check_result
#define m__matlab_ifc_s__check_result m__main__matlab_ifc_s__check_result
#undef cast_m__matlab_ifc_s__check_result
#define cast_m__matlab_ifc_s__check_result cast_m__main__matlab_ifc_s__check_result
#define m__main__matlab_ifc_s__do_init 35
#define cast_m__main__matlab_ifc_s__do_init void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__do_init
#define m__matlab_ifc_s__do_init m__main__matlab_ifc_s__do_init
#undef cast_m__matlab_ifc_s__do_init
#define cast_m__matlab_ifc_s__do_init cast_m__main__matlab_ifc_s__do_init
#define m__main__matlab_ifc_s__matlab_init 36
#define cast_m__main__matlab_ifc_s__matlab_init t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__matlab_init
#define m__matlab_ifc_s__matlab_init m__main__matlab_ifc_s__matlab_init
#undef cast_m__matlab_ifc_s__matlab_init
#define cast_m__matlab_ifc_s__matlab_init cast_m__main__matlab_ifc_s__matlab_init
#define m__main__matlab_ifc_s__matlab_fini 37
#define cast_m__main__matlab_ifc_s__matlab_fini t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__matlab_fini
#define m__matlab_ifc_s__matlab_fini m__main__matlab_ifc_s__matlab_fini
#undef cast_m__matlab_ifc_s__matlab_fini
#define cast_m__matlab_ifc_s__matlab_fini cast_m__main__matlab_ifc_s__matlab_fini
#define m__main__matlab_ifc_s__matlab_get_var 38
#define cast_m__main__matlab_ifc_s__matlab_get_var t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*, t__main__sn_matlab_var_s))
#undef m__matlab_ifc_s__matlab_get_var
#define m__matlab_ifc_s__matlab_get_var m__main__matlab_ifc_s__matlab_get_var
#undef cast_m__matlab_ifc_s__matlab_get_var
#define cast_m__matlab_ifc_s__matlab_get_var cast_m__main__matlab_ifc_s__matlab_get_var
#define m__main__matlab_ifc_s__matlab_put_var 39
#define cast_m__main__matlab_ifc_s__matlab_put_var t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*, t__main__sn_matlab_var_s))
#undef m__matlab_ifc_s__matlab_put_var
#define m__matlab_ifc_s__matlab_put_var m__main__matlab_ifc_s__matlab_put_var
#undef cast_m__matlab_ifc_s__matlab_put_var
#define cast_m__matlab_ifc_s__matlab_put_var cast_m__main__matlab_ifc_s__matlab_put_var
#define m__main__matlab_ifc_s__matlab_is_equal 40
#define cast_m__main__matlab_ifc_s__matlab_is_equal t__bool (*)  _SN_ANSI_ARGS_ ((void*, t__main__sn_matlab_var_s, t__main__matlab_mx_array_s))
#undef m__matlab_ifc_s__matlab_is_equal
#define m__matlab_ifc_s__matlab_is_equal m__main__matlab_ifc_s__matlab_is_equal
#undef cast_m__matlab_ifc_s__matlab_is_equal
#define cast_m__matlab_ifc_s__matlab_is_equal cast_m__main__matlab_ifc_s__matlab_is_equal
#define m__main__matlab_ifc_s__matlab_is_equal_mx 41
#define cast_m__main__matlab_ifc_s__matlab_is_equal_mx t__bool (*)  _SN_ANSI_ARGS_ ((void*, t__main__matlab_mx_array_s, t__main__matlab_mx_array_s))
#undef m__matlab_ifc_s__matlab_is_equal_mx
#define m__matlab_ifc_s__matlab_is_equal_mx m__main__matlab_ifc_s__matlab_is_equal_mx
#undef cast_m__matlab_ifc_s__matlab_is_equal_mx
#define cast_m__matlab_ifc_s__matlab_is_equal_mx cast_m__main__matlab_ifc_s__matlab_is_equal_mx
#define m__main__matlab_ifc_s__matlab_mx_to_sn_var 42
#define cast_m__main__matlab_ifc_s__matlab_mx_to_sn_var t__bool (*)  _SN_ANSI_ARGS_ ((void*, t__main__matlab_mx_array_s, t__main__sn_matlab_var_s))
#undef m__matlab_ifc_s__matlab_mx_to_sn_var
#define m__matlab_ifc_s__matlab_mx_to_sn_var m__main__matlab_ifc_s__matlab_mx_to_sn_var
#undef cast_m__matlab_ifc_s__matlab_mx_to_sn_var
#define cast_m__matlab_ifc_s__matlab_mx_to_sn_var cast_m__main__matlab_ifc_s__matlab_mx_to_sn_var
#define m__main__matlab_ifc_s__do_matlab 43
#define cast_m__main__matlab_ifc_s__do_matlab t__main__matlab_rc_t (*)  _SN_ANSI_ARGS_ ((void*, t__string))
#undef m__matlab_ifc_s__do_matlab
#define m__matlab_ifc_s__do_matlab m__main__matlab_ifc_s__do_matlab
#undef cast_m__matlab_ifc_s__do_matlab
#define cast_m__matlab_ifc_s__do_matlab cast_m__main__matlab_ifc_s__do_matlab
#define m__main__matlab_ifc_s__init 0
#define cast_m__main__matlab_ifc_s__init void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__init
#define m__matlab_ifc_s__init m__main__matlab_ifc_s__init
#undef cast_m__matlab_ifc_s__init
#define cast_m__matlab_ifc_s__init cast_m__main__matlab_ifc_s__init
#define m__main__matlab_ifc_s__quit 19
#define cast_m__main__matlab_ifc_s__quit void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__quit
#define m__matlab_ifc_s__quit m__main__matlab_ifc_s__quit
#undef cast_m__matlab_ifc_s__quit
#define cast_m__matlab_ifc_s__quit cast_m__main__matlab_ifc_s__quit
#define m__main__matlab_ifc_s__do_fini 44
#define cast_m__main__matlab_ifc_s__do_fini void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__matlab_ifc_s__do_fini
#define m__matlab_ifc_s__do_fini m__main__matlab_ifc_s__do_fini
#undef cast_m__matlab_ifc_s__do_fini
#define cast_m__matlab_ifc_s__do_fini cast_m__main__matlab_ifc_s__do_fini
#define m__e_core__global__start_matlab 477
#define cast_m__e_core__global__start_matlab void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__global__start_matlab
#define m__global__start_matlab m__e_core__global__start_matlab
#undef cast_m__global__start_matlab
#define cast_m__global__start_matlab cast_m__e_core__global__start_matlab
#define m__e_core__global__init 0
#define cast_m__e_core__global__init void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__global__init
#define m__global__init m__e_core__global__init
#undef cast_m__global__init
#define cast_m__global__init cast_m__e_core__global__init
#define m__e_core__sys__quit 19
#define cast_m__e_core__sys__quit void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__sys__quit
#define m__sys__quit m__e_core__sys__quit
#undef cast_m__sys__quit
#define cast_m__sys__quit cast_m__e_core__sys__quit
#define m__e_core__covers__check_done 27
#define cast_m__e_core__covers__check_done void (*)  _SN_ANSI_ARGS_ ((void*, t__int, t__bool, t__e_core__any_struct))
#undef m__covers__check_done
#define m__covers__check_done m__e_core__covers__check_done
#undef cast_m__covers__check_done
#define cast_m__covers__check_done cast_m__e_core__covers__check_done
#define m__sn__sn_dut_manager__start_dut_error 13
#define cast_m__sn__sn_dut_manager__start_dut_error t__bool (*)  _SN_ANSI_ARGS_ ((void*, t__int, t__string, t__e_core__any_struct))
#undef m__sn_dut_manager__start_dut_error
#define m__sn_dut_manager__start_dut_error m__sn__sn_dut_manager__start_dut_error
#undef cast_m__sn_dut_manager__start_dut_error
#define cast_m__sn_dut_manager__start_dut_error cast_m__sn__sn_dut_manager__start_dut_error
#define m__sn__sn_dut_manager__do_the_dut_error 14
#define cast_m__sn__sn_dut_manager__do_the_dut_error void (*)  _SN_ANSI_ARGS_ ((void*, t__e_core__any_struct, t__int, t__string))
#undef m__sn_dut_manager__do_the_dut_error
#define m__sn_dut_manager__do_the_dut_error m__sn__sn_dut_manager__do_the_dut_error
#undef cast_m__sn_dut_manager__do_the_dut_error
#define cast_m__sn_dut_manager__do_the_dut_error cast_m__sn__sn_dut_manager__do_the_dut_error
#define m__e_core__any_struct__quit 19
#define cast_m__e_core__any_struct__quit void (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__any_struct__quit
#define m__any_struct__quit m__e_core__any_struct__quit
#undef cast_m__any_struct__quit
#define cast_m__any_struct__quit cast_m__e_core__any_struct__quit
#define m__sn__ref_param__eval4get 11
#define cast_m__sn__ref_param__eval4get t__untyped (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__ref_param__eval4get
#define m__ref_param__eval4get m__sn__ref_param__eval4get
#undef cast_m__ref_param__eval4get
#define cast_m__ref_param__eval4get cast_m__sn__ref_param__eval4get
#define m__sn__ref_param__eval4set 13
#define cast_m__sn__ref_param__eval4set void (*)  _SN_ANSI_ARGS_ ((void*, t__untyped))
#undef m__ref_param__eval4set
#define m__ref_param__eval4set m__sn__ref_param__eval4set
#undef cast_m__ref_param__eval4set
#define cast_m__ref_param__eval4set cast_m__sn__ref_param__eval4set
#define m__sn__ref_param__eval4get_ref 12
#define cast_m__sn__ref_param__eval4get_ref t__untyped (*)  _SN_ANSI_ARGS_ ((void*))
#undef m__ref_param__eval4get_ref
#define m__ref_param__eval4get_ref m__sn__ref_param__eval4get_ref
#undef cast_m__ref_param__eval4get_ref
#define cast_m__ref_param__eval4get_ref cast_m__sn__ref_param__eval4get_ref
#ifndef SN_USE_DYNAMIC_C_INTERFACE
#undef SN_LIST_SIZE
#undef SN_LIST_GET
#undef SN_LIST_SET
#undef SN_LIST_ADD
#undef SN_LIST_CHANGE

#define SN_LIST_SIZE(li) (CHECK_H_CONSISTENCY(), SN_SN_LIST_SIZE(li))
#define SN_LIST_GET(li,index,type) (CHECK_H_CONSISTENCY(), SN_SN_LIST_GET(li,index,type))
#define SN_LIST_SET(li,index,item) (CHECK_H_CONSISTENCY(), SN_SN_LIST_SET(li,index,item))
#define SN_LIST_ADD(li,item) (CHECK_H_CONSISTENCY(), SN_SN_LIST_ADD(li,item))
#define SN_LIST_CHANGE(li,size) (CHECK_H_CONSISTENCY(), SN_SN_LIST_CHANGE(li,size))

#endif

/* l__string */ 
typedef struct s__l__string {
    t__int d__;
    t__int gen__;
    t__string*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__string;
#define d__l__string 57   


/* l__e_core__any_port */ 
typedef struct s__l__e_core__any_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_port;
#define d__l__e_core__any_port 1229   

typedef l__e_core__any_port l__any_port;
#define d__l__any_port d__l__e_core__any_port

/* l__int */ 
typedef struct s__l__int {
    t__int d__;
    t__int gen__;
    t__int*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__int;
#define d__l__int 23   


/* l__e_core__any_unit */ 
typedef struct s__l__e_core__any_unit {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_unit;
#define d__l__e_core__any_unit 59   

typedef l__e_core__any_unit l__any_unit;
#define d__l__any_unit d__l__e_core__any_unit

/* l__bit */ 
typedef struct s__l__bit {
    t__int d__;
    t__int gen__;
    t__bit*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__bit;
#define d__l__bit 79   


/* l__sn__single_callback_info */ 
typedef struct s__l__sn__single_callback_info {
    t__int d__;
    t__int gen__;
    struct s__sn__single_callback_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__single_callback_info;
#define d__l__sn__single_callback_info 1210   

typedef l__sn__single_callback_info l__single_callback_info;
#define d__l__single_callback_info d__l__sn__single_callback_info

/* l__sn__desc_info */ 
typedef struct s__l__sn__desc_info {
    t__int d__;
    t__int gen__;
    struct s__sn__desc_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__desc_info;
#define d__l__sn__desc_info 2246   

typedef l__sn__desc_info l__desc_info;
#define d__l__desc_info d__l__sn__desc_info

/* l__sn__package_descriptor */ 
typedef struct s__l__sn__package_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__package_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__package_descriptor;
#define d__l__sn__package_descriptor 147   

typedef l__sn__package_descriptor l__package_descriptor;
#define d__l__package_descriptor d__l__sn__package_descriptor

/* l__sn__type_layer */ 
typedef struct s__l__sn__type_layer {
    t__int d__;
    t__int gen__;
    struct s__sn__type_layer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__type_layer;
#define d__l__sn__type_layer 150   

typedef l__sn__type_layer l__type_layer;
#define d__l__type_layer d__l__sn__type_layer

/* l__sn__type_descriptor */ 
typedef struct s__l__sn__type_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__type_descriptor;
#define d__l__sn__type_descriptor 93   

typedef l__sn__type_descriptor l__type_descriptor;
#define d__l__type_descriptor d__l__sn__type_descriptor

/* k__sn__field__short_name */ 
typedef struct s__k__sn__field__short_name {
    t__int d__;
    t__int gen__;
    struct s__sn__field **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__field__short_name;
#define d__k__sn__field__short_name 174   

typedef k__sn__field__short_name k__field__short_name;
#define d__k__field__short_name d__k__sn__field__short_name

/* l__sn__field */ 
typedef struct s__l__sn__field {
    t__int d__;
    t__int gen__;
    struct s__sn__field **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__field;
#define d__l__sn__field 48   

typedef l__sn__field l__field;
#define d__l__field d__l__sn__field

/* l__sn__simple_gen_constraint */ 
typedef struct s__l__sn__simple_gen_constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__simple_gen_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__simple_gen_constraint;
#define d__l__sn__simple_gen_constraint 2061   

typedef l__sn__simple_gen_constraint l__simple_gen_constraint;
#define d__l__simple_gen_constraint d__l__sn__simple_gen_constraint

/* l__sn__method */ 
typedef struct s__l__sn__method {
    t__int d__;
    t__int gen__;
    struct s__sn__method **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__method;
#define d__l__sn__method 50   

typedef l__sn__method l__method;
#define d__l__method d__l__sn__method

/* l__sn__form */ 
typedef struct s__l__sn__form {
    t__int d__;
    t__int gen__;
    struct s__sn__form **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__form;
#define d__l__sn__form 45   

typedef l__sn__form l__form;
#define d__l__form d__l__sn__form

/* l__sn__struct_descriptor */ 
typedef struct s__l__sn__struct_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__struct_descriptor;
#define d__l__sn__struct_descriptor 175   

typedef l__sn__struct_descriptor l__struct_descriptor;
#define d__l__struct_descriptor d__l__sn__struct_descriptor

/* l__sn__sn_verilog_variable */ 
typedef struct s__l__sn__sn_verilog_variable {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_verilog_variable **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_verilog_variable;
#define d__l__sn__sn_verilog_variable 2240   

typedef l__sn__sn_verilog_variable l__sn_verilog_variable;
#define d__l__sn_verilog_variable d__l__sn__sn_verilog_variable

/* l__sn__mvl */ 
typedef struct s__l__sn__mvl {
    t__int d__;
    t__int gen__;
    t__sn__mvl*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__mvl;
#define d__l__sn__mvl 501   

typedef l__sn__mvl l__mvl;
#define d__l__mvl d__l__sn__mvl

/* l__sn__vhdl_driver_descriptor */ 
typedef struct s__l__sn__vhdl_driver_desc14563 {
    t__int d__;
    t__int gen__;
    struct s__sn__vhdl_driver_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__vhdl_driver_descriptor;
#define d__l__sn__vhdl_driver_descriptor 2241   

typedef l__sn__vhdl_driver_descriptor l__vhdl_driver_descriptor;
#define d__l__vhdl_driver_descriptor d__l__sn__vhdl_driver_descriptor

/* k__sn__subprogram_definiti12631 */ 
typedef struct s__k__sn__subprogram_defin14564 {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_definition **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__subprogram_definiti12631;
#define d__k__sn__subprogram_definiti12631 2256   

typedef k__sn__subprogram_definiti12631 k__subprogram_definition__14593;
#define d__k__subprogram_definition__14593 d__k__sn__subprogram_definiti12631

/* l__sn__subprogram_param */ 
typedef struct s__l__sn__subprogram_param {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_param **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__subprogram_param;
#define d__l__sn__subprogram_param 2248   

typedef l__sn__subprogram_param l__subprogram_param;
#define d__l__subprogram_param d__l__sn__subprogram_param

/* l__sn__event_descriptor */ 
typedef struct s__l__sn__event_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__event_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__event_descriptor;
#define d__l__sn__event_descriptor 166   

typedef l__sn__event_descriptor l__event_descriptor;
#define d__l__event_descriptor d__l__sn__event_descriptor

/* l__sn__index */ 
typedef struct s__l__sn__index {
    t__int d__;
    t__int gen__;
    t__sn__index*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__index;
#define d__l__sn__index 1664   

typedef l__sn__index l__index;
#define d__l__index d__l__sn__index

/* l__e_core__base_struct */ 
typedef struct s__l__e_core__base_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__base_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__base_struct;
#define d__l__e_core__base_struct 104   

typedef l__e_core__base_struct l__base_struct;
#define d__l__base_struct d__l__e_core__base_struct

/* l__sn__st_exp */ 
typedef struct s__l__sn__st_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__st_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_exp;
#define d__l__sn__st_exp 709   

typedef l__sn__st_exp l__st_exp;
#define d__l__st_exp d__l__sn__st_exp

/* l__sn__n__action */ 
typedef struct s__l__sn__n__action {
    t__int d__;
    t__int gen__;
    struct s__sn__n__action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__n__action;
#define d__l__sn__n__action 554   

typedef l__sn__n__action l__n__action;
#define d__l__n__action d__l__sn__n__action

/* l__sn__local */ 
typedef struct s__l__sn__local {
    t__int d__;
    t__int gen__;
    struct s__sn__local **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__local;
#define d__l__sn__local 195   

typedef l__sn__local l__local;
#define d__l__local d__l__sn__local

/* l__sn__cover_item_descriptor */ 
typedef struct s__l__sn__cover_item_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__cover_item_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cover_item_descriptor;
#define d__l__sn__cover_item_descriptor 3527   

typedef l__sn__cover_item_descriptor l__cover_item_descriptor;
#define d__l__cover_item_descriptor d__l__sn__cover_item_descriptor

/* l__sn__cover_item_layer */ 
typedef struct s__l__sn__cover_item_layer {
    t__int d__;
    t__int gen__;
    struct s__sn__cover_item_layer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cover_item_layer;
#define d__l__sn__cover_item_layer 3529   

typedef l__sn__cover_item_layer l__cover_item_layer;
#define d__l__cover_item_layer d__l__sn__cover_item_layer

/* l__sn__st_cover_option */ 
typedef struct s__l__sn__st_cover_option {
    t__int d__;
    t__int gen__;
    struct s__sn__st_cover_option **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_cover_option;
#define d__l__sn__st_cover_option 3531   

typedef l__sn__st_cover_option l__st_cover_option;
#define d__l__st_cover_option d__l__sn__st_cover_option

/* l__sn__st_cover_range */ 
typedef struct s__l__sn__st_cover_range {
    t__int d__;
    t__int gen__;
    struct s__sn__st_cover_range **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_cover_range;
#define d__l__sn__st_cover_range 3530   

typedef l__sn__st_cover_range l__st_cover_range;
#define d__l__st_cover_range d__l__sn__st_cover_range

/* l__sn__cover_group_layer */ 
typedef struct s__l__sn__cover_group_layer {
    t__int d__;
    t__int gen__;
    struct s__sn__cover_group_layer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cover_group_layer;
#define d__l__sn__cover_group_layer 3528   

typedef l__sn__cover_group_layer l__cover_group_layer;
#define d__l__cover_group_layer d__l__sn__cover_group_layer

/* k__main__sn_cvr_instance_g24192 */ 
typedef struct s__k__main__sn_cvr_instanc27169 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_instance_g27174 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_cvr_instance_g24192;
#define d__k__main__sn_cvr_instance_g24192 3650   

typedef k__main__sn_cvr_instance_g24192 k__sn_cvr_instance_group_d27173;
#define d__k__sn_cvr_instance_group_d27173 d__k__main__sn_cvr_instance_g24192

/* l__main__sn_cvr_item_descriptor */ 
typedef struct s__l__main__sn_cvr_item_de24135 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_item_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_item_descriptor;
#define d__l__main__sn_cvr_item_descriptor 3652   

typedef l__main__sn_cvr_item_descriptor l__sn_cvr_item_descriptor;
#define d__l__sn_cvr_item_descriptor d__l__main__sn_cvr_item_descriptor

/* l__main__n__cover_range_params */ 
typedef struct s__l__main__n__cover_range27175 {
    t__int d__;
    t__int gen__;
    struct s__main__n__cover_range_params **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__n__cover_range_params;
#define d__l__main__n__cover_range_params 3656   

typedef l__main__n__cover_range_params l__n__cover_range_params;
#define d__l__n__cover_range_params d__l__main__n__cover_range_params

/* k__string__it */ 
typedef struct s__k__string__it {
    t__int d__;
    t__int gen__;
    t__string*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__string__it;
#define d__k__string__it 51   


/* l__main__sn_cover_sampling24538 */ 
typedef struct s__l__main__sn_cover_sampl24539 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_sampling24509 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cover_sampling24538;
#define d__l__main__sn_cover_sampling24538 3691   

typedef l__main__sn_cover_sampling24538 l__sn_cover_sampling_distr27227;
#define d__l__sn_cover_sampling_distr27227 d__l__main__sn_cover_sampling24538

/* l__main__sn_abs_cover_test */ 
typedef struct s__l__main__sn_abs_cover_test {
    t__int d__;
    t__int gen__;
    struct s__main__sn_abs_cover_test **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_abs_cover_test;
#define d__l__main__sn_abs_cover_test 3695   

typedef l__main__sn_abs_cover_test l__sn_abs_cover_test;
#define d__l__sn_abs_cover_test d__l__main__sn_abs_cover_test

/* l__main__sn_cover_exp */ 
typedef struct s__l__main__sn_cover_exp {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cover_exp;
#define d__l__main__sn_cover_exp 3657   

typedef l__main__sn_cover_exp l__sn_cover_exp;
#define d__l__sn_cover_exp d__l__main__sn_cover_exp

/* k__main__sn_cvr_bucket_ran24609 */ 
typedef struct s__k__main__sn_cvr_bucket_24610 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_bucket_ran27195 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_cvr_bucket_ran24609;
#define d__k__main__sn_cvr_bucket_ran24609 3700   

typedef k__main__sn_cvr_bucket_ran24609 k__sn_cvr_bucket_rank_desc27233;
#define d__k__sn_cvr_bucket_rank_desc27233 d__k__main__sn_cvr_bucket_ran24609

/* l__main__sn_cvr_bucket */ 
typedef struct s__l__main__sn_cvr_bucket {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_bucket **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_bucket;
#define d__l__main__sn_cvr_bucket 7448   

typedef l__main__sn_cvr_bucket l__sn_cvr_bucket;
#define d__l__sn_cvr_bucket d__l__main__sn_cvr_bucket

/* k__main__sn_cvr_ignore_buc71562 */ 
typedef struct s__k__main__sn_cvr_ignore_75079 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_ignore_bucket **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_cvr_ignore_buc71562;
#define d__k__main__sn_cvr_ignore_buc71562 7454   

typedef k__main__sn_cvr_ignore_buc71562 k__sn_cvr_ignore_bucket__u75080;
#define d__k__sn_cvr_ignore_bucket__u75080 d__k__main__sn_cvr_ignore_buc71562

/* l__main__sn_cvr_item_attributes */ 
typedef struct s__l__main__sn_cvr_item_at27171 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_item_attributes **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_item_attributes;
#define d__l__main__sn_cvr_item_attributes 3651   

typedef l__main__sn_cvr_item_attributes l__sn_cvr_item_attributes;
#define d__l__sn_cvr_item_attributes d__l__main__sn_cvr_item_attributes

/* l__bool__8 */ 
typedef struct s__l__bool__8 {
    t__int d__;
    t__int gen__;
    t__bool__8*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__bool__8;
#define d__l__bool__8 3722   


/* l__main__sn_cvr_abstract_i26480 */ 
typedef struct s__l__main__sn_cvr_abstrac27172 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_abstract_i24144 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_abstract_i26480;
#define d__l__main__sn_cvr_abstract_i26480 3666   

typedef l__main__sn_cvr_abstract_i26480 l__sn_cvr_abstract_instanc27249;
#define d__l__sn_cvr_abstract_instanc27249 d__l__main__sn_cvr_abstract_i26480

/* l__sn__wave_event_element */ 
typedef struct s__l__sn__wave_event_element {
    t__int d__;
    t__int gen__;
    struct s__sn__wave_event_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__wave_event_element;
#define d__l__sn__wave_event_element 4352   

typedef l__sn__wave_event_element l__wave_event_element;
#define d__l__wave_event_element d__l__sn__wave_event_element

/* l__sn__abs_wave_entry */ 
typedef struct s__l__sn__abs_wave_entry {
    t__int d__;
    t__int gen__;
    struct s__sn__abs_wave_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__abs_wave_entry;
#define d__l__sn__abs_wave_entry 4335   

typedef l__sn__abs_wave_entry l__abs_wave_entry;
#define d__l__abs_wave_entry d__l__sn__abs_wave_entry

/* l__sn__cover_descriptor */ 
typedef struct s__l__sn__cover_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__cover_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cover_descriptor;
#define d__l__sn__cover_descriptor 168   

typedef l__sn__cover_descriptor l__cover_descriptor;
#define d__l__cover_descriptor d__l__sn__cover_descriptor

/* l__sn__constraint_descriptor */ 
typedef struct s__l__sn__constraint_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__constraint_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__constraint_descriptor;
#define d__l__sn__constraint_descriptor 167   

typedef l__sn__constraint_descriptor l__constraint_descriptor;
#define d__l__constraint_descriptor d__l__sn__constraint_descriptor

/* l__sn__context_item */ 
typedef struct s__l__sn__context_item {
    t__int d__;
    t__int gen__;
    struct s__sn__context_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__context_item;
#define d__l__sn__context_item 258   

typedef l__sn__context_item l__context_item;
#define d__l__context_item d__l__sn__context_item

/* l__sn__temp_field */ 
typedef struct s__l__sn__temp_field {
    t__int d__;
    t__int gen__;
    struct s__sn__temp_field **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__temp_field;
#define d__l__sn__temp_field 2000   

typedef l__sn__temp_field l__temp_field;
#define d__l__temp_field d__l__sn__temp_field

/* l__sn__gen_constraint */ 
typedef struct s__l__sn__gen_constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_constraint;
#define d__l__sn__gen_constraint 47   

typedef l__sn__gen_constraint l__gen_constraint;
#define d__l__gen_constraint d__l__sn__gen_constraint

/* l__sn__field_holder */ 
typedef struct s__l__sn__field_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__field_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__field_holder;
#define d__l__sn__field_holder 2013   

typedef l__sn__field_holder l__field_holder;
#define d__l__field_holder d__l__sn__field_holder

/* l__sn__gc_order_info */ 
typedef struct s__l__sn__gc_order_info {
    t__int d__;
    t__int gen__;
    struct s__sn__gc_order_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gc_order_info;
#define d__l__sn__gc_order_info 2058   

typedef l__sn__gc_order_info l__gc_order_info;
#define d__l__gc_order_info d__l__sn__gc_order_info

/* k__sn__constraint_path__it */ 
typedef struct s__k__sn__constraint_path__it {
    t__int d__;
    t__int gen__;
    struct s__sn__constraint_path **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__constraint_path__it;
#define d__k__sn__constraint_path__it 2059   

typedef k__sn__constraint_path__it k__constraint_path__it;
#define d__k__constraint_path__it d__k__sn__constraint_path__it

/* k__sn__field__it */ 
typedef struct s__k__sn__field__it {
    t__int d__;
    t__int gen__;
    struct s__sn__field **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__field__it;
#define d__k__sn__field__it 1999   

typedef k__sn__field__it k__field__it;
#define d__k__field__it d__k__sn__field__it

/* l__bool */ 
typedef struct s__l__bool {
    t__int d__;
    t__int gen__;
    t__bool*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__bool;
#define d__l__bool 102   


/* l__sn__a_role */ 
typedef struct s__l__sn__a_role {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__a_role;
#define d__l__sn__a_role 2014   

typedef l__sn__a_role l__a_role;
#define d__l__a_role d__l__sn__a_role

/* l__sn__om_edge */ 
typedef struct s__l__sn__om_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__om_edge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__om_edge;
#define d__l__sn__om_edge 5656   

typedef l__sn__om_edge l__om_edge;
#define d__l__om_edge d__l__sn__om_edge

/* l__sn__om_alt_edge */ 
typedef struct s__l__sn__om_alt_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__om_alt_edge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__om_alt_edge;
#define d__l__sn__om_alt_edge 5804   

typedef l__sn__om_alt_edge l__om_alt_edge;
#define d__l__om_alt_edge d__l__sn__om_alt_edge

/* l__sn__om_edge_reason */ 
typedef struct s__l__sn__om_edge_reason {
    t__int d__;
    t__int gen__;
    t__sn__om_edge_reason*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__om_edge_reason;
#define d__l__sn__om_edge_reason 5658   

typedef l__sn__om_edge_reason l__om_edge_reason;
#define d__l__om_edge_reason d__l__sn__om_edge_reason

/* k__sn__field_gen_role__id */ 
typedef struct s__k__sn__field_gen_role__id {
    t__int d__;
    t__int gen__;
    struct s__sn__field_gen_role **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__field_gen_role__id;
#define d__k__sn__field_gen_role__id 5663   

typedef k__sn__field_gen_role__id k__field_gen_role__id;
#define d__k__field_gen_role__id d__k__sn__field_gen_role__id

/* l__sn__status_in_role */ 
typedef struct s__l__sn__status_in_role {
    t__int d__;
    t__int gen__;
    t__sn__status_in_role*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__status_in_role;
#define d__l__sn__status_in_role 5659   

typedef l__sn__status_in_role l__status_in_role;
#define d__l__status_in_role d__l__sn__status_in_role

/* k__sn__role_gc_stat__gc */ 
typedef struct s__k__sn__role_gc_stat__gc {
    t__int d__;
    t__int gen__;
    struct s__sn__role_gc_stat **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__role_gc_stat__gc;
#define d__k__sn__role_gc_stat__gc 5660   

typedef k__sn__role_gc_stat__gc k__role_gc_stat__gc;
#define d__k__role_gc_stat__gc d__k__sn__role_gc_stat__gc

/* k__sn__gc_last_reduction__gc */ 
typedef struct s__k__sn__gc_last_reduction__gc {
    t__int d__;
    t__int gen__;
    struct s__sn__gc_last_reduction **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gc_last_reduction__gc;
#define d__k__sn__gc_last_reduction__gc 5661   

typedef k__sn__gc_last_reduction__gc k__gc_last_reduction__gc;
#define d__k__gc_last_reduction__gc d__k__sn__gc_last_reduction__gc

/* l__sn__when_det_info */ 
typedef struct s__l__sn__when_det_info {
    t__int d__;
    t__int gen__;
    struct s__sn__when_det_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__when_det_info;
#define d__l__sn__when_det_info 5864   

typedef l__sn__when_det_info l__when_det_info;
#define d__l__when_det_info d__l__sn__when_det_info

/* k__sn__subtype_descriptor__it */ 
typedef struct s__k__sn__subtype_descript48789 {
    t__int d__;
    t__int gen__;
    struct s__sn__subtype_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__subtype_descriptor__it;
#define d__k__sn__subtype_descriptor__it 5865   

typedef k__sn__subtype_descriptor__it k__subtype_descriptor__it;
#define d__k__subtype_descriptor__it d__k__sn__subtype_descriptor__it

/* l__sn__final_fgr_info_none */ 
typedef struct s__l__sn__final_fgr_info_none {
    t__int d__;
    t__int gen__;
    struct s__sn__final_fgr_info_none **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__final_fgr_info_none;
#define d__l__sn__final_fgr_info_none 5857   

typedef l__sn__final_fgr_info_none l__final_fgr_info_none;
#define d__l__final_fgr_info_none d__l__sn__final_fgr_info_none

/* l__sn__gen_command */ 
typedef struct s__l__sn__gen_command {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_command **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_command;
#define d__l__sn__gen_command 5858   

typedef l__sn__gen_command l__gen_command;
#define d__l__gen_command d__l__sn__gen_command

/* k__sn__init_graph_gen_comm48335 */ 
typedef struct s__k__sn__init_graph_gen_c48777 {
    t__int d__;
    t__int gen__;
    struct s__sn__init_graph_gen_command **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__init_graph_gen_comm48335;
#define d__k__sn__init_graph_gen_comm48335 5862   

typedef k__sn__init_graph_gen_comm48335 k__init_graph_gen_command__sd;
#define d__k__init_graph_gen_command__sd d__k__sn__init_graph_gen_comm48335

/* k__sn__final_fgr_info_none__f */ 
typedef struct s__k__sn__final_fgr_info_n48794 {
    t__int d__;
    t__int gen__;
    struct s__sn__final_fgr_info_none **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__final_fgr_info_none__f;
#define d__k__sn__final_fgr_info_none__f 5861   

typedef k__sn__final_fgr_info_none__f k__final_fgr_info_none__f;
#define d__k__final_fgr_info_none__f d__k__sn__final_fgr_info_none__f

/* l__sn__gc_holder */ 
typedef struct s__l__sn__gc_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__gc_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gc_holder;
#define d__l__sn__gc_holder 5860   

typedef l__sn__gc_holder l__gc_holder;
#define d__l__gc_holder d__l__sn__gc_holder

/* k__sn__index__it */ 
typedef struct s__k__sn__index__it {
    t__int d__;
    t__int gen__;
    t__sn__index*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__index__it;
#define d__k__sn__index__it 2099   

typedef k__sn__index__it k__index__it;
#define d__k__index__it d__k__sn__index__it

/* l__sn__subtype_descriptor */ 
typedef struct s__l__sn__subtype_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__subtype_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__subtype_descriptor;
#define d__l__sn__subtype_descriptor 1093   

typedef l__sn__subtype_descriptor l__subtype_descriptor;
#define d__l__subtype_descriptor d__l__sn__subtype_descriptor

/* l__reflection__rf_like_struct */ 
typedef struct s__l__reflection__rf_like_s7790 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_like_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_like_struct;
#define d__l__reflection__rf_like_struct 1786   

typedef l__reflection__rf_like_struct l__rf_like_struct;
#define d__l__rf_like_struct d__l__reflection__rf_like_struct

/* l__reflection__rf_field */ 
typedef struct s__l__reflection__rf_field {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_field **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_field;
#define d__l__reflection__rf_field 1780   

typedef l__reflection__rf_field l__rf_field;
#define d__l__rf_field d__l__reflection__rf_field

/* k__sn__when_tree_node__value */ 
typedef struct s__k__sn__when_tree_node__value {
    t__int d__;
    t__int gen__;
    struct s__sn__when_tree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__when_tree_node__value;
#define d__k__sn__when_tree_node__value 1092   

typedef k__sn__when_tree_node__value k__when_tree_node__value;
#define d__k__when_tree_node__value d__k__sn__when_tree_node__value

/* l__sn__macro_descriptor */ 
typedef struct s__l__sn__macro_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__macro_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__macro_descriptor;
#define d__l__sn__macro_descriptor 263   

typedef l__sn__macro_descriptor l__macro_descriptor;
#define d__l__macro_descriptor d__l__sn__macro_descriptor

/* l__sn__sub_nt */ 
typedef struct s__l__sn__sub_nt {
    t__int d__;
    t__int gen__;
    struct s__sn__sub_nt **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sub_nt;
#define d__l__sn__sub_nt 267   

typedef l__sn__sub_nt l__sub_nt;
#define d__l__sub_nt d__l__sn__sub_nt

/* l__sn__ntv */ 
typedef struct s__l__sn__ntv {
    t__int d__;
    t__int gen__;
    struct s__sn__ntv **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__ntv;
#define d__l__sn__ntv 54   

typedef l__sn__ntv l__ntv;
#define d__l__ntv d__l__sn__ntv

/* l__sn__any_rl */ 
typedef struct s__l__sn__any_rl {
    t__int d__;
    t__int gen__;
    struct s__sn__any_rl **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__any_rl;
#define d__l__sn__any_rl 2062   

typedef l__sn__any_rl l__any_rl;
#define d__l__any_rl d__l__sn__any_rl

/* l__sn__constraint_path */ 
typedef struct s__l__sn__constraint_path {
    t__int d__;
    t__int gen__;
    struct s__sn__constraint_path **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__constraint_path;
#define d__l__sn__constraint_path 2060   

typedef l__sn__constraint_path l__constraint_path;
#define d__l__constraint_path d__l__sn__constraint_path

/* l__sn__soft_gc */ 
typedef struct s__l__sn__soft_gc {
    t__int d__;
    t__int gen__;
    struct s__sn__soft_gc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__soft_gc;
#define d__l__sn__soft_gc 2064   

typedef l__sn__soft_gc l__soft_gc;
#define d__l__soft_gc d__l__sn__soft_gc

/* l__sn__hdl_element */ 
typedef struct s__l__sn__hdl_element {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__hdl_element;
#define d__l__sn__hdl_element 2245   

typedef l__sn__hdl_element l__hdl_element;
#define d__l__hdl_element d__l__sn__hdl_element

/* k__sn__desc_info__the_desc */ 
typedef struct s__k__sn__desc_info__the_desc {
    t__int d__;
    t__int gen__;
    struct s__sn__desc_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__desc_info__the_desc;
#define d__k__sn__desc_info__the_desc 2247   

typedef k__sn__desc_info__the_desc k__desc_info__the_desc;
#define d__k__desc_info__the_desc d__k__sn__desc_info__the_desc

/* k__sn__driver_handle__inst_id */ 
typedef struct s__k__sn__driver_handle__i14580 {
    t__int d__;
    t__int gen__;
    struct s__sn__driver_handle **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__driver_handle__inst_id;
#define d__k__sn__driver_handle__inst_id 2263   

typedef k__sn__driver_handle__inst_id k__driver_handle__inst_id;
#define d__k__driver_handle__inst_id d__k__sn__driver_handle__inst_id

/* l__uint */ 
typedef struct s__l__uint {
    t__int d__;
    t__int gen__;
    t__uint*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__uint;
#define d__l__uint 229   


/* l__source_ref */ 
typedef struct s__l__source_ref {
    t__int d__;
    t__int gen__;
    t__source_ref*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__source_ref;
#define d__l__source_ref 1071   


/* l__sn__any_port_cb_list_item */ 
typedef struct s__l__sn__any_port_cb_list_item {
    t__int d__;
    t__int gen__;
    struct s__sn__any_port_cb_list_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__any_port_cb_list_item;
#define d__l__sn__any_port_cb_list_item 1211   

typedef l__sn__any_port_cb_list_item l__any_port_cb_list_item;
#define d__l__any_port_cb_list_item d__l__sn__any_port_cb_list_item

/* k__sn__port_cb_reason_and_61203 */ 
typedef struct s__k__sn__port_cb_reason_a61204 {
    t__int d__;
    t__int gen__;
    struct s__sn__port_cb_reason_and_id **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__port_cb_reason_and_61203;
#define d__k__sn__port_cb_reason_and_61203 6881   

typedef k__sn__port_cb_reason_and_61203 k__port_cb_reason_and_id__id;
#define d__k__port_cb_reason_and_id__id d__k__sn__port_cb_reason_and_61203

/* l__e_core__any_simple_port */ 
typedef struct s__l__e_core__any_simple_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_simple_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_simple_port;
#define d__l__e_core__any_simple_port 2268   

typedef l__e_core__any_simple_port l__any_simple_port;
#define d__l__any_simple_port d__l__e_core__any_simple_port

/* l__sn__sn_event_done_wrapper */ 
typedef struct s__l__sn__sn_event_done_wrapper {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_event_done_wrapper **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_event_done_wrapper;
#define d__l__sn__sn_event_done_wrapper 2269   

typedef l__sn__sn_event_done_wrapper l__sn_event_done_wrapper;
#define d__l__sn_event_done_wrapper d__l__sn__sn_event_done_wrapper

/* l__e_core__any_buffer_port */ 
typedef struct s__l__e_core__any_buffer_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_buffer_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_buffer_port;
#define d__l__e_core__any_buffer_port 2270   

typedef l__e_core__any_buffer_port l__any_buffer_port;
#define d__l__any_buffer_port d__l__e_core__any_buffer_port

/* l__sn__wait_entry */ 
typedef struct s__l__sn__wait_entry {
    t__int d__;
    t__int gen__;
    struct s__sn__wait_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__wait_entry;
#define d__l__sn__wait_entry 2812   

typedef l__sn__wait_entry l__wait_entry;
#define d__l__wait_entry d__l__sn__wait_entry

/* l__untyped */ 
typedef struct s__l__untyped {
    t__int d__;
    t__int gen__;
    t__untyped*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__untyped;
#define d__l__untyped 113   


/* l__bool__32 */ 
typedef struct s__l__bool__32 {
    t__int d__;
    t__int gen__;
    t__bool__32*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__bool__32;
#define d__l__bool__32 2788   


/* l__sn_fl__counter_list */ 
typedef struct s__l__sn_fl__counter_list {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__counter_list **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__counter_list;
#define d__l__sn_fl__counter_list 2789   

typedef l__sn_fl__counter_list l__counter_list;
#define d__l__counter_list d__l__sn_fl__counter_list

/* l__sn__tick_port */ 
typedef struct s__l__sn__tick_port {
    t__int d__;
    t__int gen__;
    struct s__sn__tick_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__tick_port;
#define d__l__sn__tick_port 2271   

typedef l__sn__tick_port l__tick_port;
#define d__l__tick_port d__l__sn__tick_port

/* l__sn__instance_path_t */ 
typedef struct s__l__sn__instance_path_t {
    t__int d__;
    t__int gen__;
    struct s__sn__instance_path_t **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__instance_path_t;
#define d__l__sn__instance_path_t 2272   

typedef l__sn__instance_path_t l__instance_path_t;
#define d__l__instance_path_t d__l__sn__instance_path_t

/* l__sn__any_adapter_unit */ 
typedef struct s__l__sn__any_adapter_unit {
    t__int d__;
    t__int gen__;
    struct s__sn__any_adapter_unit **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__any_adapter_unit;
#define d__l__sn__any_adapter_unit 7084   

typedef l__sn__any_adapter_unit l__any_adapter_unit;
#define d__l__any_adapter_unit d__l__sn__any_adapter_unit

/* l__sn__sn_basic_time */ 
typedef struct s__l__sn__sn_basic_time {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_basic_time **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_basic_time;
#define d__l__sn__sn_basic_time 6707   

typedef l__sn__sn_basic_time l__sn_basic_time;
#define d__l__sn_basic_time d__l__sn__sn_basic_time

/* k__sn__driver_proc_struct_63873 */ 
typedef struct s__k__sn__driver_proc_stru68952 {
    t__int d__;
    t__int gen__;
    struct s__sn__driver_proc_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__driver_proc_struct_63873;
#define d__k__sn__driver_proc_struct_63873 6986   

typedef k__sn__driver_proc_struct_63873 k__driver_proc_struct__port_id;
#define d__k__driver_proc_struct__port_id d__k__sn__driver_proc_struct_63873

/* k__sn__sim_net_struct__sim63875 */ 
typedef struct s__k__sn__sim_net_struct__68953 {
    t__int d__;
    t__int gen__;
    struct s__sn__sim_net_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sim_net_struct__sim63875;
#define d__k__sn__sim_net_struct__sim63875 6987   

typedef k__sn__sim_net_struct__sim63875 k__sim_net_struct__sim_net_hand;
#define d__k__sim_net_struct__sim_net_hand d__k__sn__sim_net_struct__sim63875

/* k__sn__module__name */ 
typedef struct s__k__sn__module__name {
    t__int d__;
    t__int gen__;
    struct s__sn__module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__module__name;
#define d__k__sn__module__name 42   

typedef k__sn__module__name k__module__name;
#define d__k__module__name d__k__sn__module__name

/* l__sn__erm_packages_req_ve75837 */ 
typedef struct s__l__sn__erm_packages_req80362 {
    t__int d__;
    t__int gen__;
    struct s__sn__erm_packages_req_ve80375 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__erm_packages_req_ve75837;
#define d__l__sn__erm_packages_req_ve75837 7680   

typedef l__sn__erm_packages_req_ve75837 l__erm_packages_req_versions;
#define d__l__erm_packages_req_versions d__l__sn__erm_packages_req_ve75837

/* l__sn__erm_package_convert75838 */ 
typedef struct s__l__sn__erm_package_conv80376 {
    t__int d__;
    t__int gen__;
    struct s__sn__erm_package_convert75618 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__erm_package_convert75838;
#define d__l__sn__erm_package_convert75838 7684   

typedef l__sn__erm_package_convert75838 l__erm_package_converted_r80377;
#define d__l__erm_package_converted_r80377 d__l__sn__erm_package_convert75838

/* k__sn__module__it */ 
typedef struct s__k__sn__module__it {
    t__int d__;
    t__int gen__;
    struct s__sn__module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__module__it;
#define d__k__sn__module__it 7681   

typedef k__sn__module__it k__module__it;
#define d__k__module__it d__k__sn__module__it

/* l__sn__sn_erm_package_desc75702 */ 
typedef struct s__l__sn__sn_erm_package_d80383 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_erm_package_descri480 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_erm_package_desc75702;
#define d__l__sn__sn_erm_package_desc75702 7691   

typedef l__sn__sn_erm_package_desc75702 l__sn_erm_package_descriptor;
#define d__l__sn_erm_package_descriptor d__l__sn__sn_erm_package_desc75702

/* l__sn__sn_erm_req_error */ 
typedef struct s__l__sn__sn_erm_req_error {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_erm_req_error **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_erm_req_error;
#define d__l__sn__sn_erm_req_error 7702   

typedef l__sn__sn_erm_req_error l__sn_erm_req_error;
#define d__l__sn_erm_req_error d__l__sn__sn_erm_req_error

/* k__sn__pp_module__name */ 
typedef struct s__k__sn__pp_module__name {
    t__int d__;
    t__int gen__;
    struct s__sn__pp_module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__pp_module__name;
#define d__k__sn__pp_module__name 43   

typedef k__sn__pp_module__name k__pp_module__name;
#define d__k__pp_module__name d__k__sn__pp_module__name

/* l__sn__pp_module */ 
typedef struct s__l__sn__pp_module {
    t__int d__;
    t__int gen__;
    struct s__sn__pp_module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__pp_module;
#define d__l__sn__pp_module 436   

typedef l__sn__pp_module l__pp_module;
#define d__l__pp_module d__l__sn__pp_module

/* k__sn__package_descriptor__name */ 
typedef struct s__k__sn__package_descriptor476 {
    t__int d__;
    t__int gen__;
    struct s__sn__package_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__package_descriptor__name;
#define d__k__sn__package_descriptor__name 44   

typedef k__sn__package_descriptor__name k__package_descriptor__name;
#define d__k__package_descriptor__name d__k__sn__package_descriptor__name

/* k__sn__routine__name */ 
typedef struct s__k__sn__routine__name {
    t__int d__;
    t__int gen__;
    struct s__sn__routine **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__routine__name;
#define d__k__sn__routine__name 46   

typedef k__sn__routine__name k__routine__name;
#define d__k__routine__name d__k__sn__routine__name

/* k__sn__token_descriptor__name */ 
typedef struct s__k__sn__token_descriptor__477 {
    t__int d__;
    t__int gen__;
    struct s__sn__token_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__token_descriptor__name;
#define d__k__sn__token_descriptor__name 49   

typedef k__sn__token_descriptor__name k__token_descriptor__name;
#define d__k__token_descriptor__name d__k__sn__token_descriptor__name

/* l__sn__sn_vec */ 
typedef struct s__l__sn__sn_vec {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_vec **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_vec;
#define d__l__sn__sn_vec 52   

typedef l__sn__sn_vec l__sn_vec;
#define d__l__sn_vec d__l__sn__sn_vec

/* k__e_core__both__long_str */ 
typedef struct s__k__e_core__both__long_str {
    t__int d__;
    t__int gen__;
    struct s__e_core__both **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__both__long_str;
#define d__k__e_core__both__long_str 75   

typedef k__e_core__both__long_str k__both__long_str;
#define d__k__both__long_str d__k__e_core__both__long_str

/* l__e_core__real */ 
typedef struct s__l__e_core__real {
    t__int d__;
    t__int gen__;
    struct s__e_core__real **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__real;
#define d__l__e_core__real 71   

typedef l__e_core__real l__real;
#define d__l__real d__l__e_core__real

/* k__sn__type_descriptor__it */ 
typedef struct s__k__sn__type_descriptor__it {
    t__int d__;
    t__int gen__;
    struct s__sn__type_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__type_descriptor__it;
#define d__k__sn__type_descriptor__it 53   

typedef k__sn__type_descriptor__it k__type_descriptor__it;
#define d__k__type_descriptor__it d__k__sn__type_descriptor__it

/* k__sn__sn_exception__name */ 
typedef struct s__k__sn__sn_exception__name {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_exception **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_exception__name;
#define d__k__sn__sn_exception__name 415   

typedef k__sn__sn_exception__name k__sn_exception__name;
#define d__k__sn_exception__name d__k__sn__sn_exception__name

/* l__sn__sn_exception_data */ 
typedef struct s__l__sn__sn_exception_data {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_exception_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_exception_data;
#define d__l__sn__sn_exception_data 416   

typedef l__sn__sn_exception_data l__sn_exception_data;
#define d__l__sn_exception_data d__l__sn__sn_exception_data

/* k__e_core__vertice__name */ 
typedef struct s__k__e_core__vertice__name {
    t__int d__;
    t__int gen__;
    struct s__e_core__vertice **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__vertice__name;
#define d__k__e_core__vertice__name 28   

typedef k__e_core__vertice__name k__vertice__name;
#define d__k__vertice__name d__k__e_core__vertice__name

/* l__e_core__vertice */ 
typedef struct s__l__e_core__vertice {
    t__int d__;
    t__int gen__;
    struct s__e_core__vertice **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__vertice;
#define d__l__e_core__vertice 22   

typedef l__e_core__vertice l__vertice;
#define d__l__vertice d__l__e_core__vertice

/* l__sn__cyclic_import_pair */ 
typedef struct s__l__sn__cyclic_import_pair {
    t__int d__;
    t__int gen__;
    struct s__sn__cyclic_import_pair **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cyclic_import_pair;
#define d__l__sn__cyclic_import_pair 1716   

typedef l__sn__cyclic_import_pair l__cyclic_import_pair;
#define d__l__cyclic_import_pair d__l__sn__cyclic_import_pair

/* l__e_core__scc_item */ 
typedef struct s__l__e_core__scc_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__scc_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__scc_item;
#define d__l__e_core__scc_item 26   

typedef l__e_core__scc_item l__scc_item;
#define d__l__scc_item d__l__e_core__scc_item

/* l__byte */ 
typedef struct s__l__byte {
    t__int d__;
    t__int gen__;
    t__byte*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__byte;
#define d__l__byte 117   


/* l__sn__interval_set */ 
typedef struct s__l__sn__interval_set {
    t__int d__;
    t__int gen__;
    struct s__sn__interval_set **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__interval_set;
#define d__l__sn__interval_set 988   

typedef l__sn__interval_set l__interval_set;
#define d__l__interval_set d__l__sn__interval_set

/* l__sn__sn_uint_list_holder */ 
typedef struct s__l__sn__sn_uint_list_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_uint_list_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_uint_list_holder;
#define d__l__sn__sn_uint_list_holder 1013   

typedef l__sn__sn_uint_list_holder l__sn_uint_list_holder;
#define d__l__sn_uint_list_holder d__l__sn__sn_uint_list_holder

/* l__sn__sn_string_list_holder */ 
typedef struct s__l__sn__sn_string_list_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_string_list_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_string_list_holder;
#define d__l__sn__sn_string_list_holder 1014   

typedef l__sn__sn_string_list_holder l__sn_string_list_holder;
#define d__l__sn_string_list_holder d__l__sn__sn_string_list_holder

/* l__sn__sn_struct_list_holder */ 
typedef struct s__l__sn__sn_struct_list_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_struct_list_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_struct_list_holder;
#define d__l__sn__sn_struct_list_holder 484   

typedef l__sn__sn_struct_list_holder l__sn_struct_list_holder;
#define d__l__sn_struct_list_holder d__l__sn__sn_struct_list_holder

/* l__sn__sn_vec_list_holder */ 
typedef struct s__l__sn__sn_vec_list_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_vec_list_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_vec_list_holder;
#define d__l__sn__sn_vec_list_holder 1015   

typedef l__sn__sn_vec_list_holder l__sn_vec_list_holder;
#define d__l__sn_vec_list_holder d__l__sn__sn_vec_list_holder

/* l__sn__sn_double_list_holder */ 
typedef struct s__l__sn__sn_double_list_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_double_list_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_double_list_holder;
#define d__l__sn__sn_double_list_holder 1016   

typedef l__sn__sn_double_list_holder l__sn_double_list_holder;
#define d__l__sn_double_list_holder d__l__sn__sn_double_list_holder

/* k__sn__sn_copied_item__src */ 
typedef struct s__k__sn__sn_copied_item__src {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_copied_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_copied_item__src;
#define d__k__sn__sn_copied_item__src 1304   

typedef k__sn__sn_copied_item__src k__sn_copied_item__src;
#define d__k__sn_copied_item__src d__k__sn__sn_copied_item__src

/* k__e_core__any_struct__it */ 
typedef struct s__k__e_core__any_struct__it {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__any_struct__it;
#define d__k__e_core__any_struct__it 1012   

typedef k__e_core__any_struct__it k__any_struct__it;
#define d__k__any_struct__it d__k__e_core__any_struct__it

/* l__e_core__any_struct */ 
typedef struct s__l__e_core__any_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_struct;
#define d__l__e_core__any_struct 982   

typedef l__e_core__any_struct l__any_struct;
#define d__l__any_struct d__l__e_core__any_struct

/* l__sn__sn_basic_fields_iterator */ 
typedef struct s__l__sn__sn_basic_fields_i4195 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_basic_fields_iterator **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_basic_fields_iterator;
#define d__l__sn__sn_basic_fields_iterator 1298   

typedef l__sn__sn_basic_fields_iterator l__sn_basic_fields_iterator;
#define d__l__sn_basic_fields_iterator d__l__sn__sn_basic_fields_iterator

/* k__sn__option_list_descript4168 */ 
typedef struct s__k__sn__option_list_descr4169 {
    t__int d__;
    t__int gen__;
    struct s__sn__option_list_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__option_list_descript4168;
#define d__k__sn__option_list_descript4168 1497   

typedef k__sn__option_list_descript4168 k__option_list_descriptor__name;
#define d__k__option_list_descriptor__name d__k__sn__option_list_descript4168

/* l__sn__option_descriptor */ 
typedef struct s__l__sn__option_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__option_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__option_descriptor;
#define d__l__sn__option_descriptor 1494   

typedef l__sn__option_descriptor l__option_descriptor;
#define d__l__option_descriptor d__l__sn__option_descriptor

/* l__sn_rl__scalar_rl */ 
typedef struct s__l__sn_rl__scalar_rl {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__scalar_rl **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_rl__scalar_rl;
#define d__l__sn_rl__scalar_rl 1654   

typedef l__sn_rl__scalar_rl l__scalar_rl;
#define d__l__scalar_rl d__l__sn_rl__scalar_rl

/* l__sn__attr_handle */ 
typedef struct s__l__sn__attr_handle {
    t__int d__;
    t__int gen__;
    struct s__sn__attr_handle **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__attr_handle;
#define d__l__sn__attr_handle 2083   

typedef l__sn__attr_handle l__attr_handle;
#define d__l__attr_handle d__l__sn__attr_handle

/* l__sn__local_frame */ 
typedef struct s__l__sn__local_frame {
    t__int d__;
    t__int gen__;
    struct s__sn__local_frame **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__local_frame;
#define d__l__sn__local_frame 2097   

typedef l__sn__local_frame l__local_frame;
#define d__l__local_frame d__l__sn__local_frame

/* l__sn__local_item */ 
typedef struct s__l__sn__local_item {
    t__int d__;
    t__int gen__;
    struct s__sn__local_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__local_item;
#define d__l__sn__local_item 2096   

typedef l__sn__local_item l__local_item;
#define d__l__local_item d__l__sn__local_item

/* l__sn__me_constraint_path */ 
typedef struct s__l__sn__me_constraint_path {
    t__int d__;
    t__int gen__;
    struct s__sn__me_constraint_path **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__me_constraint_path;
#define d__l__sn__me_constraint_path 2098   

typedef l__sn__me_constraint_path l__me_constraint_path;
#define d__l__me_constraint_path d__l__sn__me_constraint_path

/* k__sn__field_type_relation11893 */ 
typedef struct s__k__sn__field_type_relat11894 {
    t__int d__;
    t__int gen__;
    struct s__sn__field_type_relation **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__field_type_relation11893;
#define d__k__sn__field_type_relation11893 2166   

typedef k__sn__field_type_relation11893 k__field_type_relation__field;
#define d__k__field_type_relation__field d__k__sn__field_type_relation11893

/* l__sn__struct_pair */ 
typedef struct s__l__sn__struct_pair {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_pair **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__struct_pair;
#define d__l__sn__struct_pair 2165   

typedef l__sn__struct_pair l__struct_pair;
#define d__l__struct_pair d__l__sn__struct_pair

/* l__sn__construct_keyword */ 
typedef struct s__l__sn__construct_keyword {
    t__int d__;
    t__int gen__;
    struct s__sn__construct_keyword **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__construct_keyword;
#define d__l__sn__construct_keyword 2741   

typedef l__sn__construct_keyword l__construct_keyword;
#define d__l__construct_keyword d__l__sn__construct_keyword

/* l__sn__te_header_desc */ 
typedef struct s__l__sn__te_header_desc {
    t__int d__;
    t__int gen__;
    struct s__sn__te_header_desc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__te_header_desc;
#define d__l__sn__te_header_desc 2791   

typedef l__sn__te_header_desc l__te_header_desc;
#define d__l__te_header_desc d__l__sn__te_header_desc

/* l__sn__macro_call_info */ 
typedef struct s__l__sn__macro_call_info {
    t__int d__;
    t__int gen__;
    struct s__sn__macro_call_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__macro_call_info;
#define d__l__sn__macro_call_info 4034   

typedef l__sn__macro_call_info l__macro_call_info;
#define d__l__macro_call_info d__l__sn__macro_call_info

/* k__sn__struct_threads__str32566 */ 
typedef struct s__k__sn__struct_threads__34125 {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_threads **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__struct_threads__str32566;
#define d__k__sn__struct_threads__str32566 4310   

typedef k__sn__struct_threads__str32566 k__struct_threads__struct_name;
#define d__k__struct_threads__struct_name d__k__sn__struct_threads__str32566

/* l__sn__tcm */ 
typedef struct s__l__sn__tcm {
    t__int d__;
    t__int gen__;
    struct s__sn__tcm **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__tcm;
#define d__l__sn__tcm 4309   

typedef l__sn__tcm l__tcm;
#define d__l__tcm d__l__sn__tcm

/* l__sn__tcm_body */ 
typedef struct s__l__sn__tcm_body {
    t__int d__;
    t__int gen__;
    struct s__sn__tcm_body **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__tcm_body;
#define d__l__sn__tcm_body 3104   

typedef l__sn__tcm_body l__tcm_body;
#define d__l__tcm_body d__l__sn__tcm_body

/* l__sn__sn_tcm_flow_graph_node */ 
typedef struct s__l__sn__sn_tcm_flow_grap21205 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_tcm_flow_graph_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_tcm_flow_graph_node;
#define d__l__sn__sn_tcm_flow_graph_node 3209   

typedef l__sn__sn_tcm_flow_graph_node l__sn_tcm_flow_graph_node;
#define d__l__sn_tcm_flow_graph_node d__l__sn__sn_tcm_flow_graph_node

/* l__sn__routine */ 
typedef struct s__l__sn__routine {
    t__int d__;
    t__int gen__;
    struct s__sn__routine **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__routine;
#define d__l__sn__routine 193   

typedef l__sn__routine l__routine;
#define d__l__routine d__l__sn__routine

/* l__sn__save_reduction_info */ 
typedef struct s__l__sn__save_reduction_info {
    t__int d__;
    t__int gen__;
    struct s__sn__save_reduction_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__save_reduction_info;
#define d__l__sn__save_reduction_info 5758   

typedef l__sn__save_reduction_info l__save_reduction_info;
#define d__l__save_reduction_info d__l__sn__save_reduction_info

/* l__sn__gendb_item */ 
typedef struct s__l__sn__gendb_item {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gendb_item;
#define d__l__sn__gendb_item 2145   

typedef l__sn__gendb_item l__gendb_item;
#define d__l__gendb_item d__l__sn__gendb_item

/* l__sn__field_gen_role */ 
typedef struct s__l__sn__field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__sn__field_gen_role **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__field_gen_role;
#define d__l__sn__field_gen_role 5825   

typedef l__sn__field_gen_role l__field_gen_role;
#define d__l__field_gen_role d__l__sn__field_gen_role

/* l__sn__which_rl */ 
typedef struct s__l__sn__which_rl {
    t__int d__;
    t__int gen__;
    t__sn__which_rl*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__which_rl;
#define d__l__sn__which_rl 5826   

typedef l__sn__which_rl l__which_rl;
#define d__l__which_rl d__l__sn__which_rl

/* l__sn__field_node */ 
typedef struct s__l__sn__field_node {
    t__int d__;
    t__int gen__;
    struct s__sn__field_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__field_node;
#define d__l__sn__field_node 5725   

typedef l__sn__field_node l__field_node;
#define d__l__field_node d__l__sn__field_node

/* l__sn__dangling_ci */ 
typedef struct s__l__sn__dangling_ci {
    t__int d__;
    t__int gen__;
    struct s__sn__dangling_ci **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__dangling_ci;
#define d__l__sn__dangling_ci 5706   

typedef l__sn__dangling_ci l__dangling_ci;
#define d__l__dangling_ci d__l__sn__dangling_ci

/* l__sn__sn_constraint_instance */ 
typedef struct s__l__sn__sn_constraint_in48781 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_constraint_instance **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_constraint_instance;
#define d__l__sn__sn_constraint_instance 5726   

typedef l__sn__sn_constraint_instance l__sn_constraint_instance;
#define d__l__sn_constraint_instance d__l__sn__sn_constraint_instance

/* l__sn__sn_me_cpi */ 
typedef struct s__l__sn__sn_me_cpi {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_me_cpi **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_me_cpi;
#define d__l__sn__sn_me_cpi 5902   

typedef l__sn__sn_me_cpi l__sn_me_cpi;
#define d__l__sn_me_cpi d__l__sn__sn_me_cpi

/* l__sn__deffered_gendb_item */ 
typedef struct s__l__sn__deffered_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__sn__deffered_gendb_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__deffered_gendb_item;
#define d__l__sn__deffered_gendb_item 6012   

typedef l__sn__deffered_gendb_item l__deffered_gendb_item;
#define d__l__deffered_gendb_item d__l__sn__deffered_gendb_item

/* l__sn__count */ 
typedef struct s__l__sn__count {
    t__int d__;
    t__int gen__;
    t__sn__count*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__count;
#define d__l__sn__count 2121   

typedef l__sn__count l__count;
#define d__l__count d__l__sn__count

/* l__sn__sn_cpi */ 
typedef struct s__l__sn__sn_cpi {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_cpi **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_cpi;
#define d__l__sn__sn_cpi 5719   

typedef l__sn__sn_cpi l__sn_cpi;
#define d__l__sn_cpi d__l__sn__sn_cpi

/* l__sn__attach_cpi_result */ 
typedef struct s__l__sn__attach_cpi_result {
    t__int d__;
    t__int gen__;
    struct s__sn__attach_cpi_result **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__attach_cpi_result;
#define d__l__sn__attach_cpi_result 6052   

typedef l__sn__attach_cpi_result l__attach_cpi_result;
#define d__l__attach_cpi_result d__l__sn__attach_cpi_result

/* k__sn__subtype_dangling_ci__sd */ 
typedef struct s__k__sn__subtype_dangling54690 {
    t__int d__;
    t__int gen__;
    struct s__sn__subtype_dangling_ci **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__subtype_dangling_ci__sd;
#define d__k__sn__subtype_dangling_ci__sd 6054   

typedef k__sn__subtype_dangling_ci__sd k__subtype_dangling_ci__sd;
#define d__k__subtype_dangling_ci__sd d__k__sn__subtype_dangling_ci__sd

/* l__sn_rl__uint_rl */ 
typedef struct s__l__sn_rl__uint_rl {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__uint_rl **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_rl__uint_rl;
#define d__l__sn_rl__uint_rl 1646   

typedef l__sn_rl__uint_rl l__uint_rl;
#define d__l__uint_rl d__l__sn_rl__uint_rl

/* l__sn_rl__int_rl */ 
typedef struct s__l__sn_rl__int_rl {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__int_rl **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_rl__int_rl;
#define d__l__sn_rl__int_rl 1675   

typedef l__sn_rl__int_rl l__int_rl;
#define d__l__int_rl d__l__sn_rl__int_rl

/* l__sn_rl__long_rl */ 
typedef struct s__l__sn_rl__long_rl {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__long_rl **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_rl__long_rl;
#define d__l__sn_rl__long_rl 1676   

typedef l__sn_rl__long_rl l__long_rl;
#define d__l__long_rl d__l__sn_rl__long_rl

/* l__sn_rl__struct_rl */ 
typedef struct s__l__sn_rl__struct_rl {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__struct_rl **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_rl__struct_rl;
#define d__l__sn_rl__struct_rl 1677   

typedef l__sn_rl__struct_rl l__struct_rl;
#define d__l__struct_rl d__l__sn_rl__struct_rl

/* l__sn_rl__string_rl */ 
typedef struct s__l__sn_rl__string_rl {
    t__int d__;
    t__int gen__;
    struct s__sn_rl__string_rl **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_rl__string_rl;
#define d__l__sn_rl__string_rl 1678   

typedef l__sn_rl__string_rl l__string_rl;
#define d__l__string_rl d__l__sn_rl__string_rl

/* l__sn__list_ci */ 
typedef struct s__l__sn__list_ci {
    t__int d__;
    t__int gen__;
    struct s__sn__list_ci **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__list_ci;
#define d__l__sn__list_ci 5724   

typedef l__sn__list_ci l__list_ci;
#define d__l__list_ci d__l__sn__list_ci

/* l__sn__sn_simple_constrain49744 */ 
typedef struct s__l__sn__sn_simple_constr49763 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_simple_constrain46815 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_simple_constrain49744;
#define d__l__sn__sn_simple_constrain49744 5904   

typedef l__sn__sn_simple_constrain49744 l__sn_simple_constraint_in49773;
#define d__l__sn_simple_constraint_in49773 d__l__sn__sn_simple_constrain49744

/* l__sn__sn_gen_event */ 
typedef struct s__l__sn__sn_gen_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_gen_event;
#define d__l__sn__sn_gen_event 6009   

typedef l__sn__sn_gen_event l__sn_gen_event;
#define d__l__sn_gen_event d__l__sn__sn_gen_event

/* l__sn__sn_soft_testing_event */ 
typedef struct s__l__sn__sn_soft_testing_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_soft_testing_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_soft_testing_event;
#define d__l__sn__sn_soft_testing_event 6041   

typedef l__sn__sn_soft_testing_event l__sn_soft_testing_event;
#define d__l__sn_soft_testing_event d__l__sn__sn_soft_testing_event

/* l__sn__sn_gendb_item */ 
typedef struct s__l__sn__sn_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gendb_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_gendb_item;
#define d__l__sn__sn_gendb_item 6005   

typedef l__sn__sn_gendb_item l__sn_gendb_item;
#define d__l__sn_gendb_item d__l__sn__sn_gendb_item

/* l__sn__sn_ci_status_changed */ 
typedef struct s__l__sn__sn_ci_status_changed {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_ci_status_changed **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_ci_status_changed;
#define d__l__sn__sn_ci_status_changed 6020   

typedef l__sn__sn_ci_status_changed l__sn_ci_status_changed;
#define d__l__sn_ci_status_changed d__l__sn__sn_ci_status_changed

/* l__sn__not_fix_me_gendb_item */ 
typedef struct s__l__sn__not_fix_me_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__sn__not_fix_me_gendb_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__not_fix_me_gendb_item;
#define d__l__sn__not_fix_me_gendb_item 6011   

typedef l__sn__not_fix_me_gendb_item l__not_fix_me_gendb_item;
#define d__l__not_fix_me_gendb_item d__l__sn__not_fix_me_gendb_item

/* k__sn__gendb_field_in_gen__f */ 
typedef struct s__k__sn__gendb_field_in_gen__f {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_field_in_gen **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gendb_field_in_gen__f;
#define d__k__sn__gendb_field_in_gen__f 6027   

typedef k__sn__gendb_field_in_gen__f k__gendb_field_in_gen__f;
#define d__k__gendb_field_in_gen__f d__k__sn__gendb_field_in_gen__f

/* k__sn__gendb_ci_in_gen__gc */ 
typedef struct s__k__sn__gendb_ci_in_gen__gc {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_ci_in_gen **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gendb_ci_in_gen__gc;
#define d__k__sn__gendb_ci_in_gen__gc 6028   

typedef k__sn__gendb_ci_in_gen__gc k__gendb_ci_in_gen__gc;
#define d__k__gendb_ci_in_gen__gc d__k__sn__gendb_ci_in_gen__gc

/* l__sn__gendb_ci_in_gen */ 
typedef struct s__l__sn__gendb_ci_in_gen {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_ci_in_gen **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gendb_ci_in_gen;
#define d__l__sn__gendb_ci_in_gen 6021   

typedef l__sn__gendb_ci_in_gen l__gendb_ci_in_gen;
#define d__l__gendb_ci_in_gen d__l__sn__gendb_ci_in_gen

/* k__sn__gendb_field_in_role__f */ 
typedef struct s__k__sn__gendb_field_in_r54775 {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_field_in_role **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gendb_field_in_role__f;
#define d__k__sn__gendb_field_in_role__f 6029   

typedef k__sn__gendb_field_in_role__f k__gendb_field_in_role__f;
#define d__k__gendb_field_in_role__f d__k__sn__gendb_field_in_role__f

/* l__sn__changed_static_gend49781 */ 
typedef struct s__l__sn__changed_static_g49782 {
    t__int d__;
    t__int gen__;
    struct s__sn__changed_static_gend50111 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__changed_static_gend49781;
#define d__l__sn__changed_static_gend49781 6004   

typedef l__sn__changed_static_gend49781 l__changed_static_gendb_item;
#define d__l__changed_static_gendb_item d__l__sn__changed_static_gend49781

/* l__sn__gendb_gc_in_role */ 
typedef struct s__l__sn__gendb_gc_in_role {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_gc_in_role **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gendb_gc_in_role;
#define d__l__sn__gendb_gc_in_role 6017   

typedef l__sn__gendb_gc_in_role l__gendb_gc_in_role;
#define d__l__gendb_gc_in_role d__l__sn__gendb_gc_in_role

/* k__sn__gendb_gc_in_role__gc */ 
typedef struct s__k__sn__gendb_gc_in_role__gc {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_gc_in_role **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gendb_gc_in_role__gc;
#define d__k__sn__gendb_gc_in_role__gc 6030   

typedef k__sn__gendb_gc_in_role__gc k__gendb_gc_in_role__gc;
#define d__k__gendb_gc_in_role__gc d__k__sn__gendb_gc_in_role__gc

/* l__sn__and_info */ 
typedef struct s__l__sn__and_info {
    t__int d__;
    t__int gen__;
    struct s__sn__and_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__and_info;
#define d__l__sn__and_info 5770   

typedef l__sn__and_info l__and_info;
#define d__l__and_info d__l__sn__and_info

/* l__sn__status_in_and */ 
typedef struct s__l__sn__status_in_and {
    t__int d__;
    t__int gen__;
    t__sn__status_in_and*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__status_in_and;
#define d__l__sn__status_in_and 5768   

typedef l__sn__status_in_and l__status_in_and;
#define d__l__status_in_and d__l__sn__status_in_and

/* l__sn__gen_constraint_range */ 
typedef struct s__l__sn__gen_constraint_range {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_range **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_constraint_range;
#define d__l__sn__gen_constraint_range 5766   

typedef l__sn__gen_constraint_range l__gen_constraint_range;
#define d__l__gen_constraint_range d__l__sn__gen_constraint_range

/* l__sn__gen_constraint_or */ 
typedef struct s__l__sn__gen_constraint_or {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_or **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_constraint_or;
#define d__l__sn__gen_constraint_or 5767   

typedef l__sn__gen_constraint_or l__gen_constraint_or;
#define d__l__gen_constraint_or d__l__sn__gen_constraint_or

/* l__sn__derived_or_info */ 
typedef struct s__l__sn__derived_or_info {
    t__int d__;
    t__int gen__;
    struct s__sn__derived_or_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__derived_or_info;
#define d__l__sn__derived_or_info 5771   

typedef l__sn__derived_or_info l__derived_or_info;
#define d__l__derived_or_info d__l__sn__derived_or_info

/* k__sn__or_info__gco */ 
typedef struct s__k__sn__or_info__gco {
    t__int d__;
    t__int gen__;
    struct s__sn__or_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__or_info__gco;
#define d__k__sn__or_info__gco 5772   

typedef k__sn__or_info__gco k__or_info__gco;
#define d__k__or_info__gco d__k__sn__or_info__gco

/* l__sn__status_in_or */ 
typedef struct s__l__sn__status_in_or {
    t__int d__;
    t__int gen__;
    t__sn__status_in_or*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__status_in_or;
#define d__l__sn__status_in_or 5769   

typedef l__sn__status_in_or l__status_in_or;
#define d__l__status_in_or d__l__sn__status_in_or

/* l__sn__composite_descriptor */ 
typedef struct s__l__sn__composite_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__composite_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__composite_descriptor;
#define d__l__sn__composite_descriptor 5745   

typedef l__sn__composite_descriptor l__composite_descriptor;
#define d__l__composite_descriptor d__l__sn__composite_descriptor

/* l__sn__sn_field_collector */ 
typedef struct s__l__sn__sn_field_collector {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_field_collector **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_field_collector;
#define d__l__sn__sn_field_collector 5823   

typedef l__sn__sn_field_collector l__sn_field_collector;
#define d__l__sn_field_collector d__l__sn__sn_field_collector

/* l__sn__computed_struct_list */ 
typedef struct s__l__sn__computed_struct_list {
    t__int d__;
    t__int gen__;
    struct s__sn__computed_struct_list **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__computed_struct_list;
#define d__l__sn__computed_struct_list 2236   

typedef l__sn__computed_struct_list l__computed_struct_list;
#define d__l__computed_struct_list d__l__sn__computed_struct_list

/* l__sn__computed_name */ 
typedef struct s__l__sn__computed_name {
    t__int d__;
    t__int gen__;
    struct s__sn__computed_name **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__computed_name;
#define d__l__sn__computed_name 2234   

typedef l__sn__computed_name l__computed_name;
#define d__l__computed_name d__l__sn__computed_name

/* l__sn__unit_instance_info */ 
typedef struct s__l__sn__unit_instance_info {
    t__int d__;
    t__int gen__;
    struct s__sn__unit_instance_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__unit_instance_info;
#define d__l__sn__unit_instance_info 2242   

typedef l__sn__unit_instance_info l__unit_instance_info;
#define d__l__unit_instance_info d__l__sn__unit_instance_info

/* k__sn__subprogram_handle__12407 */ 
typedef struct s__k__sn__subprogram_handl12408 {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_handle **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__subprogram_handle__12407;
#define d__k__sn__subprogram_handle__12407 2260   

typedef k__sn__subprogram_handle__12407 k__subprogram_handle__subp14586;
#define d__k__subprogram_handle__subp14586 d__k__sn__subprogram_handle__12407

/* l__sn__translated_model_struct */ 
typedef struct s__l__sn__translated_model14577 {
    t__int d__;
    t__int gen__;
    struct s__sn__translated_model_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__translated_model_struct;
#define d__l__sn__translated_model_struct 2239   

typedef l__sn__translated_model_struct l__translated_model_struct;
#define d__l__translated_model_struct d__l__sn__translated_model_struct

/* k__sn__desc_subprogram_inf12641 */ 
typedef struct s__k__sn__desc_subprogram_14581 {
    t__int d__;
    t__int gen__;
    struct s__sn__desc_subprogram_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__desc_subprogram_inf12641;
#define d__k__sn__desc_subprogram_inf12641 2251   

typedef k__sn__desc_subprogram_inf12641 k__desc_subprogram_info__u14582;
#define d__k__desc_subprogram_info__u14582 d__k__sn__desc_subprogram_inf12641

/* l__sn__subprogram_handle */ 
typedef struct s__l__sn__subprogram_handle {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_handle **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__subprogram_handle;
#define d__l__sn__subprogram_handle 2250   

typedef l__sn__subprogram_handle l__subprogram_handle;
#define d__l__subprogram_handle d__l__sn__subprogram_handle

/* l__sn__hdl_data_type */ 
typedef struct s__l__sn__hdl_data_type {
    t__int d__;
    t__int gen__;
    t__sn__hdl_data_type*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__hdl_data_type;
#define d__l__sn__hdl_data_type 2249   

typedef l__sn__hdl_data_type l__hdl_data_type;
#define d__l__hdl_data_type d__l__sn__hdl_data_type

/* l__sn__connecte_cell */ 
typedef struct s__l__sn__connecte_cell {
    t__int d__;
    t__int gen__;
    struct s__sn__connecte_cell **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__connecte_cell;
#define d__l__sn__connecte_cell 2252   

typedef l__sn__connecte_cell l__connecte_cell;
#define d__l__connecte_cell d__l__sn__connecte_cell

/* k__sn__hdl_struct__name */ 
typedef struct s__k__sn__hdl_struct__name {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__hdl_struct__name;
#define d__k__sn__hdl_struct__name 2262   

typedef k__sn__hdl_struct__name k__hdl_struct__name;
#define d__k__hdl_struct__name d__k__sn__hdl_struct__name

/* k__sn__hdl_full_type_desc_12688 */ 
typedef struct s__k__sn__hdl_full_type_de14565 {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_full_type_desc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__hdl_full_type_desc_12688;
#define d__k__sn__hdl_full_type_desc_12688 2243   

typedef k__sn__hdl_full_type_desc_12688 k__hdl_full_type_desc__ful14588;
#define d__k__hdl_full_type_desc__ful14588 d__k__sn__hdl_full_type_desc_12688

/* k__sn__hdl_cache_rf_subtyp14566 */ 
typedef struct s__k__sn__hdl_cache_rf_sub14567 {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_cache_rf_subtype **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__hdl_cache_rf_subtyp14566;
#define d__k__sn__hdl_cache_rf_subtyp14566 2244   

typedef k__sn__hdl_cache_rf_subtyp14566 k__hdl_cache_rf_subtype__b14589;
#define d__k__hdl_cache_rf_subtype__b14589 d__k__sn__hdl_cache_rf_subtyp14566

/* l__reflection__rf_struct */ 
typedef struct s__l__reflection__rf_struct {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_struct;
#define d__l__reflection__rf_struct 1785   

typedef l__reflection__rf_struct l__rf_struct;
#define d__l__rf_struct d__l__reflection__rf_struct

/* k__sn__subprogram_handle__12793 */ 
typedef struct s__k__sn__subprogram_handl14568 {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_handle **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__subprogram_handle__12793;
#define d__k__sn__subprogram_handle__12793 2254   

typedef k__sn__subprogram_handle__12793 k__subprogram_handle__subp14591;
#define d__k__subprogram_handle__subp14591 d__k__sn__subprogram_handle__12793

/* k__sn__subprogram_entry__s12791 */ 
typedef struct s__k__sn__subprogram_entry14569 {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__subprogram_entry__s12791;
#define d__k__sn__subprogram_entry__s12791 2255   

typedef k__sn__subprogram_entry__s12791 k__subprogram_entry__subpr14592;
#define d__k__subprogram_entry__subpr14592 d__k__sn__subprogram_entry__s12791

/* l__sn__subprogram_exp_info */ 
typedef struct s__l__sn__subprogram_exp_info {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_exp_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__subprogram_exp_info;
#define d__l__sn__subprogram_exp_info 2257   

typedef l__sn__subprogram_exp_info l__subprogram_exp_info;
#define d__l__subprogram_exp_info d__l__sn__subprogram_exp_info

/* l__sn__computed_subprogram_list */ 
typedef struct s__l__sn__computed_subprog14585 {
    t__int d__;
    t__int gen__;
    struct s__sn__computed_subprogram_list **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__computed_subprogram_list;
#define d__l__sn__computed_subprogram_list 2237   

typedef l__sn__computed_subprogram_list l__computed_subprogram_list;
#define d__l__computed_subprogram_list d__l__sn__computed_subprogram_list

/* l__sn__computed_subprogram_name */ 
typedef struct s__l__sn__computed_subprog14584 {
    t__int d__;
    t__int gen__;
    struct s__sn__computed_subprogram_name **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__computed_subprogram_name;
#define d__l__sn__computed_subprogram_name 2235   

typedef l__sn__computed_subprogram_name l__computed_subprogram_name;
#define d__l__computed_subprogram_name d__l__sn__computed_subprogram_name

/* k__e_core__any_unit__root_14571 */ 
typedef struct s__k__e_core__any_unit__ro14572 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_unit **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__any_unit__root_14571;
#define d__k__e_core__any_unit__root_14571 2278   

typedef k__e_core__any_unit__root_14571 k__any_unit__root___normal14594;
#define d__k__any_unit__root___normal14594 d__k__e_core__any_unit__root_14571

/* l__sn__sn_simple_def_channel */ 
typedef struct s__l__sn__sn_simple_def_channel {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_simple_def_channel **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_simple_def_channel;
#define d__l__sn__sn_simple_def_channel 6772   

typedef l__sn__sn_simple_def_channel l__sn_simple_def_channel;
#define d__l__sn_simple_def_channel d__l__sn__sn_simple_def_channel

/* l__vr_gsa__vr_gsa_unit */ 
typedef struct s__l__vr_gsa__vr_gsa_unit {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa__vr_gsa_unit **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa__vr_gsa_unit;
#define d__l__vr_gsa__vr_gsa_unit 9027   

typedef l__vr_gsa__vr_gsa_unit l__vr_gsa_unit;
#define d__l__vr_gsa_unit d__l__vr_gsa__vr_gsa_unit

/* l__sn__sn_dynamic_call */ 
typedef struct s__l__sn__sn_dynamic_call {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_dynamic_call **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_dynamic_call;
#define d__l__sn__sn_dynamic_call 2154   

typedef l__sn__sn_dynamic_call l__sn_dynamic_call;
#define d__l__sn_dynamic_call d__l__sn__sn_dynamic_call

/* l__vr_gsa__vr_gsa_basic_po99236 */ 
typedef struct s__l__vr_gsa__vr_gsa_basi100930 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa__vr_gsa_basic_p100932 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa__vr_gsa_basic_po99236;
#define d__l__vr_gsa__vr_gsa_basic_po99236 8987   

typedef l__vr_gsa__vr_gsa_basic_po99236 l__vr_gsa_basic_port_struct;
#define d__l__vr_gsa_basic_port_struct d__l__vr_gsa__vr_gsa_basic_po99236

/* l__vr_gsa_sw_debug__func_info */ 
typedef struct s__l__vr_gsa_sw_debug__fu100920 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__func_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa_sw_debug__func_info;
#define d__l__vr_gsa_sw_debug__func_info 8957   

typedef l__vr_gsa_sw_debug__func_info l__func_info;
#define d__l__func_info d__l__vr_gsa_sw_debug__func_info

/* l__vr_gsa_sw_debug__id_info */ 
typedef struct s__l__vr_gsa_sw_debug__id_info {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__id_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa_sw_debug__id_info;
#define d__l__vr_gsa_sw_debug__id_info 8958   

typedef l__vr_gsa_sw_debug__id_info l__id_info;
#define d__l__id_info d__l__vr_gsa_sw_debug__id_info

/* l__vr_gsa__vr_gsa_observer */ 
typedef struct s__l__vr_gsa__vr_gsa_observer {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa__vr_gsa_observer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa__vr_gsa_observer;
#define d__l__vr_gsa__vr_gsa_observer 8966   

typedef l__vr_gsa__vr_gsa_observer l__vr_gsa_observer;
#define d__l__vr_gsa_observer d__l__vr_gsa__vr_gsa_observer

/* l__reflection__rf_type */ 
typedef struct s__l__reflection__rf_type {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_type **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_type;
#define d__l__reflection__rf_type 1789   

typedef l__reflection__rf_type l__rf_type;
#define d__l__rf_type d__l__reflection__rf_type

/* l__vr_gsa__vr_gsa_mapping_value */ 
typedef struct s__l__vr_gsa__vr_gsa_mapp100933 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa__vr_gsa_mapping_value **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa__vr_gsa_mapping_value;
#define d__l__vr_gsa__vr_gsa_mapping_value 8999   

typedef l__vr_gsa__vr_gsa_mapping_value l__vr_gsa_mapping_value;
#define d__l__vr_gsa_mapping_value d__l__vr_gsa__vr_gsa_mapping_value

/* l__vr_gsa__vr_gsa_event_po99170 */ 
typedef struct s__l__vr_gsa__vr_gsa_event99171 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa__vr_gsa_event_p100934 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa__vr_gsa_event_po99170;
#define d__l__vr_gsa__vr_gsa_event_po99170 8988   

typedef l__vr_gsa__vr_gsa_event_po99170 l__vr_gsa_event_port_struct;
#define d__l__vr_gsa_event_port_struct d__l__vr_gsa__vr_gsa_event_po99170

/* l__vr_gsa__vr_gsa_method_p99164 */ 
typedef struct s__l__vr_gsa__vr_gsa_metho99165 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa__vr_gsa_method_p99181 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa__vr_gsa_method_p99164;
#define d__l__vr_gsa__vr_gsa_method_p99164 8989   

typedef l__vr_gsa__vr_gsa_method_p99164 l__vr_gsa_method_port_struct;
#define d__l__vr_gsa_method_port_struct d__l__vr_gsa__vr_gsa_method_p99164

/* l__reflection__rf_parameter */ 
typedef struct s__l__reflection__rf_parameter {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_parameter **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_parameter;
#define d__l__reflection__rf_parameter 1790   

typedef l__reflection__rf_parameter l__rf_parameter;
#define d__l__rf_parameter d__l__reflection__rf_parameter

/* l__sn__any_in_method_port */ 
typedef struct s__l__sn__any_in_method_port {
    t__int d__;
    t__int gen__;
    struct s__sn__any_in_method_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__any_in_method_port;
#define d__l__sn__any_in_method_port 6838   

typedef l__sn__any_in_method_port l__any_in_method_port;
#define d__l__any_in_method_port d__l__sn__any_in_method_port

/* k__sn__sv_when_hierarchy__69132 */ 
typedef struct s__k__sn__sv_when_hierarch69133 {
    t__int d__;
    t__int gen__;
    struct s__sn__sv_when_hierarchy **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sv_when_hierarchy__69132;
#define d__k__sn__sv_when_hierarchy__69132 7109   

typedef k__sn__sv_when_hierarchy__69132 k__sv_when_hierarchy__hier69140;
#define d__k__sv_when_hierarchy__hier69140 d__k__sn__sv_when_hierarchy__69132

/* l__reflection__rf_when_subtype */ 
typedef struct s__l__reflection__rf_when_s7796 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_when_subtype **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_when_subtype;
#define d__l__reflection__rf_when_subtype 1787   

typedef l__reflection__rf_when_subtype l__rf_when_subtype;
#define d__l__rf_when_subtype d__l__reflection__rf_when_subtype

/* k__sv_stub__sn_sv_when_sub69134 */ 
typedef struct s__k__sv_stub__sn_sv_when_69135 {
    t__int d__;
    t__int gen__;
    struct s__sv_stub__sn_sv_when_subtypes **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sv_stub__sn_sv_when_sub69134;
#define d__k__sv_stub__sn_sv_when_sub69134 7110   

typedef k__sv_stub__sn_sv_when_sub69134 k__sn_sv_when_subtypes__base;
#define d__k__sn_sv_when_subtypes__base d__k__sv_stub__sn_sv_when_sub69134

/* k__sv_stub__sn_sv_wst_pare69136 */ 
typedef struct s__k__sv_stub__sn_sv_wst_p69137 {
    t__int d__;
    t__int gen__;
    struct s__sv_stub__sn_sv_wst_pare69139 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sv_stub__sn_sv_wst_pare69136;
#define d__k__sv_stub__sn_sv_wst_pare69136 7111   

typedef k__sv_stub__sn_sv_wst_pare69136 k__sn_sv_wst_parent_info__wst;
#define d__k__sn_sv_wst_parent_info__wst d__k__sv_stub__sn_sv_wst_pare69136

/* l__sn__any_out_method_port */ 
typedef struct s__l__sn__any_out_method_port {
    t__int d__;
    t__int gen__;
    struct s__sn__any_out_method_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__any_out_method_port;
#define d__l__sn__any_out_method_port 6839   

typedef l__sn__any_out_method_port l__any_out_method_port;
#define d__l__any_out_method_port d__l__sn__any_out_method_port

/* k__sn__sn_method_port_even69031 */ 
typedef struct s__k__sn__sn_method_port_e69032 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_method_port_even60793 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_method_port_even69031;
#define d__k__sn__sn_method_port_even69031 6840   

typedef k__sn__sn_method_port_even69031 k__sn_method_port_event_do69036;
#define d__k__sn_method_port_event_do69036 d__k__sn__sn_method_port_even69031

/* l__vr_gsa__gsa_mailbox_state */ 
typedef struct s__l__vr_gsa__gsa_mailbox_state {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa__gsa_mailbox_state **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa__gsa_mailbox_state;
#define d__l__vr_gsa__gsa_mailbox_state 9005   

typedef l__vr_gsa__gsa_mailbox_state l__gsa_mailbox_state;
#define d__l__gsa_mailbox_state d__l__vr_gsa__gsa_mailbox_state

/* l__sn__sn_thread_handle */ 
typedef struct s__l__sn__sn_thread_handle {
    t__int d__;
    t__int gen__;
    t__sn__sn_thread_handle*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_thread_handle;
#define d__l__sn__sn_thread_handle 3112   

typedef l__sn__sn_thread_handle l__sn_thread_handle;
#define d__l__sn_thread_handle d__l__sn__sn_thread_handle

/* l__vr_gsa_sw_debug__file_info */ 
typedef struct s__l__vr_gsa_sw_debug__fi100926 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__file_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa_sw_debug__file_info;
#define d__l__vr_gsa_sw_debug__file_info 8959   

typedef l__vr_gsa_sw_debug__file_info l__file_info;
#define d__l__file_info d__l__vr_gsa_sw_debug__file_info

/* k__vr_gsa_sw_debug__type_s99068 */ 
typedef struct s__k__vr_gsa_sw_debug__ty100927 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__type_size **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vr_gsa_sw_debug__type_s99068;
#define d__k__vr_gsa_sw_debug__type_s99068 8960   

typedef k__vr_gsa_sw_debug__type_s99068 k__type_size__name;
#define d__k__type_size__name d__k__vr_gsa_sw_debug__type_s99068

/* l__vr_dwarf__vr_dwarf_entry */ 
typedef struct s__l__vr_dwarf__vr_dwarf_entry {
    t__int d__;
    t__int gen__;
    struct s__vr_dwarf__vr_dwarf_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_dwarf__vr_dwarf_entry;
#define d__l__vr_dwarf__vr_dwarf_entry 8953   

typedef l__vr_dwarf__vr_dwarf_entry l__vr_dwarf_entry;
#define d__l__vr_dwarf_entry d__l__vr_dwarf__vr_dwarf_entry

/* l__vr_dwarf__vr_dwarf_attribute */ 
typedef struct s__l__vr_dwarf__vr_dwarf_100919 {
    t__int d__;
    t__int gen__;
    struct s__vr_dwarf__vr_dwarf_attribute **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_dwarf__vr_dwarf_attribute;
#define d__l__vr_dwarf__vr_dwarf_attribute 8952   

typedef l__vr_dwarf__vr_dwarf_attribute l__vr_dwarf_attribute;
#define d__l__vr_dwarf_attribute d__l__vr_dwarf__vr_dwarf_attribute

/* k__vr_gsa_sw_debug__id_in100928 */ 
typedef struct s__k__vr_gsa_sw_debug__id100929 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__id_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vr_gsa_sw_debug__id_in100928;
#define d__k__vr_gsa_sw_debug__id_in100928 8961   

typedef k__vr_gsa_sw_debug__id_in100928 k__id_info__type;
#define d__k__id_info__type d__k__vr_gsa_sw_debug__id_in100928

/* l__vr_gsa_sw_debug__vr_gsa99991 */ 
typedef struct s__l__vr_gsa_sw_debug__vr100947 {
    t__int d__;
    t__int gen__;
    struct s__vr_gsa_sw_debug__vr_gsa99957 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vr_gsa_sw_debug__vr_gsa99991;
#define d__l__vr_gsa_sw_debug__vr_gsa99991 9028   

typedef l__vr_gsa_sw_debug__vr_gsa99991 l__vr_gsa_dbserver_regist100948;
#define d__l__vr_gsa_dbserver_regist100948 d__l__vr_gsa_sw_debug__vr_gsa99991

/* l__e_core__any_event_port */ 
typedef struct s__l__e_core__any_event_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_event_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_event_port;
#define d__l__e_core__any_event_port 6814   

typedef l__e_core__any_event_port l__any_event_port;
#define d__l__any_event_port d__l__e_core__any_event_port

/* l__e_core__event_port */ 
typedef struct s__l__e_core__event_port {
    t__int d__;
    t__int gen__;
    struct s__e_core__event_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__event_port;
#define d__l__e_core__event_port 6818   

typedef l__e_core__event_port l__event_port;
#define d__l__event_port d__l__e_core__event_port

/* l__sn__vr_gsa_dbserver_bp_unit */ 
typedef struct s__l__sn__vr_gsa_dbserver100949 {
    t__int d__;
    t__int gen__;
    struct s__sn__vr_gsa_dbserver_bp_unit **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__vr_gsa_dbserver_bp_unit;
#define d__l__sn__vr_gsa_dbserver_bp_unit 9034   

typedef l__sn__vr_gsa_dbserver_bp_unit l__vr_gsa_dbserver_bp_unit;
#define d__l__vr_gsa_dbserver_bp_unit d__l__sn__vr_gsa_dbserver_bp_unit

/* l__vt__vtx_action */ 
typedef struct s__l__vt__vtx_action {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_action;
#define d__l__vt__vtx_action 5196   

typedef l__vt__vtx_action l__vtx_action;
#define d__l__vtx_action d__l__vt__vtx_action

/* l__vt__vt_statusbar_pane */ 
typedef struct s__l__vt__vt_statusbar_pane {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_statusbar_pane **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_statusbar_pane;
#define d__l__vt__vt_statusbar_pane 4921   

typedef l__vt__vt_statusbar_pane l__vt_statusbar_pane;
#define d__l__vt_statusbar_pane d__l__vt__vt_statusbar_pane

/* l__vt__jvt_action */ 
typedef struct s__l__vt__jvt_action {
    t__int d__;
    t__int gen__;
    struct s__vt__jvt_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__jvt_action;
#define d__l__vt__jvt_action 5075   

typedef l__vt__jvt_action l__jvt_action;
#define d__l__jvt_action d__l__vt__jvt_action

/* l__vt__vtx_component */ 
typedef struct s__l__vt__vtx_component {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_component **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_component;
#define d__l__vt__vtx_component 5183   

typedef l__vt__vtx_component l__vtx_component;
#define d__l__vtx_component d__l__vt__vtx_component

/* k__vt__vtx_table_col__m_name */ 
typedef struct s__k__vt__vtx_table_col__m_name {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_table_col **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vtx_table_col__m_name;
#define d__k__vt__vtx_table_col__m_name 5192   

typedef k__vt__vtx_table_col__m_name k__vtx_table_col__m_name;
#define d__k__vtx_table_col__m_name d__k__vt__vtx_table_col__m_name

/* k__vt__vtx_table_row__m_id */ 
typedef struct s__k__vt__vtx_table_row__m_id {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_table_row **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vtx_table_row__m_id;
#define d__k__vt__vtx_table_row__m_id 5193   

typedef k__vt__vtx_table_row__m_id k__vtx_table_row__m_id;
#define d__k__vtx_table_row__m_id d__k__vt__vtx_table_row__m_id

/* k__sn__seed_domain__name */ 
typedef struct s__k__sn__seed_domain__name {
    t__int d__;
    t__int gen__;
    struct s__sn__seed_domain **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__seed_domain__name;
#define d__k__sn__seed_domain__name 1248   

typedef k__sn__seed_domain__name k__seed_domain__name;
#define d__k__seed_domain__name d__k__sn__seed_domain__name

/* l__gen__gen_mm_cmd */ 
typedef struct s__l__gen__gen_mm_cmd {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_mm_cmd **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_mm_cmd;
#define d__l__gen__gen_mm_cmd 6651   

typedef l__gen__gen_mm_cmd l__gen_mm_cmd;
#define d__l__gen_mm_cmd d__l__gen__gen_mm_cmd

/* k__gen__gen_mm_rf_port_por56796 */ 
typedef struct s__k__gen__gen_mm_rf_port_56799 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_mm_rf_port_por56898 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_mm_rf_port_por56796;
#define d__k__gen__gen_mm_rf_port_por56796 6649   

typedef k__gen__gen_mm_rf_port_por56796 k__gen_mm_rf_port_ports_an56901;
#define d__k__gen_mm_rf_port_ports_an56901 d__k__gen__gen_mm_rf_port_por56796

/* k__gen__gen_mm_rf_struct_s56797 */ 
typedef struct s__k__gen__gen_mm_rf_struc56800 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_mm_rf_struct_s56899 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_mm_rf_struct_s56797;
#define d__k__gen__gen_mm_rf_struct_s56797 6650   

typedef k__gen__gen_mm_rf_struct_s56797 k__gen_mm_rf_struct_st_con56902;
#define d__k__gen_mm_rf_struct_st_con56902 d__k__gen__gen_mm_rf_struct_s56797

/* l__reflection__st_constraint */ 
typedef struct s__l__reflection__st_constraint {
    t__int d__;
    t__int gen__;
    struct s__reflection__st_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__st_constraint;
#define d__l__reflection__st_constraint 2112   

typedef l__reflection__st_constraint l__st_constraint;
#define d__l__st_constraint d__l__reflection__st_constraint

/* l__sn__configuration_category */ 
typedef struct s__l__sn__configuration_cat4170 {
    t__int d__;
    t__int gen__;
    struct s__sn__configuration_category **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__configuration_category;
#define d__l__sn__configuration_category 1412   

typedef l__sn__configuration_category l__configuration_category;
#define d__l__configuration_category d__l__sn__configuration_category

/* l__sn__configuration_option */ 
typedef struct s__l__sn__configuration_option {
    t__int d__;
    t__int gen__;
    struct s__sn__configuration_option **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__configuration_option;
#define d__l__sn__configuration_option 1413   

typedef l__sn__configuration_option l__configuration_option;
#define d__l__configuration_option d__l__sn__configuration_option

/* l__sn__sn_gc_debug_thing */ 
typedef struct s__l__sn__sn_gc_debug_thing {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gc_debug_thing **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_gc_debug_thing;
#define d__l__sn__sn_gc_debug_thing 2348   

typedef l__sn__sn_gc_debug_thing l__sn_gc_debug_thing;
#define d__l__sn_gc_debug_thing d__l__sn__sn_gc_debug_thing

/* l__sn__esv_info_s */ 
typedef struct s__l__sn__esv_info_s {
    t__int d__;
    t__int gen__;
    struct s__sn__esv_info_s **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__esv_info_s;
#define d__l__sn__esv_info_s 2747   

typedef l__sn__esv_info_s l__esv_info_s;
#define d__l__esv_info_s d__l__sn__esv_info_s

/* k__sn_debugger__sn_dbg_cal28140 */ 
typedef struct s__k__sn_debugger__sn_dbg_28141 {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__sn_dbg_call **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn_debugger__sn_dbg_cal28140;
#define d__k__sn_debugger__sn_dbg_cal28140 4074   

typedef k__sn_debugger__sn_dbg_cal28140 k__sn_dbg_call__s_id;
#define d__k__sn_dbg_call__s_id d__k__sn_debugger__sn_dbg_cal28140

/* l__sn_debugger__sn_dbg_call */ 
typedef struct s__l__sn_debugger__sn_dbg_call {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__sn_dbg_call **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_debugger__sn_dbg_call;
#define d__l__sn_debugger__sn_dbg_call 4056   

typedef l__sn_debugger__sn_dbg_call l__sn_dbg_call;
#define d__l__sn_dbg_call d__l__sn_debugger__sn_dbg_call

/* l__sn_debugger__sn_dbg_min28898 */ 
typedef struct s__l__sn_debugger__sn_dbg_28899 {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__sn_dbg_min28894 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_debugger__sn_dbg_min28898;
#define d__l__sn_debugger__sn_dbg_min28898 4135   

typedef l__sn_debugger__sn_dbg_min28898 l__sn_dbg_mini_thread;
#define d__l__sn_dbg_mini_thread d__l__sn_debugger__sn_dbg_min28898

/* l__sn_debugger__ar_sr */ 
typedef struct s__l__sn_debugger__ar_sr {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__ar_sr **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_debugger__ar_sr;
#define d__l__sn_debugger__ar_sr 4181   

typedef l__sn_debugger__ar_sr l__ar_sr;
#define d__l__ar_sr d__l__sn_debugger__ar_sr

/* k__sn_debugger__sn_dbg_thr28895 */ 
typedef struct s__k__sn_debugger__sn_dbg_28896 {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__sn_dbg_thread **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn_debugger__sn_dbg_thr28895;
#define d__k__sn_debugger__sn_dbg_thr28895 4137   

typedef k__sn_debugger__sn_dbg_thr28895 k__sn_dbg_thread__n_id;
#define d__k__sn_dbg_thread__n_id d__k__sn_debugger__sn_dbg_thr28895

/* k__sn_debugger__sn_dbg_min29859 */ 
typedef struct s__k__sn_debugger__sn_dbg_29860 {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__sn_dbg_min28894 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn_debugger__sn_dbg_min29859;
#define d__k__sn_debugger__sn_dbg_min29859 4182   

typedef k__sn_debugger__sn_dbg_min29859 k__sn_dbg_mini_thread__mini_id;
#define d__k__sn_dbg_mini_thread__mini_id d__k__sn_debugger__sn_dbg_min29859

/* l__sn__on_request */ 
typedef struct s__l__sn__on_request {
    t__int d__;
    t__int gen__;
    struct s__sn__on_request **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__on_request;
#define d__l__sn__on_request 662   

typedef l__sn__on_request l__on_request;
#define d__l__on_request d__l__sn__on_request

/* l__sn_debugger__watch_item */ 
typedef struct s__l__sn_debugger__watch_item {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__watch_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_debugger__watch_item;
#define d__l__sn_debugger__watch_item 4073   

typedef l__sn_debugger__watch_item l__watch_item;
#define d__l__watch_item d__l__sn_debugger__watch_item

/* l__vt__vt_user_action */ 
typedef struct s__l__vt__vt_user_action {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_user_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_user_action;
#define d__l__vt__vt_user_action 2559   

typedef l__vt__vt_user_action l__vt_user_action;
#define d__l__vt_user_action d__l__vt__vt_user_action

/* l__vt__sn_table_col */ 
typedef struct s__l__vt__sn_table_col {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_table_col **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__sn_table_col;
#define d__l__vt__sn_table_col 2560   

typedef l__vt__sn_table_col l__sn_table_col;
#define d__l__sn_table_col d__l__vt__sn_table_col

/* l__sn_debugger__thread_tre30322 */ 
typedef struct s__l__sn_debugger__thread_31824 {
    t__int d__;
    t__int gen__;
    struct s__sn_debugger__thread_tre31864 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_debugger__thread_tre30322;
#define d__l__sn_debugger__thread_tre30322 4184   

typedef l__sn_debugger__thread_tre30322 l__thread_tree_win_counter;
#define d__l__thread_tree_win_counter d__l__sn_debugger__thread_tre30322

/* k__int__it */ 
typedef struct s__k__int__it {
    t__int d__;
    t__int gen__;
    t__int*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__int__it;
#define d__k__int__it 474   


/* l__e_core__type_translation */ 
typedef struct s__l__e_core__type_translation {
    t__int d__;
    t__int gen__;
    struct s__e_core__type_translation **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__type_translation;
#define d__l__e_core__type_translation 101   

typedef l__e_core__type_translation l__type_translation;
#define d__l__type_translation d__l__e_core__type_translation

/* l__e_core__display_item */ 
typedef struct s__l__e_core__display_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__display_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__display_item;
#define d__l__e_core__display_item 103   

typedef l__e_core__display_item l__display_item;
#define d__l__display_item d__l__e_core__display_item

/* k__e_core__file_contents__fi482 */ 
typedef struct s__k__e_core__file_contents_483 {
    t__int d__;
    t__int gen__;
    struct s__e_core__file_contents **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__file_contents__fi482;
#define d__k__e_core__file_contents__fi482 105   

typedef k__e_core__file_contents__fi482 k__file_contents__file_name;
#define d__k__file_contents__file_name d__k__e_core__file_contents__fi482

/* l__sn_when_subtype__n__subt2198 */ 
typedef struct s__l__sn_when_subtype__n__s2668 {
    t__int d__;
    t__int gen__;
    struct s__sn_when_subtype__n__subt2674 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_when_subtype__n__subt2198;
#define d__l__sn_when_subtype__n__subt2198 1091   

typedef l__sn_when_subtype__n__subt2198 l__n__subtype__regular_type;
#define d__l__n__subtype__regular_type d__l__sn_when_subtype__n__subt2198

/* l__sn__when_tree_node */ 
typedef struct s__l__sn__when_tree_node {
    t__int d__;
    t__int gen__;
    struct s__sn__when_tree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__when_tree_node;
#define d__l__sn__when_tree_node 1094   

typedef l__sn__when_tree_node l__when_tree_node;
#define d__l__when_tree_node d__l__sn__when_tree_node

/* k__sn__sn_user_dir_pair__us4505 */ 
typedef struct s__k__sn__sn_user_dir_pair_4506 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_user_dir_pair **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_user_dir_pair__us4505;
#define d__k__sn__sn_user_dir_pair__us4505 1523   

typedef k__sn__sn_user_dir_pair__us4505 k__sn_user_dir_pair__user_name;
#define d__k__sn_user_dir_pair__user_name d__k__sn__sn_user_dir_pair__us4505

/* k__sn__sn_prof_user_modul101515 */ 
typedef struct s__k__sn__sn_prof_user_mo101516 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_user_module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_user_modul101515;
#define d__k__sn__sn_prof_user_modul101515 9153   

typedef k__sn__sn_prof_user_modul101515 k__sn_prof_user_module__name;
#define d__k__sn_prof_user_module__name d__k__sn__sn_prof_user_modul101515

/* k__sn__sn_prof_e_routine_101518 */ 
typedef struct s__k__sn__sn_prof_e_routi101519 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_e_routine **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_e_routine_101518;
#define d__k__sn__sn_prof_e_routine_101518 9154   

typedef k__sn__sn_prof_e_routine_101518 k__sn_prof_e_routine__c_name;
#define d__k__sn_prof_e_routine__c_name d__k__sn__sn_prof_e_routine_101518

/* k__sn__sn_prof_func_summa102415 */ 
typedef struct s__k__sn__sn_prof_func_su103516 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_func_summary **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_func_summa102415;
#define d__k__sn__sn_prof_func_summa102415 9209   

typedef k__sn__sn_prof_func_summa102415 k__sn_prof_func_summary__name;
#define d__k__sn_prof_func_summary__name d__k__sn__sn_prof_func_summa102415

/* l__sn__sn_prof_func_summa102416 */ 
typedef struct s__l__sn__sn_prof_func_su103518 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_func_summa103519 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_func_summa102416;
#define d__l__sn__sn_prof_func_summa102416 9203   

typedef l__sn__sn_prof_func_summa102416 l__sn_prof_func_summary_call;
#define d__l__sn_prof_func_summary_call d__l__sn__sn_prof_func_summa102416

/* k__sn__sn_prof_program_ca102414 */ 
typedef struct s__k__sn__sn_prof_program103517 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_program_category **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_program_ca102414;
#define d__k__sn__sn_prof_program_ca102414 9208   

typedef k__sn__sn_prof_program_ca102414 k__sn_prof_program_catego103520;
#define d__k__sn_prof_program_catego103520 d__k__sn__sn_prof_program_ca102414

/* k__sn__sn_prof_function_w101797 */ 
typedef struct s__k__sn__sn_prof_functio103522 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_function_w103521 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_function_w101797;
#define d__k__sn__sn_prof_function_w101797 9202   

typedef k__sn__sn_prof_function_w101797 k__sn_prof_function_with_103523;
#define d__k__sn_prof_function_with_103523 d__k__sn__sn_prof_function_w101797

/* l__sn__sn_prof_long */ 
typedef struct s__l__sn__sn_prof_long {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_long **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_long;
#define d__l__sn__sn_prof_long 9200   

typedef l__sn__sn_prof_long l__sn_prof_long;
#define d__l__sn_prof_long d__l__sn__sn_prof_long

/* l__sn__sn_prof_cb_thing */ 
typedef struct s__l__sn__sn_prof_cb_thing {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_cb_thing **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_cb_thing;
#define d__l__sn__sn_prof_cb_thing 9204   

typedef l__sn__sn_prof_cb_thing l__sn_prof_cb_thing;
#define d__l__sn_prof_cb_thing d__l__sn__sn_prof_cb_thing

/* l__sn__sn_profiler_state_saver */ 
typedef struct s__l__sn__sn_profiler_sta103524 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_profiler_state_saver **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_profiler_state_saver;
#define d__l__sn__sn_profiler_state_saver 9205   

typedef l__sn__sn_profiler_state_saver l__sn_profiler_state_saver;
#define d__l__sn_profiler_state_saver d__l__sn__sn_profiler_state_saver

/* l__sn__sn_prof_known_thing */ 
typedef struct s__l__sn__sn_prof_known_thing {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_known_thing **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_known_thing;
#define d__l__sn__sn_prof_known_thing 9206   

typedef l__sn__sn_prof_known_thing l__sn_prof_known_thing;
#define d__l__sn_prof_known_thing d__l__sn__sn_prof_known_thing

/* l__sn__sn_prof_name_subst103525 */ 
typedef struct s__l__sn__sn_prof_name_su103526 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_name_subst101753 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_name_subst103525;
#define d__l__sn__sn_prof_name_subst103525 9207   

typedef l__sn__sn_prof_name_subst103525 l__sn_prof_name_substitution;
#define d__l__sn_prof_name_substitution d__l__sn__sn_prof_name_subst103525

/* l__sn__sn_prof_sampling_action */ 
typedef struct s__l__sn__sn_prof_samplin103530 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_sampling_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_sampling_action;
#define d__l__sn__sn_prof_sampling_action 9217   

typedef l__sn__sn_prof_sampling_action l__sn_prof_sampling_action;
#define d__l__sn_prof_sampling_action d__l__sn__sn_prof_sampling_action

/* k__sn__sn_prof_html_link_103538 */ 
typedef struct s__k__sn__sn_prof_html_li103539 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_html_link_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_html_link_103538;
#define d__k__sn__sn_prof_html_link_103538 9267   

typedef k__sn__sn_prof_html_link_103538 k__sn_prof_html_link_data__name;
#define d__k__sn_prof_html_link_data__name d__k__sn__sn_prof_html_link_103538

/* l__sn__sn_prof_call */ 
typedef struct s__l__sn__sn_prof_call {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_call **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_call;
#define d__l__sn__sn_prof_call 9305   

typedef l__sn__sn_prof_call l__sn_prof_call;
#define d__l__sn_prof_call d__l__sn__sn_prof_call

/* k__sn__sn_prof_entity__name */ 
typedef struct s__k__sn__sn_prof_entity__name {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_entity **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_entity__name;
#define d__k__sn__sn_prof_entity__name 9306   

typedef k__sn__sn_prof_entity__name k__sn_prof_entity__name;
#define d__k__sn_prof_entity__name d__k__sn__sn_prof_entity__name

/* k__sn__sn_prof_category__name */ 
typedef struct s__k__sn__sn_prof_categor103540 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_category **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_category__name;
#define d__k__sn__sn_prof_category__name 9307   

typedef k__sn__sn_prof_category__name k__sn_prof_category__name;
#define d__k__sn_prof_category__name d__k__sn__sn_prof_category__name

/* k__sn__sn_prof_name_pair__key */ 
typedef struct s__k__sn__sn_prof_name_pa103541 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_name_pair **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_name_pair__key;
#define d__k__sn__sn_prof_name_pair__key 9310   

typedef k__sn__sn_prof_name_pair__key k__sn_prof_name_pair__key;
#define d__k__sn_prof_name_pair__key d__k__sn__sn_prof_name_pair__key

/* l__sn__sn_prof_summary_node */ 
typedef struct s__l__sn__sn_prof_summary_node {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_summary_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_summary_node;
#define d__l__sn__sn_prof_summary_node 9301   

typedef l__sn__sn_prof_summary_node l__sn_prof_summary_node;
#define d__l__sn_prof_summary_node d__l__sn__sn_prof_summary_node

/* l__sn__sn_prof_summary_by103542 */ 
typedef struct s__l__sn__sn_prof_summary103543 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_summary_by103545 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_summary_by103542;
#define d__l__sn__sn_prof_summary_by103542 9302   

typedef l__sn__sn_prof_summary_by103542 l__sn_prof_summary_by_cat103544;
#define d__l__sn_prof_summary_by_cat103544 d__l__sn__sn_prof_summary_by103542

/* l__sn__sn_prof_category */ 
typedef struct s__l__sn__sn_prof_category {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_category **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_prof_category;
#define d__l__sn__sn_prof_category 9300   

typedef l__sn__sn_prof_category l__sn_prof_category;
#define d__l__sn_prof_category d__l__sn__sn_prof_category

/* k__sn__sn_prof_source_fil103546 */ 
typedef struct s__k__sn__sn_prof_source_103547 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_prof_source_file **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_prof_source_fil103546;
#define d__k__sn__sn_prof_source_fil103546 9309   

typedef k__sn__sn_prof_source_fil103546 k__sn_prof_source_file__m103548;
#define d__k__sn_prof_source_file__m103548 d__k__sn__sn_prof_source_fil103546

/* l__e_core__file */ 
typedef struct s__l__e_core__file {
    t__int d__;
    t__int gen__;
    struct s__e_core__file **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__file;
#define d__l__e_core__file 2386   

typedef l__e_core__file l__file;
#define d__l__file d__l__e_core__file

/* l__sn__sn_value_holder */ 
typedef struct s__l__sn__sn_value_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_value_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_value_holder;
#define d__l__sn__sn_value_holder 197   

typedef l__sn__sn_value_holder l__sn_value_holder;
#define d__l__sn_value_holder d__l__sn__sn_value_holder

/* l__sn__gdo_node */ 
typedef struct s__l__sn__gdo_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gdo_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gdo_node;
#define d__l__sn__gdo_node 6104   

typedef l__sn__gdo_node l__gdo_node;
#define d__l__gdo_node d__l__sn__gdo_node

/* l__sn__gdo_edge */ 
typedef struct s__l__sn__gdo_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__gdo_edge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gdo_edge;
#define d__l__sn__gdo_edge 6105   

typedef l__sn__gdo_edge l__gdo_edge;
#define d__l__gdo_edge d__l__sn__gdo_edge

/* l__sn__gdo_frc */ 
typedef struct s__l__sn__gdo_frc {
    t__int d__;
    t__int gen__;
    struct s__sn__gdo_frc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gdo_frc;
#define d__l__sn__gdo_frc 6106   

typedef l__sn__gdo_frc l__gdo_frc;
#define d__l__gdo_frc d__l__sn__gdo_frc

/* l__sn__sn_msg_struct */ 
typedef struct s__l__sn__sn_msg_struct {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_msg_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_msg_struct;
#define d__l__sn__sn_msg_struct 6090   

typedef l__sn__sn_msg_struct l__sn_msg_struct;
#define d__l__sn_msg_struct d__l__sn__sn_msg_struct

/* l__sn__trace_gen_request */ 
typedef struct s__l__sn__trace_gen_request {
    t__int d__;
    t__int gen__;
    struct s__sn__trace_gen_request **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__trace_gen_request;
#define d__l__sn__trace_gen_request 6111   

typedef l__sn__trace_gen_request l__trace_gen_request;
#define d__l__trace_gen_request d__l__sn__trace_gen_request

/* k__sn__sn_msg_set_struct__value */ 
typedef struct s__k__sn__sn_msg_set_struc54692 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_msg_set_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_msg_set_struct__value;
#define d__k__sn__sn_msg_set_struct__value 6096   

typedef k__sn__sn_msg_set_struct__value k__sn_msg_set_struct__value;
#define d__k__sn_msg_set_struct__value d__k__sn__sn_msg_set_struct__value

/* l__sn__sn_msg_show_request */ 
typedef struct s__l__sn__sn_msg_show_request {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_msg_show_request **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_msg_show_request;
#define d__l__sn__sn_msg_show_request 6091   

typedef l__sn__sn_msg_show_request l__sn_msg_show_request;
#define d__l__sn_msg_show_request d__l__sn__sn_msg_show_request

/* k__sn__sn_gen_repeat_count54693 */ 
typedef struct s__k__sn__sn_gen_repeat_co54694 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_repeat_counter **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_gen_repeat_count54693;
#define d__k__sn__sn_gen_repeat_count54693 6092   

typedef k__sn__sn_gen_repeat_count54693 k__sn_gen_repeat_counter__sr;
#define d__k__sn_gen_repeat_counter__sr d__k__sn__sn_gen_repeat_count54693

/* k__sn__sn_gen_string_repea54695 */ 
typedef struct s__k__sn__sn_gen_string_re54696 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_string_repea54808 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_gen_string_repea54695;
#define d__k__sn__sn_gen_string_repea54695 6093   

typedef k__sn__sn_gen_string_repea54695 k__sn_gen_string_repeat_co54809;
#define d__k__sn_gen_string_repeat_co54809 d__k__sn__sn_gen_string_repea54695

/* l__sn__sn_msg_start_gen */ 
typedef struct s__l__sn__sn_msg_start_gen {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_msg_start_gen **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_msg_start_gen;
#define d__l__sn__sn_msg_start_gen 6094   

typedef l__sn__sn_msg_start_gen l__sn_msg_start_gen;
#define d__l__sn_msg_start_gen d__l__sn__sn_msg_start_gen

/* k__e_core__base_struct__it */ 
typedef struct s__k__e_core__base_struct__it {
    t__int d__;
    t__int gen__;
    struct s__e_core__base_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__base_struct__it;
#define d__k__e_core__base_struct__it 130   

typedef k__e_core__base_struct__it k__base_struct__it;
#define d__k__base_struct__it d__k__e_core__base_struct__it

/* l__e_core__source_item */ 
typedef struct s__l__e_core__source_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__source_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__source_item;
#define d__l__e_core__source_item 1573   

typedef l__e_core__source_item l__source_item;
#define d__l__source_item d__l__e_core__source_item

/* k__sn__om_item_node__it */ 
typedef struct s__k__sn__om_item_node__it {
    t__int d__;
    t__int gen__;
    struct s__sn__om_item_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__om_item_node__it;
#define d__k__sn__om_item_node__it 5892   

typedef k__sn__om_item_node__it k__om_item_node__it;
#define d__k__om_item_node__it d__k__sn__om_item_node__it

/* l__sn__om_item_node */ 
typedef struct s__l__sn__om_item_node {
    t__int d__;
    t__int gen__;
    struct s__sn__om_item_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__om_item_node;
#define d__l__sn__om_item_node 5891   

typedef l__sn__om_item_node l__om_item_node;
#define d__l__om_item_node d__l__sn__om_item_node

/* l__sn__om_frame */ 
typedef struct s__l__sn__om_frame {
    t__int d__;
    t__int gen__;
    struct s__sn__om_frame **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__om_frame;
#define d__l__sn__om_frame 5896   

typedef l__sn__om_frame l__om_frame;
#define d__l__om_frame d__l__sn__om_frame

/* l__sn__om_node */ 
typedef struct s__l__sn__om_node {
    t__int d__;
    t__int gen__;
    struct s__sn__om_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__om_node;
#define d__l__sn__om_node 5895   

typedef l__sn__om_node l__om_node;
#define d__l__om_node d__l__sn__om_node

/* k__sn__a_role__key_number */ 
typedef struct s__k__sn__a_role__key_number {
    t__int d__;
    t__int gen__;
    struct s__sn__a_role **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__a_role__key_number;
#define d__k__sn__a_role__key_number 5749   

typedef k__sn__a_role__key_number k__a_role__key_number;
#define d__k__a_role__key_number d__k__sn__a_role__key_number

/* l__sn__fields_constraint_path */ 
typedef struct s__l__sn__fields_constrain48780 {
    t__int d__;
    t__int gen__;
    struct s__sn__fields_constraint_path **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__fields_constraint_path;
#define d__l__sn__fields_constraint_path 5791   

typedef l__sn__fields_constraint_path l__fields_constraint_path;
#define d__l__fields_constraint_path d__l__sn__fields_constraint_path

/* k__sn__role_count__role_str */ 
typedef struct s__k__sn__role_count__role_str {
    t__int d__;
    t__int gen__;
    struct s__sn__role_count **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__role_count__role_str;
#define d__k__sn__role_count__role_str 5746   

typedef k__sn__role_count__role_str k__role_count__role_str;
#define d__k__role_count__role_str d__k__sn__role_count__role_str

/* l__sn__gotf_info */ 
typedef struct s__l__sn__gotf_info {
    t__int d__;
    t__int gen__;
    struct s__sn__gotf_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gotf_info;
#define d__l__sn__gotf_info 5747   

typedef l__sn__gotf_info l__gotf_info;
#define d__l__gotf_info d__l__sn__gotf_info

/* k__sn__gotf_count__gotf_id */ 
typedef struct s__k__sn__gotf_count__gotf_id {
    t__int d__;
    t__int gen__;
    struct s__sn__gotf_count **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gotf_count__gotf_id;
#define d__k__sn__gotf_count__gotf_id 5748   

typedef k__sn__gotf_count__gotf_id k__gotf_count__gotf_id;
#define d__k__gotf_count__gotf_id d__k__sn__gotf_count__gotf_id

/* l__sn__static_om_f */ 
typedef struct s__l__sn__static_om_f {
    t__int d__;
    t__int gen__;
    struct s__sn__static_om_f **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__static_om_f;
#define d__l__sn__static_om_f 5859   

typedef l__sn__static_om_f l__static_om_f;
#define d__l__static_om_f d__l__sn__static_om_f

/* l__sn__struct_path_item */ 
typedef struct s__l__sn__struct_path_item {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_path_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__struct_path_item;
#define d__l__sn__struct_path_item 5903   

typedef l__sn__struct_path_item l__struct_path_item;
#define d__l__struct_path_item d__l__sn__struct_path_item

/* k__sn__instanciated_fields54779 */ 
typedef struct s__k__sn__instanciated_fie54780 {
    t__int d__;
    t__int gen__;
    struct s__sn__instanciated_fields54782 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__instanciated_fields54779;
#define d__k__sn__instanciated_fields54779 6025   

typedef k__sn__instanciated_fields54779 k__instanciated_fields_of_54781;
#define d__k__instanciated_fields_of_54781 d__k__sn__instanciated_fields54779

/* k__sn__sn_instanciated_field__f */ 
typedef struct s__k__sn__sn_instanciated_54783 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_instanciated_field **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_instanciated_field__f;
#define d__k__sn__sn_instanciated_field__f 6026   

typedef k__sn__sn_instanciated_field__f k__sn_instanciated_field__f;
#define d__k__sn_instanciated_field__f d__k__sn__sn_instanciated_field__f

/* l__sn__gendb_field_in_gen */ 
typedef struct s__l__sn__gendb_field_in_gen {
    t__int d__;
    t__int gen__;
    struct s__sn__gendb_field_in_gen **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gendb_field_in_gen;
#define d__l__sn__gendb_field_in_gen 6015   

typedef l__sn__gendb_field_in_gen l__gendb_field_in_gen;
#define d__l__gendb_field_in_gen d__l__sn__gendb_field_in_gen

/* l__sn__sn_instanciated_field */ 
typedef struct s__l__sn__sn_instanciated_field {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_instanciated_field **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_instanciated_field;
#define d__l__sn__sn_instanciated_field 6007   

typedef l__sn__sn_instanciated_field l__sn_instanciated_field;
#define d__l__sn_instanciated_field d__l__sn__sn_instanciated_field

/* k__sn__sn_gen_event__index */ 
typedef struct s__k__sn__sn_gen_event__index {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_gen_event__index;
#define d__k__sn__sn_gen_event__index 6022   

typedef k__sn__sn_gen_event__index k__sn_gen_event__index;
#define d__k__sn_gen_event__index d__k__sn__sn_gen_event__index

/* k__sn__sn_role_info__role_id */ 
typedef struct s__k__sn__sn_role_info__role_id {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_role_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_role_info__role_id;
#define d__k__sn__sn_role_info__role_id 6023   

typedef k__sn__sn_role_info__role_id k__sn_role_info__role_id;
#define d__k__sn_role_info__role_id d__k__sn__sn_role_info__role_id

/* l__sn__sn_start_gen_event */ 
typedef struct s__l__sn__sn_start_gen_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_start_gen_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_start_gen_event;
#define d__l__sn__sn_start_gen_event 6001   

typedef l__sn__sn_start_gen_event l__sn_start_gen_event;
#define d__l__sn_start_gen_event d__l__sn__sn_start_gen_event

/* l__sn__sn_gen_root_event */ 
typedef struct s__l__sn__sn_gen_root_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gen_root_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_gen_root_event;
#define d__l__sn__sn_gen_root_event 6002   

typedef l__sn__sn_gen_root_event l__sn_gen_root_event;
#define d__l__sn_gen_root_event d__l__sn__sn_gen_root_event

/* l__sn__sn_set_value_event */ 
typedef struct s__l__sn__sn_set_value_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_set_value_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_set_value_event;
#define d__l__sn__sn_set_value_event 6003   

typedef l__sn__sn_set_value_event l__sn_set_value_event;
#define d__l__sn_set_value_event d__l__sn__sn_set_value_event

/* k__sn__sn_event_parameter_54777 */ 
typedef struct s__k__sn__sn_event_paramet54778 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_event_parameter **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_event_parameter_54777;
#define d__k__sn__sn_event_parameter_54777 6024   

typedef k__sn__sn_event_parameter_54777 k__sn_event_parameter__par54784;
#define d__k__sn_event_parameter__par54784 d__k__sn__sn_event_parameter_54777

/* k__sn__sn_ci_to_fig__ci */ 
typedef struct s__k__sn__sn_ci_to_fig__ci {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_ci_to_fig **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_ci_to_fig__ci;
#define d__k__sn__sn_ci_to_fig__ci 6038   

typedef k__sn__sn_ci_to_fig__ci k__sn_ci_to_fig__ci;
#define d__k__sn_ci_to_fig__ci d__k__sn__sn_ci_to_fig__ci

/* k__sn__sn_ci_to_deferred__ci */ 
typedef struct s__k__sn__sn_ci_to_deferred__ci {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_ci_to_deferred **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_ci_to_deferred__ci;
#define d__k__sn__sn_ci_to_deferred__ci 6040   

typedef k__sn__sn_ci_to_deferred__ci k__sn_ci_to_deferred__ci;
#define d__k__sn_ci_to_deferred__ci d__k__sn__sn_ci_to_deferred__ci

/* k__sn__deferred_par__par_no */ 
typedef struct s__k__sn__deferred_par__par_no {
    t__int d__;
    t__int gen__;
    struct s__sn__deferred_par **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__deferred_par__par_no;
#define d__k__sn__deferred_par__par_no 6039   

typedef k__sn__deferred_par__par_no k__deferred_par__par_no;
#define d__k__deferred_par__par_no d__k__sn__deferred_par__par_no

/* l__sn__changed_gendb_item */ 
typedef struct s__l__sn__changed_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__sn__changed_gendb_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__changed_gendb_item;
#define d__l__sn__changed_gendb_item 6006   

typedef l__sn__changed_gendb_item l__changed_gendb_item;
#define d__l__changed_gendb_item d__l__sn__changed_gendb_item

/* l__sn__sn_skeleton_event */ 
typedef struct s__l__sn__sn_skeleton_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_skeleton_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_skeleton_event;
#define d__l__sn__sn_skeleton_event 6008   

typedef l__sn__sn_skeleton_event l__sn_skeleton_event;
#define d__l__sn_skeleton_event d__l__sn__sn_skeleton_event

/* l__sn__new_gdo_node */ 
typedef struct s__l__sn__new_gdo_node {
    t__int d__;
    t__int gen__;
    struct s__sn__new_gdo_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__new_gdo_node;
#define d__l__sn__new_gdo_node 6391   

typedef l__sn__new_gdo_node l__new_gdo_node;
#define d__l__new_gdo_node d__l__sn__new_gdo_node

/* l__sn__new_gdo_edge */ 
typedef struct s__l__sn__new_gdo_edge {
    t__int d__;
    t__int gen__;
    struct s__sn__new_gdo_edge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__new_gdo_edge;
#define d__l__sn__new_gdo_edge 6392   

typedef l__sn__new_gdo_edge l__new_gdo_edge;
#define d__l__new_gdo_edge d__l__sn__new_gdo_edge

/* l__sn__new_gdo_frc */ 
typedef struct s__l__sn__new_gdo_frc {
    t__int d__;
    t__int gen__;
    struct s__sn__new_gdo_frc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__new_gdo_frc;
#define d__l__sn__new_gdo_frc 6393   

typedef l__sn__new_gdo_frc l__new_gdo_frc;
#define d__l__new_gdo_frc d__l__sn__new_gdo_frc

/* l__sn__sn_ci_info */ 
typedef struct s__l__sn__sn_ci_info {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_ci_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_ci_info;
#define d__l__sn__sn_ci_info 5728   

typedef l__sn__sn_ci_info l__sn_ci_info;
#define d__l__sn_ci_info d__l__sn__sn_ci_info

/* l__sn__sn_preorder_top_event */ 
typedef struct s__l__sn__sn_preorder_top_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_preorder_top_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_preorder_top_event;
#define d__l__sn__sn_preorder_top_event 6042   

typedef l__sn__sn_preorder_top_event l__sn_preorder_top_event;
#define d__l__sn_preorder_top_event d__l__sn__sn_preorder_top_event

/* l__sn__sn_static_edge_event */ 
typedef struct s__l__sn__sn_static_edge_event {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_static_edge_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_static_edge_event;
#define d__l__sn__sn_static_edge_event 6043   

typedef l__sn__sn_static_edge_event l__sn_static_edge_event;
#define d__l__sn_static_edge_event d__l__sn__sn_static_edge_event

/* l__sn__sn_compute_select_struct */ 
typedef struct s__l__sn__sn_compute_selec54691 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_compute_select_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_compute_select_struct;
#define d__l__sn__sn_compute_select_struct 6060   

typedef l__sn__sn_compute_select_struct l__sn_compute_select_struct;
#define d__l__sn_compute_select_struct d__l__sn__sn_compute_select_struct

/* l__sn__struct_status */ 
typedef struct s__l__sn__struct_status {
    t__int d__;
    t__int gen__;
    struct s__sn__struct_status **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__struct_status;
#define d__l__sn__struct_status 6116   

typedef l__sn__struct_status l__struct_status;
#define d__l__struct_status d__l__sn__struct_status

/* l__sn__phase_status */ 
typedef struct s__l__sn__phase_status {
    t__int d__;
    t__int gen__;
    struct s__sn__phase_status **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__phase_status;
#define d__l__sn__phase_status 6115   

typedef l__sn__phase_status l__phase_status;
#define d__l__phase_status d__l__sn__phase_status

/* l__sn__display_window */ 
typedef struct s__l__sn__display_window {
    t__int d__;
    t__int gen__;
    struct s__sn__display_window **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__display_window;
#define d__l__sn__display_window 2508   

typedef l__sn__display_window l__display_window;
#define d__l__display_window d__l__sn__display_window

/* k__sn__sn_action__p_s_key */ 
typedef struct s__k__sn__sn_action__p_s_key {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_action__p_s_key;
#define d__k__sn__sn_action__p_s_key 2512   

typedef k__sn__sn_action__p_s_key k__sn_action__p_s_key;
#define d__k__sn_action__p_s_key d__k__sn__sn_action__p_s_key

/* l__sn__sn_action_widget */ 
typedef struct s__l__sn__sn_action_widget {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_action_widget **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_action_widget;
#define d__l__sn__sn_action_widget 2507   

typedef l__sn__sn_action_widget l__sn_action_widget;
#define d__l__sn_action_widget d__l__sn__sn_action_widget

/* l__sn__counter_of_open_win */ 
typedef struct s__l__sn__counter_of_open_win {
    t__int d__;
    t__int gen__;
    struct s__sn__counter_of_open_win **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__counter_of_open_win;
#define d__l__sn__counter_of_open_win 2510   

typedef l__sn__counter_of_open_win l__counter_of_open_win;
#define d__l__counter_of_open_win d__l__sn__counter_of_open_win

/* k__sn__dbg_thread_geometry16661 */ 
typedef struct s__k__sn__dbg_thread_geome16662 {
    t__int d__;
    t__int gen__;
    struct s__sn__dbg_thread_geometry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__dbg_thread_geometry16661;
#define d__k__sn__dbg_thread_geometry16661 2513   

typedef k__sn__dbg_thread_geometry16661 k__dbg_thread_geometry__p_16665;
#define d__k__dbg_thread_geometry__p_16665 d__k__sn__dbg_thread_geometry16661

/* k__sn__product_shortcut_at15274 */ 
typedef struct s__k__sn__product_shortcut16663 {
    t__int d__;
    t__int gen__;
    struct s__sn__product_shortcut_at16682 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__product_shortcut_at15274;
#define d__k__sn__product_shortcut_at15274 2665   

typedef k__sn__product_shortcut_at15274 k__product_shortcut_attrib16684;
#define d__k__product_shortcut_attrib16684 d__k__sn__product_shortcut_at15274

/* k__sn__property_item__p_s_16506 */ 
typedef struct s__k__sn__property_item__p16725 {
    t__int d__;
    t__int gen__;
    struct s__sn__property_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__property_item__p_s_16506;
#define d__k__sn__property_item__p_s_16506 2744   

typedef k__sn__property_item__p_s_16506 k__property_item__p_s_prop16724;
#define d__k__property_item__p_s_prop16724 d__k__sn__property_item__p_s_16506

/* k__sn__sn_gui_tag_info__s_name */ 
typedef struct s__k__sn__sn_gui_tag_info_16664 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_gui_tag_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_gui_tag_info__s_name;
#define d__k__sn__sn_gui_tag_info__s_name 2752   

typedef k__sn__sn_gui_tag_info__s_name k__sn_gui_tag_info__s_name;
#define d__k__sn_gui_tag_info__s_name d__k__sn__sn_gui_tag_info__s_name

/* k__vt__sn_image_data__name */ 
typedef struct s__k__vt__sn_image_data__name {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_image_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__sn_image_data__name;
#define d__k__vt__sn_image_data__name 5391   

typedef k__vt__sn_image_data__name k__sn_image_data__name;
#define d__k__sn_image_data__name d__k__vt__sn_image_data__name

/* k__sn__const__name */ 
typedef struct s__k__sn__const__name {
    t__int d__;
    t__int gen__;
    struct s__sn__const **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__const__name;
#define d__k__sn__const__name 468   

typedef k__sn__const__name k__const__name;
#define d__k__const__name d__k__sn__const__name

/* l__sn__post_load_detail */ 
typedef struct s__l__sn__post_load_detail {
    t__int d__;
    t__int gen__;
    struct s__sn__post_load_detail **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__post_load_detail;
#define d__l__sn__post_load_detail 67   

typedef l__sn__post_load_detail l__post_load_detail;
#define d__l__post_load_detail d__l__sn__post_load_detail

/* l__e_core__sn_filter_level */ 
typedef struct s__l__e_core__sn_filter_level {
    t__int d__;
    t__int gen__;
    t__e_core__sn_filter_level*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__sn_filter_level;
#define d__l__e_core__sn_filter_level 64   

typedef l__e_core__sn_filter_level l__sn_filter_level;
#define d__l__sn_filter_level d__l__e_core__sn_filter_level

/* l__sn__sn_generated_exp_code */ 
typedef struct s__l__sn__sn_generated_exp_code {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_generated_exp_code **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_generated_exp_code;
#define d__l__sn__sn_generated_exp_code 980   

typedef l__sn__sn_generated_exp_code l__sn_generated_exp_code;
#define d__l__sn_generated_exp_code d__l__sn__sn_generated_exp_code

/* k__sn__field_attributes__field */ 
typedef struct s__k__sn__field_attributes_4171 {
    t__int d__;
    t__int gen__;
    struct s__sn__field_attributes **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__field_attributes__field;
#define d__k__sn__field_attributes__field 1287   

typedef k__sn__field_attributes__field k__field_attributes__field;
#define d__k__field_attributes__field d__k__sn__field_attributes__field

/* l__sn__attr_item */ 
typedef struct s__l__sn__attr_item {
    t__int d__;
    t__int gen__;
    struct s__sn__attr_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__attr_item;
#define d__l__sn__attr_item 1286   

typedef l__sn__attr_item l__attr_item;
#define d__l__attr_item d__l__sn__attr_item

/* l__sn__n__struct_member */ 
typedef struct s__l__sn__n__struct_member {
    t__int d__;
    t__int gen__;
    struct s__sn__n__struct_member **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__n__struct_member;
#define d__l__sn__n__struct_member 329   

typedef l__sn__n__struct_member l__n__struct_member;
#define d__l__n__struct_member d__l__sn__n__struct_member

/* l__sn__template_instance_de5384 */ 
typedef struct s__l__sn__template_instance9845 {
    t__int d__;
    t__int gen__;
    struct s__sn__template_instance_de5329 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__template_instance_de5384;
#define d__l__sn__template_instance_de5384 1602   

typedef l__sn__template_instance_de5384 l__template_instance_descriptor;
#define d__l__template_instance_descriptor d__l__sn__template_instance_de5384

/* l__sn__n__type */ 
typedef struct s__l__sn__n__type {
    t__int d__;
    t__int gen__;
    struct s__sn__n__type **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__n__type;
#define d__l__sn__n__type 1608   

typedef l__sn__n__type l__n__type;
#define d__l__n__type d__l__sn__n__type

/* l__sn__encrypt_module */ 
typedef struct s__l__sn__encrypt_module {
    t__int d__;
    t__int gen__;
    struct s__sn__encrypt_module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__encrypt_module;
#define d__l__sn__encrypt_module 2406   

typedef l__sn__encrypt_module l__encrypt_module;
#define d__l__encrypt_module d__l__sn__encrypt_module

/* k__e_core__verilog_macro__name */ 
typedef struct s__k__e_core__verilog_macro_485 {
    t__int d__;
    t__int gen__;
    struct s__e_core__verilog_macro **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__verilog_macro__name;
#define d__k__e_core__verilog_macro__name 85   

typedef k__e_core__verilog_macro__name k__verilog_macro__name;
#define d__k__verilog_macro__name d__k__e_core__verilog_macro__name

/* k__e_core__deferred_macro__name */ 
typedef struct s__k__e_core__deferred_macro486 {
    t__int d__;
    t__int gen__;
    struct s__e_core__deferred_macro **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__deferred_macro__name;
#define d__k__e_core__deferred_macro__name 86   

typedef k__e_core__deferred_macro__name k__deferred_macro__name;
#define d__k__deferred_macro__name d__k__e_core__deferred_macro__name

/* k__sn__computed_name__name */ 
typedef struct s__k__sn__computed_name__name {
    t__int d__;
    t__int gen__;
    struct s__sn__computed_name **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__computed_name__name;
#define d__k__sn__computed_name__name 2232   

typedef k__sn__computed_name__name k__computed_name__name;
#define d__k__computed_name__name d__k__sn__computed_name__name

/* k__sn__computed_subprogram14573 */ 
typedef struct s__k__sn__computed_subprog14574 {
    t__int d__;
    t__int gen__;
    struct s__sn__computed_subprogram_name **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__computed_subprogram14573;
#define d__k__sn__computed_subprogram14573 2258   

typedef k__sn__computed_subprogram14573 k__computed_subprogram_nam14583;
#define d__k__computed_subprogram_nam14583 d__k__sn__computed_subprogram14573

/* k__sn__vhdl_driver_inst__name */ 
typedef struct s__k__sn__vhdl_driver_inst14575 {
    t__int d__;
    t__int gen__;
    struct s__sn__vhdl_driver_inst **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__vhdl_driver_inst__name;
#define d__k__sn__vhdl_driver_inst__name 2259   

typedef k__sn__vhdl_driver_inst__name k__vhdl_driver_inst__name;
#define d__k__vhdl_driver_inst__name d__k__sn__vhdl_driver_inst__name

/* l__sn__sn_verilog_code_inst */ 
typedef struct s__l__sn__sn_verilog_code_inst {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_verilog_code_inst **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_verilog_code_inst;
#define d__l__sn__sn_verilog_code_inst 2233   

typedef l__sn__sn_verilog_code_inst l__sn_verilog_code_inst;
#define d__l__sn_verilog_code_inst d__l__sn__sn_verilog_code_inst

/* l__sn__hdl_exp_info */ 
typedef struct s__l__sn__hdl_exp_info {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_exp_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__hdl_exp_info;
#define d__l__sn__hdl_exp_info 2238   

typedef l__sn__hdl_exp_info l__hdl_exp_info;
#define d__l__hdl_exp_info d__l__sn__hdl_exp_info

/* k__sn__translated_model_st14083 */ 
typedef struct s__k__sn__translated_model14576 {
    t__int d__;
    t__int gen__;
    struct s__sn__translated_model_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__translated_model_st14083;
#define d__k__sn__translated_model_st14083 2261   

typedef k__sn__translated_model_st14083 k__translated_model_struct14587;
#define d__k__translated_model_struct14587 d__k__sn__translated_model_st14083

/* l__sn__subprogram_param_info */ 
typedef struct s__l__sn__subprogram_param_info {
    t__int d__;
    t__int gen__;
    struct s__sn__subprogram_param_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__subprogram_param_info;
#define d__l__sn__subprogram_param_info 2253   

typedef l__sn__subprogram_param_info l__subprogram_param_info;
#define d__l__subprogram_param_info d__l__sn__subprogram_param_info

/* l__external_pointer */ 
typedef struct s__l__external_pointer {
    t__int d__;
    t__int gen__;
    t__external_pointer*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__external_pointer;
#define d__l__external_pointer 128   


/* k__sn__vlogfile__full_file_name */ 
typedef struct s__k__sn__vlogfile__full_f14578 {
    t__int d__;
    t__int gen__;
    struct s__sn__vlogfile **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__vlogfile__full_file_name;
#define d__k__sn__vlogfile__full_file_name 2399   

typedef k__sn__vlogfile__full_file_name k__vlogfile__full_file_name;
#define d__k__vlogfile__full_file_name d__k__sn__vlogfile__full_file_name

/* l__sn__low_high */ 
typedef struct s__l__sn__low_high {
    t__int d__;
    t__int gen__;
    struct s__sn__low_high **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__low_high;
#define d__l__sn__low_high 3042   

typedef l__sn__low_high l__low_high;
#define d__l__low_high d__l__sn__low_high

/* l__e_core__any_interface_port */ 
typedef struct s__l__e_core__any_interfa103496 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_interface_port **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_interface_port;
#define d__l__e_core__any_interface_port 9121   

typedef l__e_core__any_interface_port l__any_interface_port;
#define d__l__any_interface_port d__l__e_core__any_interface_port

/* k__sn__sn_interface_port_e68956 */ 
typedef struct s__k__sn__sn_interface_por68957 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_interface_port_e61024 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_interface_port_e68956;
#define d__k__sn__sn_interface_port_e68956 6862   

typedef k__sn__sn_interface_port_e68956 k__sn_interface_port_event69046;
#define d__k__sn_interface_port_event69046 d__k__sn__sn_interface_port_e68956

/* k__ml_ovm__bitstream_hold103497 */ 
typedef struct s__k__ml_ovm__bitstream_h103498 {
    t__int d__;
    t__int gen__;
    struct s__ml_ovm__bitstream_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__ml_ovm__bitstream_hold103497;
#define d__k__ml_ovm__bitstream_hold103497 9122   

typedef k__ml_ovm__bitstream_hold103497 k__bitstream_holder__call_id;
#define d__k__bitstream_holder__call_id d__k__ml_ovm__bitstream_hold103497

/* l__sn__sn_adapter_bridge */ 
typedef struct s__l__sn__sn_adapter_bridge {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_adapter_bridge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_adapter_bridge;
#define d__l__sn__sn_adapter_bridge 2264   

typedef l__sn__sn_adapter_bridge l__sn_adapter_bridge;
#define d__l__sn_adapter_bridge d__l__sn__sn_adapter_bridge

/* l__sn__sn_port_trace */ 
typedef struct s__l__sn__sn_port_trace {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_port_trace **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_port_trace;
#define d__l__sn__sn_port_trace 6720   

typedef l__sn__sn_port_trace l__sn_port_trace;
#define d__l__sn_port_trace d__l__sn__sn_port_trace

/* l__sn__sn_bind_channel */ 
typedef struct s__l__sn__sn_bind_channel {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_bind_channel **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_bind_channel;
#define d__l__sn__sn_bind_channel 6725   

typedef l__sn__sn_bind_channel l__sn_bind_channel;
#define d__l__sn_bind_channel d__l__sn__sn_bind_channel

/* l__sn__sn_esi_trace */ 
typedef struct s__l__sn__sn_esi_trace {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_esi_trace **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_esi_trace;
#define d__l__sn__sn_esi_trace 6972   

typedef l__sn__sn_esi_trace l__sn_esi_trace;
#define d__l__sn_esi_trace d__l__sn__sn_esi_trace

/* l__sn__sn_adapter_unit_manager */ 
typedef struct s__l__sn__sn_adapter_unit_68954 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_adapter_unit_manager **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_adapter_unit_manager;
#define d__l__sn__sn_adapter_unit_manager 7085   

typedef l__sn__sn_adapter_unit_manager l__sn_adapter_unit_manager;
#define d__l__sn_adapter_unit_manager d__l__sn__sn_adapter_unit_manager

/* l__sn__thread_list */ 
typedef struct s__l__sn__thread_list {
    t__int d__;
    t__int gen__;
    struct s__sn__thread_list **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__thread_list;
#define d__l__sn__thread_list 2358   

typedef l__sn__thread_list l__thread_list;
#define d__l__thread_list d__l__sn__thread_list

/* l__sn__script_instance */ 
typedef struct s__l__sn__script_instance {
    t__int d__;
    t__int gen__;
    struct s__sn__script_instance **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__script_instance;
#define d__l__sn__script_instance 2357   

typedef l__sn__script_instance l__script_instance;
#define d__l__script_instance d__l__sn__script_instance

/* l__sn__event_type */ 
typedef struct s__l__sn__event_type {
    t__int d__;
    t__int gen__;
    struct s__sn__event_type **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__event_type;
#define d__l__sn__event_type 2786   

typedef l__sn__event_type l__event_type;
#define d__l__event_type d__l__sn__event_type

/* k__sn__te_aliased_change_d20064 */ 
typedef struct s__k__sn__te_aliased_chang20065 {
    t__int d__;
    t__int gen__;
    struct s__sn__te_aliased_change_desc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__te_aliased_change_d20064;
#define d__k__sn__te_aliased_change_d20064 3047   

typedef k__sn__te_aliased_change_d20064 k__te_aliased_change_desc_20071;
#define d__k__te_aliased_change_desc_20071 d__k__sn__te_aliased_change_d20064

/* l__sn__sn_fl_count_state */ 
typedef struct s__l__sn__sn_fl_count_state {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_fl_count_state **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_fl_count_state;
#define d__l__sn__sn_fl_count_state 2790   

typedef l__sn__sn_fl_count_state l__sn_fl_count_state;
#define d__l__sn_fl_count_state d__l__sn__sn_fl_count_state

/* l__sn_fl__sn_fl_var_scndry */ 
typedef struct s__l__sn_fl__sn_fl_var_scndry {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_var_scndry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_var_scndry;
#define d__l__sn_fl__sn_fl_var_scndry 2963   

typedef l__sn_fl__sn_fl_var_scndry l__sn_fl_var_scndry;
#define d__l__sn_fl_var_scndry d__l__sn_fl__sn_fl_var_scndry

/* k__sn_fl__sn_fl_fsm_entry__id */ 
typedef struct s__k__sn_fl__sn_fl_fsm_ent19617 {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_fsm_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn_fl__sn_fl_fsm_entry__id;
#define d__k__sn_fl__sn_fl_fsm_entry__id 2996   

typedef k__sn_fl__sn_fl_fsm_entry__id k__sn_fl_fsm_entry__id;
#define d__k__sn_fl_fsm_entry__id d__k__sn_fl__sn_fl_fsm_entry__id

/* l__sn_fl__sn_fl_fsm_edge */ 
typedef struct s__l__sn_fl__sn_fl_fsm_edge {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_fsm_edge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_fsm_edge;
#define d__l__sn_fl__sn_fl_fsm_edge 2995   

typedef l__sn_fl__sn_fl_fsm_edge l__sn_fl_fsm_edge;
#define d__l__sn_fl_fsm_edge d__l__sn_fl__sn_fl_fsm_edge

/* k__sn__sn_bdd_var__name */ 
typedef struct s__k__sn__sn_bdd_var__name {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_bdd_var **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_bdd_var__name;
#define d__k__sn__sn_bdd_var__name 2874   

typedef k__sn__sn_bdd_var__name k__sn_bdd_var__name;
#define d__k__sn_bdd_var__name d__k__sn__sn_bdd_var__name

/* l__sn_fl__sn_fl_var_exec */ 
typedef struct s__l__sn_fl__sn_fl_var_exec {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_var_exec **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_var_exec;
#define d__l__sn_fl__sn_fl_var_exec 2967   

typedef l__sn_fl__sn_fl_var_exec l__sn_fl_var_exec;
#define d__l__sn_fl_var_exec d__l__sn_fl__sn_fl_var_exec

/* l__sn_fl__sn_fl_var_alpha */ 
typedef struct s__l__sn_fl__sn_fl_var_alpha {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_var_alpha **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_var_alpha;
#define d__l__sn_fl__sn_fl_var_alpha 2994   

typedef l__sn_fl__sn_fl_var_alpha l__sn_fl_var_alpha;
#define d__l__sn_fl_var_alpha d__l__sn_fl__sn_fl_var_alpha

/* l__sn_fl__sn_fl_var_true */ 
typedef struct s__l__sn_fl__sn_fl_var_true {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_var_true **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_var_true;
#define d__l__sn_fl__sn_fl_var_true 2968   

typedef l__sn_fl__sn_fl_var_true l__sn_fl_var_true;
#define d__l__sn_fl_var_true d__l__sn_fl__sn_fl_var_true

/* l__sn_fl__sn_fl_fsm_entry */ 
typedef struct s__l__sn_fl__sn_fl_fsm_entry {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_fsm_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_fsm_entry;
#define d__l__sn_fl__sn_fl_fsm_entry 2973   

typedef l__sn_fl__sn_fl_fsm_entry l__sn_fl_fsm_entry;
#define d__l__sn_fl_fsm_entry d__l__sn_fl__sn_fl_fsm_entry

/* l__sn_fl__sn_fl_detach_top_node */ 
typedef struct s__l__sn_fl__sn_fl_detach_19616 {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_detach_top_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_detach_top_node;
#define d__l__sn_fl__sn_fl_detach_top_node 2966   

typedef l__sn_fl__sn_fl_detach_top_node l__sn_fl_detach_top_node;
#define d__l__sn_fl_detach_top_node d__l__sn_fl__sn_fl_detach_top_node

/* l__sn_fl__sn_fl_var_count */ 
typedef struct s__l__sn_fl__sn_fl_var_count {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_var_count **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_var_count;
#define d__l__sn_fl__sn_fl_var_count 2969   

typedef l__sn_fl__sn_fl_var_count l__sn_fl_var_count;
#define d__l__sn_fl_var_count d__l__sn_fl__sn_fl_var_count

/* l__sn_fl__sn_fl_var_event */ 
typedef struct s__l__sn_fl__sn_fl_var_event {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_var_event **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_var_event;
#define d__l__sn_fl__sn_fl_var_event 2970   

typedef l__sn_fl__sn_fl_var_event l__sn_fl_var_event;
#define d__l__sn_fl_var_event d__l__sn_fl__sn_fl_var_event

/* k__sn__te_aliased_change_d20066 */ 
typedef struct s__k__sn__te_aliased_chang20067 {
    t__int d__;
    t__int gen__;
    struct s__sn__te_aliased_change_desc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__te_aliased_change_d20066;
#define d__k__sn__te_aliased_change_d20066 3048   

typedef k__sn__te_aliased_change_d20066 k__te_aliased_change_desc_20072;
#define d__k__te_aliased_change_desc_20072 d__k__sn__te_aliased_change_d20066

/* k__sn__one_instances_wts__inst */ 
typedef struct s__k__sn__one_instances_wt20068 {
    t__int d__;
    t__int gen__;
    struct s__sn__one_instances_wts **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__one_instances_wts__inst;
#define d__k__sn__one_instances_wts__inst 3051   

typedef k__sn__one_instances_wts__inst k__one_instances_wts__inst;
#define d__k__one_instances_wts__inst d__k__sn__one_instances_wts__inst

/* l__sn__waiting_thread */ 
typedef struct s__l__sn__waiting_thread {
    t__int d__;
    t__int gen__;
    struct s__sn__waiting_thread **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__waiting_thread;
#define d__l__sn__waiting_thread 2817   

typedef l__sn__waiting_thread l__waiting_thread;
#define d__l__waiting_thread d__l__sn__waiting_thread

/* l__sn__one_instances_wts */ 
typedef struct s__l__sn__one_instances_wts {
    t__int d__;
    t__int gen__;
    struct s__sn__one_instances_wts **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__one_instances_wts;
#define d__l__sn__one_instances_wts 3050   

typedef l__sn__one_instances_wts l__one_instances_wts;
#define d__l__one_instances_wts d__l__sn__one_instances_wts

/* k__sn__sn_one_inst_alias_d20069 */ 
typedef struct s__k__sn__sn_one_inst_alia20070 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_one_inst_alias_d20073 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_one_inst_alias_d20069;
#define d__k__sn__sn_one_inst_alias_d20069 3054   

typedef k__sn__sn_one_inst_alias_d20069 k__sn_one_inst_alias_descr20075;
#define d__k__sn_one_inst_alias_descr20075 d__k__sn__sn_one_inst_alias_d20069

/* l__sn__te_aliased_change_desc */ 
typedef struct s__l__sn__te_aliased_chang20074 {
    t__int d__;
    t__int gen__;
    struct s__sn__te_aliased_change_desc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__te_aliased_change_desc;
#define d__l__sn__te_aliased_change_desc 3053   

typedef l__sn__te_aliased_change_desc l__te_aliased_change_desc;
#define d__l__te_aliased_change_desc d__l__sn__te_aliased_change_desc

/* l__sn__event_trace_type */ 
typedef struct s__l__sn__event_trace_type {
    t__int d__;
    t__int gen__;
    struct s__sn__event_trace_type **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__event_trace_type;
#define d__l__sn__event_trace_type 2813   

typedef l__sn__event_trace_type l__event_trace_type;
#define d__l__event_trace_type d__l__sn__event_trace_type

/* l__sn__sn_event_struct */ 
typedef struct s__l__sn__sn_event_struct {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_event_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_event_struct;
#define d__l__sn__sn_event_struct 2814   

typedef l__sn__sn_event_struct l__sn_event_struct;
#define d__l__sn_event_struct d__l__sn__sn_event_struct

/* l__sn__sn_queue */ 
typedef struct s__l__sn__sn_queue {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_queue **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_queue;
#define d__l__sn__sn_queue 2816   

typedef l__sn__sn_queue l__sn_queue;
#define d__l__sn_queue d__l__sn__sn_queue

/* l__e_core__sn_struct */ 
typedef struct s__l__e_core__sn_struct {
    t__int d__;
    t__int gen__;
    struct s__e_core__sn_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__sn_struct;
#define d__l__e_core__sn_struct 2815   

typedef l__e_core__sn_struct l__sn_struct;
#define d__l__sn_struct d__l__e_core__sn_struct

/* l__sn__tesv_store */ 
typedef struct s__l__sn__tesv_store {
    t__int d__;
    t__int gen__;
    struct s__sn__tesv_store **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__tesv_store;
#define d__l__sn__tesv_store 3044   

typedef l__sn__tesv_store l__tesv_store;
#define d__l__tesv_store d__l__sn__tesv_store

/* l__sn__te_memory */ 
typedef struct s__l__sn__te_memory {
    t__int d__;
    t__int gen__;
    struct s__sn__te_memory **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__te_memory;
#define d__l__sn__te_memory 3043   

typedef l__sn__te_memory l__te_memory;
#define d__l__te_memory d__l__sn__te_memory

/* l__sn__sn_tcm_thread */ 
typedef struct s__l__sn__sn_tcm_thread {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_tcm_thread **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_tcm_thread;
#define d__l__sn__sn_tcm_thread 3113   

typedef l__sn__sn_tcm_thread l__sn_tcm_thread;
#define d__l__sn_tcm_thread d__l__sn__sn_tcm_thread

/* l__sn__frame_list */ 
typedef struct s__l__sn__frame_list {
    t__int d__;
    t__int gen__;
    struct s__sn__frame_list **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__frame_list;
#define d__l__sn__frame_list 3116   

typedef l__sn__frame_list l__frame_list;
#define d__l__frame_list d__l__sn__frame_list

/* l__reflection__rf_value_holder */ 
typedef struct s__l__reflection__rf_value_9907 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_value_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_value_holder;
#define d__l__reflection__rf_value_holder 1798   

typedef l__reflection__rf_value_holder l__rf_value_holder;
#define d__l__rf_value_holder d__l__reflection__rf_value_holder

/* l__sn__sn_tprof_util */ 
typedef struct s__l__sn__sn_tprof_util {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_tprof_util **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_tprof_util;
#define d__l__sn__sn_tprof_util 9142   

typedef l__sn__sn_tprof_util l__sn_tprof_util;
#define d__l__sn_tprof_util d__l__sn__sn_tprof_util

/* k__sn__ExplicitName__name */ 
typedef struct s__k__sn__ExplicitName__name {
    t__int d__;
    t__int gen__;
    struct s__sn__ExplicitName **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__ExplicitName__name;
#define d__k__sn__ExplicitName__name 94   

typedef k__sn__ExplicitName__name k__ExplicitName__name;
#define d__k__ExplicitName__name d__k__sn__ExplicitName__name

/* l__e_core__sn_redirect_outpu487 */ 
typedef struct s__l__e_core__sn_redirect_ou488 {
    t__int d__;
    t__int gen__;
    struct s__e_core__sn_redirect_outpu489 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__sn_redirect_outpu487;
#define d__l__e_core__sn_redirect_outpu487 96   

typedef l__e_core__sn_redirect_outpu487 l__sn_redirect_output_bucket;
#define d__l__sn_redirect_output_bucket d__l__e_core__sn_redirect_outpu487

/* k__sn__sn_warn_struct__id */ 
typedef struct s__k__sn__sn_warn_struct__id {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_warn_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_warn_struct__id;
#define d__k__sn__sn_warn_struct__id 1622   

typedef k__sn__sn_warn_struct__id k__sn_warn_struct__id;
#define d__k__sn_warn_struct__id d__k__sn__sn_warn_struct__id

/* k__sn__sn_warn_struct_memb11895 */ 
typedef struct s__k__sn__sn_warn_struct_m11896 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_warn_struct_member **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_warn_struct_memb11895;
#define d__k__sn__sn_warn_struct_memb11895 1932   

typedef k__sn__sn_warn_struct_memb11895 k__sn_warn_struct_member__11905;
#define d__k__sn_warn_struct_member__11905 d__k__sn__sn_warn_struct_memb11895

/* k__sn__sn_warn_struct_memb11897 */ 
typedef struct s__k__sn__sn_warn_struct_m11898 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_warn_struct_member **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_warn_struct_memb11897;
#define d__k__sn__sn_warn_struct_memb11897 1933   

typedef k__sn__sn_warn_struct_memb11897 k__sn_warn_struct_member__sd;
#define d__k__sn_warn_struct_member__sd d__k__sn__sn_warn_struct_memb11897

/* k__sn__comm_transfered_out22362 */ 
typedef struct s__k__sn__comm_transfered_22363 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_transfered_out22230 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__comm_transfered_out22362;
#define d__k__sn__comm_transfered_out22362 3329   

typedef k__sn__comm_transfered_out22362 k__comm_transfered_out_req22364;
#define d__k__comm_transfered_out_req22364 d__k__sn__comm_transfered_out22362

/* k__sn__comm_waiting_in_rep22365 */ 
typedef struct s__k__sn__comm_waiting_in_22366 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_waiting_in_reply **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__comm_waiting_in_rep22365;
#define d__k__sn__comm_waiting_in_rep22365 3328   

typedef k__sn__comm_waiting_in_rep22365 k__comm_waiting_in_reply__id;
#define d__k__comm_waiting_in_reply__id d__k__sn__comm_waiting_in_rep22365

/* l__sn__comm_client_applica22346 */ 
typedef struct s__l__sn__comm_client_appl22356 {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_client_applica22370 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__comm_client_applica22346;
#define d__l__sn__comm_client_applica22346 3345   

typedef l__sn__comm_client_applica22346 l__comm_client_application_desc;
#define d__l__comm_client_application_desc d__l__sn__comm_client_applica22346

/* l__sn__Token */ 
typedef struct s__l__sn__Token {
    t__int d__;
    t__int gen__;
    struct s__sn__Token **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__Token;
#define d__l__sn__Token 9368   

typedef l__sn__Token l__Token;
#define d__l__Token d__l__sn__Token

/* l__pat */ 
typedef struct s__l__pat {
    t__int d__;
    t__int gen__;
    t__pat*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__pat;
#define d__l__pat 614   


/* l__sn__cvl_connection */ 
typedef struct s__l__sn__cvl_connection {
    t__int d__;
    t__int gen__;
    struct s__sn__cvl_connection **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cvl_connection;
#define d__l__sn__cvl_connection 3262   

typedef l__sn__cvl_connection l__cvl_connection;
#define d__l__cvl_connection d__l__sn__cvl_connection

/* l__sn__queued_cvl_call */ 
typedef struct s__l__sn__queued_cvl_call {
    t__int d__;
    t__int gen__;
    struct s__sn__queued_cvl_call **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__queued_cvl_call;
#define d__l__sn__queued_cvl_call 3261   

typedef l__sn__queued_cvl_call l__queued_cvl_call;
#define d__l__queued_cvl_call d__l__sn__queued_cvl_call

/* l__sn__sn_checksum_t */ 
typedef struct s__l__sn__sn_checksum_t {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_checksum_t **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_checksum_t;
#define d__l__sn__sn_checksum_t 3263   

typedef l__sn__sn_checksum_t l__sn_checksum_t;
#define d__l__sn_checksum_t d__l__sn__sn_checksum_t

/* l__sn__sn_cvl_method */ 
typedef struct s__l__sn__sn_cvl_method {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_cvl_method **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_cvl_method;
#define d__l__sn__sn_cvl_method 3277   

typedef l__sn__sn_cvl_method l__sn_cvl_method;
#define d__l__sn_cvl_method d__l__sn__sn_cvl_method

/* k__sn__sn_message_action__it */ 
typedef struct s__k__sn__sn_message_action__it {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_message_action__it;
#define d__k__sn__sn_message_action__it 7334   

typedef k__sn__sn_message_action__it k__sn_message_action__it;
#define d__k__sn_message_action__it d__k__sn__sn_message_action__it

/* k__sn__sn_message_destinat70564 */ 
typedef struct s__k__sn__sn_message_desti70941 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_destination **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_message_destinat70564;
#define d__k__sn__sn_message_destinat70564 7330   

typedef k__sn__sn_message_destinat70564 k__sn_message_destination__it;
#define d__k__sn_message_destination__it d__k__sn__sn_message_destinat70564

/* l__e_core__message_tag */ 
typedef struct s__l__e_core__message_tag {
    t__int d__;
    t__int gen__;
    t__e_core__message_tag*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__message_tag;
#define d__l__e_core__message_tag 7337   

typedef l__e_core__message_tag l__message_tag;
#define d__l__message_tag d__l__e_core__message_tag

/* l__sn__sn_message_destinations */ 
typedef struct s__l__sn__sn_message_desti70942 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_destinations **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_message_destinations;
#define d__l__sn__sn_message_destinations 7380   

typedef l__sn__sn_message_destinations l__sn_message_destinations;
#define d__l__sn_message_destinations d__l__sn__sn_message_destinations

/* l__sn__sn_message_destination */ 
typedef struct s__l__sn__sn_message_desti70940 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_destination **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_message_destination;
#define d__l__sn__sn_message_destination 7336   

typedef l__sn__sn_message_destination l__sn_message_destination;
#define d__l__sn_message_destination d__l__sn__sn_message_destination

/* l__sn__sort_item */ 
typedef struct s__l__sn__sort_item {
    t__int d__;
    t__int gen__;
    struct s__sn__sort_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sort_item;
#define d__l__sn__sort_item 981   

typedef l__sn__sort_item l__sort_item;
#define d__l__sort_item d__l__sn__sort_item

/* l__sn__trans_table_item */ 
typedef struct s__l__sn__trans_table_item {
    t__int d__;
    t__int gen__;
    struct s__sn__trans_table_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__trans_table_item;
#define d__l__sn__trans_table_item 7278   

typedef l__sn__trans_table_item l__trans_table_item;
#define d__l__trans_table_item d__l__sn__trans_table_item

/* l__main__sn_cvr_instance_g26491 */ 
typedef struct s__l__main__sn_cvr_instanc27209 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_instance_g27174 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_instance_g26491;
#define d__l__main__sn_cvr_instance_g26491 3663   

typedef l__main__sn_cvr_instance_g26491 l__sn_cvr_instance_group_d27208;
#define d__l__sn_cvr_instance_group_d27208 d__l__main__sn_cvr_instance_g26491

/* k__main__sn_external_A_cov24732 */ 
typedef struct s__k__main__sn_external_A_27138 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_external_A_cov27202 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_external_A_cov24732;
#define d__k__main__sn_external_A_cov24732 3664   

typedef k__main__sn_external_A_cov24732 k__sn_external_A_cover_age27210;
#define d__k__sn_external_A_cover_age27210 d__k__main__sn_external_A_cov24732

/* l__main__sn_cvr_external_m25057 */ 
typedef struct s__l__main__sn_cvr_externa27190 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_external_m27192 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_external_m25057;
#define d__l__main__sn_cvr_external_m25057 3659   

typedef l__main__sn_cvr_external_m25057 l__sn_cvr_external_main_gr27191;
#define d__l__sn_cvr_external_main_gr27191 d__l__main__sn_cvr_external_m25057

/* l__main__sn_cvr_test_rank_info */ 
typedef struct s__l__main__sn_cvr_test_ra27211 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_test_rank_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_test_rank_info;
#define d__l__main__sn_cvr_test_rank_info 3879   

typedef l__main__sn_cvr_test_rank_info l__sn_cvr_test_rank_info;
#define d__l__sn_cvr_test_rank_info d__l__main__sn_cvr_test_rank_info

/* l__main__sn_cvr_group_rank_info */ 
typedef struct s__l__main__sn_cvr_group_r24528 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_group_rank_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_group_rank_info;
#define d__l__main__sn_cvr_group_rank_info 3660   

typedef l__main__sn_cvr_group_rank_info l__sn_cvr_group_rank_info;
#define d__l__sn_cvr_group_rank_info d__l__main__sn_cvr_group_rank_info

/* l__main__sn_cvr_item_rank_info */ 
typedef struct s__l__main__sn_cvr_item_ra27205 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_item_rank_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_item_rank_info;
#define d__l__main__sn_cvr_item_rank_info 3662   

typedef l__main__sn_cvr_item_rank_info l__sn_cvr_item_rank_info;
#define d__l__sn_cvr_item_rank_info d__l__main__sn_cvr_item_rank_info

/* l__main__sn_cvr_bucket_ran24153 */ 
typedef struct s__l__main__sn_cvr_bucket_24154 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_bucket_ran27194 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_bucket_ran24153;
#define d__l__main__sn_cvr_bucket_ran24153 3658   

typedef l__main__sn_cvr_bucket_ran24153 l__sn_cvr_bucket_rank_info;
#define d__l__sn_cvr_bucket_rank_info d__l__main__sn_cvr_bucket_ran24153

/* l__main__sn_cvr_bucket_ran26617 */ 
typedef struct s__l__main__sn_cvr_bucket_27207 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_bucket_ran27195 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_bucket_ran26617;
#define d__l__main__sn_cvr_bucket_ran26617 3661   

typedef l__main__sn_cvr_bucket_ran26617 l__sn_cvr_bucket_rank_desc27206;
#define d__l__sn_cvr_bucket_rank_desc27206 d__l__main__sn_cvr_bucket_ran26617

/* k__main__sn_cvr_test_rank_26414 */ 
typedef struct s__k__main__sn_cvr_test_ra27212 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_test_rank_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_cvr_test_rank_26414;
#define d__k__main__sn_cvr_test_rank_26414 3881   

typedef k__main__sn_cvr_test_rank_26414 k__sn_cvr_test_rank_info__id;
#define d__k__sn_cvr_test_rank_info__id d__k__main__sn_cvr_test_rank_26414

/* l__main__sn_cvr_gui_curr_page */ 
typedef struct s__l__main__sn_cvr_gui_cur75073 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_gui_curr_page **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_gui_curr_page;
#define d__l__main__sn_cvr_gui_curr_page 7395   

typedef l__main__sn_cvr_gui_curr_page l__sn_cvr_gui_curr_page;
#define d__l__sn_cvr_gui_curr_page d__l__main__sn_cvr_gui_curr_page

/* l__main__sn_cvr_table_column */ 
typedef struct s__l__main__sn_cvr_table_column {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_table_column **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_table_column;
#define d__l__main__sn_cvr_table_column 7394   

typedef l__main__sn_cvr_table_column l__sn_cvr_table_column;
#define d__l__sn_cvr_table_column d__l__main__sn_cvr_table_column

/* l__vt__vt_menu_component */ 
typedef struct s__l__vt__vt_menu_component {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_menu_component **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_menu_component;
#define d__l__vt__vt_menu_component 4964   

typedef l__vt__vt_menu_component l__vt_menu_component;
#define d__l__vt_menu_component d__l__vt__vt_menu_component

/* l__vt__vt_toolbar */ 
typedef struct s__l__vt__vt_toolbar {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_toolbar **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_toolbar;
#define d__l__vt__vt_toolbar 4959   

typedef l__vt__vt_toolbar l__vt_toolbar;
#define d__l__vt_toolbar d__l__vt__vt_toolbar

/* l__vt__vt_appl_action */ 
typedef struct s__l__vt__vt_appl_action {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_appl_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_appl_action;
#define d__l__vt__vt_appl_action 4963   

typedef l__vt__vt_appl_action l__vt_appl_action;
#define d__l__vt_appl_action d__l__vt__vt_appl_action

/* k__vt__vt_menu__m_name */ 
typedef struct s__k__vt__vt_menu__m_name {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_menu **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_menu__m_name;
#define d__k__vt__vt_menu__m_name 4966   

typedef k__vt__vt_menu__m_name k__vt_menu__m_name;
#define d__k__vt_menu__m_name d__k__vt__vt_menu__m_name

/* k__vt__vt_base_action__m_name */ 
typedef struct s__k__vt__vt_base_action__39950 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_base_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_base_action__m_name;
#define d__k__vt__vt_base_action__m_name 4967   

typedef k__vt__vt_base_action__m_name k__vt_base_action__m_name;
#define d__k__vt_base_action__m_name d__k__vt__vt_base_action__m_name

/* k__vt__vt_action_group__m_name */ 
typedef struct s__k__vt__vt_action_group_39951 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_action_group **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_action_group__m_name;
#define d__k__vt__vt_action_group__m_name 4968   

typedef k__vt__vt_action_group__m_name k__vt_action_group__m_name;
#define d__k__vt_action_group__m_name d__k__vt__vt_action_group__m_name

/* l__vt__vt_member_action */ 
typedef struct s__l__vt__vt_member_action {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_member_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_member_action;
#define d__l__vt__vt_member_action 4965   

typedef l__vt__vt_member_action l__vt_member_action;
#define d__l__vt_member_action d__l__vt__vt_member_action

/* l__vt__jvt_menu */ 
typedef struct s__l__vt__jvt_menu {
    t__int d__;
    t__int gen__;
    struct s__vt__jvt_menu **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__jvt_menu;
#define d__l__vt__jvt_menu 5076   

typedef l__vt__jvt_menu l__jvt_menu;
#define d__l__jvt_menu d__l__vt__jvt_menu

/* l__vt__jmenu_component */ 
typedef struct s__l__vt__jmenu_component {
    t__int d__;
    t__int gen__;
    struct s__vt__jmenu_component **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__jmenu_component;
#define d__l__vt__jmenu_component 5078   

typedef l__vt__jmenu_component l__jmenu_component;
#define d__l__jmenu_component d__l__vt__jmenu_component

/* l__vt__jvt_toolbar */ 
typedef struct s__l__vt__jvt_toolbar {
    t__int d__;
    t__int gen__;
    struct s__vt__jvt_toolbar **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__jvt_toolbar;
#define d__l__vt__jvt_toolbar 5077   

typedef l__vt__jvt_toolbar l__jvt_toolbar;
#define d__l__jvt_toolbar d__l__vt__jvt_toolbar

/* k__vt__vt_element__m_name */ 
typedef struct s__k__vt__vt_element__m_name {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_element__m_name;
#define d__k__vt__vt_element__m_name 5028   

typedef k__vt__vt_element__m_name k__vt_element__m_name;
#define d__k__vt_element__m_name d__k__vt__vt_element__m_name

/* k__vt__vt_control__m_name */ 
typedef struct s__k__vt__vt_control__m_name {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_control **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_control__m_name;
#define d__k__vt__vt_control__m_name 5029   

typedef k__vt__vt_control__m_name k__vt_control__m_name;
#define d__k__vt_control__m_name d__k__vt__vt_control__m_name

/* k__vt__vt_container__m_name */ 
typedef struct s__k__vt__vt_container__m_name {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_container **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_container__m_name;
#define d__k__vt__vt_container__m_name 5030   

typedef k__vt__vt_container__m_name k__vt_container__m_name;
#define d__k__vt_container__m_name d__k__vt__vt_container__m_name

/* l__vt__vt_element */ 
typedef struct s__l__vt__vt_element {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_element;
#define d__l__vt__vt_element 4916   

typedef l__vt__vt_element l__vt_element;
#define d__l__vt_element d__l__vt__vt_element

/* k__vt__vt_control__m_id */ 
typedef struct s__k__vt__vt_control__m_id {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_control **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_control__m_id;
#define d__k__vt__vt_control__m_id 5031   

typedef k__vt__vt_control__m_id k__vt_control__m_id;
#define d__k__vt_control__m_id d__k__vt__vt_control__m_id

/* k__vt__vt_container__m_id */ 
typedef struct s__k__vt__vt_container__m_id {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_container **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_container__m_id;
#define d__k__vt__vt_container__m_id 5032   

typedef k__vt__vt_container__m_id k__vt_container__m_id;
#define d__k__vt_container__m_id d__k__vt__vt_container__m_id

/* l__vt__vt_toggle_button_group */ 
typedef struct s__l__vt__vt_toggle_button37314 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_toggle_button_group **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_toggle_button_group;
#define d__l__vt__vt_toggle_button_group 4911   

typedef l__vt__vt_toggle_button_group l__vt_toggle_button_group;
#define d__l__vt_toggle_button_group d__l__vt__vt_toggle_button_group

/* k__vt__vt_temp_file_data__39737 */ 
typedef struct s__k__vt__vt_temp_file_dat39738 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_temp_file_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_temp_file_data__39737;
#define d__k__vt__vt_temp_file_data__39737 5379   

typedef k__vt__vt_temp_file_data__39737 k__vt_temp_file_data__file_name;
#define d__k__vt_temp_file_data__file_name d__k__vt__vt_temp_file_data__39737

/* l__vt__vt_action_enabling_info */ 
typedef struct s__l__vt__vt_action_enabli48631 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_action_enabling_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_action_enabling_info;
#define d__l__vt__vt_action_enabling_info 5406   

typedef l__vt__vt_action_enabling_info l__vt_action_enabling_info;
#define d__l__vt_action_enabling_info d__l__vt__vt_action_enabling_info

/* l__vt__status_pane_modifya37343 */ 
typedef struct s__l__vt__status_pane_modi37344 {
    t__int d__;
    t__int gen__;
    struct s__vt__status_pane_modifya37345 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__status_pane_modifya37343;
#define d__l__vt__status_pane_modifya37343 5025   

typedef l__vt__status_pane_modifya37343 l__status_pane_modifyable_data;
#define d__l__status_pane_modifyable_data d__l__vt__status_pane_modifya37343

/* k__vt__vt_symbol__name */ 
typedef struct s__k__vt__vt_symbol__name {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_symbol **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_symbol__name;
#define d__k__vt__vt_symbol__name 5375   

typedef k__vt__vt_symbol__name k__vt_symbol__name;
#define d__k__vt_symbol__name d__k__vt__vt_symbol__name

/* l__vt__vt_table */ 
typedef struct s__l__vt__vt_table {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_table **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_table;
#define d__l__vt__vt_table 4914   

typedef l__vt__vt_table l__vt_table;
#define d__l__vt_table d__l__vt__vt_table

/* k__vt__vt_table_col_wrappe76965 */ 
typedef struct s__k__vt__vt_table_col_wra76966 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_table_col_wrapper **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_table_col_wrappe76965;
#define d__k__vt__vt_table_col_wrappe76965 7844   

typedef k__vt__vt_table_col_wrappe76965 k__vt_table_col_wrapper__m_name;
#define d__k__vt_table_col_wrapper__m_name d__k__vt__vt_table_col_wrappe76965

/* l__vt__vt_filter_kind */ 
typedef struct s__l__vt__vt_filter_kind {
    t__int d__;
    t__int gen__;
    t__vt__vt_filter_kind*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_filter_kind;
#define d__l__vt__vt_filter_kind 5033   

typedef l__vt__vt_filter_kind l__vt_filter_kind;
#define d__l__vt_filter_kind d__l__vt__vt_filter_kind

/* k__vt__vt_data_table_row__it */ 
typedef struct s__k__vt__vt_data_table_row__it {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_data_table_row **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_data_table_row__it;
#define d__k__vt__vt_data_table_row__it 7851   

typedef k__vt__vt_data_table_row__it k__vt_data_table_row__it;
#define d__k__vt_data_table_row__it d__k__vt__vt_data_table_row__it

/* l__vt__vt_color */ 
typedef struct s__l__vt__vt_color {
    t__int d__;
    t__int gen__;
    t__vt__vt_color*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_color;
#define d__l__vt__vt_color 3979   

typedef l__vt__vt_color l__vt_color;
#define d__l__vt_color d__l__vt__vt_color

/* k__vt__vt_table_sorted_col77718 */ 
typedef struct s__k__vt__vt_table_sorted_80438 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_table_sorted_col_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_table_sorted_col77718;
#define d__k__vt__vt_table_sorted_col77718 7852   

typedef k__vt__vt_table_sorted_col77718 k__vt_table_sorted_col_dat80442;
#define d__k__vt_table_sorted_col_dat80442 d__k__vt__vt_table_sorted_col77718

/* l__e_core__any_sequence_item */ 
typedef struct s__l__e_core__any_sequence_item {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_sequence_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_sequence_item;
#define d__l__e_core__any_sequence_item 7740   

typedef l__e_core__any_sequence_item l__any_sequence_item;
#define d__l__any_sequence_item d__l__e_core__any_sequence_item

/* l__e_core__any_sequence */ 
typedef struct s__l__e_core__any_sequence {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_sequence **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_sequence;
#define d__l__e_core__any_sequence 7741   

typedef l__e_core__any_sequence l__any_sequence;
#define d__l__any_sequence d__l__e_core__any_sequence

/* l__sn__do_request */ 
typedef struct s__l__sn__do_request {
    t__int d__;
    t__int gen__;
    struct s__sn__do_request **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__do_request;
#define d__l__sn__do_request 7744   

typedef l__sn__do_request l__do_request;
#define d__l__do_request d__l__sn__do_request

/* l__sn__item_producer */ 
typedef struct s__l__sn__item_producer {
    t__int d__;
    t__int gen__;
    struct s__sn__item_producer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__item_producer;
#define d__l__sn__item_producer 7745   

typedef l__sn__item_producer l__item_producer;
#define d__l__item_producer d__l__sn__item_producer

/* l__sn__sn_sequence_tr_ext_info */ 
typedef struct s__l__sn__sn_sequence_tr_e80363 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_sequence_tr_ext_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_sequence_tr_ext_info;
#define d__l__sn__sn_sequence_tr_ext_info 7747   

typedef l__sn__sn_sequence_tr_ext_info l__sn_sequence_tr_ext_info;
#define d__l__sn_sequence_tr_ext_info d__l__sn__sn_sequence_tr_ext_info

/* l__sn__sn_transaction_attr */ 
typedef struct s__l__sn__sn_transaction_attr {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_transaction_attr **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_transaction_attr;
#define d__l__sn__sn_transaction_attr 4383   

typedef l__sn__sn_transaction_attr l__sn_transaction_attr;
#define d__l__sn_transaction_attr d__l__sn__sn_transaction_attr

/* l__sn__sn_transaction_exte34151 */ 
typedef struct s__l__sn__sn_transaction_e34152 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_transaction_exte33625 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_transaction_exte34151;
#define d__l__sn__sn_transaction_exte34151 4384   

typedef l__sn__sn_transaction_exte34151 l__sn_transaction_external_info;
#define d__l__sn_transaction_external_info d__l__sn__sn_transaction_exte34151

/* k__sn__sn_fiber__scope_and33745 */ 
typedef struct s__k__sn__sn_fiber__scope_34153 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_fiber **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_fiber__scope_and33745;
#define d__k__sn__sn_fiber__scope_and33745 4387   

typedef k__sn__sn_fiber__scope_and33745 k__sn_fiber__scope_and_fib34160;
#define d__k__sn_fiber__scope_and_fib34160 d__k__sn__sn_fiber__scope_and33745

/* k__sn__sn_trans_type_threa33748 */ 
typedef struct s__k__sn__sn_trans_type_th34158 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_trans_type_thread **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_trans_type_threa33748;
#define d__k__sn__sn_trans_type_threa33748 4388   

typedef k__sn__sn_trans_type_threa33748 k__sn_trans_type_thread__t34161;
#define d__k__sn_trans_type_thread__t34161 d__k__sn__sn_trans_type_threa33748

/* l__sn__sn_root_sequence_tr80364 */ 
typedef struct s__l__sn__sn_root_sequence80365 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_root_sequence_tr80399 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_root_sequence_tr80364;
#define d__l__sn__sn_root_sequence_tr80364 7748   

typedef l__sn__sn_root_sequence_tr80364 l__sn_root_sequence_tr_ext_info;
#define d__l__sn_root_sequence_tr_ext_info d__l__sn__sn_root_sequence_tr80364

/* k__main__sn_cvr_main_group24409 */ 
typedef struct s__k__main__sn_cvr_main_gr27134 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_main_group24182 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_cvr_main_group24409;
#define d__k__main__sn_cvr_main_group24409 3669   

typedef k__main__sn_cvr_main_group24409 k__sn_cvr_main_group_descr27214;
#define d__k__sn_cvr_main_group_descr27214 d__k__main__sn_cvr_main_group24409

/* l__sn__sn_run_time_match_check */ 
typedef struct s__l__sn__sn_run_time_match4201 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_run_time_match_check **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_run_time_match_check;
#define d__l__sn__sn_run_time_match_check 1339   

typedef l__sn__sn_run_time_match_check l__sn_run_time_match_check;
#define d__l__sn_run_time_match_check d__l__sn__sn_run_time_match_check

/* k__main__sn_cvr_main_group27135 */ 
typedef struct s__k__main__sn_cvr_main_gr27136 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_main_group24182 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_cvr_main_group27135;
#define d__k__main__sn_cvr_main_group27135 3681   

typedef k__main__sn_cvr_main_group27135 k__sn_cvr_main_group_descr27226;
#define d__k__sn_cvr_main_group_descr27226 d__k__main__sn_cvr_main_group27135

/* l__main__sn_cvr_main_group24373 */ 
typedef struct s__l__main__sn_cvr_main_gr24808 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_main_group24182 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_main_group24373;
#define d__l__main__sn_cvr_main_group24373 3682   

typedef l__main__sn_cvr_main_group24373 l__sn_cvr_main_group_descriptor;
#define d__l__sn_cvr_main_group_descriptor d__l__main__sn_cvr_main_group24373

/* l__main__sn_cover_analysis_test */ 
typedef struct s__l__main__sn_cover_analy27137 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_analysis_test **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cover_analysis_test;
#define d__l__main__sn_cover_analysis_test 3694   

typedef l__main__sn_cover_analysis_test l__sn_cover_analysis_test;
#define d__l__sn_cover_analysis_test d__l__main__sn_cover_analysis_test

/* l__main__sn_cover_group_inst */ 
typedef struct s__l__main__sn_cover_group_inst {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_group_inst **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cover_group_inst;
#define d__l__main__sn_cover_group_inst 3690   

typedef l__main__sn_cover_group_inst l__sn_cover_group_inst;
#define d__l__sn_cover_group_inst d__l__main__sn_cover_group_inst

/* l__main__sn_cover_item_inst */ 
typedef struct s__l__main__sn_cover_item_inst {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_item_inst **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cover_item_inst;
#define d__l__main__sn_cover_item_inst 3692   

typedef l__main__sn_cover_item_inst l__sn_cover_item_inst;
#define d__l__sn_cover_item_inst d__l__main__sn_cover_item_inst

/* k__main__mapping_env_pair_72582 */ 
typedef struct s__k__main__mapping_env_pa75068 {
    t__int d__;
    t__int gen__;
    struct s__main__mapping_env_pair **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__mapping_env_pair_72582;
#define d__k__main__mapping_env_pair_72582 7518   

typedef k__main__mapping_env_pair_72582 k__mapping_env_pair__numer75147;
#define d__k__mapping_env_pair__numer75147 d__k__main__mapping_env_pair_72582

/* l__main__cover_struct */ 
typedef struct s__l__main__cover_struct {
    t__int d__;
    t__int gen__;
    struct s__main__cover_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__cover_struct;
#define d__l__main__cover_struct 3689   

typedef l__main__cover_struct l__cover_struct;
#define d__l__cover_struct d__l__main__cover_struct

/* k__main__sn_external_asser75069 */ 
typedef struct s__k__main__sn_external_as75070 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_external_asser24698 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_external_asser75069;
#define d__k__main__sn_external_asser75069 7553   

typedef k__main__sn_external_asser75069 k__sn_external_assertion_a75167;
#define d__k__sn_external_assertion_a75167 d__k__main__sn_external_asser75069

/* l__sn__assert_info */ 
typedef struct s__l__sn__assert_info {
    t__int d__;
    t__int gen__;
    struct s__sn__assert_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__assert_info;
#define d__l__sn__assert_info 7554   

typedef l__sn__assert_info l__assert_info;
#define d__l__assert_info d__l__sn__assert_info

/* k__sn__enum_item__name */ 
typedef struct s__k__sn__enum_item__name {
    t__int d__;
    t__int gen__;
    struct s__sn__enum_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__enum_item__name;
#define d__k__sn__enum_item__name 182   

typedef k__sn__enum_item__name k__enum_item__name;
#define d__k__enum_item__name d__k__sn__enum_item__name

/* k__main__sn_external_B_cov24753 */ 
typedef struct s__k__main__sn_external_B_27139 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_external_B_cov27203 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_external_B_cov24753;
#define d__k__main__sn_external_B_cov24753 3709   

typedef k__main__sn_external_B_cov24753 k__sn_external_B_cover_age27234;
#define d__k__sn_external_B_cover_age27234 d__k__main__sn_external_B_cov24753

/* k__main__sn_external_C_cov27140 */ 
typedef struct s__k__main__sn_external_C_27141 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_external_C_cov27204 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_external_C_cov27140;
#define d__k__main__sn_external_C_cov27140 3710   

typedef k__main__sn_external_C_cov27140 k__sn_external_C_cover_age27235;
#define d__k__sn_external_C_cover_age27235 d__k__main__sn_external_C_cov27140

/* k__main__sn_external_cover25059 */ 
typedef struct s__k__main__sn_external_co27142 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_external_cover24234 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_external_cover25059;
#define d__k__main__sn_external_cover25059 3711   

typedef k__main__sn_external_cover25059 k__sn_external_cover_agent27236;
#define d__k__sn_external_cover_agent27236 d__k__main__sn_external_cover25059

/* l__main__sn_search_item */ 
typedef struct s__l__main__sn_search_item {
    t__int d__;
    t__int gen__;
    struct s__main__sn_search_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_search_item;
#define d__l__main__sn_search_item 3787   

typedef l__main__sn_search_item l__sn_search_item;
#define d__l__sn_search_item d__l__main__sn_search_item

/* k__sn__sn_p_key_store_entry4514 */ 
typedef struct s__k__sn__sn_p_key_store_en4515 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_p_key_store_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_p_key_store_entry4514;
#define d__k__sn__sn_p_key_store_entry4514 1527   

typedef k__sn__sn_p_key_store_entry4514 k__sn_p_key_store_entry__key;
#define d__k__sn_p_key_store_entry__key d__k__sn__sn_p_key_store_entry4514

/* k__main__sn_cover_item_inst__it */ 
typedef struct s__k__main__sn_cover_item_75057 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_item_inst **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_cover_item_inst__it;
#define d__k__main__sn_cover_item_inst__it 7446   

typedef k__main__sn_cover_item_inst__it k__sn_cover_item_inst__it;
#define d__k__sn_cover_item_inst__it d__k__main__sn_cover_item_inst__it

/* k__main__sn_unicov_check_d72343 */ 
typedef struct s__k__main__sn_unicov_chec75058 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_unicov_check_d75128 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_unicov_check_d72343;
#define d__k__main__sn_unicov_check_d72343 7494   

typedef k__main__sn_unicov_check_d72343 k__sn_unicov_check_descrip75133;
#define d__k__sn_unicov_check_descrip75133 d__k__main__sn_unicov_check_d72343

/* k__main__sn_per_inst_unico72358 */ 
typedef struct s__k__main__sn_per_inst_un75131 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_per_inst_unico72311 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__sn_per_inst_unico72358;
#define d__k__main__sn_per_inst_unico72358 7497   

typedef k__main__sn_per_inst_unico72358 k__sn_per_inst_unicov_chec75132;
#define d__k__sn_per_inst_unicov_chec75132 d__k__main__sn_per_inst_unico72358

/* l__main__sn_set_cover_check_com */ 
typedef struct s__l__main__sn_set_cover_c75059 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_set_cover_check_com **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_set_cover_check_com;
#define d__l__main__sn_set_cover_check_com 7496   

typedef l__main__sn_set_cover_check_com l__sn_set_cover_check_com;
#define d__l__sn_set_cover_check_com d__l__main__sn_set_cover_check_com

/* l__main__sn_block_cover_de72510 */ 
typedef struct s__l__main__sn_block_cover75060 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_block_cover_de75135 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_block_cover_de72510;
#define d__l__main__sn_block_cover_de72510 7504   

typedef l__main__sn_block_cover_de72510 l__sn_block_cover_descriptor;
#define d__l__sn_block_cover_descriptor d__l__main__sn_block_cover_de72510

/* k__main__cov_per_instance_72512 */ 
typedef struct s__k__main__cov_per_instan75062 {
    t__int d__;
    t__int gen__;
    struct s__main__cov_per_instance_75144 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__cov_per_instance_72512;
#define d__k__main__cov_per_instance_72512 7511   

typedef k__main__cov_per_instance_72512 k__cov_per_instance_groups75145;
#define d__k__cov_per_instance_groups75145 d__k__main__cov_per_instance_72512

/* l__main__sn_unicov_check_d72511 */ 
typedef struct s__l__main__sn_unicov_chec75143 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_unicov_check_d75128 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_unicov_check_d72511;
#define d__l__main__sn_unicov_check_d72511 7508   

typedef l__main__sn_unicov_check_d72511 l__sn_unicov_check_descriptor;
#define d__l__sn_unicov_check_descriptor d__l__main__sn_unicov_check_d72511

/* k__main__cov_per_instance_72476 */ 
typedef struct s__k__main__cov_per_instan75140 {
    t__int d__;
    t__int gen__;
    struct s__main__cov_per_instance_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__cov_per_instance_72476;
#define d__k__main__cov_per_instance_72476 7509   

typedef k__main__cov_per_instance_72476 k__cov_per_instance_node__ptr;
#define d__k__cov_per_instance_node__ptr d__k__main__cov_per_instance_72476

/* l__main__sn_cvr_real_insta24430 */ 
typedef struct s__l__main__sn_cvr_real_in27184 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_real_insta24113 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_real_insta24430;
#define d__l__main__sn_cvr_real_insta24430 3654   

typedef l__main__sn_cvr_real_insta24430 l__sn_cvr_real_instance_de27183;
#define d__l__sn_cvr_real_instance_de27183 d__l__main__sn_cvr_real_insta24430

/* l__main__sn_per_inst_unico74848 */ 
typedef struct s__l__main__sn_per_inst_un75141 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_per_inst_unico72311 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_per_inst_unico74848;
#define d__l__main__sn_per_inst_unico74848 7510   

typedef l__main__sn_per_inst_unico74848 l__sn_per_inst_unicov_chec75142;
#define d__l__sn_per_inst_unicov_chec75142 d__l__main__sn_per_inst_unico74848

/* l__main__sn_cvr_excov_hold73954 */ 
typedef struct s__l__main__sn_cvr_excov_h75063 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cvr_excov_hold75174 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cvr_excov_hold73954;
#define d__l__main__sn_cvr_excov_hold73954 7572   

typedef l__main__sn_cvr_excov_hold73954 l__sn_cvr_excov_holder_wrapper;
#define d__l__sn_cvr_excov_holder_wrapper d__l__main__sn_cvr_excov_hold73954

/* l__main__sn_excov_group_holder */ 
typedef struct s__l__main__sn_excov_group75171 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_excov_group_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_excov_group_holder;
#define d__l__main__sn_excov_group_holder 7571   

typedef l__main__sn_excov_group_holder l__sn_excov_group_holder;
#define d__l__sn_excov_group_holder d__l__main__sn_excov_group_holder

/* l__main__sn_excov_inst_holder */ 
typedef struct s__l__main__sn_excov_inst_75172 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_excov_inst_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_excov_inst_holder;
#define d__l__main__sn_excov_inst_holder 7570   

typedef l__main__sn_excov_inst_holder l__sn_excov_inst_holder;
#define d__l__sn_excov_inst_holder d__l__main__sn_excov_inst_holder

/* l__main__sn_excov_item_holder */ 
typedef struct s__l__main__sn_excov_item_75173 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_excov_item_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_excov_item_holder;
#define d__l__main__sn_excov_item_holder 7569   

typedef l__main__sn_excov_item_holder l__sn_excov_item_holder;
#define d__l__sn_excov_item_holder d__l__main__sn_excov_item_holder

/* l__main__sn_excov_buckets_info */ 
typedef struct s__l__main__sn_excov_bucke73870 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_excov_buckets_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_excov_buckets_info;
#define d__l__main__sn_excov_buckets_info 7568   

typedef l__main__sn_excov_buckets_info l__sn_excov_buckets_info;
#define d__l__sn_excov_buckets_info d__l__main__sn_excov_buckets_info

/* k__sn__st_exp__it */ 
typedef struct s__k__sn__st_exp__it {
    t__int d__;
    t__int gen__;
    struct s__sn__st_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__st_exp__it;
#define d__k__sn__st_exp__it 7573   

typedef k__sn__st_exp__it k__st_exp__it;
#define d__k__st_exp__it d__k__sn__st_exp__it

/* k__main__unicov_handle_con74741 */ 
typedef struct s__k__main__unicov_handle_75064 {
    t__int d__;
    t__int gen__;
    struct s__main__unicov_handle_con75176 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__unicov_handle_con74741;
#define d__k__main__unicov_handle_con74741 7635   

typedef k__main__unicov_handle_con74741 k__unicov_handle_container75177;
#define d__k__unicov_handle_container75177 d__k__main__unicov_handle_con74741

/* l__main__sn_unicov_item_ptr */ 
typedef struct s__l__main__sn_unicov_item_ptr {
    t__int d__;
    t__int gen__;
    struct s__main__sn_unicov_item_ptr **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_unicov_item_ptr;
#define d__l__main__sn_unicov_item_ptr 7636   

typedef l__main__sn_unicov_item_ptr l__sn_unicov_item_ptr;
#define d__l__sn_unicov_item_ptr d__l__main__sn_unicov_item_ptr

/* k__main__unicov_handle_tre75179 */ 
typedef struct s__k__main__unicov_handle_75180 {
    t__int d__;
    t__int gen__;
    struct s__main__unicov_handle_tre74902 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__main__unicov_handle_tre75179;
#define d__k__main__unicov_handle_tre75179 7640   

typedef k__main__unicov_handle_tre75179 k__unicov_handle_tree_node75181;
#define d__k__unicov_handle_tree_node75181 d__k__main__unicov_handle_tre75179

/* l__sn__sn_cvr_double_space75065 */ 
typedef struct s__l__sn__sn_cvr_double_sp75066 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_cvr_double_space75168 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_cvr_double_space75065;
#define d__l__sn__sn_cvr_double_space75065 7641   

typedef l__sn__sn_cvr_double_space75065 l__sn_cvr_double_space_des75182;
#define d__l__sn_cvr_double_space_des75182 d__l__sn__sn_cvr_double_space75065

/* l__main__sn_cover_item_dis74972 */ 
typedef struct s__l__main__sn_cover_item_75067 {
    t__int d__;
    t__int gen__;
    struct s__main__sn_cover_item_dis75183 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__sn_cover_item_dis74972;
#define d__l__main__sn_cover_item_dis74972 7642   

typedef l__main__sn_cover_item_dis74972 l__sn_cover_item_dis_keyed_list;
#define d__l__sn_cover_item_dis_keyed_list d__l__main__sn_cover_item_dis74972

/* l__sn__abs_wave_command_manager */ 
typedef struct s__l__sn__abs_wave_command34141 {
    t__int d__;
    t__int gen__;
    struct s__sn__abs_wave_command_manager **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__abs_wave_command_manager;
#define d__l__sn__abs_wave_command_manager 4354   

typedef l__sn__abs_wave_command_manager l__abs_wave_command_manager;
#define d__l__abs_wave_command_manager d__l__sn__abs_wave_command_manager

/* k__sn__signal_naming_map__32421 */ 
typedef struct s__k__sn__signal_naming_ma34135 {
    t__int d__;
    t__int gen__;
    struct s__sn__signal_naming_map **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__signal_naming_map__32421;
#define d__k__sn__signal_naming_map__32421 4308   

typedef k__sn__signal_naming_map__32421 k__signal_naming_map__new_name;
#define d__k__signal_naming_map__new_name d__k__sn__signal_naming_map__32421

/* l__sn__sn_hidden_command */ 
typedef struct s__l__sn__sn_hidden_command {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_hidden_command **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_hidden_command;
#define d__l__sn__sn_hidden_command 4357   

typedef l__sn__sn_hidden_command l__sn_hidden_command;
#define d__l__sn_hidden_command d__l__sn__sn_hidden_command

/* k__sn__sn_wave_drill_down_34142 */ 
typedef struct s__k__sn__sn_wave_drill_do34143 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_wave_drill_down_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_wave_drill_down_34142;
#define d__k__sn__sn_wave_drill_down_34142 4358   

typedef k__sn__sn_wave_drill_down_34142 k__sn_wave_drill_down_info34145;
#define d__k__sn_wave_drill_down_info34145 d__k__sn__sn_wave_drill_down_34142

/* k__sn__sn_wave_signal_data34007 */ 
typedef struct s__k__sn__sn_wave_signal_d34136 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_wave_signal_data33946 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_wave_signal_data34007;
#define d__k__sn__sn_wave_signal_data34007 4395   

typedef k__sn__sn_wave_signal_data34007 k__sn_wave_signal_database34162;
#define d__k__sn_wave_signal_database34162 d__k__sn__sn_wave_signal_data34007

/* k__sn__sn_wave_signal_data34013 */ 
typedef struct s__k__sn__sn_wave_signal_d34137 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_wave_signal_data33996 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_wave_signal_data34013;
#define d__k__sn__sn_wave_signal_data34013 4396   

typedef k__sn__sn_wave_signal_data34013 k__sn_wave_signal_database34163;
#define d__k__sn_wave_signal_database34163 d__k__sn__sn_wave_signal_data34013

/* l__sn__check */ 
typedef struct s__l__sn__check {
    t__int d__;
    t__int gen__;
    struct s__sn__check **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__check;
#define d__l__sn__check 1340   

typedef l__sn__check l__check;
#define d__l__check d__l__sn__check

/* l__sn__int_interval_set */ 
typedef struct s__l__sn__int_interval_set {
    t__int d__;
    t__int gen__;
    struct s__sn__int_interval_set **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__int_interval_set;
#define d__l__sn__int_interval_set 1462   

typedef l__sn__int_interval_set l__int_interval_set;
#define d__l__int_interval_set d__l__sn__int_interval_set

/* l__sn__uint_interval_set */ 
typedef struct s__l__sn__uint_interval_set {
    t__int d__;
    t__int gen__;
    struct s__sn__uint_interval_set **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__uint_interval_set;
#define d__l__sn__uint_interval_set 1463   

typedef l__sn__uint_interval_set l__uint_interval_set;
#define d__l__uint_interval_set d__l__sn__uint_interval_set

/* l__sn__enum_interval_set */ 
typedef struct s__l__sn__enum_interval_set {
    t__int d__;
    t__int gen__;
    struct s__sn__enum_interval_set **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__enum_interval_set;
#define d__l__sn__enum_interval_set 1464   

typedef l__sn__enum_interval_set l__enum_interval_set;
#define d__l__enum_interval_set d__l__sn__enum_interval_set

/* l__sn__long_interval_set */ 
typedef struct s__l__sn__long_interval_set {
    t__int d__;
    t__int gen__;
    struct s__sn__long_interval_set **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__long_interval_set;
#define d__l__sn__long_interval_set 1465   

typedef l__sn__long_interval_set l__long_interval_set;
#define d__l__long_interval_set d__l__sn__long_interval_set

/* l__sn__sn_long */ 
typedef struct s__l__sn__sn_long {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_long **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_long;
#define d__l__sn__sn_long 483   

typedef l__sn__sn_long l__sn_long;
#define d__l__sn_long d__l__sn__sn_long

/* l__int__2147483647 */ 
typedef struct s__l__int__2147483647 {
    t__int d__;
    t__int gen__;
    struct s__int__2147483647 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__int__2147483647;
#define d__l__int__2147483647 1466   


/* l__sn__sn_recycler */ 
typedef struct s__l__sn__sn_recycler {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_recycler **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_recycler;
#define d__l__sn__sn_recycler 1478   

typedef l__sn__sn_recycler l__sn_recycler;
#define d__l__sn_recycler d__l__sn__sn_recycler

/* k__sn__fake_signal__name */ 
typedef struct s__k__sn__fake_signal__name {
    t__int d__;
    t__int gen__;
    struct s__sn__fake_signal **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__fake_signal__name;
#define d__k__sn__fake_signal__name 1502   

typedef k__sn__fake_signal__name k__fake_signal__name;
#define d__k__fake_signal__name d__k__sn__fake_signal__name

/* l__sn__debug_item */ 
typedef struct s__l__sn__debug_item {
    t__int d__;
    t__int gen__;
    struct s__sn__debug_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__debug_item;
#define d__l__sn__debug_item 1574   

typedef l__sn__debug_item l__debug_item;
#define d__l__debug_item d__l__sn__debug_item

/* l__sn__pack_string_item */ 
typedef struct s__l__sn__pack_string_item {
    t__int d__;
    t__int gen__;
    struct s__sn__pack_string_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__pack_string_item;
#define d__l__sn__pack_string_item 1572   

typedef l__sn__pack_string_item l__pack_string_item;
#define d__l__pack_string_item d__l__sn__pack_string_item

/* k__sn__sn_vttp_struct__id */ 
typedef struct s__k__sn__sn_vttp_struct__id {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_vttp_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_vttp_struct__id;
#define d__k__sn__sn_vttp_struct__id 1576   

typedef k__sn__sn_vttp_struct__id k__sn_vttp_struct__id;
#define d__k__sn_vttp_struct__id d__k__sn__sn_vttp_struct__id

/* k__sn__vttp_field_offset__f */ 
typedef struct s__k__sn__vttp_field_offset__f {
    t__int d__;
    t__int gen__;
    struct s__sn__vttp_field_offset **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__vttp_field_offset__f;
#define d__k__sn__vttp_field_offset__f 1575   

typedef k__sn__vttp_field_offset__f k__vttp_field_offset__f;
#define d__k__vttp_field_offset__f d__k__sn__vttp_field_offset__f

/* l__reflection__instance_pat8477 */ 
typedef struct s__l__reflection__instance_9908 {
    t__int d__;
    t__int gen__;
    struct s__reflection__instance_pat8138 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__instance_pat8477;
#define d__l__reflection__instance_pat8477 1801   

typedef l__reflection__instance_pat8477 l__instance_path_node;
#define d__l__instance_path_node d__l__reflection__instance_pat8477

/* k__reflection__rf_define__name */ 
typedef struct s__k__reflection__rf_define9909 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_define **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__reflection__rf_define__name;
#define d__k__reflection__rf_define__name 1803   

typedef k__reflection__rf_define__name k__rf_define__name;
#define d__k__rf_define__name d__k__reflection__rf_define__name

/* l__sn__st_node */ 
typedef struct s__l__sn__st_node {
    t__int d__;
    t__int gen__;
    struct s__sn__st_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_node;
#define d__l__sn__st_node 1848   

typedef l__sn__st_node l__st_node;
#define d__l__st_node d__l__sn__st_node

/* l__ea__eanalyzer_category_t */ 
typedef struct s__l__ea__eanalyzer_category_t {
    t__int d__;
    t__int gen__;
    t__ea__eanalyzer_category_t*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__ea__eanalyzer_category_t;
#define d__l__ea__eanalyzer_category_t 1917   

typedef l__ea__eanalyzer_category_t l__eanalyzer_category_t;
#define d__l__eanalyzer_category_t d__l__ea__eanalyzer_category_t

/* k__ea__eanalyzer_check__id */ 
typedef struct s__k__ea__eanalyzer_check__id {
    t__int d__;
    t__int gen__;
    struct s__ea__eanalyzer_check **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__ea__eanalyzer_check__id;
#define d__k__ea__eanalyzer_check__id 1918   

typedef k__ea__eanalyzer_check__id k__eanalyzer_check__id;
#define d__k__eanalyzer_check__id d__k__ea__eanalyzer_check__id

/* k__sn__ea_sn_ea_elint_msg__id */ 
typedef struct s__k__sn__ea_sn_ea_elint_m98723 {
    t__int d__;
    t__int gen__;
    struct s__sn__ea_sn_ea_elint_msg **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__ea_sn_ea_elint_msg__id;
#define d__k__sn__ea_sn_ea_elint_msg__id 8900   

typedef k__sn__ea_sn_ea_elint_msg__id k__ea_sn_ea_elint_msg__id;
#define d__k__ea_sn_ea_elint_msg__id d__k__sn__ea_sn_ea_elint_msg__id

/* k__reflection__rf_module__it */ 
typedef struct s__k__reflection__rf_module__it {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__reflection__rf_module__it;
#define d__k__reflection__rf_module__it 8901   

typedef k__reflection__rf_module__it k__rf_module__it;
#define d__k__rf_module__it d__k__reflection__rf_module__it

/* k__reflection__rf_struct__it */ 
typedef struct s__k__reflection__rf_struct__it {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__reflection__rf_struct__it;
#define d__k__reflection__rf_struct__it 7495   

typedef k__reflection__rf_struct__it k__rf_struct__it;
#define d__k__rf_struct__it d__k__reflection__rf_struct__it

/* k__sn__ea_rf_unit_inst__it */ 
typedef struct s__k__sn__ea_rf_unit_inst__it {
    t__int d__;
    t__int gen__;
    struct s__sn__ea_rf_unit_inst **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__ea_rf_unit_inst__it;
#define d__k__sn__ea_rf_unit_inst__it 8920   

typedef k__sn__ea_rf_unit_inst__it k__ea_rf_unit_inst__it;
#define d__k__ea_rf_unit_inst__it d__k__sn__ea_rf_unit_inst__it

/* k__sn__rf_sequence__it */ 
typedef struct s__k__sn__rf_sequence__it {
    t__int d__;
    t__int gen__;
    struct s__sn__rf_sequence **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__rf_sequence__it;
#define d__k__sn__rf_sequence__it 8924   

typedef k__sn__rf_sequence__it k__rf_sequence__it;
#define d__k__rf_sequence__it d__k__sn__rf_sequence__it

/* l__sn__rf_virtual_sequence */ 
typedef struct s__l__sn__rf_virtual_sequence {
    t__int d__;
    t__int gen__;
    struct s__sn__rf_virtual_sequence **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__rf_virtual_sequence;
#define d__l__sn__rf_virtual_sequence 8925   

typedef l__sn__rf_virtual_sequence l__rf_virtual_sequence;
#define d__l__rf_virtual_sequence d__l__sn__rf_virtual_sequence

/* l__sn__rf_bfm_sequence */ 
typedef struct s__l__sn__rf_bfm_sequence {
    t__int d__;
    t__int gen__;
    struct s__sn__rf_bfm_sequence **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__rf_bfm_sequence;
#define d__l__sn__rf_bfm_sequence 8923   

typedef l__sn__rf_bfm_sequence l__rf_bfm_sequence;
#define d__l__rf_bfm_sequence d__l__sn__rf_bfm_sequence

/* k__reflection__rf_check__it */ 
typedef struct s__k__reflection__rf_check__it {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_check **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__reflection__rf_check__it;
#define d__k__reflection__rf_check__it 8930   

typedef k__reflection__rf_check__it k__rf_check__it;
#define d__k__rf_check__it d__k__reflection__rf_check__it

/* k__reflection__rf_check_ac98194 */ 
typedef struct s__k__reflection__rf_check98724 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_check_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__reflection__rf_check_ac98194;
#define d__k__reflection__rf_check_ac98194 8931   

typedef k__reflection__rf_check_ac98194 k__rf_check_action__it;
#define d__k__rf_check_action__it d__k__reflection__rf_check_ac98194

/* k__reflection__rf_expect__it */ 
typedef struct s__k__reflection__rf_expect__it {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_expect **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__reflection__rf_expect__it;
#define d__k__reflection__rf_expect__it 8932   

typedef k__reflection__rf_expect__it k__rf_expect__it;
#define d__k__rf_expect__it d__k__reflection__rf_expect__it

/* k__sn__option__option_desc */ 
typedef struct s__k__sn__option__option_desc {
    t__int d__;
    t__int gen__;
    struct s__sn__option **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__option__option_desc;
#define d__k__sn__option__option_desc 1496   

typedef k__sn__option__option_desc k__option__option_desc;
#define d__k__option__option_desc d__k__sn__option__option_desc

/* l__ea__eanalyzer_notification */ 
typedef struct s__l__ea__eanalyzer_notifi98720 {
    t__int d__;
    t__int gen__;
    struct s__ea__eanalyzer_notification **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__ea__eanalyzer_notification;
#define d__l__ea__eanalyzer_notification 8886   

typedef l__ea__eanalyzer_notification l__eanalyzer_notification;
#define d__l__eanalyzer_notification d__l__ea__eanalyzer_notification

/* l__ea__eanalyzer_filtered_lines */ 
typedef struct s__l__ea__eanalyzer_filter98721 {
    t__int d__;
    t__int gen__;
    struct s__ea__eanalyzer_filtered_lines **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__ea__eanalyzer_filtered_lines;
#define d__l__ea__eanalyzer_filtered_lines 8887   

typedef l__ea__eanalyzer_filtered_lines l__eanalyzer_filtered_lines;
#define d__l__eanalyzer_filtered_lines d__l__ea__eanalyzer_filtered_lines

/* k__uint__it */ 
typedef struct s__k__uint__it {
    t__int d__;
    t__int gen__;
    t__uint*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__uint__it;
#define d__k__uint__it 8888   


/* l__ea__ea_local */ 
typedef struct s__l__ea__ea_local {
    t__int d__;
    t__int gen__;
    struct s__ea__ea_local **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__ea__ea_local;
#define d__l__ea__ea_local 8891   

typedef l__ea__ea_local l__ea_local;
#define d__l__ea_local d__l__ea__ea_local

/* l__ea__ea_config_option */ 
typedef struct s__l__ea__ea_config_option {
    t__int d__;
    t__int gen__;
    struct s__ea__ea_config_option **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__ea__ea_config_option;
#define d__l__ea__ea_config_option 8892   

typedef l__ea__ea_config_option l__ea_config_option;
#define d__l__ea_config_option d__l__ea__ea_config_option

/* k__sn__ea_rf_elint_define_97592 */ 
typedef struct s__k__sn__ea_rf_elint_defi97593 {
    t__int d__;
    t__int gen__;
    struct s__sn__ea_rf_elint_define **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__ea_rf_elint_define_97592;
#define d__k__sn__ea_rf_elint_define_97592 8897   

typedef k__sn__ea_rf_elint_define_97592 k__ea_rf_elint_define__def98726;
#define d__k__ea_rf_elint_define__def98726 d__k__sn__ea_rf_elint_define_97592

/* l__sn__ea_rf_unit_inst */ 
typedef struct s__l__sn__ea_rf_unit_inst {
    t__int d__;
    t__int gen__;
    struct s__sn__ea_rf_unit_inst **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__ea_rf_unit_inst;
#define d__l__sn__ea_rf_unit_inst 8898   

typedef l__sn__ea_rf_unit_inst l__ea_rf_unit_inst;
#define d__l__ea_rf_unit_inst d__l__sn__ea_rf_unit_inst

/* k__sn__ea_sn_ea_erm_check__tag */ 
typedef struct s__k__sn__ea_sn_ea_erm_che98727 {
    t__int d__;
    t__int gen__;
    struct s__sn__ea_sn_ea_erm_check **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__ea_sn_ea_erm_check__tag;
#define d__k__sn__ea_sn_ea_erm_check__tag 8913   

typedef k__sn__ea_sn_ea_erm_check__tag k__ea_sn_ea_erm_check__tag;
#define d__k__ea_sn_ea_erm_check__tag d__k__sn__ea_sn_ea_erm_check__tag

/* l__sn__untyped_list_to_sca11891 */ 
typedef struct s__l__sn__untyped_list_to_11892 {
    t__int d__;
    t__int gen__;
    struct s__sn__untyped_list_to_sca11909 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__untyped_list_to_sca11891;
#define d__l__sn__untyped_list_to_sca11891 1966   

typedef l__sn__untyped_list_to_sca11891 l__untyped_list_to_scalar_11910;
#define d__l__untyped_list_to_scalar_11910 d__l__sn__untyped_list_to_sca11891

/* l__sn__gen_path */ 
typedef struct s__l__sn__gen_path {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_path;
#define d__l__sn__gen_path 6448   

typedef l__sn__gen_path l__gen_path;
#define d__l__gen_path d__l__sn__gen_path

/* l__sn__gen_path_element */ 
typedef struct s__l__sn__gen_path_element {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_path_element;
#define d__l__sn__gen_path_element 6449   

typedef l__sn__gen_path_element l__gen_path_element;
#define d__l__gen_path_element d__l__sn__gen_path_element

/* l__sn__st_local_exp */ 
typedef struct s__l__sn__st_local_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__st_local_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_local_exp;
#define d__l__sn__st_local_exp 6627   

typedef l__sn__st_local_exp l__st_local_exp;
#define d__l__st_local_exp d__l__sn__st_local_exp

/* l__gen__gen_sa_list_index_54960 */ 
typedef struct s__l__gen__gen_sa_list_ind54961 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_list_index_56851 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_list_index_54960;
#define d__l__gen__gen_sa_list_index_54960 6595   

typedef l__gen__gen_sa_list_index_54960 l__gen_sa_list_index_condition;
#define d__l__gen_sa_list_index_condition d__l__gen__gen_sa_list_index_54960

/* l__gen__gen_determinant */ 
typedef struct s__l__gen__gen_determinant {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_determinant **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_determinant;
#define d__l__gen__gen_determinant 6564   

typedef l__gen__gen_determinant l__gen_determinant;
#define d__l__gen_determinant d__l__gen__gen_determinant

/* l__sn__gen_rt_record */ 
typedef struct s__l__sn__gen_rt_record {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_rt_record **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_rt_record;
#define d__l__sn__gen_rt_record 8412   

typedef l__sn__gen_rt_record l__gen_rt_record;
#define d__l__gen_rt_record d__l__sn__gen_rt_record

/* l__sn__n__constraint */ 
typedef struct s__l__sn__n__constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__n__constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__n__constraint;
#define d__l__sn__n__constraint 1842   

typedef l__sn__n__constraint l__n__constraint;
#define d__l__n__constraint d__l__sn__n__constraint

/* l__sn__scope */ 
typedef struct s__l__sn__scope {
    t__int d__;
    t__int gen__;
    struct s__sn__scope **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__scope;
#define d__l__sn__scope 502   

typedef l__sn__scope l__scope;
#define d__l__scope d__l__sn__scope

/* l__sn__gen_user_constraint */ 
typedef struct s__l__sn__gen_user_constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_user_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_user_constraint;
#define d__l__sn__gen_user_constraint 6620   

typedef l__sn__gen_user_constraint l__gen_user_constraint;
#define d__l__gen_user_constraint d__l__sn__gen_user_constraint

/* l__gen__gen_sa_atomic_condition */ 
typedef struct s__l__gen__gen_sa_atomic_c54962 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_atomic_condition **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_atomic_condition;
#define d__l__gen__gen_sa_atomic_condition 6593   

typedef l__gen__gen_sa_atomic_condition l__gen_sa_atomic_condition;
#define d__l__gen_sa_atomic_condition d__l__gen__gen_sa_atomic_condition

/* l__gen__gen_implicit_constraint */ 
typedef struct s__l__gen__gen_implicit_co54963 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_implicit_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_implicit_constraint;
#define d__l__gen__gen_implicit_constraint 6596   

typedef l__gen__gen_implicit_constraint l__gen_implicit_constraint;
#define d__l__gen_implicit_constraint d__l__gen__gen_implicit_constraint

/* l__sn__gen_constraint_input_exp */ 
typedef struct s__l__sn__gen_constraint_i55052 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_constraint_input_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_constraint_input_exp;
#define d__l__sn__gen_constraint_input_exp 6617   

typedef l__sn__gen_constraint_input_exp l__gen_constraint_input_exp;
#define d__l__gen_constraint_input_exp d__l__sn__gen_constraint_input_exp

/* k__gen__gen_sa_direct_cc_h82680 */ 
typedef struct s__k__gen__gen_sa_direct_c82681 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_direct_cc_h82650 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_direct_cc_h82680;
#define d__k__gen__gen_sa_direct_cc_h82680 8167   

typedef k__gen__gen_sa_direct_cc_h82680 k__gen_sa_direct_cc_header96914;
#define d__k__gen_sa_direct_cc_header96914 d__k__gen__gen_sa_direct_cc_h82680

/* l__sn__gen_sa_constraint_i82580 */ 
typedef struct s__l__sn__gen_sa_constrain82582 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_constraint_i54950 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_constraint_i82580;
#define d__l__sn__gen_sa_constraint_i82580 8138   

typedef l__sn__gen_sa_constraint_i82580 l__gen_sa_constraint_instance;
#define d__l__gen_sa_constraint_instance d__l__sn__gen_sa_constraint_i82580

/* k__sn__gen_sa_direct_cc_he82647 */ 
typedef struct s__k__sn__gen_sa_direct_cc82648 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_direct_cc_header **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_sa_direct_cc_he82647;
#define d__k__sn__gen_sa_direct_cc_he82647 8163   

typedef k__sn__gen_sa_direct_cc_he82647 k__gen_sa_direct_cc_header__it;
#define d__k__gen_sa_direct_cc_header__it d__k__sn__gen_sa_direct_cc_he82647

/* k__gen__gen_sa_direct_cc_h82685 */ 
typedef struct s__k__gen__gen_sa_direct_c96910 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_direct_cc_h82650 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_direct_cc_h82685;
#define d__k__gen__gen_sa_direct_cc_h82685 8166   

typedef k__gen__gen_sa_direct_cc_h82685 k__gen_sa_direct_cc_header96912;
#define d__k__gen_sa_direct_cc_header96912 d__k__gen__gen_sa_direct_cc_h82685

/* k__gen__gen_sa_direct_cc_h82626 */ 
typedef struct s__k__gen__gen_sa_direct_c96913 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_direct_cc_h82625 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_direct_cc_h82626;
#define d__k__gen__gen_sa_direct_cc_h82626 8165   

typedef k__gen__gen_sa_direct_cc_h82626 k__gen_sa_direct_cc_header96915;
#define d__k__gen_sa_direct_cc_header96915 d__k__gen__gen_sa_direct_cc_h82626

/* k__sn__gen_sa_reuse_node__84880 */ 
typedef struct s__k__sn__gen_sa_reuse_nod84881 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_reuse_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_sa_reuse_node__84880;
#define d__k__sn__gen_sa_reuse_node__84880 8211   

typedef k__sn__gen_sa_reuse_node__84880 k__gen_sa_reuse_node__label_key;
#define d__k__gen_sa_reuse_node__label_key d__k__sn__gen_sa_reuse_node__84880

/* l__gen__gen_sa_pas_record */ 
typedef struct s__l__gen__gen_sa_pas_record {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_pas_record **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_pas_record;
#define d__l__gen__gen_sa_pas_record 8286   

typedef l__gen__gen_sa_pas_record l__gen_sa_pas_record;
#define d__l__gen_sa_pas_record d__l__gen__gen_sa_pas_record

/* k__gen__gen_sa_alloced_nod85889 */ 
typedef struct s__k__gen__gen_sa_alloced_96895 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_alloced_nod96934 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_alloced_nod85889;
#define d__k__gen__gen_sa_alloced_nod85889 8213   

typedef k__gen__gen_sa_alloced_nod85889 k__gen_sa_alloced_node_rec96935;
#define d__k__gen_sa_alloced_node_rec96935 d__k__gen__gen_sa_alloced_nod85889

/* k__gen__gen_sa_solving_nod96924 */ 
typedef struct s__k__gen__gen_sa_solving_96925 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_solving_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_solving_nod96924;
#define d__k__gen__gen_sa_solving_nod96924 8179   

typedef k__gen__gen_sa_solving_nod96924 k__gen_sa_solving_node__graph;
#define d__k__gen_sa_solving_node__graph d__k__gen__gen_sa_solving_nod96924

/* l__sn__gen_sa_solving_status */ 
typedef struct s__l__sn__gen_sa_solving_status {
    t__int d__;
    t__int gen__;
    t__sn__gen_sa_solving_status*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_solving_status;
#define d__l__sn__gen_sa_solving_status 8139   

typedef l__sn__gen_sa_solving_status l__gen_sa_solving_status;
#define d__l__gen_sa_solving_status d__l__sn__gen_sa_solving_status

/* l__sn__gen_sa_hierarchy_node */ 
typedef struct s__l__sn__gen_sa_hierarchy_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_hierarchy_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_hierarchy_node;
#define d__l__sn__gen_sa_hierarchy_node 8110   

typedef l__sn__gen_sa_hierarchy_node l__gen_sa_hierarchy_node;
#define d__l__gen_sa_hierarchy_node d__l__sn__gen_sa_hierarchy_node

/* l__sn__gen_sa_input_node */ 
typedef struct s__l__sn__gen_sa_input_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_input_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_input_node;
#define d__l__sn__gen_sa_input_node 8135   

typedef l__sn__gen_sa_input_node l__gen_sa_input_node;
#define d__l__gen_sa_input_node d__l__sn__gen_sa_input_node

/* k__sn__gen_sa_folded_domai85003 */ 
typedef struct s__k__sn__gen_sa_folded_do85004 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_folded_domai56834 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_sa_folded_domai85003;
#define d__k__sn__gen_sa_folded_domai85003 8215   

typedef k__sn__gen_sa_folded_domai85003 k__gen_sa_folded_domain_it96937;
#define d__k__gen_sa_folded_domain_it96937 d__k__sn__gen_sa_folded_domai85003

/* l__gen__gen_sa_graph_and_stats */ 
typedef struct s__l__gen__gen_sa_graph_an96940 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_graph_and_stats **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_graph_and_stats;
#define d__l__gen__gen_sa_graph_and_stats 8219   

typedef l__gen__gen_sa_graph_and_stats l__gen_sa_graph_and_stats;
#define d__l__gen_sa_graph_and_stats d__l__gen__gen_sa_graph_and_stats

/* l__sn__orderable_object */ 
typedef struct s__l__sn__orderable_object {
    t__int d__;
    t__int gen__;
    struct s__sn__orderable_object **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__orderable_object;
#define d__l__sn__orderable_object 8275   

typedef l__sn__orderable_object l__orderable_object;
#define d__l__orderable_object d__l__sn__orderable_object

/* l__sn__object_layer */ 
typedef struct s__l__sn__object_layer {
    t__int d__;
    t__int gen__;
    struct s__sn__object_layer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__object_layer;
#define d__l__sn__object_layer 8276   

typedef l__sn__object_layer l__object_layer;
#define d__l__object_layer d__l__sn__object_layer

/* l__gen__slm_tree_map */ 
typedef struct s__l__gen__slm_tree_map {
    t__int d__;
    t__int gen__;
    struct s__gen__slm_tree_map **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__slm_tree_map;
#define d__l__gen__slm_tree_map 8607   

typedef l__gen__slm_tree_map l__slm_tree_map;
#define d__l__slm_tree_map d__l__gen__slm_tree_map

/* l__sn__int_list_holder */ 
typedef struct s__l__sn__int_list_holder {
    t__int d__;
    t__int gen__;
    struct s__sn__int_list_holder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__int_list_holder;
#define d__l__sn__int_list_holder 8608   

typedef l__sn__int_list_holder l__int_list_holder;
#define d__l__int_list_holder d__l__sn__int_list_holder

/* l__gen__selects_chain_container */ 
typedef struct s__l__gen__selects_chain_c96986 {
    t__int d__;
    t__int gen__;
    struct s__gen__selects_chain_container **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__selects_chain_container;
#define d__l__gen__selects_chain_container 8610   

typedef l__gen__selects_chain_container l__selects_chain_container;
#define d__l__selects_chain_container d__l__gen__selects_chain_container

/* l__sn__gen_sa_cc_header */ 
typedef struct s__l__sn__gen_sa_cc_header {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_cc_header **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_cc_header;
#define d__l__sn__gen_sa_cc_header 8073   

typedef l__sn__gen_sa_cc_header l__gen_sa_cc_header;
#define d__l__gen_sa_cc_header d__l__sn__gen_sa_cc_header

/* l__gen__gen_sa_condition */ 
typedef struct s__l__gen__gen_sa_condition {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_condition **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_condition;
#define d__l__gen__gen_sa_condition 8031   

typedef l__gen__gen_sa_condition l__gen_sa_condition;
#define d__l__gen_sa_condition d__l__gen__gen_sa_condition

/* l__gen__gen_sa_exported_de85484 */ 
typedef struct s__l__gen__gen_sa_exported85485 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_exported_de96944 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_exported_de85484;
#define d__l__gen__gen_sa_exported_de85484 8229   

typedef l__gen__gen_sa_exported_de85484 l__gen_sa_exported_dependency;
#define d__l__gen_sa_exported_dependency d__l__gen__gen_sa_exported_de85484

/* l__sn__gen_sa_pgen3_node */ 
typedef struct s__l__sn__gen_sa_pgen3_node {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_pgen3_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_pgen3_node;
#define d__l__sn__gen_sa_pgen3_node 8120   

typedef l__sn__gen_sa_pgen3_node l__gen_sa_pgen3_node;
#define d__l__gen_sa_pgen3_node d__l__sn__gen_sa_pgen3_node

/* l__gen__gen_sa_pointer_equ83390 */ 
typedef struct s__l__gen__gen_sa_pointer_83391 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_pointer_equ56859 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_pointer_equ83390;
#define d__l__gen__gen_sa_pointer_equ83390 8189   

typedef l__gen__gen_sa_pointer_equ83390 l__gen_sa_pointer_equality96927;
#define d__l__gen_sa_pointer_equality96927 d__l__gen__gen_sa_pointer_equ83390

/* l__sn__gen_sa_ccs */ 
typedef struct s__l__sn__gen_sa_ccs {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_ccs **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_ccs;
#define d__l__sn__gen_sa_ccs 8153   

typedef l__sn__gen_sa_ccs l__gen_sa_ccs;
#define d__l__gen_sa_ccs d__l__sn__gen_sa_ccs

/* k__gen__root_to_indices_ma96849 */ 
typedef struct s__k__gen__root_to_indices96850 {
    t__int d__;
    t__int gen__;
    struct s__gen__root_to_indices_mapper **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__root_to_indices_ma96849;
#define d__k__gen__root_to_indices_ma96849 8185   

typedef k__gen__root_to_indices_ma96849 k__root_to_indices_mapper__root;
#define d__k__root_to_indices_mapper__root d__k__gen__root_to_indices_ma96849

/* l__gen__gen_sa_ci_sample_r83787 */ 
typedef struct s__l__gen__gen_sa_ci_sampl96830 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_ci_sample_r96929 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_ci_sample_r83787;
#define d__l__gen__gen_sa_ci_sample_r83787 8192   

typedef l__gen__gen_sa_ci_sample_r83787 l__gen_sa_ci_sample_results;
#define d__l__gen_sa_ci_sample_results d__l__gen__gen_sa_ci_sample_r83787

/* l__sn__gen_slm_abstract_in86074 */ 
typedef struct s__l__sn__gen_slm_abstract96851 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_abstract_in56844 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_slm_abstract_in86074;
#define d__l__sn__gen_slm_abstract_in86074 8294   

typedef l__sn__gen_slm_abstract_in86074 l__gen_slm_abstract_index_96965;
#define d__l__gen_slm_abstract_index_96965 d__l__sn__gen_slm_abstract_in86074

/* l__sn__gen_slm_rl_iterator */ 
typedef struct s__l__sn__gen_slm_rl_iterator {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_rl_iterator **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_slm_rl_iterator;
#define d__l__sn__gen_slm_rl_iterator 8168   

typedef l__sn__gen_slm_rl_iterator l__gen_slm_rl_iterator;
#define d__l__gen_slm_rl_iterator d__l__sn__gen_slm_rl_iterator

/* l__sn__gen_slm_size_tree_node */ 
typedef struct s__l__sn__gen_slm_size_tre96958 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_size_tree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_slm_size_tree_node;
#define d__l__sn__gen_slm_size_tree_node 8326   

typedef l__sn__gen_slm_size_tree_node l__gen_slm_size_tree_node;
#define d__l__gen_slm_size_tree_node d__l__sn__gen_slm_size_tree_node

/* l__gen__pgen_context_edge */ 
typedef struct s__l__gen__pgen_context_edge {
    t__int d__;
    t__int gen__;
    struct s__gen__pgen_context_edge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__pgen_context_edge;
#define d__l__gen__pgen_context_edge 6565   

typedef l__gen__pgen_context_edge l__pgen_context_edge;
#define d__l__pgen_context_edge d__l__gen__pgen_context_edge

/* k__gen__gen_mm_parsing_rf_56802 */ 
typedef struct s__k__gen__gen_mm_parsing_56803 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_mm_parsing_rf_56897 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_mm_parsing_rf_56802;
#define d__k__gen__gen_mm_parsing_rf_56802 6648   

typedef k__gen__gen_mm_parsing_rf_56802 k__gen_mm_parsing_rf_struc56900;
#define d__k__gen_mm_parsing_rf_struc56900 d__k__gen__gen_mm_parsing_rf_56802

/* l__sn__gen_context */ 
typedef struct s__l__sn__gen_context {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_context **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_context;
#define d__l__sn__gen_context 6621   

typedef l__sn__gen_context l__gen_context;
#define d__l__gen_context d__l__sn__gen_context

/* k__sn__gen_user_constraint__it */ 
typedef struct s__k__sn__gen_user_constra96794 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_user_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_user_constraint__it;
#define d__k__sn__gen_user_constraint__it 8190   

typedef k__sn__gen_user_constraint__it k__gen_user_constraint__it;
#define d__k__gen_user_constraint__it d__k__sn__gen_user_constraint__it

/* k__sn__gen_path_field_elem56876 */ 
typedef struct s__k__sn__gen_path_field_e56878 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path_field_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_path_field_elem56876;
#define d__k__sn__gen_path_field_elem56876 6623   

typedef k__sn__gen_path_field_elem56876 k__gen_path_field_element_56877;
#define d__k__gen_path_field_element_56877 d__k__sn__gen_path_field_elem56876

/* k__sn__gen_path_attr_eleme56879 */ 
typedef struct s__k__sn__gen_path_attr_el56881 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path_attr_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_path_attr_eleme56879;
#define d__k__sn__gen_path_attr_eleme56879 6624   

typedef k__sn__gen_path_attr_eleme56879 k__gen_path_attr_element__56880;
#define d__k__gen_path_attr_element__56880 d__k__sn__gen_path_attr_eleme56879

/* l__sn__gen_path_temp_list_56882 */ 
typedef struct s__l__sn__gen_path_temp_li56884 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path_temp_list_55027 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_path_temp_list_56882;
#define d__l__sn__gen_path_temp_list_56882 6625   

typedef l__sn__gen_path_temp_list_56882 l__gen_path_temp_list_inde56883;
#define d__l__gen_path_temp_list_inde56883 d__l__sn__gen_path_temp_list_56882

/* k__external_pointer__it */ 
typedef struct s__k__external_pointer__it {
    t__int d__;
    t__int gen__;
    t__external_pointer*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__external_pointer__it;
#define d__k__external_pointer__it 127   


/* l__sn__gen_cc_seed_domain */ 
typedef struct s__l__sn__gen_cc_seed_domain {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_cc_seed_domain **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_cc_seed_domain;
#define d__l__sn__gen_cc_seed_domain 8081   

typedef l__sn__gen_cc_seed_domain l__gen_cc_seed_domain;
#define d__l__gen_cc_seed_domain d__l__sn__gen_cc_seed_domain

/* l__gen_dbg__gen_dbg_variable */ 
typedef struct s__l__gen_dbg__gen_dbg_variable {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_variable **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_variable;
#define d__l__gen_dbg__gen_dbg_variable 8082   

typedef l__gen_dbg__gen_dbg_variable l__gen_dbg_variable;
#define d__l__gen_dbg_variable d__l__gen_dbg__gen_dbg_variable

/* l__gen_dbg__gen_dbg_cc */ 
typedef struct s__l__gen_dbg__gen_dbg_cc {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_cc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_cc;
#define d__l__gen_dbg__gen_dbg_cc 8718   

typedef l__gen_dbg__gen_dbg_cc l__gen_dbg_cc;
#define d__l__gen_dbg_cc d__l__gen_dbg__gen_dbg_cc

/* k__gen_dbg__gen_dbg_stree_94201 */ 
typedef struct s__k__gen_dbg__gen_dbg_str94202 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_stree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen_dbg__gen_dbg_stree_94201;
#define d__k__gen_dbg__gen_dbg_stree_94201 8727   

typedef k__gen_dbg__gen_dbg_stree_94201 k__gen_dbg_stree_node__el;
#define d__k__gen_dbg_stree_node__el d__k__gen_dbg__gen_dbg_stree_94201

/* k__sn__gen_path_temp_list_96828 */ 
typedef struct s__k__sn__gen_path_temp_li96829 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_path_temp_list_55027 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_path_temp_list_96828;
#define d__k__sn__gen_path_temp_list_96828 8728   

typedef k__sn__gen_path_temp_list_96828 k__gen_path_temp_list_inde97218;
#define d__k__gen_path_temp_list_inde97218 d__k__sn__gen_path_temp_list_96828

/* l__gen_dbg__gen_dbg_determinant */ 
typedef struct s__l__gen_dbg__gen_dbg_det96826 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_determinant **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_determinant;
#define d__l__gen_dbg__gen_dbg_determinant 8729   

typedef l__gen_dbg__gen_dbg_determinant l__gen_dbg_determinant;
#define d__l__gen_dbg_determinant d__l__gen_dbg__gen_dbg_determinant

/* l__gen_dbg__gen_dbg_constraint */ 
typedef struct s__l__gen_dbg__gen_dbg_con93696 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_constraint;
#define d__l__gen_dbg__gen_dbg_constraint 8083   

typedef l__gen_dbg__gen_dbg_constraint l__gen_dbg_constraint;
#define d__l__gen_dbg_constraint d__l__gen_dbg__gen_dbg_constraint

/* l__gen_dbg__gen_dbg_cycle */ 
typedef struct s__l__gen_dbg__gen_dbg_cycle {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_cycle **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_cycle;
#define d__l__gen_dbg__gen_dbg_cycle 8723   

typedef l__gen_dbg__gen_dbg_cycle l__gen_dbg_cycle;
#define d__l__gen_dbg_cycle d__l__gen_dbg__gen_dbg_cycle

/* l__gen_dbg__gen_dbg_edge */ 
typedef struct s__l__gen_dbg__gen_dbg_edge {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_edge **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_edge;
#define d__l__gen_dbg__gen_dbg_edge 8722   

typedef l__gen_dbg__gen_dbg_edge l__gen_dbg_edge;
#define d__l__gen_dbg_edge d__l__gen_dbg__gen_dbg_edge

/* l__sn__gen_edge_t */ 
typedef struct s__l__sn__gen_edge_t {
    t__int d__;
    t__int gen__;
    t__sn__gen_edge_t*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_edge_t;
#define d__l__sn__gen_edge_t 8169   

typedef l__sn__gen_edge_t l__gen_edge_t;
#define d__l__gen_edge_t d__l__sn__gen_edge_t

/* l__gen_dbg__gen_dbg_simple93779 */ 
typedef struct s__l__gen_dbg__gen_dbg_sim93780 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_simple93530 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_simple93779;
#define d__l__gen_dbg__gen_dbg_simple93779 8724   

typedef l__gen_dbg__gen_dbg_simple93779 l__gen_dbg_simple_variable;
#define d__l__gen_dbg_simple_variable d__l__gen_dbg__gen_dbg_simple93779

/* l__gen_dbg__gen_dbg_context */ 
typedef struct s__l__gen_dbg__gen_dbg_context {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_context **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_context;
#define d__l__gen_dbg__gen_dbg_context 8717   

typedef l__gen_dbg__gen_dbg_context l__gen_dbg_context;
#define d__l__gen_dbg_context d__l__gen_dbg__gen_dbg_context

/* k__gen_dbg__gen_dbg_reusab96798 */ 
typedef struct s__k__gen_dbg__gen_dbg_reu96799 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_reusable_cc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen_dbg__gen_dbg_reusab96798;
#define d__k__gen_dbg__gen_dbg_reusab96798 8725   

typedef k__gen_dbg__gen_dbg_reusab96798 k__gen_dbg_reusable_cc__solver;
#define d__k__gen_dbg_reusable_cc__solver d__k__gen_dbg__gen_dbg_reusab96798

/* l__gen_dbg__gen_dbg_reduct93949 */ 
typedef struct s__l__gen_dbg__gen_dbg_red96827 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_reduct93259 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_reduct93949;
#define d__l__gen_dbg__gen_dbg_reduct93949 8721   

typedef l__gen_dbg__gen_dbg_reduct93949 l__gen_dbg_reduction_event;
#define d__l__gen_dbg_reduction_event d__l__gen_dbg__gen_dbg_reduct93949

/* k__gen_dbg__gen_dbg_reusab93910 */ 
typedef struct s__k__gen_dbg__gen_dbg_reu96800 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_reusable_cc **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen_dbg__gen_dbg_reusab93910;
#define d__k__gen_dbg__gen_dbg_reusab93910 8726   

typedef k__gen_dbg__gen_dbg_reusab93910 k__gen_dbg_reusable_cc__cc;
#define d__k__gen_dbg_reusable_cc__cc d__k__gen_dbg__gen_dbg_reusab93910

/* l__vt__vtx_tree_node */ 
typedef struct s__l__vt__vtx_tree_node {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_tree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_tree_node;
#define d__l__vt__vtx_tree_node 5190   

typedef l__vt__vtx_tree_node l__vtx_tree_node;
#define d__l__vtx_tree_node d__l__vt__vtx_tree_node

/* l__vt__vtx_bar_data */ 
typedef struct s__l__vt__vtx_bar_data {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_bar_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_bar_data;
#define d__l__vt__vtx_bar_data 5191   

typedef l__vt__vtx_bar_data l__vtx_bar_data;
#define d__l__vtx_bar_data d__l__vt__vtx_bar_data

/* l__vt__vtx_pie_slice */ 
typedef struct s__l__vt__vtx_pie_slice {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_pie_slice **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_pie_slice;
#define d__l__vt__vtx_pie_slice 5250   

typedef l__vt__vtx_pie_slice l__vtx_pie_slice;
#define d__l__vtx_pie_slice d__l__vt__vtx_pie_slice

/* l__vt__vtx_snorb_tree_node */ 
typedef struct s__l__vt__vtx_snorb_tree_node {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_snorb_tree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_snorb_tree_node;
#define d__l__vt__vtx_snorb_tree_node 5248   

typedef l__vt__vtx_snorb_tree_node l__vtx_snorb_tree_node;
#define d__l__vtx_snorb_tree_node d__l__vt__vtx_snorb_tree_node

/* l__vt__vtx_base_button */ 
typedef struct s__l__vt__vtx_base_button {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_base_button **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_base_button;
#define d__l__vt__vtx_base_button 5188   

typedef l__vt__vtx_base_button l__vtx_base_button;
#define d__l__vtx_base_button d__l__vt__vtx_base_button

/* l__vt__vtx_table_row */ 
typedef struct s__l__vt__vtx_table_row {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_table_row **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_table_row;
#define d__l__vt__vtx_table_row 5194   

typedef l__vt__vtx_table_row l__vtx_table_row;
#define d__l__vtx_table_row d__l__vt__vtx_table_row

/* k__vt__vtx_tab__m_id */ 
typedef struct s__k__vt__vtx_tab__m_id {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_tab **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vtx_tab__m_id;
#define d__k__vt__vtx_tab__m_id 5184   

typedef k__vt__vtx_tab__m_id k__vtx_tab__m_id;
#define d__k__vtx_tab__m_id d__k__vt__vtx_tab__m_id

/* l__gen_dbg_gui__gen_dbg_de95257 */ 
typedef struct s__l__gen_dbg_gui__gen_dbg97261 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg_gui__gen_dbg_de97262 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg_gui__gen_dbg_de95257;
#define d__l__gen_dbg_gui__gen_dbg_de95257 8795   

typedef l__gen_dbg_gui__gen_dbg_de95257 l__gen_dbg_details_tab;
#define d__l__gen_dbg_details_tab d__l__gen_dbg_gui__gen_dbg_de95257

/* l__gen_dbg_gui__gen_dbg_de97229 */ 
typedef struct s__l__gen_dbg_gui__gen_dbg97230 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg_gui__gen_dbg_de95181 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg_gui__gen_dbg_de97229;
#define d__l__gen_dbg_gui__gen_dbg_de97229 8794   

typedef l__gen_dbg_gui__gen_dbg_de97229 l__gen_dbg_details_changer97263;
#define d__l__gen_dbg_details_changer97263 d__l__gen_dbg_gui__gen_dbg_de97229

/* l__gen_dbg_gui__gen_dbg_panel */ 
typedef struct s__l__gen_dbg_gui__gen_dbg97231 {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg_gui__gen_dbg_panel **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg_gui__gen_dbg_panel;
#define d__l__gen_dbg_gui__gen_dbg_panel 8798   

typedef l__gen_dbg_gui__gen_dbg_panel l__gen_dbg_panel;
#define d__l__gen_dbg_panel d__l__gen_dbg_gui__gen_dbg_panel

/* l__gen_dbg__gen_dbg_struct */ 
typedef struct s__l__gen_dbg__gen_dbg_struct {
    t__int d__;
    t__int gen__;
    struct s__gen_dbg__gen_dbg_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen_dbg__gen_dbg_struct;
#define d__l__gen_dbg__gen_dbg_struct 8799   

typedef l__gen_dbg__gen_dbg_struct l__gen_dbg_struct;
#define d__l__gen_dbg_struct d__l__gen_dbg__gen_dbg_struct

/* k__sn__gen_sa_pure_type__etype */ 
typedef struct s__k__sn__gen_sa_pure_type96896 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_pure_type **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_sa_pure_type__etype;
#define d__k__sn__gen_sa_pure_type__etype 8197   

typedef k__sn__gen_sa_pure_type__etype k__gen_sa_pure_type__etype;
#define d__k__gen_sa_pure_type__etype d__k__sn__gen_sa_pure_type__etype

/* l__sn__gen_sa_cc_graph */ 
typedef struct s__l__sn__gen_sa_cc_graph {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_cc_graph **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_cc_graph;
#define d__l__sn__gen_sa_cc_graph 8231   

typedef l__sn__gen_sa_cc_graph l__gen_sa_cc_graph;
#define d__l__gen_sa_cc_graph d__l__sn__gen_sa_cc_graph

/* l__gen__gen_sa_hierarchy_n96897 */ 
typedef struct s__l__gen__gen_sa_hierarch96898 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_hierarchy_n82234 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_hierarchy_n96897;
#define d__l__gen__gen_sa_hierarchy_n96897 8235   

typedef l__gen__gen_sa_hierarchy_n96897 l__gen_sa_hierarchy_node_d96949;
#define d__l__gen_sa_hierarchy_node_d96949 d__l__gen__gen_sa_hierarchy_n96897

/* k__gen__gen_sa_hierarchy_n82442 */ 
typedef struct s__k__gen__gen_sa_hierarch96865 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_hierarchy_n82231 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_hierarchy_n82442;
#define d__k__gen__gen_sa_hierarchy_n82442 8123   

typedef k__gen__gen_sa_hierarchy_n82442 k__gen_sa_hierarchy_node_d96867;
#define d__k__gen_sa_hierarchy_node_d96867 d__k__gen__gen_sa_hierarchy_n82442

/* k__sn__gen_sa_hierarchy_no82228 */ 
typedef struct s__k__sn__gen_sa_hierarchy82229 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_hierarchy_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_sa_hierarchy_no82228;
#define d__k__sn__gen_sa_hierarchy_no82228 8107   

typedef k__sn__gen_sa_hierarchy_no82228 k__gen_sa_hierarchy_node__it;
#define d__k__gen_sa_hierarchy_node__it d__k__sn__gen_sa_hierarchy_no82228

/* k__gen__gen_sa_hierarchy_n82433 */ 
typedef struct s__k__gen__gen_sa_hierarch96862 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_hierarchy_n82231 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_hierarchy_n82433;
#define d__k__gen__gen_sa_hierarchy_n82433 8111   

typedef k__gen__gen_sa_hierarchy_n82433 k__gen_sa_hierarchy_node_d96864;
#define d__k__gen_sa_hierarchy_node_d96864 d__k__gen__gen_sa_hierarchy_n82433

/* k__gen__gen_sa_hierarchy_n82207 */ 
typedef struct s__k__gen__gen_sa_hierarch96866 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_hierarchy_n82206 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__gen__gen_sa_hierarchy_n82207;
#define d__k__gen__gen_sa_hierarchy_n82207 8109   

typedef k__gen__gen_sa_hierarchy_n82207 k__gen_sa_hierarchy_node_c96868;
#define d__k__gen_sa_hierarchy_node_c96868 d__k__gen__gen_sa_hierarchy_n82207

/* l__sn__gen_sa_cc_motivator */ 
typedef struct s__l__sn__gen_sa_cc_motivator {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_cc_motivator **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_cc_motivator;
#define d__l__sn__gen_sa_cc_motivator 8236   

typedef l__sn__gen_sa_cc_motivator l__gen_sa_cc_motivator;
#define d__l__gen_sa_cc_motivator d__l__sn__gen_sa_cc_motivator

/* l__sn__gen_sa_direct_cc_header */ 
typedef struct s__l__sn__gen_sa_direct_cc82607 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_direct_cc_header **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_direct_cc_header;
#define d__l__sn__gen_sa_direct_cc_header 8136   

typedef l__sn__gen_sa_direct_cc_header l__gen_sa_direct_cc_header;
#define d__l__gen_sa_direct_cc_header d__l__sn__gen_sa_direct_cc_header

/* l__sn__gen_sa_cc_reuse_data */ 
typedef struct s__l__sn__gen_sa_cc_reuse_data {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_cc_reuse_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_sa_cc_reuse_data;
#define d__l__sn__gen_sa_cc_reuse_data 8237   

typedef l__sn__gen_sa_cc_reuse_data l__gen_sa_cc_reuse_data;
#define d__l__gen_sa_cc_reuse_data d__l__sn__gen_sa_cc_reuse_data

/* l__gen__gen_sa_cc_merge_data */ 
typedef struct s__l__gen__gen_sa_cc_merge_data {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_sa_cc_merge_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_sa_cc_merge_data;
#define d__l__gen__gen_sa_cc_merge_data 8181   

typedef l__gen__gen_sa_cc_merge_data l__gen_sa_cc_merge_data;
#define d__l__gen_sa_cc_merge_data d__l__gen__gen_sa_cc_merge_data

/* k__sn__gen_sa_simple_cc_he96791 */ 
typedef struct s__k__sn__gen_sa_simple_cc96792 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_sa_simple_cc_header **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_sa_simple_cc_he96791;
#define d__k__sn__gen_sa_simple_cc_he96791 8202   

typedef k__sn__gen_sa_simple_cc_he96791 k__gen_sa_simple_cc_header96930;
#define d__k__gen_sa_simple_cc_header96930 d__k__sn__gen_sa_simple_cc_he96791

/* k__sn__sn_bdd__bdd */ 
typedef struct s__k__sn__sn_bdd__bdd {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_bdd **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_bdd__bdd;
#define d__k__sn__sn_bdd__bdd 8033   

typedef k__sn__sn_bdd__bdd k__sn_bdd__bdd;
#define d__k__sn_bdd__bdd d__k__sn__sn_bdd__bdd

/* l__sn__sn_bdd */ 
typedef struct s__l__sn__sn_bdd {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_bdd **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_bdd;
#define d__l__sn__sn_bdd 2872   

typedef l__sn__sn_bdd l__sn_bdd;
#define d__l__sn_bdd d__l__sn__sn_bdd

/* l__sn__gen_pnet_var */ 
typedef struct s__l__sn__gen_pnet_var {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_var **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_pnet_var;
#define d__l__sn__gen_pnet_var 8402   

typedef l__sn__gen_pnet_var l__gen_pnet_var;
#define d__l__gen_pnet_var d__l__sn__gen_pnet_var

/* l__sn__gen_pnet_propagator */ 
typedef struct s__l__sn__gen_pnet_propagator {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_propagator **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_pnet_propagator;
#define d__l__sn__gen_pnet_propagator 8403   

typedef l__sn__gen_pnet_propagator l__gen_pnet_propagator;
#define d__l__gen_pnet_propagator d__l__sn__gen_pnet_propagator

/* l__sn__queue */ 
typedef struct s__l__sn__queue {
    t__int d__;
    t__int gen__;
    struct s__sn__queue **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__queue;
#define d__l__sn__queue 8660   

typedef l__sn__queue l__queue;
#define d__l__queue d__l__sn__queue

/* l__sn__gen_cc_solver */ 
typedef struct s__l__sn__gen_cc_solver {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_cc_solver **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_cc_solver;
#define d__l__sn__gen_cc_solver 8732   

typedef l__sn__gen_cc_solver l__gen_cc_solver;
#define d__l__gen_cc_solver d__l__sn__gen_cc_solver

/* l__sn__listener_mode */ 
typedef struct s__l__sn__listener_mode {
    t__int d__;
    t__int gen__;
    t__sn__listener_mode*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__listener_mode;
#define d__l__sn__listener_mode 8733   

typedef l__sn__listener_mode l__listener_mode;
#define d__l__listener_mode d__l__sn__listener_mode

/* l__gen__list_indices */ 
typedef struct s__l__gen__list_indices {
    t__int d__;
    t__int gen__;
    struct s__gen__list_indices **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__list_indices;
#define d__l__gen__list_indices 8734   

typedef l__gen__list_indices l__list_indices;
#define d__l__list_indices d__l__gen__list_indices

/* l__sn__var_eq_class */ 
typedef struct s__l__sn__var_eq_class {
    t__int d__;
    t__int gen__;
    struct s__sn__var_eq_class **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__var_eq_class;
#define d__l__sn__var_eq_class 8664   

typedef l__sn__var_eq_class l__var_eq_class;
#define d__l__var_eq_class d__l__sn__var_eq_class

/* k__sn__var2class__v */ 
typedef struct s__k__sn__var2class__v {
    t__int d__;
    t__int gen__;
    struct s__sn__var2class **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__var2class__v;
#define d__k__sn__var2class__v 8665   

typedef k__sn__var2class__v k__var2class__v;
#define d__k__var2class__v d__k__sn__var2class__v

/* l__sn__gen_policy */ 
typedef struct s__l__sn__gen_policy {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_policy **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_policy;
#define d__l__sn__gen_policy 8404   

typedef l__sn__gen_policy l__gen_policy;
#define d__l__gen_policy d__l__sn__gen_policy

/* l__gen__gen_slm_reuse_component */ 
typedef struct s__l__gen__gen_slm_reuse_c96987 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_slm_reuse_component **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_slm_reuse_component;
#define d__l__gen__gen_slm_reuse_component 8324   

typedef l__gen__gen_slm_reuse_component l__gen_slm_reuse_component;
#define d__l__gen_slm_reuse_component d__l__gen__gen_slm_reuse_component

/* l__gen__gen_slm_constraint88103 */ 
typedef struct s__l__gen__gen_slm_constra96951 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_slm_constraint96990 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_slm_constraint88103;
#define d__l__gen__gen_slm_constraint88103 8323   

typedef l__gen__gen_slm_constraint88103 l__gen_slm_constraint_reus96989;
#define d__l__gen_slm_constraint_reus96989 d__l__gen__gen_slm_constraint88103

/* l__gen__gen_mult_node_reus88367 */ 
typedef struct s__l__gen__gen_mult_node_r96988 {
    t__int d__;
    t__int gen__;
    struct s__gen__gen_mult_node_reus86103 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__gen_mult_node_reus88367;
#define d__l__gen__gen_mult_node_reus88367 8325   

typedef l__gen__gen_mult_node_reus88367 l__gen_mult_node_reuse_info;
#define d__l__gen_mult_node_reuse_info d__l__gen__gen_mult_node_reus88367

/* l__sn__gen_slm_multiplicit85666 */ 
typedef struct s__l__sn__gen_slm_multipli96952 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_multiplicit86160 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_slm_multiplicit85666;
#define d__l__sn__gen_slm_multiplicit85666 8257   

typedef l__sn__gen_slm_multiplicit85666 l__gen_slm_multiplicity_node;
#define d__l__gen_slm_multiplicity_node d__l__sn__gen_slm_multiplicit85666

/* l__sn__gen_slm_multiplicit85667 */ 
typedef struct s__l__sn__gen_slm_multipli96953 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_slm_multiplicit86158 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_slm_multiplicit85667;
#define d__l__sn__gen_slm_multiplicit85667 8258   

typedef l__sn__gen_slm_multiplicit85667 l__gen_slm_multiplicity_input;
#define d__l__gen_slm_multiplicity_input d__l__sn__gen_slm_multiplicit85667

/* k__sn__gen_pnet_var__it */ 
typedef struct s__k__sn__gen_pnet_var__it {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_var **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_pnet_var__it;
#define d__k__sn__gen_pnet_var__it 8680   

typedef k__sn__gen_pnet_var__it k__gen_pnet_var__it;
#define d__k__gen_pnet_var__it d__k__sn__gen_pnet_var__it

/* k__sn__gen_pnet_propagator__it */ 
typedef struct s__k__sn__gen_pnet_propaga96793 {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_pnet_propagator **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__gen_pnet_propagator__it;
#define d__k__sn__gen_pnet_propagator__it 8681   

typedef k__sn__gen_pnet_propagator__it k__gen_pnet_propagator__it;
#define d__k__gen_pnet_propagator__it d__k__sn__gen_pnet_propagator__it

/* l__sn__etx_type */ 
typedef struct s__l__sn__etx_type {
    t__int d__;
    t__int gen__;
    struct s__sn__etx_type **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__etx_type;
#define d__l__sn__etx_type 8873   

typedef l__sn__etx_type l__etx_type;
#define d__l__etx_type d__l__sn__etx_type

/* l__sn__etx_constraint */ 
typedef struct s__l__sn__etx_constraint {
    t__int d__;
    t__int gen__;
    struct s__sn__etx_constraint **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__etx_constraint;
#define d__l__sn__etx_constraint 8878   

typedef l__sn__etx_constraint l__etx_constraint;
#define d__l__etx_constraint d__l__sn__etx_constraint

/* k__sn__input_map__i */ 
typedef struct s__k__sn__input_map__i {
    t__int d__;
    t__int gen__;
    struct s__sn__input_map **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__input_map__i;
#define d__k__sn__input_map__i 8880   

typedef k__sn__input_map__i k__input_map__i;
#define d__k__input_map__i d__k__sn__input_map__i

/* l__sn__etx_ref_local */ 
typedef struct s__l__sn__etx_ref_local {
    t__int d__;
    t__int gen__;
    struct s__sn__etx_ref_local **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__etx_ref_local;
#define d__l__sn__etx_ref_local 8879   

typedef l__sn__etx_ref_local l__etx_ref_local;
#define d__l__etx_ref_local d__l__sn__etx_ref_local

/* l__sn__st_field_access_exp */ 
typedef struct s__l__sn__st_field_access_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__st_field_access_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_field_access_exp;
#define d__l__sn__st_field_access_exp 8809   

typedef l__sn__st_field_access_exp l__st_field_access_exp;
#define d__l__st_field_access_exp d__l__sn__st_field_access_exp

/* l__sn__st_named_is_a_exp */ 
typedef struct s__l__sn__st_named_is_a_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__st_named_is_a_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_named_is_a_exp;
#define d__l__sn__st_named_is_a_exp 6635   

typedef l__sn__st_named_is_a_exp l__st_named_is_a_exp;
#define d__l__st_named_is_a_exp d__l__sn__st_named_is_a_exp

/* l__sn__st_method_call_exp */ 
typedef struct s__l__sn__st_method_call_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__st_method_call_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__st_method_call_exp;
#define d__l__sn__st_method_call_exp 8808   

typedef l__sn__st_method_call_exp l__st_method_call_exp;
#define d__l__st_method_call_exp d__l__sn__st_method_call_exp

/* l__sn__n__rhs_exp */ 
typedef struct s__l__sn__n__rhs_exp {
    t__int d__;
    t__int gen__;
    struct s__sn__n__rhs_exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__n__rhs_exp;
#define d__l__sn__n__rhs_exp 710   

typedef l__sn__n__rhs_exp l__n__rhs_exp;
#define d__l__n__rhs_exp d__l__sn__n__rhs_exp

/* l__gen__linter_error */ 
typedef struct s__l__gen__linter_error {
    t__int d__;
    t__int gen__;
    struct s__gen__linter_error **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__gen__linter_error;
#define d__l__gen__linter_error 8818   

typedef l__gen__linter_error l__linter_error;
#define d__l__linter_error d__l__gen__linter_error

/* l__sn__checked_method */ 
typedef struct s__l__sn__checked_method {
    t__int d__;
    t__int gen__;
    struct s__sn__checked_method **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__checked_method;
#define d__l__sn__checked_method 8820   

typedef l__sn__checked_method l__checked_method;
#define d__l__checked_method d__l__sn__checked_method

/* l__sn__sn_library */ 
typedef struct s__l__sn__sn_library {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_library **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_library;
#define d__l__sn__sn_library 2155   

typedef l__sn__sn_library l__sn_library;
#define d__l__sn_library d__l__sn__sn_library

/* k__e_core__sn_component__name */ 
typedef struct s__k__e_core__sn_component34126 {
    t__int d__;
    t__int gen__;
    struct s__e_core__sn_component **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__sn_component__name;
#define d__k__e_core__sn_component__name 4295   

typedef k__e_core__sn_component__name k__sn_component__name;
#define d__k__sn_component__name d__k__e_core__sn_component__name

/* l__e_core__sn_component */ 
typedef struct s__l__e_core__sn_component {
    t__int d__;
    t__int gen__;
    struct s__e_core__sn_component **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__sn_component;
#define d__l__e_core__sn_component 4296   

typedef l__e_core__sn_component l__sn_component;
#define d__l__sn_component d__l__e_core__sn_component

/* l__reflection__rf_erm_package */ 
typedef struct s__l__reflection__rf_erm_p75752 {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_erm_package **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_erm_package;
#define d__l__reflection__rf_erm_package 7696   

typedef l__reflection__rf_erm_package l__rf_erm_package;
#define d__l__rf_erm_package d__l__reflection__rf_erm_package

/* l__reflection__rf_module */ 
typedef struct s__l__reflection__rf_module {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_module **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_module;
#define d__l__reflection__rf_module 1797   

typedef l__reflection__rf_module l__rf_module;
#define d__l__rf_module d__l__reflection__rf_module

/* k__sn__edoc_rf_struct__name */ 
typedef struct s__k__sn__edoc_rf_struct__name {
    t__int d__;
    t__int gen__;
    struct s__sn__edoc_rf_struct **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__edoc_rf_struct__name;
#define d__k__sn__edoc_rf_struct__name 7906   

typedef k__sn__edoc_rf_struct__name k__edoc_rf_struct__name;
#define d__k__edoc_rf_struct__name d__k__sn__edoc_rf_struct__name

/* l__sn__edoc_members_list_w78617 */ 
typedef struct s__l__sn__edoc_members_lis80449 {
    t__int d__;
    t__int gen__;
    struct s__sn__edoc_members_list_w78540 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__edoc_members_list_w78617;
#define d__l__sn__edoc_members_list_w78617 7903   

typedef l__sn__edoc_members_list_w78617 l__edoc_members_list_wrapper;
#define d__l__edoc_members_list_wrapper d__l__sn__edoc_members_list_w78617

/* k__sn__edoc_rf_struct_memb78542 */ 
typedef struct s__k__sn__edoc_rf_struct_m78543 {
    t__int d__;
    t__int gen__;
    struct s__sn__edoc_rf_struct_member **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__edoc_rf_struct_memb78542;
#define d__k__sn__edoc_rf_struct_memb78542 7904   

typedef k__sn__edoc_rf_struct_memb78542 k__edoc_rf_struct_member__name;
#define d__k__edoc_rf_struct_member__name d__k__sn__edoc_rf_struct_memb78542

/* l__reflection__rf_scalar */ 
typedef struct s__l__reflection__rf_scalar {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_scalar **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_scalar;
#define d__l__reflection__rf_scalar 7901   

typedef l__reflection__rf_scalar l__rf_scalar;
#define d__l__rf_scalar d__l__reflection__rf_scalar

/* l__sn__edoc_encapsulation_t */ 
typedef struct s__l__sn__edoc_encapsulation_t {
    t__int d__;
    t__int gen__;
    t__sn__edoc_encapsulation_t*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__edoc_encapsulation_t;
#define d__l__sn__edoc_encapsulation_t 7902   

typedef l__sn__edoc_encapsulation_t l__edoc_encapsulation_t;
#define d__l__edoc_encapsulation_t d__l__sn__edoc_encapsulation_t

/* k__e_core__sn_patch__info_key */ 
typedef struct s__k__e_core__sn_patch__in34127 {
    t__int d__;
    t__int gen__;
    struct s__e_core__sn_patch **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__sn_patch__info_key;
#define d__k__e_core__sn_patch__info_key 4291   

typedef k__e_core__sn_patch__info_key k__sn_patch__info_key;
#define d__k__sn_patch__info_key d__k__e_core__sn_patch__info_key

/* l__e_core__sn_patch */ 
typedef struct s__l__e_core__sn_patch {
    t__int d__;
    t__int gen__;
    struct s__e_core__sn_patch **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__sn_patch;
#define d__l__e_core__sn_patch 4292   

typedef l__e_core__sn_patch l__sn_patch;
#define d__l__sn_patch d__l__e_core__sn_patch

/* k__sn__sn_command_option_d32153 */ 
typedef struct s__k__sn__sn_command_optio34129 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_command_option_d32215 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_command_option_d32153;
#define d__k__sn__sn_command_option_d32153 4280   

typedef k__sn__sn_command_option_d32153 k__sn_command_option_descr34128;
#define d__k__sn_command_option_descr34128 d__k__sn__sn_command_option_d32153

/* k__sn__unit_size__unit */ 
typedef struct s__k__sn__unit_size__unit {
    t__int d__;
    t__int gen__;
    struct s__sn__unit_size **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__unit_size__unit;
#define d__k__sn__unit_size__unit 2351   

typedef k__sn__unit_size__unit k__unit_size__unit;
#define d__k__unit_size__unit d__k__sn__unit_size__unit

/* l__sn__line_kind */ 
typedef struct s__l__sn__line_kind {
    t__int d__;
    t__int gen__;
    t__sn__line_kind*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__line_kind;
#define d__l__sn__line_kind 2363   

typedef l__sn__line_kind l__line_kind;
#define d__l__line_kind d__l__sn__line_kind

/* l__sn__word_indices */ 
typedef struct s__l__sn__word_indices {
    t__int d__;
    t__int gen__;
    struct s__sn__word_indices **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__word_indices;
#define d__l__sn__word_indices 2364   

typedef l__sn__word_indices l__word_indices;
#define d__l__word_indices d__l__sn__word_indices

/* k__vt__vt_style_props__p_style */ 
typedef struct s__k__vt__vt_style_props__16666 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_style_props **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_style_props__p_style;
#define d__k__vt__vt_style_props__p_style 2568   

typedef k__vt__vt_style_props__p_style k__vt_style_props__p_style;
#define d__k__vt_style_props__p_style d__k__vt__vt_style_props__p_style

/* k__vt__sn_vt_buffer__name */ 
typedef struct s__k__vt__sn_vt_buffer__name {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_vt_buffer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__sn_vt_buffer__name;
#define d__k__vt__sn_vt_buffer__name 4762   

typedef k__vt__sn_vt_buffer__name k__sn_vt_buffer__name;
#define d__k__sn_vt_buffer__name d__k__vt__sn_vt_buffer__name

/* l__vt__sn_vt_buffer */ 
typedef struct s__l__vt__sn_vt_buffer {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_vt_buffer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__sn_vt_buffer;
#define d__l__vt__sn_vt_buffer 4763   

typedef l__vt__sn_vt_buffer l__sn_vt_buffer;
#define d__l__sn_vt_buffer d__l__vt__sn_vt_buffer

/* k__vt__vt_element__m_eid */ 
typedef struct s__k__vt__vt_element__m_eid {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_element **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_element__m_eid;
#define d__k__vt__vt_element__m_eid 5402   

typedef k__vt__vt_element__m_eid k__vt_element__m_eid;
#define d__k__vt_element__m_eid d__k__vt__vt_element__m_eid

/* l__vt__export_table_data */ 
typedef struct s__l__vt__export_table_data {
    t__int d__;
    t__int gen__;
    struct s__vt__export_table_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__export_table_data;
#define d__l__vt__export_table_data 7843   

typedef l__vt__export_table_data l__export_table_data;
#define d__l__export_table_data d__l__vt__export_table_data

/* l__vt__vt_window */ 
typedef struct s__l__vt__vt_window {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_window **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_window;
#define d__l__vt__vt_window 4919   

typedef l__vt__vt_window l__vt_window;
#define d__l__vt_window d__l__vt__vt_window

/* k__vt__file_chooser_data__39953 */ 
typedef struct s__k__vt__file_chooser_dat39954 {
    t__int d__;
    t__int gen__;
    struct s__vt__file_chooser_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__file_chooser_data__39953;
#define d__k__vt__file_chooser_data__39953 5374   

typedef k__vt__file_chooser_data__39953 k__file_chooser_data__category;
#define d__k__file_chooser_data__category d__k__vt__file_chooser_data__39953

/* l__vt__vt_file_kind */ 
typedef struct s__l__vt__vt_file_kind {
    t__int d__;
    t__int gen__;
    t__vt__vt_file_kind*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_file_kind;
#define d__l__vt__vt_file_kind 5376   

typedef l__vt__vt_file_kind l__vt_file_kind;
#define d__l__vt_file_kind d__l__vt__vt_file_kind

/* k__vt__vt_file_kind_data__kind */ 
typedef struct s__k__vt__vt_file_kind_dat39736 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_file_kind_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_file_kind_data__kind;
#define d__k__vt__vt_file_kind_data__kind 5377   

typedef k__vt__vt_file_kind_data__kind k__vt_file_kind_data__kind;
#define d__k__vt_file_kind_data__kind d__k__vt__vt_file_kind_data__kind

/* k__vt__vt_widget_window_in39648 */ 
typedef struct s__k__vt__vt_widget_window39739 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_widget_window_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_widget_window_in39648;
#define d__k__vt__vt_widget_window_in39648 5396   

typedef k__vt__vt_widget_window_in39648 k__vt_widget_window_info__id;
#define d__k__vt_widget_window_info__id d__k__vt__vt_widget_window_in39648

/* k__vt__sn_tree_node_pairs_39740 */ 
typedef struct s__k__vt__sn_tree_node_pai39741 {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_tree_node_pairs **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__sn_tree_node_pairs_39740;
#define d__k__vt__sn_tree_node_pairs_39740 5397   

typedef k__vt__sn_tree_node_pairs_39740 k__sn_tree_node_pairs__s_i40020;
#define d__k__sn_tree_node_pairs__s_i40020 d__k__vt__sn_tree_node_pairs_39740

/* l__vt__sn_internal_tree_node */ 
typedef struct s__l__vt__sn_internal_tree_node {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_internal_tree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__sn_internal_tree_node;
#define d__l__vt__sn_internal_tree_node 2558   

typedef l__vt__sn_internal_tree_node l__sn_internal_tree_node;
#define d__l__sn_internal_tree_node d__l__vt__sn_internal_tree_node

/* l__vt__sn_tree_node */ 
typedef struct s__l__vt__sn_tree_node {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_tree_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__sn_tree_node;
#define d__l__vt__sn_tree_node 2562   

typedef l__vt__sn_tree_node l__sn_tree_node;
#define d__l__sn_tree_node d__l__vt__sn_tree_node

/* l__vt__sn_vt_box */ 
typedef struct s__l__vt__sn_vt_box {
    t__int d__;
    t__int gen__;
    struct s__vt__sn_vt_box **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__sn_vt_box;
#define d__l__vt__sn_vt_box 4912   

typedef l__vt__sn_vt_box l__sn_vt_box;
#define d__l__sn_vt_box d__l__vt__sn_vt_box

/* k__vt__vt_predefined_menu_42480 */ 
typedef struct s__k__vt__vt_predefined_me48627 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_predefined_menu_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_predefined_menu_42480;
#define d__k__vt__vt_predefined_menu_42480 5408   

typedef k__vt__vt_predefined_menu_42480 k__vt_predefined_menu_data48707;
#define d__k__vt_predefined_menu_data48707 d__k__vt__vt_predefined_menu_42480

/* k__vt__vt_predefined_actio42481 */ 
typedef struct s__k__vt__vt_predefined_ac48628 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_predefined_actio37374 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_predefined_actio42481;
#define d__k__vt__vt_predefined_actio42481 5409   

typedef k__vt__vt_predefined_actio42481 k__vt_predefined_action_da48708;
#define d__k__vt_predefined_action_da48708 d__k__vt__vt_predefined_actio42481

/* k__vt__vt_predefined_group48629 */ 
typedef struct s__k__vt__vt_predefined_gr48630 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_predefined_group_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vt_predefined_group48629;
#define d__k__vt__vt_predefined_group48629 5410   

typedef k__vt__vt_predefined_group48629 k__vt_predefined_group_dat48709;
#define d__k__vt_predefined_group_dat48709 d__k__vt__vt_predefined_group48629

/* l__vt__vt_predefined_actio37372 */ 
typedef struct s__l__vt__vt_predefined_ac37373 {
    t__int d__;
    t__int gen__;
    struct s__vt__vt_predefined_actio37374 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vt_predefined_actio37372;
#define d__l__vt__vt_predefined_actio37372 5074   

typedef l__vt__vt_predefined_actio37372 l__vt_predefined_action_data;
#define d__l__vt_predefined_action_data d__l__vt__vt_predefined_actio37372

/* l__sn_fl__sn_fl_te_node */ 
typedef struct s__l__sn_fl__sn_fl_te_node {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_te_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_te_node;
#define d__l__sn_fl__sn_fl_te_node 2972   

typedef l__sn_fl__sn_fl_te_node l__sn_fl_te_node;
#define d__l__sn_fl_te_node d__l__sn_fl__sn_fl_te_node

/* l__sn_fl__sn_fl_top_node */ 
typedef struct s__l__sn_fl__sn_fl_top_node {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__sn_fl_top_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__sn_fl_top_node;
#define d__l__sn_fl__sn_fl_top_node 2974   

typedef l__sn_fl__sn_fl_top_node l__sn_fl_top_node;
#define d__l__sn_fl_top_node d__l__sn_fl__sn_fl_top_node

/* l__sn_te_new_parser__sn_te19632 */ 
typedef struct s__l__sn_te_new_parser__sn19633 {
    t__int d__;
    t__int gen__;
    struct s__sn_te_new_parser__sn_te19631 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_te_new_parser__sn_te19632;
#define d__l__sn_te_new_parser__sn_te19632 2985   

typedef l__sn_te_new_parser__sn_te19632 l__sn_te_descriptor;
#define d__l__sn_te_descriptor d__l__sn_te_new_parser__sn_te19632

/* l__sn_te_new_parser__sn_la17777 */ 
typedef struct s__l__sn_te_new_parser__sn19634 {
    t__int d__;
    t__int gen__;
    struct s__sn_te_new_parser__sn_la19630 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_te_new_parser__sn_la17777;
#define d__l__sn_te_new_parser__sn_la17777 2986   

typedef l__sn_te_new_parser__sn_la17777 l__sn_last_line_pair;
#define d__l__sn_last_line_pair d__l__sn_te_new_parser__sn_la17777

/* l__sn_fl__tdb_break_point */ 
typedef struct s__l__sn_fl__tdb_break_point {
    t__int d__;
    t__int gen__;
    struct s__sn_fl__tdb_break_point **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn_fl__tdb_break_point;
#define d__l__sn_fl__tdb_break_point 3007   

typedef l__sn_fl__tdb_break_point l__tdb_break_point;
#define d__l__tdb_break_point d__l__sn_fl__tdb_break_point

/* k__sn__sn_define2_descript20062 */ 
typedef struct s__k__sn__sn_define2_descr20063 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_define2_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_define2_descript20062;
#define d__k__sn__sn_define2_descript20062 3097   

typedef k__sn__sn_define2_descript20062 k__sn_define2_descriptor__name;
#define d__k__sn_define2_descriptor__name d__k__sn__sn_define2_descript20062

/* k__sn__def2_name_string__name */ 
typedef struct s__k__sn__def2_name_string20098 {
    t__int d__;
    t__int gen__;
    struct s__sn__def2_name_string **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__def2_name_string__name;
#define d__k__sn__def2_name_string__name 3096   

typedef k__sn__def2_name_string__name k__def2_name_string__name;
#define d__k__def2_name_string__name d__k__sn__def2_name_string__name

/* k__sn__seamless_connection__tag */ 
typedef struct s__k__sn__seamless_connect22006 {
    t__int d__;
    t__int gen__;
    struct s__sn__seamless_connection **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__seamless_connection__tag;
#define d__k__sn__seamless_connection__tag 3242   

typedef k__sn__seamless_connection__tag k__seamless_connection__tag;
#define d__k__seamless_connection__tag d__k__sn__seamless_connection__tag

/* k__sn__sw_obj__descr */ 
typedef struct s__k__sn__sw_obj__descr {
    t__int d__;
    t__int gen__;
    struct s__sn__sw_obj **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sw_obj__descr;
#define d__k__sn__sw_obj__descr 3243   

typedef k__sn__sw_obj__descr k__sw_obj__descr;
#define d__k__sw_obj__descr d__k__sn__sw_obj__descr

/* l__sn__comm_pack_unpackable */ 
typedef struct s__l__sn__comm_pack_unpackable {
    t__int d__;
    t__int gen__;
    struct s__sn__comm_pack_unpackable **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__comm_pack_unpackable;
#define d__l__sn__comm_pack_unpackable 3292   

typedef l__sn__comm_pack_unpackable l__comm_pack_unpackable;
#define d__l__comm_pack_unpackable d__l__sn__comm_pack_unpackable

/* k__sn__name_id_pair__name */ 
typedef struct s__k__sn__name_id_pair__name {
    t__int d__;
    t__int gen__;
    struct s__sn__name_id_pair **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__name_id_pair__name;
#define d__k__sn__name_id_pair__name 3480   

typedef k__sn__name_id_pair__name k__name_id_pair__name;
#define d__k__name_id_pair__name d__k__sn__name_id_pair__name

/* l__sn__snorb_data_descriptor */ 
typedef struct s__l__sn__snorb_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__snorb_data_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__snorb_data_descriptor;
#define d__l__sn__snorb_data_descriptor 3481   

typedef l__sn__snorb_data_descriptor l__snorb_data_descriptor;
#define d__l__snorb_data_descriptor d__l__sn__snorb_data_descriptor

/* k__sn__p_sn_string_hash_tab4353 */ 
typedef struct s__k__sn__p_sn_string_hash_4513 {
    t__int d__;
    t__int gen__;
    struct s__sn__p_sn_string_hash_tab4511 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__p_sn_string_hash_tab4353;
#define d__k__sn__p_sn_string_hash_tab4353 1525   

typedef k__sn__p_sn_string_hash_tab4353 k__p_sn_string_hash_table_e4512;
#define d__k__p_sn_string_hash_table_e4512 d__k__sn__p_sn_string_hash_tab4353

/* k__sn__p_map_entry__key */ 
typedef struct s__k__sn__p_map_entry__key {
    t__int d__;
    t__int gen__;
    struct s__sn__p_map_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__p_map_entry__key;
#define d__k__sn__p_map_entry__key 1524   

typedef k__sn__p_map_entry__key k__p_map_entry__key;
#define d__k__p_map_entry__key d__k__sn__p_map_entry__key

/* k__sn__sn_edl_struct_info__p_td */ 
typedef struct s__k__sn__sn_edl_struct_in22780 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_edl_struct_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_edl_struct_info__p_td;
#define d__k__sn__sn_edl_struct_info__p_td 3364   

typedef k__sn__sn_edl_struct_info__p_td k__sn_edl_struct_info__p_td;
#define d__k__sn_edl_struct_info__p_td d__k__sn__sn_edl_struct_info__p_td

/* k__sn__sn_edl_method_info_22692 */ 
typedef struct s__k__sn__sn_edl_method_in22778 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_edl_method_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_edl_method_info_22692;
#define d__k__sn__sn_edl_method_info_22692 3365   

typedef k__sn__sn_edl_method_info_22692 k__sn_edl_method_info__p_method;
#define d__k__sn_edl_method_info__p_method d__k__sn__sn_edl_method_info_22692

/* k__sn__sn_edl_const_info__22693 */ 
typedef struct s__k__sn__sn_edl_const_inf22779 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_edl_const_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_edl_const_info__22693;
#define d__k__sn__sn_edl_const_info__22693 3366   

typedef k__sn__sn_edl_const_info__22693 k__sn_edl_const_info__p_s_name;
#define d__k__sn_edl_const_info__p_s_name d__k__sn__sn_edl_const_info__22693

/* l__sn__EDLPackage */ 
typedef struct s__l__sn__EDLPackage {
    t__int d__;
    t__int gen__;
    struct s__sn__EDLPackage **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__EDLPackage;
#define d__l__sn__EDLPackage 3402   

typedef l__sn__EDLPackage l__EDLPackage;
#define d__l__EDLPackage d__l__sn__EDLPackage

/* l__sn__EDLAbsUserType */ 
typedef struct s__l__sn__EDLAbsUserType {
    t__int d__;
    t__int gen__;
    struct s__sn__EDLAbsUserType **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__EDLAbsUserType;
#define d__l__sn__EDLAbsUserType 3403   

typedef l__sn__EDLAbsUserType l__EDLAbsUserType;
#define d__l__EDLAbsUserType d__l__sn__EDLAbsUserType

/* k__sn__EDLAbsUserType__it */ 
typedef struct s__k__sn__EDLAbsUserType__it {
    t__int d__;
    t__int gen__;
    struct s__sn__EDLAbsUserType **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__EDLAbsUserType__it;
#define d__k__sn__EDLAbsUserType__it 3407   

typedef k__sn__EDLAbsUserType__it k__EDLAbsUserType__it;
#define d__k__EDLAbsUserType__it d__k__sn__EDLAbsUserType__it

/* l__sn__EDLAbsBasicType */ 
typedef struct s__l__sn__EDLAbsBasicType {
    t__int d__;
    t__int gen__;
    struct s__sn__EDLAbsBasicType **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__EDLAbsBasicType;
#define d__l__sn__EDLAbsBasicType 3413   

typedef l__sn__EDLAbsBasicType l__EDLAbsBasicType;
#define d__l__EDLAbsBasicType d__l__sn__EDLAbsBasicType

/* l__sn__sn_curly_brackets_p27132 */ 
typedef struct s__l__sn__sn_curly_bracket27133 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_curly_brackets_p25736 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_curly_brackets_p27132;
#define d__l__sn__sn_curly_brackets_p27132 3824   

typedef l__sn__sn_curly_brackets_p27132 l__sn_curly_brackets_processor;
#define d__l__sn_curly_brackets_processor d__l__sn__sn_curly_brackets_p27132

/* l__sn__sn_vm_parse_element25772 */ 
typedef struct s__l__sn__sn_vm_parse_elem27312 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_vm_parse_element27313 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_vm_parse_element25772;
#define d__l__sn__sn_vm_parse_element25772 3825   

typedef l__sn__sn_vm_parse_element25772 l__sn_vm_parse_elements_holder;
#define d__l__sn_vm_parse_elements_holder d__l__sn__sn_vm_parse_element25772

/* l__sn__sn_vm_parse_entity */ 
typedef struct s__l__sn__sn_vm_parse_entity {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_vm_parse_entity **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_vm_parse_entity;
#define d__l__sn__sn_vm_parse_entity 3823   

typedef l__sn__sn_vm_parse_entity l__sn_vm_parse_entity;
#define d__l__sn_vm_parse_entity d__l__sn__sn_vm_parse_entity

/* l__main__basic_event_log */ 
typedef struct s__l__main__basic_event_log {
    t__int d__;
    t__int gen__;
    struct s__main__basic_event_log **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__basic_event_log;
#define d__l__main__basic_event_log 3788   

typedef l__main__basic_event_log l__basic_event_log;
#define d__l__basic_event_log d__l__main__basic_event_log

/* l__sn__sn_ec_point_environment */ 
typedef struct s__l__sn__sn_ec_point_envi25953 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_ec_point_environment **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_ec_point_environment;
#define d__l__sn__sn_ec_point_environment 3863   

typedef l__sn__sn_ec_point_environment l__sn_ec_point_environment;
#define d__l__sn_ec_point_environment d__l__sn__sn_ec_point_environment

/* k__sn__sn_service_deli_ent31656 */ 
typedef struct s__k__sn__sn_service_deli_31887 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_service_deli_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_service_deli_ent31656;
#define d__k__sn__sn_service_deli_ent31656 4252   

typedef k__sn__sn_service_deli_ent31656 k__sn_service_deli_entry__31886;
#define d__k__sn_service_deli_entry__31886 d__k__sn__sn_service_deli_ent31656

/* l__sn__sni_jcvr_change_listener */ 
typedef struct s__l__sn__sni_jcvr_change_39854 {
    t__int d__;
    t__int gen__;
    struct s__sn__sni_jcvr_change_listener **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sni_jcvr_change_listener;
#define d__l__sn__sni_jcvr_change_listener 4419   

typedef l__sn__sni_jcvr_change_listener l__sni_jcvr_change_listener;
#define d__l__sni_jcvr_change_listener d__l__sn__sni_jcvr_change_listener

/* k__sn__sn_transaction_inte33720 */ 
typedef struct s__k__sn__sn_transaction_i34154 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_transaction_interface **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_transaction_inte33720;
#define d__k__sn__sn_transaction_inte33720 4385   

typedef k__sn__sn_transaction_inte33720 k__sn_transaction_interfac34159;
#define d__k__sn_transaction_interfac34159 d__k__sn__sn_transaction_inte33720

/* k__sn__unit_info_s__unit_object */ 
typedef struct s__k__sn__unit_info_s__uni34155 {
    t__int d__;
    t__int gen__;
    struct s__sn__unit_info_s **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__unit_info_s__unit_object;
#define d__k__sn__unit_info_s__unit_object 4386   

typedef k__sn__unit_info_s__unit_object k__unit_info_s__unit_object;
#define d__k__unit_info_s__unit_object d__k__sn__unit_info_s__unit_object

/* k__sn__sn_sdi_feature__fea34156 */ 
typedef struct s__k__sn__sn_sdi_feature__34157 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_sdi_feature **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_sdi_feature__fea34156;
#define d__k__sn__sn_sdi_feature__fea34156 4390   

typedef k__sn__sn_sdi_feature__fea34156 k__sn_sdi_feature__feature_name;
#define d__k__sn_sdi_feature__feature_name d__k__sn__sn_sdi_feature__fea34156

/* k__sn__sn_config_full_item34803 */ 
typedef struct s__k__sn__sn_config_full_i39864 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_config_full_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_config_full_item34803;
#define d__k__sn__sn_config_full_item34803 4477   

typedef k__sn__sn_config_full_item34803 k__sn_config_full_item__p_s_key;
#define d__k__sn_config_full_item__p_s_key d__k__sn__sn_config_full_item34803

/* l__sn__sn_jconfig_category_val */ 
typedef struct s__l__sn__sn_jconfig_categ39859 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_jconfig_category_val **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_jconfig_category_val;
#define d__l__sn__sn_jconfig_category_val 4458   

typedef l__sn__sn_jconfig_category_val l__sn_jconfig_category_val;
#define d__l__sn_jconfig_category_val d__l__sn__sn_jconfig_category_val

/* l__sn__sn_jconfig_item_val */ 
typedef struct s__l__sn__sn_jconfig_item_val {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_jconfig_item_val **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_jconfig_item_val;
#define d__l__sn__sn_jconfig_item_val 4459   

typedef l__sn__sn_jconfig_item_val l__sn_jconfig_item_val;
#define d__l__sn_jconfig_item_val d__l__sn__sn_jconfig_item_val

/* k__sn__scalars_holders__pa36918 */ 
typedef struct s__k__sn__scalars_holders_39918 {
    t__int d__;
    t__int gen__;
    struct s__sn__scalars_holders **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__scalars_holders__pa36918;
#define d__k__sn__scalars_holders__pa36918 4729   

typedef k__sn__scalars_holders__pa36918 k__scalars_holders__parent_id;
#define d__k__scalars_holders__parent_id d__k__sn__scalars_holders__pa36918

/* k__sn__scalar_cache_node__39919 */ 
typedef struct s__k__sn__scalar_cache_nod39920 {
    t__int d__;
    t__int gen__;
    struct s__sn__scalar_cache_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__scalar_cache_node__39919;
#define d__k__sn__scalar_cache_node__39919 4725   

typedef k__sn__scalar_cache_node__39919 k__scalar_cache_node__chil39921;
#define d__k__scalar_cache_node__chil39921 d__k__sn__scalar_cache_node__39919

/* k__sn__container_cache_nod39922 */ 
typedef struct s__k__sn__container_cache_39923 {
    t__int d__;
    t__int gen__;
    struct s__sn__container_cache_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__container_cache_nod39922;
#define d__k__sn__container_cache_nod39922 4726   

typedef k__sn__container_cache_nod39922 k__container_cache_node__u39927;
#define d__k__container_cache_node__u39927 d__k__sn__container_cache_nod39922

/* l__sn__abs_cache_node */ 
typedef struct s__l__sn__abs_cache_node {
    t__int d__;
    t__int gen__;
    struct s__sn__abs_cache_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__abs_cache_node;
#define d__l__sn__abs_cache_node 4718   

typedef l__sn__abs_cache_node l__abs_cache_node;
#define d__l__abs_cache_node d__l__sn__abs_cache_node

/* k__sn__null_container_cach39924 */ 
typedef struct s__k__sn__null_container_c39925 {
    t__int d__;
    t__int gen__;
    struct s__sn__null_container_cach39876 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__null_container_cach39924;
#define d__k__sn__null_container_cach39924 4727   

typedef k__sn__null_container_cach39924 k__null_container_cache_no39928;
#define d__k__null_container_cache_no39928 d__k__sn__null_container_cach39924

/* k__sn__container_cache_node__id */ 
typedef struct s__k__sn__container_cache_39926 {
    t__int d__;
    t__int gen__;
    struct s__sn__container_cache_node **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__container_cache_node__id;
#define d__k__sn__container_cache_node__id 4728   

typedef k__sn__container_cache_node__id k__container_cache_node__id;
#define d__k__container_cache_node__id d__k__sn__container_cache_node__id

/* l__sn__cache_entry */ 
typedef struct s__l__sn__cache_entry {
    t__int d__;
    t__int gen__;
    struct s__sn__cache_entry **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cache_entry;
#define d__l__sn__cache_entry 4724   

typedef l__sn__cache_entry l__cache_entry;
#define d__l__cache_entry d__l__sn__cache_entry

/* k__vt__vtx_base_window__m_id */ 
typedef struct s__k__vt__vtx_base_window__m_id {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_base_window **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vtx_base_window__m_id;
#define d__k__vt__vtx_base_window__m_id 5594   

typedef k__vt__vtx_base_window__m_id k__vtx_base_window__m_id;
#define d__k__vtx_base_window__m_id d__k__vt__vtx_base_window__m_id

/* k__vt__vtx_window_kind_gui48702 */ 
typedef struct s__k__vt__vtx_window_kind_48703 {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_window_kind_gui39964 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__vt__vtx_window_kind_gui48702;
#define d__k__vt__vtx_window_kind_gui48702 5595   

typedef k__vt__vtx_window_kind_gui48702 k__vtx_window_kind_gui_set48771;
#define d__k__vtx_window_kind_gui_set48771 d__k__vt__vtx_window_kind_gui48702

/* l__vt__vtx_snorb_splitter_39958 */ 
typedef struct s__l__vt__vtx_snorb_splitt39959 {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_snorb_splitter_39962 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_snorb_splitter_39958;
#define d__l__vt__vtx_snorb_splitter_39958 5256   

typedef l__vt__vtx_snorb_splitter_39958 l__vtx_snorb_splitter_settings;
#define d__l__vtx_snorb_splitter_settings d__l__vt__vtx_snorb_splitter_39958

/* l__vt__vtx_snorb_tabctrl_s39960 */ 
typedef struct s__l__vt__vtx_snorb_tabctr39961 {
    t__int d__;
    t__int gen__;
    struct s__vt__vtx_snorb_tabctrl_s39963 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__vt__vtx_snorb_tabctrl_s39960;
#define d__l__vt__vtx_snorb_tabctrl_s39960 5257   

typedef l__vt__vtx_snorb_tabctrl_s39960 l__vtx_snorb_tabctrl_settings;
#define d__l__vtx_snorb_tabctrl_settings d__l__vt__vtx_snorb_tabctrl_s39960

/* l__sn__gen_frame */ 
typedef struct s__l__sn__gen_frame {
    t__int d__;
    t__int gen__;
    struct s__sn__gen_frame **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__gen_frame;
#define d__l__sn__gen_frame 5727   

typedef l__sn__gen_frame l__gen_frame;
#define d__l__gen_frame d__l__sn__gen_frame

/* l__sn__hdl_assertion */ 
typedef struct s__l__sn__hdl_assertion {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_assertion **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__hdl_assertion;
#define d__l__sn__hdl_assertion 6700   

typedef l__sn__hdl_assertion l__hdl_assertion;
#define d__l__hdl_assertion d__l__sn__hdl_assertion

/* l__sn__hdl_assertion_cb */ 
typedef struct s__l__sn__hdl_assertion_cb {
    t__int d__;
    t__int gen__;
    struct s__sn__hdl_assertion_cb **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__hdl_assertion_cb;
#define d__l__sn__hdl_assertion_cb 6701   

typedef l__sn__hdl_assertion_cb l__hdl_assertion_cb;
#define d__l__hdl_assertion_cb d__l__sn__hdl_assertion_cb

/* l__sn__cb_assertion */ 
typedef struct s__l__sn__cb_assertion {
    t__int d__;
    t__int gen__;
    struct s__sn__cb_assertion **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__cb_assertion;
#define d__l__sn__cb_assertion 6936   

typedef l__sn__cb_assertion l__cb_assertion;
#define d__l__cb_assertion d__l__sn__cb_assertion

/* k__sn__calculated_mvl_stri68978 */ 
typedef struct s__k__sn__calculated_mvl_s68979 {
    t__int d__;
    t__int gen__;
    struct s__sn__calculated_mvl_string **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__calculated_mvl_stri68978;
#define d__k__sn__calculated_mvl_stri68978 6732   

typedef k__sn__calculated_mvl_stri68978 k__calculated_mvl_string__str;
#define d__k__calculated_mvl_string__str d__k__sn__calculated_mvl_stri68978

/* k__sn__any_tick_cb_list_it61427 */ 
typedef struct s__k__sn__any_tick_cb_list69052 {
    t__int d__;
    t__int gen__;
    struct s__sn__any_tick_cb_list_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__any_tick_cb_list_it61427;
#define d__k__sn__any_tick_cb_list_it61427 6890   

typedef k__sn__any_tick_cb_list_it61427 k__any_tick_cb_list_item__cb;
#define d__k__any_tick_cb_list_item__cb d__k__sn__any_tick_cb_list_it61427

/* k__sn__sn_denali_unit__den69629 */ 
typedef struct s__k__sn__sn_denali_unit__70900 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_denali_unit **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_denali_unit__den69629;
#define d__k__sn__sn_denali_unit__den69629 7245   

typedef k__sn__sn_denali_unit__den69629 k__sn_denali_unit__denali_70903;
#define d__k__sn_denali_unit__denali_70903 d__k__sn__sn_denali_unit__den69629

/* l__sn__sn_denali_cb_data_item */ 
typedef struct s__l__sn__sn_denali_cb_dat70902 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_denali_cb_data_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_denali_cb_data_item;
#define d__l__sn__sn_denali_cb_data_item 7244   

typedef l__sn__sn_denali_cb_data_item l__sn_denali_cb_data_item;
#define d__l__sn_denali_cb_data_item d__l__sn__sn_denali_cb_data_item

/* l__sn__sn_message_action_h70563 */ 
typedef struct s__l__sn__sn_message_actio70943 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_action_h70619 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_message_action_h70563;
#define d__l__sn__sn_message_action_h70563 7333   

typedef l__sn__sn_message_action_h70563 l__sn_message_action_handler;
#define d__l__sn_message_action_handler d__l__sn__sn_message_action_h70563

/* l__sn__sn_active_logger_data */ 
typedef struct s__l__sn__sn_active_logger_data {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_active_logger_data **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_active_logger_data;
#define d__l__sn__sn_active_logger_data 7329   

typedef l__sn__sn_active_logger_data l__sn_active_logger_data;
#define d__l__sn_active_logger_data d__l__sn__sn_active_logger_data

/* l__sn__sn_message_action */ 
typedef struct s__l__sn__sn_message_action {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_action **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_message_action;
#define d__l__sn__sn_message_action 7335   

typedef l__sn__sn_message_action l__sn_message_action;
#define d__l__sn_message_action d__l__sn__sn_message_action

/* k__e_core__message_logger__it */ 
typedef struct s__k__e_core__message_logg70626 {
    t__int d__;
    t__int gen__;
    struct s__e_core__message_logger **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__e_core__message_logger__it;
#define d__k__e_core__message_logger__it 7332   

typedef k__e_core__message_logger__it k__message_logger__it;
#define d__k__message_logger__it d__k__e_core__message_logger__it

/* l__sn__sn_message_command */ 
typedef struct s__l__sn__sn_message_command {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_command **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_message_command;
#define d__l__sn__sn_message_command 7381   

typedef l__sn__sn_message_command l__sn_message_command;
#define d__l__sn_message_command d__l__sn__sn_message_command

/* l__sn__sn_message_unit_info */ 
typedef struct s__l__sn__sn_message_unit_info {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_message_unit_info **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_message_unit_info;
#define d__l__sn__sn_message_unit_info 7382   

typedef l__sn__sn_message_unit_info l__sn_message_unit_info;
#define d__l__sn_message_unit_info d__l__sn__sn_message_unit_info

/* k__untyped__it */ 
typedef struct s__k__untyped__it {
    t__int d__;
    t__int gen__;
    t__untyped*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__untyped__it;
#define d__k__untyped__it 1802   


/* k__sn__code_cover_item__sref */ 
typedef struct s__k__sn__code_cover_item__sref {
    t__int d__;
    t__int gen__;
    struct s__sn__code_cover_item **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__code_cover_item__sref;
#define d__k__sn__code_cover_item__sref 7655   

typedef k__sn__code_cover_item__sref k__code_cover_item__sref;
#define d__k__code_cover_item__sref d__k__sn__code_cover_item__sref

/* l__e_core__any_sequence_driver */ 
typedef struct s__l__e_core__any_sequence75911 {
    t__int d__;
    t__int gen__;
    struct s__e_core__any_sequence_driver **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__any_sequence_driver;
#define d__l__e_core__any_sequence_driver 7668   

typedef l__e_core__any_sequence_driver l__any_sequence_driver;
#define d__l__any_sequence_driver d__l__e_core__any_sequence_driver

/* k__sn__item_producer__prod_id */ 
typedef struct s__k__sn__item_producer__p80366 {
    t__int d__;
    t__int gen__;
    struct s__sn__item_producer **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__item_producer__prod_id;
#define d__k__sn__item_producer__prod_id 7742   

typedef k__sn__item_producer__prod_id k__item_producer__prod_id;
#define d__k__item_producer__prod_id d__k__sn__item_producer__prod_id

/* l__sn__trace_seq_cmd */ 
typedef struct s__l__sn__trace_seq_cmd {
    t__int d__;
    t__int gen__;
    struct s__sn__trace_seq_cmd **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__trace_seq_cmd;
#define d__l__sn__trace_seq_cmd 7743   

typedef l__sn__trace_seq_cmd l__trace_seq_cmd;
#define d__l__trace_seq_cmd d__l__sn__trace_seq_cmd

/* k__sn__sn_erm_package_desc75639 */ 
typedef struct s__k__sn__sn_erm_package_d80378 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_erm_package_descri480 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_erm_package_desc75639;
#define d__k__sn__sn_erm_package_desc75639 7682   

typedef k__sn__sn_erm_package_desc75639 k__sn_erm_package_descript80381;
#define d__k__sn_erm_package_descript80381 d__k__sn__sn_erm_package_desc75639

/* k__sn__sn_erm_package_desc80379 */ 
typedef struct s__k__sn__sn_erm_package_d80380 {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_erm_package_descri480 **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *k__sn__sn_erm_package_desc80379;
#define d__k__sn__sn_erm_package_desc80379 7683   

typedef k__sn__sn_erm_package_desc80379 k__sn_erm_package_descript80382;
#define d__k__sn_erm_package_descript80382 d__k__sn__sn_erm_package_desc80379

/* l__sn__sn_library_descriptor */ 
typedef struct s__l__sn__sn_library_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_library_descriptor **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_library_descriptor;
#define d__l__sn__sn_library_descriptor 7692   

typedef l__sn__sn_library_descriptor l__sn_library_descriptor;
#define d__l__sn_library_descriptor d__l__sn__sn_library_descriptor

/* l__sn__any_env */ 
typedef struct s__l__sn__any_env {
    t__int d__;
    t__int gen__;
    struct s__sn__any_env **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__any_env;
#define d__l__sn__any_env 7693   

typedef l__sn__any_env l__any_env;
#define d__l__any_env d__l__sn__any_env

/* l__sn__sn_stripe_env */ 
typedef struct s__l__sn__sn_stripe_env {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_stripe_env **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_stripe_env;
#define d__l__sn__sn_stripe_env 7886   

typedef l__sn__sn_stripe_env l__sn_stripe_env;
#define d__l__sn_stripe_env d__l__sn__sn_stripe_env

/* l__sn__sn_stripe_container */ 
typedef struct s__l__sn__sn_stripe_container {
    t__int d__;
    t__int gen__;
    struct s__sn__sn_stripe_container **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__sn_stripe_container;
#define d__l__sn__sn_stripe_container 7888   

typedef l__sn__sn_stripe_container l__sn_stripe_container;
#define d__l__sn_stripe_container d__l__sn__sn_stripe_container

/* l__sn__objection_kind */ 
typedef struct s__l__sn__objection_kind {
    t__int d__;
    t__int gen__;
    t__sn__objection_kind*data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__objection_kind;
#define d__l__sn__objection_kind 7788   

typedef l__sn__objection_kind l__objection_kind;
#define d__l__objection_kind d__l__sn__objection_kind

/* l__sn__rf_sequence */ 
typedef struct s__l__sn__rf_sequence {
    t__int d__;
    t__int gen__;
    struct s__sn__rf_sequence **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__rf_sequence;
#define d__l__sn__rf_sequence 7675   

typedef l__sn__rf_sequence l__rf_sequence;
#define d__l__rf_sequence d__l__sn__rf_sequence

/* l__reflection__rf_enum */ 
typedef struct s__l__reflection__rf_enum {
    t__int d__;
    t__int gen__;
    struct s__reflection__rf_enum **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__reflection__rf_enum;
#define d__l__reflection__rf_enum 7130   

typedef l__reflection__rf_enum l__rf_enum;
#define d__l__rf_enum d__l__reflection__rf_enum

/* l__sn__edoc_html_page_builder */ 
typedef struct s__l__sn__edoc_html_page_b80455 {
    t__int d__;
    t__int gen__;
    struct s__sn__edoc_html_page_builder **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__edoc_html_page_builder;
#define d__l__sn__edoc_html_page_builder 7942   

typedef l__sn__edoc_html_page_builder l__edoc_html_page_builder;
#define d__l__edoc_html_page_builder d__l__sn__edoc_html_page_builder

/* l__e_core__sn_weak_map */ 
typedef struct s__l__e_core__sn_weak_map {
    t__int d__;
    t__int gen__;
    struct s__e_core__sn_weak_map **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__e_core__sn_weak_map;
#define d__l__e_core__sn_weak_map 8027   

typedef l__e_core__sn_weak_map l__sn_weak_map;
#define d__l__sn_weak_map d__l__e_core__sn_weak_map

/* l__sn__exception */ 
typedef struct s__l__sn__exception {
    t__int d__;
    t__int gen__;
    struct s__sn__exception **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__exception;
#define d__l__sn__exception 8936   

typedef l__sn__exception l__exception;
#define d__l__exception d__l__sn__exception

/* l__main__matlab_mx_array_s */ 
typedef struct s__l__main__matlab_mx_array_s {
    t__int d__;
    t__int gen__;
    struct s__main__matlab_mx_array_s **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__main__matlab_mx_array_s;
#define d__l__main__matlab_mx_array_s 9411   

typedef l__main__matlab_mx_array_s l__matlab_mx_array_s;
#define d__l__matlab_mx_array_s d__l__main__matlab_mx_array_s

/* l__sn__n__exp */ 
typedef struct s__l__sn__n__exp {
    t__int d__;
    t__int gen__;
    struct s__sn__n__exp **data;
    int size;
    int allocated;
    sn_key_map_t *key_map;
    int reserved_stuff;
} *l__sn__n__exp;
#define d__l__sn__n__exp 556   

typedef l__sn__n__exp l__n__exp;
#define d__l__n__exp d__l__sn__n__exp
SN_EXTERNC t__untyped sn_get_computed_signal_value(t__hdl_exp_info,int,t__computed_name,t__any_struct,t__type_descriptor);
SN_EXTERNC t__untyped sn_get_subprogram_signal_value(t__subprogram_handle,t__bool,int,t__hdl_data_type,int);
SN_EXTERNC SN_STRING sn_append_strings _SN_ANSI_ARGS_((int, ...));
SN_EXTERNC SN_STRING sn_appendf_comp _SN_ANSI_ARGS_((int, t__bool, ...));
SN_EXTERNC SN_STRING full_string(t__ntv);
SN_EXTERNC t__untyped call_from_dispatch_table(t__base_struct, int,t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped, t__untyped);
SN_EXTERNC t__base_struct as_a_subtype_of(t__base_struct, int);
SN_EXTERNC SN_STRING generic_scalar_to_string(int, t__type_descriptor, bool);
SN_EXTERNC SN_STRING sn_str_dollar(l__string, int);
SN_EXTERNC SN_STRING any_to_string(void *, int);
SN_EXTERNC t__base_struct sn_new_struct_by_d_index(int);
SN_EXTERNC l__bit sn_pack_args(t__bool,t__pack_options,t__source_item, int, ...);
SN_EXTERNC l__bit sn_unpack_get_lob(l__bit,t__pack_options);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) sn_str2double(SN_STRING src);
SN_EXTERNC void method_debug(t__base_struct, int, int, int, bool, t__untyped);
SN_EXTERNC void sn_do_run(t__any_struct);
SN_EXTERNC void sn_print_any(SN_STRING, t__untyped, int);
SN_EXTERNC void sn_dut_error(t__any_struct, int, SN_STRING);
SN_EXTERNC l__bit sn_implicit_pack_exp(t__pack_options, t__source_item,t__type_descriptor,t__untyped,SN_STRING);
SN_EXTERNC l__bit sn_implicit_pack_bet_exp(t__pack_options, t__source_item,t__type_descriptor,t__untyped,int,SN_STRING);
SN_EXTERNC t__any_unit sn_get_enclosing_unit(t__any_struct,int,t__type_descriptor);
SN_EXTERNC t__any_unit sn_try_enclosing_unit(t__any_struct,int,t__type_descriptor);
SN_EXTERNC l__any_unit sn_internal_get_all_units(t__list_descriptor);
SN_EXTERNC SN_STRING generic_to_string(t__base_struct);
SN_EXTERNC SN_STRING generic_uint_to_string(SN_TYPE(uint),SN_TYPE(type_descriptor));
SN_EXTERNC t__sn_vec sn_long_ilog(t__sn_vec);
SN_EXTERNC t__sn_vec sn_long_ilog2(t__sn_vec);
SN_EXTERNC t__sn_vec sn_long_ilog10(t__sn_vec);
SN_EXTERNC t__sn_vec sn_ipow2long(t__sn_vec, t__sn_vec);
SN_EXTERNC t__sn_vec sn_long_isqrt(t__sn_vec);
SN_EXTERNC t__sn_vec sn_long_div_round_up(t__sn_vec, t__sn_vec);
SN_EXTERNC t__form make_forms_of_string(SN_STRING,t__source_ref sr);
SN_EXTERNC SN_STRING sn_enum_to_c_string(int, t__enum_descriptor);
SN_EXTERNC SN_STRING str_replace(SN_STRING, SN_STRING, SN_STRING, int);
SN_EXTERNC SN_TYPE(plist) sn_pm_get_indices(SN_TYPE(plist),SN_TYPE(plist),SN_LIST(int),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_exp_type)));
SN_EXTERNC t__plist sn_pm_sorted_unique(SN_TYPE(plist),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_sort_type)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_exp_type)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_binary_exps_type)),int,int);
SN_EXTERNC t__plist sn_pm_sort_by_field_unique(SN_TYPE(plist),SN_TYPE(SN_QUALIFIED_NAME(sn,field)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_sort_type)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_exp_type)),SN_TYPE(SN_QUALIFIED_NAME(sn,sn_binary_exps_type)),int,int);
SN_EXTERNC intptr_t sn_list_key_get(SN_TYPE(plist), SN_TYPE(untyped));
SN_EXTERNC t__untyped sn_get_casted_undef(t__type_descriptor);
l__untyped sn_unsafe_get_list (int d_index);
SN_EXTERNC t__base_struct sn_unsafe_get_clean_struct (int);
SN_EXTERNC l__untyped sn_unsafe_get_clean_lisr (int);
SN_EXTERNC SN_TYPE(plist) sn_plist_in_place_reverse(SN_TYPE(plist));
SN_EXTERNC SN_TYPE(ilist) sn_ilist_in_place_reverse(SN_TYPE(ilist));
SN_EXTERNC l__string sn_get_match_list(l__string);
SN_EXTERNC SN_LIST(int) sn_double_list2scalar_list(SN_TYPE(plist) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(ilist) sn_double_list2packed_list(SN_TYPE(plist) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_double_list2long_list(SN_TYPE(plist) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC intptr_t *ar_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,activation_record)),SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
SN_EXTERNC intptr_t *car_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
SN_EXTERNC intptr_t *on_ar_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
SN_EXTERNC SN_LIST(string) real_output_from _SN_ANSI_ARGS_((SN_TYPE(global), SN_STRING));
SN_EXTERNC SN_LIST(string) output_from _SN_ANSI_ARGS_((SN_STRING));
SN_EXTERNC SN_LIST(int) sn_str2packed_list(SN_STRING src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(int) sn_str2scalar_list(SN_STRING src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_str2long_list(SN_STRING,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)));
SN_EXTERNC SN_TYPE(plist) sn_str2double_list(SN_STRING,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)));
SN_EXTERNC SN_LIST(string) sn_packed_list2str_list(SN_LIST(int) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) src_ld, SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) target_ld);
SN_EXTERNC SN_LIST(string) sn_scalar_list2str_list(SN_LIST(int) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) src_ld, SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) target_ld);
SN_EXTERNC SN_LIST(string) sn_long_list2str_list(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) target_ld);
SN_EXTERNC SN_LIST(string) sn_double_list2str_list(SN_TYPE(plist) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) target_ld);
SN_EXTERNC SN_STRING sn_packed_list2str(SN_TYPE(ilist) src);
SN_EXTERNC SN_STRING sn_numeric_list2str(SN_LIST(int) src);
SN_EXTERNC SN_STRING sn_long_list2str(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) src);
SN_EXTERNC SN_STRING sn_double_list2str(SN_TYPE(plist) src);
SN_EXTERNC SN_LIST(int) sn_long_list2scalar_list(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(ilist) sn_long_list2packed_list(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_long_list2long_list(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(plist) sn_long_list2double_list(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(ilist) sn_scalar_list2packed_list(SN_LIST(int) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_scalar_list2long_list(SN_LIST(int),SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) );
SN_EXTERNC SN_TYPE(plist) sn_scalar_list2double_list(SN_LIST(int),SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) );
SN_EXTERNC SN_LIST(int) sn_scalar_list2scalar_list(SN_LIST(int) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_packed_list2long_list(SN_TYPE(ilist),SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)));
SN_EXTERNC SN_TYPE(plist) sn_packed_list2double_list(SN_TYPE(ilist),SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)));
SN_EXTERNC SN_LIST(int) sn_packed_list2scalar_list(SN_TYPE(ilist) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(ilist) sn_packed_list2packed_list(SN_TYPE(ilist) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(ilist) sn_str_list2packed_list(SN_LIST(string) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(int) sn_str_list2scalar_list(SN_LIST(string) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(int) sn_str_list2enum_list(SN_LIST(string) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(bool) sn_str_list2bool_list(SN_LIST(string) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_str_list2long_list(SN_LIST(string) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(plist) sn_str_list2double_list(SN_LIST(string) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) ld);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_conv_long2long(SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) src, SN_TYPE(SN_QUALIFIED_NAME(sn,long_descriptor)) ld);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_conv_double2long(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) src, SN_TYPE(SN_QUALIFIED_NAME(sn,long_descriptor)) ld);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_conv_int2long(int src, SN_TYPE(SN_QUALIFIED_NAME(sn,long_descriptor)) ld);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_conv_uint2long(SN_TYPE(uint) src, SN_TYPE(SN_QUALIFIED_NAME(sn,long_descriptor)) ld);
SN_EXTERNC SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) sn_conv_str2long(SN_STRING src, SN_TYPE(SN_QUALIFIED_NAME(sn,long_descriptor)) ld);
SN_EXTERNC SN_LIST(base_struct) sn_list_of_subtype2list_of_subtype(SN_LIST(base_struct),SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)),SN_TYPE(bool));
SN_EXTERNC SN_LIST(base_struct) sn_list_of_struct2list_of_struct(SN_LIST(base_struct) src,SN_TYPE(SN_QUALIFIED_NAME(sn,list_descriptor)) to_ld);
SN_EXTERNC SN_TYPE(base_struct) sn_conv_subtype2subtype(SN_TYPE(base_struct), SN_TYPE(SN_QUALIFIED_NAME(sn,struct_descriptor)),SN_TYPE(bool));
SN_EXTERNC SN_STRING sn_long2str(SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)) src); 
SN_EXTERNC SN_STRING sn_double2str(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)) src); 
SN_EXTERNC SN_TYPE(base_struct) make_new_helper0(int);
SN_EXTERNC SN_TYPE(base_struct) make_new_helper1(int);
SN_EXTERNC void make_new_helper2(SN_TYPE(base_struct));
SN_EXTERNC SN_TYPE(ilist) packed_list_copy_helper(SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(ilist) list_scalar_copy_helper(SN_TYPE(ilist), int);
SN_EXTERNC SN_TYPE(ilist) sn_ilist_copy_helper(SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(plist) sn_plist_copy_helper(SN_TYPE(plist));
SN_EXTERNC SN_TYPE(ilist) ilist_get_index_list_helper(SN_TYPE(ilist), SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(plist) plist_get_index_list_helper(SN_TYPE(plist), SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(plist) sn_double_list_copy(SN_TYPE(plist));
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_long_list_key_copy_helper(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_long_list_copy_helper(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) list_long_reverse_helper(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_TYPE(plist) sn_double_list_reverse(SN_TYPE(plist));
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) list_get_index_list_long_helper(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)), SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(ilist) sn_ilist_key_copy_helper(SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(plist) sn_plist_key_copy_helper(SN_TYPE(plist));
SN_EXTERNC SN_TYPE(ilist) list_unsigned_scalar_copy_helper(SN_TYPE(ilist), int);
SN_EXTERNC SN_TYPE(ilist) packed_list_reverse_helper(SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(ilist) ilist_reverse_helper(SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(plist) plist_reverse_helper(SN_TYPE(plist));
SN_EXTERNC t__ilist sn_ilist_get_list_field_helper(t__ilist , SN_TYPE(SN_QUALIFIED_NAME(sn,field)), int);
SN_EXTERNC t__plist sn_plist_get_list_field_helper(t__plist , SN_TYPE(SN_QUALIFIED_NAME(sn,field)), int);
SN_EXTERNC t__ilist sn_packed_list_get_list_field_helper(t__ilist, SN_TYPE(SN_QUALIFIED_NAME(sn,field)), int);
SN_EXTERNC SN_TYPE(untyped) sn_eval_cast(SN_TYPE(untyped), SN_TYPE(SN_QUALIFIED_NAME(sn,cast)));
SN_EXTERNC t__untyped sn_copy_exp_eval(t__untyped, t__sn_exp_type, t__bool);
SN_EXTERNC SN_TYPE(ilist) sn_packed_list_get_slice(SN_TYPE(ilist), int,int,t__bool, t__list_descriptor);
SN_EXTERNC SN_TYPE(ilist) sn_ilist_get_slice(SN_TYPE(ilist), int, int,t__bool, t__list_descriptor);
SN_EXTERNC SN_TYPE(plist) sn_plist_get_slice(SN_TYPE(plist), int, int,t__bool, t__list_descriptor);
SN_EXTERNC SN_LIST(int) list_long_to_list_int(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_LIST(int) packed_list_to_list_int(SN_LIST(int));
SN_EXTERNC SN_STRING sn_str_from_byte_list(SN_LIST(byte));
SN_EXTERNC SN_TYPE(ilist) sn_copy_packed_list_by_index(SN_TYPE(ilist) list,int list_type);
SN_EXTERNC SN_TYPE(ilist) sn_packed_list_key_rehash(SN_TYPE(ilist) list);
SN_EXTERNC SN_TYPE(plist) sn_list_key_rehash(SN_TYPE(plist) list);
SN_EXTERNC intptr_t *ar_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,activation_record)),SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
SN_EXTERNC intptr_t *car_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
SN_EXTERNC intptr_t *on_ar_value_64(SN_TYPE(SN_QUALIFIED_NAME(sn,local)));
SN_EXTERNC SN_TYPE(ilist) sn_ilist_copy_helper(SN_TYPE(ilist) list);
SN_EXTERNC SN_TYPE(plist) sn_plist_copy_helper(SN_TYPE(plist) list);
SN_EXTERNC SN_TYPE(ilist) sn_ilist_key_copy_helper(SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(plist) sn_plist_key_copy_helper(SN_TYPE(plist));
SN_EXTERNC SN_TYPE(ilist) packed_list_key_copy_helper(SN_TYPE(ilist));
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_long_list_copy_helper(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)) sn_long_list_key_copy_helper(SN_LIST(SN_QUALIFIED_NAME(sn,sn_vec)));
SN_EXTERNC SN_TYPE(ilist) packed_list_copy_helper(SN_TYPE(ilist));
SN_EXTERNC SN_TYPE(plist) sn_new_list_by_d_index(int, int);
SN_EXTERNC l__method order_methods_by_execution(t__method);
SN_EXTERNC t__plist sn_internal_sort(t__plist,t__plist,t__untyped,int,int,t__bool);
SN_EXTERNC l__int sn_sort_indices(l__base_struct, t__untyped, int);
SN_EXTERNC t__local sn_get_local(SN_STRING,t__type_descriptor);
SN_EXTERNC t__type_descriptor sn_binary_opetator_update_type(t__type_descriptor td);
SN_EXTERNC t__sn_vec sn_min2long(t__sn_vec, t__sn_vec);
SN_EXTERNC t__sn_vec sn_max2long(t__sn_vec, t__sn_vec);
SN_EXTERNC intptr_t sn_list_key_get(t__plist, t__untyped);
SN_EXTERNC l__bit sn_int2lob(int, int);
SN_EXTERNC void add_ntv_list(t__ntv, SN_STRING, SN_STRING, t__form, int, SN_TYPE(sub_nt), SN_STRING);
SN_EXTERNC void free_activation_record(t__activation_record);
SN_EXTERNC SN_STRING full_string(t__ntv);
SN_EXTERNC void generic_do_h_code(t__ntv);
SN_EXTERNC void generic_do_patch(t__ntv);
SN_EXTERNC int ilist_key_delete_helper(t__ilist, int);
SN_EXTERNC void list_init_long_helper(l__sn_vec, int, bool, t__sn_vec, bool);
SN_EXTERNC void sn_double_list_resize(t__plist, int, t__bool, SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__bool);
SN_EXTERNC void list_key_rehash_helper(t__plist);
SN_EXTERNC void packed_list_add_helper(t__ilist);
SN_EXTERNC void packed_list_add_list_helper(t__ilist, t__ilist);
SN_EXTERNC void packed_list_assign_slice_to_slice(t__ilist, int, int, t__ilist, int, int);
SN_EXTERNC int packed_list_delete_helper(t__ilist, int);
SN_EXTERNC void packed_list_insert_helper(t__ilist, int, int);
SN_EXTERNC void packed_list_insert_list_helper(t__ilist, int, t__ilist);
SN_EXTERNC int packed_list_key_delete_helper(t__ilist, int);
SN_EXTERNC int packed_list_key_get_helper(t__ilist, SN_STRING);
SN_EXTERNC void packed_list_key_insert_helper(t__ilist, int, int);
SN_EXTERNC void packed_list_key_insert_list_helper(t__ilist, int, t__ilist);
SN_EXTERNC void packed_list_key_rehash_helper(t__ilist);
SN_EXTERNC void packed_list_litem_function(t__ilist, int, int);
SN_EXTERNC intptr_t safe_get_field_helper(t__base_struct, t__field);
SN_EXTERNC int sn_abs(int);
SN_EXTERNC void sn_assign_uint2long(t__sn_vec, unsigned int);
SN_EXTERNC void sn_check_str_args_num_matching(int, SN_STRING);
SN_EXTERNC void sn_check_str_args_type_matching(int, SN_STRING, int []);
SN_EXTERNC void sn_check_validity_of_format_string(SN_STRING);
SN_EXTERNC int sn_count_args_in_format(SN_STRING);
void sn_create_printing_msg(t__sn_exception, int, int *, t__untyped *);
SN_EXTERNC t__bool sn_even(int);
void sn_export_routine_h(SN_STRING);
bool sn_field_is_instance(t__field me);
SN_STRING sn_get_application_home_name(void);
SN_EXTERNC void sn_ilist_key_fast_delete(t__ilist,int);
SN_EXTERNC void sn_ilist_key_insert_helper(t__ilist list, int index, int item);
SN_EXTERNC void sn_ilist_key_insert_list_helper(t__ilist, int, t__ilist);
SN_EXTERNC bool sn_islongnull(t__sn_vec);
SN_EXTERNC bool sn_str_list_is_in_list(t__plist, t__plist, t__bool);
SN_EXTERNC bool sn_plist_is_in_list(t__plist, t__plist, t__bool);
SN_EXTERNC bool sn_short_list_is_in_real_list(t__ilist, t__plist, t__bool);
SN_EXTERNC bool sn_ushort_list_is_in_real_list(t__ilist, t__plist, t__bool);
SN_EXTERNC bool sn_short_list_is_in_long_list(t__ilist, l__sn_vec, t__bool);
SN_EXTERNC bool sn_ushort_list_is_in_long_list(t__ilist, l__sn_vec, t__bool);
SN_EXTERNC bool sn_short_list_is_in_scalar_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_ushort_list_is_in_scalar_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_short_list_is_in_short_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_ushort_list_is_in_short_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_short_list_is_in_ushort_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_ushort_list_is_in_ushort_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_ilist_is_in_real_list(t__ilist, t__plist, t__bool);
SN_EXTERNC bool sn_ulist_is_in_real_list(t__ilist, t__plist, t__bool);
SN_EXTERNC bool sn_ilist_is_in_long_list(t__ilist, l__sn_vec, t__bool);
SN_EXTERNC bool sn_ulist_is_in_long_list(t__ilist, l__sn_vec, t__bool);
SN_EXTERNC bool sn_scalar_list_is_in_scalar_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_scalar_list_is_in_short_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_scalar_list_is_in_ushort_list(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_long_list_is_in_real_list(l__sn_vec, t__plist, t__bool);
SN_EXTERNC bool sn_long_list_is_in_long_list(l__sn_vec, l__sn_vec, t__bool);
SN_EXTERNC bool sn_long_list_is_in_ilist(l__sn_vec, t__ilist, t__bool);
SN_EXTERNC bool sn_long_list_is_in_ulist(l__sn_vec, t__ilist, t__bool);
SN_EXTERNC bool sn_long_list_is_in_short_list(l__sn_vec, t__ilist, t__bool);
SN_EXTERNC bool sn_long_list_is_in_ushort_list(l__sn_vec, t__ilist, t__bool);
SN_EXTERNC bool sn_real_list_is_in_real_list(t__plist, t__plist, t__bool);
SN_EXTERNC bool sn_real_list_is_in_long_list(t__plist, l__sn_vec, t__bool);
SN_EXTERNC bool sn_real_list_is_in_ilist(t__plist, t__ilist, t__bool);
SN_EXTERNC bool sn_real_list_is_in_ulist(t__plist, t__ilist, t__bool);
SN_EXTERNC bool sn_real_list_is_in_short_list(t__plist, t__ilist, t__bool);
SN_EXTERNC bool sn_real_list_is_in_ushort_list(t__plist, t__ilist, t__bool);
SN_EXTERNC bool sn_string_is_in_list(SN_STRING, l__string);
SN_EXTERNC bool sn_struct_is_in_list(t__untyped, t__plist);
SN_EXTERNC bool sn_int_is_in_long_list(int, l__sn_vec);
SN_EXTERNC bool sn_uint_is_in_long_list(int, l__sn_vec);
SN_EXTERNC bool sn_scalar_is_in_short_list(int, t__ilist);
SN_EXTERNC bool sn_scalar_is_in_ushort_list(int, t__ilist);
SN_EXTERNC bool sn_scalar_is_in_scalar_list(int, t__ilist);
SN_EXTERNC bool sn_long_is_in_long_list(t__sn_vec, l__sn_vec);
SN_EXTERNC bool sn_long_is_in_ilist(t__sn_vec, t__ilist);
SN_EXTERNC bool sn_long_is_in_ulist(t__sn_vec, t__ilist);
SN_EXTERNC bool sn_long_is_in_short_list(t__sn_vec, t__ilist);
SN_EXTERNC bool sn_long_is_in_ushort_list(t__sn_vec, t__ilist);
SN_EXTERNC bool sn_real_is_in_real_list(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__plist);
SN_EXTERNC bool sn_long_is_in_real_list(SN_TYPE(SN_QUALIFIED_NAME(sn,sn_vec)), t__plist);
SN_EXTERNC bool sn_uint_is_in_real_list(t__uint, t__plist);
SN_EXTERNC bool sn_int_is_in_real_list(int, t__plist);
SN_EXTERNC bool sn_real_is_in_long_list(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), l__sn_vec);
SN_EXTERNC bool sn_real_is_in_ilist(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__ilist);
SN_EXTERNC bool sn_real_is_in_ulist(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__ilist);
SN_EXTERNC bool sn_real_is_in_short_list(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__ilist);
SN_EXTERNC bool sn_real_is_in_ushort_list(SN_TYPE(SN_QUALIFIED_NAME(e_core,real)), t__ilist);
SN_EXTERNC bool sn_enum_descriptor_is_initialized_value(t__type_descriptor me, t__untyped value);
SN_EXTERNC t__bool sn_long_even(t__sn_vec);
SN_EXTERNC t__bool sn_long_odd(t__sn_vec);
SN_EXTERNC int sn_max2int(int,int);
SN_EXTERNC t__uint sn_max2uint(t__uint,t__uint);
SN_EXTERNC int sn_min2int(int,int);
SN_EXTERNC t__uint sn_min2uint(t__uint,t__uint);
sn_bool sn_module_internal(t__module);
SN_EXTERNC t__bool sn_namer_is_auto_temp_name(t__namer, SN_STRING);
SN_EXTERNC t__bool sn_odd(int);
SN_EXTERNC void sn_out1(char *, ...);
SN_EXTERNC void sn_out_opt(SN_STRING);
SN_EXTERNC void sn_outf_opt(SN_STRING);
SN_EXTERNC void sn_packed_list_add_slice(SN_TYPE(ilist),int,int,int,int);
SN_EXTERNC void sn_packed_list_init_helper(t__ilist, int, bool, int, bool);
SN_EXTERNC void sn_plist_key_fast_delete(t__plist,int);
SN_EXTERNC void sn_plist_key_insert_list_helper(t__plist, int, t__plist);
SN_EXTERNC void sn_put_bits2int(int *, int, int, int,int);
SN_EXTERNC void sn_put_bits2uint(t__uint *, int, int, t__uint,int);
SN_EXTERNC SN_TYPE(uint) sn_str2uint(SN_STRING);
SN_EXTERNC bool sn_string_list_equal(l__string, l__string);
SN_EXTERNC void sn_warning(char *, ...);
SN_EXTERNC void sn_packed_list_slice(t__ilist, t__ilist, int, int, int);
SN_EXTERNC bool sn_plist_equal(t__plist,t__plist);
SN_EXTERNC bool sn_packed_list_equal(t__ilist,t__bool, t__ilist, t__bool);
SN_EXTERNC bool sn_ilist_packed_list_equal(t__ilist, t__ilist, t__bool);
SN_EXTERNC bool sn_ilist_equal(t__ilist,t__ilist);
SN_EXTERNC bool sn_long_list_packed_list_equal(l__sn_vec, t__ilist, t__bool);
SN_EXTERNC bool sn_long_list_ilist_equal(l__sn_vec, t__ilist, t__bool);
SN_EXTERNC bool sn_long_list_equal(l__sn_vec, l__sn_vec);
SN_EXTERNC bool sn_double_list_packed_list_equal(t__plist, t__ilist, t__bool);
SN_EXTERNC bool sn_double_list_ilist_equal(t__plist, t__ilist, t__bool);
SN_EXTERNC bool sn_double_list_long_list_equal(t__plist, l__sn_vec);
SN_EXTERNC bool sn_double_list_equal(t__plist, t__plist);
SN_EXTERNC bool sn_sub_plist_equal(t__plist, int, int, t__plist, int, int);
SN_EXTERNC bool sn_sub_ilist_equal(t__ilist, int, int, t__ilist, int, int);
SN_EXTERNC bool sn_sub_packed_list_equal(t__ilist, int, int, t__ilist, int, int);
SN_EXTERNC void sn_prof_out();
SN_EXTERNC SN_STRING sn_code_cast(SN_STRING, t__cast);
SN_EXTERNC void sn_indent_str(l__string, int, SN_STRING);
SN_EXTERNC t__bool sn_equal_long2int(t__sn_vec, int);
SN_EXTERNC t__bool sn_equal_long2uint(t__sn_vec, t__uint);
SN_EXTERNC int sn_order_long2int(t__sn_vec, int);
SN_EXTERNC int sn_order_long2uint(t__sn_vec, t__uint);
SN_EXTERNC t__activation_record add_local_to_on_eval_AR(int, t__untyped);
/* line 1 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '' */
SN_EXTERNC void r__103619__global  _SN_ANSI_ARGS_ ((t__e_core__global));

/* line 77 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '' */
SN_EXTERNC t__bool r__103622  _SN_ANSI_ARGS_ ((t__main__sn_matlab_var_s));

/* line 80 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '' */
SN_EXTERNC t__bool r__103623  _SN_ANSI_ARGS_ ((t__main__sn_matlab_var_s));

/* line 102 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '' */
SN_EXTERNC t__bool r__103624__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 105 "/home/jangook/shr_sn_matlab/e/matlab.e"  From '' */
SN_EXTERNC t__bool r__103625__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__sn_matlab_var_s));

/* line 1 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103626__global  _SN_ANSI_ARGS_ ((t__e_core__global));

/* line 10 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103627  _SN_ANSI_ARGS_ ((t__main__sn_matlab_complex_s));

/* line 40 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC struct s__main__sn_matlab_complex_s * r__103628  _SN_ANSI_ARGS_ ((t__main__matlab_mx_array_s,t__uint,t__uint));

/* line 52 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC struct s__main__sn_matlab_complex_s * r__103629  _SN_ANSI_ARGS_ ((t__main__matlab_mx_array_s,t__uint,t__uint));

/* line 66 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void sn_matlab_get_mx_item  _SN_ANSI_ARGS_ ((t__main__matlab_mx_array_s,t__uint,t__uint,t__main__sn_matlab_complex_s));

/* line 69 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void sn_matlab_free_mx  _SN_ANSI_ARGS_ ((t__main__matlab_mx_array_s));

/* line 84 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103630  _SN_ANSI_ARGS_ ((t__main__sn_matlab_var_s));

/* line 89 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC struct s__main__sn_matlab_complex_s * r__103631  _SN_ANSI_ARGS_ ((t__main__sn_matlab_var_s,t__uint));

/* line 123 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t r__103632__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,l__string));

/* line 134 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t r__103633__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__sn_matlab_var_s));

/* line 150 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t r__103634__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__sn_matlab_var_s));

/* line 164 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103635__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 174 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103636__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 180 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__bool r__103637__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__sn_matlab_var_s,t__main__matlab_mx_array_s));

/* line 204 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__bool r__103638__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__matlab_mx_array_s,t__main__matlab_mx_array_s));

/* line 227 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC struct s__main__sn_matlab_var_s * r__103639__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__matlab_mx_array_s));

/* line 250 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t sn_matlab_init  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 251 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t sn_matlab_fini  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 252 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t sn_matlab_get_var  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__sn_matlab_var_s));

/* line 253 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t sn_matlab_put_var  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__sn_matlab_var_s));

/* line 254 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__bool sn_matlab_is_equal  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__sn_matlab_var_s,t__main__matlab_mx_array_s));

/* line 255 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__bool sn_matlab_is_equal_mx  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__matlab_mx_array_s,t__main__matlab_mx_array_s));

/* line 256 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__bool sn_matlab_mx_to_sn_var  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__main__matlab_mx_array_s,t__main__sn_matlab_var_s));

/* line 257 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC t__main__matlab_rc_t sn_matlab_exec  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s,t__string));

/* line 274 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103640__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 284 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103641__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 288 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103642__main__matlab_ifc_s  _SN_ANSI_ARGS_ ((t__main__matlab_ifc_s));

/* line 304 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103643__e_core__global  _SN_ANSI_ARGS_ ((t__e_core__global));

/* line 313 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103644__e_core__global__init  _SN_ANSI_ARGS_ ((t__e_core__global));

/* line 318 "/home/jangook/shr_sn_matlab/e/sn_matlab.e"  From '' */
SN_EXTERNC void r__103645__e_core__sys__quit  _SN_ANSI_ARGS_ ((t__e_core__sys));

/* line 184 "/vobs/specman/src/te_threads.e"  From '' */
SN_EXTERNC void r__19655__e_core__any_struct  _SN_ANSI_ARGS_ ((t__e_core__any_struct));

/* line 17 "/vobs/specman/src/specman.e"  From '' */
SN_EXTERNC void r__103616__e_core__global__init  _SN_ANSI_ARGS_ ((t__e_core__global));

/* line 342 "/vobs/specman/src/evc_util_objections.e"  From '' */
SN_EXTERNC void r__76740__e_core__any_unit  _SN_ANSI_ARGS_ ((t__e_core__any_unit));

/* line 212 "/vobs/specman/src/port_access_ep.e"  From '' */
SN_EXTERNC struct s__sn__sn_event_channel * sn_get_event_port_channel_unsafe  _SN_ANSI_ARGS_ ((t__e_core__any_event_port,t__source_ref));

/* line 546 "/vobs/specman/src/tcm.e"  From '' */
SN_EXTERNC struct s__sn__ref_field * sn_make_new_ref_field  _SN_ANSI_ARGS_ ((t__e_core__base_struct,t__sn__field));

/* line 547 "/vobs/specman/src/tcm.e"  From '' */
SN_EXTERNC struct s__sn__ref_item * sn_make_new_ref_item  _SN_ANSI_ARGS_ ((t__untyped,t__int));

/* line 548 "/vobs/specman/src/tcm.e"  From '' */
SN_EXTERNC struct s__sn__ref_item * sn_make_check_new_ref_item  _SN_ANSI_ARGS_ ((t__untyped,t__int));

/* line 53 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_add2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 54 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_add_int2long  _SN_ANSI_ARGS_ ((t__int,t__sn__sn_vec));

/* line 55 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_add_long2int  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__int));

/* line 56 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_add_uint2long  _SN_ANSI_ARGS_ ((t__uint,t__sn__sn_vec));

/* line 57 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_add_long2uint  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__uint));

/* line 58 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_sub2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 63 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_mult2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 64 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_div2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 65 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_mod2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 68 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_bit_not_long  _SN_ANSI_ARGS_ ((t__sn__sn_vec));

/* line 69 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_minus_long  _SN_ANSI_ARGS_ ((t__sn__sn_vec));

/* line 72 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__uint sn_long2uint  _SN_ANSI_ARGS_ ((t__sn__sn_vec));

/* line 73 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_sized_int2long  _SN_ANSI_ARGS_ ((t__int,t__int));

/* line 74 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_int2long  _SN_ANSI_ARGS_ ((t__int));

/* line 75 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_uint2long  _SN_ANSI_ARGS_ ((t__uint));

/* line 76 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_str2long  _SN_ANSI_ARGS_ ((t__string));

/* line 80 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__int sn_order2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 82 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_equal2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 83 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_lt2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 84 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_le2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 85 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_gt2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 86 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_ge2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 88 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_shift_right  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__int));

/* line 89 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_shift_left  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__int));

/* line 91 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_or2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 92 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_and2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 93 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_xor2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 95 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC void sn_assign  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 97 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_assign_ret  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__sn_vec));

/* line 98 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC void sn_condense_last_byte  _SN_ANSI_ARGS_ ((t__sn__sn_vec));

/* line 100 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__int sn_order_long  _SN_ANSI_ARGS_ ((t__sn__sn_vec));

/* line 101 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_is_long_value_int  _SN_ANSI_ARGS_ ((t__sn__sn_vec));

/* line 102 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_is_long_value_uint  _SN_ANSI_ARGS_ ((t__sn__sn_vec));

/* line 300 "/vobs/specman/src/files.e"  From '' */
SN_EXTERNC struct s__sn__type_descriptor * type_called  _SN_ANSI_ARGS_ ((t__string));

/* line 114 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string sn_numeric_list2str  _SN_ANSI_ARGS_ ((l__int));

/* line 115 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string sn_long_list2str  _SN_ANSI_ARGS_ ((l__sn__sn_vec));

/* line 116 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__string * sn_long_list2str_list  _SN_ANSI_ARGS_ ((l__sn__sn_vec,t__sn__list_descriptor));

/* line 117 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__string * sn_packed_list2str_list  _SN_ANSI_ARGS_ ((l__int,t__sn__list_descriptor,t__sn__list_descriptor));

/* line 118 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__string * sn_scalar_list2str_list  _SN_ANSI_ARGS_ ((l__int,t__sn__list_descriptor,t__sn__list_descriptor));

/* line 119 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__sn__sn_vec * sn_scalar_list2long_list  _SN_ANSI_ARGS_ ((l__int,t__sn__list_descriptor));

/* line 120 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__int * sn_long_list2scalar_list  _SN_ANSI_ARGS_ ((l__sn__sn_vec,t__sn__list_descriptor));

/* line 121 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__int * sn_scalar_list2scalar_list  _SN_ANSI_ARGS_ ((l__int,t__sn__list_descriptor));

/* line 122 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_conv_long2long  _SN_ANSI_ARGS_ ((t__sn__sn_vec,t__sn__long_descriptor));

/* line 123 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_conv_int2long  _SN_ANSI_ARGS_ ((t__int,t__sn__long_descriptor));

/* line 124 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_conv_uint2long  _SN_ANSI_ARGS_ ((t__uint,t__sn__long_descriptor));

/* line 125 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__e_core__base_struct * sn_conv_subtype2subtype  _SN_ANSI_ARGS_ ((t__e_core__base_struct,t__sn__struct_descriptor,t__bool));

/* line 126 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__e_core__base_struct * sn_list_of_struct2list_of_struct  _SN_ANSI_ARGS_ ((l__e_core__base_struct,t__sn__list_descriptor));

/* line 127 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__e_core__base_struct * sn_list_of_subtype2list_of_subtype  _SN_ANSI_ARGS_ ((l__e_core__base_struct,t__sn__list_descriptor,t__bool));

/* line 128 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_vec * sn_conv_str2long  _SN_ANSI_ARGS_ ((t__string,t__sn__long_descriptor));

/* line 129 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_str_bool  _SN_ANSI_ARGS_ ((t__string));

/* line 130 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__sn__sn_vec * sn_copy_long_list_by_index  _SN_ANSI_ARGS_ ((l__sn__sn_vec,t__int));

/* line 131 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__sn_exception * sn_get_current_exception  _SN_ANSI_ARGS_ (());

/* line 132 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__int * packed_list_to_list_int  _SN_ANSI_ARGS_ ((l__int));

/* line 133 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__l__int * list_long_to_list_int  _SN_ANSI_ARGS_ ((l__sn__sn_vec));

/* line 134 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string sn_appendf  _SN_ANSI_ARGS_ ((t__int,t__untyped*,t__int*,t__string));

/* line 135 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string sn_append_numbered_strings  _SN_ANSI_ARGS_ ((t__string,t__int,t__string*));

/* line 136 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string sn_str_join  _SN_ANSI_ARGS_ ((l__string,t__string));

/* line 138 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__e_core__base_struct * sn_new_struct_by_d_index  _SN_ANSI_ARGS_ ((t__int));

/* line 140 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string sn_code_for_multi_string  _SN_ANSI_ARGS_ ((t__bool,l__sn__n__exp,l__sn__local,l__string));

/* line 141 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn__list_descriptor * sn_get_or_create_list_descriptor  _SN_ANSI_ARGS_ ((t__sn__type_descriptor,t__source_ref));

/* line 142 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string value_for_multi_string  _SN_ANSI_ARGS_ ((t__bool,l__sn__n__exp,t__string));

/* line 662 "/vobs/specman/src/action.e"  From '' */
SN_EXTERNC struct s__l__string * sn_str_split  _SN_ANSI_ARGS_ ((t__string,t__string));

/* line 143 "/vobs/specman/src/exp.e"  From '' */
SN_EXTERNC t__string enum_to_string  _SN_ANSI_ARGS_ ((t__int,t__sn__enum_descriptor));

/* line 838 "/vobs/specman/src/exp_new.e"  From '' */
SN_EXTERNC struct s__e_core__base_struct * sn_unsafe_copy_struct  _SN_ANSI_ARGS_ ((t__e_core__base_struct));

/* line 837 "/vobs/specman/src/exp_new.e"  From '' */
SN_EXTERNC struct s__e_core__base_struct * sn_unsafe_get_struct  _SN_ANSI_ARGS_ ((t__int));

/* #include mm-proxy_ix2.h */
#ifndef MM_PROXY_IX2_H
#define MM_PROXY_IX2_H

struct s__sn__sn_heapwalk;

SN_EXTERNC void sn_free_struct(t__base_struct);
SN_EXTERNC void sn_free_list(l__untyped);
SN_EXTERNC t__base_struct sn_new_struct_by_d_index(int);
SN_EXTERNC void sn_register_lists_for_copy(l__base_struct init_hash,l__base_struct init_method,l__base_struct init_fields);
SN_EXTERNC void set_dump_clean_weaks_routine(t__routine_pointer r);
SN_EXTERNC void set_sn_dump_add_weaks_routine(t__routine_pointer r);
SN_EXTERNC void sn_mm_dump_wr__write(intptr_t key,intptr_t value);
SN_EXTERNC void sn_mm_dump_wr__read(t__base_struct *key,t__base_struct *value);
SN_EXTERNC bool sn_add_to_list_if_not_marked(l__untyped,void*);
SN_EXTERNC int sn_d_index(t__base_struct);
SN_EXTERNC char* sn_make_new_string_helper(int);
SN_EXTERNC void sn_walk_from_conservative_roots(struct s__sn__sn_heapwalk * walk,sn_bool raw);
SN_EXTERNC void sn_walk_from_precise_roots(struct s__sn__sn_heapwalk * walk,sn_bool raw);
SN_EXTERNC void sn_walk_from_root(t__base_struct root,struct s__sn__sn_heapwalk * walk,sn_bool raw);
SN_EXTERNC void sn_walk_unmarked(struct s__sn__sn_heapwalk * walk,sn_bool raw);
SN_EXTERNC void sn_free_sn_struct(t__sn_struct st);


#endif /* MM_PROXY_IX2_H */
SN_EXTERNAL t__sn__module CM;  /* Same as GLOB_ST->current_module */
SN_EXTERNAL t__base_struct sn_partial_init_struct;
SN_EXTERNAL t__sn_exception_data sn_current_exception;
SN_EXTERNAL t__symtab  sn_symtab;
SN_EXTERNAL t__session  sn_session;
SN_EXTERNAL t__sn_dbg  sn_on;
SN_EXTERNAL t__simulator  sn_simulator;

#endif /* SN_SN_MATLAB_H */
